-- MySQL dump 10.11
--
-- Host: localhost    Database: ilias3103rel
-- ------------------------------------------------------
-- Server version	5.0.37-log

--
-- Table structure for table `acc_cache`
--

CREATE TABLE `acc_cache` (
  `user_id` int(11) NOT NULL default '0',
  `time` int(11) NOT NULL default '0',
  `result` mediumtext,
  PRIMARY KEY  (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `acc_cache`
--

/*!40000 ALTER TABLE `acc_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `acc_cache` ENABLE KEYS */;

--
-- Table structure for table `addressbook`
--

CREATE TABLE `addressbook` (
  `addr_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `login` varchar(40) default NULL,
  `firstname` varchar(40) default NULL,
  `lastname` varchar(40) default NULL,
  `email` varchar(40) default NULL,
  PRIMARY KEY  (`addr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `addressbook`
--

/*!40000 ALTER TABLE `addressbook` DISABLE KEYS */;
/*!40000 ALTER TABLE `addressbook` ENABLE KEYS */;

--
-- Table structure for table `addressbook_mailing_lists`
--

CREATE TABLE `addressbook_mailing_lists` (
  `ml_id` bigint(20) NOT NULL auto_increment,
  `user_id` bigint(20) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `createdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `changedate` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ml_id`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `addressbook_mailing_lists`
--

/*!40000 ALTER TABLE `addressbook_mailing_lists` DISABLE KEYS */;
/*!40000 ALTER TABLE `addressbook_mailing_lists` ENABLE KEYS */;

--
-- Table structure for table `addressbook_mailing_lists_assignments`
--

CREATE TABLE `addressbook_mailing_lists_assignments` (
  `a_id` bigint(20) NOT NULL auto_increment,
  `ml_id` bigint(20) NOT NULL default '0',
  `addr_id` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`a_id`),
  KEY `ml_id` (`ml_id`),
  KEY `addr_id` (`addr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `addressbook_mailing_lists_assignments`
--

/*!40000 ALTER TABLE `addressbook_mailing_lists_assignments` DISABLE KEYS */;
/*!40000 ALTER TABLE `addressbook_mailing_lists_assignments` ENABLE KEYS */;

--
-- Table structure for table `adv_md_field_definition`
--

CREATE TABLE `adv_md_field_definition` (
  `field_id` int(11) NOT NULL auto_increment,
  `record_id` int(11) NOT NULL default '0',
  `import_id` varchar(32) NOT NULL default '',
  `position` int(3) NOT NULL default '0',
  `field_type` tinyint(1) NOT NULL default '0',
  `field_values` text NOT NULL,
  `title` text NOT NULL,
  `description` text NOT NULL,
  `searchable` tinyint(1) NOT NULL default '0',
  `required` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`field_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `adv_md_field_definition`
--

/*!40000 ALTER TABLE `adv_md_field_definition` DISABLE KEYS */;
/*!40000 ALTER TABLE `adv_md_field_definition` ENABLE KEYS */;

--
-- Table structure for table `adv_md_record`
--

CREATE TABLE `adv_md_record` (
  `record_id` tinyint(3) NOT NULL auto_increment,
  `import_id` varchar(64) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '0',
  `title` varchar(128) NOT NULL default '',
  `description` text NOT NULL,
  PRIMARY KEY  (`record_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `adv_md_record`
--

/*!40000 ALTER TABLE `adv_md_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `adv_md_record` ENABLE KEYS */;

--
-- Table structure for table `adv_md_record_objs`
--

CREATE TABLE `adv_md_record_objs` (
  `record_id` tinyint(3) NOT NULL default '0',
  `obj_type` char(6) NOT NULL default '',
  PRIMARY KEY  (`record_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `adv_md_record_objs`
--

/*!40000 ALTER TABLE `adv_md_record_objs` DISABLE KEYS */;
/*!40000 ALTER TABLE `adv_md_record_objs` ENABLE KEYS */;

--
-- Table structure for table `adv_md_substitutions`
--

CREATE TABLE `adv_md_substitutions` (
  `obj_type` varchar(4) NOT NULL default '',
  `substitution` text NOT NULL,
  `hide_description` tinyint(1) NOT NULL default '0',
  `hide_field_names` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `adv_md_substitutions`
--

/*!40000 ALTER TABLE `adv_md_substitutions` DISABLE KEYS */;
/*!40000 ALTER TABLE `adv_md_substitutions` ENABLE KEYS */;

--
-- Table structure for table `adv_md_values`
--

CREATE TABLE `adv_md_values` (
  `obj_id` int(11) NOT NULL default '0',
  `field_id` int(11) NOT NULL default '0',
  `value` text NOT NULL,
  `disabled` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`field_id`),
  KEY `obj_id` (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `adv_md_values`
--

/*!40000 ALTER TABLE `adv_md_values` DISABLE KEYS */;
/*!40000 ALTER TABLE `adv_md_values` ENABLE KEYS */;

--
-- Table structure for table `aicc_course`
--

CREATE TABLE `aicc_course` (
  `obj_id` int(11) NOT NULL default '0',
  `course_creator` varchar(255) default NULL,
  `course_id` varchar(50) default NULL,
  `course_system` varchar(50) default NULL,
  `course_title` varchar(255) default NULL,
  `level` varchar(5) default NULL,
  `max_fields_cst` smallint(6) default NULL,
  `max_fields_ort` smallint(6) default NULL,
  `total_aus` smallint(6) default NULL,
  `total_blocks` smallint(6) default NULL,
  `total_complex_obj` smallint(6) default NULL,
  `total_objectives` smallint(6) default NULL,
  `version` varchar(10) default NULL,
  `max_normal` tinyint(4) default NULL,
  `description` text,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `aicc_course`
--

/*!40000 ALTER TABLE `aicc_course` DISABLE KEYS */;
/*!40000 ALTER TABLE `aicc_course` ENABLE KEYS */;

--
-- Table structure for table `aicc_object`
--

CREATE TABLE `aicc_object` (
  `obj_id` int(11) NOT NULL auto_increment,
  `slm_id` int(11) NOT NULL default '0',
  `system_id` varchar(50) NOT NULL default '',
  `title` text NOT NULL,
  `description` text,
  `developer_id` varchar(50) default NULL,
  `type` char(3) NOT NULL default '',
  PRIMARY KEY  (`obj_id`),
  KEY `alm_id` (`slm_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `aicc_object`
--

/*!40000 ALTER TABLE `aicc_object` DISABLE KEYS */;
/*!40000 ALTER TABLE `aicc_object` ENABLE KEYS */;

--
-- Table structure for table `aicc_units`
--

CREATE TABLE `aicc_units` (
  `obj_id` int(11) NOT NULL auto_increment,
  `type` varchar(50) default NULL,
  `command_line` varchar(255) default NULL,
  `max_time_allowed` time default NULL,
  `time_limit_action` varchar(50) default NULL,
  `max_score` decimal(10,0) default NULL,
  `core_vendor` text,
  `system_vendor` text,
  `file_name` varchar(255) default NULL,
  `mastery_score` smallint(6) default NULL,
  `web_launch` varchar(255) default NULL,
  `au_password` varchar(50) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `aicc_units`
--

/*!40000 ALTER TABLE `aicc_units` DISABLE KEYS */;
/*!40000 ALTER TABLE `aicc_units` ENABLE KEYS */;

--
-- Table structure for table `ass_log`
--

CREATE TABLE `ass_log` (
  `ass_log_id` int(11) NOT NULL auto_increment,
  `user_fi` int(11) NOT NULL default '0',
  `obj_fi` int(11) NOT NULL default '0',
  `logtext` text NOT NULL,
  `question_fi` int(11) default NULL,
  `original_fi` int(11) default NULL,
  `ref_id` int(11) default NULL,
  `test_only` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`ass_log_id`),
  KEY `user_fi` (`user_fi`,`obj_fi`),
  KEY `obj_fi` (`obj_fi`)
) TYPE=MyISAM COMMENT='Logging of Test&Assessment object changes';

--
-- Dumping data for table `ass_log`
--

/*!40000 ALTER TABLE `ass_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `ass_log` ENABLE KEYS */;

--
-- Table structure for table `benchmark`
--

CREATE TABLE `benchmark` (
  `cdate` datetime default NULL,
  `module` varchar(150) default NULL,
  `benchmark` varchar(150) default NULL,
  `duration` double(14,5) default NULL,
  KEY `module` (`module`,`benchmark`)
) TYPE=MyISAM;

--
-- Dumping data for table `benchmark`
--

/*!40000 ALTER TABLE `benchmark` DISABLE KEYS */;
/*!40000 ALTER TABLE `benchmark` ENABLE KEYS */;

--
-- Table structure for table `bookmark_data`
--

CREATE TABLE `bookmark_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `description` varchar(255) NOT NULL default '',
  `target` varchar(200) NOT NULL default '',
  `type` varchar(4) NOT NULL default '',
  PRIMARY KEY  (`obj_id`,`user_id`)
) TYPE=MyISAM AUTO_INCREMENT=2;

--
-- Dumping data for table `bookmark_data`
--

/*!40000 ALTER TABLE `bookmark_data` DISABLE KEYS */;
INSERT INTO `bookmark_data` VALUES (1,0,'dummy_folder','','','bmf');
/*!40000 ALTER TABLE `bookmark_data` ENABLE KEYS */;

--
-- Table structure for table `bookmark_tree`
--

CREATE TABLE `bookmark_tree` (
  `tree` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `bookmark_tree`
--

/*!40000 ALTER TABLE `bookmark_tree` DISABLE KEYS */;
INSERT INTO `bookmark_tree` VALUES (6,1,0,1,2,1);
/*!40000 ALTER TABLE `bookmark_tree` ENABLE KEYS */;

--
-- Table structure for table `cal_categories`
--

CREATE TABLE `cal_categories` (
  `cat_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL,
  `title` char(128) NOT NULL,
  `color` char(8) NOT NULL,
  `type` tinyint(1) NOT NULL,
  PRIMARY KEY  (`cat_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cal_categories`
--

/*!40000 ALTER TABLE `cal_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `cal_categories` ENABLE KEYS */;

--
-- Table structure for table `cal_categories_hidden`
--

CREATE TABLE `cal_categories_hidden` (
  `user_id` int(11) NOT NULL,
  `cat_id` int(11) NOT NULL,
  PRIMARY KEY  (`user_id`,`cat_id`),
  KEY `cat_id` (`cat_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cal_categories_hidden`
--

/*!40000 ALTER TABLE `cal_categories_hidden` DISABLE KEYS */;
/*!40000 ALTER TABLE `cal_categories_hidden` ENABLE KEYS */;

--
-- Table structure for table `cal_category_assignments`
--

CREATE TABLE `cal_category_assignments` (
  `cal_id` int(11) NOT NULL,
  `cat_id` int(11) NOT NULL,
  KEY `cal_id` (`cal_id`,`cat_id`),
  KEY `cat_id` (`cat_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cal_category_assignments`
--

/*!40000 ALTER TABLE `cal_category_assignments` DISABLE KEYS */;
/*!40000 ALTER TABLE `cal_category_assignments` ENABLE KEYS */;

--
-- Table structure for table `cal_entries`
--

CREATE TABLE `cal_entries` (
  `cal_id` int(11) NOT NULL auto_increment,
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `title` char(128) NOT NULL,
  `subtitle` char(64) NOT NULL,
  `description` text NOT NULL,
  `location` text NOT NULL,
  `fullday` tinyint(1) NOT NULL default '0',
  `start` datetime NOT NULL default '0000-00-00 00:00:00',
  `end` datetime NOT NULL default '0000-00-00 00:00:00',
  `informations` text NOT NULL,
  `auto_generated` tinyint(1) NOT NULL default '0',
  `context_id` tinyint(2) NOT NULL default '0',
  `translation_type` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`cal_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cal_entries`
--

/*!40000 ALTER TABLE `cal_entries` DISABLE KEYS */;
/*!40000 ALTER TABLE `cal_entries` ENABLE KEYS */;

--
-- Table structure for table `cal_recurrence_rules`
--

CREATE TABLE `cal_recurrence_rules` (
  `rule_id` int(11) NOT NULL auto_increment,
  `cal_id` int(11) NOT NULL default '0',
  `cal_recurrence` int(1) NOT NULL default '0',
  `freq_type` char(20) NOT NULL default '',
  `freq_until_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `freq_until_count` int(4) NOT NULL default '0',
  `intervall` int(4) NOT NULL default '0',
  `byday` char(64) NOT NULL default '',
  `byweekno` char(64) NOT NULL default '0',
  `bymonth` char(64) NOT NULL default '',
  `bymonthday` char(64) NOT NULL default '',
  `byyearday` char(64) NOT NULL default '',
  `bysetpos` char(64) NOT NULL default '0',
  `weekstart` char(2) NOT NULL default '',
  PRIMARY KEY  (`rule_id`),
  KEY `cal_id` (`cal_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cal_recurrence_rules`
--

/*!40000 ALTER TABLE `cal_recurrence_rules` DISABLE KEYS */;
/*!40000 ALTER TABLE `cal_recurrence_rules` ENABLE KEYS */;

--
-- Table structure for table `cal_shared`
--

CREATE TABLE `cal_shared` (
  `cal_id` int(11) NOT NULL,
  `obj_id` int(11) NOT NULL,
  `obj_type` int(1) NOT NULL,
  `create_date` timestamp NOT NULL,
  PRIMARY KEY  (`cal_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cal_shared`
--

/*!40000 ALTER TABLE `cal_shared` DISABLE KEYS */;
/*!40000 ALTER TABLE `cal_shared` ENABLE KEYS */;

--
-- Table structure for table `cal_shared_status`
--

CREATE TABLE `cal_shared_status` (
  `cal_id` int(11) NOT NULL,
  `usr_id` int(11) NOT NULL,
  `status` int(1) NOT NULL,
  PRIMARY KEY  (`cal_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cal_shared_status`
--

/*!40000 ALTER TABLE `cal_shared_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `cal_shared_status` ENABLE KEYS */;

--
-- Table structure for table `catch_write_events`
--

CREATE TABLE `catch_write_events` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `ts` timestamp NOT NULL,
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `catch_write_events`
--

/*!40000 ALTER TABLE `catch_write_events` DISABLE KEYS */;
/*!40000 ALTER TABLE `catch_write_events` ENABLE KEYS */;

--
-- Table structure for table `chat_blocked`
--

CREATE TABLE `chat_blocked` (
  `chat_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `chat_blocked`
--

/*!40000 ALTER TABLE `chat_blocked` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_blocked` ENABLE KEYS */;

--
-- Table structure for table `chat_invitations`
--

CREATE TABLE `chat_invitations` (
  `chat_id` int(11) NOT NULL default '0',
  `room_id` int(11) NOT NULL default '0',
  `guest_id` int(11) NOT NULL default '0',
  `guest_informed` tinyint(1) NOT NULL default '0',
  `invitation_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`chat_id`,`room_id`,`guest_id`),
  KEY `invitations` (`guest_id`,`guest_informed`,`invitation_time`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_invitations`
--

/*!40000 ALTER TABLE `chat_invitations` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_invitations` ENABLE KEYS */;

--
-- Table structure for table `chat_record_data`
--

CREATE TABLE `chat_record_data` (
  `record_data_id` int(11) NOT NULL auto_increment,
  `record_id` int(11) NOT NULL default '0',
  `message` mediumtext NOT NULL,
  `msg_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`record_data_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_record_data`
--

/*!40000 ALTER TABLE `chat_record_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_record_data` ENABLE KEYS */;

--
-- Table structure for table `chat_records`
--

CREATE TABLE `chat_records` (
  `record_id` int(11) NOT NULL auto_increment,
  `moderator_id` int(11) NOT NULL default '0',
  `chat_id` int(11) NOT NULL default '0',
  `room_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `start_time` int(11) NOT NULL default '0',
  `end_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`record_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_records`
--

/*!40000 ALTER TABLE `chat_records` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_records` ENABLE KEYS */;

--
-- Table structure for table `chat_room_messages`
--

CREATE TABLE `chat_room_messages` (
  `entry_id` int(11) NOT NULL auto_increment,
  `chat_id` int(11) NOT NULL default '0',
  `room_id` int(11) NOT NULL default '0',
  `message` text,
  `commit_timestamp` timestamp NOT NULL,
  PRIMARY KEY  (`entry_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_room_messages`
--

/*!40000 ALTER TABLE `chat_room_messages` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_room_messages` ENABLE KEYS */;

--
-- Table structure for table `chat_rooms`
--

CREATE TABLE `chat_rooms` (
  `room_id` int(11) NOT NULL auto_increment,
  `chat_id` int(11) NOT NULL default '0',
  `title` varchar(64) default NULL,
  `owner` int(11) NOT NULL default '0',
  PRIMARY KEY  (`room_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_rooms`
--

/*!40000 ALTER TABLE `chat_rooms` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_rooms` ENABLE KEYS */;

--
-- Table structure for table `chat_user`
--

CREATE TABLE `chat_user` (
  `usr_id` int(11) NOT NULL default '0',
  `chat_id` int(11) NOT NULL default '0',
  `room_id` int(11) NOT NULL default '0',
  `last_conn_timestamp` int(14) default NULL,
  `kicked` tinyint(4) default '0',
  PRIMARY KEY  (`usr_id`,`chat_id`,`room_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `chat_user`
--

/*!40000 ALTER TABLE `chat_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `chat_user` ENABLE KEYS */;

--
-- Table structure for table `cmi_comment`
--

CREATE TABLE `cmi_comment` (
  `cmi_comment_id` int(11) NOT NULL auto_increment,
  `cmi_node_id` int(11) default NULL,
  `comment` text,
  `timestamp` varchar(20) default NULL,
  `location` varchar(255) default NULL,
  `sourceIsLMS` tinyint(4) default NULL,
  PRIMARY KEY  (`cmi_comment_id`),
  KEY `cmi_comment_id` (`cmi_comment_id`),
  KEY `cmi_id` (`cmi_node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cmi_comment`
--

/*!40000 ALTER TABLE `cmi_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `cmi_comment` ENABLE KEYS */;

--
-- Table structure for table `cmi_correct_response`
--

CREATE TABLE `cmi_correct_response` (
  `cmi_correct_response_id` int(11) NOT NULL auto_increment,
  `cmi_interaction_id` int(11) default NULL,
  `pattern` varchar(255) default NULL,
  PRIMARY KEY  (`cmi_correct_response_id`),
  KEY `cmi_correct_response_id` (`cmi_correct_response_id`),
  KEY `cmi_correct_responsecmi_interaction_id` (`cmi_interaction_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cmi_correct_response`
--

/*!40000 ALTER TABLE `cmi_correct_response` DISABLE KEYS */;
/*!40000 ALTER TABLE `cmi_correct_response` ENABLE KEYS */;

--
-- Table structure for table `cmi_custom`
--

CREATE TABLE `cmi_custom` (
  `sco_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `lvalue` varchar(64) NOT NULL default '',
  `rvalue` text,
  `timestamp` timestamp NOT NULL,
  PRIMARY KEY  (`user_id`,`lvalue`,`obj_id`,`sco_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cmi_custom`
--

/*!40000 ALTER TABLE `cmi_custom` DISABLE KEYS */;
/*!40000 ALTER TABLE `cmi_custom` ENABLE KEYS */;

--
-- Table structure for table `cmi_gobjective`
--

CREATE TABLE `cmi_gobjective` (
  `user_id` int(11) default NULL,
  `satisfied` varchar(50) default NULL,
  `measure` varchar(50) default NULL,
  `scope_id` int(11) default NULL,
  `status` varchar(50) default NULL,
  `objective_id` varchar(255) default NULL,
  UNIQUE KEY `gobjective` (`user_id`,`objective_id`,`scope_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cmi_gobjective`
--

/*!40000 ALTER TABLE `cmi_gobjective` DISABLE KEYS */;
/*!40000 ALTER TABLE `cmi_gobjective` ENABLE KEYS */;

--
-- Table structure for table `cmi_interaction`
--

CREATE TABLE `cmi_interaction` (
  `cmi_interaction_id` int(11) NOT NULL auto_increment,
  `cmi_node_id` int(11) default NULL,
  `description` text,
  `id` varchar(255) default NULL,
  `latency` varchar(20) default NULL,
  `learner_response` text,
  `result` text,
  `timestamp` varchar(20) default NULL,
  `type` varchar(32) default NULL,
  `weighting` double default NULL,
  PRIMARY KEY  (`cmi_interaction_id`),
  KEY `cmi_interaction_id` (`cmi_interaction_id`),
  KEY `id` (`id`),
  KEY `type` (`type`)
) TYPE=MyISAM;

--
-- Dumping data for table `cmi_interaction`
--

/*!40000 ALTER TABLE `cmi_interaction` DISABLE KEYS */;
/*!40000 ALTER TABLE `cmi_interaction` ENABLE KEYS */;

--
-- Table structure for table `cmi_node`
--

CREATE TABLE `cmi_node` (
  `accesscount` int(11) default NULL,
  `accessduration` varchar(20) default NULL,
  `accessed` varchar(20) default NULL,
  `activityAbsoluteDuration` varchar(20) default NULL,
  `activityAttemptCount` int(11) default NULL,
  `activityExperiencedDuration` varchar(20) default NULL,
  `activityProgressStatus` tinyint(4) default NULL,
  `attemptAbsoluteDuration` varchar(20) default NULL,
  `attemptCompletionAmount` double default NULL,
  `attemptCompletionStatus` tinyint(4) default NULL,
  `attemptExperiencedDuration` varchar(20) default NULL,
  `attemptProgressStatus` tinyint(4) default NULL,
  `audio_captioning` int(11) default NULL,
  `audio_level` double default NULL,
  `availableChildren` varchar(255) default NULL,
  `cmi_node_id` int(11) NOT NULL auto_increment,
  `completion` double default NULL,
  `completion_status` varchar(32) default NULL,
  `completion_threshold` varchar(32) default NULL,
  `cp_node_id` int(11) default NULL,
  `created` varchar(20) default NULL,
  `credit` varchar(32) default NULL,
  `delivery_speed` double default NULL,
  `entry` varchar(255) default NULL,
  `exit` varchar(255) default NULL,
  `language` varchar(5) default NULL,
  `launch_data` text,
  `learner_name` varchar(255) default NULL,
  `location` varchar(255) default NULL,
  `max` double default NULL,
  `min` double default NULL,
  `mode` varchar(20) default NULL,
  `modified` varchar(20) default NULL,
  `progress_measure` double default NULL,
  `raw` double default NULL,
  `scaled` double default NULL,
  `scaled_passing_score` double default NULL,
  `session_time` varchar(20) default NULL,
  `success_status` varchar(255) default NULL,
  `suspend_data` text,
  `total_time` varchar(20) default NULL,
  `user_id` int(11) default NULL,
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`cmi_node_id`),
  KEY `cmi_itemcp_id` (`cp_node_id`),
  KEY `completion_status` (`completion_status`),
  KEY `credit` (`credit`),
  KEY `id` (`cmi_node_id`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cmi_node`
--

/*!40000 ALTER TABLE `cmi_node` DISABLE KEYS */;
/*!40000 ALTER TABLE `cmi_node` ENABLE KEYS */;

--
-- Table structure for table `cmi_objective`
--

CREATE TABLE `cmi_objective` (
  `cmi_interaction_id` int(11) default NULL,
  `cmi_node_id` int(11) default NULL,
  `cmi_objective_id` int(11) NOT NULL auto_increment,
  `completion_status` double default NULL,
  `description` text,
  `id` varchar(255) default NULL,
  `max` double default NULL,
  `min` double default NULL,
  `raw` double default NULL,
  `scaled` double default NULL,
  `progress_measure` double default NULL,
  `success_status` varchar(32) default NULL,
  `scope` varchar(16) default NULL,
  PRIMARY KEY  (`cmi_objective_id`),
  KEY `cmi_objective_id` (`cmi_objective_id`),
  KEY `cmi_objectivecmi_interaction_id` (`cmi_interaction_id`),
  KEY `id` (`id`),
  KEY `success_status` (`success_status`)
) TYPE=MyISAM;

--
-- Dumping data for table `cmi_objective`
--

/*!40000 ALTER TABLE `cmi_objective` DISABLE KEYS */;
/*!40000 ALTER TABLE `cmi_objective` ENABLE KEYS */;

--
-- Table structure for table `conditions`
--

CREATE TABLE `conditions` (
  `id` int(11) NOT NULL auto_increment,
  `target_ref_id` int(11) NOT NULL default '0',
  `target_obj_id` int(11) NOT NULL default '0',
  `target_type` varchar(8) NOT NULL default '',
  `trigger_ref_id` int(11) NOT NULL default '0',
  `trigger_obj_id` int(11) NOT NULL default '0',
  `trigger_type` varchar(8) NOT NULL default '',
  `operator` varchar(64) default NULL,
  `value` varchar(64) default NULL,
  `ref_handling` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `conditions`
--

/*!40000 ALTER TABLE `conditions` DISABLE KEYS */;
/*!40000 ALTER TABLE `conditions` ENABLE KEYS */;

--
-- Table structure for table `container_reference`
--

CREATE TABLE `container_reference` (
  `obj_id` int(11) NOT NULL,
  `target_obj_id` int(11) NOT NULL,
  PRIMARY KEY  (`obj_id`,`target_obj_id`),
  KEY `obj_id` (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `container_reference`
--

/*!40000 ALTER TABLE `container_reference` DISABLE KEYS */;
/*!40000 ALTER TABLE `container_reference` ENABLE KEYS */;

--
-- Table structure for table `container_settings`
--

CREATE TABLE `container_settings` (
  `id` int(11) NOT NULL default '0',
  `keyword` char(40) NOT NULL default '',
  `value` char(50) default NULL,
  PRIMARY KEY  (`id`,`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `container_settings`
--

/*!40000 ALTER TABLE `container_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `container_settings` ENABLE KEYS */;

--
-- Table structure for table `container_sorting`
--

CREATE TABLE `container_sorting` (
  `obj_id` int(11) NOT NULL default '0',
  `parent_type` varchar(5) NOT NULL,
  `parent_id` int(11) NOT NULL,
  `child_id` int(11) NOT NULL,
  `position` decimal(10,2) NOT NULL,
  PRIMARY KEY  (`obj_id`,`parent_type`,`parent_id`,`child_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `container_sorting`
--

/*!40000 ALTER TABLE `container_sorting` DISABLE KEYS */;
/*!40000 ALTER TABLE `container_sorting` ENABLE KEYS */;

--
-- Table structure for table `container_sorting_settings`
--

CREATE TABLE `container_sorting_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `sort_mode` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `container_sorting_settings`
--

/*!40000 ALTER TABLE `container_sorting_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `container_sorting_settings` ENABLE KEYS */;

--
-- Table structure for table `content_object`
--

CREATE TABLE `content_object` (
  `id` int(11) NOT NULL default '0',
  `default_layout` varchar(100) NOT NULL default 'toc2win',
  `stylesheet` int(11) NOT NULL default '0',
  `page_header` enum('st_title','pg_title','none') default 'st_title',
  `online` enum('y','n') default 'n',
  `toc_active` enum('y','n') default 'y',
  `lm_menu_active` enum('y','n') default 'y',
  `toc_mode` enum('chapters','pages') default 'chapters',
  `clean_frames` enum('y','n') NOT NULL default 'n',
  `print_view_active` enum('y','n') default 'y',
  `numbering` enum('y','n') default 'n',
  `hist_user_comments` enum('y','n') default 'n',
  `public_access_mode` enum('complete','selected') NOT NULL default 'complete',
  `public_html_file` varchar(50) NOT NULL default '',
  `public_xml_file` varchar(50) NOT NULL default '',
  `downloads_active` enum('y','n') default 'n',
  `downloads_public_active` enum('y','n') NOT NULL default 'y',
  `pub_notes` enum('y','n') NOT NULL default 'n',
  `header_page` int(11) NOT NULL default '0',
  `footer_page` int(11) NOT NULL default '0',
  `prevent_glossary_appendix_active` enum('y','n') default 'n',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `content_object`
--

/*!40000 ALTER TABLE `content_object` DISABLE KEYS */;
/*!40000 ALTER TABLE `content_object` ENABLE KEYS */;

--
-- Table structure for table `copy_wizard_options`
--

CREATE TABLE `copy_wizard_options` (
  `copy_id` int(11) NOT NULL default '0',
  `source_id` int(11) NOT NULL default '0',
  `options` longtext NOT NULL,
  PRIMARY KEY  (`copy_id`,`source_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `copy_wizard_options`
--

/*!40000 ALTER TABLE `copy_wizard_options` DISABLE KEYS */;
/*!40000 ALTER TABLE `copy_wizard_options` ENABLE KEYS */;

--
-- Table structure for table `cp_auxilaryResource`
--

CREATE TABLE `cp_auxilaryResource` (
  `auxiliaryResourceID` varchar(255) default NULL,
  `cp_node_id` int(11) NOT NULL default '0',
  `purpose` varchar(255) default NULL,
  PRIMARY KEY  (`cp_node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_auxilaryResource`
--

/*!40000 ALTER TABLE `cp_auxilaryResource` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_auxilaryResource` ENABLE KEYS */;

--
-- Table structure for table `cp_condition`
--

CREATE TABLE `cp_condition` (
  `condition` varchar(50) default NULL,
  `cp_node_id` int(11) NOT NULL default '0',
  `measureThreshold` varchar(50) default NULL,
  `operator` varchar(50) default NULL,
  `referencedObjective` varchar(50) default NULL,
  PRIMARY KEY  (`cp_node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_condition`
--

/*!40000 ALTER TABLE `cp_condition` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_condition` ENABLE KEYS */;

--
-- Table structure for table `cp_dependency`
--

CREATE TABLE `cp_dependency` (
  `cp_node_id` int(11) NOT NULL default '0',
  `resourceId` varchar(50) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `cp_id` (`cp_node_id`),
  KEY `identifierref` (`resourceId`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_dependency`
--

/*!40000 ALTER TABLE `cp_dependency` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_dependency` ENABLE KEYS */;

--
-- Table structure for table `cp_file`
--

CREATE TABLE `cp_file` (
  `cp_node_id` int(11) NOT NULL default '0',
  `href` varchar(50) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `cp_id` (`cp_node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_file`
--

/*!40000 ALTER TABLE `cp_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_file` ENABLE KEYS */;

--
-- Table structure for table `cp_hidelmsui`
--

CREATE TABLE `cp_hidelmsui` (
  `cp_node_id` int(11) NOT NULL default '0',
  `value` varchar(50) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `ss_sequencing_id` (`value`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_hidelmsui`
--

/*!40000 ALTER TABLE `cp_hidelmsui` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_hidelmsui` ENABLE KEYS */;

--
-- Table structure for table `cp_item`
--

CREATE TABLE `cp_item` (
  `completionThreshold` varchar(50) default NULL,
  `cp_node_id` int(11) NOT NULL default '0',
  `dataFromLMS` varchar(255) default NULL,
  `id` varchar(200) default NULL,
  `isvisible` varchar(32) default NULL,
  `parameters` varchar(255) default NULL,
  `resourceId` varchar(200) default NULL,
  `sequencingId` varchar(50) default NULL,
  `timeLimitAction` varchar(30) default NULL,
  `title` varchar(255) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `cp_itemidentifier` (`id`),
  KEY `ss_sequencing_id` (`sequencingId`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_item`
--

/*!40000 ALTER TABLE `cp_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_item` ENABLE KEYS */;

--
-- Table structure for table `cp_manifest`
--

CREATE TABLE `cp_manifest` (
  `base` varchar(200) default NULL,
  `cp_node_id` int(11) NOT NULL default '0',
  `defaultOrganization` varchar(50) default NULL,
  `id` varchar(200) default NULL,
  `title` varchar(255) default NULL,
  `uri` varchar(255) default NULL,
  `version` varchar(200) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `identifier` (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_manifest`
--

/*!40000 ALTER TABLE `cp_manifest` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_manifest` ENABLE KEYS */;

--
-- Table structure for table `cp_mapinfo`
--

CREATE TABLE `cp_mapinfo` (
  `cp_node_id` int(11) NOT NULL default '0',
  `readNormalizedMeasure` tinyint(4) default NULL,
  `readSatisfiedStatus` tinyint(4) default NULL,
  `targetObjectiveID` varchar(50) default NULL,
  `writeNormalizedMeasure` tinyint(4) default NULL,
  `writeSatisfiedStatus` tinyint(4) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `targetObjectiveId` (`targetObjectiveID`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_mapinfo`
--

/*!40000 ALTER TABLE `cp_mapinfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_mapinfo` ENABLE KEYS */;

--
-- Table structure for table `cp_node`
--

CREATE TABLE `cp_node` (
  `cp_node_id` int(11) NOT NULL auto_increment,
  `nodeName` varchar(50) default NULL,
  `slm_id` int(11) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `cp_id` (`cp_node_id`),
  KEY `nodeName` (`nodeName`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_node`
--

/*!40000 ALTER TABLE `cp_node` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_node` ENABLE KEYS */;

--
-- Table structure for table `cp_objective`
--

CREATE TABLE `cp_objective` (
  `cp_node_id` int(11) NOT NULL default '0',
  `minNormalizedMeasure` varchar(50) default NULL,
  `objectiveID` varchar(200) default NULL,
  `primary` tinyint(4) default NULL,
  `satisfiedByMeasure` tinyint(4) default NULL,
  PRIMARY KEY  (`cp_node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_objective`
--

/*!40000 ALTER TABLE `cp_objective` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_objective` ENABLE KEYS */;

--
-- Table structure for table `cp_organization`
--

CREATE TABLE `cp_organization` (
  `cp_node_id` int(11) NOT NULL default '0',
  `id` varchar(200) default NULL,
  `objectivesGlobalToSystem` tinyint(4) default NULL,
  `sequencingId` varchar(50) default NULL,
  `structure` varchar(200) default NULL,
  `title` varchar(255) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `cp_organizationid` (`id`),
  KEY `ss_sequencing_id` (`sequencingId`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_organization`
--

/*!40000 ALTER TABLE `cp_organization` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_organization` ENABLE KEYS */;

--
-- Table structure for table `cp_package`
--

CREATE TABLE `cp_package` (
  `created` varchar(20) default NULL,
  `identifier` varchar(255) default NULL,
  `jsdata` mediumtext,
  `modified` varchar(20) default NULL,
  `obj_id` int(11) NOT NULL default '0',
  `persistPreviousAttempts` int(11) default NULL,
  `settings` varchar(255) default NULL,
  `xmldata` text,
  `activitytree` mediumtext,
  `global_to_system` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`obj_id`),
  KEY `identifier` (`identifier`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_package`
--

/*!40000 ALTER TABLE `cp_package` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_package` ENABLE KEYS */;

--
-- Table structure for table `cp_resource`
--

CREATE TABLE `cp_resource` (
  `base` varchar(200) default NULL,
  `cp_node_id` int(11) NOT NULL default '0',
  `href` varchar(250) default NULL,
  `id` varchar(200) default NULL,
  `scormType` varchar(32) default NULL,
  `type` varchar(30) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `import_id` (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_resource`
--

/*!40000 ALTER TABLE `cp_resource` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_resource` ENABLE KEYS */;

--
-- Table structure for table `cp_rule`
--

CREATE TABLE `cp_rule` (
  `action` varchar(50) default NULL,
  `childActivitySet` varchar(50) default NULL,
  `conditionCombination` varchar(50) default NULL,
  `cp_node_id` int(11) NOT NULL default '0',
  `minimumCount` int(11) default NULL,
  `minimumPercent` varchar(50) default NULL,
  `type` varchar(50) default NULL,
  PRIMARY KEY  (`cp_node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_rule`
--

/*!40000 ALTER TABLE `cp_rule` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_rule` ENABLE KEYS */;

--
-- Table structure for table `cp_sequencing`
--

CREATE TABLE `cp_sequencing` (
  `activityAbsoluteDurationLimit` varchar(20) default NULL,
  `activityExperiencedDurationLimit` varchar(20) default NULL,
  `attemptAbsoluteDurationLimit` varchar(20) default NULL,
  `attemptExperiencedDurationLimit` varchar(20) default NULL,
  `attemptLimit` int(11) default NULL,
  `beginTimeLimit` varchar(20) default NULL,
  `choice` tinyint(4) default NULL,
  `choiceExit` tinyint(4) default NULL,
  `completionSetByContent` tinyint(4) default NULL,
  `constrainChoice` tinyint(4) default NULL,
  `cp_node_id` int(11) NOT NULL default '0',
  `endTimeLimit` varchar(20) default NULL,
  `flow` tinyint(4) default NULL,
  `forwardOnly` tinyint(4) default NULL,
  `id` varchar(200) default NULL,
  `measureSatisfactionIfActive` tinyint(4) default NULL,
  `objectiveMeasureWeight` double default NULL,
  `objectiveSetByContent` tinyint(4) default NULL,
  `preventActivation` tinyint(4) default NULL,
  `randomizationTiming` varchar(50) default NULL,
  `reorderChildren` tinyint(4) default NULL,
  `requiredForCompleted` varchar(50) default NULL,
  `requiredForIncomplete` varchar(50) default NULL,
  `requiredForNotSatisfied` varchar(50) default NULL,
  `requiredForSatisfied` varchar(50) default NULL,
  `rollupObjectiveSatisfied` tinyint(4) default NULL,
  `rollupProgressCompletion` tinyint(4) default NULL,
  `selectCount` int(11) default NULL,
  `selectionTiming` varchar(50) default NULL,
  `sequencingId` varchar(50) default NULL,
  `tracked` tinyint(4) default NULL,
  `useCurrentAttemptObjectiveInfo` tinyint(4) default NULL,
  `useCurrentAttemptProgressInfo` tinyint(4) default NULL,
  PRIMARY KEY  (`cp_node_id`),
  KEY `cp_sequencingid` (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_sequencing`
--

/*!40000 ALTER TABLE `cp_sequencing` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_sequencing` ENABLE KEYS */;

--
-- Table structure for table `cp_suspend`
--

CREATE TABLE `cp_suspend` (
  `data` mediumtext,
  `user_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  UNIQUE KEY `user_obj` (`user_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_suspend`
--

/*!40000 ALTER TABLE `cp_suspend` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_suspend` ENABLE KEYS */;

--
-- Table structure for table `cp_tree`
--

CREATE TABLE `cp_tree` (
  `child` int(11) default NULL,
  `depth` int(11) default NULL,
  `lft` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `parent` int(11) default NULL,
  `rgt` int(11) default NULL,
  KEY `child` (`child`),
  KEY `cp_treeobj_id` (`obj_id`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `cp_tree`
--

/*!40000 ALTER TABLE `cp_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `cp_tree` ENABLE KEYS */;

--
-- Table structure for table `crs_archives`
--

CREATE TABLE `crs_archives` (
  `archive_id` int(11) NOT NULL auto_increment,
  `course_id` int(11) NOT NULL default '0',
  `archive_name` varchar(255) NOT NULL default '',
  `archive_type` tinyint(2) NOT NULL default '0',
  `archive_date` int(11) default NULL,
  `archive_size` int(11) default NULL,
  `archive_lang` varchar(16) default NULL,
  PRIMARY KEY  (`archive_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_archives`
--

/*!40000 ALTER TABLE `crs_archives` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_archives` ENABLE KEYS */;

--
-- Table structure for table `crs_defined_field_definitions`
--

CREATE TABLE `crs_defined_field_definitions` (
  `field_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `field_name` varchar(255) NOT NULL default '',
  `field_type` tinyint(1) NOT NULL default '0',
  `field_values` text NOT NULL,
  `field_required` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`field_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_defined_field_definitions`
--

/*!40000 ALTER TABLE `crs_defined_field_definitions` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_defined_field_definitions` ENABLE KEYS */;

--
-- Table structure for table `crs_file`
--

CREATE TABLE `crs_file` (
  `file_id` int(11) NOT NULL auto_increment,
  `course_id` int(11) NOT NULL default '0',
  `file_name` char(64) NOT NULL default '',
  `file_type` char(64) NOT NULL default '',
  `file_size` int(11) NOT NULL default '0',
  PRIMARY KEY  (`file_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_file`
--

/*!40000 ALTER TABLE `crs_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_file` ENABLE KEYS */;

--
-- Table structure for table `crs_groupings`
--

CREATE TABLE `crs_groupings` (
  `crs_grp_id` int(11) NOT NULL default '0',
  `crs_ref_id` int(11) NOT NULL default '0',
  `crs_id` int(11) NOT NULL default '0',
  `unique_field` char(32) NOT NULL default '',
  PRIMARY KEY  (`crs_grp_id`),
  KEY `crs_id` (`crs_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_groupings`
--

/*!40000 ALTER TABLE `crs_groupings` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_groupings` ENABLE KEYS */;

--
-- Table structure for table `crs_items`
--

CREATE TABLE `crs_items` (
  `parent_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `timing_type` tinyint(2) default NULL,
  `timing_start` int(8) default NULL,
  `timing_end` int(8) default NULL,
  `suggestion_start` int(11) NOT NULL default '0',
  `suggestion_end` int(11) NOT NULL default '0',
  `changeable` tinyint(1) NOT NULL default '0',
  `earliest_start` int(11) NOT NULL default '0',
  `latest_end` int(11) NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '0',
  `position` int(11) default NULL,
  PRIMARY KEY  (`parent_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_items`
--

/*!40000 ALTER TABLE `crs_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_items` ENABLE KEYS */;

--
-- Table structure for table `crs_lm_history`
--

CREATE TABLE `crs_lm_history` (
  `usr_id` int(11) NOT NULL default '0',
  `crs_ref_id` int(11) NOT NULL default '0',
  `lm_ref_id` int(11) NOT NULL default '0',
  `lm_page_id` int(11) NOT NULL default '0',
  `last_access` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`crs_ref_id`,`lm_ref_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_lm_history`
--

/*!40000 ALTER TABLE `crs_lm_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_lm_history` ENABLE KEYS */;

--
-- Table structure for table `crs_members`
--

CREATE TABLE `crs_members` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `blocked` tinyint(2) NOT NULL default '0',
  `notification` tinyint(2) NOT NULL default '0',
  `passed` tinyint(1) default NULL,
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_members`
--

/*!40000 ALTER TABLE `crs_members` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_members` ENABLE KEYS */;

--
-- Table structure for table `crs_objective_lm`
--

CREATE TABLE `crs_objective_lm` (
  `lm_ass_id` int(11) NOT NULL auto_increment,
  `objective_id` int(11) NOT NULL default '0',
  `ref_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `type` char(6) NOT NULL default '',
  PRIMARY KEY  (`lm_ass_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_lm`
--

/*!40000 ALTER TABLE `crs_objective_lm` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_objective_lm` ENABLE KEYS */;

--
-- Table structure for table `crs_objective_qst`
--

CREATE TABLE `crs_objective_qst` (
  `qst_ass_id` int(11) NOT NULL auto_increment,
  `objective_id` int(11) NOT NULL default '0',
  `ref_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `question_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`qst_ass_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_qst`
--

/*!40000 ALTER TABLE `crs_objective_qst` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_objective_qst` ENABLE KEYS */;

--
-- Table structure for table `crs_objective_results`
--

CREATE TABLE `crs_objective_results` (
  `res_id` int(11) NOT NULL auto_increment,
  `usr_id` int(11) NOT NULL default '0',
  `question_id` int(11) NOT NULL default '0',
  `points` int(11) NOT NULL default '0',
  PRIMARY KEY  (`res_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_results`
--

/*!40000 ALTER TABLE `crs_objective_results` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_objective_results` ENABLE KEYS */;

--
-- Table structure for table `crs_objective_status`
--

CREATE TABLE `crs_objective_status` (
  `objective_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `status` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`objective_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_status`
--

/*!40000 ALTER TABLE `crs_objective_status` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_objective_status` ENABLE KEYS */;

--
-- Table structure for table `crs_objective_status_pretest`
--

CREATE TABLE `crs_objective_status_pretest` (
  `objective_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`objective_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_status_pretest`
--

/*!40000 ALTER TABLE `crs_objective_status_pretest` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_objective_status_pretest` ENABLE KEYS */;

--
-- Table structure for table `crs_objective_tst`
--

CREATE TABLE `crs_objective_tst` (
  `test_objective_id` int(11) NOT NULL auto_increment,
  `objective_id` int(11) NOT NULL default '0',
  `ref_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `tst_status` tinyint(2) default NULL,
  `tst_limit` tinyint(3) default NULL,
  PRIMARY KEY  (`test_objective_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objective_tst`
--

/*!40000 ALTER TABLE `crs_objective_tst` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_objective_tst` ENABLE KEYS */;

--
-- Table structure for table `crs_objectives`
--

CREATE TABLE `crs_objectives` (
  `crs_id` int(11) NOT NULL default '0',
  `objective_id` int(11) NOT NULL auto_increment,
  `title` varchar(70) NOT NULL default '',
  `description` varchar(128) NOT NULL default '',
  `position` int(3) NOT NULL default '0',
  `created` int(11) NOT NULL default '0',
  PRIMARY KEY  (`objective_id`),
  KEY `crs_id` (`crs_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_objectives`
--

/*!40000 ALTER TABLE `crs_objectives` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_objectives` ENABLE KEYS */;

--
-- Table structure for table `crs_settings`
--

CREATE TABLE `crs_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `syllabus` text,
  `contact_name` varchar(255) default NULL,
  `contact_responsibility` varchar(255) default NULL,
  `contact_phone` varchar(255) default NULL,
  `contact_email` varchar(255) default NULL,
  `contact_consultation` text,
  `activation_type` tinyint(1) NOT NULL default '0',
  `activation_start` int(11) default NULL,
  `activation_end` int(11) default NULL,
  `subscription_limitation_type` tinyint(1) NOT NULL default '0',
  `subscription_start` int(11) default NULL,
  `subscription_end` int(11) default NULL,
  `subscription_type` int(2) default NULL,
  `subscription_password` varchar(32) default NULL,
  `subscription_membership_limitation` tinyint(1) NOT NULL default '0',
  `subscription_max_members` int(4) default NULL,
  `subscription_notify` int(2) default NULL,
  `view_mode` tinyint(1) NOT NULL default '0',
  `sortorder` int(2) default NULL,
  `archive_start` int(11) default NULL,
  `archive_end` int(11) default NULL,
  `archive_type` int(2) default NULL,
  `abo` tinyint(2) default '1',
  `waiting_list` tinyint(1) NOT NULL default '1',
  `important` text NOT NULL,
  `show_members` tinyint(4) NOT NULL default '1',
  `latitude` varchar(30) NOT NULL default '',
  `longitude` varchar(30) NOT NULL default '',
  `location_zoom` int(11) NOT NULL default '0',
  `enable_course_map` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_settings`
--

/*!40000 ALTER TABLE `crs_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_settings` ENABLE KEYS */;

--
-- Table structure for table `crs_start`
--

CREATE TABLE `crs_start` (
  `crs_start_id` int(11) NOT NULL auto_increment,
  `crs_id` int(11) NOT NULL default '0',
  `item_ref_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`crs_start_id`),
  KEY `crs_id` (`crs_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_start`
--

/*!40000 ALTER TABLE `crs_start` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_start` ENABLE KEYS */;

--
-- Table structure for table `crs_timings_planed`
--

CREATE TABLE `crs_timings_planed` (
  `item_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `planed_start` int(11) NOT NULL default '0',
  `planed_end` int(11) NOT NULL default '0',
  PRIMARY KEY  (`item_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_timings_planed`
--

/*!40000 ALTER TABLE `crs_timings_planed` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_timings_planed` ENABLE KEYS */;

--
-- Table structure for table `crs_timings_usr_accept`
--

CREATE TABLE `crs_timings_usr_accept` (
  `crs_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `accept` tinyint(1) NOT NULL default '0',
  `remark` text NOT NULL,
  `visible` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`crs_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_timings_usr_accept`
--

/*!40000 ALTER TABLE `crs_timings_usr_accept` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_timings_usr_accept` ENABLE KEYS */;

--
-- Table structure for table `crs_user_data`
--

CREATE TABLE `crs_user_data` (
  `usr_id` int(11) NOT NULL default '0',
  `field_id` int(11) NOT NULL default '0',
  `value` text NOT NULL,
  PRIMARY KEY  (`usr_id`,`field_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_user_data`
--

/*!40000 ALTER TABLE `crs_user_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_user_data` ENABLE KEYS */;

--
-- Table structure for table `crs_waiting_list`
--

CREATE TABLE `crs_waiting_list` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `sub_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `crs_waiting_list`
--

/*!40000 ALTER TABLE `crs_waiting_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `crs_waiting_list` ENABLE KEYS */;

--
-- Table structure for table `ctrl_calls`
--

CREATE TABLE `ctrl_calls` (
  `parent` varchar(100) NOT NULL default '',
  `child` varchar(100) default NULL,
  `comp_prefix` varchar(50) NOT NULL default '',
  KEY `jmp_parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `ctrl_calls`
--

/*!40000 ALTER TABLE `ctrl_calls` DISABLE KEYS */;
INSERT INTO `ctrl_calls` VALUES ('ilcalendarinboxgui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendardaygui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarcategorygui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarblockgui','ilcalendarinboxgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarblockgui','ilcalendarweekgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarblockgui','ilcalendarmonthgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarblockgui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarblockgui','ilcalendardaygui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdtaggingblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilusersonlineblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdselecteditemsblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilbookmarkblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdnotesblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdnewsblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilnewsforcontextblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdsysmessageblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdmailblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdexternalfeedblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdfeedbackblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilpdcalendarblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilcalendarblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilhtmlblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ilexternalfeedblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','ildummyblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcolumngui','','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendargui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjauthsettingsgui','ilradiussettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjauthsettingsgui','illdapsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjauthsettingsgui','ilregistrationsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjauthsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('iladvancedmdsettingsgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjadvancededitinggui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrecoveryfoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexternaltoolssettingsgui','ilecssettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexternaltoolssettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjroletemplategui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrolegui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrolefoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentobjectgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentgui','ilpurchasebmfgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentgui','ilpaymentbuyedobjectsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentgui','ilpaymentshoppingcartgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymentcoupongui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymentbilladmingui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymentobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymentstatisticgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpaymentadmingui','ilpaymenttrusteegui','');
INSERT INTO `ctrl_calls` VALUES ('ilwikipagegui','ilnotegui','');
INSERT INTO `ctrl_calls` VALUES ('ilwikipagegui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilwikipagegui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilwikipagegui','ilratinggui','');
INSERT INTO `ctrl_calls` VALUES ('ilwikipagegui','ilmediapooltargetselector','');
INSERT INTO `ctrl_calls` VALUES ('ilwikipagegui','ileditclipboardgui','');
INSERT INTO `ctrl_calls` VALUES ('ilwikipagegui','ilpageeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilwikihandlergui','ilobjwikigui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjwikigui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjwikigui','ilwikipagegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjwikigui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjwikigui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlinkresourcegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlinkresourcegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlinkresourcegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('illinkresourcehandlergui','ilobjlinkresourcegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','asstextquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','asssinglechoicegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','asstextsubsetgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assnumericgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assjavaappletgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assimagemapquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assorderingquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assmatchingquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assclozetestgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assmultiplechoicegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjquestionpoolgui','assquestiontypetemplategui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','iltestservicegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilshoppurchasegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','iltestscoringgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','iltestcertificategui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','iltestevaluationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','iltestoutputgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtestgui','ilobjcoursegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjassessmentfoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsystemfoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','ilsurveyphrasesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveymatrixquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveytextquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveyordinalquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveymetricquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyquestionpoolgui','surveynominalquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilsurveyexecutiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveygui','ilsurveyevaluationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsurveyadministrationgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsessiongui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsessiongui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilshoppurchasegui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilscorm13player','');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilhacppresentationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilaiccpresentationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahspresentationgui','ilscormpresentationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahseditgui','ilobjscorm2004learningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahseditgui','ilobjhacplearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahseditgui','ilobjaicclearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('ilsahseditgui','ilobjscormlearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscormlearningmodulegui','ilfilesystemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsahslearningmodulegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsahslearningmodulegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsahslearningmodulegui','ilfilesystemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjhacplearningmodulegui','ilfilesystemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjaicclearningmodulegui','ilfilesystemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscorm2004learningmodulegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscorm2004learningmodulegui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscorm2004learningmodulegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscorm2004learningmodulegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjscorm2004learningmodulegui','ilfilesystemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrootfoldergui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrootfoldergui','ilcontainerlinklistgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrootfoldergui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjrootfoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjremotecoursegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjremotecoursegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ileditclipboardgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ilobjfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediapoolgui','ilobjmediaobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmediapoolpresentationgui','ilobjmediapoolgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediacastsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediacastgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediacastgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilmediacasthandlergui','ilobjmediacastgui','');
INSERT INTO `ctrl_calls` VALUES ('ilstructureobjectgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilstructureobjectgui','ilconditionhandlerinterface','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilobjstylesheetgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','ilstructureobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlearningmodulegui','illmpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilobjstylesheetgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','ilstructureobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjdlbookgui','illmpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('illmpresentationgui','ilshoppurchasegui','');
INSERT INTO `ctrl_calls` VALUES ('illmpresentationgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('illmpresentationgui','ilnotegui','');
INSERT INTO `ctrl_calls` VALUES ('illmpageobjectgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('illmeditorgui','ilobjlearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('illmeditorgui','ilobjdlbookgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilrepositorysearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjilinccoursegui','ilobjilincclassroomgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjilincclassroomgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilshoppurchasegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilebasedlmgui','ilfilesystemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilhtlmpresentationgui','ilobjfilebasedlmgui','');
INSERT INTO `ctrl_calls` VALUES ('ilhtlmeditorgui','ilobjfilebasedlmgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilcourseitemadministrationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilcoursecontentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilobjcoursegroupinggui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilrepositorysearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilconditionhandlerinterface','');
INSERT INTO `ctrl_calls` VALUES ('ilobjgroupgui','ilgroupregistrationgui','');
INSERT INTO `ctrl_calls` VALUES ('iltermdefinitioneditorgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('iltermdefinitioneditorgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjglossarygui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjglossarygui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjglossarygui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjglossarygui','ilglossarytermgui','');
INSERT INTO `ctrl_calls` VALUES ('ilglossarytermgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilglossarytermgui','iltermdefinitioneditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilglossarypresentationgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilglossarypresentationgui','ilnotegui','');
INSERT INTO `ctrl_calls` VALUES ('ilglossaryeditorgui','ilobjglossarygui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjforumgui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjforumgui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjforumgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjforumgui','ilforumexportgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjforumgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilcourseitemadministrationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilcoursecontentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfoldergui','ilconditionhandlerinterface','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilegui','ilshoppurchasegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfilegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjtaggingsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjfileaccesssettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcoursereferencegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcategoryreferencegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsurveyadministrationgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcalendarsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcomponentsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjmdsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjlanguageextgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjpersonaldesktopsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjnewssettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjprivacysecuritygui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjadvancededitinggui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjusertrackinggui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjexternaltoolssettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjassessmentfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjstylesettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsearchsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrecoveryfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjpaymentsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjobjectfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjmailgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjlanguagefoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjchatservergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjauthsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrolefoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsystemfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsessiongui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrootfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjstylesheetgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjroletemplategui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjlinkresourcegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjilincclassroomgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjilinccoursegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjuserfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjrolegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjusergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcategorygui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjfilebasedlmgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjmediapoolgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjexercisegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsurveygui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjtestgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsurveyquestionpoolgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjquestionpoolgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjglossarygui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjdlbookgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjlearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjforumgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjchatgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjsahslearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilcourseobjectivesgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjcoursegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjfilegui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjgroupgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjwikigui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjmediacastsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjmediacastgui','');
INSERT INTO `ctrl_calls` VALUES ('iladministrationgui','ilobjexternalfeedgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexternalfeedgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexternalfeedgui','ilexternalfeedblockgui','');
INSERT INTO `ctrl_calls` VALUES ('ilexternalfeedhandlergui','ilobjexternalfeedgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','ilrepositorysearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjexercisegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilexercisehandlergui','ilobjexercisegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursereferencegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursereferencegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilmemberexportgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcourseitemadministrationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilsessionoverviewgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcourseagreementgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcourseuserfieldsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilmemberexportgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcoursecontentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilconditionhandlerinterface','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilrepositorysearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilobjcoursegroupinggui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcourseobjectivesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilshoppurchasegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcoursegui','ilcourseregistrationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcourseregistrationgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilcourseobjectivepresentationgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilcourseitemadministrationgui','ilconditionhandlerinterface','');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentgui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentgui','ilcourseobjectivepresentationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcoursecontentgui','ilcoursearchivesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcourseagreementgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjchatservergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjchatgui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjchatgui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjchatgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilchatpresentationgui','ilobjchatgui','');
INSERT INTO `ctrl_calls` VALUES ('ilchathandlergui','ilobjchatgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategoryreferencegui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategoryreferencegui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilinfoscreengui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilobjuserfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilobjusergui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilcontainerlinklistgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcategorygui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjwikigui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjexternalfeedgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjcategoryreferencegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjcoursereferencegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjsessiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjremotecoursegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjmediacastgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjrootfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjlinkresourcegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjilincclassroomgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjilinccoursegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjrolegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjcategorygui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjfilebasedlmgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjmediapoolgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjexercisegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjsurveygui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjtestgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjsurveyquestionpoolgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjquestionpoolgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjglossarygui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjdlbookgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjlearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjforumgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjchatgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjsahslearningmodulegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilcourseobjectivesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjcoursegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjfilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('ilrepositorygui','ilobjgroupgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpermissiongui','ilobjrolegui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarmonthgui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarpresentationgui','ilcalendarmonthgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarpresentationgui','ilcalendarusersettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarpresentationgui','ilcalendarcategorygui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarpresentationgui','ilcalendarweekgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarpresentationgui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarpresentationgui','ilcalendardaygui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarpresentationgui','ilcalendarinboxgui','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarusersettingsgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilcalendarweekgui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcalendarsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdcalendarblockgui','ilcalendardaygui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdcalendarblockgui','ilcalendarappointmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdcalendarblockgui','ilcalendarmonthgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdcalendarblockgui','ilcalendarweekgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdcalendarblockgui','ilcalendarinboxgui','');
INSERT INTO `ctrl_calls` VALUES ('ileditclipboardgui','ilobjmediaobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjcomponentsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilcontainerlinklistgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcparagraphgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpctablegui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpctabledatagui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcmediaobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpclistgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpclistitemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcfilelistgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcfileitemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilobjmediaobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcsourcecodegui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilinternallinkgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcquestiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcsectiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcdatatablegui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcresourcesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcmapgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpcpluggedgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageeditorgui','ilpctabsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageobjectgui','ilpageeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageobjectgui','ileditclipboardgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageobjectgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpageobjectgui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilpcimagemapeditorgui','ilinternallinkgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpcmediaobjectgui','ilobjmediaobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpcmediaobjectgui','ilpcimagemapeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilfeedbackgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilinfoscreengui','ilnotegui','');
INSERT INTO `ctrl_calls` VALUES ('ilinfoscreengui','ilfeedbackgui','');
INSERT INTO `ctrl_calls` VALUES ('ilinfoscreengui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilinfoscreengui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilstartupgui','ilregistrationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilstartupgui','ilpasswordassistancegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlanguageextgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilobjlanguageextgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilpersonalprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilbookmarkadministrationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilobjusergui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilpdnotesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilfeedbackgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilpdnewsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonaldesktopgui','ilcalendarpresentationgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjlanguagefoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('illdapsettingsgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilmailaddressbookgui','ilmailsearchcoursesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailaddressbookgui','ilmailsearchgroupsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailaddressbookgui','ilmailinglistsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailfoldergui','ilmailaddressbookgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailfoldergui','ilmailattachmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailfoldergui','ilmailsearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailfoldergui','ilmailoptionsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailfoldergui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailformgui','ilmailfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailformgui','ilmailattachmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailformgui','ilmailsearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailformgui','ilmailsearchcoursesgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailformgui','ilmailsearchgroupsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailgui','ilmailfoldergui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailgui','ilmailformgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailgui','ilmailaddressbookgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailgui','ilmailoptionsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailgui','ilmailattachmentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailgui','ilmailsearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilmailgui','ilobjusergui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmailgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilimagemapeditorgui','ilinternallinkgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediaobjectgui','ilmdeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmediaobjectgui','ilimagemapeditorgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmdsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjmdsettingsgui','iladvancedmdsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilnewsforcontextblockgui','ilnewsitemgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjnewssettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdnewsgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilpdnotesgui','ilnotegui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdnotesgui','ilfeedbackgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjobjectfoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjpaymentsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjpaymentsettingsgui','ilshoptopicsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjpaymentsettingsgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilshopgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilshopadvancedsearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilshopshoppingcartgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilshopboughtobjectsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilpurchasebmfgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilshoppersonalsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilpaymentgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopcontroller','ilpaymentadmingui','');
INSERT INTO `ctrl_calls` VALUES ('ilshopgui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilshoppurchasegui','ilpageobjectgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpermanentlinkgui','ilnotegui','');
INSERT INTO `ctrl_calls` VALUES ('ilpermanentlinkgui','ilfeedbackgui','');
INSERT INTO `ctrl_calls` VALUES ('ilpermanentlinkgui','ilcolumngui','');
INSERT INTO `ctrl_calls` VALUES ('ilpermanentlinkgui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilbookmarkadministrationgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjpersonaldesktopsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilusersonlineblockgui','ilpublicuserprofilegui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjprivacysecuritygui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilregistrationgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilregistrationsettingsgui','','');
INSERT INTO `ctrl_calls` VALUES ('iladminusersearchgui','ilobjusergui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjsearchsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilsearchcontroller','ilsearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilsearchcontroller','iladvancedsearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilsearchcontroller','ilsearchresultgui','');
INSERT INTO `ctrl_calls` VALUES ('iluserfiltergui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjstylesettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjstylesheetgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjtaggingsettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illplistofobjectsgui','');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illplistofsettingsgui','');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illplistofprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('illearningprogressgui','illmstatisticsgui','');
INSERT INTO `ctrl_calls` VALUES ('illpfiltergui','','');
INSERT INTO `ctrl_calls` VALUES ('illpgui','','');
INSERT INTO `ctrl_calls` VALUES ('illplistofobjectsgui','illpfiltergui','');
INSERT INTO `ctrl_calls` VALUES ('illplistofobjectsgui','iluserfiltergui','');
INSERT INTO `ctrl_calls` VALUES ('illplistofobjectsgui','ilpdfpresentation','');
INSERT INTO `ctrl_calls` VALUES ('illplistofprogressgui','illpfiltergui','');
INSERT INTO `ctrl_calls` VALUES ('illplistofprogressgui','ilpdfpresentation','');
INSERT INTO `ctrl_calls` VALUES ('illplistofsettingsgui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjusertrackinggui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjusertrackinggui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilpdfpresentation','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjuserfoldergui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjuserfoldergui','iladminusersearchgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjusergui','illearningprogressgui','');
INSERT INTO `ctrl_calls` VALUES ('ilobjusergui','ilobjilincusergui','');
INSERT INTO `ctrl_calls` VALUES ('ilpersonalprofilegui','','');
INSERT INTO `ctrl_calls` VALUES ('ilobjfileaccesssettingsgui','ilpermissiongui','');
INSERT INTO `ctrl_calls` VALUES ('ilecssettingsgui','','');
/*!40000 ALTER TABLE `ctrl_calls` ENABLE KEYS */;

--
-- Table structure for table `ctrl_classfile`
--

CREATE TABLE `ctrl_classfile` (
  `class` varchar(100) NOT NULL default '',
  `file` varchar(250) default NULL,
  `comp_prefix` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`class`)
) TYPE=MyISAM;

--
-- Dumping data for table `ctrl_classfile`
--

/*!40000 ALTER TABLE `ctrl_classfile` DISABLE KEYS */;
INSERT INTO `ctrl_classfile` VALUES ('ilpdnotesblockgui','Services/Notes/classes/class.ilPDNotesBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdnewsgui','Services/News/classes/class.ilPDNewsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdnewsblockgui','Services/News/classes/class.ilPDNewsBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjnewssettingsgui','Services/News/classes/class.ilObjNewsSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilnewsforcontextblockgui','Services/News/classes/class.ilNewsForContextBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmdsettingsgui','Services/MetaData/classes/class.ilObjMDSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmediaobjectgui','Services/MediaObjects/classes/class.ilObjMediaObjectGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilimagemapeditorgui','Services/MediaObjects/classes/class.ilImageMapEditorGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdsysmessageblockgui','Services/Mail/classes/class.ilPDSysMessageBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdmailblockgui','Services/Mail/classes/class.ilPDMailBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmailgui','Services/Mail/classes/class.ilObjMailGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilmailgui','Services/Mail/classes/class.ilMailGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilmailformgui','Services/Mail/classes/class.ilMailFormGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilmailfoldergui','Services/Mail/classes/class.ilMailFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilmailaddressbookgui','Services/Mail/classes/class.ilMailAddressbookGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illdapsettingsgui','Services/LDAP/classes/class.ilLDAPSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjlanguagefoldergui','Services/Language/classes/class.ilObjLanguageFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjlanguageextgui','Services/Language/classes/class.ilObjLanguageExtGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilstartupgui','Services/Init/classes/class.ilStartUpGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilinfoscreengui','Services/InfoScreen/classes/class.ilInfoScreenGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdexternalfeedblockgui','Services/Feeds/classes/class.ilPDExternalFeedBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdfeedbackblockgui','Services/Feedback/classes/class.ilPDFeedbackBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilfeedbackgui','Services/Feedback/classes/class.ilFeedbackGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpcmediaobjectgui','Services/COPage/classes/class.ilPCMediaObjectGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpcimagemapeditorgui','Services/COPage/classes/class.ilPCImageMapEditorGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpageobjectgui','Services/COPage/classes/class.ilPageObjectGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpageeditorgui','Services/COPage/classes/class.ilPageEditorGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcontainerlinklistgui','Services/Container/classes/class.ilContainerLinkListGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcomponentsettingsgui','Services/Component/classes/class.ilObjComponentSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ileditclipboardgui','Services/Clipboard/classes/class.ilEditClipboardGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdcalendarblockgui','Services/Calendar/classes/class.ilPDCalendarBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcalendarsettingsgui','Services/Calendar/classes/class.ilObjCalendarSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendarweekgui','Services/Calendar/classes/class.ilCalendarWeekGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendarusersettingsgui','Services/Calendar/classes/class.ilCalendarUserSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendarpresentationgui','Services/Calendar/classes/class.ilCalendarPresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendarmonthgui','Services/Calendar/classes/class.ilCalendarMonthGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendarinboxgui','Services/Calendar/classes/class.ilCalendarInboxGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendardaygui','Services/Calendar/classes/class.ilCalendarDayGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendarcategorygui','Services/Calendar/classes/class.ilCalendarCategoryGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcalendarblockgui','Services/Calendar/classes/class.ilCalendarBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilhtmlblockgui','Services/Block/classes/class.ilHtmlBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilexternalfeedblockgui','Services/Block/classes/class.ilExternalFeedBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ildummyblockgui','Services/Block/classes/class.ilDummyBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcolumngui','Services/Block/classes/class.ilColumnGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjauthsettingsgui','Services/Authentication/classes/class.ilObjAuthSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('iladvancedmdsettingsgui','Services/AdvancedMetaData/classes/class.ilAdvancedMDSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjadvancededitinggui','Services/AdvancedEditing/classes/class.ilObjAdvancedEditingGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrecoveryfoldergui','Services/Administration/classes/class.ilObjRecoveryFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjexternaltoolssettingsgui','Services/Administration/classes/class.ilObjExternalToolsSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('iladministrationgui','Services/Administration/classes/class.ilAdministrationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjroletemplategui','Services/AccessControl/classes/class.ilObjRoleTemplateGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrolegui','Services/AccessControl/classes/class.ilObjRoleGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrolefoldergui','Services/AccessControl/classes/class.ilObjRoleFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpaymentobjectgui','payment/classes/class.ilPaymentObjectGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpaymentgui','payment/classes/class.ilPaymentGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpaymentadmingui','payment/classes/class.ilPaymentAdminGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilwikipagegui','Modules/Wiki/classes/class.ilWikiPageGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilwikihandlergui','Modules/Wiki/classes/class.ilWikiHandlerGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjwikigui','Modules/Wiki/classes/class.ilObjWikiGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjlinkresourcegui','Modules/WebResource/classes/class.ilObjLinkResourceGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illinkresourcehandlergui','Modules/WebResource/classes/class.ilLinkResourceHandlerGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjquestionpoolgui','Modules/TestQuestionPool/classes/class.ilObjQuestionPoolGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('assquestiontypetemplategui','Modules/TestQuestionPool/classes/class.assQuestionTypeTemplateGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('iltestservicegui','Modules/Test/classes/class.ilTestServiceGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjtestgui','Modules/Test/classes/class.ilObjTestGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjassessmentfoldergui','Modules/Test/classes/class.ilObjAssessmentFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsystemfoldergui','Modules/SystemFolder/classes/class.ilObjSystemFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsurveyquestionpoolgui','Modules/SurveyQuestionPool/classes/class.ilObjSurveyQuestionPoolGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsurveygui','Modules/Survey/classes/class.ilObjSurveyGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsurveyadministrationgui','Modules/Survey/classes/class.ilObjSurveyAdministrationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsessiongui','Modules/Session/classes/class.ilObjSessionGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilsahspresentationgui','Modules/ScormAicc/classes/class.ilSAHSPresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilsahseditgui','Modules/ScormAicc/classes/class.ilSAHSEditGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjscormlearningmodulegui','Modules/ScormAicc/classes/class.ilObjSCORMLearningModuleGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsahslearningmodulegui','Modules/ScormAicc/classes/class.ilObjSAHSLearningModuleGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjhacplearningmodulegui','Modules/ScormAicc/classes/class.ilObjHACPLearningModuleGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjaicclearningmodulegui','Modules/ScormAicc/classes/class.ilObjAICCLearningModuleGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjscorm2004learningmodulegui','Modules/Scorm2004/classes/class.ilObjSCORM2004LearningModuleGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjrootfoldergui','Modules/RootFolder/classes/class.ilObjRootFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjremotecoursegui','Modules/RemoteCourse/classes/class.ilObjRemoteCourseGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmediapoolgui','Modules/MediaPool/classes/class.ilObjMediaPoolGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilmediapoolpresentationgui','Modules/MediaPool/classes/class.ilMediaPoolPresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmediacastsettingsgui','Modules/MediaCast/classes/class.ilObjMediaCastSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjmediacastgui','Modules/MediaCast/classes/class.ilObjMediaCastGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilmediacasthandlergui','Modules/MediaCast/classes/class.ilMediaCastHandlerGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilstructureobjectgui','Modules/LearningModule/classes/class.ilStructureObjectGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjlearningmodulegui','Modules/LearningModule/classes/class.ilObjLearningModuleGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjdlbookgui','Modules/LearningModule/classes/class.ilObjDlBookGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illmpresentationgui','Modules/LearningModule/classes/class.ilLMPresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illmpageobjectgui','Modules/LearningModule/classes/class.ilLMPageObjectGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illmeditorgui','Modules/LearningModule/classes/class.ilLMEditorGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjilinccoursegui','Modules/ILinc/classes/class.ilObjiLincCourseGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjilincclassroomgui','Modules/ILinc/classes/class.ilObjiLincClassroomGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjfilebasedlmgui','Modules/HTMLLearningModule/classes/class.ilObjFileBasedLMGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilhtlmpresentationgui','Modules/HTMLLearningModule/classes/class.ilHTLMPresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilhtlmeditorgui','Modules/HTMLLearningModule/classes/class.ilHTLMEditorGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjgroupgui','Modules/Group/classes/class.ilObjGroupGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('iltermdefinitioneditorgui','Modules/Glossary/classes/class.ilTermDefinitionEditorGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjglossarygui','Modules/Glossary/classes/class.ilObjGlossaryGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilglossarytermgui','Modules/Glossary/classes/class.ilGlossaryTermGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilglossarypresentationgui','Modules/Glossary/classes/class.ilGlossaryPresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilglossaryeditorgui','Modules/Glossary/classes/class.ilGlossaryEditorGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjforumgui','Modules/Forum/classes/class.ilObjForumGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjfoldergui','Modules/Folder/classes/class.ilObjFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjfilegui','Modules/File/classes/class.ilObjFileGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjexternalfeedgui','Modules/ExternalFeed/classes/class.ilObjExternalFeedGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilexternalfeedhandlergui','Modules/ExternalFeed/classes/class.ilExternalFeedHandlerGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjexercisegui','Modules/Exercise/classes/class.ilObjExerciseGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilexercisehandlergui','Modules/Exercise/classes/class.ilExerciseHandlerGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcoursereferencegui','Modules/CourseReference/classes/class.ilObjCourseReferenceGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilmemberexportgui','Modules/Course/classes/Export/class.ilMemberExportGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcoursegui','Modules/Course/classes/class.ilObjCourseGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcourseregistrationgui','Modules/Course/classes/class.ilCourseRegistrationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcourseobjectivepresentationgui','Modules/Course/classes/class.ilCourseObjectivePresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcourseitemadministrationgui','Modules/Course/classes/class.ilCourseItemAdministrationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcoursecontentgui','Modules/Course/classes/class.ilCourseContentGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilcourseagreementgui','Modules/Course/classes/class.ilCourseAgreementGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjchatservergui','Modules/Chat/classes/class.ilObjChatServerGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjchatgui','Modules/Chat/classes/class.ilObjChatGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilchatpresentationgui','Modules/Chat/classes/class.ilChatPresentationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilchathandlergui','Modules/Chat/classes/class.ilChatHandlerGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcategoryreferencegui','Modules/CategoryReference/classes/class.ilObjCategoryReferenceGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjcategorygui','Modules/Category/classes/class.ilObjCategoryGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilrepositorygui','classes/class.ilRepositoryGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpermissiongui','classes/class.ilPermissionGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdnotesgui','Services/Notes/classes/class.ilPDNotesGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjobjectfoldergui','Services/Object/classes/class.ilObjObjectFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjpaymentsettingsgui','Services/Payment/classes/class.ilObjPaymentSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilshopcontroller','Services/Payment/classes/class.ilShopController.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilshopgui','Services/Payment/classes/class.ilShopGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilshoppurchasegui','Services/Payment/classes/class.ilShopPurchaseGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpermanentlinkgui','Services/PermanentLink/classes/class.ilPermanentLinkGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilbookmarkadministrationgui','Services/PersonalDesktop/classes/class.ilBookmarkAdministrationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilbookmarkblockgui','Services/PersonalDesktop/classes/class.ilBookmarkBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjpersonaldesktopsettingsgui','Services/PersonalDesktop/classes/class.ilObjPersonalDesktopSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdselecteditemsblockgui','Services/PersonalDesktop/classes/class.ilPDSelectedItemsBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpersonaldesktopgui','Services/PersonalDesktop/classes/class.ilPersonalDesktopGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilusersonlineblockgui','Services/PersonalDesktop/classes/class.ilUsersOnlineBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjprivacysecuritygui','Services/PrivacySecurity/classes/class.ilObjPrivacySecurityGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilregistrationgui','Services/Registration/classes/class.ilRegistrationGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilregistrationsettingsgui','Services/Registration/classes/class.ilRegistrationSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('iladminusersearchgui','Services/Search/classes/class.ilAdminUserSearchGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjsearchsettingsgui','Services/Search/classes/class.ilObjSearchSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilsearchcontroller','Services/Search/classes/class.ilSearchController.php','');
INSERT INTO `ctrl_classfile` VALUES ('iluserfiltergui','Services/Search/classes/class.ilUserFilterGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjstylesettingsgui','Services/Style/classes/class.ilObjStyleSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjstylesheetgui','Services/Style/classes/class.ilObjStyleSheetGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjtaggingsettingsgui','Services/Tagging/classes/class.ilObjTaggingSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdtaggingblockgui','Services/Tagging/classes/class.ilPDTaggingBlockGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illearningprogressgui','Services/Tracking/classes/class.ilLearningProgressGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illpfiltergui','Services/Tracking/classes/class.ilLPFilterGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illpgui','Services/Tracking/classes/class.ilLPGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illplistofobjectsgui','Services/Tracking/classes/class.ilLPListOfObjectsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illplistofprogressgui','Services/Tracking/classes/class.ilLPListOfProgressGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('illplistofsettingsgui','Services/Tracking/classes/class.ilLPListOfSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjusertrackinggui','Services/Tracking/classes/class.ilObjUserTrackingGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpdfpresentation','Services/Tracking/classes/class.ilPDFPresentation.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjuserfoldergui','Services/User/classes/class.ilObjUserFolderGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjusergui','Services/User/classes/class.ilObjUserGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilpersonalprofilegui','Services/User/classes/class.ilPersonalProfileGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilobjfileaccesssettingsgui','Services/WebDAV/classes/class.ilObjFileAccessSettingsGUI.php','');
INSERT INTO `ctrl_classfile` VALUES ('ilecssettingsgui','Services/WebServices/ECS/classes/class.ilECSSettingsGUI.php','');
/*!40000 ALTER TABLE `ctrl_classfile` ENABLE KEYS */;

--
-- Table structure for table `ctrl_structure`
--

CREATE TABLE `ctrl_structure` (
  `root_class` varchar(40) NOT NULL default '',
  `call_node` mediumtext,
  `forward` mediumtext,
  `parent` mediumtext,
  PRIMARY KEY  (`root_class`)
) TYPE=MyISAM;

--
-- Dumping data for table `ctrl_structure`
--

/*!40000 ALTER TABLE `ctrl_structure` DISABLE KEYS */;
INSERT INTO `ctrl_structure` VALUES ('ilrepositorygui','a:2728:{i:1;a:2:{s:5:\"class\";s:15:\"ilrepositorygui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:16:\"ilobjcategorygui\";s:6:\"parent\";i:1;}i:4;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:4;}i:6;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:4;}i:7;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:4;}i:8;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:7;}i:9;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:7;}i:10;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:9;}i:11;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:7;}i:12;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:11;}i:13;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:7;}i:14;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:13;}i:15;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:7;}i:16;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:15;}i:17;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:4;}i:18;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:4;}i:19;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:4;}i:20;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:4;}i:21;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:20;}i:22;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:4;}i:23;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:22;}i:24;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:22;}i:25;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:24;}i:26;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:22;}i:27;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:26;}i:28;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:22;}i:29;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:28;}i:30;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:22;}i:31;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:30;}i:32;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:4;}i:33;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:4;}i:34;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:4;}i:35;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:4;}i:36;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:4;}i:37;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:4;}i:38;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:4;}i:39;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:4;}i:40;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:4;}i:41;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:40;}i:42;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:3;}i:43;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:42;}i:44;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:3;}i:45;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:44;}i:46;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:45;}i:47;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:45;}i:48;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:45;}i:49;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:48;}i:50;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:48;}i:51;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:50;}i:52;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:48;}i:53;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:52;}i:54;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:48;}i:55;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:54;}i:56;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:48;}i:57;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:56;}i:58;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:45;}i:59;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:45;}i:60;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:45;}i:61;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:45;}i:62;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:61;}i:63;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:45;}i:64;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:63;}i:65;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:63;}i:66;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:65;}i:67;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:63;}i:68;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:67;}i:69;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:63;}i:70;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:69;}i:71;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:63;}i:72;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:71;}i:73;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:45;}i:74;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:45;}i:75;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:45;}i:76;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:45;}i:77;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:45;}i:78;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:45;}i:79;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:45;}i:80;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:45;}i:81;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:45;}i:82;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:81;}i:83;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:44;}i:84;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:83;}i:85;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:44;}i:86;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:44;}i:87;a:2:{s:5:\"class\";s:18:\"ilobjuserfoldergui\";s:6:\"parent\";i:3;}i:88;a:2:{s:5:\"class\";s:20:\"iladminusersearchgui\";s:6:\"parent\";i:87;}i:89;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:88;}i:90;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:89;}i:91;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:90;}i:92;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:90;}i:93;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:92;}i:94;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:93;}i:95;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:92;}i:96;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:95;}i:97;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:92;}i:98;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:97;}i:99;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:90;}i:100;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:99;}i:101;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:100;}i:102;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:99;}i:103;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:102;}i:104;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:90;}i:105;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:104;}i:106;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:89;}i:107;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:87;}i:108;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:107;}i:109;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:108;}i:110;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:3;}i:111;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:110;}i:112;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:111;}i:113;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:111;}i:114;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:113;}i:115;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:114;}i:116;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:113;}i:117;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:116;}i:118;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:113;}i:119;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:118;}i:120;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:111;}i:121;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:120;}i:122;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:121;}i:123;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:120;}i:124;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:123;}i:125;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:111;}i:126;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:125;}i:127;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:110;}i:128;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:3;}i:129;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:128;}i:130;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:129;}i:131;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:130;}i:132;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:131;}i:133;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:130;}i:134;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:128;}i:135;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:128;}i:136;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:135;}i:137;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:135;}i:138;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:137;}i:139;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:138;}i:140;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:137;}i:141;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:135;}i:142;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:135;}i:143;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:135;}i:144;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:135;}i:145;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:135;}i:146;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:135;}i:147;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:135;}i:148;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:147;}i:149;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:148;}i:150;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:149;}i:151;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:148;}i:152;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:147;}i:153;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:152;}i:154;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:135;}i:155;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:135;}i:156;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:135;}i:157;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:135;}i:158;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:135;}i:159;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:135;}i:160;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:135;}i:161;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:135;}i:162;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:135;}i:163;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:128;}i:164;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:3;}i:165;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:164;}i:166;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:165;}i:167;a:2:{s:5:\"class\";s:25:\"ilobjcategoryreferencegui\";s:6:\"parent\";i:1;}i:168;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:167;}i:169;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:168;}i:170;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:169;}i:171;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:169;}i:172;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:169;}i:173;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:172;}i:174;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:172;}i:175;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:174;}i:176;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:172;}i:177;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:176;}i:178;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:172;}i:179;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:178;}i:180;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:172;}i:181;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:180;}i:182;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:169;}i:183;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:169;}i:184;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:169;}i:185;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:169;}i:186;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:185;}i:187;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:169;}i:188;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:187;}i:189;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:187;}i:190;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:189;}i:191;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:187;}i:192;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:191;}i:193;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:187;}i:194;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:193;}i:195;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:187;}i:196;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:195;}i:197;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:169;}i:198;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:169;}i:199;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:169;}i:200;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:169;}i:201;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:169;}i:202;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:169;}i:203;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:169;}i:204;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:169;}i:205;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:169;}i:206;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:205;}i:207;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:168;}i:208;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:207;}i:209;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:168;}i:210;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:168;}i:211;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:167;}i:212;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:211;}i:213;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:212;}i:214;a:2:{s:5:\"class\";s:12:\"ilobjchatgui\";s:6:\"parent\";i:1;}i:215;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:214;}i:216;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:215;}i:217;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:216;}i:218;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:216;}i:219;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:216;}i:220;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:219;}i:221;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:219;}i:222;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:221;}i:223;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:219;}i:224;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:223;}i:225;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:219;}i:226;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:225;}i:227;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:219;}i:228;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:227;}i:229;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:216;}i:230;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:216;}i:231;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:216;}i:232;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:216;}i:233;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:232;}i:234;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:216;}i:235;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:234;}i:236;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:234;}i:237;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:236;}i:238;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:234;}i:239;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:238;}i:240;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:234;}i:241;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:240;}i:242;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:234;}i:243;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:242;}i:244;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:216;}i:245;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:216;}i:246;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:216;}i:247;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:216;}i:248;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:216;}i:249;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:216;}i:250;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:216;}i:251;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:216;}i:252;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:216;}i:253;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:252;}i:254;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:215;}i:255;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:254;}i:256;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:215;}i:257;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:215;}i:258;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:214;}i:259;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:258;}i:260;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:259;}i:261;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:214;}i:262;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:1;}i:263;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:262;}i:264;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:263;}i:265;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:263;}i:266;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:263;}i:267;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:266;}i:268;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:266;}i:269;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:268;}i:270;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:266;}i:271;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:270;}i:272;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:266;}i:273;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:272;}i:274;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:266;}i:275;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:274;}i:276;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:263;}i:277;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:263;}i:278;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:263;}i:279;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:263;}i:280;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:279;}i:281;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:263;}i:282;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:281;}i:283;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:281;}i:284;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:283;}i:285;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:281;}i:286;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:285;}i:287;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:281;}i:288;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:287;}i:289;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:281;}i:290;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:289;}i:291;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:263;}i:292;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:263;}i:293;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:263;}i:294;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:263;}i:295;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:263;}i:296;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:263;}i:297;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:263;}i:298;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:263;}i:299;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:263;}i:300;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:299;}i:301;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:262;}i:302;a:2:{s:5:\"class\";s:20:\"ilcourseagreementgui\";s:6:\"parent\";i:262;}i:303;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:302;}i:304;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:262;}i:305;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:304;}i:306;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:305;}i:307;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:305;}i:308;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:305;}i:309;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:308;}i:310;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:308;}i:311;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:310;}i:312;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:308;}i:313;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:312;}i:314;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:308;}i:315;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:314;}i:316;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:308;}i:317;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:316;}i:318;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:305;}i:319;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:305;}i:320;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:305;}i:321;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:305;}i:322;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:321;}i:323;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:305;}i:324;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:323;}i:325;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:323;}i:326;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:325;}i:327;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:323;}i:328;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:327;}i:329;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:323;}i:330;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:329;}i:331;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:323;}i:332;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:331;}i:333;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:305;}i:334;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:305;}i:335;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:305;}i:336;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:305;}i:337;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:305;}i:338;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:305;}i:339;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:305;}i:340;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:305;}i:341;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:305;}i:342;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:341;}i:343;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:304;}i:344;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:304;}i:345;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:344;}i:346;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:262;}i:347;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:346;}i:348;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:262;}i:349;a:2:{s:5:\"class\";s:23:\"ilcourseregistrationgui\";s:6:\"parent\";i:262;}i:350;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:349;}i:351;a:2:{s:5:\"class\";s:21:\"ilcourseuserfieldsgui\";s:6:\"parent\";i:262;}i:352;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:262;}i:353;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:352;}i:354;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:353;}i:355;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:353;}i:356;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:353;}i:357;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:356;}i:358;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:356;}i:359;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:358;}i:360;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:356;}i:361;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:360;}i:362;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:356;}i:363;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:362;}i:364;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:356;}i:365;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:364;}i:366;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:353;}i:367;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:353;}i:368;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:353;}i:369;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:353;}i:370;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:369;}i:371;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:353;}i:372;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:371;}i:373;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:371;}i:374;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:373;}i:375;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:371;}i:376;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:375;}i:377;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:371;}i:378;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:377;}i:379;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:371;}i:380;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:379;}i:381;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:353;}i:382;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:353;}i:383;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:353;}i:384;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:353;}i:385;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:353;}i:386;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:353;}i:387;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:353;}i:388;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:353;}i:389;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:353;}i:390;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:389;}i:391;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:352;}i:392;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:391;}i:393;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:352;}i:394;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:352;}i:395;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:262;}i:396;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:395;}i:397;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:395;}i:398;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:397;}i:399;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:398;}i:400;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:397;}i:401;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:400;}i:402;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:397;}i:403;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:402;}i:404;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:395;}i:405;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:404;}i:406;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:405;}i:407;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:404;}i:408;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:407;}i:409;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:395;}i:410;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:409;}i:411;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:262;}i:412;a:2:{s:5:\"class\";s:17:\"ilmemberexportgui\";s:6:\"parent\";i:262;}i:413;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:412;}i:414;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:262;}i:415;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:262;}i:416;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:415;}i:417;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:416;}i:418;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:417;}i:419;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:418;}i:420;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:417;}i:421;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:415;}i:422;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:415;}i:423;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:422;}i:424;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:422;}i:425;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:424;}i:426;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:425;}i:427;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:424;}i:428;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:422;}i:429;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:422;}i:430;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:422;}i:431;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:422;}i:432;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:422;}i:433;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:422;}i:434;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:422;}i:435;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:434;}i:436;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:435;}i:437;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:436;}i:438;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:435;}i:439;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:434;}i:440;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:439;}i:441;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:422;}i:442;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:422;}i:443;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:422;}i:444;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:422;}i:445;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:422;}i:446;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:422;}i:447;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:422;}i:448;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:422;}i:449;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:422;}i:450;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:415;}i:451;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:262;}i:452;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:451;}i:453;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:452;}i:454;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:262;}i:455;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:262;}i:456;a:2:{s:5:\"class\";s:20:\"ilsessionoverviewgui\";s:6:\"parent\";i:262;}i:457;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:262;}i:458;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:457;}i:459;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:458;}i:460;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:459;}i:461;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:460;}i:462;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:461;}i:463;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:460;}i:464;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:458;}i:465;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:458;}i:466;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:465;}i:467;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:465;}i:468;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:467;}i:469;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:468;}i:470;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:467;}i:471;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:465;}i:472;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:465;}i:473;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:465;}i:474;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:465;}i:475;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:465;}i:476;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:465;}i:477;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:465;}i:478;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:477;}i:479;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:478;}i:480;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:479;}i:481;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:478;}i:482;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:477;}i:483;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:482;}i:484;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:465;}i:485;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:465;}i:486;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:465;}i:487;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:465;}i:488;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:465;}i:489;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:465;}i:490;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:465;}i:491;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:465;}i:492;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:465;}i:493;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:458;}i:494;a:2:{s:5:\"class\";s:23:\"ilobjcoursereferencegui\";s:6:\"parent\";i:1;}i:495;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:494;}i:496;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:495;}i:497;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:496;}i:498;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:496;}i:499;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:496;}i:500;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:499;}i:501;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:499;}i:502;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:501;}i:503;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:499;}i:504;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:503;}i:505;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:499;}i:506;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:505;}i:507;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:499;}i:508;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:507;}i:509;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:496;}i:510;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:496;}i:511;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:496;}i:512;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:496;}i:513;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:512;}i:514;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:496;}i:515;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:514;}i:516;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:514;}i:517;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:516;}i:518;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:514;}i:519;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:518;}i:520;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:514;}i:521;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:520;}i:522;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:514;}i:523;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:522;}i:524;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:496;}i:525;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:496;}i:526;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:496;}i:527;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:496;}i:528;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:496;}i:529;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:496;}i:530;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:496;}i:531;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:496;}i:532;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:496;}i:533;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:532;}i:534;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:495;}i:535;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:534;}i:536;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:495;}i:537;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:495;}i:538;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:494;}i:539;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:538;}i:540;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:539;}i:541;a:2:{s:5:\"class\";s:14:\"ilobjdlbookgui\";s:6:\"parent\";i:1;}i:542;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:541;}i:543;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:542;}i:544;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:543;}i:545;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:543;}i:546;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:543;}i:547;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:546;}i:548;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:546;}i:549;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:548;}i:550;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:546;}i:551;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:550;}i:552;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:546;}i:553;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:552;}i:554;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:546;}i:555;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:554;}i:556;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:543;}i:557;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:543;}i:558;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:543;}i:559;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:543;}i:560;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:559;}i:561;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:543;}i:562;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:561;}i:563;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:561;}i:564;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:563;}i:565;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:561;}i:566;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:565;}i:567;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:561;}i:568;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:567;}i:569;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:561;}i:570;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:569;}i:571;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:543;}i:572;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:543;}i:573;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:543;}i:574;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:543;}i:575;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:543;}i:576;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:543;}i:577;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:543;}i:578;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:543;}i:579;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:543;}i:580;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:579;}i:581;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:542;}i:582;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:581;}i:583;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:542;}i:584;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:542;}i:585;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:541;}i:586;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:585;}i:587;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:585;}i:588;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:587;}i:589;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:588;}i:590;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:587;}i:591;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:590;}i:592;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:587;}i:593;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:592;}i:594;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:585;}i:595;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:594;}i:596;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:595;}i:597;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:594;}i:598;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:597;}i:599;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:585;}i:600;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:599;}i:601;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:541;}i:602;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:601;}i:603;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:602;}i:604;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:603;}i:605;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:604;}i:606;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:605;}i:607;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:604;}i:608;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:602;}i:609;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:602;}i:610;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:609;}i:611;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:609;}i:612;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:611;}i:613;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:612;}i:614;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:611;}i:615;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:609;}i:616;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:609;}i:617;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:609;}i:618;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:609;}i:619;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:609;}i:620;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:609;}i:621;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:609;}i:622;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:621;}i:623;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:622;}i:624;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:623;}i:625;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:622;}i:626;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:621;}i:627;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:626;}i:628;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:609;}i:629;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:609;}i:630;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:609;}i:631;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:609;}i:632;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:609;}i:633;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:609;}i:634;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:609;}i:635;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:609;}i:636;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:609;}i:637;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:602;}i:638;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:541;}i:639;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:541;}i:640;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:639;}i:641;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:541;}i:642;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:641;}i:643;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:642;}i:644;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:541;}i:645;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:644;}i:646;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:644;}i:647;a:2:{s:5:\"class\";s:16:\"ilobjexercisegui\";s:6:\"parent\";i:1;}i:648;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:647;}i:649;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:648;}i:650;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:649;}i:651;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:649;}i:652;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:649;}i:653;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:652;}i:654;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:652;}i:655;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:654;}i:656;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:652;}i:657;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:656;}i:658;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:652;}i:659;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:658;}i:660;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:652;}i:661;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:660;}i:662;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:649;}i:663;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:649;}i:664;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:649;}i:665;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:649;}i:666;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:665;}i:667;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:649;}i:668;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:667;}i:669;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:667;}i:670;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:669;}i:671;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:667;}i:672;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:671;}i:673;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:667;}i:674;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:673;}i:675;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:667;}i:676;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:675;}i:677;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:649;}i:678;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:649;}i:679;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:649;}i:680;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:649;}i:681;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:649;}i:682;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:649;}i:683;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:649;}i:684;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:649;}i:685;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:649;}i:686;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:685;}i:687;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:648;}i:688;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:687;}i:689;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:648;}i:690;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:648;}i:691;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:647;}i:692;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:691;}i:693;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:691;}i:694;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:693;}i:695;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:694;}i:696;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:693;}i:697;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:696;}i:698;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:693;}i:699;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:698;}i:700;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:691;}i:701;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:700;}i:702;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:701;}i:703;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:700;}i:704;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:703;}i:705;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:691;}i:706;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:705;}i:707;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:647;}i:708;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:707;}i:709;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:708;}i:710;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:647;}i:711;a:2:{s:5:\"class\";s:20:\"ilobjexternalfeedgui\";s:6:\"parent\";i:1;}i:712;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:711;}i:713;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:711;}i:714;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:713;}i:715;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:714;}i:716;a:2:{s:5:\"class\";s:19:\"ilobjfilebasedlmgui\";s:6:\"parent\";i:1;}i:717;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:716;}i:718;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:716;}i:719;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:718;}i:720;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:719;}i:721;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:719;}i:722;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:719;}i:723;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:722;}i:724;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:722;}i:725;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:724;}i:726;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:722;}i:727;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:726;}i:728;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:722;}i:729;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:728;}i:730;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:722;}i:731;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:730;}i:732;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:719;}i:733;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:719;}i:734;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:719;}i:735;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:719;}i:736;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:735;}i:737;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:719;}i:738;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:737;}i:739;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:737;}i:740;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:739;}i:741;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:737;}i:742;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:741;}i:743;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:737;}i:744;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:743;}i:745;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:737;}i:746;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:745;}i:747;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:719;}i:748;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:719;}i:749;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:719;}i:750;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:719;}i:751;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:719;}i:752;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:719;}i:753;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:719;}i:754;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:719;}i:755;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:719;}i:756;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:755;}i:757;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:718;}i:758;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:757;}i:759;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:718;}i:760;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:718;}i:761;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:716;}i:762;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:761;}i:763;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:761;}i:764;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:763;}i:765;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:764;}i:766;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:763;}i:767;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:766;}i:768;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:763;}i:769;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:768;}i:770;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:761;}i:771;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:770;}i:772;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:771;}i:773;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:770;}i:774;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:773;}i:775;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:761;}i:776;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:775;}i:777;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:716;}i:778;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:716;}i:779;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:778;}i:780;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:779;}i:781;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:716;}i:782;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:781;}i:783;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:782;}i:784;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:783;}i:785;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:784;}i:786;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:785;}i:787;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:784;}i:788;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:782;}i:789;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:782;}i:790;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:789;}i:791;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:789;}i:792;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:791;}i:793;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:792;}i:794;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:791;}i:795;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:789;}i:796;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:789;}i:797;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:789;}i:798;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:789;}i:799;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:789;}i:800;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:789;}i:801;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:789;}i:802;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:801;}i:803;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:802;}i:804;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:803;}i:805;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:802;}i:806;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:801;}i:807;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:806;}i:808;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:789;}i:809;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:789;}i:810;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:789;}i:811;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:789;}i:812;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:789;}i:813;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:789;}i:814;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:789;}i:815;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:789;}i:816;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:789;}i:817;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:782;}i:818;a:2:{s:5:\"class\";s:12:\"ilobjfilegui\";s:6:\"parent\";i:1;}i:819;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:818;}i:820;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:819;}i:821;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:820;}i:822;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:820;}i:823;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:820;}i:824;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:823;}i:825;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:823;}i:826;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:825;}i:827;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:823;}i:828;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:827;}i:829;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:823;}i:830;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:829;}i:831;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:823;}i:832;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:831;}i:833;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:820;}i:834;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:820;}i:835;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:820;}i:836;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:820;}i:837;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:836;}i:838;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:820;}i:839;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:838;}i:840;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:838;}i:841;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:840;}i:842;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:838;}i:843;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:842;}i:844;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:838;}i:845;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:844;}i:846;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:838;}i:847;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:846;}i:848;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:820;}i:849;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:820;}i:850;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:820;}i:851;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:820;}i:852;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:820;}i:853;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:820;}i:854;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:820;}i:855;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:820;}i:856;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:820;}i:857;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:856;}i:858;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:819;}i:859;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:858;}i:860;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:819;}i:861;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:819;}i:862;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:818;}i:863;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:818;}i:864;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:863;}i:865;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:864;}i:866;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:818;}i:867;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:866;}i:868;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:867;}i:869;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:868;}i:870;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:869;}i:871;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:870;}i:872;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:869;}i:873;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:867;}i:874;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:867;}i:875;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:874;}i:876;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:874;}i:877;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:876;}i:878;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:877;}i:879;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:876;}i:880;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:874;}i:881;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:874;}i:882;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:874;}i:883;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:874;}i:884;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:874;}i:885;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:874;}i:886;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:874;}i:887;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:886;}i:888;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:887;}i:889;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:888;}i:890;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:887;}i:891;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:886;}i:892;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:891;}i:893;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:874;}i:894;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:874;}i:895;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:874;}i:896;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:874;}i:897;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:874;}i:898;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:874;}i:899;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:874;}i:900;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:874;}i:901;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:874;}i:902;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:867;}i:903;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:1;}i:904;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:903;}i:905;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:904;}i:906;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:904;}i:907;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:904;}i:908;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:907;}i:909;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:907;}i:910;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:909;}i:911;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:907;}i:912;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:911;}i:913;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:907;}i:914;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:913;}i:915;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:907;}i:916;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:915;}i:917;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:904;}i:918;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:904;}i:919;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:904;}i:920;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:904;}i:921;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:920;}i:922;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:904;}i:923;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:922;}i:924;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:922;}i:925;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:924;}i:926;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:922;}i:927;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:926;}i:928;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:922;}i:929;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:928;}i:930;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:922;}i:931;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:930;}i:932;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:904;}i:933;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:904;}i:934;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:904;}i:935;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:904;}i:936;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:904;}i:937;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:904;}i:938;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:904;}i:939;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:904;}i:940;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:904;}i:941;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:940;}i:942;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:903;}i:943;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:903;}i:944;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:943;}i:945;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:944;}i:946;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:944;}i:947;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:944;}i:948;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:947;}i:949;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:947;}i:950;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:949;}i:951;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:947;}i:952;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:951;}i:953;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:947;}i:954;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:953;}i:955;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:947;}i:956;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:955;}i:957;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:944;}i:958;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:944;}i:959;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:944;}i:960;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:944;}i:961;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:960;}i:962;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:944;}i:963;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:962;}i:964;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:962;}i:965;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:964;}i:966;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:962;}i:967;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:966;}i:968;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:962;}i:969;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:968;}i:970;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:962;}i:971;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:970;}i:972;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:944;}i:973;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:944;}i:974;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:944;}i:975;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:944;}i:976;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:944;}i:977;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:944;}i:978;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:944;}i:979;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:944;}i:980;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:944;}i:981;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:980;}i:982;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:943;}i:983;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:943;}i:984;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:983;}i:985;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:903;}i:986;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:985;}i:987;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:903;}i:988;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:987;}i:989;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:988;}i:990;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:988;}i:991;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:988;}i:992;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:991;}i:993;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:991;}i:994;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:993;}i:995;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:991;}i:996;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:995;}i:997;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:991;}i:998;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:997;}i:999;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:991;}i:1000;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:999;}i:1001;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:988;}i:1002;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:988;}i:1003;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:988;}i:1004;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:988;}i:1005;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1004;}i:1006;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:988;}i:1007;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1006;}i:1008;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1006;}i:1009;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1008;}i:1010;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1006;}i:1011;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1010;}i:1012;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1006;}i:1013;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1012;}i:1014;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1006;}i:1015;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1014;}i:1016;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:988;}i:1017;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:988;}i:1018;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:988;}i:1019;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:988;}i:1020;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:988;}i:1021;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:988;}i:1022;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:988;}i:1023;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:988;}i:1024;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:988;}i:1025;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1024;}i:1026;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:987;}i:1027;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1026;}i:1028;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:987;}i:1029;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:987;}i:1030;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:903;}i:1031;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1030;}i:1032;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1030;}i:1033;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1032;}i:1034;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1033;}i:1035;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1032;}i:1036;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1035;}i:1037;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1032;}i:1038;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1037;}i:1039;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1030;}i:1040;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1039;}i:1041;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1040;}i:1042;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1039;}i:1043;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1042;}i:1044;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1030;}i:1045;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1044;}i:1046;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:903;}i:1047;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1046;}i:1048;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1047;}i:1049;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1048;}i:1050;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1049;}i:1051;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1048;}i:1052;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1046;}i:1053;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1046;}i:1054;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1053;}i:1055;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1053;}i:1056;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1055;}i:1057;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1056;}i:1058;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1055;}i:1059;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1053;}i:1060;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1053;}i:1061;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1053;}i:1062;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1053;}i:1063;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1053;}i:1064;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1053;}i:1065;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1053;}i:1066;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1065;}i:1067;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1066;}i:1068;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1067;}i:1069;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1066;}i:1070;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1065;}i:1071;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1070;}i:1072;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1053;}i:1073;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1053;}i:1074;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1053;}i:1075;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1053;}i:1076;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1053;}i:1077;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1053;}i:1078;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1053;}i:1079;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1053;}i:1080;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1053;}i:1081;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1046;}i:1082;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:903;}i:1083;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1082;}i:1084;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1083;}i:1085;a:2:{s:5:\"class\";s:13:\"ilobjforumgui\";s:6:\"parent\";i:1;}i:1086;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1085;}i:1087;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1086;}i:1088;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1086;}i:1089;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1086;}i:1090;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1089;}i:1091;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1089;}i:1092;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1091;}i:1093;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1089;}i:1094;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1093;}i:1095;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1089;}i:1096;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1095;}i:1097;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1089;}i:1098;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1097;}i:1099;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1086;}i:1100;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1086;}i:1101;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1086;}i:1102;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1086;}i:1103;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1102;}i:1104;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1086;}i:1105;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1104;}i:1106;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1104;}i:1107;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1106;}i:1108;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1104;}i:1109;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1108;}i:1110;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1104;}i:1111;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1110;}i:1112;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1104;}i:1113;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1112;}i:1114;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1086;}i:1115;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1086;}i:1116;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1086;}i:1117;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1086;}i:1118;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1086;}i:1119;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1086;}i:1120;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1086;}i:1121;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1086;}i:1122;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1086;}i:1123;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1122;}i:1124;a:2:{s:5:\"class\";s:16:\"ilforumexportgui\";s:6:\"parent\";i:1085;}i:1125;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1085;}i:1126;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1125;}i:1127;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1126;}i:1128;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1126;}i:1129;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1126;}i:1130;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1129;}i:1131;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1129;}i:1132;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1131;}i:1133;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1129;}i:1134;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1133;}i:1135;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1129;}i:1136;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1135;}i:1137;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1129;}i:1138;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1137;}i:1139;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1126;}i:1140;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1126;}i:1141;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1126;}i:1142;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1126;}i:1143;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1142;}i:1144;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1126;}i:1145;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1144;}i:1146;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1144;}i:1147;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1146;}i:1148;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1144;}i:1149;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1148;}i:1150;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1144;}i:1151;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1150;}i:1152;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1144;}i:1153;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1152;}i:1154;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1126;}i:1155;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1126;}i:1156;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1126;}i:1157;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1126;}i:1158;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1126;}i:1159;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1126;}i:1160;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1126;}i:1161;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1126;}i:1162;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1126;}i:1163;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1162;}i:1164;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1125;}i:1165;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1164;}i:1166;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1125;}i:1167;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1125;}i:1168;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1085;}i:1169;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1168;}i:1170;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1169;}i:1171;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1085;}i:1172;a:2:{s:5:\"class\";s:16:\"ilobjglossarygui\";s:6:\"parent\";i:1;}i:1173;a:2:{s:5:\"class\";s:17:\"ilglossarytermgui\";s:6:\"parent\";i:1172;}i:1174;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1173;}i:1175;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1174;}i:1176;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1175;}i:1177;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1176;}i:1178;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1177;}i:1179;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1176;}i:1180;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1174;}i:1181;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1174;}i:1182;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1181;}i:1183;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1181;}i:1184;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1183;}i:1185;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1184;}i:1186;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1183;}i:1187;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1181;}i:1188;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1181;}i:1189;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1181;}i:1190;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1181;}i:1191;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1181;}i:1192;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1181;}i:1193;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1181;}i:1194;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1193;}i:1195;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1194;}i:1196;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1195;}i:1197;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1194;}i:1198;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1193;}i:1199;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1198;}i:1200;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1181;}i:1201;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1181;}i:1202;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1181;}i:1203;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1181;}i:1204;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1181;}i:1205;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1181;}i:1206;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1181;}i:1207;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1181;}i:1208;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1181;}i:1209;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1174;}i:1210;a:2:{s:5:\"class\";s:25:\"iltermdefinitioneditorgui\";s:6:\"parent\";i:1173;}i:1211;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1210;}i:1212;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1210;}i:1213;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1212;}i:1214;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1213;}i:1215;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1214;}i:1216;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1215;}i:1217;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1214;}i:1218;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1212;}i:1219;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1212;}i:1220;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1219;}i:1221;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1219;}i:1222;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1221;}i:1223;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1222;}i:1224;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1221;}i:1225;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1219;}i:1226;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1219;}i:1227;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1219;}i:1228;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1219;}i:1229;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1219;}i:1230;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1219;}i:1231;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1219;}i:1232;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1231;}i:1233;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1232;}i:1234;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1233;}i:1235;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1232;}i:1236;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1231;}i:1237;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1236;}i:1238;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1219;}i:1239;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1219;}i:1240;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1219;}i:1241;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1219;}i:1242;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1219;}i:1243;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1219;}i:1244;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1219;}i:1245;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1219;}i:1246;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1219;}i:1247;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1212;}i:1248;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1172;}i:1249;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1248;}i:1250;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1249;}i:1251;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1249;}i:1252;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1249;}i:1253;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1252;}i:1254;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1252;}i:1255;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1254;}i:1256;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1252;}i:1257;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1256;}i:1258;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1252;}i:1259;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1258;}i:1260;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1252;}i:1261;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1260;}i:1262;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1249;}i:1263;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1249;}i:1264;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1249;}i:1265;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1249;}i:1266;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1265;}i:1267;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1249;}i:1268;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1267;}i:1269;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1267;}i:1270;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1269;}i:1271;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1267;}i:1272;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1271;}i:1273;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1267;}i:1274;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1273;}i:1275;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1267;}i:1276;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1275;}i:1277;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1249;}i:1278;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1249;}i:1279;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1249;}i:1280;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1249;}i:1281;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1249;}i:1282;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1249;}i:1283;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1249;}i:1284;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1249;}i:1285;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1249;}i:1286;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1285;}i:1287;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1248;}i:1288;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1287;}i:1289;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1248;}i:1290;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1248;}i:1291;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1172;}i:1292;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1172;}i:1293;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1292;}i:1294;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1293;}i:1295;a:2:{s:5:\"class\";s:13:\"ilobjgroupgui\";s:6:\"parent\";i:1;}i:1296;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1295;}i:1297;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1295;}i:1298;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1297;}i:1299;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1297;}i:1300;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1297;}i:1301;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1300;}i:1302;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1300;}i:1303;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1302;}i:1304;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1300;}i:1305;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1304;}i:1306;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1300;}i:1307;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1306;}i:1308;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1300;}i:1309;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1308;}i:1310;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1297;}i:1311;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1297;}i:1312;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1297;}i:1313;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1297;}i:1314;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1313;}i:1315;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1297;}i:1316;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1315;}i:1317;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1315;}i:1318;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1317;}i:1319;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1315;}i:1320;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1319;}i:1321;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1315;}i:1322;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1321;}i:1323;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1315;}i:1324;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1323;}i:1325;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1297;}i:1326;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1297;}i:1327;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1297;}i:1328;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1297;}i:1329;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1297;}i:1330;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1297;}i:1331;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1297;}i:1332;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1297;}i:1333;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1297;}i:1334;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1333;}i:1335;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1295;}i:1336;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:1295;}i:1337;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1336;}i:1338;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1337;}i:1339;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1337;}i:1340;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1337;}i:1341;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1340;}i:1342;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1340;}i:1343;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1342;}i:1344;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1340;}i:1345;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1344;}i:1346;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1340;}i:1347;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1346;}i:1348;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1340;}i:1349;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1348;}i:1350;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1337;}i:1351;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1337;}i:1352;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1337;}i:1353;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1337;}i:1354;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1353;}i:1355;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1337;}i:1356;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1355;}i:1357;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1355;}i:1358;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1357;}i:1359;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1355;}i:1360;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1359;}i:1361;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1355;}i:1362;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1361;}i:1363;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1355;}i:1364;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1363;}i:1365;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1337;}i:1366;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1337;}i:1367;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1337;}i:1368;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1337;}i:1369;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1337;}i:1370;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1337;}i:1371;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1337;}i:1372;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1337;}i:1373;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1337;}i:1374;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1373;}i:1375;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:1336;}i:1376;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:1336;}i:1377;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1376;}i:1378;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:1295;}i:1379;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1378;}i:1380;a:2:{s:5:\"class\";s:22:\"ilgroupregistrationgui\";s:6:\"parent\";i:1295;}i:1381;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1295;}i:1382;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1381;}i:1383;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1382;}i:1384;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1382;}i:1385;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1382;}i:1386;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1385;}i:1387;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1385;}i:1388;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1387;}i:1389;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1385;}i:1390;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1389;}i:1391;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1385;}i:1392;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1391;}i:1393;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1385;}i:1394;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1393;}i:1395;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1382;}i:1396;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1382;}i:1397;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1382;}i:1398;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1382;}i:1399;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1398;}i:1400;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1382;}i:1401;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1400;}i:1402;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1400;}i:1403;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1402;}i:1404;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1400;}i:1405;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1404;}i:1406;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1400;}i:1407;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1406;}i:1408;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1400;}i:1409;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1408;}i:1410;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1382;}i:1411;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1382;}i:1412;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1382;}i:1413;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1382;}i:1414;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1382;}i:1415;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1382;}i:1416;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1382;}i:1417;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1382;}i:1418;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1382;}i:1419;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1418;}i:1420;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1381;}i:1421;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1420;}i:1422;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1381;}i:1423;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1381;}i:1424;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1295;}i:1425;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1424;}i:1426;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1424;}i:1427;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1426;}i:1428;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1427;}i:1429;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1426;}i:1430;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1429;}i:1431;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1426;}i:1432;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1431;}i:1433;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1424;}i:1434;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1433;}i:1435;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1434;}i:1436;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1433;}i:1437;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1436;}i:1438;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1424;}i:1439;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1438;}i:1440;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:1295;}i:1441;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1295;}i:1442;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1441;}i:1443;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1442;}i:1444;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1443;}i:1445;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1444;}i:1446;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1443;}i:1447;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1441;}i:1448;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1441;}i:1449;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1448;}i:1450;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1448;}i:1451;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1450;}i:1452;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1451;}i:1453;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1450;}i:1454;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1448;}i:1455;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1448;}i:1456;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1448;}i:1457;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1448;}i:1458;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1448;}i:1459;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1448;}i:1460;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1448;}i:1461;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1460;}i:1462;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1461;}i:1463;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1462;}i:1464;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1461;}i:1465;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1460;}i:1466;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1465;}i:1467;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1448;}i:1468;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1448;}i:1469;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1448;}i:1470;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1448;}i:1471;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1448;}i:1472;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1448;}i:1473;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1448;}i:1474;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1448;}i:1475;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1448;}i:1476;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1441;}i:1477;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1295;}i:1478;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1477;}i:1479;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1478;}i:1480;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1295;}i:1481;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:1295;}i:1482;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:1;}i:1483;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1482;}i:1484;a:2:{s:5:\"class\";s:19:\"ilobjilinccoursegui\";s:6:\"parent\";i:1;}i:1485;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1484;}i:1486;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1485;}i:1487;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1486;}i:1488;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1486;}i:1489;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1486;}i:1490;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1489;}i:1491;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1489;}i:1492;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1491;}i:1493;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1489;}i:1494;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1493;}i:1495;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1489;}i:1496;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1495;}i:1497;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1489;}i:1498;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1497;}i:1499;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1486;}i:1500;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1486;}i:1501;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1486;}i:1502;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1486;}i:1503;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1502;}i:1504;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1486;}i:1505;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1504;}i:1506;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1504;}i:1507;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1506;}i:1508;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1504;}i:1509;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1508;}i:1510;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1504;}i:1511;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1510;}i:1512;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1504;}i:1513;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1512;}i:1514;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1486;}i:1515;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1486;}i:1516;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1486;}i:1517;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1486;}i:1518;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1486;}i:1519;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1486;}i:1520;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1486;}i:1521;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1486;}i:1522;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1486;}i:1523;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1522;}i:1524;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1485;}i:1525;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1524;}i:1526;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1485;}i:1527;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1485;}i:1528;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:1484;}i:1529;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1528;}i:1530;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1484;}i:1531;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1530;}i:1532;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1531;}i:1533;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1484;}i:1534;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:1484;}i:1535;a:2:{s:5:\"class\";s:22:\"ilobjlearningmodulegui\";s:6:\"parent\";i:1;}i:1536;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1535;}i:1537;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1536;}i:1538;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1537;}i:1539;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1537;}i:1540;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1537;}i:1541;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1540;}i:1542;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1540;}i:1543;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1542;}i:1544;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1540;}i:1545;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1544;}i:1546;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1540;}i:1547;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1546;}i:1548;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1540;}i:1549;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1548;}i:1550;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1537;}i:1551;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1537;}i:1552;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1537;}i:1553;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1537;}i:1554;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1553;}i:1555;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1537;}i:1556;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1555;}i:1557;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1555;}i:1558;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1557;}i:1559;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1555;}i:1560;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1559;}i:1561;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1555;}i:1562;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1561;}i:1563;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1555;}i:1564;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1563;}i:1565;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1537;}i:1566;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1537;}i:1567;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1537;}i:1568;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1537;}i:1569;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1537;}i:1570;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1537;}i:1571;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1537;}i:1572;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1537;}i:1573;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1537;}i:1574;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1573;}i:1575;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1536;}i:1576;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1575;}i:1577;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1536;}i:1578;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1536;}i:1579;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1535;}i:1580;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1579;}i:1581;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1579;}i:1582;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1581;}i:1583;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1582;}i:1584;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1581;}i:1585;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1584;}i:1586;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1581;}i:1587;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1586;}i:1588;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1579;}i:1589;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1588;}i:1590;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1589;}i:1591;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1588;}i:1592;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1591;}i:1593;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1579;}i:1594;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1593;}i:1595;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:1535;}i:1596;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1595;}i:1597;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1596;}i:1598;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1597;}i:1599;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1598;}i:1600;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1599;}i:1601;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1598;}i:1602;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1596;}i:1603;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1596;}i:1604;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1603;}i:1605;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1603;}i:1606;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1605;}i:1607;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1606;}i:1608;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1605;}i:1609;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1603;}i:1610;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1603;}i:1611;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1603;}i:1612;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1603;}i:1613;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1603;}i:1614;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1603;}i:1615;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1603;}i:1616;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1615;}i:1617;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1616;}i:1618;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1617;}i:1619;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1616;}i:1620;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1615;}i:1621;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1620;}i:1622;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1603;}i:1623;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1603;}i:1624;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1603;}i:1625;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1603;}i:1626;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1603;}i:1627;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1603;}i:1628;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1603;}i:1629;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1603;}i:1630;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1603;}i:1631;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1596;}i:1632;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1535;}i:1633;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:1535;}i:1634;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1633;}i:1635;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1535;}i:1636;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1635;}i:1637;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1636;}i:1638;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:1535;}i:1639;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1638;}i:1640;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1638;}i:1641;a:2:{s:5:\"class\";s:20:\"ilobjlinkresourcegui\";s:6:\"parent\";i:1;}i:1642;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1641;}i:1643;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1642;}i:1644;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1643;}i:1645;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1643;}i:1646;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1643;}i:1647;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1646;}i:1648;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1646;}i:1649;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1648;}i:1650;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1646;}i:1651;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1650;}i:1652;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1646;}i:1653;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1652;}i:1654;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1646;}i:1655;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1654;}i:1656;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1643;}i:1657;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1643;}i:1658;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1643;}i:1659;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1643;}i:1660;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1659;}i:1661;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1643;}i:1662;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1661;}i:1663;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1661;}i:1664;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1663;}i:1665;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1661;}i:1666;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1665;}i:1667;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1661;}i:1668;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1667;}i:1669;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1661;}i:1670;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1669;}i:1671;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1643;}i:1672;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1643;}i:1673;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1643;}i:1674;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1643;}i:1675;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1643;}i:1676;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1643;}i:1677;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1643;}i:1678;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1643;}i:1679;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1643;}i:1680;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1679;}i:1681;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1642;}i:1682;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1681;}i:1683;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1642;}i:1684;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1642;}i:1685;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1641;}i:1686;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1641;}i:1687;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1686;}i:1688;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1687;}i:1689;a:2:{s:5:\"class\";s:17:\"ilobjmediacastgui\";s:6:\"parent\";i:1;}i:1690;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1689;}i:1691;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1690;}i:1692;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1691;}i:1693;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1691;}i:1694;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1691;}i:1695;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1694;}i:1696;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1694;}i:1697;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1696;}i:1698;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1694;}i:1699;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1698;}i:1700;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1694;}i:1701;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1700;}i:1702;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1694;}i:1703;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1702;}i:1704;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1691;}i:1705;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1691;}i:1706;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1691;}i:1707;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1691;}i:1708;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1707;}i:1709;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1691;}i:1710;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1709;}i:1711;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1709;}i:1712;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1711;}i:1713;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1709;}i:1714;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1713;}i:1715;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1709;}i:1716;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1715;}i:1717;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1709;}i:1718;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1717;}i:1719;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1691;}i:1720;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1691;}i:1721;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1691;}i:1722;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1691;}i:1723;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1691;}i:1724;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1691;}i:1725;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1691;}i:1726;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1691;}i:1727;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1691;}i:1728;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1727;}i:1729;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1690;}i:1730;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1729;}i:1731;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1690;}i:1732;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1690;}i:1733;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1689;}i:1734;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1733;}i:1735;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1734;}i:1736;a:2:{s:5:\"class\";s:17:\"ilobjmediapoolgui\";s:6:\"parent\";i:1;}i:1737;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1736;}i:1738;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1737;}i:1739;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1738;}i:1740;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1739;}i:1741;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1738;}i:1742;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1736;}i:1743;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1742;}i:1744;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1743;}i:1745;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1743;}i:1746;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1743;}i:1747;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1746;}i:1748;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1746;}i:1749;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1748;}i:1750;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1746;}i:1751;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1750;}i:1752;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1746;}i:1753;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1752;}i:1754;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1746;}i:1755;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1754;}i:1756;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1743;}i:1757;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1743;}i:1758;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1743;}i:1759;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1743;}i:1760;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1759;}i:1761;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1743;}i:1762;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1761;}i:1763;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1761;}i:1764;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1763;}i:1765;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1761;}i:1766;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1765;}i:1767;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1761;}i:1768;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1767;}i:1769;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1761;}i:1770;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1769;}i:1771;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1743;}i:1772;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1743;}i:1773;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1743;}i:1774;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1743;}i:1775;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1743;}i:1776;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1743;}i:1777;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1743;}i:1778;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1743;}i:1779;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1743;}i:1780;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1779;}i:1781;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1742;}i:1782;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1781;}i:1783;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1742;}i:1784;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1742;}i:1785;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:1736;}i:1786;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1785;}i:1787;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1786;}i:1788;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1786;}i:1789;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1786;}i:1790;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1789;}i:1791;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1789;}i:1792;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1791;}i:1793;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1789;}i:1794;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1793;}i:1795;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1789;}i:1796;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1795;}i:1797;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1789;}i:1798;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1797;}i:1799;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1786;}i:1800;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1786;}i:1801;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1786;}i:1802;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1786;}i:1803;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1802;}i:1804;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1786;}i:1805;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1804;}i:1806;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1804;}i:1807;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1806;}i:1808;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1804;}i:1809;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1808;}i:1810;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1804;}i:1811;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1810;}i:1812;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1804;}i:1813;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1812;}i:1814;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1786;}i:1815;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1786;}i:1816;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1786;}i:1817;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1786;}i:1818;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1786;}i:1819;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1786;}i:1820;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1786;}i:1821;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1786;}i:1822;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1786;}i:1823;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1822;}i:1824;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1785;}i:1825;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:1785;}i:1826;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1825;}i:1827;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1826;}i:1828;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1826;}i:1829;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1826;}i:1830;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1829;}i:1831;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1829;}i:1832;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1831;}i:1833;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1829;}i:1834;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1833;}i:1835;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1829;}i:1836;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1835;}i:1837;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1829;}i:1838;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1837;}i:1839;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1826;}i:1840;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1826;}i:1841;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1826;}i:1842;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1826;}i:1843;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1842;}i:1844;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1826;}i:1845;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1844;}i:1846;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1844;}i:1847;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1846;}i:1848;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1844;}i:1849;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1848;}i:1850;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1844;}i:1851;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1850;}i:1852;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1844;}i:1853;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1852;}i:1854;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1826;}i:1855;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1826;}i:1856;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1826;}i:1857;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1826;}i:1858;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1826;}i:1859;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1826;}i:1860;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1826;}i:1861;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1826;}i:1862;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1826;}i:1863;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1862;}i:1864;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:1825;}i:1865;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:1825;}i:1866;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1865;}i:1867;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:1785;}i:1868;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1867;}i:1869;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1785;}i:1870;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1869;}i:1871;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1870;}i:1872;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1870;}i:1873;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1870;}i:1874;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1873;}i:1875;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1873;}i:1876;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1875;}i:1877;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1873;}i:1878;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1877;}i:1879;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1873;}i:1880;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1879;}i:1881;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1873;}i:1882;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1881;}i:1883;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1870;}i:1884;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1870;}i:1885;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1870;}i:1886;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1870;}i:1887;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1886;}i:1888;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1870;}i:1889;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1888;}i:1890;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1888;}i:1891;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1890;}i:1892;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1888;}i:1893;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1892;}i:1894;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1888;}i:1895;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1894;}i:1896;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1888;}i:1897;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1896;}i:1898;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1870;}i:1899;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1870;}i:1900;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1870;}i:1901;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1870;}i:1902;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1870;}i:1903;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1870;}i:1904;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1870;}i:1905;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1870;}i:1906;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1870;}i:1907;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1906;}i:1908;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1869;}i:1909;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1908;}i:1910;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1869;}i:1911;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1869;}i:1912;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1785;}i:1913;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1912;}i:1914;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1912;}i:1915;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1914;}i:1916;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1915;}i:1917;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1914;}i:1918;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1917;}i:1919;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1914;}i:1920;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1919;}i:1921;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1912;}i:1922;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1921;}i:1923;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1922;}i:1924;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1921;}i:1925;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1924;}i:1926;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1912;}i:1927;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1926;}i:1928;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1785;}i:1929;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1928;}i:1930;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1929;}i:1931;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1930;}i:1932;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1931;}i:1933;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1930;}i:1934;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1928;}i:1935;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1928;}i:1936;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1935;}i:1937;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1935;}i:1938;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1937;}i:1939;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1938;}i:1940;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1937;}i:1941;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1935;}i:1942;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1935;}i:1943;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1935;}i:1944;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1935;}i:1945;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1935;}i:1946;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1935;}i:1947;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1935;}i:1948;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1947;}i:1949;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1948;}i:1950;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1949;}i:1951;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1948;}i:1952;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1947;}i:1953;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1952;}i:1954;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1935;}i:1955;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1935;}i:1956;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1935;}i:1957;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1935;}i:1958;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1935;}i:1959;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1935;}i:1960;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1935;}i:1961;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1935;}i:1962;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1935;}i:1963;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1928;}i:1964;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1785;}i:1965;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1964;}i:1966;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1965;}i:1967;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1736;}i:1968;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1967;}i:1969;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1968;}i:1970;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1967;}i:1971;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1736;}i:1972;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1971;}i:1973;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1972;}i:1974;a:2:{s:5:\"class\";s:20:\"ilobjquestionpoolgui\";s:6:\"parent\";i:1;}i:1975;a:2:{s:5:\"class\";s:15:\"assclozetestgui\";s:6:\"parent\";i:1974;}i:1976;a:2:{s:5:\"class\";s:22:\"assimagemapquestiongui\";s:6:\"parent\";i:1974;}i:1977;a:2:{s:5:\"class\";s:16:\"assjavaappletgui\";s:6:\"parent\";i:1974;}i:1978;a:2:{s:5:\"class\";s:22:\"assmatchingquestiongui\";s:6:\"parent\";i:1974;}i:1979;a:2:{s:5:\"class\";s:20:\"assmultiplechoicegui\";s:6:\"parent\";i:1974;}i:1980;a:2:{s:5:\"class\";s:13:\"assnumericgui\";s:6:\"parent\";i:1974;}i:1981;a:2:{s:5:\"class\";s:22:\"assorderingquestiongui\";s:6:\"parent\";i:1974;}i:1982;a:2:{s:5:\"class\";s:26:\"assquestiontypetemplategui\";s:6:\"parent\";i:1974;}i:1983;a:2:{s:5:\"class\";s:18:\"asssinglechoicegui\";s:6:\"parent\";i:1974;}i:1984;a:2:{s:5:\"class\";s:18:\"asstextquestiongui\";s:6:\"parent\";i:1974;}i:1985;a:2:{s:5:\"class\";s:16:\"asstextsubsetgui\";s:6:\"parent\";i:1974;}i:1986;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1974;}i:1987;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1974;}i:1988;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1987;}i:1989;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1988;}i:1990;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1989;}i:1991;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1990;}i:1992;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1989;}i:1993;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1987;}i:1994;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1987;}i:1995;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1994;}i:1996;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1994;}i:1997;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1996;}i:1998;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1997;}i:1999;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1996;}i:2000;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1994;}i:2001;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1994;}i:2002;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1994;}i:2003;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1994;}i:2004;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1994;}i:2005;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1994;}i:2006;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1994;}i:2007;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2006;}i:2008;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2007;}i:2009;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2008;}i:2010;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2007;}i:2011;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2006;}i:2012;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2011;}i:2013;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1994;}i:2014;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1994;}i:2015;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1994;}i:2016;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1994;}i:2017;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1994;}i:2018;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1994;}i:2019;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1994;}i:2020;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1994;}i:2021;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1994;}i:2022;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1987;}i:2023;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1974;}i:2024;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2023;}i:2025;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2024;}i:2026;a:2:{s:5:\"class\";s:20:\"ilobjremotecoursegui\";s:6:\"parent\";i:1;}i:2027;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2026;}i:2028;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2027;}i:2029;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2028;}i:2030;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2028;}i:2031;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2028;}i:2032;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2031;}i:2033;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2031;}i:2034;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2033;}i:2035;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2031;}i:2036;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2035;}i:2037;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2031;}i:2038;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2037;}i:2039;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2031;}i:2040;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2039;}i:2041;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2028;}i:2042;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2028;}i:2043;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2028;}i:2044;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2028;}i:2045;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2044;}i:2046;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2028;}i:2047;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2046;}i:2048;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2046;}i:2049;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2048;}i:2050;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2046;}i:2051;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2050;}i:2052;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2046;}i:2053;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2052;}i:2054;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2046;}i:2055;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2054;}i:2056;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2028;}i:2057;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2028;}i:2058;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2028;}i:2059;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2028;}i:2060;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2028;}i:2061;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2028;}i:2062;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2028;}i:2063;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2028;}i:2064;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2028;}i:2065;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2064;}i:2066;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2027;}i:2067;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2066;}i:2068;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2027;}i:2069;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2027;}i:2070;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2026;}i:2071;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2070;}i:2072;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2071;}i:2073;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1;}i:2074;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2073;}i:2075;a:2:{s:5:\"class\";s:18:\"ilobjrootfoldergui\";s:6:\"parent\";i:1;}i:2076;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2075;}i:2077;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2076;}i:2078;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2076;}i:2079;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2076;}i:2080;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2079;}i:2081;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2079;}i:2082;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2081;}i:2083;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2079;}i:2084;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2083;}i:2085;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2079;}i:2086;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2085;}i:2087;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2079;}i:2088;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2087;}i:2089;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2076;}i:2090;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2076;}i:2091;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2076;}i:2092;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2076;}i:2093;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2092;}i:2094;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2076;}i:2095;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2094;}i:2096;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2094;}i:2097;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2096;}i:2098;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2094;}i:2099;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2098;}i:2100;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2094;}i:2101;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2100;}i:2102;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2094;}i:2103;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2102;}i:2104;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2076;}i:2105;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2076;}i:2106;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2076;}i:2107;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2076;}i:2108;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2076;}i:2109;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2076;}i:2110;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2076;}i:2111;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2076;}i:2112;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2076;}i:2113;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2112;}i:2114;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:2075;}i:2115;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2114;}i:2116;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2075;}i:2117;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2116;}i:2118;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2117;}i:2119;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2118;}i:2120;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2119;}i:2121;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2118;}i:2122;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2116;}i:2123;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2116;}i:2124;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2123;}i:2125;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2123;}i:2126;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2125;}i:2127;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2126;}i:2128;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2125;}i:2129;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2123;}i:2130;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2123;}i:2131;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2123;}i:2132;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2123;}i:2133;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2123;}i:2134;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2123;}i:2135;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2123;}i:2136;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2135;}i:2137;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2136;}i:2138;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2137;}i:2139;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2136;}i:2140;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2135;}i:2141;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2140;}i:2142;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2123;}i:2143;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2123;}i:2144;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2123;}i:2145;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2123;}i:2146;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2123;}i:2147;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2123;}i:2148;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2123;}i:2149;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2123;}i:2150;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2123;}i:2151;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2116;}i:2152;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2075;}i:2153;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2152;}i:2154;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2153;}i:2155;a:2:{s:5:\"class\";s:26:\"ilobjsahslearningmodulegui\";s:6:\"parent\";i:1;}i:2156;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:2155;}i:2157;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2155;}i:2158;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2155;}i:2159;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2158;}i:2160;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2159;}i:2161;a:2:{s:5:\"class\";s:15:\"ilobjsessiongui\";s:6:\"parent\";i:1;}i:2162;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2161;}i:2163;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2162;}i:2164;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2163;}i:2165;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2163;}i:2166;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2163;}i:2167;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2166;}i:2168;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2166;}i:2169;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2168;}i:2170;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2166;}i:2171;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2170;}i:2172;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2166;}i:2173;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2172;}i:2174;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2166;}i:2175;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2174;}i:2176;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2163;}i:2177;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2163;}i:2178;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2163;}i:2179;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2163;}i:2180;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2179;}i:2181;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2163;}i:2182;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2181;}i:2183;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2181;}i:2184;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2183;}i:2185;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2181;}i:2186;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2185;}i:2187;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2181;}i:2188;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2187;}i:2189;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2181;}i:2190;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2189;}i:2191;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2163;}i:2192;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2163;}i:2193;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2163;}i:2194;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2163;}i:2195;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2163;}i:2196;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2163;}i:2197;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2163;}i:2198;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2163;}i:2199;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2163;}i:2200;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2199;}i:2201;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2162;}i:2202;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2201;}i:2203;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2162;}i:2204;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2162;}i:2205;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2161;}i:2206;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2205;}i:2207;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2206;}i:2208;a:2:{s:5:\"class\";s:14:\"ilobjsurveygui\";s:6:\"parent\";i:1;}i:2209;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2208;}i:2210;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2209;}i:2211;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2210;}i:2212;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2210;}i:2213;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2210;}i:2214;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2213;}i:2215;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2213;}i:2216;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2215;}i:2217;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2213;}i:2218;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2217;}i:2219;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2213;}i:2220;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2219;}i:2221;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2213;}i:2222;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2221;}i:2223;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2210;}i:2224;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2210;}i:2225;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2210;}i:2226;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2210;}i:2227;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2226;}i:2228;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2210;}i:2229;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2228;}i:2230;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2228;}i:2231;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2230;}i:2232;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2228;}i:2233;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2232;}i:2234;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2228;}i:2235;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2234;}i:2236;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2228;}i:2237;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2236;}i:2238;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2210;}i:2239;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2210;}i:2240;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2210;}i:2241;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2210;}i:2242;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2210;}i:2243;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2210;}i:2244;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2210;}i:2245;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2210;}i:2246;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2210;}i:2247;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2246;}i:2248;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2209;}i:2249;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2248;}i:2250;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2209;}i:2251;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2209;}i:2252;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2208;}i:2253;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2208;}i:2254;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2253;}i:2255;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2254;}i:2256;a:2:{s:5:\"class\";s:21:\"ilsurveyevaluationgui\";s:6:\"parent\";i:2208;}i:2257;a:2:{s:5:\"class\";s:20:\"ilsurveyexecutiongui\";s:6:\"parent\";i:2208;}i:2258;a:2:{s:5:\"class\";s:26:\"ilobjsurveyquestionpoolgui\";s:6:\"parent\";i:1;}i:2259;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2258;}i:2260;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2258;}i:2261;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2260;}i:2262;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2261;}i:2263;a:2:{s:5:\"class\";s:18:\"ilsurveyphrasesgui\";s:6:\"parent\";i:2258;}i:2264;a:2:{s:5:\"class\";s:23:\"surveymatrixquestiongui\";s:6:\"parent\";i:2258;}i:2265;a:2:{s:5:\"class\";s:23:\"surveymetricquestiongui\";s:6:\"parent\";i:2258;}i:2266;a:2:{s:5:\"class\";s:24:\"surveynominalquestiongui\";s:6:\"parent\";i:2258;}i:2267;a:2:{s:5:\"class\";s:24:\"surveyordinalquestiongui\";s:6:\"parent\";i:2258;}i:2268;a:2:{s:5:\"class\";s:21:\"surveytextquestiongui\";s:6:\"parent\";i:2258;}i:2269;a:2:{s:5:\"class\";s:12:\"ilobjtestgui\";s:6:\"parent\";i:1;}i:2270;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2269;}i:2271;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2270;}i:2272;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2271;}i:2273;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2271;}i:2274;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2271;}i:2275;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2274;}i:2276;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2274;}i:2277;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2276;}i:2278;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2274;}i:2279;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2278;}i:2280;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2274;}i:2281;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2280;}i:2282;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2274;}i:2283;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2282;}i:2284;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2271;}i:2285;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2271;}i:2286;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2271;}i:2287;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2271;}i:2288;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2287;}i:2289;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2271;}i:2290;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2289;}i:2291;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2289;}i:2292;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2291;}i:2293;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2289;}i:2294;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2293;}i:2295;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2289;}i:2296;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2295;}i:2297;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2289;}i:2298;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2297;}i:2299;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2271;}i:2300;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2271;}i:2301;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2271;}i:2302;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2271;}i:2303;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2271;}i:2304;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2271;}i:2305;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2271;}i:2306;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2271;}i:2307;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2271;}i:2308;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2307;}i:2309;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2270;}i:2310;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2309;}i:2311;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2270;}i:2312;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2270;}i:2313;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2269;}i:2314;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:2313;}i:2315;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:2313;}i:2316;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2315;}i:2317;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2316;}i:2318;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2315;}i:2319;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2318;}i:2320;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:2315;}i:2321;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2320;}i:2322;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:2313;}i:2323;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2322;}i:2324;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2323;}i:2325;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2322;}i:2326;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2325;}i:2327;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:2313;}i:2328;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2327;}i:2329;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2269;}i:2330;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:2269;}i:2331;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2330;}i:2332;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2331;}i:2333;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2331;}i:2334;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2331;}i:2335;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2334;}i:2336;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2334;}i:2337;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2336;}i:2338;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2334;}i:2339;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2338;}i:2340;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2334;}i:2341;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2340;}i:2342;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2334;}i:2343;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2342;}i:2344;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2331;}i:2345;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2331;}i:2346;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2331;}i:2347;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2331;}i:2348;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2347;}i:2349;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2331;}i:2350;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2349;}i:2351;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2349;}i:2352;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2351;}i:2353;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2349;}i:2354;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2353;}i:2355;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2349;}i:2356;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2355;}i:2357;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2349;}i:2358;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2357;}i:2359;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2331;}i:2360;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2331;}i:2361;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2331;}i:2362;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2331;}i:2363;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2331;}i:2364;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2331;}i:2365;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2331;}i:2366;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2331;}i:2367;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2331;}i:2368;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2367;}i:2369;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:2330;}i:2370;a:2:{s:5:\"class\";s:20:\"ilcourseagreementgui\";s:6:\"parent\";i:2330;}i:2371;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2370;}i:2372;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:2330;}i:2373;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2372;}i:2374;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2373;}i:2375;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2373;}i:2376;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2373;}i:2377;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2376;}i:2378;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2376;}i:2379;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2378;}i:2380;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2376;}i:2381;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2380;}i:2382;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2376;}i:2383;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2382;}i:2384;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2376;}i:2385;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2384;}i:2386;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2373;}i:2387;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2373;}i:2388;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2373;}i:2389;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2373;}i:2390;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2389;}i:2391;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2373;}i:2392;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2391;}i:2393;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2391;}i:2394;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2393;}i:2395;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2391;}i:2396;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2395;}i:2397;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2391;}i:2398;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2397;}i:2399;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2391;}i:2400;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2399;}i:2401;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2373;}i:2402;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2373;}i:2403;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2373;}i:2404;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2373;}i:2405;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2373;}i:2406;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2373;}i:2407;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2373;}i:2408;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2373;}i:2409;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2373;}i:2410;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2409;}i:2411;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:2372;}i:2412;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:2372;}i:2413;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2412;}i:2414;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:2330;}i:2415;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:2414;}i:2416;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:2330;}i:2417;a:2:{s:5:\"class\";s:23:\"ilcourseregistrationgui\";s:6:\"parent\";i:2330;}i:2418;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2417;}i:2419;a:2:{s:5:\"class\";s:21:\"ilcourseuserfieldsgui\";s:6:\"parent\";i:2330;}i:2420;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2330;}i:2421;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2420;}i:2422;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2421;}i:2423;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2421;}i:2424;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2421;}i:2425;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2424;}i:2426;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2424;}i:2427;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2426;}i:2428;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2424;}i:2429;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2428;}i:2430;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2424;}i:2431;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2430;}i:2432;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2424;}i:2433;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2432;}i:2434;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2421;}i:2435;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2421;}i:2436;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2421;}i:2437;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2421;}i:2438;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2437;}i:2439;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2421;}i:2440;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2439;}i:2441;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2439;}i:2442;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2441;}i:2443;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2439;}i:2444;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2443;}i:2445;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2439;}i:2446;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2445;}i:2447;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2439;}i:2448;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2447;}i:2449;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2421;}i:2450;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2421;}i:2451;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2421;}i:2452;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2421;}i:2453;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2421;}i:2454;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2421;}i:2455;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2421;}i:2456;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2421;}i:2457;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2421;}i:2458;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2457;}i:2459;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2420;}i:2460;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2459;}i:2461;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2420;}i:2462;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2420;}i:2463;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2330;}i:2464;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:2463;}i:2465;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:2463;}i:2466;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2465;}i:2467;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2466;}i:2468;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2465;}i:2469;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2468;}i:2470;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:2465;}i:2471;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2470;}i:2472;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:2463;}i:2473;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2472;}i:2474;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2473;}i:2475;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2472;}i:2476;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2475;}i:2477;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:2463;}i:2478;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2477;}i:2479;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2330;}i:2480;a:2:{s:5:\"class\";s:17:\"ilmemberexportgui\";s:6:\"parent\";i:2330;}i:2481;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2480;}i:2482;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:2330;}i:2483;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2330;}i:2484;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2483;}i:2485;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2484;}i:2486;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2485;}i:2487;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2486;}i:2488;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2485;}i:2489;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2483;}i:2490;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2483;}i:2491;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2490;}i:2492;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2490;}i:2493;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2492;}i:2494;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2493;}i:2495;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2492;}i:2496;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2490;}i:2497;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2490;}i:2498;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2490;}i:2499;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2490;}i:2500;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2490;}i:2501;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2490;}i:2502;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2490;}i:2503;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2502;}i:2504;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2503;}i:2505;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2504;}i:2506;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2503;}i:2507;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2502;}i:2508;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2507;}i:2509;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2490;}i:2510;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2490;}i:2511;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2490;}i:2512;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2490;}i:2513;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2490;}i:2514;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2490;}i:2515;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2490;}i:2516;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2490;}i:2517;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2490;}i:2518;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2483;}i:2519;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2330;}i:2520;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2519;}i:2521;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2520;}i:2522;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2330;}i:2523;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:2330;}i:2524;a:2:{s:5:\"class\";s:20:\"ilsessionoverviewgui\";s:6:\"parent\";i:2330;}i:2525;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:2330;}i:2526;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2525;}i:2527;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2526;}i:2528;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2527;}i:2529;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2528;}i:2530;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2529;}i:2531;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2528;}i:2532;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2526;}i:2533;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2526;}i:2534;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2533;}i:2535;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2533;}i:2536;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2535;}i:2537;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2536;}i:2538;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2535;}i:2539;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2533;}i:2540;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2533;}i:2541;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2533;}i:2542;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2533;}i:2543;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2533;}i:2544;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2533;}i:2545;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2533;}i:2546;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2545;}i:2547;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2546;}i:2548;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2547;}i:2549;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2546;}i:2550;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2545;}i:2551;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2550;}i:2552;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2533;}i:2553;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2533;}i:2554;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2533;}i:2555;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2533;}i:2556;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2533;}i:2557;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2533;}i:2558;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2533;}i:2559;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2533;}i:2560;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2533;}i:2561;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2526;}i:2562;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2269;}i:2563;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2562;}i:2564;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2563;}i:2565;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:2269;}i:2566;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2565;}i:2567;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2566;}i:2568;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2567;}i:2569;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2568;}i:2570;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2569;}i:2571;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2568;}i:2572;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2566;}i:2573;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2566;}i:2574;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2573;}i:2575;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2573;}i:2576;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2575;}i:2577;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2576;}i:2578;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2575;}i:2579;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2573;}i:2580;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2573;}i:2581;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2573;}i:2582;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2573;}i:2583;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2573;}i:2584;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2573;}i:2585;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2573;}i:2586;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2585;}i:2587;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2586;}i:2588;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2587;}i:2589;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2586;}i:2590;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2585;}i:2591;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2590;}i:2592;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2573;}i:2593;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2573;}i:2594;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2573;}i:2595;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2573;}i:2596;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2573;}i:2597;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2573;}i:2598;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2573;}i:2599;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2573;}i:2600;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2573;}i:2601;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2566;}i:2602;a:2:{s:5:\"class\";s:20:\"iltestcertificategui\";s:6:\"parent\";i:2269;}i:2603;a:2:{s:5:\"class\";s:19:\"iltestevaluationgui\";s:6:\"parent\";i:2269;}i:2604;a:2:{s:5:\"class\";s:15:\"iltestoutputgui\";s:6:\"parent\";i:2269;}i:2605;a:2:{s:5:\"class\";s:16:\"iltestscoringgui\";s:6:\"parent\";i:2269;}i:2606;a:2:{s:5:\"class\";s:16:\"iltestservicegui\";s:6:\"parent\";i:2269;}i:2607;a:2:{s:5:\"class\";s:12:\"ilobjwikigui\";s:6:\"parent\";i:1;}i:2608;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2607;}i:2609;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2608;}i:2610;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2609;}i:2611;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2609;}i:2612;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2609;}i:2613;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2612;}i:2614;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2612;}i:2615;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2614;}i:2616;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2612;}i:2617;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2616;}i:2618;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2612;}i:2619;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2618;}i:2620;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2612;}i:2621;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2620;}i:2622;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2609;}i:2623;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2609;}i:2624;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2609;}i:2625;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2609;}i:2626;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2625;}i:2627;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2609;}i:2628;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2627;}i:2629;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2627;}i:2630;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2629;}i:2631;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2627;}i:2632;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2631;}i:2633;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2627;}i:2634;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2633;}i:2635;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2627;}i:2636;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2635;}i:2637;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2609;}i:2638;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2609;}i:2639;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2609;}i:2640;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2609;}i:2641;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2609;}i:2642;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2609;}i:2643;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2609;}i:2644;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2609;}i:2645;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2609;}i:2646;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2645;}i:2647;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2608;}i:2648;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2647;}i:2649;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2608;}i:2650;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2608;}i:2651;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2607;}i:2652;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2651;}i:2653;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2652;}i:2654;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2607;}i:2655;a:2:{s:5:\"class\";s:13:\"ilwikipagegui\";s:6:\"parent\";i:2607;}i:2656;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2655;}i:2657;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2656;}i:2658;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2657;}i:2659;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2658;}i:2660;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2657;}i:2661;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:2655;}i:2662;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2655;}i:2663;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2655;}i:2664;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2663;}i:2665;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2663;}i:2666;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2665;}i:2667;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2666;}i:2668;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2665;}i:2669;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2663;}i:2670;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2663;}i:2671;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2663;}i:2672;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2663;}i:2673;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2663;}i:2674;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2663;}i:2675;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2663;}i:2676;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2675;}i:2677;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2676;}i:2678;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2677;}i:2679;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2676;}i:2680;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2675;}i:2681;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2680;}i:2682;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2663;}i:2683;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2663;}i:2684;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2663;}i:2685;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2663;}i:2686;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2663;}i:2687;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2663;}i:2688;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2663;}i:2689;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2663;}i:2690;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2663;}i:2691;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2655;}i:2692;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2691;}i:2693;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2692;}i:2694;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2693;}i:2695;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2694;}i:2696;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2693;}i:2697;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2691;}i:2698;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2691;}i:2699;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2698;}i:2700;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2698;}i:2701;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2700;}i:2702;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2701;}i:2703;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2700;}i:2704;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2698;}i:2705;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2698;}i:2706;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2698;}i:2707;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2698;}i:2708;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2698;}i:2709;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2698;}i:2710;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2698;}i:2711;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2710;}i:2712;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2711;}i:2713;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2712;}i:2714;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2711;}i:2715;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2710;}i:2716;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2715;}i:2717;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2698;}i:2718;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2698;}i:2719;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2698;}i:2720;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2698;}i:2721;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2698;}i:2722;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2698;}i:2723;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2698;}i:2724;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2698;}i:2725;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2698;}i:2726;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2691;}i:2727;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2655;}i:2728;a:2:{s:5:\"class\";s:11:\"ilratinggui\";s:6:\"parent\";i:2655;}}','a:75:{s:0:\"\";a:1726:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:0:\"\";i:69;s:0:\"\";i:70;s:0:\"\";i:71;s:0:\"\";i:72;s:0:\"\";i:73;s:0:\"\";i:74;s:0:\"\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:0:\"\";i:78;s:0:\"\";i:79;s:0:\"\";i:80;s:0:\"\";i:81;s:0:\"\";i:82;s:0:\"\";i:83;s:0:\"\";i:84;s:0:\"\";i:85;s:0:\"\";i:86;s:0:\"\";i:87;s:0:\"\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:0:\"\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:0:\"\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:0:\"\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:0:\"\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:0:\"\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:0:\"\";i:137;s:0:\"\";i:138;s:0:\"\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:0:\"\";i:142;s:0:\"\";i:143;s:0:\"\";i:144;s:0:\"\";i:145;s:0:\"\";i:146;s:0:\"\";i:147;s:0:\"\";i:148;s:0:\"\";i:149;s:0:\"\";i:150;s:0:\"\";i:151;s:0:\"\";i:152;s:0:\"\";i:153;s:0:\"\";i:154;s:0:\"\";i:155;s:0:\"\";i:156;s:0:\"\";i:157;s:0:\"\";i:158;s:0:\"\";i:159;s:0:\"\";i:160;s:0:\"\";i:161;s:0:\"\";i:162;s:0:\"\";i:163;s:0:\"\";i:164;s:0:\"\";i:165;s:0:\"\";i:166;s:0:\"\";i:167;s:0:\"\";i:168;s:0:\"\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:0:\"\";i:172;s:0:\"\";i:173;s:0:\"\";i:174;s:0:\"\";i:175;s:0:\"\";i:176;s:0:\"\";i:177;s:0:\"\";i:178;s:0:\"\";i:179;s:0:\"\";i:180;s:0:\"\";i:181;s:0:\"\";i:182;s:0:\"\";i:183;s:0:\"\";i:184;s:0:\"\";i:185;s:0:\"\";i:186;s:0:\"\";i:187;s:0:\"\";i:188;s:0:\"\";i:189;s:0:\"\";i:190;s:0:\"\";i:191;s:0:\"\";i:192;s:0:\"\";i:193;s:0:\"\";i:194;s:0:\"\";i:195;s:0:\"\";i:196;s:0:\"\";i:197;s:0:\"\";i:198;s:0:\"\";i:199;s:0:\"\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:0:\"\";i:207;s:0:\"\";i:208;s:0:\"\";i:209;s:0:\"\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:0:\"\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:0:\"\";i:220;s:0:\"\";i:221;s:0:\"\";i:222;s:0:\"\";i:223;s:0:\"\";i:224;s:0:\"\";i:225;s:0:\"\";i:226;s:0:\"\";i:227;s:0:\"\";i:228;s:0:\"\";i:229;s:0:\"\";i:230;s:0:\"\";i:231;s:0:\"\";i:232;s:0:\"\";i:233;s:0:\"\";i:234;s:0:\"\";i:235;s:0:\"\";i:236;s:0:\"\";i:237;s:0:\"\";i:238;s:0:\"\";i:239;s:0:\"\";i:240;s:0:\"\";i:241;s:0:\"\";i:242;s:0:\"\";i:243;s:0:\"\";i:244;s:0:\"\";i:245;s:0:\"\";i:246;s:0:\"\";i:247;s:0:\"\";i:248;s:0:\"\";i:249;s:0:\"\";i:250;s:0:\"\";i:251;s:0:\"\";i:252;s:0:\"\";i:253;s:0:\"\";i:254;s:0:\"\";i:255;s:0:\"\";i:256;s:0:\"\";i:257;s:0:\"\";i:258;s:0:\"\";i:259;s:0:\"\";i:260;s:0:\"\";i:261;s:0:\"\";i:262;s:0:\"\";i:263;s:0:\"\";i:264;s:0:\"\";i:265;s:0:\"\";i:266;s:0:\"\";i:267;s:0:\"\";i:268;s:0:\"\";i:269;s:0:\"\";i:270;s:0:\"\";i:271;s:0:\"\";i:272;s:0:\"\";i:273;s:0:\"\";i:274;s:0:\"\";i:275;s:0:\"\";i:276;s:0:\"\";i:277;s:0:\"\";i:278;s:0:\"\";i:279;s:0:\"\";i:280;s:0:\"\";i:281;s:0:\"\";i:282;s:0:\"\";i:283;s:0:\"\";i:284;s:0:\"\";i:285;s:0:\"\";i:286;s:0:\"\";i:287;s:0:\"\";i:288;s:0:\"\";i:289;s:0:\"\";i:290;s:0:\"\";i:291;s:0:\"\";i:292;s:0:\"\";i:293;s:0:\"\";i:294;s:0:\"\";i:295;s:0:\"\";i:296;s:0:\"\";i:297;s:0:\"\";i:298;s:0:\"\";i:299;s:0:\"\";i:300;s:0:\"\";i:301;s:0:\"\";i:302;s:0:\"\";i:303;s:0:\"\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:0:\"\";i:307;s:0:\"\";i:308;s:0:\"\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:0:\"\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:0:\"\";i:317;s:0:\"\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:0:\"\";i:321;s:0:\"\";i:322;s:0:\"\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:0:\"\";i:327;s:0:\"\";i:328;s:0:\"\";i:329;s:0:\"\";i:330;s:0:\"\";i:331;s:0:\"\";i:332;s:0:\"\";i:333;s:0:\"\";i:334;s:0:\"\";i:335;s:0:\"\";i:336;s:0:\"\";i:337;s:0:\"\";i:338;s:0:\"\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:0:\"\";i:343;s:0:\"\";i:344;s:0:\"\";i:345;s:0:\"\";i:346;s:0:\"\";i:347;s:0:\"\";i:348;s:0:\"\";i:349;s:0:\"\";i:350;s:0:\"\";i:351;s:0:\"\";i:352;s:0:\"\";i:353;s:0:\"\";i:354;s:0:\"\";i:355;s:0:\"\";i:356;s:0:\"\";i:357;s:0:\"\";i:358;s:0:\"\";i:359;s:0:\"\";i:360;s:0:\"\";i:361;s:0:\"\";i:362;s:0:\"\";i:363;s:0:\"\";i:364;s:0:\"\";i:365;s:0:\"\";i:366;s:0:\"\";i:367;s:0:\"\";i:368;s:0:\"\";i:369;s:0:\"\";i:370;s:0:\"\";i:371;s:0:\"\";i:372;s:0:\"\";i:373;s:0:\"\";i:374;s:0:\"\";i:375;s:0:\"\";i:376;s:0:\"\";i:377;s:0:\"\";i:378;s:0:\"\";i:379;s:0:\"\";i:380;s:0:\"\";i:381;s:0:\"\";i:382;s:0:\"\";i:383;s:0:\"\";i:384;s:0:\"\";i:385;s:0:\"\";i:386;s:0:\"\";i:387;s:0:\"\";i:388;s:0:\"\";i:389;s:0:\"\";i:390;s:0:\"\";i:391;s:0:\"\";i:392;s:0:\"\";i:393;s:0:\"\";i:394;s:0:\"\";i:395;s:0:\"\";i:396;s:0:\"\";i:397;s:0:\"\";i:398;s:0:\"\";i:399;s:0:\"\";i:400;s:0:\"\";i:401;s:0:\"\";i:402;s:0:\"\";i:403;s:0:\"\";i:404;s:0:\"\";i:405;s:0:\"\";i:406;s:0:\"\";i:407;s:0:\"\";i:408;s:0:\"\";i:409;s:0:\"\";i:410;s:0:\"\";i:411;s:0:\"\";i:412;s:0:\"\";i:413;s:0:\"\";i:414;s:0:\"\";i:415;s:0:\"\";i:416;s:0:\"\";i:417;s:0:\"\";i:418;s:0:\"\";i:419;s:0:\"\";i:420;s:0:\"\";i:421;s:0:\"\";i:422;s:0:\"\";i:423;s:0:\"\";i:424;s:0:\"\";i:425;s:0:\"\";i:426;s:0:\"\";i:427;s:0:\"\";i:428;s:0:\"\";i:429;s:0:\"\";i:430;s:0:\"\";i:431;s:0:\"\";i:432;s:0:\"\";i:433;s:0:\"\";i:434;s:0:\"\";i:435;s:0:\"\";i:436;s:0:\"\";i:437;s:0:\"\";i:438;s:0:\"\";i:439;s:0:\"\";i:440;s:0:\"\";i:441;s:0:\"\";i:442;s:0:\"\";i:443;s:0:\"\";i:444;s:0:\"\";i:445;s:0:\"\";i:446;s:0:\"\";i:447;s:0:\"\";i:448;s:0:\"\";i:449;s:0:\"\";i:450;s:0:\"\";i:451;s:0:\"\";i:452;s:0:\"\";i:453;s:0:\"\";i:454;s:0:\"\";i:455;s:0:\"\";i:456;s:0:\"\";i:457;s:0:\"\";i:458;s:0:\"\";i:459;s:0:\"\";i:460;s:0:\"\";i:461;s:0:\"\";i:462;s:0:\"\";i:463;s:0:\"\";i:464;s:0:\"\";i:465;s:0:\"\";i:466;s:0:\"\";i:467;s:0:\"\";i:468;s:0:\"\";i:469;s:0:\"\";i:470;s:0:\"\";i:471;s:0:\"\";i:472;s:0:\"\";i:473;s:0:\"\";i:474;s:0:\"\";i:475;s:0:\"\";i:476;s:0:\"\";i:477;s:0:\"\";i:478;s:0:\"\";i:479;s:0:\"\";i:480;s:0:\"\";i:481;s:0:\"\";i:482;s:0:\"\";i:483;s:0:\"\";i:484;s:0:\"\";i:485;s:0:\"\";i:486;s:0:\"\";i:487;s:0:\"\";i:488;s:0:\"\";i:489;s:0:\"\";i:490;s:0:\"\";i:491;s:0:\"\";i:492;s:0:\"\";i:493;s:0:\"\";i:494;s:0:\"\";i:495;s:0:\"\";i:496;s:0:\"\";i:497;s:0:\"\";i:498;s:0:\"\";i:499;s:0:\"\";i:500;s:0:\"\";i:501;s:0:\"\";i:502;s:0:\"\";i:503;s:0:\"\";i:504;s:0:\"\";i:505;s:0:\"\";i:506;s:0:\"\";i:507;s:0:\"\";i:508;s:0:\"\";i:509;s:0:\"\";i:510;s:0:\"\";i:511;s:0:\"\";i:512;s:0:\"\";i:513;s:0:\"\";i:514;s:0:\"\";i:515;s:0:\"\";i:516;s:0:\"\";i:517;s:0:\"\";i:518;s:0:\"\";i:519;s:0:\"\";i:520;s:0:\"\";i:521;s:0:\"\";i:522;s:0:\"\";i:523;s:0:\"\";i:524;s:0:\"\";i:525;s:0:\"\";i:526;s:0:\"\";i:527;s:0:\"\";i:528;s:0:\"\";i:529;s:0:\"\";i:530;s:0:\"\";i:531;s:0:\"\";i:532;s:0:\"\";i:533;s:0:\"\";i:534;s:0:\"\";i:535;s:0:\"\";i:536;s:0:\"\";i:537;s:0:\"\";i:538;s:0:\"\";i:539;s:0:\"\";i:540;s:0:\"\";i:541;s:0:\"\";i:542;s:0:\"\";i:543;s:0:\"\";i:544;s:0:\"\";i:545;s:0:\"\";i:546;s:0:\"\";i:547;s:0:\"\";i:548;s:0:\"\";i:549;s:0:\"\";i:550;s:0:\"\";i:551;s:0:\"\";i:552;s:0:\"\";i:553;s:0:\"\";i:554;s:0:\"\";i:555;s:0:\"\";i:556;s:0:\"\";i:557;s:0:\"\";i:558;s:0:\"\";i:559;s:0:\"\";i:560;s:0:\"\";i:561;s:0:\"\";i:562;s:0:\"\";i:563;s:0:\"\";i:564;s:0:\"\";i:565;s:0:\"\";i:566;s:0:\"\";i:567;s:0:\"\";i:568;s:0:\"\";i:569;s:0:\"\";i:570;s:0:\"\";i:571;s:0:\"\";i:572;s:0:\"\";i:573;s:0:\"\";i:574;s:0:\"\";i:575;s:0:\"\";i:576;s:0:\"\";i:577;s:0:\"\";i:578;s:0:\"\";i:579;s:0:\"\";i:580;s:0:\"\";i:581;s:0:\"\";i:582;s:0:\"\";i:583;s:0:\"\";i:584;s:0:\"\";i:585;s:0:\"\";i:586;s:0:\"\";i:587;s:0:\"\";i:588;s:0:\"\";i:589;s:0:\"\";i:590;s:0:\"\";i:591;s:0:\"\";i:592;s:0:\"\";i:593;s:0:\"\";i:594;s:0:\"\";i:595;s:0:\"\";i:596;s:0:\"\";i:597;s:0:\"\";i:598;s:0:\"\";i:599;s:0:\"\";i:600;s:0:\"\";i:601;s:0:\"\";i:602;s:0:\"\";i:603;s:0:\"\";i:604;s:0:\"\";i:605;s:0:\"\";i:606;s:0:\"\";i:607;s:0:\"\";i:608;s:0:\"\";i:609;s:0:\"\";i:610;s:0:\"\";i:611;s:0:\"\";i:612;s:0:\"\";i:613;s:0:\"\";i:614;s:0:\"\";i:615;s:0:\"\";i:616;s:0:\"\";i:617;s:0:\"\";i:618;s:0:\"\";i:619;s:0:\"\";i:620;s:0:\"\";i:621;s:0:\"\";i:622;s:0:\"\";i:623;s:0:\"\";i:624;s:0:\"\";i:625;s:0:\"\";i:626;s:0:\"\";i:627;s:0:\"\";i:628;s:0:\"\";i:629;s:0:\"\";i:630;s:0:\"\";i:631;s:0:\"\";i:632;s:0:\"\";i:633;s:0:\"\";i:634;s:0:\"\";i:635;s:0:\"\";i:636;s:0:\"\";i:637;s:0:\"\";i:638;s:0:\"\";i:639;s:0:\"\";i:640;s:0:\"\";i:641;s:0:\"\";i:642;s:0:\"\";i:643;s:0:\"\";i:644;s:0:\"\";i:645;s:0:\"\";i:646;s:0:\"\";i:647;s:0:\"\";i:648;s:0:\"\";i:649;s:0:\"\";i:650;s:0:\"\";i:651;s:0:\"\";i:652;s:0:\"\";i:653;s:0:\"\";i:654;s:0:\"\";i:655;s:0:\"\";i:656;s:0:\"\";i:657;s:0:\"\";i:658;s:0:\"\";i:659;s:0:\"\";i:660;s:0:\"\";i:661;s:0:\"\";i:662;s:0:\"\";i:663;s:0:\"\";i:664;s:0:\"\";i:665;s:0:\"\";i:666;s:0:\"\";i:667;s:0:\"\";i:668;s:0:\"\";i:669;s:0:\"\";i:670;s:0:\"\";i:671;s:0:\"\";i:672;s:0:\"\";i:673;s:0:\"\";i:674;s:0:\"\";i:675;s:0:\"\";i:676;s:0:\"\";i:677;s:0:\"\";i:678;s:0:\"\";i:679;s:0:\"\";i:680;s:0:\"\";i:681;s:0:\"\";i:682;s:0:\"\";i:683;s:0:\"\";i:684;s:0:\"\";i:685;s:0:\"\";i:686;s:0:\"\";i:687;s:0:\"\";i:688;s:0:\"\";i:689;s:0:\"\";i:690;s:0:\"\";i:691;s:0:\"\";i:692;s:0:\"\";i:693;s:0:\"\";i:694;s:0:\"\";i:695;s:0:\"\";i:696;s:0:\"\";i:697;s:0:\"\";i:698;s:0:\"\";i:699;s:0:\"\";i:700;s:0:\"\";i:701;s:0:\"\";i:702;s:0:\"\";i:703;s:0:\"\";i:704;s:0:\"\";i:705;s:0:\"\";i:706;s:0:\"\";i:707;s:0:\"\";i:708;s:0:\"\";i:709;s:0:\"\";i:710;s:0:\"\";i:711;s:0:\"\";i:712;s:0:\"\";i:713;s:0:\"\";i:714;s:0:\"\";i:715;s:0:\"\";i:716;s:0:\"\";i:717;s:0:\"\";i:718;s:0:\"\";i:719;s:0:\"\";i:720;s:0:\"\";i:721;s:0:\"\";i:722;s:0:\"\";i:723;s:0:\"\";i:724;s:0:\"\";i:725;s:0:\"\";i:726;s:0:\"\";i:727;s:0:\"\";i:728;s:0:\"\";i:729;s:0:\"\";i:730;s:0:\"\";i:731;s:0:\"\";i:732;s:0:\"\";i:733;s:0:\"\";i:734;s:0:\"\";i:735;s:0:\"\";i:736;s:0:\"\";i:737;s:0:\"\";i:738;s:0:\"\";i:739;s:0:\"\";i:740;s:0:\"\";i:741;s:0:\"\";i:742;s:0:\"\";i:743;s:0:\"\";i:744;s:0:\"\";i:745;s:0:\"\";i:746;s:0:\"\";i:747;s:0:\"\";i:748;s:0:\"\";i:749;s:0:\"\";i:750;s:0:\"\";i:751;s:0:\"\";i:752;s:0:\"\";i:753;s:0:\"\";i:754;s:0:\"\";i:755;s:0:\"\";i:756;s:0:\"\";i:757;s:0:\"\";i:758;s:0:\"\";i:759;s:0:\"\";i:760;s:0:\"\";i:761;s:0:\"\";i:762;s:0:\"\";i:763;s:0:\"\";i:764;s:0:\"\";i:765;s:0:\"\";i:766;s:0:\"\";i:767;s:0:\"\";i:768;s:0:\"\";i:769;s:0:\"\";i:770;s:0:\"\";i:771;s:0:\"\";i:772;s:0:\"\";i:773;s:0:\"\";i:774;s:0:\"\";i:775;s:0:\"\";i:776;s:0:\"\";i:777;s:0:\"\";i:778;s:0:\"\";i:779;s:0:\"\";i:780;s:0:\"\";i:781;s:0:\"\";i:782;s:0:\"\";i:783;s:0:\"\";i:784;s:0:\"\";i:785;s:0:\"\";i:786;s:0:\"\";i:787;s:0:\"\";i:788;s:0:\"\";i:789;s:0:\"\";i:790;s:0:\"\";i:791;s:0:\"\";i:792;s:0:\"\";i:793;s:0:\"\";i:794;s:0:\"\";i:795;s:0:\"\";i:796;s:0:\"\";i:797;s:0:\"\";i:798;s:0:\"\";i:799;s:0:\"\";i:800;s:0:\"\";i:801;s:0:\"\";i:802;s:0:\"\";i:803;s:0:\"\";i:804;s:0:\"\";i:805;s:0:\"\";i:806;s:0:\"\";i:807;s:0:\"\";i:808;s:0:\"\";i:809;s:0:\"\";i:810;s:0:\"\";i:811;s:0:\"\";i:812;s:0:\"\";i:813;s:0:\"\";i:814;s:0:\"\";i:815;s:0:\"\";i:816;s:0:\"\";i:817;s:0:\"\";i:818;s:0:\"\";i:819;s:0:\"\";i:820;s:0:\"\";i:821;s:0:\"\";i:822;s:0:\"\";i:823;s:0:\"\";i:824;s:0:\"\";i:825;s:0:\"\";i:826;s:0:\"\";i:827;s:0:\"\";i:828;s:0:\"\";i:829;s:0:\"\";i:830;s:0:\"\";i:831;s:0:\"\";i:832;s:0:\"\";i:833;s:0:\"\";i:834;s:0:\"\";i:835;s:0:\"\";i:836;s:0:\"\";i:837;s:0:\"\";i:838;s:0:\"\";i:839;s:0:\"\";i:840;s:0:\"\";i:841;s:0:\"\";i:842;s:0:\"\";i:843;s:0:\"\";i:844;s:0:\"\";i:845;s:0:\"\";i:846;s:0:\"\";i:847;s:0:\"\";i:848;s:0:\"\";i:849;s:0:\"\";i:850;s:0:\"\";i:851;s:0:\"\";i:852;s:0:\"\";i:853;s:0:\"\";i:854;s:0:\"\";i:855;s:0:\"\";i:856;s:0:\"\";i:857;s:0:\"\";i:858;s:0:\"\";i:859;s:0:\"\";i:860;s:0:\"\";i:861;s:0:\"\";i:862;s:0:\"\";i:863;s:0:\"\";i:864;s:0:\"\";i:865;s:0:\"\";i:866;s:0:\"\";i:867;s:0:\"\";i:868;s:0:\"\";i:869;s:0:\"\";i:870;s:0:\"\";i:871;s:0:\"\";i:872;s:0:\"\";i:873;s:0:\"\";i:874;s:0:\"\";i:875;s:0:\"\";i:876;s:0:\"\";i:877;s:0:\"\";i:878;s:0:\"\";i:879;s:0:\"\";i:880;s:0:\"\";i:881;s:0:\"\";i:882;s:0:\"\";i:883;s:0:\"\";i:884;s:0:\"\";i:885;s:0:\"\";i:886;s:0:\"\";i:887;s:0:\"\";i:888;s:0:\"\";i:889;s:0:\"\";i:890;s:0:\"\";i:891;s:0:\"\";i:892;s:0:\"\";i:893;s:0:\"\";i:894;s:0:\"\";i:895;s:0:\"\";i:896;s:0:\"\";i:897;s:0:\"\";i:898;s:0:\"\";i:899;s:0:\"\";i:900;s:0:\"\";i:901;s:0:\"\";i:902;s:0:\"\";i:903;s:0:\"\";i:904;s:0:\"\";i:905;s:0:\"\";i:906;s:0:\"\";i:907;s:0:\"\";i:908;s:0:\"\";i:909;s:0:\"\";i:910;s:0:\"\";i:911;s:0:\"\";i:912;s:0:\"\";i:913;s:0:\"\";i:914;s:0:\"\";i:915;s:0:\"\";i:916;s:0:\"\";i:917;s:0:\"\";i:918;s:0:\"\";i:919;s:0:\"\";i:920;s:0:\"\";i:921;s:0:\"\";i:922;s:0:\"\";i:923;s:0:\"\";i:924;s:0:\"\";i:925;s:0:\"\";i:926;s:0:\"\";i:927;s:0:\"\";i:928;s:0:\"\";i:929;s:0:\"\";i:930;s:0:\"\";i:931;s:0:\"\";i:932;s:0:\"\";i:933;s:0:\"\";i:934;s:0:\"\";i:935;s:0:\"\";i:936;s:0:\"\";i:937;s:0:\"\";i:938;s:0:\"\";i:939;s:0:\"\";i:940;s:0:\"\";i:941;s:0:\"\";i:942;s:0:\"\";i:943;s:0:\"\";i:944;s:0:\"\";i:945;s:0:\"\";i:946;s:0:\"\";i:947;s:0:\"\";i:948;s:0:\"\";i:949;s:0:\"\";i:950;s:0:\"\";i:951;s:0:\"\";i:952;s:0:\"\";i:953;s:0:\"\";i:954;s:0:\"\";i:955;s:0:\"\";i:956;s:0:\"\";i:957;s:0:\"\";i:958;s:0:\"\";i:959;s:0:\"\";i:960;s:0:\"\";i:961;s:0:\"\";i:962;s:0:\"\";i:963;s:0:\"\";i:964;s:0:\"\";i:965;s:0:\"\";i:966;s:0:\"\";i:967;s:0:\"\";i:968;s:0:\"\";i:969;s:0:\"\";i:970;s:0:\"\";i:971;s:0:\"\";i:972;s:0:\"\";i:973;s:0:\"\";i:974;s:0:\"\";i:975;s:0:\"\";i:976;s:0:\"\";i:977;s:0:\"\";i:978;s:0:\"\";i:979;s:0:\"\";i:980;s:0:\"\";i:981;s:0:\"\";i:982;s:0:\"\";i:983;s:0:\"\";i:984;s:0:\"\";i:985;s:0:\"\";i:986;s:0:\"\";i:987;s:0:\"\";i:988;s:0:\"\";i:989;s:0:\"\";i:990;s:0:\"\";i:991;s:0:\"\";i:992;s:0:\"\";i:993;s:0:\"\";i:994;s:0:\"\";i:995;s:0:\"\";i:996;s:0:\"\";i:997;s:0:\"\";i:998;s:0:\"\";i:999;s:0:\"\";i:1000;s:0:\"\";i:1001;s:0:\"\";i:1002;s:0:\"\";i:1003;s:0:\"\";i:1004;s:0:\"\";i:1005;s:0:\"\";i:1006;s:0:\"\";i:1007;s:0:\"\";i:1008;s:0:\"\";i:1009;s:0:\"\";i:1010;s:0:\"\";i:1011;s:0:\"\";i:1012;s:0:\"\";i:1013;s:0:\"\";i:1014;s:0:\"\";i:1015;s:0:\"\";i:1016;s:0:\"\";i:1017;s:0:\"\";i:1018;s:0:\"\";i:1019;s:0:\"\";i:1020;s:0:\"\";i:1021;s:0:\"\";i:1022;s:0:\"\";i:1023;s:0:\"\";i:1024;s:0:\"\";i:1025;s:0:\"\";i:1026;s:0:\"\";i:1027;s:0:\"\";i:1028;s:0:\"\";i:1029;s:0:\"\";i:1030;s:0:\"\";i:1031;s:0:\"\";i:1032;s:0:\"\";i:1033;s:0:\"\";i:1034;s:0:\"\";i:1035;s:0:\"\";i:1036;s:0:\"\";i:1037;s:0:\"\";i:1038;s:0:\"\";i:1039;s:0:\"\";i:1040;s:0:\"\";i:1041;s:0:\"\";i:1042;s:0:\"\";i:1043;s:0:\"\";i:1044;s:0:\"\";i:1045;s:0:\"\";i:1046;s:0:\"\";i:1047;s:0:\"\";i:1048;s:0:\"\";i:1049;s:0:\"\";i:1050;s:0:\"\";i:1051;s:0:\"\";i:1052;s:0:\"\";i:1053;s:0:\"\";i:1054;s:0:\"\";i:1055;s:0:\"\";i:1056;s:0:\"\";i:1057;s:0:\"\";i:1058;s:0:\"\";i:1059;s:0:\"\";i:1060;s:0:\"\";i:1061;s:0:\"\";i:1062;s:0:\"\";i:1063;s:0:\"\";i:1064;s:0:\"\";i:1065;s:0:\"\";i:1066;s:0:\"\";i:1067;s:0:\"\";i:1068;s:0:\"\";i:1069;s:0:\"\";i:1070;s:0:\"\";i:1071;s:0:\"\";i:1072;s:0:\"\";i:1073;s:0:\"\";i:1074;s:0:\"\";i:1075;s:0:\"\";i:1076;s:0:\"\";i:1077;s:0:\"\";i:1078;s:0:\"\";i:1079;s:0:\"\";i:1080;s:0:\"\";i:1081;s:0:\"\";i:1082;s:0:\"\";i:1083;s:0:\"\";i:1084;s:0:\"\";i:1085;s:0:\"\";i:1086;s:0:\"\";i:1087;s:0:\"\";i:1088;s:0:\"\";i:1089;s:0:\"\";i:1090;s:0:\"\";i:1091;s:0:\"\";i:1092;s:0:\"\";i:1093;s:0:\"\";i:1094;s:0:\"\";i:1095;s:0:\"\";i:1096;s:0:\"\";i:1097;s:0:\"\";i:1098;s:0:\"\";i:1099;s:0:\"\";i:1100;s:0:\"\";i:1101;s:0:\"\";i:1102;s:0:\"\";i:1103;s:0:\"\";i:1104;s:0:\"\";i:1105;s:0:\"\";i:1106;s:0:\"\";i:1107;s:0:\"\";i:1108;s:0:\"\";i:1109;s:0:\"\";i:1110;s:0:\"\";i:1111;s:0:\"\";i:1112;s:0:\"\";i:1113;s:0:\"\";i:1114;s:0:\"\";i:1115;s:0:\"\";i:1116;s:0:\"\";i:1117;s:0:\"\";i:1118;s:0:\"\";i:1119;s:0:\"\";i:1120;s:0:\"\";i:1121;s:0:\"\";i:1122;s:0:\"\";i:1123;s:0:\"\";i:1124;s:0:\"\";i:1125;s:0:\"\";i:1126;s:0:\"\";i:1127;s:0:\"\";i:1128;s:0:\"\";i:1129;s:0:\"\";i:1130;s:0:\"\";i:1131;s:0:\"\";i:1132;s:0:\"\";i:1133;s:0:\"\";i:1134;s:0:\"\";i:1135;s:0:\"\";i:1136;s:0:\"\";i:1137;s:0:\"\";i:1138;s:0:\"\";i:1139;s:0:\"\";i:1140;s:0:\"\";i:1141;s:0:\"\";i:1142;s:0:\"\";i:1143;s:0:\"\";i:1144;s:0:\"\";i:1145;s:0:\"\";i:1146;s:0:\"\";i:1147;s:0:\"\";i:1148;s:0:\"\";i:1149;s:0:\"\";i:1150;s:0:\"\";i:1151;s:0:\"\";i:1152;s:0:\"\";i:1153;s:0:\"\";i:1154;s:0:\"\";i:1155;s:0:\"\";i:1156;s:0:\"\";i:1157;s:0:\"\";i:1158;s:0:\"\";i:1159;s:0:\"\";i:1160;s:0:\"\";i:1161;s:0:\"\";i:1162;s:0:\"\";i:1163;s:0:\"\";i:1164;s:0:\"\";i:1165;s:0:\"\";i:1166;s:0:\"\";i:1167;s:0:\"\";i:1168;s:0:\"\";i:1169;s:0:\"\";i:1170;s:0:\"\";i:1171;s:0:\"\";i:1172;s:0:\"\";i:1173;s:0:\"\";i:1174;s:0:\"\";i:1175;s:0:\"\";i:1176;s:0:\"\";i:1177;s:0:\"\";i:1178;s:0:\"\";i:1179;s:0:\"\";i:1180;s:0:\"\";i:1181;s:0:\"\";i:1182;s:0:\"\";i:1183;s:0:\"\";i:1184;s:0:\"\";i:1185;s:0:\"\";i:1186;s:0:\"\";i:1187;s:0:\"\";i:1188;s:0:\"\";i:1189;s:0:\"\";i:1190;s:0:\"\";i:1191;s:0:\"\";i:1192;s:0:\"\";i:1193;s:0:\"\";i:1194;s:0:\"\";i:1195;s:0:\"\";i:1196;s:0:\"\";i:1197;s:0:\"\";i:1198;s:0:\"\";i:1199;s:0:\"\";i:1200;s:0:\"\";i:1201;s:0:\"\";i:1202;s:0:\"\";i:1203;s:0:\"\";i:1204;s:0:\"\";i:1205;s:0:\"\";i:1206;s:0:\"\";i:1207;s:0:\"\";i:1208;s:0:\"\";i:1209;s:0:\"\";i:1210;s:0:\"\";i:1211;s:0:\"\";i:1212;s:0:\"\";i:1213;s:0:\"\";i:1214;s:0:\"\";i:1215;s:0:\"\";i:1216;s:0:\"\";i:1217;s:0:\"\";i:1218;s:0:\"\";i:1219;s:0:\"\";i:1220;s:0:\"\";i:1221;s:0:\"\";i:1222;s:0:\"\";i:1223;s:0:\"\";i:1224;s:0:\"\";i:1225;s:0:\"\";i:1226;s:0:\"\";i:1227;s:0:\"\";i:1228;s:0:\"\";i:1229;s:0:\"\";i:1230;s:0:\"\";i:1231;s:0:\"\";i:1232;s:0:\"\";i:1233;s:0:\"\";i:1234;s:0:\"\";i:1235;s:0:\"\";i:1236;s:0:\"\";i:1237;s:0:\"\";i:1238;s:0:\"\";i:1239;s:0:\"\";i:1240;s:0:\"\";i:1241;s:0:\"\";i:1242;s:0:\"\";i:1243;s:0:\"\";i:1244;s:0:\"\";i:1245;s:0:\"\";i:1246;s:0:\"\";i:1247;s:0:\"\";i:1248;s:0:\"\";i:1249;s:0:\"\";i:1250;s:0:\"\";i:1251;s:0:\"\";i:1252;s:0:\"\";i:1253;s:0:\"\";i:1254;s:0:\"\";i:1255;s:0:\"\";i:1256;s:0:\"\";i:1257;s:0:\"\";i:1258;s:0:\"\";i:1259;s:0:\"\";i:1260;s:0:\"\";i:1261;s:0:\"\";i:1262;s:0:\"\";i:1263;s:0:\"\";i:1264;s:0:\"\";i:1265;s:0:\"\";i:1266;s:0:\"\";i:1267;s:0:\"\";i:1268;s:0:\"\";i:1269;s:0:\"\";i:1270;s:0:\"\";i:1271;s:0:\"\";i:1272;s:0:\"\";i:1273;s:0:\"\";i:1274;s:0:\"\";i:1275;s:0:\"\";i:1276;s:0:\"\";i:1277;s:0:\"\";i:1278;s:0:\"\";i:1279;s:0:\"\";i:1280;s:0:\"\";i:1281;s:0:\"\";i:1282;s:0:\"\";i:1283;s:0:\"\";i:1284;s:0:\"\";i:1285;s:0:\"\";i:1286;s:0:\"\";i:1287;s:0:\"\";i:1288;s:0:\"\";i:1289;s:0:\"\";i:1290;s:0:\"\";i:1291;s:0:\"\";i:1292;s:0:\"\";i:1293;s:0:\"\";i:1294;s:0:\"\";i:1295;s:0:\"\";i:1296;s:0:\"\";i:1297;s:0:\"\";i:1298;s:0:\"\";i:1299;s:0:\"\";i:1300;s:0:\"\";i:1301;s:0:\"\";i:1302;s:0:\"\";i:1303;s:0:\"\";i:1304;s:0:\"\";i:1305;s:0:\"\";i:1306;s:0:\"\";i:1307;s:0:\"\";i:1308;s:0:\"\";i:1309;s:0:\"\";i:1310;s:0:\"\";i:1311;s:0:\"\";i:1312;s:0:\"\";i:1313;s:0:\"\";i:1314;s:0:\"\";i:1315;s:0:\"\";i:1316;s:0:\"\";i:1317;s:0:\"\";i:1318;s:0:\"\";i:1319;s:0:\"\";i:1320;s:0:\"\";i:1321;s:0:\"\";i:1322;s:0:\"\";i:1323;s:0:\"\";i:1324;s:0:\"\";i:1325;s:0:\"\";i:1326;s:0:\"\";i:1327;s:0:\"\";i:1328;s:0:\"\";i:1329;s:0:\"\";i:1330;s:0:\"\";i:1331;s:0:\"\";i:1332;s:0:\"\";i:1333;s:0:\"\";i:1334;s:0:\"\";i:1335;s:0:\"\";i:1336;s:0:\"\";i:1337;s:0:\"\";i:1338;s:0:\"\";i:1339;s:0:\"\";i:1340;s:0:\"\";i:1341;s:0:\"\";i:1342;s:0:\"\";i:1343;s:0:\"\";i:1344;s:0:\"\";i:1345;s:0:\"\";i:1346;s:0:\"\";i:1347;s:0:\"\";i:1348;s:0:\"\";i:1349;s:0:\"\";i:1350;s:0:\"\";i:1351;s:0:\"\";i:1352;s:0:\"\";i:1353;s:0:\"\";i:1354;s:0:\"\";i:1355;s:0:\"\";i:1356;s:0:\"\";i:1357;s:0:\"\";i:1358;s:0:\"\";i:1359;s:0:\"\";i:1360;s:0:\"\";i:1361;s:0:\"\";i:1362;s:0:\"\";i:1363;s:0:\"\";i:1364;s:0:\"\";i:1365;s:0:\"\";i:1366;s:0:\"\";i:1367;s:0:\"\";i:1368;s:0:\"\";i:1369;s:0:\"\";i:1370;s:0:\"\";i:1371;s:0:\"\";i:1372;s:0:\"\";i:1373;s:0:\"\";i:1374;s:0:\"\";i:1375;s:0:\"\";i:1376;s:0:\"\";i:1377;s:0:\"\";i:1378;s:0:\"\";i:1379;s:0:\"\";i:1380;s:0:\"\";i:1381;s:0:\"\";i:1382;s:0:\"\";i:1383;s:0:\"\";i:1384;s:0:\"\";i:1385;s:0:\"\";i:1386;s:0:\"\";i:1387;s:0:\"\";i:1388;s:0:\"\";i:1389;s:0:\"\";i:1390;s:0:\"\";i:1391;s:0:\"\";i:1392;s:0:\"\";i:1393;s:0:\"\";i:1394;s:0:\"\";i:1395;s:0:\"\";i:1396;s:0:\"\";i:1397;s:0:\"\";i:1398;s:0:\"\";i:1399;s:0:\"\";i:1400;s:0:\"\";i:1401;s:0:\"\";i:1402;s:0:\"\";i:1403;s:0:\"\";i:1404;s:0:\"\";i:1405;s:0:\"\";i:1406;s:0:\"\";i:1407;s:0:\"\";i:1408;s:0:\"\";i:1409;s:0:\"\";i:1410;s:0:\"\";i:1411;s:0:\"\";i:1412;s:0:\"\";i:1413;s:0:\"\";i:1414;s:0:\"\";i:1415;s:0:\"\";i:1416;s:0:\"\";i:1417;s:0:\"\";i:1418;s:0:\"\";i:1419;s:0:\"\";i:1420;s:0:\"\";i:1421;s:0:\"\";i:1422;s:0:\"\";i:1423;s:0:\"\";i:1424;s:0:\"\";i:1425;s:0:\"\";i:1426;s:0:\"\";i:1427;s:0:\"\";i:1428;s:0:\"\";i:1429;s:0:\"\";i:1430;s:0:\"\";i:1431;s:0:\"\";i:1432;s:0:\"\";i:1433;s:0:\"\";i:1434;s:0:\"\";i:1435;s:0:\"\";i:1436;s:0:\"\";i:1437;s:0:\"\";i:1438;s:0:\"\";i:1439;s:0:\"\";i:1440;s:0:\"\";i:1441;s:0:\"\";i:1442;s:0:\"\";i:1443;s:0:\"\";i:1444;s:0:\"\";i:1445;s:0:\"\";i:1446;s:0:\"\";i:1447;s:0:\"\";i:1448;s:0:\"\";i:1449;s:0:\"\";i:1450;s:0:\"\";i:1451;s:0:\"\";i:1452;s:0:\"\";i:1453;s:0:\"\";i:1454;s:0:\"\";i:1455;s:0:\"\";i:1456;s:0:\"\";i:1457;s:0:\"\";i:1458;s:0:\"\";i:1459;s:0:\"\";i:1460;s:0:\"\";i:1461;s:0:\"\";i:1462;s:0:\"\";i:1463;s:0:\"\";i:1464;s:0:\"\";i:1465;s:0:\"\";i:1466;s:0:\"\";i:1467;s:0:\"\";i:1468;s:0:\"\";i:1469;s:0:\"\";i:1470;s:0:\"\";i:1471;s:0:\"\";i:1472;s:0:\"\";i:1473;s:0:\"\";i:1474;s:0:\"\";i:1475;s:0:\"\";i:1476;s:0:\"\";i:1477;s:0:\"\";i:1478;s:0:\"\";i:1479;s:0:\"\";i:1480;s:0:\"\";i:1481;s:0:\"\";i:1482;s:0:\"\";i:1483;s:0:\"\";i:1484;s:0:\"\";i:1485;s:0:\"\";i:1486;s:0:\"\";i:1487;s:0:\"\";i:1488;s:0:\"\";i:1489;s:0:\"\";i:1490;s:0:\"\";i:1491;s:0:\"\";i:1492;s:0:\"\";i:1493;s:0:\"\";i:1494;s:0:\"\";i:1495;s:0:\"\";i:1496;s:0:\"\";i:1497;s:0:\"\";i:1498;s:0:\"\";i:1499;s:0:\"\";i:1500;s:0:\"\";i:1501;s:0:\"\";i:1502;s:0:\"\";i:1503;s:0:\"\";i:1504;s:0:\"\";i:1505;s:0:\"\";i:1506;s:0:\"\";i:1507;s:0:\"\";i:1508;s:0:\"\";i:1509;s:0:\"\";i:1510;s:0:\"\";i:1511;s:0:\"\";i:1512;s:0:\"\";i:1513;s:0:\"\";i:1514;s:0:\"\";i:1515;s:0:\"\";i:1516;s:0:\"\";i:1517;s:0:\"\";i:1518;s:0:\"\";i:1519;s:0:\"\";i:1520;s:0:\"\";i:1521;s:0:\"\";i:1522;s:0:\"\";i:1523;s:0:\"\";i:1524;s:0:\"\";i:1525;s:0:\"\";i:1526;s:0:\"\";i:1527;s:0:\"\";i:1528;s:0:\"\";i:1529;s:0:\"\";i:1530;s:0:\"\";i:1531;s:0:\"\";i:1532;s:0:\"\";i:1533;s:0:\"\";i:1534;s:0:\"\";i:1535;s:0:\"\";i:1536;s:0:\"\";i:1537;s:0:\"\";i:1538;s:0:\"\";i:1539;s:0:\"\";i:1540;s:0:\"\";i:1541;s:0:\"\";i:1542;s:0:\"\";i:1543;s:0:\"\";i:1544;s:0:\"\";i:1545;s:0:\"\";i:1546;s:0:\"\";i:1547;s:0:\"\";i:1548;s:0:\"\";i:1549;s:0:\"\";i:1550;s:0:\"\";i:1551;s:0:\"\";i:1552;s:0:\"\";i:1553;s:0:\"\";i:1554;s:0:\"\";i:1555;s:0:\"\";i:1556;s:0:\"\";i:1557;s:0:\"\";i:1558;s:0:\"\";i:1559;s:0:\"\";i:1560;s:0:\"\";i:1561;s:0:\"\";i:1562;s:0:\"\";i:1563;s:0:\"\";i:1564;s:0:\"\";i:1565;s:0:\"\";i:1566;s:0:\"\";i:1567;s:0:\"\";i:1568;s:0:\"\";i:1569;s:0:\"\";i:1570;s:0:\"\";i:1571;s:0:\"\";i:1572;s:0:\"\";i:1573;s:0:\"\";i:1574;s:0:\"\";i:1575;s:0:\"\";i:1576;s:0:\"\";i:1577;s:0:\"\";i:1578;s:0:\"\";i:1579;s:0:\"\";i:1580;s:0:\"\";i:1581;s:0:\"\";i:1582;s:0:\"\";i:1583;s:0:\"\";i:1584;s:0:\"\";i:1585;s:0:\"\";i:1586;s:0:\"\";i:1587;s:0:\"\";i:1588;s:0:\"\";i:1589;s:0:\"\";i:1590;s:0:\"\";i:1591;s:0:\"\";i:1592;s:0:\"\";i:1593;s:0:\"\";i:1594;s:0:\"\";i:1595;s:0:\"\";i:1596;s:0:\"\";i:1597;s:0:\"\";i:1598;s:0:\"\";i:1599;s:0:\"\";i:1600;s:0:\"\";i:1601;s:0:\"\";i:1602;s:0:\"\";i:1603;s:0:\"\";i:1604;s:0:\"\";i:1605;s:0:\"\";i:1606;s:0:\"\";i:1607;s:0:\"\";i:1608;s:0:\"\";i:1609;s:0:\"\";i:1610;s:0:\"\";i:1611;s:0:\"\";i:1612;s:0:\"\";i:1613;s:0:\"\";i:1614;s:0:\"\";i:1615;s:0:\"\";i:1616;s:0:\"\";i:1617;s:0:\"\";i:1618;s:0:\"\";i:1619;s:0:\"\";i:1620;s:0:\"\";i:1621;s:0:\"\";i:1622;s:0:\"\";i:1623;s:0:\"\";i:1624;s:0:\"\";i:1625;s:0:\"\";i:1626;s:0:\"\";i:1627;s:0:\"\";i:1628;s:0:\"\";i:1629;s:0:\"\";i:1630;s:0:\"\";i:1631;s:0:\"\";i:1632;s:0:\"\";i:1633;s:0:\"\";i:1634;s:0:\"\";i:1635;s:0:\"\";i:1636;s:0:\"\";i:1637;s:0:\"\";i:1638;s:0:\"\";i:1639;s:0:\"\";i:1640;s:0:\"\";i:1641;s:0:\"\";i:1642;s:0:\"\";i:1643;s:0:\"\";i:1644;s:0:\"\";i:1645;s:0:\"\";i:1646;s:0:\"\";i:1647;s:0:\"\";i:1648;s:0:\"\";i:1649;s:0:\"\";i:1650;s:0:\"\";i:1651;s:0:\"\";i:1652;s:0:\"\";i:1653;s:0:\"\";i:1654;s:0:\"\";i:1655;s:0:\"\";i:1656;s:0:\"\";i:1657;s:0:\"\";i:1658;s:0:\"\";i:1659;s:0:\"\";i:1660;s:0:\"\";i:1661;s:0:\"\";i:1662;s:0:\"\";i:1663;s:0:\"\";i:1664;s:0:\"\";i:1665;s:0:\"\";i:1666;s:0:\"\";i:1667;s:0:\"\";i:1668;s:0:\"\";i:1669;s:0:\"\";i:1670;s:0:\"\";i:1671;s:0:\"\";i:1672;s:0:\"\";i:1673;s:0:\"\";i:1674;s:0:\"\";i:1675;s:0:\"\";i:1676;s:0:\"\";i:1677;s:0:\"\";i:1678;s:0:\"\";i:1679;s:0:\"\";i:1680;s:0:\"\";i:1681;s:0:\"\";i:1682;s:0:\"\";i:1683;s:0:\"\";i:1684;s:0:\"\";i:1685;s:0:\"\";i:1686;s:0:\"\";i:1687;s:0:\"\";i:1688;s:0:\"\";i:1689;s:0:\"\";i:1690;s:0:\"\";i:1691;s:0:\"\";i:1692;s:0:\"\";i:1693;s:0:\"\";i:1694;s:0:\"\";i:1695;s:0:\"\";i:1696;s:0:\"\";i:1697;s:0:\"\";i:1698;s:0:\"\";i:1699;s:0:\"\";i:1700;s:0:\"\";i:1701;s:0:\"\";i:1702;s:0:\"\";i:1703;s:0:\"\";i:1704;s:0:\"\";i:1705;s:0:\"\";i:1706;s:0:\"\";i:1707;s:0:\"\";i:1708;s:0:\"\";i:1709;s:0:\"\";i:1710;s:0:\"\";i:1711;s:0:\"\";i:1712;s:0:\"\";i:1713;s:0:\"\";i:1714;s:0:\"\";i:1715;s:0:\"\";i:1716;s:0:\"\";i:1717;s:0:\"\";i:1718;s:0:\"\";i:1719;s:0:\"\";i:1720;s:0:\"\";i:1721;s:0:\"\";i:1722;s:0:\"\";i:1723;s:0:\"\";i:1724;s:0:\"\";i:1725;s:0:\"\";}s:16:\"ilcalendardaygui\";a:76:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";i:74;s:24:\"ilcalendarappointmentgui\";i:75;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarinboxgui\";a:76:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";i:74;s:24:\"ilcalendarappointmentgui\";i:75;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarmonthgui\";a:76:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";i:74;s:24:\"ilcalendarappointmentgui\";i:75;s:24:\"ilcalendarappointmentgui\";}s:17:\"ilcalendarweekgui\";a:76:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";i:74;s:24:\"ilcalendarappointmentgui\";i:75;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarblockgui\";a:190:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:16:\"ilcalendardaygui\";i:7;s:18:\"ilcalendarinboxgui\";i:8;s:18:\"ilcalendarmonthgui\";i:9;s:17:\"ilcalendarweekgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:16:\"ilcalendardaygui\";i:12;s:18:\"ilcalendarinboxgui\";i:13;s:18:\"ilcalendarmonthgui\";i:14;s:17:\"ilcalendarweekgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:16:\"ilcalendardaygui\";i:17;s:18:\"ilcalendarinboxgui\";i:18;s:18:\"ilcalendarmonthgui\";i:19;s:17:\"ilcalendarweekgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:16:\"ilcalendardaygui\";i:22;s:18:\"ilcalendarinboxgui\";i:23;s:18:\"ilcalendarmonthgui\";i:24;s:17:\"ilcalendarweekgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:16:\"ilcalendardaygui\";i:27;s:18:\"ilcalendarinboxgui\";i:28;s:18:\"ilcalendarmonthgui\";i:29;s:17:\"ilcalendarweekgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:16:\"ilcalendardaygui\";i:32;s:18:\"ilcalendarinboxgui\";i:33;s:18:\"ilcalendarmonthgui\";i:34;s:17:\"ilcalendarweekgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:16:\"ilcalendardaygui\";i:37;s:18:\"ilcalendarinboxgui\";i:38;s:18:\"ilcalendarmonthgui\";i:39;s:17:\"ilcalendarweekgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:16:\"ilcalendardaygui\";i:42;s:18:\"ilcalendarinboxgui\";i:43;s:18:\"ilcalendarmonthgui\";i:44;s:17:\"ilcalendarweekgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:16:\"ilcalendardaygui\";i:47;s:18:\"ilcalendarinboxgui\";i:48;s:18:\"ilcalendarmonthgui\";i:49;s:17:\"ilcalendarweekgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:16:\"ilcalendardaygui\";i:52;s:18:\"ilcalendarinboxgui\";i:53;s:18:\"ilcalendarmonthgui\";i:54;s:17:\"ilcalendarweekgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:16:\"ilcalendardaygui\";i:57;s:18:\"ilcalendarinboxgui\";i:58;s:18:\"ilcalendarmonthgui\";i:59;s:17:\"ilcalendarweekgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:16:\"ilcalendardaygui\";i:62;s:18:\"ilcalendarinboxgui\";i:63;s:18:\"ilcalendarmonthgui\";i:64;s:17:\"ilcalendarweekgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:16:\"ilcalendardaygui\";i:67;s:18:\"ilcalendarinboxgui\";i:68;s:18:\"ilcalendarmonthgui\";i:69;s:17:\"ilcalendarweekgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:16:\"ilcalendardaygui\";i:72;s:18:\"ilcalendarinboxgui\";i:73;s:18:\"ilcalendarmonthgui\";i:74;s:17:\"ilcalendarweekgui\";i:75;s:24:\"ilcalendarappointmentgui\";i:76;s:16:\"ilcalendardaygui\";i:77;s:18:\"ilcalendarinboxgui\";i:78;s:18:\"ilcalendarmonthgui\";i:79;s:17:\"ilcalendarweekgui\";i:80;s:24:\"ilcalendarappointmentgui\";i:81;s:16:\"ilcalendardaygui\";i:82;s:18:\"ilcalendarinboxgui\";i:83;s:18:\"ilcalendarmonthgui\";i:84;s:17:\"ilcalendarweekgui\";i:85;s:24:\"ilcalendarappointmentgui\";i:86;s:16:\"ilcalendardaygui\";i:87;s:18:\"ilcalendarinboxgui\";i:88;s:18:\"ilcalendarmonthgui\";i:89;s:17:\"ilcalendarweekgui\";i:90;s:24:\"ilcalendarappointmentgui\";i:91;s:16:\"ilcalendardaygui\";i:92;s:18:\"ilcalendarinboxgui\";i:93;s:18:\"ilcalendarmonthgui\";i:94;s:17:\"ilcalendarweekgui\";i:95;s:24:\"ilcalendarappointmentgui\";i:96;s:16:\"ilcalendardaygui\";i:97;s:18:\"ilcalendarinboxgui\";i:98;s:18:\"ilcalendarmonthgui\";i:99;s:17:\"ilcalendarweekgui\";i:100;s:24:\"ilcalendarappointmentgui\";i:101;s:16:\"ilcalendardaygui\";i:102;s:18:\"ilcalendarinboxgui\";i:103;s:18:\"ilcalendarmonthgui\";i:104;s:17:\"ilcalendarweekgui\";i:105;s:24:\"ilcalendarappointmentgui\";i:106;s:16:\"ilcalendardaygui\";i:107;s:18:\"ilcalendarinboxgui\";i:108;s:18:\"ilcalendarmonthgui\";i:109;s:17:\"ilcalendarweekgui\";i:110;s:24:\"ilcalendarappointmentgui\";i:111;s:16:\"ilcalendardaygui\";i:112;s:18:\"ilcalendarinboxgui\";i:113;s:18:\"ilcalendarmonthgui\";i:114;s:17:\"ilcalendarweekgui\";i:115;s:24:\"ilcalendarappointmentgui\";i:116;s:16:\"ilcalendardaygui\";i:117;s:18:\"ilcalendarinboxgui\";i:118;s:18:\"ilcalendarmonthgui\";i:119;s:17:\"ilcalendarweekgui\";i:120;s:24:\"ilcalendarappointmentgui\";i:121;s:16:\"ilcalendardaygui\";i:122;s:18:\"ilcalendarinboxgui\";i:123;s:18:\"ilcalendarmonthgui\";i:124;s:17:\"ilcalendarweekgui\";i:125;s:24:\"ilcalendarappointmentgui\";i:126;s:16:\"ilcalendardaygui\";i:127;s:18:\"ilcalendarinboxgui\";i:128;s:18:\"ilcalendarmonthgui\";i:129;s:17:\"ilcalendarweekgui\";i:130;s:24:\"ilcalendarappointmentgui\";i:131;s:16:\"ilcalendardaygui\";i:132;s:18:\"ilcalendarinboxgui\";i:133;s:18:\"ilcalendarmonthgui\";i:134;s:17:\"ilcalendarweekgui\";i:135;s:24:\"ilcalendarappointmentgui\";i:136;s:16:\"ilcalendardaygui\";i:137;s:18:\"ilcalendarinboxgui\";i:138;s:18:\"ilcalendarmonthgui\";i:139;s:17:\"ilcalendarweekgui\";i:140;s:24:\"ilcalendarappointmentgui\";i:141;s:16:\"ilcalendardaygui\";i:142;s:18:\"ilcalendarinboxgui\";i:143;s:18:\"ilcalendarmonthgui\";i:144;s:17:\"ilcalendarweekgui\";i:145;s:24:\"ilcalendarappointmentgui\";i:146;s:16:\"ilcalendardaygui\";i:147;s:18:\"ilcalendarinboxgui\";i:148;s:18:\"ilcalendarmonthgui\";i:149;s:17:\"ilcalendarweekgui\";i:150;s:24:\"ilcalendarappointmentgui\";i:151;s:16:\"ilcalendardaygui\";i:152;s:18:\"ilcalendarinboxgui\";i:153;s:18:\"ilcalendarmonthgui\";i:154;s:17:\"ilcalendarweekgui\";i:155;s:24:\"ilcalendarappointmentgui\";i:156;s:16:\"ilcalendardaygui\";i:157;s:18:\"ilcalendarinboxgui\";i:158;s:18:\"ilcalendarmonthgui\";i:159;s:17:\"ilcalendarweekgui\";i:160;s:24:\"ilcalendarappointmentgui\";i:161;s:16:\"ilcalendardaygui\";i:162;s:18:\"ilcalendarinboxgui\";i:163;s:18:\"ilcalendarmonthgui\";i:164;s:17:\"ilcalendarweekgui\";i:165;s:24:\"ilcalendarappointmentgui\";i:166;s:16:\"ilcalendardaygui\";i:167;s:18:\"ilcalendarinboxgui\";i:168;s:18:\"ilcalendarmonthgui\";i:169;s:17:\"ilcalendarweekgui\";i:170;s:24:\"ilcalendarappointmentgui\";i:171;s:16:\"ilcalendardaygui\";i:172;s:18:\"ilcalendarinboxgui\";i:173;s:18:\"ilcalendarmonthgui\";i:174;s:17:\"ilcalendarweekgui\";i:175;s:24:\"ilcalendarappointmentgui\";i:176;s:16:\"ilcalendardaygui\";i:177;s:18:\"ilcalendarinboxgui\";i:178;s:18:\"ilcalendarmonthgui\";i:179;s:17:\"ilcalendarweekgui\";i:180;s:24:\"ilcalendarappointmentgui\";i:181;s:16:\"ilcalendardaygui\";i:182;s:18:\"ilcalendarinboxgui\";i:183;s:18:\"ilcalendarmonthgui\";i:184;s:17:\"ilcalendarweekgui\";i:185;s:24:\"ilcalendarappointmentgui\";i:186;s:16:\"ilcalendardaygui\";i:187;s:18:\"ilcalendarinboxgui\";i:188;s:18:\"ilcalendarmonthgui\";i:189;s:17:\"ilcalendarweekgui\";}s:24:\"ilnewsforcontextblockgui\";a:38:{i:0;s:13:\"ilnewsitemgui\";i:1;s:13:\"ilnewsitemgui\";i:2;s:13:\"ilnewsitemgui\";i:3;s:13:\"ilnewsitemgui\";i:4;s:13:\"ilnewsitemgui\";i:5;s:13:\"ilnewsitemgui\";i:6;s:13:\"ilnewsitemgui\";i:7;s:13:\"ilnewsitemgui\";i:8;s:13:\"ilnewsitemgui\";i:9;s:13:\"ilnewsitemgui\";i:10;s:13:\"ilnewsitemgui\";i:11;s:13:\"ilnewsitemgui\";i:12;s:13:\"ilnewsitemgui\";i:13;s:13:\"ilnewsitemgui\";i:14;s:13:\"ilnewsitemgui\";i:15;s:13:\"ilnewsitemgui\";i:16;s:13:\"ilnewsitemgui\";i:17;s:13:\"ilnewsitemgui\";i:18;s:13:\"ilnewsitemgui\";i:19;s:13:\"ilnewsitemgui\";i:20;s:13:\"ilnewsitemgui\";i:21;s:13:\"ilnewsitemgui\";i:22;s:13:\"ilnewsitemgui\";i:23;s:13:\"ilnewsitemgui\";i:24;s:13:\"ilnewsitemgui\";i:25;s:13:\"ilnewsitemgui\";i:26;s:13:\"ilnewsitemgui\";i:27;s:13:\"ilnewsitemgui\";i:28;s:13:\"ilnewsitemgui\";i:29;s:13:\"ilnewsitemgui\";i:30;s:13:\"ilnewsitemgui\";i:31;s:13:\"ilnewsitemgui\";i:32;s:13:\"ilnewsitemgui\";i:33;s:13:\"ilnewsitemgui\";i:34;s:13:\"ilnewsitemgui\";i:35;s:13:\"ilnewsitemgui\";i:36;s:13:\"ilnewsitemgui\";i:37;s:13:\"ilnewsitemgui\";}s:20:\"ilpdcalendarblockgui\";a:190:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:16:\"ilcalendardaygui\";i:7;s:18:\"ilcalendarinboxgui\";i:8;s:18:\"ilcalendarmonthgui\";i:9;s:17:\"ilcalendarweekgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:16:\"ilcalendardaygui\";i:12;s:18:\"ilcalendarinboxgui\";i:13;s:18:\"ilcalendarmonthgui\";i:14;s:17:\"ilcalendarweekgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:16:\"ilcalendardaygui\";i:17;s:18:\"ilcalendarinboxgui\";i:18;s:18:\"ilcalendarmonthgui\";i:19;s:17:\"ilcalendarweekgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:16:\"ilcalendardaygui\";i:22;s:18:\"ilcalendarinboxgui\";i:23;s:18:\"ilcalendarmonthgui\";i:24;s:17:\"ilcalendarweekgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:16:\"ilcalendardaygui\";i:27;s:18:\"ilcalendarinboxgui\";i:28;s:18:\"ilcalendarmonthgui\";i:29;s:17:\"ilcalendarweekgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:16:\"ilcalendardaygui\";i:32;s:18:\"ilcalendarinboxgui\";i:33;s:18:\"ilcalendarmonthgui\";i:34;s:17:\"ilcalendarweekgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:16:\"ilcalendardaygui\";i:37;s:18:\"ilcalendarinboxgui\";i:38;s:18:\"ilcalendarmonthgui\";i:39;s:17:\"ilcalendarweekgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:16:\"ilcalendardaygui\";i:42;s:18:\"ilcalendarinboxgui\";i:43;s:18:\"ilcalendarmonthgui\";i:44;s:17:\"ilcalendarweekgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:16:\"ilcalendardaygui\";i:47;s:18:\"ilcalendarinboxgui\";i:48;s:18:\"ilcalendarmonthgui\";i:49;s:17:\"ilcalendarweekgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:16:\"ilcalendardaygui\";i:52;s:18:\"ilcalendarinboxgui\";i:53;s:18:\"ilcalendarmonthgui\";i:54;s:17:\"ilcalendarweekgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:16:\"ilcalendardaygui\";i:57;s:18:\"ilcalendarinboxgui\";i:58;s:18:\"ilcalendarmonthgui\";i:59;s:17:\"ilcalendarweekgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:16:\"ilcalendardaygui\";i:62;s:18:\"ilcalendarinboxgui\";i:63;s:18:\"ilcalendarmonthgui\";i:64;s:17:\"ilcalendarweekgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:16:\"ilcalendardaygui\";i:67;s:18:\"ilcalendarinboxgui\";i:68;s:18:\"ilcalendarmonthgui\";i:69;s:17:\"ilcalendarweekgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:16:\"ilcalendardaygui\";i:72;s:18:\"ilcalendarinboxgui\";i:73;s:18:\"ilcalendarmonthgui\";i:74;s:17:\"ilcalendarweekgui\";i:75;s:24:\"ilcalendarappointmentgui\";i:76;s:16:\"ilcalendardaygui\";i:77;s:18:\"ilcalendarinboxgui\";i:78;s:18:\"ilcalendarmonthgui\";i:79;s:17:\"ilcalendarweekgui\";i:80;s:24:\"ilcalendarappointmentgui\";i:81;s:16:\"ilcalendardaygui\";i:82;s:18:\"ilcalendarinboxgui\";i:83;s:18:\"ilcalendarmonthgui\";i:84;s:17:\"ilcalendarweekgui\";i:85;s:24:\"ilcalendarappointmentgui\";i:86;s:16:\"ilcalendardaygui\";i:87;s:18:\"ilcalendarinboxgui\";i:88;s:18:\"ilcalendarmonthgui\";i:89;s:17:\"ilcalendarweekgui\";i:90;s:24:\"ilcalendarappointmentgui\";i:91;s:16:\"ilcalendardaygui\";i:92;s:18:\"ilcalendarinboxgui\";i:93;s:18:\"ilcalendarmonthgui\";i:94;s:17:\"ilcalendarweekgui\";i:95;s:24:\"ilcalendarappointmentgui\";i:96;s:16:\"ilcalendardaygui\";i:97;s:18:\"ilcalendarinboxgui\";i:98;s:18:\"ilcalendarmonthgui\";i:99;s:17:\"ilcalendarweekgui\";i:100;s:24:\"ilcalendarappointmentgui\";i:101;s:16:\"ilcalendardaygui\";i:102;s:18:\"ilcalendarinboxgui\";i:103;s:18:\"ilcalendarmonthgui\";i:104;s:17:\"ilcalendarweekgui\";i:105;s:24:\"ilcalendarappointmentgui\";i:106;s:16:\"ilcalendardaygui\";i:107;s:18:\"ilcalendarinboxgui\";i:108;s:18:\"ilcalendarmonthgui\";i:109;s:17:\"ilcalendarweekgui\";i:110;s:24:\"ilcalendarappointmentgui\";i:111;s:16:\"ilcalendardaygui\";i:112;s:18:\"ilcalendarinboxgui\";i:113;s:18:\"ilcalendarmonthgui\";i:114;s:17:\"ilcalendarweekgui\";i:115;s:24:\"ilcalendarappointmentgui\";i:116;s:16:\"ilcalendardaygui\";i:117;s:18:\"ilcalendarinboxgui\";i:118;s:18:\"ilcalendarmonthgui\";i:119;s:17:\"ilcalendarweekgui\";i:120;s:24:\"ilcalendarappointmentgui\";i:121;s:16:\"ilcalendardaygui\";i:122;s:18:\"ilcalendarinboxgui\";i:123;s:18:\"ilcalendarmonthgui\";i:124;s:17:\"ilcalendarweekgui\";i:125;s:24:\"ilcalendarappointmentgui\";i:126;s:16:\"ilcalendardaygui\";i:127;s:18:\"ilcalendarinboxgui\";i:128;s:18:\"ilcalendarmonthgui\";i:129;s:17:\"ilcalendarweekgui\";i:130;s:24:\"ilcalendarappointmentgui\";i:131;s:16:\"ilcalendardaygui\";i:132;s:18:\"ilcalendarinboxgui\";i:133;s:18:\"ilcalendarmonthgui\";i:134;s:17:\"ilcalendarweekgui\";i:135;s:24:\"ilcalendarappointmentgui\";i:136;s:16:\"ilcalendardaygui\";i:137;s:18:\"ilcalendarinboxgui\";i:138;s:18:\"ilcalendarmonthgui\";i:139;s:17:\"ilcalendarweekgui\";i:140;s:24:\"ilcalendarappointmentgui\";i:141;s:16:\"ilcalendardaygui\";i:142;s:18:\"ilcalendarinboxgui\";i:143;s:18:\"ilcalendarmonthgui\";i:144;s:17:\"ilcalendarweekgui\";i:145;s:24:\"ilcalendarappointmentgui\";i:146;s:16:\"ilcalendardaygui\";i:147;s:18:\"ilcalendarinboxgui\";i:148;s:18:\"ilcalendarmonthgui\";i:149;s:17:\"ilcalendarweekgui\";i:150;s:24:\"ilcalendarappointmentgui\";i:151;s:16:\"ilcalendardaygui\";i:152;s:18:\"ilcalendarinboxgui\";i:153;s:18:\"ilcalendarmonthgui\";i:154;s:17:\"ilcalendarweekgui\";i:155;s:24:\"ilcalendarappointmentgui\";i:156;s:16:\"ilcalendardaygui\";i:157;s:18:\"ilcalendarinboxgui\";i:158;s:18:\"ilcalendarmonthgui\";i:159;s:17:\"ilcalendarweekgui\";i:160;s:24:\"ilcalendarappointmentgui\";i:161;s:16:\"ilcalendardaygui\";i:162;s:18:\"ilcalendarinboxgui\";i:163;s:18:\"ilcalendarmonthgui\";i:164;s:17:\"ilcalendarweekgui\";i:165;s:24:\"ilcalendarappointmentgui\";i:166;s:16:\"ilcalendardaygui\";i:167;s:18:\"ilcalendarinboxgui\";i:168;s:18:\"ilcalendarmonthgui\";i:169;s:17:\"ilcalendarweekgui\";i:170;s:24:\"ilcalendarappointmentgui\";i:171;s:16:\"ilcalendardaygui\";i:172;s:18:\"ilcalendarinboxgui\";i:173;s:18:\"ilcalendarmonthgui\";i:174;s:17:\"ilcalendarweekgui\";i:175;s:24:\"ilcalendarappointmentgui\";i:176;s:16:\"ilcalendardaygui\";i:177;s:18:\"ilcalendarinboxgui\";i:178;s:18:\"ilcalendarmonthgui\";i:179;s:17:\"ilcalendarweekgui\";i:180;s:24:\"ilcalendarappointmentgui\";i:181;s:16:\"ilcalendardaygui\";i:182;s:18:\"ilcalendarinboxgui\";i:183;s:18:\"ilcalendarmonthgui\";i:184;s:17:\"ilcalendarweekgui\";i:185;s:24:\"ilcalendarappointmentgui\";i:186;s:16:\"ilcalendardaygui\";i:187;s:18:\"ilcalendarinboxgui\";i:188;s:18:\"ilcalendarmonthgui\";i:189;s:17:\"ilcalendarweekgui\";}s:21:\"ilusersonlineblockgui\";a:38:{i:0;s:22:\"ilpublicuserprofilegui\";i:1;s:22:\"ilpublicuserprofilegui\";i:2;s:22:\"ilpublicuserprofilegui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:22:\"ilpublicuserprofilegui\";i:5;s:22:\"ilpublicuserprofilegui\";i:6;s:22:\"ilpublicuserprofilegui\";i:7;s:22:\"ilpublicuserprofilegui\";i:8;s:22:\"ilpublicuserprofilegui\";i:9;s:22:\"ilpublicuserprofilegui\";i:10;s:22:\"ilpublicuserprofilegui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:22:\"ilpublicuserprofilegui\";i:13;s:22:\"ilpublicuserprofilegui\";i:14;s:22:\"ilpublicuserprofilegui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:22:\"ilpublicuserprofilegui\";i:17;s:22:\"ilpublicuserprofilegui\";i:18;s:22:\"ilpublicuserprofilegui\";i:19;s:22:\"ilpublicuserprofilegui\";i:20;s:22:\"ilpublicuserprofilegui\";i:21;s:22:\"ilpublicuserprofilegui\";i:22;s:22:\"ilpublicuserprofilegui\";i:23;s:22:\"ilpublicuserprofilegui\";i:24;s:22:\"ilpublicuserprofilegui\";i:25;s:22:\"ilpublicuserprofilegui\";i:26;s:22:\"ilpublicuserprofilegui\";i:27;s:22:\"ilpublicuserprofilegui\";i:28;s:22:\"ilpublicuserprofilegui\";i:29;s:22:\"ilpublicuserprofilegui\";i:30;s:22:\"ilpublicuserprofilegui\";i:31;s:22:\"ilpublicuserprofilegui\";i:32;s:22:\"ilpublicuserprofilegui\";i:33;s:22:\"ilpublicuserprofilegui\";i:34;s:22:\"ilpublicuserprofilegui\";i:35;s:22:\"ilpublicuserprofilegui\";i:36;s:22:\"ilpublicuserprofilegui\";i:37;s:22:\"ilpublicuserprofilegui\";}s:11:\"ilcolumngui\";a:646:{i:0;s:0:\"\";i:1;s:18:\"ilbookmarkblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:15:\"ildummyblockgui\";i:4;s:22:\"ilexternalfeedblockgui\";i:5;s:14:\"ilhtmlblockgui\";i:6;s:24:\"ilnewsforcontextblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:24:\"ilpdexternalfeedblockgui\";i:9;s:20:\"ilpdfeedbackblockgui\";i:10;s:16:\"ilpdmailblockgui\";i:11;s:16:\"ilpdnewsblockgui\";i:12;s:17:\"ilpdnotesblockgui\";i:13;s:25:\"ilpdselecteditemsblockgui\";i:14;s:22:\"ilpdsysmessageblockgui\";i:15;s:19:\"ilpdtaggingblockgui\";i:16;s:21:\"ilusersonlineblockgui\";i:17;s:0:\"\";i:18;s:18:\"ilbookmarkblockgui\";i:19;s:18:\"ilcalendarblockgui\";i:20;s:15:\"ildummyblockgui\";i:21;s:22:\"ilexternalfeedblockgui\";i:22;s:14:\"ilhtmlblockgui\";i:23;s:24:\"ilnewsforcontextblockgui\";i:24;s:20:\"ilpdcalendarblockgui\";i:25;s:24:\"ilpdexternalfeedblockgui\";i:26;s:20:\"ilpdfeedbackblockgui\";i:27;s:16:\"ilpdmailblockgui\";i:28;s:16:\"ilpdnewsblockgui\";i:29;s:17:\"ilpdnotesblockgui\";i:30;s:25:\"ilpdselecteditemsblockgui\";i:31;s:22:\"ilpdsysmessageblockgui\";i:32;s:19:\"ilpdtaggingblockgui\";i:33;s:21:\"ilusersonlineblockgui\";i:34;s:0:\"\";i:35;s:18:\"ilbookmarkblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:15:\"ildummyblockgui\";i:38;s:22:\"ilexternalfeedblockgui\";i:39;s:14:\"ilhtmlblockgui\";i:40;s:24:\"ilnewsforcontextblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:24:\"ilpdexternalfeedblockgui\";i:43;s:20:\"ilpdfeedbackblockgui\";i:44;s:16:\"ilpdmailblockgui\";i:45;s:16:\"ilpdnewsblockgui\";i:46;s:17:\"ilpdnotesblockgui\";i:47;s:25:\"ilpdselecteditemsblockgui\";i:48;s:22:\"ilpdsysmessageblockgui\";i:49;s:19:\"ilpdtaggingblockgui\";i:50;s:21:\"ilusersonlineblockgui\";i:51;s:0:\"\";i:52;s:18:\"ilbookmarkblockgui\";i:53;s:18:\"ilcalendarblockgui\";i:54;s:15:\"ildummyblockgui\";i:55;s:22:\"ilexternalfeedblockgui\";i:56;s:14:\"ilhtmlblockgui\";i:57;s:24:\"ilnewsforcontextblockgui\";i:58;s:20:\"ilpdcalendarblockgui\";i:59;s:24:\"ilpdexternalfeedblockgui\";i:60;s:20:\"ilpdfeedbackblockgui\";i:61;s:16:\"ilpdmailblockgui\";i:62;s:16:\"ilpdnewsblockgui\";i:63;s:17:\"ilpdnotesblockgui\";i:64;s:25:\"ilpdselecteditemsblockgui\";i:65;s:22:\"ilpdsysmessageblockgui\";i:66;s:19:\"ilpdtaggingblockgui\";i:67;s:21:\"ilusersonlineblockgui\";i:68;s:0:\"\";i:69;s:18:\"ilbookmarkblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:15:\"ildummyblockgui\";i:72;s:22:\"ilexternalfeedblockgui\";i:73;s:14:\"ilhtmlblockgui\";i:74;s:24:\"ilnewsforcontextblockgui\";i:75;s:20:\"ilpdcalendarblockgui\";i:76;s:24:\"ilpdexternalfeedblockgui\";i:77;s:20:\"ilpdfeedbackblockgui\";i:78;s:16:\"ilpdmailblockgui\";i:79;s:16:\"ilpdnewsblockgui\";i:80;s:17:\"ilpdnotesblockgui\";i:81;s:25:\"ilpdselecteditemsblockgui\";i:82;s:22:\"ilpdsysmessageblockgui\";i:83;s:19:\"ilpdtaggingblockgui\";i:84;s:21:\"ilusersonlineblockgui\";i:85;s:0:\"\";i:86;s:18:\"ilbookmarkblockgui\";i:87;s:18:\"ilcalendarblockgui\";i:88;s:15:\"ildummyblockgui\";i:89;s:22:\"ilexternalfeedblockgui\";i:90;s:14:\"ilhtmlblockgui\";i:91;s:24:\"ilnewsforcontextblockgui\";i:92;s:20:\"ilpdcalendarblockgui\";i:93;s:24:\"ilpdexternalfeedblockgui\";i:94;s:20:\"ilpdfeedbackblockgui\";i:95;s:16:\"ilpdmailblockgui\";i:96;s:16:\"ilpdnewsblockgui\";i:97;s:17:\"ilpdnotesblockgui\";i:98;s:25:\"ilpdselecteditemsblockgui\";i:99;s:22:\"ilpdsysmessageblockgui\";i:100;s:19:\"ilpdtaggingblockgui\";i:101;s:21:\"ilusersonlineblockgui\";i:102;s:0:\"\";i:103;s:18:\"ilbookmarkblockgui\";i:104;s:18:\"ilcalendarblockgui\";i:105;s:15:\"ildummyblockgui\";i:106;s:22:\"ilexternalfeedblockgui\";i:107;s:14:\"ilhtmlblockgui\";i:108;s:24:\"ilnewsforcontextblockgui\";i:109;s:20:\"ilpdcalendarblockgui\";i:110;s:24:\"ilpdexternalfeedblockgui\";i:111;s:20:\"ilpdfeedbackblockgui\";i:112;s:16:\"ilpdmailblockgui\";i:113;s:16:\"ilpdnewsblockgui\";i:114;s:17:\"ilpdnotesblockgui\";i:115;s:25:\"ilpdselecteditemsblockgui\";i:116;s:22:\"ilpdsysmessageblockgui\";i:117;s:19:\"ilpdtaggingblockgui\";i:118;s:21:\"ilusersonlineblockgui\";i:119;s:0:\"\";i:120;s:18:\"ilbookmarkblockgui\";i:121;s:18:\"ilcalendarblockgui\";i:122;s:15:\"ildummyblockgui\";i:123;s:22:\"ilexternalfeedblockgui\";i:124;s:14:\"ilhtmlblockgui\";i:125;s:24:\"ilnewsforcontextblockgui\";i:126;s:20:\"ilpdcalendarblockgui\";i:127;s:24:\"ilpdexternalfeedblockgui\";i:128;s:20:\"ilpdfeedbackblockgui\";i:129;s:16:\"ilpdmailblockgui\";i:130;s:16:\"ilpdnewsblockgui\";i:131;s:17:\"ilpdnotesblockgui\";i:132;s:25:\"ilpdselecteditemsblockgui\";i:133;s:22:\"ilpdsysmessageblockgui\";i:134;s:19:\"ilpdtaggingblockgui\";i:135;s:21:\"ilusersonlineblockgui\";i:136;s:0:\"\";i:137;s:18:\"ilbookmarkblockgui\";i:138;s:18:\"ilcalendarblockgui\";i:139;s:15:\"ildummyblockgui\";i:140;s:22:\"ilexternalfeedblockgui\";i:141;s:14:\"ilhtmlblockgui\";i:142;s:24:\"ilnewsforcontextblockgui\";i:143;s:20:\"ilpdcalendarblockgui\";i:144;s:24:\"ilpdexternalfeedblockgui\";i:145;s:20:\"ilpdfeedbackblockgui\";i:146;s:16:\"ilpdmailblockgui\";i:147;s:16:\"ilpdnewsblockgui\";i:148;s:17:\"ilpdnotesblockgui\";i:149;s:25:\"ilpdselecteditemsblockgui\";i:150;s:22:\"ilpdsysmessageblockgui\";i:151;s:19:\"ilpdtaggingblockgui\";i:152;s:21:\"ilusersonlineblockgui\";i:153;s:0:\"\";i:154;s:18:\"ilbookmarkblockgui\";i:155;s:18:\"ilcalendarblockgui\";i:156;s:15:\"ildummyblockgui\";i:157;s:22:\"ilexternalfeedblockgui\";i:158;s:14:\"ilhtmlblockgui\";i:159;s:24:\"ilnewsforcontextblockgui\";i:160;s:20:\"ilpdcalendarblockgui\";i:161;s:24:\"ilpdexternalfeedblockgui\";i:162;s:20:\"ilpdfeedbackblockgui\";i:163;s:16:\"ilpdmailblockgui\";i:164;s:16:\"ilpdnewsblockgui\";i:165;s:17:\"ilpdnotesblockgui\";i:166;s:25:\"ilpdselecteditemsblockgui\";i:167;s:22:\"ilpdsysmessageblockgui\";i:168;s:19:\"ilpdtaggingblockgui\";i:169;s:21:\"ilusersonlineblockgui\";i:170;s:0:\"\";i:171;s:18:\"ilbookmarkblockgui\";i:172;s:18:\"ilcalendarblockgui\";i:173;s:15:\"ildummyblockgui\";i:174;s:22:\"ilexternalfeedblockgui\";i:175;s:14:\"ilhtmlblockgui\";i:176;s:24:\"ilnewsforcontextblockgui\";i:177;s:20:\"ilpdcalendarblockgui\";i:178;s:24:\"ilpdexternalfeedblockgui\";i:179;s:20:\"ilpdfeedbackblockgui\";i:180;s:16:\"ilpdmailblockgui\";i:181;s:16:\"ilpdnewsblockgui\";i:182;s:17:\"ilpdnotesblockgui\";i:183;s:25:\"ilpdselecteditemsblockgui\";i:184;s:22:\"ilpdsysmessageblockgui\";i:185;s:19:\"ilpdtaggingblockgui\";i:186;s:21:\"ilusersonlineblockgui\";i:187;s:0:\"\";i:188;s:18:\"ilbookmarkblockgui\";i:189;s:18:\"ilcalendarblockgui\";i:190;s:15:\"ildummyblockgui\";i:191;s:22:\"ilexternalfeedblockgui\";i:192;s:14:\"ilhtmlblockgui\";i:193;s:24:\"ilnewsforcontextblockgui\";i:194;s:20:\"ilpdcalendarblockgui\";i:195;s:24:\"ilpdexternalfeedblockgui\";i:196;s:20:\"ilpdfeedbackblockgui\";i:197;s:16:\"ilpdmailblockgui\";i:198;s:16:\"ilpdnewsblockgui\";i:199;s:17:\"ilpdnotesblockgui\";i:200;s:25:\"ilpdselecteditemsblockgui\";i:201;s:22:\"ilpdsysmessageblockgui\";i:202;s:19:\"ilpdtaggingblockgui\";i:203;s:21:\"ilusersonlineblockgui\";i:204;s:0:\"\";i:205;s:18:\"ilbookmarkblockgui\";i:206;s:18:\"ilcalendarblockgui\";i:207;s:15:\"ildummyblockgui\";i:208;s:22:\"ilexternalfeedblockgui\";i:209;s:14:\"ilhtmlblockgui\";i:210;s:24:\"ilnewsforcontextblockgui\";i:211;s:20:\"ilpdcalendarblockgui\";i:212;s:24:\"ilpdexternalfeedblockgui\";i:213;s:20:\"ilpdfeedbackblockgui\";i:214;s:16:\"ilpdmailblockgui\";i:215;s:16:\"ilpdnewsblockgui\";i:216;s:17:\"ilpdnotesblockgui\";i:217;s:25:\"ilpdselecteditemsblockgui\";i:218;s:22:\"ilpdsysmessageblockgui\";i:219;s:19:\"ilpdtaggingblockgui\";i:220;s:21:\"ilusersonlineblockgui\";i:221;s:0:\"\";i:222;s:18:\"ilbookmarkblockgui\";i:223;s:18:\"ilcalendarblockgui\";i:224;s:15:\"ildummyblockgui\";i:225;s:22:\"ilexternalfeedblockgui\";i:226;s:14:\"ilhtmlblockgui\";i:227;s:24:\"ilnewsforcontextblockgui\";i:228;s:20:\"ilpdcalendarblockgui\";i:229;s:24:\"ilpdexternalfeedblockgui\";i:230;s:20:\"ilpdfeedbackblockgui\";i:231;s:16:\"ilpdmailblockgui\";i:232;s:16:\"ilpdnewsblockgui\";i:233;s:17:\"ilpdnotesblockgui\";i:234;s:25:\"ilpdselecteditemsblockgui\";i:235;s:22:\"ilpdsysmessageblockgui\";i:236;s:19:\"ilpdtaggingblockgui\";i:237;s:21:\"ilusersonlineblockgui\";i:238;s:0:\"\";i:239;s:18:\"ilbookmarkblockgui\";i:240;s:18:\"ilcalendarblockgui\";i:241;s:15:\"ildummyblockgui\";i:242;s:22:\"ilexternalfeedblockgui\";i:243;s:14:\"ilhtmlblockgui\";i:244;s:24:\"ilnewsforcontextblockgui\";i:245;s:20:\"ilpdcalendarblockgui\";i:246;s:24:\"ilpdexternalfeedblockgui\";i:247;s:20:\"ilpdfeedbackblockgui\";i:248;s:16:\"ilpdmailblockgui\";i:249;s:16:\"ilpdnewsblockgui\";i:250;s:17:\"ilpdnotesblockgui\";i:251;s:25:\"ilpdselecteditemsblockgui\";i:252;s:22:\"ilpdsysmessageblockgui\";i:253;s:19:\"ilpdtaggingblockgui\";i:254;s:21:\"ilusersonlineblockgui\";i:255;s:0:\"\";i:256;s:18:\"ilbookmarkblockgui\";i:257;s:18:\"ilcalendarblockgui\";i:258;s:15:\"ildummyblockgui\";i:259;s:22:\"ilexternalfeedblockgui\";i:260;s:14:\"ilhtmlblockgui\";i:261;s:24:\"ilnewsforcontextblockgui\";i:262;s:20:\"ilpdcalendarblockgui\";i:263;s:24:\"ilpdexternalfeedblockgui\";i:264;s:20:\"ilpdfeedbackblockgui\";i:265;s:16:\"ilpdmailblockgui\";i:266;s:16:\"ilpdnewsblockgui\";i:267;s:17:\"ilpdnotesblockgui\";i:268;s:25:\"ilpdselecteditemsblockgui\";i:269;s:22:\"ilpdsysmessageblockgui\";i:270;s:19:\"ilpdtaggingblockgui\";i:271;s:21:\"ilusersonlineblockgui\";i:272;s:0:\"\";i:273;s:18:\"ilbookmarkblockgui\";i:274;s:18:\"ilcalendarblockgui\";i:275;s:15:\"ildummyblockgui\";i:276;s:22:\"ilexternalfeedblockgui\";i:277;s:14:\"ilhtmlblockgui\";i:278;s:24:\"ilnewsforcontextblockgui\";i:279;s:20:\"ilpdcalendarblockgui\";i:280;s:24:\"ilpdexternalfeedblockgui\";i:281;s:20:\"ilpdfeedbackblockgui\";i:282;s:16:\"ilpdmailblockgui\";i:283;s:16:\"ilpdnewsblockgui\";i:284;s:17:\"ilpdnotesblockgui\";i:285;s:25:\"ilpdselecteditemsblockgui\";i:286;s:22:\"ilpdsysmessageblockgui\";i:287;s:19:\"ilpdtaggingblockgui\";i:288;s:21:\"ilusersonlineblockgui\";i:289;s:0:\"\";i:290;s:18:\"ilbookmarkblockgui\";i:291;s:18:\"ilcalendarblockgui\";i:292;s:15:\"ildummyblockgui\";i:293;s:22:\"ilexternalfeedblockgui\";i:294;s:14:\"ilhtmlblockgui\";i:295;s:24:\"ilnewsforcontextblockgui\";i:296;s:20:\"ilpdcalendarblockgui\";i:297;s:24:\"ilpdexternalfeedblockgui\";i:298;s:20:\"ilpdfeedbackblockgui\";i:299;s:16:\"ilpdmailblockgui\";i:300;s:16:\"ilpdnewsblockgui\";i:301;s:17:\"ilpdnotesblockgui\";i:302;s:25:\"ilpdselecteditemsblockgui\";i:303;s:22:\"ilpdsysmessageblockgui\";i:304;s:19:\"ilpdtaggingblockgui\";i:305;s:21:\"ilusersonlineblockgui\";i:306;s:0:\"\";i:307;s:18:\"ilbookmarkblockgui\";i:308;s:18:\"ilcalendarblockgui\";i:309;s:15:\"ildummyblockgui\";i:310;s:22:\"ilexternalfeedblockgui\";i:311;s:14:\"ilhtmlblockgui\";i:312;s:24:\"ilnewsforcontextblockgui\";i:313;s:20:\"ilpdcalendarblockgui\";i:314;s:24:\"ilpdexternalfeedblockgui\";i:315;s:20:\"ilpdfeedbackblockgui\";i:316;s:16:\"ilpdmailblockgui\";i:317;s:16:\"ilpdnewsblockgui\";i:318;s:17:\"ilpdnotesblockgui\";i:319;s:25:\"ilpdselecteditemsblockgui\";i:320;s:22:\"ilpdsysmessageblockgui\";i:321;s:19:\"ilpdtaggingblockgui\";i:322;s:21:\"ilusersonlineblockgui\";i:323;s:0:\"\";i:324;s:18:\"ilbookmarkblockgui\";i:325;s:18:\"ilcalendarblockgui\";i:326;s:15:\"ildummyblockgui\";i:327;s:22:\"ilexternalfeedblockgui\";i:328;s:14:\"ilhtmlblockgui\";i:329;s:24:\"ilnewsforcontextblockgui\";i:330;s:20:\"ilpdcalendarblockgui\";i:331;s:24:\"ilpdexternalfeedblockgui\";i:332;s:20:\"ilpdfeedbackblockgui\";i:333;s:16:\"ilpdmailblockgui\";i:334;s:16:\"ilpdnewsblockgui\";i:335;s:17:\"ilpdnotesblockgui\";i:336;s:25:\"ilpdselecteditemsblockgui\";i:337;s:22:\"ilpdsysmessageblockgui\";i:338;s:19:\"ilpdtaggingblockgui\";i:339;s:21:\"ilusersonlineblockgui\";i:340;s:0:\"\";i:341;s:18:\"ilbookmarkblockgui\";i:342;s:18:\"ilcalendarblockgui\";i:343;s:15:\"ildummyblockgui\";i:344;s:22:\"ilexternalfeedblockgui\";i:345;s:14:\"ilhtmlblockgui\";i:346;s:24:\"ilnewsforcontextblockgui\";i:347;s:20:\"ilpdcalendarblockgui\";i:348;s:24:\"ilpdexternalfeedblockgui\";i:349;s:20:\"ilpdfeedbackblockgui\";i:350;s:16:\"ilpdmailblockgui\";i:351;s:16:\"ilpdnewsblockgui\";i:352;s:17:\"ilpdnotesblockgui\";i:353;s:25:\"ilpdselecteditemsblockgui\";i:354;s:22:\"ilpdsysmessageblockgui\";i:355;s:19:\"ilpdtaggingblockgui\";i:356;s:21:\"ilusersonlineblockgui\";i:357;s:0:\"\";i:358;s:18:\"ilbookmarkblockgui\";i:359;s:18:\"ilcalendarblockgui\";i:360;s:15:\"ildummyblockgui\";i:361;s:22:\"ilexternalfeedblockgui\";i:362;s:14:\"ilhtmlblockgui\";i:363;s:24:\"ilnewsforcontextblockgui\";i:364;s:20:\"ilpdcalendarblockgui\";i:365;s:24:\"ilpdexternalfeedblockgui\";i:366;s:20:\"ilpdfeedbackblockgui\";i:367;s:16:\"ilpdmailblockgui\";i:368;s:16:\"ilpdnewsblockgui\";i:369;s:17:\"ilpdnotesblockgui\";i:370;s:25:\"ilpdselecteditemsblockgui\";i:371;s:22:\"ilpdsysmessageblockgui\";i:372;s:19:\"ilpdtaggingblockgui\";i:373;s:21:\"ilusersonlineblockgui\";i:374;s:0:\"\";i:375;s:18:\"ilbookmarkblockgui\";i:376;s:18:\"ilcalendarblockgui\";i:377;s:15:\"ildummyblockgui\";i:378;s:22:\"ilexternalfeedblockgui\";i:379;s:14:\"ilhtmlblockgui\";i:380;s:24:\"ilnewsforcontextblockgui\";i:381;s:20:\"ilpdcalendarblockgui\";i:382;s:24:\"ilpdexternalfeedblockgui\";i:383;s:20:\"ilpdfeedbackblockgui\";i:384;s:16:\"ilpdmailblockgui\";i:385;s:16:\"ilpdnewsblockgui\";i:386;s:17:\"ilpdnotesblockgui\";i:387;s:25:\"ilpdselecteditemsblockgui\";i:388;s:22:\"ilpdsysmessageblockgui\";i:389;s:19:\"ilpdtaggingblockgui\";i:390;s:21:\"ilusersonlineblockgui\";i:391;s:0:\"\";i:392;s:18:\"ilbookmarkblockgui\";i:393;s:18:\"ilcalendarblockgui\";i:394;s:15:\"ildummyblockgui\";i:395;s:22:\"ilexternalfeedblockgui\";i:396;s:14:\"ilhtmlblockgui\";i:397;s:24:\"ilnewsforcontextblockgui\";i:398;s:20:\"ilpdcalendarblockgui\";i:399;s:24:\"ilpdexternalfeedblockgui\";i:400;s:20:\"ilpdfeedbackblockgui\";i:401;s:16:\"ilpdmailblockgui\";i:402;s:16:\"ilpdnewsblockgui\";i:403;s:17:\"ilpdnotesblockgui\";i:404;s:25:\"ilpdselecteditemsblockgui\";i:405;s:22:\"ilpdsysmessageblockgui\";i:406;s:19:\"ilpdtaggingblockgui\";i:407;s:21:\"ilusersonlineblockgui\";i:408;s:0:\"\";i:409;s:18:\"ilbookmarkblockgui\";i:410;s:18:\"ilcalendarblockgui\";i:411;s:15:\"ildummyblockgui\";i:412;s:22:\"ilexternalfeedblockgui\";i:413;s:14:\"ilhtmlblockgui\";i:414;s:24:\"ilnewsforcontextblockgui\";i:415;s:20:\"ilpdcalendarblockgui\";i:416;s:24:\"ilpdexternalfeedblockgui\";i:417;s:20:\"ilpdfeedbackblockgui\";i:418;s:16:\"ilpdmailblockgui\";i:419;s:16:\"ilpdnewsblockgui\";i:420;s:17:\"ilpdnotesblockgui\";i:421;s:25:\"ilpdselecteditemsblockgui\";i:422;s:22:\"ilpdsysmessageblockgui\";i:423;s:19:\"ilpdtaggingblockgui\";i:424;s:21:\"ilusersonlineblockgui\";i:425;s:0:\"\";i:426;s:18:\"ilbookmarkblockgui\";i:427;s:18:\"ilcalendarblockgui\";i:428;s:15:\"ildummyblockgui\";i:429;s:22:\"ilexternalfeedblockgui\";i:430;s:14:\"ilhtmlblockgui\";i:431;s:24:\"ilnewsforcontextblockgui\";i:432;s:20:\"ilpdcalendarblockgui\";i:433;s:24:\"ilpdexternalfeedblockgui\";i:434;s:20:\"ilpdfeedbackblockgui\";i:435;s:16:\"ilpdmailblockgui\";i:436;s:16:\"ilpdnewsblockgui\";i:437;s:17:\"ilpdnotesblockgui\";i:438;s:25:\"ilpdselecteditemsblockgui\";i:439;s:22:\"ilpdsysmessageblockgui\";i:440;s:19:\"ilpdtaggingblockgui\";i:441;s:21:\"ilusersonlineblockgui\";i:442;s:0:\"\";i:443;s:18:\"ilbookmarkblockgui\";i:444;s:18:\"ilcalendarblockgui\";i:445;s:15:\"ildummyblockgui\";i:446;s:22:\"ilexternalfeedblockgui\";i:447;s:14:\"ilhtmlblockgui\";i:448;s:24:\"ilnewsforcontextblockgui\";i:449;s:20:\"ilpdcalendarblockgui\";i:450;s:24:\"ilpdexternalfeedblockgui\";i:451;s:20:\"ilpdfeedbackblockgui\";i:452;s:16:\"ilpdmailblockgui\";i:453;s:16:\"ilpdnewsblockgui\";i:454;s:17:\"ilpdnotesblockgui\";i:455;s:25:\"ilpdselecteditemsblockgui\";i:456;s:22:\"ilpdsysmessageblockgui\";i:457;s:19:\"ilpdtaggingblockgui\";i:458;s:21:\"ilusersonlineblockgui\";i:459;s:0:\"\";i:460;s:18:\"ilbookmarkblockgui\";i:461;s:18:\"ilcalendarblockgui\";i:462;s:15:\"ildummyblockgui\";i:463;s:22:\"ilexternalfeedblockgui\";i:464;s:14:\"ilhtmlblockgui\";i:465;s:24:\"ilnewsforcontextblockgui\";i:466;s:20:\"ilpdcalendarblockgui\";i:467;s:24:\"ilpdexternalfeedblockgui\";i:468;s:20:\"ilpdfeedbackblockgui\";i:469;s:16:\"ilpdmailblockgui\";i:470;s:16:\"ilpdnewsblockgui\";i:471;s:17:\"ilpdnotesblockgui\";i:472;s:25:\"ilpdselecteditemsblockgui\";i:473;s:22:\"ilpdsysmessageblockgui\";i:474;s:19:\"ilpdtaggingblockgui\";i:475;s:21:\"ilusersonlineblockgui\";i:476;s:0:\"\";i:477;s:18:\"ilbookmarkblockgui\";i:478;s:18:\"ilcalendarblockgui\";i:479;s:15:\"ildummyblockgui\";i:480;s:22:\"ilexternalfeedblockgui\";i:481;s:14:\"ilhtmlblockgui\";i:482;s:24:\"ilnewsforcontextblockgui\";i:483;s:20:\"ilpdcalendarblockgui\";i:484;s:24:\"ilpdexternalfeedblockgui\";i:485;s:20:\"ilpdfeedbackblockgui\";i:486;s:16:\"ilpdmailblockgui\";i:487;s:16:\"ilpdnewsblockgui\";i:488;s:17:\"ilpdnotesblockgui\";i:489;s:25:\"ilpdselecteditemsblockgui\";i:490;s:22:\"ilpdsysmessageblockgui\";i:491;s:19:\"ilpdtaggingblockgui\";i:492;s:21:\"ilusersonlineblockgui\";i:493;s:0:\"\";i:494;s:18:\"ilbookmarkblockgui\";i:495;s:18:\"ilcalendarblockgui\";i:496;s:15:\"ildummyblockgui\";i:497;s:22:\"ilexternalfeedblockgui\";i:498;s:14:\"ilhtmlblockgui\";i:499;s:24:\"ilnewsforcontextblockgui\";i:500;s:20:\"ilpdcalendarblockgui\";i:501;s:24:\"ilpdexternalfeedblockgui\";i:502;s:20:\"ilpdfeedbackblockgui\";i:503;s:16:\"ilpdmailblockgui\";i:504;s:16:\"ilpdnewsblockgui\";i:505;s:17:\"ilpdnotesblockgui\";i:506;s:25:\"ilpdselecteditemsblockgui\";i:507;s:22:\"ilpdsysmessageblockgui\";i:508;s:19:\"ilpdtaggingblockgui\";i:509;s:21:\"ilusersonlineblockgui\";i:510;s:0:\"\";i:511;s:18:\"ilbookmarkblockgui\";i:512;s:18:\"ilcalendarblockgui\";i:513;s:15:\"ildummyblockgui\";i:514;s:22:\"ilexternalfeedblockgui\";i:515;s:14:\"ilhtmlblockgui\";i:516;s:24:\"ilnewsforcontextblockgui\";i:517;s:20:\"ilpdcalendarblockgui\";i:518;s:24:\"ilpdexternalfeedblockgui\";i:519;s:20:\"ilpdfeedbackblockgui\";i:520;s:16:\"ilpdmailblockgui\";i:521;s:16:\"ilpdnewsblockgui\";i:522;s:17:\"ilpdnotesblockgui\";i:523;s:25:\"ilpdselecteditemsblockgui\";i:524;s:22:\"ilpdsysmessageblockgui\";i:525;s:19:\"ilpdtaggingblockgui\";i:526;s:21:\"ilusersonlineblockgui\";i:527;s:0:\"\";i:528;s:18:\"ilbookmarkblockgui\";i:529;s:18:\"ilcalendarblockgui\";i:530;s:15:\"ildummyblockgui\";i:531;s:22:\"ilexternalfeedblockgui\";i:532;s:14:\"ilhtmlblockgui\";i:533;s:24:\"ilnewsforcontextblockgui\";i:534;s:20:\"ilpdcalendarblockgui\";i:535;s:24:\"ilpdexternalfeedblockgui\";i:536;s:20:\"ilpdfeedbackblockgui\";i:537;s:16:\"ilpdmailblockgui\";i:538;s:16:\"ilpdnewsblockgui\";i:539;s:17:\"ilpdnotesblockgui\";i:540;s:25:\"ilpdselecteditemsblockgui\";i:541;s:22:\"ilpdsysmessageblockgui\";i:542;s:19:\"ilpdtaggingblockgui\";i:543;s:21:\"ilusersonlineblockgui\";i:544;s:0:\"\";i:545;s:18:\"ilbookmarkblockgui\";i:546;s:18:\"ilcalendarblockgui\";i:547;s:15:\"ildummyblockgui\";i:548;s:22:\"ilexternalfeedblockgui\";i:549;s:14:\"ilhtmlblockgui\";i:550;s:24:\"ilnewsforcontextblockgui\";i:551;s:20:\"ilpdcalendarblockgui\";i:552;s:24:\"ilpdexternalfeedblockgui\";i:553;s:20:\"ilpdfeedbackblockgui\";i:554;s:16:\"ilpdmailblockgui\";i:555;s:16:\"ilpdnewsblockgui\";i:556;s:17:\"ilpdnotesblockgui\";i:557;s:25:\"ilpdselecteditemsblockgui\";i:558;s:22:\"ilpdsysmessageblockgui\";i:559;s:19:\"ilpdtaggingblockgui\";i:560;s:21:\"ilusersonlineblockgui\";i:561;s:0:\"\";i:562;s:18:\"ilbookmarkblockgui\";i:563;s:18:\"ilcalendarblockgui\";i:564;s:15:\"ildummyblockgui\";i:565;s:22:\"ilexternalfeedblockgui\";i:566;s:14:\"ilhtmlblockgui\";i:567;s:24:\"ilnewsforcontextblockgui\";i:568;s:20:\"ilpdcalendarblockgui\";i:569;s:24:\"ilpdexternalfeedblockgui\";i:570;s:20:\"ilpdfeedbackblockgui\";i:571;s:16:\"ilpdmailblockgui\";i:572;s:16:\"ilpdnewsblockgui\";i:573;s:17:\"ilpdnotesblockgui\";i:574;s:25:\"ilpdselecteditemsblockgui\";i:575;s:22:\"ilpdsysmessageblockgui\";i:576;s:19:\"ilpdtaggingblockgui\";i:577;s:21:\"ilusersonlineblockgui\";i:578;s:0:\"\";i:579;s:18:\"ilbookmarkblockgui\";i:580;s:18:\"ilcalendarblockgui\";i:581;s:15:\"ildummyblockgui\";i:582;s:22:\"ilexternalfeedblockgui\";i:583;s:14:\"ilhtmlblockgui\";i:584;s:24:\"ilnewsforcontextblockgui\";i:585;s:20:\"ilpdcalendarblockgui\";i:586;s:24:\"ilpdexternalfeedblockgui\";i:587;s:20:\"ilpdfeedbackblockgui\";i:588;s:16:\"ilpdmailblockgui\";i:589;s:16:\"ilpdnewsblockgui\";i:590;s:17:\"ilpdnotesblockgui\";i:591;s:25:\"ilpdselecteditemsblockgui\";i:592;s:22:\"ilpdsysmessageblockgui\";i:593;s:19:\"ilpdtaggingblockgui\";i:594;s:21:\"ilusersonlineblockgui\";i:595;s:0:\"\";i:596;s:18:\"ilbookmarkblockgui\";i:597;s:18:\"ilcalendarblockgui\";i:598;s:15:\"ildummyblockgui\";i:599;s:22:\"ilexternalfeedblockgui\";i:600;s:14:\"ilhtmlblockgui\";i:601;s:24:\"ilnewsforcontextblockgui\";i:602;s:20:\"ilpdcalendarblockgui\";i:603;s:24:\"ilpdexternalfeedblockgui\";i:604;s:20:\"ilpdfeedbackblockgui\";i:605;s:16:\"ilpdmailblockgui\";i:606;s:16:\"ilpdnewsblockgui\";i:607;s:17:\"ilpdnotesblockgui\";i:608;s:25:\"ilpdselecteditemsblockgui\";i:609;s:22:\"ilpdsysmessageblockgui\";i:610;s:19:\"ilpdtaggingblockgui\";i:611;s:21:\"ilusersonlineblockgui\";i:612;s:0:\"\";i:613;s:18:\"ilbookmarkblockgui\";i:614;s:18:\"ilcalendarblockgui\";i:615;s:15:\"ildummyblockgui\";i:616;s:22:\"ilexternalfeedblockgui\";i:617;s:14:\"ilhtmlblockgui\";i:618;s:24:\"ilnewsforcontextblockgui\";i:619;s:20:\"ilpdcalendarblockgui\";i:620;s:24:\"ilpdexternalfeedblockgui\";i:621;s:20:\"ilpdfeedbackblockgui\";i:622;s:16:\"ilpdmailblockgui\";i:623;s:16:\"ilpdnewsblockgui\";i:624;s:17:\"ilpdnotesblockgui\";i:625;s:25:\"ilpdselecteditemsblockgui\";i:626;s:22:\"ilpdsysmessageblockgui\";i:627;s:19:\"ilpdtaggingblockgui\";i:628;s:21:\"ilusersonlineblockgui\";i:629;s:0:\"\";i:630;s:18:\"ilbookmarkblockgui\";i:631;s:18:\"ilcalendarblockgui\";i:632;s:15:\"ildummyblockgui\";i:633;s:22:\"ilexternalfeedblockgui\";i:634;s:14:\"ilhtmlblockgui\";i:635;s:24:\"ilnewsforcontextblockgui\";i:636;s:20:\"ilpdcalendarblockgui\";i:637;s:24:\"ilpdexternalfeedblockgui\";i:638;s:20:\"ilpdfeedbackblockgui\";i:639;s:16:\"ilpdmailblockgui\";i:640;s:16:\"ilpdnewsblockgui\";i:641;s:17:\"ilpdnotesblockgui\";i:642;s:25:\"ilpdselecteditemsblockgui\";i:643;s:22:\"ilpdsysmessageblockgui\";i:644;s:19:\"ilpdtaggingblockgui\";i:645;s:21:\"ilusersonlineblockgui\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:13:\"ilfeedbackgui\";a:25:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";}s:15:\"ilinfoscreengui\";a:100:{i:0;s:11:\"ilcolumngui\";i:1;s:13:\"ilfeedbackgui\";i:2;s:9:\"ilnotegui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:11:\"ilcolumngui\";i:5;s:13:\"ilfeedbackgui\";i:6;s:9:\"ilnotegui\";i:7;s:22:\"ilpublicuserprofilegui\";i:8;s:11:\"ilcolumngui\";i:9;s:13:\"ilfeedbackgui\";i:10;s:9:\"ilnotegui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:11:\"ilcolumngui\";i:13;s:13:\"ilfeedbackgui\";i:14;s:9:\"ilnotegui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:11:\"ilcolumngui\";i:17;s:13:\"ilfeedbackgui\";i:18;s:9:\"ilnotegui\";i:19;s:22:\"ilpublicuserprofilegui\";i:20;s:11:\"ilcolumngui\";i:21;s:13:\"ilfeedbackgui\";i:22;s:9:\"ilnotegui\";i:23;s:22:\"ilpublicuserprofilegui\";i:24;s:11:\"ilcolumngui\";i:25;s:13:\"ilfeedbackgui\";i:26;s:9:\"ilnotegui\";i:27;s:22:\"ilpublicuserprofilegui\";i:28;s:11:\"ilcolumngui\";i:29;s:13:\"ilfeedbackgui\";i:30;s:9:\"ilnotegui\";i:31;s:22:\"ilpublicuserprofilegui\";i:32;s:11:\"ilcolumngui\";i:33;s:13:\"ilfeedbackgui\";i:34;s:9:\"ilnotegui\";i:35;s:22:\"ilpublicuserprofilegui\";i:36;s:11:\"ilcolumngui\";i:37;s:13:\"ilfeedbackgui\";i:38;s:9:\"ilnotegui\";i:39;s:22:\"ilpublicuserprofilegui\";i:40;s:11:\"ilcolumngui\";i:41;s:13:\"ilfeedbackgui\";i:42;s:9:\"ilnotegui\";i:43;s:22:\"ilpublicuserprofilegui\";i:44;s:11:\"ilcolumngui\";i:45;s:13:\"ilfeedbackgui\";i:46;s:9:\"ilnotegui\";i:47;s:22:\"ilpublicuserprofilegui\";i:48;s:11:\"ilcolumngui\";i:49;s:13:\"ilfeedbackgui\";i:50;s:9:\"ilnotegui\";i:51;s:22:\"ilpublicuserprofilegui\";i:52;s:11:\"ilcolumngui\";i:53;s:13:\"ilfeedbackgui\";i:54;s:9:\"ilnotegui\";i:55;s:22:\"ilpublicuserprofilegui\";i:56;s:11:\"ilcolumngui\";i:57;s:13:\"ilfeedbackgui\";i:58;s:9:\"ilnotegui\";i:59;s:22:\"ilpublicuserprofilegui\";i:60;s:11:\"ilcolumngui\";i:61;s:13:\"ilfeedbackgui\";i:62;s:9:\"ilnotegui\";i:63;s:22:\"ilpublicuserprofilegui\";i:64;s:11:\"ilcolumngui\";i:65;s:13:\"ilfeedbackgui\";i:66;s:9:\"ilnotegui\";i:67;s:22:\"ilpublicuserprofilegui\";i:68;s:11:\"ilcolumngui\";i:69;s:13:\"ilfeedbackgui\";i:70;s:9:\"ilnotegui\";i:71;s:22:\"ilpublicuserprofilegui\";i:72;s:11:\"ilcolumngui\";i:73;s:13:\"ilfeedbackgui\";i:74;s:9:\"ilnotegui\";i:75;s:22:\"ilpublicuserprofilegui\";i:76;s:11:\"ilcolumngui\";i:77;s:13:\"ilfeedbackgui\";i:78;s:9:\"ilnotegui\";i:79;s:22:\"ilpublicuserprofilegui\";i:80;s:11:\"ilcolumngui\";i:81;s:13:\"ilfeedbackgui\";i:82;s:9:\"ilnotegui\";i:83;s:22:\"ilpublicuserprofilegui\";i:84;s:11:\"ilcolumngui\";i:85;s:13:\"ilfeedbackgui\";i:86;s:9:\"ilnotegui\";i:87;s:22:\"ilpublicuserprofilegui\";i:88;s:11:\"ilcolumngui\";i:89;s:13:\"ilfeedbackgui\";i:90;s:9:\"ilnotegui\";i:91;s:22:\"ilpublicuserprofilegui\";i:92;s:11:\"ilcolumngui\";i:93;s:13:\"ilfeedbackgui\";i:94;s:9:\"ilnotegui\";i:95;s:22:\"ilpublicuserprofilegui\";i:96;s:11:\"ilcolumngui\";i:97;s:13:\"ilfeedbackgui\";i:98;s:9:\"ilnotegui\";i:99;s:22:\"ilpublicuserprofilegui\";}s:13:\"illpfiltergui\";a:24:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";}s:17:\"ilpdfpresentation\";a:24:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";}s:15:\"iluserfiltergui\";a:12:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:36:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:15:\"iluserfiltergui\";i:9;s:13:\"illpfiltergui\";i:10;s:17:\"ilpdfpresentation\";i:11;s:15:\"iluserfiltergui\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:15:\"iluserfiltergui\";i:15;s:13:\"illpfiltergui\";i:16;s:17:\"ilpdfpresentation\";i:17;s:15:\"iluserfiltergui\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:15:\"iluserfiltergui\";i:21;s:13:\"illpfiltergui\";i:22;s:17:\"ilpdfpresentation\";i:23;s:15:\"iluserfiltergui\";i:24;s:13:\"illpfiltergui\";i:25;s:17:\"ilpdfpresentation\";i:26;s:15:\"iluserfiltergui\";i:27;s:13:\"illpfiltergui\";i:28;s:17:\"ilpdfpresentation\";i:29;s:15:\"iluserfiltergui\";i:30;s:13:\"illpfiltergui\";i:31;s:17:\"ilpdfpresentation\";i:32;s:15:\"iluserfiltergui\";i:33;s:13:\"illpfiltergui\";i:34;s:17:\"ilpdfpresentation\";i:35;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:24:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";i:4;s:13:\"illpfiltergui\";i:5;s:17:\"ilpdfpresentation\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:13:\"illpfiltergui\";i:9;s:17:\"ilpdfpresentation\";i:10;s:13:\"illpfiltergui\";i:11;s:17:\"ilpdfpresentation\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:13:\"illpfiltergui\";i:15;s:17:\"ilpdfpresentation\";i:16;s:13:\"illpfiltergui\";i:17;s:17:\"ilpdfpresentation\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:13:\"illpfiltergui\";i:21;s:17:\"ilpdfpresentation\";i:22;s:13:\"illpfiltergui\";i:23;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:12:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";}s:21:\"illearningprogressgui\";a:48:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";i:8;s:17:\"illmstatisticsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:21:\"illplistofprogressgui\";i:11;s:21:\"illplistofsettingsgui\";i:12;s:17:\"illmstatisticsgui\";i:13;s:20:\"illplistofobjectsgui\";i:14;s:21:\"illplistofprogressgui\";i:15;s:21:\"illplistofsettingsgui\";i:16;s:17:\"illmstatisticsgui\";i:17;s:20:\"illplistofobjectsgui\";i:18;s:21:\"illplistofprogressgui\";i:19;s:21:\"illplistofsettingsgui\";i:20;s:17:\"illmstatisticsgui\";i:21;s:20:\"illplistofobjectsgui\";i:22;s:21:\"illplistofprogressgui\";i:23;s:21:\"illplistofsettingsgui\";i:24;s:17:\"illmstatisticsgui\";i:25;s:20:\"illplistofobjectsgui\";i:26;s:21:\"illplistofprogressgui\";i:27;s:21:\"illplistofsettingsgui\";i:28;s:17:\"illmstatisticsgui\";i:29;s:20:\"illplistofobjectsgui\";i:30;s:21:\"illplistofprogressgui\";i:31;s:21:\"illplistofsettingsgui\";i:32;s:17:\"illmstatisticsgui\";i:33;s:20:\"illplistofobjectsgui\";i:34;s:21:\"illplistofprogressgui\";i:35;s:21:\"illplistofsettingsgui\";i:36;s:17:\"illmstatisticsgui\";i:37;s:20:\"illplistofobjectsgui\";i:38;s:21:\"illplistofprogressgui\";i:39;s:21:\"illplistofsettingsgui\";i:40;s:17:\"illmstatisticsgui\";i:41;s:20:\"illplistofobjectsgui\";i:42;s:21:\"illplistofprogressgui\";i:43;s:21:\"illplistofsettingsgui\";i:44;s:17:\"illmstatisticsgui\";i:45;s:20:\"illplistofobjectsgui\";i:46;s:21:\"illplistofprogressgui\";i:47;s:21:\"illplistofsettingsgui\";}s:12:\"ilobjusergui\";a:4:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"ilobjilincusergui\";i:2;s:21:\"illearningprogressgui\";i:3;s:17:\"ilobjilincusergui\";}s:20:\"iladminusersearchgui\";a:1:{i:0;s:12:\"ilobjusergui\";}s:12:\"ilobjrolegui\";a:32:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";}s:15:\"ilpermissiongui\";a:31:{i:0;s:12:\"ilobjrolegui\";i:1;s:12:\"ilobjrolegui\";i:2;s:12:\"ilobjrolegui\";i:3;s:12:\"ilobjrolegui\";i:4;s:12:\"ilobjrolegui\";i:5;s:12:\"ilobjrolegui\";i:6;s:12:\"ilobjrolegui\";i:7;s:12:\"ilobjrolegui\";i:8;s:12:\"ilobjrolegui\";i:9;s:12:\"ilobjrolegui\";i:10;s:12:\"ilobjrolegui\";i:11;s:12:\"ilobjrolegui\";i:12;s:12:\"ilobjrolegui\";i:13;s:12:\"ilobjrolegui\";i:14;s:12:\"ilobjrolegui\";i:15;s:12:\"ilobjrolegui\";i:16;s:12:\"ilobjrolegui\";i:17;s:12:\"ilobjrolegui\";i:18;s:12:\"ilobjrolegui\";i:19;s:12:\"ilobjrolegui\";i:20;s:12:\"ilobjrolegui\";i:21;s:12:\"ilobjrolegui\";i:22;s:12:\"ilobjrolegui\";i:23;s:12:\"ilobjrolegui\";i:24;s:12:\"ilobjrolegui\";i:25;s:12:\"ilobjrolegui\";i:26;s:12:\"ilobjrolegui\";i:27;s:12:\"ilobjrolegui\";i:28;s:12:\"ilobjrolegui\";i:29;s:12:\"ilobjrolegui\";i:30;s:12:\"ilobjrolegui\";}s:18:\"ilobjuserfoldergui\";a:2:{i:0;s:20:\"iladminusersearchgui\";i:1;s:15:\"ilpermissiongui\";}s:19:\"ilimagemapeditorgui\";a:59:{i:0;s:17:\"ilinternallinkgui\";i:1;s:17:\"ilinternallinkgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:17:\"ilinternallinkgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:17:\"ilinternallinkgui\";i:6;s:17:\"ilinternallinkgui\";i:7;s:17:\"ilinternallinkgui\";i:8;s:17:\"ilinternallinkgui\";i:9;s:17:\"ilinternallinkgui\";i:10;s:17:\"ilinternallinkgui\";i:11;s:17:\"ilinternallinkgui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:17:\"ilinternallinkgui\";i:14;s:17:\"ilinternallinkgui\";i:15;s:17:\"ilinternallinkgui\";i:16;s:17:\"ilinternallinkgui\";i:17;s:17:\"ilinternallinkgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:17:\"ilinternallinkgui\";i:20;s:17:\"ilinternallinkgui\";i:21;s:17:\"ilinternallinkgui\";i:22;s:17:\"ilinternallinkgui\";i:23;s:17:\"ilinternallinkgui\";i:24;s:17:\"ilinternallinkgui\";i:25;s:17:\"ilinternallinkgui\";i:26;s:17:\"ilinternallinkgui\";i:27;s:17:\"ilinternallinkgui\";i:28;s:17:\"ilinternallinkgui\";i:29;s:17:\"ilinternallinkgui\";i:30;s:17:\"ilinternallinkgui\";i:31;s:17:\"ilinternallinkgui\";i:32;s:17:\"ilinternallinkgui\";i:33;s:17:\"ilinternallinkgui\";i:34;s:17:\"ilinternallinkgui\";i:35;s:17:\"ilinternallinkgui\";i:36;s:17:\"ilinternallinkgui\";i:37;s:17:\"ilinternallinkgui\";i:38;s:17:\"ilinternallinkgui\";i:39;s:17:\"ilinternallinkgui\";i:40;s:17:\"ilinternallinkgui\";i:41;s:17:\"ilinternallinkgui\";i:42;s:17:\"ilinternallinkgui\";i:43;s:17:\"ilinternallinkgui\";i:44;s:17:\"ilinternallinkgui\";i:45;s:17:\"ilinternallinkgui\";i:46;s:17:\"ilinternallinkgui\";i:47;s:17:\"ilinternallinkgui\";i:48;s:17:\"ilinternallinkgui\";i:49;s:17:\"ilinternallinkgui\";i:50;s:17:\"ilinternallinkgui\";i:51;s:17:\"ilinternallinkgui\";i:52;s:17:\"ilinternallinkgui\";i:53;s:17:\"ilinternallinkgui\";i:54;s:17:\"ilinternallinkgui\";i:55;s:17:\"ilinternallinkgui\";i:56;s:17:\"ilinternallinkgui\";i:57;s:17:\"ilinternallinkgui\";i:58;s:17:\"ilinternallinkgui\";}s:19:\"ilobjmediaobjectgui\";a:118:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:19:\"ilimagemapeditorgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:19:\"ilimagemapeditorgui\";i:7;s:13:\"ilmdeditorgui\";i:8;s:19:\"ilimagemapeditorgui\";i:9;s:13:\"ilmdeditorgui\";i:10;s:19:\"ilimagemapeditorgui\";i:11;s:13:\"ilmdeditorgui\";i:12;s:19:\"ilimagemapeditorgui\";i:13;s:13:\"ilmdeditorgui\";i:14;s:19:\"ilimagemapeditorgui\";i:15;s:13:\"ilmdeditorgui\";i:16;s:19:\"ilimagemapeditorgui\";i:17;s:13:\"ilmdeditorgui\";i:18;s:19:\"ilimagemapeditorgui\";i:19;s:13:\"ilmdeditorgui\";i:20;s:19:\"ilimagemapeditorgui\";i:21;s:13:\"ilmdeditorgui\";i:22;s:19:\"ilimagemapeditorgui\";i:23;s:13:\"ilmdeditorgui\";i:24;s:19:\"ilimagemapeditorgui\";i:25;s:13:\"ilmdeditorgui\";i:26;s:19:\"ilimagemapeditorgui\";i:27;s:13:\"ilmdeditorgui\";i:28;s:19:\"ilimagemapeditorgui\";i:29;s:13:\"ilmdeditorgui\";i:30;s:19:\"ilimagemapeditorgui\";i:31;s:13:\"ilmdeditorgui\";i:32;s:19:\"ilimagemapeditorgui\";i:33;s:13:\"ilmdeditorgui\";i:34;s:19:\"ilimagemapeditorgui\";i:35;s:13:\"ilmdeditorgui\";i:36;s:19:\"ilimagemapeditorgui\";i:37;s:13:\"ilmdeditorgui\";i:38;s:19:\"ilimagemapeditorgui\";i:39;s:13:\"ilmdeditorgui\";i:40;s:19:\"ilimagemapeditorgui\";i:41;s:13:\"ilmdeditorgui\";i:42;s:19:\"ilimagemapeditorgui\";i:43;s:13:\"ilmdeditorgui\";i:44;s:19:\"ilimagemapeditorgui\";i:45;s:13:\"ilmdeditorgui\";i:46;s:19:\"ilimagemapeditorgui\";i:47;s:13:\"ilmdeditorgui\";i:48;s:19:\"ilimagemapeditorgui\";i:49;s:13:\"ilmdeditorgui\";i:50;s:19:\"ilimagemapeditorgui\";i:51;s:13:\"ilmdeditorgui\";i:52;s:19:\"ilimagemapeditorgui\";i:53;s:13:\"ilmdeditorgui\";i:54;s:19:\"ilimagemapeditorgui\";i:55;s:13:\"ilmdeditorgui\";i:56;s:19:\"ilimagemapeditorgui\";i:57;s:13:\"ilmdeditorgui\";i:58;s:19:\"ilimagemapeditorgui\";i:59;s:13:\"ilmdeditorgui\";i:60;s:19:\"ilimagemapeditorgui\";i:61;s:13:\"ilmdeditorgui\";i:62;s:19:\"ilimagemapeditorgui\";i:63;s:13:\"ilmdeditorgui\";i:64;s:19:\"ilimagemapeditorgui\";i:65;s:13:\"ilmdeditorgui\";i:66;s:19:\"ilimagemapeditorgui\";i:67;s:13:\"ilmdeditorgui\";i:68;s:19:\"ilimagemapeditorgui\";i:69;s:13:\"ilmdeditorgui\";i:70;s:19:\"ilimagemapeditorgui\";i:71;s:13:\"ilmdeditorgui\";i:72;s:19:\"ilimagemapeditorgui\";i:73;s:13:\"ilmdeditorgui\";i:74;s:19:\"ilimagemapeditorgui\";i:75;s:13:\"ilmdeditorgui\";i:76;s:19:\"ilimagemapeditorgui\";i:77;s:13:\"ilmdeditorgui\";i:78;s:19:\"ilimagemapeditorgui\";i:79;s:13:\"ilmdeditorgui\";i:80;s:19:\"ilimagemapeditorgui\";i:81;s:13:\"ilmdeditorgui\";i:82;s:19:\"ilimagemapeditorgui\";i:83;s:13:\"ilmdeditorgui\";i:84;s:19:\"ilimagemapeditorgui\";i:85;s:13:\"ilmdeditorgui\";i:86;s:19:\"ilimagemapeditorgui\";i:87;s:13:\"ilmdeditorgui\";i:88;s:19:\"ilimagemapeditorgui\";i:89;s:13:\"ilmdeditorgui\";i:90;s:19:\"ilimagemapeditorgui\";i:91;s:13:\"ilmdeditorgui\";i:92;s:19:\"ilimagemapeditorgui\";i:93;s:13:\"ilmdeditorgui\";i:94;s:19:\"ilimagemapeditorgui\";i:95;s:13:\"ilmdeditorgui\";i:96;s:19:\"ilimagemapeditorgui\";i:97;s:13:\"ilmdeditorgui\";i:98;s:19:\"ilimagemapeditorgui\";i:99;s:13:\"ilmdeditorgui\";i:100;s:19:\"ilimagemapeditorgui\";i:101;s:13:\"ilmdeditorgui\";i:102;s:19:\"ilimagemapeditorgui\";i:103;s:13:\"ilmdeditorgui\";i:104;s:19:\"ilimagemapeditorgui\";i:105;s:13:\"ilmdeditorgui\";i:106;s:19:\"ilimagemapeditorgui\";i:107;s:13:\"ilmdeditorgui\";i:108;s:19:\"ilimagemapeditorgui\";i:109;s:13:\"ilmdeditorgui\";i:110;s:19:\"ilimagemapeditorgui\";i:111;s:13:\"ilmdeditorgui\";i:112;s:19:\"ilimagemapeditorgui\";i:113;s:13:\"ilmdeditorgui\";i:114;s:19:\"ilimagemapeditorgui\";i:115;s:13:\"ilmdeditorgui\";i:116;s:19:\"ilimagemapeditorgui\";i:117;s:13:\"ilmdeditorgui\";}s:18:\"ileditclipboardgui\";a:20:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:19:\"ilobjmediaobjectgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:19:\"ilobjmediaobjectgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:19:\"ilobjmediaobjectgui\";i:17;s:19:\"ilobjmediaobjectgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:19:\"ilobjmediaobjectgui\";}s:21:\"ilpcimagemapeditorgui\";a:19:{i:0;s:17:\"ilinternallinkgui\";i:1;s:17:\"ilinternallinkgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:17:\"ilinternallinkgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:17:\"ilinternallinkgui\";i:6;s:17:\"ilinternallinkgui\";i:7;s:17:\"ilinternallinkgui\";i:8;s:17:\"ilinternallinkgui\";i:9;s:17:\"ilinternallinkgui\";i:10;s:17:\"ilinternallinkgui\";i:11;s:17:\"ilinternallinkgui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:17:\"ilinternallinkgui\";i:14;s:17:\"ilinternallinkgui\";i:15;s:17:\"ilinternallinkgui\";i:16;s:17:\"ilinternallinkgui\";i:17;s:17:\"ilinternallinkgui\";i:18;s:17:\"ilinternallinkgui\";}s:18:\"ilpcmediaobjectgui\";a:38:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:21:\"ilpcimagemapeditorgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:21:\"ilpcimagemapeditorgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:21:\"ilpcimagemapeditorgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:21:\"ilpcimagemapeditorgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:21:\"ilpcimagemapeditorgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:21:\"ilpcimagemapeditorgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:21:\"ilpcimagemapeditorgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:21:\"ilpcimagemapeditorgui\";i:16;s:19:\"ilobjmediaobjectgui\";i:17;s:21:\"ilpcimagemapeditorgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:21:\"ilpcimagemapeditorgui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:21:\"ilpcimagemapeditorgui\";i:22;s:19:\"ilobjmediaobjectgui\";i:23;s:21:\"ilpcimagemapeditorgui\";i:24;s:19:\"ilobjmediaobjectgui\";i:25;s:21:\"ilpcimagemapeditorgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:21:\"ilpcimagemapeditorgui\";i:28;s:19:\"ilobjmediaobjectgui\";i:29;s:21:\"ilpcimagemapeditorgui\";i:30;s:19:\"ilobjmediaobjectgui\";i:31;s:21:\"ilpcimagemapeditorgui\";i:32;s:19:\"ilobjmediaobjectgui\";i:33;s:21:\"ilpcimagemapeditorgui\";i:34;s:19:\"ilobjmediaobjectgui\";i:35;s:21:\"ilpcimagemapeditorgui\";i:36;s:19:\"ilobjmediaobjectgui\";i:37;s:21:\"ilpcimagemapeditorgui\";}s:15:\"ilpageeditorgui\";a:342:{i:0;s:17:\"ilinternallinkgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:16:\"ilpcdatatablegui\";i:3;s:15:\"ilpcfileitemgui\";i:4;s:15:\"ilpcfilelistgui\";i:5;s:11:\"ilpclistgui\";i:6;s:15:\"ilpclistitemgui\";i:7;s:10:\"ilpcmapgui\";i:8;s:18:\"ilpcmediaobjectgui\";i:9;s:16:\"ilpcparagraphgui\";i:10;s:14:\"ilpcpluggedgui\";i:11;s:15:\"ilpcquestiongui\";i:12;s:16:\"ilpcresourcesgui\";i:13;s:14:\"ilpcsectiongui\";i:14;s:17:\"ilpcsourcecodegui\";i:15;s:16:\"ilpctabledatagui\";i:16;s:12:\"ilpctablegui\";i:17;s:11:\"ilpctabsgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:16:\"ilpcdatatablegui\";i:21;s:15:\"ilpcfileitemgui\";i:22;s:15:\"ilpcfilelistgui\";i:23;s:11:\"ilpclistgui\";i:24;s:15:\"ilpclistitemgui\";i:25;s:10:\"ilpcmapgui\";i:26;s:18:\"ilpcmediaobjectgui\";i:27;s:16:\"ilpcparagraphgui\";i:28;s:14:\"ilpcpluggedgui\";i:29;s:15:\"ilpcquestiongui\";i:30;s:16:\"ilpcresourcesgui\";i:31;s:14:\"ilpcsectiongui\";i:32;s:17:\"ilpcsourcecodegui\";i:33;s:16:\"ilpctabledatagui\";i:34;s:12:\"ilpctablegui\";i:35;s:11:\"ilpctabsgui\";i:36;s:17:\"ilinternallinkgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:16:\"ilpcdatatablegui\";i:39;s:15:\"ilpcfileitemgui\";i:40;s:15:\"ilpcfilelistgui\";i:41;s:11:\"ilpclistgui\";i:42;s:15:\"ilpclistitemgui\";i:43;s:10:\"ilpcmapgui\";i:44;s:18:\"ilpcmediaobjectgui\";i:45;s:16:\"ilpcparagraphgui\";i:46;s:14:\"ilpcpluggedgui\";i:47;s:15:\"ilpcquestiongui\";i:48;s:16:\"ilpcresourcesgui\";i:49;s:14:\"ilpcsectiongui\";i:50;s:17:\"ilpcsourcecodegui\";i:51;s:16:\"ilpctabledatagui\";i:52;s:12:\"ilpctablegui\";i:53;s:11:\"ilpctabsgui\";i:54;s:17:\"ilinternallinkgui\";i:55;s:19:\"ilobjmediaobjectgui\";i:56;s:16:\"ilpcdatatablegui\";i:57;s:15:\"ilpcfileitemgui\";i:58;s:15:\"ilpcfilelistgui\";i:59;s:11:\"ilpclistgui\";i:60;s:15:\"ilpclistitemgui\";i:61;s:10:\"ilpcmapgui\";i:62;s:18:\"ilpcmediaobjectgui\";i:63;s:16:\"ilpcparagraphgui\";i:64;s:14:\"ilpcpluggedgui\";i:65;s:15:\"ilpcquestiongui\";i:66;s:16:\"ilpcresourcesgui\";i:67;s:14:\"ilpcsectiongui\";i:68;s:17:\"ilpcsourcecodegui\";i:69;s:16:\"ilpctabledatagui\";i:70;s:12:\"ilpctablegui\";i:71;s:11:\"ilpctabsgui\";i:72;s:17:\"ilinternallinkgui\";i:73;s:19:\"ilobjmediaobjectgui\";i:74;s:16:\"ilpcdatatablegui\";i:75;s:15:\"ilpcfileitemgui\";i:76;s:15:\"ilpcfilelistgui\";i:77;s:11:\"ilpclistgui\";i:78;s:15:\"ilpclistitemgui\";i:79;s:10:\"ilpcmapgui\";i:80;s:18:\"ilpcmediaobjectgui\";i:81;s:16:\"ilpcparagraphgui\";i:82;s:14:\"ilpcpluggedgui\";i:83;s:15:\"ilpcquestiongui\";i:84;s:16:\"ilpcresourcesgui\";i:85;s:14:\"ilpcsectiongui\";i:86;s:17:\"ilpcsourcecodegui\";i:87;s:16:\"ilpctabledatagui\";i:88;s:12:\"ilpctablegui\";i:89;s:11:\"ilpctabsgui\";i:90;s:17:\"ilinternallinkgui\";i:91;s:19:\"ilobjmediaobjectgui\";i:92;s:16:\"ilpcdatatablegui\";i:93;s:15:\"ilpcfileitemgui\";i:94;s:15:\"ilpcfilelistgui\";i:95;s:11:\"ilpclistgui\";i:96;s:15:\"ilpclistitemgui\";i:97;s:10:\"ilpcmapgui\";i:98;s:18:\"ilpcmediaobjectgui\";i:99;s:16:\"ilpcparagraphgui\";i:100;s:14:\"ilpcpluggedgui\";i:101;s:15:\"ilpcquestiongui\";i:102;s:16:\"ilpcresourcesgui\";i:103;s:14:\"ilpcsectiongui\";i:104;s:17:\"ilpcsourcecodegui\";i:105;s:16:\"ilpctabledatagui\";i:106;s:12:\"ilpctablegui\";i:107;s:11:\"ilpctabsgui\";i:108;s:17:\"ilinternallinkgui\";i:109;s:19:\"ilobjmediaobjectgui\";i:110;s:16:\"ilpcdatatablegui\";i:111;s:15:\"ilpcfileitemgui\";i:112;s:15:\"ilpcfilelistgui\";i:113;s:11:\"ilpclistgui\";i:114;s:15:\"ilpclistitemgui\";i:115;s:10:\"ilpcmapgui\";i:116;s:18:\"ilpcmediaobjectgui\";i:117;s:16:\"ilpcparagraphgui\";i:118;s:14:\"ilpcpluggedgui\";i:119;s:15:\"ilpcquestiongui\";i:120;s:16:\"ilpcresourcesgui\";i:121;s:14:\"ilpcsectiongui\";i:122;s:17:\"ilpcsourcecodegui\";i:123;s:16:\"ilpctabledatagui\";i:124;s:12:\"ilpctablegui\";i:125;s:11:\"ilpctabsgui\";i:126;s:17:\"ilinternallinkgui\";i:127;s:19:\"ilobjmediaobjectgui\";i:128;s:16:\"ilpcdatatablegui\";i:129;s:15:\"ilpcfileitemgui\";i:130;s:15:\"ilpcfilelistgui\";i:131;s:11:\"ilpclistgui\";i:132;s:15:\"ilpclistitemgui\";i:133;s:10:\"ilpcmapgui\";i:134;s:18:\"ilpcmediaobjectgui\";i:135;s:16:\"ilpcparagraphgui\";i:136;s:14:\"ilpcpluggedgui\";i:137;s:15:\"ilpcquestiongui\";i:138;s:16:\"ilpcresourcesgui\";i:139;s:14:\"ilpcsectiongui\";i:140;s:17:\"ilpcsourcecodegui\";i:141;s:16:\"ilpctabledatagui\";i:142;s:12:\"ilpctablegui\";i:143;s:11:\"ilpctabsgui\";i:144;s:17:\"ilinternallinkgui\";i:145;s:19:\"ilobjmediaobjectgui\";i:146;s:16:\"ilpcdatatablegui\";i:147;s:15:\"ilpcfileitemgui\";i:148;s:15:\"ilpcfilelistgui\";i:149;s:11:\"ilpclistgui\";i:150;s:15:\"ilpclistitemgui\";i:151;s:10:\"ilpcmapgui\";i:152;s:18:\"ilpcmediaobjectgui\";i:153;s:16:\"ilpcparagraphgui\";i:154;s:14:\"ilpcpluggedgui\";i:155;s:15:\"ilpcquestiongui\";i:156;s:16:\"ilpcresourcesgui\";i:157;s:14:\"ilpcsectiongui\";i:158;s:17:\"ilpcsourcecodegui\";i:159;s:16:\"ilpctabledatagui\";i:160;s:12:\"ilpctablegui\";i:161;s:11:\"ilpctabsgui\";i:162;s:17:\"ilinternallinkgui\";i:163;s:19:\"ilobjmediaobjectgui\";i:164;s:16:\"ilpcdatatablegui\";i:165;s:15:\"ilpcfileitemgui\";i:166;s:15:\"ilpcfilelistgui\";i:167;s:11:\"ilpclistgui\";i:168;s:15:\"ilpclistitemgui\";i:169;s:10:\"ilpcmapgui\";i:170;s:18:\"ilpcmediaobjectgui\";i:171;s:16:\"ilpcparagraphgui\";i:172;s:14:\"ilpcpluggedgui\";i:173;s:15:\"ilpcquestiongui\";i:174;s:16:\"ilpcresourcesgui\";i:175;s:14:\"ilpcsectiongui\";i:176;s:17:\"ilpcsourcecodegui\";i:177;s:16:\"ilpctabledatagui\";i:178;s:12:\"ilpctablegui\";i:179;s:11:\"ilpctabsgui\";i:180;s:17:\"ilinternallinkgui\";i:181;s:19:\"ilobjmediaobjectgui\";i:182;s:16:\"ilpcdatatablegui\";i:183;s:15:\"ilpcfileitemgui\";i:184;s:15:\"ilpcfilelistgui\";i:185;s:11:\"ilpclistgui\";i:186;s:15:\"ilpclistitemgui\";i:187;s:10:\"ilpcmapgui\";i:188;s:18:\"ilpcmediaobjectgui\";i:189;s:16:\"ilpcparagraphgui\";i:190;s:14:\"ilpcpluggedgui\";i:191;s:15:\"ilpcquestiongui\";i:192;s:16:\"ilpcresourcesgui\";i:193;s:14:\"ilpcsectiongui\";i:194;s:17:\"ilpcsourcecodegui\";i:195;s:16:\"ilpctabledatagui\";i:196;s:12:\"ilpctablegui\";i:197;s:11:\"ilpctabsgui\";i:198;s:17:\"ilinternallinkgui\";i:199;s:19:\"ilobjmediaobjectgui\";i:200;s:16:\"ilpcdatatablegui\";i:201;s:15:\"ilpcfileitemgui\";i:202;s:15:\"ilpcfilelistgui\";i:203;s:11:\"ilpclistgui\";i:204;s:15:\"ilpclistitemgui\";i:205;s:10:\"ilpcmapgui\";i:206;s:18:\"ilpcmediaobjectgui\";i:207;s:16:\"ilpcparagraphgui\";i:208;s:14:\"ilpcpluggedgui\";i:209;s:15:\"ilpcquestiongui\";i:210;s:16:\"ilpcresourcesgui\";i:211;s:14:\"ilpcsectiongui\";i:212;s:17:\"ilpcsourcecodegui\";i:213;s:16:\"ilpctabledatagui\";i:214;s:12:\"ilpctablegui\";i:215;s:11:\"ilpctabsgui\";i:216;s:17:\"ilinternallinkgui\";i:217;s:19:\"ilobjmediaobjectgui\";i:218;s:16:\"ilpcdatatablegui\";i:219;s:15:\"ilpcfileitemgui\";i:220;s:15:\"ilpcfilelistgui\";i:221;s:11:\"ilpclistgui\";i:222;s:15:\"ilpclistitemgui\";i:223;s:10:\"ilpcmapgui\";i:224;s:18:\"ilpcmediaobjectgui\";i:225;s:16:\"ilpcparagraphgui\";i:226;s:14:\"ilpcpluggedgui\";i:227;s:15:\"ilpcquestiongui\";i:228;s:16:\"ilpcresourcesgui\";i:229;s:14:\"ilpcsectiongui\";i:230;s:17:\"ilpcsourcecodegui\";i:231;s:16:\"ilpctabledatagui\";i:232;s:12:\"ilpctablegui\";i:233;s:11:\"ilpctabsgui\";i:234;s:17:\"ilinternallinkgui\";i:235;s:19:\"ilobjmediaobjectgui\";i:236;s:16:\"ilpcdatatablegui\";i:237;s:15:\"ilpcfileitemgui\";i:238;s:15:\"ilpcfilelistgui\";i:239;s:11:\"ilpclistgui\";i:240;s:15:\"ilpclistitemgui\";i:241;s:10:\"ilpcmapgui\";i:242;s:18:\"ilpcmediaobjectgui\";i:243;s:16:\"ilpcparagraphgui\";i:244;s:14:\"ilpcpluggedgui\";i:245;s:15:\"ilpcquestiongui\";i:246;s:16:\"ilpcresourcesgui\";i:247;s:14:\"ilpcsectiongui\";i:248;s:17:\"ilpcsourcecodegui\";i:249;s:16:\"ilpctabledatagui\";i:250;s:12:\"ilpctablegui\";i:251;s:11:\"ilpctabsgui\";i:252;s:17:\"ilinternallinkgui\";i:253;s:19:\"ilobjmediaobjectgui\";i:254;s:16:\"ilpcdatatablegui\";i:255;s:15:\"ilpcfileitemgui\";i:256;s:15:\"ilpcfilelistgui\";i:257;s:11:\"ilpclistgui\";i:258;s:15:\"ilpclistitemgui\";i:259;s:10:\"ilpcmapgui\";i:260;s:18:\"ilpcmediaobjectgui\";i:261;s:16:\"ilpcparagraphgui\";i:262;s:14:\"ilpcpluggedgui\";i:263;s:15:\"ilpcquestiongui\";i:264;s:16:\"ilpcresourcesgui\";i:265;s:14:\"ilpcsectiongui\";i:266;s:17:\"ilpcsourcecodegui\";i:267;s:16:\"ilpctabledatagui\";i:268;s:12:\"ilpctablegui\";i:269;s:11:\"ilpctabsgui\";i:270;s:17:\"ilinternallinkgui\";i:271;s:19:\"ilobjmediaobjectgui\";i:272;s:16:\"ilpcdatatablegui\";i:273;s:15:\"ilpcfileitemgui\";i:274;s:15:\"ilpcfilelistgui\";i:275;s:11:\"ilpclistgui\";i:276;s:15:\"ilpclistitemgui\";i:277;s:10:\"ilpcmapgui\";i:278;s:18:\"ilpcmediaobjectgui\";i:279;s:16:\"ilpcparagraphgui\";i:280;s:14:\"ilpcpluggedgui\";i:281;s:15:\"ilpcquestiongui\";i:282;s:16:\"ilpcresourcesgui\";i:283;s:14:\"ilpcsectiongui\";i:284;s:17:\"ilpcsourcecodegui\";i:285;s:16:\"ilpctabledatagui\";i:286;s:12:\"ilpctablegui\";i:287;s:11:\"ilpctabsgui\";i:288;s:17:\"ilinternallinkgui\";i:289;s:19:\"ilobjmediaobjectgui\";i:290;s:16:\"ilpcdatatablegui\";i:291;s:15:\"ilpcfileitemgui\";i:292;s:15:\"ilpcfilelistgui\";i:293;s:11:\"ilpclistgui\";i:294;s:15:\"ilpclistitemgui\";i:295;s:10:\"ilpcmapgui\";i:296;s:18:\"ilpcmediaobjectgui\";i:297;s:16:\"ilpcparagraphgui\";i:298;s:14:\"ilpcpluggedgui\";i:299;s:15:\"ilpcquestiongui\";i:300;s:16:\"ilpcresourcesgui\";i:301;s:14:\"ilpcsectiongui\";i:302;s:17:\"ilpcsourcecodegui\";i:303;s:16:\"ilpctabledatagui\";i:304;s:12:\"ilpctablegui\";i:305;s:11:\"ilpctabsgui\";i:306;s:17:\"ilinternallinkgui\";i:307;s:19:\"ilobjmediaobjectgui\";i:308;s:16:\"ilpcdatatablegui\";i:309;s:15:\"ilpcfileitemgui\";i:310;s:15:\"ilpcfilelistgui\";i:311;s:11:\"ilpclistgui\";i:312;s:15:\"ilpclistitemgui\";i:313;s:10:\"ilpcmapgui\";i:314;s:18:\"ilpcmediaobjectgui\";i:315;s:16:\"ilpcparagraphgui\";i:316;s:14:\"ilpcpluggedgui\";i:317;s:15:\"ilpcquestiongui\";i:318;s:16:\"ilpcresourcesgui\";i:319;s:14:\"ilpcsectiongui\";i:320;s:17:\"ilpcsourcecodegui\";i:321;s:16:\"ilpctabledatagui\";i:322;s:12:\"ilpctablegui\";i:323;s:11:\"ilpctabsgui\";i:324;s:17:\"ilinternallinkgui\";i:325;s:19:\"ilobjmediaobjectgui\";i:326;s:16:\"ilpcdatatablegui\";i:327;s:15:\"ilpcfileitemgui\";i:328;s:15:\"ilpcfilelistgui\";i:329;s:11:\"ilpclistgui\";i:330;s:15:\"ilpclistitemgui\";i:331;s:10:\"ilpcmapgui\";i:332;s:18:\"ilpcmediaobjectgui\";i:333;s:16:\"ilpcparagraphgui\";i:334;s:14:\"ilpcpluggedgui\";i:335;s:15:\"ilpcquestiongui\";i:336;s:16:\"ilpcresourcesgui\";i:337;s:14:\"ilpcsectiongui\";i:338;s:17:\"ilpcsourcecodegui\";i:339;s:16:\"ilpctabledatagui\";i:340;s:12:\"ilpctablegui\";i:341;s:11:\"ilpctabsgui\";}s:15:\"ilpageobjectgui\";a:72:{i:0;s:18:\"ileditclipboardgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:18:\"ileditclipboardgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:22:\"ilpublicuserprofilegui\";i:8;s:18:\"ileditclipboardgui\";i:9;s:13:\"ilmdeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:13:\"ilmdeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:18:\"ileditclipboardgui\";i:17;s:13:\"ilmdeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:22:\"ilpublicuserprofilegui\";i:20;s:18:\"ileditclipboardgui\";i:21;s:13:\"ilmdeditorgui\";i:22;s:15:\"ilpageeditorgui\";i:23;s:22:\"ilpublicuserprofilegui\";i:24;s:18:\"ileditclipboardgui\";i:25;s:13:\"ilmdeditorgui\";i:26;s:15:\"ilpageeditorgui\";i:27;s:22:\"ilpublicuserprofilegui\";i:28;s:18:\"ileditclipboardgui\";i:29;s:13:\"ilmdeditorgui\";i:30;s:15:\"ilpageeditorgui\";i:31;s:22:\"ilpublicuserprofilegui\";i:32;s:18:\"ileditclipboardgui\";i:33;s:13:\"ilmdeditorgui\";i:34;s:15:\"ilpageeditorgui\";i:35;s:22:\"ilpublicuserprofilegui\";i:36;s:18:\"ileditclipboardgui\";i:37;s:13:\"ilmdeditorgui\";i:38;s:15:\"ilpageeditorgui\";i:39;s:22:\"ilpublicuserprofilegui\";i:40;s:18:\"ileditclipboardgui\";i:41;s:13:\"ilmdeditorgui\";i:42;s:15:\"ilpageeditorgui\";i:43;s:22:\"ilpublicuserprofilegui\";i:44;s:18:\"ileditclipboardgui\";i:45;s:13:\"ilmdeditorgui\";i:46;s:15:\"ilpageeditorgui\";i:47;s:22:\"ilpublicuserprofilegui\";i:48;s:18:\"ileditclipboardgui\";i:49;s:13:\"ilmdeditorgui\";i:50;s:15:\"ilpageeditorgui\";i:51;s:22:\"ilpublicuserprofilegui\";i:52;s:18:\"ileditclipboardgui\";i:53;s:13:\"ilmdeditorgui\";i:54;s:15:\"ilpageeditorgui\";i:55;s:22:\"ilpublicuserprofilegui\";i:56;s:18:\"ileditclipboardgui\";i:57;s:13:\"ilmdeditorgui\";i:58;s:15:\"ilpageeditorgui\";i:59;s:22:\"ilpublicuserprofilegui\";i:60;s:18:\"ileditclipboardgui\";i:61;s:13:\"ilmdeditorgui\";i:62;s:15:\"ilpageeditorgui\";i:63;s:22:\"ilpublicuserprofilegui\";i:64;s:18:\"ileditclipboardgui\";i:65;s:13:\"ilmdeditorgui\";i:66;s:15:\"ilpageeditorgui\";i:67;s:22:\"ilpublicuserprofilegui\";i:68;s:18:\"ileditclipboardgui\";i:69;s:13:\"ilmdeditorgui\";i:70;s:15:\"ilpageeditorgui\";i:71;s:22:\"ilpublicuserprofilegui\";}s:16:\"ilobjcategorygui\";a:7:{i:0;s:11:\"ilcolumngui\";i:1;s:22:\"ilcontainerlinklistgui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:18:\"ilobjuserfoldergui\";i:4;s:12:\"ilobjusergui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpermissiongui\";}s:25:\"ilobjcategoryreferencegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:12:\"ilobjchatgui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";i:2;s:22:\"ilpublicuserprofilegui\";}s:20:\"ilcourseagreementgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:32:\"ilcourseobjectivepresentationgui\";a:5:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";}s:18:\"ilcoursecontentgui\";a:15:{i:0;s:11:\"ilcolumngui\";i:1;s:19:\"ilcoursearchivesgui\";i:2;s:32:\"ilcourseobjectivepresentationgui\";i:3;s:11:\"ilcolumngui\";i:4;s:19:\"ilcoursearchivesgui\";i:5;s:32:\"ilcourseobjectivepresentationgui\";i:6;s:11:\"ilcolumngui\";i:7;s:19:\"ilcoursearchivesgui\";i:8;s:32:\"ilcourseobjectivepresentationgui\";i:9;s:11:\"ilcolumngui\";i:10;s:19:\"ilcoursearchivesgui\";i:11;s:32:\"ilcourseobjectivepresentationgui\";i:12;s:11:\"ilcolumngui\";i:13;s:19:\"ilcoursearchivesgui\";i:14;s:32:\"ilcourseobjectivepresentationgui\";}s:29:\"ilcourseitemadministrationgui\";a:5:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:27:\"ilconditionhandlerinterface\";i:4;s:27:\"ilconditionhandlerinterface\";}s:23:\"ilcourseregistrationgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:17:\"ilmemberexportgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:17:\"ilshoppurchasegui\";a:5:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";}s:14:\"ilobjcoursegui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:20:\"ilcourseagreementgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:29:\"ilcourseitemadministrationgui\";i:5;s:21:\"ilcourseobjectivesgui\";i:6;s:23:\"ilcourseregistrationgui\";i:7;s:21:\"ilcourseuserfieldsgui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:21:\"illearningprogressgui\";i:10;s:13:\"ilmdeditorgui\";i:11;s:17:\"ilmemberexportgui\";i:12;s:22:\"ilobjcoursegroupinggui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpermissiongui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:21:\"ilrepositorysearchgui\";i:17;s:20:\"ilsessionoverviewgui\";i:18;s:17:\"ilshoppurchasegui\";i:19;s:11:\"ilcolumngui\";i:20;s:27:\"ilconditionhandlerinterface\";i:21;s:20:\"ilcourseagreementgui\";i:22;s:18:\"ilcoursecontentgui\";i:23;s:29:\"ilcourseitemadministrationgui\";i:24;s:21:\"ilcourseobjectivesgui\";i:25;s:23:\"ilcourseregistrationgui\";i:26;s:21:\"ilcourseuserfieldsgui\";i:27;s:15:\"ilinfoscreengui\";i:28;s:21:\"illearningprogressgui\";i:29;s:13:\"ilmdeditorgui\";i:30;s:17:\"ilmemberexportgui\";i:31;s:22:\"ilobjcoursegroupinggui\";i:32;s:15:\"ilpageobjectgui\";i:33;s:15:\"ilpermissiongui\";i:34;s:22:\"ilpublicuserprofilegui\";i:35;s:21:\"ilrepositorysearchgui\";i:36;s:20:\"ilsessionoverviewgui\";i:37;s:17:\"ilshoppurchasegui\";}s:23:\"ilobjcoursereferencegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:20:\"ilstructureobjectgui\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:13:\"ilmdeditorgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:13:\"ilmdeditorgui\";}s:14:\"ilobjdlbookgui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:17:\"illmpageobjectgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:18:\"ilobjstylesheetgui\";i:5;s:15:\"ilpermissiongui\";i:6;s:20:\"ilstructureobjectgui\";}s:16:\"ilobjexercisegui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilrepositorysearchgui\";}s:20:\"ilobjexternalfeedgui\";a:2:{i:0;s:22:\"ilexternalfeedblockgui\";i:1;s:15:\"ilpermissiongui\";}s:19:\"ilobjfilebasedlmgui\";a:6:{i:0;s:15:\"ilfilesystemgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:21:\"illearningprogressgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:17:\"ilshoppurchasegui\";}s:12:\"ilobjfilegui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:17:\"ilshoppurchasegui\";}s:14:\"ilobjfoldergui\";a:16:{i:0;s:11:\"ilcolumngui\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:29:\"ilcourseitemadministrationgui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:21:\"illearningprogressgui\";i:6;s:15:\"ilpageobjectgui\";i:7;s:15:\"ilpermissiongui\";i:8;s:11:\"ilcolumngui\";i:9;s:27:\"ilconditionhandlerinterface\";i:10;s:18:\"ilcoursecontentgui\";i:11;s:29:\"ilcourseitemadministrationgui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:21:\"illearningprogressgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:15:\"ilpermissiongui\";}s:13:\"ilobjforumgui\";a:5:{i:0;s:11:\"ilcolumngui\";i:1;s:16:\"ilforumexportgui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilpermissiongui\";i:4;s:22:\"ilpublicuserprofilegui\";}s:25:\"iltermdefinitioneditorgui\";a:2:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpageobjectgui\";}s:17:\"ilglossarytermgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:25:\"iltermdefinitioneditorgui\";}s:16:\"ilobjglossarygui\";a:4:{i:0;s:17:\"ilglossarytermgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:15:\"ilpermissiongui\";}s:13:\"ilobjgroupgui\";a:13:{i:0;s:0:\"\";i:1;s:11:\"ilcolumngui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:29:\"ilcourseitemadministrationgui\";i:5;s:22:\"ilgroupregistrationgui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:21:\"illearningprogressgui\";i:8;s:22:\"ilobjcoursegroupinggui\";i:9;s:15:\"ilpageobjectgui\";i:10;s:15:\"ilpermissiongui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:21:\"ilrepositorysearchgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:19:\"ilobjilinccoursegui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:22:\"ilobjilincclassroomgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:21:\"ilrepositorysearchgui\";}s:22:\"ilobjlearningmodulegui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:17:\"illmpageobjectgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:18:\"ilobjstylesheetgui\";i:5;s:15:\"ilpermissiongui\";i:6;s:20:\"ilstructureobjectgui\";}s:20:\"ilobjlinkresourcegui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:17:\"ilobjmediacastgui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:17:\"ilobjmediapoolgui\";a:5:{i:0;s:18:\"ileditclipboardgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:14:\"ilobjfoldergui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:15:\"ilpermissiongui\";}s:20:\"ilobjquestionpoolgui\";a:14:{i:0;s:15:\"assclozetestgui\";i:1;s:22:\"assimagemapquestiongui\";i:2;s:16:\"assjavaappletgui\";i:3;s:22:\"assmatchingquestiongui\";i:4;s:20:\"assmultiplechoicegui\";i:5;s:13:\"assnumericgui\";i:6;s:22:\"assorderingquestiongui\";i:7;s:26:\"assquestiontypetemplategui\";i:8;s:18:\"asssinglechoicegui\";i:9;s:18:\"asstextquestiongui\";i:10;s:16:\"asstextsubsetgui\";i:11;s:13:\"ilmdeditorgui\";i:12;s:15:\"ilpageobjectgui\";i:13;s:15:\"ilpermissiongui\";}s:20:\"ilobjremotecoursegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:18:\"ilobjrootfoldergui\";a:4:{i:0;s:11:\"ilcolumngui\";i:1;s:22:\"ilcontainerlinklistgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpermissiongui\";}s:26:\"ilobjsahslearningmodulegui\";a:3:{i:0;s:15:\"ilfilesystemgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:15:\"ilobjsessiongui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:14:\"ilobjsurveygui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilsurveyevaluationgui\";i:4;s:20:\"ilsurveyexecutiongui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:8:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpermissiongui\";i:2;s:18:\"ilsurveyphrasesgui\";i:3;s:23:\"surveymatrixquestiongui\";i:4;s:23:\"surveymetricquestiongui\";i:5;s:24:\"surveynominalquestiongui\";i:6;s:24:\"surveyordinalquestiongui\";i:7;s:21:\"surveytextquestiongui\";}s:12:\"ilobjtestgui\";a:11:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:15:\"ilpermissiongui\";i:5;s:17:\"ilshoppurchasegui\";i:6;s:20:\"iltestcertificategui\";i:7;s:19:\"iltestevaluationgui\";i:8;s:15:\"iltestoutputgui\";i:9;s:16:\"iltestscoringgui\";i:10;s:16:\"iltestservicegui\";}s:13:\"ilwikipagegui\";a:7:{i:0;s:18:\"ileditclipboardgui\";i:1;s:25:\"ilmediapooltargetselector\";i:2;s:9:\"ilnotegui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:22:\"ilpublicuserprofilegui\";i:6;s:11:\"ilratinggui\";}s:12:\"ilobjwikigui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";i:2;s:22:\"ilpublicuserprofilegui\";i:3;s:13:\"ilwikipagegui\";}s:15:\"ilrepositorygui\";a:31:{i:0;s:21:\"ilcourseobjectivesgui\";i:1;s:16:\"ilobjcategorygui\";i:2;s:25:\"ilobjcategoryreferencegui\";i:3;s:12:\"ilobjchatgui\";i:4;s:14:\"ilobjcoursegui\";i:5;s:23:\"ilobjcoursereferencegui\";i:6;s:14:\"ilobjdlbookgui\";i:7;s:16:\"ilobjexercisegui\";i:8;s:20:\"ilobjexternalfeedgui\";i:9;s:19:\"ilobjfilebasedlmgui\";i:10;s:12:\"ilobjfilegui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:13:\"ilobjforumgui\";i:13;s:16:\"ilobjglossarygui\";i:14;s:13:\"ilobjgroupgui\";i:15;s:22:\"ilobjilincclassroomgui\";i:16;s:19:\"ilobjilinccoursegui\";i:17;s:22:\"ilobjlearningmodulegui\";i:18;s:20:\"ilobjlinkresourcegui\";i:19;s:17:\"ilobjmediacastgui\";i:20;s:17:\"ilobjmediapoolgui\";i:21;s:20:\"ilobjquestionpoolgui\";i:22;s:20:\"ilobjremotecoursegui\";i:23;s:12:\"ilobjrolegui\";i:24;s:18:\"ilobjrootfoldergui\";i:25;s:26:\"ilobjsahslearningmodulegui\";i:26;s:15:\"ilobjsessiongui\";i:27;s:14:\"ilobjsurveygui\";i:28;s:26:\"ilobjsurveyquestionpoolgui\";i:29;s:12:\"ilobjtestgui\";i:30;s:12:\"ilobjwikigui\";}}','a:145:{s:0:\"\";a:1911:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:11:\"ilcolumngui\";i:27;s:0:\"\";i:28;s:22:\"ilcontainerlinklistgui\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:11:\"ilcolumngui\";i:55;s:0:\"\";i:56;s:13:\"ilfeedbackgui\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:13:\"illpfiltergui\";i:62;s:0:\"\";i:63;s:17:\"ilpdfpresentation\";i:64;s:0:\"\";i:65;s:15:\"iluserfiltergui\";i:66;s:0:\"\";i:67;s:13:\"illpfiltergui\";i:68;s:0:\"\";i:69;s:17:\"ilpdfpresentation\";i:70;s:0:\"\";i:71;s:21:\"illplistofsettingsgui\";i:72;s:0:\"\";i:73;s:0:\"\";i:74;s:12:\"ilobjrolegui\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:13:\"illpfiltergui\";i:78;s:0:\"\";i:79;s:17:\"ilpdfpresentation\";i:80;s:0:\"\";i:81;s:15:\"iluserfiltergui\";i:82;s:0:\"\";i:83;s:13:\"illpfiltergui\";i:84;s:0:\"\";i:85;s:17:\"ilpdfpresentation\";i:86;s:0:\"\";i:87;s:21:\"illplistofsettingsgui\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:0:\"\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:0:\"\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:0:\"\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:12:\"ilobjrolegui\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:0:\"\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:0:\"\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:0:\"\";i:137;s:0:\"\";i:138;s:0:\"\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:11:\"ilcolumngui\";i:142;s:0:\"\";i:143;s:13:\"ilfeedbackgui\";i:144;s:0:\"\";i:145;s:0:\"\";i:146;s:0:\"\";i:147;s:12:\"ilobjrolegui\";i:148;s:0:\"\";i:149;s:0:\"\";i:150;s:0:\"\";i:151;s:0:\"\";i:152;s:0:\"\";i:153;s:0:\"\";i:154;s:0:\"\";i:155;s:0:\"\";i:156;s:0:\"\";i:157;s:0:\"\";i:158;s:0:\"\";i:159;s:0:\"\";i:160;s:0:\"\";i:161;s:0:\"\";i:162;s:0:\"\";i:163;s:0:\"\";i:164;s:0:\"\";i:165;s:0:\"\";i:166;s:0:\"\";i:167;s:0:\"\";i:168;s:0:\"\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:0:\"\";i:172;s:0:\"\";i:173;s:11:\"ilcolumngui\";i:174;s:0:\"\";i:175;s:13:\"ilfeedbackgui\";i:176;s:0:\"\";i:177;s:0:\"\";i:178;s:0:\"\";i:179;s:12:\"ilobjrolegui\";i:180;s:0:\"\";i:181;s:0:\"\";i:182;s:0:\"\";i:183;s:0:\"\";i:184;s:0:\"\";i:185;s:0:\"\";i:186;s:0:\"\";i:187;s:0:\"\";i:188;s:0:\"\";i:189;s:0:\"\";i:190;s:0:\"\";i:191;s:0:\"\";i:192;s:0:\"\";i:193;s:0:\"\";i:194;s:0:\"\";i:195;s:0:\"\";i:196;s:0:\"\";i:197;s:0:\"\";i:198;s:0:\"\";i:199;s:0:\"\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:11:\"ilcolumngui\";i:207;s:0:\"\";i:208;s:0:\"\";i:209;s:20:\"ilcourseagreementgui\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:0:\"\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:0:\"\";i:220;s:0:\"\";i:221;s:0:\"\";i:222;s:0:\"\";i:223;s:0:\"\";i:224;s:0:\"\";i:225;s:0:\"\";i:226;s:0:\"\";i:227;s:0:\"\";i:228;s:0:\"\";i:229;s:0:\"\";i:230;s:0:\"\";i:231;s:0:\"\";i:232;s:0:\"\";i:233;s:0:\"\";i:234;s:0:\"\";i:235;s:11:\"ilcolumngui\";i:236;s:0:\"\";i:237;s:0:\"\";i:238;s:32:\"ilcourseobjectivepresentationgui\";i:239;s:0:\"\";i:240;s:0:\"\";i:241;s:0:\"\";i:242;s:23:\"ilcourseregistrationgui\";i:243;s:0:\"\";i:244;s:0:\"\";i:245;s:0:\"\";i:246;s:0:\"\";i:247;s:0:\"\";i:248;s:0:\"\";i:249;s:0:\"\";i:250;s:0:\"\";i:251;s:0:\"\";i:252;s:0:\"\";i:253;s:0:\"\";i:254;s:0:\"\";i:255;s:0:\"\";i:256;s:0:\"\";i:257;s:0:\"\";i:258;s:0:\"\";i:259;s:0:\"\";i:260;s:0:\"\";i:261;s:0:\"\";i:262;s:0:\"\";i:263;s:0:\"\";i:264;s:0:\"\";i:265;s:0:\"\";i:266;s:0:\"\";i:267;s:0:\"\";i:268;s:0:\"\";i:269;s:11:\"ilcolumngui\";i:270;s:0:\"\";i:271;s:13:\"ilfeedbackgui\";i:272;s:0:\"\";i:273;s:0:\"\";i:274;s:0:\"\";i:275;s:0:\"\";i:276;s:13:\"illpfiltergui\";i:277;s:0:\"\";i:278;s:17:\"ilpdfpresentation\";i:279;s:0:\"\";i:280;s:15:\"iluserfiltergui\";i:281;s:0:\"\";i:282;s:13:\"illpfiltergui\";i:283;s:0:\"\";i:284;s:17:\"ilpdfpresentation\";i:285;s:0:\"\";i:286;s:21:\"illplistofsettingsgui\";i:287;s:0:\"\";i:288;s:0:\"\";i:289;s:17:\"ilmemberexportgui\";i:290;s:0:\"\";i:291;s:0:\"\";i:292;s:0:\"\";i:293;s:0:\"\";i:294;s:0:\"\";i:295;s:0:\"\";i:296;s:0:\"\";i:297;s:0:\"\";i:298;s:0:\"\";i:299;s:0:\"\";i:300;s:0:\"\";i:301;s:0:\"\";i:302;s:0:\"\";i:303;s:0:\"\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:0:\"\";i:307;s:0:\"\";i:308;s:0:\"\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:0:\"\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:0:\"\";i:317;s:12:\"ilobjrolegui\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:0:\"\";i:321;s:0:\"\";i:322;s:0:\"\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:0:\"\";i:327;s:0:\"\";i:328;s:0:\"\";i:329;s:0:\"\";i:330;s:0:\"\";i:331;s:0:\"\";i:332;s:0:\"\";i:333;s:0:\"\";i:334;s:0:\"\";i:335;s:0:\"\";i:336;s:0:\"\";i:337;s:0:\"\";i:338;s:0:\"\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:0:\"\";i:343;s:0:\"\";i:344;s:0:\"\";i:345;s:0:\"\";i:346;s:0:\"\";i:347;s:0:\"\";i:348;s:0:\"\";i:349;s:0:\"\";i:350;s:0:\"\";i:351;s:0:\"\";i:352;s:0:\"\";i:353;s:0:\"\";i:354;s:0:\"\";i:355;s:0:\"\";i:356;s:0:\"\";i:357;s:0:\"\";i:358;s:0:\"\";i:359;s:0:\"\";i:360;s:0:\"\";i:361;s:0:\"\";i:362;s:0:\"\";i:363;s:0:\"\";i:364;s:0:\"\";i:365;s:0:\"\";i:366;s:0:\"\";i:367;s:0:\"\";i:368;s:0:\"\";i:369;s:0:\"\";i:370;s:0:\"\";i:371;s:11:\"ilcolumngui\";i:372;s:0:\"\";i:373;s:13:\"ilfeedbackgui\";i:374;s:0:\"\";i:375;s:0:\"\";i:376;s:0:\"\";i:377;s:12:\"ilobjrolegui\";i:378;s:0:\"\";i:379;s:0:\"\";i:380;s:0:\"\";i:381;s:0:\"\";i:382;s:0:\"\";i:383;s:0:\"\";i:384;s:0:\"\";i:385;s:0:\"\";i:386;s:0:\"\";i:387;s:0:\"\";i:388;s:0:\"\";i:389;s:0:\"\";i:390;s:0:\"\";i:391;s:0:\"\";i:392;s:0:\"\";i:393;s:0:\"\";i:394;s:0:\"\";i:395;s:0:\"\";i:396;s:0:\"\";i:397;s:0:\"\";i:398;s:0:\"\";i:399;s:0:\"\";i:400;s:0:\"\";i:401;s:0:\"\";i:402;s:0:\"\";i:403;s:11:\"ilcolumngui\";i:404;s:0:\"\";i:405;s:13:\"ilfeedbackgui\";i:406;s:0:\"\";i:407;s:0:\"\";i:408;s:0:\"\";i:409;s:0:\"\";i:410;s:13:\"illpfiltergui\";i:411;s:0:\"\";i:412;s:17:\"ilpdfpresentation\";i:413;s:0:\"\";i:414;s:15:\"iluserfiltergui\";i:415;s:0:\"\";i:416;s:13:\"illpfiltergui\";i:417;s:0:\"\";i:418;s:17:\"ilpdfpresentation\";i:419;s:0:\"\";i:420;s:21:\"illplistofsettingsgui\";i:421;s:0:\"\";i:422;s:0:\"\";i:423;s:0:\"\";i:424;s:0:\"\";i:425;s:0:\"\";i:426;s:0:\"\";i:427;s:0:\"\";i:428;s:0:\"\";i:429;s:0:\"\";i:430;s:0:\"\";i:431;s:0:\"\";i:432;s:0:\"\";i:433;s:0:\"\";i:434;s:0:\"\";i:435;s:0:\"\";i:436;s:0:\"\";i:437;s:0:\"\";i:438;s:0:\"\";i:439;s:0:\"\";i:440;s:0:\"\";i:441;s:0:\"\";i:442;s:0:\"\";i:443;s:0:\"\";i:444;s:0:\"\";i:445;s:0:\"\";i:446;s:0:\"\";i:447;s:0:\"\";i:448;s:18:\"ilobjstylesheetgui\";i:449;s:0:\"\";i:450;s:12:\"ilobjrolegui\";i:451;s:0:\"\";i:452;s:0:\"\";i:453;s:0:\"\";i:454;s:0:\"\";i:455;s:0:\"\";i:456;s:0:\"\";i:457;s:0:\"\";i:458;s:0:\"\";i:459;s:0:\"\";i:460;s:0:\"\";i:461;s:0:\"\";i:462;s:0:\"\";i:463;s:0:\"\";i:464;s:0:\"\";i:465;s:0:\"\";i:466;s:0:\"\";i:467;s:0:\"\";i:468;s:0:\"\";i:469;s:0:\"\";i:470;s:0:\"\";i:471;s:0:\"\";i:472;s:0:\"\";i:473;s:0:\"\";i:474;s:0:\"\";i:475;s:0:\"\";i:476;s:0:\"\";i:477;s:0:\"\";i:478;s:11:\"ilcolumngui\";i:479;s:0:\"\";i:480;s:13:\"ilfeedbackgui\";i:481;s:0:\"\";i:482;s:0:\"\";i:483;s:0:\"\";i:484;s:0:\"\";i:485;s:13:\"illpfiltergui\";i:486;s:0:\"\";i:487;s:17:\"ilpdfpresentation\";i:488;s:0:\"\";i:489;s:15:\"iluserfiltergui\";i:490;s:0:\"\";i:491;s:13:\"illpfiltergui\";i:492;s:0:\"\";i:493;s:17:\"ilpdfpresentation\";i:494;s:0:\"\";i:495;s:21:\"illplistofsettingsgui\";i:496;s:0:\"\";i:497;s:12:\"ilobjrolegui\";i:498;s:0:\"\";i:499;s:0:\"\";i:500;s:0:\"\";i:501;s:12:\"ilobjrolegui\";i:502;s:0:\"\";i:503;s:0:\"\";i:504;s:0:\"\";i:505;s:0:\"\";i:506;s:0:\"\";i:507;s:0:\"\";i:508;s:0:\"\";i:509;s:0:\"\";i:510;s:0:\"\";i:511;s:0:\"\";i:512;s:0:\"\";i:513;s:0:\"\";i:514;s:0:\"\";i:515;s:0:\"\";i:516;s:0:\"\";i:517;s:0:\"\";i:518;s:0:\"\";i:519;s:0:\"\";i:520;s:0:\"\";i:521;s:0:\"\";i:522;s:0:\"\";i:523;s:0:\"\";i:524;s:0:\"\";i:525;s:0:\"\";i:526;s:0:\"\";i:527;s:0:\"\";i:528;s:11:\"ilcolumngui\";i:529;s:0:\"\";i:530;s:13:\"ilfeedbackgui\";i:531;s:0:\"\";i:532;s:0:\"\";i:533;s:0:\"\";i:534;s:0:\"\";i:535;s:13:\"illpfiltergui\";i:536;s:0:\"\";i:537;s:17:\"ilpdfpresentation\";i:538;s:0:\"\";i:539;s:15:\"iluserfiltergui\";i:540;s:0:\"\";i:541;s:13:\"illpfiltergui\";i:542;s:0:\"\";i:543;s:17:\"ilpdfpresentation\";i:544;s:0:\"\";i:545;s:21:\"illplistofsettingsgui\";i:546;s:0:\"\";i:547;s:0:\"\";i:548;s:12:\"ilobjrolegui\";i:549;s:0:\"\";i:550;s:0:\"\";i:551;s:0:\"\";i:552;s:0:\"\";i:553;s:0:\"\";i:554;s:0:\"\";i:555;s:0:\"\";i:556;s:0:\"\";i:557;s:0:\"\";i:558;s:0:\"\";i:559;s:0:\"\";i:560;s:0:\"\";i:561;s:0:\"\";i:562;s:0:\"\";i:563;s:0:\"\";i:564;s:0:\"\";i:565;s:0:\"\";i:566;s:0:\"\";i:567;s:0:\"\";i:568;s:0:\"\";i:569;s:0:\"\";i:570;s:0:\"\";i:571;s:0:\"\";i:572;s:0:\"\";i:573;s:0:\"\";i:574;s:0:\"\";i:575;s:0:\"\";i:576;s:0:\"\";i:577;s:0:\"\";i:578;s:0:\"\";i:579;s:0:\"\";i:580;s:0:\"\";i:581;s:0:\"\";i:582;s:0:\"\";i:583;s:0:\"\";i:584;s:0:\"\";i:585;s:0:\"\";i:586;s:0:\"\";i:587;s:0:\"\";i:588;s:0:\"\";i:589;s:0:\"\";i:590;s:0:\"\";i:591;s:0:\"\";i:592;s:0:\"\";i:593;s:0:\"\";i:594;s:0:\"\";i:595;s:0:\"\";i:596;s:0:\"\";i:597;s:0:\"\";i:598;s:0:\"\";i:599;s:11:\"ilcolumngui\";i:600;s:0:\"\";i:601;s:13:\"ilfeedbackgui\";i:602;s:0:\"\";i:603;s:0:\"\";i:604;s:0:\"\";i:605;s:0:\"\";i:606;s:12:\"ilobjrolegui\";i:607;s:0:\"\";i:608;s:0:\"\";i:609;s:0:\"\";i:610;s:0:\"\";i:611;s:0:\"\";i:612;s:0:\"\";i:613;s:0:\"\";i:614;s:0:\"\";i:615;s:0:\"\";i:616;s:0:\"\";i:617;s:0:\"\";i:618;s:0:\"\";i:619;s:0:\"\";i:620;s:0:\"\";i:621;s:0:\"\";i:622;s:0:\"\";i:623;s:0:\"\";i:624;s:0:\"\";i:625;s:0:\"\";i:626;s:0:\"\";i:627;s:0:\"\";i:628;s:0:\"\";i:629;s:0:\"\";i:630;s:0:\"\";i:631;s:0:\"\";i:632;s:0:\"\";i:633;s:0:\"\";i:634;s:0:\"\";i:635;s:0:\"\";i:636;s:0:\"\";i:637;s:0:\"\";i:638;s:0:\"\";i:639;s:0:\"\";i:640;s:0:\"\";i:641;s:0:\"\";i:642;s:0:\"\";i:643;s:0:\"\";i:644;s:0:\"\";i:645;s:0:\"\";i:646;s:0:\"\";i:647;s:0:\"\";i:648;s:0:\"\";i:649;s:0:\"\";i:650;s:0:\"\";i:651;s:0:\"\";i:652;s:0:\"\";i:653;s:0:\"\";i:654;s:0:\"\";i:655;s:0:\"\";i:656;s:0:\"\";i:657;s:11:\"ilcolumngui\";i:658;s:0:\"\";i:659;s:0:\"\";i:660;s:0:\"\";i:661;s:0:\"\";i:662;s:0:\"\";i:663;s:0:\"\";i:664;s:0:\"\";i:665;s:0:\"\";i:666;s:0:\"\";i:667;s:0:\"\";i:668;s:0:\"\";i:669;s:0:\"\";i:670;s:0:\"\";i:671;s:0:\"\";i:672;s:0:\"\";i:673;s:0:\"\";i:674;s:0:\"\";i:675;s:0:\"\";i:676;s:0:\"\";i:677;s:0:\"\";i:678;s:0:\"\";i:679;s:0:\"\";i:680;s:0:\"\";i:681;s:0:\"\";i:682;s:0:\"\";i:683;s:0:\"\";i:684;s:11:\"ilcolumngui\";i:685;s:0:\"\";i:686;s:0:\"\";i:687;s:32:\"ilcourseobjectivepresentationgui\";i:688;s:0:\"\";i:689;s:0:\"\";i:690;s:0:\"\";i:691;s:0:\"\";i:692;s:0:\"\";i:693;s:0:\"\";i:694;s:0:\"\";i:695;s:0:\"\";i:696;s:0:\"\";i:697;s:0:\"\";i:698;s:0:\"\";i:699;s:0:\"\";i:700;s:0:\"\";i:701;s:0:\"\";i:702;s:0:\"\";i:703;s:0:\"\";i:704;s:0:\"\";i:705;s:0:\"\";i:706;s:0:\"\";i:707;s:0:\"\";i:708;s:0:\"\";i:709;s:0:\"\";i:710;s:0:\"\";i:711;s:0:\"\";i:712;s:0:\"\";i:713;s:0:\"\";i:714;s:11:\"ilcolumngui\";i:715;s:0:\"\";i:716;s:13:\"ilfeedbackgui\";i:717;s:0:\"\";i:718;s:0:\"\";i:719;s:0:\"\";i:720;s:0:\"\";i:721;s:13:\"illpfiltergui\";i:722;s:0:\"\";i:723;s:17:\"ilpdfpresentation\";i:724;s:0:\"\";i:725;s:15:\"iluserfiltergui\";i:726;s:0:\"\";i:727;s:13:\"illpfiltergui\";i:728;s:0:\"\";i:729;s:17:\"ilpdfpresentation\";i:730;s:0:\"\";i:731;s:21:\"illplistofsettingsgui\";i:732;s:0:\"\";i:733;s:0:\"\";i:734;s:0:\"\";i:735;s:0:\"\";i:736;s:0:\"\";i:737;s:0:\"\";i:738;s:0:\"\";i:739;s:0:\"\";i:740;s:0:\"\";i:741;s:0:\"\";i:742;s:0:\"\";i:743;s:0:\"\";i:744;s:0:\"\";i:745;s:0:\"\";i:746;s:0:\"\";i:747;s:0:\"\";i:748;s:0:\"\";i:749;s:0:\"\";i:750;s:0:\"\";i:751;s:0:\"\";i:752;s:0:\"\";i:753;s:0:\"\";i:754;s:0:\"\";i:755;s:0:\"\";i:756;s:0:\"\";i:757;s:0:\"\";i:758;s:12:\"ilobjrolegui\";i:759;s:0:\"\";i:760;s:0:\"\";i:761;s:0:\"\";i:762;s:0:\"\";i:763;s:0:\"\";i:764;s:0:\"\";i:765;s:0:\"\";i:766;s:0:\"\";i:767;s:0:\"\";i:768;s:0:\"\";i:769;s:0:\"\";i:770;s:0:\"\";i:771;s:0:\"\";i:772;s:0:\"\";i:773;s:0:\"\";i:774;s:0:\"\";i:775;s:0:\"\";i:776;s:0:\"\";i:777;s:0:\"\";i:778;s:0:\"\";i:779;s:0:\"\";i:780;s:0:\"\";i:781;s:0:\"\";i:782;s:0:\"\";i:783;s:0:\"\";i:784;s:11:\"ilcolumngui\";i:785;s:0:\"\";i:786;s:0:\"\";i:787;s:0:\"\";i:788;s:0:\"\";i:789;s:0:\"\";i:790;s:0:\"\";i:791;s:0:\"\";i:792;s:0:\"\";i:793;s:0:\"\";i:794;s:0:\"\";i:795;s:0:\"\";i:796;s:0:\"\";i:797;s:0:\"\";i:798;s:0:\"\";i:799;s:0:\"\";i:800;s:0:\"\";i:801;s:0:\"\";i:802;s:0:\"\";i:803;s:0:\"\";i:804;s:0:\"\";i:805;s:0:\"\";i:806;s:0:\"\";i:807;s:0:\"\";i:808;s:0:\"\";i:809;s:0:\"\";i:810;s:0:\"\";i:811;s:11:\"ilcolumngui\";i:812;s:0:\"\";i:813;s:13:\"ilfeedbackgui\";i:814;s:0:\"\";i:815;s:0:\"\";i:816;s:0:\"\";i:817;s:12:\"ilobjrolegui\";i:818;s:0:\"\";i:819;s:0:\"\";i:820;s:0:\"\";i:821;s:0:\"\";i:822;s:0:\"\";i:823;s:0:\"\";i:824;s:0:\"\";i:825;s:0:\"\";i:826;s:0:\"\";i:827;s:0:\"\";i:828;s:0:\"\";i:829;s:0:\"\";i:830;s:0:\"\";i:831;s:0:\"\";i:832;s:0:\"\";i:833;s:0:\"\";i:834;s:0:\"\";i:835;s:0:\"\";i:836;s:0:\"\";i:837;s:0:\"\";i:838;s:0:\"\";i:839;s:0:\"\";i:840;s:0:\"\";i:841;s:0:\"\";i:842;s:0:\"\";i:843;s:0:\"\";i:844;s:0:\"\";i:845;s:0:\"\";i:846;s:0:\"\";i:847;s:0:\"\";i:848;s:0:\"\";i:849;s:0:\"\";i:850;s:0:\"\";i:851;s:0:\"\";i:852;s:0:\"\";i:853;s:0:\"\";i:854;s:0:\"\";i:855;s:0:\"\";i:856;s:0:\"\";i:857;s:0:\"\";i:858;s:0:\"\";i:859;s:0:\"\";i:860;s:0:\"\";i:861;s:0:\"\";i:862;s:0:\"\";i:863;s:0:\"\";i:864;s:0:\"\";i:865;s:0:\"\";i:866;s:0:\"\";i:867;s:0:\"\";i:868;s:0:\"\";i:869;s:0:\"\";i:870;s:0:\"\";i:871;s:0:\"\";i:872;s:0:\"\";i:873;s:0:\"\";i:874;s:0:\"\";i:875;s:0:\"\";i:876;s:0:\"\";i:877;s:0:\"\";i:878;s:0:\"\";i:879;s:0:\"\";i:880;s:0:\"\";i:881;s:0:\"\";i:882;s:0:\"\";i:883;s:0:\"\";i:884;s:0:\"\";i:885;s:0:\"\";i:886;s:0:\"\";i:887;s:0:\"\";i:888;s:0:\"\";i:889;s:0:\"\";i:890;s:0:\"\";i:891;s:0:\"\";i:892;s:0:\"\";i:893;s:0:\"\";i:894;s:0:\"\";i:895;s:11:\"ilcolumngui\";i:896;s:0:\"\";i:897;s:13:\"ilfeedbackgui\";i:898;s:0:\"\";i:899;s:0:\"\";i:900;s:0:\"\";i:901;s:0:\"\";i:902;s:12:\"ilobjrolegui\";i:903;s:0:\"\";i:904;s:0:\"\";i:905;s:0:\"\";i:906;s:0:\"\";i:907;s:0:\"\";i:908;s:0:\"\";i:909;s:0:\"\";i:910;s:0:\"\";i:911;s:0:\"\";i:912;s:0:\"\";i:913;s:0:\"\";i:914;s:0:\"\";i:915;s:0:\"\";i:916;s:0:\"\";i:917;s:0:\"\";i:918;s:0:\"\";i:919;s:0:\"\";i:920;s:0:\"\";i:921;s:0:\"\";i:922;s:0:\"\";i:923;s:0:\"\";i:924;s:0:\"\";i:925;s:0:\"\";i:926;s:0:\"\";i:927;s:0:\"\";i:928;s:0:\"\";i:929;s:11:\"ilcolumngui\";i:930;s:0:\"\";i:931;s:0:\"\";i:932;s:0:\"\";i:933;s:0:\"\";i:934;s:0:\"\";i:935;s:0:\"\";i:936;s:0:\"\";i:937;s:0:\"\";i:938;s:0:\"\";i:939;s:0:\"\";i:940;s:0:\"\";i:941;s:0:\"\";i:942;s:0:\"\";i:943;s:0:\"\";i:944;s:0:\"\";i:945;s:0:\"\";i:946;s:0:\"\";i:947;s:0:\"\";i:948;s:0:\"\";i:949;s:0:\"\";i:950;s:0:\"\";i:951;s:0:\"\";i:952;s:0:\"\";i:953;s:0:\"\";i:954;s:0:\"\";i:955;s:0:\"\";i:956;s:11:\"ilcolumngui\";i:957;s:0:\"\";i:958;s:0:\"\";i:959;s:32:\"ilcourseobjectivepresentationgui\";i:960;s:0:\"\";i:961;s:0:\"\";i:962;s:0:\"\";i:963;s:0:\"\";i:964;s:0:\"\";i:965;s:0:\"\";i:966;s:0:\"\";i:967;s:0:\"\";i:968;s:0:\"\";i:969;s:0:\"\";i:970;s:0:\"\";i:971;s:0:\"\";i:972;s:0:\"\";i:973;s:0:\"\";i:974;s:0:\"\";i:975;s:0:\"\";i:976;s:0:\"\";i:977;s:0:\"\";i:978;s:0:\"\";i:979;s:0:\"\";i:980;s:0:\"\";i:981;s:0:\"\";i:982;s:0:\"\";i:983;s:0:\"\";i:984;s:0:\"\";i:985;s:0:\"\";i:986;s:0:\"\";i:987;s:11:\"ilcolumngui\";i:988;s:0:\"\";i:989;s:13:\"ilfeedbackgui\";i:990;s:0:\"\";i:991;s:0:\"\";i:992;s:0:\"\";i:993;s:0:\"\";i:994;s:13:\"illpfiltergui\";i:995;s:0:\"\";i:996;s:17:\"ilpdfpresentation\";i:997;s:0:\"\";i:998;s:15:\"iluserfiltergui\";i:999;s:0:\"\";i:1000;s:13:\"illpfiltergui\";i:1001;s:0:\"\";i:1002;s:17:\"ilpdfpresentation\";i:1003;s:0:\"\";i:1004;s:21:\"illplistofsettingsgui\";i:1005;s:0:\"\";i:1006;s:0:\"\";i:1007;s:0:\"\";i:1008;s:0:\"\";i:1009;s:0:\"\";i:1010;s:0:\"\";i:1011;s:0:\"\";i:1012;s:0:\"\";i:1013;s:0:\"\";i:1014;s:0:\"\";i:1015;s:0:\"\";i:1016;s:0:\"\";i:1017;s:0:\"\";i:1018;s:0:\"\";i:1019;s:0:\"\";i:1020;s:0:\"\";i:1021;s:0:\"\";i:1022;s:0:\"\";i:1023;s:0:\"\";i:1024;s:0:\"\";i:1025;s:0:\"\";i:1026;s:0:\"\";i:1027;s:0:\"\";i:1028;s:0:\"\";i:1029;s:0:\"\";i:1030;s:0:\"\";i:1031;s:0:\"\";i:1032;s:12:\"ilobjrolegui\";i:1033;s:0:\"\";i:1034;s:0:\"\";i:1035;s:13:\"ilobjgroupgui\";i:1036;s:0:\"\";i:1037;s:22:\"ilobjilincclassroomgui\";i:1038;s:0:\"\";i:1039;s:0:\"\";i:1040;s:0:\"\";i:1041;s:0:\"\";i:1042;s:0:\"\";i:1043;s:0:\"\";i:1044;s:0:\"\";i:1045;s:0:\"\";i:1046;s:0:\"\";i:1047;s:0:\"\";i:1048;s:0:\"\";i:1049;s:0:\"\";i:1050;s:0:\"\";i:1051;s:0:\"\";i:1052;s:0:\"\";i:1053;s:0:\"\";i:1054;s:0:\"\";i:1055;s:0:\"\";i:1056;s:0:\"\";i:1057;s:0:\"\";i:1058;s:0:\"\";i:1059;s:0:\"\";i:1060;s:0:\"\";i:1061;s:0:\"\";i:1062;s:0:\"\";i:1063;s:11:\"ilcolumngui\";i:1064;s:0:\"\";i:1065;s:13:\"ilfeedbackgui\";i:1066;s:0:\"\";i:1067;s:0:\"\";i:1068;s:0:\"\";i:1069;s:22:\"ilobjilincclassroomgui\";i:1070;s:0:\"\";i:1071;s:12:\"ilobjrolegui\";i:1072;s:0:\"\";i:1073;s:0:\"\";i:1074;s:0:\"\";i:1075;s:0:\"\";i:1076;s:0:\"\";i:1077;s:0:\"\";i:1078;s:0:\"\";i:1079;s:0:\"\";i:1080;s:0:\"\";i:1081;s:0:\"\";i:1082;s:0:\"\";i:1083;s:0:\"\";i:1084;s:0:\"\";i:1085;s:0:\"\";i:1086;s:0:\"\";i:1087;s:0:\"\";i:1088;s:0:\"\";i:1089;s:0:\"\";i:1090;s:0:\"\";i:1091;s:0:\"\";i:1092;s:0:\"\";i:1093;s:0:\"\";i:1094;s:0:\"\";i:1095;s:0:\"\";i:1096;s:0:\"\";i:1097;s:0:\"\";i:1098;s:0:\"\";i:1099;s:11:\"ilcolumngui\";i:1100;s:0:\"\";i:1101;s:13:\"ilfeedbackgui\";i:1102;s:0:\"\";i:1103;s:0:\"\";i:1104;s:0:\"\";i:1105;s:0:\"\";i:1106;s:13:\"illpfiltergui\";i:1107;s:0:\"\";i:1108;s:17:\"ilpdfpresentation\";i:1109;s:0:\"\";i:1110;s:15:\"iluserfiltergui\";i:1111;s:0:\"\";i:1112;s:13:\"illpfiltergui\";i:1113;s:0:\"\";i:1114;s:17:\"ilpdfpresentation\";i:1115;s:0:\"\";i:1116;s:21:\"illplistofsettingsgui\";i:1117;s:0:\"\";i:1118;s:0:\"\";i:1119;s:0:\"\";i:1120;s:0:\"\";i:1121;s:0:\"\";i:1122;s:0:\"\";i:1123;s:0:\"\";i:1124;s:0:\"\";i:1125;s:0:\"\";i:1126;s:0:\"\";i:1127;s:0:\"\";i:1128;s:0:\"\";i:1129;s:0:\"\";i:1130;s:0:\"\";i:1131;s:0:\"\";i:1132;s:0:\"\";i:1133;s:0:\"\";i:1134;s:0:\"\";i:1135;s:0:\"\";i:1136;s:0:\"\";i:1137;s:0:\"\";i:1138;s:0:\"\";i:1139;s:0:\"\";i:1140;s:0:\"\";i:1141;s:0:\"\";i:1142;s:0:\"\";i:1143;s:0:\"\";i:1144;s:18:\"ilobjstylesheetgui\";i:1145;s:0:\"\";i:1146;s:12:\"ilobjrolegui\";i:1147;s:0:\"\";i:1148;s:0:\"\";i:1149;s:0:\"\";i:1150;s:0:\"\";i:1151;s:0:\"\";i:1152;s:0:\"\";i:1153;s:0:\"\";i:1154;s:0:\"\";i:1155;s:0:\"\";i:1156;s:0:\"\";i:1157;s:0:\"\";i:1158;s:0:\"\";i:1159;s:0:\"\";i:1160;s:0:\"\";i:1161;s:0:\"\";i:1162;s:0:\"\";i:1163;s:0:\"\";i:1164;s:0:\"\";i:1165;s:0:\"\";i:1166;s:0:\"\";i:1167;s:0:\"\";i:1168;s:0:\"\";i:1169;s:0:\"\";i:1170;s:0:\"\";i:1171;s:0:\"\";i:1172;s:0:\"\";i:1173;s:0:\"\";i:1174;s:11:\"ilcolumngui\";i:1175;s:0:\"\";i:1176;s:13:\"ilfeedbackgui\";i:1177;s:0:\"\";i:1178;s:0:\"\";i:1179;s:0:\"\";i:1180;s:0:\"\";i:1181;s:12:\"ilobjrolegui\";i:1182;s:0:\"\";i:1183;s:0:\"\";i:1184;s:0:\"\";i:1185;s:0:\"\";i:1186;s:0:\"\";i:1187;s:0:\"\";i:1188;s:0:\"\";i:1189;s:0:\"\";i:1190;s:0:\"\";i:1191;s:0:\"\";i:1192;s:0:\"\";i:1193;s:0:\"\";i:1194;s:0:\"\";i:1195;s:0:\"\";i:1196;s:0:\"\";i:1197;s:0:\"\";i:1198;s:0:\"\";i:1199;s:0:\"\";i:1200;s:0:\"\";i:1201;s:0:\"\";i:1202;s:0:\"\";i:1203;s:0:\"\";i:1204;s:0:\"\";i:1205;s:0:\"\";i:1206;s:0:\"\";i:1207;s:11:\"ilcolumngui\";i:1208;s:0:\"\";i:1209;s:13:\"ilfeedbackgui\";i:1210;s:0:\"\";i:1211;s:0:\"\";i:1212;s:0:\"\";i:1213;s:12:\"ilobjrolegui\";i:1214;s:0:\"\";i:1215;s:0:\"\";i:1216;s:0:\"\";i:1217;s:0:\"\";i:1218;s:0:\"\";i:1219;s:0:\"\";i:1220;s:0:\"\";i:1221;s:0:\"\";i:1222;s:0:\"\";i:1223;s:0:\"\";i:1224;s:0:\"\";i:1225;s:0:\"\";i:1226;s:0:\"\";i:1227;s:0:\"\";i:1228;s:0:\"\";i:1229;s:0:\"\";i:1230;s:0:\"\";i:1231;s:0:\"\";i:1232;s:0:\"\";i:1233;s:0:\"\";i:1234;s:0:\"\";i:1235;s:0:\"\";i:1236;s:0:\"\";i:1237;s:0:\"\";i:1238;s:0:\"\";i:1239;s:0:\"\";i:1240;s:0:\"\";i:1241;s:11:\"ilcolumngui\";i:1242;s:0:\"\";i:1243;s:13:\"ilfeedbackgui\";i:1244;s:0:\"\";i:1245;s:0:\"\";i:1246;s:0:\"\";i:1247;s:0:\"\";i:1248;s:0:\"\";i:1249;s:0:\"\";i:1250;s:0:\"\";i:1251;s:0:\"\";i:1252;s:0:\"\";i:1253;s:0:\"\";i:1254;s:0:\"\";i:1255;s:0:\"\";i:1256;s:0:\"\";i:1257;s:0:\"\";i:1258;s:0:\"\";i:1259;s:0:\"\";i:1260;s:0:\"\";i:1261;s:0:\"\";i:1262;s:0:\"\";i:1263;s:0:\"\";i:1264;s:0:\"\";i:1265;s:0:\"\";i:1266;s:0:\"\";i:1267;s:0:\"\";i:1268;s:0:\"\";i:1269;s:0:\"\";i:1270;s:0:\"\";i:1271;s:11:\"ilcolumngui\";i:1272;s:0:\"\";i:1273;s:0:\"\";i:1274;s:0:\"\";i:1275;s:0:\"\";i:1276;s:0:\"\";i:1277;s:0:\"\";i:1278;s:0:\"\";i:1279;s:0:\"\";i:1280;s:0:\"\";i:1281;s:0:\"\";i:1282;s:0:\"\";i:1283;s:0:\"\";i:1284;s:0:\"\";i:1285;s:0:\"\";i:1286;s:0:\"\";i:1287;s:0:\"\";i:1288;s:0:\"\";i:1289;s:0:\"\";i:1290;s:0:\"\";i:1291;s:0:\"\";i:1292;s:0:\"\";i:1293;s:0:\"\";i:1294;s:0:\"\";i:1295;s:0:\"\";i:1296;s:0:\"\";i:1297;s:0:\"\";i:1298;s:11:\"ilcolumngui\";i:1299;s:0:\"\";i:1300;s:0:\"\";i:1301;s:32:\"ilcourseobjectivepresentationgui\";i:1302;s:0:\"\";i:1303;s:0:\"\";i:1304;s:0:\"\";i:1305;s:0:\"\";i:1306;s:0:\"\";i:1307;s:0:\"\";i:1308;s:0:\"\";i:1309;s:0:\"\";i:1310;s:0:\"\";i:1311;s:0:\"\";i:1312;s:0:\"\";i:1313;s:0:\"\";i:1314;s:0:\"\";i:1315;s:0:\"\";i:1316;s:0:\"\";i:1317;s:0:\"\";i:1318;s:0:\"\";i:1319;s:0:\"\";i:1320;s:0:\"\";i:1321;s:0:\"\";i:1322;s:0:\"\";i:1323;s:0:\"\";i:1324;s:0:\"\";i:1325;s:0:\"\";i:1326;s:0:\"\";i:1327;s:0:\"\";i:1328;s:11:\"ilcolumngui\";i:1329;s:0:\"\";i:1330;s:13:\"ilfeedbackgui\";i:1331;s:0:\"\";i:1332;s:0:\"\";i:1333;s:0:\"\";i:1334;s:0:\"\";i:1335;s:13:\"illpfiltergui\";i:1336;s:0:\"\";i:1337;s:17:\"ilpdfpresentation\";i:1338;s:0:\"\";i:1339;s:15:\"iluserfiltergui\";i:1340;s:0:\"\";i:1341;s:13:\"illpfiltergui\";i:1342;s:0:\"\";i:1343;s:17:\"ilpdfpresentation\";i:1344;s:0:\"\";i:1345;s:21:\"illplistofsettingsgui\";i:1346;s:0:\"\";i:1347;s:0:\"\";i:1348;s:0:\"\";i:1349;s:0:\"\";i:1350;s:0:\"\";i:1351;s:0:\"\";i:1352;s:0:\"\";i:1353;s:0:\"\";i:1354;s:0:\"\";i:1355;s:0:\"\";i:1356;s:0:\"\";i:1357;s:0:\"\";i:1358;s:0:\"\";i:1359;s:0:\"\";i:1360;s:0:\"\";i:1361;s:0:\"\";i:1362;s:0:\"\";i:1363;s:0:\"\";i:1364;s:0:\"\";i:1365;s:0:\"\";i:1366;s:0:\"\";i:1367;s:0:\"\";i:1368;s:0:\"\";i:1369;s:0:\"\";i:1370;s:0:\"\";i:1371;s:0:\"\";i:1372;s:12:\"ilobjrolegui\";i:1373;s:0:\"\";i:1374;s:0:\"\";i:1375;s:0:\"\";i:1376;s:12:\"ilobjrolegui\";i:1377;s:0:\"\";i:1378;s:0:\"\";i:1379;s:0:\"\";i:1380;s:0:\"\";i:1381;s:0:\"\";i:1382;s:0:\"\";i:1383;s:0:\"\";i:1384;s:0:\"\";i:1385;s:0:\"\";i:1386;s:0:\"\";i:1387;s:0:\"\";i:1388;s:0:\"\";i:1389;s:0:\"\";i:1390;s:0:\"\";i:1391;s:0:\"\";i:1392;s:0:\"\";i:1393;s:0:\"\";i:1394;s:0:\"\";i:1395;s:0:\"\";i:1396;s:0:\"\";i:1397;s:0:\"\";i:1398;s:0:\"\";i:1399;s:0:\"\";i:1400;s:0:\"\";i:1401;s:0:\"\";i:1402;s:0:\"\";i:1403;s:0:\"\";i:1404;s:0:\"\";i:1405;s:0:\"\";i:1406;s:0:\"\";i:1407;s:0:\"\";i:1408;s:0:\"\";i:1409;s:0:\"\";i:1410;s:0:\"\";i:1411;s:0:\"\";i:1412;s:0:\"\";i:1413;s:0:\"\";i:1414;s:0:\"\";i:1415;s:12:\"ilobjrolegui\";i:1416;s:0:\"\";i:1417;s:0:\"\";i:1418;s:0:\"\";i:1419;s:0:\"\";i:1420;s:0:\"\";i:1421;s:0:\"\";i:1422;s:0:\"\";i:1423;s:0:\"\";i:1424;s:0:\"\";i:1425;s:0:\"\";i:1426;s:0:\"\";i:1427;s:0:\"\";i:1428;s:0:\"\";i:1429;s:0:\"\";i:1430;s:0:\"\";i:1431;s:0:\"\";i:1432;s:0:\"\";i:1433;s:0:\"\";i:1434;s:0:\"\";i:1435;s:0:\"\";i:1436;s:0:\"\";i:1437;s:0:\"\";i:1438;s:0:\"\";i:1439;s:0:\"\";i:1440;s:0:\"\";i:1441;s:11:\"ilcolumngui\";i:1442;s:0:\"\";i:1443;s:13:\"ilfeedbackgui\";i:1444;s:0:\"\";i:1445;s:0:\"\";i:1446;s:0:\"\";i:1447;s:12:\"ilobjrolegui\";i:1448;s:0:\"\";i:1449;s:12:\"ilobjrolegui\";i:1450;s:0:\"\";i:1451;s:0:\"\";i:1452;s:0:\"\";i:1453;s:0:\"\";i:1454;s:0:\"\";i:1455;s:0:\"\";i:1456;s:0:\"\";i:1457;s:0:\"\";i:1458;s:0:\"\";i:1459;s:0:\"\";i:1460;s:0:\"\";i:1461;s:0:\"\";i:1462;s:0:\"\";i:1463;s:0:\"\";i:1464;s:0:\"\";i:1465;s:0:\"\";i:1466;s:0:\"\";i:1467;s:0:\"\";i:1468;s:0:\"\";i:1469;s:0:\"\";i:1470;s:0:\"\";i:1471;s:0:\"\";i:1472;s:0:\"\";i:1473;s:0:\"\";i:1474;s:0:\"\";i:1475;s:11:\"ilcolumngui\";i:1476;s:0:\"\";i:1477;s:22:\"ilcontainerlinklistgui\";i:1478;s:0:\"\";i:1479;s:0:\"\";i:1480;s:0:\"\";i:1481;s:0:\"\";i:1482;s:0:\"\";i:1483;s:0:\"\";i:1484;s:0:\"\";i:1485;s:0:\"\";i:1486;s:0:\"\";i:1487;s:0:\"\";i:1488;s:0:\"\";i:1489;s:0:\"\";i:1490;s:0:\"\";i:1491;s:0:\"\";i:1492;s:0:\"\";i:1493;s:0:\"\";i:1494;s:0:\"\";i:1495;s:0:\"\";i:1496;s:0:\"\";i:1497;s:0:\"\";i:1498;s:0:\"\";i:1499;s:0:\"\";i:1500;s:0:\"\";i:1501;s:0:\"\";i:1502;s:0:\"\";i:1503;s:0:\"\";i:1504;s:12:\"ilobjrolegui\";i:1505;s:0:\"\";i:1506;s:0:\"\";i:1507;s:0:\"\";i:1508;s:12:\"ilobjrolegui\";i:1509;s:0:\"\";i:1510;s:0:\"\";i:1511;s:0:\"\";i:1512;s:0:\"\";i:1513;s:0:\"\";i:1514;s:0:\"\";i:1515;s:0:\"\";i:1516;s:0:\"\";i:1517;s:0:\"\";i:1518;s:0:\"\";i:1519;s:0:\"\";i:1520;s:0:\"\";i:1521;s:0:\"\";i:1522;s:0:\"\";i:1523;s:0:\"\";i:1524;s:0:\"\";i:1525;s:0:\"\";i:1526;s:0:\"\";i:1527;s:0:\"\";i:1528;s:0:\"\";i:1529;s:0:\"\";i:1530;s:0:\"\";i:1531;s:0:\"\";i:1532;s:0:\"\";i:1533;s:0:\"\";i:1534;s:11:\"ilcolumngui\";i:1535;s:0:\"\";i:1536;s:13:\"ilfeedbackgui\";i:1537;s:0:\"\";i:1538;s:0:\"\";i:1539;s:0:\"\";i:1540;s:12:\"ilobjrolegui\";i:1541;s:0:\"\";i:1542;s:0:\"\";i:1543;s:0:\"\";i:1544;s:0:\"\";i:1545;s:0:\"\";i:1546;s:0:\"\";i:1547;s:0:\"\";i:1548;s:0:\"\";i:1549;s:0:\"\";i:1550;s:0:\"\";i:1551;s:0:\"\";i:1552;s:0:\"\";i:1553;s:0:\"\";i:1554;s:0:\"\";i:1555;s:0:\"\";i:1556;s:0:\"\";i:1557;s:0:\"\";i:1558;s:0:\"\";i:1559;s:0:\"\";i:1560;s:0:\"\";i:1561;s:0:\"\";i:1562;s:0:\"\";i:1563;s:0:\"\";i:1564;s:0:\"\";i:1565;s:0:\"\";i:1566;s:11:\"ilcolumngui\";i:1567;s:0:\"\";i:1568;s:13:\"ilfeedbackgui\";i:1569;s:0:\"\";i:1570;s:0:\"\";i:1571;s:0:\"\";i:1572;s:0:\"\";i:1573;s:12:\"ilobjrolegui\";i:1574;s:0:\"\";i:1575;s:0:\"\";i:1576;s:0:\"\";i:1577;s:0:\"\";i:1578;s:12:\"ilobjrolegui\";i:1579;s:0:\"\";i:1580;s:0:\"\";i:1581;s:0:\"\";i:1582;s:0:\"\";i:1583;s:0:\"\";i:1584;s:0:\"\";i:1585;s:0:\"\";i:1586;s:0:\"\";i:1587;s:0:\"\";i:1588;s:0:\"\";i:1589;s:0:\"\";i:1590;s:0:\"\";i:1591;s:0:\"\";i:1592;s:0:\"\";i:1593;s:0:\"\";i:1594;s:0:\"\";i:1595;s:0:\"\";i:1596;s:0:\"\";i:1597;s:0:\"\";i:1598;s:0:\"\";i:1599;s:0:\"\";i:1600;s:0:\"\";i:1601;s:0:\"\";i:1602;s:0:\"\";i:1603;s:0:\"\";i:1604;s:0:\"\";i:1605;s:0:\"\";i:1606;s:0:\"\";i:1607;s:0:\"\";i:1608;s:0:\"\";i:1609;s:0:\"\";i:1610;s:11:\"ilcolumngui\";i:1611;s:0:\"\";i:1612;s:13:\"ilfeedbackgui\";i:1613;s:0:\"\";i:1614;s:0:\"\";i:1615;s:0:\"\";i:1616;s:0:\"\";i:1617;s:13:\"illpfiltergui\";i:1618;s:0:\"\";i:1619;s:17:\"ilpdfpresentation\";i:1620;s:0:\"\";i:1621;s:15:\"iluserfiltergui\";i:1622;s:0:\"\";i:1623;s:13:\"illpfiltergui\";i:1624;s:0:\"\";i:1625;s:17:\"ilpdfpresentation\";i:1626;s:0:\"\";i:1627;s:21:\"illplistofsettingsgui\";i:1628;s:0:\"\";i:1629;s:0:\"\";i:1630;s:0:\"\";i:1631;s:0:\"\";i:1632;s:0:\"\";i:1633;s:0:\"\";i:1634;s:0:\"\";i:1635;s:0:\"\";i:1636;s:0:\"\";i:1637;s:0:\"\";i:1638;s:0:\"\";i:1639;s:0:\"\";i:1640;s:0:\"\";i:1641;s:0:\"\";i:1642;s:0:\"\";i:1643;s:0:\"\";i:1644;s:0:\"\";i:1645;s:0:\"\";i:1646;s:0:\"\";i:1647;s:0:\"\";i:1648;s:0:\"\";i:1649;s:0:\"\";i:1650;s:0:\"\";i:1651;s:0:\"\";i:1652;s:0:\"\";i:1653;s:0:\"\";i:1654;s:11:\"ilcolumngui\";i:1655;s:0:\"\";i:1656;s:0:\"\";i:1657;s:20:\"ilcourseagreementgui\";i:1658;s:0:\"\";i:1659;s:0:\"\";i:1660;s:0:\"\";i:1661;s:0:\"\";i:1662;s:0:\"\";i:1663;s:0:\"\";i:1664;s:0:\"\";i:1665;s:0:\"\";i:1666;s:0:\"\";i:1667;s:0:\"\";i:1668;s:0:\"\";i:1669;s:0:\"\";i:1670;s:0:\"\";i:1671;s:0:\"\";i:1672;s:0:\"\";i:1673;s:0:\"\";i:1674;s:0:\"\";i:1675;s:0:\"\";i:1676;s:0:\"\";i:1677;s:0:\"\";i:1678;s:0:\"\";i:1679;s:0:\"\";i:1680;s:0:\"\";i:1681;s:0:\"\";i:1682;s:0:\"\";i:1683;s:11:\"ilcolumngui\";i:1684;s:0:\"\";i:1685;s:0:\"\";i:1686;s:32:\"ilcourseobjectivepresentationgui\";i:1687;s:0:\"\";i:1688;s:0:\"\";i:1689;s:0:\"\";i:1690;s:23:\"ilcourseregistrationgui\";i:1691;s:0:\"\";i:1692;s:0:\"\";i:1693;s:0:\"\";i:1694;s:0:\"\";i:1695;s:0:\"\";i:1696;s:0:\"\";i:1697;s:0:\"\";i:1698;s:0:\"\";i:1699;s:0:\"\";i:1700;s:0:\"\";i:1701;s:0:\"\";i:1702;s:0:\"\";i:1703;s:0:\"\";i:1704;s:0:\"\";i:1705;s:0:\"\";i:1706;s:0:\"\";i:1707;s:0:\"\";i:1708;s:0:\"\";i:1709;s:0:\"\";i:1710;s:0:\"\";i:1711;s:0:\"\";i:1712;s:0:\"\";i:1713;s:0:\"\";i:1714;s:0:\"\";i:1715;s:0:\"\";i:1716;s:0:\"\";i:1717;s:11:\"ilcolumngui\";i:1718;s:0:\"\";i:1719;s:13:\"ilfeedbackgui\";i:1720;s:0:\"\";i:1721;s:0:\"\";i:1722;s:0:\"\";i:1723;s:0:\"\";i:1724;s:13:\"illpfiltergui\";i:1725;s:0:\"\";i:1726;s:17:\"ilpdfpresentation\";i:1727;s:0:\"\";i:1728;s:15:\"iluserfiltergui\";i:1729;s:0:\"\";i:1730;s:13:\"illpfiltergui\";i:1731;s:0:\"\";i:1732;s:17:\"ilpdfpresentation\";i:1733;s:0:\"\";i:1734;s:21:\"illplistofsettingsgui\";i:1735;s:0:\"\";i:1736;s:0:\"\";i:1737;s:17:\"ilmemberexportgui\";i:1738;s:0:\"\";i:1739;s:0:\"\";i:1740;s:0:\"\";i:1741;s:0:\"\";i:1742;s:0:\"\";i:1743;s:0:\"\";i:1744;s:0:\"\";i:1745;s:0:\"\";i:1746;s:0:\"\";i:1747;s:0:\"\";i:1748;s:0:\"\";i:1749;s:0:\"\";i:1750;s:0:\"\";i:1751;s:0:\"\";i:1752;s:0:\"\";i:1753;s:0:\"\";i:1754;s:0:\"\";i:1755;s:0:\"\";i:1756;s:0:\"\";i:1757;s:0:\"\";i:1758;s:0:\"\";i:1759;s:0:\"\";i:1760;s:0:\"\";i:1761;s:0:\"\";i:1762;s:0:\"\";i:1763;s:0:\"\";i:1764;s:0:\"\";i:1765;s:12:\"ilobjrolegui\";i:1766;s:0:\"\";i:1767;s:0:\"\";i:1768;s:0:\"\";i:1769;s:0:\"\";i:1770;s:0:\"\";i:1771;s:0:\"\";i:1772;s:0:\"\";i:1773;s:0:\"\";i:1774;s:0:\"\";i:1775;s:0:\"\";i:1776;s:0:\"\";i:1777;s:0:\"\";i:1778;s:0:\"\";i:1779;s:0:\"\";i:1780;s:0:\"\";i:1781;s:0:\"\";i:1782;s:0:\"\";i:1783;s:0:\"\";i:1784;s:0:\"\";i:1785;s:0:\"\";i:1786;s:0:\"\";i:1787;s:0:\"\";i:1788;s:0:\"\";i:1789;s:0:\"\";i:1790;s:0:\"\";i:1791;s:0:\"\";i:1792;s:0:\"\";i:1793;s:0:\"\";i:1794;s:0:\"\";i:1795;s:12:\"ilobjrolegui\";i:1796;s:0:\"\";i:1797;s:0:\"\";i:1798;s:0:\"\";i:1799;s:0:\"\";i:1800;s:0:\"\";i:1801;s:0:\"\";i:1802;s:0:\"\";i:1803;s:0:\"\";i:1804;s:0:\"\";i:1805;s:0:\"\";i:1806;s:0:\"\";i:1807;s:0:\"\";i:1808;s:0:\"\";i:1809;s:0:\"\";i:1810;s:0:\"\";i:1811;s:0:\"\";i:1812;s:0:\"\";i:1813;s:0:\"\";i:1814;s:0:\"\";i:1815;s:0:\"\";i:1816;s:0:\"\";i:1817;s:0:\"\";i:1818;s:0:\"\";i:1819;s:0:\"\";i:1820;s:0:\"\";i:1821;s:0:\"\";i:1822;s:0:\"\";i:1823;s:0:\"\";i:1824;s:0:\"\";i:1825;s:0:\"\";i:1826;s:0:\"\";i:1827;s:0:\"\";i:1828;s:0:\"\";i:1829;s:0:\"\";i:1830;s:0:\"\";i:1831;s:0:\"\";i:1832;s:0:\"\";i:1833;s:0:\"\";i:1834;s:0:\"\";i:1835;s:0:\"\";i:1836;s:0:\"\";i:1837;s:0:\"\";i:1838;s:0:\"\";i:1839;s:0:\"\";i:1840;s:0:\"\";i:1841;s:0:\"\";i:1842;s:0:\"\";i:1843;s:0:\"\";i:1844;s:0:\"\";i:1845;s:0:\"\";i:1846;s:0:\"\";i:1847;s:0:\"\";i:1848;s:0:\"\";i:1849;s:0:\"\";i:1850;s:0:\"\";i:1851;s:11:\"ilcolumngui\";i:1852;s:0:\"\";i:1853;s:13:\"ilfeedbackgui\";i:1854;s:0:\"\";i:1855;s:0:\"\";i:1856;s:0:\"\";i:1857;s:12:\"ilobjrolegui\";i:1858;s:0:\"\";i:1859;s:0:\"\";i:1860;s:0:\"\";i:1861;s:0:\"\";i:1862;s:0:\"\";i:1863;s:0:\"\";i:1864;s:0:\"\";i:1865;s:0:\"\";i:1866;s:0:\"\";i:1867;s:0:\"\";i:1868;s:0:\"\";i:1869;s:0:\"\";i:1870;s:0:\"\";i:1871;s:0:\"\";i:1872;s:0:\"\";i:1873;s:0:\"\";i:1874;s:0:\"\";i:1875;s:0:\"\";i:1876;s:0:\"\";i:1877;s:0:\"\";i:1878;s:0:\"\";i:1879;s:0:\"\";i:1880;s:0:\"\";i:1881;s:0:\"\";i:1882;s:0:\"\";i:1883;s:0:\"\";i:1884;s:0:\"\";i:1885;s:0:\"\";i:1886;s:0:\"\";i:1887;s:0:\"\";i:1888;s:0:\"\";i:1889;s:0:\"\";i:1890;s:0:\"\";i:1891;s:0:\"\";i:1892;s:0:\"\";i:1893;s:0:\"\";i:1894;s:0:\"\";i:1895;s:0:\"\";i:1896;s:0:\"\";i:1897;s:0:\"\";i:1898;s:0:\"\";i:1899;s:0:\"\";i:1900;s:0:\"\";i:1901;s:0:\"\";i:1902;s:0:\"\";i:1903;s:0:\"\";i:1904;s:0:\"\";i:1905;s:0:\"\";i:1906;s:0:\"\";i:1907;s:0:\"\";i:1908;s:0:\"\";i:1909;s:0:\"\";i:1910;s:0:\"\";}s:24:\"ilcalendarappointmentgui\";a:380:{i:0;s:16:\"ilcalendardaygui\";i:1;s:18:\"ilcalendarinboxgui\";i:2;s:18:\"ilcalendarmonthgui\";i:3;s:17:\"ilcalendarweekgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:16:\"ilcalendardaygui\";i:6;s:18:\"ilcalendarinboxgui\";i:7;s:18:\"ilcalendarmonthgui\";i:8;s:17:\"ilcalendarweekgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:16:\"ilcalendardaygui\";i:11;s:18:\"ilcalendarinboxgui\";i:12;s:18:\"ilcalendarmonthgui\";i:13;s:17:\"ilcalendarweekgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:16:\"ilcalendardaygui\";i:16;s:18:\"ilcalendarinboxgui\";i:17;s:18:\"ilcalendarmonthgui\";i:18;s:17:\"ilcalendarweekgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:16:\"ilcalendardaygui\";i:21;s:18:\"ilcalendarinboxgui\";i:22;s:18:\"ilcalendarmonthgui\";i:23;s:17:\"ilcalendarweekgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:16:\"ilcalendardaygui\";i:26;s:18:\"ilcalendarinboxgui\";i:27;s:18:\"ilcalendarmonthgui\";i:28;s:17:\"ilcalendarweekgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:16:\"ilcalendardaygui\";i:31;s:18:\"ilcalendarinboxgui\";i:32;s:18:\"ilcalendarmonthgui\";i:33;s:17:\"ilcalendarweekgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:16:\"ilcalendardaygui\";i:36;s:18:\"ilcalendarinboxgui\";i:37;s:18:\"ilcalendarmonthgui\";i:38;s:17:\"ilcalendarweekgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:16:\"ilcalendardaygui\";i:41;s:18:\"ilcalendarinboxgui\";i:42;s:18:\"ilcalendarmonthgui\";i:43;s:17:\"ilcalendarweekgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:16:\"ilcalendardaygui\";i:46;s:18:\"ilcalendarinboxgui\";i:47;s:18:\"ilcalendarmonthgui\";i:48;s:17:\"ilcalendarweekgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:16:\"ilcalendardaygui\";i:51;s:18:\"ilcalendarinboxgui\";i:52;s:18:\"ilcalendarmonthgui\";i:53;s:17:\"ilcalendarweekgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:16:\"ilcalendardaygui\";i:56;s:18:\"ilcalendarinboxgui\";i:57;s:18:\"ilcalendarmonthgui\";i:58;s:17:\"ilcalendarweekgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:16:\"ilcalendardaygui\";i:61;s:18:\"ilcalendarinboxgui\";i:62;s:18:\"ilcalendarmonthgui\";i:63;s:17:\"ilcalendarweekgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:16:\"ilcalendardaygui\";i:66;s:18:\"ilcalendarinboxgui\";i:67;s:18:\"ilcalendarmonthgui\";i:68;s:17:\"ilcalendarweekgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:16:\"ilcalendardaygui\";i:71;s:18:\"ilcalendarinboxgui\";i:72;s:18:\"ilcalendarmonthgui\";i:73;s:17:\"ilcalendarweekgui\";i:74;s:18:\"ilcalendarblockgui\";i:75;s:16:\"ilcalendardaygui\";i:76;s:18:\"ilcalendarinboxgui\";i:77;s:18:\"ilcalendarmonthgui\";i:78;s:17:\"ilcalendarweekgui\";i:79;s:20:\"ilpdcalendarblockgui\";i:80;s:16:\"ilcalendardaygui\";i:81;s:18:\"ilcalendarinboxgui\";i:82;s:18:\"ilcalendarmonthgui\";i:83;s:17:\"ilcalendarweekgui\";i:84;s:18:\"ilcalendarblockgui\";i:85;s:16:\"ilcalendardaygui\";i:86;s:18:\"ilcalendarinboxgui\";i:87;s:18:\"ilcalendarmonthgui\";i:88;s:17:\"ilcalendarweekgui\";i:89;s:20:\"ilpdcalendarblockgui\";i:90;s:16:\"ilcalendardaygui\";i:91;s:18:\"ilcalendarinboxgui\";i:92;s:18:\"ilcalendarmonthgui\";i:93;s:17:\"ilcalendarweekgui\";i:94;s:18:\"ilcalendarblockgui\";i:95;s:16:\"ilcalendardaygui\";i:96;s:18:\"ilcalendarinboxgui\";i:97;s:18:\"ilcalendarmonthgui\";i:98;s:17:\"ilcalendarweekgui\";i:99;s:20:\"ilpdcalendarblockgui\";i:100;s:16:\"ilcalendardaygui\";i:101;s:18:\"ilcalendarinboxgui\";i:102;s:18:\"ilcalendarmonthgui\";i:103;s:17:\"ilcalendarweekgui\";i:104;s:18:\"ilcalendarblockgui\";i:105;s:16:\"ilcalendardaygui\";i:106;s:18:\"ilcalendarinboxgui\";i:107;s:18:\"ilcalendarmonthgui\";i:108;s:17:\"ilcalendarweekgui\";i:109;s:20:\"ilpdcalendarblockgui\";i:110;s:16:\"ilcalendardaygui\";i:111;s:18:\"ilcalendarinboxgui\";i:112;s:18:\"ilcalendarmonthgui\";i:113;s:17:\"ilcalendarweekgui\";i:114;s:18:\"ilcalendarblockgui\";i:115;s:16:\"ilcalendardaygui\";i:116;s:18:\"ilcalendarinboxgui\";i:117;s:18:\"ilcalendarmonthgui\";i:118;s:17:\"ilcalendarweekgui\";i:119;s:20:\"ilpdcalendarblockgui\";i:120;s:16:\"ilcalendardaygui\";i:121;s:18:\"ilcalendarinboxgui\";i:122;s:18:\"ilcalendarmonthgui\";i:123;s:17:\"ilcalendarweekgui\";i:124;s:18:\"ilcalendarblockgui\";i:125;s:16:\"ilcalendardaygui\";i:126;s:18:\"ilcalendarinboxgui\";i:127;s:18:\"ilcalendarmonthgui\";i:128;s:17:\"ilcalendarweekgui\";i:129;s:20:\"ilpdcalendarblockgui\";i:130;s:16:\"ilcalendardaygui\";i:131;s:18:\"ilcalendarinboxgui\";i:132;s:18:\"ilcalendarmonthgui\";i:133;s:17:\"ilcalendarweekgui\";i:134;s:18:\"ilcalendarblockgui\";i:135;s:16:\"ilcalendardaygui\";i:136;s:18:\"ilcalendarinboxgui\";i:137;s:18:\"ilcalendarmonthgui\";i:138;s:17:\"ilcalendarweekgui\";i:139;s:20:\"ilpdcalendarblockgui\";i:140;s:16:\"ilcalendardaygui\";i:141;s:18:\"ilcalendarinboxgui\";i:142;s:18:\"ilcalendarmonthgui\";i:143;s:17:\"ilcalendarweekgui\";i:144;s:18:\"ilcalendarblockgui\";i:145;s:16:\"ilcalendardaygui\";i:146;s:18:\"ilcalendarinboxgui\";i:147;s:18:\"ilcalendarmonthgui\";i:148;s:17:\"ilcalendarweekgui\";i:149;s:20:\"ilpdcalendarblockgui\";i:150;s:16:\"ilcalendardaygui\";i:151;s:18:\"ilcalendarinboxgui\";i:152;s:18:\"ilcalendarmonthgui\";i:153;s:17:\"ilcalendarweekgui\";i:154;s:18:\"ilcalendarblockgui\";i:155;s:16:\"ilcalendardaygui\";i:156;s:18:\"ilcalendarinboxgui\";i:157;s:18:\"ilcalendarmonthgui\";i:158;s:17:\"ilcalendarweekgui\";i:159;s:20:\"ilpdcalendarblockgui\";i:160;s:16:\"ilcalendardaygui\";i:161;s:18:\"ilcalendarinboxgui\";i:162;s:18:\"ilcalendarmonthgui\";i:163;s:17:\"ilcalendarweekgui\";i:164;s:18:\"ilcalendarblockgui\";i:165;s:16:\"ilcalendardaygui\";i:166;s:18:\"ilcalendarinboxgui\";i:167;s:18:\"ilcalendarmonthgui\";i:168;s:17:\"ilcalendarweekgui\";i:169;s:20:\"ilpdcalendarblockgui\";i:170;s:16:\"ilcalendardaygui\";i:171;s:18:\"ilcalendarinboxgui\";i:172;s:18:\"ilcalendarmonthgui\";i:173;s:17:\"ilcalendarweekgui\";i:174;s:18:\"ilcalendarblockgui\";i:175;s:16:\"ilcalendardaygui\";i:176;s:18:\"ilcalendarinboxgui\";i:177;s:18:\"ilcalendarmonthgui\";i:178;s:17:\"ilcalendarweekgui\";i:179;s:20:\"ilpdcalendarblockgui\";i:180;s:16:\"ilcalendardaygui\";i:181;s:18:\"ilcalendarinboxgui\";i:182;s:18:\"ilcalendarmonthgui\";i:183;s:17:\"ilcalendarweekgui\";i:184;s:18:\"ilcalendarblockgui\";i:185;s:16:\"ilcalendardaygui\";i:186;s:18:\"ilcalendarinboxgui\";i:187;s:18:\"ilcalendarmonthgui\";i:188;s:17:\"ilcalendarweekgui\";i:189;s:20:\"ilpdcalendarblockgui\";i:190;s:16:\"ilcalendardaygui\";i:191;s:18:\"ilcalendarinboxgui\";i:192;s:18:\"ilcalendarmonthgui\";i:193;s:17:\"ilcalendarweekgui\";i:194;s:18:\"ilcalendarblockgui\";i:195;s:16:\"ilcalendardaygui\";i:196;s:18:\"ilcalendarinboxgui\";i:197;s:18:\"ilcalendarmonthgui\";i:198;s:17:\"ilcalendarweekgui\";i:199;s:20:\"ilpdcalendarblockgui\";i:200;s:16:\"ilcalendardaygui\";i:201;s:18:\"ilcalendarinboxgui\";i:202;s:18:\"ilcalendarmonthgui\";i:203;s:17:\"ilcalendarweekgui\";i:204;s:18:\"ilcalendarblockgui\";i:205;s:16:\"ilcalendardaygui\";i:206;s:18:\"ilcalendarinboxgui\";i:207;s:18:\"ilcalendarmonthgui\";i:208;s:17:\"ilcalendarweekgui\";i:209;s:20:\"ilpdcalendarblockgui\";i:210;s:16:\"ilcalendardaygui\";i:211;s:18:\"ilcalendarinboxgui\";i:212;s:18:\"ilcalendarmonthgui\";i:213;s:17:\"ilcalendarweekgui\";i:214;s:18:\"ilcalendarblockgui\";i:215;s:16:\"ilcalendardaygui\";i:216;s:18:\"ilcalendarinboxgui\";i:217;s:18:\"ilcalendarmonthgui\";i:218;s:17:\"ilcalendarweekgui\";i:219;s:20:\"ilpdcalendarblockgui\";i:220;s:16:\"ilcalendardaygui\";i:221;s:18:\"ilcalendarinboxgui\";i:222;s:18:\"ilcalendarmonthgui\";i:223;s:17:\"ilcalendarweekgui\";i:224;s:18:\"ilcalendarblockgui\";i:225;s:16:\"ilcalendardaygui\";i:226;s:18:\"ilcalendarinboxgui\";i:227;s:18:\"ilcalendarmonthgui\";i:228;s:17:\"ilcalendarweekgui\";i:229;s:20:\"ilpdcalendarblockgui\";i:230;s:16:\"ilcalendardaygui\";i:231;s:18:\"ilcalendarinboxgui\";i:232;s:18:\"ilcalendarmonthgui\";i:233;s:17:\"ilcalendarweekgui\";i:234;s:18:\"ilcalendarblockgui\";i:235;s:16:\"ilcalendardaygui\";i:236;s:18:\"ilcalendarinboxgui\";i:237;s:18:\"ilcalendarmonthgui\";i:238;s:17:\"ilcalendarweekgui\";i:239;s:20:\"ilpdcalendarblockgui\";i:240;s:16:\"ilcalendardaygui\";i:241;s:18:\"ilcalendarinboxgui\";i:242;s:18:\"ilcalendarmonthgui\";i:243;s:17:\"ilcalendarweekgui\";i:244;s:18:\"ilcalendarblockgui\";i:245;s:16:\"ilcalendardaygui\";i:246;s:18:\"ilcalendarinboxgui\";i:247;s:18:\"ilcalendarmonthgui\";i:248;s:17:\"ilcalendarweekgui\";i:249;s:20:\"ilpdcalendarblockgui\";i:250;s:16:\"ilcalendardaygui\";i:251;s:18:\"ilcalendarinboxgui\";i:252;s:18:\"ilcalendarmonthgui\";i:253;s:17:\"ilcalendarweekgui\";i:254;s:18:\"ilcalendarblockgui\";i:255;s:16:\"ilcalendardaygui\";i:256;s:18:\"ilcalendarinboxgui\";i:257;s:18:\"ilcalendarmonthgui\";i:258;s:17:\"ilcalendarweekgui\";i:259;s:20:\"ilpdcalendarblockgui\";i:260;s:16:\"ilcalendardaygui\";i:261;s:18:\"ilcalendarinboxgui\";i:262;s:18:\"ilcalendarmonthgui\";i:263;s:17:\"ilcalendarweekgui\";i:264;s:18:\"ilcalendarblockgui\";i:265;s:16:\"ilcalendardaygui\";i:266;s:18:\"ilcalendarinboxgui\";i:267;s:18:\"ilcalendarmonthgui\";i:268;s:17:\"ilcalendarweekgui\";i:269;s:20:\"ilpdcalendarblockgui\";i:270;s:16:\"ilcalendardaygui\";i:271;s:18:\"ilcalendarinboxgui\";i:272;s:18:\"ilcalendarmonthgui\";i:273;s:17:\"ilcalendarweekgui\";i:274;s:18:\"ilcalendarblockgui\";i:275;s:16:\"ilcalendardaygui\";i:276;s:18:\"ilcalendarinboxgui\";i:277;s:18:\"ilcalendarmonthgui\";i:278;s:17:\"ilcalendarweekgui\";i:279;s:20:\"ilpdcalendarblockgui\";i:280;s:16:\"ilcalendardaygui\";i:281;s:18:\"ilcalendarinboxgui\";i:282;s:18:\"ilcalendarmonthgui\";i:283;s:17:\"ilcalendarweekgui\";i:284;s:18:\"ilcalendarblockgui\";i:285;s:16:\"ilcalendardaygui\";i:286;s:18:\"ilcalendarinboxgui\";i:287;s:18:\"ilcalendarmonthgui\";i:288;s:17:\"ilcalendarweekgui\";i:289;s:20:\"ilpdcalendarblockgui\";i:290;s:16:\"ilcalendardaygui\";i:291;s:18:\"ilcalendarinboxgui\";i:292;s:18:\"ilcalendarmonthgui\";i:293;s:17:\"ilcalendarweekgui\";i:294;s:18:\"ilcalendarblockgui\";i:295;s:16:\"ilcalendardaygui\";i:296;s:18:\"ilcalendarinboxgui\";i:297;s:18:\"ilcalendarmonthgui\";i:298;s:17:\"ilcalendarweekgui\";i:299;s:20:\"ilpdcalendarblockgui\";i:300;s:16:\"ilcalendardaygui\";i:301;s:18:\"ilcalendarinboxgui\";i:302;s:18:\"ilcalendarmonthgui\";i:303;s:17:\"ilcalendarweekgui\";i:304;s:18:\"ilcalendarblockgui\";i:305;s:16:\"ilcalendardaygui\";i:306;s:18:\"ilcalendarinboxgui\";i:307;s:18:\"ilcalendarmonthgui\";i:308;s:17:\"ilcalendarweekgui\";i:309;s:20:\"ilpdcalendarblockgui\";i:310;s:16:\"ilcalendardaygui\";i:311;s:18:\"ilcalendarinboxgui\";i:312;s:18:\"ilcalendarmonthgui\";i:313;s:17:\"ilcalendarweekgui\";i:314;s:18:\"ilcalendarblockgui\";i:315;s:16:\"ilcalendardaygui\";i:316;s:18:\"ilcalendarinboxgui\";i:317;s:18:\"ilcalendarmonthgui\";i:318;s:17:\"ilcalendarweekgui\";i:319;s:20:\"ilpdcalendarblockgui\";i:320;s:16:\"ilcalendardaygui\";i:321;s:18:\"ilcalendarinboxgui\";i:322;s:18:\"ilcalendarmonthgui\";i:323;s:17:\"ilcalendarweekgui\";i:324;s:18:\"ilcalendarblockgui\";i:325;s:16:\"ilcalendardaygui\";i:326;s:18:\"ilcalendarinboxgui\";i:327;s:18:\"ilcalendarmonthgui\";i:328;s:17:\"ilcalendarweekgui\";i:329;s:20:\"ilpdcalendarblockgui\";i:330;s:16:\"ilcalendardaygui\";i:331;s:18:\"ilcalendarinboxgui\";i:332;s:18:\"ilcalendarmonthgui\";i:333;s:17:\"ilcalendarweekgui\";i:334;s:18:\"ilcalendarblockgui\";i:335;s:16:\"ilcalendardaygui\";i:336;s:18:\"ilcalendarinboxgui\";i:337;s:18:\"ilcalendarmonthgui\";i:338;s:17:\"ilcalendarweekgui\";i:339;s:20:\"ilpdcalendarblockgui\";i:340;s:16:\"ilcalendardaygui\";i:341;s:18:\"ilcalendarinboxgui\";i:342;s:18:\"ilcalendarmonthgui\";i:343;s:17:\"ilcalendarweekgui\";i:344;s:18:\"ilcalendarblockgui\";i:345;s:16:\"ilcalendardaygui\";i:346;s:18:\"ilcalendarinboxgui\";i:347;s:18:\"ilcalendarmonthgui\";i:348;s:17:\"ilcalendarweekgui\";i:349;s:20:\"ilpdcalendarblockgui\";i:350;s:16:\"ilcalendardaygui\";i:351;s:18:\"ilcalendarinboxgui\";i:352;s:18:\"ilcalendarmonthgui\";i:353;s:17:\"ilcalendarweekgui\";i:354;s:18:\"ilcalendarblockgui\";i:355;s:16:\"ilcalendardaygui\";i:356;s:18:\"ilcalendarinboxgui\";i:357;s:18:\"ilcalendarmonthgui\";i:358;s:17:\"ilcalendarweekgui\";i:359;s:20:\"ilpdcalendarblockgui\";i:360;s:16:\"ilcalendardaygui\";i:361;s:18:\"ilcalendarinboxgui\";i:362;s:18:\"ilcalendarmonthgui\";i:363;s:17:\"ilcalendarweekgui\";i:364;s:18:\"ilcalendarblockgui\";i:365;s:16:\"ilcalendardaygui\";i:366;s:18:\"ilcalendarinboxgui\";i:367;s:18:\"ilcalendarmonthgui\";i:368;s:17:\"ilcalendarweekgui\";i:369;s:20:\"ilpdcalendarblockgui\";i:370;s:16:\"ilcalendardaygui\";i:371;s:18:\"ilcalendarinboxgui\";i:372;s:18:\"ilcalendarmonthgui\";i:373;s:17:\"ilcalendarweekgui\";i:374;s:18:\"ilcalendarblockgui\";i:375;s:16:\"ilcalendardaygui\";i:376;s:18:\"ilcalendarinboxgui\";i:377;s:18:\"ilcalendarmonthgui\";i:378;s:17:\"ilcalendarweekgui\";i:379;s:20:\"ilpdcalendarblockgui\";}s:16:\"ilcalendardaygui\";a:76:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";i:74;s:18:\"ilcalendarblockgui\";i:75;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarinboxgui\";a:76:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";i:74;s:18:\"ilcalendarblockgui\";i:75;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarmonthgui\";a:76:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";i:74;s:18:\"ilcalendarblockgui\";i:75;s:20:\"ilpdcalendarblockgui\";}s:17:\"ilcalendarweekgui\";a:76:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";i:74;s:18:\"ilcalendarblockgui\";i:75;s:20:\"ilpdcalendarblockgui\";}s:13:\"ilnewsitemgui\";a:38:{i:0;s:24:\"ilnewsforcontextblockgui\";i:1;s:24:\"ilnewsforcontextblockgui\";i:2;s:24:\"ilnewsforcontextblockgui\";i:3;s:24:\"ilnewsforcontextblockgui\";i:4;s:24:\"ilnewsforcontextblockgui\";i:5;s:24:\"ilnewsforcontextblockgui\";i:6;s:24:\"ilnewsforcontextblockgui\";i:7;s:24:\"ilnewsforcontextblockgui\";i:8;s:24:\"ilnewsforcontextblockgui\";i:9;s:24:\"ilnewsforcontextblockgui\";i:10;s:24:\"ilnewsforcontextblockgui\";i:11;s:24:\"ilnewsforcontextblockgui\";i:12;s:24:\"ilnewsforcontextblockgui\";i:13;s:24:\"ilnewsforcontextblockgui\";i:14;s:24:\"ilnewsforcontextblockgui\";i:15;s:24:\"ilnewsforcontextblockgui\";i:16;s:24:\"ilnewsforcontextblockgui\";i:17;s:24:\"ilnewsforcontextblockgui\";i:18;s:24:\"ilnewsforcontextblockgui\";i:19;s:24:\"ilnewsforcontextblockgui\";i:20;s:24:\"ilnewsforcontextblockgui\";i:21;s:24:\"ilnewsforcontextblockgui\";i:22;s:24:\"ilnewsforcontextblockgui\";i:23;s:24:\"ilnewsforcontextblockgui\";i:24;s:24:\"ilnewsforcontextblockgui\";i:25;s:24:\"ilnewsforcontextblockgui\";i:26;s:24:\"ilnewsforcontextblockgui\";i:27;s:24:\"ilnewsforcontextblockgui\";i:28;s:24:\"ilnewsforcontextblockgui\";i:29;s:24:\"ilnewsforcontextblockgui\";i:30;s:24:\"ilnewsforcontextblockgui\";i:31;s:24:\"ilnewsforcontextblockgui\";i:32;s:24:\"ilnewsforcontextblockgui\";i:33;s:24:\"ilnewsforcontextblockgui\";i:34;s:24:\"ilnewsforcontextblockgui\";i:35;s:24:\"ilnewsforcontextblockgui\";i:36;s:24:\"ilnewsforcontextblockgui\";i:37;s:24:\"ilnewsforcontextblockgui\";}s:22:\"ilpublicuserprofilegui\";a:89:{i:0;s:21:\"ilusersonlineblockgui\";i:1;s:21:\"ilusersonlineblockgui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:21:\"ilusersonlineblockgui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:21:\"ilusersonlineblockgui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:12:\"ilobjchatgui\";i:9;s:21:\"ilusersonlineblockgui\";i:10;s:21:\"ilusersonlineblockgui\";i:11;s:21:\"ilusersonlineblockgui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:14:\"ilobjcoursegui\";i:16;s:21:\"ilusersonlineblockgui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:21:\"ilusersonlineblockgui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:15:\"ilpageobjectgui\";i:21;s:21:\"ilusersonlineblockgui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:21:\"ilusersonlineblockgui\";i:24;s:15:\"ilinfoscreengui\";i:25;s:15:\"ilpageobjectgui\";i:26;s:21:\"ilusersonlineblockgui\";i:27;s:15:\"ilinfoscreengui\";i:28;s:15:\"ilpageobjectgui\";i:29;s:21:\"ilusersonlineblockgui\";i:30;s:21:\"ilusersonlineblockgui\";i:31;s:21:\"ilusersonlineblockgui\";i:32;s:15:\"ilinfoscreengui\";i:33;s:15:\"ilpageobjectgui\";i:34;s:21:\"ilusersonlineblockgui\";i:35;s:21:\"ilusersonlineblockgui\";i:36;s:15:\"ilinfoscreengui\";i:37;s:13:\"ilobjforumgui\";i:38;s:15:\"ilpageobjectgui\";i:39;s:15:\"ilpageobjectgui\";i:40;s:21:\"ilusersonlineblockgui\";i:41;s:15:\"ilinfoscreengui\";i:42;s:21:\"ilusersonlineblockgui\";i:43;s:21:\"ilusersonlineblockgui\";i:44;s:21:\"ilusersonlineblockgui\";i:45;s:15:\"ilinfoscreengui\";i:46;s:15:\"ilpageobjectgui\";i:47;s:13:\"ilobjgroupgui\";i:48;s:21:\"ilusersonlineblockgui\";i:49;s:15:\"ilinfoscreengui\";i:50;s:19:\"ilobjilinccoursegui\";i:51;s:21:\"ilusersonlineblockgui\";i:52;s:15:\"ilinfoscreengui\";i:53;s:15:\"ilpageobjectgui\";i:54;s:21:\"ilusersonlineblockgui\";i:55;s:15:\"ilinfoscreengui\";i:56;s:21:\"ilusersonlineblockgui\";i:57;s:15:\"ilinfoscreengui\";i:58;s:21:\"ilusersonlineblockgui\";i:59;s:15:\"ilinfoscreengui\";i:60;s:21:\"ilusersonlineblockgui\";i:61;s:21:\"ilusersonlineblockgui\";i:62;s:21:\"ilusersonlineblockgui\";i:63;s:15:\"ilinfoscreengui\";i:64;s:15:\"ilpageobjectgui\";i:65;s:15:\"ilpageobjectgui\";i:66;s:21:\"ilusersonlineblockgui\";i:67;s:15:\"ilinfoscreengui\";i:68;s:21:\"ilusersonlineblockgui\";i:69;s:15:\"ilpageobjectgui\";i:70;s:21:\"ilusersonlineblockgui\";i:71;s:15:\"ilinfoscreengui\";i:72;s:21:\"ilusersonlineblockgui\";i:73;s:15:\"ilinfoscreengui\";i:74;s:21:\"ilusersonlineblockgui\";i:75;s:15:\"ilinfoscreengui\";i:76;s:21:\"ilusersonlineblockgui\";i:77;s:21:\"ilusersonlineblockgui\";i:78;s:21:\"ilusersonlineblockgui\";i:79;s:15:\"ilinfoscreengui\";i:80;s:15:\"ilpageobjectgui\";i:81;s:15:\"ilpageobjectgui\";i:82;s:14:\"ilobjcoursegui\";i:83;s:15:\"ilpageobjectgui\";i:84;s:21:\"ilusersonlineblockgui\";i:85;s:15:\"ilinfoscreengui\";i:86;s:15:\"ilpageobjectgui\";i:87;s:13:\"ilwikipagegui\";i:88;s:12:\"ilobjwikigui\";}s:18:\"ilbookmarkblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:18:\"ilcalendarblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:15:\"ildummyblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:22:\"ilexternalfeedblockgui\";a:39:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:20:\"ilobjexternalfeedgui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";i:38;s:11:\"ilcolumngui\";}s:14:\"ilhtmlblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:24:\"ilnewsforcontextblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:20:\"ilpdcalendarblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:24:\"ilpdexternalfeedblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:20:\"ilpdfeedbackblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:16:\"ilpdmailblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:16:\"ilpdnewsblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:17:\"ilpdnotesblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:25:\"ilpdselecteditemsblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:22:\"ilpdsysmessageblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:19:\"ilpdtaggingblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:21:\"ilusersonlineblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:11:\"ilcolumngui\";a:38:{i:0;s:15:\"ilinfoscreengui\";i:1;s:16:\"ilobjcategorygui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:18:\"ilcoursecontentgui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:14:\"ilobjcoursegui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";i:10;s:15:\"ilinfoscreengui\";i:11;s:15:\"ilinfoscreengui\";i:12;s:18:\"ilcoursecontentgui\";i:13;s:15:\"ilinfoscreengui\";i:14;s:14:\"ilobjfoldergui\";i:15;s:15:\"ilinfoscreengui\";i:16;s:13:\"ilobjforumgui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:18:\"ilcoursecontentgui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:13:\"ilobjgroupgui\";i:21;s:15:\"ilinfoscreengui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:15:\"ilinfoscreengui\";i:24;s:15:\"ilinfoscreengui\";i:25;s:15:\"ilinfoscreengui\";i:26;s:18:\"ilcoursecontentgui\";i:27;s:15:\"ilinfoscreengui\";i:28;s:14:\"ilobjfoldergui\";i:29;s:15:\"ilinfoscreengui\";i:30;s:18:\"ilobjrootfoldergui\";i:31;s:15:\"ilinfoscreengui\";i:32;s:15:\"ilinfoscreengui\";i:33;s:15:\"ilinfoscreengui\";i:34;s:18:\"ilcoursecontentgui\";i:35;s:15:\"ilinfoscreengui\";i:36;s:14:\"ilobjcoursegui\";i:37;s:15:\"ilinfoscreengui\";}s:13:\"ilfeedbackgui\";a:25:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";i:10;s:15:\"ilinfoscreengui\";i:11;s:15:\"ilinfoscreengui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:15:\"ilinfoscreengui\";i:14;s:15:\"ilinfoscreengui\";i:15;s:15:\"ilinfoscreengui\";i:16;s:15:\"ilinfoscreengui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:15:\"ilinfoscreengui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:15:\"ilinfoscreengui\";i:21;s:15:\"ilinfoscreengui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:15:\"ilinfoscreengui\";i:24;s:15:\"ilinfoscreengui\";}s:9:\"ilnotegui\";a:26:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";i:10;s:15:\"ilinfoscreengui\";i:11;s:15:\"ilinfoscreengui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:15:\"ilinfoscreengui\";i:14;s:15:\"ilinfoscreengui\";i:15;s:15:\"ilinfoscreengui\";i:16;s:15:\"ilinfoscreengui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:15:\"ilinfoscreengui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:15:\"ilinfoscreengui\";i:21;s:15:\"ilinfoscreengui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:15:\"ilinfoscreengui\";i:24;s:15:\"ilinfoscreengui\";i:25;s:13:\"ilwikipagegui\";}s:13:\"illpfiltergui\";a:24:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:24:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:12:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:20:\"illplistofobjectsgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:20:\"illplistofobjectsgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:12:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:12:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:12:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:12:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";}s:21:\"illearningprogressgui\";a:12:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:14:\"ilobjdlbookgui\";i:4;s:16:\"ilobjexercisegui\";i:5;s:19:\"ilobjfilebasedlmgui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:13:\"ilobjgroupgui\";i:8;s:22:\"ilobjlearningmodulegui\";i:9;s:14:\"ilobjfoldergui\";i:10;s:14:\"ilobjcoursegui\";i:11;s:12:\"ilobjtestgui\";}s:17:\"ilobjilincusergui\";a:2:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";}s:12:\"ilobjusergui\";a:2:{i:0;s:20:\"iladminusersearchgui\";i:1;s:16:\"ilobjcategorygui\";}s:12:\"ilobjrolegui\";a:32:{i:0;s:15:\"ilpermissiongui\";i:1;s:15:\"ilpermissiongui\";i:2;s:15:\"ilpermissiongui\";i:3;s:15:\"ilpermissiongui\";i:4;s:15:\"ilpermissiongui\";i:5;s:15:\"ilpermissiongui\";i:6;s:15:\"ilpermissiongui\";i:7;s:15:\"ilpermissiongui\";i:8;s:15:\"ilpermissiongui\";i:9;s:15:\"ilpermissiongui\";i:10;s:15:\"ilpermissiongui\";i:11;s:15:\"ilpermissiongui\";i:12;s:15:\"ilpermissiongui\";i:13;s:15:\"ilpermissiongui\";i:14;s:15:\"ilpermissiongui\";i:15;s:15:\"ilpermissiongui\";i:16;s:15:\"ilpermissiongui\";i:17;s:15:\"ilpermissiongui\";i:18;s:15:\"ilpermissiongui\";i:19;s:15:\"ilpermissiongui\";i:20;s:15:\"ilpermissiongui\";i:21;s:15:\"ilpermissiongui\";i:22;s:15:\"ilpermissiongui\";i:23;s:15:\"ilpermissiongui\";i:24;s:15:\"ilpermissiongui\";i:25;s:15:\"ilpermissiongui\";i:26;s:15:\"ilpermissiongui\";i:27;s:15:\"ilpermissiongui\";i:28;s:15:\"ilpermissiongui\";i:29;s:15:\"ilpermissiongui\";i:30;s:15:\"ilpermissiongui\";i:31;s:15:\"ilrepositorygui\";}s:20:\"iladminusersearchgui\";a:1:{i:0;s:18:\"ilobjuserfoldergui\";}s:15:\"ilpermissiongui\";a:31:{i:0;s:18:\"ilobjuserfoldergui\";i:1;s:16:\"ilobjcategorygui\";i:2;s:25:\"ilobjcategoryreferencegui\";i:3;s:12:\"ilobjchatgui\";i:4;s:14:\"ilobjcoursegui\";i:5;s:23:\"ilobjcoursereferencegui\";i:6;s:14:\"ilobjdlbookgui\";i:7;s:16:\"ilobjexercisegui\";i:8;s:20:\"ilobjexternalfeedgui\";i:9;s:19:\"ilobjfilebasedlmgui\";i:10;s:12:\"ilobjfilegui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:13:\"ilobjforumgui\";i:13;s:16:\"ilobjglossarygui\";i:14;s:13:\"ilobjgroupgui\";i:15;s:19:\"ilobjilinccoursegui\";i:16;s:22:\"ilobjlearningmodulegui\";i:17;s:20:\"ilobjlinkresourcegui\";i:18;s:17:\"ilobjmediacastgui\";i:19;s:14:\"ilobjfoldergui\";i:20;s:17:\"ilobjmediapoolgui\";i:21;s:20:\"ilobjquestionpoolgui\";i:22;s:20:\"ilobjremotecoursegui\";i:23;s:18:\"ilobjrootfoldergui\";i:24;s:26:\"ilobjsahslearningmodulegui\";i:25;s:15:\"ilobjsessiongui\";i:26;s:14:\"ilobjsurveygui\";i:27;s:26:\"ilobjsurveyquestionpoolgui\";i:28;s:14:\"ilobjcoursegui\";i:29;s:12:\"ilobjtestgui\";i:30;s:12:\"ilobjwikigui\";}s:17:\"ilinternallinkgui\";a:97:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:19:\"ilimagemapeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:21:\"ilpcimagemapeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:19:\"ilimagemapeditorgui\";i:6;s:19:\"ilimagemapeditorgui\";i:7;s:19:\"ilimagemapeditorgui\";i:8;s:21:\"ilpcimagemapeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:19:\"ilimagemapeditorgui\";i:11;s:19:\"ilimagemapeditorgui\";i:12;s:19:\"ilimagemapeditorgui\";i:13;s:21:\"ilpcimagemapeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:19:\"ilimagemapeditorgui\";i:16;s:19:\"ilimagemapeditorgui\";i:17;s:19:\"ilimagemapeditorgui\";i:18;s:21:\"ilpcimagemapeditorgui\";i:19;s:15:\"ilpageeditorgui\";i:20;s:19:\"ilimagemapeditorgui\";i:21;s:19:\"ilimagemapeditorgui\";i:22;s:19:\"ilimagemapeditorgui\";i:23;s:21:\"ilpcimagemapeditorgui\";i:24;s:15:\"ilpageeditorgui\";i:25;s:19:\"ilimagemapeditorgui\";i:26;s:19:\"ilimagemapeditorgui\";i:27;s:19:\"ilimagemapeditorgui\";i:28;s:21:\"ilpcimagemapeditorgui\";i:29;s:15:\"ilpageeditorgui\";i:30;s:19:\"ilimagemapeditorgui\";i:31;s:19:\"ilimagemapeditorgui\";i:32;s:19:\"ilimagemapeditorgui\";i:33;s:21:\"ilpcimagemapeditorgui\";i:34;s:15:\"ilpageeditorgui\";i:35;s:19:\"ilimagemapeditorgui\";i:36;s:19:\"ilimagemapeditorgui\";i:37;s:19:\"ilimagemapeditorgui\";i:38;s:21:\"ilpcimagemapeditorgui\";i:39;s:15:\"ilpageeditorgui\";i:40;s:19:\"ilimagemapeditorgui\";i:41;s:19:\"ilimagemapeditorgui\";i:42;s:19:\"ilimagemapeditorgui\";i:43;s:21:\"ilpcimagemapeditorgui\";i:44;s:15:\"ilpageeditorgui\";i:45;s:19:\"ilimagemapeditorgui\";i:46;s:19:\"ilimagemapeditorgui\";i:47;s:19:\"ilimagemapeditorgui\";i:48;s:21:\"ilpcimagemapeditorgui\";i:49;s:15:\"ilpageeditorgui\";i:50;s:19:\"ilimagemapeditorgui\";i:51;s:19:\"ilimagemapeditorgui\";i:52;s:19:\"ilimagemapeditorgui\";i:53;s:21:\"ilpcimagemapeditorgui\";i:54;s:15:\"ilpageeditorgui\";i:55;s:19:\"ilimagemapeditorgui\";i:56;s:19:\"ilimagemapeditorgui\";i:57;s:19:\"ilimagemapeditorgui\";i:58;s:19:\"ilimagemapeditorgui\";i:59;s:21:\"ilpcimagemapeditorgui\";i:60;s:15:\"ilpageeditorgui\";i:61;s:19:\"ilimagemapeditorgui\";i:62;s:19:\"ilimagemapeditorgui\";i:63;s:19:\"ilimagemapeditorgui\";i:64;s:19:\"ilimagemapeditorgui\";i:65;s:21:\"ilpcimagemapeditorgui\";i:66;s:15:\"ilpageeditorgui\";i:67;s:19:\"ilimagemapeditorgui\";i:68;s:19:\"ilimagemapeditorgui\";i:69;s:19:\"ilimagemapeditorgui\";i:70;s:21:\"ilpcimagemapeditorgui\";i:71;s:15:\"ilpageeditorgui\";i:72;s:19:\"ilimagemapeditorgui\";i:73;s:19:\"ilimagemapeditorgui\";i:74;s:19:\"ilimagemapeditorgui\";i:75;s:21:\"ilpcimagemapeditorgui\";i:76;s:15:\"ilpageeditorgui\";i:77;s:19:\"ilimagemapeditorgui\";i:78;s:19:\"ilimagemapeditorgui\";i:79;s:19:\"ilimagemapeditorgui\";i:80;s:21:\"ilpcimagemapeditorgui\";i:81;s:15:\"ilpageeditorgui\";i:82;s:19:\"ilimagemapeditorgui\";i:83;s:19:\"ilimagemapeditorgui\";i:84;s:19:\"ilimagemapeditorgui\";i:85;s:21:\"ilpcimagemapeditorgui\";i:86;s:15:\"ilpageeditorgui\";i:87;s:19:\"ilimagemapeditorgui\";i:88;s:19:\"ilimagemapeditorgui\";i:89;s:19:\"ilimagemapeditorgui\";i:90;s:21:\"ilpcimagemapeditorgui\";i:91;s:15:\"ilpageeditorgui\";i:92;s:19:\"ilimagemapeditorgui\";i:93;s:19:\"ilimagemapeditorgui\";i:94;s:19:\"ilimagemapeditorgui\";i:95;s:21:\"ilpcimagemapeditorgui\";i:96;s:15:\"ilpageeditorgui\";}s:19:\"ilimagemapeditorgui\";a:59:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:19:\"ilobjmediaobjectgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:19:\"ilobjmediaobjectgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:19:\"ilobjmediaobjectgui\";i:17;s:19:\"ilobjmediaobjectgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:19:\"ilobjmediaobjectgui\";i:22;s:19:\"ilobjmediaobjectgui\";i:23;s:19:\"ilobjmediaobjectgui\";i:24;s:19:\"ilobjmediaobjectgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:19:\"ilobjmediaobjectgui\";i:28;s:19:\"ilobjmediaobjectgui\";i:29;s:19:\"ilobjmediaobjectgui\";i:30;s:19:\"ilobjmediaobjectgui\";i:31;s:19:\"ilobjmediaobjectgui\";i:32;s:19:\"ilobjmediaobjectgui\";i:33;s:19:\"ilobjmediaobjectgui\";i:34;s:19:\"ilobjmediaobjectgui\";i:35;s:19:\"ilobjmediaobjectgui\";i:36;s:19:\"ilobjmediaobjectgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:19:\"ilobjmediaobjectgui\";i:39;s:19:\"ilobjmediaobjectgui\";i:40;s:19:\"ilobjmediaobjectgui\";i:41;s:19:\"ilobjmediaobjectgui\";i:42;s:19:\"ilobjmediaobjectgui\";i:43;s:19:\"ilobjmediaobjectgui\";i:44;s:19:\"ilobjmediaobjectgui\";i:45;s:19:\"ilobjmediaobjectgui\";i:46;s:19:\"ilobjmediaobjectgui\";i:47;s:19:\"ilobjmediaobjectgui\";i:48;s:19:\"ilobjmediaobjectgui\";i:49;s:19:\"ilobjmediaobjectgui\";i:50;s:19:\"ilobjmediaobjectgui\";i:51;s:19:\"ilobjmediaobjectgui\";i:52;s:19:\"ilobjmediaobjectgui\";i:53;s:19:\"ilobjmediaobjectgui\";i:54;s:19:\"ilobjmediaobjectgui\";i:55;s:19:\"ilobjmediaobjectgui\";i:56;s:19:\"ilobjmediaobjectgui\";i:57;s:19:\"ilobjmediaobjectgui\";i:58;s:19:\"ilobjmediaobjectgui\";}s:13:\"ilmdeditorgui\";a:93:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:15:\"ilpageobjectgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:14:\"ilobjcoursegui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:15:\"ilpageobjectgui\";i:17;s:20:\"ilstructureobjectgui\";i:18;s:14:\"ilobjdlbookgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:19:\"ilobjmediaobjectgui\";i:22;s:15:\"ilpageobjectgui\";i:23;s:19:\"ilobjfilebasedlmgui\";i:24;s:19:\"ilobjmediaobjectgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:15:\"ilpageobjectgui\";i:28;s:12:\"ilobjfilegui\";i:29;s:19:\"ilobjmediaobjectgui\";i:30;s:19:\"ilobjmediaobjectgui\";i:31;s:19:\"ilobjmediaobjectgui\";i:32;s:15:\"ilpageobjectgui\";i:33;s:19:\"ilobjmediaobjectgui\";i:34;s:19:\"ilobjmediaobjectgui\";i:35;s:19:\"ilobjmediaobjectgui\";i:36;s:15:\"ilpageobjectgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:19:\"ilobjmediaobjectgui\";i:39;s:19:\"ilobjmediaobjectgui\";i:40;s:15:\"ilpageobjectgui\";i:41;s:25:\"iltermdefinitioneditorgui\";i:42;s:16:\"ilobjglossarygui\";i:43;s:19:\"ilobjmediaobjectgui\";i:44;s:19:\"ilobjmediaobjectgui\";i:45;s:19:\"ilobjmediaobjectgui\";i:46;s:15:\"ilpageobjectgui\";i:47;s:19:\"ilobjmediaobjectgui\";i:48;s:19:\"ilobjmediaobjectgui\";i:49;s:19:\"ilobjmediaobjectgui\";i:50;s:15:\"ilpageobjectgui\";i:51;s:20:\"ilstructureobjectgui\";i:52;s:22:\"ilobjlearningmodulegui\";i:53;s:20:\"ilobjlinkresourcegui\";i:54;s:19:\"ilobjmediaobjectgui\";i:55;s:19:\"ilobjmediaobjectgui\";i:56;s:19:\"ilobjmediaobjectgui\";i:57;s:19:\"ilobjmediaobjectgui\";i:58;s:15:\"ilpageobjectgui\";i:59;s:19:\"ilobjmediaobjectgui\";i:60;s:19:\"ilobjmediaobjectgui\";i:61;s:19:\"ilobjmediaobjectgui\";i:62;s:19:\"ilobjmediaobjectgui\";i:63;s:15:\"ilpageobjectgui\";i:64;s:20:\"ilobjquestionpoolgui\";i:65;s:19:\"ilobjmediaobjectgui\";i:66;s:19:\"ilobjmediaobjectgui\";i:67;s:19:\"ilobjmediaobjectgui\";i:68;s:15:\"ilpageobjectgui\";i:69;s:26:\"ilobjsahslearningmodulegui\";i:70;s:14:\"ilobjsurveygui\";i:71;s:26:\"ilobjsurveyquestionpoolgui\";i:72;s:19:\"ilobjmediaobjectgui\";i:73;s:19:\"ilobjmediaobjectgui\";i:74;s:19:\"ilobjmediaobjectgui\";i:75;s:15:\"ilpageobjectgui\";i:76;s:19:\"ilobjmediaobjectgui\";i:77;s:19:\"ilobjmediaobjectgui\";i:78;s:19:\"ilobjmediaobjectgui\";i:79;s:15:\"ilpageobjectgui\";i:80;s:14:\"ilobjcoursegui\";i:81;s:19:\"ilobjmediaobjectgui\";i:82;s:19:\"ilobjmediaobjectgui\";i:83;s:19:\"ilobjmediaobjectgui\";i:84;s:15:\"ilpageobjectgui\";i:85;s:12:\"ilobjtestgui\";i:86;s:19:\"ilobjmediaobjectgui\";i:87;s:19:\"ilobjmediaobjectgui\";i:88;s:19:\"ilobjmediaobjectgui\";i:89;s:19:\"ilobjmediaobjectgui\";i:90;s:19:\"ilobjmediaobjectgui\";i:91;s:19:\"ilobjmediaobjectgui\";i:92;s:15:\"ilpageobjectgui\";}s:19:\"ilobjmediaobjectgui\";a:59:{i:0;s:18:\"ileditclipboardgui\";i:1;s:18:\"ilpcmediaobjectgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:18:\"ileditclipboardgui\";i:4;s:18:\"ilpcmediaobjectgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:18:\"ileditclipboardgui\";i:7;s:18:\"ilpcmediaobjectgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:18:\"ileditclipboardgui\";i:10;s:18:\"ilpcmediaobjectgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:18:\"ilpcmediaobjectgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:18:\"ileditclipboardgui\";i:16;s:18:\"ilpcmediaobjectgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:18:\"ileditclipboardgui\";i:19;s:18:\"ilpcmediaobjectgui\";i:20;s:15:\"ilpageeditorgui\";i:21;s:18:\"ileditclipboardgui\";i:22;s:18:\"ilpcmediaobjectgui\";i:23;s:15:\"ilpageeditorgui\";i:24;s:18:\"ileditclipboardgui\";i:25;s:18:\"ilpcmediaobjectgui\";i:26;s:15:\"ilpageeditorgui\";i:27;s:18:\"ileditclipboardgui\";i:28;s:18:\"ilpcmediaobjectgui\";i:29;s:15:\"ilpageeditorgui\";i:30;s:18:\"ileditclipboardgui\";i:31;s:18:\"ilpcmediaobjectgui\";i:32;s:15:\"ilpageeditorgui\";i:33;s:18:\"ileditclipboardgui\";i:34;s:18:\"ileditclipboardgui\";i:35;s:18:\"ilpcmediaobjectgui\";i:36;s:15:\"ilpageeditorgui\";i:37;s:17:\"ilobjmediapoolgui\";i:38;s:18:\"ileditclipboardgui\";i:39;s:18:\"ilpcmediaobjectgui\";i:40;s:15:\"ilpageeditorgui\";i:41;s:18:\"ileditclipboardgui\";i:42;s:18:\"ilpcmediaobjectgui\";i:43;s:15:\"ilpageeditorgui\";i:44;s:18:\"ileditclipboardgui\";i:45;s:18:\"ilpcmediaobjectgui\";i:46;s:15:\"ilpageeditorgui\";i:47;s:18:\"ileditclipboardgui\";i:48;s:18:\"ilpcmediaobjectgui\";i:49;s:15:\"ilpageeditorgui\";i:50;s:18:\"ileditclipboardgui\";i:51;s:18:\"ilpcmediaobjectgui\";i:52;s:15:\"ilpageeditorgui\";i:53;s:18:\"ileditclipboardgui\";i:54;s:18:\"ilpcmediaobjectgui\";i:55;s:15:\"ilpageeditorgui\";i:56;s:18:\"ileditclipboardgui\";i:57;s:18:\"ilpcmediaobjectgui\";i:58;s:15:\"ilpageeditorgui\";}s:21:\"ilpcimagemapeditorgui\";a:19:{i:0;s:18:\"ilpcmediaobjectgui\";i:1;s:18:\"ilpcmediaobjectgui\";i:2;s:18:\"ilpcmediaobjectgui\";i:3;s:18:\"ilpcmediaobjectgui\";i:4;s:18:\"ilpcmediaobjectgui\";i:5;s:18:\"ilpcmediaobjectgui\";i:6;s:18:\"ilpcmediaobjectgui\";i:7;s:18:\"ilpcmediaobjectgui\";i:8;s:18:\"ilpcmediaobjectgui\";i:9;s:18:\"ilpcmediaobjectgui\";i:10;s:18:\"ilpcmediaobjectgui\";i:11;s:18:\"ilpcmediaobjectgui\";i:12;s:18:\"ilpcmediaobjectgui\";i:13;s:18:\"ilpcmediaobjectgui\";i:14;s:18:\"ilpcmediaobjectgui\";i:15;s:18:\"ilpcmediaobjectgui\";i:16;s:18:\"ilpcmediaobjectgui\";i:17;s:18:\"ilpcmediaobjectgui\";i:18;s:18:\"ilpcmediaobjectgui\";}s:16:\"ilpcdatatablegui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfileitemgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfilelistgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:11:\"ilpclistgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:15:\"ilpclistitemgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:10:\"ilpcmapgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:18:\"ilpcmediaobjectgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:16:\"ilpcparagraphgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:14:\"ilpcpluggedgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:15:\"ilpcquestiongui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:16:\"ilpcresourcesgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:14:\"ilpcsectiongui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:17:\"ilpcsourcecodegui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:16:\"ilpctabledatagui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:12:\"ilpctablegui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:11:\"ilpctabsgui\";a:19:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";}s:18:\"ileditclipboardgui\";a:20:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpageobjectgui\";i:7;s:15:\"ilpageobjectgui\";i:8;s:15:\"ilpageobjectgui\";i:9;s:15:\"ilpageobjectgui\";i:10;s:15:\"ilpageobjectgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:17:\"ilobjmediapoolgui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:15:\"ilpageobjectgui\";i:16;s:15:\"ilpageobjectgui\";i:17;s:15:\"ilpageobjectgui\";i:18;s:15:\"ilpageobjectgui\";i:19;s:13:\"ilwikipagegui\";}s:15:\"ilpageeditorgui\";a:19:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpageobjectgui\";i:7;s:15:\"ilpageobjectgui\";i:8;s:15:\"ilpageobjectgui\";i:9;s:15:\"ilpageobjectgui\";i:10;s:15:\"ilpageobjectgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:15:\"ilpageobjectgui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:15:\"ilpageobjectgui\";i:16;s:15:\"ilpageobjectgui\";i:17;s:15:\"ilpageobjectgui\";i:18;s:13:\"ilwikipagegui\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:16:\"ilobjcategorygui\";i:1;s:18:\"ilobjrootfoldergui\";}s:15:\"ilinfoscreengui\";a:25:{i:0;s:16:\"ilobjcategorygui\";i:1;s:25:\"ilobjcategoryreferencegui\";i:2;s:12:\"ilobjchatgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:23:\"ilobjcoursereferencegui\";i:5;s:14:\"ilobjdlbookgui\";i:6;s:16:\"ilobjexercisegui\";i:7;s:19:\"ilobjfilebasedlmgui\";i:8;s:12:\"ilobjfilegui\";i:9;s:14:\"ilobjfoldergui\";i:10;s:13:\"ilobjforumgui\";i:11;s:16:\"ilobjglossarygui\";i:12;s:13:\"ilobjgroupgui\";i:13;s:19:\"ilobjilinccoursegui\";i:14;s:22:\"ilobjlearningmodulegui\";i:15;s:20:\"ilobjlinkresourcegui\";i:16;s:17:\"ilobjmediacastgui\";i:17;s:14:\"ilobjfoldergui\";i:18;s:17:\"ilobjmediapoolgui\";i:19;s:20:\"ilobjremotecoursegui\";i:20;s:15:\"ilobjsessiongui\";i:21;s:14:\"ilobjsurveygui\";i:22;s:14:\"ilobjcoursegui\";i:23;s:12:\"ilobjtestgui\";i:24;s:12:\"ilobjwikigui\";}s:18:\"ilobjuserfoldergui\";a:1:{i:0;s:16:\"ilobjcategorygui\";}s:15:\"ilpageobjectgui\";a:18:{i:0;s:16:\"ilobjcategorygui\";i:1;s:17:\"ilshoppurchasegui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:17:\"illmpageobjectgui\";i:4;s:17:\"ilshoppurchasegui\";i:5;s:17:\"ilshoppurchasegui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:25:\"iltermdefinitioneditorgui\";i:8;s:17:\"ilglossarytermgui\";i:9;s:13:\"ilobjgroupgui\";i:10;s:17:\"illmpageobjectgui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:20:\"ilobjquestionpoolgui\";i:13;s:18:\"ilobjrootfoldergui\";i:14;s:17:\"ilshoppurchasegui\";i:15;s:14:\"ilobjcoursegui\";i:16;s:17:\"ilshoppurchasegui\";i:17;s:13:\"ilwikipagegui\";}s:19:\"ilcoursearchivesgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:32:\"ilcourseobjectivepresentationgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:27:\"ilconditionhandlerinterface\";a:12:{i:0;s:29:\"ilcourseitemadministrationgui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:20:\"ilstructureobjectgui\";i:3;s:29:\"ilcourseitemadministrationgui\";i:4;s:14:\"ilobjfoldergui\";i:5;s:29:\"ilcourseitemadministrationgui\";i:6;s:13:\"ilobjgroupgui\";i:7;s:20:\"ilstructureobjectgui\";i:8;s:29:\"ilcourseitemadministrationgui\";i:9;s:14:\"ilobjfoldergui\";i:10;s:29:\"ilcourseitemadministrationgui\";i:11;s:14:\"ilobjcoursegui\";}s:20:\"ilcourseagreementgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:18:\"ilcoursecontentgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:14:\"ilobjfoldergui\";i:4;s:14:\"ilobjcoursegui\";}s:29:\"ilcourseitemadministrationgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:14:\"ilobjfoldergui\";i:4;s:14:\"ilobjcoursegui\";}s:21:\"ilcourseobjectivesgui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:15:\"ilrepositorygui\";}s:23:\"ilcourseregistrationgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:21:\"ilcourseuserfieldsgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:17:\"ilmemberexportgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:22:\"ilobjcoursegroupinggui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:13:\"ilobjgroupgui\";i:2;s:14:\"ilobjcoursegui\";}s:21:\"ilrepositorysearchgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:16:\"ilobjexercisegui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:19:\"ilobjilinccoursegui\";i:4;s:14:\"ilobjcoursegui\";}s:20:\"ilsessionoverviewgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:17:\"ilshoppurchasegui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:19:\"ilobjfilebasedlmgui\";i:2;s:12:\"ilobjfilegui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:12:\"ilobjtestgui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:20:\"ilstructureobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:15:\"ilfilesystemgui\";a:2:{i:0;s:19:\"ilobjfilebasedlmgui\";i:1;s:26:\"ilobjsahslearningmodulegui\";}s:16:\"ilforumexportgui\";a:1:{i:0;s:13:\"ilobjforumgui\";}s:25:\"iltermdefinitioneditorgui\";a:1:{i:0;s:17:\"ilglossarytermgui\";}s:17:\"ilglossarytermgui\";a:1:{i:0;s:16:\"ilobjglossarygui\";}s:22:\"ilgroupregistrationgui\";a:1:{i:0;s:13:\"ilobjgroupgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:19:\"ilobjilinccoursegui\";i:1;s:15:\"ilrepositorygui\";}s:14:\"ilobjfoldergui\";a:2:{i:0;s:17:\"ilobjmediapoolgui\";i:1;s:15:\"ilrepositorygui\";}s:15:\"assclozetestgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assimagemapquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"assjavaappletgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assmatchingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:20:\"assmultiplechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:13:\"assnumericgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assorderingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:26:\"assquestiontypetemplategui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asssinglechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asstextquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"asstextsubsetgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:21:\"ilsurveyevaluationgui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:20:\"ilsurveyexecutiongui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:18:\"ilsurveyphrasesgui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:23:\"surveymatrixquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:23:\"surveymetricquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveynominalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveyordinalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:21:\"surveytextquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:14:\"ilobjcoursegui\";a:2:{i:0;s:12:\"ilobjtestgui\";i:1;s:15:\"ilrepositorygui\";}s:20:\"iltestcertificategui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:19:\"iltestevaluationgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:15:\"iltestoutputgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:16:\"iltestscoringgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:16:\"iltestservicegui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:25:\"ilmediapooltargetselector\";a:1:{i:0;s:13:\"ilwikipagegui\";}s:11:\"ilratinggui\";a:1:{i:0;s:13:\"ilwikipagegui\";}s:13:\"ilwikipagegui\";a:1:{i:0;s:12:\"ilobjwikigui\";}s:16:\"ilobjcategorygui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:25:\"ilobjcategoryreferencegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:12:\"ilobjchatgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:23:\"ilobjcoursereferencegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:14:\"ilobjdlbookgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:16:\"ilobjexercisegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:20:\"ilobjexternalfeedgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:19:\"ilobjfilebasedlmgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:12:\"ilobjfilegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:13:\"ilobjforumgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:16:\"ilobjglossarygui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:13:\"ilobjgroupgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:19:\"ilobjilinccoursegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:22:\"ilobjlearningmodulegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:20:\"ilobjlinkresourcegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:17:\"ilobjmediacastgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:17:\"ilobjmediapoolgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:20:\"ilobjquestionpoolgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:20:\"ilobjremotecoursegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:18:\"ilobjrootfoldergui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:26:\"ilobjsahslearningmodulegui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:15:\"ilobjsessiongui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:14:\"ilobjsurveygui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:12:\"ilobjtestgui\";a:1:{i:0;s:15:\"ilrepositorygui\";}s:12:\"ilobjwikigui\";a:1:{i:0;s:15:\"ilrepositorygui\";}}');
INSERT INTO `ctrl_structure` VALUES ('ilpersonaldesktopgui','a:101:{i:1;a:2:{s:5:\"class\";s:20:\"ilpersonaldesktopgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:27:\"ilbookmarkadministrationgui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2;}i:4;a:2:{s:5:\"class\";s:25:\"ilcalendarpresentationgui\";s:6:\"parent\";i:1;}i:5;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:4;}i:6;a:2:{s:5:\"class\";s:21:\"ilcalendarcategorygui\";s:6:\"parent\";i:4;}i:7;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:6;}i:8;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:4;}i:9;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:8;}i:10;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:4;}i:11;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:10;}i:12;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:4;}i:13;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:12;}i:14;a:2:{s:5:\"class\";s:25:\"ilcalendarusersettingsgui\";s:6:\"parent\";i:4;}i:15;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:14;}i:16;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:4;}i:17;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:16;}i:18;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1;}i:19;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:18;}i:20;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:18;}i:21;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:18;}i:22;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:21;}i:23;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:21;}i:24;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:23;}i:25;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:21;}i:26;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:25;}i:27;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:21;}i:28;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:27;}i:29;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:21;}i:30;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:29;}i:31;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:18;}i:32;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:18;}i:33;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:18;}i:34;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:18;}i:35;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:34;}i:36;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:18;}i:37;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:36;}i:38;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:36;}i:39;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:38;}i:40;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:36;}i:41;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:40;}i:42;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:36;}i:43;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:42;}i:44;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:36;}i:45;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:44;}i:46;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:18;}i:47;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:18;}i:48;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:18;}i:49;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:18;}i:50;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:18;}i:51;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:18;}i:52;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:18;}i:53;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:18;}i:54;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:18;}i:55;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:54;}i:56;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1;}i:57;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:56;}i:58;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1;}i:59;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:58;}i:60;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:58;}i:61;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:60;}i:62;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:61;}i:63;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:60;}i:64;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:63;}i:65;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:60;}i:66;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:65;}i:67;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:58;}i:68;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:67;}i:69;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:68;}i:70;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:67;}i:71;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:70;}i:72;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:58;}i:73;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:72;}i:74;a:2:{s:5:\"class\";s:19:\"ilobjlanguageextgui\";s:6:\"parent\";i:1;}i:75;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:74;}i:76;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:1;}i:77;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:76;}i:78;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:77;}i:79;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:77;}i:80;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:79;}i:81;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:80;}i:82;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:79;}i:83;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:82;}i:84;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:79;}i:85;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:84;}i:86;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:77;}i:87;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:86;}i:88;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:87;}i:89;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:86;}i:90;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:89;}i:91;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:77;}i:92;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:91;}i:93;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:76;}i:94;a:2:{s:5:\"class\";s:11:\"ilpdnewsgui\";s:6:\"parent\";i:1;}i:95;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:94;}i:96;a:2:{s:5:\"class\";s:12:\"ilpdnotesgui\";s:6:\"parent\";i:1;}i:97;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:96;}i:98;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:97;}i:99;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:96;}i:100;a:2:{s:5:\"class\";s:20:\"ilpersonalprofilegui\";s:6:\"parent\";i:1;}i:101;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:100;}}','a:28:{s:0:\"\";a:54:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";}s:27:\"ilbookmarkadministrationgui\";a:1:{i:0;s:0:\"\";}s:21:\"ilcalendarcategorygui\";a:1:{i:0;s:24:\"ilcalendarappointmentgui\";}s:16:\"ilcalendardaygui\";a:3:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarinboxgui\";a:3:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarmonthgui\";a:3:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";}s:25:\"ilcalendarusersettingsgui\";a:1:{i:0;s:0:\"\";}s:17:\"ilcalendarweekgui\";a:3:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";}s:25:\"ilcalendarpresentationgui\";a:7:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:21:\"ilcalendarcategorygui\";i:2;s:16:\"ilcalendardaygui\";i:3;s:18:\"ilcalendarinboxgui\";i:4;s:18:\"ilcalendarmonthgui\";i:5;s:25:\"ilcalendarusersettingsgui\";i:6;s:17:\"ilcalendarweekgui\";}s:18:\"ilcalendarblockgui\";a:5:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";}s:24:\"ilnewsforcontextblockgui\";a:1:{i:0;s:13:\"ilnewsitemgui\";}s:20:\"ilpdcalendarblockgui\";a:5:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";}s:21:\"ilusersonlineblockgui\";a:1:{i:0;s:22:\"ilpublicuserprofilegui\";}s:11:\"ilcolumngui\";a:17:{i:0;s:0:\"\";i:1;s:18:\"ilbookmarkblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:15:\"ildummyblockgui\";i:4;s:22:\"ilexternalfeedblockgui\";i:5;s:14:\"ilhtmlblockgui\";i:6;s:24:\"ilnewsforcontextblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:24:\"ilpdexternalfeedblockgui\";i:9;s:20:\"ilpdfeedbackblockgui\";i:10;s:16:\"ilpdmailblockgui\";i:11;s:16:\"ilpdnewsblockgui\";i:12;s:17:\"ilpdnotesblockgui\";i:13;s:25:\"ilpdselecteditemsblockgui\";i:14;s:22:\"ilpdsysmessageblockgui\";i:15;s:19:\"ilpdtaggingblockgui\";i:16;s:21:\"ilusersonlineblockgui\";}s:13:\"ilfeedbackgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:13:\"illpfiltergui\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:6:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:4:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:21:\"illearningprogressgui\";a:8:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";}s:19:\"ilobjlanguageextgui\";a:1:{i:0;s:0:\"\";}s:12:\"ilobjusergui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"ilobjilincusergui\";}s:11:\"ilpdnewsgui\";a:1:{i:0;s:0:\"\";}s:12:\"ilpdnotesgui\";a:2:{i:0;s:13:\"ilfeedbackgui\";i:1;s:9:\"ilnotegui\";}s:20:\"ilpersonalprofilegui\";a:1:{i:0;s:0:\"\";}s:20:\"ilpersonaldesktopgui\";a:10:{i:0;s:27:\"ilbookmarkadministrationgui\";i:1;s:25:\"ilcalendarpresentationgui\";i:2;s:11:\"ilcolumngui\";i:3;s:13:\"ilfeedbackgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:19:\"ilobjlanguageextgui\";i:6;s:12:\"ilobjusergui\";i:7;s:11:\"ilpdnewsgui\";i:8;s:12:\"ilpdnotesgui\";i:9;s:20:\"ilpersonalprofilegui\";}}','a:45:{s:0:\"\";a:74:{i:0;s:0:\"\";i:1;s:27:\"ilbookmarkadministrationgui\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:25:\"ilcalendarusersettingsgui\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:11:\"ilcolumngui\";i:36;s:0:\"\";i:37;s:13:\"ilfeedbackgui\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:13:\"illpfiltergui\";i:41;s:0:\"\";i:42;s:17:\"ilpdfpresentation\";i:43;s:0:\"\";i:44;s:15:\"iluserfiltergui\";i:45;s:0:\"\";i:46;s:13:\"illpfiltergui\";i:47;s:0:\"\";i:48;s:17:\"ilpdfpresentation\";i:49;s:0:\"\";i:50;s:21:\"illplistofsettingsgui\";i:51;s:0:\"\";i:52;s:19:\"ilobjlanguageextgui\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:13:\"illpfiltergui\";i:56;s:0:\"\";i:57;s:17:\"ilpdfpresentation\";i:58;s:0:\"\";i:59;s:15:\"iluserfiltergui\";i:60;s:0:\"\";i:61;s:13:\"illpfiltergui\";i:62;s:0:\"\";i:63;s:17:\"ilpdfpresentation\";i:64;s:0:\"\";i:65;s:21:\"illplistofsettingsgui\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:11:\"ilpdnewsgui\";i:69;s:0:\"\";i:70;s:13:\"ilfeedbackgui\";i:71;s:0:\"\";i:72;s:0:\"\";i:73;s:20:\"ilpersonalprofilegui\";}s:24:\"ilcalendarappointmentgui\";a:16:{i:0;s:21:\"ilcalendarcategorygui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";i:5;s:25:\"ilcalendarpresentationgui\";i:6;s:16:\"ilcalendardaygui\";i:7;s:18:\"ilcalendarinboxgui\";i:8;s:18:\"ilcalendarmonthgui\";i:9;s:17:\"ilcalendarweekgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:16:\"ilcalendardaygui\";i:12;s:18:\"ilcalendarinboxgui\";i:13;s:18:\"ilcalendarmonthgui\";i:14;s:17:\"ilcalendarweekgui\";i:15;s:20:\"ilpdcalendarblockgui\";}s:21:\"ilcalendarcategorygui\";a:1:{i:0;s:25:\"ilcalendarpresentationgui\";}s:16:\"ilcalendardaygui\";a:3:{i:0;s:25:\"ilcalendarpresentationgui\";i:1;s:18:\"ilcalendarblockgui\";i:2;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarinboxgui\";a:3:{i:0;s:25:\"ilcalendarpresentationgui\";i:1;s:18:\"ilcalendarblockgui\";i:2;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarmonthgui\";a:3:{i:0;s:25:\"ilcalendarpresentationgui\";i:1;s:18:\"ilcalendarblockgui\";i:2;s:20:\"ilpdcalendarblockgui\";}s:25:\"ilcalendarusersettingsgui\";a:1:{i:0;s:25:\"ilcalendarpresentationgui\";}s:17:\"ilcalendarweekgui\";a:3:{i:0;s:25:\"ilcalendarpresentationgui\";i:1;s:18:\"ilcalendarblockgui\";i:2;s:20:\"ilpdcalendarblockgui\";}s:13:\"ilnewsitemgui\";a:1:{i:0;s:24:\"ilnewsforcontextblockgui\";}s:22:\"ilpublicuserprofilegui\";a:1:{i:0;s:21:\"ilusersonlineblockgui\";}s:18:\"ilbookmarkblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:18:\"ilcalendarblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:15:\"ildummyblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:22:\"ilexternalfeedblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:14:\"ilhtmlblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:24:\"ilnewsforcontextblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:20:\"ilpdcalendarblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:24:\"ilpdexternalfeedblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:20:\"ilpdfeedbackblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:16:\"ilpdmailblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:16:\"ilpdnewsblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:17:\"ilpdnotesblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:25:\"ilpdselecteditemsblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:22:\"ilpdsysmessageblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:19:\"ilpdtaggingblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:21:\"ilusersonlineblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:13:\"illpfiltergui\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illearningprogressgui\";a:2:{i:0;s:12:\"ilobjusergui\";i:1;s:20:\"ilpersonaldesktopgui\";}s:17:\"ilobjilincusergui\";a:1:{i:0;s:12:\"ilobjusergui\";}s:13:\"ilfeedbackgui\";a:2:{i:0;s:12:\"ilpdnotesgui\";i:1;s:20:\"ilpersonaldesktopgui\";}s:9:\"ilnotegui\";a:1:{i:0;s:12:\"ilpdnotesgui\";}s:27:\"ilbookmarkadministrationgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:25:\"ilcalendarpresentationgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:11:\"ilcolumngui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:19:\"ilobjlanguageextgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:12:\"ilobjusergui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:11:\"ilpdnewsgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:12:\"ilpdnotesgui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}s:20:\"ilpersonalprofilegui\";a:1:{i:0;s:20:\"ilpersonaldesktopgui\";}}');
INSERT INTO `ctrl_structure` VALUES ('illmpresentationgui','a:82:{i:1;a:2:{s:5:\"class\";s:19:\"illmpresentationgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2;}i:4;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:3;}i:6;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:3;}i:7;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:6;}i:8;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:6;}i:9;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:8;}i:10;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:6;}i:11;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:10;}i:12;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:6;}i:13;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:12;}i:14;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:6;}i:15;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:14;}i:16;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:3;}i:17;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:3;}i:18;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:3;}i:19;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:3;}i:20;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:19;}i:21;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:3;}i:22;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:21;}i:23;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:21;}i:24;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:23;}i:25;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:21;}i:26;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:25;}i:27;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:21;}i:28;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:27;}i:29;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:21;}i:30;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:29;}i:31;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:3;}i:32;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:3;}i:33;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:3;}i:34;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:3;}i:35;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:3;}i:36;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:3;}i:37;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:3;}i:38;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:3;}i:39;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:3;}i:40;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:39;}i:41;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2;}i:42;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:41;}i:43;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2;}i:44;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2;}i:45;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1;}i:46;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:1;}i:47;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:46;}i:48;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:47;}i:49;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:48;}i:50;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:49;}i:51;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:50;}i:52;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:49;}i:53;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:47;}i:54;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:47;}i:55;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:54;}i:56;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:54;}i:57;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:56;}i:58;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:57;}i:59;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:56;}i:60;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:54;}i:61;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:54;}i:62;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:54;}i:63;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:54;}i:64;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:54;}i:65;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:54;}i:66;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:54;}i:67;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:66;}i:68;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:67;}i:69;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:68;}i:70;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:67;}i:71;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:66;}i:72;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:71;}i:73;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:54;}i:74;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:54;}i:75;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:54;}i:76;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:54;}i:77;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:54;}i:78;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:54;}i:79;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:54;}i:80;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:54;}i:81;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:54;}i:82;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:47;}}','a:21:{s:0:\"\";a:54:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";}s:16:\"ilcalendardaygui\";a:2:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarinboxgui\";a:2:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarmonthgui\";a:2:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";}s:17:\"ilcalendarweekgui\";a:2:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarblockgui\";a:5:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";}s:24:\"ilnewsforcontextblockgui\";a:1:{i:0;s:13:\"ilnewsitemgui\";}s:20:\"ilpdcalendarblockgui\";a:5:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";}s:21:\"ilusersonlineblockgui\";a:1:{i:0;s:22:\"ilpublicuserprofilegui\";}s:11:\"ilcolumngui\";a:17:{i:0;s:0:\"\";i:1;s:18:\"ilbookmarkblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:15:\"ildummyblockgui\";i:4;s:22:\"ilexternalfeedblockgui\";i:5;s:14:\"ilhtmlblockgui\";i:6;s:24:\"ilnewsforcontextblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:24:\"ilpdexternalfeedblockgui\";i:9;s:20:\"ilpdfeedbackblockgui\";i:10;s:16:\"ilpdmailblockgui\";i:11;s:16:\"ilpdnewsblockgui\";i:12;s:17:\"ilpdnotesblockgui\";i:13;s:25:\"ilpdselecteditemsblockgui\";i:14;s:22:\"ilpdsysmessageblockgui\";i:15;s:19:\"ilpdtaggingblockgui\";i:16;s:21:\"ilusersonlineblockgui\";}s:13:\"ilfeedbackgui\";a:1:{i:0;s:0:\"\";}s:15:\"ilinfoscreengui\";a:4:{i:0;s:11:\"ilcolumngui\";i:1;s:13:\"ilfeedbackgui\";i:2;s:9:\"ilnotegui\";i:3;s:22:\"ilpublicuserprofilegui\";}s:19:\"ilimagemapeditorgui\";a:3:{i:0;s:17:\"ilinternallinkgui\";i:1;s:17:\"ilinternallinkgui\";i:2;s:17:\"ilinternallinkgui\";}s:19:\"ilobjmediaobjectgui\";a:6:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:19:\"ilimagemapeditorgui\";i:5;s:13:\"ilmdeditorgui\";}s:18:\"ileditclipboardgui\";a:1:{i:0;s:19:\"ilobjmediaobjectgui\";}s:21:\"ilpcimagemapeditorgui\";a:1:{i:0;s:17:\"ilinternallinkgui\";}s:18:\"ilpcmediaobjectgui\";a:2:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:21:\"ilpcimagemapeditorgui\";}s:15:\"ilpageeditorgui\";a:18:{i:0;s:17:\"ilinternallinkgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:16:\"ilpcdatatablegui\";i:3;s:15:\"ilpcfileitemgui\";i:4;s:15:\"ilpcfilelistgui\";i:5;s:11:\"ilpclistgui\";i:6;s:15:\"ilpclistitemgui\";i:7;s:10:\"ilpcmapgui\";i:8;s:18:\"ilpcmediaobjectgui\";i:9;s:16:\"ilpcparagraphgui\";i:10;s:14:\"ilpcpluggedgui\";i:11;s:15:\"ilpcquestiongui\";i:12;s:16:\"ilpcresourcesgui\";i:13;s:14:\"ilpcsectiongui\";i:14;s:17:\"ilpcsourcecodegui\";i:15;s:16:\"ilpctabledatagui\";i:16;s:12:\"ilpctablegui\";i:17;s:11:\"ilpctabsgui\";}s:15:\"ilpageobjectgui\";a:4:{i:0;s:18:\"ileditclipboardgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:22:\"ilpublicuserprofilegui\";}s:17:\"ilshoppurchasegui\";a:1:{i:0;s:15:\"ilpageobjectgui\";}s:19:\"illmpresentationgui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:9:\"ilnotegui\";i:2;s:17:\"ilshoppurchasegui\";}}','a:53:{s:0:\"\";a:56:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:11:\"ilcolumngui\";i:26;s:0:\"\";i:27;s:13:\"ilfeedbackgui\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";}s:24:\"ilcalendarappointmentgui\";a:10:{i:0;s:16:\"ilcalendardaygui\";i:1;s:18:\"ilcalendarinboxgui\";i:2;s:18:\"ilcalendarmonthgui\";i:3;s:17:\"ilcalendarweekgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:16:\"ilcalendardaygui\";i:6;s:18:\"ilcalendarinboxgui\";i:7;s:18:\"ilcalendarmonthgui\";i:8;s:17:\"ilcalendarweekgui\";i:9;s:20:\"ilpdcalendarblockgui\";}s:16:\"ilcalendardaygui\";a:2:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarinboxgui\";a:2:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarmonthgui\";a:2:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";}s:17:\"ilcalendarweekgui\";a:2:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";}s:13:\"ilnewsitemgui\";a:1:{i:0;s:24:\"ilnewsforcontextblockgui\";}s:22:\"ilpublicuserprofilegui\";a:3:{i:0;s:21:\"ilusersonlineblockgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilpageobjectgui\";}s:18:\"ilbookmarkblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:18:\"ilcalendarblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:15:\"ildummyblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:22:\"ilexternalfeedblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:14:\"ilhtmlblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:24:\"ilnewsforcontextblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:20:\"ilpdcalendarblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:24:\"ilpdexternalfeedblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:20:\"ilpdfeedbackblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:16:\"ilpdmailblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:16:\"ilpdnewsblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:17:\"ilpdnotesblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:25:\"ilpdselecteditemsblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:22:\"ilpdsysmessageblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:19:\"ilpdtaggingblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:21:\"ilusersonlineblockgui\";a:1:{i:0;s:11:\"ilcolumngui\";}s:11:\"ilcolumngui\";a:1:{i:0;s:15:\"ilinfoscreengui\";}s:13:\"ilfeedbackgui\";a:1:{i:0;s:15:\"ilinfoscreengui\";}s:9:\"ilnotegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:19:\"illmpresentationgui\";}s:17:\"ilinternallinkgui\";a:5:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:19:\"ilimagemapeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:21:\"ilpcimagemapeditorgui\";i:4;s:15:\"ilpageeditorgui\";}s:19:\"ilimagemapeditorgui\";a:3:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";}s:13:\"ilmdeditorgui\";a:4:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:15:\"ilpageobjectgui\";}s:19:\"ilobjmediaobjectgui\";a:3:{i:0;s:18:\"ileditclipboardgui\";i:1;s:18:\"ilpcmediaobjectgui\";i:2;s:15:\"ilpageeditorgui\";}s:21:\"ilpcimagemapeditorgui\";a:1:{i:0;s:18:\"ilpcmediaobjectgui\";}s:16:\"ilpcdatatablegui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfileitemgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfilelistgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:11:\"ilpclistgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:15:\"ilpclistitemgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:10:\"ilpcmapgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:18:\"ilpcmediaobjectgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:16:\"ilpcparagraphgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:14:\"ilpcpluggedgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:15:\"ilpcquestiongui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:16:\"ilpcresourcesgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:14:\"ilpcsectiongui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:17:\"ilpcsourcecodegui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:16:\"ilpctabledatagui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:12:\"ilpctablegui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:11:\"ilpctabsgui\";a:1:{i:0;s:15:\"ilpageeditorgui\";}s:18:\"ileditclipboardgui\";a:1:{i:0;s:15:\"ilpageobjectgui\";}s:15:\"ilpageeditorgui\";a:1:{i:0;s:15:\"ilpageobjectgui\";}s:15:\"ilpageobjectgui\";a:1:{i:0;s:17:\"ilshoppurchasegui\";}s:15:\"ilinfoscreengui\";a:1:{i:0;s:19:\"illmpresentationgui\";}s:17:\"ilshoppurchasegui\";a:1:{i:0;s:19:\"illmpresentationgui\";}}');
INSERT INTO `ctrl_structure` VALUES ('illmeditorgui','a:213:{i:1;a:2:{s:5:\"class\";s:13:\"illmeditorgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:14:\"ilobjdlbookgui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2;}i:4;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:4;}i:6;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:4;}i:7;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:4;}i:8;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:7;}i:9;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:7;}i:10;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:9;}i:11;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:7;}i:12;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:11;}i:13;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:7;}i:14;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:13;}i:15;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:7;}i:16;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:15;}i:17;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:4;}i:18;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:4;}i:19;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:4;}i:20;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:4;}i:21;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:20;}i:22;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:4;}i:23;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:22;}i:24;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:22;}i:25;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:24;}i:26;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:22;}i:27;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:26;}i:28;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:22;}i:29;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:28;}i:30;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:22;}i:31;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:30;}i:32;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:4;}i:33;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:4;}i:34;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:4;}i:35;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:4;}i:36;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:4;}i:37;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:4;}i:38;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:4;}i:39;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:4;}i:40;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:4;}i:41;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:40;}i:42;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:3;}i:43;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:42;}i:44;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:3;}i:45;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:3;}i:46;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2;}i:47;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:46;}i:48;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:46;}i:49;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:48;}i:50;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:49;}i:51;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:48;}i:52;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:51;}i:53;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:48;}i:54;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:53;}i:55;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:46;}i:56;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:55;}i:57;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:56;}i:58;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:55;}i:59;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:58;}i:60;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:46;}i:61;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:60;}i:62;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:2;}i:63;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:62;}i:64;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:63;}i:65;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:64;}i:66;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:65;}i:67;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:66;}i:68;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:65;}i:69;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:63;}i:70;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:63;}i:71;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:70;}i:72;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:70;}i:73;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:72;}i:74;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:73;}i:75;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:72;}i:76;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:70;}i:77;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:70;}i:78;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:70;}i:79;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:70;}i:80;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:70;}i:81;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:70;}i:82;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:70;}i:83;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:82;}i:84;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:83;}i:85;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:84;}i:86;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:83;}i:87;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:82;}i:88;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:87;}i:89;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:70;}i:90;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:70;}i:91;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:70;}i:92;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:70;}i:93;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:70;}i:94;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:70;}i:95;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:70;}i:96;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:70;}i:97;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:70;}i:98;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:63;}i:99;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2;}i:100;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:2;}i:101;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:100;}i:102;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2;}i:103;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:102;}i:104;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:103;}i:105;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:2;}i:106;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:105;}i:107;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:105;}i:108;a:2:{s:5:\"class\";s:22:\"ilobjlearningmodulegui\";s:6:\"parent\";i:1;}i:109;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:108;}i:110;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:109;}i:111;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:110;}i:112;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:110;}i:113;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:110;}i:114;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:113;}i:115;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:113;}i:116;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:115;}i:117;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:113;}i:118;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:117;}i:119;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:113;}i:120;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:119;}i:121;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:113;}i:122;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:121;}i:123;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:110;}i:124;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:110;}i:125;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:110;}i:126;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:110;}i:127;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:126;}i:128;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:110;}i:129;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:128;}i:130;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:128;}i:131;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:130;}i:132;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:128;}i:133;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:132;}i:134;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:128;}i:135;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:134;}i:136;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:128;}i:137;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:136;}i:138;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:110;}i:139;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:110;}i:140;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:110;}i:141;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:110;}i:142;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:110;}i:143;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:110;}i:144;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:110;}i:145;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:110;}i:146;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:110;}i:147;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:146;}i:148;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:109;}i:149;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:148;}i:150;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:109;}i:151;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:109;}i:152;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:108;}i:153;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:152;}i:154;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:152;}i:155;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:154;}i:156;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:155;}i:157;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:154;}i:158;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:157;}i:159;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:154;}i:160;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:159;}i:161;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:152;}i:162;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:161;}i:163;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:162;}i:164;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:161;}i:165;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:164;}i:166;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:152;}i:167;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:166;}i:168;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:108;}i:169;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:168;}i:170;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:169;}i:171;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:170;}i:172;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:171;}i:173;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:172;}i:174;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:171;}i:175;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:169;}i:176;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:169;}i:177;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:176;}i:178;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:176;}i:179;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:178;}i:180;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:179;}i:181;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:178;}i:182;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:176;}i:183;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:176;}i:184;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:176;}i:185;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:176;}i:186;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:176;}i:187;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:176;}i:188;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:176;}i:189;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:188;}i:190;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:189;}i:191;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:190;}i:192;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:189;}i:193;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:188;}i:194;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:193;}i:195;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:176;}i:196;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:176;}i:197;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:176;}i:198;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:176;}i:199;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:176;}i:200;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:176;}i:201;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:176;}i:202;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:176;}i:203;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:176;}i:204;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:169;}i:205;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:108;}i:206;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:108;}i:207;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:206;}i:208;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:108;}i:209;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:208;}i:210;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:209;}i:211;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:108;}i:212;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:211;}i:213;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:211;}}','a:34:{s:0:\"\";a:130:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:0:\"\";i:69;s:0:\"\";i:70;s:0:\"\";i:71;s:0:\"\";i:72;s:0:\"\";i:73;s:0:\"\";i:74;s:0:\"\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:0:\"\";i:78;s:0:\"\";i:79;s:0:\"\";i:80;s:0:\"\";i:81;s:0:\"\";i:82;s:0:\"\";i:83;s:0:\"\";i:84;s:0:\"\";i:85;s:0:\"\";i:86;s:0:\"\";i:87;s:0:\"\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:0:\"\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:0:\"\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:0:\"\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:0:\"\";i:129;s:0:\"\";}s:16:\"ilcalendardaygui\";a:4:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarinboxgui\";a:4:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarmonthgui\";a:4:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";}s:17:\"ilcalendarweekgui\";a:4:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarblockgui\";a:10:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:16:\"ilcalendardaygui\";i:7;s:18:\"ilcalendarinboxgui\";i:8;s:18:\"ilcalendarmonthgui\";i:9;s:17:\"ilcalendarweekgui\";}s:24:\"ilnewsforcontextblockgui\";a:2:{i:0;s:13:\"ilnewsitemgui\";i:1;s:13:\"ilnewsitemgui\";}s:20:\"ilpdcalendarblockgui\";a:10:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:16:\"ilcalendardaygui\";i:7;s:18:\"ilcalendarinboxgui\";i:8;s:18:\"ilcalendarmonthgui\";i:9;s:17:\"ilcalendarweekgui\";}s:21:\"ilusersonlineblockgui\";a:2:{i:0;s:22:\"ilpublicuserprofilegui\";i:1;s:22:\"ilpublicuserprofilegui\";}s:11:\"ilcolumngui\";a:34:{i:0;s:0:\"\";i:1;s:18:\"ilbookmarkblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:15:\"ildummyblockgui\";i:4;s:22:\"ilexternalfeedblockgui\";i:5;s:14:\"ilhtmlblockgui\";i:6;s:24:\"ilnewsforcontextblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:24:\"ilpdexternalfeedblockgui\";i:9;s:20:\"ilpdfeedbackblockgui\";i:10;s:16:\"ilpdmailblockgui\";i:11;s:16:\"ilpdnewsblockgui\";i:12;s:17:\"ilpdnotesblockgui\";i:13;s:25:\"ilpdselecteditemsblockgui\";i:14;s:22:\"ilpdsysmessageblockgui\";i:15;s:19:\"ilpdtaggingblockgui\";i:16;s:21:\"ilusersonlineblockgui\";i:17;s:0:\"\";i:18;s:18:\"ilbookmarkblockgui\";i:19;s:18:\"ilcalendarblockgui\";i:20;s:15:\"ildummyblockgui\";i:21;s:22:\"ilexternalfeedblockgui\";i:22;s:14:\"ilhtmlblockgui\";i:23;s:24:\"ilnewsforcontextblockgui\";i:24;s:20:\"ilpdcalendarblockgui\";i:25;s:24:\"ilpdexternalfeedblockgui\";i:26;s:20:\"ilpdfeedbackblockgui\";i:27;s:16:\"ilpdmailblockgui\";i:28;s:16:\"ilpdnewsblockgui\";i:29;s:17:\"ilpdnotesblockgui\";i:30;s:25:\"ilpdselecteditemsblockgui\";i:31;s:22:\"ilpdsysmessageblockgui\";i:32;s:19:\"ilpdtaggingblockgui\";i:33;s:21:\"ilusersonlineblockgui\";}s:13:\"ilfeedbackgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:15:\"ilinfoscreengui\";a:8:{i:0;s:11:\"ilcolumngui\";i:1;s:13:\"ilfeedbackgui\";i:2;s:9:\"ilnotegui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:11:\"ilcolumngui\";i:5;s:13:\"ilfeedbackgui\";i:6;s:9:\"ilnotegui\";i:7;s:22:\"ilpublicuserprofilegui\";}s:13:\"illpfiltergui\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:6:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:4:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:21:\"illearningprogressgui\";a:8:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";}s:19:\"ilimagemapeditorgui\";a:6:{i:0;s:17:\"ilinternallinkgui\";i:1;s:17:\"ilinternallinkgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:17:\"ilinternallinkgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:17:\"ilinternallinkgui\";}s:19:\"ilobjmediaobjectgui\";a:12:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:19:\"ilimagemapeditorgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:19:\"ilimagemapeditorgui\";i:7;s:13:\"ilmdeditorgui\";i:8;s:19:\"ilimagemapeditorgui\";i:9;s:13:\"ilmdeditorgui\";i:10;s:19:\"ilimagemapeditorgui\";i:11;s:13:\"ilmdeditorgui\";}s:18:\"ileditclipboardgui\";a:2:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";}s:21:\"ilpcimagemapeditorgui\";a:2:{i:0;s:17:\"ilinternallinkgui\";i:1;s:17:\"ilinternallinkgui\";}s:18:\"ilpcmediaobjectgui\";a:4:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:21:\"ilpcimagemapeditorgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:21:\"ilpcimagemapeditorgui\";}s:15:\"ilpageeditorgui\";a:36:{i:0;s:17:\"ilinternallinkgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:16:\"ilpcdatatablegui\";i:3;s:15:\"ilpcfileitemgui\";i:4;s:15:\"ilpcfilelistgui\";i:5;s:11:\"ilpclistgui\";i:6;s:15:\"ilpclistitemgui\";i:7;s:10:\"ilpcmapgui\";i:8;s:18:\"ilpcmediaobjectgui\";i:9;s:16:\"ilpcparagraphgui\";i:10;s:14:\"ilpcpluggedgui\";i:11;s:15:\"ilpcquestiongui\";i:12;s:16:\"ilpcresourcesgui\";i:13;s:14:\"ilpcsectiongui\";i:14;s:17:\"ilpcsourcecodegui\";i:15;s:16:\"ilpctabledatagui\";i:16;s:12:\"ilpctablegui\";i:17;s:11:\"ilpctabsgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:16:\"ilpcdatatablegui\";i:21;s:15:\"ilpcfileitemgui\";i:22;s:15:\"ilpcfilelistgui\";i:23;s:11:\"ilpclistgui\";i:24;s:15:\"ilpclistitemgui\";i:25;s:10:\"ilpcmapgui\";i:26;s:18:\"ilpcmediaobjectgui\";i:27;s:16:\"ilpcparagraphgui\";i:28;s:14:\"ilpcpluggedgui\";i:29;s:15:\"ilpcquestiongui\";i:30;s:16:\"ilpcresourcesgui\";i:31;s:14:\"ilpcsectiongui\";i:32;s:17:\"ilpcsourcecodegui\";i:33;s:16:\"ilpctabledatagui\";i:34;s:12:\"ilpctablegui\";i:35;s:11:\"ilpctabsgui\";}s:15:\"ilpageobjectgui\";a:8:{i:0;s:18:\"ileditclipboardgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:18:\"ileditclipboardgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:22:\"ilpublicuserprofilegui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:12:\"ilobjrolegui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:15:\"ilpermissiongui\";a:2:{i:0;s:12:\"ilobjrolegui\";i:1;s:12:\"ilobjrolegui\";}s:20:\"ilstructureobjectgui\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:13:\"ilmdeditorgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:13:\"ilmdeditorgui\";}s:14:\"ilobjdlbookgui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:17:\"illmpageobjectgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:18:\"ilobjstylesheetgui\";i:5;s:15:\"ilpermissiongui\";i:6;s:20:\"ilstructureobjectgui\";}s:22:\"ilobjlearningmodulegui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:17:\"illmpageobjectgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:18:\"ilobjstylesheetgui\";i:5;s:15:\"ilpermissiongui\";i:6;s:20:\"ilstructureobjectgui\";}s:13:\"illmeditorgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}}','a:68:{s:0:\"\";a:150:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:11:\"ilcolumngui\";i:26;s:0:\"\";i:27;s:13:\"ilfeedbackgui\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:13:\"illpfiltergui\";i:33;s:0:\"\";i:34;s:17:\"ilpdfpresentation\";i:35;s:0:\"\";i:36;s:15:\"iluserfiltergui\";i:37;s:0:\"\";i:38;s:13:\"illpfiltergui\";i:39;s:0:\"\";i:40;s:17:\"ilpdfpresentation\";i:41;s:0:\"\";i:42;s:21:\"illplistofsettingsgui\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:0:\"\";i:69;s:0:\"\";i:70;s:18:\"ilobjstylesheetgui\";i:71;s:0:\"\";i:72;s:12:\"ilobjrolegui\";i:73;s:0:\"\";i:74;s:0:\"\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:0:\"\";i:78;s:0:\"\";i:79;s:0:\"\";i:80;s:0:\"\";i:81;s:0:\"\";i:82;s:0:\"\";i:83;s:0:\"\";i:84;s:0:\"\";i:85;s:0:\"\";i:86;s:0:\"\";i:87;s:0:\"\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:0:\"\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:0:\"\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:11:\"ilcolumngui\";i:101;s:0:\"\";i:102;s:13:\"ilfeedbackgui\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:13:\"illpfiltergui\";i:108;s:0:\"\";i:109;s:17:\"ilpdfpresentation\";i:110;s:0:\"\";i:111;s:15:\"iluserfiltergui\";i:112;s:0:\"\";i:113;s:13:\"illpfiltergui\";i:114;s:0:\"\";i:115;s:17:\"ilpdfpresentation\";i:116;s:0:\"\";i:117;s:21:\"illplistofsettingsgui\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:0:\"\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:0:\"\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:0:\"\";i:137;s:0:\"\";i:138;s:0:\"\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:0:\"\";i:142;s:0:\"\";i:143;s:0:\"\";i:144;s:0:\"\";i:145;s:18:\"ilobjstylesheetgui\";i:146;s:0:\"\";i:147;s:12:\"ilobjrolegui\";i:148;s:0:\"\";i:149;s:0:\"\";}s:24:\"ilcalendarappointmentgui\";a:20:{i:0;s:16:\"ilcalendardaygui\";i:1;s:18:\"ilcalendarinboxgui\";i:2;s:18:\"ilcalendarmonthgui\";i:3;s:17:\"ilcalendarweekgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:16:\"ilcalendardaygui\";i:6;s:18:\"ilcalendarinboxgui\";i:7;s:18:\"ilcalendarmonthgui\";i:8;s:17:\"ilcalendarweekgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:16:\"ilcalendardaygui\";i:11;s:18:\"ilcalendarinboxgui\";i:12;s:18:\"ilcalendarmonthgui\";i:13;s:17:\"ilcalendarweekgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:16:\"ilcalendardaygui\";i:16;s:18:\"ilcalendarinboxgui\";i:17;s:18:\"ilcalendarmonthgui\";i:18;s:17:\"ilcalendarweekgui\";i:19;s:20:\"ilpdcalendarblockgui\";}s:16:\"ilcalendardaygui\";a:4:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarinboxgui\";a:4:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarmonthgui\";a:4:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";}s:17:\"ilcalendarweekgui\";a:4:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";}s:13:\"ilnewsitemgui\";a:2:{i:0;s:24:\"ilnewsforcontextblockgui\";i:1;s:24:\"ilnewsforcontextblockgui\";}s:22:\"ilpublicuserprofilegui\";a:6:{i:0;s:21:\"ilusersonlineblockgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:21:\"ilusersonlineblockgui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilpageobjectgui\";}s:18:\"ilbookmarkblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:18:\"ilcalendarblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:15:\"ildummyblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:22:\"ilexternalfeedblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:14:\"ilhtmlblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:24:\"ilnewsforcontextblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:20:\"ilpdcalendarblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:24:\"ilpdexternalfeedblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:20:\"ilpdfeedbackblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:16:\"ilpdmailblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:16:\"ilpdnewsblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:17:\"ilpdnotesblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:25:\"ilpdselecteditemsblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:22:\"ilpdsysmessageblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:19:\"ilpdtaggingblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:21:\"ilusersonlineblockgui\";a:2:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";}s:11:\"ilcolumngui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";}s:13:\"ilfeedbackgui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";}s:9:\"ilnotegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";}s:13:\"illpfiltergui\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:4:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:2:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";}s:17:\"ilinternallinkgui\";a:10:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:19:\"ilimagemapeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:21:\"ilpcimagemapeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:19:\"ilimagemapeditorgui\";i:6;s:19:\"ilimagemapeditorgui\";i:7;s:19:\"ilimagemapeditorgui\";i:8;s:21:\"ilpcimagemapeditorgui\";i:9;s:15:\"ilpageeditorgui\";}s:19:\"ilimagemapeditorgui\";a:6:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";}s:13:\"ilmdeditorgui\";a:12:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:20:\"ilstructureobjectgui\";i:5;s:14:\"ilobjdlbookgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:19:\"ilobjmediaobjectgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:15:\"ilpageobjectgui\";i:10;s:20:\"ilstructureobjectgui\";i:11;s:22:\"ilobjlearningmodulegui\";}s:19:\"ilobjmediaobjectgui\";a:6:{i:0;s:18:\"ileditclipboardgui\";i:1;s:18:\"ilpcmediaobjectgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:18:\"ileditclipboardgui\";i:4;s:18:\"ilpcmediaobjectgui\";i:5;s:15:\"ilpageeditorgui\";}s:21:\"ilpcimagemapeditorgui\";a:2:{i:0;s:18:\"ilpcmediaobjectgui\";i:1;s:18:\"ilpcmediaobjectgui\";}s:16:\"ilpcdatatablegui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfileitemgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfilelistgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:11:\"ilpclistgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:15:\"ilpclistitemgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:10:\"ilpcmapgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:18:\"ilpcmediaobjectgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:16:\"ilpcparagraphgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:14:\"ilpcpluggedgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:15:\"ilpcquestiongui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:16:\"ilpcresourcesgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:14:\"ilpcsectiongui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:17:\"ilpcsourcecodegui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:16:\"ilpctabledatagui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:12:\"ilpctablegui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:11:\"ilpctabsgui\";a:2:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";}s:18:\"ileditclipboardgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:15:\"ilpageeditorgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:15:\"ilpageobjectgui\";a:2:{i:0;s:17:\"illmpageobjectgui\";i:1;s:17:\"illmpageobjectgui\";}s:12:\"ilobjrolegui\";a:2:{i:0;s:15:\"ilpermissiongui\";i:1;s:15:\"ilpermissiongui\";}s:27:\"ilconditionhandlerinterface\";a:2:{i:0;s:20:\"ilstructureobjectgui\";i:1;s:20:\"ilstructureobjectgui\";}s:15:\"ilinfoscreengui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:21:\"illearningprogressgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:18:\"ilobjstylesheetgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:15:\"ilpermissiongui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:20:\"ilstructureobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:14:\"ilobjdlbookgui\";a:1:{i:0;s:13:\"illmeditorgui\";}s:22:\"ilobjlearningmodulegui\";a:1:{i:0;s:13:\"illmeditorgui\";}}');
INSERT INTO `ctrl_structure` VALUES ('iladministrationgui','a:2893:{i:1;a:2:{s:5:\"class\";s:19:\"iladministrationgui\";s:6:\"parent\";i:0;}i:2;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:1;}i:3;a:2:{s:5:\"class\";s:23:\"ilobjadvancededitinggui\";s:6:\"parent\";i:1;}i:4;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:3;}i:5;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:4;}i:6;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:5;}i:7;a:2:{s:5:\"class\";s:24:\"ilobjassessmentfoldergui\";s:6:\"parent\";i:1;}i:8;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:7;}i:9;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:8;}i:10;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:9;}i:11;a:2:{s:5:\"class\";s:20:\"ilobjauthsettingsgui\";s:6:\"parent\";i:1;}i:12;a:2:{s:5:\"class\";s:17:\"illdapsettingsgui\";s:6:\"parent\";i:11;}i:13;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:12;}i:14;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:11;}i:15;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:14;}i:16;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:15;}i:17;a:2:{s:5:\"class\";s:19:\"ilradiussettingsgui\";s:6:\"parent\";i:11;}i:18;a:2:{s:5:\"class\";s:25:\"ilregistrationsettingsgui\";s:6:\"parent\";i:11;}i:19;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:18;}i:20;a:2:{s:5:\"class\";s:24:\"ilobjcalendarsettingsgui\";s:6:\"parent\";i:1;}i:21;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:20;}i:22;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:21;}i:23;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:22;}i:24;a:2:{s:5:\"class\";s:16:\"ilobjcategorygui\";s:6:\"parent\";i:1;}i:25;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:24;}i:26;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:25;}i:27;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:25;}i:28;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:25;}i:29;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:28;}i:30;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:28;}i:31;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:30;}i:32;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:28;}i:33;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:32;}i:34;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:28;}i:35;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:34;}i:36;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:28;}i:37;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:36;}i:38;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:25;}i:39;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:25;}i:40;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:25;}i:41;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:25;}i:42;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:41;}i:43;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:25;}i:44;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:43;}i:45;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:43;}i:46;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:45;}i:47;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:43;}i:48;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:47;}i:49;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:43;}i:50;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:49;}i:51;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:43;}i:52;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:51;}i:53;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:25;}i:54;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:25;}i:55;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:25;}i:56;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:25;}i:57;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:25;}i:58;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:25;}i:59;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:25;}i:60;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:25;}i:61;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:25;}i:62;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:61;}i:63;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:24;}i:64;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:63;}i:65;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:24;}i:66;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:65;}i:67;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:66;}i:68;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:66;}i:69;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:66;}i:70;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:69;}i:71;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:69;}i:72;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:71;}i:73;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:69;}i:74;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:73;}i:75;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:69;}i:76;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:75;}i:77;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:69;}i:78;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:77;}i:79;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:66;}i:80;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:66;}i:81;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:66;}i:82;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:66;}i:83;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:82;}i:84;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:66;}i:85;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:84;}i:86;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:84;}i:87;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:86;}i:88;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:84;}i:89;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:88;}i:90;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:84;}i:91;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:90;}i:92;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:84;}i:93;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:92;}i:94;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:66;}i:95;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:66;}i:96;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:66;}i:97;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:66;}i:98;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:66;}i:99;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:66;}i:100;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:66;}i:101;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:66;}i:102;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:66;}i:103;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:102;}i:104;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:65;}i:105;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:104;}i:106;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:65;}i:107;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:65;}i:108;a:2:{s:5:\"class\";s:18:\"ilobjuserfoldergui\";s:6:\"parent\";i:24;}i:109;a:2:{s:5:\"class\";s:20:\"iladminusersearchgui\";s:6:\"parent\";i:108;}i:110;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:109;}i:111;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:110;}i:112;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:111;}i:113;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:111;}i:114;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:113;}i:115;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:114;}i:116;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:113;}i:117;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:116;}i:118;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:113;}i:119;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:118;}i:120;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:111;}i:121;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:120;}i:122;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:121;}i:123;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:120;}i:124;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:123;}i:125;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:111;}i:126;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:125;}i:127;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:110;}i:128;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:108;}i:129;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:128;}i:130;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:129;}i:131;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:24;}i:132;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:131;}i:133;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:132;}i:134;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:132;}i:135;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:134;}i:136;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:135;}i:137;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:134;}i:138;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:137;}i:139;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:134;}i:140;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:139;}i:141;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:132;}i:142;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:141;}i:143;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:142;}i:144;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:141;}i:145;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:144;}i:146;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:132;}i:147;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:146;}i:148;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:131;}i:149;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:24;}i:150;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:149;}i:151;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:150;}i:152;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:151;}i:153;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:152;}i:154;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:151;}i:155;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:149;}i:156;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:149;}i:157;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:156;}i:158;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:156;}i:159;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:158;}i:160;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:159;}i:161;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:158;}i:162;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:156;}i:163;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:156;}i:164;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:156;}i:165;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:156;}i:166;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:156;}i:167;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:156;}i:168;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:156;}i:169;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:168;}i:170;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:169;}i:171;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:170;}i:172;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:169;}i:173;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:168;}i:174;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:173;}i:175;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:156;}i:176;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:156;}i:177;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:156;}i:178;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:156;}i:179;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:156;}i:180;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:156;}i:181;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:156;}i:182;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:156;}i:183;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:156;}i:184;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:149;}i:185;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:24;}i:186;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:185;}i:187;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:186;}i:188;a:2:{s:5:\"class\";s:25:\"ilobjcategoryreferencegui\";s:6:\"parent\";i:1;}i:189;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:188;}i:190;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:189;}i:191;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:190;}i:192;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:190;}i:193;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:190;}i:194;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:193;}i:195;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:193;}i:196;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:195;}i:197;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:193;}i:198;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:197;}i:199;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:193;}i:200;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:199;}i:201;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:193;}i:202;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:201;}i:203;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:190;}i:204;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:190;}i:205;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:190;}i:206;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:190;}i:207;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:206;}i:208;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:190;}i:209;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:208;}i:210;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:208;}i:211;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:210;}i:212;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:208;}i:213;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:212;}i:214;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:208;}i:215;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:214;}i:216;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:208;}i:217;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:216;}i:218;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:190;}i:219;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:190;}i:220;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:190;}i:221;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:190;}i:222;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:190;}i:223;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:190;}i:224;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:190;}i:225;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:190;}i:226;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:190;}i:227;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:226;}i:228;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:189;}i:229;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:228;}i:230;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:189;}i:231;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:189;}i:232;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:188;}i:233;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:232;}i:234;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:233;}i:235;a:2:{s:5:\"class\";s:12:\"ilobjchatgui\";s:6:\"parent\";i:1;}i:236;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:235;}i:237;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:236;}i:238;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:237;}i:239;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:237;}i:240;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:237;}i:241;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:240;}i:242;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:240;}i:243;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:242;}i:244;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:240;}i:245;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:244;}i:246;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:240;}i:247;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:246;}i:248;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:240;}i:249;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:248;}i:250;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:237;}i:251;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:237;}i:252;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:237;}i:253;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:237;}i:254;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:253;}i:255;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:237;}i:256;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:255;}i:257;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:255;}i:258;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:257;}i:259;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:255;}i:260;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:259;}i:261;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:255;}i:262;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:261;}i:263;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:255;}i:264;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:263;}i:265;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:237;}i:266;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:237;}i:267;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:237;}i:268;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:237;}i:269;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:237;}i:270;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:237;}i:271;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:237;}i:272;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:237;}i:273;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:237;}i:274;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:273;}i:275;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:236;}i:276;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:275;}i:277;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:236;}i:278;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:236;}i:279;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:235;}i:280;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:279;}i:281;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:280;}i:282;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:235;}i:283;a:2:{s:5:\"class\";s:18:\"ilobjchatservergui\";s:6:\"parent\";i:1;}i:284;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:283;}i:285;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:284;}i:286;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:285;}i:287;a:2:{s:5:\"class\";s:25:\"ilobjcomponentsettingsgui\";s:6:\"parent\";i:1;}i:288;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:287;}i:289;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:288;}i:290;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:289;}i:291;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:1;}i:292;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:291;}i:293;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:292;}i:294;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:292;}i:295;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:292;}i:296;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:295;}i:297;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:295;}i:298;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:297;}i:299;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:295;}i:300;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:299;}i:301;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:295;}i:302;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:301;}i:303;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:295;}i:304;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:303;}i:305;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:292;}i:306;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:292;}i:307;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:292;}i:308;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:292;}i:309;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:308;}i:310;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:292;}i:311;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:310;}i:312;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:310;}i:313;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:312;}i:314;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:310;}i:315;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:314;}i:316;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:310;}i:317;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:316;}i:318;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:310;}i:319;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:318;}i:320;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:292;}i:321;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:292;}i:322;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:292;}i:323;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:292;}i:324;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:292;}i:325;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:292;}i:326;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:292;}i:327;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:292;}i:328;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:292;}i:329;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:328;}i:330;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:291;}i:331;a:2:{s:5:\"class\";s:20:\"ilcourseagreementgui\";s:6:\"parent\";i:291;}i:332;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:331;}i:333;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:291;}i:334;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:333;}i:335;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:334;}i:336;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:334;}i:337;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:334;}i:338;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:337;}i:339;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:337;}i:340;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:339;}i:341;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:337;}i:342;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:341;}i:343;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:337;}i:344;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:343;}i:345;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:337;}i:346;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:345;}i:347;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:334;}i:348;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:334;}i:349;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:334;}i:350;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:334;}i:351;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:350;}i:352;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:334;}i:353;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:352;}i:354;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:352;}i:355;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:354;}i:356;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:352;}i:357;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:356;}i:358;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:352;}i:359;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:358;}i:360;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:352;}i:361;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:360;}i:362;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:334;}i:363;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:334;}i:364;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:334;}i:365;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:334;}i:366;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:334;}i:367;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:334;}i:368;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:334;}i:369;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:334;}i:370;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:334;}i:371;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:370;}i:372;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:333;}i:373;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:333;}i:374;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:373;}i:375;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:291;}i:376;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:375;}i:377;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:291;}i:378;a:2:{s:5:\"class\";s:23:\"ilcourseregistrationgui\";s:6:\"parent\";i:291;}i:379;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:378;}i:380;a:2:{s:5:\"class\";s:21:\"ilcourseuserfieldsgui\";s:6:\"parent\";i:291;}i:381;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:291;}i:382;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:381;}i:383;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:382;}i:384;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:382;}i:385;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:382;}i:386;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:385;}i:387;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:385;}i:388;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:387;}i:389;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:385;}i:390;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:389;}i:391;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:385;}i:392;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:391;}i:393;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:385;}i:394;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:393;}i:395;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:382;}i:396;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:382;}i:397;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:382;}i:398;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:382;}i:399;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:398;}i:400;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:382;}i:401;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:400;}i:402;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:400;}i:403;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:402;}i:404;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:400;}i:405;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:404;}i:406;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:400;}i:407;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:406;}i:408;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:400;}i:409;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:408;}i:410;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:382;}i:411;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:382;}i:412;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:382;}i:413;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:382;}i:414;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:382;}i:415;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:382;}i:416;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:382;}i:417;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:382;}i:418;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:382;}i:419;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:418;}i:420;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:381;}i:421;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:420;}i:422;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:381;}i:423;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:381;}i:424;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:291;}i:425;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:424;}i:426;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:424;}i:427;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:426;}i:428;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:427;}i:429;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:426;}i:430;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:429;}i:431;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:426;}i:432;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:431;}i:433;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:424;}i:434;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:433;}i:435;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:434;}i:436;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:433;}i:437;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:436;}i:438;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:424;}i:439;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:438;}i:440;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:291;}i:441;a:2:{s:5:\"class\";s:17:\"ilmemberexportgui\";s:6:\"parent\";i:291;}i:442;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:441;}i:443;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:291;}i:444;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:291;}i:445;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:444;}i:446;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:445;}i:447;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:446;}i:448;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:447;}i:449;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:446;}i:450;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:444;}i:451;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:444;}i:452;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:451;}i:453;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:451;}i:454;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:453;}i:455;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:454;}i:456;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:453;}i:457;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:451;}i:458;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:451;}i:459;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:451;}i:460;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:451;}i:461;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:451;}i:462;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:451;}i:463;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:451;}i:464;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:463;}i:465;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:464;}i:466;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:465;}i:467;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:464;}i:468;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:463;}i:469;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:468;}i:470;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:451;}i:471;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:451;}i:472;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:451;}i:473;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:451;}i:474;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:451;}i:475;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:451;}i:476;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:451;}i:477;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:451;}i:478;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:451;}i:479;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:444;}i:480;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:291;}i:481;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:480;}i:482;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:481;}i:483;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:291;}i:484;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:291;}i:485;a:2:{s:5:\"class\";s:20:\"ilsessionoverviewgui\";s:6:\"parent\";i:291;}i:486;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:291;}i:487;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:486;}i:488;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:487;}i:489;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:488;}i:490;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:489;}i:491;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:490;}i:492;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:489;}i:493;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:487;}i:494;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:487;}i:495;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:494;}i:496;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:494;}i:497;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:496;}i:498;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:497;}i:499;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:496;}i:500;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:494;}i:501;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:494;}i:502;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:494;}i:503;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:494;}i:504;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:494;}i:505;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:494;}i:506;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:494;}i:507;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:506;}i:508;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:507;}i:509;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:508;}i:510;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:507;}i:511;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:506;}i:512;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:511;}i:513;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:494;}i:514;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:494;}i:515;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:494;}i:516;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:494;}i:517;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:494;}i:518;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:494;}i:519;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:494;}i:520;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:494;}i:521;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:494;}i:522;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:487;}i:523;a:2:{s:5:\"class\";s:23:\"ilobjcoursereferencegui\";s:6:\"parent\";i:1;}i:524;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:523;}i:525;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:524;}i:526;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:525;}i:527;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:525;}i:528;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:525;}i:529;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:528;}i:530;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:528;}i:531;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:530;}i:532;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:528;}i:533;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:532;}i:534;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:528;}i:535;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:534;}i:536;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:528;}i:537;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:536;}i:538;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:525;}i:539;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:525;}i:540;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:525;}i:541;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:525;}i:542;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:541;}i:543;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:525;}i:544;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:543;}i:545;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:543;}i:546;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:545;}i:547;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:543;}i:548;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:547;}i:549;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:543;}i:550;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:549;}i:551;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:543;}i:552;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:551;}i:553;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:525;}i:554;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:525;}i:555;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:525;}i:556;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:525;}i:557;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:525;}i:558;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:525;}i:559;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:525;}i:560;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:525;}i:561;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:525;}i:562;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:561;}i:563;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:524;}i:564;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:563;}i:565;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:524;}i:566;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:524;}i:567;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:523;}i:568;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:567;}i:569;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:568;}i:570;a:2:{s:5:\"class\";s:14:\"ilobjdlbookgui\";s:6:\"parent\";i:1;}i:571;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:570;}i:572;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:571;}i:573;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:572;}i:574;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:572;}i:575;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:572;}i:576;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:575;}i:577;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:575;}i:578;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:577;}i:579;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:575;}i:580;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:579;}i:581;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:575;}i:582;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:581;}i:583;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:575;}i:584;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:583;}i:585;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:572;}i:586;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:572;}i:587;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:572;}i:588;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:572;}i:589;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:588;}i:590;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:572;}i:591;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:590;}i:592;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:590;}i:593;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:592;}i:594;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:590;}i:595;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:594;}i:596;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:590;}i:597;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:596;}i:598;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:590;}i:599;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:598;}i:600;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:572;}i:601;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:572;}i:602;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:572;}i:603;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:572;}i:604;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:572;}i:605;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:572;}i:606;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:572;}i:607;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:572;}i:608;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:572;}i:609;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:608;}i:610;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:571;}i:611;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:610;}i:612;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:571;}i:613;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:571;}i:614;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:570;}i:615;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:614;}i:616;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:614;}i:617;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:616;}i:618;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:617;}i:619;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:616;}i:620;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:619;}i:621;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:616;}i:622;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:621;}i:623;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:614;}i:624;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:623;}i:625;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:624;}i:626;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:623;}i:627;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:626;}i:628;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:614;}i:629;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:628;}i:630;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:570;}i:631;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:630;}i:632;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:631;}i:633;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:632;}i:634;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:633;}i:635;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:634;}i:636;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:633;}i:637;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:631;}i:638;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:631;}i:639;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:638;}i:640;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:638;}i:641;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:640;}i:642;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:641;}i:643;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:640;}i:644;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:638;}i:645;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:638;}i:646;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:638;}i:647;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:638;}i:648;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:638;}i:649;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:638;}i:650;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:638;}i:651;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:650;}i:652;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:651;}i:653;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:652;}i:654;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:651;}i:655;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:650;}i:656;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:655;}i:657;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:638;}i:658;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:638;}i:659;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:638;}i:660;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:638;}i:661;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:638;}i:662;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:638;}i:663;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:638;}i:664;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:638;}i:665;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:638;}i:666;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:631;}i:667;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:570;}i:668;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:570;}i:669;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:668;}i:670;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:570;}i:671;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:670;}i:672;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:671;}i:673;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:570;}i:674;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:673;}i:675;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:673;}i:676;a:2:{s:5:\"class\";s:16:\"ilobjexercisegui\";s:6:\"parent\";i:1;}i:677;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:676;}i:678;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:677;}i:679;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:678;}i:680;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:678;}i:681;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:678;}i:682;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:681;}i:683;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:681;}i:684;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:683;}i:685;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:681;}i:686;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:685;}i:687;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:681;}i:688;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:687;}i:689;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:681;}i:690;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:689;}i:691;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:678;}i:692;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:678;}i:693;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:678;}i:694;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:678;}i:695;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:694;}i:696;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:678;}i:697;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:696;}i:698;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:696;}i:699;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:698;}i:700;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:696;}i:701;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:700;}i:702;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:696;}i:703;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:702;}i:704;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:696;}i:705;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:704;}i:706;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:678;}i:707;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:678;}i:708;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:678;}i:709;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:678;}i:710;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:678;}i:711;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:678;}i:712;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:678;}i:713;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:678;}i:714;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:678;}i:715;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:714;}i:716;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:677;}i:717;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:716;}i:718;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:677;}i:719;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:677;}i:720;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:676;}i:721;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:720;}i:722;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:720;}i:723;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:722;}i:724;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:723;}i:725;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:722;}i:726;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:725;}i:727;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:722;}i:728;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:727;}i:729;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:720;}i:730;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:729;}i:731;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:730;}i:732;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:729;}i:733;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:732;}i:734;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:720;}i:735;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:734;}i:736;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:676;}i:737;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:736;}i:738;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:737;}i:739;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:676;}i:740;a:2:{s:5:\"class\";s:20:\"ilobjexternalfeedgui\";s:6:\"parent\";i:1;}i:741;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:740;}i:742;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:740;}i:743;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:742;}i:744;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:743;}i:745;a:2:{s:5:\"class\";s:29:\"ilobjexternaltoolssettingsgui\";s:6:\"parent\";i:1;}i:746;a:2:{s:5:\"class\";s:16:\"ilecssettingsgui\";s:6:\"parent\";i:745;}i:747;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:746;}i:748;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:745;}i:749;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:748;}i:750;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:749;}i:751;a:2:{s:5:\"class\";s:26:\"ilobjfileaccesssettingsgui\";s:6:\"parent\";i:1;}i:752;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:751;}i:753;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:752;}i:754;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:753;}i:755;a:2:{s:5:\"class\";s:19:\"ilobjfilebasedlmgui\";s:6:\"parent\";i:1;}i:756;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:755;}i:757;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:755;}i:758;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:757;}i:759;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:758;}i:760;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:758;}i:761;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:758;}i:762;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:761;}i:763;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:761;}i:764;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:763;}i:765;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:761;}i:766;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:765;}i:767;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:761;}i:768;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:767;}i:769;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:761;}i:770;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:769;}i:771;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:758;}i:772;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:758;}i:773;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:758;}i:774;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:758;}i:775;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:774;}i:776;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:758;}i:777;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:776;}i:778;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:776;}i:779;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:778;}i:780;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:776;}i:781;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:780;}i:782;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:776;}i:783;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:782;}i:784;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:776;}i:785;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:784;}i:786;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:758;}i:787;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:758;}i:788;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:758;}i:789;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:758;}i:790;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:758;}i:791;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:758;}i:792;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:758;}i:793;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:758;}i:794;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:758;}i:795;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:794;}i:796;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:757;}i:797;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:796;}i:798;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:757;}i:799;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:757;}i:800;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:755;}i:801;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:800;}i:802;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:800;}i:803;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:802;}i:804;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:803;}i:805;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:802;}i:806;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:805;}i:807;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:802;}i:808;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:807;}i:809;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:800;}i:810;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:809;}i:811;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:810;}i:812;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:809;}i:813;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:812;}i:814;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:800;}i:815;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:814;}i:816;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:755;}i:817;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:755;}i:818;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:817;}i:819;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:818;}i:820;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:755;}i:821;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:820;}i:822;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:821;}i:823;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:822;}i:824;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:823;}i:825;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:824;}i:826;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:823;}i:827;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:821;}i:828;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:821;}i:829;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:828;}i:830;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:828;}i:831;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:830;}i:832;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:831;}i:833;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:830;}i:834;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:828;}i:835;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:828;}i:836;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:828;}i:837;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:828;}i:838;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:828;}i:839;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:828;}i:840;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:828;}i:841;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:840;}i:842;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:841;}i:843;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:842;}i:844;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:841;}i:845;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:840;}i:846;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:845;}i:847;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:828;}i:848;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:828;}i:849;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:828;}i:850;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:828;}i:851;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:828;}i:852;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:828;}i:853;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:828;}i:854;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:828;}i:855;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:828;}i:856;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:821;}i:857;a:2:{s:5:\"class\";s:12:\"ilobjfilegui\";s:6:\"parent\";i:1;}i:858;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:857;}i:859;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:858;}i:860;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:859;}i:861;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:859;}i:862;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:859;}i:863;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:862;}i:864;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:862;}i:865;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:864;}i:866;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:862;}i:867;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:866;}i:868;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:862;}i:869;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:868;}i:870;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:862;}i:871;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:870;}i:872;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:859;}i:873;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:859;}i:874;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:859;}i:875;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:859;}i:876;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:875;}i:877;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:859;}i:878;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:877;}i:879;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:877;}i:880;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:879;}i:881;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:877;}i:882;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:881;}i:883;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:877;}i:884;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:883;}i:885;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:877;}i:886;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:885;}i:887;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:859;}i:888;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:859;}i:889;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:859;}i:890;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:859;}i:891;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:859;}i:892;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:859;}i:893;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:859;}i:894;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:859;}i:895;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:859;}i:896;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:895;}i:897;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:858;}i:898;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:897;}i:899;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:858;}i:900;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:858;}i:901;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:857;}i:902;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:857;}i:903;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:902;}i:904;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:903;}i:905;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:857;}i:906;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:905;}i:907;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:906;}i:908;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:907;}i:909;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:908;}i:910;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:909;}i:911;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:908;}i:912;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:906;}i:913;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:906;}i:914;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:913;}i:915;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:913;}i:916;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:915;}i:917;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:916;}i:918;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:915;}i:919;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:913;}i:920;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:913;}i:921;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:913;}i:922;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:913;}i:923;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:913;}i:924;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:913;}i:925;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:913;}i:926;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:925;}i:927;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:926;}i:928;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:927;}i:929;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:926;}i:930;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:925;}i:931;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:930;}i:932;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:913;}i:933;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:913;}i:934;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:913;}i:935;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:913;}i:936;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:913;}i:937;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:913;}i:938;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:913;}i:939;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:913;}i:940;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:913;}i:941;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:906;}i:942;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:1;}i:943;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:942;}i:944;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:943;}i:945;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:943;}i:946;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:943;}i:947;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:946;}i:948;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:946;}i:949;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:948;}i:950;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:946;}i:951;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:950;}i:952;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:946;}i:953;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:952;}i:954;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:946;}i:955;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:954;}i:956;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:943;}i:957;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:943;}i:958;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:943;}i:959;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:943;}i:960;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:959;}i:961;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:943;}i:962;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:961;}i:963;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:961;}i:964;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:963;}i:965;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:961;}i:966;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:965;}i:967;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:961;}i:968;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:967;}i:969;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:961;}i:970;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:969;}i:971;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:943;}i:972;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:943;}i:973;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:943;}i:974;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:943;}i:975;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:943;}i:976;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:943;}i:977;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:943;}i:978;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:943;}i:979;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:943;}i:980;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:979;}i:981;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:942;}i:982;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:942;}i:983;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:982;}i:984;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:983;}i:985;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:983;}i:986;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:983;}i:987;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:986;}i:988;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:986;}i:989;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:988;}i:990;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:986;}i:991;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:990;}i:992;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:986;}i:993;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:992;}i:994;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:986;}i:995;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:994;}i:996;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:983;}i:997;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:983;}i:998;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:983;}i:999;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:983;}i:1000;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:999;}i:1001;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:983;}i:1002;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1001;}i:1003;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1001;}i:1004;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1003;}i:1005;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1001;}i:1006;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1005;}i:1007;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1001;}i:1008;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1007;}i:1009;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1001;}i:1010;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1009;}i:1011;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:983;}i:1012;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:983;}i:1013;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:983;}i:1014;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:983;}i:1015;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:983;}i:1016;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:983;}i:1017;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:983;}i:1018;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:983;}i:1019;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:983;}i:1020;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1019;}i:1021;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:982;}i:1022;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:982;}i:1023;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1022;}i:1024;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:942;}i:1025;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1024;}i:1026;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:942;}i:1027;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1026;}i:1028;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1027;}i:1029;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1027;}i:1030;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1027;}i:1031;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1030;}i:1032;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1030;}i:1033;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1032;}i:1034;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1030;}i:1035;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1034;}i:1036;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1030;}i:1037;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1036;}i:1038;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1030;}i:1039;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1038;}i:1040;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1027;}i:1041;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1027;}i:1042;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1027;}i:1043;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1027;}i:1044;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1043;}i:1045;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1027;}i:1046;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1045;}i:1047;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1045;}i:1048;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1047;}i:1049;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1045;}i:1050;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1049;}i:1051;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1045;}i:1052;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1051;}i:1053;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1045;}i:1054;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1053;}i:1055;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1027;}i:1056;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1027;}i:1057;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1027;}i:1058;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1027;}i:1059;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1027;}i:1060;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1027;}i:1061;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1027;}i:1062;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1027;}i:1063;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1027;}i:1064;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1063;}i:1065;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1026;}i:1066;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1065;}i:1067;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1026;}i:1068;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1026;}i:1069;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:942;}i:1070;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1069;}i:1071;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1069;}i:1072;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1071;}i:1073;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1072;}i:1074;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1071;}i:1075;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1074;}i:1076;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1071;}i:1077;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1076;}i:1078;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1069;}i:1079;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1078;}i:1080;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1079;}i:1081;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1078;}i:1082;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1081;}i:1083;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1069;}i:1084;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1083;}i:1085;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:942;}i:1086;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1085;}i:1087;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1086;}i:1088;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1087;}i:1089;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1088;}i:1090;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1087;}i:1091;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1085;}i:1092;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1085;}i:1093;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1092;}i:1094;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1092;}i:1095;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1094;}i:1096;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1095;}i:1097;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1094;}i:1098;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1092;}i:1099;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1092;}i:1100;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1092;}i:1101;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1092;}i:1102;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1092;}i:1103;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1092;}i:1104;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1092;}i:1105;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1104;}i:1106;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1105;}i:1107;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1106;}i:1108;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1105;}i:1109;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1104;}i:1110;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1109;}i:1111;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1092;}i:1112;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1092;}i:1113;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1092;}i:1114;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1092;}i:1115;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1092;}i:1116;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1092;}i:1117;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1092;}i:1118;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1092;}i:1119;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1092;}i:1120;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1085;}i:1121;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:942;}i:1122;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1121;}i:1123;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1122;}i:1124;a:2:{s:5:\"class\";s:13:\"ilobjforumgui\";s:6:\"parent\";i:1;}i:1125;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1124;}i:1126;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1125;}i:1127;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1125;}i:1128;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1125;}i:1129;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1128;}i:1130;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1128;}i:1131;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1130;}i:1132;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1128;}i:1133;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1132;}i:1134;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1128;}i:1135;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1134;}i:1136;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1128;}i:1137;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1136;}i:1138;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1125;}i:1139;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1125;}i:1140;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1125;}i:1141;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1125;}i:1142;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1141;}i:1143;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1125;}i:1144;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1143;}i:1145;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1143;}i:1146;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1145;}i:1147;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1143;}i:1148;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1147;}i:1149;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1143;}i:1150;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1149;}i:1151;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1143;}i:1152;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1151;}i:1153;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1125;}i:1154;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1125;}i:1155;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1125;}i:1156;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1125;}i:1157;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1125;}i:1158;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1125;}i:1159;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1125;}i:1160;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1125;}i:1161;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1125;}i:1162;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1161;}i:1163;a:2:{s:5:\"class\";s:16:\"ilforumexportgui\";s:6:\"parent\";i:1124;}i:1164;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1124;}i:1165;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1164;}i:1166;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1165;}i:1167;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1165;}i:1168;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1165;}i:1169;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1168;}i:1170;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1168;}i:1171;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1170;}i:1172;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1168;}i:1173;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1172;}i:1174;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1168;}i:1175;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1174;}i:1176;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1168;}i:1177;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1176;}i:1178;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1165;}i:1179;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1165;}i:1180;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1165;}i:1181;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1165;}i:1182;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1181;}i:1183;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1165;}i:1184;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1183;}i:1185;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1183;}i:1186;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1185;}i:1187;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1183;}i:1188;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1187;}i:1189;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1183;}i:1190;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1189;}i:1191;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1183;}i:1192;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1191;}i:1193;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1165;}i:1194;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1165;}i:1195;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1165;}i:1196;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1165;}i:1197;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1165;}i:1198;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1165;}i:1199;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1165;}i:1200;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1165;}i:1201;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1165;}i:1202;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1201;}i:1203;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1164;}i:1204;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1203;}i:1205;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1164;}i:1206;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1164;}i:1207;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1124;}i:1208;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1207;}i:1209;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1208;}i:1210;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1124;}i:1211;a:2:{s:5:\"class\";s:16:\"ilobjglossarygui\";s:6:\"parent\";i:1;}i:1212;a:2:{s:5:\"class\";s:17:\"ilglossarytermgui\";s:6:\"parent\";i:1211;}i:1213;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1212;}i:1214;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1213;}i:1215;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1214;}i:1216;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1215;}i:1217;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1216;}i:1218;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1215;}i:1219;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1213;}i:1220;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1213;}i:1221;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1220;}i:1222;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1220;}i:1223;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1222;}i:1224;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1223;}i:1225;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1222;}i:1226;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1220;}i:1227;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1220;}i:1228;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1220;}i:1229;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1220;}i:1230;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1220;}i:1231;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1220;}i:1232;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1220;}i:1233;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1232;}i:1234;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1233;}i:1235;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1234;}i:1236;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1233;}i:1237;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1232;}i:1238;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1237;}i:1239;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1220;}i:1240;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1220;}i:1241;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1220;}i:1242;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1220;}i:1243;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1220;}i:1244;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1220;}i:1245;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1220;}i:1246;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1220;}i:1247;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1220;}i:1248;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1213;}i:1249;a:2:{s:5:\"class\";s:25:\"iltermdefinitioneditorgui\";s:6:\"parent\";i:1212;}i:1250;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1249;}i:1251;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1249;}i:1252;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1251;}i:1253;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1252;}i:1254;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1253;}i:1255;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1254;}i:1256;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1253;}i:1257;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1251;}i:1258;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1251;}i:1259;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1258;}i:1260;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1258;}i:1261;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1260;}i:1262;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1261;}i:1263;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1260;}i:1264;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1258;}i:1265;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1258;}i:1266;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1258;}i:1267;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1258;}i:1268;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1258;}i:1269;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1258;}i:1270;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1258;}i:1271;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1270;}i:1272;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1271;}i:1273;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1272;}i:1274;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1271;}i:1275;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1270;}i:1276;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1275;}i:1277;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1258;}i:1278;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1258;}i:1279;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1258;}i:1280;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1258;}i:1281;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1258;}i:1282;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1258;}i:1283;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1258;}i:1284;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1258;}i:1285;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1258;}i:1286;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1251;}i:1287;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1211;}i:1288;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1287;}i:1289;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1288;}i:1290;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1288;}i:1291;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1288;}i:1292;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1291;}i:1293;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1291;}i:1294;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1293;}i:1295;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1291;}i:1296;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1295;}i:1297;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1291;}i:1298;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1297;}i:1299;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1291;}i:1300;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1299;}i:1301;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1288;}i:1302;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1288;}i:1303;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1288;}i:1304;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1288;}i:1305;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1304;}i:1306;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1288;}i:1307;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1306;}i:1308;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1306;}i:1309;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1308;}i:1310;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1306;}i:1311;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1310;}i:1312;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1306;}i:1313;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1312;}i:1314;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1306;}i:1315;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1314;}i:1316;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1288;}i:1317;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1288;}i:1318;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1288;}i:1319;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1288;}i:1320;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1288;}i:1321;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1288;}i:1322;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1288;}i:1323;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1288;}i:1324;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1288;}i:1325;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1324;}i:1326;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1287;}i:1327;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1326;}i:1328;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1287;}i:1329;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1287;}i:1330;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1211;}i:1331;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1211;}i:1332;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1331;}i:1333;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1332;}i:1334;a:2:{s:5:\"class\";s:13:\"ilobjgroupgui\";s:6:\"parent\";i:1;}i:1335;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1334;}i:1336;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1334;}i:1337;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1336;}i:1338;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1336;}i:1339;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1336;}i:1340;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1339;}i:1341;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1339;}i:1342;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1341;}i:1343;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1339;}i:1344;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1343;}i:1345;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1339;}i:1346;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1345;}i:1347;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1339;}i:1348;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1347;}i:1349;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1336;}i:1350;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1336;}i:1351;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1336;}i:1352;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1336;}i:1353;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1352;}i:1354;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1336;}i:1355;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1354;}i:1356;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1354;}i:1357;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1356;}i:1358;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1354;}i:1359;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1358;}i:1360;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1354;}i:1361;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1360;}i:1362;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1354;}i:1363;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1362;}i:1364;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1336;}i:1365;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1336;}i:1366;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1336;}i:1367;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1336;}i:1368;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1336;}i:1369;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1336;}i:1370;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1336;}i:1371;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1336;}i:1372;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1336;}i:1373;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1372;}i:1374;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1334;}i:1375;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:1334;}i:1376;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1375;}i:1377;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1376;}i:1378;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1376;}i:1379;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1376;}i:1380;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1379;}i:1381;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1379;}i:1382;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1381;}i:1383;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1379;}i:1384;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1383;}i:1385;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1379;}i:1386;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1385;}i:1387;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1379;}i:1388;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1387;}i:1389;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1376;}i:1390;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1376;}i:1391;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1376;}i:1392;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1376;}i:1393;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1392;}i:1394;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1376;}i:1395;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1394;}i:1396;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1394;}i:1397;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1396;}i:1398;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1394;}i:1399;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1398;}i:1400;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1394;}i:1401;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1400;}i:1402;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1394;}i:1403;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1402;}i:1404;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1376;}i:1405;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1376;}i:1406;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1376;}i:1407;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1376;}i:1408;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1376;}i:1409;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1376;}i:1410;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1376;}i:1411;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1376;}i:1412;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1376;}i:1413;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1412;}i:1414;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:1375;}i:1415;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:1375;}i:1416;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1415;}i:1417;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:1334;}i:1418;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1417;}i:1419;a:2:{s:5:\"class\";s:22:\"ilgroupregistrationgui\";s:6:\"parent\";i:1334;}i:1420;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1334;}i:1421;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1420;}i:1422;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1421;}i:1423;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1421;}i:1424;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1421;}i:1425;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1424;}i:1426;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1424;}i:1427;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1426;}i:1428;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1424;}i:1429;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1428;}i:1430;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1424;}i:1431;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1430;}i:1432;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1424;}i:1433;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1432;}i:1434;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1421;}i:1435;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1421;}i:1436;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1421;}i:1437;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1421;}i:1438;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1437;}i:1439;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1421;}i:1440;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1439;}i:1441;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1439;}i:1442;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1441;}i:1443;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1439;}i:1444;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1443;}i:1445;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1439;}i:1446;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1445;}i:1447;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1439;}i:1448;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1447;}i:1449;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1421;}i:1450;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1421;}i:1451;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1421;}i:1452;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1421;}i:1453;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1421;}i:1454;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1421;}i:1455;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1421;}i:1456;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1421;}i:1457;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1421;}i:1458;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1457;}i:1459;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1420;}i:1460;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1459;}i:1461;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1420;}i:1462;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1420;}i:1463;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1334;}i:1464;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1463;}i:1465;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1463;}i:1466;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1465;}i:1467;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1466;}i:1468;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1465;}i:1469;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1468;}i:1470;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1465;}i:1471;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1470;}i:1472;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1463;}i:1473;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1472;}i:1474;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1473;}i:1475;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1472;}i:1476;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1475;}i:1477;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1463;}i:1478;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1477;}i:1479;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:1334;}i:1480;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1334;}i:1481;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1480;}i:1482;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1481;}i:1483;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1482;}i:1484;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1483;}i:1485;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1482;}i:1486;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1480;}i:1487;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1480;}i:1488;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1487;}i:1489;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1487;}i:1490;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1489;}i:1491;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1490;}i:1492;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1489;}i:1493;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1487;}i:1494;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1487;}i:1495;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1487;}i:1496;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1487;}i:1497;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1487;}i:1498;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1487;}i:1499;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1487;}i:1500;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1499;}i:1501;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1500;}i:1502;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1501;}i:1503;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1500;}i:1504;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1499;}i:1505;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1504;}i:1506;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1487;}i:1507;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1487;}i:1508;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1487;}i:1509;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1487;}i:1510;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1487;}i:1511;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1487;}i:1512;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1487;}i:1513;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1487;}i:1514;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1487;}i:1515;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1480;}i:1516;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1334;}i:1517;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1516;}i:1518;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1517;}i:1519;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1334;}i:1520;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:1334;}i:1521;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:1;}i:1522;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1521;}i:1523;a:2:{s:5:\"class\";s:19:\"ilobjilinccoursegui\";s:6:\"parent\";i:1;}i:1524;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1523;}i:1525;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1524;}i:1526;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1525;}i:1527;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1525;}i:1528;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1525;}i:1529;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1528;}i:1530;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1528;}i:1531;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1530;}i:1532;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1528;}i:1533;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1532;}i:1534;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1528;}i:1535;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1534;}i:1536;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1528;}i:1537;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1536;}i:1538;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1525;}i:1539;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1525;}i:1540;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1525;}i:1541;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1525;}i:1542;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1541;}i:1543;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1525;}i:1544;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1543;}i:1545;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1543;}i:1546;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1545;}i:1547;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1543;}i:1548;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1547;}i:1549;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1543;}i:1550;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1549;}i:1551;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1543;}i:1552;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1551;}i:1553;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1525;}i:1554;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1525;}i:1555;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1525;}i:1556;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1525;}i:1557;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1525;}i:1558;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1525;}i:1559;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1525;}i:1560;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1525;}i:1561;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1525;}i:1562;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1561;}i:1563;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1524;}i:1564;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1563;}i:1565;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1524;}i:1566;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1524;}i:1567;a:2:{s:5:\"class\";s:22:\"ilobjilincclassroomgui\";s:6:\"parent\";i:1523;}i:1568;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1567;}i:1569;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1523;}i:1570;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1569;}i:1571;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1570;}i:1572;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1523;}i:1573;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:1523;}i:1574;a:2:{s:5:\"class\";s:19:\"ilobjlanguageextgui\";s:6:\"parent\";i:1;}i:1575;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1574;}i:1576;a:2:{s:5:\"class\";s:22:\"ilobjlanguagefoldergui\";s:6:\"parent\";i:1;}i:1577;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1576;}i:1578;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1577;}i:1579;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1578;}i:1580;a:2:{s:5:\"class\";s:22:\"ilobjlearningmodulegui\";s:6:\"parent\";i:1;}i:1581;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1580;}i:1582;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1581;}i:1583;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1582;}i:1584;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1582;}i:1585;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1582;}i:1586;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1585;}i:1587;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1585;}i:1588;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1587;}i:1589;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1585;}i:1590;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1589;}i:1591;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1585;}i:1592;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1591;}i:1593;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1585;}i:1594;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1593;}i:1595;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1582;}i:1596;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1582;}i:1597;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1582;}i:1598;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1582;}i:1599;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1598;}i:1600;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1582;}i:1601;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1600;}i:1602;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1600;}i:1603;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1602;}i:1604;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1600;}i:1605;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1604;}i:1606;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1600;}i:1607;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1606;}i:1608;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1600;}i:1609;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1608;}i:1610;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1582;}i:1611;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1582;}i:1612;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1582;}i:1613;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1582;}i:1614;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1582;}i:1615;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1582;}i:1616;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1582;}i:1617;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1582;}i:1618;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1582;}i:1619;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1618;}i:1620;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1581;}i:1621;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1620;}i:1622;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1581;}i:1623;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1581;}i:1624;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1580;}i:1625;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1624;}i:1626;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1624;}i:1627;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1626;}i:1628;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1627;}i:1629;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1626;}i:1630;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1629;}i:1631;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1626;}i:1632;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1631;}i:1633;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1624;}i:1634;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1633;}i:1635;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1634;}i:1636;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1633;}i:1637;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1636;}i:1638;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1624;}i:1639;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1638;}i:1640;a:2:{s:5:\"class\";s:17:\"illmpageobjectgui\";s:6:\"parent\";i:1580;}i:1641;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1640;}i:1642;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1641;}i:1643;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1642;}i:1644;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1643;}i:1645;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1644;}i:1646;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1643;}i:1647;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1641;}i:1648;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1641;}i:1649;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1648;}i:1650;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1648;}i:1651;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1650;}i:1652;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1651;}i:1653;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1650;}i:1654;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1648;}i:1655;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1648;}i:1656;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1648;}i:1657;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1648;}i:1658;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1648;}i:1659;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1648;}i:1660;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1648;}i:1661;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1660;}i:1662;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1661;}i:1663;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1662;}i:1664;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1661;}i:1665;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:1660;}i:1666;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1665;}i:1667;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1648;}i:1668;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1648;}i:1669;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1648;}i:1670;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1648;}i:1671;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1648;}i:1672;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1648;}i:1673;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1648;}i:1674;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1648;}i:1675;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1648;}i:1676;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1641;}i:1677;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1580;}i:1678;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:1580;}i:1679;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1678;}i:1680;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1580;}i:1681;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1680;}i:1682;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1681;}i:1683;a:2:{s:5:\"class\";s:20:\"ilstructureobjectgui\";s:6:\"parent\";i:1580;}i:1684;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1683;}i:1685;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1683;}i:1686;a:2:{s:5:\"class\";s:20:\"ilobjlinkresourcegui\";s:6:\"parent\";i:1;}i:1687;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1686;}i:1688;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1687;}i:1689;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1688;}i:1690;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1688;}i:1691;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1688;}i:1692;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1691;}i:1693;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1691;}i:1694;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1693;}i:1695;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1691;}i:1696;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1695;}i:1697;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1691;}i:1698;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1697;}i:1699;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1691;}i:1700;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1699;}i:1701;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1688;}i:1702;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1688;}i:1703;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1688;}i:1704;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1688;}i:1705;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1704;}i:1706;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1688;}i:1707;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1706;}i:1708;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1706;}i:1709;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1708;}i:1710;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1706;}i:1711;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1710;}i:1712;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1706;}i:1713;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1712;}i:1714;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1706;}i:1715;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1714;}i:1716;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1688;}i:1717;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1688;}i:1718;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1688;}i:1719;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1688;}i:1720;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1688;}i:1721;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1688;}i:1722;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1688;}i:1723;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1688;}i:1724;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1688;}i:1725;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1724;}i:1726;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1687;}i:1727;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1726;}i:1728;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1687;}i:1729;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1687;}i:1730;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1686;}i:1731;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1686;}i:1732;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1731;}i:1733;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1732;}i:1734;a:2:{s:5:\"class\";s:12:\"ilobjmailgui\";s:6:\"parent\";i:1;}i:1735;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1734;}i:1736;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1735;}i:1737;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1736;}i:1738;a:2:{s:5:\"class\";s:18:\"ilobjmdsettingsgui\";s:6:\"parent\";i:1;}i:1739;a:2:{s:5:\"class\";s:23:\"iladvancedmdsettingsgui\";s:6:\"parent\";i:1738;}i:1740;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1739;}i:1741;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1738;}i:1742;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1741;}i:1743;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1742;}i:1744;a:2:{s:5:\"class\";s:17:\"ilobjmediacastgui\";s:6:\"parent\";i:1;}i:1745;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1744;}i:1746;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1745;}i:1747;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1746;}i:1748;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1746;}i:1749;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1746;}i:1750;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1749;}i:1751;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1749;}i:1752;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1751;}i:1753;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1749;}i:1754;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1753;}i:1755;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1749;}i:1756;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1755;}i:1757;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1749;}i:1758;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1757;}i:1759;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1746;}i:1760;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1746;}i:1761;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1746;}i:1762;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1746;}i:1763;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1762;}i:1764;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1746;}i:1765;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1764;}i:1766;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1764;}i:1767;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1766;}i:1768;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1764;}i:1769;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1768;}i:1770;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1764;}i:1771;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1770;}i:1772;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1764;}i:1773;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1772;}i:1774;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1746;}i:1775;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1746;}i:1776;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1746;}i:1777;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1746;}i:1778;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1746;}i:1779;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1746;}i:1780;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1746;}i:1781;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1746;}i:1782;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1746;}i:1783;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1782;}i:1784;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1745;}i:1785;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1784;}i:1786;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1745;}i:1787;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1745;}i:1788;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1744;}i:1789;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1788;}i:1790;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1789;}i:1791;a:2:{s:5:\"class\";s:25:\"ilobjmediacastsettingsgui\";s:6:\"parent\";i:1;}i:1792;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1791;}i:1793;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1792;}i:1794;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1793;}i:1795;a:2:{s:5:\"class\";s:17:\"ilobjmediapoolgui\";s:6:\"parent\";i:1;}i:1796;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1795;}i:1797;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1796;}i:1798;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1797;}i:1799;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1798;}i:1800;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1797;}i:1801;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1795;}i:1802;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1801;}i:1803;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1802;}i:1804;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1802;}i:1805;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1802;}i:1806;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1805;}i:1807;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1805;}i:1808;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1807;}i:1809;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1805;}i:1810;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1809;}i:1811;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1805;}i:1812;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1811;}i:1813;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1805;}i:1814;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1813;}i:1815;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1802;}i:1816;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1802;}i:1817;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1802;}i:1818;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1802;}i:1819;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1818;}i:1820;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1802;}i:1821;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1820;}i:1822;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1820;}i:1823;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1822;}i:1824;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1820;}i:1825;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1824;}i:1826;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1820;}i:1827;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1826;}i:1828;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1820;}i:1829;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1828;}i:1830;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1802;}i:1831;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1802;}i:1832;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1802;}i:1833;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1802;}i:1834;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1802;}i:1835;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1802;}i:1836;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1802;}i:1837;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1802;}i:1838;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1802;}i:1839;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1838;}i:1840;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1801;}i:1841;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1840;}i:1842;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1801;}i:1843;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1801;}i:1844;a:2:{s:5:\"class\";s:14:\"ilobjfoldergui\";s:6:\"parent\";i:1795;}i:1845;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1844;}i:1846;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1845;}i:1847;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1845;}i:1848;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1845;}i:1849;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1848;}i:1850;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1848;}i:1851;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1850;}i:1852;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1848;}i:1853;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1852;}i:1854;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1848;}i:1855;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1854;}i:1856;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1848;}i:1857;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1856;}i:1858;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1845;}i:1859;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1845;}i:1860;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1845;}i:1861;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1845;}i:1862;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1861;}i:1863;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1845;}i:1864;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1863;}i:1865;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1863;}i:1866;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1865;}i:1867;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1863;}i:1868;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1867;}i:1869;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1863;}i:1870;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1869;}i:1871;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1863;}i:1872;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1871;}i:1873;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1845;}i:1874;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1845;}i:1875;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1845;}i:1876;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1845;}i:1877;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1845;}i:1878;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1845;}i:1879;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1845;}i:1880;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1845;}i:1881;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1845;}i:1882;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1881;}i:1883;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1844;}i:1884;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:1844;}i:1885;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1884;}i:1886;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1885;}i:1887;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1885;}i:1888;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1885;}i:1889;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1888;}i:1890;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1888;}i:1891;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1890;}i:1892;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1888;}i:1893;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1892;}i:1894;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1888;}i:1895;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1894;}i:1896;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1888;}i:1897;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1896;}i:1898;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1885;}i:1899;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1885;}i:1900;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1885;}i:1901;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1885;}i:1902;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1901;}i:1903;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1885;}i:1904;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1903;}i:1905;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1903;}i:1906;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1905;}i:1907;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1903;}i:1908;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1907;}i:1909;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1903;}i:1910;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1909;}i:1911;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1903;}i:1912;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1911;}i:1913;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1885;}i:1914;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1885;}i:1915;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1885;}i:1916;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1885;}i:1917;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1885;}i:1918;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1885;}i:1919;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1885;}i:1920;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1885;}i:1921;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1885;}i:1922;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1921;}i:1923;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:1884;}i:1924;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:1884;}i:1925;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1924;}i:1926;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:1844;}i:1927;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:1926;}i:1928;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:1844;}i:1929;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:1928;}i:1930;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1929;}i:1931;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:1929;}i:1932;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:1929;}i:1933;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1932;}i:1934;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1932;}i:1935;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1934;}i:1936;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1932;}i:1937;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1936;}i:1938;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1932;}i:1939;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1938;}i:1940;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1932;}i:1941;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1940;}i:1942;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:1929;}i:1943;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:1929;}i:1944;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:1929;}i:1945;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:1929;}i:1946;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:1945;}i:1947;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:1929;}i:1948;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1947;}i:1949;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:1947;}i:1950;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1949;}i:1951;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:1947;}i:1952;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1951;}i:1953;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:1947;}i:1954;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1953;}i:1955;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:1947;}i:1956;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:1955;}i:1957;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:1929;}i:1958;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:1929;}i:1959;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:1929;}i:1960;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:1929;}i:1961;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:1929;}i:1962;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:1929;}i:1963;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:1929;}i:1964;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:1929;}i:1965;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:1929;}i:1966;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1965;}i:1967;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:1928;}i:1968;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1967;}i:1969;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:1928;}i:1970;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1928;}i:1971;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:1844;}i:1972;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:1971;}i:1973;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:1971;}i:1974;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1973;}i:1975;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1974;}i:1976;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1973;}i:1977;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1976;}i:1978;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:1973;}i:1979;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1978;}i:1980;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:1971;}i:1981;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:1980;}i:1982;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1981;}i:1983;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:1980;}i:1984;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1983;}i:1985;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:1971;}i:1986;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:1985;}i:1987;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:1844;}i:1988;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:1987;}i:1989;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1988;}i:1990;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1989;}i:1991;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1990;}i:1992;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1989;}i:1993;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1987;}i:1994;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:1987;}i:1995;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1994;}i:1996;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1994;}i:1997;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:1996;}i:1998;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:1997;}i:1999;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:1996;}i:2000;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:1994;}i:2001;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:1994;}i:2002;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:1994;}i:2003;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:1994;}i:2004;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:1994;}i:2005;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:1994;}i:2006;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:1994;}i:2007;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2006;}i:2008;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2007;}i:2009;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2008;}i:2010;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2007;}i:2011;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2006;}i:2012;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2011;}i:2013;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:1994;}i:2014;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:1994;}i:2015;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:1994;}i:2016;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:1994;}i:2017;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:1994;}i:2018;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:1994;}i:2019;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:1994;}i:2020;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:1994;}i:2021;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:1994;}i:2022;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:1987;}i:2023;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1844;}i:2024;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2023;}i:2025;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2024;}i:2026;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:1795;}i:2027;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2026;}i:2028;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2027;}i:2029;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2026;}i:2030;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1795;}i:2031;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2030;}i:2032;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2031;}i:2033;a:2:{s:5:\"class\";s:20:\"ilobjnewssettingsgui\";s:6:\"parent\";i:1;}i:2034;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2033;}i:2035;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2034;}i:2036;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2035;}i:2037;a:2:{s:5:\"class\";s:20:\"ilobjobjectfoldergui\";s:6:\"parent\";i:1;}i:2038;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2037;}i:2039;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2038;}i:2040;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2039;}i:2041;a:2:{s:5:\"class\";s:23:\"ilobjpaymentsettingsgui\";s:6:\"parent\";i:1;}i:2042;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2041;}i:2043;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2042;}i:2044;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2043;}i:2045;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2044;}i:2046;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2045;}i:2047;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2044;}i:2048;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2042;}i:2049;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2042;}i:2050;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2049;}i:2051;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2049;}i:2052;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2051;}i:2053;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2052;}i:2054;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2051;}i:2055;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2049;}i:2056;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2049;}i:2057;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2049;}i:2058;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2049;}i:2059;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2049;}i:2060;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2049;}i:2061;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2049;}i:2062;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2061;}i:2063;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2062;}i:2064;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2063;}i:2065;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2062;}i:2066;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2061;}i:2067;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2066;}i:2068;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2049;}i:2069;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2049;}i:2070;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2049;}i:2071;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2049;}i:2072;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2049;}i:2073;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2049;}i:2074;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2049;}i:2075;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2049;}i:2076;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2049;}i:2077;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2042;}i:2078;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2041;}i:2079;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2078;}i:2080;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2079;}i:2081;a:2:{s:5:\"class\";s:15:\"ilshoptopicsgui\";s:6:\"parent\";i:2041;}i:2082;a:2:{s:5:\"class\";s:31:\"ilobjpersonaldesktopsettingsgui\";s:6:\"parent\";i:1;}i:2083;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2082;}i:2084;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2083;}i:2085;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2084;}i:2086;a:2:{s:5:\"class\";s:23:\"ilobjprivacysecuritygui\";s:6:\"parent\";i:1;}i:2087;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2086;}i:2088;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2087;}i:2089;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2088;}i:2090;a:2:{s:5:\"class\";s:20:\"ilobjquestionpoolgui\";s:6:\"parent\";i:1;}i:2091;a:2:{s:5:\"class\";s:15:\"assclozetestgui\";s:6:\"parent\";i:2090;}i:2092;a:2:{s:5:\"class\";s:22:\"assimagemapquestiongui\";s:6:\"parent\";i:2090;}i:2093;a:2:{s:5:\"class\";s:16:\"assjavaappletgui\";s:6:\"parent\";i:2090;}i:2094;a:2:{s:5:\"class\";s:22:\"assmatchingquestiongui\";s:6:\"parent\";i:2090;}i:2095;a:2:{s:5:\"class\";s:20:\"assmultiplechoicegui\";s:6:\"parent\";i:2090;}i:2096;a:2:{s:5:\"class\";s:13:\"assnumericgui\";s:6:\"parent\";i:2090;}i:2097;a:2:{s:5:\"class\";s:22:\"assorderingquestiongui\";s:6:\"parent\";i:2090;}i:2098;a:2:{s:5:\"class\";s:26:\"assquestiontypetemplategui\";s:6:\"parent\";i:2090;}i:2099;a:2:{s:5:\"class\";s:18:\"asssinglechoicegui\";s:6:\"parent\";i:2090;}i:2100;a:2:{s:5:\"class\";s:18:\"asstextquestiongui\";s:6:\"parent\";i:2090;}i:2101;a:2:{s:5:\"class\";s:16:\"asstextsubsetgui\";s:6:\"parent\";i:2090;}i:2102;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2090;}i:2103;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2090;}i:2104;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2103;}i:2105;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2104;}i:2106;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2105;}i:2107;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2106;}i:2108;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2105;}i:2109;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2103;}i:2110;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2103;}i:2111;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2110;}i:2112;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2110;}i:2113;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2112;}i:2114;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2113;}i:2115;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2112;}i:2116;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2110;}i:2117;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2110;}i:2118;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2110;}i:2119;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2110;}i:2120;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2110;}i:2121;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2110;}i:2122;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2110;}i:2123;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2122;}i:2124;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2123;}i:2125;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2124;}i:2126;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2123;}i:2127;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2122;}i:2128;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2127;}i:2129;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2110;}i:2130;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2110;}i:2131;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2110;}i:2132;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2110;}i:2133;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2110;}i:2134;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2110;}i:2135;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2110;}i:2136;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2110;}i:2137;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2110;}i:2138;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2103;}i:2139;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2090;}i:2140;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2139;}i:2141;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2140;}i:2142;a:2:{s:5:\"class\";s:22:\"ilobjrecoveryfoldergui\";s:6:\"parent\";i:1;}i:2143;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2142;}i:2144;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2143;}i:2145;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2144;}i:2146;a:2:{s:5:\"class\";s:18:\"ilobjrolefoldergui\";s:6:\"parent\";i:1;}i:2147;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2146;}i:2148;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2147;}i:2149;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2148;}i:2150;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:1;}i:2151;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2150;}i:2152;a:2:{s:5:\"class\";s:20:\"ilobjroletemplategui\";s:6:\"parent\";i:1;}i:2153;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2152;}i:2154;a:2:{s:5:\"class\";s:18:\"ilobjrootfoldergui\";s:6:\"parent\";i:1;}i:2155;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2154;}i:2156;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2155;}i:2157;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2155;}i:2158;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2155;}i:2159;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2158;}i:2160;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2158;}i:2161;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2160;}i:2162;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2158;}i:2163;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2162;}i:2164;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2158;}i:2165;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2164;}i:2166;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2158;}i:2167;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2166;}i:2168;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2155;}i:2169;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2155;}i:2170;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2155;}i:2171;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2155;}i:2172;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2171;}i:2173;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2155;}i:2174;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2173;}i:2175;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2173;}i:2176;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2175;}i:2177;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2173;}i:2178;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2177;}i:2179;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2173;}i:2180;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2179;}i:2181;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2173;}i:2182;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2181;}i:2183;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2155;}i:2184;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2155;}i:2185;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2155;}i:2186;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2155;}i:2187;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2155;}i:2188;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2155;}i:2189;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2155;}i:2190;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2155;}i:2191;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2155;}i:2192;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2191;}i:2193;a:2:{s:5:\"class\";s:22:\"ilcontainerlinklistgui\";s:6:\"parent\";i:2154;}i:2194;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2193;}i:2195;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2154;}i:2196;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2195;}i:2197;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2196;}i:2198;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2197;}i:2199;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2198;}i:2200;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2197;}i:2201;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2195;}i:2202;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2195;}i:2203;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2202;}i:2204;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2202;}i:2205;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2204;}i:2206;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2205;}i:2207;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2204;}i:2208;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2202;}i:2209;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2202;}i:2210;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2202;}i:2211;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2202;}i:2212;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2202;}i:2213;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2202;}i:2214;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2202;}i:2215;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2214;}i:2216;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2215;}i:2217;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2216;}i:2218;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2215;}i:2219;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2214;}i:2220;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2219;}i:2221;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2202;}i:2222;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2202;}i:2223;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2202;}i:2224;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2202;}i:2225;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2202;}i:2226;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2202;}i:2227;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2202;}i:2228;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2202;}i:2229;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2202;}i:2230;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2195;}i:2231;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2154;}i:2232;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2231;}i:2233;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2232;}i:2234;a:2:{s:5:\"class\";s:26:\"ilobjsahslearningmodulegui\";s:6:\"parent\";i:1;}i:2235;a:2:{s:5:\"class\";s:15:\"ilfilesystemgui\";s:6:\"parent\";i:2234;}i:2236;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2234;}i:2237;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2234;}i:2238;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2237;}i:2239;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2238;}i:2240;a:2:{s:5:\"class\";s:22:\"ilobjsearchsettingsgui\";s:6:\"parent\";i:1;}i:2241;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2240;}i:2242;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2241;}i:2243;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2242;}i:2244;a:2:{s:5:\"class\";s:15:\"ilobjsessiongui\";s:6:\"parent\";i:1;}i:2245;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2244;}i:2246;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2245;}i:2247;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2246;}i:2248;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2246;}i:2249;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2246;}i:2250;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2249;}i:2251;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2249;}i:2252;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2251;}i:2253;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2249;}i:2254;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2253;}i:2255;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2249;}i:2256;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2255;}i:2257;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2249;}i:2258;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2257;}i:2259;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2246;}i:2260;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2246;}i:2261;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2246;}i:2262;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2246;}i:2263;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2262;}i:2264;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2246;}i:2265;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2264;}i:2266;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2264;}i:2267;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2266;}i:2268;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2264;}i:2269;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2268;}i:2270;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2264;}i:2271;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2270;}i:2272;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2264;}i:2273;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2272;}i:2274;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2246;}i:2275;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2246;}i:2276;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2246;}i:2277;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2246;}i:2278;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2246;}i:2279;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2246;}i:2280;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2246;}i:2281;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2246;}i:2282;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2246;}i:2283;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2282;}i:2284;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2245;}i:2285;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2284;}i:2286;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2245;}i:2287;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2245;}i:2288;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2244;}i:2289;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2288;}i:2290;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2289;}i:2291;a:2:{s:5:\"class\";s:21:\"ilobjstylesettingsgui\";s:6:\"parent\";i:1;}i:2292;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2291;}i:2293;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2292;}i:2294;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2293;}i:2295;a:2:{s:5:\"class\";s:18:\"ilobjstylesheetgui\";s:6:\"parent\";i:1;}i:2296;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2295;}i:2297;a:2:{s:5:\"class\";s:28:\"ilobjsurveyadministrationgui\";s:6:\"parent\";i:1;}i:2298;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2297;}i:2299;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2298;}i:2300;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2299;}i:2301;a:2:{s:5:\"class\";s:14:\"ilobjsurveygui\";s:6:\"parent\";i:1;}i:2302;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2301;}i:2303;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2302;}i:2304;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2303;}i:2305;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2303;}i:2306;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2303;}i:2307;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2306;}i:2308;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2306;}i:2309;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2308;}i:2310;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2306;}i:2311;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2310;}i:2312;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2306;}i:2313;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2312;}i:2314;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2306;}i:2315;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2314;}i:2316;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2303;}i:2317;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2303;}i:2318;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2303;}i:2319;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2303;}i:2320;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2319;}i:2321;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2303;}i:2322;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2321;}i:2323;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2321;}i:2324;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2323;}i:2325;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2321;}i:2326;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2325;}i:2327;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2321;}i:2328;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2327;}i:2329;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2321;}i:2330;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2329;}i:2331;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2303;}i:2332;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2303;}i:2333;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2303;}i:2334;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2303;}i:2335;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2303;}i:2336;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2303;}i:2337;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2303;}i:2338;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2303;}i:2339;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2303;}i:2340;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2339;}i:2341;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2302;}i:2342;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2341;}i:2343;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2302;}i:2344;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2302;}i:2345;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2301;}i:2346;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2301;}i:2347;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2346;}i:2348;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2347;}i:2349;a:2:{s:5:\"class\";s:21:\"ilsurveyevaluationgui\";s:6:\"parent\";i:2301;}i:2350;a:2:{s:5:\"class\";s:20:\"ilsurveyexecutiongui\";s:6:\"parent\";i:2301;}i:2351;a:2:{s:5:\"class\";s:26:\"ilobjsurveyquestionpoolgui\";s:6:\"parent\";i:1;}i:2352;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2351;}i:2353;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2351;}i:2354;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2353;}i:2355;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2354;}i:2356;a:2:{s:5:\"class\";s:18:\"ilsurveyphrasesgui\";s:6:\"parent\";i:2351;}i:2357;a:2:{s:5:\"class\";s:23:\"surveymatrixquestiongui\";s:6:\"parent\";i:2351;}i:2358;a:2:{s:5:\"class\";s:23:\"surveymetricquestiongui\";s:6:\"parent\";i:2351;}i:2359;a:2:{s:5:\"class\";s:24:\"surveynominalquestiongui\";s:6:\"parent\";i:2351;}i:2360;a:2:{s:5:\"class\";s:24:\"surveyordinalquestiongui\";s:6:\"parent\";i:2351;}i:2361;a:2:{s:5:\"class\";s:21:\"surveytextquestiongui\";s:6:\"parent\";i:2351;}i:2362;a:2:{s:5:\"class\";s:20:\"ilobjsystemfoldergui\";s:6:\"parent\";i:1;}i:2363;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2362;}i:2364;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2363;}i:2365;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2364;}i:2366;a:2:{s:5:\"class\";s:23:\"ilobjtaggingsettingsgui\";s:6:\"parent\";i:1;}i:2367;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2366;}i:2368;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2367;}i:2369;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2368;}i:2370;a:2:{s:5:\"class\";s:12:\"ilobjtestgui\";s:6:\"parent\";i:1;}i:2371;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2370;}i:2372;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2371;}i:2373;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2372;}i:2374;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2372;}i:2375;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2372;}i:2376;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2375;}i:2377;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2375;}i:2378;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2377;}i:2379;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2375;}i:2380;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2379;}i:2381;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2375;}i:2382;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2381;}i:2383;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2375;}i:2384;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2383;}i:2385;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2372;}i:2386;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2372;}i:2387;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2372;}i:2388;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2372;}i:2389;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2388;}i:2390;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2372;}i:2391;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2390;}i:2392;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2390;}i:2393;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2392;}i:2394;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2390;}i:2395;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2394;}i:2396;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2390;}i:2397;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2396;}i:2398;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2390;}i:2399;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2398;}i:2400;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2372;}i:2401;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2372;}i:2402;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2372;}i:2403;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2372;}i:2404;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2372;}i:2405;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2372;}i:2406;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2372;}i:2407;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2372;}i:2408;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2372;}i:2409;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2408;}i:2410;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2371;}i:2411;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2410;}i:2412;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2371;}i:2413;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2371;}i:2414;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2370;}i:2415;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:2414;}i:2416;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:2414;}i:2417;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2416;}i:2418;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2417;}i:2419;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2416;}i:2420;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2419;}i:2421;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:2416;}i:2422;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2421;}i:2423;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:2414;}i:2424;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2423;}i:2425;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2424;}i:2426;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2423;}i:2427;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2426;}i:2428;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:2414;}i:2429;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2428;}i:2430;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2370;}i:2431;a:2:{s:5:\"class\";s:14:\"ilobjcoursegui\";s:6:\"parent\";i:2370;}i:2432;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2431;}i:2433;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2432;}i:2434;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2432;}i:2435;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2432;}i:2436;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2435;}i:2437;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2435;}i:2438;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2437;}i:2439;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2435;}i:2440;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2439;}i:2441;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2435;}i:2442;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2441;}i:2443;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2435;}i:2444;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2443;}i:2445;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2432;}i:2446;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2432;}i:2447;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2432;}i:2448;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2432;}i:2449;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2448;}i:2450;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2432;}i:2451;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2450;}i:2452;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2450;}i:2453;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2452;}i:2454;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2450;}i:2455;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2454;}i:2456;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2450;}i:2457;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2456;}i:2458;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2450;}i:2459;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2458;}i:2460;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2432;}i:2461;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2432;}i:2462;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2432;}i:2463;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2432;}i:2464;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2432;}i:2465;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2432;}i:2466;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2432;}i:2467;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2432;}i:2468;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2432;}i:2469;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2468;}i:2470;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:2431;}i:2471;a:2:{s:5:\"class\";s:20:\"ilcourseagreementgui\";s:6:\"parent\";i:2431;}i:2472;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2471;}i:2473;a:2:{s:5:\"class\";s:18:\"ilcoursecontentgui\";s:6:\"parent\";i:2431;}i:2474;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2473;}i:2475;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2474;}i:2476;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2474;}i:2477;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2474;}i:2478;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2477;}i:2479;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2477;}i:2480;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2479;}i:2481;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2477;}i:2482;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2481;}i:2483;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2477;}i:2484;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2483;}i:2485;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2477;}i:2486;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2485;}i:2487;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2474;}i:2488;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2474;}i:2489;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2474;}i:2490;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2474;}i:2491;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2490;}i:2492;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2474;}i:2493;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2492;}i:2494;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2492;}i:2495;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2494;}i:2496;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2492;}i:2497;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2496;}i:2498;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2492;}i:2499;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2498;}i:2500;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2492;}i:2501;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2500;}i:2502;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2474;}i:2503;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2474;}i:2504;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2474;}i:2505;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2474;}i:2506;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2474;}i:2507;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2474;}i:2508;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2474;}i:2509;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2474;}i:2510;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2474;}i:2511;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2510;}i:2512;a:2:{s:5:\"class\";s:19:\"ilcoursearchivesgui\";s:6:\"parent\";i:2473;}i:2513;a:2:{s:5:\"class\";s:32:\"ilcourseobjectivepresentationgui\";s:6:\"parent\";i:2473;}i:2514;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2513;}i:2515;a:2:{s:5:\"class\";s:29:\"ilcourseitemadministrationgui\";s:6:\"parent\";i:2431;}i:2516;a:2:{s:5:\"class\";s:27:\"ilconditionhandlerinterface\";s:6:\"parent\";i:2515;}i:2517;a:2:{s:5:\"class\";s:21:\"ilcourseobjectivesgui\";s:6:\"parent\";i:2431;}i:2518;a:2:{s:5:\"class\";s:23:\"ilcourseregistrationgui\";s:6:\"parent\";i:2431;}i:2519;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2518;}i:2520;a:2:{s:5:\"class\";s:21:\"ilcourseuserfieldsgui\";s:6:\"parent\";i:2431;}i:2521;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2431;}i:2522;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2521;}i:2523;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2522;}i:2524;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2522;}i:2525;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2522;}i:2526;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2525;}i:2527;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2525;}i:2528;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2527;}i:2529;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2525;}i:2530;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2529;}i:2531;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2525;}i:2532;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2531;}i:2533;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2525;}i:2534;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2533;}i:2535;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2522;}i:2536;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2522;}i:2537;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2522;}i:2538;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2522;}i:2539;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2538;}i:2540;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2522;}i:2541;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2540;}i:2542;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2540;}i:2543;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2542;}i:2544;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2540;}i:2545;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2544;}i:2546;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2540;}i:2547;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2546;}i:2548;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2540;}i:2549;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2548;}i:2550;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2522;}i:2551;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2522;}i:2552;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2522;}i:2553;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2522;}i:2554;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2522;}i:2555;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2522;}i:2556;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2522;}i:2557;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2522;}i:2558;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2522;}i:2559;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2558;}i:2560;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2521;}i:2561;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2560;}i:2562;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2521;}i:2563;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2521;}i:2564;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2431;}i:2565;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:2564;}i:2566;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:2564;}i:2567;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2566;}i:2568;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2567;}i:2569;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2566;}i:2570;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2569;}i:2571;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:2566;}i:2572;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2571;}i:2573;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:2564;}i:2574;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2573;}i:2575;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2574;}i:2576;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2573;}i:2577;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2576;}i:2578;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:2564;}i:2579;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2578;}i:2580;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2431;}i:2581;a:2:{s:5:\"class\";s:17:\"ilmemberexportgui\";s:6:\"parent\";i:2431;}i:2582;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2581;}i:2583;a:2:{s:5:\"class\";s:22:\"ilobjcoursegroupinggui\";s:6:\"parent\";i:2431;}i:2584;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2431;}i:2585;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2584;}i:2586;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2585;}i:2587;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2586;}i:2588;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2587;}i:2589;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2586;}i:2590;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2584;}i:2591;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2584;}i:2592;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2591;}i:2593;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2591;}i:2594;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2593;}i:2595;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2594;}i:2596;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2593;}i:2597;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2591;}i:2598;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2591;}i:2599;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2591;}i:2600;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2591;}i:2601;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2591;}i:2602;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2591;}i:2603;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2591;}i:2604;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2603;}i:2605;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2604;}i:2606;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2605;}i:2607;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2604;}i:2608;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2603;}i:2609;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2608;}i:2610;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2591;}i:2611;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2591;}i:2612;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2591;}i:2613;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2591;}i:2614;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2591;}i:2615;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2591;}i:2616;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2591;}i:2617;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2591;}i:2618;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2591;}i:2619;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2584;}i:2620;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2431;}i:2621;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2620;}i:2622;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2621;}i:2623;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2431;}i:2624;a:2:{s:5:\"class\";s:21:\"ilrepositorysearchgui\";s:6:\"parent\";i:2431;}i:2625;a:2:{s:5:\"class\";s:20:\"ilsessionoverviewgui\";s:6:\"parent\";i:2431;}i:2626;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:2431;}i:2627;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2626;}i:2628;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2627;}i:2629;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2628;}i:2630;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2629;}i:2631;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2630;}i:2632;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2629;}i:2633;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2627;}i:2634;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2627;}i:2635;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2634;}i:2636;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2634;}i:2637;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2636;}i:2638;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2637;}i:2639;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2636;}i:2640;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2634;}i:2641;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2634;}i:2642;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2634;}i:2643;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2634;}i:2644;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2634;}i:2645;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2634;}i:2646;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2634;}i:2647;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2646;}i:2648;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2647;}i:2649;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2648;}i:2650;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2647;}i:2651;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2646;}i:2652;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2651;}i:2653;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2634;}i:2654;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2634;}i:2655;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2634;}i:2656;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2634;}i:2657;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2634;}i:2658;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2634;}i:2659;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2634;}i:2660;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2634;}i:2661;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2634;}i:2662;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2627;}i:2663;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2370;}i:2664;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2663;}i:2665;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2664;}i:2666;a:2:{s:5:\"class\";s:17:\"ilshoppurchasegui\";s:6:\"parent\";i:2370;}i:2667;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2666;}i:2668;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2667;}i:2669;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2668;}i:2670;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2669;}i:2671;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2670;}i:2672;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2669;}i:2673;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2667;}i:2674;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2667;}i:2675;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2674;}i:2676;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2674;}i:2677;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2676;}i:2678;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2677;}i:2679;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2676;}i:2680;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2674;}i:2681;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2674;}i:2682;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2674;}i:2683;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2674;}i:2684;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2674;}i:2685;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2674;}i:2686;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2674;}i:2687;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2686;}i:2688;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2687;}i:2689;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2688;}i:2690;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2687;}i:2691;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2686;}i:2692;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2691;}i:2693;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2674;}i:2694;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2674;}i:2695;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2674;}i:2696;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2674;}i:2697;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2674;}i:2698;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2674;}i:2699;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2674;}i:2700;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2674;}i:2701;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2674;}i:2702;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2667;}i:2703;a:2:{s:5:\"class\";s:20:\"iltestcertificategui\";s:6:\"parent\";i:2370;}i:2704;a:2:{s:5:\"class\";s:19:\"iltestevaluationgui\";s:6:\"parent\";i:2370;}i:2705;a:2:{s:5:\"class\";s:15:\"iltestoutputgui\";s:6:\"parent\";i:2370;}i:2706;a:2:{s:5:\"class\";s:16:\"iltestscoringgui\";s:6:\"parent\";i:2370;}i:2707;a:2:{s:5:\"class\";s:16:\"iltestservicegui\";s:6:\"parent\";i:2370;}i:2708;a:2:{s:5:\"class\";s:18:\"ilobjuserfoldergui\";s:6:\"parent\";i:1;}i:2709;a:2:{s:5:\"class\";s:20:\"iladminusersearchgui\";s:6:\"parent\";i:2708;}i:2710;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:2709;}i:2711;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2710;}i:2712;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:2711;}i:2713;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:2711;}i:2714;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2713;}i:2715;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2714;}i:2716;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2713;}i:2717;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2716;}i:2718;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:2713;}i:2719;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2718;}i:2720;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:2711;}i:2721;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2720;}i:2722;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2721;}i:2723;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2720;}i:2724;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2723;}i:2725;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:2711;}i:2726;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2725;}i:2727;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:2710;}i:2728;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2708;}i:2729;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2728;}i:2730;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2729;}i:2731;a:2:{s:5:\"class\";s:12:\"ilobjusergui\";s:6:\"parent\";i:1;}i:2732;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2731;}i:2733;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:2732;}i:2734;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:2732;}i:2735;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2734;}i:2736;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2735;}i:2737;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2734;}i:2738;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2737;}i:2739;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:2734;}i:2740;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2739;}i:2741;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:2732;}i:2742;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2741;}i:2743;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2742;}i:2744;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2741;}i:2745;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2744;}i:2746;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:2732;}i:2747;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2746;}i:2748;a:2:{s:5:\"class\";s:17:\"ilobjilincusergui\";s:6:\"parent\";i:2731;}i:2749;a:2:{s:5:\"class\";s:20:\"ilobjusertrackinggui\";s:6:\"parent\";i:1;}i:2750;a:2:{s:5:\"class\";s:21:\"illearningprogressgui\";s:6:\"parent\";i:2749;}i:2751;a:2:{s:5:\"class\";s:17:\"illmstatisticsgui\";s:6:\"parent\";i:2750;}i:2752;a:2:{s:5:\"class\";s:20:\"illplistofobjectsgui\";s:6:\"parent\";i:2750;}i:2753;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2752;}i:2754;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2753;}i:2755;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2752;}i:2756;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2755;}i:2757;a:2:{s:5:\"class\";s:15:\"iluserfiltergui\";s:6:\"parent\";i:2752;}i:2758;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2757;}i:2759;a:2:{s:5:\"class\";s:21:\"illplistofprogressgui\";s:6:\"parent\";i:2750;}i:2760;a:2:{s:5:\"class\";s:13:\"illpfiltergui\";s:6:\"parent\";i:2759;}i:2761;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2760;}i:2762;a:2:{s:5:\"class\";s:17:\"ilpdfpresentation\";s:6:\"parent\";i:2759;}i:2763;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2762;}i:2764;a:2:{s:5:\"class\";s:21:\"illplistofsettingsgui\";s:6:\"parent\";i:2750;}i:2765;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2764;}i:2766;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2749;}i:2767;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2766;}i:2768;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2767;}i:2769;a:2:{s:5:\"class\";s:12:\"ilobjwikigui\";s:6:\"parent\";i:1;}i:2770;a:2:{s:5:\"class\";s:15:\"ilinfoscreengui\";s:6:\"parent\";i:2769;}i:2771;a:2:{s:5:\"class\";s:11:\"ilcolumngui\";s:6:\"parent\";i:2770;}i:2772;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2771;}i:2773;a:2:{s:5:\"class\";s:18:\"ilbookmarkblockgui\";s:6:\"parent\";i:2771;}i:2774;a:2:{s:5:\"class\";s:18:\"ilcalendarblockgui\";s:6:\"parent\";i:2771;}i:2775;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2774;}i:2776;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2774;}i:2777;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2776;}i:2778;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2774;}i:2779;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2778;}i:2780;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2774;}i:2781;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2780;}i:2782;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2774;}i:2783;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2782;}i:2784;a:2:{s:5:\"class\";s:15:\"ildummyblockgui\";s:6:\"parent\";i:2771;}i:2785;a:2:{s:5:\"class\";s:22:\"ilexternalfeedblockgui\";s:6:\"parent\";i:2771;}i:2786;a:2:{s:5:\"class\";s:14:\"ilhtmlblockgui\";s:6:\"parent\";i:2771;}i:2787;a:2:{s:5:\"class\";s:24:\"ilnewsforcontextblockgui\";s:6:\"parent\";i:2771;}i:2788;a:2:{s:5:\"class\";s:13:\"ilnewsitemgui\";s:6:\"parent\";i:2787;}i:2789;a:2:{s:5:\"class\";s:20:\"ilpdcalendarblockgui\";s:6:\"parent\";i:2771;}i:2790;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2789;}i:2791;a:2:{s:5:\"class\";s:16:\"ilcalendardaygui\";s:6:\"parent\";i:2789;}i:2792;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2791;}i:2793;a:2:{s:5:\"class\";s:18:\"ilcalendarinboxgui\";s:6:\"parent\";i:2789;}i:2794;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2793;}i:2795;a:2:{s:5:\"class\";s:18:\"ilcalendarmonthgui\";s:6:\"parent\";i:2789;}i:2796;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2795;}i:2797;a:2:{s:5:\"class\";s:17:\"ilcalendarweekgui\";s:6:\"parent\";i:2789;}i:2798;a:2:{s:5:\"class\";s:24:\"ilcalendarappointmentgui\";s:6:\"parent\";i:2797;}i:2799;a:2:{s:5:\"class\";s:24:\"ilpdexternalfeedblockgui\";s:6:\"parent\";i:2771;}i:2800;a:2:{s:5:\"class\";s:20:\"ilpdfeedbackblockgui\";s:6:\"parent\";i:2771;}i:2801;a:2:{s:5:\"class\";s:16:\"ilpdmailblockgui\";s:6:\"parent\";i:2771;}i:2802;a:2:{s:5:\"class\";s:16:\"ilpdnewsblockgui\";s:6:\"parent\";i:2771;}i:2803;a:2:{s:5:\"class\";s:17:\"ilpdnotesblockgui\";s:6:\"parent\";i:2771;}i:2804;a:2:{s:5:\"class\";s:25:\"ilpdselecteditemsblockgui\";s:6:\"parent\";i:2771;}i:2805;a:2:{s:5:\"class\";s:22:\"ilpdsysmessageblockgui\";s:6:\"parent\";i:2771;}i:2806;a:2:{s:5:\"class\";s:19:\"ilpdtaggingblockgui\";s:6:\"parent\";i:2771;}i:2807;a:2:{s:5:\"class\";s:21:\"ilusersonlineblockgui\";s:6:\"parent\";i:2771;}i:2808;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2807;}i:2809;a:2:{s:5:\"class\";s:13:\"ilfeedbackgui\";s:6:\"parent\";i:2770;}i:2810;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2809;}i:2811;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2770;}i:2812;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2770;}i:2813;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:2769;}i:2814;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2813;}i:2815;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2814;}i:2816;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2769;}i:2817;a:2:{s:5:\"class\";s:13:\"ilwikipagegui\";s:6:\"parent\";i:2769;}i:2818;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2817;}i:2819;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2818;}i:2820;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2819;}i:2821;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2820;}i:2822;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2819;}i:2823;a:2:{s:5:\"class\";s:25:\"ilmediapooltargetselector\";s:6:\"parent\";i:2817;}i:2824;a:2:{s:5:\"class\";s:9:\"ilnotegui\";s:6:\"parent\";i:2817;}i:2825;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2817;}i:2826;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2825;}i:2827;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2825;}i:2828;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2827;}i:2829;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2828;}i:2830;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2827;}i:2831;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2825;}i:2832;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2825;}i:2833;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2825;}i:2834;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2825;}i:2835;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2825;}i:2836;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2825;}i:2837;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2825;}i:2838;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2837;}i:2839;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2838;}i:2840;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2839;}i:2841;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2838;}i:2842;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2837;}i:2843;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2842;}i:2844;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2825;}i:2845;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2825;}i:2846;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2825;}i:2847;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2825;}i:2848;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2825;}i:2849;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2825;}i:2850;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2825;}i:2851;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2825;}i:2852;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2825;}i:2853;a:2:{s:5:\"class\";s:15:\"ilpageobjectgui\";s:6:\"parent\";i:2817;}i:2854;a:2:{s:5:\"class\";s:18:\"ileditclipboardgui\";s:6:\"parent\";i:2853;}i:2855;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2854;}i:2856;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2855;}i:2857;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2856;}i:2858;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2855;}i:2859;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2853;}i:2860;a:2:{s:5:\"class\";s:15:\"ilpageeditorgui\";s:6:\"parent\";i:2853;}i:2861;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2860;}i:2862;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2860;}i:2863;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2862;}i:2864;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2863;}i:2865;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2862;}i:2866;a:2:{s:5:\"class\";s:16:\"ilpcdatatablegui\";s:6:\"parent\";i:2860;}i:2867;a:2:{s:5:\"class\";s:15:\"ilpcfileitemgui\";s:6:\"parent\";i:2860;}i:2868;a:2:{s:5:\"class\";s:15:\"ilpcfilelistgui\";s:6:\"parent\";i:2860;}i:2869;a:2:{s:5:\"class\";s:11:\"ilpclistgui\";s:6:\"parent\";i:2860;}i:2870;a:2:{s:5:\"class\";s:15:\"ilpclistitemgui\";s:6:\"parent\";i:2860;}i:2871;a:2:{s:5:\"class\";s:10:\"ilpcmapgui\";s:6:\"parent\";i:2860;}i:2872;a:2:{s:5:\"class\";s:18:\"ilpcmediaobjectgui\";s:6:\"parent\";i:2860;}i:2873;a:2:{s:5:\"class\";s:19:\"ilobjmediaobjectgui\";s:6:\"parent\";i:2872;}i:2874;a:2:{s:5:\"class\";s:19:\"ilimagemapeditorgui\";s:6:\"parent\";i:2873;}i:2875;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2874;}i:2876;a:2:{s:5:\"class\";s:13:\"ilmdeditorgui\";s:6:\"parent\";i:2873;}i:2877;a:2:{s:5:\"class\";s:21:\"ilpcimagemapeditorgui\";s:6:\"parent\";i:2872;}i:2878;a:2:{s:5:\"class\";s:17:\"ilinternallinkgui\";s:6:\"parent\";i:2877;}i:2879;a:2:{s:5:\"class\";s:16:\"ilpcparagraphgui\";s:6:\"parent\";i:2860;}i:2880;a:2:{s:5:\"class\";s:14:\"ilpcpluggedgui\";s:6:\"parent\";i:2860;}i:2881;a:2:{s:5:\"class\";s:15:\"ilpcquestiongui\";s:6:\"parent\";i:2860;}i:2882;a:2:{s:5:\"class\";s:16:\"ilpcresourcesgui\";s:6:\"parent\";i:2860;}i:2883;a:2:{s:5:\"class\";s:14:\"ilpcsectiongui\";s:6:\"parent\";i:2860;}i:2884;a:2:{s:5:\"class\";s:17:\"ilpcsourcecodegui\";s:6:\"parent\";i:2860;}i:2885;a:2:{s:5:\"class\";s:16:\"ilpctabledatagui\";s:6:\"parent\";i:2860;}i:2886;a:2:{s:5:\"class\";s:12:\"ilpctablegui\";s:6:\"parent\";i:2860;}i:2887;a:2:{s:5:\"class\";s:11:\"ilpctabsgui\";s:6:\"parent\";i:2860;}i:2888;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2853;}i:2889;a:2:{s:5:\"class\";s:22:\"ilpublicuserprofilegui\";s:6:\"parent\";i:2817;}i:2890;a:2:{s:5:\"class\";s:11:\"ilratinggui\";s:6:\"parent\";i:2817;}i:2891;a:2:{s:5:\"class\";s:15:\"ilpermissiongui\";s:6:\"parent\";i:1;}i:2892;a:2:{s:5:\"class\";s:12:\"ilobjrolegui\";s:6:\"parent\";i:2891;}i:2893;a:2:{s:5:\"class\";s:0:\"\";s:6:\"parent\";i:2892;}}','a:105:{s:0:\"\";a:1781:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:0:\"\";i:68;s:0:\"\";i:69;s:0:\"\";i:70;s:0:\"\";i:71;s:0:\"\";i:72;s:0:\"\";i:73;s:0:\"\";i:74;s:0:\"\";i:75;s:0:\"\";i:76;s:0:\"\";i:77;s:0:\"\";i:78;s:0:\"\";i:79;s:0:\"\";i:80;s:0:\"\";i:81;s:0:\"\";i:82;s:0:\"\";i:83;s:0:\"\";i:84;s:0:\"\";i:85;s:0:\"\";i:86;s:0:\"\";i:87;s:0:\"\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:0:\"\";i:91;s:0:\"\";i:92;s:0:\"\";i:93;s:0:\"\";i:94;s:0:\"\";i:95;s:0:\"\";i:96;s:0:\"\";i:97;s:0:\"\";i:98;s:0:\"\";i:99;s:0:\"\";i:100;s:0:\"\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:0:\"\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:0:\"\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:0:\"\";i:137;s:0:\"\";i:138;s:0:\"\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:0:\"\";i:142;s:0:\"\";i:143;s:0:\"\";i:144;s:0:\"\";i:145;s:0:\"\";i:146;s:0:\"\";i:147;s:0:\"\";i:148;s:0:\"\";i:149;s:0:\"\";i:150;s:0:\"\";i:151;s:0:\"\";i:152;s:0:\"\";i:153;s:0:\"\";i:154;s:0:\"\";i:155;s:0:\"\";i:156;s:0:\"\";i:157;s:0:\"\";i:158;s:0:\"\";i:159;s:0:\"\";i:160;s:0:\"\";i:161;s:0:\"\";i:162;s:0:\"\";i:163;s:0:\"\";i:164;s:0:\"\";i:165;s:0:\"\";i:166;s:0:\"\";i:167;s:0:\"\";i:168;s:0:\"\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:0:\"\";i:172;s:0:\"\";i:173;s:0:\"\";i:174;s:0:\"\";i:175;s:0:\"\";i:176;s:0:\"\";i:177;s:0:\"\";i:178;s:0:\"\";i:179;s:0:\"\";i:180;s:0:\"\";i:181;s:0:\"\";i:182;s:0:\"\";i:183;s:0:\"\";i:184;s:0:\"\";i:185;s:0:\"\";i:186;s:0:\"\";i:187;s:0:\"\";i:188;s:0:\"\";i:189;s:0:\"\";i:190;s:0:\"\";i:191;s:0:\"\";i:192;s:0:\"\";i:193;s:0:\"\";i:194;s:0:\"\";i:195;s:0:\"\";i:196;s:0:\"\";i:197;s:0:\"\";i:198;s:0:\"\";i:199;s:0:\"\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:0:\"\";i:207;s:0:\"\";i:208;s:0:\"\";i:209;s:0:\"\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:0:\"\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:0:\"\";i:220;s:0:\"\";i:221;s:0:\"\";i:222;s:0:\"\";i:223;s:0:\"\";i:224;s:0:\"\";i:225;s:0:\"\";i:226;s:0:\"\";i:227;s:0:\"\";i:228;s:0:\"\";i:229;s:0:\"\";i:230;s:0:\"\";i:231;s:0:\"\";i:232;s:0:\"\";i:233;s:0:\"\";i:234;s:0:\"\";i:235;s:0:\"\";i:236;s:0:\"\";i:237;s:0:\"\";i:238;s:0:\"\";i:239;s:0:\"\";i:240;s:0:\"\";i:241;s:0:\"\";i:242;s:0:\"\";i:243;s:0:\"\";i:244;s:0:\"\";i:245;s:0:\"\";i:246;s:0:\"\";i:247;s:0:\"\";i:248;s:0:\"\";i:249;s:0:\"\";i:250;s:0:\"\";i:251;s:0:\"\";i:252;s:0:\"\";i:253;s:0:\"\";i:254;s:0:\"\";i:255;s:0:\"\";i:256;s:0:\"\";i:257;s:0:\"\";i:258;s:0:\"\";i:259;s:0:\"\";i:260;s:0:\"\";i:261;s:0:\"\";i:262;s:0:\"\";i:263;s:0:\"\";i:264;s:0:\"\";i:265;s:0:\"\";i:266;s:0:\"\";i:267;s:0:\"\";i:268;s:0:\"\";i:269;s:0:\"\";i:270;s:0:\"\";i:271;s:0:\"\";i:272;s:0:\"\";i:273;s:0:\"\";i:274;s:0:\"\";i:275;s:0:\"\";i:276;s:0:\"\";i:277;s:0:\"\";i:278;s:0:\"\";i:279;s:0:\"\";i:280;s:0:\"\";i:281;s:0:\"\";i:282;s:0:\"\";i:283;s:0:\"\";i:284;s:0:\"\";i:285;s:0:\"\";i:286;s:0:\"\";i:287;s:0:\"\";i:288;s:0:\"\";i:289;s:0:\"\";i:290;s:0:\"\";i:291;s:0:\"\";i:292;s:0:\"\";i:293;s:0:\"\";i:294;s:0:\"\";i:295;s:0:\"\";i:296;s:0:\"\";i:297;s:0:\"\";i:298;s:0:\"\";i:299;s:0:\"\";i:300;s:0:\"\";i:301;s:0:\"\";i:302;s:0:\"\";i:303;s:0:\"\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:0:\"\";i:307;s:0:\"\";i:308;s:0:\"\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:0:\"\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:0:\"\";i:317;s:0:\"\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:0:\"\";i:321;s:0:\"\";i:322;s:0:\"\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:0:\"\";i:327;s:0:\"\";i:328;s:0:\"\";i:329;s:0:\"\";i:330;s:0:\"\";i:331;s:0:\"\";i:332;s:0:\"\";i:333;s:0:\"\";i:334;s:0:\"\";i:335;s:0:\"\";i:336;s:0:\"\";i:337;s:0:\"\";i:338;s:0:\"\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:0:\"\";i:343;s:0:\"\";i:344;s:0:\"\";i:345;s:0:\"\";i:346;s:0:\"\";i:347;s:0:\"\";i:348;s:0:\"\";i:349;s:0:\"\";i:350;s:0:\"\";i:351;s:0:\"\";i:352;s:0:\"\";i:353;s:0:\"\";i:354;s:0:\"\";i:355;s:0:\"\";i:356;s:0:\"\";i:357;s:0:\"\";i:358;s:0:\"\";i:359;s:0:\"\";i:360;s:0:\"\";i:361;s:0:\"\";i:362;s:0:\"\";i:363;s:0:\"\";i:364;s:0:\"\";i:365;s:0:\"\";i:366;s:0:\"\";i:367;s:0:\"\";i:368;s:0:\"\";i:369;s:0:\"\";i:370;s:0:\"\";i:371;s:0:\"\";i:372;s:0:\"\";i:373;s:0:\"\";i:374;s:0:\"\";i:375;s:0:\"\";i:376;s:0:\"\";i:377;s:0:\"\";i:378;s:0:\"\";i:379;s:0:\"\";i:380;s:0:\"\";i:381;s:0:\"\";i:382;s:0:\"\";i:383;s:0:\"\";i:384;s:0:\"\";i:385;s:0:\"\";i:386;s:0:\"\";i:387;s:0:\"\";i:388;s:0:\"\";i:389;s:0:\"\";i:390;s:0:\"\";i:391;s:0:\"\";i:392;s:0:\"\";i:393;s:0:\"\";i:394;s:0:\"\";i:395;s:0:\"\";i:396;s:0:\"\";i:397;s:0:\"\";i:398;s:0:\"\";i:399;s:0:\"\";i:400;s:0:\"\";i:401;s:0:\"\";i:402;s:0:\"\";i:403;s:0:\"\";i:404;s:0:\"\";i:405;s:0:\"\";i:406;s:0:\"\";i:407;s:0:\"\";i:408;s:0:\"\";i:409;s:0:\"\";i:410;s:0:\"\";i:411;s:0:\"\";i:412;s:0:\"\";i:413;s:0:\"\";i:414;s:0:\"\";i:415;s:0:\"\";i:416;s:0:\"\";i:417;s:0:\"\";i:418;s:0:\"\";i:419;s:0:\"\";i:420;s:0:\"\";i:421;s:0:\"\";i:422;s:0:\"\";i:423;s:0:\"\";i:424;s:0:\"\";i:425;s:0:\"\";i:426;s:0:\"\";i:427;s:0:\"\";i:428;s:0:\"\";i:429;s:0:\"\";i:430;s:0:\"\";i:431;s:0:\"\";i:432;s:0:\"\";i:433;s:0:\"\";i:434;s:0:\"\";i:435;s:0:\"\";i:436;s:0:\"\";i:437;s:0:\"\";i:438;s:0:\"\";i:439;s:0:\"\";i:440;s:0:\"\";i:441;s:0:\"\";i:442;s:0:\"\";i:443;s:0:\"\";i:444;s:0:\"\";i:445;s:0:\"\";i:446;s:0:\"\";i:447;s:0:\"\";i:448;s:0:\"\";i:449;s:0:\"\";i:450;s:0:\"\";i:451;s:0:\"\";i:452;s:0:\"\";i:453;s:0:\"\";i:454;s:0:\"\";i:455;s:0:\"\";i:456;s:0:\"\";i:457;s:0:\"\";i:458;s:0:\"\";i:459;s:0:\"\";i:460;s:0:\"\";i:461;s:0:\"\";i:462;s:0:\"\";i:463;s:0:\"\";i:464;s:0:\"\";i:465;s:0:\"\";i:466;s:0:\"\";i:467;s:0:\"\";i:468;s:0:\"\";i:469;s:0:\"\";i:470;s:0:\"\";i:471;s:0:\"\";i:472;s:0:\"\";i:473;s:0:\"\";i:474;s:0:\"\";i:475;s:0:\"\";i:476;s:0:\"\";i:477;s:0:\"\";i:478;s:0:\"\";i:479;s:0:\"\";i:480;s:0:\"\";i:481;s:0:\"\";i:482;s:0:\"\";i:483;s:0:\"\";i:484;s:0:\"\";i:485;s:0:\"\";i:486;s:0:\"\";i:487;s:0:\"\";i:488;s:0:\"\";i:489;s:0:\"\";i:490;s:0:\"\";i:491;s:0:\"\";i:492;s:0:\"\";i:493;s:0:\"\";i:494;s:0:\"\";i:495;s:0:\"\";i:496;s:0:\"\";i:497;s:0:\"\";i:498;s:0:\"\";i:499;s:0:\"\";i:500;s:0:\"\";i:501;s:0:\"\";i:502;s:0:\"\";i:503;s:0:\"\";i:504;s:0:\"\";i:505;s:0:\"\";i:506;s:0:\"\";i:507;s:0:\"\";i:508;s:0:\"\";i:509;s:0:\"\";i:510;s:0:\"\";i:511;s:0:\"\";i:512;s:0:\"\";i:513;s:0:\"\";i:514;s:0:\"\";i:515;s:0:\"\";i:516;s:0:\"\";i:517;s:0:\"\";i:518;s:0:\"\";i:519;s:0:\"\";i:520;s:0:\"\";i:521;s:0:\"\";i:522;s:0:\"\";i:523;s:0:\"\";i:524;s:0:\"\";i:525;s:0:\"\";i:526;s:0:\"\";i:527;s:0:\"\";i:528;s:0:\"\";i:529;s:0:\"\";i:530;s:0:\"\";i:531;s:0:\"\";i:532;s:0:\"\";i:533;s:0:\"\";i:534;s:0:\"\";i:535;s:0:\"\";i:536;s:0:\"\";i:537;s:0:\"\";i:538;s:0:\"\";i:539;s:0:\"\";i:540;s:0:\"\";i:541;s:0:\"\";i:542;s:0:\"\";i:543;s:0:\"\";i:544;s:0:\"\";i:545;s:0:\"\";i:546;s:0:\"\";i:547;s:0:\"\";i:548;s:0:\"\";i:549;s:0:\"\";i:550;s:0:\"\";i:551;s:0:\"\";i:552;s:0:\"\";i:553;s:0:\"\";i:554;s:0:\"\";i:555;s:0:\"\";i:556;s:0:\"\";i:557;s:0:\"\";i:558;s:0:\"\";i:559;s:0:\"\";i:560;s:0:\"\";i:561;s:0:\"\";i:562;s:0:\"\";i:563;s:0:\"\";i:564;s:0:\"\";i:565;s:0:\"\";i:566;s:0:\"\";i:567;s:0:\"\";i:568;s:0:\"\";i:569;s:0:\"\";i:570;s:0:\"\";i:571;s:0:\"\";i:572;s:0:\"\";i:573;s:0:\"\";i:574;s:0:\"\";i:575;s:0:\"\";i:576;s:0:\"\";i:577;s:0:\"\";i:578;s:0:\"\";i:579;s:0:\"\";i:580;s:0:\"\";i:581;s:0:\"\";i:582;s:0:\"\";i:583;s:0:\"\";i:584;s:0:\"\";i:585;s:0:\"\";i:586;s:0:\"\";i:587;s:0:\"\";i:588;s:0:\"\";i:589;s:0:\"\";i:590;s:0:\"\";i:591;s:0:\"\";i:592;s:0:\"\";i:593;s:0:\"\";i:594;s:0:\"\";i:595;s:0:\"\";i:596;s:0:\"\";i:597;s:0:\"\";i:598;s:0:\"\";i:599;s:0:\"\";i:600;s:0:\"\";i:601;s:0:\"\";i:602;s:0:\"\";i:603;s:0:\"\";i:604;s:0:\"\";i:605;s:0:\"\";i:606;s:0:\"\";i:607;s:0:\"\";i:608;s:0:\"\";i:609;s:0:\"\";i:610;s:0:\"\";i:611;s:0:\"\";i:612;s:0:\"\";i:613;s:0:\"\";i:614;s:0:\"\";i:615;s:0:\"\";i:616;s:0:\"\";i:617;s:0:\"\";i:618;s:0:\"\";i:619;s:0:\"\";i:620;s:0:\"\";i:621;s:0:\"\";i:622;s:0:\"\";i:623;s:0:\"\";i:624;s:0:\"\";i:625;s:0:\"\";i:626;s:0:\"\";i:627;s:0:\"\";i:628;s:0:\"\";i:629;s:0:\"\";i:630;s:0:\"\";i:631;s:0:\"\";i:632;s:0:\"\";i:633;s:0:\"\";i:634;s:0:\"\";i:635;s:0:\"\";i:636;s:0:\"\";i:637;s:0:\"\";i:638;s:0:\"\";i:639;s:0:\"\";i:640;s:0:\"\";i:641;s:0:\"\";i:642;s:0:\"\";i:643;s:0:\"\";i:644;s:0:\"\";i:645;s:0:\"\";i:646;s:0:\"\";i:647;s:0:\"\";i:648;s:0:\"\";i:649;s:0:\"\";i:650;s:0:\"\";i:651;s:0:\"\";i:652;s:0:\"\";i:653;s:0:\"\";i:654;s:0:\"\";i:655;s:0:\"\";i:656;s:0:\"\";i:657;s:0:\"\";i:658;s:0:\"\";i:659;s:0:\"\";i:660;s:0:\"\";i:661;s:0:\"\";i:662;s:0:\"\";i:663;s:0:\"\";i:664;s:0:\"\";i:665;s:0:\"\";i:666;s:0:\"\";i:667;s:0:\"\";i:668;s:0:\"\";i:669;s:0:\"\";i:670;s:0:\"\";i:671;s:0:\"\";i:672;s:0:\"\";i:673;s:0:\"\";i:674;s:0:\"\";i:675;s:0:\"\";i:676;s:0:\"\";i:677;s:0:\"\";i:678;s:0:\"\";i:679;s:0:\"\";i:680;s:0:\"\";i:681;s:0:\"\";i:682;s:0:\"\";i:683;s:0:\"\";i:684;s:0:\"\";i:685;s:0:\"\";i:686;s:0:\"\";i:687;s:0:\"\";i:688;s:0:\"\";i:689;s:0:\"\";i:690;s:0:\"\";i:691;s:0:\"\";i:692;s:0:\"\";i:693;s:0:\"\";i:694;s:0:\"\";i:695;s:0:\"\";i:696;s:0:\"\";i:697;s:0:\"\";i:698;s:0:\"\";i:699;s:0:\"\";i:700;s:0:\"\";i:701;s:0:\"\";i:702;s:0:\"\";i:703;s:0:\"\";i:704;s:0:\"\";i:705;s:0:\"\";i:706;s:0:\"\";i:707;s:0:\"\";i:708;s:0:\"\";i:709;s:0:\"\";i:710;s:0:\"\";i:711;s:0:\"\";i:712;s:0:\"\";i:713;s:0:\"\";i:714;s:0:\"\";i:715;s:0:\"\";i:716;s:0:\"\";i:717;s:0:\"\";i:718;s:0:\"\";i:719;s:0:\"\";i:720;s:0:\"\";i:721;s:0:\"\";i:722;s:0:\"\";i:723;s:0:\"\";i:724;s:0:\"\";i:725;s:0:\"\";i:726;s:0:\"\";i:727;s:0:\"\";i:728;s:0:\"\";i:729;s:0:\"\";i:730;s:0:\"\";i:731;s:0:\"\";i:732;s:0:\"\";i:733;s:0:\"\";i:734;s:0:\"\";i:735;s:0:\"\";i:736;s:0:\"\";i:737;s:0:\"\";i:738;s:0:\"\";i:739;s:0:\"\";i:740;s:0:\"\";i:741;s:0:\"\";i:742;s:0:\"\";i:743;s:0:\"\";i:744;s:0:\"\";i:745;s:0:\"\";i:746;s:0:\"\";i:747;s:0:\"\";i:748;s:0:\"\";i:749;s:0:\"\";i:750;s:0:\"\";i:751;s:0:\"\";i:752;s:0:\"\";i:753;s:0:\"\";i:754;s:0:\"\";i:755;s:0:\"\";i:756;s:0:\"\";i:757;s:0:\"\";i:758;s:0:\"\";i:759;s:0:\"\";i:760;s:0:\"\";i:761;s:0:\"\";i:762;s:0:\"\";i:763;s:0:\"\";i:764;s:0:\"\";i:765;s:0:\"\";i:766;s:0:\"\";i:767;s:0:\"\";i:768;s:0:\"\";i:769;s:0:\"\";i:770;s:0:\"\";i:771;s:0:\"\";i:772;s:0:\"\";i:773;s:0:\"\";i:774;s:0:\"\";i:775;s:0:\"\";i:776;s:0:\"\";i:777;s:0:\"\";i:778;s:0:\"\";i:779;s:0:\"\";i:780;s:0:\"\";i:781;s:0:\"\";i:782;s:0:\"\";i:783;s:0:\"\";i:784;s:0:\"\";i:785;s:0:\"\";i:786;s:0:\"\";i:787;s:0:\"\";i:788;s:0:\"\";i:789;s:0:\"\";i:790;s:0:\"\";i:791;s:0:\"\";i:792;s:0:\"\";i:793;s:0:\"\";i:794;s:0:\"\";i:795;s:0:\"\";i:796;s:0:\"\";i:797;s:0:\"\";i:798;s:0:\"\";i:799;s:0:\"\";i:800;s:0:\"\";i:801;s:0:\"\";i:802;s:0:\"\";i:803;s:0:\"\";i:804;s:0:\"\";i:805;s:0:\"\";i:806;s:0:\"\";i:807;s:0:\"\";i:808;s:0:\"\";i:809;s:0:\"\";i:810;s:0:\"\";i:811;s:0:\"\";i:812;s:0:\"\";i:813;s:0:\"\";i:814;s:0:\"\";i:815;s:0:\"\";i:816;s:0:\"\";i:817;s:0:\"\";i:818;s:0:\"\";i:819;s:0:\"\";i:820;s:0:\"\";i:821;s:0:\"\";i:822;s:0:\"\";i:823;s:0:\"\";i:824;s:0:\"\";i:825;s:0:\"\";i:826;s:0:\"\";i:827;s:0:\"\";i:828;s:0:\"\";i:829;s:0:\"\";i:830;s:0:\"\";i:831;s:0:\"\";i:832;s:0:\"\";i:833;s:0:\"\";i:834;s:0:\"\";i:835;s:0:\"\";i:836;s:0:\"\";i:837;s:0:\"\";i:838;s:0:\"\";i:839;s:0:\"\";i:840;s:0:\"\";i:841;s:0:\"\";i:842;s:0:\"\";i:843;s:0:\"\";i:844;s:0:\"\";i:845;s:0:\"\";i:846;s:0:\"\";i:847;s:0:\"\";i:848;s:0:\"\";i:849;s:0:\"\";i:850;s:0:\"\";i:851;s:0:\"\";i:852;s:0:\"\";i:853;s:0:\"\";i:854;s:0:\"\";i:855;s:0:\"\";i:856;s:0:\"\";i:857;s:0:\"\";i:858;s:0:\"\";i:859;s:0:\"\";i:860;s:0:\"\";i:861;s:0:\"\";i:862;s:0:\"\";i:863;s:0:\"\";i:864;s:0:\"\";i:865;s:0:\"\";i:866;s:0:\"\";i:867;s:0:\"\";i:868;s:0:\"\";i:869;s:0:\"\";i:870;s:0:\"\";i:871;s:0:\"\";i:872;s:0:\"\";i:873;s:0:\"\";i:874;s:0:\"\";i:875;s:0:\"\";i:876;s:0:\"\";i:877;s:0:\"\";i:878;s:0:\"\";i:879;s:0:\"\";i:880;s:0:\"\";i:881;s:0:\"\";i:882;s:0:\"\";i:883;s:0:\"\";i:884;s:0:\"\";i:885;s:0:\"\";i:886;s:0:\"\";i:887;s:0:\"\";i:888;s:0:\"\";i:889;s:0:\"\";i:890;s:0:\"\";i:891;s:0:\"\";i:892;s:0:\"\";i:893;s:0:\"\";i:894;s:0:\"\";i:895;s:0:\"\";i:896;s:0:\"\";i:897;s:0:\"\";i:898;s:0:\"\";i:899;s:0:\"\";i:900;s:0:\"\";i:901;s:0:\"\";i:902;s:0:\"\";i:903;s:0:\"\";i:904;s:0:\"\";i:905;s:0:\"\";i:906;s:0:\"\";i:907;s:0:\"\";i:908;s:0:\"\";i:909;s:0:\"\";i:910;s:0:\"\";i:911;s:0:\"\";i:912;s:0:\"\";i:913;s:0:\"\";i:914;s:0:\"\";i:915;s:0:\"\";i:916;s:0:\"\";i:917;s:0:\"\";i:918;s:0:\"\";i:919;s:0:\"\";i:920;s:0:\"\";i:921;s:0:\"\";i:922;s:0:\"\";i:923;s:0:\"\";i:924;s:0:\"\";i:925;s:0:\"\";i:926;s:0:\"\";i:927;s:0:\"\";i:928;s:0:\"\";i:929;s:0:\"\";i:930;s:0:\"\";i:931;s:0:\"\";i:932;s:0:\"\";i:933;s:0:\"\";i:934;s:0:\"\";i:935;s:0:\"\";i:936;s:0:\"\";i:937;s:0:\"\";i:938;s:0:\"\";i:939;s:0:\"\";i:940;s:0:\"\";i:941;s:0:\"\";i:942;s:0:\"\";i:943;s:0:\"\";i:944;s:0:\"\";i:945;s:0:\"\";i:946;s:0:\"\";i:947;s:0:\"\";i:948;s:0:\"\";i:949;s:0:\"\";i:950;s:0:\"\";i:951;s:0:\"\";i:952;s:0:\"\";i:953;s:0:\"\";i:954;s:0:\"\";i:955;s:0:\"\";i:956;s:0:\"\";i:957;s:0:\"\";i:958;s:0:\"\";i:959;s:0:\"\";i:960;s:0:\"\";i:961;s:0:\"\";i:962;s:0:\"\";i:963;s:0:\"\";i:964;s:0:\"\";i:965;s:0:\"\";i:966;s:0:\"\";i:967;s:0:\"\";i:968;s:0:\"\";i:969;s:0:\"\";i:970;s:0:\"\";i:971;s:0:\"\";i:972;s:0:\"\";i:973;s:0:\"\";i:974;s:0:\"\";i:975;s:0:\"\";i:976;s:0:\"\";i:977;s:0:\"\";i:978;s:0:\"\";i:979;s:0:\"\";i:980;s:0:\"\";i:981;s:0:\"\";i:982;s:0:\"\";i:983;s:0:\"\";i:984;s:0:\"\";i:985;s:0:\"\";i:986;s:0:\"\";i:987;s:0:\"\";i:988;s:0:\"\";i:989;s:0:\"\";i:990;s:0:\"\";i:991;s:0:\"\";i:992;s:0:\"\";i:993;s:0:\"\";i:994;s:0:\"\";i:995;s:0:\"\";i:996;s:0:\"\";i:997;s:0:\"\";i:998;s:0:\"\";i:999;s:0:\"\";i:1000;s:0:\"\";i:1001;s:0:\"\";i:1002;s:0:\"\";i:1003;s:0:\"\";i:1004;s:0:\"\";i:1005;s:0:\"\";i:1006;s:0:\"\";i:1007;s:0:\"\";i:1008;s:0:\"\";i:1009;s:0:\"\";i:1010;s:0:\"\";i:1011;s:0:\"\";i:1012;s:0:\"\";i:1013;s:0:\"\";i:1014;s:0:\"\";i:1015;s:0:\"\";i:1016;s:0:\"\";i:1017;s:0:\"\";i:1018;s:0:\"\";i:1019;s:0:\"\";i:1020;s:0:\"\";i:1021;s:0:\"\";i:1022;s:0:\"\";i:1023;s:0:\"\";i:1024;s:0:\"\";i:1025;s:0:\"\";i:1026;s:0:\"\";i:1027;s:0:\"\";i:1028;s:0:\"\";i:1029;s:0:\"\";i:1030;s:0:\"\";i:1031;s:0:\"\";i:1032;s:0:\"\";i:1033;s:0:\"\";i:1034;s:0:\"\";i:1035;s:0:\"\";i:1036;s:0:\"\";i:1037;s:0:\"\";i:1038;s:0:\"\";i:1039;s:0:\"\";i:1040;s:0:\"\";i:1041;s:0:\"\";i:1042;s:0:\"\";i:1043;s:0:\"\";i:1044;s:0:\"\";i:1045;s:0:\"\";i:1046;s:0:\"\";i:1047;s:0:\"\";i:1048;s:0:\"\";i:1049;s:0:\"\";i:1050;s:0:\"\";i:1051;s:0:\"\";i:1052;s:0:\"\";i:1053;s:0:\"\";i:1054;s:0:\"\";i:1055;s:0:\"\";i:1056;s:0:\"\";i:1057;s:0:\"\";i:1058;s:0:\"\";i:1059;s:0:\"\";i:1060;s:0:\"\";i:1061;s:0:\"\";i:1062;s:0:\"\";i:1063;s:0:\"\";i:1064;s:0:\"\";i:1065;s:0:\"\";i:1066;s:0:\"\";i:1067;s:0:\"\";i:1068;s:0:\"\";i:1069;s:0:\"\";i:1070;s:0:\"\";i:1071;s:0:\"\";i:1072;s:0:\"\";i:1073;s:0:\"\";i:1074;s:0:\"\";i:1075;s:0:\"\";i:1076;s:0:\"\";i:1077;s:0:\"\";i:1078;s:0:\"\";i:1079;s:0:\"\";i:1080;s:0:\"\";i:1081;s:0:\"\";i:1082;s:0:\"\";i:1083;s:0:\"\";i:1084;s:0:\"\";i:1085;s:0:\"\";i:1086;s:0:\"\";i:1087;s:0:\"\";i:1088;s:0:\"\";i:1089;s:0:\"\";i:1090;s:0:\"\";i:1091;s:0:\"\";i:1092;s:0:\"\";i:1093;s:0:\"\";i:1094;s:0:\"\";i:1095;s:0:\"\";i:1096;s:0:\"\";i:1097;s:0:\"\";i:1098;s:0:\"\";i:1099;s:0:\"\";i:1100;s:0:\"\";i:1101;s:0:\"\";i:1102;s:0:\"\";i:1103;s:0:\"\";i:1104;s:0:\"\";i:1105;s:0:\"\";i:1106;s:0:\"\";i:1107;s:0:\"\";i:1108;s:0:\"\";i:1109;s:0:\"\";i:1110;s:0:\"\";i:1111;s:0:\"\";i:1112;s:0:\"\";i:1113;s:0:\"\";i:1114;s:0:\"\";i:1115;s:0:\"\";i:1116;s:0:\"\";i:1117;s:0:\"\";i:1118;s:0:\"\";i:1119;s:0:\"\";i:1120;s:0:\"\";i:1121;s:0:\"\";i:1122;s:0:\"\";i:1123;s:0:\"\";i:1124;s:0:\"\";i:1125;s:0:\"\";i:1126;s:0:\"\";i:1127;s:0:\"\";i:1128;s:0:\"\";i:1129;s:0:\"\";i:1130;s:0:\"\";i:1131;s:0:\"\";i:1132;s:0:\"\";i:1133;s:0:\"\";i:1134;s:0:\"\";i:1135;s:0:\"\";i:1136;s:0:\"\";i:1137;s:0:\"\";i:1138;s:0:\"\";i:1139;s:0:\"\";i:1140;s:0:\"\";i:1141;s:0:\"\";i:1142;s:0:\"\";i:1143;s:0:\"\";i:1144;s:0:\"\";i:1145;s:0:\"\";i:1146;s:0:\"\";i:1147;s:0:\"\";i:1148;s:0:\"\";i:1149;s:0:\"\";i:1150;s:0:\"\";i:1151;s:0:\"\";i:1152;s:0:\"\";i:1153;s:0:\"\";i:1154;s:0:\"\";i:1155;s:0:\"\";i:1156;s:0:\"\";i:1157;s:0:\"\";i:1158;s:0:\"\";i:1159;s:0:\"\";i:1160;s:0:\"\";i:1161;s:0:\"\";i:1162;s:0:\"\";i:1163;s:0:\"\";i:1164;s:0:\"\";i:1165;s:0:\"\";i:1166;s:0:\"\";i:1167;s:0:\"\";i:1168;s:0:\"\";i:1169;s:0:\"\";i:1170;s:0:\"\";i:1171;s:0:\"\";i:1172;s:0:\"\";i:1173;s:0:\"\";i:1174;s:0:\"\";i:1175;s:0:\"\";i:1176;s:0:\"\";i:1177;s:0:\"\";i:1178;s:0:\"\";i:1179;s:0:\"\";i:1180;s:0:\"\";i:1181;s:0:\"\";i:1182;s:0:\"\";i:1183;s:0:\"\";i:1184;s:0:\"\";i:1185;s:0:\"\";i:1186;s:0:\"\";i:1187;s:0:\"\";i:1188;s:0:\"\";i:1189;s:0:\"\";i:1190;s:0:\"\";i:1191;s:0:\"\";i:1192;s:0:\"\";i:1193;s:0:\"\";i:1194;s:0:\"\";i:1195;s:0:\"\";i:1196;s:0:\"\";i:1197;s:0:\"\";i:1198;s:0:\"\";i:1199;s:0:\"\";i:1200;s:0:\"\";i:1201;s:0:\"\";i:1202;s:0:\"\";i:1203;s:0:\"\";i:1204;s:0:\"\";i:1205;s:0:\"\";i:1206;s:0:\"\";i:1207;s:0:\"\";i:1208;s:0:\"\";i:1209;s:0:\"\";i:1210;s:0:\"\";i:1211;s:0:\"\";i:1212;s:0:\"\";i:1213;s:0:\"\";i:1214;s:0:\"\";i:1215;s:0:\"\";i:1216;s:0:\"\";i:1217;s:0:\"\";i:1218;s:0:\"\";i:1219;s:0:\"\";i:1220;s:0:\"\";i:1221;s:0:\"\";i:1222;s:0:\"\";i:1223;s:0:\"\";i:1224;s:0:\"\";i:1225;s:0:\"\";i:1226;s:0:\"\";i:1227;s:0:\"\";i:1228;s:0:\"\";i:1229;s:0:\"\";i:1230;s:0:\"\";i:1231;s:0:\"\";i:1232;s:0:\"\";i:1233;s:0:\"\";i:1234;s:0:\"\";i:1235;s:0:\"\";i:1236;s:0:\"\";i:1237;s:0:\"\";i:1238;s:0:\"\";i:1239;s:0:\"\";i:1240;s:0:\"\";i:1241;s:0:\"\";i:1242;s:0:\"\";i:1243;s:0:\"\";i:1244;s:0:\"\";i:1245;s:0:\"\";i:1246;s:0:\"\";i:1247;s:0:\"\";i:1248;s:0:\"\";i:1249;s:0:\"\";i:1250;s:0:\"\";i:1251;s:0:\"\";i:1252;s:0:\"\";i:1253;s:0:\"\";i:1254;s:0:\"\";i:1255;s:0:\"\";i:1256;s:0:\"\";i:1257;s:0:\"\";i:1258;s:0:\"\";i:1259;s:0:\"\";i:1260;s:0:\"\";i:1261;s:0:\"\";i:1262;s:0:\"\";i:1263;s:0:\"\";i:1264;s:0:\"\";i:1265;s:0:\"\";i:1266;s:0:\"\";i:1267;s:0:\"\";i:1268;s:0:\"\";i:1269;s:0:\"\";i:1270;s:0:\"\";i:1271;s:0:\"\";i:1272;s:0:\"\";i:1273;s:0:\"\";i:1274;s:0:\"\";i:1275;s:0:\"\";i:1276;s:0:\"\";i:1277;s:0:\"\";i:1278;s:0:\"\";i:1279;s:0:\"\";i:1280;s:0:\"\";i:1281;s:0:\"\";i:1282;s:0:\"\";i:1283;s:0:\"\";i:1284;s:0:\"\";i:1285;s:0:\"\";i:1286;s:0:\"\";i:1287;s:0:\"\";i:1288;s:0:\"\";i:1289;s:0:\"\";i:1290;s:0:\"\";i:1291;s:0:\"\";i:1292;s:0:\"\";i:1293;s:0:\"\";i:1294;s:0:\"\";i:1295;s:0:\"\";i:1296;s:0:\"\";i:1297;s:0:\"\";i:1298;s:0:\"\";i:1299;s:0:\"\";i:1300;s:0:\"\";i:1301;s:0:\"\";i:1302;s:0:\"\";i:1303;s:0:\"\";i:1304;s:0:\"\";i:1305;s:0:\"\";i:1306;s:0:\"\";i:1307;s:0:\"\";i:1308;s:0:\"\";i:1309;s:0:\"\";i:1310;s:0:\"\";i:1311;s:0:\"\";i:1312;s:0:\"\";i:1313;s:0:\"\";i:1314;s:0:\"\";i:1315;s:0:\"\";i:1316;s:0:\"\";i:1317;s:0:\"\";i:1318;s:0:\"\";i:1319;s:0:\"\";i:1320;s:0:\"\";i:1321;s:0:\"\";i:1322;s:0:\"\";i:1323;s:0:\"\";i:1324;s:0:\"\";i:1325;s:0:\"\";i:1326;s:0:\"\";i:1327;s:0:\"\";i:1328;s:0:\"\";i:1329;s:0:\"\";i:1330;s:0:\"\";i:1331;s:0:\"\";i:1332;s:0:\"\";i:1333;s:0:\"\";i:1334;s:0:\"\";i:1335;s:0:\"\";i:1336;s:0:\"\";i:1337;s:0:\"\";i:1338;s:0:\"\";i:1339;s:0:\"\";i:1340;s:0:\"\";i:1341;s:0:\"\";i:1342;s:0:\"\";i:1343;s:0:\"\";i:1344;s:0:\"\";i:1345;s:0:\"\";i:1346;s:0:\"\";i:1347;s:0:\"\";i:1348;s:0:\"\";i:1349;s:0:\"\";i:1350;s:0:\"\";i:1351;s:0:\"\";i:1352;s:0:\"\";i:1353;s:0:\"\";i:1354;s:0:\"\";i:1355;s:0:\"\";i:1356;s:0:\"\";i:1357;s:0:\"\";i:1358;s:0:\"\";i:1359;s:0:\"\";i:1360;s:0:\"\";i:1361;s:0:\"\";i:1362;s:0:\"\";i:1363;s:0:\"\";i:1364;s:0:\"\";i:1365;s:0:\"\";i:1366;s:0:\"\";i:1367;s:0:\"\";i:1368;s:0:\"\";i:1369;s:0:\"\";i:1370;s:0:\"\";i:1371;s:0:\"\";i:1372;s:0:\"\";i:1373;s:0:\"\";i:1374;s:0:\"\";i:1375;s:0:\"\";i:1376;s:0:\"\";i:1377;s:0:\"\";i:1378;s:0:\"\";i:1379;s:0:\"\";i:1380;s:0:\"\";i:1381;s:0:\"\";i:1382;s:0:\"\";i:1383;s:0:\"\";i:1384;s:0:\"\";i:1385;s:0:\"\";i:1386;s:0:\"\";i:1387;s:0:\"\";i:1388;s:0:\"\";i:1389;s:0:\"\";i:1390;s:0:\"\";i:1391;s:0:\"\";i:1392;s:0:\"\";i:1393;s:0:\"\";i:1394;s:0:\"\";i:1395;s:0:\"\";i:1396;s:0:\"\";i:1397;s:0:\"\";i:1398;s:0:\"\";i:1399;s:0:\"\";i:1400;s:0:\"\";i:1401;s:0:\"\";i:1402;s:0:\"\";i:1403;s:0:\"\";i:1404;s:0:\"\";i:1405;s:0:\"\";i:1406;s:0:\"\";i:1407;s:0:\"\";i:1408;s:0:\"\";i:1409;s:0:\"\";i:1410;s:0:\"\";i:1411;s:0:\"\";i:1412;s:0:\"\";i:1413;s:0:\"\";i:1414;s:0:\"\";i:1415;s:0:\"\";i:1416;s:0:\"\";i:1417;s:0:\"\";i:1418;s:0:\"\";i:1419;s:0:\"\";i:1420;s:0:\"\";i:1421;s:0:\"\";i:1422;s:0:\"\";i:1423;s:0:\"\";i:1424;s:0:\"\";i:1425;s:0:\"\";i:1426;s:0:\"\";i:1427;s:0:\"\";i:1428;s:0:\"\";i:1429;s:0:\"\";i:1430;s:0:\"\";i:1431;s:0:\"\";i:1432;s:0:\"\";i:1433;s:0:\"\";i:1434;s:0:\"\";i:1435;s:0:\"\";i:1436;s:0:\"\";i:1437;s:0:\"\";i:1438;s:0:\"\";i:1439;s:0:\"\";i:1440;s:0:\"\";i:1441;s:0:\"\";i:1442;s:0:\"\";i:1443;s:0:\"\";i:1444;s:0:\"\";i:1445;s:0:\"\";i:1446;s:0:\"\";i:1447;s:0:\"\";i:1448;s:0:\"\";i:1449;s:0:\"\";i:1450;s:0:\"\";i:1451;s:0:\"\";i:1452;s:0:\"\";i:1453;s:0:\"\";i:1454;s:0:\"\";i:1455;s:0:\"\";i:1456;s:0:\"\";i:1457;s:0:\"\";i:1458;s:0:\"\";i:1459;s:0:\"\";i:1460;s:0:\"\";i:1461;s:0:\"\";i:1462;s:0:\"\";i:1463;s:0:\"\";i:1464;s:0:\"\";i:1465;s:0:\"\";i:1466;s:0:\"\";i:1467;s:0:\"\";i:1468;s:0:\"\";i:1469;s:0:\"\";i:1470;s:0:\"\";i:1471;s:0:\"\";i:1472;s:0:\"\";i:1473;s:0:\"\";i:1474;s:0:\"\";i:1475;s:0:\"\";i:1476;s:0:\"\";i:1477;s:0:\"\";i:1478;s:0:\"\";i:1479;s:0:\"\";i:1480;s:0:\"\";i:1481;s:0:\"\";i:1482;s:0:\"\";i:1483;s:0:\"\";i:1484;s:0:\"\";i:1485;s:0:\"\";i:1486;s:0:\"\";i:1487;s:0:\"\";i:1488;s:0:\"\";i:1489;s:0:\"\";i:1490;s:0:\"\";i:1491;s:0:\"\";i:1492;s:0:\"\";i:1493;s:0:\"\";i:1494;s:0:\"\";i:1495;s:0:\"\";i:1496;s:0:\"\";i:1497;s:0:\"\";i:1498;s:0:\"\";i:1499;s:0:\"\";i:1500;s:0:\"\";i:1501;s:0:\"\";i:1502;s:0:\"\";i:1503;s:0:\"\";i:1504;s:0:\"\";i:1505;s:0:\"\";i:1506;s:0:\"\";i:1507;s:0:\"\";i:1508;s:0:\"\";i:1509;s:0:\"\";i:1510;s:0:\"\";i:1511;s:0:\"\";i:1512;s:0:\"\";i:1513;s:0:\"\";i:1514;s:0:\"\";i:1515;s:0:\"\";i:1516;s:0:\"\";i:1517;s:0:\"\";i:1518;s:0:\"\";i:1519;s:0:\"\";i:1520;s:0:\"\";i:1521;s:0:\"\";i:1522;s:0:\"\";i:1523;s:0:\"\";i:1524;s:0:\"\";i:1525;s:0:\"\";i:1526;s:0:\"\";i:1527;s:0:\"\";i:1528;s:0:\"\";i:1529;s:0:\"\";i:1530;s:0:\"\";i:1531;s:0:\"\";i:1532;s:0:\"\";i:1533;s:0:\"\";i:1534;s:0:\"\";i:1535;s:0:\"\";i:1536;s:0:\"\";i:1537;s:0:\"\";i:1538;s:0:\"\";i:1539;s:0:\"\";i:1540;s:0:\"\";i:1541;s:0:\"\";i:1542;s:0:\"\";i:1543;s:0:\"\";i:1544;s:0:\"\";i:1545;s:0:\"\";i:1546;s:0:\"\";i:1547;s:0:\"\";i:1548;s:0:\"\";i:1549;s:0:\"\";i:1550;s:0:\"\";i:1551;s:0:\"\";i:1552;s:0:\"\";i:1553;s:0:\"\";i:1554;s:0:\"\";i:1555;s:0:\"\";i:1556;s:0:\"\";i:1557;s:0:\"\";i:1558;s:0:\"\";i:1559;s:0:\"\";i:1560;s:0:\"\";i:1561;s:0:\"\";i:1562;s:0:\"\";i:1563;s:0:\"\";i:1564;s:0:\"\";i:1565;s:0:\"\";i:1566;s:0:\"\";i:1567;s:0:\"\";i:1568;s:0:\"\";i:1569;s:0:\"\";i:1570;s:0:\"\";i:1571;s:0:\"\";i:1572;s:0:\"\";i:1573;s:0:\"\";i:1574;s:0:\"\";i:1575;s:0:\"\";i:1576;s:0:\"\";i:1577;s:0:\"\";i:1578;s:0:\"\";i:1579;s:0:\"\";i:1580;s:0:\"\";i:1581;s:0:\"\";i:1582;s:0:\"\";i:1583;s:0:\"\";i:1584;s:0:\"\";i:1585;s:0:\"\";i:1586;s:0:\"\";i:1587;s:0:\"\";i:1588;s:0:\"\";i:1589;s:0:\"\";i:1590;s:0:\"\";i:1591;s:0:\"\";i:1592;s:0:\"\";i:1593;s:0:\"\";i:1594;s:0:\"\";i:1595;s:0:\"\";i:1596;s:0:\"\";i:1597;s:0:\"\";i:1598;s:0:\"\";i:1599;s:0:\"\";i:1600;s:0:\"\";i:1601;s:0:\"\";i:1602;s:0:\"\";i:1603;s:0:\"\";i:1604;s:0:\"\";i:1605;s:0:\"\";i:1606;s:0:\"\";i:1607;s:0:\"\";i:1608;s:0:\"\";i:1609;s:0:\"\";i:1610;s:0:\"\";i:1611;s:0:\"\";i:1612;s:0:\"\";i:1613;s:0:\"\";i:1614;s:0:\"\";i:1615;s:0:\"\";i:1616;s:0:\"\";i:1617;s:0:\"\";i:1618;s:0:\"\";i:1619;s:0:\"\";i:1620;s:0:\"\";i:1621;s:0:\"\";i:1622;s:0:\"\";i:1623;s:0:\"\";i:1624;s:0:\"\";i:1625;s:0:\"\";i:1626;s:0:\"\";i:1627;s:0:\"\";i:1628;s:0:\"\";i:1629;s:0:\"\";i:1630;s:0:\"\";i:1631;s:0:\"\";i:1632;s:0:\"\";i:1633;s:0:\"\";i:1634;s:0:\"\";i:1635;s:0:\"\";i:1636;s:0:\"\";i:1637;s:0:\"\";i:1638;s:0:\"\";i:1639;s:0:\"\";i:1640;s:0:\"\";i:1641;s:0:\"\";i:1642;s:0:\"\";i:1643;s:0:\"\";i:1644;s:0:\"\";i:1645;s:0:\"\";i:1646;s:0:\"\";i:1647;s:0:\"\";i:1648;s:0:\"\";i:1649;s:0:\"\";i:1650;s:0:\"\";i:1651;s:0:\"\";i:1652;s:0:\"\";i:1653;s:0:\"\";i:1654;s:0:\"\";i:1655;s:0:\"\";i:1656;s:0:\"\";i:1657;s:0:\"\";i:1658;s:0:\"\";i:1659;s:0:\"\";i:1660;s:0:\"\";i:1661;s:0:\"\";i:1662;s:0:\"\";i:1663;s:0:\"\";i:1664;s:0:\"\";i:1665;s:0:\"\";i:1666;s:0:\"\";i:1667;s:0:\"\";i:1668;s:0:\"\";i:1669;s:0:\"\";i:1670;s:0:\"\";i:1671;s:0:\"\";i:1672;s:0:\"\";i:1673;s:0:\"\";i:1674;s:0:\"\";i:1675;s:0:\"\";i:1676;s:0:\"\";i:1677;s:0:\"\";i:1678;s:0:\"\";i:1679;s:0:\"\";i:1680;s:0:\"\";i:1681;s:0:\"\";i:1682;s:0:\"\";i:1683;s:0:\"\";i:1684;s:0:\"\";i:1685;s:0:\"\";i:1686;s:0:\"\";i:1687;s:0:\"\";i:1688;s:0:\"\";i:1689;s:0:\"\";i:1690;s:0:\"\";i:1691;s:0:\"\";i:1692;s:0:\"\";i:1693;s:0:\"\";i:1694;s:0:\"\";i:1695;s:0:\"\";i:1696;s:0:\"\";i:1697;s:0:\"\";i:1698;s:0:\"\";i:1699;s:0:\"\";i:1700;s:0:\"\";i:1701;s:0:\"\";i:1702;s:0:\"\";i:1703;s:0:\"\";i:1704;s:0:\"\";i:1705;s:0:\"\";i:1706;s:0:\"\";i:1707;s:0:\"\";i:1708;s:0:\"\";i:1709;s:0:\"\";i:1710;s:0:\"\";i:1711;s:0:\"\";i:1712;s:0:\"\";i:1713;s:0:\"\";i:1714;s:0:\"\";i:1715;s:0:\"\";i:1716;s:0:\"\";i:1717;s:0:\"\";i:1718;s:0:\"\";i:1719;s:0:\"\";i:1720;s:0:\"\";i:1721;s:0:\"\";i:1722;s:0:\"\";i:1723;s:0:\"\";i:1724;s:0:\"\";i:1725;s:0:\"\";i:1726;s:0:\"\";i:1727;s:0:\"\";i:1728;s:0:\"\";i:1729;s:0:\"\";i:1730;s:0:\"\";i:1731;s:0:\"\";i:1732;s:0:\"\";i:1733;s:0:\"\";i:1734;s:0:\"\";i:1735;s:0:\"\";i:1736;s:0:\"\";i:1737;s:0:\"\";i:1738;s:0:\"\";i:1739;s:0:\"\";i:1740;s:0:\"\";i:1741;s:0:\"\";i:1742;s:0:\"\";i:1743;s:0:\"\";i:1744;s:0:\"\";i:1745;s:0:\"\";i:1746;s:0:\"\";i:1747;s:0:\"\";i:1748;s:0:\"\";i:1749;s:0:\"\";i:1750;s:0:\"\";i:1751;s:0:\"\";i:1752;s:0:\"\";i:1753;s:0:\"\";i:1754;s:0:\"\";i:1755;s:0:\"\";i:1756;s:0:\"\";i:1757;s:0:\"\";i:1758;s:0:\"\";i:1759;s:0:\"\";i:1760;s:0:\"\";i:1761;s:0:\"\";i:1762;s:0:\"\";i:1763;s:0:\"\";i:1764;s:0:\"\";i:1765;s:0:\"\";i:1766;s:0:\"\";i:1767;s:0:\"\";i:1768;s:0:\"\";i:1769;s:0:\"\";i:1770;s:0:\"\";i:1771;s:0:\"\";i:1772;s:0:\"\";i:1773;s:0:\"\";i:1774;s:0:\"\";i:1775;s:0:\"\";i:1776;s:0:\"\";i:1777;s:0:\"\";i:1778;s:0:\"\";i:1779;s:0:\"\";i:1780;s:0:\"\";}s:12:\"ilobjrolegui\";a:58:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:0:\"\";i:40;s:0:\"\";i:41;s:0:\"\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";}s:15:\"ilpermissiongui\";a:57:{i:0;s:12:\"ilobjrolegui\";i:1;s:12:\"ilobjrolegui\";i:2;s:12:\"ilobjrolegui\";i:3;s:12:\"ilobjrolegui\";i:4;s:12:\"ilobjrolegui\";i:5;s:12:\"ilobjrolegui\";i:6;s:12:\"ilobjrolegui\";i:7;s:12:\"ilobjrolegui\";i:8;s:12:\"ilobjrolegui\";i:9;s:12:\"ilobjrolegui\";i:10;s:12:\"ilobjrolegui\";i:11;s:12:\"ilobjrolegui\";i:12;s:12:\"ilobjrolegui\";i:13;s:12:\"ilobjrolegui\";i:14;s:12:\"ilobjrolegui\";i:15;s:12:\"ilobjrolegui\";i:16;s:12:\"ilobjrolegui\";i:17;s:12:\"ilobjrolegui\";i:18;s:12:\"ilobjrolegui\";i:19;s:12:\"ilobjrolegui\";i:20;s:12:\"ilobjrolegui\";i:21;s:12:\"ilobjrolegui\";i:22;s:12:\"ilobjrolegui\";i:23;s:12:\"ilobjrolegui\";i:24;s:12:\"ilobjrolegui\";i:25;s:12:\"ilobjrolegui\";i:26;s:12:\"ilobjrolegui\";i:27;s:12:\"ilobjrolegui\";i:28;s:12:\"ilobjrolegui\";i:29;s:12:\"ilobjrolegui\";i:30;s:12:\"ilobjrolegui\";i:31;s:12:\"ilobjrolegui\";i:32;s:12:\"ilobjrolegui\";i:33;s:12:\"ilobjrolegui\";i:34;s:12:\"ilobjrolegui\";i:35;s:12:\"ilobjrolegui\";i:36;s:12:\"ilobjrolegui\";i:37;s:12:\"ilobjrolegui\";i:38;s:12:\"ilobjrolegui\";i:39;s:12:\"ilobjrolegui\";i:40;s:12:\"ilobjrolegui\";i:41;s:12:\"ilobjrolegui\";i:42;s:12:\"ilobjrolegui\";i:43;s:12:\"ilobjrolegui\";i:44;s:12:\"ilobjrolegui\";i:45;s:12:\"ilobjrolegui\";i:46;s:12:\"ilobjrolegui\";i:47;s:12:\"ilobjrolegui\";i:48;s:12:\"ilobjrolegui\";i:49;s:12:\"ilobjrolegui\";i:50;s:12:\"ilobjrolegui\";i:51;s:12:\"ilobjrolegui\";i:52;s:12:\"ilobjrolegui\";i:53;s:12:\"ilobjrolegui\";i:54;s:12:\"ilobjrolegui\";i:55;s:12:\"ilobjrolegui\";i:56;s:12:\"ilobjrolegui\";}s:23:\"ilobjadvancededitinggui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:24:\"ilobjassessmentfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:17:\"illdapsettingsgui\";a:1:{i:0;s:0:\"\";}s:25:\"ilregistrationsettingsgui\";a:1:{i:0;s:0:\"\";}s:20:\"ilobjauthsettingsgui\";a:4:{i:0;s:17:\"illdapsettingsgui\";i:1;s:15:\"ilpermissiongui\";i:2;s:19:\"ilradiussettingsgui\";i:3;s:25:\"ilregistrationsettingsgui\";}s:24:\"ilobjcalendarsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:16:\"ilcalendardaygui\";a:74:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarinboxgui\";a:74:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarmonthgui\";a:74:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";}s:17:\"ilcalendarweekgui\";a:74:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:24:\"ilcalendarappointmentgui\";i:2;s:24:\"ilcalendarappointmentgui\";i:3;s:24:\"ilcalendarappointmentgui\";i:4;s:24:\"ilcalendarappointmentgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:24:\"ilcalendarappointmentgui\";i:7;s:24:\"ilcalendarappointmentgui\";i:8;s:24:\"ilcalendarappointmentgui\";i:9;s:24:\"ilcalendarappointmentgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:24:\"ilcalendarappointmentgui\";i:12;s:24:\"ilcalendarappointmentgui\";i:13;s:24:\"ilcalendarappointmentgui\";i:14;s:24:\"ilcalendarappointmentgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:24:\"ilcalendarappointmentgui\";i:17;s:24:\"ilcalendarappointmentgui\";i:18;s:24:\"ilcalendarappointmentgui\";i:19;s:24:\"ilcalendarappointmentgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:24:\"ilcalendarappointmentgui\";i:22;s:24:\"ilcalendarappointmentgui\";i:23;s:24:\"ilcalendarappointmentgui\";i:24;s:24:\"ilcalendarappointmentgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:24:\"ilcalendarappointmentgui\";i:27;s:24:\"ilcalendarappointmentgui\";i:28;s:24:\"ilcalendarappointmentgui\";i:29;s:24:\"ilcalendarappointmentgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:24:\"ilcalendarappointmentgui\";i:32;s:24:\"ilcalendarappointmentgui\";i:33;s:24:\"ilcalendarappointmentgui\";i:34;s:24:\"ilcalendarappointmentgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:24:\"ilcalendarappointmentgui\";i:37;s:24:\"ilcalendarappointmentgui\";i:38;s:24:\"ilcalendarappointmentgui\";i:39;s:24:\"ilcalendarappointmentgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:24:\"ilcalendarappointmentgui\";i:42;s:24:\"ilcalendarappointmentgui\";i:43;s:24:\"ilcalendarappointmentgui\";i:44;s:24:\"ilcalendarappointmentgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:24:\"ilcalendarappointmentgui\";i:47;s:24:\"ilcalendarappointmentgui\";i:48;s:24:\"ilcalendarappointmentgui\";i:49;s:24:\"ilcalendarappointmentgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:24:\"ilcalendarappointmentgui\";i:52;s:24:\"ilcalendarappointmentgui\";i:53;s:24:\"ilcalendarappointmentgui\";i:54;s:24:\"ilcalendarappointmentgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:24:\"ilcalendarappointmentgui\";i:57;s:24:\"ilcalendarappointmentgui\";i:58;s:24:\"ilcalendarappointmentgui\";i:59;s:24:\"ilcalendarappointmentgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:24:\"ilcalendarappointmentgui\";i:62;s:24:\"ilcalendarappointmentgui\";i:63;s:24:\"ilcalendarappointmentgui\";i:64;s:24:\"ilcalendarappointmentgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:24:\"ilcalendarappointmentgui\";i:67;s:24:\"ilcalendarappointmentgui\";i:68;s:24:\"ilcalendarappointmentgui\";i:69;s:24:\"ilcalendarappointmentgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:24:\"ilcalendarappointmentgui\";i:72;s:24:\"ilcalendarappointmentgui\";i:73;s:24:\"ilcalendarappointmentgui\";}s:18:\"ilcalendarblockgui\";a:185:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:16:\"ilcalendardaygui\";i:7;s:18:\"ilcalendarinboxgui\";i:8;s:18:\"ilcalendarmonthgui\";i:9;s:17:\"ilcalendarweekgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:16:\"ilcalendardaygui\";i:12;s:18:\"ilcalendarinboxgui\";i:13;s:18:\"ilcalendarmonthgui\";i:14;s:17:\"ilcalendarweekgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:16:\"ilcalendardaygui\";i:17;s:18:\"ilcalendarinboxgui\";i:18;s:18:\"ilcalendarmonthgui\";i:19;s:17:\"ilcalendarweekgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:16:\"ilcalendardaygui\";i:22;s:18:\"ilcalendarinboxgui\";i:23;s:18:\"ilcalendarmonthgui\";i:24;s:17:\"ilcalendarweekgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:16:\"ilcalendardaygui\";i:27;s:18:\"ilcalendarinboxgui\";i:28;s:18:\"ilcalendarmonthgui\";i:29;s:17:\"ilcalendarweekgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:16:\"ilcalendardaygui\";i:32;s:18:\"ilcalendarinboxgui\";i:33;s:18:\"ilcalendarmonthgui\";i:34;s:17:\"ilcalendarweekgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:16:\"ilcalendardaygui\";i:37;s:18:\"ilcalendarinboxgui\";i:38;s:18:\"ilcalendarmonthgui\";i:39;s:17:\"ilcalendarweekgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:16:\"ilcalendardaygui\";i:42;s:18:\"ilcalendarinboxgui\";i:43;s:18:\"ilcalendarmonthgui\";i:44;s:17:\"ilcalendarweekgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:16:\"ilcalendardaygui\";i:47;s:18:\"ilcalendarinboxgui\";i:48;s:18:\"ilcalendarmonthgui\";i:49;s:17:\"ilcalendarweekgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:16:\"ilcalendardaygui\";i:52;s:18:\"ilcalendarinboxgui\";i:53;s:18:\"ilcalendarmonthgui\";i:54;s:17:\"ilcalendarweekgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:16:\"ilcalendardaygui\";i:57;s:18:\"ilcalendarinboxgui\";i:58;s:18:\"ilcalendarmonthgui\";i:59;s:17:\"ilcalendarweekgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:16:\"ilcalendardaygui\";i:62;s:18:\"ilcalendarinboxgui\";i:63;s:18:\"ilcalendarmonthgui\";i:64;s:17:\"ilcalendarweekgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:16:\"ilcalendardaygui\";i:67;s:18:\"ilcalendarinboxgui\";i:68;s:18:\"ilcalendarmonthgui\";i:69;s:17:\"ilcalendarweekgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:16:\"ilcalendardaygui\";i:72;s:18:\"ilcalendarinboxgui\";i:73;s:18:\"ilcalendarmonthgui\";i:74;s:17:\"ilcalendarweekgui\";i:75;s:24:\"ilcalendarappointmentgui\";i:76;s:16:\"ilcalendardaygui\";i:77;s:18:\"ilcalendarinboxgui\";i:78;s:18:\"ilcalendarmonthgui\";i:79;s:17:\"ilcalendarweekgui\";i:80;s:24:\"ilcalendarappointmentgui\";i:81;s:16:\"ilcalendardaygui\";i:82;s:18:\"ilcalendarinboxgui\";i:83;s:18:\"ilcalendarmonthgui\";i:84;s:17:\"ilcalendarweekgui\";i:85;s:24:\"ilcalendarappointmentgui\";i:86;s:16:\"ilcalendardaygui\";i:87;s:18:\"ilcalendarinboxgui\";i:88;s:18:\"ilcalendarmonthgui\";i:89;s:17:\"ilcalendarweekgui\";i:90;s:24:\"ilcalendarappointmentgui\";i:91;s:16:\"ilcalendardaygui\";i:92;s:18:\"ilcalendarinboxgui\";i:93;s:18:\"ilcalendarmonthgui\";i:94;s:17:\"ilcalendarweekgui\";i:95;s:24:\"ilcalendarappointmentgui\";i:96;s:16:\"ilcalendardaygui\";i:97;s:18:\"ilcalendarinboxgui\";i:98;s:18:\"ilcalendarmonthgui\";i:99;s:17:\"ilcalendarweekgui\";i:100;s:24:\"ilcalendarappointmentgui\";i:101;s:16:\"ilcalendardaygui\";i:102;s:18:\"ilcalendarinboxgui\";i:103;s:18:\"ilcalendarmonthgui\";i:104;s:17:\"ilcalendarweekgui\";i:105;s:24:\"ilcalendarappointmentgui\";i:106;s:16:\"ilcalendardaygui\";i:107;s:18:\"ilcalendarinboxgui\";i:108;s:18:\"ilcalendarmonthgui\";i:109;s:17:\"ilcalendarweekgui\";i:110;s:24:\"ilcalendarappointmentgui\";i:111;s:16:\"ilcalendardaygui\";i:112;s:18:\"ilcalendarinboxgui\";i:113;s:18:\"ilcalendarmonthgui\";i:114;s:17:\"ilcalendarweekgui\";i:115;s:24:\"ilcalendarappointmentgui\";i:116;s:16:\"ilcalendardaygui\";i:117;s:18:\"ilcalendarinboxgui\";i:118;s:18:\"ilcalendarmonthgui\";i:119;s:17:\"ilcalendarweekgui\";i:120;s:24:\"ilcalendarappointmentgui\";i:121;s:16:\"ilcalendardaygui\";i:122;s:18:\"ilcalendarinboxgui\";i:123;s:18:\"ilcalendarmonthgui\";i:124;s:17:\"ilcalendarweekgui\";i:125;s:24:\"ilcalendarappointmentgui\";i:126;s:16:\"ilcalendardaygui\";i:127;s:18:\"ilcalendarinboxgui\";i:128;s:18:\"ilcalendarmonthgui\";i:129;s:17:\"ilcalendarweekgui\";i:130;s:24:\"ilcalendarappointmentgui\";i:131;s:16:\"ilcalendardaygui\";i:132;s:18:\"ilcalendarinboxgui\";i:133;s:18:\"ilcalendarmonthgui\";i:134;s:17:\"ilcalendarweekgui\";i:135;s:24:\"ilcalendarappointmentgui\";i:136;s:16:\"ilcalendardaygui\";i:137;s:18:\"ilcalendarinboxgui\";i:138;s:18:\"ilcalendarmonthgui\";i:139;s:17:\"ilcalendarweekgui\";i:140;s:24:\"ilcalendarappointmentgui\";i:141;s:16:\"ilcalendardaygui\";i:142;s:18:\"ilcalendarinboxgui\";i:143;s:18:\"ilcalendarmonthgui\";i:144;s:17:\"ilcalendarweekgui\";i:145;s:24:\"ilcalendarappointmentgui\";i:146;s:16:\"ilcalendardaygui\";i:147;s:18:\"ilcalendarinboxgui\";i:148;s:18:\"ilcalendarmonthgui\";i:149;s:17:\"ilcalendarweekgui\";i:150;s:24:\"ilcalendarappointmentgui\";i:151;s:16:\"ilcalendardaygui\";i:152;s:18:\"ilcalendarinboxgui\";i:153;s:18:\"ilcalendarmonthgui\";i:154;s:17:\"ilcalendarweekgui\";i:155;s:24:\"ilcalendarappointmentgui\";i:156;s:16:\"ilcalendardaygui\";i:157;s:18:\"ilcalendarinboxgui\";i:158;s:18:\"ilcalendarmonthgui\";i:159;s:17:\"ilcalendarweekgui\";i:160;s:24:\"ilcalendarappointmentgui\";i:161;s:16:\"ilcalendardaygui\";i:162;s:18:\"ilcalendarinboxgui\";i:163;s:18:\"ilcalendarmonthgui\";i:164;s:17:\"ilcalendarweekgui\";i:165;s:24:\"ilcalendarappointmentgui\";i:166;s:16:\"ilcalendardaygui\";i:167;s:18:\"ilcalendarinboxgui\";i:168;s:18:\"ilcalendarmonthgui\";i:169;s:17:\"ilcalendarweekgui\";i:170;s:24:\"ilcalendarappointmentgui\";i:171;s:16:\"ilcalendardaygui\";i:172;s:18:\"ilcalendarinboxgui\";i:173;s:18:\"ilcalendarmonthgui\";i:174;s:17:\"ilcalendarweekgui\";i:175;s:24:\"ilcalendarappointmentgui\";i:176;s:16:\"ilcalendardaygui\";i:177;s:18:\"ilcalendarinboxgui\";i:178;s:18:\"ilcalendarmonthgui\";i:179;s:17:\"ilcalendarweekgui\";i:180;s:24:\"ilcalendarappointmentgui\";i:181;s:16:\"ilcalendardaygui\";i:182;s:18:\"ilcalendarinboxgui\";i:183;s:18:\"ilcalendarmonthgui\";i:184;s:17:\"ilcalendarweekgui\";}s:24:\"ilnewsforcontextblockgui\";a:37:{i:0;s:13:\"ilnewsitemgui\";i:1;s:13:\"ilnewsitemgui\";i:2;s:13:\"ilnewsitemgui\";i:3;s:13:\"ilnewsitemgui\";i:4;s:13:\"ilnewsitemgui\";i:5;s:13:\"ilnewsitemgui\";i:6;s:13:\"ilnewsitemgui\";i:7;s:13:\"ilnewsitemgui\";i:8;s:13:\"ilnewsitemgui\";i:9;s:13:\"ilnewsitemgui\";i:10;s:13:\"ilnewsitemgui\";i:11;s:13:\"ilnewsitemgui\";i:12;s:13:\"ilnewsitemgui\";i:13;s:13:\"ilnewsitemgui\";i:14;s:13:\"ilnewsitemgui\";i:15;s:13:\"ilnewsitemgui\";i:16;s:13:\"ilnewsitemgui\";i:17;s:13:\"ilnewsitemgui\";i:18;s:13:\"ilnewsitemgui\";i:19;s:13:\"ilnewsitemgui\";i:20;s:13:\"ilnewsitemgui\";i:21;s:13:\"ilnewsitemgui\";i:22;s:13:\"ilnewsitemgui\";i:23;s:13:\"ilnewsitemgui\";i:24;s:13:\"ilnewsitemgui\";i:25;s:13:\"ilnewsitemgui\";i:26;s:13:\"ilnewsitemgui\";i:27;s:13:\"ilnewsitemgui\";i:28;s:13:\"ilnewsitemgui\";i:29;s:13:\"ilnewsitemgui\";i:30;s:13:\"ilnewsitemgui\";i:31;s:13:\"ilnewsitemgui\";i:32;s:13:\"ilnewsitemgui\";i:33;s:13:\"ilnewsitemgui\";i:34;s:13:\"ilnewsitemgui\";i:35;s:13:\"ilnewsitemgui\";i:36;s:13:\"ilnewsitemgui\";}s:20:\"ilpdcalendarblockgui\";a:185:{i:0;s:24:\"ilcalendarappointmentgui\";i:1;s:16:\"ilcalendardaygui\";i:2;s:18:\"ilcalendarinboxgui\";i:3;s:18:\"ilcalendarmonthgui\";i:4;s:17:\"ilcalendarweekgui\";i:5;s:24:\"ilcalendarappointmentgui\";i:6;s:16:\"ilcalendardaygui\";i:7;s:18:\"ilcalendarinboxgui\";i:8;s:18:\"ilcalendarmonthgui\";i:9;s:17:\"ilcalendarweekgui\";i:10;s:24:\"ilcalendarappointmentgui\";i:11;s:16:\"ilcalendardaygui\";i:12;s:18:\"ilcalendarinboxgui\";i:13;s:18:\"ilcalendarmonthgui\";i:14;s:17:\"ilcalendarweekgui\";i:15;s:24:\"ilcalendarappointmentgui\";i:16;s:16:\"ilcalendardaygui\";i:17;s:18:\"ilcalendarinboxgui\";i:18;s:18:\"ilcalendarmonthgui\";i:19;s:17:\"ilcalendarweekgui\";i:20;s:24:\"ilcalendarappointmentgui\";i:21;s:16:\"ilcalendardaygui\";i:22;s:18:\"ilcalendarinboxgui\";i:23;s:18:\"ilcalendarmonthgui\";i:24;s:17:\"ilcalendarweekgui\";i:25;s:24:\"ilcalendarappointmentgui\";i:26;s:16:\"ilcalendardaygui\";i:27;s:18:\"ilcalendarinboxgui\";i:28;s:18:\"ilcalendarmonthgui\";i:29;s:17:\"ilcalendarweekgui\";i:30;s:24:\"ilcalendarappointmentgui\";i:31;s:16:\"ilcalendardaygui\";i:32;s:18:\"ilcalendarinboxgui\";i:33;s:18:\"ilcalendarmonthgui\";i:34;s:17:\"ilcalendarweekgui\";i:35;s:24:\"ilcalendarappointmentgui\";i:36;s:16:\"ilcalendardaygui\";i:37;s:18:\"ilcalendarinboxgui\";i:38;s:18:\"ilcalendarmonthgui\";i:39;s:17:\"ilcalendarweekgui\";i:40;s:24:\"ilcalendarappointmentgui\";i:41;s:16:\"ilcalendardaygui\";i:42;s:18:\"ilcalendarinboxgui\";i:43;s:18:\"ilcalendarmonthgui\";i:44;s:17:\"ilcalendarweekgui\";i:45;s:24:\"ilcalendarappointmentgui\";i:46;s:16:\"ilcalendardaygui\";i:47;s:18:\"ilcalendarinboxgui\";i:48;s:18:\"ilcalendarmonthgui\";i:49;s:17:\"ilcalendarweekgui\";i:50;s:24:\"ilcalendarappointmentgui\";i:51;s:16:\"ilcalendardaygui\";i:52;s:18:\"ilcalendarinboxgui\";i:53;s:18:\"ilcalendarmonthgui\";i:54;s:17:\"ilcalendarweekgui\";i:55;s:24:\"ilcalendarappointmentgui\";i:56;s:16:\"ilcalendardaygui\";i:57;s:18:\"ilcalendarinboxgui\";i:58;s:18:\"ilcalendarmonthgui\";i:59;s:17:\"ilcalendarweekgui\";i:60;s:24:\"ilcalendarappointmentgui\";i:61;s:16:\"ilcalendardaygui\";i:62;s:18:\"ilcalendarinboxgui\";i:63;s:18:\"ilcalendarmonthgui\";i:64;s:17:\"ilcalendarweekgui\";i:65;s:24:\"ilcalendarappointmentgui\";i:66;s:16:\"ilcalendardaygui\";i:67;s:18:\"ilcalendarinboxgui\";i:68;s:18:\"ilcalendarmonthgui\";i:69;s:17:\"ilcalendarweekgui\";i:70;s:24:\"ilcalendarappointmentgui\";i:71;s:16:\"ilcalendardaygui\";i:72;s:18:\"ilcalendarinboxgui\";i:73;s:18:\"ilcalendarmonthgui\";i:74;s:17:\"ilcalendarweekgui\";i:75;s:24:\"ilcalendarappointmentgui\";i:76;s:16:\"ilcalendardaygui\";i:77;s:18:\"ilcalendarinboxgui\";i:78;s:18:\"ilcalendarmonthgui\";i:79;s:17:\"ilcalendarweekgui\";i:80;s:24:\"ilcalendarappointmentgui\";i:81;s:16:\"ilcalendardaygui\";i:82;s:18:\"ilcalendarinboxgui\";i:83;s:18:\"ilcalendarmonthgui\";i:84;s:17:\"ilcalendarweekgui\";i:85;s:24:\"ilcalendarappointmentgui\";i:86;s:16:\"ilcalendardaygui\";i:87;s:18:\"ilcalendarinboxgui\";i:88;s:18:\"ilcalendarmonthgui\";i:89;s:17:\"ilcalendarweekgui\";i:90;s:24:\"ilcalendarappointmentgui\";i:91;s:16:\"ilcalendardaygui\";i:92;s:18:\"ilcalendarinboxgui\";i:93;s:18:\"ilcalendarmonthgui\";i:94;s:17:\"ilcalendarweekgui\";i:95;s:24:\"ilcalendarappointmentgui\";i:96;s:16:\"ilcalendardaygui\";i:97;s:18:\"ilcalendarinboxgui\";i:98;s:18:\"ilcalendarmonthgui\";i:99;s:17:\"ilcalendarweekgui\";i:100;s:24:\"ilcalendarappointmentgui\";i:101;s:16:\"ilcalendardaygui\";i:102;s:18:\"ilcalendarinboxgui\";i:103;s:18:\"ilcalendarmonthgui\";i:104;s:17:\"ilcalendarweekgui\";i:105;s:24:\"ilcalendarappointmentgui\";i:106;s:16:\"ilcalendardaygui\";i:107;s:18:\"ilcalendarinboxgui\";i:108;s:18:\"ilcalendarmonthgui\";i:109;s:17:\"ilcalendarweekgui\";i:110;s:24:\"ilcalendarappointmentgui\";i:111;s:16:\"ilcalendardaygui\";i:112;s:18:\"ilcalendarinboxgui\";i:113;s:18:\"ilcalendarmonthgui\";i:114;s:17:\"ilcalendarweekgui\";i:115;s:24:\"ilcalendarappointmentgui\";i:116;s:16:\"ilcalendardaygui\";i:117;s:18:\"ilcalendarinboxgui\";i:118;s:18:\"ilcalendarmonthgui\";i:119;s:17:\"ilcalendarweekgui\";i:120;s:24:\"ilcalendarappointmentgui\";i:121;s:16:\"ilcalendardaygui\";i:122;s:18:\"ilcalendarinboxgui\";i:123;s:18:\"ilcalendarmonthgui\";i:124;s:17:\"ilcalendarweekgui\";i:125;s:24:\"ilcalendarappointmentgui\";i:126;s:16:\"ilcalendardaygui\";i:127;s:18:\"ilcalendarinboxgui\";i:128;s:18:\"ilcalendarmonthgui\";i:129;s:17:\"ilcalendarweekgui\";i:130;s:24:\"ilcalendarappointmentgui\";i:131;s:16:\"ilcalendardaygui\";i:132;s:18:\"ilcalendarinboxgui\";i:133;s:18:\"ilcalendarmonthgui\";i:134;s:17:\"ilcalendarweekgui\";i:135;s:24:\"ilcalendarappointmentgui\";i:136;s:16:\"ilcalendardaygui\";i:137;s:18:\"ilcalendarinboxgui\";i:138;s:18:\"ilcalendarmonthgui\";i:139;s:17:\"ilcalendarweekgui\";i:140;s:24:\"ilcalendarappointmentgui\";i:141;s:16:\"ilcalendardaygui\";i:142;s:18:\"ilcalendarinboxgui\";i:143;s:18:\"ilcalendarmonthgui\";i:144;s:17:\"ilcalendarweekgui\";i:145;s:24:\"ilcalendarappointmentgui\";i:146;s:16:\"ilcalendardaygui\";i:147;s:18:\"ilcalendarinboxgui\";i:148;s:18:\"ilcalendarmonthgui\";i:149;s:17:\"ilcalendarweekgui\";i:150;s:24:\"ilcalendarappointmentgui\";i:151;s:16:\"ilcalendardaygui\";i:152;s:18:\"ilcalendarinboxgui\";i:153;s:18:\"ilcalendarmonthgui\";i:154;s:17:\"ilcalendarweekgui\";i:155;s:24:\"ilcalendarappointmentgui\";i:156;s:16:\"ilcalendardaygui\";i:157;s:18:\"ilcalendarinboxgui\";i:158;s:18:\"ilcalendarmonthgui\";i:159;s:17:\"ilcalendarweekgui\";i:160;s:24:\"ilcalendarappointmentgui\";i:161;s:16:\"ilcalendardaygui\";i:162;s:18:\"ilcalendarinboxgui\";i:163;s:18:\"ilcalendarmonthgui\";i:164;s:17:\"ilcalendarweekgui\";i:165;s:24:\"ilcalendarappointmentgui\";i:166;s:16:\"ilcalendardaygui\";i:167;s:18:\"ilcalendarinboxgui\";i:168;s:18:\"ilcalendarmonthgui\";i:169;s:17:\"ilcalendarweekgui\";i:170;s:24:\"ilcalendarappointmentgui\";i:171;s:16:\"ilcalendardaygui\";i:172;s:18:\"ilcalendarinboxgui\";i:173;s:18:\"ilcalendarmonthgui\";i:174;s:17:\"ilcalendarweekgui\";i:175;s:24:\"ilcalendarappointmentgui\";i:176;s:16:\"ilcalendardaygui\";i:177;s:18:\"ilcalendarinboxgui\";i:178;s:18:\"ilcalendarmonthgui\";i:179;s:17:\"ilcalendarweekgui\";i:180;s:24:\"ilcalendarappointmentgui\";i:181;s:16:\"ilcalendardaygui\";i:182;s:18:\"ilcalendarinboxgui\";i:183;s:18:\"ilcalendarmonthgui\";i:184;s:17:\"ilcalendarweekgui\";}s:21:\"ilusersonlineblockgui\";a:37:{i:0;s:22:\"ilpublicuserprofilegui\";i:1;s:22:\"ilpublicuserprofilegui\";i:2;s:22:\"ilpublicuserprofilegui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:22:\"ilpublicuserprofilegui\";i:5;s:22:\"ilpublicuserprofilegui\";i:6;s:22:\"ilpublicuserprofilegui\";i:7;s:22:\"ilpublicuserprofilegui\";i:8;s:22:\"ilpublicuserprofilegui\";i:9;s:22:\"ilpublicuserprofilegui\";i:10;s:22:\"ilpublicuserprofilegui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:22:\"ilpublicuserprofilegui\";i:13;s:22:\"ilpublicuserprofilegui\";i:14;s:22:\"ilpublicuserprofilegui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:22:\"ilpublicuserprofilegui\";i:17;s:22:\"ilpublicuserprofilegui\";i:18;s:22:\"ilpublicuserprofilegui\";i:19;s:22:\"ilpublicuserprofilegui\";i:20;s:22:\"ilpublicuserprofilegui\";i:21;s:22:\"ilpublicuserprofilegui\";i:22;s:22:\"ilpublicuserprofilegui\";i:23;s:22:\"ilpublicuserprofilegui\";i:24;s:22:\"ilpublicuserprofilegui\";i:25;s:22:\"ilpublicuserprofilegui\";i:26;s:22:\"ilpublicuserprofilegui\";i:27;s:22:\"ilpublicuserprofilegui\";i:28;s:22:\"ilpublicuserprofilegui\";i:29;s:22:\"ilpublicuserprofilegui\";i:30;s:22:\"ilpublicuserprofilegui\";i:31;s:22:\"ilpublicuserprofilegui\";i:32;s:22:\"ilpublicuserprofilegui\";i:33;s:22:\"ilpublicuserprofilegui\";i:34;s:22:\"ilpublicuserprofilegui\";i:35;s:22:\"ilpublicuserprofilegui\";i:36;s:22:\"ilpublicuserprofilegui\";}s:11:\"ilcolumngui\";a:629:{i:0;s:0:\"\";i:1;s:18:\"ilbookmarkblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:15:\"ildummyblockgui\";i:4;s:22:\"ilexternalfeedblockgui\";i:5;s:14:\"ilhtmlblockgui\";i:6;s:24:\"ilnewsforcontextblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:24:\"ilpdexternalfeedblockgui\";i:9;s:20:\"ilpdfeedbackblockgui\";i:10;s:16:\"ilpdmailblockgui\";i:11;s:16:\"ilpdnewsblockgui\";i:12;s:17:\"ilpdnotesblockgui\";i:13;s:25:\"ilpdselecteditemsblockgui\";i:14;s:22:\"ilpdsysmessageblockgui\";i:15;s:19:\"ilpdtaggingblockgui\";i:16;s:21:\"ilusersonlineblockgui\";i:17;s:0:\"\";i:18;s:18:\"ilbookmarkblockgui\";i:19;s:18:\"ilcalendarblockgui\";i:20;s:15:\"ildummyblockgui\";i:21;s:22:\"ilexternalfeedblockgui\";i:22;s:14:\"ilhtmlblockgui\";i:23;s:24:\"ilnewsforcontextblockgui\";i:24;s:20:\"ilpdcalendarblockgui\";i:25;s:24:\"ilpdexternalfeedblockgui\";i:26;s:20:\"ilpdfeedbackblockgui\";i:27;s:16:\"ilpdmailblockgui\";i:28;s:16:\"ilpdnewsblockgui\";i:29;s:17:\"ilpdnotesblockgui\";i:30;s:25:\"ilpdselecteditemsblockgui\";i:31;s:22:\"ilpdsysmessageblockgui\";i:32;s:19:\"ilpdtaggingblockgui\";i:33;s:21:\"ilusersonlineblockgui\";i:34;s:0:\"\";i:35;s:18:\"ilbookmarkblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:15:\"ildummyblockgui\";i:38;s:22:\"ilexternalfeedblockgui\";i:39;s:14:\"ilhtmlblockgui\";i:40;s:24:\"ilnewsforcontextblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:24:\"ilpdexternalfeedblockgui\";i:43;s:20:\"ilpdfeedbackblockgui\";i:44;s:16:\"ilpdmailblockgui\";i:45;s:16:\"ilpdnewsblockgui\";i:46;s:17:\"ilpdnotesblockgui\";i:47;s:25:\"ilpdselecteditemsblockgui\";i:48;s:22:\"ilpdsysmessageblockgui\";i:49;s:19:\"ilpdtaggingblockgui\";i:50;s:21:\"ilusersonlineblockgui\";i:51;s:0:\"\";i:52;s:18:\"ilbookmarkblockgui\";i:53;s:18:\"ilcalendarblockgui\";i:54;s:15:\"ildummyblockgui\";i:55;s:22:\"ilexternalfeedblockgui\";i:56;s:14:\"ilhtmlblockgui\";i:57;s:24:\"ilnewsforcontextblockgui\";i:58;s:20:\"ilpdcalendarblockgui\";i:59;s:24:\"ilpdexternalfeedblockgui\";i:60;s:20:\"ilpdfeedbackblockgui\";i:61;s:16:\"ilpdmailblockgui\";i:62;s:16:\"ilpdnewsblockgui\";i:63;s:17:\"ilpdnotesblockgui\";i:64;s:25:\"ilpdselecteditemsblockgui\";i:65;s:22:\"ilpdsysmessageblockgui\";i:66;s:19:\"ilpdtaggingblockgui\";i:67;s:21:\"ilusersonlineblockgui\";i:68;s:0:\"\";i:69;s:18:\"ilbookmarkblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:15:\"ildummyblockgui\";i:72;s:22:\"ilexternalfeedblockgui\";i:73;s:14:\"ilhtmlblockgui\";i:74;s:24:\"ilnewsforcontextblockgui\";i:75;s:20:\"ilpdcalendarblockgui\";i:76;s:24:\"ilpdexternalfeedblockgui\";i:77;s:20:\"ilpdfeedbackblockgui\";i:78;s:16:\"ilpdmailblockgui\";i:79;s:16:\"ilpdnewsblockgui\";i:80;s:17:\"ilpdnotesblockgui\";i:81;s:25:\"ilpdselecteditemsblockgui\";i:82;s:22:\"ilpdsysmessageblockgui\";i:83;s:19:\"ilpdtaggingblockgui\";i:84;s:21:\"ilusersonlineblockgui\";i:85;s:0:\"\";i:86;s:18:\"ilbookmarkblockgui\";i:87;s:18:\"ilcalendarblockgui\";i:88;s:15:\"ildummyblockgui\";i:89;s:22:\"ilexternalfeedblockgui\";i:90;s:14:\"ilhtmlblockgui\";i:91;s:24:\"ilnewsforcontextblockgui\";i:92;s:20:\"ilpdcalendarblockgui\";i:93;s:24:\"ilpdexternalfeedblockgui\";i:94;s:20:\"ilpdfeedbackblockgui\";i:95;s:16:\"ilpdmailblockgui\";i:96;s:16:\"ilpdnewsblockgui\";i:97;s:17:\"ilpdnotesblockgui\";i:98;s:25:\"ilpdselecteditemsblockgui\";i:99;s:22:\"ilpdsysmessageblockgui\";i:100;s:19:\"ilpdtaggingblockgui\";i:101;s:21:\"ilusersonlineblockgui\";i:102;s:0:\"\";i:103;s:18:\"ilbookmarkblockgui\";i:104;s:18:\"ilcalendarblockgui\";i:105;s:15:\"ildummyblockgui\";i:106;s:22:\"ilexternalfeedblockgui\";i:107;s:14:\"ilhtmlblockgui\";i:108;s:24:\"ilnewsforcontextblockgui\";i:109;s:20:\"ilpdcalendarblockgui\";i:110;s:24:\"ilpdexternalfeedblockgui\";i:111;s:20:\"ilpdfeedbackblockgui\";i:112;s:16:\"ilpdmailblockgui\";i:113;s:16:\"ilpdnewsblockgui\";i:114;s:17:\"ilpdnotesblockgui\";i:115;s:25:\"ilpdselecteditemsblockgui\";i:116;s:22:\"ilpdsysmessageblockgui\";i:117;s:19:\"ilpdtaggingblockgui\";i:118;s:21:\"ilusersonlineblockgui\";i:119;s:0:\"\";i:120;s:18:\"ilbookmarkblockgui\";i:121;s:18:\"ilcalendarblockgui\";i:122;s:15:\"ildummyblockgui\";i:123;s:22:\"ilexternalfeedblockgui\";i:124;s:14:\"ilhtmlblockgui\";i:125;s:24:\"ilnewsforcontextblockgui\";i:126;s:20:\"ilpdcalendarblockgui\";i:127;s:24:\"ilpdexternalfeedblockgui\";i:128;s:20:\"ilpdfeedbackblockgui\";i:129;s:16:\"ilpdmailblockgui\";i:130;s:16:\"ilpdnewsblockgui\";i:131;s:17:\"ilpdnotesblockgui\";i:132;s:25:\"ilpdselecteditemsblockgui\";i:133;s:22:\"ilpdsysmessageblockgui\";i:134;s:19:\"ilpdtaggingblockgui\";i:135;s:21:\"ilusersonlineblockgui\";i:136;s:0:\"\";i:137;s:18:\"ilbookmarkblockgui\";i:138;s:18:\"ilcalendarblockgui\";i:139;s:15:\"ildummyblockgui\";i:140;s:22:\"ilexternalfeedblockgui\";i:141;s:14:\"ilhtmlblockgui\";i:142;s:24:\"ilnewsforcontextblockgui\";i:143;s:20:\"ilpdcalendarblockgui\";i:144;s:24:\"ilpdexternalfeedblockgui\";i:145;s:20:\"ilpdfeedbackblockgui\";i:146;s:16:\"ilpdmailblockgui\";i:147;s:16:\"ilpdnewsblockgui\";i:148;s:17:\"ilpdnotesblockgui\";i:149;s:25:\"ilpdselecteditemsblockgui\";i:150;s:22:\"ilpdsysmessageblockgui\";i:151;s:19:\"ilpdtaggingblockgui\";i:152;s:21:\"ilusersonlineblockgui\";i:153;s:0:\"\";i:154;s:18:\"ilbookmarkblockgui\";i:155;s:18:\"ilcalendarblockgui\";i:156;s:15:\"ildummyblockgui\";i:157;s:22:\"ilexternalfeedblockgui\";i:158;s:14:\"ilhtmlblockgui\";i:159;s:24:\"ilnewsforcontextblockgui\";i:160;s:20:\"ilpdcalendarblockgui\";i:161;s:24:\"ilpdexternalfeedblockgui\";i:162;s:20:\"ilpdfeedbackblockgui\";i:163;s:16:\"ilpdmailblockgui\";i:164;s:16:\"ilpdnewsblockgui\";i:165;s:17:\"ilpdnotesblockgui\";i:166;s:25:\"ilpdselecteditemsblockgui\";i:167;s:22:\"ilpdsysmessageblockgui\";i:168;s:19:\"ilpdtaggingblockgui\";i:169;s:21:\"ilusersonlineblockgui\";i:170;s:0:\"\";i:171;s:18:\"ilbookmarkblockgui\";i:172;s:18:\"ilcalendarblockgui\";i:173;s:15:\"ildummyblockgui\";i:174;s:22:\"ilexternalfeedblockgui\";i:175;s:14:\"ilhtmlblockgui\";i:176;s:24:\"ilnewsforcontextblockgui\";i:177;s:20:\"ilpdcalendarblockgui\";i:178;s:24:\"ilpdexternalfeedblockgui\";i:179;s:20:\"ilpdfeedbackblockgui\";i:180;s:16:\"ilpdmailblockgui\";i:181;s:16:\"ilpdnewsblockgui\";i:182;s:17:\"ilpdnotesblockgui\";i:183;s:25:\"ilpdselecteditemsblockgui\";i:184;s:22:\"ilpdsysmessageblockgui\";i:185;s:19:\"ilpdtaggingblockgui\";i:186;s:21:\"ilusersonlineblockgui\";i:187;s:0:\"\";i:188;s:18:\"ilbookmarkblockgui\";i:189;s:18:\"ilcalendarblockgui\";i:190;s:15:\"ildummyblockgui\";i:191;s:22:\"ilexternalfeedblockgui\";i:192;s:14:\"ilhtmlblockgui\";i:193;s:24:\"ilnewsforcontextblockgui\";i:194;s:20:\"ilpdcalendarblockgui\";i:195;s:24:\"ilpdexternalfeedblockgui\";i:196;s:20:\"ilpdfeedbackblockgui\";i:197;s:16:\"ilpdmailblockgui\";i:198;s:16:\"ilpdnewsblockgui\";i:199;s:17:\"ilpdnotesblockgui\";i:200;s:25:\"ilpdselecteditemsblockgui\";i:201;s:22:\"ilpdsysmessageblockgui\";i:202;s:19:\"ilpdtaggingblockgui\";i:203;s:21:\"ilusersonlineblockgui\";i:204;s:0:\"\";i:205;s:18:\"ilbookmarkblockgui\";i:206;s:18:\"ilcalendarblockgui\";i:207;s:15:\"ildummyblockgui\";i:208;s:22:\"ilexternalfeedblockgui\";i:209;s:14:\"ilhtmlblockgui\";i:210;s:24:\"ilnewsforcontextblockgui\";i:211;s:20:\"ilpdcalendarblockgui\";i:212;s:24:\"ilpdexternalfeedblockgui\";i:213;s:20:\"ilpdfeedbackblockgui\";i:214;s:16:\"ilpdmailblockgui\";i:215;s:16:\"ilpdnewsblockgui\";i:216;s:17:\"ilpdnotesblockgui\";i:217;s:25:\"ilpdselecteditemsblockgui\";i:218;s:22:\"ilpdsysmessageblockgui\";i:219;s:19:\"ilpdtaggingblockgui\";i:220;s:21:\"ilusersonlineblockgui\";i:221;s:0:\"\";i:222;s:18:\"ilbookmarkblockgui\";i:223;s:18:\"ilcalendarblockgui\";i:224;s:15:\"ildummyblockgui\";i:225;s:22:\"ilexternalfeedblockgui\";i:226;s:14:\"ilhtmlblockgui\";i:227;s:24:\"ilnewsforcontextblockgui\";i:228;s:20:\"ilpdcalendarblockgui\";i:229;s:24:\"ilpdexternalfeedblockgui\";i:230;s:20:\"ilpdfeedbackblockgui\";i:231;s:16:\"ilpdmailblockgui\";i:232;s:16:\"ilpdnewsblockgui\";i:233;s:17:\"ilpdnotesblockgui\";i:234;s:25:\"ilpdselecteditemsblockgui\";i:235;s:22:\"ilpdsysmessageblockgui\";i:236;s:19:\"ilpdtaggingblockgui\";i:237;s:21:\"ilusersonlineblockgui\";i:238;s:0:\"\";i:239;s:18:\"ilbookmarkblockgui\";i:240;s:18:\"ilcalendarblockgui\";i:241;s:15:\"ildummyblockgui\";i:242;s:22:\"ilexternalfeedblockgui\";i:243;s:14:\"ilhtmlblockgui\";i:244;s:24:\"ilnewsforcontextblockgui\";i:245;s:20:\"ilpdcalendarblockgui\";i:246;s:24:\"ilpdexternalfeedblockgui\";i:247;s:20:\"ilpdfeedbackblockgui\";i:248;s:16:\"ilpdmailblockgui\";i:249;s:16:\"ilpdnewsblockgui\";i:250;s:17:\"ilpdnotesblockgui\";i:251;s:25:\"ilpdselecteditemsblockgui\";i:252;s:22:\"ilpdsysmessageblockgui\";i:253;s:19:\"ilpdtaggingblockgui\";i:254;s:21:\"ilusersonlineblockgui\";i:255;s:0:\"\";i:256;s:18:\"ilbookmarkblockgui\";i:257;s:18:\"ilcalendarblockgui\";i:258;s:15:\"ildummyblockgui\";i:259;s:22:\"ilexternalfeedblockgui\";i:260;s:14:\"ilhtmlblockgui\";i:261;s:24:\"ilnewsforcontextblockgui\";i:262;s:20:\"ilpdcalendarblockgui\";i:263;s:24:\"ilpdexternalfeedblockgui\";i:264;s:20:\"ilpdfeedbackblockgui\";i:265;s:16:\"ilpdmailblockgui\";i:266;s:16:\"ilpdnewsblockgui\";i:267;s:17:\"ilpdnotesblockgui\";i:268;s:25:\"ilpdselecteditemsblockgui\";i:269;s:22:\"ilpdsysmessageblockgui\";i:270;s:19:\"ilpdtaggingblockgui\";i:271;s:21:\"ilusersonlineblockgui\";i:272;s:0:\"\";i:273;s:18:\"ilbookmarkblockgui\";i:274;s:18:\"ilcalendarblockgui\";i:275;s:15:\"ildummyblockgui\";i:276;s:22:\"ilexternalfeedblockgui\";i:277;s:14:\"ilhtmlblockgui\";i:278;s:24:\"ilnewsforcontextblockgui\";i:279;s:20:\"ilpdcalendarblockgui\";i:280;s:24:\"ilpdexternalfeedblockgui\";i:281;s:20:\"ilpdfeedbackblockgui\";i:282;s:16:\"ilpdmailblockgui\";i:283;s:16:\"ilpdnewsblockgui\";i:284;s:17:\"ilpdnotesblockgui\";i:285;s:25:\"ilpdselecteditemsblockgui\";i:286;s:22:\"ilpdsysmessageblockgui\";i:287;s:19:\"ilpdtaggingblockgui\";i:288;s:21:\"ilusersonlineblockgui\";i:289;s:0:\"\";i:290;s:18:\"ilbookmarkblockgui\";i:291;s:18:\"ilcalendarblockgui\";i:292;s:15:\"ildummyblockgui\";i:293;s:22:\"ilexternalfeedblockgui\";i:294;s:14:\"ilhtmlblockgui\";i:295;s:24:\"ilnewsforcontextblockgui\";i:296;s:20:\"ilpdcalendarblockgui\";i:297;s:24:\"ilpdexternalfeedblockgui\";i:298;s:20:\"ilpdfeedbackblockgui\";i:299;s:16:\"ilpdmailblockgui\";i:300;s:16:\"ilpdnewsblockgui\";i:301;s:17:\"ilpdnotesblockgui\";i:302;s:25:\"ilpdselecteditemsblockgui\";i:303;s:22:\"ilpdsysmessageblockgui\";i:304;s:19:\"ilpdtaggingblockgui\";i:305;s:21:\"ilusersonlineblockgui\";i:306;s:0:\"\";i:307;s:18:\"ilbookmarkblockgui\";i:308;s:18:\"ilcalendarblockgui\";i:309;s:15:\"ildummyblockgui\";i:310;s:22:\"ilexternalfeedblockgui\";i:311;s:14:\"ilhtmlblockgui\";i:312;s:24:\"ilnewsforcontextblockgui\";i:313;s:20:\"ilpdcalendarblockgui\";i:314;s:24:\"ilpdexternalfeedblockgui\";i:315;s:20:\"ilpdfeedbackblockgui\";i:316;s:16:\"ilpdmailblockgui\";i:317;s:16:\"ilpdnewsblockgui\";i:318;s:17:\"ilpdnotesblockgui\";i:319;s:25:\"ilpdselecteditemsblockgui\";i:320;s:22:\"ilpdsysmessageblockgui\";i:321;s:19:\"ilpdtaggingblockgui\";i:322;s:21:\"ilusersonlineblockgui\";i:323;s:0:\"\";i:324;s:18:\"ilbookmarkblockgui\";i:325;s:18:\"ilcalendarblockgui\";i:326;s:15:\"ildummyblockgui\";i:327;s:22:\"ilexternalfeedblockgui\";i:328;s:14:\"ilhtmlblockgui\";i:329;s:24:\"ilnewsforcontextblockgui\";i:330;s:20:\"ilpdcalendarblockgui\";i:331;s:24:\"ilpdexternalfeedblockgui\";i:332;s:20:\"ilpdfeedbackblockgui\";i:333;s:16:\"ilpdmailblockgui\";i:334;s:16:\"ilpdnewsblockgui\";i:335;s:17:\"ilpdnotesblockgui\";i:336;s:25:\"ilpdselecteditemsblockgui\";i:337;s:22:\"ilpdsysmessageblockgui\";i:338;s:19:\"ilpdtaggingblockgui\";i:339;s:21:\"ilusersonlineblockgui\";i:340;s:0:\"\";i:341;s:18:\"ilbookmarkblockgui\";i:342;s:18:\"ilcalendarblockgui\";i:343;s:15:\"ildummyblockgui\";i:344;s:22:\"ilexternalfeedblockgui\";i:345;s:14:\"ilhtmlblockgui\";i:346;s:24:\"ilnewsforcontextblockgui\";i:347;s:20:\"ilpdcalendarblockgui\";i:348;s:24:\"ilpdexternalfeedblockgui\";i:349;s:20:\"ilpdfeedbackblockgui\";i:350;s:16:\"ilpdmailblockgui\";i:351;s:16:\"ilpdnewsblockgui\";i:352;s:17:\"ilpdnotesblockgui\";i:353;s:25:\"ilpdselecteditemsblockgui\";i:354;s:22:\"ilpdsysmessageblockgui\";i:355;s:19:\"ilpdtaggingblockgui\";i:356;s:21:\"ilusersonlineblockgui\";i:357;s:0:\"\";i:358;s:18:\"ilbookmarkblockgui\";i:359;s:18:\"ilcalendarblockgui\";i:360;s:15:\"ildummyblockgui\";i:361;s:22:\"ilexternalfeedblockgui\";i:362;s:14:\"ilhtmlblockgui\";i:363;s:24:\"ilnewsforcontextblockgui\";i:364;s:20:\"ilpdcalendarblockgui\";i:365;s:24:\"ilpdexternalfeedblockgui\";i:366;s:20:\"ilpdfeedbackblockgui\";i:367;s:16:\"ilpdmailblockgui\";i:368;s:16:\"ilpdnewsblockgui\";i:369;s:17:\"ilpdnotesblockgui\";i:370;s:25:\"ilpdselecteditemsblockgui\";i:371;s:22:\"ilpdsysmessageblockgui\";i:372;s:19:\"ilpdtaggingblockgui\";i:373;s:21:\"ilusersonlineblockgui\";i:374;s:0:\"\";i:375;s:18:\"ilbookmarkblockgui\";i:376;s:18:\"ilcalendarblockgui\";i:377;s:15:\"ildummyblockgui\";i:378;s:22:\"ilexternalfeedblockgui\";i:379;s:14:\"ilhtmlblockgui\";i:380;s:24:\"ilnewsforcontextblockgui\";i:381;s:20:\"ilpdcalendarblockgui\";i:382;s:24:\"ilpdexternalfeedblockgui\";i:383;s:20:\"ilpdfeedbackblockgui\";i:384;s:16:\"ilpdmailblockgui\";i:385;s:16:\"ilpdnewsblockgui\";i:386;s:17:\"ilpdnotesblockgui\";i:387;s:25:\"ilpdselecteditemsblockgui\";i:388;s:22:\"ilpdsysmessageblockgui\";i:389;s:19:\"ilpdtaggingblockgui\";i:390;s:21:\"ilusersonlineblockgui\";i:391;s:0:\"\";i:392;s:18:\"ilbookmarkblockgui\";i:393;s:18:\"ilcalendarblockgui\";i:394;s:15:\"ildummyblockgui\";i:395;s:22:\"ilexternalfeedblockgui\";i:396;s:14:\"ilhtmlblockgui\";i:397;s:24:\"ilnewsforcontextblockgui\";i:398;s:20:\"ilpdcalendarblockgui\";i:399;s:24:\"ilpdexternalfeedblockgui\";i:400;s:20:\"ilpdfeedbackblockgui\";i:401;s:16:\"ilpdmailblockgui\";i:402;s:16:\"ilpdnewsblockgui\";i:403;s:17:\"ilpdnotesblockgui\";i:404;s:25:\"ilpdselecteditemsblockgui\";i:405;s:22:\"ilpdsysmessageblockgui\";i:406;s:19:\"ilpdtaggingblockgui\";i:407;s:21:\"ilusersonlineblockgui\";i:408;s:0:\"\";i:409;s:18:\"ilbookmarkblockgui\";i:410;s:18:\"ilcalendarblockgui\";i:411;s:15:\"ildummyblockgui\";i:412;s:22:\"ilexternalfeedblockgui\";i:413;s:14:\"ilhtmlblockgui\";i:414;s:24:\"ilnewsforcontextblockgui\";i:415;s:20:\"ilpdcalendarblockgui\";i:416;s:24:\"ilpdexternalfeedblockgui\";i:417;s:20:\"ilpdfeedbackblockgui\";i:418;s:16:\"ilpdmailblockgui\";i:419;s:16:\"ilpdnewsblockgui\";i:420;s:17:\"ilpdnotesblockgui\";i:421;s:25:\"ilpdselecteditemsblockgui\";i:422;s:22:\"ilpdsysmessageblockgui\";i:423;s:19:\"ilpdtaggingblockgui\";i:424;s:21:\"ilusersonlineblockgui\";i:425;s:0:\"\";i:426;s:18:\"ilbookmarkblockgui\";i:427;s:18:\"ilcalendarblockgui\";i:428;s:15:\"ildummyblockgui\";i:429;s:22:\"ilexternalfeedblockgui\";i:430;s:14:\"ilhtmlblockgui\";i:431;s:24:\"ilnewsforcontextblockgui\";i:432;s:20:\"ilpdcalendarblockgui\";i:433;s:24:\"ilpdexternalfeedblockgui\";i:434;s:20:\"ilpdfeedbackblockgui\";i:435;s:16:\"ilpdmailblockgui\";i:436;s:16:\"ilpdnewsblockgui\";i:437;s:17:\"ilpdnotesblockgui\";i:438;s:25:\"ilpdselecteditemsblockgui\";i:439;s:22:\"ilpdsysmessageblockgui\";i:440;s:19:\"ilpdtaggingblockgui\";i:441;s:21:\"ilusersonlineblockgui\";i:442;s:0:\"\";i:443;s:18:\"ilbookmarkblockgui\";i:444;s:18:\"ilcalendarblockgui\";i:445;s:15:\"ildummyblockgui\";i:446;s:22:\"ilexternalfeedblockgui\";i:447;s:14:\"ilhtmlblockgui\";i:448;s:24:\"ilnewsforcontextblockgui\";i:449;s:20:\"ilpdcalendarblockgui\";i:450;s:24:\"ilpdexternalfeedblockgui\";i:451;s:20:\"ilpdfeedbackblockgui\";i:452;s:16:\"ilpdmailblockgui\";i:453;s:16:\"ilpdnewsblockgui\";i:454;s:17:\"ilpdnotesblockgui\";i:455;s:25:\"ilpdselecteditemsblockgui\";i:456;s:22:\"ilpdsysmessageblockgui\";i:457;s:19:\"ilpdtaggingblockgui\";i:458;s:21:\"ilusersonlineblockgui\";i:459;s:0:\"\";i:460;s:18:\"ilbookmarkblockgui\";i:461;s:18:\"ilcalendarblockgui\";i:462;s:15:\"ildummyblockgui\";i:463;s:22:\"ilexternalfeedblockgui\";i:464;s:14:\"ilhtmlblockgui\";i:465;s:24:\"ilnewsforcontextblockgui\";i:466;s:20:\"ilpdcalendarblockgui\";i:467;s:24:\"ilpdexternalfeedblockgui\";i:468;s:20:\"ilpdfeedbackblockgui\";i:469;s:16:\"ilpdmailblockgui\";i:470;s:16:\"ilpdnewsblockgui\";i:471;s:17:\"ilpdnotesblockgui\";i:472;s:25:\"ilpdselecteditemsblockgui\";i:473;s:22:\"ilpdsysmessageblockgui\";i:474;s:19:\"ilpdtaggingblockgui\";i:475;s:21:\"ilusersonlineblockgui\";i:476;s:0:\"\";i:477;s:18:\"ilbookmarkblockgui\";i:478;s:18:\"ilcalendarblockgui\";i:479;s:15:\"ildummyblockgui\";i:480;s:22:\"ilexternalfeedblockgui\";i:481;s:14:\"ilhtmlblockgui\";i:482;s:24:\"ilnewsforcontextblockgui\";i:483;s:20:\"ilpdcalendarblockgui\";i:484;s:24:\"ilpdexternalfeedblockgui\";i:485;s:20:\"ilpdfeedbackblockgui\";i:486;s:16:\"ilpdmailblockgui\";i:487;s:16:\"ilpdnewsblockgui\";i:488;s:17:\"ilpdnotesblockgui\";i:489;s:25:\"ilpdselecteditemsblockgui\";i:490;s:22:\"ilpdsysmessageblockgui\";i:491;s:19:\"ilpdtaggingblockgui\";i:492;s:21:\"ilusersonlineblockgui\";i:493;s:0:\"\";i:494;s:18:\"ilbookmarkblockgui\";i:495;s:18:\"ilcalendarblockgui\";i:496;s:15:\"ildummyblockgui\";i:497;s:22:\"ilexternalfeedblockgui\";i:498;s:14:\"ilhtmlblockgui\";i:499;s:24:\"ilnewsforcontextblockgui\";i:500;s:20:\"ilpdcalendarblockgui\";i:501;s:24:\"ilpdexternalfeedblockgui\";i:502;s:20:\"ilpdfeedbackblockgui\";i:503;s:16:\"ilpdmailblockgui\";i:504;s:16:\"ilpdnewsblockgui\";i:505;s:17:\"ilpdnotesblockgui\";i:506;s:25:\"ilpdselecteditemsblockgui\";i:507;s:22:\"ilpdsysmessageblockgui\";i:508;s:19:\"ilpdtaggingblockgui\";i:509;s:21:\"ilusersonlineblockgui\";i:510;s:0:\"\";i:511;s:18:\"ilbookmarkblockgui\";i:512;s:18:\"ilcalendarblockgui\";i:513;s:15:\"ildummyblockgui\";i:514;s:22:\"ilexternalfeedblockgui\";i:515;s:14:\"ilhtmlblockgui\";i:516;s:24:\"ilnewsforcontextblockgui\";i:517;s:20:\"ilpdcalendarblockgui\";i:518;s:24:\"ilpdexternalfeedblockgui\";i:519;s:20:\"ilpdfeedbackblockgui\";i:520;s:16:\"ilpdmailblockgui\";i:521;s:16:\"ilpdnewsblockgui\";i:522;s:17:\"ilpdnotesblockgui\";i:523;s:25:\"ilpdselecteditemsblockgui\";i:524;s:22:\"ilpdsysmessageblockgui\";i:525;s:19:\"ilpdtaggingblockgui\";i:526;s:21:\"ilusersonlineblockgui\";i:527;s:0:\"\";i:528;s:18:\"ilbookmarkblockgui\";i:529;s:18:\"ilcalendarblockgui\";i:530;s:15:\"ildummyblockgui\";i:531;s:22:\"ilexternalfeedblockgui\";i:532;s:14:\"ilhtmlblockgui\";i:533;s:24:\"ilnewsforcontextblockgui\";i:534;s:20:\"ilpdcalendarblockgui\";i:535;s:24:\"ilpdexternalfeedblockgui\";i:536;s:20:\"ilpdfeedbackblockgui\";i:537;s:16:\"ilpdmailblockgui\";i:538;s:16:\"ilpdnewsblockgui\";i:539;s:17:\"ilpdnotesblockgui\";i:540;s:25:\"ilpdselecteditemsblockgui\";i:541;s:22:\"ilpdsysmessageblockgui\";i:542;s:19:\"ilpdtaggingblockgui\";i:543;s:21:\"ilusersonlineblockgui\";i:544;s:0:\"\";i:545;s:18:\"ilbookmarkblockgui\";i:546;s:18:\"ilcalendarblockgui\";i:547;s:15:\"ildummyblockgui\";i:548;s:22:\"ilexternalfeedblockgui\";i:549;s:14:\"ilhtmlblockgui\";i:550;s:24:\"ilnewsforcontextblockgui\";i:551;s:20:\"ilpdcalendarblockgui\";i:552;s:24:\"ilpdexternalfeedblockgui\";i:553;s:20:\"ilpdfeedbackblockgui\";i:554;s:16:\"ilpdmailblockgui\";i:555;s:16:\"ilpdnewsblockgui\";i:556;s:17:\"ilpdnotesblockgui\";i:557;s:25:\"ilpdselecteditemsblockgui\";i:558;s:22:\"ilpdsysmessageblockgui\";i:559;s:19:\"ilpdtaggingblockgui\";i:560;s:21:\"ilusersonlineblockgui\";i:561;s:0:\"\";i:562;s:18:\"ilbookmarkblockgui\";i:563;s:18:\"ilcalendarblockgui\";i:564;s:15:\"ildummyblockgui\";i:565;s:22:\"ilexternalfeedblockgui\";i:566;s:14:\"ilhtmlblockgui\";i:567;s:24:\"ilnewsforcontextblockgui\";i:568;s:20:\"ilpdcalendarblockgui\";i:569;s:24:\"ilpdexternalfeedblockgui\";i:570;s:20:\"ilpdfeedbackblockgui\";i:571;s:16:\"ilpdmailblockgui\";i:572;s:16:\"ilpdnewsblockgui\";i:573;s:17:\"ilpdnotesblockgui\";i:574;s:25:\"ilpdselecteditemsblockgui\";i:575;s:22:\"ilpdsysmessageblockgui\";i:576;s:19:\"ilpdtaggingblockgui\";i:577;s:21:\"ilusersonlineblockgui\";i:578;s:0:\"\";i:579;s:18:\"ilbookmarkblockgui\";i:580;s:18:\"ilcalendarblockgui\";i:581;s:15:\"ildummyblockgui\";i:582;s:22:\"ilexternalfeedblockgui\";i:583;s:14:\"ilhtmlblockgui\";i:584;s:24:\"ilnewsforcontextblockgui\";i:585;s:20:\"ilpdcalendarblockgui\";i:586;s:24:\"ilpdexternalfeedblockgui\";i:587;s:20:\"ilpdfeedbackblockgui\";i:588;s:16:\"ilpdmailblockgui\";i:589;s:16:\"ilpdnewsblockgui\";i:590;s:17:\"ilpdnotesblockgui\";i:591;s:25:\"ilpdselecteditemsblockgui\";i:592;s:22:\"ilpdsysmessageblockgui\";i:593;s:19:\"ilpdtaggingblockgui\";i:594;s:21:\"ilusersonlineblockgui\";i:595;s:0:\"\";i:596;s:18:\"ilbookmarkblockgui\";i:597;s:18:\"ilcalendarblockgui\";i:598;s:15:\"ildummyblockgui\";i:599;s:22:\"ilexternalfeedblockgui\";i:600;s:14:\"ilhtmlblockgui\";i:601;s:24:\"ilnewsforcontextblockgui\";i:602;s:20:\"ilpdcalendarblockgui\";i:603;s:24:\"ilpdexternalfeedblockgui\";i:604;s:20:\"ilpdfeedbackblockgui\";i:605;s:16:\"ilpdmailblockgui\";i:606;s:16:\"ilpdnewsblockgui\";i:607;s:17:\"ilpdnotesblockgui\";i:608;s:25:\"ilpdselecteditemsblockgui\";i:609;s:22:\"ilpdsysmessageblockgui\";i:610;s:19:\"ilpdtaggingblockgui\";i:611;s:21:\"ilusersonlineblockgui\";i:612;s:0:\"\";i:613;s:18:\"ilbookmarkblockgui\";i:614;s:18:\"ilcalendarblockgui\";i:615;s:15:\"ildummyblockgui\";i:616;s:22:\"ilexternalfeedblockgui\";i:617;s:14:\"ilhtmlblockgui\";i:618;s:24:\"ilnewsforcontextblockgui\";i:619;s:20:\"ilpdcalendarblockgui\";i:620;s:24:\"ilpdexternalfeedblockgui\";i:621;s:20:\"ilpdfeedbackblockgui\";i:622;s:16:\"ilpdmailblockgui\";i:623;s:16:\"ilpdnewsblockgui\";i:624;s:17:\"ilpdnotesblockgui\";i:625;s:25:\"ilpdselecteditemsblockgui\";i:626;s:22:\"ilpdsysmessageblockgui\";i:627;s:19:\"ilpdtaggingblockgui\";i:628;s:21:\"ilusersonlineblockgui\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:13:\"ilfeedbackgui\";a:24:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";}s:15:\"ilinfoscreengui\";a:96:{i:0;s:11:\"ilcolumngui\";i:1;s:13:\"ilfeedbackgui\";i:2;s:9:\"ilnotegui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:11:\"ilcolumngui\";i:5;s:13:\"ilfeedbackgui\";i:6;s:9:\"ilnotegui\";i:7;s:22:\"ilpublicuserprofilegui\";i:8;s:11:\"ilcolumngui\";i:9;s:13:\"ilfeedbackgui\";i:10;s:9:\"ilnotegui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:11:\"ilcolumngui\";i:13;s:13:\"ilfeedbackgui\";i:14;s:9:\"ilnotegui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:11:\"ilcolumngui\";i:17;s:13:\"ilfeedbackgui\";i:18;s:9:\"ilnotegui\";i:19;s:22:\"ilpublicuserprofilegui\";i:20;s:11:\"ilcolumngui\";i:21;s:13:\"ilfeedbackgui\";i:22;s:9:\"ilnotegui\";i:23;s:22:\"ilpublicuserprofilegui\";i:24;s:11:\"ilcolumngui\";i:25;s:13:\"ilfeedbackgui\";i:26;s:9:\"ilnotegui\";i:27;s:22:\"ilpublicuserprofilegui\";i:28;s:11:\"ilcolumngui\";i:29;s:13:\"ilfeedbackgui\";i:30;s:9:\"ilnotegui\";i:31;s:22:\"ilpublicuserprofilegui\";i:32;s:11:\"ilcolumngui\";i:33;s:13:\"ilfeedbackgui\";i:34;s:9:\"ilnotegui\";i:35;s:22:\"ilpublicuserprofilegui\";i:36;s:11:\"ilcolumngui\";i:37;s:13:\"ilfeedbackgui\";i:38;s:9:\"ilnotegui\";i:39;s:22:\"ilpublicuserprofilegui\";i:40;s:11:\"ilcolumngui\";i:41;s:13:\"ilfeedbackgui\";i:42;s:9:\"ilnotegui\";i:43;s:22:\"ilpublicuserprofilegui\";i:44;s:11:\"ilcolumngui\";i:45;s:13:\"ilfeedbackgui\";i:46;s:9:\"ilnotegui\";i:47;s:22:\"ilpublicuserprofilegui\";i:48;s:11:\"ilcolumngui\";i:49;s:13:\"ilfeedbackgui\";i:50;s:9:\"ilnotegui\";i:51;s:22:\"ilpublicuserprofilegui\";i:52;s:11:\"ilcolumngui\";i:53;s:13:\"ilfeedbackgui\";i:54;s:9:\"ilnotegui\";i:55;s:22:\"ilpublicuserprofilegui\";i:56;s:11:\"ilcolumngui\";i:57;s:13:\"ilfeedbackgui\";i:58;s:9:\"ilnotegui\";i:59;s:22:\"ilpublicuserprofilegui\";i:60;s:11:\"ilcolumngui\";i:61;s:13:\"ilfeedbackgui\";i:62;s:9:\"ilnotegui\";i:63;s:22:\"ilpublicuserprofilegui\";i:64;s:11:\"ilcolumngui\";i:65;s:13:\"ilfeedbackgui\";i:66;s:9:\"ilnotegui\";i:67;s:22:\"ilpublicuserprofilegui\";i:68;s:11:\"ilcolumngui\";i:69;s:13:\"ilfeedbackgui\";i:70;s:9:\"ilnotegui\";i:71;s:22:\"ilpublicuserprofilegui\";i:72;s:11:\"ilcolumngui\";i:73;s:13:\"ilfeedbackgui\";i:74;s:9:\"ilnotegui\";i:75;s:22:\"ilpublicuserprofilegui\";i:76;s:11:\"ilcolumngui\";i:77;s:13:\"ilfeedbackgui\";i:78;s:9:\"ilnotegui\";i:79;s:22:\"ilpublicuserprofilegui\";i:80;s:11:\"ilcolumngui\";i:81;s:13:\"ilfeedbackgui\";i:82;s:9:\"ilnotegui\";i:83;s:22:\"ilpublicuserprofilegui\";i:84;s:11:\"ilcolumngui\";i:85;s:13:\"ilfeedbackgui\";i:86;s:9:\"ilnotegui\";i:87;s:22:\"ilpublicuserprofilegui\";i:88;s:11:\"ilcolumngui\";i:89;s:13:\"ilfeedbackgui\";i:90;s:9:\"ilnotegui\";i:91;s:22:\"ilpublicuserprofilegui\";i:92;s:11:\"ilcolumngui\";i:93;s:13:\"ilfeedbackgui\";i:94;s:9:\"ilnotegui\";i:95;s:22:\"ilpublicuserprofilegui\";}s:13:\"illpfiltergui\";a:30:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";}s:17:\"ilpdfpresentation\";a:30:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";}s:15:\"iluserfiltergui\";a:15:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";}s:20:\"illplistofobjectsgui\";a:45:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:15:\"iluserfiltergui\";i:3;s:13:\"illpfiltergui\";i:4;s:17:\"ilpdfpresentation\";i:5;s:15:\"iluserfiltergui\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:15:\"iluserfiltergui\";i:9;s:13:\"illpfiltergui\";i:10;s:17:\"ilpdfpresentation\";i:11;s:15:\"iluserfiltergui\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:15:\"iluserfiltergui\";i:15;s:13:\"illpfiltergui\";i:16;s:17:\"ilpdfpresentation\";i:17;s:15:\"iluserfiltergui\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:15:\"iluserfiltergui\";i:21;s:13:\"illpfiltergui\";i:22;s:17:\"ilpdfpresentation\";i:23;s:15:\"iluserfiltergui\";i:24;s:13:\"illpfiltergui\";i:25;s:17:\"ilpdfpresentation\";i:26;s:15:\"iluserfiltergui\";i:27;s:13:\"illpfiltergui\";i:28;s:17:\"ilpdfpresentation\";i:29;s:15:\"iluserfiltergui\";i:30;s:13:\"illpfiltergui\";i:31;s:17:\"ilpdfpresentation\";i:32;s:15:\"iluserfiltergui\";i:33;s:13:\"illpfiltergui\";i:34;s:17:\"ilpdfpresentation\";i:35;s:15:\"iluserfiltergui\";i:36;s:13:\"illpfiltergui\";i:37;s:17:\"ilpdfpresentation\";i:38;s:15:\"iluserfiltergui\";i:39;s:13:\"illpfiltergui\";i:40;s:17:\"ilpdfpresentation\";i:41;s:15:\"iluserfiltergui\";i:42;s:13:\"illpfiltergui\";i:43;s:17:\"ilpdfpresentation\";i:44;s:15:\"iluserfiltergui\";}s:21:\"illplistofprogressgui\";a:30:{i:0;s:13:\"illpfiltergui\";i:1;s:17:\"ilpdfpresentation\";i:2;s:13:\"illpfiltergui\";i:3;s:17:\"ilpdfpresentation\";i:4;s:13:\"illpfiltergui\";i:5;s:17:\"ilpdfpresentation\";i:6;s:13:\"illpfiltergui\";i:7;s:17:\"ilpdfpresentation\";i:8;s:13:\"illpfiltergui\";i:9;s:17:\"ilpdfpresentation\";i:10;s:13:\"illpfiltergui\";i:11;s:17:\"ilpdfpresentation\";i:12;s:13:\"illpfiltergui\";i:13;s:17:\"ilpdfpresentation\";i:14;s:13:\"illpfiltergui\";i:15;s:17:\"ilpdfpresentation\";i:16;s:13:\"illpfiltergui\";i:17;s:17:\"ilpdfpresentation\";i:18;s:13:\"illpfiltergui\";i:19;s:17:\"ilpdfpresentation\";i:20;s:13:\"illpfiltergui\";i:21;s:17:\"ilpdfpresentation\";i:22;s:13:\"illpfiltergui\";i:23;s:17:\"ilpdfpresentation\";i:24;s:13:\"illpfiltergui\";i:25;s:17:\"ilpdfpresentation\";i:26;s:13:\"illpfiltergui\";i:27;s:17:\"ilpdfpresentation\";i:28;s:13:\"illpfiltergui\";i:29;s:17:\"ilpdfpresentation\";}s:21:\"illplistofsettingsgui\";a:15:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";i:5;s:0:\"\";i:6;s:0:\"\";i:7;s:0:\"\";i:8;s:0:\"\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:0:\"\";i:12;s:0:\"\";i:13;s:0:\"\";i:14;s:0:\"\";}s:21:\"illearningprogressgui\";a:60:{i:0;s:17:\"illmstatisticsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:21:\"illplistofprogressgui\";i:3;s:21:\"illplistofsettingsgui\";i:4;s:17:\"illmstatisticsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:21:\"illplistofprogressgui\";i:7;s:21:\"illplistofsettingsgui\";i:8;s:17:\"illmstatisticsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:21:\"illplistofprogressgui\";i:11;s:21:\"illplistofsettingsgui\";i:12;s:17:\"illmstatisticsgui\";i:13;s:20:\"illplistofobjectsgui\";i:14;s:21:\"illplistofprogressgui\";i:15;s:21:\"illplistofsettingsgui\";i:16;s:17:\"illmstatisticsgui\";i:17;s:20:\"illplistofobjectsgui\";i:18;s:21:\"illplistofprogressgui\";i:19;s:21:\"illplistofsettingsgui\";i:20;s:17:\"illmstatisticsgui\";i:21;s:20:\"illplistofobjectsgui\";i:22;s:21:\"illplistofprogressgui\";i:23;s:21:\"illplistofsettingsgui\";i:24;s:17:\"illmstatisticsgui\";i:25;s:20:\"illplistofobjectsgui\";i:26;s:21:\"illplistofprogressgui\";i:27;s:21:\"illplistofsettingsgui\";i:28;s:17:\"illmstatisticsgui\";i:29;s:20:\"illplistofobjectsgui\";i:30;s:21:\"illplistofprogressgui\";i:31;s:21:\"illplistofsettingsgui\";i:32;s:17:\"illmstatisticsgui\";i:33;s:20:\"illplistofobjectsgui\";i:34;s:21:\"illplistofprogressgui\";i:35;s:21:\"illplistofsettingsgui\";i:36;s:17:\"illmstatisticsgui\";i:37;s:20:\"illplistofobjectsgui\";i:38;s:21:\"illplistofprogressgui\";i:39;s:21:\"illplistofsettingsgui\";i:40;s:17:\"illmstatisticsgui\";i:41;s:20:\"illplistofobjectsgui\";i:42;s:21:\"illplistofprogressgui\";i:43;s:21:\"illplistofsettingsgui\";i:44;s:17:\"illmstatisticsgui\";i:45;s:20:\"illplistofobjectsgui\";i:46;s:21:\"illplistofprogressgui\";i:47;s:21:\"illplistofsettingsgui\";i:48;s:17:\"illmstatisticsgui\";i:49;s:20:\"illplistofobjectsgui\";i:50;s:21:\"illplistofprogressgui\";i:51;s:21:\"illplistofsettingsgui\";i:52;s:17:\"illmstatisticsgui\";i:53;s:20:\"illplistofobjectsgui\";i:54;s:21:\"illplistofprogressgui\";i:55;s:21:\"illplistofsettingsgui\";i:56;s:17:\"illmstatisticsgui\";i:57;s:20:\"illplistofobjectsgui\";i:58;s:21:\"illplistofprogressgui\";i:59;s:21:\"illplistofsettingsgui\";}s:12:\"ilobjusergui\";a:8:{i:0;s:21:\"illearningprogressgui\";i:1;s:17:\"ilobjilincusergui\";i:2;s:21:\"illearningprogressgui\";i:3;s:17:\"ilobjilincusergui\";i:4;s:21:\"illearningprogressgui\";i:5;s:17:\"ilobjilincusergui\";i:6;s:21:\"illearningprogressgui\";i:7;s:17:\"ilobjilincusergui\";}s:20:\"iladminusersearchgui\";a:2:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";}s:18:\"ilobjuserfoldergui\";a:4:{i:0;s:20:\"iladminusersearchgui\";i:1;s:15:\"ilpermissiongui\";i:2;s:20:\"iladminusersearchgui\";i:3;s:15:\"ilpermissiongui\";}s:19:\"ilimagemapeditorgui\";a:62:{i:0;s:17:\"ilinternallinkgui\";i:1;s:17:\"ilinternallinkgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:17:\"ilinternallinkgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:17:\"ilinternallinkgui\";i:6;s:17:\"ilinternallinkgui\";i:7;s:17:\"ilinternallinkgui\";i:8;s:17:\"ilinternallinkgui\";i:9;s:17:\"ilinternallinkgui\";i:10;s:17:\"ilinternallinkgui\";i:11;s:17:\"ilinternallinkgui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:17:\"ilinternallinkgui\";i:14;s:17:\"ilinternallinkgui\";i:15;s:17:\"ilinternallinkgui\";i:16;s:17:\"ilinternallinkgui\";i:17;s:17:\"ilinternallinkgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:17:\"ilinternallinkgui\";i:20;s:17:\"ilinternallinkgui\";i:21;s:17:\"ilinternallinkgui\";i:22;s:17:\"ilinternallinkgui\";i:23;s:17:\"ilinternallinkgui\";i:24;s:17:\"ilinternallinkgui\";i:25;s:17:\"ilinternallinkgui\";i:26;s:17:\"ilinternallinkgui\";i:27;s:17:\"ilinternallinkgui\";i:28;s:17:\"ilinternallinkgui\";i:29;s:17:\"ilinternallinkgui\";i:30;s:17:\"ilinternallinkgui\";i:31;s:17:\"ilinternallinkgui\";i:32;s:17:\"ilinternallinkgui\";i:33;s:17:\"ilinternallinkgui\";i:34;s:17:\"ilinternallinkgui\";i:35;s:17:\"ilinternallinkgui\";i:36;s:17:\"ilinternallinkgui\";i:37;s:17:\"ilinternallinkgui\";i:38;s:17:\"ilinternallinkgui\";i:39;s:17:\"ilinternallinkgui\";i:40;s:17:\"ilinternallinkgui\";i:41;s:17:\"ilinternallinkgui\";i:42;s:17:\"ilinternallinkgui\";i:43;s:17:\"ilinternallinkgui\";i:44;s:17:\"ilinternallinkgui\";i:45;s:17:\"ilinternallinkgui\";i:46;s:17:\"ilinternallinkgui\";i:47;s:17:\"ilinternallinkgui\";i:48;s:17:\"ilinternallinkgui\";i:49;s:17:\"ilinternallinkgui\";i:50;s:17:\"ilinternallinkgui\";i:51;s:17:\"ilinternallinkgui\";i:52;s:17:\"ilinternallinkgui\";i:53;s:17:\"ilinternallinkgui\";i:54;s:17:\"ilinternallinkgui\";i:55;s:17:\"ilinternallinkgui\";i:56;s:17:\"ilinternallinkgui\";i:57;s:17:\"ilinternallinkgui\";i:58;s:17:\"ilinternallinkgui\";i:59;s:17:\"ilinternallinkgui\";i:60;s:17:\"ilinternallinkgui\";i:61;s:17:\"ilinternallinkgui\";}s:19:\"ilobjmediaobjectgui\";a:124:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:19:\"ilimagemapeditorgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:19:\"ilimagemapeditorgui\";i:7;s:13:\"ilmdeditorgui\";i:8;s:19:\"ilimagemapeditorgui\";i:9;s:13:\"ilmdeditorgui\";i:10;s:19:\"ilimagemapeditorgui\";i:11;s:13:\"ilmdeditorgui\";i:12;s:19:\"ilimagemapeditorgui\";i:13;s:13:\"ilmdeditorgui\";i:14;s:19:\"ilimagemapeditorgui\";i:15;s:13:\"ilmdeditorgui\";i:16;s:19:\"ilimagemapeditorgui\";i:17;s:13:\"ilmdeditorgui\";i:18;s:19:\"ilimagemapeditorgui\";i:19;s:13:\"ilmdeditorgui\";i:20;s:19:\"ilimagemapeditorgui\";i:21;s:13:\"ilmdeditorgui\";i:22;s:19:\"ilimagemapeditorgui\";i:23;s:13:\"ilmdeditorgui\";i:24;s:19:\"ilimagemapeditorgui\";i:25;s:13:\"ilmdeditorgui\";i:26;s:19:\"ilimagemapeditorgui\";i:27;s:13:\"ilmdeditorgui\";i:28;s:19:\"ilimagemapeditorgui\";i:29;s:13:\"ilmdeditorgui\";i:30;s:19:\"ilimagemapeditorgui\";i:31;s:13:\"ilmdeditorgui\";i:32;s:19:\"ilimagemapeditorgui\";i:33;s:13:\"ilmdeditorgui\";i:34;s:19:\"ilimagemapeditorgui\";i:35;s:13:\"ilmdeditorgui\";i:36;s:19:\"ilimagemapeditorgui\";i:37;s:13:\"ilmdeditorgui\";i:38;s:19:\"ilimagemapeditorgui\";i:39;s:13:\"ilmdeditorgui\";i:40;s:19:\"ilimagemapeditorgui\";i:41;s:13:\"ilmdeditorgui\";i:42;s:19:\"ilimagemapeditorgui\";i:43;s:13:\"ilmdeditorgui\";i:44;s:19:\"ilimagemapeditorgui\";i:45;s:13:\"ilmdeditorgui\";i:46;s:19:\"ilimagemapeditorgui\";i:47;s:13:\"ilmdeditorgui\";i:48;s:19:\"ilimagemapeditorgui\";i:49;s:13:\"ilmdeditorgui\";i:50;s:19:\"ilimagemapeditorgui\";i:51;s:13:\"ilmdeditorgui\";i:52;s:19:\"ilimagemapeditorgui\";i:53;s:13:\"ilmdeditorgui\";i:54;s:19:\"ilimagemapeditorgui\";i:55;s:13:\"ilmdeditorgui\";i:56;s:19:\"ilimagemapeditorgui\";i:57;s:13:\"ilmdeditorgui\";i:58;s:19:\"ilimagemapeditorgui\";i:59;s:13:\"ilmdeditorgui\";i:60;s:19:\"ilimagemapeditorgui\";i:61;s:13:\"ilmdeditorgui\";i:62;s:19:\"ilimagemapeditorgui\";i:63;s:13:\"ilmdeditorgui\";i:64;s:19:\"ilimagemapeditorgui\";i:65;s:13:\"ilmdeditorgui\";i:66;s:19:\"ilimagemapeditorgui\";i:67;s:13:\"ilmdeditorgui\";i:68;s:19:\"ilimagemapeditorgui\";i:69;s:13:\"ilmdeditorgui\";i:70;s:19:\"ilimagemapeditorgui\";i:71;s:13:\"ilmdeditorgui\";i:72;s:19:\"ilimagemapeditorgui\";i:73;s:13:\"ilmdeditorgui\";i:74;s:19:\"ilimagemapeditorgui\";i:75;s:13:\"ilmdeditorgui\";i:76;s:19:\"ilimagemapeditorgui\";i:77;s:13:\"ilmdeditorgui\";i:78;s:19:\"ilimagemapeditorgui\";i:79;s:13:\"ilmdeditorgui\";i:80;s:19:\"ilimagemapeditorgui\";i:81;s:13:\"ilmdeditorgui\";i:82;s:19:\"ilimagemapeditorgui\";i:83;s:13:\"ilmdeditorgui\";i:84;s:19:\"ilimagemapeditorgui\";i:85;s:13:\"ilmdeditorgui\";i:86;s:19:\"ilimagemapeditorgui\";i:87;s:13:\"ilmdeditorgui\";i:88;s:19:\"ilimagemapeditorgui\";i:89;s:13:\"ilmdeditorgui\";i:90;s:19:\"ilimagemapeditorgui\";i:91;s:13:\"ilmdeditorgui\";i:92;s:19:\"ilimagemapeditorgui\";i:93;s:13:\"ilmdeditorgui\";i:94;s:19:\"ilimagemapeditorgui\";i:95;s:13:\"ilmdeditorgui\";i:96;s:19:\"ilimagemapeditorgui\";i:97;s:13:\"ilmdeditorgui\";i:98;s:19:\"ilimagemapeditorgui\";i:99;s:13:\"ilmdeditorgui\";i:100;s:19:\"ilimagemapeditorgui\";i:101;s:13:\"ilmdeditorgui\";i:102;s:19:\"ilimagemapeditorgui\";i:103;s:13:\"ilmdeditorgui\";i:104;s:19:\"ilimagemapeditorgui\";i:105;s:13:\"ilmdeditorgui\";i:106;s:19:\"ilimagemapeditorgui\";i:107;s:13:\"ilmdeditorgui\";i:108;s:19:\"ilimagemapeditorgui\";i:109;s:13:\"ilmdeditorgui\";i:110;s:19:\"ilimagemapeditorgui\";i:111;s:13:\"ilmdeditorgui\";i:112;s:19:\"ilimagemapeditorgui\";i:113;s:13:\"ilmdeditorgui\";i:114;s:19:\"ilimagemapeditorgui\";i:115;s:13:\"ilmdeditorgui\";i:116;s:19:\"ilimagemapeditorgui\";i:117;s:13:\"ilmdeditorgui\";i:118;s:19:\"ilimagemapeditorgui\";i:119;s:13:\"ilmdeditorgui\";i:120;s:19:\"ilimagemapeditorgui\";i:121;s:13:\"ilmdeditorgui\";i:122;s:19:\"ilimagemapeditorgui\";i:123;s:13:\"ilmdeditorgui\";}s:18:\"ileditclipboardgui\";a:21:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:19:\"ilobjmediaobjectgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:19:\"ilobjmediaobjectgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:19:\"ilobjmediaobjectgui\";i:17;s:19:\"ilobjmediaobjectgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:19:\"ilobjmediaobjectgui\";}s:21:\"ilpcimagemapeditorgui\";a:20:{i:0;s:17:\"ilinternallinkgui\";i:1;s:17:\"ilinternallinkgui\";i:2;s:17:\"ilinternallinkgui\";i:3;s:17:\"ilinternallinkgui\";i:4;s:17:\"ilinternallinkgui\";i:5;s:17:\"ilinternallinkgui\";i:6;s:17:\"ilinternallinkgui\";i:7;s:17:\"ilinternallinkgui\";i:8;s:17:\"ilinternallinkgui\";i:9;s:17:\"ilinternallinkgui\";i:10;s:17:\"ilinternallinkgui\";i:11;s:17:\"ilinternallinkgui\";i:12;s:17:\"ilinternallinkgui\";i:13;s:17:\"ilinternallinkgui\";i:14;s:17:\"ilinternallinkgui\";i:15;s:17:\"ilinternallinkgui\";i:16;s:17:\"ilinternallinkgui\";i:17;s:17:\"ilinternallinkgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:17:\"ilinternallinkgui\";}s:18:\"ilpcmediaobjectgui\";a:40:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:21:\"ilpcimagemapeditorgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:21:\"ilpcimagemapeditorgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:21:\"ilpcimagemapeditorgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:21:\"ilpcimagemapeditorgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:21:\"ilpcimagemapeditorgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:21:\"ilpcimagemapeditorgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:21:\"ilpcimagemapeditorgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:21:\"ilpcimagemapeditorgui\";i:16;s:19:\"ilobjmediaobjectgui\";i:17;s:21:\"ilpcimagemapeditorgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:21:\"ilpcimagemapeditorgui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:21:\"ilpcimagemapeditorgui\";i:22;s:19:\"ilobjmediaobjectgui\";i:23;s:21:\"ilpcimagemapeditorgui\";i:24;s:19:\"ilobjmediaobjectgui\";i:25;s:21:\"ilpcimagemapeditorgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:21:\"ilpcimagemapeditorgui\";i:28;s:19:\"ilobjmediaobjectgui\";i:29;s:21:\"ilpcimagemapeditorgui\";i:30;s:19:\"ilobjmediaobjectgui\";i:31;s:21:\"ilpcimagemapeditorgui\";i:32;s:19:\"ilobjmediaobjectgui\";i:33;s:21:\"ilpcimagemapeditorgui\";i:34;s:19:\"ilobjmediaobjectgui\";i:35;s:21:\"ilpcimagemapeditorgui\";i:36;s:19:\"ilobjmediaobjectgui\";i:37;s:21:\"ilpcimagemapeditorgui\";i:38;s:19:\"ilobjmediaobjectgui\";i:39;s:21:\"ilpcimagemapeditorgui\";}s:15:\"ilpageeditorgui\";a:360:{i:0;s:17:\"ilinternallinkgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:16:\"ilpcdatatablegui\";i:3;s:15:\"ilpcfileitemgui\";i:4;s:15:\"ilpcfilelistgui\";i:5;s:11:\"ilpclistgui\";i:6;s:15:\"ilpclistitemgui\";i:7;s:10:\"ilpcmapgui\";i:8;s:18:\"ilpcmediaobjectgui\";i:9;s:16:\"ilpcparagraphgui\";i:10;s:14:\"ilpcpluggedgui\";i:11;s:15:\"ilpcquestiongui\";i:12;s:16:\"ilpcresourcesgui\";i:13;s:14:\"ilpcsectiongui\";i:14;s:17:\"ilpcsourcecodegui\";i:15;s:16:\"ilpctabledatagui\";i:16;s:12:\"ilpctablegui\";i:17;s:11:\"ilpctabsgui\";i:18;s:17:\"ilinternallinkgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:16:\"ilpcdatatablegui\";i:21;s:15:\"ilpcfileitemgui\";i:22;s:15:\"ilpcfilelistgui\";i:23;s:11:\"ilpclistgui\";i:24;s:15:\"ilpclistitemgui\";i:25;s:10:\"ilpcmapgui\";i:26;s:18:\"ilpcmediaobjectgui\";i:27;s:16:\"ilpcparagraphgui\";i:28;s:14:\"ilpcpluggedgui\";i:29;s:15:\"ilpcquestiongui\";i:30;s:16:\"ilpcresourcesgui\";i:31;s:14:\"ilpcsectiongui\";i:32;s:17:\"ilpcsourcecodegui\";i:33;s:16:\"ilpctabledatagui\";i:34;s:12:\"ilpctablegui\";i:35;s:11:\"ilpctabsgui\";i:36;s:17:\"ilinternallinkgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:16:\"ilpcdatatablegui\";i:39;s:15:\"ilpcfileitemgui\";i:40;s:15:\"ilpcfilelistgui\";i:41;s:11:\"ilpclistgui\";i:42;s:15:\"ilpclistitemgui\";i:43;s:10:\"ilpcmapgui\";i:44;s:18:\"ilpcmediaobjectgui\";i:45;s:16:\"ilpcparagraphgui\";i:46;s:14:\"ilpcpluggedgui\";i:47;s:15:\"ilpcquestiongui\";i:48;s:16:\"ilpcresourcesgui\";i:49;s:14:\"ilpcsectiongui\";i:50;s:17:\"ilpcsourcecodegui\";i:51;s:16:\"ilpctabledatagui\";i:52;s:12:\"ilpctablegui\";i:53;s:11:\"ilpctabsgui\";i:54;s:17:\"ilinternallinkgui\";i:55;s:19:\"ilobjmediaobjectgui\";i:56;s:16:\"ilpcdatatablegui\";i:57;s:15:\"ilpcfileitemgui\";i:58;s:15:\"ilpcfilelistgui\";i:59;s:11:\"ilpclistgui\";i:60;s:15:\"ilpclistitemgui\";i:61;s:10:\"ilpcmapgui\";i:62;s:18:\"ilpcmediaobjectgui\";i:63;s:16:\"ilpcparagraphgui\";i:64;s:14:\"ilpcpluggedgui\";i:65;s:15:\"ilpcquestiongui\";i:66;s:16:\"ilpcresourcesgui\";i:67;s:14:\"ilpcsectiongui\";i:68;s:17:\"ilpcsourcecodegui\";i:69;s:16:\"ilpctabledatagui\";i:70;s:12:\"ilpctablegui\";i:71;s:11:\"ilpctabsgui\";i:72;s:17:\"ilinternallinkgui\";i:73;s:19:\"ilobjmediaobjectgui\";i:74;s:16:\"ilpcdatatablegui\";i:75;s:15:\"ilpcfileitemgui\";i:76;s:15:\"ilpcfilelistgui\";i:77;s:11:\"ilpclistgui\";i:78;s:15:\"ilpclistitemgui\";i:79;s:10:\"ilpcmapgui\";i:80;s:18:\"ilpcmediaobjectgui\";i:81;s:16:\"ilpcparagraphgui\";i:82;s:14:\"ilpcpluggedgui\";i:83;s:15:\"ilpcquestiongui\";i:84;s:16:\"ilpcresourcesgui\";i:85;s:14:\"ilpcsectiongui\";i:86;s:17:\"ilpcsourcecodegui\";i:87;s:16:\"ilpctabledatagui\";i:88;s:12:\"ilpctablegui\";i:89;s:11:\"ilpctabsgui\";i:90;s:17:\"ilinternallinkgui\";i:91;s:19:\"ilobjmediaobjectgui\";i:92;s:16:\"ilpcdatatablegui\";i:93;s:15:\"ilpcfileitemgui\";i:94;s:15:\"ilpcfilelistgui\";i:95;s:11:\"ilpclistgui\";i:96;s:15:\"ilpclistitemgui\";i:97;s:10:\"ilpcmapgui\";i:98;s:18:\"ilpcmediaobjectgui\";i:99;s:16:\"ilpcparagraphgui\";i:100;s:14:\"ilpcpluggedgui\";i:101;s:15:\"ilpcquestiongui\";i:102;s:16:\"ilpcresourcesgui\";i:103;s:14:\"ilpcsectiongui\";i:104;s:17:\"ilpcsourcecodegui\";i:105;s:16:\"ilpctabledatagui\";i:106;s:12:\"ilpctablegui\";i:107;s:11:\"ilpctabsgui\";i:108;s:17:\"ilinternallinkgui\";i:109;s:19:\"ilobjmediaobjectgui\";i:110;s:16:\"ilpcdatatablegui\";i:111;s:15:\"ilpcfileitemgui\";i:112;s:15:\"ilpcfilelistgui\";i:113;s:11:\"ilpclistgui\";i:114;s:15:\"ilpclistitemgui\";i:115;s:10:\"ilpcmapgui\";i:116;s:18:\"ilpcmediaobjectgui\";i:117;s:16:\"ilpcparagraphgui\";i:118;s:14:\"ilpcpluggedgui\";i:119;s:15:\"ilpcquestiongui\";i:120;s:16:\"ilpcresourcesgui\";i:121;s:14:\"ilpcsectiongui\";i:122;s:17:\"ilpcsourcecodegui\";i:123;s:16:\"ilpctabledatagui\";i:124;s:12:\"ilpctablegui\";i:125;s:11:\"ilpctabsgui\";i:126;s:17:\"ilinternallinkgui\";i:127;s:19:\"ilobjmediaobjectgui\";i:128;s:16:\"ilpcdatatablegui\";i:129;s:15:\"ilpcfileitemgui\";i:130;s:15:\"ilpcfilelistgui\";i:131;s:11:\"ilpclistgui\";i:132;s:15:\"ilpclistitemgui\";i:133;s:10:\"ilpcmapgui\";i:134;s:18:\"ilpcmediaobjectgui\";i:135;s:16:\"ilpcparagraphgui\";i:136;s:14:\"ilpcpluggedgui\";i:137;s:15:\"ilpcquestiongui\";i:138;s:16:\"ilpcresourcesgui\";i:139;s:14:\"ilpcsectiongui\";i:140;s:17:\"ilpcsourcecodegui\";i:141;s:16:\"ilpctabledatagui\";i:142;s:12:\"ilpctablegui\";i:143;s:11:\"ilpctabsgui\";i:144;s:17:\"ilinternallinkgui\";i:145;s:19:\"ilobjmediaobjectgui\";i:146;s:16:\"ilpcdatatablegui\";i:147;s:15:\"ilpcfileitemgui\";i:148;s:15:\"ilpcfilelistgui\";i:149;s:11:\"ilpclistgui\";i:150;s:15:\"ilpclistitemgui\";i:151;s:10:\"ilpcmapgui\";i:152;s:18:\"ilpcmediaobjectgui\";i:153;s:16:\"ilpcparagraphgui\";i:154;s:14:\"ilpcpluggedgui\";i:155;s:15:\"ilpcquestiongui\";i:156;s:16:\"ilpcresourcesgui\";i:157;s:14:\"ilpcsectiongui\";i:158;s:17:\"ilpcsourcecodegui\";i:159;s:16:\"ilpctabledatagui\";i:160;s:12:\"ilpctablegui\";i:161;s:11:\"ilpctabsgui\";i:162;s:17:\"ilinternallinkgui\";i:163;s:19:\"ilobjmediaobjectgui\";i:164;s:16:\"ilpcdatatablegui\";i:165;s:15:\"ilpcfileitemgui\";i:166;s:15:\"ilpcfilelistgui\";i:167;s:11:\"ilpclistgui\";i:168;s:15:\"ilpclistitemgui\";i:169;s:10:\"ilpcmapgui\";i:170;s:18:\"ilpcmediaobjectgui\";i:171;s:16:\"ilpcparagraphgui\";i:172;s:14:\"ilpcpluggedgui\";i:173;s:15:\"ilpcquestiongui\";i:174;s:16:\"ilpcresourcesgui\";i:175;s:14:\"ilpcsectiongui\";i:176;s:17:\"ilpcsourcecodegui\";i:177;s:16:\"ilpctabledatagui\";i:178;s:12:\"ilpctablegui\";i:179;s:11:\"ilpctabsgui\";i:180;s:17:\"ilinternallinkgui\";i:181;s:19:\"ilobjmediaobjectgui\";i:182;s:16:\"ilpcdatatablegui\";i:183;s:15:\"ilpcfileitemgui\";i:184;s:15:\"ilpcfilelistgui\";i:185;s:11:\"ilpclistgui\";i:186;s:15:\"ilpclistitemgui\";i:187;s:10:\"ilpcmapgui\";i:188;s:18:\"ilpcmediaobjectgui\";i:189;s:16:\"ilpcparagraphgui\";i:190;s:14:\"ilpcpluggedgui\";i:191;s:15:\"ilpcquestiongui\";i:192;s:16:\"ilpcresourcesgui\";i:193;s:14:\"ilpcsectiongui\";i:194;s:17:\"ilpcsourcecodegui\";i:195;s:16:\"ilpctabledatagui\";i:196;s:12:\"ilpctablegui\";i:197;s:11:\"ilpctabsgui\";i:198;s:17:\"ilinternallinkgui\";i:199;s:19:\"ilobjmediaobjectgui\";i:200;s:16:\"ilpcdatatablegui\";i:201;s:15:\"ilpcfileitemgui\";i:202;s:15:\"ilpcfilelistgui\";i:203;s:11:\"ilpclistgui\";i:204;s:15:\"ilpclistitemgui\";i:205;s:10:\"ilpcmapgui\";i:206;s:18:\"ilpcmediaobjectgui\";i:207;s:16:\"ilpcparagraphgui\";i:208;s:14:\"ilpcpluggedgui\";i:209;s:15:\"ilpcquestiongui\";i:210;s:16:\"ilpcresourcesgui\";i:211;s:14:\"ilpcsectiongui\";i:212;s:17:\"ilpcsourcecodegui\";i:213;s:16:\"ilpctabledatagui\";i:214;s:12:\"ilpctablegui\";i:215;s:11:\"ilpctabsgui\";i:216;s:17:\"ilinternallinkgui\";i:217;s:19:\"ilobjmediaobjectgui\";i:218;s:16:\"ilpcdatatablegui\";i:219;s:15:\"ilpcfileitemgui\";i:220;s:15:\"ilpcfilelistgui\";i:221;s:11:\"ilpclistgui\";i:222;s:15:\"ilpclistitemgui\";i:223;s:10:\"ilpcmapgui\";i:224;s:18:\"ilpcmediaobjectgui\";i:225;s:16:\"ilpcparagraphgui\";i:226;s:14:\"ilpcpluggedgui\";i:227;s:15:\"ilpcquestiongui\";i:228;s:16:\"ilpcresourcesgui\";i:229;s:14:\"ilpcsectiongui\";i:230;s:17:\"ilpcsourcecodegui\";i:231;s:16:\"ilpctabledatagui\";i:232;s:12:\"ilpctablegui\";i:233;s:11:\"ilpctabsgui\";i:234;s:17:\"ilinternallinkgui\";i:235;s:19:\"ilobjmediaobjectgui\";i:236;s:16:\"ilpcdatatablegui\";i:237;s:15:\"ilpcfileitemgui\";i:238;s:15:\"ilpcfilelistgui\";i:239;s:11:\"ilpclistgui\";i:240;s:15:\"ilpclistitemgui\";i:241;s:10:\"ilpcmapgui\";i:242;s:18:\"ilpcmediaobjectgui\";i:243;s:16:\"ilpcparagraphgui\";i:244;s:14:\"ilpcpluggedgui\";i:245;s:15:\"ilpcquestiongui\";i:246;s:16:\"ilpcresourcesgui\";i:247;s:14:\"ilpcsectiongui\";i:248;s:17:\"ilpcsourcecodegui\";i:249;s:16:\"ilpctabledatagui\";i:250;s:12:\"ilpctablegui\";i:251;s:11:\"ilpctabsgui\";i:252;s:17:\"ilinternallinkgui\";i:253;s:19:\"ilobjmediaobjectgui\";i:254;s:16:\"ilpcdatatablegui\";i:255;s:15:\"ilpcfileitemgui\";i:256;s:15:\"ilpcfilelistgui\";i:257;s:11:\"ilpclistgui\";i:258;s:15:\"ilpclistitemgui\";i:259;s:10:\"ilpcmapgui\";i:260;s:18:\"ilpcmediaobjectgui\";i:261;s:16:\"ilpcparagraphgui\";i:262;s:14:\"ilpcpluggedgui\";i:263;s:15:\"ilpcquestiongui\";i:264;s:16:\"ilpcresourcesgui\";i:265;s:14:\"ilpcsectiongui\";i:266;s:17:\"ilpcsourcecodegui\";i:267;s:16:\"ilpctabledatagui\";i:268;s:12:\"ilpctablegui\";i:269;s:11:\"ilpctabsgui\";i:270;s:17:\"ilinternallinkgui\";i:271;s:19:\"ilobjmediaobjectgui\";i:272;s:16:\"ilpcdatatablegui\";i:273;s:15:\"ilpcfileitemgui\";i:274;s:15:\"ilpcfilelistgui\";i:275;s:11:\"ilpclistgui\";i:276;s:15:\"ilpclistitemgui\";i:277;s:10:\"ilpcmapgui\";i:278;s:18:\"ilpcmediaobjectgui\";i:279;s:16:\"ilpcparagraphgui\";i:280;s:14:\"ilpcpluggedgui\";i:281;s:15:\"ilpcquestiongui\";i:282;s:16:\"ilpcresourcesgui\";i:283;s:14:\"ilpcsectiongui\";i:284;s:17:\"ilpcsourcecodegui\";i:285;s:16:\"ilpctabledatagui\";i:286;s:12:\"ilpctablegui\";i:287;s:11:\"ilpctabsgui\";i:288;s:17:\"ilinternallinkgui\";i:289;s:19:\"ilobjmediaobjectgui\";i:290;s:16:\"ilpcdatatablegui\";i:291;s:15:\"ilpcfileitemgui\";i:292;s:15:\"ilpcfilelistgui\";i:293;s:11:\"ilpclistgui\";i:294;s:15:\"ilpclistitemgui\";i:295;s:10:\"ilpcmapgui\";i:296;s:18:\"ilpcmediaobjectgui\";i:297;s:16:\"ilpcparagraphgui\";i:298;s:14:\"ilpcpluggedgui\";i:299;s:15:\"ilpcquestiongui\";i:300;s:16:\"ilpcresourcesgui\";i:301;s:14:\"ilpcsectiongui\";i:302;s:17:\"ilpcsourcecodegui\";i:303;s:16:\"ilpctabledatagui\";i:304;s:12:\"ilpctablegui\";i:305;s:11:\"ilpctabsgui\";i:306;s:17:\"ilinternallinkgui\";i:307;s:19:\"ilobjmediaobjectgui\";i:308;s:16:\"ilpcdatatablegui\";i:309;s:15:\"ilpcfileitemgui\";i:310;s:15:\"ilpcfilelistgui\";i:311;s:11:\"ilpclistgui\";i:312;s:15:\"ilpclistitemgui\";i:313;s:10:\"ilpcmapgui\";i:314;s:18:\"ilpcmediaobjectgui\";i:315;s:16:\"ilpcparagraphgui\";i:316;s:14:\"ilpcpluggedgui\";i:317;s:15:\"ilpcquestiongui\";i:318;s:16:\"ilpcresourcesgui\";i:319;s:14:\"ilpcsectiongui\";i:320;s:17:\"ilpcsourcecodegui\";i:321;s:16:\"ilpctabledatagui\";i:322;s:12:\"ilpctablegui\";i:323;s:11:\"ilpctabsgui\";i:324;s:17:\"ilinternallinkgui\";i:325;s:19:\"ilobjmediaobjectgui\";i:326;s:16:\"ilpcdatatablegui\";i:327;s:15:\"ilpcfileitemgui\";i:328;s:15:\"ilpcfilelistgui\";i:329;s:11:\"ilpclistgui\";i:330;s:15:\"ilpclistitemgui\";i:331;s:10:\"ilpcmapgui\";i:332;s:18:\"ilpcmediaobjectgui\";i:333;s:16:\"ilpcparagraphgui\";i:334;s:14:\"ilpcpluggedgui\";i:335;s:15:\"ilpcquestiongui\";i:336;s:16:\"ilpcresourcesgui\";i:337;s:14:\"ilpcsectiongui\";i:338;s:17:\"ilpcsourcecodegui\";i:339;s:16:\"ilpctabledatagui\";i:340;s:12:\"ilpctablegui\";i:341;s:11:\"ilpctabsgui\";i:342;s:17:\"ilinternallinkgui\";i:343;s:19:\"ilobjmediaobjectgui\";i:344;s:16:\"ilpcdatatablegui\";i:345;s:15:\"ilpcfileitemgui\";i:346;s:15:\"ilpcfilelistgui\";i:347;s:11:\"ilpclistgui\";i:348;s:15:\"ilpclistitemgui\";i:349;s:10:\"ilpcmapgui\";i:350;s:18:\"ilpcmediaobjectgui\";i:351;s:16:\"ilpcparagraphgui\";i:352;s:14:\"ilpcpluggedgui\";i:353;s:15:\"ilpcquestiongui\";i:354;s:16:\"ilpcresourcesgui\";i:355;s:14:\"ilpcsectiongui\";i:356;s:17:\"ilpcsourcecodegui\";i:357;s:16:\"ilpctabledatagui\";i:358;s:12:\"ilpctablegui\";i:359;s:11:\"ilpctabsgui\";}s:15:\"ilpageobjectgui\";a:76:{i:0;s:18:\"ileditclipboardgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:18:\"ileditclipboardgui\";i:5;s:13:\"ilmdeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:22:\"ilpublicuserprofilegui\";i:8;s:18:\"ileditclipboardgui\";i:9;s:13:\"ilmdeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:13:\"ilmdeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:18:\"ileditclipboardgui\";i:17;s:13:\"ilmdeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:22:\"ilpublicuserprofilegui\";i:20;s:18:\"ileditclipboardgui\";i:21;s:13:\"ilmdeditorgui\";i:22;s:15:\"ilpageeditorgui\";i:23;s:22:\"ilpublicuserprofilegui\";i:24;s:18:\"ileditclipboardgui\";i:25;s:13:\"ilmdeditorgui\";i:26;s:15:\"ilpageeditorgui\";i:27;s:22:\"ilpublicuserprofilegui\";i:28;s:18:\"ileditclipboardgui\";i:29;s:13:\"ilmdeditorgui\";i:30;s:15:\"ilpageeditorgui\";i:31;s:22:\"ilpublicuserprofilegui\";i:32;s:18:\"ileditclipboardgui\";i:33;s:13:\"ilmdeditorgui\";i:34;s:15:\"ilpageeditorgui\";i:35;s:22:\"ilpublicuserprofilegui\";i:36;s:18:\"ileditclipboardgui\";i:37;s:13:\"ilmdeditorgui\";i:38;s:15:\"ilpageeditorgui\";i:39;s:22:\"ilpublicuserprofilegui\";i:40;s:18:\"ileditclipboardgui\";i:41;s:13:\"ilmdeditorgui\";i:42;s:15:\"ilpageeditorgui\";i:43;s:22:\"ilpublicuserprofilegui\";i:44;s:18:\"ileditclipboardgui\";i:45;s:13:\"ilmdeditorgui\";i:46;s:15:\"ilpageeditorgui\";i:47;s:22:\"ilpublicuserprofilegui\";i:48;s:18:\"ileditclipboardgui\";i:49;s:13:\"ilmdeditorgui\";i:50;s:15:\"ilpageeditorgui\";i:51;s:22:\"ilpublicuserprofilegui\";i:52;s:18:\"ileditclipboardgui\";i:53;s:13:\"ilmdeditorgui\";i:54;s:15:\"ilpageeditorgui\";i:55;s:22:\"ilpublicuserprofilegui\";i:56;s:18:\"ileditclipboardgui\";i:57;s:13:\"ilmdeditorgui\";i:58;s:15:\"ilpageeditorgui\";i:59;s:22:\"ilpublicuserprofilegui\";i:60;s:18:\"ileditclipboardgui\";i:61;s:13:\"ilmdeditorgui\";i:62;s:15:\"ilpageeditorgui\";i:63;s:22:\"ilpublicuserprofilegui\";i:64;s:18:\"ileditclipboardgui\";i:65;s:13:\"ilmdeditorgui\";i:66;s:15:\"ilpageeditorgui\";i:67;s:22:\"ilpublicuserprofilegui\";i:68;s:18:\"ileditclipboardgui\";i:69;s:13:\"ilmdeditorgui\";i:70;s:15:\"ilpageeditorgui\";i:71;s:22:\"ilpublicuserprofilegui\";i:72;s:18:\"ileditclipboardgui\";i:73;s:13:\"ilmdeditorgui\";i:74;s:15:\"ilpageeditorgui\";i:75;s:22:\"ilpublicuserprofilegui\";}s:16:\"ilobjcategorygui\";a:7:{i:0;s:11:\"ilcolumngui\";i:1;s:22:\"ilcontainerlinklistgui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:18:\"ilobjuserfoldergui\";i:4;s:12:\"ilobjusergui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpermissiongui\";}s:25:\"ilobjcategoryreferencegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:12:\"ilobjchatgui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";i:2;s:22:\"ilpublicuserprofilegui\";}s:18:\"ilobjchatservergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:25:\"ilobjcomponentsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:20:\"ilcourseagreementgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:32:\"ilcourseobjectivepresentationgui\";a:5:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";i:3;s:0:\"\";i:4;s:0:\"\";}s:18:\"ilcoursecontentgui\";a:15:{i:0;s:11:\"ilcolumngui\";i:1;s:19:\"ilcoursearchivesgui\";i:2;s:32:\"ilcourseobjectivepresentationgui\";i:3;s:11:\"ilcolumngui\";i:4;s:19:\"ilcoursearchivesgui\";i:5;s:32:\"ilcourseobjectivepresentationgui\";i:6;s:11:\"ilcolumngui\";i:7;s:19:\"ilcoursearchivesgui\";i:8;s:32:\"ilcourseobjectivepresentationgui\";i:9;s:11:\"ilcolumngui\";i:10;s:19:\"ilcoursearchivesgui\";i:11;s:32:\"ilcourseobjectivepresentationgui\";i:12;s:11:\"ilcolumngui\";i:13;s:19:\"ilcoursearchivesgui\";i:14;s:32:\"ilcourseobjectivepresentationgui\";}s:29:\"ilcourseitemadministrationgui\";a:5:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:27:\"ilconditionhandlerinterface\";i:4;s:27:\"ilconditionhandlerinterface\";}s:23:\"ilcourseregistrationgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:17:\"ilmemberexportgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:17:\"ilshoppurchasegui\";a:5:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";}s:14:\"ilobjcoursegui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:20:\"ilcourseagreementgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:29:\"ilcourseitemadministrationgui\";i:5;s:21:\"ilcourseobjectivesgui\";i:6;s:23:\"ilcourseregistrationgui\";i:7;s:21:\"ilcourseuserfieldsgui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:21:\"illearningprogressgui\";i:10;s:13:\"ilmdeditorgui\";i:11;s:17:\"ilmemberexportgui\";i:12;s:22:\"ilobjcoursegroupinggui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpermissiongui\";i:15;s:22:\"ilpublicuserprofilegui\";i:16;s:21:\"ilrepositorysearchgui\";i:17;s:20:\"ilsessionoverviewgui\";i:18;s:17:\"ilshoppurchasegui\";i:19;s:11:\"ilcolumngui\";i:20;s:27:\"ilconditionhandlerinterface\";i:21;s:20:\"ilcourseagreementgui\";i:22;s:18:\"ilcoursecontentgui\";i:23;s:29:\"ilcourseitemadministrationgui\";i:24;s:21:\"ilcourseobjectivesgui\";i:25;s:23:\"ilcourseregistrationgui\";i:26;s:21:\"ilcourseuserfieldsgui\";i:27;s:15:\"ilinfoscreengui\";i:28;s:21:\"illearningprogressgui\";i:29;s:13:\"ilmdeditorgui\";i:30;s:17:\"ilmemberexportgui\";i:31;s:22:\"ilobjcoursegroupinggui\";i:32;s:15:\"ilpageobjectgui\";i:33;s:15:\"ilpermissiongui\";i:34;s:22:\"ilpublicuserprofilegui\";i:35;s:21:\"ilrepositorysearchgui\";i:36;s:20:\"ilsessionoverviewgui\";i:37;s:17:\"ilshoppurchasegui\";}s:23:\"ilobjcoursereferencegui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";}s:18:\"ilobjstylesheetgui\";a:3:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:0:\"\";}s:20:\"ilstructureobjectgui\";a:4:{i:0;s:27:\"ilconditionhandlerinterface\";i:1;s:13:\"ilmdeditorgui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:13:\"ilmdeditorgui\";}s:14:\"ilobjdlbookgui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:17:\"illmpageobjectgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:18:\"ilobjstylesheetgui\";i:5;s:15:\"ilpermissiongui\";i:6;s:20:\"ilstructureobjectgui\";}s:16:\"ilobjexercisegui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilrepositorysearchgui\";}s:20:\"ilobjexternalfeedgui\";a:2:{i:0;s:22:\"ilexternalfeedblockgui\";i:1;s:15:\"ilpermissiongui\";}s:16:\"ilecssettingsgui\";a:1:{i:0;s:0:\"\";}s:29:\"ilobjexternaltoolssettingsgui\";a:2:{i:0;s:16:\"ilecssettingsgui\";i:1;s:15:\"ilpermissiongui\";}s:26:\"ilobjfileaccesssettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:19:\"ilobjfilebasedlmgui\";a:6:{i:0;s:15:\"ilfilesystemgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:21:\"illearningprogressgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:15:\"ilpermissiongui\";i:5;s:17:\"ilshoppurchasegui\";}s:12:\"ilobjfilegui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:17:\"ilshoppurchasegui\";}s:14:\"ilobjfoldergui\";a:16:{i:0;s:11:\"ilcolumngui\";i:1;s:27:\"ilconditionhandlerinterface\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:29:\"ilcourseitemadministrationgui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:21:\"illearningprogressgui\";i:6;s:15:\"ilpageobjectgui\";i:7;s:15:\"ilpermissiongui\";i:8;s:11:\"ilcolumngui\";i:9;s:27:\"ilconditionhandlerinterface\";i:10;s:18:\"ilcoursecontentgui\";i:11;s:29:\"ilcourseitemadministrationgui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:21:\"illearningprogressgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:15:\"ilpermissiongui\";}s:13:\"ilobjforumgui\";a:5:{i:0;s:11:\"ilcolumngui\";i:1;s:16:\"ilforumexportgui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilpermissiongui\";i:4;s:22:\"ilpublicuserprofilegui\";}s:25:\"iltermdefinitioneditorgui\";a:2:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpageobjectgui\";}s:17:\"ilglossarytermgui\";a:2:{i:0;s:15:\"ilpageobjectgui\";i:1;s:25:\"iltermdefinitioneditorgui\";}s:16:\"ilobjglossarygui\";a:4:{i:0;s:17:\"ilglossarytermgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:15:\"ilpermissiongui\";}s:13:\"ilobjgroupgui\";a:13:{i:0;s:0:\"\";i:1;s:11:\"ilcolumngui\";i:2;s:27:\"ilconditionhandlerinterface\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:29:\"ilcourseitemadministrationgui\";i:5;s:22:\"ilgroupregistrationgui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:21:\"illearningprogressgui\";i:8;s:22:\"ilobjcoursegroupinggui\";i:9;s:15:\"ilpageobjectgui\";i:10;s:15:\"ilpermissiongui\";i:11;s:22:\"ilpublicuserprofilegui\";i:12;s:21:\"ilrepositorysearchgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:0:\"\";i:1;s:0:\"\";}s:19:\"ilobjilinccoursegui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:22:\"ilobjilincclassroomgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:22:\"ilpublicuserprofilegui\";i:4;s:21:\"ilrepositorysearchgui\";}s:19:\"ilobjlanguageextgui\";a:1:{i:0;s:0:\"\";}s:22:\"ilobjlanguagefoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:22:\"ilobjlearningmodulegui\";a:7:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:17:\"illmpageobjectgui\";i:3;s:13:\"ilmdeditorgui\";i:4;s:18:\"ilobjstylesheetgui\";i:5;s:15:\"ilpermissiongui\";i:6;s:20:\"ilstructureobjectgui\";}s:20:\"ilobjlinkresourcegui\";a:3:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:12:\"ilobjmailgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:23:\"iladvancedmdsettingsgui\";a:1:{i:0;s:0:\"\";}s:18:\"ilobjmdsettingsgui\";a:2:{i:0;s:23:\"iladvancedmdsettingsgui\";i:1;s:15:\"ilpermissiongui\";}s:17:\"ilobjmediacastgui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:25:\"ilobjmediacastsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:17:\"ilobjmediapoolgui\";a:5:{i:0;s:18:\"ileditclipboardgui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:14:\"ilobjfoldergui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:15:\"ilpermissiongui\";}s:20:\"ilobjnewssettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:20:\"ilobjobjectfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:23:\"ilobjpaymentsettingsgui\";a:3:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpermissiongui\";i:2;s:15:\"ilshoptopicsgui\";}s:31:\"ilobjpersonaldesktopsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:23:\"ilobjprivacysecuritygui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:20:\"ilobjquestionpoolgui\";a:14:{i:0;s:15:\"assclozetestgui\";i:1;s:22:\"assimagemapquestiongui\";i:2;s:16:\"assjavaappletgui\";i:3;s:22:\"assmatchingquestiongui\";i:4;s:20:\"assmultiplechoicegui\";i:5;s:13:\"assnumericgui\";i:6;s:22:\"assorderingquestiongui\";i:7;s:26:\"assquestiontypetemplategui\";i:8;s:18:\"asssinglechoicegui\";i:9;s:18:\"asstextquestiongui\";i:10;s:16:\"asstextsubsetgui\";i:11;s:13:\"ilmdeditorgui\";i:12;s:15:\"ilpageobjectgui\";i:13;s:15:\"ilpermissiongui\";}s:22:\"ilobjrecoveryfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:18:\"ilobjrolefoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:20:\"ilobjroletemplategui\";a:1:{i:0;s:0:\"\";}s:18:\"ilobjrootfoldergui\";a:4:{i:0;s:11:\"ilcolumngui\";i:1;s:22:\"ilcontainerlinklistgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpermissiongui\";}s:26:\"ilobjsahslearningmodulegui\";a:3:{i:0;s:15:\"ilfilesystemgui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";}s:22:\"ilobjsearchsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:15:\"ilobjsessiongui\";a:2:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";}s:21:\"ilobjstylesettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:28:\"ilobjsurveyadministrationgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:14:\"ilobjsurveygui\";a:5:{i:0;s:15:\"ilinfoscreengui\";i:1;s:13:\"ilmdeditorgui\";i:2;s:15:\"ilpermissiongui\";i:3;s:21:\"ilsurveyevaluationgui\";i:4;s:20:\"ilsurveyexecutiongui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:8:{i:0;s:13:\"ilmdeditorgui\";i:1;s:15:\"ilpermissiongui\";i:2;s:18:\"ilsurveyphrasesgui\";i:3;s:23:\"surveymatrixquestiongui\";i:4;s:23:\"surveymetricquestiongui\";i:5;s:24:\"surveynominalquestiongui\";i:6;s:24:\"surveyordinalquestiongui\";i:7;s:21:\"surveytextquestiongui\";}s:20:\"ilobjsystemfoldergui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:23:\"ilobjtaggingsettingsgui\";a:1:{i:0;s:15:\"ilpermissiongui\";}s:12:\"ilobjtestgui\";a:11:{i:0;s:15:\"ilinfoscreengui\";i:1;s:21:\"illearningprogressgui\";i:2;s:13:\"ilmdeditorgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:15:\"ilpermissiongui\";i:5;s:17:\"ilshoppurchasegui\";i:6;s:20:\"iltestcertificategui\";i:7;s:19:\"iltestevaluationgui\";i:8;s:15:\"iltestoutputgui\";i:9;s:16:\"iltestscoringgui\";i:10;s:16:\"iltestservicegui\";}s:20:\"ilobjusertrackinggui\";a:2:{i:0;s:21:\"illearningprogressgui\";i:1;s:15:\"ilpermissiongui\";}s:13:\"ilwikipagegui\";a:7:{i:0;s:18:\"ileditclipboardgui\";i:1;s:25:\"ilmediapooltargetselector\";i:2;s:9:\"ilnotegui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:22:\"ilpublicuserprofilegui\";i:6;s:11:\"ilratinggui\";}s:12:\"ilobjwikigui\";a:4:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilpermissiongui\";i:2;s:22:\"ilpublicuserprofilegui\";i:3;s:13:\"ilwikipagegui\";}s:19:\"iladministrationgui\";a:61:{i:0;s:21:\"ilcourseobjectivesgui\";i:1;s:23:\"ilobjadvancededitinggui\";i:2;s:24:\"ilobjassessmentfoldergui\";i:3;s:20:\"ilobjauthsettingsgui\";i:4;s:24:\"ilobjcalendarsettingsgui\";i:5;s:16:\"ilobjcategorygui\";i:6;s:25:\"ilobjcategoryreferencegui\";i:7;s:12:\"ilobjchatgui\";i:8;s:18:\"ilobjchatservergui\";i:9;s:25:\"ilobjcomponentsettingsgui\";i:10;s:14:\"ilobjcoursegui\";i:11;s:23:\"ilobjcoursereferencegui\";i:12;s:14:\"ilobjdlbookgui\";i:13;s:16:\"ilobjexercisegui\";i:14;s:20:\"ilobjexternalfeedgui\";i:15;s:29:\"ilobjexternaltoolssettingsgui\";i:16;s:26:\"ilobjfileaccesssettingsgui\";i:17;s:19:\"ilobjfilebasedlmgui\";i:18;s:12:\"ilobjfilegui\";i:19;s:14:\"ilobjfoldergui\";i:20;s:13:\"ilobjforumgui\";i:21;s:16:\"ilobjglossarygui\";i:22;s:13:\"ilobjgroupgui\";i:23;s:22:\"ilobjilincclassroomgui\";i:24;s:19:\"ilobjilinccoursegui\";i:25;s:19:\"ilobjlanguageextgui\";i:26;s:22:\"ilobjlanguagefoldergui\";i:27;s:22:\"ilobjlearningmodulegui\";i:28;s:20:\"ilobjlinkresourcegui\";i:29;s:12:\"ilobjmailgui\";i:30;s:18:\"ilobjmdsettingsgui\";i:31;s:17:\"ilobjmediacastgui\";i:32;s:25:\"ilobjmediacastsettingsgui\";i:33;s:17:\"ilobjmediapoolgui\";i:34;s:20:\"ilobjnewssettingsgui\";i:35;s:20:\"ilobjobjectfoldergui\";i:36;s:23:\"ilobjpaymentsettingsgui\";i:37;s:31:\"ilobjpersonaldesktopsettingsgui\";i:38;s:23:\"ilobjprivacysecuritygui\";i:39;s:20:\"ilobjquestionpoolgui\";i:40;s:22:\"ilobjrecoveryfoldergui\";i:41;s:18:\"ilobjrolefoldergui\";i:42;s:12:\"ilobjrolegui\";i:43;s:20:\"ilobjroletemplategui\";i:44;s:18:\"ilobjrootfoldergui\";i:45;s:26:\"ilobjsahslearningmodulegui\";i:46;s:22:\"ilobjsearchsettingsgui\";i:47;s:15:\"ilobjsessiongui\";i:48;s:21:\"ilobjstylesettingsgui\";i:49;s:18:\"ilobjstylesheetgui\";i:50;s:28:\"ilobjsurveyadministrationgui\";i:51;s:14:\"ilobjsurveygui\";i:52;s:26:\"ilobjsurveyquestionpoolgui\";i:53;s:20:\"ilobjsystemfoldergui\";i:54;s:23:\"ilobjtaggingsettingsgui\";i:55;s:12:\"ilobjtestgui\";i:56;s:18:\"ilobjuserfoldergui\";i:57;s:12:\"ilobjusergui\";i:58;s:20:\"ilobjusertrackinggui\";i:59;s:12:\"ilobjwikigui\";i:60;s:15:\"ilpermissiongui\";}}','a:177:{s:0:\"\";a:2015:{i:0;s:0:\"\";i:1;s:0:\"\";i:2;s:12:\"ilobjrolegui\";i:3;s:0:\"\";i:4;s:12:\"ilobjrolegui\";i:5;s:0:\"\";i:6;s:17:\"illdapsettingsgui\";i:7;s:0:\"\";i:8;s:12:\"ilobjrolegui\";i:9;s:0:\"\";i:10;s:0:\"\";i:11;s:25:\"ilregistrationsettingsgui\";i:12;s:0:\"\";i:13;s:12:\"ilobjrolegui\";i:14;s:0:\"\";i:15;s:0:\"\";i:16;s:0:\"\";i:17;s:0:\"\";i:18;s:0:\"\";i:19;s:0:\"\";i:20;s:0:\"\";i:21;s:0:\"\";i:22;s:0:\"\";i:23;s:0:\"\";i:24;s:0:\"\";i:25;s:0:\"\";i:26;s:0:\"\";i:27;s:0:\"\";i:28;s:0:\"\";i:29;s:0:\"\";i:30;s:0:\"\";i:31;s:0:\"\";i:32;s:0:\"\";i:33;s:0:\"\";i:34;s:0:\"\";i:35;s:0:\"\";i:36;s:0:\"\";i:37;s:0:\"\";i:38;s:0:\"\";i:39;s:11:\"ilcolumngui\";i:40;s:0:\"\";i:41;s:22:\"ilcontainerlinklistgui\";i:42;s:0:\"\";i:43;s:0:\"\";i:44;s:0:\"\";i:45;s:0:\"\";i:46;s:0:\"\";i:47;s:0:\"\";i:48;s:0:\"\";i:49;s:0:\"\";i:50;s:0:\"\";i:51;s:0:\"\";i:52;s:0:\"\";i:53;s:0:\"\";i:54;s:0:\"\";i:55;s:0:\"\";i:56;s:0:\"\";i:57;s:0:\"\";i:58;s:0:\"\";i:59;s:0:\"\";i:60;s:0:\"\";i:61;s:0:\"\";i:62;s:0:\"\";i:63;s:0:\"\";i:64;s:0:\"\";i:65;s:0:\"\";i:66;s:0:\"\";i:67;s:11:\"ilcolumngui\";i:68;s:0:\"\";i:69;s:13:\"ilfeedbackgui\";i:70;s:0:\"\";i:71;s:0:\"\";i:72;s:0:\"\";i:73;s:0:\"\";i:74;s:13:\"illpfiltergui\";i:75;s:0:\"\";i:76;s:17:\"ilpdfpresentation\";i:77;s:0:\"\";i:78;s:15:\"iluserfiltergui\";i:79;s:0:\"\";i:80;s:13:\"illpfiltergui\";i:81;s:0:\"\";i:82;s:17:\"ilpdfpresentation\";i:83;s:0:\"\";i:84;s:21:\"illplistofsettingsgui\";i:85;s:0:\"\";i:86;s:0:\"\";i:87;s:12:\"ilobjrolegui\";i:88;s:0:\"\";i:89;s:0:\"\";i:90;s:13:\"illpfiltergui\";i:91;s:0:\"\";i:92;s:17:\"ilpdfpresentation\";i:93;s:0:\"\";i:94;s:15:\"iluserfiltergui\";i:95;s:0:\"\";i:96;s:13:\"illpfiltergui\";i:97;s:0:\"\";i:98;s:17:\"ilpdfpresentation\";i:99;s:0:\"\";i:100;s:21:\"illplistofsettingsgui\";i:101;s:0:\"\";i:102;s:0:\"\";i:103;s:0:\"\";i:104;s:0:\"\";i:105;s:0:\"\";i:106;s:0:\"\";i:107;s:0:\"\";i:108;s:0:\"\";i:109;s:0:\"\";i:110;s:0:\"\";i:111;s:0:\"\";i:112;s:0:\"\";i:113;s:0:\"\";i:114;s:0:\"\";i:115;s:0:\"\";i:116;s:0:\"\";i:117;s:0:\"\";i:118;s:0:\"\";i:119;s:0:\"\";i:120;s:0:\"\";i:121;s:0:\"\";i:122;s:0:\"\";i:123;s:0:\"\";i:124;s:0:\"\";i:125;s:0:\"\";i:126;s:0:\"\";i:127;s:0:\"\";i:128;s:12:\"ilobjrolegui\";i:129;s:0:\"\";i:130;s:0:\"\";i:131;s:0:\"\";i:132;s:0:\"\";i:133;s:0:\"\";i:134;s:0:\"\";i:135;s:0:\"\";i:136;s:0:\"\";i:137;s:0:\"\";i:138;s:0:\"\";i:139;s:0:\"\";i:140;s:0:\"\";i:141;s:0:\"\";i:142;s:0:\"\";i:143;s:0:\"\";i:144;s:0:\"\";i:145;s:0:\"\";i:146;s:0:\"\";i:147;s:0:\"\";i:148;s:0:\"\";i:149;s:0:\"\";i:150;s:0:\"\";i:151;s:0:\"\";i:152;s:0:\"\";i:153;s:0:\"\";i:154;s:11:\"ilcolumngui\";i:155;s:0:\"\";i:156;s:13:\"ilfeedbackgui\";i:157;s:0:\"\";i:158;s:0:\"\";i:159;s:0:\"\";i:160;s:12:\"ilobjrolegui\";i:161;s:0:\"\";i:162;s:0:\"\";i:163;s:0:\"\";i:164;s:0:\"\";i:165;s:0:\"\";i:166;s:0:\"\";i:167;s:0:\"\";i:168;s:0:\"\";i:169;s:0:\"\";i:170;s:0:\"\";i:171;s:0:\"\";i:172;s:0:\"\";i:173;s:0:\"\";i:174;s:0:\"\";i:175;s:0:\"\";i:176;s:0:\"\";i:177;s:0:\"\";i:178;s:0:\"\";i:179;s:0:\"\";i:180;s:0:\"\";i:181;s:0:\"\";i:182;s:0:\"\";i:183;s:0:\"\";i:184;s:0:\"\";i:185;s:0:\"\";i:186;s:11:\"ilcolumngui\";i:187;s:0:\"\";i:188;s:13:\"ilfeedbackgui\";i:189;s:0:\"\";i:190;s:0:\"\";i:191;s:0:\"\";i:192;s:12:\"ilobjrolegui\";i:193;s:0:\"\";i:194;s:0:\"\";i:195;s:12:\"ilobjrolegui\";i:196;s:0:\"\";i:197;s:12:\"ilobjrolegui\";i:198;s:0:\"\";i:199;s:0:\"\";i:200;s:0:\"\";i:201;s:0:\"\";i:202;s:0:\"\";i:203;s:0:\"\";i:204;s:0:\"\";i:205;s:0:\"\";i:206;s:0:\"\";i:207;s:0:\"\";i:208;s:0:\"\";i:209;s:0:\"\";i:210;s:0:\"\";i:211;s:0:\"\";i:212;s:0:\"\";i:213;s:0:\"\";i:214;s:0:\"\";i:215;s:0:\"\";i:216;s:0:\"\";i:217;s:0:\"\";i:218;s:0:\"\";i:219;s:0:\"\";i:220;s:0:\"\";i:221;s:0:\"\";i:222;s:0:\"\";i:223;s:11:\"ilcolumngui\";i:224;s:0:\"\";i:225;s:0:\"\";i:226;s:20:\"ilcourseagreementgui\";i:227;s:0:\"\";i:228;s:0:\"\";i:229;s:0:\"\";i:230;s:0:\"\";i:231;s:0:\"\";i:232;s:0:\"\";i:233;s:0:\"\";i:234;s:0:\"\";i:235;s:0:\"\";i:236;s:0:\"\";i:237;s:0:\"\";i:238;s:0:\"\";i:239;s:0:\"\";i:240;s:0:\"\";i:241;s:0:\"\";i:242;s:0:\"\";i:243;s:0:\"\";i:244;s:0:\"\";i:245;s:0:\"\";i:246;s:0:\"\";i:247;s:0:\"\";i:248;s:0:\"\";i:249;s:0:\"\";i:250;s:0:\"\";i:251;s:0:\"\";i:252;s:11:\"ilcolumngui\";i:253;s:0:\"\";i:254;s:0:\"\";i:255;s:32:\"ilcourseobjectivepresentationgui\";i:256;s:0:\"\";i:257;s:0:\"\";i:258;s:0:\"\";i:259;s:23:\"ilcourseregistrationgui\";i:260;s:0:\"\";i:261;s:0:\"\";i:262;s:0:\"\";i:263;s:0:\"\";i:264;s:0:\"\";i:265;s:0:\"\";i:266;s:0:\"\";i:267;s:0:\"\";i:268;s:0:\"\";i:269;s:0:\"\";i:270;s:0:\"\";i:271;s:0:\"\";i:272;s:0:\"\";i:273;s:0:\"\";i:274;s:0:\"\";i:275;s:0:\"\";i:276;s:0:\"\";i:277;s:0:\"\";i:278;s:0:\"\";i:279;s:0:\"\";i:280;s:0:\"\";i:281;s:0:\"\";i:282;s:0:\"\";i:283;s:0:\"\";i:284;s:0:\"\";i:285;s:0:\"\";i:286;s:11:\"ilcolumngui\";i:287;s:0:\"\";i:288;s:13:\"ilfeedbackgui\";i:289;s:0:\"\";i:290;s:0:\"\";i:291;s:0:\"\";i:292;s:0:\"\";i:293;s:13:\"illpfiltergui\";i:294;s:0:\"\";i:295;s:17:\"ilpdfpresentation\";i:296;s:0:\"\";i:297;s:15:\"iluserfiltergui\";i:298;s:0:\"\";i:299;s:13:\"illpfiltergui\";i:300;s:0:\"\";i:301;s:17:\"ilpdfpresentation\";i:302;s:0:\"\";i:303;s:21:\"illplistofsettingsgui\";i:304;s:0:\"\";i:305;s:0:\"\";i:306;s:17:\"ilmemberexportgui\";i:307;s:0:\"\";i:308;s:0:\"\";i:309;s:0:\"\";i:310;s:0:\"\";i:311;s:0:\"\";i:312;s:0:\"\";i:313;s:0:\"\";i:314;s:0:\"\";i:315;s:0:\"\";i:316;s:0:\"\";i:317;s:0:\"\";i:318;s:0:\"\";i:319;s:0:\"\";i:320;s:0:\"\";i:321;s:0:\"\";i:322;s:0:\"\";i:323;s:0:\"\";i:324;s:0:\"\";i:325;s:0:\"\";i:326;s:0:\"\";i:327;s:0:\"\";i:328;s:0:\"\";i:329;s:0:\"\";i:330;s:0:\"\";i:331;s:0:\"\";i:332;s:0:\"\";i:333;s:0:\"\";i:334;s:12:\"ilobjrolegui\";i:335;s:0:\"\";i:336;s:0:\"\";i:337;s:0:\"\";i:338;s:0:\"\";i:339;s:0:\"\";i:340;s:0:\"\";i:341;s:0:\"\";i:342;s:0:\"\";i:343;s:0:\"\";i:344;s:0:\"\";i:345;s:0:\"\";i:346;s:0:\"\";i:347;s:0:\"\";i:348;s:0:\"\";i:349;s:0:\"\";i:350;s:0:\"\";i:351;s:0:\"\";i:352;s:0:\"\";i:353;s:0:\"\";i:354;s:0:\"\";i:355;s:0:\"\";i:356;s:0:\"\";i:357;s:0:\"\";i:358;s:0:\"\";i:359;s:0:\"\";i:360;s:0:\"\";i:361;s:0:\"\";i:362;s:0:\"\";i:363;s:0:\"\";i:364;s:0:\"\";i:365;s:0:\"\";i:366;s:0:\"\";i:367;s:0:\"\";i:368;s:0:\"\";i:369;s:0:\"\";i:370;s:0:\"\";i:371;s:0:\"\";i:372;s:0:\"\";i:373;s:0:\"\";i:374;s:0:\"\";i:375;s:0:\"\";i:376;s:0:\"\";i:377;s:0:\"\";i:378;s:0:\"\";i:379;s:0:\"\";i:380;s:0:\"\";i:381;s:0:\"\";i:382;s:0:\"\";i:383;s:0:\"\";i:384;s:0:\"\";i:385;s:0:\"\";i:386;s:0:\"\";i:387;s:0:\"\";i:388;s:11:\"ilcolumngui\";i:389;s:0:\"\";i:390;s:13:\"ilfeedbackgui\";i:391;s:0:\"\";i:392;s:0:\"\";i:393;s:0:\"\";i:394;s:12:\"ilobjrolegui\";i:395;s:0:\"\";i:396;s:0:\"\";i:397;s:0:\"\";i:398;s:0:\"\";i:399;s:0:\"\";i:400;s:0:\"\";i:401;s:0:\"\";i:402;s:0:\"\";i:403;s:0:\"\";i:404;s:0:\"\";i:405;s:0:\"\";i:406;s:0:\"\";i:407;s:0:\"\";i:408;s:0:\"\";i:409;s:0:\"\";i:410;s:0:\"\";i:411;s:0:\"\";i:412;s:0:\"\";i:413;s:0:\"\";i:414;s:0:\"\";i:415;s:0:\"\";i:416;s:0:\"\";i:417;s:0:\"\";i:418;s:0:\"\";i:419;s:0:\"\";i:420;s:11:\"ilcolumngui\";i:421;s:0:\"\";i:422;s:13:\"ilfeedbackgui\";i:423;s:0:\"\";i:424;s:0:\"\";i:425;s:0:\"\";i:426;s:0:\"\";i:427;s:13:\"illpfiltergui\";i:428;s:0:\"\";i:429;s:17:\"ilpdfpresentation\";i:430;s:0:\"\";i:431;s:15:\"iluserfiltergui\";i:432;s:0:\"\";i:433;s:13:\"illpfiltergui\";i:434;s:0:\"\";i:435;s:17:\"ilpdfpresentation\";i:436;s:0:\"\";i:437;s:21:\"illplistofsettingsgui\";i:438;s:0:\"\";i:439;s:0:\"\";i:440;s:0:\"\";i:441;s:0:\"\";i:442;s:0:\"\";i:443;s:0:\"\";i:444;s:0:\"\";i:445;s:0:\"\";i:446;s:0:\"\";i:447;s:0:\"\";i:448;s:0:\"\";i:449;s:0:\"\";i:450;s:0:\"\";i:451;s:0:\"\";i:452;s:0:\"\";i:453;s:0:\"\";i:454;s:0:\"\";i:455;s:0:\"\";i:456;s:0:\"\";i:457;s:0:\"\";i:458;s:0:\"\";i:459;s:0:\"\";i:460;s:0:\"\";i:461;s:0:\"\";i:462;s:0:\"\";i:463;s:0:\"\";i:464;s:0:\"\";i:465;s:18:\"ilobjstylesheetgui\";i:466;s:0:\"\";i:467;s:12:\"ilobjrolegui\";i:468;s:0:\"\";i:469;s:0:\"\";i:470;s:0:\"\";i:471;s:0:\"\";i:472;s:0:\"\";i:473;s:0:\"\";i:474;s:0:\"\";i:475;s:0:\"\";i:476;s:0:\"\";i:477;s:0:\"\";i:478;s:0:\"\";i:479;s:0:\"\";i:480;s:0:\"\";i:481;s:0:\"\";i:482;s:0:\"\";i:483;s:0:\"\";i:484;s:0:\"\";i:485;s:0:\"\";i:486;s:0:\"\";i:487;s:0:\"\";i:488;s:0:\"\";i:489;s:0:\"\";i:490;s:0:\"\";i:491;s:0:\"\";i:492;s:0:\"\";i:493;s:0:\"\";i:494;s:0:\"\";i:495;s:11:\"ilcolumngui\";i:496;s:0:\"\";i:497;s:13:\"ilfeedbackgui\";i:498;s:0:\"\";i:499;s:0:\"\";i:500;s:0:\"\";i:501;s:0:\"\";i:502;s:13:\"illpfiltergui\";i:503;s:0:\"\";i:504;s:17:\"ilpdfpresentation\";i:505;s:0:\"\";i:506;s:15:\"iluserfiltergui\";i:507;s:0:\"\";i:508;s:13:\"illpfiltergui\";i:509;s:0:\"\";i:510;s:17:\"ilpdfpresentation\";i:511;s:0:\"\";i:512;s:21:\"illplistofsettingsgui\";i:513;s:0:\"\";i:514;s:12:\"ilobjrolegui\";i:515;s:0:\"\";i:516;s:0:\"\";i:517;s:0:\"\";i:518;s:12:\"ilobjrolegui\";i:519;s:0:\"\";i:520;s:16:\"ilecssettingsgui\";i:521;s:0:\"\";i:522;s:12:\"ilobjrolegui\";i:523;s:0:\"\";i:524;s:12:\"ilobjrolegui\";i:525;s:0:\"\";i:526;s:0:\"\";i:527;s:0:\"\";i:528;s:0:\"\";i:529;s:0:\"\";i:530;s:0:\"\";i:531;s:0:\"\";i:532;s:0:\"\";i:533;s:0:\"\";i:534;s:0:\"\";i:535;s:0:\"\";i:536;s:0:\"\";i:537;s:0:\"\";i:538;s:0:\"\";i:539;s:0:\"\";i:540;s:0:\"\";i:541;s:0:\"\";i:542;s:0:\"\";i:543;s:0:\"\";i:544;s:0:\"\";i:545;s:0:\"\";i:546;s:0:\"\";i:547;s:0:\"\";i:548;s:0:\"\";i:549;s:0:\"\";i:550;s:0:\"\";i:551;s:11:\"ilcolumngui\";i:552;s:0:\"\";i:553;s:13:\"ilfeedbackgui\";i:554;s:0:\"\";i:555;s:0:\"\";i:556;s:0:\"\";i:557;s:0:\"\";i:558;s:13:\"illpfiltergui\";i:559;s:0:\"\";i:560;s:17:\"ilpdfpresentation\";i:561;s:0:\"\";i:562;s:15:\"iluserfiltergui\";i:563;s:0:\"\";i:564;s:13:\"illpfiltergui\";i:565;s:0:\"\";i:566;s:17:\"ilpdfpresentation\";i:567;s:0:\"\";i:568;s:21:\"illplistofsettingsgui\";i:569;s:0:\"\";i:570;s:0:\"\";i:571;s:12:\"ilobjrolegui\";i:572;s:0:\"\";i:573;s:0:\"\";i:574;s:0:\"\";i:575;s:0:\"\";i:576;s:0:\"\";i:577;s:0:\"\";i:578;s:0:\"\";i:579;s:0:\"\";i:580;s:0:\"\";i:581;s:0:\"\";i:582;s:0:\"\";i:583;s:0:\"\";i:584;s:0:\"\";i:585;s:0:\"\";i:586;s:0:\"\";i:587;s:0:\"\";i:588;s:0:\"\";i:589;s:0:\"\";i:590;s:0:\"\";i:591;s:0:\"\";i:592;s:0:\"\";i:593;s:0:\"\";i:594;s:0:\"\";i:595;s:0:\"\";i:596;s:0:\"\";i:597;s:0:\"\";i:598;s:0:\"\";i:599;s:0:\"\";i:600;s:0:\"\";i:601;s:0:\"\";i:602;s:0:\"\";i:603;s:0:\"\";i:604;s:0:\"\";i:605;s:0:\"\";i:606;s:0:\"\";i:607;s:0:\"\";i:608;s:0:\"\";i:609;s:0:\"\";i:610;s:0:\"\";i:611;s:0:\"\";i:612;s:0:\"\";i:613;s:0:\"\";i:614;s:0:\"\";i:615;s:0:\"\";i:616;s:0:\"\";i:617;s:0:\"\";i:618;s:0:\"\";i:619;s:0:\"\";i:620;s:0:\"\";i:621;s:0:\"\";i:622;s:11:\"ilcolumngui\";i:623;s:0:\"\";i:624;s:13:\"ilfeedbackgui\";i:625;s:0:\"\";i:626;s:0:\"\";i:627;s:0:\"\";i:628;s:0:\"\";i:629;s:12:\"ilobjrolegui\";i:630;s:0:\"\";i:631;s:0:\"\";i:632;s:0:\"\";i:633;s:0:\"\";i:634;s:0:\"\";i:635;s:0:\"\";i:636;s:0:\"\";i:637;s:0:\"\";i:638;s:0:\"\";i:639;s:0:\"\";i:640;s:0:\"\";i:641;s:0:\"\";i:642;s:0:\"\";i:643;s:0:\"\";i:644;s:0:\"\";i:645;s:0:\"\";i:646;s:0:\"\";i:647;s:0:\"\";i:648;s:0:\"\";i:649;s:0:\"\";i:650;s:0:\"\";i:651;s:0:\"\";i:652;s:0:\"\";i:653;s:0:\"\";i:654;s:0:\"\";i:655;s:0:\"\";i:656;s:0:\"\";i:657;s:0:\"\";i:658;s:0:\"\";i:659;s:0:\"\";i:660;s:0:\"\";i:661;s:0:\"\";i:662;s:0:\"\";i:663;s:0:\"\";i:664;s:0:\"\";i:665;s:0:\"\";i:666;s:0:\"\";i:667;s:0:\"\";i:668;s:0:\"\";i:669;s:0:\"\";i:670;s:0:\"\";i:671;s:0:\"\";i:672;s:0:\"\";i:673;s:0:\"\";i:674;s:0:\"\";i:675;s:0:\"\";i:676;s:0:\"\";i:677;s:0:\"\";i:678;s:0:\"\";i:679;s:0:\"\";i:680;s:11:\"ilcolumngui\";i:681;s:0:\"\";i:682;s:0:\"\";i:683;s:0:\"\";i:684;s:0:\"\";i:685;s:0:\"\";i:686;s:0:\"\";i:687;s:0:\"\";i:688;s:0:\"\";i:689;s:0:\"\";i:690;s:0:\"\";i:691;s:0:\"\";i:692;s:0:\"\";i:693;s:0:\"\";i:694;s:0:\"\";i:695;s:0:\"\";i:696;s:0:\"\";i:697;s:0:\"\";i:698;s:0:\"\";i:699;s:0:\"\";i:700;s:0:\"\";i:701;s:0:\"\";i:702;s:0:\"\";i:703;s:0:\"\";i:704;s:0:\"\";i:705;s:0:\"\";i:706;s:0:\"\";i:707;s:11:\"ilcolumngui\";i:708;s:0:\"\";i:709;s:0:\"\";i:710;s:32:\"ilcourseobjectivepresentationgui\";i:711;s:0:\"\";i:712;s:0:\"\";i:713;s:0:\"\";i:714;s:0:\"\";i:715;s:0:\"\";i:716;s:0:\"\";i:717;s:0:\"\";i:718;s:0:\"\";i:719;s:0:\"\";i:720;s:0:\"\";i:721;s:0:\"\";i:722;s:0:\"\";i:723;s:0:\"\";i:724;s:0:\"\";i:725;s:0:\"\";i:726;s:0:\"\";i:727;s:0:\"\";i:728;s:0:\"\";i:729;s:0:\"\";i:730;s:0:\"\";i:731;s:0:\"\";i:732;s:0:\"\";i:733;s:0:\"\";i:734;s:0:\"\";i:735;s:0:\"\";i:736;s:0:\"\";i:737;s:11:\"ilcolumngui\";i:738;s:0:\"\";i:739;s:13:\"ilfeedbackgui\";i:740;s:0:\"\";i:741;s:0:\"\";i:742;s:0:\"\";i:743;s:0:\"\";i:744;s:13:\"illpfiltergui\";i:745;s:0:\"\";i:746;s:17:\"ilpdfpresentation\";i:747;s:0:\"\";i:748;s:15:\"iluserfiltergui\";i:749;s:0:\"\";i:750;s:13:\"illpfiltergui\";i:751;s:0:\"\";i:752;s:17:\"ilpdfpresentation\";i:753;s:0:\"\";i:754;s:21:\"illplistofsettingsgui\";i:755;s:0:\"\";i:756;s:0:\"\";i:757;s:0:\"\";i:758;s:0:\"\";i:759;s:0:\"\";i:760;s:0:\"\";i:761;s:0:\"\";i:762;s:0:\"\";i:763;s:0:\"\";i:764;s:0:\"\";i:765;s:0:\"\";i:766;s:0:\"\";i:767;s:0:\"\";i:768;s:0:\"\";i:769;s:0:\"\";i:770;s:0:\"\";i:771;s:0:\"\";i:772;s:0:\"\";i:773;s:0:\"\";i:774;s:0:\"\";i:775;s:0:\"\";i:776;s:0:\"\";i:777;s:0:\"\";i:778;s:0:\"\";i:779;s:0:\"\";i:780;s:0:\"\";i:781;s:12:\"ilobjrolegui\";i:782;s:0:\"\";i:783;s:0:\"\";i:784;s:0:\"\";i:785;s:0:\"\";i:786;s:0:\"\";i:787;s:0:\"\";i:788;s:0:\"\";i:789;s:0:\"\";i:790;s:0:\"\";i:791;s:0:\"\";i:792;s:0:\"\";i:793;s:0:\"\";i:794;s:0:\"\";i:795;s:0:\"\";i:796;s:0:\"\";i:797;s:0:\"\";i:798;s:0:\"\";i:799;s:0:\"\";i:800;s:0:\"\";i:801;s:0:\"\";i:802;s:0:\"\";i:803;s:0:\"\";i:804;s:0:\"\";i:805;s:0:\"\";i:806;s:0:\"\";i:807;s:11:\"ilcolumngui\";i:808;s:0:\"\";i:809;s:0:\"\";i:810;s:0:\"\";i:811;s:0:\"\";i:812;s:0:\"\";i:813;s:0:\"\";i:814;s:0:\"\";i:815;s:0:\"\";i:816;s:0:\"\";i:817;s:0:\"\";i:818;s:0:\"\";i:819;s:0:\"\";i:820;s:0:\"\";i:821;s:0:\"\";i:822;s:0:\"\";i:823;s:0:\"\";i:824;s:0:\"\";i:825;s:0:\"\";i:826;s:0:\"\";i:827;s:0:\"\";i:828;s:0:\"\";i:829;s:0:\"\";i:830;s:0:\"\";i:831;s:0:\"\";i:832;s:0:\"\";i:833;s:0:\"\";i:834;s:11:\"ilcolumngui\";i:835;s:0:\"\";i:836;s:13:\"ilfeedbackgui\";i:837;s:0:\"\";i:838;s:0:\"\";i:839;s:0:\"\";i:840;s:12:\"ilobjrolegui\";i:841;s:0:\"\";i:842;s:0:\"\";i:843;s:0:\"\";i:844;s:0:\"\";i:845;s:0:\"\";i:846;s:0:\"\";i:847;s:0:\"\";i:848;s:0:\"\";i:849;s:0:\"\";i:850;s:0:\"\";i:851;s:0:\"\";i:852;s:0:\"\";i:853;s:0:\"\";i:854;s:0:\"\";i:855;s:0:\"\";i:856;s:0:\"\";i:857;s:0:\"\";i:858;s:0:\"\";i:859;s:0:\"\";i:860;s:0:\"\";i:861;s:0:\"\";i:862;s:0:\"\";i:863;s:0:\"\";i:864;s:0:\"\";i:865;s:0:\"\";i:866;s:0:\"\";i:867;s:0:\"\";i:868;s:0:\"\";i:869;s:0:\"\";i:870;s:0:\"\";i:871;s:0:\"\";i:872;s:0:\"\";i:873;s:0:\"\";i:874;s:0:\"\";i:875;s:0:\"\";i:876;s:0:\"\";i:877;s:0:\"\";i:878;s:0:\"\";i:879;s:0:\"\";i:880;s:0:\"\";i:881;s:0:\"\";i:882;s:0:\"\";i:883;s:0:\"\";i:884;s:0:\"\";i:885;s:0:\"\";i:886;s:0:\"\";i:887;s:0:\"\";i:888;s:0:\"\";i:889;s:0:\"\";i:890;s:0:\"\";i:891;s:0:\"\";i:892;s:0:\"\";i:893;s:0:\"\";i:894;s:0:\"\";i:895;s:0:\"\";i:896;s:0:\"\";i:897;s:0:\"\";i:898;s:0:\"\";i:899;s:0:\"\";i:900;s:0:\"\";i:901;s:0:\"\";i:902;s:0:\"\";i:903;s:0:\"\";i:904;s:0:\"\";i:905;s:0:\"\";i:906;s:0:\"\";i:907;s:0:\"\";i:908;s:0:\"\";i:909;s:0:\"\";i:910;s:0:\"\";i:911;s:0:\"\";i:912;s:0:\"\";i:913;s:0:\"\";i:914;s:0:\"\";i:915;s:0:\"\";i:916;s:0:\"\";i:917;s:0:\"\";i:918;s:11:\"ilcolumngui\";i:919;s:0:\"\";i:920;s:13:\"ilfeedbackgui\";i:921;s:0:\"\";i:922;s:0:\"\";i:923;s:0:\"\";i:924;s:0:\"\";i:925;s:12:\"ilobjrolegui\";i:926;s:0:\"\";i:927;s:0:\"\";i:928;s:0:\"\";i:929;s:0:\"\";i:930;s:0:\"\";i:931;s:0:\"\";i:932;s:0:\"\";i:933;s:0:\"\";i:934;s:0:\"\";i:935;s:0:\"\";i:936;s:0:\"\";i:937;s:0:\"\";i:938;s:0:\"\";i:939;s:0:\"\";i:940;s:0:\"\";i:941;s:0:\"\";i:942;s:0:\"\";i:943;s:0:\"\";i:944;s:0:\"\";i:945;s:0:\"\";i:946;s:0:\"\";i:947;s:0:\"\";i:948;s:0:\"\";i:949;s:0:\"\";i:950;s:0:\"\";i:951;s:0:\"\";i:952;s:11:\"ilcolumngui\";i:953;s:0:\"\";i:954;s:0:\"\";i:955;s:0:\"\";i:956;s:0:\"\";i:957;s:0:\"\";i:958;s:0:\"\";i:959;s:0:\"\";i:960;s:0:\"\";i:961;s:0:\"\";i:962;s:0:\"\";i:963;s:0:\"\";i:964;s:0:\"\";i:965;s:0:\"\";i:966;s:0:\"\";i:967;s:0:\"\";i:968;s:0:\"\";i:969;s:0:\"\";i:970;s:0:\"\";i:971;s:0:\"\";i:972;s:0:\"\";i:973;s:0:\"\";i:974;s:0:\"\";i:975;s:0:\"\";i:976;s:0:\"\";i:977;s:0:\"\";i:978;s:0:\"\";i:979;s:11:\"ilcolumngui\";i:980;s:0:\"\";i:981;s:0:\"\";i:982;s:32:\"ilcourseobjectivepresentationgui\";i:983;s:0:\"\";i:984;s:0:\"\";i:985;s:0:\"\";i:986;s:0:\"\";i:987;s:0:\"\";i:988;s:0:\"\";i:989;s:0:\"\";i:990;s:0:\"\";i:991;s:0:\"\";i:992;s:0:\"\";i:993;s:0:\"\";i:994;s:0:\"\";i:995;s:0:\"\";i:996;s:0:\"\";i:997;s:0:\"\";i:998;s:0:\"\";i:999;s:0:\"\";i:1000;s:0:\"\";i:1001;s:0:\"\";i:1002;s:0:\"\";i:1003;s:0:\"\";i:1004;s:0:\"\";i:1005;s:0:\"\";i:1006;s:0:\"\";i:1007;s:0:\"\";i:1008;s:0:\"\";i:1009;s:0:\"\";i:1010;s:11:\"ilcolumngui\";i:1011;s:0:\"\";i:1012;s:13:\"ilfeedbackgui\";i:1013;s:0:\"\";i:1014;s:0:\"\";i:1015;s:0:\"\";i:1016;s:0:\"\";i:1017;s:13:\"illpfiltergui\";i:1018;s:0:\"\";i:1019;s:17:\"ilpdfpresentation\";i:1020;s:0:\"\";i:1021;s:15:\"iluserfiltergui\";i:1022;s:0:\"\";i:1023;s:13:\"illpfiltergui\";i:1024;s:0:\"\";i:1025;s:17:\"ilpdfpresentation\";i:1026;s:0:\"\";i:1027;s:21:\"illplistofsettingsgui\";i:1028;s:0:\"\";i:1029;s:0:\"\";i:1030;s:0:\"\";i:1031;s:0:\"\";i:1032;s:0:\"\";i:1033;s:0:\"\";i:1034;s:0:\"\";i:1035;s:0:\"\";i:1036;s:0:\"\";i:1037;s:0:\"\";i:1038;s:0:\"\";i:1039;s:0:\"\";i:1040;s:0:\"\";i:1041;s:0:\"\";i:1042;s:0:\"\";i:1043;s:0:\"\";i:1044;s:0:\"\";i:1045;s:0:\"\";i:1046;s:0:\"\";i:1047;s:0:\"\";i:1048;s:0:\"\";i:1049;s:0:\"\";i:1050;s:0:\"\";i:1051;s:0:\"\";i:1052;s:0:\"\";i:1053;s:0:\"\";i:1054;s:0:\"\";i:1055;s:12:\"ilobjrolegui\";i:1056;s:0:\"\";i:1057;s:0:\"\";i:1058;s:13:\"ilobjgroupgui\";i:1059;s:0:\"\";i:1060;s:22:\"ilobjilincclassroomgui\";i:1061;s:0:\"\";i:1062;s:0:\"\";i:1063;s:0:\"\";i:1064;s:0:\"\";i:1065;s:0:\"\";i:1066;s:0:\"\";i:1067;s:0:\"\";i:1068;s:0:\"\";i:1069;s:0:\"\";i:1070;s:0:\"\";i:1071;s:0:\"\";i:1072;s:0:\"\";i:1073;s:0:\"\";i:1074;s:0:\"\";i:1075;s:0:\"\";i:1076;s:0:\"\";i:1077;s:0:\"\";i:1078;s:0:\"\";i:1079;s:0:\"\";i:1080;s:0:\"\";i:1081;s:0:\"\";i:1082;s:0:\"\";i:1083;s:0:\"\";i:1084;s:0:\"\";i:1085;s:0:\"\";i:1086;s:11:\"ilcolumngui\";i:1087;s:0:\"\";i:1088;s:13:\"ilfeedbackgui\";i:1089;s:0:\"\";i:1090;s:0:\"\";i:1091;s:0:\"\";i:1092;s:22:\"ilobjilincclassroomgui\";i:1093;s:0:\"\";i:1094;s:12:\"ilobjrolegui\";i:1095;s:0:\"\";i:1096;s:0:\"\";i:1097;s:0:\"\";i:1098;s:19:\"ilobjlanguageextgui\";i:1099;s:0:\"\";i:1100;s:12:\"ilobjrolegui\";i:1101;s:0:\"\";i:1102;s:0:\"\";i:1103;s:0:\"\";i:1104;s:0:\"\";i:1105;s:0:\"\";i:1106;s:0:\"\";i:1107;s:0:\"\";i:1108;s:0:\"\";i:1109;s:0:\"\";i:1110;s:0:\"\";i:1111;s:0:\"\";i:1112;s:0:\"\";i:1113;s:0:\"\";i:1114;s:0:\"\";i:1115;s:0:\"\";i:1116;s:0:\"\";i:1117;s:0:\"\";i:1118;s:0:\"\";i:1119;s:0:\"\";i:1120;s:0:\"\";i:1121;s:0:\"\";i:1122;s:0:\"\";i:1123;s:0:\"\";i:1124;s:0:\"\";i:1125;s:0:\"\";i:1126;s:11:\"ilcolumngui\";i:1127;s:0:\"\";i:1128;s:13:\"ilfeedbackgui\";i:1129;s:0:\"\";i:1130;s:0:\"\";i:1131;s:0:\"\";i:1132;s:0:\"\";i:1133;s:13:\"illpfiltergui\";i:1134;s:0:\"\";i:1135;s:17:\"ilpdfpresentation\";i:1136;s:0:\"\";i:1137;s:15:\"iluserfiltergui\";i:1138;s:0:\"\";i:1139;s:13:\"illpfiltergui\";i:1140;s:0:\"\";i:1141;s:17:\"ilpdfpresentation\";i:1142;s:0:\"\";i:1143;s:21:\"illplistofsettingsgui\";i:1144;s:0:\"\";i:1145;s:0:\"\";i:1146;s:0:\"\";i:1147;s:0:\"\";i:1148;s:0:\"\";i:1149;s:0:\"\";i:1150;s:0:\"\";i:1151;s:0:\"\";i:1152;s:0:\"\";i:1153;s:0:\"\";i:1154;s:0:\"\";i:1155;s:0:\"\";i:1156;s:0:\"\";i:1157;s:0:\"\";i:1158;s:0:\"\";i:1159;s:0:\"\";i:1160;s:0:\"\";i:1161;s:0:\"\";i:1162;s:0:\"\";i:1163;s:0:\"\";i:1164;s:0:\"\";i:1165;s:0:\"\";i:1166;s:0:\"\";i:1167;s:0:\"\";i:1168;s:0:\"\";i:1169;s:0:\"\";i:1170;s:0:\"\";i:1171;s:18:\"ilobjstylesheetgui\";i:1172;s:0:\"\";i:1173;s:12:\"ilobjrolegui\";i:1174;s:0:\"\";i:1175;s:0:\"\";i:1176;s:0:\"\";i:1177;s:0:\"\";i:1178;s:0:\"\";i:1179;s:0:\"\";i:1180;s:0:\"\";i:1181;s:0:\"\";i:1182;s:0:\"\";i:1183;s:0:\"\";i:1184;s:0:\"\";i:1185;s:0:\"\";i:1186;s:0:\"\";i:1187;s:0:\"\";i:1188;s:0:\"\";i:1189;s:0:\"\";i:1190;s:0:\"\";i:1191;s:0:\"\";i:1192;s:0:\"\";i:1193;s:0:\"\";i:1194;s:0:\"\";i:1195;s:0:\"\";i:1196;s:0:\"\";i:1197;s:0:\"\";i:1198;s:0:\"\";i:1199;s:0:\"\";i:1200;s:0:\"\";i:1201;s:11:\"ilcolumngui\";i:1202;s:0:\"\";i:1203;s:13:\"ilfeedbackgui\";i:1204;s:0:\"\";i:1205;s:0:\"\";i:1206;s:0:\"\";i:1207;s:0:\"\";i:1208;s:12:\"ilobjrolegui\";i:1209;s:0:\"\";i:1210;s:12:\"ilobjrolegui\";i:1211;s:0:\"\";i:1212;s:23:\"iladvancedmdsettingsgui\";i:1213;s:0:\"\";i:1214;s:12:\"ilobjrolegui\";i:1215;s:0:\"\";i:1216;s:0:\"\";i:1217;s:0:\"\";i:1218;s:0:\"\";i:1219;s:0:\"\";i:1220;s:0:\"\";i:1221;s:0:\"\";i:1222;s:0:\"\";i:1223;s:0:\"\";i:1224;s:0:\"\";i:1225;s:0:\"\";i:1226;s:0:\"\";i:1227;s:0:\"\";i:1228;s:0:\"\";i:1229;s:0:\"\";i:1230;s:0:\"\";i:1231;s:0:\"\";i:1232;s:0:\"\";i:1233;s:0:\"\";i:1234;s:0:\"\";i:1235;s:0:\"\";i:1236;s:0:\"\";i:1237;s:0:\"\";i:1238;s:0:\"\";i:1239;s:0:\"\";i:1240;s:11:\"ilcolumngui\";i:1241;s:0:\"\";i:1242;s:13:\"ilfeedbackgui\";i:1243;s:0:\"\";i:1244;s:0:\"\";i:1245;s:0:\"\";i:1246;s:12:\"ilobjrolegui\";i:1247;s:0:\"\";i:1248;s:12:\"ilobjrolegui\";i:1249;s:0:\"\";i:1250;s:0:\"\";i:1251;s:0:\"\";i:1252;s:0:\"\";i:1253;s:0:\"\";i:1254;s:0:\"\";i:1255;s:0:\"\";i:1256;s:0:\"\";i:1257;s:0:\"\";i:1258;s:0:\"\";i:1259;s:0:\"\";i:1260;s:0:\"\";i:1261;s:0:\"\";i:1262;s:0:\"\";i:1263;s:0:\"\";i:1264;s:0:\"\";i:1265;s:0:\"\";i:1266;s:0:\"\";i:1267;s:0:\"\";i:1268;s:0:\"\";i:1269;s:0:\"\";i:1270;s:0:\"\";i:1271;s:0:\"\";i:1272;s:0:\"\";i:1273;s:0:\"\";i:1274;s:0:\"\";i:1275;s:0:\"\";i:1276;s:11:\"ilcolumngui\";i:1277;s:0:\"\";i:1278;s:13:\"ilfeedbackgui\";i:1279;s:0:\"\";i:1280;s:0:\"\";i:1281;s:0:\"\";i:1282;s:0:\"\";i:1283;s:0:\"\";i:1284;s:0:\"\";i:1285;s:0:\"\";i:1286;s:0:\"\";i:1287;s:0:\"\";i:1288;s:0:\"\";i:1289;s:0:\"\";i:1290;s:0:\"\";i:1291;s:0:\"\";i:1292;s:0:\"\";i:1293;s:0:\"\";i:1294;s:0:\"\";i:1295;s:0:\"\";i:1296;s:0:\"\";i:1297;s:0:\"\";i:1298;s:0:\"\";i:1299;s:0:\"\";i:1300;s:0:\"\";i:1301;s:0:\"\";i:1302;s:0:\"\";i:1303;s:0:\"\";i:1304;s:0:\"\";i:1305;s:0:\"\";i:1306;s:11:\"ilcolumngui\";i:1307;s:0:\"\";i:1308;s:0:\"\";i:1309;s:0:\"\";i:1310;s:0:\"\";i:1311;s:0:\"\";i:1312;s:0:\"\";i:1313;s:0:\"\";i:1314;s:0:\"\";i:1315;s:0:\"\";i:1316;s:0:\"\";i:1317;s:0:\"\";i:1318;s:0:\"\";i:1319;s:0:\"\";i:1320;s:0:\"\";i:1321;s:0:\"\";i:1322;s:0:\"\";i:1323;s:0:\"\";i:1324;s:0:\"\";i:1325;s:0:\"\";i:1326;s:0:\"\";i:1327;s:0:\"\";i:1328;s:0:\"\";i:1329;s:0:\"\";i:1330;s:0:\"\";i:1331;s:0:\"\";i:1332;s:0:\"\";i:1333;s:11:\"ilcolumngui\";i:1334;s:0:\"\";i:1335;s:0:\"\";i:1336;s:32:\"ilcourseobjectivepresentationgui\";i:1337;s:0:\"\";i:1338;s:0:\"\";i:1339;s:0:\"\";i:1340;s:0:\"\";i:1341;s:0:\"\";i:1342;s:0:\"\";i:1343;s:0:\"\";i:1344;s:0:\"\";i:1345;s:0:\"\";i:1346;s:0:\"\";i:1347;s:0:\"\";i:1348;s:0:\"\";i:1349;s:0:\"\";i:1350;s:0:\"\";i:1351;s:0:\"\";i:1352;s:0:\"\";i:1353;s:0:\"\";i:1354;s:0:\"\";i:1355;s:0:\"\";i:1356;s:0:\"\";i:1357;s:0:\"\";i:1358;s:0:\"\";i:1359;s:0:\"\";i:1360;s:0:\"\";i:1361;s:0:\"\";i:1362;s:0:\"\";i:1363;s:11:\"ilcolumngui\";i:1364;s:0:\"\";i:1365;s:13:\"ilfeedbackgui\";i:1366;s:0:\"\";i:1367;s:0:\"\";i:1368;s:0:\"\";i:1369;s:0:\"\";i:1370;s:13:\"illpfiltergui\";i:1371;s:0:\"\";i:1372;s:17:\"ilpdfpresentation\";i:1373;s:0:\"\";i:1374;s:15:\"iluserfiltergui\";i:1375;s:0:\"\";i:1376;s:13:\"illpfiltergui\";i:1377;s:0:\"\";i:1378;s:17:\"ilpdfpresentation\";i:1379;s:0:\"\";i:1380;s:21:\"illplistofsettingsgui\";i:1381;s:0:\"\";i:1382;s:0:\"\";i:1383;s:0:\"\";i:1384;s:0:\"\";i:1385;s:0:\"\";i:1386;s:0:\"\";i:1387;s:0:\"\";i:1388;s:0:\"\";i:1389;s:0:\"\";i:1390;s:0:\"\";i:1391;s:0:\"\";i:1392;s:0:\"\";i:1393;s:0:\"\";i:1394;s:0:\"\";i:1395;s:0:\"\";i:1396;s:0:\"\";i:1397;s:0:\"\";i:1398;s:0:\"\";i:1399;s:0:\"\";i:1400;s:0:\"\";i:1401;s:0:\"\";i:1402;s:0:\"\";i:1403;s:0:\"\";i:1404;s:0:\"\";i:1405;s:0:\"\";i:1406;s:0:\"\";i:1407;s:12:\"ilobjrolegui\";i:1408;s:0:\"\";i:1409;s:0:\"\";i:1410;s:0:\"\";i:1411;s:12:\"ilobjrolegui\";i:1412;s:0:\"\";i:1413;s:12:\"ilobjrolegui\";i:1414;s:0:\"\";i:1415;s:12:\"ilobjrolegui\";i:1416;s:0:\"\";i:1417;s:0:\"\";i:1418;s:0:\"\";i:1419;s:0:\"\";i:1420;s:0:\"\";i:1421;s:0:\"\";i:1422;s:0:\"\";i:1423;s:0:\"\";i:1424;s:0:\"\";i:1425;s:0:\"\";i:1426;s:0:\"\";i:1427;s:0:\"\";i:1428;s:0:\"\";i:1429;s:0:\"\";i:1430;s:0:\"\";i:1431;s:0:\"\";i:1432;s:0:\"\";i:1433;s:0:\"\";i:1434;s:0:\"\";i:1435;s:0:\"\";i:1436;s:0:\"\";i:1437;s:0:\"\";i:1438;s:0:\"\";i:1439;s:0:\"\";i:1440;s:0:\"\";i:1441;s:0:\"\";i:1442;s:12:\"ilobjrolegui\";i:1443;s:0:\"\";i:1444;s:0:\"\";i:1445;s:12:\"ilobjrolegui\";i:1446;s:0:\"\";i:1447;s:12:\"ilobjrolegui\";i:1448;s:0:\"\";i:1449;s:0:\"\";i:1450;s:0:\"\";i:1451;s:0:\"\";i:1452;s:0:\"\";i:1453;s:0:\"\";i:1454;s:0:\"\";i:1455;s:0:\"\";i:1456;s:0:\"\";i:1457;s:0:\"\";i:1458;s:0:\"\";i:1459;s:0:\"\";i:1460;s:0:\"\";i:1461;s:0:\"\";i:1462;s:0:\"\";i:1463;s:0:\"\";i:1464;s:0:\"\";i:1465;s:0:\"\";i:1466;s:0:\"\";i:1467;s:0:\"\";i:1468;s:0:\"\";i:1469;s:0:\"\";i:1470;s:0:\"\";i:1471;s:0:\"\";i:1472;s:0:\"\";i:1473;s:0:\"\";i:1474;s:0:\"\";i:1475;s:0:\"\";i:1476;s:0:\"\";i:1477;s:0:\"\";i:1478;s:0:\"\";i:1479;s:0:\"\";i:1480;s:0:\"\";i:1481;s:0:\"\";i:1482;s:0:\"\";i:1483;s:0:\"\";i:1484;s:0:\"\";i:1485;s:0:\"\";i:1486;s:12:\"ilobjrolegui\";i:1487;s:0:\"\";i:1488;s:12:\"ilobjrolegui\";i:1489;s:0:\"\";i:1490;s:12:\"ilobjrolegui\";i:1491;s:0:\"\";i:1492;s:12:\"ilobjrolegui\";i:1493;s:0:\"\";i:1494;s:20:\"ilobjroletemplategui\";i:1495;s:0:\"\";i:1496;s:0:\"\";i:1497;s:0:\"\";i:1498;s:0:\"\";i:1499;s:0:\"\";i:1500;s:0:\"\";i:1501;s:0:\"\";i:1502;s:0:\"\";i:1503;s:0:\"\";i:1504;s:0:\"\";i:1505;s:0:\"\";i:1506;s:0:\"\";i:1507;s:0:\"\";i:1508;s:0:\"\";i:1509;s:0:\"\";i:1510;s:0:\"\";i:1511;s:0:\"\";i:1512;s:0:\"\";i:1513;s:0:\"\";i:1514;s:0:\"\";i:1515;s:0:\"\";i:1516;s:0:\"\";i:1517;s:0:\"\";i:1518;s:0:\"\";i:1519;s:0:\"\";i:1520;s:11:\"ilcolumngui\";i:1521;s:0:\"\";i:1522;s:22:\"ilcontainerlinklistgui\";i:1523;s:0:\"\";i:1524;s:0:\"\";i:1525;s:0:\"\";i:1526;s:0:\"\";i:1527;s:0:\"\";i:1528;s:0:\"\";i:1529;s:0:\"\";i:1530;s:0:\"\";i:1531;s:0:\"\";i:1532;s:0:\"\";i:1533;s:0:\"\";i:1534;s:0:\"\";i:1535;s:0:\"\";i:1536;s:0:\"\";i:1537;s:0:\"\";i:1538;s:0:\"\";i:1539;s:0:\"\";i:1540;s:0:\"\";i:1541;s:0:\"\";i:1542;s:0:\"\";i:1543;s:0:\"\";i:1544;s:0:\"\";i:1545;s:0:\"\";i:1546;s:0:\"\";i:1547;s:0:\"\";i:1548;s:0:\"\";i:1549;s:12:\"ilobjrolegui\";i:1550;s:0:\"\";i:1551;s:0:\"\";i:1552;s:0:\"\";i:1553;s:12:\"ilobjrolegui\";i:1554;s:0:\"\";i:1555;s:12:\"ilobjrolegui\";i:1556;s:0:\"\";i:1557;s:0:\"\";i:1558;s:0:\"\";i:1559;s:0:\"\";i:1560;s:0:\"\";i:1561;s:0:\"\";i:1562;s:0:\"\";i:1563;s:0:\"\";i:1564;s:0:\"\";i:1565;s:0:\"\";i:1566;s:0:\"\";i:1567;s:0:\"\";i:1568;s:0:\"\";i:1569;s:0:\"\";i:1570;s:0:\"\";i:1571;s:0:\"\";i:1572;s:0:\"\";i:1573;s:0:\"\";i:1574;s:0:\"\";i:1575;s:0:\"\";i:1576;s:0:\"\";i:1577;s:0:\"\";i:1578;s:0:\"\";i:1579;s:0:\"\";i:1580;s:0:\"\";i:1581;s:11:\"ilcolumngui\";i:1582;s:0:\"\";i:1583;s:13:\"ilfeedbackgui\";i:1584;s:0:\"\";i:1585;s:0:\"\";i:1586;s:0:\"\";i:1587;s:12:\"ilobjrolegui\";i:1588;s:0:\"\";i:1589;s:12:\"ilobjrolegui\";i:1590;s:0:\"\";i:1591;s:18:\"ilobjstylesheetgui\";i:1592;s:0:\"\";i:1593;s:12:\"ilobjrolegui\";i:1594;s:0:\"\";i:1595;s:0:\"\";i:1596;s:0:\"\";i:1597;s:0:\"\";i:1598;s:0:\"\";i:1599;s:0:\"\";i:1600;s:0:\"\";i:1601;s:0:\"\";i:1602;s:0:\"\";i:1603;s:0:\"\";i:1604;s:0:\"\";i:1605;s:0:\"\";i:1606;s:0:\"\";i:1607;s:0:\"\";i:1608;s:0:\"\";i:1609;s:0:\"\";i:1610;s:0:\"\";i:1611;s:0:\"\";i:1612;s:0:\"\";i:1613;s:0:\"\";i:1614;s:0:\"\";i:1615;s:0:\"\";i:1616;s:0:\"\";i:1617;s:0:\"\";i:1618;s:0:\"\";i:1619;s:11:\"ilcolumngui\";i:1620;s:0:\"\";i:1621;s:13:\"ilfeedbackgui\";i:1622;s:0:\"\";i:1623;s:0:\"\";i:1624;s:0:\"\";i:1625;s:0:\"\";i:1626;s:12:\"ilobjrolegui\";i:1627;s:0:\"\";i:1628;s:0:\"\";i:1629;s:0:\"\";i:1630;s:0:\"\";i:1631;s:12:\"ilobjrolegui\";i:1632;s:0:\"\";i:1633;s:0:\"\";i:1634;s:0:\"\";i:1635;s:0:\"\";i:1636;s:0:\"\";i:1637;s:0:\"\";i:1638;s:0:\"\";i:1639;s:12:\"ilobjrolegui\";i:1640;s:0:\"\";i:1641;s:12:\"ilobjrolegui\";i:1642;s:0:\"\";i:1643;s:0:\"\";i:1644;s:0:\"\";i:1645;s:0:\"\";i:1646;s:0:\"\";i:1647;s:0:\"\";i:1648;s:0:\"\";i:1649;s:0:\"\";i:1650;s:0:\"\";i:1651;s:0:\"\";i:1652;s:0:\"\";i:1653;s:0:\"\";i:1654;s:0:\"\";i:1655;s:0:\"\";i:1656;s:0:\"\";i:1657;s:0:\"\";i:1658;s:0:\"\";i:1659;s:0:\"\";i:1660;s:0:\"\";i:1661;s:0:\"\";i:1662;s:0:\"\";i:1663;s:0:\"\";i:1664;s:0:\"\";i:1665;s:0:\"\";i:1666;s:0:\"\";i:1667;s:11:\"ilcolumngui\";i:1668;s:0:\"\";i:1669;s:13:\"ilfeedbackgui\";i:1670;s:0:\"\";i:1671;s:0:\"\";i:1672;s:0:\"\";i:1673;s:0:\"\";i:1674;s:13:\"illpfiltergui\";i:1675;s:0:\"\";i:1676;s:17:\"ilpdfpresentation\";i:1677;s:0:\"\";i:1678;s:15:\"iluserfiltergui\";i:1679;s:0:\"\";i:1680;s:13:\"illpfiltergui\";i:1681;s:0:\"\";i:1682;s:17:\"ilpdfpresentation\";i:1683;s:0:\"\";i:1684;s:21:\"illplistofsettingsgui\";i:1685;s:0:\"\";i:1686;s:0:\"\";i:1687;s:0:\"\";i:1688;s:0:\"\";i:1689;s:0:\"\";i:1690;s:0:\"\";i:1691;s:0:\"\";i:1692;s:0:\"\";i:1693;s:0:\"\";i:1694;s:0:\"\";i:1695;s:0:\"\";i:1696;s:0:\"\";i:1697;s:0:\"\";i:1698;s:0:\"\";i:1699;s:0:\"\";i:1700;s:0:\"\";i:1701;s:0:\"\";i:1702;s:0:\"\";i:1703;s:0:\"\";i:1704;s:0:\"\";i:1705;s:0:\"\";i:1706;s:0:\"\";i:1707;s:0:\"\";i:1708;s:0:\"\";i:1709;s:0:\"\";i:1710;s:0:\"\";i:1711;s:11:\"ilcolumngui\";i:1712;s:0:\"\";i:1713;s:0:\"\";i:1714;s:20:\"ilcourseagreementgui\";i:1715;s:0:\"\";i:1716;s:0:\"\";i:1717;s:0:\"\";i:1718;s:0:\"\";i:1719;s:0:\"\";i:1720;s:0:\"\";i:1721;s:0:\"\";i:1722;s:0:\"\";i:1723;s:0:\"\";i:1724;s:0:\"\";i:1725;s:0:\"\";i:1726;s:0:\"\";i:1727;s:0:\"\";i:1728;s:0:\"\";i:1729;s:0:\"\";i:1730;s:0:\"\";i:1731;s:0:\"\";i:1732;s:0:\"\";i:1733;s:0:\"\";i:1734;s:0:\"\";i:1735;s:0:\"\";i:1736;s:0:\"\";i:1737;s:0:\"\";i:1738;s:0:\"\";i:1739;s:0:\"\";i:1740;s:11:\"ilcolumngui\";i:1741;s:0:\"\";i:1742;s:0:\"\";i:1743;s:32:\"ilcourseobjectivepresentationgui\";i:1744;s:0:\"\";i:1745;s:0:\"\";i:1746;s:0:\"\";i:1747;s:23:\"ilcourseregistrationgui\";i:1748;s:0:\"\";i:1749;s:0:\"\";i:1750;s:0:\"\";i:1751;s:0:\"\";i:1752;s:0:\"\";i:1753;s:0:\"\";i:1754;s:0:\"\";i:1755;s:0:\"\";i:1756;s:0:\"\";i:1757;s:0:\"\";i:1758;s:0:\"\";i:1759;s:0:\"\";i:1760;s:0:\"\";i:1761;s:0:\"\";i:1762;s:0:\"\";i:1763;s:0:\"\";i:1764;s:0:\"\";i:1765;s:0:\"\";i:1766;s:0:\"\";i:1767;s:0:\"\";i:1768;s:0:\"\";i:1769;s:0:\"\";i:1770;s:0:\"\";i:1771;s:0:\"\";i:1772;s:0:\"\";i:1773;s:0:\"\";i:1774;s:11:\"ilcolumngui\";i:1775;s:0:\"\";i:1776;s:13:\"ilfeedbackgui\";i:1777;s:0:\"\";i:1778;s:0:\"\";i:1779;s:0:\"\";i:1780;s:0:\"\";i:1781;s:13:\"illpfiltergui\";i:1782;s:0:\"\";i:1783;s:17:\"ilpdfpresentation\";i:1784;s:0:\"\";i:1785;s:15:\"iluserfiltergui\";i:1786;s:0:\"\";i:1787;s:13:\"illpfiltergui\";i:1788;s:0:\"\";i:1789;s:17:\"ilpdfpresentation\";i:1790;s:0:\"\";i:1791;s:21:\"illplistofsettingsgui\";i:1792;s:0:\"\";i:1793;s:0:\"\";i:1794;s:17:\"ilmemberexportgui\";i:1795;s:0:\"\";i:1796;s:0:\"\";i:1797;s:0:\"\";i:1798;s:0:\"\";i:1799;s:0:\"\";i:1800;s:0:\"\";i:1801;s:0:\"\";i:1802;s:0:\"\";i:1803;s:0:\"\";i:1804;s:0:\"\";i:1805;s:0:\"\";i:1806;s:0:\"\";i:1807;s:0:\"\";i:1808;s:0:\"\";i:1809;s:0:\"\";i:1810;s:0:\"\";i:1811;s:0:\"\";i:1812;s:0:\"\";i:1813;s:0:\"\";i:1814;s:0:\"\";i:1815;s:0:\"\";i:1816;s:0:\"\";i:1817;s:0:\"\";i:1818;s:0:\"\";i:1819;s:0:\"\";i:1820;s:0:\"\";i:1821;s:0:\"\";i:1822;s:12:\"ilobjrolegui\";i:1823;s:0:\"\";i:1824;s:0:\"\";i:1825;s:0:\"\";i:1826;s:0:\"\";i:1827;s:0:\"\";i:1828;s:0:\"\";i:1829;s:0:\"\";i:1830;s:0:\"\";i:1831;s:0:\"\";i:1832;s:0:\"\";i:1833;s:0:\"\";i:1834;s:0:\"\";i:1835;s:0:\"\";i:1836;s:0:\"\";i:1837;s:0:\"\";i:1838;s:0:\"\";i:1839;s:0:\"\";i:1840;s:0:\"\";i:1841;s:0:\"\";i:1842;s:0:\"\";i:1843;s:0:\"\";i:1844;s:0:\"\";i:1845;s:0:\"\";i:1846;s:0:\"\";i:1847;s:0:\"\";i:1848;s:0:\"\";i:1849;s:0:\"\";i:1850;s:0:\"\";i:1851;s:0:\"\";i:1852;s:12:\"ilobjrolegui\";i:1853;s:0:\"\";i:1854;s:0:\"\";i:1855;s:0:\"\";i:1856;s:0:\"\";i:1857;s:0:\"\";i:1858;s:0:\"\";i:1859;s:0:\"\";i:1860;s:0:\"\";i:1861;s:0:\"\";i:1862;s:0:\"\";i:1863;s:0:\"\";i:1864;s:0:\"\";i:1865;s:0:\"\";i:1866;s:0:\"\";i:1867;s:0:\"\";i:1868;s:0:\"\";i:1869;s:0:\"\";i:1870;s:0:\"\";i:1871;s:0:\"\";i:1872;s:0:\"\";i:1873;s:0:\"\";i:1874;s:0:\"\";i:1875;s:0:\"\";i:1876;s:0:\"\";i:1877;s:0:\"\";i:1878;s:0:\"\";i:1879;s:0:\"\";i:1880;s:0:\"\";i:1881;s:0:\"\";i:1882;s:0:\"\";i:1883;s:0:\"\";i:1884;s:0:\"\";i:1885;s:13:\"illpfiltergui\";i:1886;s:0:\"\";i:1887;s:17:\"ilpdfpresentation\";i:1888;s:0:\"\";i:1889;s:15:\"iluserfiltergui\";i:1890;s:0:\"\";i:1891;s:13:\"illpfiltergui\";i:1892;s:0:\"\";i:1893;s:17:\"ilpdfpresentation\";i:1894;s:0:\"\";i:1895;s:21:\"illplistofsettingsgui\";i:1896;s:0:\"\";i:1897;s:0:\"\";i:1898;s:12:\"ilobjrolegui\";i:1899;s:0:\"\";i:1900;s:0:\"\";i:1901;s:13:\"illpfiltergui\";i:1902;s:0:\"\";i:1903;s:17:\"ilpdfpresentation\";i:1904;s:0:\"\";i:1905;s:15:\"iluserfiltergui\";i:1906;s:0:\"\";i:1907;s:13:\"illpfiltergui\";i:1908;s:0:\"\";i:1909;s:17:\"ilpdfpresentation\";i:1910;s:0:\"\";i:1911;s:21:\"illplistofsettingsgui\";i:1912;s:0:\"\";i:1913;s:0:\"\";i:1914;s:0:\"\";i:1915;s:13:\"illpfiltergui\";i:1916;s:0:\"\";i:1917;s:17:\"ilpdfpresentation\";i:1918;s:0:\"\";i:1919;s:15:\"iluserfiltergui\";i:1920;s:0:\"\";i:1921;s:13:\"illpfiltergui\";i:1922;s:0:\"\";i:1923;s:17:\"ilpdfpresentation\";i:1924;s:0:\"\";i:1925;s:21:\"illplistofsettingsgui\";i:1926;s:0:\"\";i:1927;s:12:\"ilobjrolegui\";i:1928;s:0:\"\";i:1929;s:0:\"\";i:1930;s:0:\"\";i:1931;s:0:\"\";i:1932;s:0:\"\";i:1933;s:0:\"\";i:1934;s:0:\"\";i:1935;s:0:\"\";i:1936;s:0:\"\";i:1937;s:0:\"\";i:1938;s:0:\"\";i:1939;s:0:\"\";i:1940;s:0:\"\";i:1941;s:0:\"\";i:1942;s:0:\"\";i:1943;s:0:\"\";i:1944;s:0:\"\";i:1945;s:0:\"\";i:1946;s:0:\"\";i:1947;s:0:\"\";i:1948;s:0:\"\";i:1949;s:0:\"\";i:1950;s:0:\"\";i:1951;s:0:\"\";i:1952;s:0:\"\";i:1953;s:11:\"ilcolumngui\";i:1954;s:0:\"\";i:1955;s:13:\"ilfeedbackgui\";i:1956;s:0:\"\";i:1957;s:0:\"\";i:1958;s:0:\"\";i:1959;s:12:\"ilobjrolegui\";i:1960;s:0:\"\";i:1961;s:0:\"\";i:1962;s:0:\"\";i:1963;s:0:\"\";i:1964;s:0:\"\";i:1965;s:0:\"\";i:1966;s:0:\"\";i:1967;s:0:\"\";i:1968;s:0:\"\";i:1969;s:0:\"\";i:1970;s:0:\"\";i:1971;s:0:\"\";i:1972;s:0:\"\";i:1973;s:0:\"\";i:1974;s:0:\"\";i:1975;s:0:\"\";i:1976;s:0:\"\";i:1977;s:0:\"\";i:1978;s:0:\"\";i:1979;s:0:\"\";i:1980;s:0:\"\";i:1981;s:0:\"\";i:1982;s:0:\"\";i:1983;s:0:\"\";i:1984;s:0:\"\";i:1985;s:0:\"\";i:1986;s:0:\"\";i:1987;s:0:\"\";i:1988;s:0:\"\";i:1989;s:0:\"\";i:1990;s:0:\"\";i:1991;s:0:\"\";i:1992;s:0:\"\";i:1993;s:0:\"\";i:1994;s:0:\"\";i:1995;s:0:\"\";i:1996;s:0:\"\";i:1997;s:0:\"\";i:1998;s:0:\"\";i:1999;s:0:\"\";i:2000;s:0:\"\";i:2001;s:0:\"\";i:2002;s:0:\"\";i:2003;s:0:\"\";i:2004;s:0:\"\";i:2005;s:0:\"\";i:2006;s:0:\"\";i:2007;s:0:\"\";i:2008;s:0:\"\";i:2009;s:0:\"\";i:2010;s:0:\"\";i:2011;s:0:\"\";i:2012;s:0:\"\";i:2013;s:0:\"\";i:2014;s:12:\"ilobjrolegui\";}s:12:\"ilobjrolegui\";a:58:{i:0;s:15:\"ilpermissiongui\";i:1;s:15:\"ilpermissiongui\";i:2;s:15:\"ilpermissiongui\";i:3;s:15:\"ilpermissiongui\";i:4;s:15:\"ilpermissiongui\";i:5;s:15:\"ilpermissiongui\";i:6;s:15:\"ilpermissiongui\";i:7;s:15:\"ilpermissiongui\";i:8;s:15:\"ilpermissiongui\";i:9;s:15:\"ilpermissiongui\";i:10;s:15:\"ilpermissiongui\";i:11;s:15:\"ilpermissiongui\";i:12;s:15:\"ilpermissiongui\";i:13;s:15:\"ilpermissiongui\";i:14;s:15:\"ilpermissiongui\";i:15;s:15:\"ilpermissiongui\";i:16;s:15:\"ilpermissiongui\";i:17;s:15:\"ilpermissiongui\";i:18;s:15:\"ilpermissiongui\";i:19;s:15:\"ilpermissiongui\";i:20;s:15:\"ilpermissiongui\";i:21;s:15:\"ilpermissiongui\";i:22;s:15:\"ilpermissiongui\";i:23;s:15:\"ilpermissiongui\";i:24;s:15:\"ilpermissiongui\";i:25;s:15:\"ilpermissiongui\";i:26;s:15:\"ilpermissiongui\";i:27;s:15:\"ilpermissiongui\";i:28;s:15:\"ilpermissiongui\";i:29;s:15:\"ilpermissiongui\";i:30;s:15:\"ilpermissiongui\";i:31;s:15:\"ilpermissiongui\";i:32;s:15:\"ilpermissiongui\";i:33;s:15:\"ilpermissiongui\";i:34;s:15:\"ilpermissiongui\";i:35;s:15:\"ilpermissiongui\";i:36;s:15:\"ilpermissiongui\";i:37;s:15:\"ilpermissiongui\";i:38;s:15:\"ilpermissiongui\";i:39;s:15:\"ilpermissiongui\";i:40;s:15:\"ilpermissiongui\";i:41;s:15:\"ilpermissiongui\";i:42;s:15:\"ilpermissiongui\";i:43;s:15:\"ilpermissiongui\";i:44;s:15:\"ilpermissiongui\";i:45;s:15:\"ilpermissiongui\";i:46;s:15:\"ilpermissiongui\";i:47;s:15:\"ilpermissiongui\";i:48;s:15:\"ilpermissiongui\";i:49;s:15:\"ilpermissiongui\";i:50;s:15:\"ilpermissiongui\";i:51;s:15:\"ilpermissiongui\";i:52;s:15:\"ilpermissiongui\";i:53;s:15:\"ilpermissiongui\";i:54;s:15:\"ilpermissiongui\";i:55;s:15:\"ilpermissiongui\";i:56;s:15:\"ilpermissiongui\";i:57;s:19:\"iladministrationgui\";}s:15:\"ilpermissiongui\";a:57:{i:0;s:23:\"ilobjadvancededitinggui\";i:1;s:24:\"ilobjassessmentfoldergui\";i:2;s:20:\"ilobjauthsettingsgui\";i:3;s:24:\"ilobjcalendarsettingsgui\";i:4;s:18:\"ilobjuserfoldergui\";i:5;s:16:\"ilobjcategorygui\";i:6;s:25:\"ilobjcategoryreferencegui\";i:7;s:12:\"ilobjchatgui\";i:8;s:18:\"ilobjchatservergui\";i:9;s:25:\"ilobjcomponentsettingsgui\";i:10;s:14:\"ilobjcoursegui\";i:11;s:23:\"ilobjcoursereferencegui\";i:12;s:14:\"ilobjdlbookgui\";i:13;s:16:\"ilobjexercisegui\";i:14;s:20:\"ilobjexternalfeedgui\";i:15;s:29:\"ilobjexternaltoolssettingsgui\";i:16;s:26:\"ilobjfileaccesssettingsgui\";i:17;s:19:\"ilobjfilebasedlmgui\";i:18;s:12:\"ilobjfilegui\";i:19;s:14:\"ilobjfoldergui\";i:20;s:13:\"ilobjforumgui\";i:21;s:16:\"ilobjglossarygui\";i:22;s:13:\"ilobjgroupgui\";i:23;s:19:\"ilobjilinccoursegui\";i:24;s:22:\"ilobjlanguagefoldergui\";i:25;s:22:\"ilobjlearningmodulegui\";i:26;s:20:\"ilobjlinkresourcegui\";i:27;s:12:\"ilobjmailgui\";i:28;s:18:\"ilobjmdsettingsgui\";i:29;s:17:\"ilobjmediacastgui\";i:30;s:25:\"ilobjmediacastsettingsgui\";i:31;s:14:\"ilobjfoldergui\";i:32;s:17:\"ilobjmediapoolgui\";i:33;s:20:\"ilobjnewssettingsgui\";i:34;s:20:\"ilobjobjectfoldergui\";i:35;s:23:\"ilobjpaymentsettingsgui\";i:36;s:31:\"ilobjpersonaldesktopsettingsgui\";i:37;s:23:\"ilobjprivacysecuritygui\";i:38;s:20:\"ilobjquestionpoolgui\";i:39;s:22:\"ilobjrecoveryfoldergui\";i:40;s:18:\"ilobjrolefoldergui\";i:41;s:18:\"ilobjrootfoldergui\";i:42;s:26:\"ilobjsahslearningmodulegui\";i:43;s:22:\"ilobjsearchsettingsgui\";i:44;s:15:\"ilobjsessiongui\";i:45;s:21:\"ilobjstylesettingsgui\";i:46;s:28:\"ilobjsurveyadministrationgui\";i:47;s:14:\"ilobjsurveygui\";i:48;s:26:\"ilobjsurveyquestionpoolgui\";i:49;s:20:\"ilobjsystemfoldergui\";i:50;s:23:\"ilobjtaggingsettingsgui\";i:51;s:14:\"ilobjcoursegui\";i:52;s:12:\"ilobjtestgui\";i:53;s:18:\"ilobjuserfoldergui\";i:54;s:20:\"ilobjusertrackinggui\";i:55;s:12:\"ilobjwikigui\";i:56;s:19:\"iladministrationgui\";}s:17:\"illdapsettingsgui\";a:1:{i:0;s:20:\"ilobjauthsettingsgui\";}s:19:\"ilradiussettingsgui\";a:1:{i:0;s:20:\"ilobjauthsettingsgui\";}s:25:\"ilregistrationsettingsgui\";a:1:{i:0;s:20:\"ilobjauthsettingsgui\";}s:24:\"ilcalendarappointmentgui\";a:370:{i:0;s:16:\"ilcalendardaygui\";i:1;s:18:\"ilcalendarinboxgui\";i:2;s:18:\"ilcalendarmonthgui\";i:3;s:17:\"ilcalendarweekgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:16:\"ilcalendardaygui\";i:6;s:18:\"ilcalendarinboxgui\";i:7;s:18:\"ilcalendarmonthgui\";i:8;s:17:\"ilcalendarweekgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:16:\"ilcalendardaygui\";i:11;s:18:\"ilcalendarinboxgui\";i:12;s:18:\"ilcalendarmonthgui\";i:13;s:17:\"ilcalendarweekgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:16:\"ilcalendardaygui\";i:16;s:18:\"ilcalendarinboxgui\";i:17;s:18:\"ilcalendarmonthgui\";i:18;s:17:\"ilcalendarweekgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:16:\"ilcalendardaygui\";i:21;s:18:\"ilcalendarinboxgui\";i:22;s:18:\"ilcalendarmonthgui\";i:23;s:17:\"ilcalendarweekgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:16:\"ilcalendardaygui\";i:26;s:18:\"ilcalendarinboxgui\";i:27;s:18:\"ilcalendarmonthgui\";i:28;s:17:\"ilcalendarweekgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:16:\"ilcalendardaygui\";i:31;s:18:\"ilcalendarinboxgui\";i:32;s:18:\"ilcalendarmonthgui\";i:33;s:17:\"ilcalendarweekgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:16:\"ilcalendardaygui\";i:36;s:18:\"ilcalendarinboxgui\";i:37;s:18:\"ilcalendarmonthgui\";i:38;s:17:\"ilcalendarweekgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:16:\"ilcalendardaygui\";i:41;s:18:\"ilcalendarinboxgui\";i:42;s:18:\"ilcalendarmonthgui\";i:43;s:17:\"ilcalendarweekgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:16:\"ilcalendardaygui\";i:46;s:18:\"ilcalendarinboxgui\";i:47;s:18:\"ilcalendarmonthgui\";i:48;s:17:\"ilcalendarweekgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:16:\"ilcalendardaygui\";i:51;s:18:\"ilcalendarinboxgui\";i:52;s:18:\"ilcalendarmonthgui\";i:53;s:17:\"ilcalendarweekgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:16:\"ilcalendardaygui\";i:56;s:18:\"ilcalendarinboxgui\";i:57;s:18:\"ilcalendarmonthgui\";i:58;s:17:\"ilcalendarweekgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:16:\"ilcalendardaygui\";i:61;s:18:\"ilcalendarinboxgui\";i:62;s:18:\"ilcalendarmonthgui\";i:63;s:17:\"ilcalendarweekgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:16:\"ilcalendardaygui\";i:66;s:18:\"ilcalendarinboxgui\";i:67;s:18:\"ilcalendarmonthgui\";i:68;s:17:\"ilcalendarweekgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:16:\"ilcalendardaygui\";i:71;s:18:\"ilcalendarinboxgui\";i:72;s:18:\"ilcalendarmonthgui\";i:73;s:17:\"ilcalendarweekgui\";i:74;s:18:\"ilcalendarblockgui\";i:75;s:16:\"ilcalendardaygui\";i:76;s:18:\"ilcalendarinboxgui\";i:77;s:18:\"ilcalendarmonthgui\";i:78;s:17:\"ilcalendarweekgui\";i:79;s:20:\"ilpdcalendarblockgui\";i:80;s:16:\"ilcalendardaygui\";i:81;s:18:\"ilcalendarinboxgui\";i:82;s:18:\"ilcalendarmonthgui\";i:83;s:17:\"ilcalendarweekgui\";i:84;s:18:\"ilcalendarblockgui\";i:85;s:16:\"ilcalendardaygui\";i:86;s:18:\"ilcalendarinboxgui\";i:87;s:18:\"ilcalendarmonthgui\";i:88;s:17:\"ilcalendarweekgui\";i:89;s:20:\"ilpdcalendarblockgui\";i:90;s:16:\"ilcalendardaygui\";i:91;s:18:\"ilcalendarinboxgui\";i:92;s:18:\"ilcalendarmonthgui\";i:93;s:17:\"ilcalendarweekgui\";i:94;s:18:\"ilcalendarblockgui\";i:95;s:16:\"ilcalendardaygui\";i:96;s:18:\"ilcalendarinboxgui\";i:97;s:18:\"ilcalendarmonthgui\";i:98;s:17:\"ilcalendarweekgui\";i:99;s:20:\"ilpdcalendarblockgui\";i:100;s:16:\"ilcalendardaygui\";i:101;s:18:\"ilcalendarinboxgui\";i:102;s:18:\"ilcalendarmonthgui\";i:103;s:17:\"ilcalendarweekgui\";i:104;s:18:\"ilcalendarblockgui\";i:105;s:16:\"ilcalendardaygui\";i:106;s:18:\"ilcalendarinboxgui\";i:107;s:18:\"ilcalendarmonthgui\";i:108;s:17:\"ilcalendarweekgui\";i:109;s:20:\"ilpdcalendarblockgui\";i:110;s:16:\"ilcalendardaygui\";i:111;s:18:\"ilcalendarinboxgui\";i:112;s:18:\"ilcalendarmonthgui\";i:113;s:17:\"ilcalendarweekgui\";i:114;s:18:\"ilcalendarblockgui\";i:115;s:16:\"ilcalendardaygui\";i:116;s:18:\"ilcalendarinboxgui\";i:117;s:18:\"ilcalendarmonthgui\";i:118;s:17:\"ilcalendarweekgui\";i:119;s:20:\"ilpdcalendarblockgui\";i:120;s:16:\"ilcalendardaygui\";i:121;s:18:\"ilcalendarinboxgui\";i:122;s:18:\"ilcalendarmonthgui\";i:123;s:17:\"ilcalendarweekgui\";i:124;s:18:\"ilcalendarblockgui\";i:125;s:16:\"ilcalendardaygui\";i:126;s:18:\"ilcalendarinboxgui\";i:127;s:18:\"ilcalendarmonthgui\";i:128;s:17:\"ilcalendarweekgui\";i:129;s:20:\"ilpdcalendarblockgui\";i:130;s:16:\"ilcalendardaygui\";i:131;s:18:\"ilcalendarinboxgui\";i:132;s:18:\"ilcalendarmonthgui\";i:133;s:17:\"ilcalendarweekgui\";i:134;s:18:\"ilcalendarblockgui\";i:135;s:16:\"ilcalendardaygui\";i:136;s:18:\"ilcalendarinboxgui\";i:137;s:18:\"ilcalendarmonthgui\";i:138;s:17:\"ilcalendarweekgui\";i:139;s:20:\"ilpdcalendarblockgui\";i:140;s:16:\"ilcalendardaygui\";i:141;s:18:\"ilcalendarinboxgui\";i:142;s:18:\"ilcalendarmonthgui\";i:143;s:17:\"ilcalendarweekgui\";i:144;s:18:\"ilcalendarblockgui\";i:145;s:16:\"ilcalendardaygui\";i:146;s:18:\"ilcalendarinboxgui\";i:147;s:18:\"ilcalendarmonthgui\";i:148;s:17:\"ilcalendarweekgui\";i:149;s:20:\"ilpdcalendarblockgui\";i:150;s:16:\"ilcalendardaygui\";i:151;s:18:\"ilcalendarinboxgui\";i:152;s:18:\"ilcalendarmonthgui\";i:153;s:17:\"ilcalendarweekgui\";i:154;s:18:\"ilcalendarblockgui\";i:155;s:16:\"ilcalendardaygui\";i:156;s:18:\"ilcalendarinboxgui\";i:157;s:18:\"ilcalendarmonthgui\";i:158;s:17:\"ilcalendarweekgui\";i:159;s:20:\"ilpdcalendarblockgui\";i:160;s:16:\"ilcalendardaygui\";i:161;s:18:\"ilcalendarinboxgui\";i:162;s:18:\"ilcalendarmonthgui\";i:163;s:17:\"ilcalendarweekgui\";i:164;s:18:\"ilcalendarblockgui\";i:165;s:16:\"ilcalendardaygui\";i:166;s:18:\"ilcalendarinboxgui\";i:167;s:18:\"ilcalendarmonthgui\";i:168;s:17:\"ilcalendarweekgui\";i:169;s:20:\"ilpdcalendarblockgui\";i:170;s:16:\"ilcalendardaygui\";i:171;s:18:\"ilcalendarinboxgui\";i:172;s:18:\"ilcalendarmonthgui\";i:173;s:17:\"ilcalendarweekgui\";i:174;s:18:\"ilcalendarblockgui\";i:175;s:16:\"ilcalendardaygui\";i:176;s:18:\"ilcalendarinboxgui\";i:177;s:18:\"ilcalendarmonthgui\";i:178;s:17:\"ilcalendarweekgui\";i:179;s:20:\"ilpdcalendarblockgui\";i:180;s:16:\"ilcalendardaygui\";i:181;s:18:\"ilcalendarinboxgui\";i:182;s:18:\"ilcalendarmonthgui\";i:183;s:17:\"ilcalendarweekgui\";i:184;s:18:\"ilcalendarblockgui\";i:185;s:16:\"ilcalendardaygui\";i:186;s:18:\"ilcalendarinboxgui\";i:187;s:18:\"ilcalendarmonthgui\";i:188;s:17:\"ilcalendarweekgui\";i:189;s:20:\"ilpdcalendarblockgui\";i:190;s:16:\"ilcalendardaygui\";i:191;s:18:\"ilcalendarinboxgui\";i:192;s:18:\"ilcalendarmonthgui\";i:193;s:17:\"ilcalendarweekgui\";i:194;s:18:\"ilcalendarblockgui\";i:195;s:16:\"ilcalendardaygui\";i:196;s:18:\"ilcalendarinboxgui\";i:197;s:18:\"ilcalendarmonthgui\";i:198;s:17:\"ilcalendarweekgui\";i:199;s:20:\"ilpdcalendarblockgui\";i:200;s:16:\"ilcalendardaygui\";i:201;s:18:\"ilcalendarinboxgui\";i:202;s:18:\"ilcalendarmonthgui\";i:203;s:17:\"ilcalendarweekgui\";i:204;s:18:\"ilcalendarblockgui\";i:205;s:16:\"ilcalendardaygui\";i:206;s:18:\"ilcalendarinboxgui\";i:207;s:18:\"ilcalendarmonthgui\";i:208;s:17:\"ilcalendarweekgui\";i:209;s:20:\"ilpdcalendarblockgui\";i:210;s:16:\"ilcalendardaygui\";i:211;s:18:\"ilcalendarinboxgui\";i:212;s:18:\"ilcalendarmonthgui\";i:213;s:17:\"ilcalendarweekgui\";i:214;s:18:\"ilcalendarblockgui\";i:215;s:16:\"ilcalendardaygui\";i:216;s:18:\"ilcalendarinboxgui\";i:217;s:18:\"ilcalendarmonthgui\";i:218;s:17:\"ilcalendarweekgui\";i:219;s:20:\"ilpdcalendarblockgui\";i:220;s:16:\"ilcalendardaygui\";i:221;s:18:\"ilcalendarinboxgui\";i:222;s:18:\"ilcalendarmonthgui\";i:223;s:17:\"ilcalendarweekgui\";i:224;s:18:\"ilcalendarblockgui\";i:225;s:16:\"ilcalendardaygui\";i:226;s:18:\"ilcalendarinboxgui\";i:227;s:18:\"ilcalendarmonthgui\";i:228;s:17:\"ilcalendarweekgui\";i:229;s:20:\"ilpdcalendarblockgui\";i:230;s:16:\"ilcalendardaygui\";i:231;s:18:\"ilcalendarinboxgui\";i:232;s:18:\"ilcalendarmonthgui\";i:233;s:17:\"ilcalendarweekgui\";i:234;s:18:\"ilcalendarblockgui\";i:235;s:16:\"ilcalendardaygui\";i:236;s:18:\"ilcalendarinboxgui\";i:237;s:18:\"ilcalendarmonthgui\";i:238;s:17:\"ilcalendarweekgui\";i:239;s:20:\"ilpdcalendarblockgui\";i:240;s:16:\"ilcalendardaygui\";i:241;s:18:\"ilcalendarinboxgui\";i:242;s:18:\"ilcalendarmonthgui\";i:243;s:17:\"ilcalendarweekgui\";i:244;s:18:\"ilcalendarblockgui\";i:245;s:16:\"ilcalendardaygui\";i:246;s:18:\"ilcalendarinboxgui\";i:247;s:18:\"ilcalendarmonthgui\";i:248;s:17:\"ilcalendarweekgui\";i:249;s:20:\"ilpdcalendarblockgui\";i:250;s:16:\"ilcalendardaygui\";i:251;s:18:\"ilcalendarinboxgui\";i:252;s:18:\"ilcalendarmonthgui\";i:253;s:17:\"ilcalendarweekgui\";i:254;s:18:\"ilcalendarblockgui\";i:255;s:16:\"ilcalendardaygui\";i:256;s:18:\"ilcalendarinboxgui\";i:257;s:18:\"ilcalendarmonthgui\";i:258;s:17:\"ilcalendarweekgui\";i:259;s:20:\"ilpdcalendarblockgui\";i:260;s:16:\"ilcalendardaygui\";i:261;s:18:\"ilcalendarinboxgui\";i:262;s:18:\"ilcalendarmonthgui\";i:263;s:17:\"ilcalendarweekgui\";i:264;s:18:\"ilcalendarblockgui\";i:265;s:16:\"ilcalendardaygui\";i:266;s:18:\"ilcalendarinboxgui\";i:267;s:18:\"ilcalendarmonthgui\";i:268;s:17:\"ilcalendarweekgui\";i:269;s:20:\"ilpdcalendarblockgui\";i:270;s:16:\"ilcalendardaygui\";i:271;s:18:\"ilcalendarinboxgui\";i:272;s:18:\"ilcalendarmonthgui\";i:273;s:17:\"ilcalendarweekgui\";i:274;s:18:\"ilcalendarblockgui\";i:275;s:16:\"ilcalendardaygui\";i:276;s:18:\"ilcalendarinboxgui\";i:277;s:18:\"ilcalendarmonthgui\";i:278;s:17:\"ilcalendarweekgui\";i:279;s:20:\"ilpdcalendarblockgui\";i:280;s:16:\"ilcalendardaygui\";i:281;s:18:\"ilcalendarinboxgui\";i:282;s:18:\"ilcalendarmonthgui\";i:283;s:17:\"ilcalendarweekgui\";i:284;s:18:\"ilcalendarblockgui\";i:285;s:16:\"ilcalendardaygui\";i:286;s:18:\"ilcalendarinboxgui\";i:287;s:18:\"ilcalendarmonthgui\";i:288;s:17:\"ilcalendarweekgui\";i:289;s:20:\"ilpdcalendarblockgui\";i:290;s:16:\"ilcalendardaygui\";i:291;s:18:\"ilcalendarinboxgui\";i:292;s:18:\"ilcalendarmonthgui\";i:293;s:17:\"ilcalendarweekgui\";i:294;s:18:\"ilcalendarblockgui\";i:295;s:16:\"ilcalendardaygui\";i:296;s:18:\"ilcalendarinboxgui\";i:297;s:18:\"ilcalendarmonthgui\";i:298;s:17:\"ilcalendarweekgui\";i:299;s:20:\"ilpdcalendarblockgui\";i:300;s:16:\"ilcalendardaygui\";i:301;s:18:\"ilcalendarinboxgui\";i:302;s:18:\"ilcalendarmonthgui\";i:303;s:17:\"ilcalendarweekgui\";i:304;s:18:\"ilcalendarblockgui\";i:305;s:16:\"ilcalendardaygui\";i:306;s:18:\"ilcalendarinboxgui\";i:307;s:18:\"ilcalendarmonthgui\";i:308;s:17:\"ilcalendarweekgui\";i:309;s:20:\"ilpdcalendarblockgui\";i:310;s:16:\"ilcalendardaygui\";i:311;s:18:\"ilcalendarinboxgui\";i:312;s:18:\"ilcalendarmonthgui\";i:313;s:17:\"ilcalendarweekgui\";i:314;s:18:\"ilcalendarblockgui\";i:315;s:16:\"ilcalendardaygui\";i:316;s:18:\"ilcalendarinboxgui\";i:317;s:18:\"ilcalendarmonthgui\";i:318;s:17:\"ilcalendarweekgui\";i:319;s:20:\"ilpdcalendarblockgui\";i:320;s:16:\"ilcalendardaygui\";i:321;s:18:\"ilcalendarinboxgui\";i:322;s:18:\"ilcalendarmonthgui\";i:323;s:17:\"ilcalendarweekgui\";i:324;s:18:\"ilcalendarblockgui\";i:325;s:16:\"ilcalendardaygui\";i:326;s:18:\"ilcalendarinboxgui\";i:327;s:18:\"ilcalendarmonthgui\";i:328;s:17:\"ilcalendarweekgui\";i:329;s:20:\"ilpdcalendarblockgui\";i:330;s:16:\"ilcalendardaygui\";i:331;s:18:\"ilcalendarinboxgui\";i:332;s:18:\"ilcalendarmonthgui\";i:333;s:17:\"ilcalendarweekgui\";i:334;s:18:\"ilcalendarblockgui\";i:335;s:16:\"ilcalendardaygui\";i:336;s:18:\"ilcalendarinboxgui\";i:337;s:18:\"ilcalendarmonthgui\";i:338;s:17:\"ilcalendarweekgui\";i:339;s:20:\"ilpdcalendarblockgui\";i:340;s:16:\"ilcalendardaygui\";i:341;s:18:\"ilcalendarinboxgui\";i:342;s:18:\"ilcalendarmonthgui\";i:343;s:17:\"ilcalendarweekgui\";i:344;s:18:\"ilcalendarblockgui\";i:345;s:16:\"ilcalendardaygui\";i:346;s:18:\"ilcalendarinboxgui\";i:347;s:18:\"ilcalendarmonthgui\";i:348;s:17:\"ilcalendarweekgui\";i:349;s:20:\"ilpdcalendarblockgui\";i:350;s:16:\"ilcalendardaygui\";i:351;s:18:\"ilcalendarinboxgui\";i:352;s:18:\"ilcalendarmonthgui\";i:353;s:17:\"ilcalendarweekgui\";i:354;s:18:\"ilcalendarblockgui\";i:355;s:16:\"ilcalendardaygui\";i:356;s:18:\"ilcalendarinboxgui\";i:357;s:18:\"ilcalendarmonthgui\";i:358;s:17:\"ilcalendarweekgui\";i:359;s:20:\"ilpdcalendarblockgui\";i:360;s:16:\"ilcalendardaygui\";i:361;s:18:\"ilcalendarinboxgui\";i:362;s:18:\"ilcalendarmonthgui\";i:363;s:17:\"ilcalendarweekgui\";i:364;s:18:\"ilcalendarblockgui\";i:365;s:16:\"ilcalendardaygui\";i:366;s:18:\"ilcalendarinboxgui\";i:367;s:18:\"ilcalendarmonthgui\";i:368;s:17:\"ilcalendarweekgui\";i:369;s:20:\"ilpdcalendarblockgui\";}s:16:\"ilcalendardaygui\";a:74:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarinboxgui\";a:74:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";}s:18:\"ilcalendarmonthgui\";a:74:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";}s:17:\"ilcalendarweekgui\";a:74:{i:0;s:18:\"ilcalendarblockgui\";i:1;s:20:\"ilpdcalendarblockgui\";i:2;s:18:\"ilcalendarblockgui\";i:3;s:20:\"ilpdcalendarblockgui\";i:4;s:18:\"ilcalendarblockgui\";i:5;s:20:\"ilpdcalendarblockgui\";i:6;s:18:\"ilcalendarblockgui\";i:7;s:20:\"ilpdcalendarblockgui\";i:8;s:18:\"ilcalendarblockgui\";i:9;s:20:\"ilpdcalendarblockgui\";i:10;s:18:\"ilcalendarblockgui\";i:11;s:20:\"ilpdcalendarblockgui\";i:12;s:18:\"ilcalendarblockgui\";i:13;s:20:\"ilpdcalendarblockgui\";i:14;s:18:\"ilcalendarblockgui\";i:15;s:20:\"ilpdcalendarblockgui\";i:16;s:18:\"ilcalendarblockgui\";i:17;s:20:\"ilpdcalendarblockgui\";i:18;s:18:\"ilcalendarblockgui\";i:19;s:20:\"ilpdcalendarblockgui\";i:20;s:18:\"ilcalendarblockgui\";i:21;s:20:\"ilpdcalendarblockgui\";i:22;s:18:\"ilcalendarblockgui\";i:23;s:20:\"ilpdcalendarblockgui\";i:24;s:18:\"ilcalendarblockgui\";i:25;s:20:\"ilpdcalendarblockgui\";i:26;s:18:\"ilcalendarblockgui\";i:27;s:20:\"ilpdcalendarblockgui\";i:28;s:18:\"ilcalendarblockgui\";i:29;s:20:\"ilpdcalendarblockgui\";i:30;s:18:\"ilcalendarblockgui\";i:31;s:20:\"ilpdcalendarblockgui\";i:32;s:18:\"ilcalendarblockgui\";i:33;s:20:\"ilpdcalendarblockgui\";i:34;s:18:\"ilcalendarblockgui\";i:35;s:20:\"ilpdcalendarblockgui\";i:36;s:18:\"ilcalendarblockgui\";i:37;s:20:\"ilpdcalendarblockgui\";i:38;s:18:\"ilcalendarblockgui\";i:39;s:20:\"ilpdcalendarblockgui\";i:40;s:18:\"ilcalendarblockgui\";i:41;s:20:\"ilpdcalendarblockgui\";i:42;s:18:\"ilcalendarblockgui\";i:43;s:20:\"ilpdcalendarblockgui\";i:44;s:18:\"ilcalendarblockgui\";i:45;s:20:\"ilpdcalendarblockgui\";i:46;s:18:\"ilcalendarblockgui\";i:47;s:20:\"ilpdcalendarblockgui\";i:48;s:18:\"ilcalendarblockgui\";i:49;s:20:\"ilpdcalendarblockgui\";i:50;s:18:\"ilcalendarblockgui\";i:51;s:20:\"ilpdcalendarblockgui\";i:52;s:18:\"ilcalendarblockgui\";i:53;s:20:\"ilpdcalendarblockgui\";i:54;s:18:\"ilcalendarblockgui\";i:55;s:20:\"ilpdcalendarblockgui\";i:56;s:18:\"ilcalendarblockgui\";i:57;s:20:\"ilpdcalendarblockgui\";i:58;s:18:\"ilcalendarblockgui\";i:59;s:20:\"ilpdcalendarblockgui\";i:60;s:18:\"ilcalendarblockgui\";i:61;s:20:\"ilpdcalendarblockgui\";i:62;s:18:\"ilcalendarblockgui\";i:63;s:20:\"ilpdcalendarblockgui\";i:64;s:18:\"ilcalendarblockgui\";i:65;s:20:\"ilpdcalendarblockgui\";i:66;s:18:\"ilcalendarblockgui\";i:67;s:20:\"ilpdcalendarblockgui\";i:68;s:18:\"ilcalendarblockgui\";i:69;s:20:\"ilpdcalendarblockgui\";i:70;s:18:\"ilcalendarblockgui\";i:71;s:20:\"ilpdcalendarblockgui\";i:72;s:18:\"ilcalendarblockgui\";i:73;s:20:\"ilpdcalendarblockgui\";}s:13:\"ilnewsitemgui\";a:37:{i:0;s:24:\"ilnewsforcontextblockgui\";i:1;s:24:\"ilnewsforcontextblockgui\";i:2;s:24:\"ilnewsforcontextblockgui\";i:3;s:24:\"ilnewsforcontextblockgui\";i:4;s:24:\"ilnewsforcontextblockgui\";i:5;s:24:\"ilnewsforcontextblockgui\";i:6;s:24:\"ilnewsforcontextblockgui\";i:7;s:24:\"ilnewsforcontextblockgui\";i:8;s:24:\"ilnewsforcontextblockgui\";i:9;s:24:\"ilnewsforcontextblockgui\";i:10;s:24:\"ilnewsforcontextblockgui\";i:11;s:24:\"ilnewsforcontextblockgui\";i:12;s:24:\"ilnewsforcontextblockgui\";i:13;s:24:\"ilnewsforcontextblockgui\";i:14;s:24:\"ilnewsforcontextblockgui\";i:15;s:24:\"ilnewsforcontextblockgui\";i:16;s:24:\"ilnewsforcontextblockgui\";i:17;s:24:\"ilnewsforcontextblockgui\";i:18;s:24:\"ilnewsforcontextblockgui\";i:19;s:24:\"ilnewsforcontextblockgui\";i:20;s:24:\"ilnewsforcontextblockgui\";i:21;s:24:\"ilnewsforcontextblockgui\";i:22;s:24:\"ilnewsforcontextblockgui\";i:23;s:24:\"ilnewsforcontextblockgui\";i:24;s:24:\"ilnewsforcontextblockgui\";i:25;s:24:\"ilnewsforcontextblockgui\";i:26;s:24:\"ilnewsforcontextblockgui\";i:27;s:24:\"ilnewsforcontextblockgui\";i:28;s:24:\"ilnewsforcontextblockgui\";i:29;s:24:\"ilnewsforcontextblockgui\";i:30;s:24:\"ilnewsforcontextblockgui\";i:31;s:24:\"ilnewsforcontextblockgui\";i:32;s:24:\"ilnewsforcontextblockgui\";i:33;s:24:\"ilnewsforcontextblockgui\";i:34;s:24:\"ilnewsforcontextblockgui\";i:35;s:24:\"ilnewsforcontextblockgui\";i:36;s:24:\"ilnewsforcontextblockgui\";}s:22:\"ilpublicuserprofilegui\";a:88:{i:0;s:21:\"ilusersonlineblockgui\";i:1;s:21:\"ilusersonlineblockgui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:21:\"ilusersonlineblockgui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:21:\"ilusersonlineblockgui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:12:\"ilobjchatgui\";i:9;s:21:\"ilusersonlineblockgui\";i:10;s:21:\"ilusersonlineblockgui\";i:11;s:21:\"ilusersonlineblockgui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:14:\"ilobjcoursegui\";i:16;s:21:\"ilusersonlineblockgui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:21:\"ilusersonlineblockgui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:15:\"ilpageobjectgui\";i:21;s:21:\"ilusersonlineblockgui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:21:\"ilusersonlineblockgui\";i:24;s:15:\"ilinfoscreengui\";i:25;s:15:\"ilpageobjectgui\";i:26;s:21:\"ilusersonlineblockgui\";i:27;s:15:\"ilinfoscreengui\";i:28;s:15:\"ilpageobjectgui\";i:29;s:21:\"ilusersonlineblockgui\";i:30;s:21:\"ilusersonlineblockgui\";i:31;s:21:\"ilusersonlineblockgui\";i:32;s:15:\"ilinfoscreengui\";i:33;s:15:\"ilpageobjectgui\";i:34;s:21:\"ilusersonlineblockgui\";i:35;s:21:\"ilusersonlineblockgui\";i:36;s:15:\"ilinfoscreengui\";i:37;s:13:\"ilobjforumgui\";i:38;s:15:\"ilpageobjectgui\";i:39;s:15:\"ilpageobjectgui\";i:40;s:21:\"ilusersonlineblockgui\";i:41;s:15:\"ilinfoscreengui\";i:42;s:21:\"ilusersonlineblockgui\";i:43;s:21:\"ilusersonlineblockgui\";i:44;s:21:\"ilusersonlineblockgui\";i:45;s:15:\"ilinfoscreengui\";i:46;s:15:\"ilpageobjectgui\";i:47;s:13:\"ilobjgroupgui\";i:48;s:21:\"ilusersonlineblockgui\";i:49;s:15:\"ilinfoscreengui\";i:50;s:19:\"ilobjilinccoursegui\";i:51;s:21:\"ilusersonlineblockgui\";i:52;s:15:\"ilinfoscreengui\";i:53;s:15:\"ilpageobjectgui\";i:54;s:21:\"ilusersonlineblockgui\";i:55;s:15:\"ilinfoscreengui\";i:56;s:21:\"ilusersonlineblockgui\";i:57;s:15:\"ilinfoscreengui\";i:58;s:21:\"ilusersonlineblockgui\";i:59;s:15:\"ilinfoscreengui\";i:60;s:21:\"ilusersonlineblockgui\";i:61;s:21:\"ilusersonlineblockgui\";i:62;s:21:\"ilusersonlineblockgui\";i:63;s:15:\"ilinfoscreengui\";i:64;s:15:\"ilpageobjectgui\";i:65;s:15:\"ilpageobjectgui\";i:66;s:15:\"ilpageobjectgui\";i:67;s:21:\"ilusersonlineblockgui\";i:68;s:15:\"ilpageobjectgui\";i:69;s:21:\"ilusersonlineblockgui\";i:70;s:15:\"ilinfoscreengui\";i:71;s:21:\"ilusersonlineblockgui\";i:72;s:15:\"ilinfoscreengui\";i:73;s:21:\"ilusersonlineblockgui\";i:74;s:15:\"ilinfoscreengui\";i:75;s:21:\"ilusersonlineblockgui\";i:76;s:21:\"ilusersonlineblockgui\";i:77;s:21:\"ilusersonlineblockgui\";i:78;s:15:\"ilinfoscreengui\";i:79;s:15:\"ilpageobjectgui\";i:80;s:15:\"ilpageobjectgui\";i:81;s:14:\"ilobjcoursegui\";i:82;s:15:\"ilpageobjectgui\";i:83;s:21:\"ilusersonlineblockgui\";i:84;s:15:\"ilinfoscreengui\";i:85;s:15:\"ilpageobjectgui\";i:86;s:13:\"ilwikipagegui\";i:87;s:12:\"ilobjwikigui\";}s:18:\"ilbookmarkblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:18:\"ilcalendarblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:15:\"ildummyblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:22:\"ilexternalfeedblockgui\";a:38:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:20:\"ilobjexternalfeedgui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";i:37;s:11:\"ilcolumngui\";}s:14:\"ilhtmlblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:24:\"ilnewsforcontextblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:20:\"ilpdcalendarblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:24:\"ilpdexternalfeedblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:20:\"ilpdfeedbackblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:16:\"ilpdmailblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:16:\"ilpdnewsblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:17:\"ilpdnotesblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:25:\"ilpdselecteditemsblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:22:\"ilpdsysmessageblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:19:\"ilpdtaggingblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:21:\"ilusersonlineblockgui\";a:37:{i:0;s:11:\"ilcolumngui\";i:1;s:11:\"ilcolumngui\";i:2;s:11:\"ilcolumngui\";i:3;s:11:\"ilcolumngui\";i:4;s:11:\"ilcolumngui\";i:5;s:11:\"ilcolumngui\";i:6;s:11:\"ilcolumngui\";i:7;s:11:\"ilcolumngui\";i:8;s:11:\"ilcolumngui\";i:9;s:11:\"ilcolumngui\";i:10;s:11:\"ilcolumngui\";i:11;s:11:\"ilcolumngui\";i:12;s:11:\"ilcolumngui\";i:13;s:11:\"ilcolumngui\";i:14;s:11:\"ilcolumngui\";i:15;s:11:\"ilcolumngui\";i:16;s:11:\"ilcolumngui\";i:17;s:11:\"ilcolumngui\";i:18;s:11:\"ilcolumngui\";i:19;s:11:\"ilcolumngui\";i:20;s:11:\"ilcolumngui\";i:21;s:11:\"ilcolumngui\";i:22;s:11:\"ilcolumngui\";i:23;s:11:\"ilcolumngui\";i:24;s:11:\"ilcolumngui\";i:25;s:11:\"ilcolumngui\";i:26;s:11:\"ilcolumngui\";i:27;s:11:\"ilcolumngui\";i:28;s:11:\"ilcolumngui\";i:29;s:11:\"ilcolumngui\";i:30;s:11:\"ilcolumngui\";i:31;s:11:\"ilcolumngui\";i:32;s:11:\"ilcolumngui\";i:33;s:11:\"ilcolumngui\";i:34;s:11:\"ilcolumngui\";i:35;s:11:\"ilcolumngui\";i:36;s:11:\"ilcolumngui\";}s:11:\"ilcolumngui\";a:37:{i:0;s:15:\"ilinfoscreengui\";i:1;s:16:\"ilobjcategorygui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:18:\"ilcoursecontentgui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:14:\"ilobjcoursegui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";i:10;s:15:\"ilinfoscreengui\";i:11;s:15:\"ilinfoscreengui\";i:12;s:18:\"ilcoursecontentgui\";i:13;s:15:\"ilinfoscreengui\";i:14;s:14:\"ilobjfoldergui\";i:15;s:15:\"ilinfoscreengui\";i:16;s:13:\"ilobjforumgui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:18:\"ilcoursecontentgui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:13:\"ilobjgroupgui\";i:21;s:15:\"ilinfoscreengui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:15:\"ilinfoscreengui\";i:24;s:15:\"ilinfoscreengui\";i:25;s:15:\"ilinfoscreengui\";i:26;s:18:\"ilcoursecontentgui\";i:27;s:15:\"ilinfoscreengui\";i:28;s:14:\"ilobjfoldergui\";i:29;s:18:\"ilobjrootfoldergui\";i:30;s:15:\"ilinfoscreengui\";i:31;s:15:\"ilinfoscreengui\";i:32;s:15:\"ilinfoscreengui\";i:33;s:18:\"ilcoursecontentgui\";i:34;s:15:\"ilinfoscreengui\";i:35;s:14:\"ilobjcoursegui\";i:36;s:15:\"ilinfoscreengui\";}s:13:\"ilfeedbackgui\";a:24:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";i:10;s:15:\"ilinfoscreengui\";i:11;s:15:\"ilinfoscreengui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:15:\"ilinfoscreengui\";i:14;s:15:\"ilinfoscreengui\";i:15;s:15:\"ilinfoscreengui\";i:16;s:15:\"ilinfoscreengui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:15:\"ilinfoscreengui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:15:\"ilinfoscreengui\";i:21;s:15:\"ilinfoscreengui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:15:\"ilinfoscreengui\";}s:9:\"ilnotegui\";a:25:{i:0;s:15:\"ilinfoscreengui\";i:1;s:15:\"ilinfoscreengui\";i:2;s:15:\"ilinfoscreengui\";i:3;s:15:\"ilinfoscreengui\";i:4;s:15:\"ilinfoscreengui\";i:5;s:15:\"ilinfoscreengui\";i:6;s:15:\"ilinfoscreengui\";i:7;s:15:\"ilinfoscreengui\";i:8;s:15:\"ilinfoscreengui\";i:9;s:15:\"ilinfoscreengui\";i:10;s:15:\"ilinfoscreengui\";i:11;s:15:\"ilinfoscreengui\";i:12;s:15:\"ilinfoscreengui\";i:13;s:15:\"ilinfoscreengui\";i:14;s:15:\"ilinfoscreengui\";i:15;s:15:\"ilinfoscreengui\";i:16;s:15:\"ilinfoscreengui\";i:17;s:15:\"ilinfoscreengui\";i:18;s:15:\"ilinfoscreengui\";i:19;s:15:\"ilinfoscreengui\";i:20;s:15:\"ilinfoscreengui\";i:21;s:15:\"ilinfoscreengui\";i:22;s:15:\"ilinfoscreengui\";i:23;s:15:\"ilinfoscreengui\";i:24;s:13:\"ilwikipagegui\";}s:13:\"illpfiltergui\";a:30:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";i:24;s:20:\"illplistofobjectsgui\";i:25;s:21:\"illplistofprogressgui\";i:26;s:20:\"illplistofobjectsgui\";i:27;s:21:\"illplistofprogressgui\";i:28;s:20:\"illplistofobjectsgui\";i:29;s:21:\"illplistofprogressgui\";}s:17:\"ilpdfpresentation\";a:30:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:21:\"illplistofprogressgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:21:\"illplistofprogressgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:21:\"illplistofprogressgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:21:\"illplistofprogressgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:21:\"illplistofprogressgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:21:\"illplistofprogressgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:21:\"illplistofprogressgui\";i:14;s:20:\"illplistofobjectsgui\";i:15;s:21:\"illplistofprogressgui\";i:16;s:20:\"illplistofobjectsgui\";i:17;s:21:\"illplistofprogressgui\";i:18;s:20:\"illplistofobjectsgui\";i:19;s:21:\"illplistofprogressgui\";i:20;s:20:\"illplistofobjectsgui\";i:21;s:21:\"illplistofprogressgui\";i:22;s:20:\"illplistofobjectsgui\";i:23;s:21:\"illplistofprogressgui\";i:24;s:20:\"illplistofobjectsgui\";i:25;s:21:\"illplistofprogressgui\";i:26;s:20:\"illplistofobjectsgui\";i:27;s:21:\"illplistofprogressgui\";i:28;s:20:\"illplistofobjectsgui\";i:29;s:21:\"illplistofprogressgui\";}s:15:\"iluserfiltergui\";a:15:{i:0;s:20:\"illplistofobjectsgui\";i:1;s:20:\"illplistofobjectsgui\";i:2;s:20:\"illplistofobjectsgui\";i:3;s:20:\"illplistofobjectsgui\";i:4;s:20:\"illplistofobjectsgui\";i:5;s:20:\"illplistofobjectsgui\";i:6;s:20:\"illplistofobjectsgui\";i:7;s:20:\"illplistofobjectsgui\";i:8;s:20:\"illplistofobjectsgui\";i:9;s:20:\"illplistofobjectsgui\";i:10;s:20:\"illplistofobjectsgui\";i:11;s:20:\"illplistofobjectsgui\";i:12;s:20:\"illplistofobjectsgui\";i:13;s:20:\"illplistofobjectsgui\";i:14;s:20:\"illplistofobjectsgui\";}s:17:\"illmstatisticsgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:20:\"illplistofobjectsgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:21:\"illplistofprogressgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:21:\"illplistofsettingsgui\";a:15:{i:0;s:21:\"illearningprogressgui\";i:1;s:21:\"illearningprogressgui\";i:2;s:21:\"illearningprogressgui\";i:3;s:21:\"illearningprogressgui\";i:4;s:21:\"illearningprogressgui\";i:5;s:21:\"illearningprogressgui\";i:6;s:21:\"illearningprogressgui\";i:7;s:21:\"illearningprogressgui\";i:8;s:21:\"illearningprogressgui\";i:9;s:21:\"illearningprogressgui\";i:10;s:21:\"illearningprogressgui\";i:11;s:21:\"illearningprogressgui\";i:12;s:21:\"illearningprogressgui\";i:13;s:21:\"illearningprogressgui\";i:14;s:21:\"illearningprogressgui\";}s:21:\"illearningprogressgui\";a:15:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:14:\"ilobjdlbookgui\";i:4;s:16:\"ilobjexercisegui\";i:5;s:19:\"ilobjfilebasedlmgui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:13:\"ilobjgroupgui\";i:8;s:22:\"ilobjlearningmodulegui\";i:9;s:14:\"ilobjfoldergui\";i:10;s:14:\"ilobjcoursegui\";i:11;s:12:\"ilobjtestgui\";i:12;s:12:\"ilobjusergui\";i:13;s:12:\"ilobjusergui\";i:14;s:20:\"ilobjusertrackinggui\";}s:17:\"ilobjilincusergui\";a:4:{i:0;s:12:\"ilobjusergui\";i:1;s:12:\"ilobjusergui\";i:2;s:12:\"ilobjusergui\";i:3;s:12:\"ilobjusergui\";}s:12:\"ilobjusergui\";a:4:{i:0;s:20:\"iladminusersearchgui\";i:1;s:16:\"ilobjcategorygui\";i:2;s:20:\"iladminusersearchgui\";i:3;s:19:\"iladministrationgui\";}s:20:\"iladminusersearchgui\";a:2:{i:0;s:18:\"ilobjuserfoldergui\";i:1;s:18:\"ilobjuserfoldergui\";}s:17:\"ilinternallinkgui\";a:102:{i:0;s:19:\"ilimagemapeditorgui\";i:1;s:19:\"ilimagemapeditorgui\";i:2;s:19:\"ilimagemapeditorgui\";i:3;s:21:\"ilpcimagemapeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:19:\"ilimagemapeditorgui\";i:6;s:19:\"ilimagemapeditorgui\";i:7;s:19:\"ilimagemapeditorgui\";i:8;s:21:\"ilpcimagemapeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:19:\"ilimagemapeditorgui\";i:11;s:19:\"ilimagemapeditorgui\";i:12;s:19:\"ilimagemapeditorgui\";i:13;s:21:\"ilpcimagemapeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:19:\"ilimagemapeditorgui\";i:16;s:19:\"ilimagemapeditorgui\";i:17;s:19:\"ilimagemapeditorgui\";i:18;s:21:\"ilpcimagemapeditorgui\";i:19;s:15:\"ilpageeditorgui\";i:20;s:19:\"ilimagemapeditorgui\";i:21;s:19:\"ilimagemapeditorgui\";i:22;s:19:\"ilimagemapeditorgui\";i:23;s:21:\"ilpcimagemapeditorgui\";i:24;s:15:\"ilpageeditorgui\";i:25;s:19:\"ilimagemapeditorgui\";i:26;s:19:\"ilimagemapeditorgui\";i:27;s:19:\"ilimagemapeditorgui\";i:28;s:21:\"ilpcimagemapeditorgui\";i:29;s:15:\"ilpageeditorgui\";i:30;s:19:\"ilimagemapeditorgui\";i:31;s:19:\"ilimagemapeditorgui\";i:32;s:19:\"ilimagemapeditorgui\";i:33;s:21:\"ilpcimagemapeditorgui\";i:34;s:15:\"ilpageeditorgui\";i:35;s:19:\"ilimagemapeditorgui\";i:36;s:19:\"ilimagemapeditorgui\";i:37;s:19:\"ilimagemapeditorgui\";i:38;s:21:\"ilpcimagemapeditorgui\";i:39;s:15:\"ilpageeditorgui\";i:40;s:19:\"ilimagemapeditorgui\";i:41;s:19:\"ilimagemapeditorgui\";i:42;s:19:\"ilimagemapeditorgui\";i:43;s:21:\"ilpcimagemapeditorgui\";i:44;s:15:\"ilpageeditorgui\";i:45;s:19:\"ilimagemapeditorgui\";i:46;s:19:\"ilimagemapeditorgui\";i:47;s:19:\"ilimagemapeditorgui\";i:48;s:21:\"ilpcimagemapeditorgui\";i:49;s:15:\"ilpageeditorgui\";i:50;s:19:\"ilimagemapeditorgui\";i:51;s:19:\"ilimagemapeditorgui\";i:52;s:19:\"ilimagemapeditorgui\";i:53;s:21:\"ilpcimagemapeditorgui\";i:54;s:15:\"ilpageeditorgui\";i:55;s:19:\"ilimagemapeditorgui\";i:56;s:19:\"ilimagemapeditorgui\";i:57;s:19:\"ilimagemapeditorgui\";i:58;s:19:\"ilimagemapeditorgui\";i:59;s:21:\"ilpcimagemapeditorgui\";i:60;s:15:\"ilpageeditorgui\";i:61;s:19:\"ilimagemapeditorgui\";i:62;s:19:\"ilimagemapeditorgui\";i:63;s:19:\"ilimagemapeditorgui\";i:64;s:19:\"ilimagemapeditorgui\";i:65;s:21:\"ilpcimagemapeditorgui\";i:66;s:15:\"ilpageeditorgui\";i:67;s:19:\"ilimagemapeditorgui\";i:68;s:19:\"ilimagemapeditorgui\";i:69;s:19:\"ilimagemapeditorgui\";i:70;s:21:\"ilpcimagemapeditorgui\";i:71;s:15:\"ilpageeditorgui\";i:72;s:19:\"ilimagemapeditorgui\";i:73;s:19:\"ilimagemapeditorgui\";i:74;s:19:\"ilimagemapeditorgui\";i:75;s:21:\"ilpcimagemapeditorgui\";i:76;s:15:\"ilpageeditorgui\";i:77;s:19:\"ilimagemapeditorgui\";i:78;s:19:\"ilimagemapeditorgui\";i:79;s:19:\"ilimagemapeditorgui\";i:80;s:21:\"ilpcimagemapeditorgui\";i:81;s:15:\"ilpageeditorgui\";i:82;s:19:\"ilimagemapeditorgui\";i:83;s:19:\"ilimagemapeditorgui\";i:84;s:19:\"ilimagemapeditorgui\";i:85;s:21:\"ilpcimagemapeditorgui\";i:86;s:15:\"ilpageeditorgui\";i:87;s:19:\"ilimagemapeditorgui\";i:88;s:19:\"ilimagemapeditorgui\";i:89;s:19:\"ilimagemapeditorgui\";i:90;s:21:\"ilpcimagemapeditorgui\";i:91;s:15:\"ilpageeditorgui\";i:92;s:19:\"ilimagemapeditorgui\";i:93;s:19:\"ilimagemapeditorgui\";i:94;s:19:\"ilimagemapeditorgui\";i:95;s:21:\"ilpcimagemapeditorgui\";i:96;s:15:\"ilpageeditorgui\";i:97;s:19:\"ilimagemapeditorgui\";i:98;s:19:\"ilimagemapeditorgui\";i:99;s:19:\"ilimagemapeditorgui\";i:100;s:21:\"ilpcimagemapeditorgui\";i:101;s:15:\"ilpageeditorgui\";}s:19:\"ilimagemapeditorgui\";a:62:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:19:\"ilobjmediaobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:19:\"ilobjmediaobjectgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:19:\"ilobjmediaobjectgui\";i:12;s:19:\"ilobjmediaobjectgui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:19:\"ilobjmediaobjectgui\";i:17;s:19:\"ilobjmediaobjectgui\";i:18;s:19:\"ilobjmediaobjectgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:19:\"ilobjmediaobjectgui\";i:22;s:19:\"ilobjmediaobjectgui\";i:23;s:19:\"ilobjmediaobjectgui\";i:24;s:19:\"ilobjmediaobjectgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:19:\"ilobjmediaobjectgui\";i:28;s:19:\"ilobjmediaobjectgui\";i:29;s:19:\"ilobjmediaobjectgui\";i:30;s:19:\"ilobjmediaobjectgui\";i:31;s:19:\"ilobjmediaobjectgui\";i:32;s:19:\"ilobjmediaobjectgui\";i:33;s:19:\"ilobjmediaobjectgui\";i:34;s:19:\"ilobjmediaobjectgui\";i:35;s:19:\"ilobjmediaobjectgui\";i:36;s:19:\"ilobjmediaobjectgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:19:\"ilobjmediaobjectgui\";i:39;s:19:\"ilobjmediaobjectgui\";i:40;s:19:\"ilobjmediaobjectgui\";i:41;s:19:\"ilobjmediaobjectgui\";i:42;s:19:\"ilobjmediaobjectgui\";i:43;s:19:\"ilobjmediaobjectgui\";i:44;s:19:\"ilobjmediaobjectgui\";i:45;s:19:\"ilobjmediaobjectgui\";i:46;s:19:\"ilobjmediaobjectgui\";i:47;s:19:\"ilobjmediaobjectgui\";i:48;s:19:\"ilobjmediaobjectgui\";i:49;s:19:\"ilobjmediaobjectgui\";i:50;s:19:\"ilobjmediaobjectgui\";i:51;s:19:\"ilobjmediaobjectgui\";i:52;s:19:\"ilobjmediaobjectgui\";i:53;s:19:\"ilobjmediaobjectgui\";i:54;s:19:\"ilobjmediaobjectgui\";i:55;s:19:\"ilobjmediaobjectgui\";i:56;s:19:\"ilobjmediaobjectgui\";i:57;s:19:\"ilobjmediaobjectgui\";i:58;s:19:\"ilobjmediaobjectgui\";i:59;s:19:\"ilobjmediaobjectgui\";i:60;s:19:\"ilobjmediaobjectgui\";i:61;s:19:\"ilobjmediaobjectgui\";}s:13:\"ilmdeditorgui\";a:97:{i:0;s:19:\"ilobjmediaobjectgui\";i:1;s:19:\"ilobjmediaobjectgui\";i:2;s:19:\"ilobjmediaobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:19:\"ilobjmediaobjectgui\";i:5;s:19:\"ilobjmediaobjectgui\";i:6;s:19:\"ilobjmediaobjectgui\";i:7;s:15:\"ilpageobjectgui\";i:8;s:19:\"ilobjmediaobjectgui\";i:9;s:19:\"ilobjmediaobjectgui\";i:10;s:19:\"ilobjmediaobjectgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:14:\"ilobjcoursegui\";i:13;s:19:\"ilobjmediaobjectgui\";i:14;s:19:\"ilobjmediaobjectgui\";i:15;s:19:\"ilobjmediaobjectgui\";i:16;s:15:\"ilpageobjectgui\";i:17;s:20:\"ilstructureobjectgui\";i:18;s:14:\"ilobjdlbookgui\";i:19;s:19:\"ilobjmediaobjectgui\";i:20;s:19:\"ilobjmediaobjectgui\";i:21;s:19:\"ilobjmediaobjectgui\";i:22;s:15:\"ilpageobjectgui\";i:23;s:19:\"ilobjfilebasedlmgui\";i:24;s:19:\"ilobjmediaobjectgui\";i:25;s:19:\"ilobjmediaobjectgui\";i:26;s:19:\"ilobjmediaobjectgui\";i:27;s:15:\"ilpageobjectgui\";i:28;s:12:\"ilobjfilegui\";i:29;s:19:\"ilobjmediaobjectgui\";i:30;s:19:\"ilobjmediaobjectgui\";i:31;s:19:\"ilobjmediaobjectgui\";i:32;s:15:\"ilpageobjectgui\";i:33;s:19:\"ilobjmediaobjectgui\";i:34;s:19:\"ilobjmediaobjectgui\";i:35;s:19:\"ilobjmediaobjectgui\";i:36;s:15:\"ilpageobjectgui\";i:37;s:19:\"ilobjmediaobjectgui\";i:38;s:19:\"ilobjmediaobjectgui\";i:39;s:19:\"ilobjmediaobjectgui\";i:40;s:15:\"ilpageobjectgui\";i:41;s:25:\"iltermdefinitioneditorgui\";i:42;s:16:\"ilobjglossarygui\";i:43;s:19:\"ilobjmediaobjectgui\";i:44;s:19:\"ilobjmediaobjectgui\";i:45;s:19:\"ilobjmediaobjectgui\";i:46;s:15:\"ilpageobjectgui\";i:47;s:19:\"ilobjmediaobjectgui\";i:48;s:19:\"ilobjmediaobjectgui\";i:49;s:19:\"ilobjmediaobjectgui\";i:50;s:15:\"ilpageobjectgui\";i:51;s:20:\"ilstructureobjectgui\";i:52;s:22:\"ilobjlearningmodulegui\";i:53;s:20:\"ilobjlinkresourcegui\";i:54;s:19:\"ilobjmediaobjectgui\";i:55;s:19:\"ilobjmediaobjectgui\";i:56;s:19:\"ilobjmediaobjectgui\";i:57;s:19:\"ilobjmediaobjectgui\";i:58;s:15:\"ilpageobjectgui\";i:59;s:19:\"ilobjmediaobjectgui\";i:60;s:19:\"ilobjmediaobjectgui\";i:61;s:19:\"ilobjmediaobjectgui\";i:62;s:19:\"ilobjmediaobjectgui\";i:63;s:15:\"ilpageobjectgui\";i:64;s:19:\"ilobjmediaobjectgui\";i:65;s:19:\"ilobjmediaobjectgui\";i:66;s:19:\"ilobjmediaobjectgui\";i:67;s:15:\"ilpageobjectgui\";i:68;s:20:\"ilobjquestionpoolgui\";i:69;s:19:\"ilobjmediaobjectgui\";i:70;s:19:\"ilobjmediaobjectgui\";i:71;s:19:\"ilobjmediaobjectgui\";i:72;s:15:\"ilpageobjectgui\";i:73;s:26:\"ilobjsahslearningmodulegui\";i:74;s:14:\"ilobjsurveygui\";i:75;s:26:\"ilobjsurveyquestionpoolgui\";i:76;s:19:\"ilobjmediaobjectgui\";i:77;s:19:\"ilobjmediaobjectgui\";i:78;s:19:\"ilobjmediaobjectgui\";i:79;s:15:\"ilpageobjectgui\";i:80;s:19:\"ilobjmediaobjectgui\";i:81;s:19:\"ilobjmediaobjectgui\";i:82;s:19:\"ilobjmediaobjectgui\";i:83;s:15:\"ilpageobjectgui\";i:84;s:14:\"ilobjcoursegui\";i:85;s:19:\"ilobjmediaobjectgui\";i:86;s:19:\"ilobjmediaobjectgui\";i:87;s:19:\"ilobjmediaobjectgui\";i:88;s:15:\"ilpageobjectgui\";i:89;s:12:\"ilobjtestgui\";i:90;s:19:\"ilobjmediaobjectgui\";i:91;s:19:\"ilobjmediaobjectgui\";i:92;s:19:\"ilobjmediaobjectgui\";i:93;s:19:\"ilobjmediaobjectgui\";i:94;s:19:\"ilobjmediaobjectgui\";i:95;s:19:\"ilobjmediaobjectgui\";i:96;s:15:\"ilpageobjectgui\";}s:19:\"ilobjmediaobjectgui\";a:62:{i:0;s:18:\"ileditclipboardgui\";i:1;s:18:\"ilpcmediaobjectgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:18:\"ileditclipboardgui\";i:4;s:18:\"ilpcmediaobjectgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:18:\"ileditclipboardgui\";i:7;s:18:\"ilpcmediaobjectgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:18:\"ileditclipboardgui\";i:10;s:18:\"ilpcmediaobjectgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:18:\"ileditclipboardgui\";i:13;s:18:\"ilpcmediaobjectgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:18:\"ileditclipboardgui\";i:16;s:18:\"ilpcmediaobjectgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:18:\"ileditclipboardgui\";i:19;s:18:\"ilpcmediaobjectgui\";i:20;s:15:\"ilpageeditorgui\";i:21;s:18:\"ileditclipboardgui\";i:22;s:18:\"ilpcmediaobjectgui\";i:23;s:15:\"ilpageeditorgui\";i:24;s:18:\"ileditclipboardgui\";i:25;s:18:\"ilpcmediaobjectgui\";i:26;s:15:\"ilpageeditorgui\";i:27;s:18:\"ileditclipboardgui\";i:28;s:18:\"ilpcmediaobjectgui\";i:29;s:15:\"ilpageeditorgui\";i:30;s:18:\"ileditclipboardgui\";i:31;s:18:\"ilpcmediaobjectgui\";i:32;s:15:\"ilpageeditorgui\";i:33;s:18:\"ileditclipboardgui\";i:34;s:18:\"ileditclipboardgui\";i:35;s:18:\"ilpcmediaobjectgui\";i:36;s:15:\"ilpageeditorgui\";i:37;s:17:\"ilobjmediapoolgui\";i:38;s:18:\"ileditclipboardgui\";i:39;s:18:\"ilpcmediaobjectgui\";i:40;s:15:\"ilpageeditorgui\";i:41;s:18:\"ileditclipboardgui\";i:42;s:18:\"ilpcmediaobjectgui\";i:43;s:15:\"ilpageeditorgui\";i:44;s:18:\"ileditclipboardgui\";i:45;s:18:\"ilpcmediaobjectgui\";i:46;s:15:\"ilpageeditorgui\";i:47;s:18:\"ileditclipboardgui\";i:48;s:18:\"ilpcmediaobjectgui\";i:49;s:15:\"ilpageeditorgui\";i:50;s:18:\"ileditclipboardgui\";i:51;s:18:\"ilpcmediaobjectgui\";i:52;s:15:\"ilpageeditorgui\";i:53;s:18:\"ileditclipboardgui\";i:54;s:18:\"ilpcmediaobjectgui\";i:55;s:15:\"ilpageeditorgui\";i:56;s:18:\"ileditclipboardgui\";i:57;s:18:\"ilpcmediaobjectgui\";i:58;s:15:\"ilpageeditorgui\";i:59;s:18:\"ileditclipboardgui\";i:60;s:18:\"ilpcmediaobjectgui\";i:61;s:15:\"ilpageeditorgui\";}s:21:\"ilpcimagemapeditorgui\";a:20:{i:0;s:18:\"ilpcmediaobjectgui\";i:1;s:18:\"ilpcmediaobjectgui\";i:2;s:18:\"ilpcmediaobjectgui\";i:3;s:18:\"ilpcmediaobjectgui\";i:4;s:18:\"ilpcmediaobjectgui\";i:5;s:18:\"ilpcmediaobjectgui\";i:6;s:18:\"ilpcmediaobjectgui\";i:7;s:18:\"ilpcmediaobjectgui\";i:8;s:18:\"ilpcmediaobjectgui\";i:9;s:18:\"ilpcmediaobjectgui\";i:10;s:18:\"ilpcmediaobjectgui\";i:11;s:18:\"ilpcmediaobjectgui\";i:12;s:18:\"ilpcmediaobjectgui\";i:13;s:18:\"ilpcmediaobjectgui\";i:14;s:18:\"ilpcmediaobjectgui\";i:15;s:18:\"ilpcmediaobjectgui\";i:16;s:18:\"ilpcmediaobjectgui\";i:17;s:18:\"ilpcmediaobjectgui\";i:18;s:18:\"ilpcmediaobjectgui\";i:19;s:18:\"ilpcmediaobjectgui\";}s:16:\"ilpcdatatablegui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfileitemgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:15:\"ilpcfilelistgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:11:\"ilpclistgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:15:\"ilpclistitemgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:10:\"ilpcmapgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:18:\"ilpcmediaobjectgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:16:\"ilpcparagraphgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:14:\"ilpcpluggedgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:15:\"ilpcquestiongui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:16:\"ilpcresourcesgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:14:\"ilpcsectiongui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:17:\"ilpcsourcecodegui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:16:\"ilpctabledatagui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:12:\"ilpctablegui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:11:\"ilpctabsgui\";a:20:{i:0;s:15:\"ilpageeditorgui\";i:1;s:15:\"ilpageeditorgui\";i:2;s:15:\"ilpageeditorgui\";i:3;s:15:\"ilpageeditorgui\";i:4;s:15:\"ilpageeditorgui\";i:5;s:15:\"ilpageeditorgui\";i:6;s:15:\"ilpageeditorgui\";i:7;s:15:\"ilpageeditorgui\";i:8;s:15:\"ilpageeditorgui\";i:9;s:15:\"ilpageeditorgui\";i:10;s:15:\"ilpageeditorgui\";i:11;s:15:\"ilpageeditorgui\";i:12;s:15:\"ilpageeditorgui\";i:13;s:15:\"ilpageeditorgui\";i:14;s:15:\"ilpageeditorgui\";i:15;s:15:\"ilpageeditorgui\";i:16;s:15:\"ilpageeditorgui\";i:17;s:15:\"ilpageeditorgui\";i:18;s:15:\"ilpageeditorgui\";i:19;s:15:\"ilpageeditorgui\";}s:18:\"ileditclipboardgui\";a:21:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpageobjectgui\";i:7;s:15:\"ilpageobjectgui\";i:8;s:15:\"ilpageobjectgui\";i:9;s:15:\"ilpageobjectgui\";i:10;s:15:\"ilpageobjectgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:17:\"ilobjmediapoolgui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:15:\"ilpageobjectgui\";i:16;s:15:\"ilpageobjectgui\";i:17;s:15:\"ilpageobjectgui\";i:18;s:15:\"ilpageobjectgui\";i:19;s:15:\"ilpageobjectgui\";i:20;s:13:\"ilwikipagegui\";}s:15:\"ilpageeditorgui\";a:20:{i:0;s:15:\"ilpageobjectgui\";i:1;s:15:\"ilpageobjectgui\";i:2;s:15:\"ilpageobjectgui\";i:3;s:15:\"ilpageobjectgui\";i:4;s:15:\"ilpageobjectgui\";i:5;s:15:\"ilpageobjectgui\";i:6;s:15:\"ilpageobjectgui\";i:7;s:15:\"ilpageobjectgui\";i:8;s:15:\"ilpageobjectgui\";i:9;s:15:\"ilpageobjectgui\";i:10;s:15:\"ilpageobjectgui\";i:11;s:15:\"ilpageobjectgui\";i:12;s:15:\"ilpageobjectgui\";i:13;s:15:\"ilpageobjectgui\";i:14;s:15:\"ilpageobjectgui\";i:15;s:15:\"ilpageobjectgui\";i:16;s:15:\"ilpageobjectgui\";i:17;s:15:\"ilpageobjectgui\";i:18;s:15:\"ilpageobjectgui\";i:19;s:13:\"ilwikipagegui\";}s:22:\"ilcontainerlinklistgui\";a:2:{i:0;s:16:\"ilobjcategorygui\";i:1;s:18:\"ilobjrootfoldergui\";}s:15:\"ilinfoscreengui\";a:24:{i:0;s:16:\"ilobjcategorygui\";i:1;s:25:\"ilobjcategoryreferencegui\";i:2;s:12:\"ilobjchatgui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:23:\"ilobjcoursereferencegui\";i:5;s:14:\"ilobjdlbookgui\";i:6;s:16:\"ilobjexercisegui\";i:7;s:19:\"ilobjfilebasedlmgui\";i:8;s:12:\"ilobjfilegui\";i:9;s:14:\"ilobjfoldergui\";i:10;s:13:\"ilobjforumgui\";i:11;s:16:\"ilobjglossarygui\";i:12;s:13:\"ilobjgroupgui\";i:13;s:19:\"ilobjilinccoursegui\";i:14;s:22:\"ilobjlearningmodulegui\";i:15;s:20:\"ilobjlinkresourcegui\";i:16;s:17:\"ilobjmediacastgui\";i:17;s:14:\"ilobjfoldergui\";i:18;s:17:\"ilobjmediapoolgui\";i:19;s:15:\"ilobjsessiongui\";i:20;s:14:\"ilobjsurveygui\";i:21;s:14:\"ilobjcoursegui\";i:22;s:12:\"ilobjtestgui\";i:23;s:12:\"ilobjwikigui\";}s:18:\"ilobjuserfoldergui\";a:2:{i:0;s:16:\"ilobjcategorygui\";i:1;s:19:\"iladministrationgui\";}s:15:\"ilpageobjectgui\";a:19:{i:0;s:16:\"ilobjcategorygui\";i:1;s:17:\"ilshoppurchasegui\";i:2;s:14:\"ilobjcoursegui\";i:3;s:17:\"illmpageobjectgui\";i:4;s:17:\"ilshoppurchasegui\";i:5;s:17:\"ilshoppurchasegui\";i:6;s:14:\"ilobjfoldergui\";i:7;s:25:\"iltermdefinitioneditorgui\";i:8;s:17:\"ilglossarytermgui\";i:9;s:13:\"ilobjgroupgui\";i:10;s:17:\"illmpageobjectgui\";i:11;s:14:\"ilobjfoldergui\";i:12;s:23:\"ilobjpaymentsettingsgui\";i:13;s:20:\"ilobjquestionpoolgui\";i:14;s:18:\"ilobjrootfoldergui\";i:15;s:17:\"ilshoppurchasegui\";i:16;s:14:\"ilobjcoursegui\";i:17;s:17:\"ilshoppurchasegui\";i:18;s:13:\"ilwikipagegui\";}s:19:\"ilcoursearchivesgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:32:\"ilcourseobjectivepresentationgui\";a:5:{i:0;s:18:\"ilcoursecontentgui\";i:1;s:18:\"ilcoursecontentgui\";i:2;s:18:\"ilcoursecontentgui\";i:3;s:18:\"ilcoursecontentgui\";i:4;s:18:\"ilcoursecontentgui\";}s:27:\"ilconditionhandlerinterface\";a:12:{i:0;s:29:\"ilcourseitemadministrationgui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:20:\"ilstructureobjectgui\";i:3;s:29:\"ilcourseitemadministrationgui\";i:4;s:14:\"ilobjfoldergui\";i:5;s:29:\"ilcourseitemadministrationgui\";i:6;s:13:\"ilobjgroupgui\";i:7;s:20:\"ilstructureobjectgui\";i:8;s:29:\"ilcourseitemadministrationgui\";i:9;s:14:\"ilobjfoldergui\";i:10;s:29:\"ilcourseitemadministrationgui\";i:11;s:14:\"ilobjcoursegui\";}s:20:\"ilcourseagreementgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:18:\"ilcoursecontentgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:14:\"ilobjfoldergui\";i:4;s:14:\"ilobjcoursegui\";}s:29:\"ilcourseitemadministrationgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjfoldergui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:14:\"ilobjfoldergui\";i:4;s:14:\"ilobjcoursegui\";}s:21:\"ilcourseobjectivesgui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";i:2;s:19:\"iladministrationgui\";}s:23:\"ilcourseregistrationgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:21:\"ilcourseuserfieldsgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:17:\"ilmemberexportgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:22:\"ilobjcoursegroupinggui\";a:3:{i:0;s:14:\"ilobjcoursegui\";i:1;s:13:\"ilobjgroupgui\";i:2;s:14:\"ilobjcoursegui\";}s:21:\"ilrepositorysearchgui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:16:\"ilobjexercisegui\";i:2;s:13:\"ilobjgroupgui\";i:3;s:19:\"ilobjilinccoursegui\";i:4;s:14:\"ilobjcoursegui\";}s:20:\"ilsessionoverviewgui\";a:2:{i:0;s:14:\"ilobjcoursegui\";i:1;s:14:\"ilobjcoursegui\";}s:17:\"ilshoppurchasegui\";a:5:{i:0;s:14:\"ilobjcoursegui\";i:1;s:19:\"ilobjfilebasedlmgui\";i:2;s:12:\"ilobjfilegui\";i:3;s:14:\"ilobjcoursegui\";i:4;s:12:\"ilobjtestgui\";}s:17:\"illmpageobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:18:\"ilobjstylesheetgui\";a:3:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";i:2;s:19:\"iladministrationgui\";}s:20:\"ilstructureobjectgui\";a:2:{i:0;s:14:\"ilobjdlbookgui\";i:1;s:22:\"ilobjlearningmodulegui\";}s:16:\"ilecssettingsgui\";a:1:{i:0;s:29:\"ilobjexternaltoolssettingsgui\";}s:15:\"ilfilesystemgui\";a:2:{i:0;s:19:\"ilobjfilebasedlmgui\";i:1;s:26:\"ilobjsahslearningmodulegui\";}s:16:\"ilforumexportgui\";a:1:{i:0;s:13:\"ilobjforumgui\";}s:25:\"iltermdefinitioneditorgui\";a:1:{i:0;s:17:\"ilglossarytermgui\";}s:17:\"ilglossarytermgui\";a:1:{i:0;s:16:\"ilobjglossarygui\";}s:22:\"ilgroupregistrationgui\";a:1:{i:0;s:13:\"ilobjgroupgui\";}s:22:\"ilobjilincclassroomgui\";a:2:{i:0;s:19:\"ilobjilinccoursegui\";i:1;s:19:\"iladministrationgui\";}s:23:\"iladvancedmdsettingsgui\";a:1:{i:0;s:18:\"ilobjmdsettingsgui\";}s:14:\"ilobjfoldergui\";a:2:{i:0;s:17:\"ilobjmediapoolgui\";i:1;s:19:\"iladministrationgui\";}s:15:\"ilshoptopicsgui\";a:1:{i:0;s:23:\"ilobjpaymentsettingsgui\";}s:15:\"assclozetestgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assimagemapquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"assjavaappletgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assmatchingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:20:\"assmultiplechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:13:\"assnumericgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:22:\"assorderingquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:26:\"assquestiontypetemplategui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asssinglechoicegui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:18:\"asstextquestiongui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:16:\"asstextsubsetgui\";a:1:{i:0;s:20:\"ilobjquestionpoolgui\";}s:21:\"ilsurveyevaluationgui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:20:\"ilsurveyexecutiongui\";a:1:{i:0;s:14:\"ilobjsurveygui\";}s:18:\"ilsurveyphrasesgui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:23:\"surveymatrixquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:23:\"surveymetricquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveynominalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:24:\"surveyordinalquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:21:\"surveytextquestiongui\";a:1:{i:0;s:26:\"ilobjsurveyquestionpoolgui\";}s:14:\"ilobjcoursegui\";a:2:{i:0;s:12:\"ilobjtestgui\";i:1;s:19:\"iladministrationgui\";}s:20:\"iltestcertificategui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:19:\"iltestevaluationgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:15:\"iltestoutputgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:16:\"iltestscoringgui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:16:\"iltestservicegui\";a:1:{i:0;s:12:\"ilobjtestgui\";}s:25:\"ilmediapooltargetselector\";a:1:{i:0;s:13:\"ilwikipagegui\";}s:11:\"ilratinggui\";a:1:{i:0;s:13:\"ilwikipagegui\";}s:13:\"ilwikipagegui\";a:1:{i:0;s:12:\"ilobjwikigui\";}s:23:\"ilobjadvancededitinggui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:24:\"ilobjassessmentfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjauthsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:24:\"ilobjcalendarsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:16:\"ilobjcategorygui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:25:\"ilobjcategoryreferencegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjchatgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:18:\"ilobjchatservergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:25:\"ilobjcomponentsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:23:\"ilobjcoursereferencegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:14:\"ilobjdlbookgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:16:\"ilobjexercisegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjexternalfeedgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:29:\"ilobjexternaltoolssettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:26:\"ilobjfileaccesssettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:19:\"ilobjfilebasedlmgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjfilegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:13:\"ilobjforumgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:16:\"ilobjglossarygui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:13:\"ilobjgroupgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:19:\"ilobjilinccoursegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:19:\"ilobjlanguageextgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjlanguagefoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjlearningmodulegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjlinkresourcegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjmailgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:18:\"ilobjmdsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:17:\"ilobjmediacastgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:25:\"ilobjmediacastsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:17:\"ilobjmediapoolgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjnewssettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjobjectfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:23:\"ilobjpaymentsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:31:\"ilobjpersonaldesktopsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:23:\"ilobjprivacysecuritygui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjquestionpoolgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjrecoveryfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:18:\"ilobjrolefoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjroletemplategui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:18:\"ilobjrootfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:26:\"ilobjsahslearningmodulegui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:22:\"ilobjsearchsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:15:\"ilobjsessiongui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:21:\"ilobjstylesettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:28:\"ilobjsurveyadministrationgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:14:\"ilobjsurveygui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:26:\"ilobjsurveyquestionpoolgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjsystemfoldergui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:23:\"ilobjtaggingsettingsgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjtestgui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:20:\"ilobjusertrackinggui\";a:1:{i:0;s:19:\"iladministrationgui\";}s:12:\"ilobjwikigui\";a:1:{i:0;s:19:\"iladministrationgui\";}}');
/*!40000 ALTER TABLE `ctrl_structure` ENABLE KEYS */;

--
-- Table structure for table `data_cache`
--

CREATE TABLE `data_cache` (
  `module` varchar(50) NOT NULL default 'common',
  `keyword` varchar(50) NOT NULL default '',
  `value` mediumtext,
  PRIMARY KEY  (`module`,`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `data_cache`
--

/*!40000 ALTER TABLE `data_cache` DISABLE KEYS */;
/*!40000 ALTER TABLE `data_cache` ENABLE KEYS */;

--
-- Table structure for table `dav_lock`
--

CREATE TABLE `dav_lock` (
  `token` varchar(255) NOT NULL default '',
  `obj_id` int(11) NOT NULL default '0',
  `node_id` int(11) NOT NULL default '0',
  `ilias_owner` int(11) NOT NULL default '0',
  `dav_owner` varchar(200) default NULL,
  `expires` int(11) NOT NULL default '0',
  `depth` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default 'w',
  `scope` char(1) NOT NULL default 's',
  PRIMARY KEY  (`token`),
  UNIQUE KEY `token` (`token`),
  KEY `path` (`obj_id`,`node_id`),
  KEY `path_3` (`obj_id`,`node_id`,`token`),
  KEY `expires` (`expires`)
) TYPE=MyISAM;

--
-- Dumping data for table `dav_lock`
--

/*!40000 ALTER TABLE `dav_lock` DISABLE KEYS */;
/*!40000 ALTER TABLE `dav_lock` ENABLE KEYS */;

--
-- Table structure for table `dav_property`
--

CREATE TABLE `dav_property` (
  `obj_id` int(11) NOT NULL default '0',
  `node_id` int(11) NOT NULL default '0',
  `ns` varchar(120) NOT NULL default 'DAV:',
  `name` varchar(120) NOT NULL default '',
  `value` text,
  PRIMARY KEY  (`obj_id`,`node_id`,`name`,`ns`),
  KEY `path` (`obj_id`,`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `dav_property`
--

/*!40000 ALTER TABLE `dav_property` DISABLE KEYS */;
/*!40000 ALTER TABLE `dav_property` ENABLE KEYS */;

--
-- Table structure for table `dbk_translations`
--

CREATE TABLE `dbk_translations` (
  `id` int(11) NOT NULL default '0',
  `tr_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`tr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `dbk_translations`
--

/*!40000 ALTER TABLE `dbk_translations` DISABLE KEYS */;
/*!40000 ALTER TABLE `dbk_translations` ENABLE KEYS */;

--
-- Table structure for table `desktop_item`
--

CREATE TABLE `desktop_item` (
  `user_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `type` varchar(4) NOT NULL default '',
  `parameters` varchar(200) default NULL,
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `desktop_item`
--

/*!40000 ALTER TABLE `desktop_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `desktop_item` ENABLE KEYS */;

--
-- Table structure for table `dp_changed_dates`
--

CREATE TABLE `dp_changed_dates` (
  `ID` int(15) NOT NULL auto_increment,
  `user_ID` int(15) NOT NULL default '0',
  `date_ID` int(15) NOT NULL default '0',
  `status` int(15) NOT NULL default '0',
  `timestamp` int(10) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r Anzeige von Ge?nderten Termindaten';

--
-- Dumping data for table `dp_changed_dates`
--

/*!40000 ALTER TABLE `dp_changed_dates` DISABLE KEYS */;
/*!40000 ALTER TABLE `dp_changed_dates` ENABLE KEYS */;

--
-- Table structure for table `dp_dates`
--

CREATE TABLE `dp_dates` (
  `ID` int(15) NOT NULL auto_increment,
  `begin` int(10) NOT NULL default '0',
  `end` int(10) NOT NULL default '0',
  `group_ID` int(15) NOT NULL default '0',
  `user_ID` int(15) NOT NULL default '0',
  `created` int(10) NOT NULL default '0',
  `changed` int(10) NOT NULL default '0',
  `rotation` int(15) NOT NULL default '0',
  `shorttext` varchar(50) NOT NULL default '',
  `text` text,
  `end_rotation` int(10) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Termin Tabelle';

--
-- Dumping data for table `dp_dates`
--

/*!40000 ALTER TABLE `dp_dates` DISABLE KEYS */;
/*!40000 ALTER TABLE `dp_dates` ENABLE KEYS */;

--
-- Table structure for table `dp_keyword`
--

CREATE TABLE `dp_keyword` (
  `ID` int(15) NOT NULL auto_increment,
  `user_ID` int(15) NOT NULL default '0',
  `keyword` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r Schlagw?rter';

--
-- Dumping data for table `dp_keyword`
--

/*!40000 ALTER TABLE `dp_keyword` DISABLE KEYS */;
/*!40000 ALTER TABLE `dp_keyword` ENABLE KEYS */;

--
-- Table structure for table `dp_keywords`
--

CREATE TABLE `dp_keywords` (
  `ID` int(15) NOT NULL auto_increment,
  `date_ID` int(15) NOT NULL default '0',
  `keyword_ID` int(15) NOT NULL default '0',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r die Zuordnung der Schlagw?rter';

--
-- Dumping data for table `dp_keywords`
--

/*!40000 ALTER TABLE `dp_keywords` DISABLE KEYS */;
/*!40000 ALTER TABLE `dp_keywords` ENABLE KEYS */;

--
-- Table structure for table `dp_neg_dates`
--

CREATE TABLE `dp_neg_dates` (
  `ID` int(15) NOT NULL auto_increment,
  `date_ID` int(15) NOT NULL default '0',
  `user_ID` int(15) NOT NULL default '0',
  `timestamp` int(14) default NULL,
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r die negativen Termine';

--
-- Dumping data for table `dp_neg_dates`
--

/*!40000 ALTER TABLE `dp_neg_dates` DISABLE KEYS */;
/*!40000 ALTER TABLE `dp_neg_dates` ENABLE KEYS */;

--
-- Table structure for table `dp_properties`
--

CREATE TABLE `dp_properties` (
  `ID` int(15) NOT NULL auto_increment,
  `user_ID` int(15) NOT NULL default '0',
  `dv_starttime` time NOT NULL default '00:00:00',
  `dv_endtime` time NOT NULL default '00:00:00',
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Tabelle f?r UserEinstellungen';

--
-- Dumping data for table `dp_properties`
--

/*!40000 ALTER TABLE `dp_properties` DISABLE KEYS */;
/*!40000 ALTER TABLE `dp_properties` ENABLE KEYS */;

--
-- Table structure for table `ecs_events`
--

CREATE TABLE `ecs_events` (
  `event_id` int(11) NOT NULL auto_increment,
  `type` char(32) NOT NULL,
  `id` int(11) NOT NULL,
  `op` char(32) NOT NULL,
  PRIMARY KEY  (`event_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ecs_events`
--

/*!40000 ALTER TABLE `ecs_events` DISABLE KEYS */;
/*!40000 ALTER TABLE `ecs_events` ENABLE KEYS */;

--
-- Table structure for table `ecs_export`
--

CREATE TABLE `ecs_export` (
  `obj_id` int(11) NOT NULL default '0',
  `econtent_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ecs_export`
--

/*!40000 ALTER TABLE `ecs_export` DISABLE KEYS */;
/*!40000 ALTER TABLE `ecs_export` ENABLE KEYS */;

--
-- Table structure for table `ecs_import`
--

CREATE TABLE `ecs_import` (
  `obj_id` int(11) NOT NULL default '0',
  `mid` int(11) NOT NULL default '0',
  `econtent_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ecs_import`
--

/*!40000 ALTER TABLE `ecs_import` DISABLE KEYS */;
/*!40000 ALTER TABLE `ecs_import` ENABLE KEYS */;

--
-- Table structure for table `event`
--

CREATE TABLE `event` (
  `event_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `title` varchar(70) NOT NULL default '',
  `description` text NOT NULL,
  `location` text NOT NULL,
  `tutor_name` text NOT NULL,
  `tutor_email` varchar(127) NOT NULL default '',
  `tutor_phone` varchar(127) NOT NULL default '',
  `details` text NOT NULL,
  `registration` tinyint(1) NOT NULL default '0',
  `participation` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`event_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event`
--

/*!40000 ALTER TABLE `event` DISABLE KEYS */;
/*!40000 ALTER TABLE `event` ENABLE KEYS */;

--
-- Table structure for table `event_appointment`
--

CREATE TABLE `event_appointment` (
  `appointment_id` int(11) NOT NULL auto_increment,
  `event_id` int(11) NOT NULL default '0',
  `start` datetime NOT NULL,
  `end` datetime NOT NULL,
  `starting_time` int(11) NOT NULL default '0',
  `ending_time` int(11) NOT NULL default '0',
  `fulltime` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`appointment_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_appointment`
--

/*!40000 ALTER TABLE `event_appointment` DISABLE KEYS */;
/*!40000 ALTER TABLE `event_appointment` ENABLE KEYS */;

--
-- Table structure for table `event_file`
--

CREATE TABLE `event_file` (
  `file_id` int(11) NOT NULL auto_increment,
  `event_id` int(11) NOT NULL default '0',
  `file_name` char(64) NOT NULL default '',
  `file_type` char(64) NOT NULL default '',
  `file_size` int(11) NOT NULL default '0',
  PRIMARY KEY  (`file_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_file`
--

/*!40000 ALTER TABLE `event_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `event_file` ENABLE KEYS */;

--
-- Table structure for table `event_items`
--

CREATE TABLE `event_items` (
  `event_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`event_id`,`item_id`),
  KEY `event_id` (`event_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_items`
--

/*!40000 ALTER TABLE `event_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `event_items` ENABLE KEYS */;

--
-- Table structure for table `event_participants`
--

CREATE TABLE `event_participants` (
  `event_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `registered` tinyint(1) NOT NULL default '0',
  `participated` tinyint(1) NOT NULL default '0',
  `mark` text NOT NULL,
  `comment` text NOT NULL,
  PRIMARY KEY  (`event_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `event_participants`
--

/*!40000 ALTER TABLE `event_participants` DISABLE KEYS */;
/*!40000 ALTER TABLE `event_participants` ENABLE KEYS */;

--
-- Table structure for table `exc_data`
--

CREATE TABLE `exc_data` (
  `obj_id` int(11) NOT NULL default '0',
  `instruction` text,
  `time_stamp` int(10) default NULL,
  PRIMARY KEY  (`obj_id`),
  FULLTEXT KEY `instruction` (`instruction`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_data`
--

/*!40000 ALTER TABLE `exc_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `exc_data` ENABLE KEYS */;

--
-- Table structure for table `exc_members`
--

CREATE TABLE `exc_members` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `notice` text,
  `returned` tinyint(1) NOT NULL default '0',
  `solved` tinyint(1) default NULL,
  `status_time` timestamp NOT NULL,
  `sent` tinyint(1) default NULL,
  `sent_time` timestamp NOT NULL default '0000-00-00 00:00:00',
  `feedback_time` timestamp NOT NULL default '0000-00-00 00:00:00',
  `feedback` tinyint(1) NOT NULL default '0',
  `status` enum('notgraded','failed','passed') NOT NULL default 'notgraded',
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_members`
--

/*!40000 ALTER TABLE `exc_members` DISABLE KEYS */;
/*!40000 ALTER TABLE `exc_members` ENABLE KEYS */;

--
-- Table structure for table `exc_returned`
--

CREATE TABLE `exc_returned` (
  `returned_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `filename` mediumtext NOT NULL,
  `filetitle` mediumtext NOT NULL,
  `mimetype` varchar(40) NOT NULL default '',
  `timestamp` timestamp NOT NULL,
  PRIMARY KEY  (`returned_id`),
  KEY `obj_id` (`obj_id`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_returned`
--

/*!40000 ALTER TABLE `exc_returned` DISABLE KEYS */;
/*!40000 ALTER TABLE `exc_returned` ENABLE KEYS */;

--
-- Table structure for table `exc_usr_tutor`
--

CREATE TABLE `exc_usr_tutor` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `tutor_id` int(11) NOT NULL default '0',
  `download_time` timestamp NOT NULL,
  PRIMARY KEY  (`obj_id`,`usr_id`,`tutor_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `exc_usr_tutor`
--

/*!40000 ALTER TABLE `exc_usr_tutor` DISABLE KEYS */;
/*!40000 ALTER TABLE `exc_usr_tutor` ENABLE KEYS */;

--
-- Table structure for table `feedback_items`
--

CREATE TABLE `feedback_items` (
  `fb_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) default NULL,
  `description` text,
  `anonymous` tinyint(1) NOT NULL default '1',
  `required` tinyint(1) default '0',
  `show_on` varchar(6) default NULL,
  `text_answer` tinyint(1) default '0',
  `votes` text,
  `starttime` int(11) default '0',
  `endtime` int(11) default '0',
  `repeat_interval` int(11) default NULL,
  `interval_unit` tinyint(4) default NULL,
  `first_vote_best` tinyint(1) default '0',
  `obj_id` int(11) default '0',
  `ref_id` int(11) default '0',
  PRIMARY KEY  (`fb_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `feedback_items`
--

/*!40000 ALTER TABLE `feedback_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `feedback_items` ENABLE KEYS */;

--
-- Table structure for table `feedback_results`
--

CREATE TABLE `feedback_results` (
  `fb_id` int(11) NOT NULL default '0',
  `user_id` int(11) default NULL,
  `vote` int(11) NOT NULL default '0',
  `note` text NOT NULL,
  `votetime` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `feedback_results`
--

/*!40000 ALTER TABLE `feedback_results` DISABLE KEYS */;
/*!40000 ALTER TABLE `feedback_results` ENABLE KEYS */;

--
-- Table structure for table `file_based_lm`
--

CREATE TABLE `file_based_lm` (
  `id` int(11) NOT NULL default '0',
  `online` enum('y','n') default 'n',
  `startfile` varchar(200) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `file_based_lm`
--

/*!40000 ALTER TABLE `file_based_lm` DISABLE KEYS */;
/*!40000 ALTER TABLE `file_based_lm` ENABLE KEYS */;

--
-- Table structure for table `file_data`
--

CREATE TABLE `file_data` (
  `file_id` int(11) NOT NULL default '0',
  `file_name` char(128) NOT NULL default '',
  `file_type` char(64) NOT NULL default '',
  `file_size` int(11) NOT NULL default '0',
  `version` int(11) default NULL,
  `mode` char(8) default 'object',
  PRIMARY KEY  (`file_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `file_data`
--

/*!40000 ALTER TABLE `file_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `file_data` ENABLE KEYS */;

--
-- Table structure for table `file_usage`
--

CREATE TABLE `file_usage` (
  `id` int(11) NOT NULL default '0',
  `usage_type` varchar(10) NOT NULL default '',
  `usage_id` int(11) NOT NULL default '0',
  `usage_hist_nr` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`usage_type`,`usage_id`,`usage_hist_nr`)
) TYPE=MyISAM;

--
-- Dumping data for table `file_usage`
--

/*!40000 ALTER TABLE `file_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `file_usage` ENABLE KEYS */;

--
-- Table structure for table `frm_data`
--

CREATE TABLE `frm_data` (
  `top_pk` bigint(20) NOT NULL auto_increment,
  `top_frm_fk` bigint(20) NOT NULL default '0',
  `top_name` varchar(255) NOT NULL default '',
  `top_description` varchar(255) NOT NULL default '',
  `top_num_posts` int(11) NOT NULL default '0',
  `top_num_threads` int(11) NOT NULL default '0',
  `top_last_post` varchar(50) NOT NULL default '',
  `top_mods` int(11) NOT NULL default '0',
  `top_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `visits` int(11) NOT NULL default '0',
  `top_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `update_user` int(11) NOT NULL default '0',
  `top_usr_id` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`top_pk`),
  KEY `top_frm_fk` (`top_frm_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_data`
--

/*!40000 ALTER TABLE `frm_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_data` ENABLE KEYS */;

--
-- Table structure for table `frm_notification`
--

CREATE TABLE `frm_notification` (
  `notification_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `frm_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`notification_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_notification`
--

/*!40000 ALTER TABLE `frm_notification` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_notification` ENABLE KEYS */;

--
-- Table structure for table `frm_posts`
--

CREATE TABLE `frm_posts` (
  `pos_pk` bigint(20) NOT NULL auto_increment,
  `pos_top_fk` bigint(20) NOT NULL default '0',
  `pos_thr_fk` bigint(20) NOT NULL default '0',
  `pos_usr_id` bigint(20) NOT NULL default '0',
  `pos_usr_alias` varchar(255) NOT NULL default '',
  `pos_message` text NOT NULL,
  `pos_subject` text NOT NULL,
  `pos_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `pos_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `update_user` int(11) NOT NULL default '0',
  `pos_cens` tinyint(4) NOT NULL default '0',
  `pos_cens_com` text NOT NULL,
  `notify` tinyint(1) NOT NULL default '0',
  `import_name` text,
  `pos_status` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`pos_pk`),
  KEY `pos_thr_fk` (`pos_thr_fk`),
  KEY `pos_top_fk` (`pos_top_fk`),
  KEY `pos_date` (`pos_date`),
  FULLTEXT KEY `message_subject` (`pos_message`,`pos_subject`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_posts`
--

/*!40000 ALTER TABLE `frm_posts` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_posts` ENABLE KEYS */;

--
-- Table structure for table `frm_posts_tree`
--

CREATE TABLE `frm_posts_tree` (
  `fpt_pk` bigint(20) NOT NULL auto_increment,
  `thr_fk` bigint(20) NOT NULL default '0',
  `pos_fk` bigint(20) NOT NULL default '0',
  `parent_pos` bigint(20) NOT NULL default '0',
  `lft` int(11) NOT NULL default '0',
  `rgt` int(11) NOT NULL default '0',
  `depth` int(11) NOT NULL default '0',
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`fpt_pk`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_posts_tree`
--

/*!40000 ALTER TABLE `frm_posts_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_posts_tree` ENABLE KEYS */;

--
-- Table structure for table `frm_settings`
--

CREATE TABLE `frm_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `default_view` int(2) NOT NULL default '0',
  `anonymized` tinyint(1) NOT NULL default '0',
  `statistics_enabled` tinyint(1) unsigned NOT NULL default '0',
  `post_activation` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_settings`
--

/*!40000 ALTER TABLE `frm_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_settings` ENABLE KEYS */;

--
-- Table structure for table `frm_thread_access`
--

CREATE TABLE `frm_thread_access` (
  `usr_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  `access_old` int(11) NOT NULL default '0',
  `access_last` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`obj_id`,`thread_id`),
  KEY `usr_thread` (`thread_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_thread_access`
--

/*!40000 ALTER TABLE `frm_thread_access` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_thread_access` ENABLE KEYS */;

--
-- Table structure for table `frm_threads`
--

CREATE TABLE `frm_threads` (
  `thr_pk` bigint(20) NOT NULL auto_increment,
  `thr_top_fk` bigint(20) NOT NULL default '0',
  `thr_subject` varchar(255) NOT NULL default '',
  `thr_usr_id` bigint(20) NOT NULL default '0',
  `thr_usr_alias` varchar(255) NOT NULL default '',
  `thr_num_posts` int(11) NOT NULL default '0',
  `thr_last_post` varchar(50) NOT NULL default '',
  `thr_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `thr_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `visits` int(11) NOT NULL default '0',
  `import_name` text,
  `is_sticky` tinyint(1) NOT NULL default '0',
  `is_closed` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`thr_pk`),
  FULLTEXT KEY `thr_subject` (`thr_subject`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_threads`
--

/*!40000 ALTER TABLE `frm_threads` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_threads` ENABLE KEYS */;

--
-- Table structure for table `frm_user_read`
--

CREATE TABLE `frm_user_read` (
  `usr_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `thread_id` int(11) NOT NULL default '0',
  `post_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`obj_id`,`thread_id`,`post_id`),
  KEY `obj_usr` (`obj_id`,`usr_id`),
  KEY `post_usr` (`post_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `frm_user_read`
--

/*!40000 ALTER TABLE `frm_user_read` DISABLE KEYS */;
/*!40000 ALTER TABLE `frm_user_read` ENABLE KEYS */;

--
-- Table structure for table `glossary`
--

CREATE TABLE `glossary` (
  `id` int(11) NOT NULL default '0',
  `online` enum('y','n') default 'n',
  `virtual` enum('none','fixed','level','subtree') NOT NULL default 'none',
  `public_html_file` varchar(50) NOT NULL default '',
  `public_xml_file` varchar(50) NOT NULL default '',
  `glo_menu_active` enum('y','n') default 'y',
  `downloads_active` enum('y','n') default 'n',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `glossary`
--

/*!40000 ALTER TABLE `glossary` DISABLE KEYS */;
/*!40000 ALTER TABLE `glossary` ENABLE KEYS */;

--
-- Table structure for table `glossary_definition`
--

CREATE TABLE `glossary_definition` (
  `id` int(11) NOT NULL auto_increment,
  `term_id` int(11) NOT NULL default '0',
  `short_text` varchar(200) NOT NULL default '',
  `nr` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `glossary_definition`
--

/*!40000 ALTER TABLE `glossary_definition` DISABLE KEYS */;
/*!40000 ALTER TABLE `glossary_definition` ENABLE KEYS */;

--
-- Table structure for table `glossary_term`
--

CREATE TABLE `glossary_term` (
  `id` int(11) NOT NULL auto_increment,
  `glo_id` int(11) NOT NULL default '0',
  `term` varchar(200) default NULL,
  `language` char(2) default NULL,
  `import_id` varchar(50) NOT NULL default '',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  KEY `glo_id` (`glo_id`),
  FULLTEXT KEY `term` (`term`)
) TYPE=MyISAM;

--
-- Dumping data for table `glossary_term`
--

/*!40000 ALTER TABLE `glossary_term` DISABLE KEYS */;
/*!40000 ALTER TABLE `glossary_term` ENABLE KEYS */;

--
-- Table structure for table `grp_data`
--

CREATE TABLE `grp_data` (
  `grp_id` int(11) NOT NULL default '0',
  `register` int(11) default '1',
  `password` varchar(255) default NULL,
  `expiration` datetime default '0000-00-00 00:00:00',
  `latitude` varchar(30) NOT NULL default '',
  `longitude` varchar(30) NOT NULL default '',
  `location_zoom` int(11) NOT NULL default '0',
  `enable_group_map` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`grp_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `grp_data`
--

/*!40000 ALTER TABLE `grp_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `grp_data` ENABLE KEYS */;

--
-- Table structure for table `grp_settings`
--

CREATE TABLE `grp_settings` (
  `obj_id` int(11) NOT NULL,
  `information` text NOT NULL,
  `grp_type` tinyint(1) NOT NULL,
  `registration_type` tinyint(1) NOT NULL,
  `registration_enabled` tinyint(1) NOT NULL,
  `registration_unlimited` tinyint(1) NOT NULL,
  `registration_start` timestamp NULL default '0000-00-00 00:00:00',
  `registration_end` timestamp NULL default '0000-00-00 00:00:00',
  `registration_password` char(32) NOT NULL,
  `registration_membership_limited` tinyint(1) NOT NULL default '0',
  `registration_max_members` int(4) NOT NULL,
  `waiting_list` tinyint(1) NOT NULL,
  `latitude` varchar(30) NOT NULL,
  `longitude` varchar(30) NOT NULL,
  `location_zoom` int(11) NOT NULL,
  `enablemap` tinyint(4) NOT NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `grp_settings`
--

/*!40000 ALTER TABLE `grp_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `grp_settings` ENABLE KEYS */;

--
-- Table structure for table `history`
--

CREATE TABLE `history` (
  `id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` varchar(8) NOT NULL default '',
  `action` varchar(20) NOT NULL default '',
  `hdate` datetime default NULL,
  `usr_id` int(11) NOT NULL default '0',
  `info_params` text NOT NULL,
  `user_comment` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_type` (`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `history`
--

/*!40000 ALTER TABLE `history` DISABLE KEYS */;
/*!40000 ALTER TABLE `history` ENABLE KEYS */;

--
-- Table structure for table `il_block_setting`
--

CREATE TABLE `il_block_setting` (
  `type` varchar(20) NOT NULL default '',
  `user` int(11) NOT NULL default '0',
  `block_id` int(11) NOT NULL default '0',
  `setting` varchar(40) NOT NULL default '',
  `value` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`type`,`user`,`block_id`,`setting`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_block_setting`
--

/*!40000 ALTER TABLE `il_block_setting` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_block_setting` ENABLE KEYS */;

--
-- Table structure for table `il_component`
--

CREATE TABLE `il_component` (
  `type` char(10) NOT NULL default '',
  `name` varchar(200) default NULL,
  `id` char(10) NOT NULL default '',
  PRIMARY KEY  (`type`,`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_component`
--

/*!40000 ALTER TABLE `il_component` DISABLE KEYS */;
INSERT INTO `il_component` VALUES ('Modules','Category','cat');
INSERT INTO `il_component` VALUES ('Modules','CategoryReference','catr');
INSERT INTO `il_component` VALUES ('Modules','Chat','chat');
INSERT INTO `il_component` VALUES ('Modules','Course','crs');
INSERT INTO `il_component` VALUES ('Modules','CourseReference','crsr');
INSERT INTO `il_component` VALUES ('Modules','Exercise','exc');
INSERT INTO `il_component` VALUES ('Modules','ExternalFeed','feed');
INSERT INTO `il_component` VALUES ('Modules','File','file');
INSERT INTO `il_component` VALUES ('Modules','Folder','fold');
INSERT INTO `il_component` VALUES ('Modules','Forum','frm');
INSERT INTO `il_component` VALUES ('Modules','Glossary','glo');
INSERT INTO `il_component` VALUES ('Modules','Group','grp');
INSERT INTO `il_component` VALUES ('Modules','HTMLLearningModule','htlm');
INSERT INTO `il_component` VALUES ('Modules','ILinc','ilnc');
INSERT INTO `il_component` VALUES ('Modules','LearningModule','lm');
INSERT INTO `il_component` VALUES ('Modules','MediaCast','mcst');
INSERT INTO `il_component` VALUES ('Modules','MediaPool','mep');
INSERT INTO `il_component` VALUES ('Modules','RemoteCourse','rcrs');
INSERT INTO `il_component` VALUES ('Modules','RootFolder','root');
INSERT INTO `il_component` VALUES ('Modules','ScormAicc','sahs');
INSERT INTO `il_component` VALUES ('Modules','Session','sess');
INSERT INTO `il_component` VALUES ('Modules','Survey','svy');
INSERT INTO `il_component` VALUES ('Modules','SurveyQuestionPool','spl');
INSERT INTO `il_component` VALUES ('Modules','SystemFolder','adm');
INSERT INTO `il_component` VALUES ('Modules','Test','tst');
INSERT INTO `il_component` VALUES ('Modules','TestQuestionPool','qpl');
INSERT INTO `il_component` VALUES ('Modules','WebResource','webr');
INSERT INTO `il_component` VALUES ('Modules','Wiki','wiki');
INSERT INTO `il_component` VALUES ('Services','AccessControl','ac');
INSERT INTO `il_component` VALUES ('Services','Administration','adm');
INSERT INTO `il_component` VALUES ('Services','AdvancedEditing','adve');
INSERT INTO `il_component` VALUES ('Services','AdvancedMetaData','amet');
INSERT INTO `il_component` VALUES ('Services','Authentication','auth');
INSERT INTO `il_component` VALUES ('Services','Calendar','cal');
INSERT INTO `il_component` VALUES ('Services','Component','comp');
INSERT INTO `il_component` VALUES ('Services','COPage','copg');
INSERT INTO `il_component` VALUES ('Services','EventHandling','evnt');
INSERT INTO `il_component` VALUES ('Services','Help','help');
INSERT INTO `il_component` VALUES ('Services','Init','init');
INSERT INTO `il_component` VALUES ('Services','Language','lang');
INSERT INTO `il_component` VALUES ('Services','Mail','mail');
INSERT INTO `il_component` VALUES ('Services','MetaData','meta');
INSERT INTO `il_component` VALUES ('Services','News','news');
INSERT INTO `il_component` VALUES ('Services','Object','obj');
INSERT INTO `il_component` VALUES ('Services','Payment','paym');
INSERT INTO `il_component` VALUES ('Services','PersonalDesktop','pdsk');
INSERT INTO `il_component` VALUES ('Services','PrivacySecurity','ps');
INSERT INTO `il_component` VALUES ('Services','Search','src');
INSERT INTO `il_component` VALUES ('Services','Style','styl');
INSERT INTO `il_component` VALUES ('Services','Tagging','tag');
INSERT INTO `il_component` VALUES ('Services','Tracking','trac');
INSERT INTO `il_component` VALUES ('Services','User','user');
INSERT INTO `il_component` VALUES ('Services','WebDAV','');
/*!40000 ALTER TABLE `il_component` ENABLE KEYS */;

--
-- Table structure for table `il_custom_block`
--

CREATE TABLE `il_custom_block` (
  `id` int(11) NOT NULL auto_increment,
  `context_obj_id` int(11) default NULL,
  `context_obj_type` varchar(10) default NULL,
  `context_sub_obj_id` int(11) default NULL,
  `context_sub_obj_type` varchar(10) default NULL,
  `type` varchar(20) default NULL,
  `title` varchar(200) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_custom_block`
--

/*!40000 ALTER TABLE `il_custom_block` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_custom_block` ENABLE KEYS */;

--
-- Table structure for table `il_external_feed_block`
--

CREATE TABLE `il_external_feed_block` (
  `id` int(11) NOT NULL auto_increment,
  `feed_url` varchar(250) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_external_feed_block`
--

/*!40000 ALTER TABLE `il_external_feed_block` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_external_feed_block` ENABLE KEYS */;

--
-- Table structure for table `il_html_block`
--

CREATE TABLE `il_html_block` (
  `id` int(11) NOT NULL default '0',
  `content` text,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_html_block`
--

/*!40000 ALTER TABLE `il_html_block` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_html_block` ENABLE KEYS */;

--
-- Table structure for table `il_log`
--

CREATE TABLE `il_log` (
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `level` int(11) NOT NULL default '0',
  `message` varchar(250) NOT NULL default '',
  `module` varchar(50) NOT NULL default '',
  KEY `created` (`created`),
  KEY `module` (`module`),
  KEY `level` (`level`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_log`
--

/*!40000 ALTER TABLE `il_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_log` ENABLE KEYS */;

--
-- Table structure for table `il_md_copyright_selections`
--

CREATE TABLE `il_md_copyright_selections` (
  `entry_id` int(11) NOT NULL auto_increment,
  `title` varchar(128) NOT NULL default '',
  `description` text NOT NULL,
  `copyright` text NOT NULL,
  `language` char(2) NOT NULL default '',
  `costs` tinyint(1) NOT NULL default '0',
  `copyright_and_other_restrictions` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`entry_id`)
) TYPE=MyISAM AUTO_INCREMENT=7;

--
-- Dumping data for table `il_md_copyright_selections`
--

/*!40000 ALTER TABLE `il_md_copyright_selections` DISABLE KEYS */;
INSERT INTO `il_md_copyright_selections` VALUES (1,'Attribution Non-commercial No Derivatives','Creative Commons License','<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-nd/3.0/\">\r\n<img alt=\"Creative Commons License\" style=\"border-width:0\" src=\"http://i.creativecommons.org/l/by-nc-nd/3.0/88x31.png\" />\r\n</a>\r\n<br />This \r\n<span xmlns:dc=\"http://purl.org/dc/elements/1.1/\" href=\"http://purl.org/dc/dcmitype/\" rel=\"dc:type\">work</span> is licensed under a \r\n<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-nd/3.0/\">Creative Commons Attribution-Noncommercial-No Derivative Works 3.0 License</a>.','en',0,1);
INSERT INTO `il_md_copyright_selections` VALUES (2,'Attribution Non-commercial Share Alike (by-nc-sa)','Creative Commons License','<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\">\r\n<img alt=\"Creative Commons License\" style=\"border-width:0\" src=\"http://i.creativecommons.org/l/by-nc-sa/3.0/88x31.png\" />\r\n</a>\r\n<br />This \r\n<span xmlns:dc=\"http://purl.org/dc/elements/1.1/\" href=\"http://purl.org/dc/dcmitype/\" rel=\"dc:type\">work</span> is licensed under a \r\n<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\">Creative Commons Attribution-Noncommercial-Share Alike 3.0 License</a>.','en',0,1);
INSERT INTO `il_md_copyright_selections` VALUES (3,'Attribution Non-commercial (by-nc)','Creative Commons License','<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc/3.0/\">\r\n<img alt=\"Creative Commons License\" style=\"border-width:0\" src=\"http://i.creativecommons.org/l/by-nc/3.0/88x31.png\" />\r\n</a>\r\n<br />This \r\n<span xmlns:dc=\"http://purl.org/dc/elements/1.1/\" href=\"http://purl.org/dc/dcmitype/\" rel=\"dc:type\">work</span> is licensed under a \r\n<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc/3.0/\">Creative Commons Attribution-Noncommercial 3.0 License</a>.','en',0,1);
INSERT INTO `il_md_copyright_selections` VALUES (4,'Attribution No Derivatives (by-nd)','Creative Commons License','<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nd/3.0/\">\r\n<img alt=\"Creative Commons License\" style=\"border-width:0\" src=\"http://i.creativecommons.org/l/by-nd/3.0/88x31.png\" />\r\n</a>\r\n<br />This \r\n<span xmlns:dc=\"http://purl.org/dc/elements/1.1/\" href=\"http://purl.org/dc/dcmitype/\" rel=\"dc:type\">work</span> is licensed under a \r\n<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nd/3.0/\">Creative Commons Attribution-No Derivative Works 3.0 License</a>.','en',0,1);
INSERT INTO `il_md_copyright_selections` VALUES (5,'Attribution Share Alike (by-sa)','Creative Commons License','<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-sa/3.0/\">\r\n<img alt=\"Creative Commons License\" style=\"border-width:0\" src=\"http://i.creativecommons.org/l/by-sa/3.0/88x31.png\" />\r\n</a>\r\n<br />This \r\n<span xmlns:dc=\"http://purl.org/dc/elements/1.1/\" href=\"http://purl.org/dc/dcmitype/\" rel=\"dc:type\">work</span> is licensed under a \r\n<a rel=\"license\" href=\"http://creativecommons.org/licenses/by-sa/3.0/\">Creative Commons Attribution-Share Alike 3.0 License</a>.','en',0,1);
INSERT INTO `il_md_copyright_selections` VALUES (6,'Attribution (by)','Creative Commons License','<a rel=\"license\" href=\"http://creativecommons.org/licenses/by/3.0/\">\r\n<img alt=\"Creative Commons License\" style=\"border-width:0\" src=\"http://i.creativecommons.org/l/by/3.0/88x31.png\" />\r\n</a>\r\n<br />This \r\n<span xmlns:dc=\"http://purl.org/dc/elements/1.1/\" href=\\\"http://purl.org/dc/dcmitype/\" rel=\"dc:type\">work</span> is licensed under a \r\n<a rel=\"license\" href=\"http://creativecommons.org/licenses/by/3.0/\">Creative Commons Attribution 3.0 License</a>.','en',0,1);
/*!40000 ALTER TABLE `il_md_copyright_selections` ENABLE KEYS */;

--
-- Table structure for table `il_media_cast_data`
--

CREATE TABLE `il_media_cast_data` (
  `id` int(11) NOT NULL auto_increment,
  `online` tinyint(4) default '0',
  `public_files` tinyint(4) default '0',
  `downloadable` tinyint(4) default '0',
  `access` tinyint(4) default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_media_cast_data`
--

/*!40000 ALTER TABLE `il_media_cast_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_media_cast_data` ENABLE KEYS */;

--
-- Table structure for table `il_meta_annotation`
--

CREATE TABLE `il_meta_annotation` (
  `meta_annotation_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `entity` text,
  `date` text,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_annotation_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_annotation`
--

/*!40000 ALTER TABLE `il_meta_annotation` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_annotation` ENABLE KEYS */;

--
-- Table structure for table `il_meta_classification`
--

CREATE TABLE `il_meta_classification` (
  `meta_classification_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `purpose` varchar(32) default NULL,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_classification_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_classification`
--

/*!40000 ALTER TABLE `il_meta_classification` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_classification` ENABLE KEYS */;

--
-- Table structure for table `il_meta_contribute`
--

CREATE TABLE `il_meta_contribute` (
  `meta_contribute_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `role` varchar(32) default NULL,
  `date` text,
  PRIMARY KEY  (`meta_contribute_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_contribute`
--

/*!40000 ALTER TABLE `il_meta_contribute` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_contribute` ENABLE KEYS */;

--
-- Table structure for table `il_meta_description`
--

CREATE TABLE `il_meta_description` (
  `meta_description_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_description_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `description` (`description`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_description`
--

/*!40000 ALTER TABLE `il_meta_description` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_description` ENABLE KEYS */;

--
-- Table structure for table `il_meta_educational`
--

CREATE TABLE `il_meta_educational` (
  `meta_educational_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `interactivity_type` varchar(16) default NULL,
  `learning_resource_type` varchar(32) default NULL,
  `interactivity_level` varchar(16) default NULL,
  `semantic_density` varchar(16) default NULL,
  `intended_end_user_role` varchar(16) default NULL,
  `context` varchar(16) default NULL,
  `difficulty` varchar(16) default NULL,
  `typical_learning_time` text,
  PRIMARY KEY  (`meta_educational_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_educational`
--

/*!40000 ALTER TABLE `il_meta_educational` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_educational` ENABLE KEYS */;

--
-- Table structure for table `il_meta_entity`
--

CREATE TABLE `il_meta_entity` (
  `meta_entity_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `entity` text,
  PRIMARY KEY  (`meta_entity_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `entity` (`entity`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_entity`
--

/*!40000 ALTER TABLE `il_meta_entity` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_entity` ENABLE KEYS */;

--
-- Table structure for table `il_meta_format`
--

CREATE TABLE `il_meta_format` (
  `meta_format_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `format` text,
  PRIMARY KEY  (`meta_format_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_format`
--

/*!40000 ALTER TABLE `il_meta_format` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_format` ENABLE KEYS */;

--
-- Table structure for table `il_meta_general`
--

CREATE TABLE `il_meta_general` (
  `meta_general_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `general_structure` varchar(16) default NULL,
  `title` text,
  `title_language` char(2) default NULL,
  `coverage` text,
  `coverage_language` char(2) default NULL,
  PRIMARY KEY  (`meta_general_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `title_coverage` (`title`,`coverage`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_general`
--

/*!40000 ALTER TABLE `il_meta_general` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_general` ENABLE KEYS */;

--
-- Table structure for table `il_meta_identifier`
--

CREATE TABLE `il_meta_identifier` (
  `meta_identifier_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `catalog` text,
  `entry` text,
  PRIMARY KEY  (`meta_identifier_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_identifier`
--

/*!40000 ALTER TABLE `il_meta_identifier` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_identifier` ENABLE KEYS */;

--
-- Table structure for table `il_meta_identifier_`
--

CREATE TABLE `il_meta_identifier_` (
  `meta_identifier__id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `catalog` text,
  `entry` text,
  PRIMARY KEY  (`meta_identifier__id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_identifier_`
--

/*!40000 ALTER TABLE `il_meta_identifier_` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_identifier_` ENABLE KEYS */;

--
-- Table structure for table `il_meta_keyword`
--

CREATE TABLE `il_meta_keyword` (
  `meta_keyword_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `keyword` text,
  `keyword_language` char(2) default NULL,
  PRIMARY KEY  (`meta_keyword_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`),
  FULLTEXT KEY `keyword` (`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_keyword`
--

/*!40000 ALTER TABLE `il_meta_keyword` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_keyword` ENABLE KEYS */;

--
-- Table structure for table `il_meta_language`
--

CREATE TABLE `il_meta_language` (
  `meta_language_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` char(6) default NULL,
  `parent_type` char(16) default NULL,
  `parent_id` int(11) default NULL,
  `language` char(2) default NULL,
  PRIMARY KEY  (`meta_language_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_language`
--

/*!40000 ALTER TABLE `il_meta_language` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_language` ENABLE KEYS */;

--
-- Table structure for table `il_meta_lifecycle`
--

CREATE TABLE `il_meta_lifecycle` (
  `meta_lifecycle_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `lifecycle_status` varchar(16) default NULL,
  `meta_version` text,
  `version_language` char(2) binary default NULL,
  PRIMARY KEY  (`meta_lifecycle_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_lifecycle`
--

/*!40000 ALTER TABLE `il_meta_lifecycle` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_lifecycle` ENABLE KEYS */;

--
-- Table structure for table `il_meta_location`
--

CREATE TABLE `il_meta_location` (
  `meta_location_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `location` text,
  `location_type` varchar(16) default NULL,
  PRIMARY KEY  (`meta_location_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_location`
--

/*!40000 ALTER TABLE `il_meta_location` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_location` ENABLE KEYS */;

--
-- Table structure for table `il_meta_meta_data`
--

CREATE TABLE `il_meta_meta_data` (
  `meta_meta_data_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` char(6) default NULL,
  `meta_data_scheme` char(16) default NULL,
  `language` char(2) default NULL,
  PRIMARY KEY  (`meta_meta_data_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_meta_data`
--

/*!40000 ALTER TABLE `il_meta_meta_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_meta_data` ENABLE KEYS */;

--
-- Table structure for table `il_meta_relation`
--

CREATE TABLE `il_meta_relation` (
  `meta_relation_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` char(6) default NULL,
  `kind` char(16) default NULL,
  PRIMARY KEY  (`meta_relation_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_relation`
--

/*!40000 ALTER TABLE `il_meta_relation` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_relation` ENABLE KEYS */;

--
-- Table structure for table `il_meta_requirement`
--

CREATE TABLE `il_meta_requirement` (
  `meta_requirement_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `operating_system_name` varchar(16) default NULL,
  `operating_system_minimum_version` text,
  `operating_system_maximum_version` text,
  `browser_name` varchar(32) default NULL,
  `browser_minimum_version` text,
  `browser_maximum_version` text,
  `or_composite_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`meta_requirement_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_requirement`
--

/*!40000 ALTER TABLE `il_meta_requirement` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_requirement` ENABLE KEYS */;

--
-- Table structure for table `il_meta_rights`
--

CREATE TABLE `il_meta_rights` (
  `meta_rights_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `costs` char(3) default NULL,
  `copyright_and_other_restrictions` char(3) default NULL,
  `description` text,
  `description_language` char(2) default NULL,
  PRIMARY KEY  (`meta_rights_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_rights`
--

/*!40000 ALTER TABLE `il_meta_rights` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_rights` ENABLE KEYS */;

--
-- Table structure for table `il_meta_taxon`
--

CREATE TABLE `il_meta_taxon` (
  `meta_taxon_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `taxon` text,
  `taxon_language` char(2) default NULL,
  `taxon_id` text,
  PRIMARY KEY  (`meta_taxon_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_taxon`
--

/*!40000 ALTER TABLE `il_meta_taxon` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_taxon` ENABLE KEYS */;

--
-- Table structure for table `il_meta_taxon_path`
--

CREATE TABLE `il_meta_taxon_path` (
  `meta_taxon_path_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(32) default NULL,
  `parent_id` int(11) default NULL,
  `source` text,
  `source_language` char(2) default NULL,
  PRIMARY KEY  (`meta_taxon_path_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_taxon_path`
--

/*!40000 ALTER TABLE `il_meta_taxon_path` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_taxon_path` ENABLE KEYS */;

--
-- Table structure for table `il_meta_technical`
--

CREATE TABLE `il_meta_technical` (
  `meta_technical_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `size` text,
  `installation_remarks` text,
  `installation_remarks_language` char(2) default NULL,
  `other_platform_requirements` text,
  `other_platform_requirements_language` char(2) default NULL,
  `duration` text,
  PRIMARY KEY  (`meta_technical_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_technical`
--

/*!40000 ALTER TABLE `il_meta_technical` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_technical` ENABLE KEYS */;

--
-- Table structure for table `il_meta_typical_age_range`
--

CREATE TABLE `il_meta_typical_age_range` (
  `meta_typical_age_range_id` int(11) NOT NULL auto_increment,
  `rbac_id` int(11) default NULL,
  `obj_id` int(11) default NULL,
  `obj_type` varchar(6) default NULL,
  `parent_type` varchar(16) default NULL,
  `parent_id` int(11) default NULL,
  `typical_age_range` text,
  `typical_age_range_language` char(2) default NULL,
  `typical_age_range_min` tinyint(3) NOT NULL default '-1',
  `typical_age_range_max` tinyint(3) NOT NULL default '-1',
  PRIMARY KEY  (`meta_typical_age_range_id`),
  KEY `rbac_obj` (`rbac_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_meta_typical_age_range`
--

/*!40000 ALTER TABLE `il_meta_typical_age_range` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_meta_typical_age_range` ENABLE KEYS */;

--
-- Table structure for table `il_news_item`
--

CREATE TABLE `il_news_item` (
  `id` int(11) NOT NULL auto_increment,
  `priority` int(11) default '1',
  `title` varchar(200) default NULL,
  `content` text,
  `context_obj_id` int(11) default NULL,
  `context_obj_type` varchar(10) default NULL,
  `context_sub_obj_id` int(11) default NULL,
  `context_sub_obj_type` varchar(10) default NULL,
  `content_type` enum('text','html','audio') default 'text',
  `creation_date` datetime default NULL,
  `update_date` datetime default NULL,
  `user_id` int(11) default NULL,
  `visibility` enum('users','public') default 'users',
  `content_long` text,
  `content_is_lang_var` tinyint(4) default '0',
  `mob_id` int(11) default NULL,
  `playtime` varchar(8) default NULL,
  PRIMARY KEY  (`id`),
  KEY `obj_id` (`context_obj_id`),
  KEY `c_date` (`creation_date`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_news_item`
--

/*!40000 ALTER TABLE `il_news_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_news_item` ENABLE KEYS */;

--
-- Table structure for table `il_news_read`
--

CREATE TABLE `il_news_read` (
  `user_id` int(11) NOT NULL default '0',
  `news_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`user_id`,`news_id`),
  KEY `user_id` (`user_id`),
  KEY `news_id` (`news_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_news_read`
--

/*!40000 ALTER TABLE `il_news_read` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_news_read` ENABLE KEYS */;

--
-- Table structure for table `il_news_subscription`
--

CREATE TABLE `il_news_subscription` (
  `user_id` int(11) NOT NULL default '0',
  `ref_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`user_id`,`ref_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_news_subscription`
--

/*!40000 ALTER TABLE `il_news_subscription` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_news_subscription` ENABLE KEYS */;

--
-- Table structure for table `il_object_def`
--

CREATE TABLE `il_object_def` (
  `id` char(10) NOT NULL,
  `class_name` varchar(200) NOT NULL,
  `component` varchar(200) NOT NULL,
  `location` varchar(250) NOT NULL,
  `checkbox` tinyint(4) NOT NULL,
  `inherit` tinyint(4) NOT NULL,
  `translate` char(5) NOT NULL,
  `devmode` tinyint(4) NOT NULL,
  `allow_link` tinyint(4) NOT NULL,
  `allow_copy` tinyint(4) NOT NULL,
  `rbac` tinyint(4) NOT NULL,
  `system` tinyint(4) NOT NULL,
  `sideblock` tinyint(4) NOT NULL,
  `default_pos` int(11) NOT NULL,
  `grp` char(10) NOT NULL,
  `default_pres_pos` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_object_def`
--

/*!40000 ALTER TABLE `il_object_def` DISABLE KEYS */;
INSERT INTO `il_object_def` VALUES ('cat','Category','Modules/Category','Modules/Category/classes',1,1,'db',0,0,1,1,0,0,10,'cat',10);
INSERT INTO `il_object_def` VALUES ('catr','CategoryReference','Modules/CategoryReference','Modules/CategoryReference/classes',1,0,'0',0,0,1,1,0,0,15,'cat',10);
INSERT INTO `il_object_def` VALUES ('chat','Chat','Modules/Chat','Modules/Chat/classes',1,1,'0',0,1,1,1,0,0,60,'',80);
INSERT INTO `il_object_def` VALUES ('chac','ChatServer','Modules/Chat','Modules/Chat/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('crs','Course','Modules/Course','Modules/Course/classes',1,1,'0',0,0,1,1,0,0,20,'',30);
INSERT INTO `il_object_def` VALUES ('crsr','CourseReference','Modules/CourseReference','Modules/CourseReference/classes',1,0,'0',0,0,1,1,0,0,25,'crs',20);
INSERT INTO `il_object_def` VALUES ('exc','Exercise','Modules/Exercise','Modules/Exercise/classes',1,1,'',0,1,1,1,0,0,170,'',160);
INSERT INTO `il_object_def` VALUES ('feed','ExternalFeed','Modules/ExternalFeed','Modules/ExternalFeed/classes',1,1,'',0,1,1,1,0,1,80,'',0);
INSERT INTO `il_object_def` VALUES ('file','File','Modules/File','Modules/File/classes',1,0,'0',0,1,1,1,0,0,90,'',150);
INSERT INTO `il_object_def` VALUES ('fold','Folder','Modules/Folder','Modules/Folder/classes',1,1,'0',0,0,1,1,0,0,40,'',20);
INSERT INTO `il_object_def` VALUES ('frm','Forum','Modules/Forum','Modules/Forum/classes',1,1,'0',0,1,1,1,0,0,70,'',90);
INSERT INTO `il_object_def` VALUES ('glo','Glossary','Modules/Glossary','Modules/Glossary/classes',1,1,'0',0,1,0,1,0,0,160,'',110);
INSERT INTO `il_object_def` VALUES ('grp','Group','Modules/Group','Modules/Group/classes',1,1,'0',0,0,1,1,0,0,50,'',70);
INSERT INTO `il_object_def` VALUES ('htlm','FileBasedLM','Modules/HTMLLearningModule','Modules/HTMLLearningModule/classes',1,1,'0',0,1,0,1,0,0,130,'lres',0);
INSERT INTO `il_object_def` VALUES ('icrs','iLincCourse','Modules/ILinc','Modules/ILinc/classes',1,1,'0',0,0,0,1,0,0,230,'',50);
INSERT INTO `il_object_def` VALUES ('icla','iLincClassroom','Modules/ILinc','Modules/ILinc/classes',0,0,'0',0,0,0,0,0,0,240,'',60);
INSERT INTO `il_object_def` VALUES ('lm','LearningModule','Modules/LearningModule','Modules/LearningModule/classes',1,1,'0',0,1,0,1,0,0,120,'lres',0);
INSERT INTO `il_object_def` VALUES ('dbk','DlBook','Modules/LearningModule','Modules/LearningModule/classes',1,1,'0',0,1,0,1,0,0,150,'lres',0);
INSERT INTO `il_object_def` VALUES ('mcst','MediaCast','Modules/MediaCast','Modules/MediaCast/classes',1,1,'',0,1,0,1,0,0,110,'',130);
INSERT INTO `il_object_def` VALUES ('mcts','MediaCastSettings','Modules/MediaCast','Modules/MediaCast/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('mep','MediaPool','Modules/MediaPool','Modules/MediaPool/classes',1,1,'0',0,1,0,1,0,0,200,'',190);
INSERT INTO `il_object_def` VALUES ('rcrs','RemoteCourse','Modules/RemoteCourse','Modules/RemoteCourse/classes',1,0,'0',0,1,1,1,0,0,30,'crs',40);
INSERT INTO `il_object_def` VALUES ('root','RootFolder','Modules/RootFolder','Modules/RootFolder/classes',0,0,'0',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('sahs','SAHSLearningModule','Modules/ScormAicc','Modules/ScormAicc/classes',1,1,'0',0,1,0,1,0,0,140,'lres',0);
INSERT INTO `il_object_def` VALUES ('sess','Session','Modules/Session','Modules/Session/classes',1,0,'0',0,0,1,1,0,0,15,'',15);
INSERT INTO `il_object_def` VALUES ('svy','Survey','Modules/Survey','Modules/Survey/classes',1,1,'0',0,1,1,1,0,0,190,'',180);
INSERT INTO `il_object_def` VALUES ('svyf','SurveyAdministration','Modules/Survey','Modules/Survey/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('spl','SurveyQuestionPool','Modules/SurveyQuestionPool','Modules/SurveyQuestionPool/classes',1,1,'0',0,1,0,1,0,0,220,'',210);
INSERT INTO `il_object_def` VALUES ('adm','SystemFolder','Modules/SystemFolder','Modules/SystemFolder/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('tst','Test','Modules/Test','Modules/Test/classes',1,1,'0',0,1,1,1,0,0,180,'',170);
INSERT INTO `il_object_def` VALUES ('assf','AssessmentFolder','Modules/Test','Modules/Test/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('qpl','QuestionPool','Modules/TestQuestionPool','Modules/TestQuestionPool/classes',1,1,'0',0,1,0,1,0,0,210,'',200);
INSERT INTO `il_object_def` VALUES ('webr','LinkResource','Modules/WebResource','Modules/WebResource/classes',1,0,'0',0,1,1,1,0,0,100,'',120);
INSERT INTO `il_object_def` VALUES ('wiki','Wiki','Modules/Wiki','Modules/Wiki/classes',1,1,'',0,1,0,1,0,0,115,'',140);
INSERT INTO `il_object_def` VALUES ('rolf','RoleFolder','Services/AccessControl','Services/AccessControl/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('role','Role','Services/AccessControl','Services/AccessControl/classes',1,0,'0',0,0,0,0,0,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('rolt','RoleTemplate','Services/AccessControl','Services/AccessControl/classes',1,0,'0',0,0,0,0,0,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('recf','RecoveryFolder','Services/Administration','Services/Administration/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('extt','ExternalToolsSettings','Services/Administration','Services/Administration/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('adve','AdvancedEditing','Services/AdvancedEditing','Services/AdvancedEditing/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('auth','AuthSettings','Services/Authentication','Services/Authentication/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('cals','CalendarSettings','Services/Calendar','Services/Calendar/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('cmps','ComponentSettings','Services/Component','Services/Component/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('lngf','LanguageFolder','Services/Language','Services/Language/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('lng','Language','Services/Language','Services/Language/classes',1,0,'0',0,0,0,0,0,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('mail','Mail','Services/Mail','Services/Mail/classes',0,0,'sys',0,0,0,1,0,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('mds','MDSettings','Services/MetaData','Services/MetaData/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('nwss','NewsSettings','Services/News','Services/News/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('typ','TypeDefinition','Services/Object','Services/Object/classes',0,0,'0',0,0,0,0,0,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('objf','ObjectFolder','Services/Object','Services/Object/classes',0,0,'sys',1,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('pays','PaymentSettings','Services/Payment','Services/Payment/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('pdts','PersonalDesktopSettings','Services/PersonalDesktop','Services/PersonalDesktop/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('ps','PrivacySecurity','Services/PrivacySecurity','Services/PrivacySecurity/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('seas','SearchSettings','Services/Search','Services/Search/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('sty','StyleSheet','Services/Style','Services/Style/classes',1,0,'0',0,0,0,0,0,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('stys','StyleSettings','Services/Style','Services/Style/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('tags','TaggingSettings','Services/Tagging','Services/Tagging/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('trac','UserTracking','Services/Tracking','Services/Tracking/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('usr','User','Services/User','Services/User/classes',1,0,'0',0,0,0,0,0,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('usrf','UserFolder','Services/User','Services/User/classes',0,1,'sys',0,0,0,1,1,0,0,'',0);
INSERT INTO `il_object_def` VALUES ('facs','FileAccessSettings','Services/WebDAV','Services/WebDAV/classes',0,0,'sys',0,0,0,1,1,0,0,'',0);
/*!40000 ALTER TABLE `il_object_def` ENABLE KEYS */;

--
-- Table structure for table `il_object_group`
--

CREATE TABLE `il_object_group` (
  `id` char(10) NOT NULL,
  `name` varchar(200) default NULL,
  `default_pres_pos` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_object_group`
--

/*!40000 ALTER TABLE `il_object_group` DISABLE KEYS */;
INSERT INTO `il_object_group` VALUES ('cat','Categories',10);
INSERT INTO `il_object_group` VALUES ('crs','Courses',30);
INSERT INTO `il_object_group` VALUES ('lres','LearningResources',100);
/*!40000 ALTER TABLE `il_object_group` ENABLE KEYS */;

--
-- Table structure for table `il_object_subobj`
--

CREATE TABLE `il_object_subobj` (
  `parent` char(10) NOT NULL,
  `subobj` char(10) NOT NULL,
  `max` tinyint(4) NOT NULL,
  PRIMARY KEY  (`parent`,`subobj`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_object_subobj`
--

/*!40000 ALTER TABLE `il_object_subobj` DISABLE KEYS */;
INSERT INTO `il_object_subobj` VALUES ('cat','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','cat',0);
INSERT INTO `il_object_subobj` VALUES ('recf','cat',0);
INSERT INTO `il_object_subobj` VALUES ('root','cat',0);
INSERT INTO `il_object_subobj` VALUES ('catr','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','catr',0);
INSERT INTO `il_object_subobj` VALUES ('recf','catr',0);
INSERT INTO `il_object_subobj` VALUES ('root','catr',0);
INSERT INTO `il_object_subobj` VALUES ('chat','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','chat',0);
INSERT INTO `il_object_subobj` VALUES ('crs','chat',0);
INSERT INTO `il_object_subobj` VALUES ('fold','chat',0);
INSERT INTO `il_object_subobj` VALUES ('grp','chat',0);
INSERT INTO `il_object_subobj` VALUES ('recf','chat',0);
INSERT INTO `il_object_subobj` VALUES ('adm','chac',1);
INSERT INTO `il_object_subobj` VALUES ('crs','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','crs',0);
INSERT INTO `il_object_subobj` VALUES ('recf','crs',0);
INSERT INTO `il_object_subobj` VALUES ('crsr','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('recf','crsr',0);
INSERT INTO `il_object_subobj` VALUES ('cat','crsr',0);
INSERT INTO `il_object_subobj` VALUES ('exc','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','exc',0);
INSERT INTO `il_object_subobj` VALUES ('crs','exc',0);
INSERT INTO `il_object_subobj` VALUES ('fold','exc',0);
INSERT INTO `il_object_subobj` VALUES ('grp','exc',0);
INSERT INTO `il_object_subobj` VALUES ('recf','exc',0);
INSERT INTO `il_object_subobj` VALUES ('cat','feed',0);
INSERT INTO `il_object_subobj` VALUES ('crs','feed',0);
INSERT INTO `il_object_subobj` VALUES ('grp','feed',0);
INSERT INTO `il_object_subobj` VALUES ('file','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','file',0);
INSERT INTO `il_object_subobj` VALUES ('crs','file',0);
INSERT INTO `il_object_subobj` VALUES ('fold','file',0);
INSERT INTO `il_object_subobj` VALUES ('grp','file',0);
INSERT INTO `il_object_subobj` VALUES ('recf','file',0);
INSERT INTO `il_object_subobj` VALUES ('fold','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('fold','fold',0);
INSERT INTO `il_object_subobj` VALUES ('grp','fold',0);
INSERT INTO `il_object_subobj` VALUES ('crs','fold',0);
INSERT INTO `il_object_subobj` VALUES ('recf','fold',0);
INSERT INTO `il_object_subobj` VALUES ('frm','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','frm',0);
INSERT INTO `il_object_subobj` VALUES ('crs','frm',0);
INSERT INTO `il_object_subobj` VALUES ('fold','frm',0);
INSERT INTO `il_object_subobj` VALUES ('grp','frm',0);
INSERT INTO `il_object_subobj` VALUES ('recf','frm',0);
INSERT INTO `il_object_subobj` VALUES ('glo','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','glo',0);
INSERT INTO `il_object_subobj` VALUES ('crs','glo',0);
INSERT INTO `il_object_subobj` VALUES ('fold','glo',0);
INSERT INTO `il_object_subobj` VALUES ('grp','glo',0);
INSERT INTO `il_object_subobj` VALUES ('recf','glo',0);
INSERT INTO `il_object_subobj` VALUES ('grp','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','grp',0);
INSERT INTO `il_object_subobj` VALUES ('crs','grp',0);
INSERT INTO `il_object_subobj` VALUES ('grp','grp',0);
INSERT INTO `il_object_subobj` VALUES ('fold','grp',0);
INSERT INTO `il_object_subobj` VALUES ('recf','grp',0);
INSERT INTO `il_object_subobj` VALUES ('htlm','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','htlm',0);
INSERT INTO `il_object_subobj` VALUES ('crs','htlm',0);
INSERT INTO `il_object_subobj` VALUES ('fold','htlm',0);
INSERT INTO `il_object_subobj` VALUES ('grp','htlm',0);
INSERT INTO `il_object_subobj` VALUES ('recf','htlm',0);
INSERT INTO `il_object_subobj` VALUES ('icrs','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','icrs',0);
INSERT INTO `il_object_subobj` VALUES ('crs','icrs',0);
INSERT INTO `il_object_subobj` VALUES ('grp','icrs',0);
INSERT INTO `il_object_subobj` VALUES ('icrs','icla',0);
INSERT INTO `il_object_subobj` VALUES ('lm','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','lm',0);
INSERT INTO `il_object_subobj` VALUES ('crs','lm',0);
INSERT INTO `il_object_subobj` VALUES ('fold','lm',0);
INSERT INTO `il_object_subobj` VALUES ('grp','lm',0);
INSERT INTO `il_object_subobj` VALUES ('recf','lm',0);
INSERT INTO `il_object_subobj` VALUES ('dbk','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','dbk',0);
INSERT INTO `il_object_subobj` VALUES ('crs','dbk',0);
INSERT INTO `il_object_subobj` VALUES ('fold','dbk',0);
INSERT INTO `il_object_subobj` VALUES ('grp','dbk',0);
INSERT INTO `il_object_subobj` VALUES ('recf','dbk',0);
INSERT INTO `il_object_subobj` VALUES ('mcst','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','mcst',0);
INSERT INTO `il_object_subobj` VALUES ('crs','mcst',0);
INSERT INTO `il_object_subobj` VALUES ('fold','mcst',0);
INSERT INTO `il_object_subobj` VALUES ('grp','mcst',0);
INSERT INTO `il_object_subobj` VALUES ('recf','mcst',0);
INSERT INTO `il_object_subobj` VALUES ('adm','mcts',1);
INSERT INTO `il_object_subobj` VALUES ('mep','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','mep',0);
INSERT INTO `il_object_subobj` VALUES ('crs','mep',0);
INSERT INTO `il_object_subobj` VALUES ('fold','mep',0);
INSERT INTO `il_object_subobj` VALUES ('grp','mep',0);
INSERT INTO `il_object_subobj` VALUES ('recf','mep',0);
INSERT INTO `il_object_subobj` VALUES ('rcrs','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','rcrs',0);
INSERT INTO `il_object_subobj` VALUES ('root','adm',1);
INSERT INTO `il_object_subobj` VALUES ('sahs','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','sahs',0);
INSERT INTO `il_object_subobj` VALUES ('crs','sahs',0);
INSERT INTO `il_object_subobj` VALUES ('fold','sahs',0);
INSERT INTO `il_object_subobj` VALUES ('grp','sahs',0);
INSERT INTO `il_object_subobj` VALUES ('recf','sahs',0);
INSERT INTO `il_object_subobj` VALUES ('sess','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('crs','sess',0);
INSERT INTO `il_object_subobj` VALUES ('recf','sess',0);
INSERT INTO `il_object_subobj` VALUES ('svy','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','svy',0);
INSERT INTO `il_object_subobj` VALUES ('crs','svy',0);
INSERT INTO `il_object_subobj` VALUES ('fold','svy',0);
INSERT INTO `il_object_subobj` VALUES ('grp','svy',0);
INSERT INTO `il_object_subobj` VALUES ('recf','svy',0);
INSERT INTO `il_object_subobj` VALUES ('adm','svyf',1);
INSERT INTO `il_object_subobj` VALUES ('spl','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','spl',0);
INSERT INTO `il_object_subobj` VALUES ('crs','spl',0);
INSERT INTO `il_object_subobj` VALUES ('fold','spl',0);
INSERT INTO `il_object_subobj` VALUES ('grp','spl',0);
INSERT INTO `il_object_subobj` VALUES ('recf','spl',0);
INSERT INTO `il_object_subobj` VALUES ('adm','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('tst','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','tst',0);
INSERT INTO `il_object_subobj` VALUES ('crs','tst',0);
INSERT INTO `il_object_subobj` VALUES ('fold','tst',0);
INSERT INTO `il_object_subobj` VALUES ('grp','tst',0);
INSERT INTO `il_object_subobj` VALUES ('recf','tst',0);
INSERT INTO `il_object_subobj` VALUES ('adm','assf',1);
INSERT INTO `il_object_subobj` VALUES ('qpl','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','qpl',0);
INSERT INTO `il_object_subobj` VALUES ('crs','qpl',0);
INSERT INTO `il_object_subobj` VALUES ('fold','qpl',0);
INSERT INTO `il_object_subobj` VALUES ('grp','qpl',0);
INSERT INTO `il_object_subobj` VALUES ('recf','qpl',0);
INSERT INTO `il_object_subobj` VALUES ('webr','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','webr',0);
INSERT INTO `il_object_subobj` VALUES ('crs','webr',0);
INSERT INTO `il_object_subobj` VALUES ('fold','webr',0);
INSERT INTO `il_object_subobj` VALUES ('grp','webr',0);
INSERT INTO `il_object_subobj` VALUES ('recf','webr',0);
INSERT INTO `il_object_subobj` VALUES ('wiki','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('cat','wiki',0);
INSERT INTO `il_object_subobj` VALUES ('crs','wiki',0);
INSERT INTO `il_object_subobj` VALUES ('fold','wiki',0);
INSERT INTO `il_object_subobj` VALUES ('grp','wiki',0);
INSERT INTO `il_object_subobj` VALUES ('recf','wiki',0);
INSERT INTO `il_object_subobj` VALUES ('rolf','rolt',0);
INSERT INTO `il_object_subobj` VALUES ('rolf','role',0);
INSERT INTO `il_object_subobj` VALUES ('recf','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('adm','recf',1);
INSERT INTO `il_object_subobj` VALUES ('extt','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('adm','extt',1);
INSERT INTO `il_object_subobj` VALUES ('adm','adve',1);
INSERT INTO `il_object_subobj` VALUES ('adm','auth',1);
INSERT INTO `il_object_subobj` VALUES ('adm','cals',1);
INSERT INTO `il_object_subobj` VALUES ('adm','cmps',1);
INSERT INTO `il_object_subobj` VALUES ('lngf','lng',0);
INSERT INTO `il_object_subobj` VALUES ('adm','lngf',1);
INSERT INTO `il_object_subobj` VALUES ('adm','mail',1);
INSERT INTO `il_object_subobj` VALUES ('adm','mds',1);
INSERT INTO `il_object_subobj` VALUES ('adm','nwss',1);
INSERT INTO `il_object_subobj` VALUES ('objf','typ',0);
INSERT INTO `il_object_subobj` VALUES ('adm','objf',1);
INSERT INTO `il_object_subobj` VALUES ('adm','pays',1);
INSERT INTO `il_object_subobj` VALUES ('adm','pdts',1);
INSERT INTO `il_object_subobj` VALUES ('adm','ps',1);
INSERT INTO `il_object_subobj` VALUES ('adm','seas',1);
INSERT INTO `il_object_subobj` VALUES ('stys','sty',0);
INSERT INTO `il_object_subobj` VALUES ('adm','stys',1);
INSERT INTO `il_object_subobj` VALUES ('adm','tags',1);
INSERT INTO `il_object_subobj` VALUES ('adm','trac',1);
INSERT INTO `il_object_subobj` VALUES ('usrf','rolf',1);
INSERT INTO `il_object_subobj` VALUES ('usrf','usr',0);
INSERT INTO `il_object_subobj` VALUES ('adm','usrf',1);
INSERT INTO `il_object_subobj` VALUES ('adm','facs',1);
/*!40000 ALTER TABLE `il_object_subobj` ENABLE KEYS */;

--
-- Table structure for table `il_plugin`
--

CREATE TABLE `il_plugin` (
  `component_type` char(10) NOT NULL default '',
  `component_name` varchar(90) NOT NULL default '',
  `slot_id` char(10) NOT NULL default '',
  `name` varchar(40) NOT NULL default '',
  `last_update_version` char(10) default NULL,
  `active` tinyint(4) default NULL,
  `db_version` int(11) NOT NULL default '0',
  PRIMARY KEY  (`component_type`,`component_name`,`slot_id`,`name`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_plugin`
--

/*!40000 ALTER TABLE `il_plugin` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_plugin` ENABLE KEYS */;

--
-- Table structure for table `il_pluginslot`
--

CREATE TABLE `il_pluginslot` (
  `component` varchar(200) NOT NULL default '',
  `id` char(10) NOT NULL default '',
  `name` varchar(200) default NULL,
  PRIMARY KEY  (`component`,`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_pluginslot`
--

/*!40000 ALTER TABLE `il_pluginslot` DISABLE KEYS */;
INSERT INTO `il_pluginslot` VALUES ('Modules/SurveyQuestionPool','svyq','SurveyQuestions');
INSERT INTO `il_pluginslot` VALUES ('Modules/TestQuestionPool','qst','Questions');
INSERT INTO `il_pluginslot` VALUES ('Services/COPage','pgcp','PageComponent');
INSERT INTO `il_pluginslot` VALUES ('Services/EventHandling','evhk','EventHook');
/*!40000 ALTER TABLE `il_pluginslot` ENABLE KEYS */;

--
-- Table structure for table `il_rating`
--

CREATE TABLE `il_rating` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(10) NOT NULL default '',
  `sub_obj_id` int(11) NOT NULL default '0',
  `sub_obj_type` char(10) NOT NULL default '',
  `user_id` int(11) NOT NULL default '0',
  `rating` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`obj_type`,`sub_obj_id`,`sub_obj_type`,`user_id`),
  KEY `obj` (`obj_id`,`obj_type`,`sub_obj_id`,`sub_obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_rating`
--

/*!40000 ALTER TABLE `il_rating` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_rating` ENABLE KEYS */;

--
-- Table structure for table `il_request_token`
--

CREATE TABLE `il_request_token` (
  `user_id` int(11) NOT NULL,
  `token` char(64) default NULL,
  `stamp` timestamp NOT NULL,
  `session` varchar(100) default NULL,
  KEY `uid` (`user_id`),
  KEY `session` (`session`),
  KEY `token` (`token`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_request_token`
--

/*!40000 ALTER TABLE `il_request_token` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_request_token` ENABLE KEYS */;

--
-- Table structure for table `il_subscribers`
--

CREATE TABLE `il_subscribers` (
  `usr_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `subject` varchar(255) NOT NULL,
  `sub_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_subscribers`
--

/*!40000 ALTER TABLE `il_subscribers` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_subscribers` ENABLE KEYS */;

--
-- Table structure for table `il_tag`
--

CREATE TABLE `il_tag` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(10) NOT NULL default '',
  `sub_obj_id` int(11) NOT NULL default '0',
  `sub_obj_type` char(10) NOT NULL default '',
  `user_id` int(11) NOT NULL default '0',
  `tag` varchar(100) NOT NULL default '',
  `offline` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`obj_type`,`sub_obj_id`,`sub_obj_type`,`user_id`,`tag`),
  KEY `obj` (`obj_id`,`obj_type`,`sub_obj_id`,`sub_obj_type`),
  KEY `tag` (`tag`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_tag`
--

/*!40000 ALTER TABLE `il_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_tag` ENABLE KEYS */;

--
-- Table structure for table `il_wiki_contributor`
--

CREATE TABLE `il_wiki_contributor` (
  `wiki_id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `status` int(11) default NULL,
  `status_time` timestamp NOT NULL,
  PRIMARY KEY  (`wiki_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_wiki_contributor`
--

/*!40000 ALTER TABLE `il_wiki_contributor` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_wiki_contributor` ENABLE KEYS */;

--
-- Table structure for table `il_wiki_data`
--

CREATE TABLE `il_wiki_data` (
  `id` int(11) NOT NULL,
  `startpage` varchar(200) NOT NULL default '',
  `short` varchar(20) NOT NULL default '',
  `online` tinyint(4) default '0',
  `rating` tinyint(4) default '0',
  `introduction` text,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_wiki_data`
--

/*!40000 ALTER TABLE `il_wiki_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_wiki_data` ENABLE KEYS */;

--
-- Table structure for table `il_wiki_missing_page`
--

CREATE TABLE `il_wiki_missing_page` (
  `wiki_id` int(11) NOT NULL,
  `source_id` int(11) NOT NULL,
  `target_name` varchar(200) NOT NULL default '',
  KEY `wiki_id` (`wiki_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_wiki_missing_page`
--

/*!40000 ALTER TABLE `il_wiki_missing_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_wiki_missing_page` ENABLE KEYS */;

--
-- Table structure for table `il_wiki_page`
--

CREATE TABLE `il_wiki_page` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(200) NOT NULL default '',
  `wiki_id` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `il_wiki_page`
--

/*!40000 ALTER TABLE `il_wiki_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `il_wiki_page` ENABLE KEYS */;

--
-- Table structure for table `ilinc_data`
--

CREATE TABLE `ilinc_data` (
  `obj_id` int(11) unsigned NOT NULL default '0',
  `type` varchar(5) NOT NULL default '',
  `course_id` int(11) unsigned NOT NULL default '0',
  `contact_name` varchar(255) default NULL,
  `contact_responsibility` varchar(255) default NULL,
  `contact_phone` varchar(255) default NULL,
  `contact_email` varchar(255) default NULL,
  `activation_unlimited` tinyint(2) default NULL,
  `activation_start` int(11) default NULL,
  `activation_end` int(11) default NULL,
  `activation_offline` enum('y','n') default NULL,
  `subscription_unlimited` tinyint(2) default NULL,
  `subscription_start` int(11) default NULL,
  `subscription_end` int(11) default NULL,
  `subscription_type` tinyint(2) default NULL,
  `subscription_password` varchar(32) default NULL,
  `akclassvalue1` varchar(40) default NULL,
  `akclassvalue2` varchar(40) default NULL,
  KEY `obj_id` (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ilinc_data`
--

/*!40000 ALTER TABLE `ilinc_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `ilinc_data` ENABLE KEYS */;

--
-- Table structure for table `ilinc_registration`
--

CREATE TABLE `ilinc_registration` (
  `obj_id` int(10) unsigned NOT NULL default '0',
  `usr_id` int(10) unsigned NOT NULL default '0',
  `usr_text` varchar(255) default NULL,
  `application_date` datetime default NULL,
  PRIMARY KEY  (`obj_id`),
  KEY `usr_id` (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ilinc_registration`
--

/*!40000 ALTER TABLE `ilinc_registration` DISABLE KEYS */;
/*!40000 ALTER TABLE `ilinc_registration` ENABLE KEYS */;

--
-- Table structure for table `int_link`
--

CREATE TABLE `int_link` (
  `source_type` varchar(10) NOT NULL default '',
  `source_id` int(11) NOT NULL default '0',
  `target_type` varchar(4) NOT NULL default '',
  `target_id` int(11) NOT NULL default '0',
  `target_inst` int(11) NOT NULL default '0',
  PRIMARY KEY  (`source_type`,`source_id`,`target_type`,`target_id`,`target_inst`)
) TYPE=MyISAM;

--
-- Dumping data for table `int_link`
--

/*!40000 ALTER TABLE `int_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `int_link` ENABLE KEYS */;

--
-- Table structure for table `ldap_attribute_mapping`
--

CREATE TABLE `ldap_attribute_mapping` (
  `server_id` int(11) NOT NULL default '0',
  `keyword` varchar(32) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  `perform_update` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`server_id`,`keyword`),
  KEY `server_id` (`server_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ldap_attribute_mapping`
--

/*!40000 ALTER TABLE `ldap_attribute_mapping` DISABLE KEYS */;
/*!40000 ALTER TABLE `ldap_attribute_mapping` ENABLE KEYS */;

--
-- Table structure for table `ldap_role_assignments`
--

CREATE TABLE `ldap_role_assignments` (
  `server_id` int(11) NOT NULL default '0',
  `rule_id` tinyint(3) NOT NULL auto_increment,
  `type` tinyint(1) NOT NULL default '0',
  `dn` text NOT NULL,
  `attribute` varchar(32) NOT NULL default '',
  `isdn` tinyint(1) NOT NULL default '0',
  `att_name` varchar(255) NOT NULL default '',
  `att_value` varchar(255) NOT NULL default '',
  `role_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`server_id`,`rule_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ldap_role_assignments`
--

/*!40000 ALTER TABLE `ldap_role_assignments` DISABLE KEYS */;
/*!40000 ALTER TABLE `ldap_role_assignments` ENABLE KEYS */;

--
-- Table structure for table `ldap_role_group_mapping`
--

CREATE TABLE `ldap_role_group_mapping` (
  `mapping_id` int(11) NOT NULL auto_increment,
  `server_id` int(3) NOT NULL default '0',
  `url` varchar(255) NOT NULL default '',
  `dn` varchar(255) NOT NULL default '',
  `member_attribute` varchar(64) NOT NULL default '',
  `member_isdn` tinyint(1) NOT NULL default '0',
  `role` int(11) NOT NULL default '0',
  `mapping_info` text,
  `mapping_info_type` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`mapping_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ldap_role_group_mapping`
--

/*!40000 ALTER TABLE `ldap_role_group_mapping` DISABLE KEYS */;
/*!40000 ALTER TABLE `ldap_role_group_mapping` ENABLE KEYS */;

--
-- Table structure for table `ldap_server_settings`
--

CREATE TABLE `ldap_server_settings` (
  `server_id` int(2) NOT NULL auto_increment,
  `active` int(1) NOT NULL default '0',
  `name` varchar(32) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `version` int(1) NOT NULL default '0',
  `base_dn` varchar(255) NOT NULL default '',
  `referrals` int(1) NOT NULL default '0',
  `tls` int(1) NOT NULL default '0',
  `bind_type` int(1) NOT NULL default '0',
  `bind_user` varchar(255) NOT NULL default '',
  `bind_pass` varchar(32) NOT NULL default '',
  `search_base` varchar(255) NOT NULL default '',
  `user_scope` tinyint(1) NOT NULL default '0',
  `user_attribute` varchar(255) NOT NULL default '',
  `filter` varchar(255) NOT NULL default '',
  `group_dn` varchar(255) NOT NULL default '',
  `group_scope` tinyint(1) NOT NULL default '0',
  `group_filter` varchar(255) NOT NULL default '',
  `group_member` varchar(255) NOT NULL default '',
  `group_memberisdn` tinyint(1) NOT NULL default '0',
  `group_name` varchar(255) NOT NULL default '',
  `group_attribute` varchar(64) NOT NULL default '',
  `group_optional` tinyint(1) NOT NULL default '0',
  `group_user_filter` varchar(255) NOT NULL default '',
  `sync_on_login` tinyint(1) NOT NULL default '0',
  `sync_per_cron` tinyint(1) NOT NULL default '0',
  `role_sync_active` tinyint(1) NOT NULL default '0',
  `role_bind_dn` varchar(255) NOT NULL default '',
  `role_bind_pass` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`server_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ldap_server_settings`
--

/*!40000 ALTER TABLE `ldap_server_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `ldap_server_settings` ENABLE KEYS */;

--
-- Table structure for table `link_check`
--

CREATE TABLE `link_check` (
  `obj_id` int(11) NOT NULL default '0',
  `page_id` int(11) NOT NULL default '0',
  `url` varchar(255) NOT NULL default '',
  `parent_type` varchar(8) NOT NULL default '',
  `http_status_code` int(4) NOT NULL default '0',
  `last_check` int(11) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `link_check`
--

/*!40000 ALTER TABLE `link_check` DISABLE KEYS */;
/*!40000 ALTER TABLE `link_check` ENABLE KEYS */;

--
-- Table structure for table `link_check_report`
--

CREATE TABLE `link_check_report` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `link_check_report`
--

/*!40000 ALTER TABLE `link_check_report` DISABLE KEYS */;
/*!40000 ALTER TABLE `link_check_report` ENABLE KEYS */;

--
-- Table structure for table `lm_data`
--

CREATE TABLE `lm_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `title` varchar(200) NOT NULL default '',
  `type` char(2) NOT NULL default '',
  `lm_id` int(11) NOT NULL default '0',
  `import_id` varchar(50) NOT NULL default '',
  `public_access` enum('y','n') NOT NULL default 'n',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `active` enum('y','n') default 'y',
  PRIMARY KEY  (`obj_id`),
  KEY `lm_id` (`lm_id`),
  KEY `type` (`type`)
) TYPE=MyISAM AUTO_INCREMENT=2;

--
-- Dumping data for table `lm_data`
--

/*!40000 ALTER TABLE `lm_data` DISABLE KEYS */;
INSERT INTO `lm_data` VALUES (1,'dummy','du',0,'','n','0000-00-00 00:00:00','0000-00-00 00:00:00','y');
/*!40000 ALTER TABLE `lm_data` ENABLE KEYS */;

--
-- Table structure for table `lm_menu`
--

CREATE TABLE `lm_menu` (
  `id` int(11) NOT NULL auto_increment,
  `lm_id` int(11) NOT NULL default '0',
  `link_type` enum('extern','intern') default NULL,
  `title` varchar(200) default NULL,
  `target` varchar(200) default NULL,
  `link_ref_id` int(11) default NULL,
  `active` enum('y','n') NOT NULL default 'n',
  PRIMARY KEY  (`id`),
  KEY `link_type` (`link_type`),
  KEY `lm_id` (`lm_id`),
  KEY `active` (`active`)
) TYPE=MyISAM;

--
-- Dumping data for table `lm_menu`
--

/*!40000 ALTER TABLE `lm_menu` DISABLE KEYS */;
/*!40000 ALTER TABLE `lm_menu` ENABLE KEYS */;

--
-- Table structure for table `lm_tree`
--

CREATE TABLE `lm_tree` (
  `lm_id` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`),
  KEY `jmp_lm` (`lm_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `lm_tree`
--

/*!40000 ALTER TABLE `lm_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `lm_tree` ENABLE KEYS */;

--
-- Table structure for table `lng_data`
--

CREATE TABLE `lng_data` (
  `module` varchar(30) NOT NULL default '',
  `identifier` varchar(60) NOT NULL default '',
  `lang_key` char(2) NOT NULL default '',
  `value` blob NOT NULL,
  `local_change` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`module`,`identifier`,`lang_key`),
  KEY `module` (`module`),
  KEY `lang_key` (`lang_key`)
) TYPE=MyISAM;

--
-- Dumping data for table `lng_data`
--

/*!40000 ALTER TABLE `lng_data` DISABLE KEYS */;
INSERT INTO `lng_data` VALUES ('payment','paya_pay_method','en','Pay method','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_order_date','en','Order date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_object_not_purchasable','en','It is not possible to sell this object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_object','en','Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_not_buyable','en','Not buyable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_not_assign_yourself','en','It is not possible to assign yourself.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_valid_login','en','This user name is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_vendor_selected','en','You haven\'t selected a vendor.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_trustees','en','No trustees created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_settings_necessary','en','There are no settings necessary for this pay method','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_prices_selected','en','Please select one price','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_price_available','en','No prices available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_objects_assigned','en','There are no sellable objects.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_object_selected','en','Please select one object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_bookings','en','No statistic available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_no_booking_id_given','en','Error: no \'booking id\' given','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_months','en','Month(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_locator','en','Payment Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_insert_only_numbers','en','Please insert only integers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_header','en','Payment Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_expires','en','Expire payment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_filter_reseted','en','Filter reseted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_error_update_booking','en','Error saving statistic data.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_error_no_object_id_given','en','Please choose an object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_error_mandatory_fields','en','Please fill in all mandatory fields (*).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_error_adding_customer','en','An error occured while adding the selling process to the statistics.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_err_adding_object','en','Error adding object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_enabled','en','Enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_enter_login','en','Please enter an user name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_prices_first','en','Please edit the prices first.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_prices','en','Edit Prices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_details','en','Edit Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_edit_pay_method','en','Edit Pay Method','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_disabled','en','Disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_deleted_object','en','Stoped payment for the selected object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_details_updated','en','Details updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_deleted_last_price','en','The last price has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_delete_trustee_msg','en','Deleted selected trustees.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_delete_price','en','Delete price','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_customer_added_successfully','en','The selling process was added to the statistics sucessfully.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_customer','en','Customer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_count_purchaser','en','Number of purchasers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_buyed_objects','en','Bought Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_buyable','en','Buyable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_added_trustee','en','Created new trustee.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_bookings_available','en','This object has been sold. Please delete all statistic data first.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_added_new_price','en','Created new price','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_add_price_title','en','New price','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_added_new_object','en','Added new object. Please edit the pay method and the prices.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_step3_debit_entry','en','Your order - Schritt 3/3: Enter your bank data and send your order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_update_view','en','Update view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_access','en','Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_add_customer','en','Add Selling Process','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_add_price','en','Add new price','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_starting','en','starts with','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_step1','en','Your order - Schritt 1/3: Enter your personal data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_step2','en','Your order - Schritt 2/3: Choose kind of payment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_step3_credit_card','en','Your order - Schritt 3/3: Enter your credit card data and send your order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_shopping_cart_empty','en','Your shopping cart is empty.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_send_order','en','Send order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_select_one_item','en','Please select one item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_select_price','en','Please select a price/duration combination.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_reset_filter','en','Reset filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_unreachable','en','The connection to the payment server of PayPal failed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_success','en','Thanks for your purchase of ILIAS objects using PayPal! You\'ll receive a written confirmation in PDF format by e-mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_failed','en','Your puchase of ILIAS objects using PayPal failed!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_wrong_vendor','en','Checking this transaction resulted in no match of the vendor.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_wrong_items','en','Checking this transaction resulted in no match of the sold items.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_wrong_customer','en','Checking this transaction resulted in no match of the customer.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_prev_trans_id','en','The transaction id given by PayPal was already used before.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_not_completed','en','The transaction isn\'t totally completed yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_info','en','If necessary feel free to contact the system administrator of this ILIAS installation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_paypal_error_fails','en','PayPal reports errors that occured during the transaction.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_payed_debit_entry','en','The order was paid by debit entry.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_payed_paypal','en','The order was paid by PayPal.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_order_date_til','en','Order date til','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_payed_credit_card','en','The order was paid by credit card.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_order_date_from','en','Order date from','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_not_buyed_any_object','en','You have not bought any object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_no_vendors_created','en','No vendors created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_message_thanks','en','Thank you for your ILIAS 3 order.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_message_attachment','en','As a confirmation for your order we send you a bill (PDF format) as attachment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_message_hello','en','Dear','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_message_regards','en','Yours sincerely','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_message_subject','en','Your ILIAS order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_item_already_in_sc_choose_another','en','This object was already taken up in your shopping cart. Select if necessary a new price/duration combination.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_locator','en','Payment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_item_already_in_sc','en','This object already exists in your shopping cart.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_info_paypal','en','To pay for those objects that are in your shopping cart you\'ll leave ILIAS temporary and head for the PayPal website. Please follow the steps that are shown to you there. After paying successfully you\'ll be directed back to ILIAS automatically. Don\'t close the window of your browser at any time whilst the selling process. Otherwise the objects you\'ve bought can\'t be activated for you automatically.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_info','en','Access to the following material is not for free. If you want to gain access to a certain learning object please select a price. You can purchase one or several learning objects by using the button \"shopping cart\" on your personal desktop.  You are going to gain immediate access to a chosen object and period.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_hint_paypal','en','Hint for PayPal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_header','en','Payment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_goto_shopping_cart','en','Goto the shopping cart','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_goto_buyed_objects','en','Goto your buyed objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_filter','en','Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_expires_info','en','This object is disposable. The payment has been expired, you can not buy it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_entitled_retrieve','en','Entitled to retrieve data for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_ending','en','ends with','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_deleted_items','en','The selected items have been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_deleted_booking','en','The entry has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_customer_no','en','Customer no.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_confirm_order','en','Please confirm your order by entering your password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_click_to_buy','en','Buy now','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_change_price','en','Change price/duration combination','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_your_order','en','Your order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_vat_included','en','VAT included','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_validity','en','valid until','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_subtotal_amount','en','Subtotal amount','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_total_amount','en','Total amount','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_thanks','en','Thank you. Your order was submitted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_terms_conditions_show','en','show','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_terms_conditions_read','en','I\'ve read the general terms and conditions and accept it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_terms_conditions','en','General terms and conditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_street_or_pobox','en','Please enter street and house number or po box.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_shopping_cart_empty','en','Your shopping card is empty.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_server_error_sysadmin','en','Please contact system administrator for further information.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_server_error_communication','en','Error while communictaion with payment server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_server_error_code','en','Payment server returns error code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_po_box','en','PO Box','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_please_select','en','Please select','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_personal_data_not_valid','en','Your personal data isn\'t valid. Please check out whether all fields are filled out correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_personal_data','en','Your personal data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_payment_type_not_valid','en','The kind of paying you\'ve choosen isn\'t valid. Please select another option.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_payment_type','en','Kind of paying','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_password_not_valid','en','Your password wasn\'t valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_optional','en','optional','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_or','en','or','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_house_number','en','House number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_personal_data','en','Please fill out the following form completely.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_payment_type','en','Please select how to pay.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_debit_entry','en','Please check out whether all articles you would like to order are in the shopping cart. By filling in your data for the debit entry and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_description_credit_card','en','Please check out whether all articles you would like to order are in the shopping cart. By filling in your credit card data and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_debit_entry_not_valid','en','The debit entry data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_debit_entry_data','en','Debit entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_debit_entry','en','Debit entry (german bank accounts only)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_credit_card_not_valid','en','The credit card data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_credit_card_data','en','Credit card','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_credit_card','en','Credit card','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_check_terms_conditions','en','Please confirm that you\'ve read the terms and conditions and accept it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_check_number','en','Check number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_card_number','en','Card number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_card_holder','en','Card holder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_bank_code','en','Bank code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_back','en','back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_account_number','en','Account number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bmf_account_holder','en','Account holder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bill_no','en','Incoice no.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_bank_data','en','Bank data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_article','en','Article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_all','en','All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_added_to_shopping_cart','en','Added item to shopping cart.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_add_to_shopping_cart','en','Add to shopping cart','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','info','en','Informations about the pay method','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','excel_export','en','Excel export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','duration','en','Duration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','currency_euro','en','Euro','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','currency_cent','en','Cent','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_yes','en','Yes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_very_low','en','Very Low','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_very_high','en','Very High','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_very_easy','en','Very Easy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_very_difficult','en','Very Difficult','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_version','en','Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_value','en','Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_validator','en','Validator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_unknown','en','Unknown','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_unix','en','Unix','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_unavailable','en','Unavailable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_typical_learning_time','en','Typical Learning Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_typical_age_range','en','Typical Age Range','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_type','en','Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_training','en','Training','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_terminator','en','Terminator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_technicalvalidator','en','Technical validator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_technicalimplementer','en','Technical implementer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_technical','en','Technical','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_teacher','en','Teacher','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_taxon_path','en','Taxon Path','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_taxon','en','Taxon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_table','en','Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_subjectmatterexpert','en','Subject matter expert','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_structure','en','Structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_source','en','Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_slide','en','Slide','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_skill_level','en','Skill Level','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_size','en','Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_simulation','en','Simulation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_semantic_density','en','Semantic Density','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_self_assessment','en','Self Assessment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_security_level','en','Security Level','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_scriptwriter','en','Scriptwriter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_school','en','School','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_role','en','Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_rights','en','Rights','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_revised','en','Revised','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_resource','en','Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_requires','en','Requires','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_requirement','en','Requirement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_relation','en','Relation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_references','en','References','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_reference','en','Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_quickedit','en','Quick Edit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_questionnaire','en','Questionnaire','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_purpose','en','Purpose','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_publisher','en','Publisher','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_problem_statement','en','Problem Statement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_pc_dos','en','PC-DOS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_please_select','en','Please select','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_prerequisite','en','Prerequisite','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_other_plattform_requirements','en','Other Platform Requirements','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_other','en','Other','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_or_composite','en','Or Composite','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_operating_system','en','Operating System','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_none','en','None','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_technical','en','No metadata available for the Technical section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_rights','en','No metadata available for the Rights section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_relation','en','No metadata available for the Relation section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_meta_metadata','en','No metadata available for the Meta-Metadata section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_lifecycle','en','No metadata available for the Lifecycle section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_educational','en','No metadata available for the Educational section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_classification','en','No metadata available for the Classification section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no_annotation','en','No metadata available for the Annotation section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_no','en','No','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_new_element','en','New Element','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_networked','en','Networked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_narrative_text','en','Narrative Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_name','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_multi_os','en','Multi-OS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_mixed','en','Mixed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_ms_windows','en','MS-Windows','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_minimum_version','en','Minimum Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_metadatascheme','en','Metadata Scheme','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_meta_metadata','en','Meta-Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_medium','en','Medium','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_maximum_version','en','Maximum Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_manager','en','Manager','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_low','en','Low','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_mac_os','en','MacOS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_location','en','Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_local_file','en','Local File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_linear','en','Linear','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_lifecycle','en','Lifecycle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_lecture','en','Lecture','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_learning_resource_type','en','Learning Resource Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_learner','en','Learner','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_language','en','Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_zu','en','Zulu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_zh','en','Chinese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_za','en','Zhuang','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_yo','en','Yoruba','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_yi','en','Yiddish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_xh','en','Xhosa','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_wo','en','Wolof','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_vo','en','Volapuk','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_vi','en','Vietnamese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_uz','en','Uzbek','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ur','en','Urdu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_uk','en','Ukrainian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ug','en','Uigur','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tw','en','Twi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tt','en','Tatar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ts','en','Tsonga','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tr','en','Turkish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_to','en','Tonga','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tn','en','Setswana','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tl','en','Tagalog','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tk','en','Turkmen','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ti','en','Tigrinya','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_th','en','Thai','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_tg','en','Tajik','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_te','en','Telugu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ta','en','Tamil','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sw','en','Swahili','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sv','en','Swedish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_su','en','Sundanese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_st','en','Sesotho','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ss','en','Siswati','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sr','en','Serbian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sq','en','Albanian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_so','en','Somali','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sn','en','Shona','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sm','en','Samoan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sl','en','Slovenian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sk','en','Slovak','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_si','en','Singhalese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sh','en','Serbo-croatian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sg','en','Sangho','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sd','en','Sindhi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_sa','en','Sanskrit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_rw','en','Kinyarwanda','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ru','en','Russian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ro','en','Romanian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_rn','en','Kurundi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_rm','en','Rhaeto-romance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_qu','en','Quechua','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_pt','en','Portuguese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ps','en','Pashto;pushto','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_pl','en','Polish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_pa','en','Punjabi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_or','en','Oriya','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_om','en','Afan (oromo)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_oc','en','Occitan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_no','en','Norwegian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_nl','en','Dutch','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ne','en','Nepali','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_na','en','Nauru','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_my','en','Burmese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mt','en','Maltese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ms','en','Malay','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mr','en','Marathi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mo','en','Moldavian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mn','en','Mongolian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ml','en','Malayalam','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mk','en','Macedonian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mi','en','Maori','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_mg','en','Malagasy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_lv','en','Latvian;lettish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_lt','en','Lithuanian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_lo','en','Laothian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ln','en','Lingala','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_la','en','Latin','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ky','en','Kirghiz','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ku','en','Kurdish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ks','en','Kashmiri','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ko','en','Korean','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_kn','en','Kannada','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_km','en','Cambodian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_kl','en','Greenlandic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_kk','en','Kazakh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ka','en','Georgian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_jv','en','Javanese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ja','en','Japanese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_iu','en','Inuktitut','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_it','en','Italian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_is','en','Icelandic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ik','en','Inupiak','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ie','en','Interlingue','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_id','en','Indonesian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ia','en','Interlingua','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hy','en','Armenian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hu','en','Hungarian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hr','en','Croatian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_hi','en','Hindi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_he','en','Hebrew','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ha','en','Hausa','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gu','en','Gujarati','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gn','en','Guarani','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gl','en','Galician','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_gd','en','Scots gaelic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ga','en','Irish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fy','en','Frisian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fr','en','French','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fo','en','Faroese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fj','en','Fiji','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fi','en','Finnish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_fa','en','Persian (farsi)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_eu','en','Basque','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_et','en','Estonian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_es','en','Spanish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_eo','en','Esperanto','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_en','en','English','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_el','en','Greek','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_dz','en','Bhutani','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_de','en','German','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_da','en','Danish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_cy','en','Welsh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_cs','en','Czech','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_co','en','Corsican','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ca','en','Catalan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_br','en','Breton','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bo','en','Tibetan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bn','en','Bengali;bangla','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bi','en','Bislama','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bh','en','Bihari','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_bg','en','Bulgarian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_be','en','Byelorussian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ba','en','Bashkir','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_az','en','Azerbaijani','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ay','en','Aymara','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_as','en','Assamese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ar','en','Arabic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_am','en','Amharic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_af','en','Afrikaans','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_ab','en','Abkhazian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_l_aa','en','Afar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_kind','en','Kind','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_keyword','en','Keyword','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_is_version_of','en','Is Version Of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_is_required_by','en','Is Required By','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_is_referenced_by','en','Is Referenced By','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_is_part_of','en','Is Part Of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_is_format_of','en','Is Format Of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_is_basis_for','en','Is Basis For','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_is_based_on','en','Is Based On','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_interactivity_type','en','Interactivity Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_interactivity_level','en','Interactivity Level','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_intended_end_user_role','en','Intended End User Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_instructionaldesigner','en','Instructional designer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_instructional_designer','en','Instructional designer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_installation_remarks','en','Installation Remarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_initiator','en','Initiator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_info_tlt_not_valid','en','The current value is not valid. Therefore it can not be used other sections, e.g for learning progress statistics. Please insert atypical learning time in hours and/or minutes.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_index','en','Index','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_identifier','en','Identifier','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_idea','en','Idea','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_id','en','Id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_higher_education','en','Higher Education','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_high','en','High','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_hierarchical','en','Hierarchical','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_has_version','en','Has Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_has_part','en','Has Part','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_has_format','en','Has Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_graphicaldesigner','en','Graphical designer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_graph','en','Graph','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_general','en','General','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_format','en','Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_final','en','Final','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_figure','en','Figure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_expositive','en','Expositive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_experiment','en','Experiment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_exercise','en','Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_entity','en','Entity','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_entry','en','Entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_exam','en','Exam','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_educationalvalidator','en','Educational validator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_educational_objective','en','Educational Objective','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_educational_level','en','Educational Level','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_educational','en','Educational','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_education','en','Education','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_easy','en','Easy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_editor','en','Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_draft','en','Draft','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_duration','en','Duration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_difficulty','en','Difficulty','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_difficult','en','Difficult','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_diagramm','en','Diagram','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_delete','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_description','en','Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_date','en','Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_current_value','en','Current value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_coverage','en','Coverage','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_creator','en','Creator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_cost','en','Cost','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_copyright_and_other_restrictions','en','Copyright and Other Restrictions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_copyright','en','Copyright','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_contribute','en','Contribute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_context','en','Context','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_contentprovider','en','Content provider','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_competency','en','Competency','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_collection','en','Collection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_classification','en','Classification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_choose_section','en','Please choose a section','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_choose_element','en','Please choose an element you want to add!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_choose_language','en','Please choose a language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZZ','en','Other Country','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_catalog','en','Catalog','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZR','en','Zaire','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZW','en','Zimbabwe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZM','en','Zambia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_YT','en','Mayotte','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ZA','en','South Africa','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_YE','en','Yemen','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_WS','en','Samoa','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VU','en','Vanuatu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_WF','en','Wallis And Futuna Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VN','en','Viet Nam','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VG','en','Virgin Islands (British)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VI','en','Virgin Islands (US)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VC','en','Saint Vincent And The Grenadines','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VE','en','Venezuela','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UY','en','Uruguay','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UZ','en','Uzbekistan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_VA','en','Vatican City State','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UM','en','U.S. Minor Outlying Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_US','en','U.S.A','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UG','en','Uganda','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_UA','en','Ukraine','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TZ','en','Tanzania','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TW','en','Taiwan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TV','en','Tuvalu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TT','en','Trinidad And Tobago','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TR','en','Turkey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TP','en','East Timor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TO','en','Tonga','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TN','en','Tunisia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TM','en','Turkmenistan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TK','en','Tokelau','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TJ','en','Tajikistan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TH','en','Thailand','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TG','en','Togo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TF','en','French Southern Territories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TD','en','Chad','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_TC','en','Turks And Caicos Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SZ','en','Swaziland','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SY','en','Syrian Arab Republic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SV','en','El Salvador','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ST','en','Sao Tome And Principe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SR','en','Suriname','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SO','en','Somalia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SN','en','Senegal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SM','en','San Marino','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SL','en','Siearra Leone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SK','en','Slovakia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SJ','en','Svalbard And Jan Mayen Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SI','en','Slovenia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SH','en','St. Helena','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SE','en','Sweden','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SG','en','Singapore','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SD','en','Sudan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SC','en','Seychelles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SB','en','Solomon Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RW','en','Rwanda','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_SA','en','Saudi Arabia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RO','en','Romania','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RU','en','Ran Federation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_RE','en','Reunion','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_QA','en','Qatar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PY','en','Paraguay','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PW','en','Palau','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PT','en','Portugal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PR','en','Puerto Rico','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PN','en','Pitcairn','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PM','en','St. Pierre And Miquelon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PL','en','Poland','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PK','en','Pakistan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PH','en','Philippines','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PF','en','French Polynesia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PG','en','Papua New Guinea','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_OM','en','Oman','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PA','en','Panama','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_PE','en','Peru','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NZ','en','New Zealand','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NR','en','Nauru','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NU','en','Niue','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NP','en','Nepal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NO','en','Norway','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NL','en','Netherlands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NI','en','Nicaragua','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NG','en','Nigeria','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NF','en','Norfolk Island','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NE','en','Niger','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NC','en','New Caledonia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_NA','en','Namibia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MZ','en','Mozambique','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MY','en','Malaysia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MX','en','Mexico','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MW','en','Malawi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MV','en','Maldives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MU','en','Mauritius','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MT','en','Malta','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MS','en','Montserrat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MR','en','Mauritania','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MQ','en','Martinique','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MP','en','Northern Mariana Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MO','en','Macau','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MN','en','Mongolia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MM','en','Myanmar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ML','en','Mali','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MK','en','Macedonia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MH','en','Marshall Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MG','en','Madagascar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MC','en','Monaco','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MD','en','Moldova','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_MA','en','Morocco','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LY','en','Libyan Arab Jamahiriya','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LV','en','Latvia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LU','en','Luxembourg','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LT','en','Lithunia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LS','en','Lesotho','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LR','en','Liberia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LK','en','Sri Lanka','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LI','en','Liechtenstein','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LC','en','Saint Lucia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LB','en','Lebanon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_LA','en','Lao People\'s Republic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KZ','en','Kazakhstan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KY','en','Cayman Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KW','en','Kuwait','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KR','en','South Korea (Republic Of Korea)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KP','en','North Korea (People\'s Republic Of Korea)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KH','en','Cambodia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KI','en','Kiribati','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KM','en','Comoros','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KN','en','Saint Kitts And Nevis','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KG','en','Kyrgyzstan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IO','en','British Indian Ocean Territory','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IQ','en','Iraq','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IR','en','Iran','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IS','en','Iceland','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IT','en','Italy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_JM','en','Jamaica','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_JO','en','Jordan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_JP','en','Japan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_KE','en','Kenya','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IN','en','India','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IL','en','Israel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_IE','en','Ireland','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ID','en','Indonesia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HT','en','Haiti','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HU','en','Hungary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HR','en','Croatia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GY','en','Guyana','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HM','en','Heard And Nc Donald Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_HN','en','Honduras','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GW','en','Guinea-Bissau','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GU','en','Guam','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GT','en','Guatemala','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GS','en','South Georgia And The South Sandwich Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GR','en','Greece','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GQ','en','Equatorial Guinea','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GP','en','Guadeloupe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GN','en','Guinea','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GM','en','Gambia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GL','en','Greenland','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GI','en','Gibraltar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GH','en','Ghana','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GF','en','French Guiana','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GD','en','Grenada','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GE','en','Giorgia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GB','en','United Kingdom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FX','en','France, Metropolitan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_GA','en','Gabon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FR','en','France','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FM','en','Micronesia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FO','en','Faroe Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FK','en','Falkland Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FJ','en','Fiji','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_FI','en','Finland','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ET','en','Ethiopia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ES','en','Spain','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_ER','en','Eritrea','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EH','en','Western Sahara','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EG','en','Egypt','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EE','en','Estonia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_EC','en','Ecuador','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DZ','en','Algeria','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DO','en','Dominican Republic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DM','en','Dominica','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DK','en','Denmark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DJ','en','Djibouti','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_DE','en','Germany','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CZ','en','Czech Republic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CX','en','Christmas Island','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CY','en','Cyprus','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CR','en','Costa Rica','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CU','en','Cuba','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CV','en','Cape Verde','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CO','en','Colombia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CN','en','China','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CM','en','Cameroon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CL','en','Chile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CK','en','Cook Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CG','en','Congo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CH','en','Switzerland','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CI','en','Cote D\' Ivoire','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CC','en','Cocos (Keeling) Islands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CF','en','Central African Republic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BZ','en','Belize','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_CA','en','Canada','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BY','en','Belarus','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BW','en','Botswana','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BV','en','Bouvet Island','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BT','en','Bhutan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BS','en','Bahamas','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BO','en','Bolivia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BR','en','Brazil','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BM','en','Bermuda','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BN','en','Brunei Darussalam','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BJ','en','Benin','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BI','en','Burundi','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BH','en','Bahrain','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BG','en','Bulgaria','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BF','en','Burkina Faso','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BD','en','Bangladesh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BE','en','Belgium','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BB','en','Barbados','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_BA','en','Bosnia And Herzegowina','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AZ','en','Azerbaijan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AW','en','Aruba','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AU','en','Australia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AS','en','American Samoa','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AT','en','Austria','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AR','en','Argentina','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AQ','en','Antarctica','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AO','en','Angola','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AN','en','Netherlands Antilles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AM','en','Armenia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AI','en','Anguilla','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AL','en','Albania','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AG','en','Antigua And Barbuda','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AE','en','United Arab Emirates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AF','en','Afghanistan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_c_AD','en','Andorra','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_browser','en','Browser','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_atomic','en','Atomic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_author','en','Author','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_add','en','Add','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_annotation','en','Annotation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_active','en','Active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_accessibility_restrictions','en','Accessibility Restrictions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_time','en','Time:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_days','en','Days:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_months','en','Month:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','search_recipients','en','Search Recipients','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','placeholders_advise','en','Placeholders are only resolved for recipients in the To field.%sRecipients in the CC and BCC field will get unsolved placeholders.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','activate_serial_letter_placeholders','en','Activate Serial-Letter Placeholders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_no_valid_mailing_list','en','No Valid Mailing List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','send_mail_to','en','Mail to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','search_cc_recipient','en','Search CC Recipient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','search_bc_recipient','en','Search BCC Recipient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_received_x_new_mails','en','You received %s new mails.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_cronjob_notification_info','en','You can activate a periodic notification about new mail here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_empty_trash','en','Empty Trash','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_empty_trash_confirmation','en','Are you sure you want to delete all mails in trash?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_user_addr_n_valid','en','Following users have no valid e-mail address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_to','en','To','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete_folder','en','The folder and its contents will be removed permanently','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete_file','en','The file will be removed permanently','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete_entry','en','Are sure you want to delete the following entries?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_sure_delete','en','Are you sure you want to delete the marked mail(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_send_with_system_address','en','Send With System Address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_select_one_file','en','You must select one file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_select_one_entry','en','You must select one entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_search_system','en','search in system','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_search_addressbook','en','search in address book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_saved','en','The message has been saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_salutation_male','en','Salutation, male','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_salutation_general','en','Salutation, general','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_salutation_female','en','Salutation, female','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_s_unread','en','Unread Mail(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_s','en','Mail(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_recipient_not_valid','en','The recipient is not valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_options_saved','en','Options saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_options_of','en','Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_multiple_recipients_found','en','Enter a more specific mail address. ILIAS found multiple possible recipients for this address: %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_no_recipient_found','en','Enter a different mail address. ILIAS couldn\'t find a recipient with this mail address.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_no_permissions_write_smtp','en','You have no permission to write external e-mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_no_attachments_found','en','No attachments found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_no_attach_allowed','en','System messages are not allowed to contain attachments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_new_file','en','Add new file:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_use_placeholder','en','The following placeholders may be used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target_type','en','Type of target item, e.g. \"Course\" for a course item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target_title','en','Title of target item, e.g. course title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target_block','en','This text is only included, if a target item is provided.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_target','en','URL of target item, e.g. a linked course that is passed to ILIAS from outside.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_salutation','en','Salutation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_pw_block','en','This text block is only included, if the new user account has been created including a password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_no_pw_block','en','This text block is only included, if the new user account has been created without a password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_login','en','Login Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_client_name','en','Client Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_ilias_url','en','URL of ILIAS system','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_nacc_admin_mail','en','Mail address of Administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_notification_subject','en','New mail in your inbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_moved_to_trash','en','Mail has been moved to trash','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_move_to','en','Move to:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_moved','en','The mail has been moved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_move_error','en','Error moving mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_mark_read','en','Mark mail read','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_mark_unread','en','Mark mail unread','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_maxsize_attachment_error','en','The upload limit is:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_message_send','en','Message sent','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_insert_query','en','Please insert a query','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_intern','en','Internal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_insert_folder_name','en','Please insert a folder name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming_local','en','only local','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming_smtp','en','forward to e-mail address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming_both','en','local and forwarding','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_global_options','en','Global options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_incoming','en','Incoming mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_options','en','Folder Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_following_rcp_not_valid','en','The following recipients are not valid:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_name_changed','en','The folder has been renamed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_name','en','Folder name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_exists','en','A folder already exists with this name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_deleted','en','The folder has been deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_edit','en','Edit Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_folder_created','en','A new folder has been created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_file_size','en','File size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_files_deleted','en','The file(s) are deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_file_name','en','File name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_entry_exists','en','An entry with the given login name already exists.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_entry_changed','en','The entry is changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_enter_valid_email_addr','en','Please enter a valid e-mail address.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_enter_valid_login','en','Please enter a valid login name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_entry_added','en','Added new Entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_enter_login_or_email_addr','en','Please enter a valid login name or e-mail address.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_deleted_entry','en','The entries are deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_email_forbidden','en','You are not allowed to send e-mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_deleted','en','The mail is deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_compose','en','Compose Message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_check_your_email_addr','en','Your e-mail address is not valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_change_to_folder','en','Switch to folder:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_cc_not_valid','en','The CC recipient is not valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_cc_search','en','CC search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_byte','en','Byte','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_bc_search','en','BCC search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_attachments','en','Attachments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_bc_not_valid','en','The BCC recipient is not valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_assign_entry_to_mailing_list','en','Assign an Entry of Your Address Book to Mailing List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_mailing_lists_all_addressbook_entries_assigned','en','You have already assigned all of your addressbook entries to this mailing list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_mailing_lists_no_addressbook_entries','en','You have not any addressbook entries yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_addr_entries','en','Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_add_type','en','Please add the type of mail you want to send','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_add_to_addressbook','en','Add to address book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_add_subject','en','Please enter a subject','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_add_subfolder','en','Add Subfolder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_add_recipient','en','Please enter a recipient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_account_mail_check','en','Send Account Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_account_mail','en','Account Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','linebreak','en','Line break','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','forward','en','Forward','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','bc','en','BCC','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','also_as_email','en','Also as E-Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','wk','en','wk','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','tt_date_format','en','%a, %b %e','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','today','en','Today','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','time_part','en','(Shift-)Click or drag to change value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','time','en','Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','select_date','en','Select date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_we','en','We','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_tu','en','Tu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_th','en','Th','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_su','en','Su','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_sa','en','Sa','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_mo','en','Mo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_fr','en','Fr','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_12','en','Dec','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_11','en','Nov','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_10','en','Oct','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_09','en','Sep','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_08','en','Aug','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_07','en','Jul','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_06','en','Jun','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_05','en','May','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_04','en','Apr','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_03','en','Mar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_02','en','Feb','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','s_01','en','Jan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','prev_year','en','Prev. year (hold for menu)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','prev_month','en','Prev. month (hold for menu)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','part_today','en',' (today)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','open_calendar','en','Click here to open a calendar for date selection (JavaScript required!)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','next_year','en','Next year (hold for menu)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','next_month','en','Next month (hold for menu)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_we','en','Wednesday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_tu','en','Tuesday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_th','en','Thursday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_su','en','Sunday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_sa','en','Saturday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_mo','en','Monday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_fr','en','Friday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_12','en','December','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_11','en','November','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_10','en','October','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_09','en','September','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_08','en','August','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_07','en','July','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_06','en','June','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_05','en','May','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_04','en','April','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_02','en','Feburary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_03','en','March','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','go_today','en','Go Today','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','l_01','en','January','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','def_date_format','en','%Y-%m-%d','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','drag_to_move','en','Drag to move','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','day_first','en','Display %s first','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','close','en','Close','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','about_time','en','\\n\\nTime selection:\\n- Click on any of the time parts to increase it\\n- or Shift-click to decrease it\\n- or click and drag for faster selection.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','about_calendar_long','en','DHTML Date/Time Selector\\n(c) dynarch.com 2002-2003\\nFor latest version visit: http://dynarch.com/mishoo/calendar.epl\\nDistributed under GNU LGPL.  See http://gnu.org/licenses/lgpl.html for details.\\n\\nDate selection:\\n- Use the Â«, Â» buttons to select year\\n- Use the <, > buttons to select month\\n- Hold mouse button on any of the above buttons for faster selection.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jscalendar','about_calendar','en','About the calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_user_settings','en','iLinc User settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_user_id','en','iLinc UserID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_user_added','en','User account created on iLinc server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_no_account_yet','en','No iLinc Account yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_connection_error','en','Error: No connection to iLinc Server!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalues_refreshed','en','Cost centers updated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalues_desc','en','Enter here the code of the cost center(s) for this user. These values will be stored at the iLinc server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalues','en','Cost centers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalue2','en','Cost center 2','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_akuservalue1','en','Cost center 1','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','akclassvalues','en','Cost centers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','akclassvalue2','en','Cost center 2','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','akclassvalue1','en','Cost center 1','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ilinc','ilinc_member_administration','en','Edit Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_registration_unlimited','en','Unlimited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','post_activation_desc','en','If enabled, the moderator has to activate new posts.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','thread','en','Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','activate_new_posts','en','Activate Posts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','new_post','en','New Post','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','is_read','en','Mark as Read','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_title_required','en','Please insert a title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_ranking','en','Number of Postings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_enabled_desc','en','Enable Posting Statistics for all participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_enabled','en','Enable Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics_disabled_for_participants','en','Statistics are disabled for forum members.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_default_view','en','Default View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_anonymous_posting_desc','en','If enabled, anonymous posting is allowed within this forum.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_anonymous_posting','en','Anonymous Posting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_your_reply','en','Your Reply','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_threads_not_available','en','Topics Not Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_topics_overview','en','Topics Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_new_entry','en','New topic has been created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_marked','en','The topic has been marked as read.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_create_from','en','Created from','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_create_date','en','Created at','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_thread_articles','en','Articles of the topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_thread','en','Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_subject','en','Subject','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_the_post','en','Article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_respond','en','Post Reply','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_quote','en','Quote','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_print_view','en','Print View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_print_thread','en','Print Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_posts_not_available','en','Articles Not Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_posts','en','All articles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_no_posts_available','en','This topic has no posts yet or the moderator deactivated the first post.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_post_needs_to_be_activated','en','A new article has been created, but it needs to be activated by a moderator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_post_new_entry','en','A new article has been created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_post_modified','en','Article has been modified','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_post_deleted','en','Article has been deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_show_post','en','Show post: %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_subject','en','New posting in forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_overview','en','Forums Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_is_enabled','en','At the moment your notification about new posts in this topic is already enabled.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_intro','en','This mail was automatically sent to you by the ILIAS installation %s, %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_is_disabled','en','Your notification about new posts in this topic is not (yet) enabled.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_enabled','en','Notification enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification','en','Notification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_new_thread','en','New Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_not_available','en','Forums Not Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_new_entries','en','New Forums Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_mark_read','en','Mark All as Read','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_info_delete_post','en','Are you sure you want to delete this article including any responses?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_info_censor_post','en','Are you sure you want to hide this article?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_info_censor2_post','en','Revoke Censorship?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_enable_notification','en','Enable Notification for this Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_edit_post','en','Edit Article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_download_attachment','en','Download file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_disable_notification','en','Disable Notification for this Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_delete_file','en','Delete attachment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_created_by','en','Created by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_count_thr','en','Number of Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_count_art','en','Number of Articles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_count','en','Number of Forums','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','post_censored_comment_by_moderator','en','Post Censored, Comment by Moderator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_available','en','Available Forums','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_censor_comment','en','Comment of Censor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_attachments_add','en','Add attachment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_attachments_edit','en','Edit attachment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_attachments','en','Attachments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_all_threads_marked_read','en','All topics have been marked as read','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forum_add_quote','en','Add Quotation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums','en','Forums','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forum_anonymize_desc','en','Write this message anonymously (your ILIAS user name won\'t be shown anywhere).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forum_anonymize','en','Write anonymously','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_post_was_activated','en','The post was activated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_post_and_children_were_activated','en','The post and all its child posts were activated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_post_and_children_were_deactivated','en','The post and all its child posts were deactivated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','deactivate_current_and_childs','en','Deactivate All Posts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','activate_current_and_childs','en','Activate All Posts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','activate_only_current','en','Activate Current','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','deactivate_post_txt','en','Would you really like to deactivate the current post and all its child posts?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','activate_post_txt','en','Would you really like to activate the current post and if applicable all its child posts? Please note that all parent posts will be activated, too.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','deactivate_post','en','Deactivate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','activate_post','en','Activate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','reopen_topics','en','Reopen','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','close_topics','en','Close','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','topic_close','en','Closed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','make_topic_non_sticky','en','Make Topic Non-Sticky','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','make_topic_sticky','en','Make Topic Sticky','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','make_topics_non_sticky','en','Make Topics Non-Sticky','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','make_topics_sticky','en','Make Topics Sticky','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','sticky','en','Sticky','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','sure_move_threads','en','Are you sure you want to move the chosen topics?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','no_forum_selected','en','No forum selected for moving the chosen topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','to_forum','en','To Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','move_chosen_topics','en','Move Chosen Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','no_forum_available_for_moving_threads','en','No forum available to move the chosen topics to.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','topics_please_select_one_action','en','Please select an action.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','select_at_least_one_thread','en','Please select at least one topic.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','threads_moved_successfully','en','The chosen topics were moved to another forum successfully.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_your_submission','en','Your Submission','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_send_mail','en','Send Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_mark','en','Mark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_notgraded','en','Not Graded','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_grading','en','Grading','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_feedback_from_tutor','en','Feedback from Tutor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_failed','en','Failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_comment_for_learner','en','Comment for Learner','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_comment','en','Comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','year','en','Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','wk_short','en','WK','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','today','en','Today','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','viewlist','en','View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','week','en','Week','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','to','en','to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','timeslice','en','Time:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','timedate','en','Time / Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','starttime_for_view','en','Start time for view:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_11','en','Nov','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_12','en','Dec','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','shorttext','en','Short Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','singleDate','en','Single Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_10','en','Oct','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_08','en','Aug','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_09','en','Sep','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_07','en','Jul','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_06','en','Jun','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_04','en','Apr','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_05','en','May','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_03','en','Mar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_01','en','Jan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','short_02','en','Feb','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','semester_name','en','Semester Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','rotation_dates','en','Recurrence events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','rotation','en','Recurrence','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','readimportfile','en','Insert','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_year','en','Every year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_nonrecurring','en','Once','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_week','en','Every week','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_month','en','Every month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_halfyear','en','Every half year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_day','en','Every day','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_4_weeks','en','Every 4 weeks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','pyear','en','Next Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','r_14','en','Every 14 days','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','pweek','en','Next Week','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','properties','en','Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','printlist','en','Print','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','open_day','en','Day View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','pmonth','en','Next Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','of','en','of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','no_entry','en','No events available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','o_day_date','en','24-hour event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','new_doc','en','Create new event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','newDates','en','New Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','newKeyword','en','New:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','myeahr','en','Last Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','mweek','en','Last Week','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','mmonth','en','Last Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','month','en','Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','more','en','More','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','menue','en','Menu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_12','en','December','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','main_dates','en','Main Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_11','en','November','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_10','en','October','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_09','en','September','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_08','en','August','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_07','en','July','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_05','en','May','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_06','en','June','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_04','en','April','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_03','en','March','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_02','en','February','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','long_01','en','January','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','last_change','en','Last changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','keep','en','Keep','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','keyword','en','Keyword','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','keywords','en','Keywords','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','k_alldates','en','All Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','insertImportDates','en','These events were successfully registered:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','inbox','en','Inbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','importDates','en','Import of Outlook Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_week','en','Calendar week view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_week_l','en','In the week view all events of a given week are displayed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','hour','en','hour','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_starttime','en','Start time - syntax[hh/mm] 24-hour format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_starttime_l','en','Contains the starting time of the event using 24-hour format.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_text','en','Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_text_l','en','Here one can enter the text for a given event.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_startdate_l','en','Contains the starting time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_startdate','en','Start date - syntax[dd/mm/yyyy]','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_rotation','en','Recurrence','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_rotation_l','en','Contains the type of the recurrence / repetition.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_shorttext','en','Short text, max. 50 characters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_shorttext_l','en','Here one can enter the short text for a given date.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_time_l','en','The standard display time for the day view and week view can be changed. If dates are outside of the display time for a given days or week, the display time will be changed for that time span. Standard is 8h -18h.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_time','en','Display time for day view/week view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_new_l','en','Add a new keyword to the field \\\"new\\\". Important: max. 20 characters.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_new','en','Add a keyword, max. 20 characters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_import_l','en','Here a CSC-File can be selected, which contains Outlook-Events. These events will be imported into the calendar.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_import','en','Import of Outlook-CSV-Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_del_l','en','Choose a keyword from the dialog box. Click the button to delete the keyword.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_del','en','Deletes the keyword','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_alt_l','en','Choose a keyword from the dialog box.<br />Change the keyword in the text field. Important: max. 20 characters.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_properties_alt','en','Changes the keyword','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_month_l','en','In the month view all events of a given month are displayed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_month','en','Calendar month view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_list','en','Calendar event list','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_list_l','en','In the event list, all events of a given period of time are displayed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keyword_l','en','Contains the keywords which a user can associate to dates.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keywordUse_l','en','Choose one or more keywords from the dialog box.<br />TIP: use the CTRL key for selecting several entries.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keyword','en','Keyword selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_keywordUse','en','Keyword selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_inbox_l','en','Here all new, changed, and deleted group events are displayed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_inbox','en','Calendar Inbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_group_l','en','Contains the groups for which the logged-in user has administrator rights and for which a date can be created.<br />After choosing this it is possible to view the unscheduled time of the group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_group','en','Group events selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_further','en','<br /><b>click here for further information.</b>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_fullday_l','en','If the event stretches over a whole day, please choose this option.<br />This will hide the start time, end time, and end date.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_fullday','en','Whole day event - syntax[on/off]','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_filename','en','dp_help_en.html','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endtime_l','en','Contains the end time of the appointment using 24-hour format.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endtime','en','End time - syntax[hh/mm] 24-hour format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endrotation_l','en','At this day the repetition will end.<br />The symbol opens a small calendar for choosing the appropriate date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_endrotation','en','End time syntax[dd/mm/yyyy]','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_enddate','en','End date - syntax[dd/mm/yyyy]','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_enddate_l','en','Contains the end time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_day_l','en','In the day view all events of a chosen day are displayed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','help_day','en','Calendar Day View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','group','en','Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','freetime','en','Free Time in group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','free','en','Free','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','extra_dates','en','One Day Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','execute','en','Execute choices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','error_minical_img','en','Cannot create GD-picture-stream','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','endtime_for_view','en','End time for view:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','end_date','en','End Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_whole_rotation','en','Would you like to delete the entire recurring series? (click the checkbox)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_whole_day','en','Whole day:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_text','en','Text:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_startdate','en','Start date:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_shorttext','en','Short text:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_rotation_end','en','Recurrence end:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_rotation_date','en','Recurrence date:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_rotation','en','Recurrence:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_preview','en','<b>! Preview !</b>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_noKey','en','no Keyword','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_noGroup','en','no Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_message','en','Message:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_keywordselect','en','Keyword select:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_keywords','en','Keywords:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_groupview_text','en','Group:<br />','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_date_hm','en','Hour:Minute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_enddate','en','End date:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_groupselect','en','Group select:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_groupview','en','Group event:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_update','en','Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_date_begin','en','Start Date:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_date_end','en','End Date:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_insert','en','Insert','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_cancel','en','Cancel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_button_delete','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','dv_Grouptime','en','Free time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','discard','en','Discard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','del_one','en','Delete one event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','deletedDates','en','Deleted Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','del_all','en','Delete all events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','date_format_middle','en','m/d/y','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','date_format','en','m/d/Y H:i','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','date','en','Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','created','en','Created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','checkforfreetime','en','Check for free time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','changedDates','en','Changed Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','changeTo','en','Change to:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','c_date','en','Create Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','busytime','en','Busy time in group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','begin_date','en','Begin Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','back','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','apply','en','Apply','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','application','en','Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_week','en','Week View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_properties','en','Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_inbox','en','Inbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_list','en','List of Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_month','en','Month View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_freetime','en','Free time of other group members (catch a time)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_day','en','Day View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_date','en','Create Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','add_data','en','Additional Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','app_','en','Inbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Week_long','en','Week View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','We_short','en','We','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','We_long','en','Wednesday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Tu_short','en','Tu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','View','en','View:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Tu_long','en','Tuesday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Th_short','en','Th','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Th_long','en','Thursday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Text','en','Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Su_short','en','Su','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Sa_short','en','Sa','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Su_long','en','Sunday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Sa_long','en','Saturday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Month_long','en','Month View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Mo_short','en','Mo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Mo_long','en','Monday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Listbox_long','en','List of Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Language_file','en','English','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Fr_short','en','Fr','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Fr_long','en','Friday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_TS','en','Incorrect date format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_STARTTIME','en','Wrong start time. Format: hh:mm','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_STARTDATE','en','Wrong start date input. Format: dd/mm/yyyy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_SHORTTEXT','en','Wrong short text input. Short text is required.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ROT_END_START','en','Wrong recurring end date input. Recurring end date is before start date.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ROTATIONEND','en','Wrong recurring end date input. Format: dd/mm/yyyy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_JAVASCRIPT','en','<B><CENTER>your browser doesn\'t accept JavaScript.<br />Please close this Window after insert manually.<br />Thank you</CENTER></B>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_FILE_CSV_MSG','en','Please take a valid CSV File.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_END_START','en','Wrong end date input. End date is before start date.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ENDTIME','en','Wrong end time. Format: hh:mm','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_ENDDATE','en','Wrong end date input. Format: dd/mm/yyyy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DEL_MSG','en','This is a recurring event. Would you like to delete one event or the series','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DB_CONNECT','en','The database is disconnected.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DB','en','Database write error!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','ERROR_DATE_EXISTS','en','This event already exists.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','Day_long','en','Day View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','DateText','en','Message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','tutor_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','tutor_phone','en','Phone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','tutor_name','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','tutor_lastname','en','Lastname','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','tutor_email','en','E-Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','tutor_firstname','en','Firstname','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timings_usr_edit','en','Edit Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timings_timings_on','en','Switch Timings Administration On','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timings_timings_off','en','Switch Timings Administration Off','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timings_timings','en','Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timings','en','Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timings_edit','en','Edit Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timings_of','en','Timings Off','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timing_user_accept','en','Accept Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timing_user_accepted','en','Timings Accepted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timing_tutor_visible','en','Remark is visible for course tutors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timing_remark','en','Remark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timing_not_accepted','en','Not Accepted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timing_accepted','en','Accepted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','timing_accept_table','en','Timings: Remarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','import_crs','en','Import Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','learners_view','en','Learners view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','subscription_times_not_valid','en','The registration period is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_updated','en','Saved Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','events','en','Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','events_deleted','en','Session deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_unregistered','en','You have been unregistered.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_unregister','en','Unregister','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_tutor_data','en','Informations About the Lecturer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_time','en','Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_tbl_registered','en','Registered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_tbl_participated','en','Participated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_table_update','en','Edit Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_tbl_participants','en','List of Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_table_create','en','New Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_start_date','en','Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_save_participants','en','Save Participance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_registration_participance','en','Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_registration_info','en','Allow users to register to the session.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_registration','en','Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_registered','en','You have been registered to this session.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_register','en','Register','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_participation','en','Participation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_location','en','Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_lecturer','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_general_properties','en','General Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_general_infos','en','General Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_further_informations','en','Further Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_fulltime_info','en','All Day Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_fullday','en','Full-Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_full_time_info','en','full-time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_file_size_info','en','Filesize','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_file_name','en','Filename','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_file_download','en','Files for Download','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_existing_files','en','Existing Files:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_etime_smaller_stime','en','The ending time is earlier than the starting time. Please enter a valid time span.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_end_date','en','End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_edit_members','en','Edit Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_details_workflow','en','Details/Workflow','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_desc','en','Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_delete_sure','en','Do really want to delete this session?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_date_time','en','Date & Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_delete_file','en','Delete File?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_date','en','Date of Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_btn_add','en','Add Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_assign_materials_table','en','Assignment of Course Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_assign_materials_info','en','Assigned course materials will be displayed directly below the session.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_assign_materials','en','Assign Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_add_new_event','en','Added new session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event','en','Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','edit_timings_list','en','Edit Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','edit_content','en','Edit Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_youre_position','en','Your Position on the Waiting List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_xml','en','XML','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_waiting_list','en','Waiting List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_wait_info','en','If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility_until','en','Temporarily Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility_unvisible','en','Offline (Course is not available)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility_limitless','en','Unlimited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_visibility','en','Availability','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_view_timing','en','Timings View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_view_by_type','en','Grouped-by-Type View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_view_simple','en','Simple View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_view_sessions','en','Sessions View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_switched_editor','en','Switched to new content.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_switch_to_new_editor_cmd','en','Switch to this page for presentation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_switch_to_new_editor_message','en','This is the supported standard editor. Please use it to setup the content page. If you click the following link, the content presentation in the repository will switch from the old editor\'s content to this page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_back_to_old_editor','en','Back to Old Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_old_editor_open_standard_editor','en','Open Standard Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_old_editor_warning','en','The maintenance of this editor will be discontinued in a future major releases of ILIAS. You may still use it to edit the content of this page now. But we recommend to switch to the standard page editor of ILIAS when possible.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_view_objective','en','Objective Oriented View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_view_mode','en','Course Presentation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_view_info_timing','en','Presentation mode for timing presettings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_hide_title_and_icon','en','Hide Title and Icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_view_info_by_type','en','This content presentation groups all items by resource type.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_view_info_simple','en','This content presentation lists all items in one block.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cntr','cntr_view_info_sessions','en','This content presentation groups all sessions first. After that the other course content is listed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_view_info_objective','en','This presentation mode is used for the presentation of learning objectives.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_view_archive','en','Archive View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_users_removed_from_list','en','The selected users have been removed from the waiting list','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_users_already_assigned','en','The user is already assigned to this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_users_added','en','Added user to the course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_update_objective','en','Edit Learning Objective','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_unsubscribed_from_crs','en','You have been unsubscribed from this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_unsubscribe_sure','en','Do you want to unsubscribe from this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_unlimited','en','Unlimited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_unsubscribe','en','Unsubscribe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_unblocked_member_body','en','Your membership in course \"%s\" has been restored','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_unblocked_member','en','Status in course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_unblocked','en','Free entrance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_tutors','en','Tutors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_tutor_notify','en','Tutor (notification)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_to','en','Until:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_tutor','en','Tutor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_tutor_no_notify','en','Tutor (no notification)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_visibility','en','If chosen, the material is visible even outside of the given availability.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_update_error','en','Your settings are not valid, please verify the timings for the following course materials:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_time_frame','en','Time Frame','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_suggested_info','en','Suggested Editing Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_sug_end','en','Suggested End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_sug_begin','en','Suggested Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_start_end_info','en','(Start/End)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_start','en','Starting Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_start_end','en','Suggestion','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_limit_start_end','en','Changeable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_changeable','en','Changeable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_short_active','en','Enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_presetting_tbl','en','Time Target','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_presetting','en','Time Target Enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_planed_start','en','Planed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_planed_info','en','Planed Editing Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_not_changed','en','Timings not Modified','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_late_end','en','Latest End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_in_days','en','(In Days)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_info_active','en','(Active)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_from_until','en','(From/Until)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_early_begin','en','Earliest Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_end','en','Ending Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_duration','en','Duration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_disabled_info','en','Choose this option to disable any timings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_disabled','en','Timings Disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_changed','en','Timings Modified','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_changeable','en','Time Target Changeable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_availability_tbl','en','Availability','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_availability_enabled','en','Temporarily Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_time','en','Subscription time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_test_status_random','en','Random test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_test_status_not_complete','en','Not complete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_test_status_complete','en','Complete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_table_start_objects','en','Start Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_syllabus','en','Syllabus','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sure_delete_selected_archives','en','Are you sure to delete the selected archives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_suggestion_end','en','Suggested End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_suggest_lm','en','Suggest learning materials if:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_type','en','Subscription type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_successful','en','You have joined the course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_password','en','Join with Course Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_requested','en','You have requested membership for the course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_direct','en','Join Directly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_deactivated','en','Deactivated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_options_confirmation','en','Request Membership','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_notify','en','Notify for subscriptions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_max_members','en','Limited Number of Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription','en','Subscription','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscribers_deleted','en','Deleted subscriber(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscribers','en','Join Requests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_structure','en','Course structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_status_changed','en','Status in course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_status_changed_body','en','Your status in course \"%s\" has been changed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_starters_already_assigned','en','This object was already assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_starter_deleted','en','Removed assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_start_objects','en','Start Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_start','en','Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sortorder_abo','en','Content Item Sorting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sortorder','en','Sort','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_title_info','en','Choose this mode to sort course items automatically by title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_title','en','Sort by Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_timing_info','en','Sort course items be their activation time or timing presettings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_manual_info','en','This mode offers you the possibility to sort course items manually.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_manual','en','Sort Manually','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_sort_activation','en','Sort by Activation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_size','en','File size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_objectives_view','en','Objective view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_members_info','en','If activated, course members can access the members gallery and the send mail to members feature.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_members','en','Show Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_tst','en','Show tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_or','en','Show other resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_objectives','en','Show objectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_lms','en','Show learning materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_settings','en','Course Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_settings_saved','en','Settings saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_set_on_waiting_list','en','You can add your join request to the waiting list. You will receive a message from a course administrator when your request has been approved or rejected.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_starter','en','Select Start Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_registration_type','en','Please select an admittance procedure.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_one_object','en','Please select one course item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_one_archive','en','Please select one archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_native_lm','en','Single chapters can only be assigned to native ILIAS learning modules.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_exactly_one_tst','en','Please select exactly one test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_exactly_one_lm','en','Please select exactly one learning module.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_select_archive_language','en','Please select a language for the archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_search_str','en','Search term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_search_members','en','User search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_search_for','en','Search for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_role_status','en','Role / Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_search_enter_search_string','en','Please enter a search string','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reset_results','en','Reset Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_role','en','Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reject_subscriber_body','en','Your request to join course \"%s\" has been declined.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reject_subscriber','en','Declined for course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_unlimited','en','Unlimited Registration Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_type','en','Registration Procedure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_limited','en','Limited Registration Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_registration_deactivated','en','Choose this option for disabling course registration. No user can join this course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_registration','en','Course Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_user_blocked','en','You are blocked from this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_user_already_subscribed','en','You have already requested membership for this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_user_already_assigned','en','You are already assigned to this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_until','en','Registration Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_unlim_info','en','If enabled, there is no time limit for registrations. Please choose one of the registration procedures below.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_start_later','en','The registration time starts later','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_max_members_reached','en','The maximum number of users is exceeded.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_end_earlier','en','The registration time is expired','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_subscription_deactivated','en','Registration is disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_notify_info','en','If enabled all course administrators/tutors with status \'Notify\' will be informed by mail about new registrations.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_max_info','en','Define the maximum number of users that can be assigned to this course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_lim_info','en','Registrations are only possible during a fixed period of time.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_deactivated','en','Disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg','en','Registration Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_question_assignment','en','Question assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_print_list','en','Print list','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_pdf','en','PDF','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_persons_on_waiting_list','en','Persons on the Waiting List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_password_required','en','This registration procedure requires a password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_password_not_valid','en','Your password is not valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_other_resources','en','Other Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_other_groupings','en','Groupings of other courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_options','en','Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_offline','en','Offline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_reseted','en','Reseted results.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_reset_sure','en','You want to delete all results of this course. <br />All test results will be deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_qst_deassigned','en','The question assignment has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_nr_questions','en','Number of questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_no_question_selected','en','Please select one question.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_max_points','en','Maximum points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_lm_assignment','en','Assignment of Course Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_pretest_non_suggest','en','The following are the results of your self assessment. <br />According to this you have fullfilled any learning objective. You can now take the final exam of this course, which is located in the test section of this page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_pretest','en','The following are the results of your self assessment. <br />Please select the red marked objectives one after another and work through their related material. <br />After you have processed all red marked objectives, you can take the final exam of this course, which is located in the test section of this page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_none','en','The following is a list of the course objectives.<br /> Please select the objectives one after another and work through the related materials.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_finished','en','Congratulations, you have accomplished all objectives of this course!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_info_final','en','You did not accomplish all course objectives in the previous exam. <br />Please select all red marked objectives one after another and review the related materials. <br />After you have reviewed all red marked objectives, you can take the exam again.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_edit_question_assignments','en','Edit Question Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_deleted','en','Delete learning objectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_deassign_question_sure','en','Are you sure, you want to delete the following questions?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_chapter_assignment','en','Chapter assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_questions','en','Assigned questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_new_questions','en','Added new assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_lms','en','Assigned learning materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assigned_lm','en','The selected materials have been assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives_assign_chapter','en','Assign Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objectives','en','Learning Objectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_view','en','Objective oriented view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_updated_test','en','Updated modifications.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_result','en','After final test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_question_assignment','en','Question assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_pretest','en','After initial test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_overview_question_assignment','en','Overview Question Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_overview_objectives','en','Overview Objectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_not_accomplished','en','Not accomplished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_no_title_given','en','Please enter a title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_modified','en','Updated learning objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_insert_percent','en','Please enter only numbers between 0 and 100.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_delete_lm_assignment','en','Delete assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_deassign_question','en','Delete assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assign_question','en','Assign question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assign_lm','en','Save Assignments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assign_chapter','en','Assign chapters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_accomplished','en','Accomplished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_number_users_added','en','The following number of users has been assigned to the course:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_nr','en','Nr.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_notify','en','Notify for new registrations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_notification','en','Notification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_not_available','en','-Not available-','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_valid_member_id_given','en','No valid member Id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_users_selected','en','You did not select any user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_users_added','en','No members added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_tests_inside_crs','en','No tests inside this course, which can be assigned to this learning objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_subscribers_selected','en','Please select a user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_starter_created','en','No start objects assigned to this course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_roles_selected','en','Please select a role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_results_found','en','No results found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_questions_assigned','en','There are no questions assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_question_selected','en','Please select one question.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_objectives_created','en','There are no objectives assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_objective_selected','en','Please select one objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_notify','en','No notify for new registrations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_members_assigned','en','There are no members assigned to this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lms_inside_crs','en','No learning materials inside this course, which can be assigned to this learning objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_member_selected','en','Please select one member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lms_inside_course','en','No learning materials found inside this course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lms_assigned','en','There are no learning materials assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_lm_selected','en','Please select one learning material.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_language','en','No language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_items_found','en','No items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_groups_selected','en','Please select a group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_groupings_assigned','en','No groupings assigned to this course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_exercises','en','No exercises found inside this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_chapter_selected','en','Please select a chapter.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_archives_selected','en','Please select an archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_archives_available','en','There are no archives available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_archive_selected','en','No archives selected','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_request_body2','en','You have to call the member administration of that course for accepting or refusing the membership request.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_request_body','en','A user has requested to join course \"%s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_request','en','Request to join course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription_body','en','A user has joined course \"%s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_new_subscription','en','User joined course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_new_search','en','New search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_moved_objective','en','Moved learning objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_moved_item','en','Moved course item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_move_up','en','Move up','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_move_down','en','Move down','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members_title','en','Course members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members_table','en','Course Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members_print_title','en','Course members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members_footer_passed','en','passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members_footer','en','course member(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members_deleted','en','Deleted members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members','en','Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_member_updated','en','The member has been updated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_member_unblocked','en','Member (unblocked)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_member_of','en','Member of course:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_member_blocked','en','Member (blocked)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_member_administration','en','Edit Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_member','en','Member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_mem_send_mail','en','Send Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_mem_change_status','en','Change status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_max_members_reached','en','The maximum number of members has been reached','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_materials','en','Course Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_lms_already_assigned','en','These learning materials were already assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_no_assignments_selected','en','Please select one assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_deassign','en','Delete assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_assignment_deleted','en','Deleted assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_lm_assignment','en','Learning material assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_list_users','en','List users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_learning_materials','en','Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_item_presetting_info','en','Choose this option to offer the learners suggested editing times.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_item_availability_info','en','Choose this option for making the item available for a fixed period of time. If \'Visiblity\' is checked the item will remain visble but not accessible for the learners.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_start','en','Please work through all of the course items stated below.<br />After you have processed all red marked objects new course items will be activated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_settings','en','Course Informations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_password','en','If a course administrator has given you the course password, you can join this course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_direct','en','You can join this course directly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_deactivated','en','Course admittance is closed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg','en','Admittance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_reg_confirmation','en','You can request membership for this course. You will get a message from a course administrator when your request has been admitted or declined.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_download','en','Files for Download','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_important_info','en','Important Informations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_html','en','HTML','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_tst','en','Hide tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_or','en','Hide other resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_objectives','en','Hide objectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_lms','en','Hide materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_header_remove_from_waiting_list','en','Waiting list: deassign users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_header_members','en','Course members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_header_edit_members','en','Edit Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_header_delete_subscribers','en','Delete subscribers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_header_delete_members','en','Delete Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_header_archives','en','Course Archives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_table_assigned_courses','en','Assigned courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_no_courses_assigned','en','No assigned courses.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_no_course_selected','en','Please select one course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_modified_grouping','en','Saved modifications.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_matriculation_required','en','This course grouping requires an unique matriculation number. <br />Please insert this value in your settings on the personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_enter_title','en','Please enter a title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_info_reg','en','You can only register to one of this courses:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_deassigned_courses','en','Delete assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_crs_assignment','en','Course assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_courses_already_assigned','en','The selected courses were already assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_assigned_courses','en','Assigned courses.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_assigned_courses_info','en','Assigned courses:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_assign_crs','en','Assign course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_already_assigned','en','You are already member of this course grouping.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_groupings_ask_delete','en','Delete course grouping','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_groupings','en','Course groupings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_select_one','en','Please select a course grouping.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_modified_assignment','en','Changed assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_deleted','en','Deleted course grouping.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_delete_sure','en','Do you really want to delete the following course groupings?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping_assign','en','Change assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grouping','en','Course grouping','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_general_informations','en','General Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_general_info','en','General Informations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_further_settings','en','Further Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_from','en','From:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_free_places','en','Available Places','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_filename','en','Filename','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_file_size_info','en','Filesize','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_file_name','en','File name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_file_download','en','Files for Download','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_export','en','Course export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_existing_files','en','Existing Files:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_end','en','End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_timings','en','Edit Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_start_objects','en','Edit Start Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_content','en','Edit items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_edit_archive','en','Edit Archives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_dismiss_member_body','en','You membership for course \"%s\" has been terminated!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_dismiss_member','en','Terminated membership for course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_details','en','Course Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_subscribers_sure','en','Do you want to delete the following users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_subscribers','en','Delete subscriber','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_objectve_sure','en','Are you sure, you want to delete the selected objectives?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_member','en','Deassign','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_members_sure','en','Do you want to delete the following members from this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_from_waiting_list','en','Remove from waiting list','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_from_list_sure','en','Are you sure, you want to deassign the following users from the list?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_delete_file','en','Delete File?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_dates','en','Dates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_deassign_lm_sure','en','Are you sure you want to delete this assignment?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_create_date','en','Create date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_crs_structure','en','Course structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_count_questions','en','Number of questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_count_members','en','Number of members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_copy_cat_not_allowed','en','It is not possible to copy categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_responsibility','en','Responsibility','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_content','en','Course Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_change_status','en','Changes status of objective:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_chapter_already_assigned','en','These chapters are already assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_contact','en','Contact','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_consultation','en','Consultation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_email','en','E-Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_name','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_phone','en','Telephone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_cancel_subscription_body','en','A member has resigned from course \"%s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_cancel_subscription','en','Resigned from course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_blocked_member_body','en','Your membership for course \"%s\" has been blocked.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_blocked_member','en','Membership status in course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_blocked','en','Access Refused','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_availability_unvisible_info','en','Choose this mode for preparing the course. Only course administators and tutors can see and edit the course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_availability_until_info','en','Choose this mode for making the course available and accessible to users for a fixed period of time (depending on the registration settings below).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_availability_limitless_info','en','Choose this mode for making the course available and accessible to users (depending on the registration settings below).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_auto_fill','en','Auto Fill','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archives_deleted','en','The archive(s) have been deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_type_disabled','en','Not available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_type','en','Archive type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_download','en','Allow the Download of Course Archives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_info','en','If enabled, all course content will we suppressed. Only HTML archives of this course will be available to course members.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_lang','en','Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_read','en','Read access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_select_type','en','Archive view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_disabled','en','Deactivated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive','en','Archives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_already_assigned_to_list','en','You are already assigned to the waiting list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_allow_abo','en','Allow subscription of course items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_administrators','en','Administrators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_admin_notify','en','Administrator (notification)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_admin_no_notify','en','Administrator (no notification)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_admin','en','Administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_added_to_list','en','You have been assigned to the waiting list. You are assigned to position %s on the waiting list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_added_starters','en','Assigned start object(s).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_added_objective','en','A new learning objective has been created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_added_new_archive','en','A new archive has been added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_added_member_body','en','You have been admitted to course \"%s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_added_member','en','Addmission to course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_added','en','Added new course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_subscribers','en','Add subscriber','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_starter','en','Add Start Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_remove_from_desktop_info','en','Allow the members to add course items to the personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_remove_from_desktop','en','Add/Remove from Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_objective','en','Add Objective','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_member','en','Add Member(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_grp_assignment','en','Assign course(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_html_archive','en','Add HTML archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_grouping','en','Add course grouping','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_archive_xml','en','Create a XML Archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_add_archive_html','en','Create a HTML Archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_news','en','Course News','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_activation','en','Activation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_access_password','en','Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_accept_subscriber_body','en','You have been admitted to course \"%s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_accept_subscriber','en','Admission to course \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','contact_email_not_valid','en','the contact e-mail is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','assigned','en','Assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','add_event','en','Add Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','activation_times_not_valid','en','The availability period is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_phpmysqlcheck','en','You need MYSQL 4.1 or higher and enabled JSON-support to use the JavaScript-RTE','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_start','en','Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_exit','en','Exit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_exitall','en','Exit All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_suspendall','en','Suspend All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_previous','en','Previous','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_continue','en','Continue','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_hidetree','en','Hide Tree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','scplayer_showtree','en','Show Tree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_close','en','Please close the player-window.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_toc','en','From the Table Of Contents on the left, choose an activity to begin the course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_abandonall','en','The current course session has been abandoned..','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_abandon','en','An Abandon Navigation Request was received an processed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_invalidnavreq','en','The sequencer received an invalid request.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_deadlock','en','The sequencer is in a deadlock.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_error','en','An internal error in the sequencer occurred.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_nothing','en','There is no activity to deliver.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_blocked','en','The sequencing session was blocked.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_endsession','en','The current course session has ended.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','set_public_mode','en','Set public access mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','st','en','Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','start export','en','Start Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','seq_coursecomplete','en','The current course is completed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','selected_pages_only','en','only that pages selected below','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','selectFooter','en','Select As Footer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','selectHeader','en','Select As Header','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','select_a_file','en','Please select a file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','read offline','en','Read Offline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','public_section','en','Public Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','pg','en','Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','par','en','Paragraph','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','pages from','en','Pages From','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','msg_page_not_public','en','Page is not public','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','msg_page_no_public_access','en','The page you called is not available in the public area. Only registered users may view this page. Please login first to access this page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','msg_entry_updated','en','Menu entry updated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','msg_entry_removed','en','Menu entry removed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','msg_entry_added','en','Menu entry added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','lm_menu_select_object_to_add','en','Please select the object you want to add to the menu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','lm_menu_select_internal_object','en','Select internal object >>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','lm_menu_new_entry','en','Create a new menu entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','lm_menu_entry_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','glo_definition_abbr','en','Def.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','glo_term_used_in','en','The following resources linking to that term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','lm_menu_edit_entry','en','Edit menu entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','lm_menu_entry_target','en','Target','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','copied_to_clipboard','en','Copied object(s) to clipboard.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','dgl_pagebreak','en','Pagebreak','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_zip_file_invalid','en','File is not a valid import file.<br>It does not contain a file \'%s\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_year','en','Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_xml_base','en','xml:base','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_wysiwyg','en','Content WYSIWYG','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_width','en','Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_where_published','en','Where published','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_view_last_export_log','en','Last Export Log','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_version','en','version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_validate_file','en','Validate File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_users_have_mob_in_clip2','en','user(s).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_users_have_mob_in_clip1','en','This media object is in the clipboard of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_usage','en','Usage','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_url','en','URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_upload_file','en','Upload File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_update_names','en','Update Names','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_update','en','Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_tree_fixed','en','Tree structure has been fixed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_translations_assigned','en','The translation(s) have been assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_translations','en','Translation(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_tracking_items','en','Tracking Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_tracking_data','en','Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_top','en','Top','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_total_time','en','Total Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_toc_mode','en','Table of Contents shows','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_toc','en','Table of Contents','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_title_footnotes','en','Footnotes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_title','en','title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_time_limit_action','en','adlcp:timelimitaction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_time','en','Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_xln','en','External Link:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_tex','en','LaTeX Code:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_str','en','Strong Text:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_quot','en','Quotation:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_iln','en','Internal Link, e.g.:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_fn','en','Footnote:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_emp','en','Emphatic Text:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_com','en','Comment:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_text_code','en','Code:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_terms','en','Terms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_term','en','Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_operation_not_allowed','en','This operation is not allowed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_target_within_source','en','Target must not be within source object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_width','en','Table Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_spreadsheet_import_info','en','Paste table from spreadsheet application via clipboard into the textarea.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_spreadsheet_import','en','Spreadsheet Import','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_html_import_info','en','Import only works with XHTML conform tables. Table must be root tag!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_html_import','en','Import HTML Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_cellspacing','en','Table Cell Spacing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_cellpadding','en','Table Cell Padding','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_border','en','Table Border','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table','en','Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_spreadsheet_table','en','Spreadsheet Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_html_table','en','HTML Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_paste_table','en','Paste Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_synchronize_frames_desc','en','This option synchronises the table of contents frame with the content frame and clears additional frames in 3 window view. But it also decreases performance.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_synchronize_frames','en','Synchronise frames','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_subchapters','en','Subchapters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_style','en','Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_structure','en','structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_std_view','en','Standard View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_std_is_in_dir','en','Deletion not possible. Standard view file is in directory.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_startfile','en','Start File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_st_title','en','Chapter Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_st_on_pg','en','this function is not allowed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_src_other','en','other','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_src','en','Source code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_source','en','Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_skip_chapter','en','Skip this chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_size','en','Size (Bytes)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_show_print_view','en','Show Print View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_show_line_numbers','en','Show line numbers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_show_citation','en','Show with citation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_show','en','Show','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_shape','en','Shape','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_width','en','Set Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_start_file','en','Set Start File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_shape','en','Edit Shape','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_link','en','Edit Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_into','en','insert into','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_edit_mode','en','Set Edit Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_class','en','Set Class','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_cancel','en','cancel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_before','en','insert before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_after','en','insert after','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_series_volume','en','Series volume','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_series_title','en','Series title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_series_editor','en','Series editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_series','en','Series','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_translation','en','Please select the assignment from the list above','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_term','en','Select a term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_one_translation_warning','en','It is not possible to show more than one translation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_one_translation','en','Please select one translation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_one_edition','en','Please select at least one edition.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_max_one_term','en','Select one term only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_max_one_item','en','Please select one item only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_item','en','Select at least one item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_scorm_type','en','adlcp:scormtype','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_score','en','Score','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_school','en','School','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_title','en','title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_running','en','Running','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_not_attempted','en','Not attempted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_incomplete','en','Incomplete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_failed','en','Failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_completed','en','Completed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_stat_browsed','en','Browsed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_less_mode_normal','en','Normal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_less_mode_browse','en','Browse','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_auto_review','en','Set lesson mode \'review\' if student completed SCO','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_saved_map_area','en','Saved map area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_saved_map_data','en','Saved map data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_rvalue','en','Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_resources','en','Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_resource_type','en','type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_resource','en','Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_resize_image','en','Resize images','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_resize_explanation2','en','This function resizes local image files to the specified width and height.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_resize_explanation','en','If this option is activated uploaded image files are automatically resized to the specified width and height.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_repository_item_links','en','Repository Item Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_print_view_pre_glo','en','Prevent Glossary Appendix in Print View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_target_missing','en','Target Missing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_repository_item','en','Repository Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_removeiln','en','really remove internal link ?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_reference','en','Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_remove_fullscreen','en','Remove Full Screen','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ref_images','en','Referenced Images','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ref_helptext','en','(e.g. http://www.server.org/myimage.jpg)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_selected_pg_chap','en','Selected Pages/Chapters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_current_chapter','en','Current Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_current_page','en','Current Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_purpose','en','Purpose','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_publisher','en','Publisher','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_public_notes','en','Public Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_public_notes_desc','en','Allow users to share notes on every page of the learning module.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_public_access','en','Public access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_print_view','en','Print View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_preview','en','Preview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_prerequisites','en','adlcp:prerequisites','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_please_select','en','please select','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_prereq_type','en','adlcp:prerequisites.type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_pg_title','en','Page Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_page_link','en','Page Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_page_select_target_now','en','Page marked for moving. Select target now.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_pages','en','Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_parameter','en','Parameter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_parameters','en','parameters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_paste_from_clipboard','en','Paste from clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_personal_clipboard','en','Personal Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_pg_content','en','Page Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_page_deactivated_elements','en','Page contains deactivated elements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_page_header','en','Page Header','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_organizations','en','Organizations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_orig_size','en','Original Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_page_deactivated','en','Page is deactivated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_organization','en','Organization','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_order','en','Order Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_or','en','or','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_online','en','Online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_current_version','en','Current Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_versions','en','Versions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_offline_versions','en','Offline Versions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_offline_files','en','Offline versions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_offline','en','Offline Versions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_obj_removed','en','Objects removed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_nr_rows','en','Number of Rows','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_nr_items','en','Number of Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_nr_cols','en','Number of Columns','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_none','en','None','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_zip_file','en','Import file is not a zip file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_subdir_in_zip','en','Zip command failed or import file invalid.<br>It does not contain a subfolder \'%s\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_page','en','No Page found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_object_found','en','Could not find any object with this title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_manifest','en','No imsmanifest.xml file found in main directory.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_assign_itself','en','The object cannot be assigned to itself','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_access','en','No Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_term','en','New Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_media_obj','en','New Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_file','en','New File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_dir','en','New Directory','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_assignment','en','New assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_area','en','New Link Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_name','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_msg_multiple_editions','en','It\'s not possible to show details of multiple editions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_move_object','en','move object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_month','en','Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_mob_usages','en','Usage','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_mob_def_prop','en','Default Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_mob_inst_prop','en','Instance Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_missing_preconditions','en','You need to fulfill the following preconditions to access the chapter \"%s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_mep_structure','en','Media Pool Structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_max_time_allowed','en','adlcp:maxtimeallowed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_media_source','en','Media Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_mastery_score','en','adlcp:masteryscore','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_inst_map_areas','en','Instance Link Areas','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_def_map_areas','en','Default Link Areas','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_map_areas','en','Link Areas','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_page_currently_deactivated','en','Sorry, but this page is currently deactivated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_no_page_in_chapter','en','Sorry, but there is currently no activated content within this chapter.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_manifest','en','Manifest','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lvalue','en','Data element','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lm_properties','en','Learning Module Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lm_menu','en','Menu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_term_new','en','Glossary Term (New Frame)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_term','en','Glossary Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_survey','en','Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_page_new','en','Page (New Frame)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_page_faq','en','Page (FAQ Frame)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_page','en','Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_new','en','Media (New Frame)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_media','en','Media (Media Frame)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_inline','en','Media (Inline)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_media_faq','en','Media (FAQ Frame)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_chapter_new','en','Chapter (New Frame)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_lk_chapter','en','Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_list_properties','en','List Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_list_files','en','List Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_linked_mobs','en','Linked media objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_link_type','en','Link Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_link_select','en','Internal Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_link_int','en','Link (internal)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_link_ext','en','Link (external)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_link_area','en','Link Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_link','en','Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_last_access','en','Last Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_journal','en','Journal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_keyword','en','Keyword','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_item','en','Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_issn','en','ISSN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_isbn','en','ISBN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_is_visible','en','isvisible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_internal_link','en','internal link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_internal','en','internal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_table','en','Insert Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_src','en','Insert source code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_search','en','Please insert a search term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_par','en','Insert Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_new_footnote','en','insert new footnote','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_mob','en','Insert Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_list','en','Insert Advanced List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_file_item','en','Insert File Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_file_list','en','Insert File List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_imagemap','en','Image Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_import_id','en','identifier','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_id_ref','en','identifierref','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_href','en','href','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_how_published','en','How published','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_height','en','Height','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_glo_properties','en','Glossary Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_header','en','Header','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_glo_menu','en','Menu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_get_orig_size','en','Set original size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_get_link','en','get link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_fullscreen','en','Full Screen','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_full_is_in_dir','en','Deletion not possible. Full screen file is in directory.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_free_pages','en','Free Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_frame_topright','en','Content Details (FAQ and Media)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_frame_toc','en','Table of Contents','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_frame_right','en','Content Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_frame_maincontent','en','Learning Resource Main Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_frame_botright','en','Content Details (Glossary)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_format_error','en','This operation is not allowed here!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_format','en','Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_footer','en','Footer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_fix_tree_confirm','en','Please execute this command only if the tree structure of this learning module is corrupted, e.g. if blank items occur in the explorer view.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_fix_tree','en','Fix structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_files','en','Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_external_url','en','external url','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_external','en','external','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_export_files','en','Export Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_enable_media','en','Media active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_enable_js','en','JavaScript active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_empty_mep_folder','en','There are no media objects in this folder.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edition','en','Edition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_term','en','Edit Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_tab_properties','en','Table Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_src','en','Edit Source Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_par','en','Edit Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob_properties','en','Edit Media Object Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob_files','en','Object Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob_alias_prop','en','Edit Media Object Instance Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_file_list_properties','en','Edit File List Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_mob','en','Edit Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_area','en','Edit Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_width','en','Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_split_page_next','en','Split to Next Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_split_page','en','Split to New Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_row_up','en','Move Row Up','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_row_down','en','Move Row Down','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_paste_clip','en','Paste From Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_row_before','en','New Row Before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_row_after','en','New Row After','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_item_before','en','New Item Before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_item_after','en','New Item After','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_col_before','en','New Column Before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_new_col_after','en','New Column After','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_moveafter','en','Move After','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_movebefore','en','Move Before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_item_down','en','Move Item Down','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_item_up','en','Move Item Up','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_section','en','Insert Section','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_edit_data','en','Edit Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_atable','en','Insert Advanced Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_dtable','en','Insert Data Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_par','en','Insert Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_media','en','Insert Image/Media','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_list','en','Insert Advanced List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_filelist','en','Insert File List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_code','en','Insert Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_go','en','Go','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_enable','en','(De-)Activate Elements','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_edit_prop','en','Edit Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_edit','en','Edit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete_row','en','Delete Row','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete_item','en','Delete Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete_col','en','Delete Column','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_delete','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_copy_clip','en','Copy to Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_col_right','en','Move Column Right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_col_left','en','Move Column Left','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_class','en','Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_right_float','en','Align: Right Float','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_right','en','Align: Right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_left_float','en','Align: Left Float','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_left','en','Align: Left','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_map','en','Insert Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_tabs_accordion','en','Accordion','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_tabs_hor_tabs','en','Horizontal Tabs','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_number_of_tabs','en','Number of Tabs','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_update_tabs','en','Update Tabs','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_tabs','en','Insert Tabs','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_tabs','en','Insert Tabs','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_insert_repobj','en','Insert Resource List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_ed_align_center','en','Align: Center','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_update_section','en','Update Section','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_type','en','Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_section','en','Insert Section','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_update_resources','en','Update Resource List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_resources','en','Insert Resource List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_downloads_public_desc','en','Allow download even for anonymous users (in public area)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_downloads_desc','en','Enable download of all public export files.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_save_all_titles','en','Save Titles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_as_chapter','en','Insert as Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_as_subchapter','en','Insert as Subchapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_downloads','en','Downloads','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_download_title','en','Download Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_enable_html','en','HTML active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_disable_html','en','HTML inactive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_disable_media','en','Media inactive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_disable_js','en','JavaScript inactive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_dir_file','en','Directory/File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_details','en','Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_derive_from_obj','en','Derive from Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_delete_selected','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_dependencies','en','Dependencies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_del_assignment','en','Delete assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_definitions','en','Definitions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_def_lesson_mode','en','Default lesson mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_def_organization','en','default','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_definition','en','Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_def_layout','en','Default Layout','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_de_activate','en','(De-)Activate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_deactivate_page','en','Deactivate Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_credit_on','en','Credit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_credits','en','Credits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_cross_reference','en','Cross reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_data_from_lms','en','adlcp:datafromlms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_credit_mode','en','Credit mode (for lesson mode \'normal\')','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_credit_off','en','No Credit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_mob','en','Create Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_html_version','en','Create HTML Package','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_folder','en','Create Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file_xml','en','Create Export File (XML)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file_scorm','en','Create Export File (SCORM)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file_html','en','Create Export File (HTML)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_export_file','en','Create Export File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_create_dir','en','Create Directory','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_copy_to_media_pool','en','Copy to media pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_copy_to_clipboard','en','Copy to clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_copy_object','en','copy object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_coords','en','Coordinates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_confirm_delete','en','Do you really want to delete this item(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_content','en','Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_content_obj','en','Content Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_contents','en','Contents','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_click_tl_corner','en','Please click on the top left corner of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_click_starting_point','en','Please click on the starting point of the polygon.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_click_next_point','en','Please click on the next point of the polygon.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_click_next_or_save','en','Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_click_circle','en','Please click on a circle point of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_click_center','en','Please click on center of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_click_br_corner','en','Please click on the bottom right corner of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_citations','en','Citations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_citation_selection_not_valid','en','You\'re selection is not valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_citation_err_one','en','You must select exactly one edition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_choose_media_source','en','Choose Media Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_choose_glossary','en','Choose Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_choose_cont_obj','en','Choose Content Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_characteristic','en','Characteristic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_chapters_only','en','Chapters only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_chapters_and_pages','en','Chapters and Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_chapters','en','Chapters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_chap_select_target_now','en','Chapter marked for moving. Select target now.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_chap_copy_select_target_now','en','Chapter marked for copying. Select target now.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_chap_and_pages','en','Chapters and Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_change_type','en','Change Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_caption','en','Caption','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_cant_del_std','en','Deletion of standard view file not possible.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_cant_del_full','en','Deletion of full screen file not possible.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_cant_copy_folders','en','Folders cannot be copied to clipboard.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_browser_not_js_capable','en','JavaScript enabled editing is not supported for your browser.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_bottom','en','Bottom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_booktitle','en','Book title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_back','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_autoindent','en','Auto Indent','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_assignments_deleted','en','The assignments have been deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_assign_translation','en','Assign translation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_assign_std','en','Assign Standard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_assign_full','en','Assign Full Screen','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_areas_deleted','en','Map areas deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_api_func_prefix','en','API Functions Prefix','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_api_adapter','en','API Adapter Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_annex','en','Annex','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_all_pages','en','All Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_all_definitions','en','All Definitions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_added_term','en','Term added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_added_comment','en','Comment has been added to history.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_fullscreen','en','Add Full Screen','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_definition','en','Add Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_change_comment','en','Add change comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_area','en','Add Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_active','en','Enable Menu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_activate_page','en','Activate Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_act_number','en','Chapter Numeration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Unordered','en','Unordered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_TableContent','en','Table Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_roman_s','en','Roman i, ii, ...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_roman','en','Roman I, II, ...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Remark','en','Remark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Rect','en','Rectangle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Poly','en','Polygon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Number','en','Number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Block','en','Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Mnemonic','en','Mnemonic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_localfile','en','Local File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_List','en','List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Headline3','en','Headline 3','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Headline2','en','Headline 2','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Headline1','en','Headline 1','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_e_g_example','en','e.g.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Example','en','Example','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_bb_tip','en','Tip: Styles can be applied quickly to selected text.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Code','en','Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Citation','en','Citation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_delete_track_data','en','Delete Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Circle','en','Circle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_alphabetic_s','en','Alphabetic a, b, ...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_alphabetic','en','Alphabetic A, B, ...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_left_float','en','Left, Floating','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_right_float','en','Right, Floating','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_center','en','Center','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_right','en','Right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_left','en','Left','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_start_file','en','No Start File.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Excursus','en','Excursus','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Special','en','Special','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_Additional','en','Additional','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','citate_to','en','Citate To ...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','citate_page','en','Citate this Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','citate_from','en','Citate From ...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','citate','en','Citate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','choose_public_pages','en','Choose public accessible pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','choose_public_mode','en','Unregistered users may access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','all_pages','en','the entire Learning module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','all','en','All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','add_menu_entry','en','Add menu entry >>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','Pages','en','Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','PDF export','en','PDF Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','HTML export','en','HTML Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_map_file_not_generated','en','Sorry. Unable to generate map file for editing.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','content_last','en','Last','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','content_current','en','Current','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','content_page_history','en','Page History','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_latest_rev','en','Latest Revision','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_next_rev','en','Next Revision','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_page_compare','en','Compare Selected Revisions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_previous_rev','en','Previous Revision','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_pc_deleted','en','Deleted Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_pc_modified','en','Modified Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_pc_new','en','New Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_pages_and_subchapters','en','Subchapters and Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_subchapter_from_clip','en','Paste Subchapters from Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_chapter_from_clip','en','Paste Chapters from Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_page_from_clip','en','Paste Pages from Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_subchapter','en','Insert Subchapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_chapter','en','Insert Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_page','en','Insert Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_revision','en','Revision','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_align','en','Alignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_location','en','Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_styles_and_widths','en','Set Styles and Widths','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_set_tab_style_info','en','Activate checkboxes in table cells to set style.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_cell_properties','en','Table Cell Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_table_properties','en','Table Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_update_map','en','Edit Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_select_media_pool','en','Select Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_mob_from_media_pool','en','Choose From Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_mob','en','New Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_shape_polygon','en','Edit Shape (Polygon)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_shape_rectangle','en','Edit Shape (Rectangle)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_edit_shape_circle','en','Edit Shape (Circle)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_polygon','en','Add Polygon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_circle','en','Add Circle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_rectangle','en','Add Rectangle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_chapters_after_pages','en','Please note that pages have to precede all subchapters of the same level.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_js_chap_editing','en','Use JavaScript Editing Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_not_js_chap_editing','en','Use No-JavaScript Editing Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_internal_links','en','Internal Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_links','en','Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_rollback_confirmation','en','Do you really want to restore this old version of the page?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_rollback','en','Rollback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_insert_map','en','Insert Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','zipcode','en','Zip Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','zip','en','Zip Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','your_message','en','Your Message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','you_may_add_local_roles','en','You May Add Local Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','yes','en','Yes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','years','en','Years','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','year','en','Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wrong_ip_detected','en','Your access is denied because of a wrong client ip.<br>Please contact the system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','with','en','with','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','write','en','Write','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','width_x_height','en','Width x Height','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','weeks','en','Weeks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','welcome','en','Welcome','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','who_is_online','en','Who is online?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','weekly','en','weekly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_read','en','Read access to Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_sure_delete_items','en','Do you really want to delete the following Web Resource(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_visible','en','Web Resource is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_write','en','Edit Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webservices','en','Webservices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','week','en','Week','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_never_checked','en','Never checked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_new','en','Add new Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_no_items_created','en','No Web Resources created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_modified_items','en','Saved modifications.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_join','en','Subscribe Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_last_check','en','Last check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_last_check_table','en','Last check:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_leave','en','Unsubscribe Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_item_updated','en','Saved modifications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_fillout_all','en','Please fill out all required fields.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_edit','en','Edit Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_edit_item','en','Edit Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_disable_check','en','Disable check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_deleted_items','en','Deleted Web Resource(s).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_delete_items','en','Delete Web Resource(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_delete','en','Delete Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_add','en','Add Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_add_item','en','Add Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_active','en','Active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','web_resources','en','Web Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr','en','Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','visits','en','Visits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','visitors','en','Visitors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','visitor','en','Visitor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','visible','en','Visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','visible_layers','en','Visible Layers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','view','en','View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','view_content','en','View Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','versions','en','Versions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','version','en','Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','verification_warning_log','en','Verification warning log','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','verification_log','en','Verification log','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','verification_failure_log','en','Verification failure log','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','vendors','en','Vendors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','verification_failed','en','Verification failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','vcard_download','en','Download Visiting Card','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','value','en','Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','vcard','en','Visiting Card','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','valid','en','Valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','validate','en','Validate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_no_insert_ext_account_exists','en','Can\'t perform \"Insert\" action. External account already exists.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_no_update_ext_account_exists','en','Can\'t perform \"Update\" action. External account already exists.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_element_inapplicable','en','Element \"%1$s\" is inapplicable for \"%2$s\" action.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_element_for_action_required','en','Element \"%1$s\" must be specified for \"%2$s\" action.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_element_content_illegal','en','Content \"%2$s\" of element \"%1$s\" is illegal.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_attribute_value_inapplicable','en','Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is inapplicable for \"%4$s\" action.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_attribute_value_illegal','en','Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is illegal.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_xml_attribute_missing','en','Attribute \"%2$s\" in element \"%1$s\" is missing.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_with_specified_role_not_permitted','en','Import with specified role not permitted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_login_is_not_unique','en','Login is not unique.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_ignore_role','en','Ignore role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_global_role_for_action_required','en','At least one global role must be specified for \"%1$s\" action.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_conflict_handling_info','en','When \"Ignore on conflict\" is selected, ILIAS ignores an action, if it can not be performed (e. g. an \"Insert\" action is not done, if there is already a user with the same login in the database.)\\nWhen \"Update on conflict\" is selected, ILIAS updates the database if an action can not be performed. (e. g. an \"Insert\" action is replaced by an \"Update\" action, if a user with the same login exists in the database).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_cant_update','en','Can\'t perform \"Update\" action. No such user in database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_cant_insert','en','Can\'t perform \"Insert\" action. User is already in database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_action_replaced','en','Replaced action %1$s by %2$s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_cant_delete','en','Can\'t perform \"Delete\" action. No such user in database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_action_failed','en','Action %1$s failed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrimport_action_ignored','en','Ignored action %1$s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_write','en','Edit user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_read','en','Read access to user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_read_users','en','Role assignment for local administrators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_visible','en','User accounts are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_push_desktop_items','en','Allow to push items on the personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_delete','en','Delete user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_edit_permission','en','Change access to user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_edit_roleassignment','en','Change role assignment of user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf_create_user','en','Create new user account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usrf','en','User accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_style','en','User Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_skin_style','en','Skin / Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_settings_saved','en','Global user settings saved successfully!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_settings_header_profile_profile','en','Personal profile setting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_settings_header_profile','en','User profile settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_settings_explanation_profile','en','Check \'Visible\' to show fields in the registration form and personal user profile on the personal desktop. Check \'Changeable\' to allow the user to change the value in the personal profile. Please note that visible fields can always be entered in the registration form. Required fields are required in the registration form and the personal user profile. All data can be changed in the user administration independent on these settings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_hits_per_page','en','Hits/page in tables','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_inactive_only','en','Inactive Users only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_new','en','New User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_edit','en','Edit User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_filter_lastlogin','en','Last login of user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_filter_coursemember','en','Member of course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_filter_groupmember','en','Member of group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_filter_role','en','Assigned role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_agreement_empty','en','The agreement contains no text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_agreement','en','User Agreement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_add','en','Add User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_added','en','User added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_active_only','en','Active Users only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_a','en','a User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr','en','User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usertracking','en','User Tracking','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_online_show_y','en','Show all active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_online_show_n','en','Don\'t show active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_online','en','Active Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_online_show_associated','en','Show members of my courses and groups only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_not_imported','en','The following users do not exist, their messages cannot become imported','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users','en','Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilias_and_webfolder_username','en','ILIAS and Webfolder User Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_xml','en','XML','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','username','en','User Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilias_username','en','ILIAS User Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_file_size','en','File size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_files','en','Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_excel_x86','en','Microsoft Excel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','userfolder_export_csv','en','Comma Separated Values','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_profile_other','en','Other Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_send_new_account_mail','en','Send new account e-mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_statistics','en','Statistical Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','userdata','en','User Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_not_known','en','Please insert a valid username.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_not_chosen','en','You did not choose a group-member!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_new_account_mail_desc','en','This mail can be sent when an ILIAS user is created by other means then self-registration.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_new_account_mail','en','New Account Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_language','en','User Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_imported','en','User import complete.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_imported_with_warnings','en','User import complete with warnings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_import_failed','en','User import failed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_ext_account_desc','en','Account used for external authentication. (CAS, SOAP, LDAP or Radius authentication)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_ext_account','en','External Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_detail','en','Detail Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_activated','en','User has been approved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_deactivated','en','User has been disapproved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_deleted','en','User deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_defined_list','en','Overview User-defined Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_defined_fields','en','User-defined Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_comment','en','User comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_cant_receive_mail','en','user is not allowed to use the mail system','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_assignment','en','User Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_added','en','User added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_access','en','Access per user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_visible','en','URL is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_write','en','Edit URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user','en','User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_to_latex','en','URL to LaTeX CGI script','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_read','en','Open URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_not_found','en','File Not Found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_new','en','New URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_edit_permission','en','Change Permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_edit','en','Edit URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_description','en','URL Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_delete','en','Delete URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_create_url','en','Create URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_added','en','URL added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_add','en','Add URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url_a','en','a URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','url','en','URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','uri','en','URI','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','uploaded_and_checked','en','The file has been uploaded and checked, you can now start to import it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','upload_error_file_not_found','en','Upload error: File not found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','upload','en','Upload','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','update_on_conflict','en','Update on conflict','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','update_language','en','Update Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','update_applied','en','Update Applied','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','update','en','Edit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','up','en','Up','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unzip','en','Unzip','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unsubscribe','en','Remove from desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unselected','en','Unselected','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unread_lowercase','en','unread','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unread','en','Unread','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unlabeled','en','Unlabeled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unknown','en','UNKNOWN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','uninstalled','en','uninstalled.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','uninstall','en','Uninstall','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','uncheck_all','en','Uncheck all','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unambiguousness','en','Unambiguousness','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ums_login_account','en','Login Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ums_explanation_4','en','If none of them is your account, please hit \'Create New Account\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ums_explanation_3','en','Your external account could not be mapped to an ILIAS account. But ILIAS has found multiple accounts with your e-mail address. If one of those is your account, please login with your ILIAS password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ums_explanation_2','en','If this is not your account, please hit \'Create New Account\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ums_explanation','en','Your external account could not be mapped to an ILIAS account. But ILIAS has found an account with your e-mail address. If this is your account, please login with your ILIAS password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','uid','en','UID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ums_create_new_account','en','Create New Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_value','en','Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_value_deleted','en','The value has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_update_success','en','Saved modifications.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_update_text_field','en','Edit Text Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_update_select_field','en','Edit Select Box','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_type_text','en','Text (optional values)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_no_name_given','en','Please enter a field name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_type_select','en','Select Box (fixed values)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_no_entries','en','Please enter minimum one value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_field_deleted','en','Deleted field.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_name_already_exists','en','This field name already exists. Please choose a different name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_duplicate_entries','en','The values have to be unique.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_delete_sure','en','Are you sure you want to delete this field and all assigned user data ?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_delete_header','en','Delete Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_added_field','en','Added new field.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_add_field','en','Add Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','type_your_message_here','en','Type Your Message Here','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','typ','en','Object Type Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','type','en','Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','txt_submitted','en','You successfully submitted an account request to ILIAS. Your account request will be reviewed by the system administrators, and should be activated within 48 hours. You will not be able to log in until your account is activated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','txt_registered_passw_gen','en','You successfully registered to ILIAS. You should receive an e-Mail including your generated password shortly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','txt_registered','en','You successfully registered to ILIAS. Please click on the button below to login to ILIAS with your user account.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','txt_add_object_instruction2','en','.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_write','en','Edit Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','txt_add_object_instruction1','en','Browse to the location where you want to add','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_warning_test_not_complete','en','The test is not complete!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_visible','en','Test is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_user_wrong_clientip','en','You don\'t have the right ip using this test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_user_not_invited','en','You are not supposed to take this test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_upload_file','en','Upload file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_statistical_evaluation','en','Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_run','en','Run','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_tst_statistics','en','Access to Test Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_read','en','Read access to Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_new','en','New test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_no_content','en','No tests available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_delete','en','Delete Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_anon_eval','en','Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','treeview','en','Tree View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst','en','Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_add','en','Add test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tree_left','en','Left','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tree_right','en','Right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tree_frame','en','Tree Frame','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tree_frame_info','en','Defines whether the tree frame (e.g. repository tree) should appear on the left or on the right.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','trash','en','Trash','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tracking_settings','en','Tracking Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','translation','en','Translation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tracking_data_deleted','en','Tracking data deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tracking_data_del_confirm','en','Do you really want to delete all tracking data of the specified month and before?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tracking_data','en','Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tracked_objects','en','Tracked objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','trac_read','en','Read Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','trac_visible','en','User tracking is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','trac_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','trac_delete','en','Delete Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','total','en','Total','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tpl_path','en','Template Path','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','toggleGlobalFixed','en','Toggle Global Fixed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','today','en','Today','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','toggleGlobalDefault','en','Toggle Global Default','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','to_desktop','en','Add to Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','title_long','en','Long Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','to','en','To','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','to_client_list','en','Client Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_segment','en','Period of time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limits','en','Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_users_updated','en','User data updated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_until','en','Until (time limit)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_unlimited','en','Unlimited (time limit)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_reached','en','Your access period is expired.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_owner','en','Owner (time limit)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_not_within_owners','en','Your access is limited. The period is outside of your limit.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_not_valid','en','The period is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_no_users_selected','en','Please select a user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_message','en','Message (time limit)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_from','en','From (time limit)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_applied_users','en','Applied users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit_add_time_limit_for_selected','en','Please enter a time period for the selected user(s).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_limit','en','Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_h','en','Hour','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time_d','en','Day','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','time','en','Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','thumbnail','en','Thumbnail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','thread','en','Thread','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tests','en','Tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','test_module','en','Test Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','test_intern','en','Test Intern','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','test','en','Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','term','en','Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','taxf_write','en','Write access to taxonomy folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','taxf_visible','en','Taxonomy folder is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','taxf_read','en','Read access to taxonomy folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','taxf_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_write','en','Write access to taxonomies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_visible','en','Taxonomy is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_read','en','Read access to taxonomies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_new','en','New Taxonomy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_edit','en','Edit Taxonomy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_delete','en','Delete taxonomies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax_add','en','Add Taxonomy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tax','en','Taxonomy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','target','en','Target','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','table_mail_import','en','Mail import','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_styles','en','System Styles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_message','en','System Messages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_style_settings','en','System Style Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_language','en','System Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_information','en','System Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_grp','en','System Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_groups','en','System Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_choose_language','en','System Choose Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system_check','en','System Check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','system','en','System','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_write','en','Edit survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_warning_survey_not_complete','en','The survey is not finished!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_visible','en','Survey is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_upload_file','en','Upload file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_run','en','Run','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_read','en','Read access to survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_participate','en','Participate in a survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_not_started','en','not started','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_not_finished','en','not finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_invite','en','Invite users to a survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_new','en','New survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_no_content','en','No surveys available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_evaluation','en','Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_finished','en','finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_delete','en','Delete survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_add','en','Add survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy','en','Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sure_delete_selected_users','en','Are you sure you want to delete the selected user(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','summary','en','Summary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','subscription','en','Subscription','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','subobjects','en','Subobjects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','submit','en','Submit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','subject_module','en','Subject Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','subject','en','Subject','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','subchapter_new','en','New Subchapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','subcat_name','en','Subcategory Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','stys_write','en','Edit style settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','stys_visible','en','Style settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','stys_read','en','Read access to style settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','stys_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','style_activation','en','Style Activation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sty','en','Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','structure','en','Structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','street','en','Street','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','stop_inheritance','en','Stop inheritance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','step','en','Step','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','statistic','en','Statistic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','startpage','en','Start page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','standard_fields','en','Standard Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','st_new','en','New chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','st_edit','en','Edit chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','st_added','en','Chapter added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','st_add','en','Add chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ssl','en','SSL (HTTPS)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','st_a','en','a chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_write','en','Edit Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_visible','en','Question Pool Survey is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_upload_file','en','Upload file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_new','en','New Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_read','en','Read access to Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_delete','en','Delete Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl_add','en','Add Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spl','en','Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','spacer','en','Spacer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sort_by_this_column','en','Sort by this column','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','soap_user_administration_desc','en','If enabled, ILIAS can be administrated via SOAP.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','soap_user_administration','en','Administration via SOAP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','smtp','en','SMTP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tiny_icon','en','Small Icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','standard_icon','en','Standard Icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','skin_style','en','Default Skin / Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','size','en','Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','signature','en','Signature','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_users_online','en','Show active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_structure','en','Enable Structured-View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_private_notes','en','Show Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_deactivate_comments','en','Deactivate Public Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_activate_comments','en','Activate Public Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_comment','en','Comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_my_comments','en','My Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_all_comments','en','All Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_hide_comments','en','Hide Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_show_comments','en','Show Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_add_comment','en','Add Comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('notes','notes_public_comments','en','Public Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tagging_my_tags','en','My Tags','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('tagging','tagging_all_users','en','All Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('tagging','tagging_resources_for_tag','en','Resources tagged with %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rating','rating_nr_users','en','%s User(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rating','rating_average_rating','en','Average Rating','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rating','rating_your_rating','en','Your Rating','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('tagging','tagging_tag_info','en','To attach tags to a ressource open the info screen of the ressource and enter your tags.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('tagging','tagging_enable_tagging','en','Enable Tagging','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('tagging','tagging_edit_settings','en','Edit Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('tagging','tagging_settings','en','Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('tagging','tagging_tags','en','Tags','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_owner','en','Show Owner','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pd_items_news_info','en','If activated, all news related to items that have been added to the personal desktop will be included in the news block.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_list','en','Show List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_members','en','Display Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pd_items_news','en','Include News of Personal Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_details','en','Show Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show','en','Show','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_zipcode','en','Attribute for zipcode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_write','en','Edit Shibboleth settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_visible','en','Shibboleth settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_user_default_role','en','Default role assigned to Shibboleth users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_update','en','Update this field on login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_title','en','Attribute for title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_street','en','Attribute for street','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_settings_saved','en','The Shibboleth settings were saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_select_home_organization','en','For authentication via %s, please select your organization from the drop down list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_read','en','Read access to Shibboleth settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_phone_office','en','Attribute for office phone number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_phone_mobile','en','Attribute for mobile phone number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_phone_home','en','Attribute for home phone number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_member_of','en','I\'m a member of ...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_login_type','en','Organization selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_login_internal_wayf','en','Use ILIAS WAYF service','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_login_external_wayf','en','Use external WAYF service','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_login_button','en','Path to the image of a Shibboleth login button that is used to redirect users to the WAYF specified in the Shibboleth configuration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_login','en','Unique Shibboleth attribute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_lastname','en','Attribute for lastname','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_language','en','Attribute for language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_invalid_home_organization','en','Please choose a valid organization!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_shib_instructions','en','Be sure to read the README for instructions on how to configure Shibboleth support for ILIAS.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_institution','en','Attribute for institution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_idp_list','en','Provide a list of Identity Providers to let the user choose from on the ILIAS login page.<br>On each line there must be a comma-separated tuple for <strong>providerID of IdP</strong> (see the Shibboleth metadata file) and <strong>Name of IdP</strong> as it shall be displayed in the drow-down list.<br>As an optional third parameter you can add the <strong>location of a Shibboleth session initiator</strong> that shall be used in case your ILIAS installation is part of a multi federation setup.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_general_wayf_login_instructions','en','In case you are not associated with the given organizations and you need access to a course on this server, please contact the','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_general_login_instructions','en','To log in via %s, please click on the login button and choose your organization of the following page.<br>If you have questions concerning this, please ask the','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_gender','en','Attribute for gender (must be \'m\' or \'f\')','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_firstname','en','Attribute for firstname','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_federation_name','en','Name of your Shibboleth federation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_email','en','Attribute for e-mail address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_department','en','Attribute for department','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_data_conv_warning','en','The data manipulation API file you specified cannot be read','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_data_conv','en','Absolute path to data manipulation API','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_country','en','Attribute for country','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_configure','en','Configure Shibboleh Authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_city','en','Attribute for city','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib_active','en','Enable Shibboleth support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shib','en','Shibboleth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','settings_saved','en','Saved settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','settings','en','Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','set_online','en','Set Online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','set_offline','en','Set Offline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','setUserLanguage','en','Set User Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','setSystemLanguage','en','Set System Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','set_edit_mode','en','Set Edit Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','set','en','Set','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','server_software','en','Server Software','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sent','en','Sent','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sequence','en','Sequence','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sequences','en','Sequences','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','server','en','Server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','server_data','en','Server data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','send','en','Send','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','send_mail','en','Send mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','send_mail_selected','en','Select mail recipients from list','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sender','en','Sender','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','selected_items_back','en','Back to Personal Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','selected_items','en','Personal Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','selected','en','Selected','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_questionpool_option','en','--- Please select a question pool ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_questionpool','en','Insert questions into','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_password','en','Select a new password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_object_to_link','en','Please select the object which you want to link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_object_to_copy','en','Please select the object you want to copy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_mode','en','Select mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_max_one_item','en','Please select one item only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_file','en','Select file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_all','en','Select All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select','en','Select','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','second','en','Second','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seconds','en','Second(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sections','en','Sections','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_write','en','Edit search settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_visible','en','Search settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_settings','en','Search settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_search','en','Allow to use the search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_read','en','Read search settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_max_hits_info','en','Please enter a number for the maximum number of search results.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','seas_max_hits','en','Max hits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_user','en','Search User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_to_short','en','Your query is to short.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_recipient','en','Search Recipient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_result','en','Search result','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_note','en','If &quot;search in&quot; is left blank, all users will be searched. This allows you to find all active or all inactive users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_new','en','New Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_minimum_characters','en','The minimum word length is:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_in','en','Search in','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_inactive','en','Include inactive users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_for','en','Search For','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_active','en','Include active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search','en','Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','saved_successfully','en','Saved Successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','saved','en','Saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','save_user_related_data','en','Save user related access data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','save_settings','en','Save Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','save_return','en','Save and Return','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','save_refresh','en','Save and Refresh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','save_message','en','Save Message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','save_and_back','en','Save And Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','save','en','Save','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','salutation_m','en','Mr.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','salutation_f','en','Ms./Mrs.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','salutation','en','Salutation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_write','en','Edit SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_visible','en','SCORM/AICC Learning Module is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_read','en','Read access to SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_leave','en','Unsubscribe from SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_join','en','Subscribe to SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_delete','en','Delete SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_create','en','Create SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_added','en','SCORM/AICC Learning Module added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs','en','Learning Module SCORM/AICC','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rte_editor_enabled','en','Rich Text Editor enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rte_editor_disabled','en','Rich Text Editor disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','row','en','Row','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rows','en','Rows','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','root_write','en','Edit metadata of system root node','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','root_visible','en','ILIAS system is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','root_read','en','Read access to ILIAS system','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','root_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','root_edit','en','Edit system root node','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','root_create_cat','en','User may create Categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolt_new','en','New Role Template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolt_edit','en','Edit Role Template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolt_added','en','Role template added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolt_add','en','Add Role Template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolt','en','Role Template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolt_a','en','a Role Template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_write','en','Edit default permission settings of Roles/Role templates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_visible','en','Roles/Role templates are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_read','en','Read access to Roles/Role templates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_edit_userassignment','en','Change user assignment of Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_delete','en','Delete Roles/Role templates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_create_rolt','en','Create new Role definition template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_added','en','Role Folder added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf_create_role','en','Create new Role definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rolf','en','Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','roles_of_import_global','en','Global roles of import file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','roles_of_import_local','en','Local roles of import file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_user_send_mail','en','Send user a message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','roles','en','Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_user_edit','en','Edit account data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_user_deassign','en','Deassign user from role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_templates_only','en','Role templates only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_sure_delete_desk_items','en','Are you sure you want to delete the following assignments?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_select_one_item','en','Please select one object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_select_desktop_item','en','Please select one object that will be assigned to this role.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_search_users','en','User search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_search_enter_search_string','en','Please enter a search string','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_protect_permissions','en','Protect permissions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_no_users_no_desk_items','en','It is not possible to assign personal desktop items, since you cannot assign users to this role.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_no_roles_selected','en','Please select a role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_no_results_found','en','No results found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_no_groups_selected','en','Please select a group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_new_search','en','New search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_new','en','New Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_mailto','en','Mail to all assigned Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_list_users','en','List users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_header_edit_users','en','Change User Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_edit','en','Edit Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_desk_none_created','en','No desktop items assigned to this role.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_desk_add','en','Assign desktop item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_deleted_desktop_items','en','Deleted assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_deleted','en','Role deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_count_users','en','Number of users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_assignment_updated','en','Role assignment has been updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_assignment','en','Role Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_assigned_desktop_item','en','Created new assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_added','en','Role added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_assigned_desk_items','en','Assigned desktop items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_add_user','en','Add User(s) to role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_add_local','en','Add local Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_add','en','Add Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_a','en','a Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role','en','Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rights','en','Rights','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','right','en','Right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','retype_password','en','Retype Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','resources','en','Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reset','en','Reset','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','required_field','en','Required','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_zipcode','en','Require zip code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_street','en','Require street','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_referral_comment','en','Require referral comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_phone_office','en','Require office phone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_phone_mobile','en','Require mobile phone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_phone_home','en','Require home phone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_passwd2','en','Require retype password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_passwd','en','Require password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_matriculation','en','Require matriculation number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_mandatory','en','mandatory','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_login','en','Require login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_lastname','en','Require last name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_institution','en','Require institution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_hobby','en','Require hobby','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_gender','en','Require gender','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_firstname','en','Require first name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_fax','en','Require fax','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_email','en','Require e-mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_department','en','Require department','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_default_role','en','Require role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_country','en','Require country','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','require_city','en','Require city','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','request_membership','en','Request membership','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','repository_frame','en','Repository Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','repository_admin_desc','en','Set permissions for repository items, restore or remove objects from system trash','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','repository_admin','en','Repository Trash and Permissions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','repository','en','Repository','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reply','en','Reply','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','replace_file','en','Replace File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','repeat_scan_succeded','en','Repeat scan succeded.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','repeat_scan_failed','en','Repeat scan failed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','repeat_scan','en','Repeating virus scan...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rename_file','en','Rename File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','rename','en','Rename','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','remove_translation','en','Remove translation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','remove_personal_picture','en','Remove','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','remove','en','Remove','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','related_to','en','Related to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','registration_expired','en','Registration period expired...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','registration_disabled','en','Only available when using local authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','registration','en','New account registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','registered_users','en','registered Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','registered_user','en','registered User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','registered_since','en','Registered since','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','register_info','en','Please fill out the form to register (Fields marked with an asterisk are required information).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','register','en','Register','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reg_passwd_via_mail','en','Your password will be sent to your e-mail address given below.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reg_mail_subject','en','ILIAS eLearning - Your access data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_text3','en','Further personal information:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_text2','en','To access ILIAS use the following data:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_text1','en','Welcome to ILIAS eLearning!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reg_mail_body_salutation','en','Hello','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','refuse','en','Refuse','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','refresh_list','en','Refresh List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','refresh_languages','en','Refresh Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','refresh','en','Refresh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','referral_comment','en','How did you hear about ILIAS?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','recipient','en','Recipient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','recf_edit','en','Edit RecoveryFolder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','read','en','Read','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','quit','en','Quit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','quote','en','Quote','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','question_pools','en','Question Pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','question','en','Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','query_data','en','Query data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','quarterly','en','quarterly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_write','en','Edit Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_visible','en','Question Pool Test is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_upload_file','en','Upload file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_read','en','Read access to Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_new','en','New Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_add','en','Add Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl_delete','en','Delete Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','purpose','en','Purpose','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','qpl','en','Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','publishing_organisation','en','Publishing Organization','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','published','en','Published','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','publication_date','en','Publication Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','publication','en','Publication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','public_profile','en','Public Profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','public_profile_not_visible','en','The User Profile is not public','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','public_notes','en','Public Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','public','en','public','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pub_section','en','Public Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','properties','en','Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','profile_of','en','Profile of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','profile_incomplete','en','Your profile is incomplete. Please fill in all required data.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','profile_changed','en','ILIAS eLearning - Your profile has changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','profile','en','Profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','proceed','en','Proceed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pro','en','Pro','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','private_notes','en','Private Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','print_view','en','Print View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','print','en','Print','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','previous','en','Previous','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','presentation_options','en','Presentation Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','predefined_template','en','Predefined role template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','preconditions','en','Preconditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','precondition_not_accessible','en','You do not have sufficient permission to view the precondition(s) of this item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','position','en','Position','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','port','en','Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','please_wait','en','Please wait...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','please_select_a_delivered_file_to_download','en','You must select at least one delivered file to download it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','please_select_a_delivered_file_to_delete','en','You must select at least one delivered file to delete it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','please_select','en','-- Please Select --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','please_enter_title','en','Please enter a title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','please_enter_target','en','Please enter a target','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','please_choose','en','-- Select --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','phrase','en','Phrase','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','phone_office','en','Phone, Office','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pg_added','en','Page added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pg_edit','en','Edit page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pg_new','en','New page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','phone','en','Phone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','phone_home','en','Phone, Home','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','phone_mobile','en','Phone, Mobile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pg_add','en','Add page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pg_a','en','a page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','persons','en','Persons','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','personal_desktop','en','Personal Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','personal_picture','en','Personal Picture','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','personal_profile','en','Personal Profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','personal_data','en','Personal Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','person_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','permission_settings_info','en','This form determines which role is allowed to do what with the current object \'%s\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','permission_denied','en','Permission Denied','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','permission_settings','en','Object Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','perma_link','en','Permanent Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','permission','en','Permission','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','perm_settings','en','Permissions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_glob_2','en','If you want to change the permissions of role \'%s\' for all existing objects in the repository you must check the option \'Change Existing Objects\' at the bottom of the screen.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_glob_1','en','This form determines the permissions of role \'%s\' for newly created objects in the repository.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_2','en','If you want to change the permissions of role \'%s\' for all already existing objects underneath \'%s\' you must check the option \'Change Existing Objects\' at the bottom of the screen.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','perm_role_info_1','en','This form determines the permissions of role \'%s\' for newly created objects under the object \'%s\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','per_object','en','Access per object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pdf_export','en','PDF Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pays_write','en','Edit payment settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pays_visible','en','Payment settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pays_read','en','Access payment settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pays_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pays_edit','en','Edit payment settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','payment_system','en','Payment System','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','payment_payed_access','en','Payed/Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','payment_in_sc','en','Already in shopping cart','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','payment_buyable','en','Buyable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pay_methods','en','Pay methods','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pathes','en','Paths','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path_to_zip','en','Path to Zip','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path_to_unzip','en','Path to Unzip','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path_to_java','en','Path to Java','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pastePage','en','Paste','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path','en','Path','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path_not_set','en','Path not set','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path_to_babylon','en','Path to Babylon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path_to_convert','en','Path to Convert','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','path_to_htmldoc','en','Path to HTMLdoc','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pasteChapter','en','Paste','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','paste','en','Paste','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_assistance_info','en','If password assistance is enabled, a link with the text \"Forgot Password?\" is shown on the login page of ILIAS. Users can use this link to assign a new password to their user account, without needing assistance from a system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_assistance_disabled','en','Password assistance is only then available, when user authentication is done via local ILIAS database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password','en','Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passwd_wrong','en','The password you entered is wrong!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passwd_not_match','en','Your entries for the new password don\'t match! Please re-enter your new password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passwd_invalid','en','The new password is invalid! Only the following characters are allowed (minimum 6 characters): A-Z a-z 0-9 _.-+?#*@!$%~','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passwd_generation_info','en','If enabled, passwords can only be selected from a pretended list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passwd_generation','en','Password Generation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passwd','en','Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','parse','en','Parse','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','parameter','en','Parameter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','pages','en','Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','page_edit','en','Edit Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','page','en','Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','owner_updated','en','Owner updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','owner','en','Owner','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','overwrite','en','Overwrite','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','overview','en','Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','order_by_date','en','Order by Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','other','en','Other','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','order_by','en','Order by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','order_by_answers','en','Order by Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','options_for_subobjects','en','Options for subobjects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','options','en','Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','optimize','en','Optimize','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','operation','en','Operation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','open_views_inside_frameset','en','Open views inside frameset','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','online_version','en','Online Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','online_time','en','Time online (DD:HH:MM:SS)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','online_chapter','en','Online Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','online','en','Online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hh_mm','en','HH:MM','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','old','en','Old','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hh_mm_ss','en','HH:MM:SS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','go','en','Go','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ok','en','OK','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','offline_version','en','Offline Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','offline','en','Offline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','of','en','Of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_webr','en','Web Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_usr','en','Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_url','en','URLs','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_type','en','Object Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_tst','en','Tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_svy','en','Surveys','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_st','en','Chapters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_spl','en','Question Pools Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_sahs','en','SCORM/AICC Learning Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_rolt','en','Role Templates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_role','en','Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_qpl','en','Question Pools Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_pg','en','Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_note','en','Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_mob','en','Media Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_mep','en','Media Pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_lo','en','Learning Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_lng','en','Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_lm','en','ILIAS Learning Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_icrs','en','LearnLinc Seminars','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_icla','en','LearnLinc Classrooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_htlm','en','HTML Learning Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_hlm','en','HACP Learning Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_grp','en','Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_glo','en','Glossaries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_frm','en','Forums','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_file','en','Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_fold','en','Folders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_exc','en','Exercises','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_delete','en','Delete objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_dbk','en','Digilib Books','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_crs','en','Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_confirm','en','Confirm Action','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_alm','en','AICC Learning Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_cat','en','Categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_chat','en','Chats','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objf_write','en','Edit Object definitions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objf_visible','en','Object definitions are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objf_read','en','Read access to Object definitions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objf_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objf','en','Object definitions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objects','en','Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','object_imported','en','Object imported','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','object_duplicated','en','Object copied','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','object_added','en','Object added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','object','en','Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_webr','en','Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_usrf_desc','en','Manage user accounts here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_usrf','en','User Accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_user','en','User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_usr','en','User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_uset','en','User Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_url','en','URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_type','en','Object Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_typ','en','Object Type Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_tst','en','Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_trac_desc','en','User access tracking data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_taxf','en','Taxonomies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_taxf_desc','en','Folder for taxonomies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_trac','en','Tracking and Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_tax','en','Taxonomy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_svyf_desc','en','Platform settings for the Survey Tool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_svyf','en','Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_svy','en','Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_stys_desc','en','Manage system skin and style settings here','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_stys','en','Style and Layout','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_st','en','Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_spl','en','Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_seas_desc','en','Manage the search settings here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_sahs','en','Learning Module SCORM/AICC','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_seas','en','Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','invisible_block_mess','en','You do not have the permission to view this block.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_root','en','ILIAS root node','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','invisible_block','en','Invisible Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_rolt','en','Role Template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_rolf_local','en','Local Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_rolf_local_desc','en','Contains local roles of object no.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_rolf_desc','en','Manage your roles here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_rolf','en','Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_tags_desc','en','Settings for tagging feature.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_nwss_desc','en','Settings for internal news and external web feeds.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_mcts','en','Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_mcts_desc','en','General settings for mediacast.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_tags','en','Tagging','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_role','en','Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_nwss','en','News and Web Feeds','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_recf_desc','en','Contains restored Objects from System Check.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_recf','en','Restored Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_qpl','en','Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_pg','en','Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_pays_desc','en','Configure payment settings and vendors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_pays','en','Payment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_owner','en','This Object is owned by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_objf_desc','en','Manage ILIAS object types and object permissions. (only for experts!)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_objf','en','Object Definitions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_notf','en','Note Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_note','en','Note','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_not_found','en','Object Not Found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_mob','en','Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mep','mep_copy_to_mep','en','Copy to Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mep','mep_create_folder','en','Create Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mep','mep_create_mob','en','Create Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mep','mep_title_and_description','en','Title and Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mep','mep_thumbnail','en','Thumbnail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_mep','en','Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_mail_desc','en','Configure global mail settings here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_mail','en','Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_lo','en','LearningObject','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_lngf_desc','en','Manage your system languages here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_lm','en','Learning Module ILIAS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_lng','en','Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_lngf','en','Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_ldap_desc','en','Configure global LDAP Settings here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_ldap','en','LDAP Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_icla','en','LearnLinc Classroom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_icrs','en','LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_htlm','en','Learning Module HTML','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_grp','en','Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_hlm','en','Learning Module HACP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_glo','en','Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_frm','en','Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_fold','en','Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_extt_desc','en','Configure external software or services that are supported by ILIAS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_extt','en','Third Party Software','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_exc','en','Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_dbk','en','Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_crs','en','Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_chat','en','Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_chac_desc','en','Configure your chat server here. Enable/disable chats.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_chac','en','Chat Server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cen','en','Centra Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cat','en','Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_auth_desc','en','Configure your authentication mode (local, LDAP, ...) and new account registration settings here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_auth','en','Authentication and Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_assf_desc','en','Platform settings for the Test & Assessment tool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_assf','en','Test and Assessment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_alm','en','Learning Module AICC','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_adve_desc','en','Administration settings for advanced editing like JavaScript based Rich Text Editors, LaTeX support etc..','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_adve','en','Advanced Editing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_adm','en','Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_adm_desc','en','Main system settings folder containing all panels to administrate your ILIAS installation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj','en','Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','number_of_records','en','Number of records','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','number_of_accesses','en','Number of accesses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','notes','en','Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','num_users','en','Number of Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','note_all_pub_notes','en','All notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','note_my_pub_notes','en','My notes only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','note','en','Note','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','not_installed','en','Not Installed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','not_logged_in','en','You are not logged in','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','not_implemented_yet','en','Not implemented yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','not_accessed_yet','en','Not accessed yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','not_available','en','Not Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','normal','en','Normal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','not_accessed','en','Not accessed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','none','en','None','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_zip_file','en','No zip file found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','non_internal_local_roles_only','en','Local roles (only userdefined)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_xml_file_found_in_zip','en','XML file within zip file not found:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_users_selected','en','Please select one user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_users_applied','en','Please select a user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_user_defined_fields_defined','en','No user-defined fields available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_tst_in_personal_list','en','No tests in personal list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_title','en','No Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_submission_made','en','---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_roles_user_can_be_assigned_to','en','There are no global roles the user can be assigned to. Therefore you are not allowed to add users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_permission_to_join','en','You are not allowed to join this group!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_objects','en','No objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_parent_access','en','No access to a superordinated object!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_permission','en','You do not have the necessary permission.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_local_users','en','There are no local user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_lo_in_personal_list','en','No learning objects in personal list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_limit','en','No limit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_import_file_found','en','No import file found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_invalid_links','en','No invalid links found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_import_available','en','Import not available for type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_grp_in_personal_list','en','No groups in personal list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_description','en','No description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_frm_in_personal_list','en','No forums in personal list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_global_role_left','en','Every user has to be assigned to one role.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_date','en','No date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_datasets','en','The table is empty','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_conditions_found','en','No preconditions created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_condition_selected','en','Please select one precondition.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_checkbox','en','Please select at least one item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_chat_in_personal_list','en','No chats in personal list','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_bm_in_personal_list','en','No bookmarks defined.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_access_link_object','en','You are not allowed to link this object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_access_item_public','en','To access this item you need to be logged in and to have appropriate permissons.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no','en','No','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_access_item','en','You have no permission to access this item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','nickname','en','Nickname','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_page','en','Select Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delicious','en','del.icio.us Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_agreement_description','en','There is currently no user agreement text provided with this installation. Please contact the system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','next','en','Next','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_no_javascript','en','If you don\'t see the correct mathematical formula next to this hint, then you have jsMath output enabled but your web browser doesn\'t support JavaScript or JavaScript is disabled. To see mathematical formulae, please activate JavaScript in your web browser and reload this page or go to <strong>Personal Desktop &gt; Personal Profile &gt; jsMath</strong> and disable jsMath output.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_default_setting_info','en','If checked, jsMath will be used as default method to render LaTeX code for all users who did not enable or disable the jsMath support in their personal profile settings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_default_setting','en','Use as default','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_enable_user_desc','en','Activate jsMath for the output of mathematical formulae. jsMath output produces scaleable formulae and requires activated Javascript. When jsMath output is deactived, formulae will be rendered as graphics.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_enable_user','en','Enable jsMath support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_path_not_found','en','Cannot find jsMath.js in the given path. Please check the jsMath location on the server!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_path_to_jsmath_desc','en','The path to the jsMath base directory relative to the ILIAS base directory, e.g. &quot;./Services/Javascript/jsMath&quot;','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_path_to_jsmath','en','Path to jsMath','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_enable_jsmath_info','en','Activates support for jsMath based mathematical output of LaTeX expressions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_enable_jsmath','en','Enable jsMath','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_settings','en','jsMath Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('jsmath','jsmath_extt_jsmath','en','jsMath','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_std_location_desc','en','Latitude / Longitude. Click map to set location.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_std_location','en','Default Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_extt_gmaps','en','Google Maps','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_api_key_desc','en','In order to use the Google Maps extension, you need to sign up for a Google Maps API key at:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_settings','en','Google Maps Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_zoom_level','en','Zoom Level','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_enable_gmaps_info','en','Activates Google Maps in user profiles, groups and courses.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_enable_gmaps','en','Enable Google Maps','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_public_profile_info','en','Show location in your public profile.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('gmaps','gmaps_api_key','en','API Key','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('delic','delic_user_profile','en','Enable del.icio.us Account Setting in User Profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('delic','delic_add_info_links','en','Add del.icio.us Links on Info Screens','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('delic','delic_extt_delicious','en','del.icio.us','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('delic','delic_add_to_delicious','en','Add to del.icio.us','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('delic','delic_settings','en','del.icio.us Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rep','rep_intro6','en','After that procedure you may add any learning or working resource to your category.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rep','rep_intro5','en','By clicking on the title of the category you enter your category.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rep','rep_intro4','en','In the following form, enter a title and a description, and click on <i>%s</i>.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rep','rep_intro3','en','Click on the <i>%s</i> button besides the selection list on the top right.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rep','rep_intro2','en','Three steps are needed to build an initial structure:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rep','rep_intro1','en','In this area you can create learning and working resources for all users. All resources are organised in categories. Categories can reflect the structure of your organisation (e.g. departments), a hierarchie of disciplines, or classes of a school.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rep','rep_intro','en','Welcome to the Repository!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','pdesk_feedbacks','en','Feedback Request(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','pdesk_feedback_request','en','Feedback Request','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','activate_block','en','Activate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','pdesk_intro4','en','If you found something of interest, add it to your desktop by clicking the <i>Add to Desktop</i> button.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','pdesk_intro3','en','Click on \'%s\' and browse the existing working and learning resources.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','pdesk_intro','en','Welcome to your Personal Desktop!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','pdesk_intro2','en','This is your personal space for organising your working and learning. You can put resources from other areas on your personal desktop. Doing so takes two steps:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','bm_num_bookmark_folders','en','Folder(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pdesk','bm_num_bookmarks','en','Bookmark(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','block_feed_block_feed_url_info','en','Must be a valid RSS/Atom URL, e.g. http://www.ilias.de/iosbb/rss.php','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','block_feed_block_feed_url','en','Feed URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_no_valid_url','en','The Feed URL is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','block_feed_block_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','block_feed_block_head','en','External Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_open_source_page','en','Open in New Window','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_settings','en','External Web Feeds Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_nr_pd_feeds_info','en','Sets the maximum number of external web feeds, that users may add to their personal desktop. Existing feeds are not deleted, if option is set to a lower value. \'0\' disables the feature completely.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_nr_pd_feeds','en','Number of External Feeds on Personal Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_disable_rep_feeds_info','en','This option deactivates all existing external web feed blocks, in case of an unexpected problem due to an external feed source.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_disable_rep_feeds','en','Disable External Web Feeds in Categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_no_js_click_here','en','If feed is not displayed, click here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_loading_feed','en','Loading Feed...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_proxy_port_info','en','Proxy port for socket connection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_proxy_port','en','Proxy Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_proxy_info','en','Proxy host for socket connection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_proxy','en','Proxy Host','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('feed','feed_feed_items','en','Feed Item(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_item_visibility_info','en','Public news can be accessed without authentication outside of ILIAS via RSS. Please do not include any confidential information.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_public_feed_info','en','If this option is enabled, a separate RSS feed is provided for this Mediacast.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_public_feed','en','Extra RSS Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_notifications_public','en','Public Notifications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_notifications_public_info','en','If this option is enabled, notifications can be obtained by personal RSS feeds outside of ILIAS. Please note that this makes notifications accessible without authentification.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_settings','en','News Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_feed_url','en','Feed URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_get_feed_info','en','This is a personal news feed URL. The feed includes only news that are declared as public by the author. The feed is not protected by any authentication procedure. Please do not share this URL with other people.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_get_feed_title','en','Personal Feed URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_feed_url_for','en','Feed URL for \'%s\'','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_internal_news','en','News','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_get_feed_url','en','Get Feed URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_unsubscribe','en','Unsubscribe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_subscribe','en','Subscribe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_items','en','News Item(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_item_visibility','en','Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_scope','en','Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_public','en','Public','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_users','en','Logged in Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','priv_feed_no_auth_body','en','Please make sure you enabled your private Newsfeed and entered the password correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','priv_feed_no_access_body','en','Please contact the system administrator for further information.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','priv_feed_no_auth_title','en','Authentification failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','priv_feed_no_access_title','en','Private Newsfeed is disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','priv_feed_disabled','en','Private Newsfeed disabled.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','priv_feed_settings','en','Private Newsfeed settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','passwd_equals_ilpasswd','en','Please enter a password different from your ILIAS-password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_enable_private_feed_info','en','If this option is enabled, public and private news can be obtained by personal RSS feeds outside of ILIAS. Authentification is provided by password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_enable_private_feed','en','Enable private Newsfeed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_get_priv_feed_title','en','Personal private Feed-URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_get_priv_feed_info','en','This is a personal private news feed URL. The feed includes news that are declared as public and private by the author. This feed is protected by a password, which can be changed under \"Settings\". Please do not share this URL with other people. Please replace -password- in this URL with your Feed-Password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_visibility_public','en','Public','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_visibility_users','en','Logged in Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_item_content_long_info','en','This text will not be published via RSS.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_item_content','en','Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_item_content_long','en','Long Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_item_title','en','Headline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_default_visibility','en','Default Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_hide_news_date','en','Starting Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_hide_news_per_date','en','Show News After','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_hide_news_per_date_info','en','Only news that are newer than a certain date will be displayed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_hide_news_block','en','Hide News Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_hide_news_block_info','en','Hide block in learner\'s view. The news block will only be visible for users with write permission.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_hidden_news_block','en','Block is currently hidden in learner\'s view.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_news_item_head','en','News Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_notifications','en','Notifications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_first_letter_of_word_notification','en','N','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_enable_internal_rss_info','en','Allows to publish news items via RSS. These items will be accessible outside of the system without authentication.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_enable_internal_rss','en','Enable RSS for Internal News','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_enable_internal_news_info','en','Activates news blocks for categories, courses, groups and other objects. Users can subscribe to news and news are presented on the personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_enable_internal_news','en','Enable Internal News','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_edit_news_settings','en','Edit Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_all_items','en','All Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_related_to','en','Related to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_nr_of_items_info','en','Number of news items that are kept for an object (e.g. a file or a learning module) in the database. Please note, that container objects (e.g. categories, courses) may list more items, because they aggregate news of subobjects.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_nr_of_items','en','Number of Maximum News Items per Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_acc_cache_info','en','Check read permissions for news items all x minutes (personal desktop only). \'0\' means everytime. Higher values improve performance, but news may link to non-accessible items.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_acc_cache','en','Permission Check (Minutes)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_no_js_click_here','en','If news are not displayed, click here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_loading_news','en','Loading News...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_indefinite','en','Indefinite','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_pd_period_info','en','Defines the time period used for news on the personal desktop. Select lower values, if you experience any performance problems.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_pd_period','en','Personal Desktop News Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_1_postings','en','1 Posting has been added.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_x_postings','en','%s Postings have been added.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_1_file_updated','en','1 File has been updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_1_file_created','en','1 File has been added.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_x_files_updated','en','%s Files have been updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_x_files_created','en','%s Files have been added.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_allow_longer_periods_info','en','Users may select longer news periods on personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_allow_shorter_periods_info','en','Users may select shorter news periods on personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_allow_longer_periods','en','Allow Longer Periods','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_allow_shorter_periods','en','Allow Shorter Periods','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_period_1_year','en','Last Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_period_x_months','en','Last %s Months','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_period_1_month','en','Last Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_period_x_weeks','en','Last %s Weeks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_period_1_week','en','Last Week','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_period_x_days','en','Last %s Days','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_rss_period','en','RSS Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_block_information','en','The <b>News</b> block lists all news that are related to the <b>Personal Items</b> you have selected on the personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_no_news_items','en','No news available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('news','news_block_news_for_context','en','News','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('block_html','block_html_block_content','en','Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('block_html','block_html_block_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('block_html','block_html_block_head','en','HTML Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_mcst','en','Create Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_mcst','en','Create Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_feed','en','Create Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_mcst','en','Create Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_mcst','en','Create Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_feed','en','Create Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_feed','en','Create Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tags_write','en','Edit Tagging Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tags_read','en','Read access to Tagging Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tags_visible','en','Tagging Settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tags_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','nwss_write','en','Edit News and Web Feeds Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','nwss_read','en','Read access to News and Web Feeds Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','nwss_visible','en','News and Web Feeds Settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','nwss_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_write','en','Edit Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_read','en','Read access to Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_visible','en','Mediacast is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feed_read','en','Read access to Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feed_write','en','Edit Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feed_visible','en','Web Feed is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feed_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_feed','en','Web Feeds','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_feed','en','Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feed','en','Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','html_block','en','HTML Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_mail','en','New mail!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_lowercase','en','new','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_list_password','en','New suggestions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_language','en','New Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_group','en','New Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_folder','en','New Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_appointment','en','New Appointment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new','en','New','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','never','en','never','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','name','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','my_tsts','en','My Tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','my_los','en','My Learning Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','my_grps','en','My Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','my_frms','en','My Forums','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','my_bms','en','Bookmarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','multimedia','en','Multimedia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_userassignment_changed','en','User assignment changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_user_last_role2','en','Please delete the users or assign them to another role in order to delete this role.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_user_last_role1','en','The following users are assigned to this role only:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_trash_empty','en','There are no deleted objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_undeleted','en','Object(s) undeleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_sysrole_not_editable','en','The permission settings of the system role may not be changed. The system role grants all assigned users unlimited access to all objects & functions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_sysrole_not_deletable','en','The system role cannot be deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_roleassignment_changed','en','Role assignment changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_roleassignment_active_changed_comment','en','This setting is not saved to the user\'s profile! If the user logs in again, all active role assignments reset to their saved values.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_roleassignment_active_changed','en','Active role assignment changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_role_reserved_prefix','en','The prefix \'il_\' is reserved for automatically generated roles. Please choose another name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_role_exists2','en','already exists! Please choose another name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_role_exists1','en','A role/role template with the name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_removed','en','Object(s) removed from system.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_perm_adopted_from_itself','en','You cannot adopt permission settings from the current role/role template itself.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_perm_adopted_from2','en','(Settings have been saved!)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_perm_adopted_from1','en','Permission settings adopted from','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_obj_not_deletable_sold','en','Payment is activated for the following objects. They can no be deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_obj_no_link','en','are not allowed to be linked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_obj_modified','en','Modifications saved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_obj_created','en','Object created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_obj_exists','en','This object already exists in this folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_nothing_found','en','msg_nothing_found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_not_in_itself','en','It\'s not possible to paste the object in itself','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_not_available_for_anon','en','The page you have chosen is only accessible for registered users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_url','en','You didn\'t enter a URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_type_available','en','Sorry. There is no [type] available at the moment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_type_accessible','en','Sorry. You do not have the permissions to access any [type] of this list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_input_is_required','en','This input is required. Please enter a value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_title','en','Please enter a title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_sysadmin_sysrole_not_assignable','en','Only a System Administrator may assign users to the System Administrator Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_search_string','en','Please enter your query','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_search_result','en','No entries found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_scan_log','en','Scan log not implemented yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_rolf_allowed2','en','is not allowed to contain a Role Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_rolf_allowed1','en','The object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_write','en','You have no permission to write','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_undelete','en','You have no permission to undelete the following object(s):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read_track','en','You have no permission to access the user tracking.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read_lm','en','You have no permission to read this learning module.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read_item','en','You have no permission to access item \'%s\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_read','en','You have no permission to access this item.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_perm','en','You have no permission to edit permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_paste','en','You have no permission to paste the following object(s):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_modify_user','en','You have no permission to modify user data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_modify_role','en','You have no permission to modify roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_modify_rolt','en','You have no permission to modify role templates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_link','en','You have no permission to create a link from the following object(s):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_delete_track','en','You have no permission to delete tracking data.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_delete','en','You have no permission to delete the following object(s):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_cut','en','You have no permission to cut the following object(s):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_user','en','You have no permission to add users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_rolt','en','You have no permission to add role templates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_role','en','You have no permission to add roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_rolf','en','You have no permission to create a Role Folder. Therefore you may not stop inheritance of roles or add local roles here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_object2','en','at this location!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create_object1','en','You have no permission to create','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_create','en','You have no permission to create the following object(s):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_copy','en','You have no permission to create a copy of the following object(s):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_assign_role_to_user','en','You have no permission to change user\'s role assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_perm_assign_user_to_role','en','You have no permission to change the user assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_language_selected','en','No translation language specified! You must define a language for each translation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_delete_yourself','en','You cannot delete your own user account.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_file','en','You didn\'t choose a file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_no_default_language','en','No default language specified! You must define one translation as default translation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_multi_language_selected','en','You selected the same language for different translations!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_min_one_role','en','Each user must have at least one global role!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_may_not_contain','en','This object may not contain objects of type:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_min_one_active_role','en','Each user must have at least one active global role!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_linked','en','Selected object(s) linked.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_link_clipboard','en','Selected object(s) stored in clipboard (Action: link)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_last_role_for_registration','en','At least one role must be available in the registration form for new users. This role is currently the only one available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_is_last_role','en','You removed the last global role from the following users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_invalid_filetype','en','Invalid file type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_failed','en','Sorry, action failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_error_copy','en','Copy Error','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_rolts','en','Role Template deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_rolt','en','Role Template deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_roles','en','Roles deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_roles_rolts','en','Roles & Role Templates deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_deleted_role','en','Role deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_cut_copied','en','Selected object(s) moved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_cut_clipboard','en','Selected object(s) stored in clipboard (Action: cut)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_cloned','en','Selected object(s) copied','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_copy_clipboard','en','Selected object(s) stored in clipboard (Action: copy)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_cancel','en','Action cancelled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_changes_ok','en','The changes were OK','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_clear_clipboard','en','Clipboard cleared','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','move_to','en','Move to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','move_users_to_style','en','Move Users to Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','movePage','en','Move','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','move_up','en','Move Up','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','move_down','en','Move Down','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','moveChapter','en','Move','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','move','en','Move','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','months','en','Months','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','monthly','en','monthly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_12_short','en','Dec','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_12_long','en','December','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_11_short','en','Nov','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_11_long','en','November','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_10_short','en','Oct','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_10_long','en','October','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_09_short','en','Sep','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_09_long','en','September','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_08_short','en','Aug','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_08_long','en','August','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_07_short','en','Jul','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_07_long','en','July','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_06_short','en','Jun','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_06_long','en','June','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_05_short','en','May','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_05_long','en','May','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_04_short','en','Apr','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_02_long','en','February','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_02_short','en','Feb','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_03_long','en','March','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_03_short','en','Mar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_04_long','en','April','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_01_short','en','Jan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month_01_long','en','January','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','modules','en','Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','month','en','Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','module','en','module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','missing','en','Missing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mob','en','Media Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','minutes','en','Minute(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','minute','en','Minute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','min_time','en','Minimum time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','migrate','en','Migrate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','meta_data','en','Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','message_to','en','Message to:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','message_content','en','Message Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','message_no_delivered_files','en','You do not have submitted any files.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','message','en','Message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feed_delete','en','Delete Web Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_delete','en','Delete Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_write','en','Edit Media Pool Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_visible','en','Media Pool is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_read','en','Read Media Pool Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_not_insert_already_exist','en','The following items have not been inserted because they are already in the media pool:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_new','en','New Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_edit','en','Edit Media Pool Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_delete','en','Delete Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_add','en','Add Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep_added','en','Added Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mep','mep_parent_folder','en','Parent Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','max_time','en','Maximum time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','member','en','Member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','member_status','en','Member Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','members','en','Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','membership_annulled','en','Your membership has been cancelled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mep','en','Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','max_number_rec','en','Maximum number of records','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','matriculation','en','Matriculation number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mark_all_unread','en','Mark All as Unread','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mark_all_read','en','Mark All as Read','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','manage_tracking_data','en','Manage Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','main_menu_frame','en','Top Level Menu','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mails_pl','en','Mail(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mails','en','Mails','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_z_local','en','User Folders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_write','en','Edit mail settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_visible','en','Mail settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_pear_mail_needed','en','You need to install Pear Mail to use this function. To do this, enter <code>pear install Mail</code> on the terminal.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_use_pear_mail_info','en','Use Pear Mail to parse mailbox addresses. The built in parser in ILIAS is very limited. Pear Mail fully supports internet compliant e-mail addresses.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_use_pear_mail','en','Use Pear Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_system_message','en','User may send internal system messages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_system','en','System Message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_smtp_mail','en','User may send e-mail via SMTP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_sent','en','Mail sent!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_send_error','en','Error sending mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_select_one','en','You must select one mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_search_word','en','Search word','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_search_no','en','No entries found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_read','en','Read access to mail settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_not_sent','en','Mail not sent!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_members','en','Mail to Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_maxtime_mail','en','Max. days to keep mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_maxtime_attach','en','Max. days to keep attachments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_maxsize_mail','en','Max. mail size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_maxsize_box','en','Max. mailbox size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_maxsize_attach','en','Max. attachment size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_mails_of','en','Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_mail_visible','en','User may use mail system','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_intern_enable','en','Enable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_import_file','en','Export file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_import','en','Import','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_folders','en','Mail Folders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_feedback','en','Mail Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_e_sent','en','Sent','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_edit_permission','en','Change Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_delete_error_file','en','Error deleting file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_d_drafts','en','Drafts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_delete_error','en','Error while deleting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_b_inbox','en','Inbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_c_trash','en','Trash','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail','en','Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_a_root','en','Mailbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_addressbook','en','Address Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_allow_smtp','en','Allow SMTP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lres','en','Learning Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','los_last_visited','en','Last Visited Learning Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','last_visited','en','Last Visited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','logs','en','Log data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','los','en','Learning Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','logout_text','en','You logged off from ILIAS. Your session has been closed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','logout','en','Logout','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_to_ilias_via_shibboleth','en','Login to ILIAS via','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_to_ilias_via_cas','en','Login to ILIAS via Central Authentication Service','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_to_ilias','en','Login to ILIAS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_time','en','Time online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_invalid','en','The chosen login is invalid! Only the following characters are allowed (minimum 3 characters): A-Z a-z 0-9 _.-+*@!$%~','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_exists','en','There is already a user with this login name! Please choose another one.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_data','en','Login data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_as','en','Logged in as','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login','en','Login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','logic_or','en','or','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','logic_and','en','and','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','log_in','en','Login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','location','en','Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','locator','en','Location:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','local_languages_already_installed','en','Selected local language file(s) are already installed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','local_language_files','en','local language files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','local_language_file','en','local language file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','local','en','Local','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo_overview','en','LO Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo_other_langs','en','LOs in Other Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo_no_content','en','No Learning Resources Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo_new','en','New Learning Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo_edit','en','Edit Learning Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo_categories','en','LO Categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo_available','en','Overview Learning Modules & Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lo','en','Learning Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lngf_visible','en','Language settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lngf_read','en','Read access to Language settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lngf_write','en','Write access, needed for extended language maintenance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lngf_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lngf','en','Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lng','en','Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_write','en','Edit ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_visible','en','ILIAS Learning Module is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_type_scorm2004','en','SCORM 1.2/2004 (JavaScript-RTE)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_type_hacp','en','HACP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_type_scorm','en','SCORM 1.2 (Java-RTE)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_type_aicc','en','AICC','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_read','en','Read access to ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_new','en','New ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_leave','en','Unsubscribe from ILIASLearning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_join','en','Subscribe to ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_create','en','Create ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_delete','en','Delete ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_added','en','ILIAS Learning Module added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_a','en','an ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_add','en','Add ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','literature_bookmarks','en','Literature Bookmarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm','en','Learning Module ILIAS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','literature','en','Literature','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','list_of_questions','en','Question List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','list_of_pages','en','Pages List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_value','en','Parameter value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_user_name','en','ILIAS username','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_user_id','en','ILIAS user id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_session_id','en','ILIAS session id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_select_one','en','- Select one -','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_parameter_deleted','en','Parameter deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_not_available','en','Not available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_no_value_given','en','Please choose a parameter value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_no_name_given','en','Please choose a parameter name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_name','en','Parameter name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_existing_params','en','Existing parameters:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_dynamic_info','en','If enabled, it is possible to append dynamic parameters to Web Links. E.g. the ILIAS user id or the username.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_dynamic','en','Dynamic Web Links parameters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_dyn_parameter','en','Dynamic parameters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','links_add_param','en','Add parameter:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','linked_pages','en','Linked Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','linked_object','en','The object has been linked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_dynamic_info','en','You can add dynamic parameters like the ILIAS user id.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_checker_refreshed','en','Refreshed view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_check_subject','en','[ILIAS 3] Link check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_check_message_enabled','en','Messages enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_check_message_disabled','en','Messages diabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_check_message_b','en','If enabled, you will be informed about invalid links by mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_check_body_top','en','You receive this mail because you want to be informed about invalid links of the following learning modules:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_check','en','Link check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link','en','Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','level','en','Level','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','learning_resources','en','Learning Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','learning_resource','en','Learning Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','learning_resourc','en','Learning Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','learning_progress','en','Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','learning_objects','en','Learning Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','learning module','en','Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_write','en','Edit LDAP settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_visible','en','LDAP settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_version','en','LDAP protokoll version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_v3','en','LDAPv3','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_v2','en','LDAPv2','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_tls','en','Use LDAP TLS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_server','en','LDAP Server URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_search_base','en','LDAP Search base','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_read','en','Read access to LDAP settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_port','en','LDAP Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_passwd','en','Your current password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_objectclass','en','ObjectClass of user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_login_key','en','Attribute for login name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_configure','en','Configure LDAP Authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap_basedn','en','LDAP BaseDN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ldap','en','LDAP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','launch','en','Launch','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lastname','en','Last Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','last_visit','en','Last Visit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','last_update','en','Last Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','last_login','en','Last login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','last_edited_on','en','Last edited on','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','last_change','en','Last Change','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','last_access','en','Last Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','languages_updated','en','All installed languages have been updated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','languages_already_uninstalled','en','Selected language(s) are already uninstalled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','languages_already_installed','en','Selected language(s) are already installed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','languages','en','Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','language_not_installed','en','is not installed. Please install that language first','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','language','en','Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','langfile_found','en','Language file found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_zh','en','Simplified Chinese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_xx','en','Custom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_vi','en','Vietnamese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_version','en','1','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_uk','en','Ukrainian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_timeformat_no_sec','en','H:i','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_timeformat','en','H:i:s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_sv','en','Swedish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_sr','en','Serbian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_sq','en','Albanian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_sep_thousand','en',',','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_sep_decimal','en','.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_ru','en','Russian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_ro','en','Romanian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_pt','en','Portuguese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_pl','en','Polish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_path','en','Language Path','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_no','en','Norwegian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_nl','en','Dutch','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_lt','en','Lithuanian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_ja','en','Japanese','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_id','en','Indonesian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_it','en','Italian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_hu','en','Hungarian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_ge','en','Georgian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_fr','en','French','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_fi','en','Finnish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_es','en','Spanish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_en','en','English','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_et','en','Estonian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_el','en','Greek','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_de','en','German','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_dateformat','en','Y-m-d','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_da','en','Danish','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_cs','en','Czech','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_bg','en','Bulgarian','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','keywords','en','Keywords','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','kb','en','KByte','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','buy','en','Buy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','join','en','Join','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','java_server_readme','en','Setup information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','java_server_port','en','Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','java_server_no_connection','en','Attention: Cannot connect to Java server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','java_server_info','en','If activated, it is possible to search in PDF, HTML files and HTML-Learning modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','java_server_host','en','Host','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','java_server','en','Java-Server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','item','en','Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','is_already_your','en','is already your','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ip_address','en','IP Address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','internal_system','en','Internal system','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','internal_local_roles_only','en','Local roles (only autogenerated)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','institution','en','Institution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','installed_local','en','Installed With Local','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','installed','en','Installed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','install_local','en','Install With Local','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','install','en','Install','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inst_name','en','Installation Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inst_info','en','Installation Info','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inst_id','en','Installation ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','insert_object_here','en','Insert object here','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','insert','en','Insert','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','input_error','en','Input error','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inifile','en','Ini-File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_welcome','en',', welcome to your personal desktop!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_visited_le','en','All LE you have visited so far.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_vis_le','en','Visited LE','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_user_agree','en','Agreement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_title','en','Change user data.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_info3','en','Please select one of the links in the side bar.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_info2','en','It is not allowed to use special characters (like , ; . = - * + #) in your INGMEDIA username and password. To be allowed to use the INGMEDIA platform, you must accept the user agreement.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_use_info1','en','Here you can change your personal data. Except for the INGMEDIA username and password, you do not have to fill out other fields. Remember that lost passwords can only be returned by e-mail (!).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_reg_le','en','Registered LE','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_reg_fo','en','Registered forums','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_pers_dates','en','Personal data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_level_zero','en','Level up','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_info_about_work2','en',', you worked here for the last time. You can continue there by clicking here:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_info_about_work1','en','On','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_hello','en','Hello','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_night','en','Good night','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_morning','en','Good morning','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_evening','en','Good evening','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_good_afternoon','en','Good afternoon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_back_to_le','en','Back to LE','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ingmedia_all_offers','en','All LE','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','information_abbr','en','Info','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inform_user_mail','en','Send mail to inform user about changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_view_of_user','en','User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_trash','en','Deleted Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_status_info','en','Permissions of User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_short','en','Info','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_remark_interrupted','en','Role is interrupted at this position. The role\'s default permission settings in effect are located in that position.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_permission_source','en','Effective From*','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_permission_origin','en','Original Position','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_owner_of_object','en','Owner of object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_not_assigned','en','not assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_enter_login_or_id','en','<i>(Enter login name or user ID)</i>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_err_user_not_exist','en','User with that login name or user_id does not exists','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_from_role','en','Granted by Role / Ownership','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_is_member','en','User is member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_is_not_member','en','User is not a member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_deleted','en','Object(s) Deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_delete_warning_no_trash','en','(WARNING: Selected Objects will be removed irreversibly from System and may not be recovered anymore!)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_deactivate_sure','en','Are you sure that you want to disapprove the following user(s) as active user(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_activate_sure','en','Are you sure that you want to approve the following user(s) as active user(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_delete_sure','en','Are you sure that you want to delete the following item(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_available_roles','en','Available roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_change_user_view','en','Change User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_assigned','en','assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_accessFree_sure','en','Are you sure you want to remove the limited access for the following user(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_assign_sure','en','Are you sure you want to assign the following user(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_access_permissions','en','Access permissions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info_access_and_status_info','en','Access- and Statusinformation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','info','en','Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','include_local','en','include local language file when updating language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inactive','en','Inactive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inbox','en','Inbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','in','en','in','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','in_use','en','User Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','imported','en','imported','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','important','en','Important','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_warning_log','en','Import warning log','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_users','en','Import Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_svy','en','Import Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_tst','en','Import Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_spl','en','Import Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_sahs','en','Import SCORM/AICC Package','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_root_user','en','Import Root User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_questions_into_qpl','en','Import question(s) into question pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_qpl','en','Import Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_lm','en','Import ILIAS Learning module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_hlm','en','Import HACP Package','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_grp_finished','en','Imported group without any error','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_grp','en','Import Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_glossary','en','Import Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_forum_finished','en','The forum has been imported.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_finished','en','Number of imported messages.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_file_not_valid','en','The import file is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_file','en','Import File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_failure_log','en','Import failure log','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_dbk','en','Import Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_categories','en','Import Categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_cat_table','en','The following table is only meaningful if the checkbox is set','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_cat_localrol','en','Create local role for every new category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import_alm','en','Import AICC Package','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','import','en','Import','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','image_gen_unsucc','en','Image generation unsuccessful. Contact your system administrator and verify the convert path.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','image','en','Image','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_upload_pic_text','en','To display your picture in LearnLinc Seminars please use this link:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_upload_pic_linktext','en','Upload','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_server_not_active','en','iLinc Server not activated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_student','en','Participant','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_remark','en','Remark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_involved_users','en','Involved Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_body_new_subscription','en','You have been subscribed to this LearnLinc Seminar.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_body_subscription_cancelled','en','Your membership has been cancelled.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_subj_new_subscription','en','New subscription','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_mail_subj_subscription_cancelled','en','Subscription cancelled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_manage_course_documents','en','Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_mem_change_status','en','Change user\'s status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_mem_leave','en','Dismiss user from LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_mem_send_mail','en','Send user a message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_msg_joined','en','You joined the LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_msg_member_assigned','en','User(s) assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_msg_membership_annulled','en','Subscription cancelled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_no_akclassvalues','en','none','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_no_docent_assigned','en','Not assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_notset','en','Not set','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_login','en','iLinc Login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_passwd','en','iLinc Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_id','en','iLinc ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_header_edit_users','en','Edit list of involved users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_registration_data','en','Please enter a password, the expiration date and time for a valid registration period !','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_no_permission','en','You do not possess the permissions for this operation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_member_could_not_be_removed','en','User could not be removed. Please verify all dependencies of that user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_last_member','en','Last member could not be removed, please delete LearnLinc Seminar instead.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_at_least_one_groupadministrator_is_needed','en','Each LearnLinc Seminar needs at least one administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_err_administrator_required','en','Member could not be removed, at least one administrator per LearnLinc Seminar is required !','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_dismiss_myself','en','Are you sure you want to dismiss yourself from the LearnLinc Seminar?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_docent','en','Instructor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_dismiss_member','en','Are you sure you want to dismiss the following user(s) from the LearnLinc Seminar?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_courses','en','LearnLinc Seminars','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_coursemember_status','en','Attending as','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_classroom_open','en','Classroom is open','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_classrooms','en','LearnLinc Classrooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_classroom_closed','en','Classroom is closed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_classroom_always_open','en','Classroom is always open','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_akclassvalue','en','Cost center','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_akclassvalues','en','Cost centers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilinc_add_user','en','Add user(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ilias_version','en','ILIAS version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_icrs_member','en','LearnLinc Seminar member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_icrs_admin','en','LearnLinc Seminar administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_grp_member','en','Group member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_grp_admin','en','Group administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_crs_tutor','en','Course tutor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_frm_moderator','en','Forum moderator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_grp_status_closed','en','Group closed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_grp_status_open','en','Group open','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_crs_non_member','en','Course non-member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_crs_member','en','Course member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_chat_moderator','en','Chat moderator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','il_crs_admin','en','Course administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ignore_on_conflict','en','Ignore on conflict','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','if_no_title_then_url','en','Leave blank to display the URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','if_no_title_then_filename','en','Leave blank to use file name as title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','identifier','en','identifier','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_write','en','Edit LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','id','en','ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_members_gallery','en','Seminar Members Gallery','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_new','en','New LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_read','en','Read access to LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_visible','en','LearnLinc Seminar is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_leave','en','User may leave LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_join','en','User may join LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_add','en','Add LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_added','en','LearnLinc Seminar added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_create_icla','en','Create LearnLinc Classrooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_delete','en','Delete LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_edit','en','Edit LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_edit_permission','en','Edit permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs','en','LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icons_in_typed_lists_info','en','Determines where to display icons in item lists that are ordered by type within the repository and on the personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icons_in_typed_lists','en','Icon position in item lists','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icons_in_item_rows','en','Item rows','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icons_in_header','en','Header row','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icon_settings','en','Icon Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icla_new','en','New LearnLinc Classroom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icla_edit','en','Edit LearnLinc Classroom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_new','en','New HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_read','en','Read HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_visible','en','HTML Learning Module is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_write','en','Edit HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','http','en','HTTP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','http_not_possible','en','This server is not supporting http requests.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','http_path','en','Http Path','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','https_not_possible','en','This server is not supporting HTTPS connnections.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','i2passwd','en','ILIAS 2 password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icla','en','LearnLinc Classroom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icla_add','en','Add LearnLinc Classroom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icla_deleted','en','LearnLinc classroom(s) deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_edit','en','Edit HTML Learning Module Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_delete','en','Delete HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','host','en','Host','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hour','en','Hour','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hours','en','Hour(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hours_of_day','en','Hours of day','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm','en','Learning Module HTML','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_add','en','Add HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hobby','en','Interests/Hobbies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','home','en','Public Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_write','en','Edit HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_visible','en','HACP Learning Module is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_read','en','Read access to HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_leave','en','Unsubscribe from HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_join','en','Subscribe to HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_added','en','HACP Learning Module added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_create','en','Create HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_delete','en','Delete HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hlm','en','Learning Module HACP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hits_per_page','en','Hits/Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_webr_update','en','Update Web Resource. Title: \"%1\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','history','en','History','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_no_entries','en','No entries in history.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_webr_add','en','Added new Web Resource with title: \"%1\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_webr_delete','en','Deleted Web Resource. Title: \"%1\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_st_create','en','Chapter created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_st_cut_page','en','Page \"%1\" [%2] cut out of chapter.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_st_paste_page','en','Page \"%1\" [%2] pasted into chapter.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_update','en','Page changed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_paste','en','Page pasted into chapter \"%1\" [%2].','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_create','en','Page created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_pg_cut','en','Page cut out of chapter \"%1\" [%2].','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_delete_st','en','Chapter \"%1\" [%2] has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_lm_delete_pg','en','Page \"%1\" [%2] has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_file_replace','en','File replaced, new file name is \"%1\", new version is %2.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_updated','en','File has been updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_created','en','File has been added.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_file_create','en','File created, file name is \"%1\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_st_paste_page','en','Page \"%1\" [%2] pasted into chapter.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_cut','en','Page cut out of chapter \"%1\" [%2].','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_paste','en','Page pasted into chapter \"%1\" [%2].','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_update','en','Page changed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_st_cut_page','en','Page \"%1\" [%2] cut out of chapter.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_pg_create','en','Page created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_delete_pg','en','Page \"%1\" [%2] has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hist_dbk_delete_st','en','Chapter \"%1\" [%2] has been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hide_structure','en','Disable Structured-View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hide_private_notes','en','Hide Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hide_details','en','Hide Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hide','en','Hide','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','help','en','Help','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','guest','en','Guest','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','guests','en','Guests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','header_searchable','en','Searchable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','header_title','en','Header Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_write','en','Edit Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_visible','en','Group is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_select_one_file','en','Please select one file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_select_one_file_only','en','Please select exactly one file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_search_members','en','User search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_search_enter_search_string','en','Please enter a search string','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_registration','en','Join group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_registration_completed','en','You have joined the group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_read','en','Read access to Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_register','en','Join','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_no_roles_selected','en','Please select a role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_options','en','Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_no_results_found','en','No results found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_no_groups_selected','en','Please select a group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_msg_membership_annulled','en','Cancelled membership.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_name_exists','en','There is already a group with this name! Please choose another name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_new','en','New Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_new_search','en','New search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_msg_member_assigned','en','User(s) assigned as group member(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_msg_applicants_removed','en','Applicant(s) removed from list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_msg_applicants_assigned','en','Applicant(s) assigned as group member(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_members_gallery','en','Group Members Gallery','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_mem_send_mail','en','Send member a message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_mem_leave','en','Dismiss member from group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_mem_change_status','en','Change Member Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_mail_subj_subscription_cancelled','en','Subscription cancelled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_mail_subj_new_subscription','en','New subscription','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_mail_body_new_subscription','en','You have been subscribed to this group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_mail_body_subscription_cancelled','en','Your membership has been cancelled.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_leave','en','User may leave Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_list_users','en','List users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_header_edit_members','en','Edit members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_join','en','User may join Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_err_registration_data','en','Please enter a password, the expiration date and time for a valid joining period !','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_err_no_permission','en','You do not possess the permissions for this operation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_err_error','en','An error occurred','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_err_last_member','en','Last member could not be removed, please delete group instead.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_err_member_could_not_be_removed','en','Member could not be removed. Please verify all dependencies of this user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_err_at_least_one_groupadministrator_is_needed','en','Each group needs at least one group administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_err_administrator_required','en','Member could not be removed, at least one administrator per group is required !','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_edit','en','Edit Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_dismiss_myself','en','Are you sure you want to leave the group?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_webr','en','Create Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_delete','en','Delete Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_deleted_export_files','en','Deleted selected files.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_dismiss_member','en','Are you sure you want to dismiss the following member(s) from the group?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_svy','en','Create Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_tst','en','Create Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_spl','en','Create Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_sahs','en','Create SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_qpl','en','Create Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_mep','en','Create Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_lm','en','Create ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_icrs','en','Create LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_hlm','en','Create HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_htlm','en','Create HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_grp','en','Create Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_frm','en','Create Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_glo','en','Create Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_fold','en','Create Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_file','en','Upload File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_dbk','en','Create Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_exc','en','Create Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_alm','en','Create AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_chat','en','Create Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_count_members','en','Number of members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create','en','Create Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_app_send_mail','en','Send applicant a message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_back','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_already_applied','en','You have already applied to this group! Please wait for confirmation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_added','en','Group added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_add_member','en','Add Member(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','groupings_assigned_obj_crs','en','Assigned Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','groupings_assigned_obj_grp','en','Assigned Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','groups','en','Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','groups_overview','en','Groups Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp','en','Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_a','en','a Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_add','en','Add Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','groupings','en','Membership Limitations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_status_public','en','Public','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_status_desc','en','Determines the initial status of the group by using the permission settings from the role templates \'il_grp_status_closed\' or \'il_grp_status_open\'<br />Public: Group is visible; User may subscribe.<br />Closed: Group is not visible for non-members; User has to be invited by a member to join.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_status','en','Group is','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_status_closed','en','Closed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_reset','en','Reset Group Permissions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_req_registration_msg','en','You can request membership for this group. You will receive a message when a group administrator has accepted or declined your request.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_req_password','en','Join with group password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_req_registration','en','Request membership','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_req_direct','en','Join directly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_registration_mode','en','Registration Procedure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_registration_time','en','Registration Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_registration_expired','en','The time period for joining this group has expired','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_registration_expired_msg','en','The time period for joining this group has expired. Please contact a group administrator, if you want to join this group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_registration_expiration_time','en','Expiration Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_registration_expiration_date','en','Expiration Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_registration','en','Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_password_registration_msg','en','If you know the group password, you can join this group. Please contact a group administrator, if you don\'t know the password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_not_available','en','No group available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_objects','en','Group Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_no_registration_msg','en','You can join this group directly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_memstat_member','en','Member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_name','en','Group name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_new_registrations','en','Join Requests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_no_registration','en','Join group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_memstat_admin','en','Administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_members','en','Group Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_memstat','en','Member Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_info_reg','en','Admission procedure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_import_file','en','Import file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_import','en','Group import','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_details','en','Group Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_filesharing','en','Group File Sharing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_desc','en','Group Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_create_chat','en','Create chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_any_objects','en','No subobjects available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glossary_added','en','Glossary added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','group_access_denied','en','Access Denied','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glossary','en','Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glossaries','en','Glossaries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','global_user','en','Global users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','global_fixed','en','Global Fixed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','global_settings','en','Global settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','global','en','Global','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','global_default','en','Global Default','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_write','en','Edit Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_upload_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_visible','en','Glossary is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_read','en','Read access to Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_new','en','New Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_mode_normal','en','normal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_mode_subtree','en','virtual (entire subtree)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_mode_level','en','virtual (this level only)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_mode','en','Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_mode_desc','en','A virtual glossary works like a normal glossary. Additionally it contains the terms from all glossaries that are located on the same level in the repository like the virtual glossary (level) respectively from all glossaries that are located downwards in the repository from the position of the virtual glossary (subtree).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_leave','en','Unsubscribe from Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_join','en','Subscribe to Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_add','en','Add Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_added','en','Glossary added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_create','en','Create Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_delete','en','Delete Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','generate','en','Generate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo','en','Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_a','en','a Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','gender_m','en','Male','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','general_settings','en','General settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','gdf_new','en','New Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','gender','en','Gender','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','gender_f','en','Female','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fullname','en','Full name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','functions','en','Functions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','gdf_add','en','Add Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_write','en','Edit forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','from','en','From','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_statistics_ranking','en','Ranking','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_status_new','en','Status \'New\'','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_status_new_desc','en','Please select a duration how long the status \'New\' is kept for forum entries.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_visible','en','Forum is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_edit_post','en','Add new posting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_new','en','New Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_read','en','Read access to Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_edit','en','Edit Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_delete_post','en','Delete a post, censorship','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_delete','en','Delete Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_create','en','Create Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_added','en','Forum added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_article','en','article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_add','en','Add Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_a','en','a Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_latest_postings','en','Latest Articles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm','en','Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_overview','en','Forums Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_threads','en','Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_new_articles','en','New Articles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_moderators','en','Moderators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_articles','en','Articles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_last_post','en','Latest Article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_post_replied','en','Your forum entry has been replied.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums','en','Forums','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_notify_me_generally','en','Please inform me about any new contributions to my topic.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_notify_me_directly','en','Please inform me about direct answers to my contribution.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_notify_me','en','Notify me when a reply is posted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_import_file','en','Import file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_notification','en','Notification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_import','en','Forum import','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_general_notification','en','Gen. Notification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_direct_notification','en','Dir. Notification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum','en','Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','form_empty_fields','en','Please complete these fields:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forgot_username','en','Forgot username?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forgot_password','en','Forgot password?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forename','en','Forename','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','folders','en','Folders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','force_accept_usr_agreement','en','You must accept the user agreement!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','folder','en','Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_write','en','Edit Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_visible','en','Folder is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_read','en','Read access to Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_new','en','New Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_edit_permission','en','Change Permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_edit','en','Edit Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_delete','en','Delete Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_tst','en','Create Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_webr','en','Create Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_svy','en','Create Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_spl','en','Create Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_sahs','en','Create SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_qpl','en','Create Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_mep','en','Create Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_lm','en','Create ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_icrs','en','Create LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_htlm','en','Create HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_hlm','en','Create HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_glo','en','Create Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_frm','en','Create Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_fold','en','Create Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_file','en','Upload File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_exc','en','Create Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_dbk','en','Create Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_chat','en','Create Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_alm','en','Create AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_added','en','Folder added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_add','en','Add Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','flatview','en','Flat View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold','en','Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_a','en','a Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filter','en','Filter:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','firstname','en','First Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','files_location','en','Files Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fill_out_all_required_fields','en','Please fill out all required fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename','en','Filename','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','files','en','Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_write','en','Edit File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_visible','en','File is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_version','en','Version Provided in File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_valid','en','File is valid!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_suffix_repl_info','en','Files ending with these suffixes (separated by comma) will be renamed with a suffix \".sec\" if uploaded into the webspace. This is done per default for the suffixes:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_suffix_repl','en','File Upload Suffix Replacement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_allowed_suffixes','en','Allowed file types:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_read','en','Download File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_notice','en','Please take note of the maximum file size of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_not_valid','en','File not valid!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_not_found','en','File Not Found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_new','en','Upload Single File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_is_infected','en','The file is infected by a virus.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_info','en','File Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_icon','en','File icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_edit_permission','en','Change Permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_edit','en','Edit File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_added','en','File uploaded','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_delete','en','Delete File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_add_and_metadata','en','Upload File and Edit Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_add','en','Upload File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feedback_recipient','en','Feedback Recipient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','field_name','en','Field Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','field_type','en','Field Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_a','en','a File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','feedback','en','Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_title_configure','en','Configure external software','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_visible','en','Third party software settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_write','en','Configure third party software','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','faq_exercise','en','FAQ Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fax','en','Fax','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_remark','en','All software and services listed above are not part of ILIAS and do not fall under the ILIAS open source licence agreement.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_read','en','Access third party software settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_name','en','Software/Service','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_registrar_passwd','en','Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_server','en','Server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_settings_saved','en','LearnLinc settings saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_timeout','en','Max time waiting for server response','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_registrar_login','en','Login ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_protocol_port','en','Protocol & Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_enable','en','Enable LearnLinc support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_desc','en','Provides virtual classrooms. Commercial service. For an account and further information please contact netucate at www.netucate.com','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_customer_id','en','Customer ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_configure','en','Configure netucate LearnLinc','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_connection_data','en','Connection data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_required','en','Cost center required','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_required_info','en','Specifying at least one Cost center for a LearnLinc Seminar is required','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_active_info','en','With this option enabled you may use iLinc cost centers for Learnlinc-Seminars and Classrooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_configure','en','configure...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc','en','netucate LearnLinc','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_additional_options','en','Additional Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','extt_ilinc_akclassvalues_active','en','Enable cost centers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','export_xml','en','Export as XML File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','export_html','en','Export as HTML File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','export_group_members','en','Export group members (to Microsoft Excel)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','export_format','en','Export format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','export_format_selection','en','Please select the export file format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_restricted','en','Set the selected user(s) to limited access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_free_granted','en','Set the selected user(s) to unlimited access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','accessFree','en','Remove limited Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','accessRestrict','en','Set limited Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','explorer_frame','en','Explorer Tree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','export','en','Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exp_html','en','Export HTML','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','expand','en','Expand','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exercise_time_over','en','You have reached the end time of the exercise. You cannot longer deliver files!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','excs','en','Exercises','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','execute','en','Execute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_visible','en','Exercise is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_write','en','Edit exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_upload_error','en','Error uploading file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_users','en','Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_time_to_send','en','Remaining Working Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_time_over_short','en','Time is over.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_status_solved','en','Solved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_status_submitted','en','Submitted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_submission','en','Submission','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_status_sent','en','Delivered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_status_resubmitted','en','Resubmitted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_status_saved','en','Exercise updated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_sent_at','en','Sent at <br />%s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_sent','en','The exercise has been sent to the selected users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_send_exercise','en','Send exercise by mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_select_one_file','en','Please select exactly one file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_save_changes','en','Save','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_schedule','en','Schedule','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_search_for','en','Search for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_roles','en','Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_resubmitted_advice','en','This symbol will be displayed in case that a new file has been submitted after the \"solved\" field has been checked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_read','en','Access exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_obj','en','Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_notices','en','Notices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_no_members_assigned','en','No members assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_new','en','New exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_members_comments_saved','en','The exercise comments for the selected user have been saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_mail_users','en','Send mail to user(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_members_already_assigned','en','These user are already assigned to this exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_members_assigned','en','Members assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_header_members','en','Exercise (members)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_instruction','en','Work Instructions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_last_submission','en','Last Submission','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_groups','en','Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_files_returned','en','Submitted Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_files','en','Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_feedback_sent','en','Feedback Sent','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_edit_until','en','Edit Until','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_exercise_sent','en','Exercise Sent','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_edit_exercise','en','Edit exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_edit','en','New exercise created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_download_new','en','Download New','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_details','en','Exercise details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_download_all','en','Download All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_download_files','en','Download Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_date_not_valid','en','The date is not valid','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_deassign_members','en','Delete member(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_delete','en','Delete exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_create','en','Create exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_assign_usr','en','Assign User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_added','en','Exercise added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_ask_delete','en','Delete file?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc','en','Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_add','en','Add Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','error_recipient','en','Error Recipient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','error_parser','en','Error starting the parser.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_wrong_password','en','Wrong Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','error','en','Error','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_wrong_login','en','Wrong Login or Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_wrong_header','en','Reason: Wrong header.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_unknown_error','en','Unknown Error','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_session_expired','en','Your session is expired!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_role_not_assignable','en','You cannot assign users to this role at this location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_no_param','en','No parameter!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_over_3_param','en','More than 3 parameters!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_no_langfile_found','en','No language file found!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_no_cookies','en','Please enable session cookies in your browser!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_ldap_user_not_found','en','User not found on LDAP server! Please check attribute for login name and Objectclass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_ldap_search_failed','en','Connection to LDAP server failed! PLease check BaseDN and Search base','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_ldap_connect_failed','en','Connection to LDAP server failed! Please check your settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_ldap_auth_failed','en','User not authenticated on LDAP server! Please ensure that you have the same password in ILIAS and LDAP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_inactive','en','This account has not been activated. Please contact the system administrator for access.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_invalid_port','en','Invalid port number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_in_line','en','Error in line','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_enter_current_passwd','en','Please enter your current password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_count_param','en','Reason: Wrong parameter count','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_auth_soap_no_ilias_user','en','Login failed. SOAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_auth_ext_user_exists','en','External account \'%s\' for authentication mode \'%s\' is already existing. (User \'%s\')','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_auth_cas_no_ilias_user','en','Login failed. CAS authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_1_param','en','Only 1 parameter!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_2_param','en','Only 2 parameter!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enumerate','en','Enumerate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enter_filename_deliver','en','Enter file to be delivered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enabled','en','Enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_trash_info','en','If enabled, deleted Objects are moved into Trash and may be recovered later. When deactivating this option deleted Objects are removed irreversibly from the System!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_trash','en','Enable Trash','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_registration','en','Enable new user registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_password_assistance','en','Enable password assistance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_js_edit_info','en','This option enables JavaScript editing for all content objects (ILIAS Learning Modules, Glossaries, Assessment Questions, Digilib Books)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_js_edit','en','Enable JavaScript Editing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_hist_user_comments_desc','en','Give authors the opportunity to add comments to the history log of pages.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_hist_user_comments','en','Enable user comments in history','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','disable_anonymous_fora_desc','en','If option is enabled, nobody is able to make a forum anonymous. Making an anonymous forum non-anonymous is still possible.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','disable_anonymous_fora','en','Disable Anonymous Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_fora_statistics','en','Enable Statistics in Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_fora_statistics_desc','en','If disabled, nobody is able to access the forum statistics.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_custom_icons_info','en','This allows to define custom icons for single categories, courses and groups. The properties section of categories, courses and groups will provide an image upload dialog.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_custom_icons','en','Enable custom icons','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_calendar','en','Enable Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable','en','Enable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','email_not_valid','en','The e-mail address you entered is not valid!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','email_footer','en','<br />powered by ILIAS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','email_feedback','en','E-Mail feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_stylesheet','en','Edit Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edited_at','en','Edited at','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','editor','en','Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','email','en','E-Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_roleassignment','en','Edit role assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_properties','en','Edit Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_perm_ruleset','en','Edit default permission rules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_page_content','en','Edit Page Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_page','en','Edit Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_operations','en','Edit Operations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_data','en','edit data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_content','en','Edit content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_comments','en','Edit comments for the selected user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit','en','Edit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','drop','en','Drop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','drafts','en','Drafts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','disabled','en','Disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','domain','en','Domain','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','down','en','Down','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','download','en','Download','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','download_all_returned_files','en','Download all returned files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','disable_check','en','Disable check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','disable','en','disable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','details','en','Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','desktop_items','en','Personal desktop items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','description','en','Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','desired_password','en','Desired Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','department','en','Department','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','desc','en','Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','descending_order','en','Descending order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','deleted_users','en','Deleted users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','deliver','en','Deliver','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','deleted','en','Deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','deleted_user','en','The user has been deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete_selected','en','Delete Selected','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete_tr_data','en','Delete tracking data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete_all_rec','en','Delete all records','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete_object','en','Delete Object(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete_all','en','Delete All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_value','en','Default Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','defaults','en','Defaults','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_style','en','Default Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_skin_style','en','Default Skin / Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_skin','en','Default Skin','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_roles','en','Default Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_role','en','Default Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default','en','Default','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_language','en','Default Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_perm_settings','en','Default permissions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','def_repository_view','en','Default repository view','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_write','en','Edit Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_visible','en','Digilib Book is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_read','en','Read access to Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_new','en','New Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_create','en','Create Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_delete','en','Delete Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_added','en','Digilib Book added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_add','en','Add Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_a','en','a Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk','en','Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','db_user','en','Database User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','db_version','en','Database Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','db_type','en','Database Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','db_need_update','en','Database needs an update!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','db_pass','en','Database Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','db_name','en','Database Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','days_of_period','en','Days of period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','db_host','en','Database Host','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','days','en','Days','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','day','en','Day','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dateplaner','en','Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','date','en','Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dataset','en','Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','database','en','Database','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','database_version','en','Current Database Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','data_privacy','en','Data Privacy Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','daily','en','daily','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cut','en','Cut','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cutPage','en','Cut','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','custom_icon_size_standard','en','Custom icon size (standard)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','custom_icon_size_tiny','en','Custom icon size (small)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','current_password','en','Current Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','custom_icon_size_big','en','Custom icon size (big)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','current_ip_alert','en','Notice: if you enter a wrong ip you won\'t be able to access the system with this profile anymore.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_write','en','Edit Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cumulative_time','en','Cumulative time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cur_number_rec','en','Current number of records','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','current_ip','en','Current IP:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_visible','en','Course is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_subscribers_assigned','en','Assigned new user(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_status_pending','en','[Waiting for registration]','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_status_blocked','en','[Access refused]','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_read','en','Read access to Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_no_content','en','Without content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_new','en','New Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_members_gallery','en','Course Members Gallery','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_member_passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_member_not_passed','en','Not passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_management_system','en','Course Management System','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_join','en','Join Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_leave','en','Leave Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_info','en','Info','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_edit','en','Edit Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_delete','en','Delete Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_tst','en','Create Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_webr','en','Create Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_svy','en','Create Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_spl','en','Create Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_sahs','en','Create SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_qpl','en','Create Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_mep','en','Create Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_lm','en','Create ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_icrs','en','Create LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_htlm','en','Create HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_hlm','en','Create HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_grp','en','Create Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_fold','en','Create Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_frm','en','Create Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_glo','en','Create Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_file','en','Upload File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_exc','en','Create Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_chat','en','Create Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_dbk','en','Create Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_alm','en','Create AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create','en','Create Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_container_link_not_allowed','en','It is not possible to link container objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_available','en','Available Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_at_least_one_admin','en','There has to be at least one course administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_archives','en','Archives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_all_questions_answered_successfully','en','You have successfully answered every question.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_added','en','Course added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_add','en','Add Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs','en','Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_a','en','a Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_activation_start_invalid','en','The start and the end time is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_lucene_index','en','Update Lucene search index','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_lucene_index_info','en','If enabled, the lucene search index will be updated. Please configure the lucene server at \'Administration -> Search\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_jobs','en','Cron jobs','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_jobs_desc','en','A cron job is an automated process that operates at predefined time intervals. You will find information about the setup in the \'INSTALL Documentation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_mail_notification_desc','en','If enabled, all users, who want to be informed about new mail, will get notifications by external mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_mail_notification_cron','en','regularly per cron job','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_mail_notification_never','en','never','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_never','en','never','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_mail_notification','en','Send Mail Notifications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_directly','en','directly on new entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_desc','en','If enabled, all users, who want to be informed about new posts in specified forum topics, will get notifications by mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification_cron','en','regularly per cron job','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cron_forum_notification','en','Send Forum Notifications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','created','en','Creation Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','create_stylesheet','en','Create Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','create_in','en','Create in','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','create_export_file','en','Create export file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','create_date','en','Created on','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','create','en','Create','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','courses','en','Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','course','en','Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','country','en','Country','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','count','en','Count','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','could_not_verify_account','en','Sorry, we could not verify your account. Please contact the system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copy_to','en','to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copy_n_of_suffix','en','- Copy (%1$s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copy_of_suffix','en','- Copy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copy_of','en','Copy of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copyPage','en','Copy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copyChapter','en','Copy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copy','en','Copy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copied_object','en','Copied object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cookies_howto','en','How to enable cookies','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','contra','en','Contra','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','continue_work','en','Continue','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','context','en','Context','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','content_styles','en','Content Styles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','content','en','Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','container','en','Container','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','contact_data','en','Contact Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cont_object','en','Object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','conflict_handling','en','Conflict handling','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','confirm','en','Confirm','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','confirmation','en','Confirmation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_update','en','Save','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','conditions_updated','en','Conditions saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_select_one','en','-Please select one condition-','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_select_object','en','Please select one object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_precondition','en','Preconditions:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_not_finished','en','Not finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_finished','en','Finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_deleted','en','Condition deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_circle_created','en','This association is not possible, since the objects would interdepend.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition_already_assigned','en','Object already assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','condition','en','Condition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','compose','en','Compose','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','comment','en','Comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','comma_separated','en','Comma Separated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','collapse','en','Collapse','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cnt_new','en','(%s New)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','close_window','en','Close window','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','close','en','Close','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clipboard','en','Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','client_ip','en','Client IP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','client_id','en','Client ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','client','en','Client','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clear','en','Clear','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','city','en','City, State','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cleaned_file','en','File has been cleaned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cleaning_failed','en','Cleaning failed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chown_warning','en','Attention, you may loose access permissions on this object after changing the owner.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','choose_only_one_language','en','Please choose only one language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','choose_location','en','Choose Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','choose_language','en','Choose Your Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chg_ilias_and_webfolder_password','en','Change ILIAS and Webfolder Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chg_ilias_password','en','Change ILIAS Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chg_password','en','Change Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','checked_files','en','Importable files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chg_language','en','Change Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_user_accounts_desc','en','If cron jobs are activated and this option is enabled, all users whose account expires will be informed by e-mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_web_resources','en','Check Web Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_web_resources_desc','en','If enabled all Web Resources will be checked if they are active.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_link_desc','en','If enabled all external links in ILIAS learning modules will be checked if they are active.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_max_allowed_packet_size','en','The page content size is too large.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_user_accounts','en','Check user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_languages','en','Check Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_link','en','Link check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_langfile','en','Please check your language file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','textbox','en','Textbox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check_all','en','Check all','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','unchecked','en','Unchecked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','checked','en','Checked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_write','en','Edit chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','check','en','Check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_visible','en','Chat is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_read','en','Read/Write access to chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_users_active','en','Active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_new','en','New Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_moderate','en','Moderate chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_invite','en','Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_delete','en','Delete chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_add','en','Add Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_active_in','en','Active in chat:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat','en','Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','characters','en','characters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chapter_title','en','Chapter Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chapter_number','en','Chapter Number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chapter','en','Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','changed_to','en','changed to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','changeable','en','Changeable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_sort_direction','en','Change sort direction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_owner','en','Change owner','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_metadata','en','Change Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_lo_info','en','Change LO Info','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_header_title','en','Edit Header Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_existing_object_type_desc','en','Also change permissions of already existing objects of that type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_existing_prefix_single','en','Change','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_existing_suffix_single','en','&nbsp;','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_existing_suffix','en','&nbsp;','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_existing_prefix','en','Change existing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','role_protect_permissions_desc','en','The object permissions cannot be changed by systems operations anymore. Furthermore only administrator of higher levels may change the permissions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_existing_objects_desc','en','The permission settings of this role will be adpoted to ALL existing objects. If you want to change permissions only for specific object types please click the checkboxes to the right of the appropiate object type.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_existing_objects','en','Change existing Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','perm_special_options','en','Special Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_assignment','en','Change assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change_active_assignment','en','Change active assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','change','en','Change','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chac_write','en','Edit chat settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chac_visible','en','Chat settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chac_read','en','Read access to chat settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chac_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','centra_server','en','Centra Server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','centra_rooms','en','Centra Rooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','censorship','en','Censorship','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','centra_account','en','Centra Admin Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cen_save','en','Save Centra Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cen_new','en','New Centra Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cen_delete','en','Delete Centra Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cen_edit','en','Edit Centra Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cen_added','en','Centra Event added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cen_add','en','Add Centra Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cc','en','CC','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cen','en','Centra Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','categories_imported','en','Category import complete.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','categories','en','Categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_write','en','Edit Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_visible','en','Category is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_undo_last_page_changes','en','Undo Last Page Changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_read_users','en','Read access to local user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_read','en','Read access to Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_pages_undone','en','Last changes for cagegory page undone.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_pages_not_created','en','Category page not createded yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_pages_clear','en','Category page cleared.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_new','en','New Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_pages','en','Category Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_edit','en','Edit Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_delete','en','Delete Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_url','en','Create URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_webr','en','Create Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_tst','en','Create Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_spl','en','Create Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_svy','en','Create Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_sahs','en','Create SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_lm','en','Create ILIAS Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_mep','en','Create Media Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_qpl','en','Create Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_icrs','en','Create LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_htlm','en','Create HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_hlm','en','Create HACP Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_grp','en','Create Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_glo','en','Create Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_frm','en','Create Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_file','en','Upload File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_exc','en','Create Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_dbk','en','Create Digilib Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_crs','en','Create Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_chat','en','Create Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_cat','en','Create Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_alm','en','Create AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create','en','Create Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_clear_page','en','Clear Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_cat_administrate_users','en','Administrate local user accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_added','en','Category added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_add','en','Add Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_a','en','a Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','before','en','before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_file_extension_settings','en','File Extensions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_edit_settings','en','MediaCast Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_videoportable_settings_info','en','Comma separated list of file suffixes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_videoportable_settings_title','en','File Extensions for Video Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_audioportable_settings_info','en','Comma separated list of file suffixes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_audioportable_settings_title','en','File Extensions for Audio Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_standard_settings_info','en','Comma separated list of file suffixes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_standard_settings_title','en','File Extensions for Standard Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_current_value_info','en','Shows the current value of this format.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_global_settings','en','Global Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_media_cast_not_online_text','en','Mediacast is not online or has been disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_media_cast_not_online','en','Mediacast is not online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_downloadable_info','en','If this option is enabled, links for downloading are provided.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_downloadable','en','Download Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_clear_purpose_title','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_download_audioportable','en','Download Audio Portable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_download_videoportable','en','Download Video Portable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_download_standard','en','Download','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_videoportable_title','en','Additional Video File for Portable Devices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_audioportable_title','en','Additional Audio File for Portable Devices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_standard_title','en','Normal Media File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_edit_item','en','Edit Mediacast Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_incl_files_in_rss_info','en','If enabled, media files are includes as attachements in the RSS feed. Otherwise the feed just notifies subscribers about new items.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_incl_files_in_rss','en','Include Media Files in Feed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_settings','en','Mediacast Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_play_time','en','Play Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_det_playtime','en','Determine Play Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_entry','en','Mediacast Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_media_cast','en','Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_duration_info','en','If no value is entered, ILIAS tries do determine the play time automatically.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_last_submission','en','Last Submission','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_duration','en','Play Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_nr_items','en','Number of Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_visibility_info','en','Public items can be accessed via RSS without any authentication.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_add_new_item','en','Add New Mediacast Item','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_notes','en','Enable Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_bookmarks','en','Enable Bookmarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_osi_host_info','en','Instant Messenger Online Status Indicator Host (optional). See:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_osi_host','en','OSI Host','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_time_before_removal_info','en','After this time of inactivity, users are removed from the list of \"Active Users\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_time_before_removal','en','Maximum Inactivity Time (Minutes)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_active_users','en','Enable Active Users Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_settings','en','Personal Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_block_moving','en','Enable Block Moving','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_block_moving_info','en','Allow users to reorganize the content blocks on the personal desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','move_blocks','en','Move Blocks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','stop_moving_blocks','en','Stop Moving Blocks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_pdts','en','Personal Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_pdts_desc','en','Configure the Personal Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_add','en','Add Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_new','en','New Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_mcst','en','Mediacasts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_mcst','en','Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst','en','Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_search_results','en','Search Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_search','en','Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_page','en','Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_wiki_search','en','Wiki Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_media_list','en','Media List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_popular_pages','en','Popular Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_new_pages','en','New Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_all_pages','en','All Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_random_page','en','Random Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_print_view','en','Print View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_what_links_here','en','What Links Here?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_recent_changes','en','Recent Changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_quick_navigation','en','Wiki Quick Navigation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_history','en','History','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_page_hits','en','Page Hits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_no_start_page','en','Wiki is missing a valid starting page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_last_changed','en','Last Change','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_page_deleted','en','Wiki page deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_created_by','en','Created By','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_number_users_notes_or_comments','en','Number of users that attached notes or comments to this page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_other_pages_linking','en','Other Pages Linking to This Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_discussion','en','Discussion','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_edit','en','Edit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_last_changed_by','en','Last Changed By','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_article','en','Article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_pages','en','Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_orphaned_pages','en','Orphaned Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_short_title_desc2','en','This title will be used in links to the wiki. Once choosen you should not change this title, since users may loose their bookmarks.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_short_title','en','Short Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_main_page','en','Main Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_start_page_title','en','Start Page Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_start_page','en','Start Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_what_links_to_page','en','What links to page \"%s\"?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_activate_rating','en','Activate Rating','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_settings','en','Wiki Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_failed','en','Failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_mark','en','Mark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_notgraded','en','Not Graded','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_grading','en','Grading','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_contributor','en','Contributor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_page_changes','en','Page Changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_introduction','en','Introduction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_short_title_already_in_use','en','This title is already used by another wiki. Please select a different title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_msg_short_name_regexp','en','Short title must not start with a number and must not contain the following characters:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_feedback_from_tutor','en','Feedback from Tutor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_last_visited_page','en','Last Visited Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_wiki_page','en','Wiki Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_contributors','en','Contributors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('wiki','wiki_page_deletion_confirmation','en','Do you really want to delete this wiki page?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_new','en','New Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_add','en','Add Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_wiki','en','Wikis','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_lres','en','Learning Resources','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_create_write','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_wiki','en','Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_create_write','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_create_write','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_write','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_visible','en','Wiki is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_copy','en','Copy Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_delete','en','Delete Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_read','en','Read Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_write','en','Change Wiki Settings, Grade Learners','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki_edit_content','en','Edit Wiki Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat','en','Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wiki','en','Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cant_deactivate_if_users_assigned','en','You cannot deactivate a style if there are still users assigned to it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cannot_unzip_file','en','Cannot unpack file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cannot_uninstall_systemlanguage','en','You cannot uninstall the system language!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cannot_uninstall_language_in_use','en','You cannot uninstall the language currently in use!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cancel','en','Cancel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cannot_find_xml','en','Cannot find any XML-file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bytes','en','Bytes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','calendar','en','Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','by_location','en','Order by location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','by_type','en','Order by type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','by','en','By','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','btn_undelete','en','Undelete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bookmark_new','en','New Bookmark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bookmark_target','en','Target','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bookmarks','en','Bookmarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bookmarks_of','en','Bookmarks of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bottom_frame','en','Main Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','btn_add','en','Add','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','btn_new_value','en','New value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','btn_next','en','Continue','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','btn_previous','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','btn_remove_system','en','Remove from System','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bookmark_folder_new','en','New Bookmark Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bookmark_folder_edit','en','Edit Bookmark Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bookmark_edit','en','Edit Bookmark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bmf','en','Bookmark Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bm','en','Bookmark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bkm_sendmail','en','Send as attachment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bkm_import','en','Import bookmarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bkm_import_ok','en','Successfully imported %d bookmarks and %d bookmark folders.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','big_icon','en','Big Icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bib_data','en','Bibliographical Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','benchmarks','en','Benchmarks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','benchmark_settings','en','Benchmark Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','basic_settings','en','Basic Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','benchmark','en','Benchmark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','basedn','en','BaseDN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','basic_data','en','Basic Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','back_to_grp_content','en','Back to Group Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','back_to_fold_content','en','Back to Folder Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','back_to_crs_content','en','Back to Course Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','back','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','average_time','en','Average time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','available_languages','en','Available Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','available','en','Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auto_registration','en','Automatically approve registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','authors','en','Authors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','author','en','Author','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','authentication_settings','en','Authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_write','en','Edit authentication settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_visible','en','Authentication settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_user_default_role','en','Default Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_user_default_role_desc','en','This role is assigned to automatically created SOAP users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_user_default_role','en','Default role assigned to SOAP authenticated users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_use_https','en','Use HTTPS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_use_dotnet','en','Use .NET SOAP Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_uri_desc','en','Local URI, e.g. dir/server.php if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_settings_saved','en','SOAP authentication settings saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_server_desc','en','E.g. auth.yourserver.com if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_port_desc','en','E.g. 8080 if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_namespace','en','Namespace','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_namespace_desc','en','As defined in WSDL. Must be specified, if .NET SOAP style is used.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_create_users_desc','en','Creates automatically an ILIAS user account, for users that successfully authenticated against SOAP, without having an ILIAS account yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_auth_desc','en','This settings deal only with SOAP based user authentication, not with the ILIAS SOAP interface.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_auth','en','Configure SOAP Authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap_allow_local_desc','en','This allows SOAP users to authenticate with their local ILIAS username and a local password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_soap','en','SOAP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_shibboleth','en','Shibboleth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_shib_not_configured','en','Shibboleth is not configured yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_shib_desc','en','Authenticate users via Shibboleth, can be used as second authentication method','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_shib','en','Shibboleth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_select','en','Select authentication mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_script','en','Custom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_script_desc','en','Authenticate users via external script','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_role_auth_mode','en','Authentication mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_remark_non_local_auth','en','When selecting another authentication mode than ILIAS database, you may not change user\'s login name and password anymore.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_read','en','Access authentication settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_shared_secret','en','Shared secret','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_settings_saved','en','RADIUS settings saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_server_desc','en','You may add multiple servers with commas separated. Servers are rotated in Round robin fashion when queried.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_server','en','Servers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_not_configured','en','RADIUS is not configured yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_port','en','Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_enable','en','Enable RADIUS support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_desc','en','Authenticate users via RADIUS server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius_configure','en','Configure RADIUS-Authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_radius','en','RADIUS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_per_default','en','Per Default','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_new_account_mail_desc','en','Send new account e-mail to user, if user is generated automatically. A password will only be generated, if \"Allow Local Authentication\" is also activated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_mode_roles_changed','en','Changed authentication mode for this Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_mode_not_changed','en','(Nothing changed)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_mode','en','Authentication mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_login_instructions','en','Instructions shown on login page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_local','en','ILIAS database','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_local_desc','en','Authenticate users via local ILIAS database (default)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_settings_saved','en','LDAP settings saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_not_configured','en','LDAP is not configured yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_enable','en','Enable LDAP support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_ldap_desc','en','Authenticate users via LDAP server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_ldap','en','LDAP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_default_mode_changed_to','en','Default authentication mode changed to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_default','en','Default setting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_create_users','en','Create non-existing users automatically','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_configure','en','configure...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_user_default_role_desc','en','This role is assigned to automatically created CAS users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_server_desc','en','E.g. auth.yourserver.com if the full CAS server URI is https://auth.yourserver.com:443/cas/','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_settings_saved','en','CAS settings saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_uri_desc','en','Local URI, e.g. cas if the full CAS server URI is https://auth.yourserver.com:443/cas/','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_auth_desc','en','CAS requires PHP 4.3.1 or higher with CURL support (7.5 or higher)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_create_users_desc','en','Creates automatically an ILIAS user account, for users that successfully authenticated against CAS, without having an ILIAS account yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_port_desc','en','E.g. 443 if the full CAS server URI is https://auth.yourserver.com:443/cas/','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_auth','en','Configure CAS Authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas','en','CAS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_cas_allow_local_desc','en','This allows CAS users to authenticate with their local ILIAS username and a local password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_active_roles','en','Global roles available on registration form','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_allow_local','en','Allow Local Authentication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','attachments','en','Attachments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','attend','en','Attend','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','at_least_one_style','en','At least one style must remain activated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','at_location','en','at location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','attachment','en','Attachment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assf_visible','en','Test&Assessment administration is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assf_write','en','Edit Test&Assessment administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assf_questiontypes','en','Question Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assf_allowed_questiontypes','en','Available Question Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assf_allowed_questiontypes_desc','en','All the checked question types will be available in this ILIAS installation. If you don\'t want to allow the creation of a certain question type in this installation, you must remove the selection in the associated check box.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assign','en','Assign','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assign_global_role','en','Assign to Global Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assign_lo_forum','en','Assign LO Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assign_local_role','en','Assign to Local Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assign_user_to_role','en','Assign User to Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assigned_roles','en','Assigned Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assigned_users','en','Assigned Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','associated_user','en','associated User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','associated_users','en','associated Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assf_read','en','Access Test&Assessment Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_delete_no_selection','en','Please select at least one test to delete the Log Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assf_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_deleted','en','The Log Data for the selected tests has been deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_count_datasets','en','Log Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_path','en','Test Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_available_tests','en','Available Tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_delete_entries','en','Delete Log Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_output','en','Log Data Output','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ass_log_admin','en','Log Data Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_open_calendar','en','Click here to open a calendar for date selection (JavaScript required!)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_question','en','Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_select_test','en','--- Please select a test ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_text','en','Log message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_user_answer','en','User answered a question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_user_answers','en','Show user actions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_settings','en','Global Test & Assessment settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_settings_reporting_language','en','Reporting language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_defaults','en','Default settings for Test & Assessment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_use_javascript','en','JavaScript for Drag & Drop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_use_javascript_desc','en','Activates JavaScript output for drag&drop actions by default for the first time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_no_log','en','It is no log data available for the selected test and the selected time period!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_log_entries','en','log entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_for_test','en','For test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_datetime','en','Date/Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log','en','Create an Test&Assessment log for a specific time period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_manual_scoring_desc','en','If the Manual Scoring is activated for a question type, all questions of this question type could be manually scored by a test author. Please be careful with these settings, because late manual scoring of automatically scored question types could cause even judical problems!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_manual_scoring','en','Manual Scoring','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_manual_scoring_activate','en','Activate Manual Scoring for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_logging','en','Logging','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_imap_line_color','en','Imagemap Line Color','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assessment_log_deleted','en','The Test & Assessment log data has been deleted in the administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ascending_order','en','Ascending order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','articels_unread','en','Unread articels','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','as_of','en','as of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','archive','en','Archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','are_you_sure','en','Are you sure?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','arrow_downright','en','Arrow from top to down right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','approve_recipient','en','Login ID of Approver','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','approve_date','en','Approved on','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','appointment_list','en','Appointment List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','deactivate','en','Set Inactive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','appointment','en','Appointment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','activate','en','Set Active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reset_filter','en','Reset filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','apply_filter','en','Apply filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','apply','en','Apply','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','application_date','en','Application Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','applied_users','en','Applied users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','application_completed','en','Application is complete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','append_search','en','Append search results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','any_language','en','Any language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','answers','en','Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','anonymous','en','Anonymous','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','already_delivered_files','en','Submitted Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','and','en','and','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','announce','en','Announce','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','announce_changes','en','Announce Changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_write','en','Edit AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_leave','en','Unsubscribe from AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_read','en','Read access to AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_visible','en','AICC Learning Module is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_join','en','Subscribe to AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_delete','en','Delete AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm','en','Learning Module AICC','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_added','en','AICC Learning Module added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','alm_create','en','Create AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','allow_register','en','Available in registration form for new users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','allow_assign_users','en','Allow user assignment for local administrators.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_users','en','All Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_tsts','en','All tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_topics','en','All Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_roles','en','All Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_objects','en','All Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_local_roles','en','Local roles (all)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_lms','en','All learning modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_authors','en','All authors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_global_roles','en','Global roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','agree_date','en','Agreed on','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_write','en','Advanced Editing Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_visible','en','Advanced Editing Administration is Visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_read','en','Access Advanced Editing Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_survey_settings','en','Survey Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_lm_settings','en','LM / Glossary Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_general_settings','en','General Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_edit_permission','en','Change Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_cat_settings','en','Category Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adve_assessment_settings','en','Test & Assessment Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_tinymce','en','TinyMCE Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_survey_settings','en','Allowed HTML Tags for the ILIAS survey tool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_settings','en','Advanced Editing Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_no_rte','en','Do not use rich text editing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_lm_settings','en','Learning Module and Glossary Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_lm_js_editing_desc','en','Enables HTMLArea and JavaScript support for page editing in learning modules and glossaries.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_lm_js_editing','en','Enable HTMLArea for Content Editing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_cat_page_editing_desc','en','This enables the content editing of category pages. When deactivated, the categories are just displayed as a set of item lists.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_cat_page_editing','en','Enable Content Editing for Category Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_assessment_settings','en','Allowed HTML Tags for the ILIAS Test&Assessment tool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_allow_javascript_editor','en','Enable a Rich Text Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','advanced_editing_allow_html_tags','en','Allow the selected HTML tags for text editing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adopt','en','Adopt','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','administrator','en','Administrator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','administration','en','Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','administrate_users','en','Local user administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','administrate','en','Administrate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','all_commands','en','All Commands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','basic_commands','en','Basic Commands','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','admin_panel','en','Administration Panel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adm_write','en','Edit Basic system settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adm_visible','en','System settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adm_read','en','Read access to System settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adm_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adm_create_tax','en','Create taxonomy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','additional_info','en','Additional Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','added_new_condition','en','Created new condition.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_user_defined_field','en','Add New Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_user','en','Add local user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_translation','en','Add translation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_note','en','Add Note','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_new_user_defined_text_field','en','Add New Text Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_new_user_defined_select_field','en','Add New Select Box','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_new_user_defined_field','en','Add New User-defined Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_members','en','Add Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_member','en','Add Member','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_condition','en','Create New Association','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_comments','en','Edit comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add_author','en','Add Author','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','add','en','Add','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','active_roles','en','Active Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','active','en','Active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','activation','en','Edit Timings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','activate_tracking','en','Activation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','activate_https','en','HTTPS handling by ILIAS<br>(Payment, Login)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','actions','en','Actions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','activate_assessment_logging','en','Activate Test&Assessment logging','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','action','en','Action','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','action_aborted','en','Action aborted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','account_expires_subject','en','[ILIAS 3] Your account expires','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access','en','Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','account_expires_body','en','Your account is limited, it will expire at:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','accept_usr_agreement','en','Accept user agreement?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','absolute_path','en','Absolute Path','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','HH','en','HH:MM','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','DD.MM.YYYY','en','DD.MM.YYYY','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','3rd_party_software','en','3rd party software','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','hide_own_online_status','en','Hide My Online Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_password_not_allowed_for_auth','en','It is not possible to change the password for the chosen authentication method.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_password_required_for_auth','en','Password is required for the chosen authentication method.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_retype_password','en','Retype Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_seconds','en','Seconds','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_virus_found','en','Virus found in uploaded file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_days','en','Days','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_hours','en','Hours','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_minutes','en','Minutes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_wrong_file_type','en','Wrong file type.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_upload_stopped_ext','en','File upload stopped by extension.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_cannot_write_to_disk','en','Cannot write to disk.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_missing_tmp_dir','en','Temporary directory for file upload missing.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_no_upload','en','This input is required. Please select a file for upload.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_partially_uploaded','en','The file could not be uploaded completely.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_file_size_exceeds','en','The uploaded file exceeds the max. allowed file size.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_numeric_value_required','en','Please enter a numeric value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_value_too_low','en','Value too low. Please enter a higher value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_msg_value_too_high','en','Value too high. Please enter a lower value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_format','en','Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_max_value','en','Maximum Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_min_value','en','Minimum Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_hierarchy_drag_drop_help','en','Drag and drop icons on placeholders to move elements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_hierarchy_add_elements','en','Click on placeholders to add new elements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_double_click_to_delete','en','Double-click on content elements to select them for (de-)activation or deletion.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_drag_and_drop_elements','en','Drag and drop content elements on placeholders to move elements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_wiki_page_link','en','Wiki Page Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_numbered_list','en','Numbered List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_bullet_list','en','Bullet List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_add_elements','en','Click on placeholders to add new elements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_syntax_help','en','Syntax Help','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','my_chats','en','My Chats','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chats','en','Chats','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_yellow','en','yellow','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_name','en','Username','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_whisper','en','Whisper','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_invited','en','Invited user to chat.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_already_blocked','en','The access for the selected user is already blocked.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_blocked','en','Blocked access for the selected user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_dropped','en','User kicked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_title_missing','en','Please insert a name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_to_chat_body','en','To the chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_type','en','Font face','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_unblocked_user','en','The selected user have been unlocked.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_underlined','en','Underlined','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_unkick_user_session','en','Unkick user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_times','en','Times','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_teal','en','teal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_status_saved','en','The status has been changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_stop_recording','en','Stop recording','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_tahoma','en','Tahoma','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_settings_saved','en','Settings saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_show_details','en','Show details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_silver','en','silver','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_start_recording','en','Start recording','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_settings','en','Chat server settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_port','en','Server Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_loglevel','en','Log level','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_not_active','en','The chat server is not active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_logfile','en','Log file path','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_internal_ip','en','Server internal IP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_external_ip','en','Server Address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_allowed','en','Allowed hosts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_allowed_b','en','(e.g. 192.168.1.1,192.168.1.2)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_select_one_room','en','Please select one chat room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_rooms_deleted','en','Chat room(s) deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_rooms','en','Chat Rooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_room_select','en','Private chat room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_room_renamed','en','Chat room renamed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_room_added','en','Added new chat room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_room_name','en','Name of chat room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_refreshed','en','Deleted all messages of the selected chatrooms.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_red','en','red','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_refresh','en','Refresh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings_select_one','en','Please choose recordings you would like to delete.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings_deleted','en','Recordings were deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings_delete_sure','en','Deleting records - are you sure?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recordings','en','Recordings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_time_frame','en','Time frame','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_title','en','Title of recording','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_stopped','en','Recording stopped','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_running','en','Recording running','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_started','en','Recording started','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_not_found','en','Could not find recording.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_moderator','en','Moderator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_action','en','Action','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_recording_description','en','Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_purple','en','purple','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_public_room','en','Public chat room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_profile','en','Profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_private_message','en','Private Message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_online_users','en','Further users (online)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_olive','en','olive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_users_selected','en','You have to select one user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_write_perm','en','No permission to write','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_rename_public','en','The public room cannot be renamed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_recordings_available','en','No recordings are available at the moment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_refresh_public','en','The public chat room cannot be refreshed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_delete_public','en','The public chat room cannot be deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_connection','en','Cannot contact chat server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_maroon','en','maroon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_messages_deleted','en','Messages have been deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_moderator_password','en','Moderator password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_navy','en','navy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_new_message','en','New message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_active_users','en','No further users present.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_blocked','en','No blocked users available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_level_info','en','Info','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_lime','en','lime','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_level_all','en','All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_level_debug','en','Debug','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_level_error','en','Error','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_level_fatal','en','Fatal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_kicked_from_room','en','You have been kicked from this chatroom, you cannot write messages.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_kick_user_session','en','Kick user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_italic','en','Italic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_invite_user','en','Invite user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_invited_by','en','Invited by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_invitation_subject','en','Chat invitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_invitation_body','en','Invitation to chat from:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_insert_message','en','Please insert a message','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_input','en','Input','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_inactive','en','Inactive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_ilias','en','ILIAS Chat module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_html_export','en','HTML export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_hide_details','en','Hide details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_green','en','green','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_gray','en','gray','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_fuchsia','en','fuchsia','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_face','en','Font type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_enter_valid_username','en','Please enter a valid username.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_empty','en','Empty','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_edit','en','Edit chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_drop_user','en','User kicked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_delete_sure','en','Are you sure, you want to delete this chat room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_color','en','Font color','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_chatrooms','en','Chat Rooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_chatroom_rename','en','Edit chat room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_chatroom_body','en','Chat room:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_bold','en','Bold','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_blue','en','blue','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_blocked_unlocked','en','Unlock','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_blocked_users','en','Blocked users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_blocked','en','Restricted access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_block_user','en','Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_aqua','en','aqua','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_arial','en','Arial','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_black','en','black','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_address','en','Address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_address_user','en','Address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_add_private_chatroom','en','Add private chatroom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_add_moderator_password','en','Please add a moderator password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_add_port','en','Please add the server port.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_add_internal_ip','en','Please add the server\'s internal IP.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_add_external_ip','en','Please add the server\'s external IP.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_active_users','en','Further users (present)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_add_allowed_hosts','en','Please add the address of the host(s) which are allowed to access the chat server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_active','en','Active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','cancel_whisper','en','Cancel whisper','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_access_blocked','en','You are excluded from these chatrooms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_year','en','Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','cancel_talk','en','Cancel address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_url','en','URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_where_published','en','Where published','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_type','en','Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_unpublished','en','Unpublished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_technical_report','en','Technical report','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series_volume','en','Volume','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series_editor','en','Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series_title','en','Series title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_series','en','Series','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_save','en','Save','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_school','en','School','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_proceedings','en','Proceedings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_publisher','en','Publisher','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_print','en','Print','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_please_select','en','Please select','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_phd_thesis','en','PhD thesis','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_pages','en','Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_number','en','Number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_organization','en','Organization','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_not_found','en','No bibliographical information available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_note','en','Note','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_newspaper_article','en','Newspaper article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_new_element','en','New element','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_month','en','Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_middle_name','en','Middle name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_master_thesis','en','Master thesis','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_last_name','en','Last name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_manual','en','Manual','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_language','en','Language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_label','en','Label','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_journal_article','en','Journal article','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_keyword','en','Keyword','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_isbn','en','ISBN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_issn','en','ISSN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_journal','en','Journal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_institution','en','Institution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_internet','en','Internet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_inproceedings','en','In proceedings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_inbook','en','In book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_how_published','en','How published','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_identifier','en','Identifier','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_grey_literature','en','Grey literature','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_first_name','en','First name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_editor','en','Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_entry','en','Entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_edition','en','Edition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_dissertation','en','Dissertation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_delete','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_cross_reference','en','Cross reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_choose_index','en','Please select a bibliographical information:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_booktitle','en','Book title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_catalog','en','Catalog','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_bibitem','en','Bibliographical information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_book','en','Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_author','en','Author','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_av','en','AV','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','worst','en','Worst','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','year','en','Year','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('bibitem','bibitem_add','en','Add','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','weeks','en','Weeks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','votes','en','Votes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','vote','en','Vote','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','user','en','User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','until','en','Until','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','time','en','Running','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','type','en','Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','text_answer','en','Text answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','text','en','Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','table','en','Table','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','statistics','en','Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','skip','en','Skip','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','save_vote','en','Submit vote','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','save','en','Save','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','required','en','Required','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','pie','en','Pie','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','repeat','en','Repeat Every','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','optional','en','Optional','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','options','en','Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','note','en','Comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','new_vote','en','New vote','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','months','en','Months','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','month','en','Month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','login','en','Login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','missing_fields','en','Please fill in all required information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','hours','en','Hours','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','lines','en','Lines','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','from','en','From','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','feedb_time','en','Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','first_vote','en','1. Vote is the','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','feedb_feedback_settings','en','Feedback Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','feedb_feedback_list','en','Feedback List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','feedb_edit_feedback','en','Edit Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','every','en','every','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','edit_barometer','en','Edit feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','edit','en','Edit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','duration','en','Duration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','delete','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','days','en','Days','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','day','en','Day','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','bar_create','en','Create New Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','chart_votes','en','Chart votes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','chart_users','en','Chart user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','chart_type','en','Chart type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','best','en','Best','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','change_course','en','Change Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','anonymous','en','Anonymous','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','barometer_title','en','Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','working_time_avg','en','Avg. Working Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','you_received_a_of_b_points','en','You received %d of %d possible points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','working_time','en','Working Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','worked_through','en','Answered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','with_order','en','with order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','warning_test_not_complete','en','The test is not complete!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','when','en','when','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','width','en','Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','value_between_x_and_y','en','The value should be between %s and %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','warning_question_not_complete','en','The question is not complete!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','user_not_invited','en','You are not supposed to take this test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','user_wrong_clientip','en','You don\'t have the right ip using this test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','uploaded_material','en','Uploaded Material','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','upload_image','en','Upload Image','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','upload_imagemap','en','Upload an Image Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','unlock_question','en','This question is in use of at least one test and there are %s submitted results. If you choose to unlock the question the complete test results of the affected users will be deleted after saving this question. If you want to use a changed version of this question but you do not want to delete the users test results, you can duplicate the question in the question pool and change that version.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','unlock','en','Unlock','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','unlimited','en','unlimited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tt_varying_randomtest','en','Varying Random Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tt_self_assessment','en','Self Assessment Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tt_online_exam','en','Online Exam','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tt_assessment','en','Assessment Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_your_answers','en','These are your answers given to the following questions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_types','en','Test Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_use_javascript','en','Use Javascript for drag and drop actions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_your_answer_was','en','Your answer was','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_type_comment','en','Warning: Changing the test type of a running test will delete all previous processed tests!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_type_changed','en','You have changed the test type. All previous processed tests have been deleted!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_tst_date','en','Date of Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_type','en','Test Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_total_questions','en','Total Amount of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_total_questions_description','en','If you set this value, the amount of questions entered with the question pools are ignored. If you don\'t set this value, you need to enter an amount with every selected question pool!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_text_count_system','en','Scoring System','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_time_already_spent','en','You started the test at %s. Your maximum processing time is %s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_time_already_spent_left','en','You have %s left.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_submit_results','en','Yes, I do confirm the submission.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_test_output','en','Test Output','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_submit_answers_txt','en','You now may finish the test by submitting your answers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_submit_answers','en','Yes, I want to submit my answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_progress','en','In progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_ok','en','The status of the test is OK. There are no missing elements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_not_entered','en','Not started','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_missing','en','There are required elements missing in this test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_missing_elements','en','The following elements are missing:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_completed_more_tries_possible','en','Completed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_status_completed','en','completed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_selected_users','en','Selected Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_users_intro','en','Show Statistical Evaluation for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_timeofwork','en','Time of Work','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_total_participants','en','Total Number of Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_specification','en','Available Evaluation Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_resultspoints','en','Test Results in Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_resultsmarks','en','Test Results in Marks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_rank_participant','en','Rank of Participant','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_qmax','en','Total number of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_rank_median','en','Rank of Median','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_qworkedthrough','en','Questions already worked through','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_pworkedthrough','en','Percent of total workload already worked through','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_median','en','Median of Test Result in Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_mark_median','en','Mark of Median','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_lastvisit','en','Last Visit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_firstvisit','en','First Visit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_distancequintile','en','Distance to Arithmetic Quintile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_distancemedian','en','Distance to Median','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_distancemean','en','Distance to Arithmetic Mean','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_result_atimeofwork','en','Average Time of Work','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_choose_users','en','(select one or more users from the user list)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_stat_all_users','en','All Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_starting_time','en','Starting Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_start_test','en','Start the Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_started','en','Test Started','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_start_new_test_pass','en','Start New Test Pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_signature','en','Signature','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_shuffle_questions_description','en','Shuffle the sequence of questions for every test pass.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_shuffle_questions','en','Shuffle Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_summary_description','en','Offers a list with all test questions available for the test participants during the test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_summary','en','Show List of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_presentation_description','en','If \"Show Pass Details for running tests\" is selected, the question titles and the reached points for every question in the test pass are available if the test is not finished. If \"Show Solutions in Test Results\" is selected, the detailed question solution is available for participants in the test results presentation. This includes the exact scoring of every answer, otherwise only an overview with the question titles and the reached points is shown. If the list of answers is selected, an overview of all questions with the answers of the participant is generated. This list will be offered on the Info Page and at the end of a test prior to the final submission. If \"Show Answer-Specific Feedback in Test Results\" is selected, the answer specific feedback will be shown in the test results next to the questions. If \"Results print view (answers only)\" is selected, the ILIAS content you place around a question using the \"Edit content\" tab page will not be visible in a print-out. If you want to save some paper space, select this option. If \"Show Signature Placeholder\" is selected, a signature placeholder will be shown for printout.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_feedback','en','Show Answer-Specific Feedback in Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_printview','en','Show List of Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_answers_only','en','Results print view (answers only)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_signature','en','Show Signature Placeholder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_solution_details','en','Show Solutions in Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_pass_details','en','Show Pass Details for running tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_results','en','Show Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_dont_use_previous_answers','en','Your previous answers will not be used as default values in future test passes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_use_previous_answers_user','en','Use my previous answers as default values in future test passes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_use_previous_answers_description','en','If checked, a participant may choose to use the previous answers as default values in future test passes, otherwise the previous answers are not shown in future test passes.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_use_previous_answers','en','Use Previous Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_title_output_description','en','Select one of the above options for the presentation of the question titles and the available points during the test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_title_output_no_title','en','Don\'t show the Question Titles and the Available Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_title_output_hide_points','en','Show only Question Titles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_title_output_full','en','Show Question Titles and Available Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_title_output','en','Question Title Output','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_cancel_description','en','If checked, a button to suspend the test is shown during test execution.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_answer_sheet','en','Show Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_show_cancel','en','Show Suspend Test Option','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_list_of_answers_show','en','Show List of Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_session_settings','en','Session Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_set_feedback_done','en','The Manual Feedback has been saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_set_feedback_not_done','en','An Error occured! The Manual Feedback has not been saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence_properties','en','Sequence Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence_postpone','en','Questions may be postponed to the end of a test pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence_fixed','en','The Sequence of Questions is Fixed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_sequence','en','Sequence','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_selected_user_data_deleted','en','The test data of the selected user(s) was deleted successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_tsts','en','Please select a test for duplication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_random_questions','en','Select the question pool(s) and the amount of questions for the random test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_questionpools','en','Please select a question pool to store the imported questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_questionpool','en','Please select a question pool to store the created question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_file_for_import','en','You must select a file for import!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_select_qpls','en','Please select a question pool for duplication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_type','en','Score Reporting Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_reporting_date','en','Score Reporting Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_reporting','en','Score Reporting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_mcmr_zero_points_when_unanswered','en','Score 0 Points for Unchecked Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_mcmr_questions_description','en','If \"Score 0 Points for Unchecked Answers\" is selected, multiple choice questions without a selected check box will be scored with zero points, otherwise every check box will be scored dependent to the predefined points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_mcmr_use_scoring_system','en','Use the Defined Score','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_mcmr_questions','en','Multiple Choice Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_cutting','en','Cut off Negative Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_cutting_description','en','If Negative Question Points are cut off, the results for each question that a participant answers with a result of less than zero points will be set to zero points. If Negative Test Points are cut off, the results for the test will be set to zero points, if the sum of all question results is less than zero points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_cut_test','en','Cut off Negative Test Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_score_cut_question','en','Cut off Negative Question Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_resume_test','en','Resume the Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_presentation','en','Test Results Presentation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_overview','en','Pass Overview of the Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_overview_pass','en','Results Overview for Pass %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_back_overview','en','Back to Results Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_back_evaluation','en','Back to Evaluation Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_back_introduction','en','Back to Introduction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_aggregated','en','Aggregated Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_access_always','en','Always','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_access_description','en','This setting handles the access of the participants to their test results. If results can be accessed after the test is finished, the participants can access their test results after they finished a test pass for the first time. Even if a test has more than one allowed test pass, the participants can access their test results after finishing the first pass. If you choose a date access restriction, the participants will not be able to access their test results until the specified date and time is reached. You must choose this option if you want to use the ECTS scoring system of if you have to score questions manually. If \"Always\" is selected, the participants can access their test results at any time even if the did not finish the test yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_access_date','en','Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_access_finished','en','After Test is Finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results','en','Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_results_access','en','Access to Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_result_user_name','en','Test Results for %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_result_user_name_pass','en','Results of Test Pass %s for %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_reset_processing_time_desc','en','If checked, the maximum processing time will be reset back to the defined maximum processing time after a test pass has been finished. This setting only works with an enabled maximum processing time and multiple test passes.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_reset_processing_time','en','Reset the maximum processing time for every test pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_report_after_date','en','After a fixed score reporting date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_report_after_first_question','en','Offer test results when the test has been started','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_report_after_question','en','Allow instant verification of answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_report_after_test','en','Offer test results when the test is finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_remove_questions_and_results','en','This test was already executed by %s user(s). Removing questions from this test will remove all test results of these users. Are you sure you want to remove the following question(s) from the test?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_remove_questions','en','Are you sure you want to remove the following question(s) from the test?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_reached_points','en','Reached Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_test','en','Random Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_test_description','en','If checked, the questions of the test will be chosen randomly from question pools. ILIAS generates a new random selection for every test pass.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_selection_question_total_count_too_high','en','The question count you entered was higher than the maximum number of available questions for all selected question pools. The question count has been reduced automatically.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_selection_question_count_too_high','en','The question count you entered was higher than the maximum number of available questions. The question count has been reduced automatically.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_selection','en','Random Selection of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_select_questionpool','en','Select the question pool to choose the questions from','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_questionpools','en','Source Question Pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_qpl_unselected','en','There is at least one unselected question pool! You don\'t need to add a new question pool.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_questions_removed','en','Question(s) removed!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_random_nr_of_questions','en','How many questions?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_type','en','Question Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_questions_inserted','en','Question(s) inserted!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_unmark','en','Remove the mark for this question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_marker','en','Marker','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_marked','en','You marked the question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_mark','en','Mark this question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_selection_equal','en','Use question pools with equal maximum points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_selection_description','en','If you only use question pools which contain questions with an equal maximum number of available points, the test will have an equal number of maximum points for all participating users and thus the test results will be better comparable. It is recommended to choose this selection mode.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_selection','en','Question Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_offer','en','Do you accept this sample or do you want another one?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_question_no','en','Order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_summary_text','en','Here you can see all questions. Use the bulbs to mark a question as solved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_setsolved','en','Set Solved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_result_sheet','en','Show Result Sheet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_resetsolved','en','Set Unsolved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_qst_order','en','Order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_properties','en','Test Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_processing_time_desc','en','The maximum processing time starts from the time when a user starts a test for the first time and ends after the expiration of the entered hours, minutes and seconds.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_processing_time','en','Max. Processing Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_print_date','en','Date of Print','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_print','en','Test & Assessment Print View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_postpone_description','en','The participants may postpone questions to the end of the test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_postpone','en','Postpone Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_position','en','Question %s of %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_percent_solved','en','Percent Solved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_password_introduction','en','This test can only be accessed with a test password. Please enter the test password to start the test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_password_entered_wrong_password','en','You cannot start the test because you entered the wrong test password!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_password_details','en','If you define a test password, all users with test access must enter this password to start the test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_password','en','Test Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_passes','en','Test Passes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_scoring','en','Multiple Pass Scoring','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_scoring_description','en','If the last pass is scored, the last test pass of a participant will be used to calculate the test results. If the best pass is scored, the test pass with the highest number of reached points will be chosen a test result. This setting only has effect, if more than one test pass is allowed for a test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_last_pass','en','Score the Last Pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_details','en','Pass Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_pass_best_pass','en','Score the Best Pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_fixed_participating_users','en','Fixed Participants in this Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_participating_users','en','Participating Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_nr_of_tries_of_user','en','Passes Already Completed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_nr_of_tries','en','Max. Number of Passes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_nr_of_passes','en','Number of Test Passes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_tries','en','none','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_taken_tests','en','There are no taken tests!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_solution_available','en','Short answer questions don\'t have a specified solution.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_questions_for_random_test','en','You have taken no questions from the questionspools for this random test! Please take at least one question by setting the amount of questions for an added question pool.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_questions_available','en','There are no questions available! You need to create new questions or browse for questions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_questionpools_for_random_test','en','You have not added a question pool for this random test! Please select at least one question pool.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_question_selected_for_removal','en','Please check at least one question to remove it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_more_available_questionpools','en','There are no more question pools available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_marks_defined','en','There are no marks defined, please create at least a simple mark schema!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_evaluation_data','en','There is no evaluation data available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_no_export_randomtest','en','You cannot export a test with random selection of questions, because every used question pool has to be exported too which leads to enormous complexity of the export files.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_must_be_online_exam','en','This option is only available for online exams!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_title','en','You have not entered a test title! Please go to the metadata section and enter a title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_questions','en','You do not have any questions in the test! Please add at least one question into the test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_marks','en','You do not have a mark schema in the test! Please add at least a simple mark schema to the test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_maximum_points','en','Maximum Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_missing_author','en','You have not entered the authors name in the test properties! Please add an authors name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_max_allowed_users_message','en','The maximum number of simultaneous active users in the test has been reached. Please try again later to start or resume the test. If one of the active users is inactive for more than %s seconds, you may be able to enter this test. Thank you for your understanding.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_max_allowed_users_heading','en','The maximum number of simultaneous users in this test has been reached','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_max_allowed_users','en','Participants Restriction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_short_form','en','Short Form','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_official_form','en','Official Form','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_passed','en','Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_minimum_level','en','Minimum Level (in %)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_create_simple_mark_schema','en','Create Simple Mark Schema','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark_create_new_mark_step','en','Create New Mark Step','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_mark','en','Mark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_participants_no_fixed','en','There is nobody assigned as a fixed participant for this test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_participants_no','en','Nobody has started the test right now!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_list_of_questions_with_description','en','Show the question descriptions in the List of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_list_of_questions_end','en','Show the List of Questions before a participant finishes the test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_list_of_questions_start','en','Show the List of Questions prior to the first question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_list_of_questions_yes','en','Yes, and additional','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_list_of_answers','en','List of Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_invited_nobody','en','No users, groups or roles have been added as fixed test participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_invited_selected_roles','en','The selected roles have been added as fixed test participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_invited_selected_groups','en','The selected groups have been added as fixed test participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_invited_selected_users','en','The selected users have been added as fixed test participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_introduction','en','Introduction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_instant_verification','en','Instant Verification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_instant_feedback_description','en','If one of the options is selected, the instant feedback information will be shown directly after a participant answered a question. If answer-specific feedback is selected, the predefined feedback will be shown, depending on the answers of the participant. If results (in points) are selected, the reached points will be shown. If solutions are selected, the correct solution will be shown too.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_instant_feedback_solution','en','Show Solutions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_instant_feedback_results','en','Show Results (only points)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_instant_feedback_answer_specific','en','Show Answer-Specific Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_instant_feedback','en','Instant Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_insert_questions_and_results','en','This test was already executed by %s user(s). Inserting questions to this test will remove all test results of these users. Are you sure you want to insert the following question(s) to the test?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_insert_questions','en','Are you sure you want to insert the following question(s) to the test?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_insert_missing_question','en','Please select at least one question to insert it into the test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_in_use_edit_questions_disabled','en','The test is in use by %d user(s). You are not allowed to edit or move the questions in this test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_import_verify_found_questions','en','ILIAS found the following questions in the test import file. Please select the questions you want to import with this test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_import_no_items','en','Error: The import file contains no questions!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results_introduction','en','If you\'re processing more than one pass of this test, your previous entered results will not be used as default values','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results_hide','en','Hide my results from a previous test pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results_description','en','If checked, the previous results of a learner will not be used as default values in future test passes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_hide_previous_results','en','Hide Previous Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_heading_scoring','en','Scoring','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_generate_xls','en','Generate Excel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_general_properties','en','General Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_fixed_participants_disable_description','en','You are about to disable the support for fixed participants in this test. All fixed participants who did not start the test yet will be removed from the test. Are you sure you want to proceed?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_fixed_participants_disable','en','Confirm Status Change','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_fixed_participants_data_exists','en','There are already participants who ran the test. You are not allowed to change the fixed participants status!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_finished','en','Finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_finish_confirmation_question','en','You are going to finish this test and reach the maximum number of allowed test passes. You won\'t be able to enter this test again to change your answers. Do you really want to finish the test?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_finish_confirm_list_of_answers_button','en','No, go back to the List of Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_finish_confirm_cancel_button','en','No, go back to the previous question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_finish_confirm_button','en','Yes, I want to finish the test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_user_answer','en','User Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_persons','en','Total number of persons who started the test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_passed_average_time','en','Average Processing Time of all Passed Tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_passed_average_points','en','Average Points of Passed Tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_passed','en','Total Passed Tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_finished_average_time','en','Average Test Processing Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_total_finished','en','Total Finished Tests (users who submitted the test with the finish test button)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_show_answer','en','Show Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_results_by_pass','en','List of Answers for Pass %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_question_points','en','Question Results for Pass %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_eval_no_anonymous_aggregation','en','No one has entered the test yet. There are no anonymous aggregated test results available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_enter_questionpool','en','Please enter a question pool name where the new question will be stored','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_delete_missing_mark','en','Please select at least one mark step to delete it','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_delete_results','en','Reset Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_ending_time','en','Ending Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_delete_all_user_data','en','Delete all User Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_enter_name','en','Please enter a name for your test defaults!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_not_defined','en','You don\'t have any test defaults defined yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_dont_use','en','--- Use the ILIAS test defaults ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_available','en','Available test defaults','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_defaults_of_test','en','the settings of this test as','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_apply_select_one','en','Please select exact one test defaults entry to apply the defaults to this test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_apply_not_possible','en','ILIAS could not apply the selected test defaults to this test! Maybe this test already contains questions and/or participant datasets.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_defaults_applied','en','The selected test defaults have been applied.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_count_partial_solutions','en','Count Partial Solutions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_count_system_description','en','If partial solutions are counted, the points for a question are given dependent on the answers of a participant. If only complete solutions are counted, a participant must reach the maximum available points for a question, otherwise the resulting points are set to zero.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_count_correct_solutions','en','Count Only Complete Solutions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_submit_answers','en','Please confirm your submission of your solution. You won\'t be able to revert your answers after pressing the submit button.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_print','en','Press button to print all questions with points and solution. The question always appears at the end of a page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_delete_results_info','en','Your previous entered question results were deleted. You have successfully reset the test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_confirm_delete_results','en','You are about to delete all your previous entered question results of this test. This will reset all questions to its default values. Please note, that you cannot reset the number of passes, you already needed for this test. Do you really want to reset all your previous entered results?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_change_points_for_question','en','Change the Points for the Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_change_points_not_done','en','Could not change the Points of an answer! Please check the allowed range of available points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_change_points_done','en','The Points of an answer have been changed successfully!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_browse_for_questions','en','Browse for Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_best_solution_is','en','The best solution is','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_answered_questions','en','Answered Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_answer_sheet','en','Test Answer Sheet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_anonymity_description','en','If Anonymity is enabled, the names of the test participants are anonymized.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_anonymity','en','Anonymity','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_already_taken','en','Tests Already Taken','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_already_submitted','en','Test has already been finish and submitted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_allowed_users_time_gap','en','Idle Time for Active Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_allowed_users','en','Maximum Number of Users Running the Test Simultaneously','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_allow_instant_verification','en','Allow instant verification of answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_allow_fixed_participants','en','Allow fixed participants in this test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_all_user_data_deleted','en','All user data of this test has been deleted!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','true','en','True','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_access_code_created','en','To provide you with permanent access to your test results and to offer you a possibility to resume this test, a unique test access code was created. Please write down this code use it for further actions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','too_many_empty_parameters','en','Please fill out your empty applet parameters before you add a new parameter!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','time_format','en','HH MM SS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','text_rating','en','Text Matching Method','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','text_maximum_chars_allowed','en','Please do not enter more than a maximum of %s characters. Any characters above will be cut.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','text_gap','en','Text Gap','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','text_answers_saved','en','Essay points modified!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','test_reference','en','Test Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','test_cancelled','en','The test was cancelled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','term','en','Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','symbol','en','Symbol','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','suggested_solution_added_successfully','en','You successfully set a suggested solution!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','statistical_data','en','Statistical Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','statistics','en','Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','starting_time_not_reached','en','You have not reached the starting time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','start_tag','en','Start Tag','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','solution_order','en','Solution Order','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','solution_may_contain_keywords','en','The solution may contain one of the following keywords','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','solution_hint','en','Suggested Solution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','shuffle_answers','en','Shuffle Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','show_detailed_results','en','Show User\'s Detailed Results (Marked Pass)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','show_user_answers','en','Show User\'s Marked Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','show_pass_overview','en','Show Marked Pass Overview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','shape','en','Shape','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','set_filter','en','Set Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','set_manual_feedback','en','Set Manual Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','selected_image','en','Selected Image','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','set_edit_mode','en','Set Edit Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_tst_option','en','--- Please select a test ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_qpl_option','en','--- Please select a question pool ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_target_position_for_move_question','en','Please select a target position to move the question(s) and press one of the insert buttons!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_one_user','en','Please select at least one user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_one_submitted_test','en','Please select at least one user who finished the test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_max_one_item','en','Please select one item only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','numeric_gap','en','Numeric Gap','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','number_of_answers','en','Number of Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_gap','en','Select Gap','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','select_an_answer','en','--- Please select an answer ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','see_details_for_further_information','en','See details for suggested solutions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','search_term','en','Search Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','search_users','en','Search Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','search_roles','en','Search Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','search_results','en','Search Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','search_groups','en','Search Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','search_found_users','en','Found Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','search_found_groups','en','Found Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','scoring','en','Scoring and Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','scored_pass','en','Scored Pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_text_answer_points','en','Save Essay Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_previous','en','Previous','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_next','en','Next','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_introduction','en','Go to Introduction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_finish','en','Finish the Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','mark_tst_ects','en','Your ECTS grade is &quot;[markects]&quot;','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','mark_tst_passed','en','Congratulations, you passed the test.<br />Your resulting mark is: &quot;[mark]&quot;','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','mark_tst_failed','en','Sorry, you failed the test.<br />Your resulting mark is: &quot;[mark]&quot;','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_edit','en','Save and Edit Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_before_upload_javaapplet','en','You must apply your changes before you can upload a Java applet!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','save_before_upload_imagemap','en','You must apply your changes before you can upload an image map!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','result_unsuccessful_saved','en','There was an error saving the question results!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','result_successful_saved','en','Your results have been saved successful!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','result','en','Result','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','reset_terms','en','Reset Term Positions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','reset_filter','en','Reset Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','report_date_not_reached','en','You have not reached the reporting date. You will be able to view the test results at %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','remove_solution','en','Remove Suggested Solution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','remove_question','en','Remove','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','remove_as_participant','en','Remove as Fixed Participant','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','region','en','Region','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','rectangle_click_tl_corner','en','Please click on the top left corner of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','rectangle_click_br_corner','en','Please click on the bottom right corner of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','rectangle','en','Rectangle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','range_lower_limit','en','Lower Bound','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','range_upper_limit','en','Upper Bound','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','range','en','Range','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','random_selection','en','Random Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','random_another_sample','en','Get another Sample','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','random_accept_sample','en','Accept Sample','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','radio_unset','en','Unset','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','questions_from','en','questions from','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','radio_set','en','Set','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','questionpool_not_entered','en','Please enter a name for a question pool!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_type','en','Question Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_title','en','Question Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_summary','en','List of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_short','en','Q','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_saved_for_upload','en','The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_not_answered','en','The question was not answered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_marking_description','en','If checked, every participant gets the possibility to mark every question of a test with a marker symbol to indicate that something has to be done with a question (e.g. check again, answered, not answered etc.). The markers are also visible in the list of questions (if available).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_marking','en','Show Question Marking','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_instances_title','en','This question is used in the following tests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qt_multiple_choice','en','Multiple Choice Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','question_cumulated_statistics','en','Cumulated Question Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_select_file_for_import','en','You must select a file for import!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_questions_deleted','en','Question(s) deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_question_is_in_use','en','The question you are about to edit exists in %s test(s). If you change this question, you will NOT change the question(s) in the test(s), because the system creates a copy of a question when it is inserted in a test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_paste_success','en','The question(s) have been pasted into the question pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_paste_no_objects','en','There are no questions in the clipboard. Please copy or move a question into the clipboard.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_online_property','en','Online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_online_property_description','en','Only online question pools could be used in tests.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_move_select_none','en','Please check at least one question to select it for moving','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_move_insert_clipboard','en','The selected question(s) are marked for moving','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_verify_found_questions','en','ILIAS found the following questions in the import file. Please select the questions you want to import.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_non_ilias_files','en','Error: The import file contains QTI files which are not created by an ILIAS system. Please contact the ILIAS team to get in import filter for your QTI file format.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_no_items','en','Error: The import file contains no questions!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_import_create_new_qpl','en','Import the questions in a new question pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_general_properties','en','General Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_imagemap_preview_missing','en','ILIAS could not create the temporary preview file containing the imagemap areas. The original image is shown instead. This means that either the webserver\'s ImageMagick tool isn\'t configured correctly or there are no write permissions in the temporary directory! Please contact your system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_export_excel','en','Microsoft Excel File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_export_select_none','en','Please check at least one question to export it','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_export_xml','en','QTI XML File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_edit_select_none','en','Please check one question for editing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_edit_select_multiple','en','Please check only one question for editing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_edit_rbac_error','en','You have no rights to edit this question!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_display_fullsize_image','en','Click here to display the original image!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_select_none','en','Please check at least one question to delete it','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_rbac_error','en','You have no rights to delete this question!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_no_deleteable_questions','en','All questions you tried to delete are in use in a random test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_delete_describe_undeleteable_questions','en','The following questions are in use in random tests. You cannot delete these questions:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_copy_select_none','en','Please check at least one question to copy it to the clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_copy_insert_clipboard','en','The selected question(s) are copied to the clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_confirm_delete_questions','en','Are you sure you want to delete the following question(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_total_of_right_answers','en','Total Percentage of Correct Answers (percentage of maximum points)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_total_of_answers','en','Total of Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_of_questions','en','Assessment of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_assessment_no_assessment_of_questions','en','There is no assessment of questions available for the selected question. The question was never used in a test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','qpl_answertext_fields_not_filled','en','The question could only be saved, if you fill out all answer text fields!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','print_answers','en','Print Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','previous_question_rows','en','<< Questions %d - %d of %d','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','preview','en','Preview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','postpone','en','Postpone Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','postponed','en','postponed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','polygon_click_starting_point','en','Please click on the starting point of the polygon.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','polygon_click_next_point','en','Please click on the next point of the polygon.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','polygon_click_next_or_save','en','Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','points_unchecked','en','Points when Unchecked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','polygon','en','Polygon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','points_short','en','Pt.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','points_checked','en','Points when Checked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','point','en','Point','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','points','en','Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','please_select','en','-- please select --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','picture','en','Picture','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','percentile','en','Percentile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','percentage_solved','en','You have solved %.2f percent of this question!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','percentage','en','Percentage','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','passed_short','en','passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','passed_only','en','Passed Tests Only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','passed_official','en','passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','pass','en','Pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','participants_invitation_search_introduction','en','To add fixed participants to this test, please select the users in the below search form and invite them into the test. All test participants will be shown on the Participants Data subtab.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','participants_invitation_description','en','You are able to make this test accessible only for a fixed group of ILIAS users. To enable this functionality, please check the above checkbox and press the Save button.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','participants_invitation','en','Invite Fixed Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','participants_evaluation','en','Evaluation for all Test Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','participants_data','en','Participants Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','output_mode','en','Output Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','participants','en','Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','output','en','Output','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ordering_question_javascript_hint','en','Please drag a definition/picture over the definition/picture where you want to put it and drop it. The underlying definition/picture and all following definitions/pictures will move downwards.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','order_terms','en','Order Terms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','order_pictures','en','Order Pictures','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','or','en','or','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','optional_keywords','en','Optional input of keywords','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','online_exam_show_finish_test','en','You still have to call the final submission of your online exam. Please press the &quot;Finish the test&quot; button to call the final submission.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','online_exam_show_answer_print_sheet','en','You have finished your online exam. To call the answers printview to print out your test results please press the &quot;Answers printview&quot; button.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','nr_of_correct_answers','en','Number of Requested Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','not_yet_accessed','en','Not yet accessed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','not_worked_through','en','Not Answered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','no_user_or_group_selected','en','Please check an option what are you searching for (users, groups, roles)!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','no_target_selected_for_move','en','You must select a target position!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','no_questions_available','en','There are no questions available!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','no_question_selected_for_move','en','Please check at least one question to move it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','no_passed_mark','en','You must set at least one mark to PASSED! The mark schema wasn\'t saved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','next_question_rows','en','Questions %d - %d of %d >>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','negative_points_not_allowed','en','You are not allowed to enter negative points!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','multiline_terms_show','en','Use Multi-Line Terms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','multiline_terms_hide','en','Use Single-Line Terms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','multiline_answers_hide','en','Use Single-Line Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','multiline_answers_show','en','Use Multi-Line Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','min_percentage_ne_0','en','You must define a minimum percentage of 0 percent! The mark schema wasn\'t saved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','meaning','en','Meaning','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','maximum_points','en','Maxium Available Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','maxchars','en','Maximum Number of Characters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','maximum_nr_of_tries_reached','en','You have reached the maximum number of passes for this test. The test cannot be entered!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','material_download','en','Material to Download','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','material_file','en','Material File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','material','en','Material','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matching_shuffle_terms','en','Terms only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matching_shuffle_pictures','en','Pictures only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matching_shuffle_definitions','en','Definitions only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matching_shuffle_terms_pictures','en','Both (Terms and Pictures)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matching_shuffle_terms_definitions','en','Both (Terms and Definitions)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matching_question_javascript_hint','en','Please drag a definition/picture on the right side over a term on the left side and drop the definition/picture to match the term with the definition/picture.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matching_pair','en','Matching Pair','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','matches','en','matches','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','match_terms_and_pictures','en','Match Terms and Pictures','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','match_terms_and_definitions','en','Match Terms and Definitions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','mark_schema','en','Mark Schema','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','manscoring_hint','en','You have added at least one question which may require manual scoring. To guarantee a valid presentation of the test results for the participants it is strongly recommended to restrict the access to the test results using a specified date and time.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','manscoring_results_pass','en','Manual scoreable Questions for Pass %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','manscoring_questions_not_found','en','This test pass does not contain question types which can be scored manually.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','manscoring_select_user','en','Please select a participant to set the score manually','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','manscoring_not_allowed','en','The Manual Scoring wasn\'t activated for a question type. You are not allowed to use this tab.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','manscoring','en','Manual Scoring','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','maintenance','en','Maintenance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_user_not_entered_values','en','User did not enter values','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_user_entered_values','en','User entered values','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_user_data_removed','en','Removed all user data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_user_answered_question','en','User answered a question and received %s points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_total_amount_of_questions','en','Set the total amount of questions for the random test to %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_selected_user_data_removed','en','Removed test data of user %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_random_question_pool_deleted','en','Removed all random question pools for the test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_random_question_pool_added','en','Added the question pool \'%s\' with %s questions for the random test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_question_removed','en','Question removed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_question_position_changed','en','Question position changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_question_added','en','Question added at position','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_mark_removed','en','Mark removed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_modified_test','en','The test was modified','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_mark_changed','en','Mark changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_create_new_test','en','Created new test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_mark_added','en','Mark added','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_could_not_enter_test_due_to_simultaneous_users','en','The user could not enter the test because the maximum number of simultaneous users has been reached','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','log_answer_changed_points','en','Manual change of points of test person %s from %d to %d points by %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','legend','en','Legend','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','locked','en','locked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','last_update','en','Last Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','javaapplet','en','Java Applet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','keywords_hint','en','Enter a list of keywords, separated by spaces or newlines to add an automatic scoring option for the essay question. If any of the keywords will be found in the answertext of the learner, the default score will be set to the maximum available points instead of 0 points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','internal_links_update','en','Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','internal_links','en','Internal Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','insert_before','en','Insert Before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','insert_after','en','Insert After','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','import_question','en','Import Question(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','import_errors_qti','en','The were errors parsing the QTI file. The import was cancelled.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','imagemap_source','en','Image Map Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','imagemap','en','Image Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','imagemap_file','en','Image Map File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','height','en','Height','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','identical_scoring','en','Identical Scoring','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','identical_scoring_desc','en','If selected, gaps with identical solutions will be scored, even if the same solution was used twice or more. If not selected, only the first occurence of the same solution will be scored.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','graphical_answers_show','en','Show Graphical Answer Support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','graphical_answers_hide','en','Hide Graphical Answer Support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','graphical_answers','en','Graphical Answer Support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','glossary_term','en','Glossary Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','general','en','General','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','gap_selection','en','Gap Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','gap_definition','en','Gap Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','gap','en','Gap','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_flash_parameter','en','Add Flash Parameter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','flash_parameters','en','Flash parameters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assFlashApp','en','Flash application','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','flashfile','en','Flash file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','flash_attributes','en','Flash attributes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fixed_participants_hint','en','This test is only accessible for a fixed set of participants shown below. You can change this setting by deactivating the fixed participants checkbox in the %s subtab.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','filter_users','en','Filter Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','filter_show_question_types','en','Show Question Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','filter_show_questionpools','en','Show Question Pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','filter_all_question_types','en','All Question Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','filter_all_questionpools','en','All Question Pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','filter','en','Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_upload_material','en','Please fill out all required fields before you upload materials!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_upload_imagemap','en','Please fill out all required fields before you upload image maps!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_upload_image','en','Please fill out all required fields before you upload images!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_create_gaps','en','Please fill out all required fields before you create gaps!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_add_matching','en','Please fill out all required fields before you add a matching pair!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_required_fields_add_answer','en','Please fill out all required fields before you add answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_matching_pairs','en','Please fill out all matching pairs before you add a new one!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','fill_out_all_answer_fields','en','Please fill out all answer text fields before you add a new one!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','feedback_incomplete_solution','en','At least one answer is not correct','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','feedback_complete_solution','en','Correct solution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','feedback_answers','en','Feedback for every answer of the question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','false','en','False','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','failed_short','en','failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','failed_official','en','failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','externalscript_additional_parameters_hint','en','Enter the additional script parameters in key-value-coding and separate multiple key-value-pairs with a newline, e.g. <p>key1=Hello<br />key2=World</p>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','externalscript_use_kvc','en','Please use key-value-coding for the script paramters!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','externalscript_additional_parameters','en','Script Parameters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','exp_type_certificate','en','Certificate (PDF)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','exp_type_excel','en','Microsoft Excel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','exp_type_spss','en','Comma Separated Value (CSV)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','export','en','Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','exp_eval_data','en','Export evaluation data as','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_groups','en','Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_roles','en','Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_term','en','Search Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_users','en','Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_search_userselection','en','Search the users you want to add to the statistical evaluation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_selected_users','en','Evaluation for Selected Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_order_result','en','The order for the value %s is %s. You received %s points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','edit_content','en','Edit Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','edit_properties','en','Edit Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','edit_test_questions','en','Edit Test Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','enable_javascript','en','Click to enable JavaScript support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','disable_javascript','en','Click to disable JavaScript support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','end_tag','en','End Tag','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ending_time_reached','en','You have reached the ending time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','enlarge','en','Enlarge','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','enter_anonymous_code','en','Enter Anonymous Access Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','enter_enough_positive_points','en','The maxium available points for the question must be greater than 0! Please enter sufficient non negative points for your answers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','error_random_question_generation','en','A fatal error occured during the generation of your random questions for the test. Please contact your administrator with the following information: The system could not create an active ID for user ID %s and test ID %s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','error_image_upload_copy_file','en','There was an error moving the uploaded image file to its destination folder!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','error_image_upload_wrong_format','en','Please upload a valid image file! Supported image formats are gif, jpeg and png.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','error_importing_question','en','There was an error importing the question(s) from the file you have selected!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','error_open_image_file','en','Error opening an image file!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','error_open_java_file','en','Error opening an java applet!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','error_save_image_file','en','Error saving an image file!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_all_users','en','Evaluation for All Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_choice_result','en','The choice with the value %s is %s. You received %s points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_cloze_result','en','Gap number %s with the value %s is %s. You received %s points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_concatenation','en','Concatenation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_data','en','Evaluation Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_found_selected_groups','en','Selected Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_found_selected_users','en','Selected Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_imagemap_result','en','The image map selection is %s. You received %s points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_java_result','en','The answer for the value %s is %s. You received %s points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_legend_link','en','Please refer to the legend for the meaning of the column header symbols.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','eval_matching_result','en','The matching pair %s - %s is %s. You received %s points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_use_fx_grade_part2','en','percent of the total points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_e','en','Please enter a value between 0 and 100 for ECTS grade E!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_use_fx_grade','en','Use the \'FX\' grade, if failed participants reached at least','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_d','en','Please enter a value between 0 and 100 for ECTS grade D!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_b','en','Please enter a value between 0 and 100 for ECTS grade B!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_c','en','Please enter a value between 0 and 100 for ECTS grade C!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_range_error_a','en','Please enter a value between 0 and 100 for ECTS grade A!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_output_of_ects_grades','en','Output of ECTS grades','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_fx_short','en','FAIL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_fx','en','some more work required before the credit can be awarded','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_f_short','en','FAIL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_e_short','en','SUFFICIENT','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_f','en','considerable further work is required','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_e','en','performance meets the minimum criteria','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_d','en','fair but with significant shortcomings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_d_short','en','SATISFACTORY','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_c_short','en','GOOD','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_c','en','generally sound work with a number of notable errors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_b_short','en','VERY GOOD','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_b','en','above the average standard but with some errors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_a_short','en','EXCELLENT','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade_a','en','outstanding performance with only minor errors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_grade','en','ECTS Grade','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_fill_out_all_values','en','Please enter a value for every ECTS grade!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ects_allow_ects_grades','en','Show ECTS grade additional to received mark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','duplicate_order_values_entered','en','You have entered duplicate order values!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','duplicate_matching_values_selected','en','You have selected duplicate matching values!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','duplicate','en','Duplicate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','direct_feedback','en','Verify Your Solution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detailed_output_solutions','en','Detailed Output with Question Solutions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detailed_output_printview','en','Detailed Output with Question Printviews','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detailed_output','en','Detailed Output','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detailed_evaluation_show','en','Show Detailed Evaluation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detailed_evaluation_missing_active_id','en','You must call the Datailed Evaluation for a selected participant!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detailed_evaluation_for','en','Detailed Evaluation for %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detailed_evaluation','en','Detailed Evaluation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detail_starting_time_not_reached','en','You have not reached the starting time of the test. The test will be available on %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detail_max_processing_time_reached','en','You have reached the maximum allowed processing time of the test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','detail_ending_time_reached','en','You have reached the ending time of the test. The test isn\'t available since %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','description_maxchars','en','If nothing entered the maximum number of characters for this text answer is unlimited.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','delete_user_data','en','Delete Test Data of the Selected Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','delete_area','en','Delete Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','delete_image','en','Delete Image','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','delete_all_user_data_confirmation','en','Do you really want to delete the test data of all users in this test?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','delete_all_user_data','en','Delete Test Data of all Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','definition','en','Definition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','create_new','en','Create New','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','create_imagemap','en','Create an Image Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','create_gaps','en','Create Gaps','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','create_date','en','Created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','counter','en','Counter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','coordinates','en','Coordinates','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','correct_solution_is','en','The correct solution is','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','confirm_sync_questions','en','The question you changed is a copy which has been created for use with the active test. Do you want to change the original of the question too?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','confirm_delete_single_user_data','en','Are you sure you want to delete the test data of the selected users?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','confirm_delete_all_user_data','en','Are you sure you want to delete all user data of the test?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','height','en','Height','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','codebase','en','Codebase','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','concatenation','en','Concatenation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_create_grp','en','Add new Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','width','en','Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_skype_icon','en','Skype Logo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','not_enabled_or_configured','en','Not configured or enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_msn_icon','en','MSN Logo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_aim_icon','en','AIM Logo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_yahoo_icon','en','Yahoo Logo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_icq_icon','en','ICQ Logo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_skype','en','Skype','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_aim','en','AIM','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_msn','en','MSN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_yahoo','en','Yahoo','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','im_icq','en','ICQ','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','instant_messengers','en','Instant Messengers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_id','en','ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','user_profile_instant_messengers','en','Instant Messengers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_name','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_basic_files','en','Basic Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_languages','en','Languages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_database','en','Database','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_lang_files','en','Language Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_class_file','en','Class File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_available','en','Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_missing','en','Missing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_db_update','en','DB Update Script','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_main_dir','en','Main Directory','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_plugin_file','en','Plugin File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_save_options','en','Save Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_service','en','Service','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_services','en','Services','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_plugins','en','Plugins','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_plugin','en','Plugin','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_modules','en','Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_edit_settings','en','Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cmps_desc','en','General settings for Repository Modules, Services and Plugins.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_plugin_dirs','en','Plugin Directories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_plugin_lang_prefixes','en','Plugin Language Prefixes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_add_new_rank','en','Position in Add-New-Object List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_rep_object','en','Repository Object Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_disable_creation','en','Disable Creation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_plugin_db_prefixes','en','DB Table Prefixes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_lang_prefix','en','Language Variables Prefix','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_component','en','Component','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_plugin_slot','en','Plugin Slot','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_show_details','en','Show Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_needs_newer_ilias_version','en','This plugin version only runs on newer ILIAS versions. Please upgrade ILIAS.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_needs_newer_plugin_version','en','This ILIAS version needs a newer plugin version. Please upgrade the plugin.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_needs_update','en','Needs update.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_needs_upgrade','en','The plugin version currently installed is older than a previously installed version. Please upgrade the plugin.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_inactive','en','Inactive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_dir','en','Directory','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_active','en','Active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_ilias_max_version','en','Max. ILIAS Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_ilias_min_version','en','Min. ILIAS Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_update_db','en','Update DB','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_refresh','en','Refresh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_activate','en','Activate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_deactivate','en','Deactivate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_responsible','en','Responsible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_update','en','Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_version','en','Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_no_db_update_file_available','en','No DB update script available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_no_language_file_available','en','No language file available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_module','en','Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_refresh_plugins_inf','en','Refresh Plugins Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_file_version','en','Update File Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_group','en','Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('cmps','cmps_current_version','en','Current Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cmps','en','Modules, Services and Plugins','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','code','en','Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_rating','en','Text Gap Rating','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_levenshtein_of','en','Levenshtein Distance of %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cloze_text','en','Cloze Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_case_insensitive','en','Case Insensitive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cloze_textgap_case_sensitive','en','Case Sensitive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','close_text_hint','en','You can define a gap by entering [gap][/gap] at the text position of your choice. Press the \'Create gaps\' button to add an editable form for every gap.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cloze_fixed_textlength_description','en','If you enter a value greater than 0, all text and numeric gap text fields will be created with the fixed length of this value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cloze_fixed_textlength','en','Text Field Length','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','clientip','en','Client IP','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','circle_click_circle','en','Please click on a circle point of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','circle_click_center','en','Please click on center of the desired area.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','circle','en','Circle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','checkbox_unchecked','en','Unchecked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','checkbox_checked','en','Checked','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','changelog_heading','en','Changelog','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','change_solution','en','Change Suggested Solution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','changelog_description','en','The following table contains all changes of authors which have been made to this test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','change_properties_from_standard_to_random','en','You are about to change your test properties from a non random test to a random test. The questions you already added to the test will be removed, because you have to select question pools for a random test. Do you really want to change the test properties?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','change_properties_from_random_to_standard','en','You are about to change your test properties from a random test to a non random test. The information on the question pools you already added to the random test will be removed from test. Do you really want to change the test properties?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_error_upload_bgimage','en','An error occured during the upload of the background image!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_error_import','en','An error occured during the import of a certificate!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_visibility_passed','en','Only Visible if a User Passed the Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_visibility_never','en','Not Visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_visibility_always','en','Always Visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_visibility_introduction','en','The button in the test results to offer users this certificate is','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_visibility','en','Visibility','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_unit_description','en','Enter units of measure as VALUE[cm|mm|in|pt|pc|px|em], e.g. 10mm or 3in','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_country','en','Country of the user\'s address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_zipcode','en','ZIP code of the user\'s address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_city','en','City of the user\'s address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_street','en','Street of the user\'s address','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_department','en','Department of the user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_institution','en','Institution of the user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_title','en','Title of the user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_datetime','en','Actual date and time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_date','en','Actual date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_testtitle','en','Title of the test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_marklong','en','Users mark (official version)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_markshort','en','Users mark (short version)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_maxpoints','en','Maximum available points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_resultpercent','en','Reached percentage of the user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_resultpoints','en','Reached points of the user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_passed','en','\"passed\" or \"failed\", depending on the test results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_lastname','en','Last name of the user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_firstname','en','First name of the user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_fullname','en','Full name of the user (title, firstname and lastname)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_ph_introduction','en','The following placeholders may be used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_confirm_deletion_text','en','Do you really want to delete the certificate and all its related data?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_wrong_units','en','You have entered a wrong set of units','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_wrong_unit','en','You have entered a wrong unit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_pagewidth','en','Page Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_pageheight','en','Page Height','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_failed','en','failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_passed','en','passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_result_mark_long','en','Good','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_result_mark_short','en','B','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_max_points','en','46','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_result_percent','en','83%','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_result_points','en','38','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_result_passed','en','passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_country','en','USA','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_city','en','Anytown, NY','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_zipcode','en','12345','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_street','en','100 Main Street','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_department','en','Customer Support','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_institution','en','ILIAS Open Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_lastname','en','Doe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_title','en','Dr.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_fullname','en','Dr. Jane Doe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_var_user_firstname','en','Jane','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_text','en','Certificate Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_preview','en','Show Certificate Preview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_delete','en','Delete Certificate Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_status_complete','en','The certificate is complete and could be used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_status_incomplete','en','The certificate is incomplete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_show','en','Show Certificate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_not_well_formed','en','The certificate text is not well formed. Please enter valid XHTML for the certificate text!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_padding_top','en','Top Padding','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_margin_body','en','Body Margin','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_background_image','en','Background Image','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_page_format','en','Page Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_export','en','Export Certificate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_edit','en','Create/Edit a Certificate Template','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_custom','en','Custom...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_letter_landscape','en','Letter Landscape (8.5 inch x 11 inch)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_letter','en','Letter (11 inch x 8.5 inch)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_a5_landscape','en','A5 Landscape (148 mm x 210 mm)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_a5','en','A5 (210 mm x 148 mm)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_a4_landscape','en','A4 Landscape (210 mm x 297 mm)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_a4','en','A4 (297 mm x 210 mm)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_left','en','Left','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_bottom','en','Bottom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_right','en','Right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate_top','en','Top','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','certificate','en','Certificate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_save_metaobject','en','You do not possess sufficient permissions to save the meta data!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_read_questionpool','en','You do not possess sufficient permissions to read the question pool data!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_maintain_test','en','You do not possess sufficient permissions to maintain the test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_export_test','en','You do not possess sufficient permissions to export the test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_export_qpl','en','You do not possess sufficient permissions to export the question pool!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_execute_test','en','You do not possess sufficient permissions to run the test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_edit_test','en','You do not possess sufficient permissions to edit the test!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cancel_test','en','Suspend the Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','cannot_edit_marks','en','There are already learners who ran the test. You can only change the marks if a score reporting date is enabled and the reporting date is not yet reached.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','by','en','by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','backtocallingtest','en','Back to the calling test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','available_points','en','Available Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','average_reached_points','en','Average Reached Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ass_size','en','Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ass_question','en','Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ass_export_files','en','Export Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ass_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ass_create_export_test_results','en','Export Test Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','ass_create_export_file','en','Create Export File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assTextSubset','en','Text Subset Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assTextQuestion','en','Essay Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assSingleChoice','en','Multiple Choice Question (Single Response)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assQuestions','en','Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assOrderingQuestion','en','Ordering Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assNumeric','en','Numeric Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assMultipleChoice','en','Multiple Choice Question (Multiple Response)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assJavaApplet','en','Java Applet Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assMatchingQuestion','en','Matching Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assImagemapQuestion','en','Image Map Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assClozeTest','en','Cloze Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','apply','en','Apply','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','applet_parameters','en','Applet Parameters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','applet_parameter','en','Parameter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','applet_new_parameter','en','New Parameter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','applet_attributes','en','Applet Attributes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','answer_text','en','Answer Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','answer_picture','en','Answer Picture','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','answer_is_wrong','en','Your solution is wrong','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','answer_is_right','en','Your solution is correct','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','answer','en','Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','answer_is_not_correct_but_positive','en','You\'ve got points for your solution but it\'s not the best solution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','all_available_question_pools','en','All available question pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_solution','en','Add Suggested Solution','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_questionpool','en','Add Question Pool','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_imagemap','en','Import Image Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_matching_pair','en','Add Matching Pair','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_gap','en','Add Gap Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_area','en','Add Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_applet_parameter','en','Add Applet Parameter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_answer_yn','en','Yes/No Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_answer','en','Add Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','add_answer_tf','en','True/False Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','action','en','Action','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','0_unlimited','en','(0=unlimited)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_results','en','Search results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','last_search_result','en','Last Search Result','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_user_extended','en','Extended User Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_user_simple','en','Simple User Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','view_log','en','View details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','view_last_log','en','View last Scan log','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','tree_corrupt','en','Tree is corrupted! See scan log for details.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','systemcheck','en','System check','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','stop_scan','en','Stop!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','start_scan','en','Start!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','skipped','en','skipped','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','searching_missing_objs','en','Searching for missing objects...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','searching_unbound_objs','en','Searching for unbound objects...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','searching_invalid_rolfs','en','Searching for invalid rolefolders...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','searching_invalid_refs','en','Searching for invalid references...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','searching_invalid_childs','en','Searching for invalid tree entries...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','searching_deleted_objs','en','Searching for deleted objects...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','scanning_system','en','Scanning system...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','scan_modes','en','Scan modes used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','scan_details','en','Scan details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','scan_desc','en','Scan system for corrupted/invalid/missing/unbound objects.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','scan','en','Scan','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','scan_completed','en','Scan completed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restoring_unbound_objs','en','Restoring unbound objects & subobjects...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restoring_missing_objs','en','Restoring missing objects...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restoring_trash','en','Restoring trash...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restoring','en','Restoring...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restore_trash','en','Restore deleted objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restore_trash_desc','en','Restore all objects in trash bin to RecoveryFolder.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restore_missing_desc','en','Restore missing and unbound objects to RecoveryFolder.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','restore_missing','en','Restore missing objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','repair_options','en','Repair options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','removing_invalid_rolfs','en','Removing invalid rolefolders...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','removing_invalid_childs','en','Removing invalid tree entries...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','removing_invalid_refs','en','Removing invalid references...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purging_trash','en','Purging trash...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purging_unbound_objs','en','Purging unbound objects...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purging','en','Purging...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purging_missing_objs','en','Purging missing objects...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_trash','en','Purge deleted objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_trash_desc','en','Remove all objects in trash bin from system.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_type_limit_desc','en','If this field contains a value, only objects of the specified type will be purged.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_type_limit','en','Limit type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_age_limit_desc','en','If this field contains a value, only objects which were deleted before the specified number of days will be purged.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_age_limit','en','Limit age','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_count_limit_desc','en','If this field contains a value, only the specified number of objects will be purged.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_count_limit','en','Limit count','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_missing_desc','en','Remove all missing and unbound objects found from system.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','purge_missing','en','Purge missing objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','passwd_auto_generate','en','Password Forwarding/Generation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','options','en','Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','output_options','en','Output options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','nothing_to_remove','en','Nothing to remove...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','nothing_to_restore','en','Nothing to restore...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','nothing_to_purge','en','Nothing to purge...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','log_scan_desc','en','Write scan results to \'scanlog.log\' in client data directory.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_translation_mode','en','Translation mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','log_scan','en','Log scan results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_translation_enabled','en','Page translation enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_translation_disabled','en','Page translation disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_settings','en','Language Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_statistics','en','Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_unchanged','en','Unchanged entries only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_translate','en','All entries, empty for translation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_local','en','Local changes only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_equal','en','Equal to compare language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_global','en','All entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_conflicts','en','Local and update changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_different','en','Different from compare language','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_scope_commented','en','With comments from language manager','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_saved_local','en','All changes were saved to the local language file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_save_local_changes','en','Save all changes to the local language file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_process_maintenance','en','Process Maintenance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_note_translation','en','Page translation mode is activated for each language separately. Additionally the user needs read and write permission on the language folder.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_note_save_local','en','Please save your changes to the local language file regularly. If you don\'t have write permissions to the customized language files, you may export the local changes and re-import them if needed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_mode_existing_replace','en','Replace existing entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_mode_existing_keepall','en','Keep all existing entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_mode_existing_keepnew','en','Keep all local changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_mode_existing_delete','en','Delete existing entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_maintenance','en','Language Maintenance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_mode_existing','en','Existing Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_maintain','en','Maintain','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_maintain_local_changes','en','Maintain local changes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_loaded_local','en','The local language file was loaded into the database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_load_local_changes','en','Load local language file into the database','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_import_file','en','Import Language File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_former_file_missing','en','The file <b>%s</b> is missing.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_former_file_equal','en','The file <b>%s</b> is identical to the current language file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_former_file_description','en','To compare your local changes with the changes of the last update, please copy the language file of the previously installed ILIAS version to the folder of local language files. The current language file is automatically copied when you save your local language file on the \'Maintain\' tab.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_file_scope','en','Language file scope','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_file_imported','en','The language file %s was imported.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_export_file','en','Export Language File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_error_write_local','en','The local language file can\'t be written!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_error_read_local','en','The local language file doesn\'t exist or can\'t be read!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_error_clear_local','en','The local changed couldn\'t be cleared in the database!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_delete_local_changes','en','Delete all local changes in the database','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_default_entries','en',' (default entries)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_compare','en','Compare:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_cleared_local','en','The local changes were cleared in the database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_clear_local_changes','en','Clear local changes in the database','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_change_settings','en','Change Language Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_all_modules','en','All modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','language_administration','en','Language Administration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','initializing_gaps','en','Initializing gaps in tree...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','found_none','en','none found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','found','en','found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','dumping_tree','en','Dumping tree...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','dump_tree_desc','en','Perform an analysis of the tree and print all tree nodes along with analysis data.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','done','en','Done','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','dump_tree','en','Dump tree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','disabled','en','Disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','cleaning_final','en','Final cleaning...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','cleaning','en','Cleaning...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_without_courses','en','Users without courses assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_limited_access_only','en','Users with limited access only','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_unlimited','en','unlimited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','usr_filter_empty_result','en','No users found that match the selected filter criteria','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','clean_desc','en','Remove invalid references & tree entries. Initialize gaps in tree structure.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','short_inst_name_info','en','This title will appear in the browser header title bar. If no value is entered, \'ILIAS\' is used.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','short_inst_name','en','Short Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','res_links','en','Repository Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete_existing_file','en','Delete Existing File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_refresh_confirm_info','en','Extended language maintenance is currently activated. Refreshing the languages loads all language data from the ILIAS language files into the database. Local changes saved in the database before ILIAS 3.10.0 may be overwritten, if not exported before. This does not affect any \"*.lang.local\" files in the Customizing directory. Local changes saved with ILIAS 3.10.0 or higher are kept, if they are newer than the modification date of the local language file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_refresh_confirm','en','Do you really want to refresh all languages?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','disable_ext_lang_maint','en','Disable Extended Maintenance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_ext_lang_maint','en','Enable Extended Maintenance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_expired','en','expired','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','clean','en','Clean up','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','check_tree_desc','en','Check consistence of entire tree structure. Depending on tree size this may take a while!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','check_tree','en','Check tree structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','analyzing_tree_structure','en','Analyzing tree structure...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','analyzing','en','Analyzing...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','analyze_data','en','Analyze and repair data integrity','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','analysis_options','en','Analysis options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_pay_method_not_specified','en','Not specified','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_payed','en','Payed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_payed_access','en','Payed/Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_perm_obj','en','Edit objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_perm_coupons','en','Edit coupons','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_perm_stat','en','Edit statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_price_not_valid','en','This price is not valid. Please insert only numbers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_select_object_to_sell','en','Please select the object which you want to sell.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_select_pay_method_first','en','Please select one pay method first.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_sell_object','en','Sell object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_shopping_cart','en','Shopping Cart','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_statistic','en','Statistic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_object','en','Are you sure, you want to stop payment for this object? All assigned data will get lost.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_selected_prices','en','Are you sure you want to delete the selected prices?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_selected_trustees','en','Are you sure you want to delete the selected trustees?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_sure_delete_stat','en','Are you sure, you want to delete this statistic?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_transaction','en','Transaction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_trustee_table','en','Trustees','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_trustees','en','Trustees','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_update_price','en','Update prices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_updated_booking','en','Updated statistic.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_updated_prices','en','Updated prices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_updated_trustees','en','Updated permissions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_user_already_assigned','en','User already assigned.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_vendor','en','Vendor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_active_bookings','en','There active bookings for the selected vendor(s). Please delete them first.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_add_info','en','Additional information for bill (optional)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_add_vendor','en','Add vendor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_added_vendor','en','Added new vendor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_address','en','Address for bill','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_already_assigned_vendors','en','The following number of users were already assigned:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_assigned_vendors','en','The following number of users have been assigned to the vendor list:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_auth_token','en','Unique Token Given by PayPal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bank_data','en','Bank data for bill','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bill','en','Bill','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf','en','BMF','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_cost_center','en','Cost center','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_cost_center_not_valid','en','Please enter a valid cost center.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_currency_subunit','en','Currency (1/100) (e.g. Cent)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_currency_unit','en','Currency (e.g. EUR)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_delete_vendor','en','Deassign user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_deleted_number_vendors','en','The following number of vendors have been deleted:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_edit_vendor','en','Edit user','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_email_vendor','en','Mail Address of the Vendor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_general','en','General','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_general_settings','en','General settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_general_settings_not_valid','en','Your general settings aren\'t valid. Please check out whether all fields are filled out correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_header_select_vendor','en','Vendor selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_no_username_given','en','No username given','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_no_valid_username_given','en','No valid username given','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_no_vendor_selected','en','No vendor selected','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_number_bookings','en','Active bookings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_objects_bill_exist','en','Pay method \'bill\' is activated for some objects. Therefore it can not be deactivated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_objects_bmf_exist','en','Pay method \'BMF\' is activated for some objects. Therefore it can not be deactivated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_objects_paypal_exist','en','Pay method \'PayPal\' is activated for some objects. Therefore it can not be deactivated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_offline','en','Offline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_online','en','Online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_page_style','en','Page Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_pay_methods','en','Pay methods','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_paypal','en','PayPal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_paypal_settings','en','Settings for PayPal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_paypal_settings_not_valid','en','Your settings for PayPal aren\'t valid. Please check out whether all fields are filled out correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_pdf_path','en','Path for generating bill as PDF file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_server_host','en','Server Host (e.g. www.paypal.com)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_server_path','en','Path to the Scripts (e.g. /cgi-bin/webscr)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_sure_delete_selected_vendors','en','Do you really want to delete the selected vendor(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_too_many_vendors_selected','en','Please select only one customer to perform this action.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_updated_general_settings','en','Your general settings were updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_updated_pay_method','en','Changed pay method.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_updated_paypal_settings','en','Your settings for PayPal were updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_user_already_assigned','en','This user is already assigned to the vendor list','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_vat_rate','en','VAT rate in % (optional)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_vendor','en','Vendor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','price_a','en','Price','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','prices','en','Prices','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','update','en','Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','password_assistance','en','Password Assistance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_enter_email','en','Please enter an e-mail address and submit the form.\\nILIAS will send an e-mail to that address. The e-mail contains all usernames which have registered this e-mail address.\\nChoose a suitable username and use the password service to retrieve a new password. If you do not retrieve any e-mail by this service please contact your course admin or %1$s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_enter_username_and_email','en','Enter a user name and the associated e-mail address in the fields shown below.\\nILIAS will send a message to that e-mail address. The message contains an address for a web page, where you can enter a new password for the user account.\\nIn case you are unable to assign a password to your user account using this form, contact your course administration or send an e-mail to %1$s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_enter_username_and_new_password','en','Enter the user name and the new password in the fields below.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_invalid_email','en','Please correct your e-mail address.\\nThe given e-mail address could not be found in the database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_invalid_username_or_email','en','Please correct the text in the entry fields.\\nThe user name and e-mail address you have entered do not match an entry in the database.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_invalid_auth_mode','en','The user won\'t be authenticated directly at ILIAS. Thus, sending a password is impossible.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_login_not_match','en','Please enter another user name.\\nThe user name you have entered does not match the user name for which you had asked for password assistance.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_mail_body','en','Register a new password for your user account:\\n\\t%1$s\\n\\nThis message has been generated automatically by the ILIAS server\\n\\t%2$s\\n\\nYou (or someone at %3$s) has asked for password assistance for the user account \"%4$s\".\\n\\nPlease check carefully the conditions listed below, and proceed accordingly:\\n\\n- If you have used the password assistance form on the ILIAS server by accident:\\nDelete this mail.\\n\\n- If you are certain, that you never asked for password assistance at this ILIAS server:\\nPlease contact %5$s.\\n\\n- If you asked for password assistance, please proceed as follows:\\n\\n1. Open your browser.\\n\\n2. Enter the following address in your browser:\\n\\t%6$s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your email program has inserted these line breaks.\\n\\n3. On the web page shown by your browser, enter a new password for your user account.\\n\\nPlease note, that for security reasons, you can perform the three steps above only exactly once and for a limited time only. Afterwards the address becomes invalid, and you have to use the password assistance page on the ILIAS server again.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_mail_sent','en','A message has been sent to %1$s.\\nPlease check your mail box.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_mail_subject','en','ILIAS Password Assistance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_not_permitted','en','Please enter another user name.\\nPassword assistance is not permitted for the user name you have entered.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_password_assigned','en','The password has been successfully assigned to user \"%1$s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_session_expired','en','Please fill in this form again.\\nYour password assistance session has expired. This may have happened, because you tried to use the link that has been sent by e-mail to you more than once, or because too much time has passed since the link has been sent to you.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_update_error','en','Please contact your system administrator.\\nThe password could not be assigned to the user account due to an error whe updating the data base.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_username_mail_body','en','These are the active username found for the given e-mail address:\\n%s\\n\\nThis message has been created automatically by the following ILIAS Server:\\n\\t%s\\n\\nYou (or somebody with IP  %s) have requested support for forgotten usernames for the e-mail address \'%s\'.\\n\\nPlease check the following and act as suggested::\\n\\n-You have requested this e-mail by accident:\\nDelete this e-mail.\\n\\n-You are sure, that you never requested this e-mail:\\nPlease contact %s.\\n\\n- If you requested this e-mail, please proceed as follows::\\n\\n1. Start your internet browser.\\n\\n2. Enter the following url:\\n\\t%s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your e-mail program has inserted these line breaks.\\n\\n3. Your Browser now shows the Password-Service. Use this page together with one of the usernames and the according e-mail address to retrieve a new password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','edit_learning_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','filter_all_roles','en','Show all roles of current context','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','filter_global_roles','en','Show only global roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','filter_local_roles','en','Show only local roles of current context','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','filter_local_roles_object','en','Show only local roles defined at this position','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','filter_roles_local_policy','en','Show only roles using a local policy at this position','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','info_user_view_changed','en','User view changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','leave','en','Leave','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','msg_no_roles_of_type','en','No Roles available with selected filter setting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_administrate','en','Administrate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_create','en','Create new objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_create_desc','en','Determine which object types may be created under the current object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_general','en','General operations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_general_desc','en','Common operations available for all objects. Hover the mousepointer over operation to get more information.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_object','en','Special operations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_object_desc','en','Object-specific operations, only available to certain object types.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_rbac','en','Permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_class_rbac_desc','en','Access control to Permission settings (this menu) and local policy settings for automatic permission settings for new created objects.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_local_role','en','Local role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_local_role_desc','en','This role is locally defined at the current object and correspond to a local policy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_use_local_policy','en','Use local policy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','perm_use_local_policy_desc','en','If local policy is activated, you may define different default permission settings for the current object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_add_assignment','en','New Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_added_assignment','en','Added new assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_approve','en','Registration with Approvement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_approve_info','en','If checked any new user registration has to be approved by an administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_available_roles','en','Available Roles:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_default','en','Default','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_deleted_assignment','en','Deleted assignment(s).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_direct','en','Direct Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_direct_info','en','If this is checked, any new user registration request is automatically approved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_disabled','en','No Registration Possible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_domain','en','Domain','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_email','en','Automatic Role Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_email_role_assignment','en','Role Assignment By Domain','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_fixed','en','Selection From Specified List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_info_pwd','en','If enabled passwords will be send automatically to the new users per E-Mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_approve','en','You already have registered to ILIAS eLearning and received a e-mail with your account data. Now your account has been activated by an administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_profile','en','Profile data:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_profile_changed','en','your profile has changed !','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_body_pwd_generation','en','Your account request will be reviewed by an administrator, and should be activated within 48 hours. You will be informed about the approvement by e-mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_mail_new_user_body','en','A new user has been registered.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_missing_domain','en','Please fill out all fields.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_missing_role','en','Please fill out all fields.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_notification','en','Notifications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_notification_info','en','Enter one or more Login-Ids of users (comma seperated) that will be informed about new user registrations per e-mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_role_assignment','en','Role Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_role_info','en','Assigned Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_select_one','en','Please select one entry.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_selectable_roles','en','Selectable Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_settings_header','en','New Registration Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_type','en','Registration Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_unknown_recipients','en','The following logins are not valid:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','registration_settings','en','New Registrations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitations','en','Access Limitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_enable_access_limitations','en','Enable Access Limitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_limited_until','en','Access is limited until','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_limited_time','en','After registration access for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_none','en','Unlimited access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_missing_mode','en','Please choose for all roles an Access Limitation Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_out_of_date','en','One or more Roles have an outdated access limitation!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_role_access_limitations','en','Define access limitations of Roles for new registered Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_mode','en','Access Limitation Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_mode_unlimited','en','No access limitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_mode_absolute','en','Access is limited by a fixed date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','reg_access_limitation_mode_relative','en','Limited access for a fixed time period after registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','add_members_header','en','Add members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','append_results','en','Append results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_active','en','Include active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_added_new_folder','en','Added new folder.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_advanced','en','Advanced search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_all_results','en','All results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_all_words','en','All words','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_and','en','and','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_any','en','-- Any --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_any_word','en','Any word','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_area','en','Search area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_area_info','en','Please select an area where the search should start.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_below','en','Beneath:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_change','en','Change','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_choose_object_type','en','Please choose one object type.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_concatenation','en','Concatenation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_content','en','Page Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_dbk_content','en','Digital Library (content)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_dbk_meta','en','Digital Library (metadata)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_delete_sure','en','The object and its contents will be deleted permanently','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_details_info','en','Detailed search. Please select one or more resource types.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_direct','en','Direct search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_fast_info','en','Search for titles, descriptions and keywords in all object types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_for_grp_members','en','Search for group members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_for_role_members','en','Search for role members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_for_users','en','Search for users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_full_info','en','Choose this option to search in a large amount of data.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_group','en','Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_grp_title','en','Group name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_hits','en','Found in:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_in_magazin','en','In the repository','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_in_result','en','Search within results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_inactive','en','Include inactive users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_index','en','Indexed search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_like_info','en','Choose this option to get best results.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_limit_reached','en','Your search produced more than %s hits. You can restrict the search terms to receive more detailed results.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lm_content','en','Learning materials (content)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lm_meta','en','Learning materials (metadata)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lucene','en','Lucene search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lucene_host','en','Lucene-Server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lucene_info','en','If activated, it is possible to search in PDF, HTML files and HTML-Learning modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lucene_port','en','Lucene-Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lucene_readme','en','Setup information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_meta','en','Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_minimum_three','en','Your search must be at least three characters long','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_move_folder_not_allowed','en','Folder cannot be moved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_move_to','en','Move to:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_my_search_results','en','My search results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_new_folder','en','New folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_no_category','en','You have not selected any search categories','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_no_connection_lucene','en','Cannot connect to Lucene server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_no_match','en','Your search did not match any results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_no_results_saved','en','No results saved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_no_search_term','en','You have not selected any search terms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_no_selection','en','You made no selection.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_object_renamed','en','Object renamed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_objects_deleted','en','Object(s) deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_objects_moved','en','Objects moved.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_one_action','en','Select one action.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_or','en','or','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_rename_title','en','Rename title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_results','en','Search results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_results_saved','en','Search results saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_role_title','en','Role name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_save_as_select','en','Save as:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_search_for','en','Search for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_search_no_results_saved','en','There are no search results saved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_search_results','en','Search results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_search_term','en','Search term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_select_exactly_one_object','en','You must select exactly one object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_select_folder','en','Please select exactly one folder. It is not possible to rename search results.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_select_one','en','Select one folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_select_one_action','en','--Select one action--','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_select_one_folder_select','en','--Select one folder--','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_select_one_result','en','Select at least one search result','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_select_one_select','en','--Select one folder--','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_show_result','en','Show','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_tst_svy','en','Tests/Surveys','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_type','en','Search Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_user','en','Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','until','en','up to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_all','en','All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_background','en','Background','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_background_attachment','en','Background Attachment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_background_color','en','Background Color','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_background_image','en','Background Image','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_background_position','en','Background Position','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_background_repeat','en','Background Repeat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_border','en','Border','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_border_color','en','Border Color','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_border_style','en','Border Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_border_width','en','Border Width','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_bottom','en','Bottom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_clear','en','Clear','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_color','en','Colour','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_confirm_del_ind_styles','en','Confirm Deletion of Individual Content Styles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_confirm_del_ind_styles_desc','en','All learning modules with individual styles will be assigned to style \'%s\'. This will also delete all individual content styles. Are you sure to continue?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_copy_other_stylesheet','en','Copy Style from Local Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_create_ind_style','en','Create Individual Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_create_new_stylesheet','en','Create new Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_cursor','en','Cursor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_default_style','en','Default Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_font_family','en','Font Family','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_font_size','en','Font Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_font_stretch','en','Font Stretch','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_font_style','en','Font Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_font_variant','en','Font Variant','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_font_weight','en','Font Weight','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_import_stylesheet','en','Import Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_individual_style','en','Individual Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_individual_styles','en','Individual Styles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_left','en','Left','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_letter_spacing','en','Letter Spacing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_line_height','en','Line Height','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_margin','en','Margin','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_margin_and_padding','en','Margin and Padding','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_move_lm_styles','en','Change Style of Learning Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_move_style','en','Change Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_nr_learning_modules','en','Number of Learning Modules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_padding','en','Padding','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_right','en','Right','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_save_active_styles','en','Save Active Styles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_save_standard_styles','en','Save Standard Styles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_scope','en','Scope','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_set_scope','en','Set Scope','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_source','en','Source','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_special','en','Special','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_standard_style','en','Standard Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_text','en','Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_text_align','en','Text Alignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_text_decoration','en','Text Decoration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_text_indent','en','Text Indentation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_text_transform','en','Text Transform','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_top','en','Top','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_vertical_align','en','Vertical Alignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_white_space','en','White Space','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('style','sty_word_spacing','en','Word Spacing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','SurveyMatrixQuestion','en','Matrix Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','SurveyMetricQuestion','en','Metric Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','SurveyNominalQuestion','en','Nominal Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','SurveyOrdinalQuestion','en','Ordinal Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','SurveyTextQuestion','en','Essay','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','add_category','en','Add Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','add_heading','en','Add Text Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','add_limits_for_standard_numbers','en','Please enter a lower and upper limit for the standard numbers you want to add as answers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','add_phrase','en','Add Phrase','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','add_phrase_introduction','en','Please select a Phrase:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','add_standard_numbers','en','Add Standard Numbers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','already_completed_survey','en','You have already finished the survey! You are not able to enter the survey again.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymization','en','Anonymization','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_anonymous_introduction','en','This survey anonymizes all user data. To grant you access to the survey, you must use a 5-character survey code which you can receive from the creator/maintainer of this survey<br />Please enter it in the text field below.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_key_introduction','en','This survey anonymizes all user data. To grant you access to the survey, a 5-character code was created by the system and will be sent to your ILIAS mail inbox when you start the survey (after answering the first question). Your survey access code is<br /><span class=\"bold\">%s</span><br />Please enter it in the text field below.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_personalized','en','Personalized Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_registered_user','en','Anonymized Survey Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_resume_introduction','en','Please enter your survey access code to resume the survey. It was sent to your ILIAS mail inbox when you started the survey.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_survey_description','en','Anonymization removes any personal data from the survey statistics. A survey code is a five digit code which is needed to take part in an anonymized survey. For registered ILIAS users, a survey code will be generated automatically.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_with_code','en','Access with survey codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','info_anonymize_with_code','en','Anonymized Survey with Survey Code Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','info_anonymize_registered_user','en','Anonymized Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','info_anonymize_without_code','en','Anonymized Survey without Access Restrictions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymize_without_code','en','Free access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','anonymous_with_personalized_survey','en','You must be a registered user to run a personalized survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','answer','en','Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','apply','en','Apply','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','arithmetic_mean','en','Arithmetic Mean','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','ask_insert_questionblocks','en','Are you sure you want to insert the following question block(s) to the survey?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','ask_insert_questions','en','Are you sure you want to insert the following question(s) to the survey?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','back','en','<< Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','before','en','before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','browse_for_questions','en','Add Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cancel_survey','en','Suspend the Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_create_survey_codes','en','You do not possess sufficient permissions to create survey access codes!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_edit_survey','en','You do not possess sufficient permissions to edit the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_export_questionpool','en','You do not possess sufficient permissions to export the survey question pool!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_export_survey','en','You do not possess sufficient permissions to export the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_maintain_survey','en','You do not possess sufficient permissions to maintain the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_manage_phrases','en','You do not possess sufficient permissions to manage the phrases!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_participate_survey','en','You do not possess sufficient permissions to participate in the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_read_questionpool','en','You do not possess sufficient permissions to read the question pool data!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_read_survey','en','You do not possess sufficient permissions to read the survey data!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_save_metaobject','en','You do not possess sufficient permissions to save the meta data!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','cannot_switch_to_online_no_questions','en','The status cannot be changed to &quot;online&quot; because there are no questions in the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','categories','en','Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','category','en','Answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','category_delete_confirm','en','Are you sure you want to delete the following answers?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','category_delete_select_none','en','Please check at least one answer to delete it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','category_nr_selected','en','Number of users that selected this answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','chart','en','Chart','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','check_category_to_save_phrase','en','You must select a least one answer to save a phrase!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','codes','en','Access Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','combobox','en','Combobox','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','concatenation','en','Concatenation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','confirm_delete_all_user_data','en','Are you sure you want to delete all user data of the survey?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','confirm_delete_single_user_data','en','Are you sure you want to delete the survey data of the selected users?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','confirm_remove_heading','en','Are you sure you want to remove the text block?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','confirm_sync_questions','en','The question you changed is a copy which has been created for use with the active survey. Do you want to change the original of the question too?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','constraint_add','en','Add Precondition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','constraints','en','Preconditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','constraints_first_question_description','en','The first entity could not have any preconditions because there are no previous questions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','constraints_introduction','en','For every entity (a single question or a question block with multiple questions) one or more preconditions could be defined. These preconditions will be derived from the answers of the survey participants of questions which occur earlier in the survey. Since the first entity has no previous questions or questionblocks there is no possibility to define preconditions for it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','constraints_list_of_entities','en','Available survey entities for preconditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','constraints_no_nonessay_available','en','There are no previous questions or only essay questions available to calculate preconditions (essay questions are not valid to calculate preconditions)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','constraints_no_questions_or_questionblocks_selected','en','Please select at least one question or questionblock!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','contains','en','Contains','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','continue','en','Continue >>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','create_date','en','Created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','create_new','en','Create New','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','create_questionpool_before_add_question','en','You must create at least one question pool to store your questions!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_agree','en','agree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_always','en','always','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_definitelyfalse','en','definitely false','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_definitelytrue','en','definitely true','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_desired','en','desired','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_disagree','en','disagree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_fair','en','fair','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_false','en','false','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_good','en','good','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_manytimes','en','many times','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_morenegative','en','more negative','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_morepositive','en','more positive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_mostcertainly','en','most certainly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_mostcertainlynot','en','most certainly not','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_must','en','must','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_mustnot','en','must not','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_neutral','en','neutral','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_never','en','never','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_no','en','no','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_notacceptable','en','not acceptable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_poor','en','poor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_rarely','en','rarely','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_should','en','should','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_shouldnot','en','should not','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_sometimes','en','sometimes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglyagree','en','strongly agree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglydesired','en','strongly desired','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglydisagree','en','strongly disagree','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_stronglyundesired','en','strongly undesired','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_true','en','true','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_undecided','en','undecided','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_undesired','en','undesired','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_varying','en','varying','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_verygood','en','very good','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dc_yes','en','yes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','define_questionblock','en','Define Question Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','delete_user_data','en','Delete the Survey Data of the Selected Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','description_maxchars','en','If nothing entered the maximum number of characters for this text answer is unlimited.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','disinvite','en','Disinvite','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','display_all_available','en','Display all available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_agree5','en','Standard Attitude (strongly agree-agree-undecided-disagree-strongly disagree)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_agree_disagree','en','Standard Attitude (agree-disagree)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_agree_undecided_disagree','en','Standard Attitude (agree-undecided-disagree)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_desired5','en','Standard Attitude (strongly desired-desired-neutral-undesired-strongly undesired)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_desired_neutral_undesired','en','Standard Attitude (desired-neutral-undesired)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_desired_undesired','en','Standard Attitude (desired-undesired)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_good5','en','Standard Attitude (very good-good-fair-poor-not acceptable)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_good_fair_notacceptable','en','Standard Attitude (good-fair-not acceptable)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_good_notacceptable','en','Standard Attitude (good-not acceptable)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_must5','en','Standard Attitude (must-should-undecided-should not-must not)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_shold_shouldnot','en','Standard Attitude (should-should not)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_attitude_should_undecided_shouldnot','en','Standard Attitude (should-undecided-should not)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_behaviour_certainly5','en','Standard Behavior (most certainly-more positive-undecided-more negative-most certainly not)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_behaviour_yes_no','en','Standard Behavior (yes-no)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_behaviour_yes_undecided_no','en','Standard Behavior (yes-undecided-no)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_always5','en','Standard Beliefs (always-many times-varying-rarely-never)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_always_never','en','Standard Beliefs (always-never)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_always_sometimes_never','en','Standard Beliefs (always-sometimes-never)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_true5','en','Standard Beliefs (definitely true-true-undecided-false-definitely false)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_true_false','en','Standard Beliefs (true-false)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_beliefs_true_undecided_false','en','Standard Beliefs (true-undecided-false)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','dp_standard_numbers','en','Standard Numbers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','duplicate','en','Duplicate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','duplicate_svy','en','Duplicate Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','edit_ask_continue','en','Do you want to continue and edit this question?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','edit_constraints_introduction','en','You have selected the following question(s)/question block(s) to edit the preconditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','edit_heading','en','Edit Text Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','end_date','en','End Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','end_date_reached','en','You cannot start the survey. The end date is reached!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','enter_anonymous_id','en','Survey Access Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','enter_phrase_title','en','Please enter a Phrase Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','enter_questionblock_title','en','Please enter a Questionblock Title!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','enter_valid_number_of_codes','en','Please enter a valid number to generate survey access codes!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','enter_value','en','Enter a Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','error_add_heading','en','Please enter a text for the text block!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','error_importing_question','en','There was an error importing the question(s) from the file you have selected!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','error_retrieving_anonymous_survey','en','The system could not find your survey data for survey code &quot;%s&quot;. Please check the survey code you have entered!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','eval_legend_link','en','Please refer to the legend for the meaning of the column header symbols.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','evaluation','en','Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access','en','Evaluation Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_all','en','Evaluation Access for All Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_description','en','Usually the access to the survey statistics is only granted to users with write permission for the survey (Evaluation Access = Off)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_info','en','You have access to the survey evaluation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_off','en','Off','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','evaluation_access_participants','en','Evaluation Access for Survey Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','existing_constraints','en','Existing Preconditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','exit','en','Exit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','exp_type_csv','en','Comma Separated Value (CSV)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','exp_type_excel','en','Microsoft Excel','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','export_data_as','en','Export Data As','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','export_all_survey_codes','en','Export all Access Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_category_fields','en','Please fill out all answer fields before you add a new one!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_add_category','en','Please fill out all required fields before you add answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_delete_category','en','Please fill out all required fields before you delete answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_move_category','en','Please fill out all required fields before you move answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','fill_out_all_required_fields_save_phrase','en','Please fill out all required fields before you save a phrase!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','filter','en','Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','filter_all_question_types','en','All Question Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','filter_all_questionpools','en','All Question Pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','filter_show_question_types','en','Show Question Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','filter_show_questionpools','en','Show Question Pools','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','form_data_modified_press_save','en','The form data has been modified. Press the save button to keep the changes.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','found_questions','en','Found Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','geometric_mean','en','Geometric Mean','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','given_answers','en','Given Answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','glossary_term','en','Glossary Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','harmonic_mean','en','Harmonic Mean','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','heading','en','Text Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','horizontal','en','Horizontal','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','import_error_closing_file','en','Error closing the import file!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','import_error_opening_file','en','Error opening the import file!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','import_error_survey_no_proper_values','en','The survey properties do not contain proper values!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','import_error_survey_no_properties','en','No survey properties found. Cannot import the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','import_no_file_selected','en','No file selected!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','import_question','en','Import Question(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','import_wrong_file_type','en','Wrong file type!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','insert_after','en','Insert After','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','insert_before','en','Insert Before','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','insert_missing_question','en','Please select at least one question to insert it into the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','insert_missing_questionblock','en','Please select at least one question block to insert it into the survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','introduction','en','Introduction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','introduction_manage_phrases','en','Manage your own phrases which are available for all the ordinal questions you edit/create.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','invitation','en','Invitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','invitation_mode','en','Invitation Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','invited_groups','en','Invited Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','invited_users','en','Invited Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','label_resume_survey','en','Enter your 5 digit survey code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','last_update','en','Last Update','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','layout','en','Layout','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','legend','en','Legend','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','lower_limit','en','Lower Limit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','maintenance','en','Maintenance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','manage_phrases','en','My Phrases','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','material','en','Material','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','material_added_successfully','en','You successfully set a material link!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','material_file','en','Material File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_error_no_columns','en','Please fill in at least one column text!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_error_no_rows','en','Please fill in at least one row text!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_appearance','en','Appearance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_row_delete_select_none','en','Please check at least one row to delete it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_column_delete_select_none','en','Please check at least one column to delete it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_question_radio_button_not_checked','en','Please select an option button for every row!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_question_checkbox_not_checked','en','Please check at least one check box in every row!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_row_separators','en','Row Separators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_column_separators','en','Column Separators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_neutral_column_separator','en','Neutral Column Separator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_neutral_column_separator_description','en','Select the check box if you want to have a separator (thick line) between the neutral column and the other columns in the output of the Matrix Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_row_separators_description','en','Select the check box if you want to have separators (thin lines) between the rows in the output of the Matrix Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_column_separators_description','en','Select the check box if you want to have separators (thin lines) between the columns in the output of the Matrix Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_bipolar_adjectives','en','Bipolar Adjectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_bipolar_adjectives_description','en','You may use a pair of bipolar adjectives to scale the column responses to words, short phrases, or texts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_column_settings','en','Matrix Column Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_sr','en','Option Buttons (Single Response)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_mr','en','Check Boxes (Multiple Response)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_text','en','Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_integer','en','Integer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_double','en','Floating Point','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_date','en','Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_neutral_answer','en','Text for a Neutral Column (\"Not Specified\", \"I don\'t know\" etc.)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_standard_answers','en','Column Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_rows','en','Matrix Rows','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_columns','en','Matrix Columns','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_time','en','Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_subtype_description','en','Please select one of the above subtypes to define the behaviour of the answer fields.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','matrix_columns_rows','en','Column/Row Editor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','maxchars','en','Maximum Number of Characters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','maximum','en','Maximum Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','median','en','Median','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','median_between','en','between','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','menuback','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','menubacktosurvey','en','Back to the Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','message_mail_survey_id','en','You have started the anonymized survey &quot;%s&quot;. To resume this survey you need the following 5 digit survey code:<br><br><strong>%s</strong><br><br>Resuming a survey is only possible, if you interrupt the survey before finishing it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','metric_question_floating_point','en','The value you entered is a floating point value. Floating point values are not allowed for this question type!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','metric_question_not_a_value','en','The value you entered is not a numeric value!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','metric_question_out_of_bounds','en','The value you entered is not between the minimum and maximum value!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','metric_subtype_description_interval','en','Equivalent intervals between measurements allow a meaningful comparison between arbitrary pairs of measurements. The zero point on the scale is arbitrary, so negative values can be used. Examples of interval values are the year date in many calendars or the temperature in Celsius scale.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','metric_subtype_description_rationonabsolute','en','In addition to the interval measurement there are also meaningful ratios between arbitrary pairs of numbers. The zero value on a ratio scale is non-arbitrary. Most physical quantities, such as length in centimeters or duration in seconds are measured on ratio scales.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','metric_subtype_description_ratioabsolute','en','The ratio absolute measurement uses natural numbers additional to the non-arbitrary zero point for example the number of children in a family or probability.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','minimum','en','Minimum Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','missing_upper_or_lower_limit','en','Please enter a lower and an upper limit!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','mode','en','Most Selected Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','mode_nr_of_selections','en','Nr of Selections','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','mode_text','en','Most Selected Value (Text)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','multiple_choice_multiple_response','en','Multiple Choice (Multiple Response)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','multiple_choice_single_response','en','Multiple Choice (Single Response)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','multiple_choice_subtype_description','en','Choose Multiple Choice (Single Response) if you want the participants to select only one answer and Multiple Choice (Multiple Response) if you want the participants to select one ore more answers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','new_survey_codes','en','new survey access code(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','next_question_rows','en','Questions %d - %d of %d >>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_available_constraints','en','There are no preconditions defined!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_category_selected_for_deleting','en','Please select a least one answer if you want to delete answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_category_selected_for_move','en','Please check at least one answer to move it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_constraints_checked','en','Please select a least one question or question block to edit the preconditions!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_question_selected_for_move','en','Please check at least one question to move it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_question_selected_for_removal','en','Please check at least one question or question block to remove it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_questionblocks_available','en','There are no question blocks available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_questions_available','en','There are no questions available!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_search_results','en','There are no search results!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_target_selected_for_move','en','You must select a target position!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_user_or_group_selected','en','Please check an option what are you searching for (users and/or groups)!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_user_phrases_defined','en','There are no user defined phrases available!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','nominal_question_mr_not_checked','en','Please check at least one of the offered answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','nominal_question_not_checked','en','Please check one of the offered answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','non_ratio','en','Interval','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','not_used','en','not used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','obligatory','en','obligatory','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','off','en','Off','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','offline','en','offline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','on','en','On','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','on_additional','en','On, and additional','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','or','en','or','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','ordinal_question_not_checked','en','Please check one of the offered answers!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','orientation','en','Orientation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','outro','en','Final Statement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','percentage_of_entered_values','en','Percentage of users that entered this value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','percentage_of_offered_answers','en','Percentage of offered answers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','percentage_of_selections','en','Percentage of users that selected this answer','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','phrase_saved','en','The phrase was saved successfully!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','please_select','en','-- please select --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','predefined_users','en','Predefined User Set','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','preview','en','Preview','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','previous_question_rows','en','<< Questions %d - %d of %d','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_confirm_delete_phrases','en','Are you sure you want to delete the following phrase(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_confirm_delete_questions','en','Are you sure you want to delete the following question(s)?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_copy_select_none','en','Please check at least one question to copy it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_define_questionblock_select_missing','en','Please select a least two questions if you want to define a question block!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_delete_phrase_select_none','en','Please check at least one phrase to delete it','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_delete_rbac_error','en','You have no rights to delete the question(s)!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_delete_select_none','en','Please check at least one question to delete it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_export_select_none','en','Please check at least one question to export it','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_past_questions_confirmation','en','Are you sure you want to paste the following question(s) in the question pool?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_phrases_deleted','en','Phrase(s) deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_questions_deleted','en','Question(s) deleted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_questions_pasted','en','Question(s) pasted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_savephrase_empty','en','Please enter a phrase title!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_savephrase_exists','en','The phrase title already exists! Please enter another phrase title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','qpl_unfold_select_none','en','Please select at least one question block if you want to unfold question blocks!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','question_contains_no_categories','en','There are no answers defined for this question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','question_has_constraints','en','Preconditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','question_icon','en','Question Icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','question_obligatory','en','The question is obligatory!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','question_saved_for_upload','en','The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','question_type','en','Question Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questionblock','en','Question Block','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questionblock_has_constraints','en','Preconditions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questionblock_icon','en','Questionblock Icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questionblocks','en','Question Blocks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questions','en','Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questions_inserted','en','Question(s) inserted!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questions_removed','en','Question(s) and/or question block(s) removed!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','questiontype','en','Question Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','ratio_absolute','en','Ratio-Absolute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','ratio_non_absolute','en','Ratio-Non-Absolute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','ratio_scale_ge_zero','en','The minimum value for a ratio scale must be greater or equal zero','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','remove_question','en','Remove','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','remove_questions','en','Are you sure you want to remove the following question(s) and/or question block(s) from the survey?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','reset_filter','en','Reset Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','results','en','Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','resume_survey','en','Resume the Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','save_back_to_survey','en','Save and go back to the survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','save_obligatory_state','en','Save Obligatory States','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','save_phrase','en','Save as Phrase','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','save_phrase_categories_not_checked','en','Please check at least two answers to save answers in a new phrase!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','save_phrase_introduction','en','If you want to save the answers below as default phrase, please enter a phrase title. You can access a default phrase whenever you want to add a phrase to an ordinal question.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_field_all','en','Search in all fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_for','en','Search for','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_groups','en','Found Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_invitation','en','Search for users or groups to invite','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_questions','en','Search Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_roles','en','Found Roles','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_term','en','Search Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_type_all','en','Search in all Question Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','found_users','en','Found Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_option','en','--- Please select an option ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_phrase_to_add','en','Please select a phrase to add it to the question!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_prior_question','en','Select a prior question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_questionpool','en','Please select a question pool to store the created question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_questionpool_short','en','Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_relation','en','Select a Relation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_svy_option','en','--- Please select a survey ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_target_position_for_move','en','Please select a target position to move the answers and press one of the insert buttons!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_target_position_for_move_question','en','Please select a target position to move the question(s) and press one of the insert buttons!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','select_value','en','Select a Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','selection','en','Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','set_filter','en','Set Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','show_questiontext','en','Display the Question Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','show_questiontext_description','en','If this checkbox is selected, for every question in the question block the question text will be shown. If this checkbox is not selected, the question text of every question in the question block will be hidden.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','skipped','en','skipped','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','spl_general_properties','en','General Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','spl_online_property','en','Online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','spl_online_property_description','en','If the questionpool is not online, it cannot be used in surveys.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','spl_select_file_for_import','en','You must select a file for import!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','start_date','en','Start Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','start_date_not_reached','en','You cannot start the survey until the start date is reached!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','start_survey','en','Start Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','subject_mail_survey_id','en','Your survey code for \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','subtype','en','Subtype','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_code','en','Survey Access Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_code_message_sent','en','A survey code which allows you to resume the survey was sent to your INBOX!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_code_no_codes','en','You have not created any survey access codes yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_code_url','en','URL for Direct Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_code_url_name','en','URL (use right mouse button to copy URL)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_code_used','en','Code was used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_codes_lang','en','ILIAS language for the direct access URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_codes_no_anonymization','en','You must create an anonymized survey with access codes to create new access codes!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_error_insert_incomplete_question','en','You tried to add an incomplete question to the survey! The question was not added.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_finish','en','Finish Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_text_textwidth_desc','en','Enter the width in characters for the text input field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_text_textheight_desc','en','Enter the height in characters for the text input field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_finished','en','You have finished the survey. Thank you for your participation!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_has_datasets_warning','en','The survey already contains datasets. You cannot edit the survey questions until you remove these datasets in the maintenance section.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_is_offline','en','You cannot start the survey! The survey is offline.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_next','en','Next >>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_offline_message','en','Can\'t invite users. The survey is offline!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_online_warning','en','The survey is online. You cannot edit the survey questions!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_previous','en','<< Previous','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_question_editor','en','List of Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_question_obligatory','en','This question is obligatory. You must answer the question!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_question_optional','en','(Optional)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_questions','en','Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_selected_user_data_deleted','en','The survey data of the selected user(s) was deleted successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_finish','en','Skip and Finish Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_next','en','Skip >>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_previous','en','<< Skip','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_skip_start','en','Skip and Go To Start Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_start','en','Go To Start Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','survey_use_start_button','en','You must enter the survey using the start button!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_all_user_data_deleted','en','All user data of this survey has been deleted!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_check_evaluation_access_introduction','en','Since this survey evaluation is only accessable by survey participants you need to enter your survey access code to open the evaluation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_check_evaluation_authentication_needed','en','Authentication needed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_check_evaluation_wrong_key','en','You entered a wrong survey access code or you have not participated the survey. Your access to the survey evaluation is denied.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_create_export_file','en','Create Export File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_delete_all_user_data','en','Delete all User Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_eval_cumulated','en','Cumulated Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_eval_detail','en','Cumulated Results (Details)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_eval_user','en','User Specific Results','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_export_files','en','Export Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_file','en','File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_general_properties','en','General Properties','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_maintenance_information_no_results','en','There are no existing user datasets for the survey. You need at least one user dataset to maintain the data.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_missing_author','en','You have not entered the author\'s name in the survey properties! Please add an authors name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_missing_questions','en','You do not have any questions in the survey! Please add at least one question to the survey.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_missing_title','en','You have not entered a survey title! Please go to the metadata section and enter a title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_page_error','en','There was an error answering a survey question. Please refer to the question to get more information on the error!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_page_errors','en','There were errors answering the survey questions. Please refer to the questions to get more information on the errors!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_select_file_for_import','en','You must select a file for import!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_select_questionpools','en','Please select a question pool to store the imported questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_select_surveys','en','Please select a survey for duplication','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_selected_user_data_deleted','en','The survey data of the selected user(s) was deleted successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_show_questiontitles','en','Show Question Titles in Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_size','en','Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_statistical_evaluation','en','Statistical Evaluation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_status_missing','en','There are required elements missing in this survey!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_status_missing_elements','en','The following elements are missing:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','svy_status_ok','en','The status of the survey is OK. There are no missing elements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','text_maximum_chars_allowed','en','Please do not enter more than a maximum of %s characters. Any characters above will be cut.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','text_question_not_filled_out','en','Please fill out the answer field!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','text_resume_survey','en','You are trying to resume an anonymized survey. To continue the survey with your previously entered values please enter the 5 digit survey code which you received after starting the survey (it was sent with a message to your ILIAS mail folder). Instead of typing your survey code you also can copy it from your inbox and paste it into the text field below.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','title_resume_survey','en','Resume the Survey - Enter Survey Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','unfold','en','Unfold','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','unlimited_users','en','Unlimited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','uploaded_material','en','Uploaded Material','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','upper_limit','en','Upper Limit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','upper_limit_must_be_greater','en','The upper limit must be greater than the lower limit!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','used','en','used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','users_answered','en','Users Answered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','users_skipped','en','Users Skipped','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','value_nr_entered','en','Number of users that entered that value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','values','en','Values','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','vertical','en','Vertical','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','view_constraints_introduction','en','You are viewing the preconditions of the following question/question block:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','view_phrase','en','View Phrase','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','warning_question_in_use','en','Warning! The question you want to edit is in use by the surveys listed below. If you decide to continue and save/apply the question, all answers of the surveys listed below will be deleted. If you want to change the question and use it in another survey, please choose duplicate in the question browser to create a new instance of this question.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','warning_question_not_complete','en','The question is not complete!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','wrong_categories_selected_for_insert','en','ILIAS could not perform the desired action. Please check exactly one answer as target position!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','wrong_survey_code_used','en','You cannot enter the survey, because you tried to start it with an unauthorized survey code.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','found_objects','en','Found Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','found_too_much_objects','en','Thereby more than %s objects totally were found. Therefore refine your search request, please.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','info_all_objects','en','The following user tracking refers to all objects of the type \'%s\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','info_dwell_time','en','Attention: The total dwell time of an object isn\'t addicted to the given period of time!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','info_found_objects','en','The user tracking refers to the following objects of the type \'%s\' that were found according to your search terms.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','info_valid_request','en','The maximum valid time between two requests of an user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','last_login','en','Last login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','meta_typical_learning_time','en','Typical learning time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','newUT_settings','en','Learning Module Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','obj_types','en','Object Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','search_area_info','en','Please choose one object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','search_terms','en','Search term(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','select_one','en','Please select one object','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_access','en','Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_accesses','en','Accesses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_all','en','All','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter','en','Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_average_page_number','en','Average Number of Pages per Chapter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_depth_coverage','en','Degree of Coverage with Depth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_fewest_access','en','Fewest Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_listing','en','Chapter Listing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_longest_total_dwell_time_depth','en','Total Dwell Time Depth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_most_access_depth','en','Most Access with Depth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_most_pages','en','Most Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_number','en','Number of Chapters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_statisics','en','Chapter Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_stubbiest_total_dwell_time','en','Stubbiest Total Dwell Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_top','en','Top-Chapter (variance, access, etc.)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_chapter_total_statistic','en','Total-Chapter-Statistic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_choice','en','Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_current','en','Currently','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_depth','en','Depth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_duration','en','Duration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_equivalent','en','is equivalent to','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_hits','en','Hits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_hour','en','h','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_interval','en','Interval','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_interval_dwell_time','en','Interval of Dwell Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_interval_page_access','en','Interval of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_last','en','Last','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_legend','en','Legend','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_measurable_hits','en','Measurable Hits (Hits within a Session)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_minute','en','m','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_navigation','en','Navigation/Observation Model (requires JRE 1.5 or higher)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_new_selection','en','New Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_occurrence','en','Occurrence','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_of','en','of','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page','en','Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_average_access','en','Average of Access to pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_average_dwell_time','en','Average of Dwell Time to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_deviation_access','en','Deviation of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_deviation_dwell_time','en','Deviation of Dwell Time to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_fewest_access','en','Fewest Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_highest_deviation','en','Highest Deviation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_highest_varcoeff','en','Highest Variation Coefficient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_least_deviation','en','Least Deviation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_listing','en','Page Listing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_longest_average_dwell_time','en','Average Dwell Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_longest_total_dwell_time','en','Total Dwell Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_lowest_varcoeff','en','Lowest Variation Coefficient','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_median_access','en','Median of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_median_dwell_time','en','Median of Dwell Time to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_mode_access','en','Mode of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_most_access','en','Most Accesses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_number','en','Number of Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_number_access','en','Number of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_range_access','en','Range of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_range_dwell_time','en','Range of Dwell Time to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_stubbiest_average_dwell_time','en','Stubbiest Average Dwell Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_stubbiest_total_dwell_time','en','Stubbiest Total Dwell Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_total_dwell_time','en','Total-Pages-Dwell time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_total_statistic','en','Total-Pages-Statistic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_varcoeff_access','en','Variation Coefficient of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_varcoeff_dwell_time','en','Variation Coefficient of Dwell time to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_variance_access','en','Variance of Access to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_page_variance_dwell_time','en','Variance of Dwell Time to Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_pages','en','Pages','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_pages_statisics','en','Page Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_sec','en','sec','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_sel_lng','en','English','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session','en','Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_average_length','en','Average Session Length','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_average_page_access','en','Average Access to Pages per Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_evaluable','en','Evaluable Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_evaluable_access','en','Evaluable Session Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_evaluable_usr','en','Evaluable User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_involved_usr','en','Number of involved Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_listing','en','Session Listing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_longest','en','Longest Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_longest_total_duration_usr','en','Longest Total Duration per User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_most','en','Most Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_number','en','Number of Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_total_duration','en','Total Duration of all Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_session_total_statistic','en','Total-Session-Statistic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_sessions','en','Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_sessions_statisics','en','Session Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_start','en','Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_summation','en','Summation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_tracked_user','en','Selected Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_until','en','until','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_user','en','User(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_until','en','Access (until)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','news','en','News','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_from','en','Access (from)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','access_restrict_enter','en','Please set the period for the limited access restriction','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_user_selected','en','User selected','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','stats_with','en','with','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','total_dwell_time','en','Total Dwell Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_activated','en','Tracking Activated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_active_both','en','User Tracking and Learning Progress Activated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_active_lp_only','en','Learning Progress Activated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_active_ut_only','en','User Tracking Activated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_added_no_shown_list','en','The selected objects will be hidden.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_anonymized','en','Anonymized','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_anonymized_info','en','If enabled, all statistics will be anonymized.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_assigned','en','Assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_assignments','en','Assignments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_below','en','Below:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_collection_assign','en','Assign','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_collection_deassign','en','Deassign','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_comment','en','Comment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_comments','en','Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_completed','en','Completed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_assignments','en','Assignment of Course Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_items','en','Assignable Course Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_members','en','Course Participants:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_objects','en','Learning Progress of Course Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_releavant_items','en','Course Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_crs_relevant_items','en','Course Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_collection','en','Please assign materials. If the status of all assigned items is \'Completed\' the overall status is completed by the user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_progress','en','Edit Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_time','en','Processing Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_edit_visits','en','Please define the number of visits that is neccessary to complete this object.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_edited_scos','en','Processed Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_editing_time_passed','en','Editing Time Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_failed','en','Failed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_area','en','Area','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_hidden','en','Hidden','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_limit_reached','en','The number of hits is limited to %s. Please use the filter to reduce the hits.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_no_access','en','No objects found','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_none','en','None','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_filter_repository','en','In the Repository','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_fold_relevant_items','en','Folder Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_grp_relevant_items','en','Group Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_head_timing','en','Edit Until','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_hide','en','Hide','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_in_progress','en','In Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_inactive_both','en','User Tracking and Learning Progress Deactivated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_info_edited','en','Set the status to \'Completed\' if you think you have processed all content.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_last_access','en','Last Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_learning_progress','en','Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_learning_progress_tbl_header','en','Learning Progress of:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_lm_statistics','en','Access Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_determination','en','Learning Progress Status Determination','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_determination_info_crs','en','Select the items that determine the overall learning progress status.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_determination_info_sco','en','Select the items that determine the overall learning progress status of the SCORM learning module.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_lp_filter','en','Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mark','en','Mark','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_marks','en','Marks','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode','en','Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_collection','en','Automatic by Collection of Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_deactivated','en','Deactivated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_exercise_returned','en','Exercise Solved','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_manual','en','Manual by Learner','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_objectives','en','Automatic by Learning Objectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_scorm','en','Automatic by Collection of SCORM Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_scorm_package','en','Automatic by SCORM Course Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_scorm_aicc','en','Automatic by Collection of SCORM Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_test_finished','en','Test Finished','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_test_passed','en','Test Passed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_tlt','en','Typical Learning Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_visits','en','Number of Visits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_modifications_saved','en','Saved settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_modus','en','Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_no_attempted','en','Not Attempted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_no_content','en','No information about the learning progress available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_no_sahs_items_found','en','No objects found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_not_accessed','en','Not Accessed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_not_assigned','en','Not Assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_not_attempted','en','Not Attempted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_not_completed','en','Not Completed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_not_participated','en','Not Participated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_not_registered','en','Not Registered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_num_visits','en','Number of Visits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_objects','en','Learning Progress of Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_occurrences','en','Path:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_participated','en','Participated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_processing_time','en','Assumed Processing Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_progress','en','Personal Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_query','en','Title / Description:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_reached_objectives','en','Reached Learning Objectives','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_reached_points','en','Achieved Score','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_reached_visits','en','Required Visits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_refresh','en','Refresh','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_registered','en','Registered','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_required_visits','en','Number of Required Visits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_sahs_relevant_items','en','Content Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_select_one','en','You made no selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_settings','en','Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_settings_saved','en','Saved settings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_show','en','Show Learning Progress','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_show_hidden','en','Show','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_spent_time','en','Spent Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_status','en','Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_time_passed','en','Editing Time Exceeded','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_total_online','en','Total Time Online','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_update_edit_user','en','Saved settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_updated_status','en','Saved learning progress status.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_user_data','en','User Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_user_activities','en','Benutzeraktivitäten','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_repository_changes','en','Changes in the repository','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_usr_list','en','Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_valid_request','en','Max. Time Between Requests','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_view_crs','en','Back to Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_view_list','en','Back to List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_visits','en','Number of Visits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_visits_info','en','Every page visit counts as one visit.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','tracking_time_span_not_valid','en','Please enter a valid number of seconds.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','view_mode','en','View Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','vm_access_of_users','en','Access of Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','vm_days_of_period','en','Days of Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','vm_times_of_day','en','Times of Days','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','adopt_perm_from_template','en','Copy Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_mail_permanent_link','en','Choose the following link to access the course content:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_add_grouping','en','Add Membership Limitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_enter_title','en','Please fill out all required fields.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_added_grouping','en','Added new membership limitation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grouping_delete_sure','en','Are you sure you want to delete this membership limitation ?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grouping_deleted','en','Deleted membership limitation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_map_settings','en','Map Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_enable_map','en','Enable Group Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_members_map','en','Group Members Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_map_location','en','Group Map Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_grp_added_grouping','en','Added new membership limitation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_map_settings','en','Map Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_enable_map','en','Enable Course Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_map_location','en','Course Map Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_members_map','en','Course Members Map','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_grouping','en','Edit Membership Limitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','grouping_change_assignment','en','Change Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grouping_select_exactly_one','en','Please choose exactly one membership limitation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_table_assigned_courses','en','Assigned Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grouping_change_assignment','en','Change Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_assign_crs','en','Assignment of Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_no_courses_assigned','en','No Groups Assigned','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grouping_select_one','en','Please select one membership limitation.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','crs_grp_info_reg','en','You can only register to one of these groups:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_anonymized_info_short','en','(Anonymized)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','barometer_add','en','Add new Feedback','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_ssl_settings','en','SSL Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_ssl_port','en','Server SSL Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_server_ssl_active','en','SSL active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_add_ssl_port','en','Please add the server SSL port.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_type_info','en','This setting is only relevant, if the registration is not \'Disabled\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('exercise','exc_crs_add_members','en','Add students of this course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_settings','en','Mail Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','my_courses','en','My Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_list_members','en','List members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_members_added_addressbook','en','Members added to addressbook','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_in_addressbook','en','Already in addressbook','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_name','en','Name of LDAP Configuration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_referrals','en','Referrals','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_security_settings','en','Security Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_binding','en','Binding','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_bind_anonymous','en','Bind Anonymously','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_bind_user','en','Bind as User:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_bind_dn','en','User DN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_bind_pass','en','Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_authentication_settings','en','Authentication Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_user_dn','en','User Search Base','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_user_scope','en','Search Scope','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_user_attribute','en','Attribute for Login Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_search_filter','en','LDAP Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_restrictions','en','Group Membership Restrictions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_dn','en','Group DN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_scope','en','Search Scope','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_filter','en','LDAP Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_name','en','Group Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_attribute','en','Attribute for Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_memberisdn','en','Attribute Value is DN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_user_sync','en','User Synchronization Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_moment_sync','en','Type of Sychronization','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_sync_login','en','On Login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_sync_cron','en','Per Cron-Job','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_global_role_assignment','en','ILIAS-Role Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_member','en','Group Member Attribute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_scope_one','en','One','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_scope_sub','en','Sub','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_scope_base','en','Base','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_name_info','en','Please choose a name for this LDAP server configuration.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_url_info','en','A fully qualified URL for specifying the protocol, url and port to connect to. E.g \"ldap://ldap.ilias.de:389\".  You may add multiple servers with commas separated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_version_info','en','LDAP version to use, ususally 3.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_referrals_info','en','If set, determines whether the LDAP library automatically follows referrals returned by LDAP servers or not. This should be disabled if you are using an active directory server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_search_base_info','en','Gets prepended to basedn when searching for users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_user_scope_info','en','Scope for user searching. If unsure choose \"Sub\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_filter_info','en','Filter that will be added to the search filter this way: (&(userattr=username)<strong>(userfilter)</strong>).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_dn_info','en','Gets prepended to \"BaseDN\" when searching for groups.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_filter_info','en','Filter that will be added to the search filter when searching for a group: (&(groupattr=group)(memberattr=username)<strong>(groupfilter)</strong>).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_member_info','en','The attribute of the group object where the user dn may be found. Choose \"Attribute Value is DN\" if the member attribute is the distinguished name of the users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_name_info','en','The name of the group users have to be a member of to authenticate successfully.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_attribute_info','en','The group attribute to search for.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_user_sync_info','en','Defines whether new users are automatically created on login or regularly per Cron-Job.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_global_role_info','en','Please choose an ILIAS Role new users will be assigned to.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_scope_info','en','Scope for group searching. If unsure choose \"Sub\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_settings','en','Server Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_user_mapping','en','User Profile Mapping','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_mapping','en','ILIAS Role -> LDAP Group Mapping','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_mapping_table','en','Assignment of LDAP Attributes to ILIAS User Profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_mapping_template','en','Template for objectClass:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_update_field_info','en','Update automatically','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_settings','en','LDAP Group Synchronization Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_active','en','Enable Group Synchronization','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_bind_user','en','Usern DN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_bind_pass','en','Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_bind_user_info','en','Please enter a distinguished name of a LDAP user account. This user needs write access for the LDAP groups.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_bind_pass_info','en','Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_new_role_assignment','en','Add New Role -> Group Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_ilias_role','en','ILIAS Role','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_info','en','Enter the name of an ILIAS Role that will control the membership to the LDAP group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_dn_info','en','Enter the distinguished name of the LDAP group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_member_info','en','The attribute of the group object where the user dn may be found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_selection','en','Login Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','authenticate_ilias','en','Login to ILIAS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','authenticate_with','en','Login to:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_missing_bind_user','en','You have chosen \"Bind as User\": Please enter a valid LDAP username and password.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_missing_role_assignment','en','Please choose a global role new users will be assigned to.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_tls_conflict','en','LDAP-TLS can not be used in combination with LDAPv2. Please choose LDAP version \"3\" or disable TLS support.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_group_assignments','en','Existing Role -> Group Assignments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_search_base','en','Group Search Base','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','select_one','en','Please select one.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_deleted_role_mapping','en','Deleted assignment.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_not_exists','en','A role with that name does not exist','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_ps','en','Privacy and Security','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_ps_desc','en','Configure global privacy and security settings here.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','show_privacy','en','Privacy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','show_security','en','Security','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ps_edit_permission','en','Change Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ps_visible','en','Privacy/Security Settings are Visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ps_read','en','Read Access to Privacy/Security Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ps_write','en','Edit Privacy/Security','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ps_export_member_data','en','User may Export Member Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscriber','en','Subscriber','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_files','en','Export Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_size','en','Files Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_select_one','en','Please select one export file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_delete_export_files','en','Deleted export files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_settings','en','Export Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_user_selection','en','Participants Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_admin','en','Administrators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_tutor','en','Tutors','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_member','en','Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_sub','en','Subscribers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_wait','en','Users on the Waiting List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_user_data','en','Data Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_data','en','Data Types of the Personal Profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_perform_export','en','Start CSV-Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','export_members','en','Export Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_agreement_header','en','User Agreement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_user_agreement','en','Released Data Types','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_agreement','en','The following data types are visible for course administrators:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_agree','en','Acceptance','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_info_agree','en','I accept, that the above data types are visible for course administrators.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_agreement_required','en','You have to accept the user agreement, if you want to register to this course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_privacy_protection','en','Privacy Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_security_protection','en','Security Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_profile_export','en','Protection of User Profile Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_course','en','Advanced Export of User Profile Data in Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_export_confirm','en','User Confirmation when Entering Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','user_fields','en','User Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_crs_user_fields','en','Course-Specific User Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_add_field','en','Add User Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_name','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_type','en','Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_required','en','Required Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_no_fields','en','No User Fields Defined','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_field_type','en','Field Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_type_txt_long','en','Text Field (Optional Values)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_type_select_long','en','Selection Box (Fixed Values)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_new_text_field','en','Add new Text Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_name_field','en','Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_type_text','en','Text Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_type_select','en','Select Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_select_only_one_entry','en','Please select only one entry.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_select_course','en','Please select at least one course.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','course_export','en','Course Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','confirm_message_course_export','en','You added the course export functionality for one or more fields. Please confirm your changes.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_new_select_field','en','New Selection Box','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_value','en','Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_btn_add_value','en','New Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_no_name_given','en','Please enter a name.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_added_field','en','Added new selection box.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_select_one','en','Please select one.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_delete_sure','en','Do you really want to delete these user fields ?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_deleted','en','Deleted user fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_edit_select_field','en','Edit Selection Box','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_deleted_field','en','Deleted value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_online_show_short_associated','en','Only course and group members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_online_show_short_n','en','Don\'t show active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','users_online_show_short_y','en','Show all active users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_files_deleted','en','Export Files Deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_agreement_accepted','en','User Agreement Accepted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_not_accepted','en','Not Accepted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_warning_modify','en','Attention: Minimum one user has accepted the user agreement. Modifying these course specific fields will reset all user agreements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_agreement_req_info','en','Please accept the user agreement for having access to the course content.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_cdf_info','en','Further Course-Specific Data:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_user_agreement_info','en','Visible Personal Data for Course Administrators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_required_info','en','Further Course-Specific fields are required for accessing the course content.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_warning_modify','en','Attention: Minimum one user has accepted the user agreement. Modifying these settings will reset all user agreements.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_select_group','en','Please select at least one group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_my_entries','en','My Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_my_courses','en','My Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_my_groups','en','My Groups','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_my_mailing_lists','en','My Mailing Lists','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_mailing_lists','en','Mailing Lists','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_mailing_list','en','Mailing List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_members_of_mailing_list','en','Members of Mailing List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_into_addressbook','en','Take into Addressbook','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_group_members','en','Group Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_entry_of_addressbook','en','Entry of Address Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_https_header_missing','en','If you enable the automatic https detection you have to provide a header name and header value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_auto_https','en','Autodetect HTTPS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_auto_https_description','en','If enabled, ILIAS tries to detect the HTTPs Status by analysing the header value specified below.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_auto_https_header_name','en','Header Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_auto_https_header_value','en','Header Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','marked_entries','en','Marked Entries','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_overview','en','Participations in Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','legend','en','Legend','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_digit','en','Digit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_csv_export','en','CSV Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_participated','en','Participated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_not_participated','en','Not Participated','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_webr_duplicate','en','Copy Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_webr_select','en','-- Please select one Web Resource --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_file_duplicate','en','Copy File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_file_select','en','-- Please select one File --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_exc_duplicate','en','Copy Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_exc_select','en','-- Please select one Exercise --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_settings','en','Authentication Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_information','en','Login Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_information_desc','en','Please enter a login information for the respective language.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','login_information_settings_saved','en','The login information were saved successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_frm_duplicate','en','Copy Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_frm_select','en','-- Please select one Forum --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_wizard_page','en','Copy Forum (Step 2/2)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','fmr_copy_threads_info','en','You have the possibility to copy single threads. Only the beginning of the chosen threads will be duplicated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','btn_back','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_new_entry','en','New Entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_edit_entry','en','Edit Entry','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_select_attachment','en','Please select an attachment for download.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_tst_duplicate','en','Copy Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_qpl_duplicate','en','Copy Question Pool Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_spl_duplicate','en','Copy Question Pool Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_tst_select','en','-- Please select one Test --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_qpl_select','en','-- Please select one Question Pool Test --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_spl_select','en','-- Please select one Question Pool Survey --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_svy_duplicate','en','Copy Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_svy_select','en','-- Please select one Survey --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_crs_duplicate','en','Copy Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_crs_select','en','-- Please select one Course --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_wizard_page','en','Copy Course (Step 2/2)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_copy_threads_info','en','Please decide which course materials should be copied, linked or even omitted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','omit_all','en','Omit all','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copy_all','en','Copy all','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_all','en','Link all','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','omit','en','Omit','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_fold_duplicate','en','Copy Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_fold_select','en','-- Please select one Folder --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_wizard_page','en','Copy Folder (Step 2/2)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_copy_threads_info','en','Please decide which materials should be copied, linked or even omitted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_grp_duplicate','en','Copy Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_grp_select','en','-- Please select one Group --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_wizard_page','en','Copy Group (Step 2/2)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_copy_threads_info','en','Please decide which materials should be copied, linked or even omitted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assigned_materials','en','Assigned Learning Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_assigned_qst','en','Assigned Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_add_mat','en','Assign Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_add_qst','en','Assign Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_qst','en','Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','container_no_items','en','No Materials Available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','no_items','en','No Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','search_engine','en','Search Engines','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_search_engine','en','Open Public Area for Internet Search Engines (e.g Google).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mod_rewrite_disabled','en','The Apache-Module \'mod_rewrite\' is not available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','allow_override_alert','en','Rules for .htaccess are not interpreted correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_copy','en','Copy Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_copy','en','Copy Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_copy','en','Copy Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','dbk_copy','en','Copy Digilib-Book','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','exc_copy','en','Copy Exercise','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','file_copy','en','Copy File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','fold_copy','en','Copy Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_copy','en','Copy Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','glo_copy','en','Copy Glossary','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','grp_copy','en','Copy Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','htlm_copy','en','Copy HTML Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','icrs_copy','en','Copy LearnLinc Seminar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lm_copy','en','Copy ILIAS Lernmodul','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mcst_copy','en','Copy Mediacast','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sahs_copy','en','Copy SCORM/AICC Learning Module','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','svy_copy','en','Copy Survey','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tst_copy','en','Copy Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webr_copy','en','Copy Web Resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','missing_perm','en','Missing Permission','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','auth_radius_name','en','Name of RADIUS Configuration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','auth_radius_name_desc','en','Please choose a name for this server configuration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','auth_radius_sync','en','User Synchronization','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','auth_radius_role_select','en','Role:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('registration','auth_radius_sync_info','en','If enabled new user accounts will be created automatically after successful authentication.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_anonymized','en','Forum anonymized','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_anonymous','en','anonym','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_your_name','en','Your Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_use_alias','en','You may use this alias for your posting. If you leave this field blank, your posting will be marked as anonymous.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_enable_forum_notification','en','Enable Notification for this Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_disable_forum_notification','en','Disable Notification for this Forum','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forums_forum_notification_enabled','en','You will be notified about new messages in this forum.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','object_copy_in_progress','en','Started Copying.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_deactivated_info','en','No progress will be calculated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_tlt_info','en','Users who reached the Typical Learning Time will gain the status \'Completed\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_visits_info','en','Define the number of visits that is required for completing this learning material.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_manual_info','en','Users have to decide whether their status is completed or not.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_objectives_info','en','The learning progress will be calculated automatically according to the number of passed learning objectives.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_collection_info','en','Define the materials that will determine the learning progress status.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_scorm_info','en','The learning progress status will be determined by the status of selected SCO\'s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_scorm_package_info','en','The learning progress status will be determined by the SCORM course package status directly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_test_finished_info','en','Users have to finish a test completely.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_test_passed_info','en','The test has to be passed by an user to receive the status \'Completed\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_exercise_returned_info','en','The status \'Completed\' can be set only by tutors.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_manual_by_tutor','en','Manual by Tutor','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_manual_by_tutor_info','en','The overall status can only be set by tutors.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_membership','en','Group Membership','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_member_optional','en','Group Membership is Optional','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_user_filter','en','User Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_optional_info','en','If enabled, the group membership is not required for a successful authentication. Please enter a user filter for the members of these groups:<br />(&(userattr=username)<strong>(userfilter)</strong>)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_server_short','en','Server URL:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_dn_short','en','Group DN:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_group_member_short','en','Attribute:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_ilias_role_short','en','Role:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pwassist','pwassist_no_email_found','en','You can not use the password assistance, since there is no e-Mail address for the user account you have entered.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_info_text','en','Information Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_info_text_info','en','If entered, this text will be shown on the info screen for the object this role is assigned to. Optionally this text is available in the Repository and on the Personal Desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_info_text_short','en','Info Text:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','further_informations','en','Further Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_notification_intro','en','This mail was automatically sent to you by the ILIAS installation %s, %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','applications','en','Applications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_page','en','Results:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_page_next','en','Next','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_page_prev','en','Previous','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_codes_import','en','Import Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_add','en','Add Coupon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_edit','en','Edit Coupon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_coupons','en','Coupons','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_coupon','en','Coupon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_type','en','Coupon Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_fix','en','fix','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_percentaged','en','percentaged','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_number_of_codes','en','Number of Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_usage_of_codes','en','Usage of Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_objects','en','Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_from','en','Valid From','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_till','en','Valid Till','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_not_available','en','No coupons created yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_description','en','Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_value','en','Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_edit_codes','en','Edit Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_edit_objects','en','Edit Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_codes','en','Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_code','en','Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_generate_codes','en','Generate Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_availability','en','Maximum Number of Usage of one Code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_code_deleted_successfully','en','Deleted Successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_code_length','en','Code Length','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_code_chars','en','Chars','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_code_generation','en','Code Generation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_type_auto','en','Automatically','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_type_self','en','Manually','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_no_codes_selected','en','You did not select any code','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_sure_delete_selected_codes','en','Are you sure you want to delete the selected codes?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_sure_delete_all_codes','en','Are you sure you want to delete all codes?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_codes_not_available','en','No codes created yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_assigned_objects','en','Assigned Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_unassigned_objects','en','Unassigned Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_not_found','en','No coupons found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_not_valid','en','The coupon is not valid.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_no_object_assigned','en','No object assigned to the coupon.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_coupon_not_found','en','No coupon found for the code you typed in.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_already_in_use','en','The code you typed in belongs to the same coupon as a code which is already in use.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_coupon_added','en','Coupon added.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_fix_selected_objects','en','%s %s discount on the total amount of selected objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_fix_all_objects','en','%s %s discount on the total amount of all objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_percentaged_selected_objects','en','%s %s discount on the total amount of selected objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_percentaged_all_objects','en','%s %s discount on the total amount of all objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_no_codes_generated','en','No codes generated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_import_codes','en','Import Codes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupons_import_error_opening_file','en','Error opening the import file!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','paya_coupon_codes_import_successful','en','Import successful.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_settings','en','Settings for BMF','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_client_id','en','Cliend Id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_bewirtschafter_nr','en','Operator No.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_haushaltsstelle','en','Haushaltsstelle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_object_id','en','Object Id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_kennzeichen_mahnverfahren','en','Dunning Procedure Id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_waehrungskennzeichen','en','Currency (e.g. EUR)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_epayment_server','en','ePayment-Server','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_client_certificate','en','Path to Client-Certificate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_ca_certificate','en','Path to CA-Certificate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_timeout','en','Timeout','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_updated_bmf_settings','en','Your settings for BMF were updated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pays_bmf_settings_not_valid','en','Your settings for BMF aren\'t valid. Please check out whether all fields are filled out correctly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','import_use_only_textfile','en','Hint: Please use a plain-text file with one code per line.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_mapping_info_type','en','Show Information also in the Repository/Personal Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_show_link_session','en','Show sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_hide_link_session','en','Hide sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','forums_notification_disabled','en','Notification disabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','save_status','en','Save Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_selected_users','en','Selected Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_users','en','Search Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wizard_title_info','en','Please enter the title of the object you want to duplicate.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','wizard_search_list','en','Your search produced the following hits. Please select one of them.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_auth_ldap_no_ilias_user','en','Login failed. LDAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ext_acccount_required','en','Please enter the name of the external account.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_select_one','en','-- Please select one session --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','events_clone_title','en','Duplicate Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_clone_btn','en','Duplicate Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_cloned','en','The Session has been duplicated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_check_input','en','The settings could not be saved. Please check your input.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filesize','en','File Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filetype','en','File Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','event_files','en','Assigned Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','passwd_list','en','List of Passwords','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_advanced','en','Advanced Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_record_list','en','Datasets and Presentation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_file_list','en','Export Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_record_list_table','en','Available Metadata Sets','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_fields','en','Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_obj_types','en','Assigned Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_substitution_table','en','Presentation in the Repository/Personal Desktop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_substitution','en','Text','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_placeholders','en','Placeholders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_placeholder_for','en','Placeholder for:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_record_export_table','en','Export Files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_records','en','Included Datasets','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_select_one_file','en','Please choose one file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_delete_files_sure','en','Do you really want to delete the following export  files?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_deleted_files','en','Deleted export files.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_records_exported','en','A new export file has been created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_edit_record','en','Edit Dataset','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_field_table','en','Edit Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_field_fields','en','Fields','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_searchable','en','Searchable','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_edit_field','en','Edit Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_create_field','en','New Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_add_value','en','Add Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_no_fields','en','No Fields Defined','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_deleted_records','en','Deleted Dataset','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_delete_fields_sure','en','Do you really want to delete the following field definitions?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_added_new_record','en','Added new dataset','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_create_record','en','New Dataset','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_delete_record_sure','en','Do really want to delete the following datasets?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('barometer','barometer_conflict_anon_req','en','Anonymization can not be combined with type \'Required\'. Please choose one of these options.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_active','en','Active','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_auth_mode','en','Default Authentication Method','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','default_auth_mode_info','en','Please choose the authentication method that is preselected on the login page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_auth_radius_no_ilias_user','en','Login failed. Radius authentication successful, but no corresponding ILIAS user exists.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('auth','auth_rad_migration','en','Account Migration:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('auth','auth_rad_migration_info','en','Activate this option to give new users the possibility to migrate their existing ILIAS accounts to Radius authentication.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('auth','auth_account_migration','en','New ILIAS Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('auth','auth_info_migrate','en','If you have already an ILIAS account enter username and password to migrate your personal data (Mail, Test results...).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('auth','auth_info_add','en','Choose this option if you have never registered to ILIAS. A new account will be created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_assignments','en','Role Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_add_role_ass_rule','en','New Rule for Role Assignments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_assignment_type','en','Assignment Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_by_group','en','Groupmembership','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_grp_info','en','Members of a specific LDAP Group will be assigned to the given ILIAS role.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_grp_at','en','Attribute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_grp_dn_info','en','Please enter the \"Distinguished Name\" of the LDAP Group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_grp_isdn','en','Attribute value is DN','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_by_attribute','en','LDAP Attribute','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_at_info','en','The assignment is based on a specific attribute in the LDAP user profile.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_at_name','en','Attribute Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_role_at_value','en','Attribute Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_tbl_role_ass','en','Avtive Rules','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_rule_condition','en','condition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_btn_add_role_ass','en','Add New Rule','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_edit_role_ass_rule','en','Edit Role Assignment Rule','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_rule_type','en','Type of Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ldap','ldap_confirm_del_role_ass','en','Delete Role Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','header_zip','en','Upload Multiple Files as Zip-Archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','take_over_structure','en','Adopt Structure','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','take_over_structure_info','en','If activated, directories in the zip file will be mapped to categories or, if used in groups or courses, to folders.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_wrong_filetype','en','File is no zip-archive','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','zip_structure_error','en','Archive contains same filenames. Upload aborted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','archive_broken','en','Archive seems to be broken or empty.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','precondition','en','Precondition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cond_ref_handling','en','Link Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cond_ref_shared','en','Shared Preconditions for all Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cond_ref_unique','en','Unique Preconditions for Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','obj_mds','en','Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','obj_mds_desc','en','Configure Metadata and Advanced Metadata Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_input_does_not_match_regexp','en','Please provide a valid value.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_reference_info','en','Provide URL pointing to resource','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','msg_input_either_file_or_url','en','You have to provide either a URL or a file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_settings','en','Copyright Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_enabled','en','Enable Copyright Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_selection','en','Copyright Presettings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_used','en','Usage','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_preview','en','Copyright (Preview)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_edit','en','Edit Copyright Presetting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_value','en','Copyright','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_add','en','Add Copyright Presetting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_delete_cp_sure','en','Do you really want to delete the following entries ?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyrights_deleted','en','Deleted Copyright','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','meta_cp_own','en','Own Copyright Information:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_desc_show','en','Show Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_show','en','Show','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_type_date','en','Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sorting_header','en','Content Item Sorting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sorting_title_header','en','Sort by Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sorting_info_title','en','Choose this mode to sort items automatically by title.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sorting_manual_header','en','Sort Manually','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sorting_info_manual','en','This mode offers you the possibility to sort items manually.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sorting_save','en','Save Sorting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_add_thread','en','Add new topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','bold','en','Bold','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','newline','en','Newline','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ext_cat_settings','en','Edit Advanced Category Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','edit_cat_settings','en','Advanced Category Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_search_groups_not_found','en','No groups were found you are belonging to as a member.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_search_courses_not_found','en','No courses were found you are belonging to as a member.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('auth','auth_radius_charset','en','Character Encoding','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('auth','auth_radius_charset_info','en','Please choose the character encoding for the communication with the radius server. If unsure, choose UTF-8.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_add_post','en','Add new post','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','frm_moderate_frm','en','Delete a post, censorship','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_dropped_private','en','The user was disinvited/removed from the private chatroom.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_invited_public','en','The user was invited to the public chat.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_user_invited_private','en','The user was invited to the private chatroom.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_disinvite_user','en','Disinvite/remove user from private chatroom','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_no_online_users','en','No further users online.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_lom','en','LOM Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','search_adv_md','en','Extended Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('search','adv_md_search_title','en','Search in Extended Metadata','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_edit_text_field','en','Edit Text Field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_import_record','en','Import Metadata Set','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright','en','Copyright','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','msg_enter_value_for_valid_constraint','en','Please enter a value to create a valid precondition!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_copyright_enable_info','en','Choose this option to offer a selection of predefined copyrights.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_deleted_export_files','en','Deleted export files.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_select_one_file','en','Please select one file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','passes_finished','en','%s passes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','pass_finished','en','%s pass','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','recf_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','recf_visible','en','Restored Objects are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','recf_read','en','Read access to Restored Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','recf_write','en','Edit Restored Objects','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_unsubscribe','en','Unsubscribe','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_show_grp_access','en','Show last access time of group participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','auth_auth_mode_determination','en','Authentication Method Determination (for Login)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','auth_kind_determination','en','Kind of Determination','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','auth_by_user','en','By the User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','auth_automatic','en','Fixed Sequence','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('administration','auth_mode_determination_info','en','Choose either if the users have to select their authentication method on the login screen or if this is managed by a fixed sequence of authentication methods.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mds_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mds_visible','en','Metadata settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mds_read','en','Read access to Metadata settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mds_write','en','Edit Metadata settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_calendar','en','Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cals_desc','en','General Calendar settings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cals_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cals_visible','en','Calendar settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cals_read','en','Read access to Calendar settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cals_write','en','Edit Calendar settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cat_duplicate','en','Copy Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cat_select','en','-- Please select one Category --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_wizard_page','en','Copy Category (Step 2/2)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_copy_threads_info','en','Please decide which category items should be copied, linked or even omitted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_user_of_group_invited','en','All users of the selected group(s) did not possess sufficient permissions to run the survey. No user was invited.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','no_user_of_role_invited','en','All users of the selected role(s) did not possess sufficient permissions to run the survey. No user was invited.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','object_deleted','en','Object Deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','user_deleted','en','User Deleted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','statistics_filter_advice','en','Please choose your favoured filter settings and press the \"Update View\" button.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','advice_mail_body_secured','en','Because of security reasons ILIAS removed some elements of your message. Please check the secured message and send the mail again.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_crs_max_members_exceeded','en','You cannot buy this course because the maximum number of users is already exceeded.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder','en','Webfolder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mount_webfolder','en','Open as webfolder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_file_inline','en','Learning Module File','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','yesterday','en','Yesterday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','tomorrow','en','Tomorrow','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','show_profile','en','Show profile','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','delete_selected_items','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','link_selected_items','en','Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','move_selected_items','en','Move','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','copy_selected_items','en','Copy','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_no_recipient_found','en','Enter a different mail address. ILIAS couldn\'t find a recipient with this mail address.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_multiple_recipients_found','en','Enter a more specific mail address. ILIAS found multiple possible recipients for this address: %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','paste_clipboard_items','en','Paste','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clear_clipboard','en','Clear Clipboard','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','disk_space_used','en','Disk space used','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','in_use_by','en','In use by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_extension_missing','en','Filename extension missing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_special_characters','en','Due to the character / this object is not visible in webfolders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_windows_special_characters','en','Due to one of the characters \\ / : * ? \" < > | this object is not visible in Windows webfolders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_windows_empty_extension','en','Due to the character . at the end of the name this object is not visible in Windows webfolders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_windows_webdav_issue','en','Due to the character # this object is not visible in Windows webfolders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_special_filename','en','Objects with names . and .. are not visible in webfolders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_visibility','en','Visibility','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_hidden_unix_file','en','Hidden Unix file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_hidden_backup_file','en','Hidden backup file','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_interoperability','en','Interoperability','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','readcount_anonymous_users','en','Number of anonymous read accesses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','readcount_users','en','Number of non-anonymous read accesses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','accesscount_registered_users','en','Read by number of distinct ILIAS users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','state_changed','en','changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','state_changed_inside','en','changed inside','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','state_new','en','new','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','state_unread','en','unread','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','filename_extension_short','en','Extension','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_facs','en','Files & Folders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_facs_desc','en','Configure access to file and folder objects.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_webdav','en','Enable WebDAV access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_webdav_info','en','Allows WebDAV clients to access the repository as a webfolder. Users can open webfolders using the \"open as webfolder\" action in the repository, or by entering the following address in a WebDAV client: <a href=\"%1$s\" folder=\"%1$s\">%1$s</a>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder_index_of','en','Index of %1$s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder_instructions','en','Webfolder instructions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder_instructions_info','en','The webfolder instructions are shown on browsers, which can not open a webfolder directly. You can use HTML code, and the following placeholders: <b>[WEBFOLDER_TITLE]</b>, <b>[WEBFOLDER_URI]</b>, <b>[WEBFOLDER_URI_IE]</b>, <b>[WEBFOLDER_URI_KONQUEROR]</b>, <b>[WEBFOLDER_URI_NAUTILUS]</b>, <b>[ADMIN_MAIL]</b>, <b>[IF_WINDOWS]</b>...<b>[/IF_WINDOWS]</b>, <b>[IF_MAC]</b>...<b>[/IF_MAC]</b>, <b>[IF_LINUX]</b>...<b>[/IF_LINUX]</b>. Clear the field to get the default instructions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder_instructions_titletext','en','Open %1$s as webfolder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder_instructions_text','en','<p>Follow the instructions below, to open <b>[WEBFOLDER_TITLE]</b> as a webfolder:</p>[IF_WINDOWS]<h3>Instructions for Windows Vista</h3><ol><li>Press the key combination Windows+E to open Windows Explorer.</li><li>Click on \'Add Network Place\' in the toolbar. The \'Add a Network Place\' wizard will open.</li><li>Click at the link \'Connect to a website\'.</li><li>Select the \'Choose Another Network Location\' option, and select \'Next\'.<li>In the \'Internet or Network Address\' field enter<br/><b>[WEBFOLDER_URI]</b><br/>then select \'Next\'.</li><li>Enter your login and password, and select \'OK\'.</li>Repeat this step until you get to the next dialog window.</li><li>Enter a name for the webfolder, then select \'Next\'.<li>Enter your login and password, and select \'OK\'.</li>Repeat this step until you get to the next dialog window.</li><li>Select \'Finish\'.</li><li>You can now access the webfolder from the start menu \'Computer\'.</li></ol><h3>Instructions for Windows XP with Internet Explorer 6</h3><ol><li>Start Internet Explorer 6</li><li>Choose the menu \'File &gt; Open...\'</li><li>In the \'Open\' field enter the following address:<br/><b>[WEBFOLDER_URI_IE]</b></li><li>Select the \'Open as web-folder\' option, then select \'OK\'.</li><li>Enter your login and password, and select \'OK\'.</li></ol><h3>Instructions for Windows XP without Internet Explorer 6</h3><ol><li>Double-click the \'My Network Places\' icon on the Desktop.</li><li>Click on \'Add Network Place\' from the \'Network Tasks\' menu on the left side of the window.</li><li>The \'Add a Network Place\' wizard will open, select \'Next\'.</li><li>Select the \'Choose Another Network Location\' option, and select \'Next\'.<li>In the \'Internet or Network Address\' field enter<br/><b>[WEBFOLDER_URI]</b><br/>then select \'Next\'.</li><li>Enter your login and password, and select \'OK\'.</li></ol>[/IF_WINDOWS][IF_MAC]<h3>Instructions for Mac OS X</h3><ol><li>Open the Finder</li><li>Choose the menu \'Go &gt; Connect to server...\'</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI]</b>, and select \'Connect\'.</li><li>Enter your login and password, and select \'OK\'.</li></ol>[/IF_MAC][IF_LINUX]<h3>Instructions for Linux with Konqueror</h3><ol><li>Start the Konqueror browser</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI_KONQUEROR]</b></li><li>Press the Enter key.</li><li>Enter your login and password, and select \'OK\'.</li></ol><h3>Instructions for Linux with Nautilus</h3><ol><li>Start the Nautilus browser</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI_NAUTILUS]</b></li><li>Press the Enter key.</li><li>Enter your login and password, and select \'OK\'.</li></ol>[/IF_LINUX]<p>If opening the webfolder does not work, please contact <a href=\\\"mailto:[ADMIN_MAIL]\\\">[ADMIN_MAIL]</a>.</p>','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','use_default_instructions','en','Use default instructions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','use_customized_instructions','en','Use customized instructions:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inline_file_extensions','en','Web-enabled files','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','inline_file_extensions_info','en','Files with these extensions are displayed in the browser window.<br/>For example: <b>gif jpg mp3 pdf png</b><br/> All other files are offered for downloading.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder_dir_info','en','You got here, because your browser can\'t open webfolders. Read the <a href=\"%1$s\">instructions for opening webfolders</a>.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webfolder_mount_dir_with','en','Open this page as a Webfolder with <a href=\"%1$s\">Internet Explorer 6</a>, <a href=\"%2$s\">Konqueror</a>, <a href=\"%3$s\">Nautilus</a>, <a href=\"%4$s\">other Browser</a>.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','deleted_user_account','en','Deleted user account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_user_settings','en','Calendar Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_user_timezone','en','Timezone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_timezone_info','en','Please choose the nearest city in your timezone.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_week_start','en','Week Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_global_settings','en','Global Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_server_tz','en','Server Timezone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_def_timezone','en','Default Timezone','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_def_timezone_info','en','Please choose a default timezone for the presentation of appointments.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_def_week_start','en','Week Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_cals','en','Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','webdav_pear_auth_http_needed','en','You need to install Pear Auth_HTTP to use this function. To do this, enter <code>pear install Auth_HTTP</code> on the terminal.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_table_categories','en','Calendar Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_type_usr','en','Personal Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','yui_cal_choose_month','en','Month:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','yui_cal_choose_year','en','Year:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_edit_appointment','en','Edit Appointment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_what','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_category_selection','en','Calendar Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_start','en','Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_end','en','End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_fullday','en','Date/Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_fullday_title','en','All Day Event','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_where','en','Location','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_new_app','en','New Appointment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_add_appointment','en','Create Appointment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_recurrences','en','Recurrences','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_every','en','Every:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_day_s','en','Day(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_week_s','en','Week(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_month_s','en','Month(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_year_s','en','Year(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_no_recurrences','en','No Recurrences','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_daily','en','Daily','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_weekly','en','Weekly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_monthly','en','Monthly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_yearly','en','Yearly','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_on','en','On:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_on_the','en','On the:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_first','en','First','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_second','en','Second','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_third','en','Third','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_fourth','en','Fourth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_fifth','en','Fifth','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_last','en','Last','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_in','en','in','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_edit_category','en','Edit Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_calendar_name','en','Calendar Name','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_calendar_color','en','Color','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_del_cal_sure','en','Do you really want to delete the chosen calendars?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_no_ending','en','No End Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_create','en','Create','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_appointments','en','Appointment(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_moderator_f','en','Moderator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_moderator_m','en','Moderator','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_assigned_appointments','en','Assigned Appointments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_no_recurrence','en','No Recurrence','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_add_category','en','Create New Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_del_app_sure','en','Do you really want to delete the selected appointments?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_duration','en','Duration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','survey_defaults','en','Default Settings for Surveys','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','survey_unlimited_invitation','en','Unlimited Invitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','survey_unlimited_invitation_desc','en','Allows unlimited invitation in surveys. Unlimited invitation adds the survey to the personal desktop of every registered user.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_weekday','en','Weekday','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_day_of_month','en','Day of the month','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','display_webdav_actions','en','Display WebDAV actions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','display_webdav_actions_info','en','Displays the action \'open as webfolder\' next to each category, folder, course and group item in the repository.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','sess_visible','en','Sessions are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','sess_read','en','Read access to Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','sess_write','en','Edit Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','sess_edit_permission','en','Change Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_sess','en','Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_sess','en','Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crs_create_sess','en','Create Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','sess_copy','en','Copy Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_sess_duplicate','en','Copy Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_sess_select','en','-- Please select one Session --','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','sess','en','Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','specialusers','en','Special Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','search_users','en','Search Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','adm_no_users_found','en','No users were found that match the search string.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','adm_search_string_too_small','en','Please enter at least two characters in the search field!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','adm_search_select_user','en','Please select at least one user!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','adm_no_special_users','en','There are no special users defined who are able to run a survey more than once.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','adm_special_users','en','Special users who are able to run a survey more than once','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','adm_removed_users','en','Users removed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','adm_remove_select_user','en','Please select at least one user for removal!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_max_attempt','en','Max. number of attempts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_first_row_style','en','First Row Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_selected_items_have_been_copied','en','Selected items have been copied to the clipboard. Click appropriate placeholders to paste them into the learning module.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_selected_items_have_been_cut','en','Selected items have been cut to the clipboard. Click appropriate placeholders to paste them into the learning module.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_choose_pages_or_chapters_only','en','Please select either pages or chapters only.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_max_attempt_exceed','en','Max. number of attempts for this module has been reached.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_new_version','en','Upload new version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_sc_version','en','Version','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_export_all','en','Export all','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_export_tracking','en','Export Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_export_raw','en','CMI (RAW) data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_export_success','en','Success-data (aggregated)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_export_type','en','Export-Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_import_tracking','en','Import Tracking Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_invalid_new_module','en','Incompatible module! Please make sure imsmanifest.xml is not changed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_new_module_added','en','New version of module uploaded successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','attempts','en','Attempts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','decrease_attempts','en','Attempts - 1','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_closed','en','Closed Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_closed_info','en','Group is not visible for non-members.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_disabled','en','No Registration Possible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_disabled_info','en','Only group administrators can add users to the group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_request','en','Request Membership','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_request_info','en','Interested users can send a request/message to group administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_direct','en','Direct Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_direct_info','en','Direct registration.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_pass_request','en','Join With Group Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_password_info','en','Users need to type in the correct password for joining the group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_limit_time','en','Enabled','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_limit_num','en','Maximum Number of Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_max_members_info','en','Define the maximum number of users that can be assigned to this group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_waiting_list_info','en','If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_waiting_list','en','Enable Waiting List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_limit_num_info','en','Limited Registration Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_start','en','Registration Start:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_end','en','Registration End:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_open','en','Open Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_open_info','en','Non-members can see this group and join it directly..','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_public','en','Public Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_public_info','en','Group is visible for non-members but has special requirements to join it.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_typ','en','Group Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_admins','en','Administrators','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_members','en','Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_selected_users','en','Selected Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_delete_member','en','Delete','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_notification','en','Notification','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_edit_members','en','Edit Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_grp_info_reg','en','You can only register to one of these groups:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_reg_period','en','Registration Period','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_start','en','Registration Start:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_end','en','Registration End:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_participants','en','Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_max_users','en','Maximum of Users:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_free_places','en','Free Places','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_reg_type','en','Registration Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_reg_not_started','en','The registration has not started','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_waiting_list_position','en','Your Position on the Waiting List:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_waiting_list','en','Users on Waiting List:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_alert_no_places','en','There are no free places available.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_already_on_list','en','You are already subscribed to the waiting list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_reg_expired','en','The registration time is expired.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mem_unlimited','en','Unlimited','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','mail_attachments','en','Mail attachments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','forum_attachments','en','Forum attachments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_set_on_waiting_list','en','You can add your join request to the waiting list. You will receive a message from a group administrator when your request has been approved or rejected.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_added_to_list','en','You have been assigned to the waiting list. You are assigned to position %s on the waiting list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_users_added','en','Added user to the group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_users_already_assigned','en','The user is already assigned to this  group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_header_waiting_list','en','Waiting List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_users_removed_from_list','en','The selected users have been removed from the waiting list.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_general_informations','en','General Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_information','en','Important Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_settings','en','Group Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_info_settings','en','Group Information','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_icon_settings','en','Group Icon','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_information_info','en','This information will be show on the info page and for new registrations.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','reg_grp_max_members','en','Limited Number of Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_limited','en','Self-Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_btn_unsubscribe','en','Unsubscribe From Group','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','grp_cal_reg_end','en','Registration End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','grp_cal_reg_start','en','Registration Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_membership_request_subject','en','%1$s %2$s would like to join group \"%3$s\".','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_membership_request_body','en','%1$s %2$s has requested membership for group \"%5$s\".\\n\\nPlease accept or refuse this request on the \"Join Requests\" page of the group.\\n\\nGroup: %5$s\", %6$s\\n\\nRequestor: %1$s %2$s, %3$s, mailto:%4$s.\\n\\nSubject:\\n%7$s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_accept_subscriber','en','Admission to group \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_accept_subscriber_body','en','You have been admitted to group \"%1$s\".\\n\\n%2$s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reject_subscriber','en','Declined for group \"%s\"','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reject_subscriber_body','en','Your request to join group \"%s\" has been declined.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_post_not_activated_yet','en','Not activated yet.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','empty_terms_exist','en','There are already empty term fields. Please fill out these fields before you add more terms.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','terms','en','Terms','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','empty_term_message','en','There is a least one empty term field.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','no_terms_message','en','Please add at least on term.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_reg_period','en','Self-Registration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_presentation_type','en','Presentation Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','crs_cal_activation_start','en','Course Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','crs_cal_activation_end','en','Course End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','crs_cal_reg_start','en','Registration Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','crs_cal_reg_end','en','Registration End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_default_calendar','en','Personal Appointments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_details','en','Appointment Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_req_info_screen','en','You can request membership for this group. You will get a message from a group administrator when your request has been admitted or declined.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_passwd_info_screen','en','If a group administrator has given you the group password, you can join this group.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_deac_info_screen','en','Group admittance is closed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_reg_direct_info_screen','en','You can join this group directly.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cal_from','en','From:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cal_until','en','Until:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_cal_type','en','Calendar Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_type_personal','en','Private Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_type_system','en','Public Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crs_edit_event','en','Edit Calendar Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','grp_edit_event','en','Edit Calendar Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','sess_edit_event','en','Edit Calendar Events','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cals_edit_event','en','Administrate Public Calendars','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_err_limit','en','Please enter points between %s and %s.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_qst_summary','en','Overview Question Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_obj_required_points','en','Required Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_all_points','en','Total Points','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_points','en','Point(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_title','en','Learning Objective Description','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_materials','en','Assignment of Course Materials','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_self','en','Initial Test Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_self_limit','en','Limits for Initial Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_final','en','Final Test Questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_final_limit','en','Limits for Final Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_wiz_next','en','Save','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_wiz_back','en','Back','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_step','en','Step','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_self_assessment','en','Initial Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_final_test','en','Final Test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_saved_sorting','en','Saved sorting.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_title_given','en','Please insert a title for the objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_invite_public_room','en','Public Chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','chat_link_to_this_chat','en','Link to this chat','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_limit_err','en','The required points shouldn\'t be higher than the total points.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_no_objective_lms_found','en','This course does not contain any materials.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_server_settings','en','ECS Functionalities','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_settings','en','Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_communities','en','Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_mappings','en','ECS Data Mapping','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_connection_settings','en','Connection Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_active','en','Enable ECS Functionalities','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_server_url','en','Server URL','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_protocol','en','Protocol','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_port','en','Port','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_client_cert','en','Client Certificate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_ca_cert','en','CA Certificate','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_cert_key','en','Certificate Key','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_key_password','en','Key Password','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','cert_serial','en','Certificate Serial Number','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_local_settings','en','Local Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_polling','en','Polling Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_polling_info','en','Please define the polling time for creation and update of Course-Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_import_id','en','Import ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_import_id_info','en','Please enter the ID of the category, where new Course-Links will be created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_error_extract_serial','en','Cannot read serial number of certificate. Please check the client certificate path.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_participants','en','Participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_participants_infos','en','Further Informations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_active_header','en','Export Allowed','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_enable_participant','en','Allow Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_dns','en','Domainname','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_email','en','E-Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_mapping_tbl','en','Mapping of ECS-Data to ILIAS Advanced Meta Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_study_courses','en','Study Course(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_lecturer','en','Lecturer(s)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_courseType','en','Course Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_credits','en','Credits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_start','en','Start','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_term','en','Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_day','en','Day','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_time','en','Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_room','en','Room','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_cycle','en','Cycle','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_ignore_field','en','Disable export/update of this field','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_rcrs','en','Course-Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_rcrs','en','Course-Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_export','en','Course Releases','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_export_obj_settings','en','Course Release Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_export_disabled','en','Do not release this Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_export_enabled','en','Release this Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_publish_as','en','Publish as:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_publish_for','en','Release for:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_check_import_id','en','The import id is not valid. Please check this setting.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rcrs','rcrs_general_info','en','General Informations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_field_names','en','Field Names','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('meta','md_adv_fields_show','en','Show Field Names','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rcrs','rcrs_local_informations','en','Further Informations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_abr','en','Abbreviation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_read_remote_links','en','Update Remote-Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_remote_imported','en','Informations about remote courses have been refreshed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_remote_user_settings','en','Settings for ECS User Accounts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_role','en','Role Assignment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_global_role_info','en','The chosen role will be assigned to newly created ECS user accounts.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rcrs','rcrs_call','en','Call Remote Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_begin','en','Begin','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_end','en','End','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_import','en','Import','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_imported_content','en','Imported E-Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_imported_from','en','Imported From','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_meta_data','en','Meta Data','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_auto_generated_info','en','This mail was automatically sent to you by the ILIAS installation %s, %s','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_rcrs_created_body_a','en','A new Remote Course has been created:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_new_econtent_subject','en','New E-Content created','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_notifications','en','Notifications','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_user_rcp','en','Notification About ECS Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_econ_rcp','en','Notification About New E-Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_user_rcp_info','en','Enter one or more login names of users (comma seperated) that will be informed about new ECS users per e-mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_econ_rcp_info','en','Enter one or more login names of users (comma seperated) that will be informed about new ECS content per e-mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_new_user_subject','en','New ECS User Account','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_new_user_body','en','A new ECS user account has been created.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_new_user_profile','en','User profile data:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('form','form_months','en','Months','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_account_duration','en','Activation Period Extension','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_account_duration_info','en','New ECS-User accounts are limited to the session duration. After assigning an user to a course the activation period will be extended by the given number months.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','udf_type_datetime','en','Date and Time','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_no_value','en','Not available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_semester_hours','en','Semester Periods per Week','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','object_id','en','Object-Id','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_field_courseID','en','Course ID','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','organization','en','Provider','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','auth_ecs','en','ECS','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_approval_rcp_info','en','Enter one or more login names of users (comma seperated) that will be informed about new approved courses per e-mail.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_approval_rcp','en','Notification About Approved Courses','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_new_approval_subject','en','A new course has been released','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_export_created_body_a','en','A new course has been released','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_released','en','Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_released_content','en','Released E-Content','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','rcrs_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','rcrs_visible','en','Course-Link is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','rcrs_read','en','Read access to Course-Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','rcrs_delete','en','Delete Course-Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cat_create_rcrs','en','Create Course-Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','rcrs_write','en','Edit Course-Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cat_create_wiki','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crs_create_wiki','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','grp_create_wiki','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','fold_create_wiki','en','Create Wiki','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','csv_export','en','CSV-Export','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_duration','en','Duration','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ecs','ecs_event_appointment','en','Event Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','res_links_short','en','Links','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','reg_grp_max_members_short','en','Number of Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_wrong_max_members','en','Please check the maximum number of users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_subscription_max_members_short','en','Number of Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','max_members_not_numeric','en','Please check the maximum number of users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_show_crs_access','en','Show last access time of course participants','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','assessment_eval_settings','en','Show the following fields in Evaluation for All Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_external_sender_noreply','en','noreply-Adresse','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','info_mail_external_sender_noreply','en','Tragen Sie hier die E-Mail Adresse für externe System- oder Benachrichtigungsmails ein, die als Absender verwendet werden soll.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_cannot_connect_to_server','en','ILIAS cannot build a socket connection to the chat server.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_gen_attendance_list','en','Generate Attendance List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_date_time','en','Session Appointment','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','err_auth_mode_inactive','en','Your authentication method is deactivated.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','missing_precondition','en','Missing Precondition','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_gen_mark_title','en','Generate Column for Notes','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_gen_comment','en','Generate Column for Comments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_gen_signature','en','Generate Column for Signatures','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_print_attendance_list','en','Print Attendance List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_signature','en','Signature','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','sess_attendance_list','en','Attendance List','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_warn_grp_type_changed','en','Do you really want to change the group type? All permission settings will be reseted.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_type_changed_info','en','Changing the group type will reset all permission settings.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('grp','grp_change_type','en','Change Group Type','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_share','en','Share Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_shared_header','en','Shared Calendars','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_unshare_cal','en','Stop Sharing','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_unshared_selected_usr','en','Stopped sharing the calendar with the selected users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_share_search_header','en','Share Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_search','en','Search Term','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_search_info_share','en','Please enter the name of the desired user/role for sharing the calendar.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_share_search_usr_header','en','User Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_share_cal','en','Share calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_shared_selected_usr','en','The calendar has been shared with the selected users/roles.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_shared_calendars','en','Shared Calendars (Invitations)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_apps','en','Number of Appointments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_share_accept','en','Accept Invitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_share_decline','en','Decline Invitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_changed_events_header','en','Changed Appointments','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_accepted','en','Accepted','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_declined','en','Declined','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('trac','trac_mode_event','en','Participation in Sessions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_user_time_format','en','Time Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_time_format_info','en','Please choose a format for the presentation of time.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_def_time_format_info','en','Please choose a format for the presentation of time.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_def_time_format','en','Default Time Format','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','topics','en','Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','topic','en','Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','edit_topic','en','Edit Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','new_topic','en','New Topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','topic_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','advanced_search','en','Advanced Search','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','set_filter','en','Set Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','reset_filter','en','Reset Filter','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','filter_by','en','by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort_asc','en','sort ascending','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort_desc','en','sort descending','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort','en','Sort','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort_by','en','Sort Objects by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','shop','en','Shop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','price_from','en','from','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','select_one_topic','en','Please select at least one topic','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','topics_deleted','en','The chosen topics were deleted successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','no_topics_yet','en','No topics created yet','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','topic_saved','en','The topic was saved successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','topic_edited','en','The topic was edited successfully','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sure_delete_topics','en','Are you sure you want to delete the chosen topics?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_topics_default_sorting_type','en','Default Sorting Type of Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_topics_default_sorting_direction','en','Default Sorting Direction of Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_topics_allow_custom_sorting','en','Custom Sorting of Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_topics_allow_custom_sorting_info','en','If enabled, every user can determine the sorting of topics in the webshop independently.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_topics_sort_by_title','en','By Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_topics_sort_by_date','en','By Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_topics_sort_manually','en','Manually','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_sorting_value','en','Sorting Value','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_save_sorting','en','Save Sorting','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_max_hits','en','Max hits','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_max_hits_info','en','Please enter a number for the maximum number of search results.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_personal_settings','en','Personal Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_manual_sorting_of_topics','en','Manual Sorting of Topics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort_topics_by','en','Sort Topics by','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort_topics_by_title','en','Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort_topics_by_date','en','Date','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','sort_topics_manually','en','Manually','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_enable_shop','en','Enable Webshop','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_enable_shop_info','en','If activated the ILIAS webshop is available and objects can be bought.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','payment_shop_not_objects_found','en','No buyable objects could be found.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','payment_login_to_buy_object','en','Please login to ILIAS to put objects into the shopping cart.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_share_search_role_header','en','Role Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','assigned_members','en','Assigned Members','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_abstract','en','Abstract','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_edit_abstract','en','Edit Abstract','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('payment','pay_thumbnail','en','Thumbnail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_news_item_visibility_info','en','Public news can be accessed without authentication outside of ILIAS via RSS. Please do not include any confidential information.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_default_visibility','en','Default Access','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_visibility_users','en','Logged in Users','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mcst','mcst_visibility_public','en','Public','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_account_security_mode','en','Account Security','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_account_security_mode_default','en','Standard Ilias Account Security','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_account_security_mode_customized','en','Customized Account Security','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_min_length','en','Minimum Password Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_max_length','en','Maximum Password Size','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_chars_and_numbers_enabled','en','Characters and Numbers','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_special_chars_enabled','en','Special Characters','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_max_age','en','Maximum Password Age','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_login_max_attempts','en','Maximum Login Attempts','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_chars_and_numbers_enabled_info','en','If enabled, passwords have to contain characters and numbers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_special_chars_enabled_info','en','If enabled, passwords have to contain special characters.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_min_length_info','en','Sets the minimum size of account passwords. If set to 0 the passwords anyway have to have a minimum size of 1.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_max_length_info','en','Sets the maximum size of account passwords. Set this to 0 for disabling this option.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_max_age_info','en','Sets the maximum age of passwords in days. Set this to 0 for disabling this option.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_login_max_attempts_info','en',' Sets the maximum count of wrong login attempts. Set this to 0 for disabling this option.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_invalid_password_min_length','en','Minimum password size may not be less than 0.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_invalid_password_max_length','en','Maximum password size may not be less than 0.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_invalid_password_max_age','en','Maximum password age may not be less than 0.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_invalid_login_max_attempts','en','Maximum login attempts may not be less than 0.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_password_min2_because_chars_numbers','en','Minimum password size may not be less than 2 if password have to contain characters and numbers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_password_min3_because_chars_numbers_special','en','Minimum password size may not be less than 3 if password have to contain characters, numbers and special characters.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_error_message_password_max_less_min','en','Maximum password size may not be less than minimum password size.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_empty','en','The password must not be empty.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_expired','en','Your password is expired and have to be changed, because the last change was %s day(s) ago.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','new_pass_equals_old_pass','en','The new password equals the old one.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_to_short','en','The password must have at least a size of %s characters.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_to_long','en','The password must have at most a size of %s characters.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_must_chars_and_numbers','en','The password must contain characters and numbers.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_must_special_chars','en','The password must contain special characters.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_change_on_first_login_enabled','en','Change Password on First Login','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('ps','ps_password_change_on_first_login_enabled_info','en','If enabled, users have to change their password on first login (except users registered themselves).','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','password_change_on_first_login_demand','en','Your initial password have to be changed before you can start using ILIAS services.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_archive_language_selection','en','Language Selection','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','zip_test_failed','en','Zip-Test failed. Please contact you ILIAS administrator.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','ext_link','en','Link','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_my_offers','en','Enable \'Selected Items\'','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_my_offers_info','en','The view \'Selected Items\' contains all objects which are placed on the user\'s Personal Desktop.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_my_memberships','en','Enable \'My Memberships\'','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_enable_my_memberships_info','en','\'My Memberships\' contains all courses and groups the user is assigned to as a member.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_my_offers','en','Selected Items','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_my_memberships','en','My Memberships','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_personal_items_default_view','en','Default View','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_personal_items_default_view_info','en','Choose the prefered view of Personal Items.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_view_select_at_least_one','en','You have to select at least one view, either \'Selected Items\' and/or \'My Memberships\'.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_my_memberships_intro','en','Welcome to Your Memberships','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('pd','pd_my_memberships_intro2','en','This is your personal space for all courses and groups you participate in.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','kiosk','en','Kiosk Mode','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','kiosk_description','en','Run the test in a Kiosk Mode. All content elements which are not part of the test will be hidden to prevent users from leaving the test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','autosave_success','en','Autosave successful...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','autosave_failed','en','Autosave failed!','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','kiosk_show_title','en','Show Test Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','kiosk_show_participant','en','Show Name of Participant','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','kiosk_options','en','Kiosk Mode Options','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','kiosk_options_desc','en','Select whether the test title and/or the name of the active participant should be shown at the top of the test during the kiosk mode.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','redirectAfterSave','en','The maximum working time has been reached and your last question has been saved automatically. In a few seconds you will be redirected...','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','final_statement','en','Final Statement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','final_statement_show','en','Show Final Statement','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','final_statement_show_desc','en','If checked, the final statement will be shown directly after the test was finished prior to the presentation of the test results.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','showinfo','en','Show the complete Information Page','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','showinfo_desc','en','If checked, the complete Test Information Page will be shown (including the test properties). If unchecked, only the introduction text (if available) and the required properties will be shown on the Test Information Page.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','forcejs','en','Force JavaScript output for test questions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','forcejs_short','en','Force JavaScript','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','forcejs_desc','en','If checked, JavaScript output will be chosen for test questions if a JavaScript output and a fallback solution exist.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_contact_email_info','en','Enter one or more (comma seperated) E-mail addresses.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_status','en','Objective Status','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_obj_final_req_info','en','If this number of points is achieved, the learning objective is passed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_obj_initial_req_info','en','If this number of points is achieved, no course materials will be recommended for further editing.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_title_info','en','Please choose a title and a short description of the learning objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_materials_info','en','You can assign course materials that are recommended for processing the learning objective.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_self_info','en','Please define the initial test questions. Initial tests are intended to examine the previous knowledge of the course participants.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_self_limit_info','en','Please define the limits for initial test questions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_final_info','en','Assignment of final test questions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_objective_wiz_final_limit_info','en','Here you can define the limits for the final test questions.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_suggested_sections','en','Suggested Sections','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('forum','frm_statistics','en','Statistics','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_crs_list_members_not_available','en','It is not possible to list the members of the marked courses.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('mail','mail_crs_list_members_not_available_for_at_least_one_crs','en','The members of at least one selected course can not be listed.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_chat_invitation','en','Chat Invitations','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_general_settings','en','General Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_sounds','en','Sounds','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_new_invitation_sound_status','en','Play a sound if a user receives a new chat invitation','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_sound_status_activate','en','Activate Sounds','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('chat','chat_sound_status_deactivate','en','Deactivate Sounds','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','reset_pictures','en','Reset Picture Positions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','reset_definitions','en','Reset Definition Positions','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','selected_languages_updated','en','The selected languages have been updated (if installed):','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','lang_refresh_confirm_selected','en','Do you really want to refresh the selected languages?','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_single_results','en','Results by Question','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','tst_answered_questions_test','en','Questions answered in this test','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_download_folder','en','Enable Downloading Folders','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','enable_download_folder_info','en','Allows to download a folder including sub structures as a zip file.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crsr_edit_permission','en','Change Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crsr_visible','en','Course Reference is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crsr_read','en','Read access to Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crsr_delete','en','Delete Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cat_create_crsr','en','Create new Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crsr_write','en','Edit Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','crsr_copy','en','Copy Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_crsr','en','Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_crsr','en','Course References','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','catr_edit_permission','en','Change Permission Settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','catr_visible','en','Category Reference is visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','catr_read','en','Read access to Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','catr_delete','en','Delete Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cat_create_catr','en','Create Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','catr_write','en','Edit Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','catr_copy','en','Copy Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','obj_catr','en','Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_catr','en','Category References','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crsr','en','Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','catr','en','Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reference_of','en','Reference of:','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','catr_new','en','Create new Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crsr_new','en','Create new Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','catr_edit','en','Edit Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crsr_edit','en','Edit Course Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crsr_edit_info','en','Please choose one course, for creating a new reference.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','catr_edit_info','en','Please choose one category, for creating a new reference.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','reference_deleted','en','Destination not available','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clone_target_title','en','Selection of Target Folder (Step 1/2)','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clone_target','en','Target Folder','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clone_option_in_cat','en','Copy in Existing Category','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clone_option_in_crs','en','Copy in Existing Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','cat_title','en','Category Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','crs_title','en','Course Title','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','clone_existing_course','en','Copy Existing Course','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','use_google_chart_api','en','Use Google Chart API','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('survey','use_google_chart_api_desc','en','If checked, the charts in the cumulated results details of the survey statistics are drawn using the <a href=\"http://code.google.com/apis/chart/\" target=\"_blank\">Google Chart API</a>. Please note that a permanent internet connection is required for the Google Chart API to work.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_cal_details','en','Calendar Details','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_type_crs','en','Course Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_type_grp','en','Group Calendar','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('crs','crs_timings_visibility_short','en','Visibility','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','no_selection','en','--- No Selection ---','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','customstyle','en','Custom Style','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('assessment','customstyle_description','en','It is possible to use a custom style sheet for this test. Please select one of the available style sheets to assign it to this test.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('dateplaner','cal_type_info','en','Please choose one calendar type. \"Public Calendars\" are visible for all ILIAS users.','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','root_create_catr','en','Create Category Reference','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mcts_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mcts_read','en','Read access to mediacast settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mcts_visible','en','Mediacast settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','mcts_write','en','Edit mediacast settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cmps_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cmps_read','en','Read access to component settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cmps_visible','en','Component settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','cmps_write','en','Edit component settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','pdts_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','pdts_read','en','Read access to personal desktop settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','pdts_visible','en','Personal desktop settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','pdts_write','en','Edit personal desktop settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','sess_delete','en','Delete Session','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','svyf_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','svyf_read','en','Read access to survey settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','svyf_visible','en','Survey settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','svyf_write','en','Edit survey settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','facs_edit_permission','en','Change permission settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','facs_read','en','Read access to files & foldes settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','facs_visible','en','Files & foldes settings are visible','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('rbac','facs_write','en','Edit files & foldes settings','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('common','objs_mail','en','Mail','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_tracking_byuser','en','By User','0000-00-00 00:00:00');
INSERT INTO `lng_data` VALUES ('content','cont_tracking_bysco','en','By Chapter','0000-00-00 00:00:00');
/*!40000 ALTER TABLE `lng_data` ENABLE KEYS */;

--
-- Table structure for table `lng_modules`
--

CREATE TABLE `lng_modules` (
  `module` varchar(30) NOT NULL default '',
  `lang_key` char(2) NOT NULL default '',
  `lang_array` mediumtext,
  PRIMARY KEY  (`module`,`lang_key`)
) TYPE=MyISAM;

--
-- Dumping data for table `lng_modules`
--

/*!40000 ALTER TABLE `lng_modules` DISABLE KEYS */;
INSERT INTO `lng_modules` VALUES ('administration','en','a:126:{s:16:\"analysis_options\";s:16:\"Analysis options\";s:12:\"analyze_data\";s:33:\"Analyze and repair data integrity\";s:9:\"analyzing\";s:12:\"Analyzing...\";s:24:\"analyzing_tree_structure\";s:27:\"Analyzing tree structure...\";s:10:\"check_tree\";s:20:\"Check tree structure\";s:15:\"check_tree_desc\";s:89:\"Check consistence of entire tree structure. Depending on tree size this may take a while!\";s:5:\"clean\";s:8:\"Clean up\";s:10:\"clean_desc\";s:76:\"Remove invalid references & tree entries. Initialize gaps in tree structure.\";s:8:\"cleaning\";s:11:\"Cleaning...\";s:14:\"cleaning_final\";s:17:\"Final cleaning...\";s:8:\"disabled\";s:8:\"Disabled\";s:4:\"done\";s:4:\"Done\";s:9:\"dump_tree\";s:9:\"Dump tree\";s:14:\"dump_tree_desc\";s:82:\"Perform an analysis of the tree and print all tree nodes along with analysis data.\";s:12:\"dumping_tree\";s:15:\"Dumping tree...\";s:5:\"found\";s:6:\"found.\";s:10:\"found_none\";s:11:\"none found.\";s:17:\"initializing_gaps\";s:28:\"Initializing gaps in tree...\";s:23:\"language_administration\";s:23:\"Language Administration\";s:20:\"language_all_modules\";s:11:\"All modules\";s:24:\"language_change_settings\";s:24:\"Change Language Settings\";s:28:\"language_clear_local_changes\";s:35:\"Clear local changes in the database\";s:22:\"language_cleared_local\";s:47:\"The local changes were cleared in the database.\";s:16:\"language_compare\";s:8:\"Compare:\";s:24:\"language_default_entries\";s:18:\" (default entries)\";s:29:\"language_delete_local_changes\";s:40:\"Delete all local changes in the database\";s:26:\"language_error_clear_local\";s:54:\"The local changed couldn\'t be cleared in the database!\";s:25:\"language_error_read_local\";s:55:\"The local language file doesn\'t exist or can\'t be read!\";s:26:\"language_error_write_local\";s:41:\"The local language file can\'t be written!\";s:20:\"language_export_file\";s:20:\"Export Language File\";s:22:\"language_file_imported\";s:34:\"The language file %s was imported.\";s:19:\"language_file_scope\";s:19:\"Language file scope\";s:32:\"language_former_file_description\";s:289:\"To compare your local changes with the changes of the last update, please copy the language file of the previously installed ILIAS version to the folder of local language files. The current language file is automatically copied when you save your local language file on the \'Maintain\' tab.\";s:26:\"language_former_file_equal\";s:61:\"The file <b>%s</b> is identical to the current language file.\";s:28:\"language_former_file_missing\";s:30:\"The file <b>%s</b> is missing.\";s:20:\"language_import_file\";s:20:\"Import Language File\";s:27:\"language_load_local_changes\";s:42:\"Load local language file into the database\";s:21:\"language_loaded_local\";s:53:\"The local language file was loaded into the database.\";s:17:\"language_maintain\";s:8:\"Maintain\";s:31:\"language_maintain_local_changes\";s:22:\"Maintain local changes\";s:20:\"language_maintenance\";s:20:\"Language Maintenance\";s:22:\"language_mode_existing\";s:16:\"Existing Entries\";s:29:\"language_mode_existing_delete\";s:23:\"Delete existing entries\";s:30:\"language_mode_existing_keepall\";s:25:\"Keep all existing entries\";s:30:\"language_mode_existing_keepnew\";s:22:\"Keep all local changes\";s:30:\"language_mode_existing_replace\";s:24:\"Replace existing entries\";s:24:\"language_note_save_local\";s:195:\"Please save your changes to the local language file regularly. If you don\'t have write permissions to the customized language files, you may export the local changes and re-import them if needed.\";s:25:\"language_note_translation\";s:142:\"Page translation mode is activated for each language separately. Additionally the user needs read and write permission on the language folder.\";s:28:\"language_process_maintenance\";s:19:\"Process Maintenance\";s:27:\"language_save_local_changes\";s:43:\"Save all changes to the local language file\";s:20:\"language_saved_local\";s:50:\"All changes were saved to the local language file.\";s:24:\"language_scope_commented\";s:35:\"With comments from language manager\";s:24:\"language_scope_conflicts\";s:24:\"Local and update changes\";s:24:\"language_scope_different\";s:31:\"Different from compare language\";s:20:\"language_scope_equal\";s:25:\"Equal to compare language\";s:21:\"language_scope_global\";s:11:\"All entries\";s:20:\"language_scope_local\";s:18:\"Local changes only\";s:24:\"language_scope_translate\";s:34:\"All entries, empty for translation\";s:24:\"language_scope_unchanged\";s:22:\"Unchanged entries only\";s:17:\"language_settings\";s:17:\"Language Settings\";s:19:\"language_statistics\";s:10:\"Statistics\";s:29:\"language_translation_disabled\";s:25:\"Page translation disabled\";s:28:\"language_translation_enabled\";s:24:\"Page translation enabled\";s:25:\"language_translation_mode\";s:16:\"Translation mode\";s:8:\"log_scan\";s:16:\"Log scan results\";s:13:\"log_scan_desc\";s:61:\"Write scan results to \'scanlog.log\' in client data directory.\";s:16:\"nothing_to_purge\";s:19:\"Nothing to purge...\";s:17:\"nothing_to_remove\";s:20:\"Nothing to remove...\";s:18:\"nothing_to_restore\";s:21:\"Nothing to restore...\";s:7:\"options\";s:7:\"Options\";s:14:\"output_options\";s:14:\"Output options\";s:20:\"passwd_auto_generate\";s:30:\"Password Forwarding/Generation\";s:13:\"purge_missing\";s:21:\"Purge missing objects\";s:18:\"purge_missing_desc\";s:57:\"Remove all missing and unbound objects found from system.\";s:17:\"purge_count_limit\";s:11:\"Limit count\";s:22:\"purge_count_limit_desc\";s:84:\"If this field contains a value, only the specified number of objects will be purged.\";s:15:\"purge_age_limit\";s:9:\"Limit age\";s:20:\"purge_age_limit_desc\";s:115:\"If this field contains a value, only objects which were deleted before the specified number of days will be purged.\";s:16:\"purge_type_limit\";s:10:\"Limit type\";s:21:\"purge_type_limit_desc\";s:82:\"If this field contains a value, only objects of the specified type will be purged.\";s:11:\"purge_trash\";s:21:\"Purge deleted objects\";s:16:\"purge_trash_desc\";s:44:\"Remove all objects in trash bin from system.\";s:7:\"purging\";s:10:\"Purging...\";s:20:\"purging_missing_objs\";s:26:\"Purging missing objects...\";s:13:\"purging_trash\";s:16:\"Purging trash...\";s:20:\"purging_unbound_objs\";s:26:\"Purging unbound objects...\";s:23:\"removing_invalid_childs\";s:32:\"Removing invalid tree entries...\";s:21:\"removing_invalid_refs\";s:30:\"Removing invalid references...\";s:22:\"removing_invalid_rolfs\";s:31:\"Removing invalid rolefolders...\";s:14:\"repair_options\";s:14:\"Repair options\";s:15:\"restore_missing\";s:23:\"Restore missing objects\";s:20:\"restore_missing_desc\";s:54:\"Restore missing and unbound objects to RecoveryFolder.\";s:13:\"restore_trash\";s:23:\"Restore deleted objects\";s:18:\"restore_trash_desc\";s:51:\"Restore all objects in trash bin to RecoveryFolder.\";s:9:\"restoring\";s:12:\"Restoring...\";s:22:\"restoring_missing_objs\";s:28:\"Restoring missing objects...\";s:15:\"restoring_trash\";s:18:\"Restoring trash...\";s:22:\"restoring_unbound_objs\";s:41:\"Restoring unbound objects & subobjects...\";s:4:\"scan\";s:4:\"Scan\";s:14:\"scan_completed\";s:14:\"Scan completed\";s:9:\"scan_desc\";s:58:\"Scan system for corrupted/invalid/missing/unbound objects.\";s:12:\"scan_details\";s:12:\"Scan details\";s:10:\"scan_modes\";s:15:\"Scan modes used\";s:15:\"scanning_system\";s:18:\"Scanning system...\";s:22:\"searching_deleted_objs\";s:32:\"Searching for deleted objects...\";s:24:\"searching_invalid_childs\";s:37:\"Searching for invalid tree entries...\";s:22:\"searching_invalid_refs\";s:35:\"Searching for invalid references...\";s:23:\"searching_invalid_rolfs\";s:36:\"Searching for invalid rolefolders...\";s:22:\"searching_missing_objs\";s:32:\"Searching for missing objects...\";s:22:\"searching_unbound_objs\";s:32:\"Searching for unbound objects...\";s:7:\"skipped\";s:7:\"skipped\";s:10:\"start_scan\";s:6:\"Start!\";s:9:\"stop_scan\";s:5:\"Stop!\";s:11:\"systemcheck\";s:12:\"System check\";s:12:\"tree_corrupt\";s:44:\"Tree is corrupted! See scan log for details.\";s:13:\"view_last_log\";s:18:\"View last Scan log\";s:8:\"view_log\";s:12:\"View details\";s:13:\"course_export\";s:13:\"Course Export\";s:29:\"confirm_message_course_export\";s:94:\"You added the course export functionality for one or more fields. Please confirm your changes.\";s:7:\"obj_mds\";s:8:\"Metadata\";s:12:\"obj_mds_desc\";s:49:\"Configure Metadata and Advanced Metadata Settings\";s:28:\"auth_auth_mode_determination\";s:47:\"Authentication Method Determination (for Login)\";s:23:\"auth_kind_determination\";s:21:\"Kind of Determination\";s:12:\"auth_by_user\";s:11:\"By the User\";s:14:\"auth_automatic\";s:14:\"Fixed Sequence\";s:28:\"auth_mode_determination_info\";s:158:\"Choose either if the users have to select their authentication method on the login screen or if this is managed by a fixed sequence of authentication methods.\";}');
INSERT INTO `lng_modules` VALUES ('assessment','en','a:870:{s:11:\"0_unlimited\";s:13:\"(0=unlimited)\";s:6:\"action\";s:6:\"Action\";s:10:\"add_answer\";s:10:\"Add Answer\";s:13:\"add_answer_tf\";s:18:\"True/False Answers\";s:13:\"add_answer_yn\";s:14:\"Yes/No Answers\";s:20:\"add_applet_parameter\";s:20:\"Add Applet Parameter\";s:8:\"add_area\";s:8:\"Add Area\";s:7:\"add_gap\";s:12:\"Add Gap Text\";s:12:\"add_imagemap\";s:16:\"Import Image Map\";s:17:\"add_matching_pair\";s:17:\"Add Matching Pair\";s:16:\"add_questionpool\";s:17:\"Add Question Pool\";s:12:\"add_solution\";s:22:\"Add Suggested Solution\";s:28:\"all_available_question_pools\";s:28:\"All available question pools\";s:6:\"answer\";s:6:\"Answer\";s:34:\"answer_is_not_correct_but_positive\";s:66:\"You\'ve got points for your solution but it\'s not the best solution\";s:15:\"answer_is_right\";s:24:\"Your solution is correct\";s:15:\"answer_is_wrong\";s:22:\"Your solution is wrong\";s:14:\"answer_picture\";s:14:\"Answer Picture\";s:11:\"answer_text\";s:11:\"Answer Text\";s:17:\"applet_attributes\";s:17:\"Applet Attributes\";s:20:\"applet_new_parameter\";s:13:\"New Parameter\";s:16:\"applet_parameter\";s:9:\"Parameter\";s:17:\"applet_parameters\";s:17:\"Applet Parameters\";s:5:\"apply\";s:5:\"Apply\";s:12:\"assClozeTest\";s:14:\"Cloze Question\";s:19:\"assImagemapQuestion\";s:18:\"Image Map Question\";s:13:\"assJavaApplet\";s:20:\"Java Applet Question\";s:19:\"assMatchingQuestion\";s:17:\"Matching Question\";s:17:\"assMultipleChoice\";s:44:\"Multiple Choice Question (Multiple Response)\";s:10:\"assNumeric\";s:16:\"Numeric Question\";s:19:\"assOrderingQuestion\";s:17:\"Ordering Question\";s:12:\"assQuestions\";s:9:\"Questions\";s:15:\"assSingleChoice\";s:42:\"Multiple Choice Question (Single Response)\";s:15:\"assTextQuestion\";s:14:\"Essay Question\";s:13:\"assTextSubset\";s:20:\"Text Subset Question\";s:22:\"ass_create_export_file\";s:18:\"Create Export File\";s:30:\"ass_create_export_test_results\";s:19:\"Export Test Results\";s:16:\"ass_export_files\";s:12:\"Export Files\";s:8:\"ass_file\";s:4:\"File\";s:12:\"ass_question\";s:8:\"Question\";s:8:\"ass_size\";s:4:\"Size\";s:16:\"available_points\";s:16:\"Available Points\";s:22:\"average_reached_points\";s:22:\"Average Reached Points\";s:17:\"backtocallingtest\";s:24:\"Back to the calling test\";s:2:\"by\";s:2:\"by\";s:11:\"cancel_test\";s:16:\"Suspend the Test\";s:17:\"cannot_edit_marks\";s:154:\"There are already learners who ran the test. You can only change the marks if a score reporting date is enabled and the reporting date is not yet reached.\";s:16:\"cannot_edit_test\";s:59:\"You do not possess sufficient permissions to edit the test!\";s:19:\"cannot_execute_test\";s:58:\"You do not possess sufficient permissions to run the test!\";s:17:\"cannot_export_qpl\";s:70:\"You do not possess sufficient permissions to export the question pool!\";s:18:\"cannot_export_test\";s:61:\"You do not possess sufficient permissions to export the test!\";s:20:\"cannot_maintain_test\";s:63:\"You do not possess sufficient permissions to maintain the test!\";s:24:\"cannot_read_questionpool\";s:73:\"You do not possess sufficient permissions to read the question pool data!\";s:22:\"cannot_save_metaobject\";s:64:\"You do not possess sufficient permissions to save the meta data!\";s:11:\"certificate\";s:11:\"Certificate\";s:15:\"certificate_top\";s:3:\"Top\";s:17:\"certificate_right\";s:5:\"Right\";s:18:\"certificate_bottom\";s:6:\"Bottom\";s:16:\"certificate_left\";s:4:\"Left\";s:14:\"certificate_a4\";s:20:\"A4 (297 mm x 210 mm)\";s:24:\"certificate_a4_landscape\";s:30:\"A4 Landscape (210 mm x 297 mm)\";s:14:\"certificate_a5\";s:20:\"A5 (210 mm x 148 mm)\";s:24:\"certificate_a5_landscape\";s:30:\"A5 Landscape (148 mm x 210 mm)\";s:18:\"certificate_letter\";s:27:\"Letter (11 inch x 8.5 inch)\";s:28:\"certificate_letter_landscape\";s:37:\"Letter Landscape (8.5 inch x 11 inch)\";s:18:\"certificate_custom\";s:9:\"Custom...\";s:16:\"certificate_edit\";s:34:\"Create/Edit a Certificate Template\";s:18:\"certificate_export\";s:18:\"Export Certificate\";s:23:\"certificate_page_format\";s:11:\"Page Format\";s:28:\"certificate_background_image\";s:16:\"Background Image\";s:23:\"certificate_padding_top\";s:11:\"Top Padding\";s:23:\"certificate_margin_body\";s:11:\"Body Margin\";s:27:\"certificate_not_well_formed\";s:91:\"The certificate text is not well formed. Please enter valid XHTML for the certificate text!\";s:16:\"certificate_show\";s:16:\"Show Certificate\";s:18:\"certificate_status\";s:6:\"Status\";s:27:\"certificate_status_complete\";s:45:\"The certificate is complete and could be used\";s:29:\"certificate_status_incomplete\";s:29:\"The certificate is incomplete\";s:18:\"certificate_delete\";s:23:\"Delete Certificate Data\";s:19:\"certificate_preview\";s:24:\"Show Certificate Preview\";s:16:\"certificate_text\";s:16:\"Certificate Text\";s:29:\"certificate_var_user_fullname\";s:12:\"Dr. Jane Doe\";s:30:\"certificate_var_user_firstname\";s:4:\"Jane\";s:29:\"certificate_var_user_lastname\";s:3:\"Doe\";s:26:\"certificate_var_user_title\";s:3:\"Dr.\";s:32:\"certificate_var_user_institution\";s:17:\"ILIAS Open Source\";s:31:\"certificate_var_user_department\";s:16:\"Customer Support\";s:27:\"certificate_var_user_street\";s:15:\"100 Main Street\";s:25:\"certificate_var_user_city\";s:11:\"Anytown, NY\";s:28:\"certificate_var_user_zipcode\";s:5:\"12345\";s:28:\"certificate_var_user_country\";s:3:\"USA\";s:29:\"certificate_var_result_passed\";s:6:\"passed\";s:29:\"certificate_var_result_points\";s:2:\"38\";s:30:\"certificate_var_result_percent\";s:3:\"83%\";s:26:\"certificate_var_max_points\";s:2:\"46\";s:33:\"certificate_var_result_mark_short\";s:1:\"B\";s:32:\"certificate_var_result_mark_long\";s:4:\"Good\";s:18:\"certificate_passed\";s:6:\"passed\";s:18:\"certificate_failed\";s:6:\"failed\";s:22:\"certificate_pageheight\";s:11:\"Page Height\";s:21:\"certificate_pagewidth\";s:10:\"Page Width\";s:22:\"certificate_wrong_unit\";s:29:\"You have entered a wrong unit\";s:23:\"certificate_wrong_units\";s:37:\"You have entered a wrong set of units\";s:33:\"certificate_confirm_deletion_text\";s:70:\"Do you really want to delete the certificate and all its related data?\";s:27:\"certificate_ph_introduction\";s:38:\"The following placeholders may be used\";s:23:\"certificate_ph_fullname\";s:53:\"Full name of the user (title, firstname and lastname)\";s:24:\"certificate_ph_firstname\";s:22:\"First name of the user\";s:23:\"certificate_ph_lastname\";s:21:\"Last name of the user\";s:21:\"certificate_ph_passed\";s:51:\"\"passed\" or \"failed\", depending on the test results\";s:27:\"certificate_ph_resultpoints\";s:26:\"Reached points of the user\";s:28:\"certificate_ph_resultpercent\";s:30:\"Reached percentage of the user\";s:24:\"certificate_ph_maxpoints\";s:24:\"Maximum available points\";s:24:\"certificate_ph_markshort\";s:26:\"Users mark (short version)\";s:23:\"certificate_ph_marklong\";s:29:\"Users mark (official version)\";s:24:\"certificate_ph_testtitle\";s:17:\"Title of the test\";s:19:\"certificate_ph_date\";s:11:\"Actual date\";s:23:\"certificate_ph_datetime\";s:20:\"Actual date and time\";s:20:\"certificate_ph_title\";s:17:\"Title of the user\";s:26:\"certificate_ph_institution\";s:23:\"Institution of the user\";s:25:\"certificate_ph_department\";s:22:\"Department of the user\";s:21:\"certificate_ph_street\";s:28:\"Street of the user\'s address\";s:19:\"certificate_ph_city\";s:26:\"City of the user\'s address\";s:22:\"certificate_ph_zipcode\";s:30:\"ZIP code of the user\'s address\";s:22:\"certificate_ph_country\";s:29:\"Country of the user\'s address\";s:28:\"certificate_unit_description\";s:71:\"Enter units of measure as VALUE[cm|mm|in|pt|pc|px|em], e.g. 10mm or 3in\";s:22:\"certificate_visibility\";s:10:\"Visibility\";s:35:\"certificate_visibility_introduction\";s:65:\"The button in the test results to offer users this certificate is\";s:29:\"certificate_visibility_always\";s:14:\"Always Visible\";s:28:\"certificate_visibility_never\";s:11:\"Not Visible\";s:29:\"certificate_visibility_passed\";s:38:\"Only Visible if a User Passed the Test\";s:24:\"certificate_error_import\";s:52:\"An error occured during the import of a certificate!\";s:32:\"certificate_error_upload_bgimage\";s:59:\"An error occured during the upload of the background image!\";s:41:\"change_properties_from_random_to_standard\";s:237:\"You are about to change your test properties from a random test to a non random test. The information on the question pools you already added to the random test will be removed from test. Do you really want to change the test properties?\";s:41:\"change_properties_from_standard_to_random\";s:257:\"You are about to change your test properties from a non random test to a random test. The questions you already added to the test will be removed, because you have to select question pools for a random test. Do you really want to change the test properties?\";s:15:\"change_solution\";s:25:\"Change Suggested Solution\";s:21:\"changelog_description\";s:86:\"The following table contains all changes of authors which have been made to this test.\";s:17:\"changelog_heading\";s:9:\"Changelog\";s:16:\"checkbox_checked\";s:7:\"Checked\";s:18:\"checkbox_unchecked\";s:9:\"Unchecked\";s:6:\"circle\";s:6:\"Circle\";s:19:\"circle_click_center\";s:43:\"Please click on center of the desired area.\";s:19:\"circle_click_circle\";s:51:\"Please click on a circle point of the desired area.\";s:8:\"clientip\";s:9:\"Client IP\";s:22:\"cloze_fixed_textlength\";s:17:\"Text Field Length\";s:34:\"cloze_fixed_textlength_description\";s:126:\"If you enter a value greater than 0, all text and numeric gap text fields will be created with the fixed length of this value.\";s:15:\"close_text_hint\";s:151:\"You can define a gap by entering [gap][/gap] at the text position of your choice. Press the \'Create gaps\' button to add an editable form for every gap.\";s:10:\"cloze_text\";s:10:\"Cloze Text\";s:30:\"cloze_textgap_case_insensitive\";s:16:\"Case Insensitive\";s:28:\"cloze_textgap_case_sensitive\";s:14:\"Case Sensitive\";s:28:\"cloze_textgap_levenshtein_of\";s:26:\"Levenshtein Distance of %s\";s:20:\"cloze_textgap_rating\";s:15:\"Text Gap Rating\";s:4:\"code\";s:4:\"Code\";s:8:\"codebase\";s:8:\"Codebase\";s:13:\"concatenation\";s:13:\"Concatenation\";s:28:\"confirm_delete_all_user_data\";s:58:\"Are you sure you want to delete all user data of the test?\";s:31:\"confirm_delete_single_user_data\";s:68:\"Are you sure you want to delete the test data of the selected users?\";s:22:\"confirm_sync_questions\";s:143:\"The question you changed is a copy which has been created for use with the active test. Do you want to change the original of the question too?\";s:11:\"coordinates\";s:11:\"Coordinates\";s:19:\"correct_solution_is\";s:23:\"The correct solution is\";s:7:\"counter\";s:7:\"Counter\";s:11:\"create_date\";s:7:\"Created\";s:11:\"create_gaps\";s:11:\"Create Gaps\";s:15:\"create_imagemap\";s:19:\"Create an Image Map\";s:10:\"create_new\";s:10:\"Create New\";s:10:\"definition\";s:10:\"Definition\";s:20:\"delete_all_user_data\";s:29:\"Delete Test Data of all Users\";s:33:\"delete_all_user_data_confirmation\";s:69:\"Do you really want to delete the test data of all users in this test?\";s:11:\"delete_area\";s:11:\"Delete Area\";s:12:\"delete_image\";s:12:\"Delete Image\";s:16:\"delete_user_data\";s:38:\"Delete Test Data of the Selected Users\";s:20:\"description_maxchars\";s:86:\"If nothing entered the maximum number of characters for this text answer is unlimited.\";s:26:\"detail_ending_time_reached\";s:79:\"You have reached the ending time of the test. The test isn\'t available since %s\";s:34:\"detail_max_processing_time_reached\";s:65:\"You have reached the maximum allowed processing time of the test!\";s:32:\"detail_starting_time_not_reached\";s:84:\"You have not reached the starting time of the test. The test will be available on %s\";s:19:\"detailed_evaluation\";s:19:\"Detailed Evaluation\";s:23:\"detailed_evaluation_for\";s:26:\"Detailed Evaluation for %s\";s:37:\"detailed_evaluation_missing_active_id\";s:65:\"You must call the Datailed Evaluation for a selected participant!\";s:24:\"detailed_evaluation_show\";s:24:\"Show Detailed Evaluation\";s:15:\"detailed_output\";s:15:\"Detailed Output\";s:25:\"detailed_output_printview\";s:40:\"Detailed Output with Question Printviews\";s:25:\"detailed_output_solutions\";s:39:\"Detailed Output with Question Solutions\";s:15:\"direct_feedback\";s:20:\"Verify Your Solution\";s:9:\"duplicate\";s:9:\"Duplicate\";s:34:\"duplicate_matching_values_selected\";s:44:\"You have selected duplicate matching values!\";s:30:\"duplicate_order_values_entered\";s:40:\"You have entered duplicate order values!\";s:22:\"ects_allow_ects_grades\";s:43:\"Show ECTS grade additional to received mark\";s:24:\"ects_fill_out_all_values\";s:42:\"Please enter a value for every ECTS grade!\";s:10:\"ects_grade\";s:10:\"ECTS Grade\";s:12:\"ects_grade_a\";s:46:\"outstanding performance with only minor errors\";s:18:\"ects_grade_a_short\";s:9:\"EXCELLENT\";s:12:\"ects_grade_b\";s:47:\"above the average standard but with some errors\";s:18:\"ects_grade_b_short\";s:9:\"VERY GOOD\";s:12:\"ects_grade_c\";s:52:\"generally sound work with a number of notable errors\";s:18:\"ects_grade_c_short\";s:4:\"GOOD\";s:12:\"ects_grade_d\";s:38:\"fair but with significant shortcomings\";s:18:\"ects_grade_d_short\";s:12:\"SATISFACTORY\";s:12:\"ects_grade_e\";s:38:\"performance meets the minimum criteria\";s:18:\"ects_grade_e_short\";s:10:\"SUFFICIENT\";s:12:\"ects_grade_f\";s:37:\"considerable further work is required\";s:18:\"ects_grade_f_short\";s:4:\"FAIL\";s:13:\"ects_grade_fx\";s:56:\"some more work required before the credit can be awarded\";s:19:\"ects_grade_fx_short\";s:4:\"FAIL\";s:26:\"ects_output_of_ects_grades\";s:21:\"Output of ECTS grades\";s:18:\"ects_range_error_a\";s:56:\"Please enter a value between 0 and 100 for ECTS grade A!\";s:18:\"ects_range_error_b\";s:56:\"Please enter a value between 0 and 100 for ECTS grade B!\";s:18:\"ects_range_error_c\";s:56:\"Please enter a value between 0 and 100 for ECTS grade C!\";s:18:\"ects_range_error_d\";s:56:\"Please enter a value between 0 and 100 for ECTS grade D!\";s:18:\"ects_range_error_e\";s:56:\"Please enter a value between 0 and 100 for ECTS grade E!\";s:17:\"ects_use_fx_grade\";s:59:\"Use the \'FX\' grade, if failed participants reached at least\";s:23:\"ects_use_fx_grade_part2\";s:28:\"percent of the total points.\";s:12:\"edit_content\";s:12:\"Edit Content\";s:15:\"edit_properties\";s:15:\"Edit Properties\";s:19:\"edit_test_questions\";s:19:\"Edit Test Questions\";s:17:\"enable_javascript\";s:34:\"Click to enable JavaScript support\";s:18:\"disable_javascript\";s:35:\"Click to disable JavaScript support\";s:7:\"end_tag\";s:7:\"End Tag\";s:19:\"ending_time_reached\";s:32:\"You have reached the ending time\";s:7:\"enlarge\";s:7:\"Enlarge\";s:20:\"enter_anonymous_code\";s:27:\"Enter Anonymous Access Code\";s:28:\"enter_enough_positive_points\";s:130:\"The maxium available points for the question must be greater than 0! Please enter sufficient non negative points for your answers.\";s:32:\"error_random_question_generation\";s:220:\"A fatal error occured during the generation of your random questions for the test. Please contact your administrator with the following information: The system could not create an active ID for user ID %s and test ID %s.\";s:28:\"error_image_upload_copy_file\";s:76:\"There was an error moving the uploaded image file to its destination folder!\";s:31:\"error_image_upload_wrong_format\";s:80:\"Please upload a valid image file! Supported image formats are gif, jpeg and png.\";s:24:\"error_importing_question\";s:77:\"There was an error importing the question(s) from the file you have selected!\";s:21:\"error_open_image_file\";s:28:\"Error opening an image file!\";s:20:\"error_open_java_file\";s:29:\"Error opening an java applet!\";s:21:\"error_save_image_file\";s:27:\"Error saving an image file!\";s:14:\"eval_all_users\";s:24:\"Evaluation for All Users\";s:18:\"eval_choice_result\";s:59:\"The choice with the value %s is %s. You received %s points.\";s:17:\"eval_cloze_result\";s:62:\"Gap number %s with the value %s is %s. You received %s points.\";s:18:\"eval_concatenation\";s:13:\"Concatenation\";s:9:\"eval_data\";s:15:\"Evaluation Data\";s:26:\"eval_found_selected_groups\";s:15:\"Selected Groups\";s:25:\"eval_found_selected_users\";s:14:\"Selected Users\";s:20:\"eval_imagemap_result\";s:54:\"The image map selection is %s. You received %s points.\";s:16:\"eval_java_result\";s:58:\"The answer for the value %s is %s. You received %s points.\";s:16:\"eval_legend_link\";s:72:\"Please refer to the legend for the meaning of the column header symbols.\";s:20:\"eval_matching_result\";s:56:\"The matching pair %s - %s is %s. You received %s points.\";s:17:\"eval_order_result\";s:57:\"The order for the value %s is %s. You received %s points.\";s:18:\"eval_search_groups\";s:6:\"Groups\";s:17:\"eval_search_roles\";s:5:\"Roles\";s:16:\"eval_search_term\";s:11:\"Search Term\";s:17:\"eval_search_users\";s:5:\"Users\";s:25:\"eval_search_userselection\";s:62:\"Search the users you want to add to the statistical evaluation\";s:19:\"eval_selected_users\";s:29:\"Evaluation for Selected Users\";s:13:\"exp_eval_data\";s:25:\"Export evaluation data as\";s:20:\"exp_type_certificate\";s:17:\"Certificate (PDF)\";s:14:\"exp_type_excel\";s:15:\"Microsoft Excel\";s:13:\"exp_type_spss\";s:27:\"Comma Separated Value (CSV)\";s:6:\"export\";s:6:\"Export\";s:36:\"externalscript_additional_parameters\";s:17:\"Script Parameters\";s:22:\"externalscript_use_kvc\";s:53:\"Please use key-value-coding for the script paramters!\";s:41:\"externalscript_additional_parameters_hint\";s:151:\"Enter the additional script parameters in key-value-coding and separate multiple key-value-pairs with a newline, e.g. <p>key1=Hello<br />key2=World</p>\";s:15:\"failed_official\";s:6:\"failed\";s:12:\"failed_short\";s:6:\"failed\";s:5:\"false\";s:5:\"False\";s:16:\"feedback_answers\";s:41:\"Feedback for every answer of the question\";s:26:\"feedback_complete_solution\";s:16:\"Correct solution\";s:28:\"feedback_incomplete_solution\";s:34:\"At least one answer is not correct\";s:26:\"fill_out_all_answer_fields\";s:64:\"Please fill out all answer text fields before you add a new one!\";s:27:\"fill_out_all_matching_pairs\";s:60:\"Please fill out all matching pairs before you add a new one!\";s:39:\"fill_out_all_required_fields_add_answer\";s:59:\"Please fill out all required fields before you add answers!\";s:41:\"fill_out_all_required_fields_add_matching\";s:67:\"Please fill out all required fields before you add a matching pair!\";s:40:\"fill_out_all_required_fields_create_gaps\";s:59:\"Please fill out all required fields before you create gaps!\";s:41:\"fill_out_all_required_fields_upload_image\";s:61:\"Please fill out all required fields before you upload images!\";s:44:\"fill_out_all_required_fields_upload_imagemap\";s:65:\"Please fill out all required fields before you upload image maps!\";s:44:\"fill_out_all_required_fields_upload_material\";s:64:\"Please fill out all required fields before you upload materials!\";s:6:\"filter\";s:6:\"Filter\";s:25:\"filter_all_question_types\";s:18:\"All Question Types\";s:24:\"filter_all_questionpools\";s:18:\"All Question Pools\";s:26:\"filter_show_question_types\";s:19:\"Show Question Types\";s:25:\"filter_show_questionpools\";s:19:\"Show Question Pools\";s:12:\"filter_users\";s:12:\"Filter Users\";s:23:\"fixed_participants_hint\";s:167:\"This test is only accessible for a fixed set of participants shown below. You can change this setting by deactivating the fixed participants checkbox in the %s subtab.\";s:11:\"assFlashApp\";s:17:\"Flash application\";s:9:\"flashfile\";s:10:\"Flash file\";s:16:\"flash_attributes\";s:16:\"Flash attributes\";s:16:\"flash_parameters\";s:16:\"Flash parameters\";s:19:\"add_flash_parameter\";s:19:\"Add Flash Parameter\";s:3:\"gap\";s:3:\"Gap\";s:14:\"gap_definition\";s:14:\"Gap Definition\";s:13:\"gap_selection\";s:13:\"Gap Selection\";s:7:\"general\";s:7:\"General\";s:13:\"glossary_term\";s:13:\"Glossary Term\";s:17:\"graphical_answers\";s:24:\"Graphical Answer Support\";s:22:\"graphical_answers_hide\";s:29:\"Hide Graphical Answer Support\";s:22:\"graphical_answers_show\";s:29:\"Show Graphical Answer Support\";s:6:\"height\";s:6:\"Height\";s:17:\"identical_scoring\";s:17:\"Identical Scoring\";s:22:\"identical_scoring_desc\";s:187:\"If selected, gaps with identical solutions will be scored, even if the same solution was used twice or more. If not selected, only the first occurence of the same solution will be scored.\";s:8:\"imagemap\";s:9:\"Image Map\";s:13:\"imagemap_file\";s:14:\"Image Map File\";s:15:\"imagemap_source\";s:16:\"Image Map Source\";s:17:\"import_errors_qti\";s:63:\"The were errors parsing the QTI file. The import was cancelled.\";s:15:\"import_question\";s:18:\"Import Question(s)\";s:12:\"insert_after\";s:12:\"Insert After\";s:13:\"insert_before\";s:13:\"Insert Before\";s:14:\"internal_links\";s:14:\"Internal Links\";s:21:\"internal_links_update\";s:6:\"Update\";s:10:\"javaapplet\";s:11:\"Java Applet\";s:13:\"keywords_hint\";s:270:\"Enter a list of keywords, separated by spaces or newlines to add an automatic scoring option for the essay question. If any of the keywords will be found in the answertext of the learner, the default score will be set to the maximum available points instead of 0 points.\";s:11:\"last_update\";s:11:\"Last Update\";s:6:\"legend\";s:6:\"Legend\";s:6:\"locked\";s:6:\"locked\";s:25:\"log_answer_changed_points\";s:68:\"Manual change of points of test person %s from %d to %d points by %s\";s:50:\"log_could_not_enter_test_due_to_simultaneous_users\";s:99:\"The user could not enter the test because the maximum number of simultaneous users has been reached\";s:19:\"log_create_new_test\";s:16:\"Created new test\";s:14:\"log_mark_added\";s:10:\"Mark added\";s:16:\"log_mark_changed\";s:12:\"Mark changed\";s:16:\"log_mark_removed\";s:12:\"Mark removed\";s:17:\"log_modified_test\";s:21:\"The test was modified\";s:18:\"log_question_added\";s:26:\"Question added at position\";s:29:\"log_question_position_changed\";s:25:\"Question position changed\";s:20:\"log_question_removed\";s:16:\"Question removed\";s:30:\"log_random_question_pool_added\";s:66:\"Added the question pool \'%s\' with %s questions for the random test\";s:32:\"log_random_question_pool_deleted\";s:46:\"Removed all random question pools for the test\";s:30:\"log_selected_user_data_removed\";s:28:\"Removed test data of user %s\";s:29:\"log_total_amount_of_questions\";s:59:\"Set the total amount of questions for the random test to %s\";s:26:\"log_user_answered_question\";s:47:\"User answered a question and received %s points\";s:21:\"log_user_data_removed\";s:21:\"Removed all user data\";s:23:\"log_user_entered_values\";s:19:\"User entered values\";s:27:\"log_user_not_entered_values\";s:25:\"User did not enter values\";s:11:\"maintenance\";s:11:\"Maintenance\";s:10:\"manscoring\";s:14:\"Manual Scoring\";s:22:\"manscoring_not_allowed\";s:93:\"The Manual Scoring wasn\'t activated for a question type. You are not allowed to use this tab.\";s:22:\"manscoring_select_user\";s:53:\"Please select a participant to set the score manually\";s:30:\"manscoring_questions_not_found\";s:76:\"This test pass does not contain question types which can be scored manually.\";s:23:\"manscoring_results_pass\";s:38:\"Manual scoreable Questions for Pass %s\";s:15:\"manscoring_hint\";s:248:\"You have added at least one question which may require manual scoring. To guarantee a valid presentation of the test results for the participants it is strongly recommended to restrict the access to the test results using a specified date and time.\";s:11:\"mark_schema\";s:11:\"Mark Schema\";s:27:\"match_terms_and_definitions\";s:27:\"Match Terms and Definitions\";s:24:\"match_terms_and_pictures\";s:24:\"Match Terms and Pictures\";s:7:\"matches\";s:7:\"matches\";s:13:\"matching_pair\";s:13:\"Matching Pair\";s:33:\"matching_question_javascript_hint\";s:158:\"Please drag a definition/picture on the right side over a term on the left side and drop the definition/picture to match the term with the definition/picture.\";s:34:\"matching_shuffle_terms_definitions\";s:28:\"Both (Terms and Definitions)\";s:31:\"matching_shuffle_terms_pictures\";s:25:\"Both (Terms and Pictures)\";s:28:\"matching_shuffle_definitions\";s:16:\"Definitions only\";s:25:\"matching_shuffle_pictures\";s:13:\"Pictures only\";s:22:\"matching_shuffle_terms\";s:10:\"Terms only\";s:8:\"material\";s:8:\"Material\";s:17:\"material_download\";s:20:\"Material to Download\";s:13:\"material_file\";s:13:\"Material File\";s:8:\"maxchars\";s:28:\"Maximum Number of Characters\";s:27:\"maximum_nr_of_tries_reached\";s:88:\"You have reached the maximum number of passes for this test. The test cannot be entered!\";s:14:\"maximum_points\";s:23:\"Maxium Available Points\";s:7:\"meaning\";s:7:\"Meaning\";s:19:\"min_percentage_ne_0\";s:80:\"You must define a minimum percentage of 0 percent! The mark schema wasn\'t saved.\";s:22:\"multiline_answers_hide\";s:23:\"Use Single-Line Answers\";s:22:\"multiline_answers_show\";s:22:\"Use Multi-Line Answers\";s:20:\"multiline_terms_hide\";s:21:\"Use Single-Line Terms\";s:20:\"multiline_terms_show\";s:20:\"Use Multi-Line Terms\";s:27:\"negative_points_not_allowed\";s:45:\"You are not allowed to enter negative points!\";s:18:\"next_question_rows\";s:26:\"Questions %d - %d of %d >>\";s:14:\"no_passed_mark\";s:71:\"You must set at least one mark to PASSED! The mark schema wasn\'t saved.\";s:29:\"no_question_selected_for_move\";s:46:\"Please check at least one question to move it!\";s:22:\"no_questions_available\";s:33:\"There are no questions available!\";s:27:\"no_target_selected_for_move\";s:34:\"You must select a target position!\";s:25:\"no_user_or_group_selected\";s:73:\"Please check an option what are you searching for (users, groups, roles)!\";s:18:\"not_worked_through\";s:12:\"Not Answered\";s:16:\"not_yet_accessed\";s:16:\"Not yet accessed\";s:21:\"nr_of_correct_answers\";s:27:\"Number of Requested Answers\";s:35:\"online_exam_show_answer_print_sheet\";s:151:\"You have finished your online exam. To call the answers printview to print out your test results please press the &quot;Answers printview&quot; button.\";s:28:\"online_exam_show_finish_test\";s:146:\"You still have to call the final submission of your online exam. Please press the &quot;Finish the test&quot; button to call the final submission.\";s:17:\"optional_keywords\";s:26:\"Optional input of keywords\";s:2:\"or\";s:2:\"or\";s:14:\"order_pictures\";s:14:\"Order Pictures\";s:11:\"order_terms\";s:11:\"Order Terms\";s:33:\"ordering_question_javascript_hint\";s:192:\"Please drag a definition/picture over the definition/picture where you want to put it and drop it. The underlying definition/picture and all following definitions/pictures will move downwards.\";s:6:\"output\";s:6:\"Output\";s:11:\"output_mode\";s:11:\"Output Mode\";s:12:\"participants\";s:12:\"Participants\";s:17:\"participants_data\";s:17:\"Participants Data\";s:23:\"participants_evaluation\";s:36:\"Evaluation for all Test Participants\";s:23:\"participants_invitation\";s:25:\"Invite Fixed Participants\";s:35:\"participants_invitation_description\";s:169:\"You are able to make this test accessible only for a fixed group of ILIAS users. To enable this functionality, please check the above checkbox and press the Save button.\";s:43:\"participants_invitation_search_introduction\";s:188:\"To add fixed participants to this test, please select the users in the below search form and invite them into the test. All test participants will be shown on the Participants Data subtab.\";s:4:\"pass\";s:4:\"Pass\";s:15:\"passed_official\";s:6:\"passed\";s:11:\"passed_only\";s:17:\"Passed Tests Only\";s:12:\"passed_short\";s:6:\"passed\";s:10:\"percentage\";s:10:\"Percentage\";s:17:\"percentage_solved\";s:46:\"You have solved %.2f percent of this question!\";s:10:\"percentile\";s:10:\"Percentile\";s:7:\"picture\";s:7:\"Picture\";s:13:\"please_select\";s:19:\"-- please select --\";s:5:\"point\";s:5:\"Point\";s:6:\"points\";s:6:\"Points\";s:14:\"points_checked\";s:19:\"Points when Checked\";s:12:\"points_short\";s:3:\"Pt.\";s:16:\"points_unchecked\";s:21:\"Points when Unchecked\";s:7:\"polygon\";s:7:\"Polygon\";s:26:\"polygon_click_next_or_save\";s:140:\"Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)\";s:24:\"polygon_click_next_point\";s:46:\"Please click on the next point of the polygon.\";s:28:\"polygon_click_starting_point\";s:50:\"Please click on the starting point of the polygon.\";s:8:\"postpone\";s:17:\"Postpone Question\";s:9:\"postponed\";s:9:\"postponed\";s:7:\"preview\";s:7:\"Preview\";s:22:\"previous_question_rows\";s:26:\"<< Questions %d - %d of %d\";s:13:\"print_answers\";s:13:\"Print Answers\";s:32:\"qpl_answertext_fields_not_filled\";s:73:\"The question could only be saved, if you fill out all answer text fields!\";s:41:\"qpl_assessment_no_assessment_of_questions\";s:111:\"There is no assessment of questions available for the selected question. The question was never used in a test.\";s:27:\"qpl_assessment_of_questions\";s:23:\"Assessment of Questions\";s:31:\"qpl_assessment_total_of_answers\";s:16:\"Total of Answers\";s:37:\"qpl_assessment_total_of_right_answers\";s:66:\"Total Percentage of Correct Answers (percentage of maximum points)\";s:28:\"qpl_confirm_delete_questions\";s:58:\"Are you sure you want to delete the following question(s)?\";s:25:\"qpl_copy_insert_clipboard\";s:52:\"The selected question(s) are copied to the clipboard\";s:20:\"qpl_copy_select_none\";s:62:\"Please check at least one question to copy it to the clipboard\";s:42:\"qpl_delete_describe_undeleteable_questions\";s:86:\"The following questions are in use in random tests. You cannot delete these questions:\";s:34:\"qpl_delete_no_deleteable_questions\";s:61:\"All questions you tried to delete are in use in a random test\";s:21:\"qpl_delete_rbac_error\";s:43:\"You have no rights to delete this question!\";s:22:\"qpl_delete_select_none\";s:47:\"Please check at least one question to delete it\";s:26:\"qpl_display_fullsize_image\";s:41:\"Click here to display the original image!\";s:19:\"qpl_edit_rbac_error\";s:41:\"You have no rights to edit this question!\";s:24:\"qpl_edit_select_multiple\";s:42:\"Please check only one question for editing\";s:20:\"qpl_edit_select_none\";s:37:\"Please check one question for editing\";s:16:\"qpl_export_excel\";s:20:\"Microsoft Excel File\";s:22:\"qpl_export_select_none\";s:47:\"Please check at least one question to export it\";s:14:\"qpl_export_xml\";s:12:\"QTI XML File\";s:22:\"qpl_general_properties\";s:18:\"General Properties\";s:28:\"qpl_imagemap_preview_missing\";s:304:\"ILIAS could not create the temporary preview file containing the imagemap areas. The original image is shown instead. This means that either the webserver\'s ImageMagick tool isn\'t configured correctly or there are no write permissions in the temporary directory! Please contact your system administrator.\";s:25:\"qpl_import_create_new_qpl\";s:43:\"Import the questions in a new question pool\";s:19:\"qpl_import_no_items\";s:45:\"Error: The import file contains no questions!\";s:26:\"qpl_import_non_ilias_files\";s:163:\"Error: The import file contains QTI files which are not created by an ILIAS system. Please contact the ILIAS team to get in import filter for your QTI file format.\";s:33:\"qpl_import_verify_found_questions\";s:103:\"ILIAS found the following questions in the import file. Please select the questions you want to import.\";s:25:\"qpl_move_insert_clipboard\";s:46:\"The selected question(s) are marked for moving\";s:20:\"qpl_move_select_none\";s:58:\"Please check at least one question to select it for moving\";s:19:\"qpl_online_property\";s:6:\"Online\";s:31:\"qpl_online_property_description\";s:50:\"Only online question pools could be used in tests.\";s:20:\"qpl_paste_no_objects\";s:91:\"There are no questions in the clipboard. Please copy or move a question into the clipboard.\";s:17:\"qpl_paste_success\";s:55:\"The question(s) have been pasted into the question pool\";s:22:\"qpl_question_is_in_use\";s:216:\"The question you are about to edit exists in %s test(s). If you change this question, you will NOT change the question(s) in the test(s), because the system creates a copy of a question when it is inserted in a test!\";s:21:\"qpl_questions_deleted\";s:20:\"Question(s) deleted.\";s:26:\"qpl_select_file_for_import\";s:34:\"You must select a file for import!\";s:18:\"qt_multiple_choice\";s:24:\"Multiple Choice Question\";s:29:\"question_cumulated_statistics\";s:29:\"Cumulated Question Statistics\";s:24:\"question_instances_title\";s:44:\"This question is used in the following tests\";s:16:\"question_marking\";s:21:\"Show Question Marking\";s:28:\"question_marking_description\";s:281:\"If checked, every participant gets the possibility to mark every question of a test with a marker symbol to indicate that something has to be done with a question (e.g. check again, answered, not answered etc.). The markers are also visible in the list of questions (if available).\";s:21:\"question_not_answered\";s:29:\"The question was not answered\";s:25:\"question_saved_for_upload\";s:224:\"The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!\";s:14:\"question_short\";s:1:\"Q\";s:16:\"question_summary\";s:17:\"List of Questions\";s:14:\"question_title\";s:14:\"Question Title\";s:13:\"question_type\";s:13:\"Question Type\";s:24:\"questionpool_not_entered\";s:40:\"Please enter a name for a question pool!\";s:14:\"questions_from\";s:14:\"questions from\";s:9:\"radio_set\";s:3:\"Set\";s:11:\"radio_unset\";s:5:\"Unset\";s:20:\"random_accept_sample\";s:13:\"Accept Sample\";s:21:\"random_another_sample\";s:18:\"Get another Sample\";s:16:\"random_selection\";s:16:\"Random Selection\";s:5:\"range\";s:5:\"Range\";s:17:\"range_lower_limit\";s:11:\"Lower Bound\";s:17:\"range_upper_limit\";s:11:\"Upper Bound\";s:9:\"rectangle\";s:9:\"Rectangle\";s:25:\"rectangle_click_br_corner\";s:60:\"Please click on the bottom right corner of the desired area.\";s:25:\"rectangle_click_tl_corner\";s:56:\"Please click on the top left corner of the desired area.\";s:6:\"region\";s:6:\"Region\";s:21:\"remove_as_participant\";s:27:\"Remove as Fixed Participant\";s:15:\"remove_question\";s:6:\"Remove\";s:15:\"remove_solution\";s:25:\"Remove Suggested Solution\";s:23:\"report_date_not_reached\";s:88:\"You have not reached the reporting date. You will be able to view the test results at %s\";s:12:\"reset_filter\";s:12:\"Reset Filter\";s:11:\"reset_terms\";s:20:\"Reset Term Positions\";s:6:\"result\";s:6:\"Result\";s:23:\"result_successful_saved\";s:40:\"Your results have been saved successful!\";s:25:\"result_unsuccessful_saved\";s:47:\"There was an error saving the question results!\";s:27:\"save_before_upload_imagemap\";s:63:\"You must apply your changes before you can upload an image map!\";s:29:\"save_before_upload_javaapplet\";s:64:\"You must apply your changes before you can upload a Java applet!\";s:9:\"save_edit\";s:21:\"Save and Edit Content\";s:15:\"mark_tst_failed\";s:75:\"Sorry, you failed the test.<br />Your resulting mark is: &quot;[mark]&quot;\";s:15:\"mark_tst_passed\";s:85:\"Congratulations, you passed the test.<br />Your resulting mark is: &quot;[mark]&quot;\";s:13:\"mark_tst_ects\";s:41:\"Your ECTS grade is &quot;[markects]&quot;\";s:11:\"save_finish\";s:15:\"Finish the Test\";s:17:\"save_introduction\";s:18:\"Go to Introduction\";s:9:\"save_next\";s:4:\"Next\";s:13:\"save_previous\";s:8:\"Previous\";s:23:\"save_text_answer_points\";s:17:\"Save Essay Points\";s:11:\"scored_pass\";s:11:\"Scored Pass\";s:7:\"scoring\";s:19:\"Scoring and Results\";s:19:\"search_found_groups\";s:12:\"Found Groups\";s:18:\"search_found_users\";s:11:\"Found Users\";s:13:\"search_groups\";s:13:\"Search Groups\";s:14:\"search_results\";s:14:\"Search Results\";s:12:\"search_roles\";s:12:\"Search Roles\";s:11:\"search_term\";s:11:\"Search Term\";s:12:\"search_users\";s:12:\"Search Users\";s:35:\"see_details_for_further_information\";s:35:\"See details for suggested solutions\";s:16:\"select_an_answer\";s:31:\"--- Please select an answer ---\";s:10:\"select_gap\";s:10:\"Select Gap\";s:17:\"number_of_answers\";s:17:\"Number of Answers\";s:11:\"numeric_gap\";s:11:\"Numeric Gap\";s:19:\"select_max_one_item\";s:27:\"Please select one item only\";s:25:\"select_one_submitted_test\";s:53:\"Please select at least one user who finished the test\";s:15:\"select_one_user\";s:31:\"Please select at least one user\";s:17:\"select_qpl_option\";s:37:\"--- Please select a question pool ---\";s:40:\"select_target_position_for_move_question\";s:92:\"Please select a target position to move the question(s) and press one of the insert buttons!\";s:17:\"select_tst_option\";s:28:\"--- Please select a test ---\";s:14:\"selected_image\";s:14:\"Selected Image\";s:13:\"set_edit_mode\";s:13:\"Set Edit Mode\";s:10:\"set_filter\";s:10:\"Set Filter\";s:19:\"set_manual_feedback\";s:19:\"Set Manual Feedback\";s:5:\"shape\";s:5:\"Shape\";s:18:\"show_pass_overview\";s:25:\"Show Marked Pass Overview\";s:17:\"show_user_answers\";s:26:\"Show User\'s Marked Answers\";s:21:\"show_detailed_results\";s:42:\"Show User\'s Detailed Results (Marked Pass)\";s:15:\"shuffle_answers\";s:15:\"Shuffle Answers\";s:13:\"solution_hint\";s:18:\"Suggested Solution\";s:29:\"solution_may_contain_keywords\";s:54:\"The solution may contain one of the following keywords\";s:14:\"solution_order\";s:14:\"Solution Order\";s:9:\"start_tag\";s:9:\"Start Tag\";s:25:\"starting_time_not_reached\";s:38:\"You have not reached the starting time\";s:16:\"statistical_data\";s:16:\"Statistical Data\";s:10:\"statistics\";s:10:\"Statistics\";s:37:\"suggested_solution_added_successfully\";s:42:\"You successfully set a suggested solution!\";s:6:\"symbol\";s:6:\"Symbol\";s:4:\"term\";s:4:\"Term\";s:14:\"test_cancelled\";s:22:\"The test was cancelled\";s:14:\"test_reference\";s:14:\"Test Reference\";s:18:\"text_answers_saved\";s:22:\"Essay points modified!\";s:8:\"text_gap\";s:8:\"Text Gap\";s:26:\"text_maximum_chars_allowed\";s:91:\"Please do not enter more than a maximum of %s characters. Any characters above will be cut.\";s:11:\"text_rating\";s:20:\"Text Matching Method\";s:11:\"time_format\";s:8:\"HH MM SS\";s:25:\"too_many_empty_parameters\";s:76:\"Please fill out your empty applet parameters before you add a new parameter!\";s:4:\"true\";s:4:\"True\";s:23:\"tst_access_code_created\";s:204:\"To provide you with permanent access to your test results and to offer you a possibility to resume this test, a unique test access code was created. Please write down this code use it for further actions.\";s:25:\"tst_all_user_data_deleted\";s:44:\"All user data of this test has been deleted!\";s:28:\"tst_allow_fixed_participants\";s:37:\"Allow fixed participants in this test\";s:30:\"tst_allow_instant_verification\";s:37:\"Allow instant verification of answers\";s:17:\"tst_allowed_users\";s:55:\"Maximum Number of Users Running the Test Simultaneously\";s:26:\"tst_allowed_users_time_gap\";s:26:\"Idle Time for Active Users\";s:21:\"tst_already_submitted\";s:43:\"Test has already been finish and submitted.\";s:17:\"tst_already_taken\";s:19:\"Tests Already Taken\";s:13:\"tst_anonymity\";s:9:\"Anonymity\";s:25:\"tst_anonymity_description\";s:75:\"If Anonymity is enabled, the names of the test participants are anonymized.\";s:16:\"tst_answer_sheet\";s:17:\"Test Answer Sheet\";s:22:\"tst_answered_questions\";s:18:\"Answered Questions\";s:20:\"tst_best_solution_is\";s:20:\"The best solution is\";s:24:\"tst_browse_for_questions\";s:20:\"Browse for Questions\";s:22:\"tst_change_points_done\";s:55:\"The Points of an answer have been changed successfully!\";s:26:\"tst_change_points_not_done\";s:93:\"Could not change the Points of an answer! Please check the allowed range of available points.\";s:30:\"tst_change_points_for_question\";s:32:\"Change the Points for the Answer\";s:26:\"tst_confirm_delete_results\";s:287:\"You are about to delete all your previous entered question results of this test. This will reset all questions to its default values. Please note, that you cannot reset the number of passes, you already needed for this test. Do you really want to reset all your previous entered results?\";s:31:\"tst_confirm_delete_results_info\";s:90:\"Your previous entered question results were deleted. You have successfully reset the test!\";s:17:\"tst_confirm_print\";s:111:\"Press button to print all questions with points and solution. The question always appears at the end of a page.\";s:26:\"tst_confirm_submit_answers\";s:123:\"Please confirm your submission of your solution. You won\'t be able to revert your answers after pressing the submit button.\";s:27:\"tst_count_correct_solutions\";s:29:\"Count Only Complete Solutions\";s:28:\"tst_count_system_description\";s:270:\"If partial solutions are counted, the points for a question are given dependent on the answers of a participant. If only complete solutions are counted, a participant must reach the maximum available points for a question, otherwise the resulting points are set to zero.\";s:27:\"tst_count_partial_solutions\";s:23:\"Count Partial Solutions\";s:20:\"tst_defaults_applied\";s:45:\"The selected test defaults have been applied.\";s:31:\"tst_defaults_apply_not_possible\";s:134:\"ILIAS could not apply the selected test defaults to this test! Maybe this test already contains questions and/or participant datasets.\";s:29:\"tst_defaults_apply_select_one\";s:79:\"Please select exact one test defaults entry to apply the defaults to this test!\";s:22:\"tst_defaults_available\";s:23:\"Available test defaults\";s:29:\"tst_defaults_defaults_of_test\";s:28:\"the settings of this test as\";s:21:\"tst_defaults_dont_use\";s:35:\"--- Use the ILIAS test defaults ---\";s:23:\"tst_defaults_enter_name\";s:43:\"Please enter a name for your test defaults!\";s:24:\"tst_defaults_not_defined\";s:45:\"You don\'t have any test defaults defined yet.\";s:24:\"tst_delete_all_user_data\";s:20:\"Delete all User Data\";s:23:\"tst_delete_missing_mark\";s:49:\"Please select at least one mark step to delete it\";s:18:\"tst_delete_results\";s:10:\"Reset Test\";s:15:\"tst_ending_time\";s:11:\"Ending Time\";s:22:\"tst_enter_questionpool\";s:71:\"Please enter a question pool name where the new question will be stored\";s:33:\"tst_eval_no_anonymous_aggregation\";s:90:\"No one has entered the test yet. There are no anonymous aggregated test results available.\";s:24:\"tst_eval_question_points\";s:28:\"Question Results for Pass %s\";s:24:\"tst_eval_results_by_pass\";s:27:\"List of Answers for Pass %s\";s:20:\"tst_eval_show_answer\";s:11:\"Show Answer\";s:23:\"tst_eval_total_finished\";s:79:\"Total Finished Tests (users who submitted the test with the finish test button)\";s:36:\"tst_eval_total_finished_average_time\";s:28:\"Average Test Processing Time\";s:21:\"tst_eval_total_passed\";s:18:\"Total Passed Tests\";s:36:\"tst_eval_total_passed_average_points\";s:30:\"Average Points of Passed Tests\";s:34:\"tst_eval_total_passed_average_time\";s:43:\"Average Processing Time of all Passed Tests\";s:22:\"tst_eval_total_persons\";s:44:\"Total number of persons who started the test\";s:20:\"tst_eval_user_answer\";s:11:\"User Answer\";s:25:\"tst_finish_confirm_button\";s:30:\"Yes, I want to finish the test\";s:32:\"tst_finish_confirm_cancel_button\";s:36:\"No, go back to the previous question\";s:41:\"tst_finish_confirm_list_of_answers_button\";s:34:\"No, go back to the List of Answers\";s:32:\"tst_finish_confirmation_question\";s:192:\"You are going to finish this test and reach the maximum number of allowed test passes. You won\'t be able to enter this test again to change your answers. Do you really want to finish the test?\";s:12:\"tst_finished\";s:8:\"Finished\";s:34:\"tst_fixed_participants_data_exists\";s:109:\"There are already participants who ran the test. You are not allowed to change the fixed participants status!\";s:30:\"tst_fixed_participants_disable\";s:21:\"Confirm Status Change\";s:42:\"tst_fixed_participants_disable_description\";s:192:\"You are about to disable the support for fixed participants in this test. All fixed participants who did not start the test yet will be removed from the test. Are you sure you want to proceed?\";s:22:\"tst_general_properties\";s:18:\"General Properties\";s:16:\"tst_generate_xls\";s:14:\"Generate Excel\";s:19:\"tst_heading_scoring\";s:7:\"Scoring\";s:25:\"tst_hide_previous_results\";s:21:\"Hide Previous Results\";s:37:\"tst_hide_previous_results_description\";s:102:\"If checked, the previous results of a learner will not be used as default values in future test passes\";s:30:\"tst_hide_previous_results_hide\";s:41:\"Hide my results from a previous test pass\";s:38:\"tst_hide_previous_results_introduction\";s:118:\"If you\'re processing more than one pass of this test, your previous entered results will not be used as default values\";s:19:\"tst_import_no_items\";s:45:\"Error: The import file contains no questions!\";s:33:\"tst_import_verify_found_questions\";s:123:\"ILIAS found the following questions in the test import file. Please select the questions you want to import with this test.\";s:34:\"tst_in_use_edit_questions_disabled\";s:97:\"The test is in use by %d user(s). You are not allowed to edit or move the questions in this test!\";s:27:\"tst_insert_missing_question\";s:63:\"Please select at least one question to insert it into the test!\";s:20:\"tst_insert_questions\";s:70:\"Are you sure you want to insert the following question(s) to the test?\";s:32:\"tst_insert_questions_and_results\";s:194:\"This test was already executed by %s user(s). Inserting questions to this test will remove all test results of these users. Are you sure you want to insert the following question(s) to the test?\";s:20:\"tst_instant_feedback\";s:16:\"Instant Feedback\";s:36:\"tst_instant_feedback_answer_specific\";s:29:\"Show Answer-Specific Feedback\";s:28:\"tst_instant_feedback_results\";s:26:\"Show Results (only points)\";s:29:\"tst_instant_feedback_solution\";s:14:\"Show Solutions\";s:32:\"tst_instant_feedback_description\";s:394:\"If one of the options is selected, the instant feedback information will be shown directly after a participant answered a question. If answer-specific feedback is selected, the predefined feedback will be shown, depending on the answers of the participant. If results (in points) are selected, the reached points will be shown. If solutions are selected, the correct solution will be shown too.\";s:24:\"tst_instant_verification\";s:20:\"Instant Verification\";s:16:\"tst_introduction\";s:12:\"Introduction\";s:26:\"tst_invited_selected_users\";s:61:\"The selected users have been added as fixed test participants\";s:27:\"tst_invited_selected_groups\";s:62:\"The selected groups have been added as fixed test participants\";s:26:\"tst_invited_selected_roles\";s:61:\"The selected roles have been added as fixed test participants\";s:18:\"tst_invited_nobody\";s:68:\"No users, groups or roles have been added as fixed test participants\";s:19:\"tst_list_of_answers\";s:15:\"List of Answers\";s:25:\"tst_list_of_questions_yes\";s:19:\"Yes, and additional\";s:27:\"tst_list_of_questions_start\";s:54:\"Show the List of Questions prior to the first question\";s:25:\"tst_list_of_questions_end\";s:65:\"Show the List of Questions before a participant finishes the test\";s:38:\"tst_list_of_questions_with_description\";s:55:\"Show the question descriptions in the List of Questions\";s:19:\"tst_participants_no\";s:38:\"Nobody has started the test right now!\";s:25:\"tst_participants_no_fixed\";s:62:\"There is nobody assigned as a fixed participant for this test!\";s:8:\"tst_mark\";s:4:\"Mark\";s:29:\"tst_mark_create_new_mark_step\";s:20:\"Create New Mark Step\";s:34:\"tst_mark_create_simple_mark_schema\";s:25:\"Create Simple Mark Schema\";s:22:\"tst_mark_minimum_level\";s:20:\"Minimum Level (in %)\";s:22:\"tst_mark_official_form\";s:13:\"Official Form\";s:15:\"tst_mark_passed\";s:6:\"Passed\";s:19:\"tst_mark_short_form\";s:10:\"Short Form\";s:21:\"tst_max_allowed_users\";s:24:\"Participants Restriction\";s:29:\"tst_max_allowed_users_heading\";s:70:\"The maximum number of simultaneous users in this test has been reached\";s:29:\"tst_max_allowed_users_message\";s:264:\"The maximum number of simultaneous active users in the test has been reached. Please try again later to start or resume the test. If one of the active users is inactive for more than %s seconds, you may be able to enter this test. Thank you for your understanding.\";s:18:\"tst_maximum_points\";s:14:\"Maximum Points\";s:18:\"tst_missing_author\";s:89:\"You have not entered the authors name in the test properties! Please add an authors name.\";s:17:\"tst_missing_marks\";s:96:\"You do not have a mark schema in the test! Please add at least a simple mark schema to the test.\";s:21:\"tst_missing_questions\";s:90:\"You do not have any questions in the test! Please add at least one question into the test.\";s:17:\"tst_missing_title\";s:87:\"You have not entered a test title! Please go to the metadata section and enter a title.\";s:23:\"tst_must_be_online_exam\";s:47:\"This option is only available for online exams!\";s:24:\"tst_no_export_randomtest\";s:172:\"You cannot export a test with random selection of questions, because every used question pool has to be exported too which leads to enormous complexity of the export files.\";s:22:\"tst_no_evaluation_data\";s:38:\"There is no evaluation data available.\";s:20:\"tst_no_marks_defined\";s:72:\"There are no marks defined, please create at least a simple mark schema!\";s:35:\"tst_no_more_available_questionpools\";s:42:\"There are no more question pools available\";s:36:\"tst_no_question_selected_for_removal\";s:48:\"Please check at least one question to remove it!\";s:36:\"tst_no_questionpools_for_random_test\";s:98:\"You have not added a question pool for this random test! Please select at least one question pool.\";s:26:\"tst_no_questions_available\";s:91:\"There are no questions available! You need to create new questions or browse for questions.\";s:32:\"tst_no_questions_for_random_test\";s:170:\"You have taken no questions from the questionspools for this random test! Please take at least one question by setting the amount of questions for an added question pool.\";s:25:\"tst_no_solution_available\";s:55:\"Short answer questions don\'t have a specified solution.\";s:18:\"tst_no_taken_tests\";s:25:\"There are no taken tests!\";s:12:\"tst_no_tries\";s:4:\"none\";s:16:\"tst_nr_of_passes\";s:21:\"Number of Test Passes\";s:15:\"tst_nr_of_tries\";s:21:\"Max. Number of Passes\";s:23:\"tst_nr_of_tries_of_user\";s:24:\"Passes Already Completed\";s:23:\"tst_participating_users\";s:19:\"Participating Users\";s:29:\"tst_fixed_participating_users\";s:31:\"Fixed Participants in this Test\";s:18:\"tst_pass_best_pass\";s:19:\"Score the Best Pass\";s:16:\"tst_pass_details\";s:12:\"Pass Details\";s:18:\"tst_pass_last_pass\";s:19:\"Score the Last Pass\";s:28:\"tst_pass_scoring_description\";s:301:\"If the last pass is scored, the last test pass of a participant will be used to calculate the test results. If the best pass is scored, the test pass with the highest number of reached points will be chosen a test result. This setting only has effect, if more than one test pass is allowed for a test.\";s:16:\"tst_pass_scoring\";s:21:\"Multiple Pass Scoring\";s:10:\"tst_passes\";s:11:\"Test Passes\";s:12:\"tst_password\";s:13:\"Test Password\";s:20:\"tst_password_details\";s:101:\"If you define a test password, all users with test access must enter this password to start the test.\";s:35:\"tst_password_entered_wrong_password\";s:70:\"You cannot start the test because you entered the wrong test password!\";s:25:\"tst_password_introduction\";s:101:\"This test can only be accessed with a test password. Please enter the test password to start the test\";s:18:\"tst_percent_solved\";s:14:\"Percent Solved\";s:12:\"tst_position\";s:17:\"Question %s of %s\";s:12:\"tst_postpone\";s:18:\"Postpone Questions\";s:24:\"tst_postpone_description\";s:63:\"The participants may postpone questions to the end of the test.\";s:9:\"tst_print\";s:28:\"Test & Assessment Print View\";s:14:\"tst_print_date\";s:13:\"Date of Print\";s:19:\"tst_processing_time\";s:20:\"Max. Processing Time\";s:24:\"tst_processing_time_desc\";s:166:\"The maximum processing time starts from the time when a user starts a test for the first time and ends after the expiration of the entered hours, minutes and seconds.\";s:14:\"tst_properties\";s:15:\"Test Properties\";s:13:\"tst_qst_order\";s:5:\"Order\";s:19:\"tst_qst_resetsolved\";s:12:\"Set Unsolved\";s:20:\"tst_qst_result_sheet\";s:17:\"Show Result Sheet\";s:17:\"tst_qst_setsolved\";s:10:\"Set Solved\";s:20:\"tst_qst_summary_text\";s:75:\"Here you can see all questions. Use the bulbs to mark a question as solved.\";s:15:\"tst_question_no\";s:5:\"Order\";s:18:\"tst_question_offer\";s:53:\"Do you accept this sample or do you want another one?\";s:22:\"tst_question_selection\";s:18:\"Question Selection\";s:34:\"tst_question_selection_description\";s:287:\"If you only use question pools which contain questions with an equal maximum number of available points, the test will have an equal number of maximum points for all participating users and thus the test results will be better comparable. It is recommended to choose this selection mode.\";s:28:\"tst_question_selection_equal\";s:44:\"Use question pools with equal maximum points\";s:17:\"tst_question_mark\";s:18:\"Mark this question\";s:19:\"tst_question_marked\";s:23:\"You marked the question\";s:19:\"tst_question_marker\";s:6:\"Marker\";s:19:\"tst_question_unmark\";s:33:\"Remove the mark for this question\";s:18:\"tst_question_title\";s:5:\"Title\";s:17:\"tst_question_type\";s:13:\"Question Type\";s:22:\"tst_questions_inserted\";s:21:\"Question(s) inserted!\";s:21:\"tst_questions_removed\";s:20:\"Question(s) removed!\";s:26:\"tst_random_nr_of_questions\";s:19:\"How many questions?\";s:25:\"tst_random_qpl_unselected\";s:90:\"There is at least one unselected question pool! You don\'t need to add a new question pool.\";s:24:\"tst_random_questionpools\";s:21:\"Source Question Pools\";s:30:\"tst_random_select_questionpool\";s:53:\"Select the question pool to choose the questions from\";s:20:\"tst_random_selection\";s:29:\"Random Selection of Questions\";s:44:\"tst_random_selection_question_count_too_high\";s:140:\"The question count you entered was higher than the maximum number of available questions. The question count has been reduced automatically.\";s:50:\"tst_random_selection_question_total_count_too_high\";s:172:\"The question count you entered was higher than the maximum number of available questions for all selected question pools. The question count has been reduced automatically.\";s:15:\"tst_random_test\";s:11:\"Random Test\";s:27:\"tst_random_test_description\";s:142:\"If checked, the questions of the test will be chosen randomly from question pools. ILIAS generates a new random selection for every test pass.\";s:18:\"tst_reached_points\";s:14:\"Reached Points\";s:20:\"tst_remove_questions\";s:72:\"Are you sure you want to remove the following question(s) from the test?\";s:32:\"tst_remove_questions_and_results\";s:197:\"This test was already executed by %s user(s). Removing questions from this test will remove all test results of these users. Are you sure you want to remove the following question(s) from the test?\";s:31:\"tst_report_after_first_question\";s:49:\"Offer test results when the test has been started\";s:25:\"tst_report_after_question\";s:37:\"Allow instant verification of answers\";s:21:\"tst_report_after_test\";s:44:\"Offer test results when the test is finished\";s:21:\"tst_report_after_date\";s:34:\"After a fixed score reporting date\";s:25:\"tst_reset_processing_time\";s:53:\"Reset the maximum processing time for every test pass\";s:30:\"tst_reset_processing_time_desc\";s:224:\"If checked, the maximum processing time will be reset back to the defined maximum processing time after a test pass has been finished. This setting only works with an enabled maximum processing time and multiple test passes.\";s:20:\"tst_result_user_name\";s:19:\"Test Results for %s\";s:25:\"tst_result_user_name_pass\";s:30:\"Results of Test Pass %s for %s\";s:11:\"tst_results\";s:12:\"Test Results\";s:18:\"tst_results_access\";s:22:\"Access to Test Results\";s:27:\"tst_results_access_finished\";s:22:\"After Test is Finished\";s:23:\"tst_results_access_date\";s:4:\"Date\";s:25:\"tst_results_access_always\";s:6:\"Always\";s:30:\"tst_results_access_description\";s:749:\"This setting handles the access of the participants to their test results. If results can be accessed after the test is finished, the participants can access their test results after they finished a test pass for the first time. Even if a test has more than one allowed test pass, the participants can access their test results after finishing the first pass. If you choose a date access restriction, the participants will not be able to access their test results until the specified date and time is reached. You must choose this option if you want to use the ECTS scoring system of if you have to score questions manually. If \"Always\" is selected, the participants can access their test results at any time even if the did not finish the test yet.\";s:22:\"tst_results_aggregated\";s:23:\"Aggregated Test Results\";s:27:\"tst_results_back_evaluation\";s:27:\"Back to Evaluation Overview\";s:29:\"tst_results_back_introduction\";s:20:\"Back to Introduction\";s:25:\"tst_results_back_overview\";s:24:\"Back to Results Overview\";s:20:\"tst_results_overview\";s:33:\"Pass Overview of the Test Results\";s:25:\"tst_results_overview_pass\";s:28:\"Results Overview for Pass %s\";s:24:\"tst_results_presentation\";s:25:\"Test Results Presentation\";s:15:\"tst_resume_test\";s:15:\"Resume the Test\";s:22:\"tst_score_cut_question\";s:32:\"Cut off Negative Question Points\";s:18:\"tst_score_cut_test\";s:28:\"Cut off Negative Test Points\";s:29:\"tst_score_cutting_description\";s:315:\"If Negative Question Points are cut off, the results for each question that a participant answers with a result of less than zero points will be set to zero points. If Negative Test Points are cut off, the results for the test will be set to zero points, if the sum of all question results is less than zero points.\";s:17:\"tst_score_cutting\";s:23:\"Cut off Negative Points\";s:24:\"tst_score_mcmr_questions\";s:25:\"Multiple Choice Questions\";s:33:\"tst_score_mcmr_use_scoring_system\";s:21:\"Use the Defined Score\";s:36:\"tst_score_mcmr_questions_description\";s:219:\"If \"Score 0 Points for Unchecked Answers\" is selected, multiple choice questions without a selected check box will be scored with zero points, otherwise every check box will be scored dependent to the predefined points.\";s:42:\"tst_score_mcmr_zero_points_when_unanswered\";s:36:\"Score 0 Points for Unchecked Answers\";s:19:\"tst_score_reporting\";s:15:\"Score Reporting\";s:24:\"tst_score_reporting_date\";s:20:\"Score Reporting Date\";s:14:\"tst_score_type\";s:20:\"Score Reporting Type\";s:26:\"tst_select_file_for_import\";s:34:\"You must select a file for import!\";s:15:\"tst_select_qpls\";s:45:\"Please select a question pool for duplication\";s:23:\"tst_select_questionpool\";s:59:\"Please select a question pool to store the created question\";s:24:\"tst_select_questionpools\";s:61:\"Please select a question pool to store the imported questions\";s:27:\"tst_select_random_questions\";s:75:\"Select the question pool(s) and the amount of questions for the random test\";s:15:\"tst_select_tsts\";s:36:\"Please select a test for duplication\";s:30:\"tst_selected_user_data_deleted\";s:62:\"The test data of the selected user(s) was deleted successfully\";s:12:\"tst_sequence\";s:8:\"Sequence\";s:18:\"tst_sequence_fixed\";s:34:\"The Sequence of Questions is Fixed\";s:21:\"tst_sequence_postpone\";s:52:\"Questions may be postponed to the end of a test pass\";s:23:\"tst_sequence_properties\";s:19:\"Sequence Properties\";s:20:\"tst_session_settings\";s:16:\"Session Settings\";s:21:\"tst_set_feedback_done\";s:34:\"The Manual Feedback has been saved\";s:25:\"tst_set_feedback_not_done\";s:56:\"An Error occured! The Manual Feedback has not been saved\";s:24:\"tst_list_of_answers_show\";s:20:\"Show List of Answers\";s:21:\"tst_show_answer_sheet\";s:12:\"Show Answers\";s:15:\"tst_show_cancel\";s:24:\"Show Suspend Test Option\";s:27:\"tst_show_cancel_description\";s:72:\"If checked, a button to suspend the test is shown during test execution.\";s:16:\"tst_title_output\";s:21:\"Question Title Output\";s:21:\"tst_title_output_full\";s:41:\"Show Question Titles and Available Points\";s:28:\"tst_title_output_hide_points\";s:25:\"Show only Question Titles\";s:25:\"tst_title_output_no_title\";s:55:\"Don\'t show the Question Titles and the Available Points\";s:28:\"tst_title_output_description\";s:117:\"Select one of the above options for the presentation of the question titles and the available points during the test.\";s:24:\"tst_use_previous_answers\";s:20:\"Use Previous Answers\";s:36:\"tst_use_previous_answers_description\";s:173:\"If checked, a participant may choose to use the previous answers as default values in future test passes, otherwise the previous answers are not shown in future test passes.\";s:29:\"tst_use_previous_answers_user\";s:63:\"Use my previous answers as default values in future test passes\";s:29:\"tst_dont_use_previous_answers\";s:78:\"Your previous answers will not be used as default values in future test passes\";s:16:\"tst_show_results\";s:17:\"Show Test Results\";s:21:\"tst_show_pass_details\";s:35:\"Show Pass Details for running tests\";s:25:\"tst_show_solution_details\";s:30:\"Show Solutions in Test Results\";s:27:\"tst_show_solution_signature\";s:26:\"Show Signature Placeholder\";s:30:\"tst_show_solution_answers_only\";s:33:\"Results print view (answers only)\";s:27:\"tst_show_solution_printview\";s:20:\"Show List of Answers\";s:26:\"tst_show_solution_feedback\";s:45:\"Show Answer-Specific Feedback in Test Results\";s:36:\"tst_results_presentation_description\";s:1140:\"If \"Show Pass Details for running tests\" is selected, the question titles and the reached points for every question in the test pass are available if the test is not finished. If \"Show Solutions in Test Results\" is selected, the detailed question solution is available for participants in the test results presentation. This includes the exact scoring of every answer, otherwise only an overview with the question titles and the reached points is shown. If the list of answers is selected, an overview of all questions with the answers of the participant is generated. This list will be offered on the Info Page and at the end of a test prior to the final submission. If \"Show Answer-Specific Feedback in Test Results\" is selected, the answer specific feedback will be shown in the test results next to the questions. If \"Results print view (answers only)\" is selected, the ILIAS content you place around a question using the \"Edit content\" tab page will not be visible in a print-out. If you want to save some paper space, select this option. If \"Show Signature Placeholder\" is selected, a signature placeholder will be shown for printout.\";s:16:\"tst_show_summary\";s:22:\"Show List of Questions\";s:28:\"tst_show_summary_description\";s:90:\"Offers a list with all test questions available for the test participants during the test.\";s:21:\"tst_shuffle_questions\";s:17:\"Shuffle Questions\";s:33:\"tst_shuffle_questions_description\";s:54:\"Shuffle the sequence of questions for every test pass.\";s:13:\"tst_signature\";s:9:\"Signature\";s:23:\"tst_start_new_test_pass\";s:19:\"Start New Test Pass\";s:14:\"tst_start_test\";s:14:\"Start the Test\";s:11:\"tst_started\";s:12:\"Test Started\";s:17:\"tst_starting_time\";s:13:\"Starting Time\";s:18:\"tst_stat_all_users\";s:16:\"All Participants\";s:21:\"tst_stat_choose_users\";s:45:\"(select one or more users from the user list)\";s:27:\"tst_stat_result_atimeofwork\";s:20:\"Average Time of Work\";s:28:\"tst_stat_result_distancemean\";s:27:\"Distance to Arithmetic Mean\";s:30:\"tst_stat_result_distancemedian\";s:18:\"Distance to Median\";s:32:\"tst_stat_result_distancequintile\";s:31:\"Distance to Arithmetic Quintile\";s:26:\"tst_stat_result_firstvisit\";s:11:\"First Visit\";s:25:\"tst_stat_result_lastvisit\";s:10:\"Last Visit\";s:27:\"tst_stat_result_mark_median\";s:14:\"Mark of Median\";s:22:\"tst_stat_result_median\";s:31:\"Median of Test Result in Points\";s:30:\"tst_stat_result_pworkedthrough\";s:48:\"Percent of total workload already worked through\";s:30:\"tst_stat_result_qworkedthrough\";s:32:\"Questions already worked through\";s:20:\"tst_stat_result_qmax\";s:25:\"Total number of Questions\";s:27:\"tst_stat_result_rank_median\";s:14:\"Rank of Median\";s:32:\"tst_stat_result_rank_participant\";s:19:\"Rank of Participant\";s:28:\"tst_stat_result_resultsmarks\";s:21:\"Test Results in Marks\";s:29:\"tst_stat_result_resultspoints\";s:22:\"Test Results in Points\";s:29:\"tst_stat_result_specification\";s:25:\"Available Evaluation Data\";s:26:\"tst_stat_result_timeofwork\";s:12:\"Time of Work\";s:34:\"tst_stat_result_total_participants\";s:28:\"Total Number of Participants\";s:23:\"tst_stat_selected_users\";s:21:\"Selected Participants\";s:20:\"tst_stat_users_intro\";s:31:\"Show Statistical Evaluation for\";s:20:\"tst_status_completed\";s:9:\"completed\";s:40:\"tst_status_completed_more_tries_possible\";s:9:\"Completed\";s:18:\"tst_status_missing\";s:49:\"There are required elements missing in this test!\";s:27:\"tst_status_missing_elements\";s:35:\"The following elements are missing:\";s:22:\"tst_status_not_entered\";s:11:\"Not started\";s:13:\"tst_status_ok\";s:60:\"The status of the test is OK. There are no missing elements.\";s:19:\"tst_status_progress\";s:11:\"In progress\";s:18:\"tst_submit_answers\";s:32:\"Yes, I want to submit my answers\";s:22:\"tst_submit_answers_txt\";s:55:\"You now may finish the test by submitting your answers.\";s:18:\"tst_submit_results\";s:33:\"Yes, I do confirm the submission.\";s:15:\"tst_test_output\";s:11:\"Test Output\";s:21:\"tst_text_count_system\";s:14:\"Scoring System\";s:22:\"tst_time_already_spent\";s:63:\"You started the test at %s. Your maximum processing time is %s.\";s:27:\"tst_time_already_spent_left\";s:17:\"You have %s left.\";s:19:\"tst_total_questions\";s:25:\"Total Amount of Questions\";s:31:\"tst_total_questions_description\";s:183:\"If you set this value, the amount of questions entered with the question pools are ignored. If you don\'t set this value, you need to enter an amount with every selected question pool!\";s:12:\"tst_tst_date\";s:12:\"Date of Test\";s:8:\"tst_type\";s:9:\"Test Type\";s:16:\"tst_type_changed\";s:79:\"You have changed the test type. All previous processed tests have been deleted!\";s:16:\"tst_type_comment\";s:91:\"Warning: Changing the test type of a running test will delete all previous processed tests!\";s:9:\"tst_types\";s:10:\"Test Types\";s:18:\"tst_use_javascript\";s:40:\"Use Javascript for drag and drop actions\";s:19:\"tst_your_answer_was\";s:15:\"Your answer was\";s:16:\"tst_your_answers\";s:56:\"These are your answers given to the following questions.\";s:13:\"tt_assessment\";s:15:\"Assessment Test\";s:14:\"tt_online_exam\";s:11:\"Online Exam\";s:18:\"tt_self_assessment\";s:20:\"Self Assessment Test\";s:21:\"tt_varying_randomtest\";s:19:\"Varying Random Test\";s:9:\"unlimited\";s:9:\"unlimited\";s:6:\"unlock\";s:6:\"Unlock\";s:15:\"unlock_question\";s:394:\"This question is in use of at least one test and there are %s submitted results. If you choose to unlock the question the complete test results of the affected users will be deleted after saving this question. If you want to use a changed version of this question but you do not want to delete the users test results, you can duplicate the question in the question pool and change that version.\";s:12:\"upload_image\";s:12:\"Upload Image\";s:15:\"upload_imagemap\";s:19:\"Upload an Image Map\";s:17:\"uploaded_material\";s:17:\"Uploaded Material\";s:16:\"user_not_invited\";s:39:\"You are not supposed to take this test.\";s:19:\"user_wrong_clientip\";s:44:\"You don\'t have the right ip using this test.\";s:21:\"value_between_x_and_y\";s:37:\"The value should be between %s and %s\";s:29:\"warning_question_not_complete\";s:29:\"The question is not complete!\";s:25:\"warning_test_not_complete\";s:25:\"The test is not complete!\";s:4:\"when\";s:4:\"when\";s:5:\"width\";s:5:\"Width\";s:10:\"with_order\";s:10:\"with order\";s:14:\"worked_through\";s:8:\"Answered\";s:12:\"working_time\";s:12:\"Working Time\";s:16:\"working_time_avg\";s:17:\"Avg. Working Time\";s:26:\"you_received_a_of_b_points\";s:37:\"You received %d of %d possible points\";s:15:\"passes_finished\";s:9:\"%s passes\";s:13:\"pass_finished\";s:7:\"%s pass\";s:17:\"empty_terms_exist\";s:92:\"There are already empty term fields. Please fill out these fields before you add more terms.\";s:5:\"terms\";s:5:\"Terms\";s:18:\"empty_term_message\";s:38:\"There is a least one empty term field.\";s:16:\"no_terms_message\";s:28:\"Please add at least on term.\";s:24:\"assessment_eval_settings\";s:53:\"Show the following fields in Evaluation for All Users\";s:5:\"kiosk\";s:10:\"Kiosk Mode\";s:17:\"kiosk_description\";s:136:\"Run the test in a Kiosk Mode. All content elements which are not part of the test will be hidden to prevent users from leaving the test.\";s:16:\"autosave_success\";s:22:\"Autosave successful...\";s:15:\"autosave_failed\";s:16:\"Autosave failed!\";s:16:\"kiosk_show_title\";s:15:\"Show Test Title\";s:22:\"kiosk_show_participant\";s:24:\"Show Name of Participant\";s:13:\"kiosk_options\";s:18:\"Kiosk Mode Options\";s:18:\"kiosk_options_desc\";s:133:\"Select whether the test title and/or the name of the active participant should be shown at the top of the test during the kiosk mode.\";s:17:\"redirectAfterSave\";s:137:\"The maximum working time has been reached and your last question has been saved automatically. In a few seconds you will be redirected...\";s:15:\"final_statement\";s:15:\"Final Statement\";s:20:\"final_statement_show\";s:20:\"Show Final Statement\";s:25:\"final_statement_show_desc\";s:129:\"If checked, the final statement will be shown directly after the test was finished prior to the presentation of the test results.\";s:8:\"showinfo\";s:34:\"Show the complete Information Page\";s:13:\"showinfo_desc\";s:221:\"If checked, the complete Test Information Page will be shown (including the test properties). If unchecked, only the introduction text (if available) and the required properties will be shown on the Test Information Page.\";s:7:\"forcejs\";s:42:\"Force JavaScript output for test questions\";s:13:\"forcejs_short\";s:16:\"Force JavaScript\";s:12:\"forcejs_desc\";s:117:\"If checked, JavaScript output will be chosen for test questions if a JavaScript output and a fallback solution exist.\";s:14:\"reset_pictures\";s:23:\"Reset Picture Positions\";s:17:\"reset_definitions\";s:26:\"Reset Definition Positions\";s:18:\"tst_single_results\";s:19:\"Results by Question\";s:27:\"tst_answered_questions_test\";s:31:\"Questions answered in this test\";s:12:\"no_selection\";s:20:\"--- No Selection ---\";s:11:\"customstyle\";s:12:\"Custom Style\";s:23:\"customstyle_description\";s:132:\"It is possible to use a custom style sheet for this test. Please select one of the available style sheets to assign it to this test.\";}');
INSERT INTO `lng_modules` VALUES ('barometer','en','a:54:{s:9:\"anonymous\";s:9:\"Anonymous\";s:15:\"barometer_title\";s:8:\"Feedback\";s:4:\"best\";s:4:\"Best\";s:13:\"change_course\";s:13:\"Change Course\";s:10:\"chart_type\";s:10:\"Chart type\";s:11:\"chart_users\";s:10:\"Chart user\";s:11:\"chart_votes\";s:11:\"Chart votes\";s:10:\"bar_create\";s:19:\"Create New Feedback\";s:3:\"day\";s:3:\"Day\";s:4:\"days\";s:4:\"Days\";s:6:\"delete\";s:6:\"Delete\";s:8:\"duration\";s:8:\"Duration\";s:4:\"edit\";s:4:\"Edit\";s:14:\"edit_barometer\";s:13:\"Edit feedback\";s:5:\"every\";s:5:\"every\";s:19:\"feedb_edit_feedback\";s:13:\"Edit Feedback\";s:19:\"feedb_feedback_list\";s:13:\"Feedback List\";s:23:\"feedb_feedback_settings\";s:17:\"Feedback Settings\";s:10:\"feedb_time\";s:4:\"Time\";s:10:\"first_vote\";s:14:\"1. Vote is the\";s:4:\"from\";s:4:\"From\";s:5:\"hours\";s:5:\"Hours\";s:5:\"lines\";s:5:\"Lines\";s:5:\"login\";s:5:\"Login\";s:14:\"missing_fields\";s:39:\"Please fill in all required information\";s:5:\"month\";s:5:\"Month\";s:6:\"months\";s:6:\"Months\";s:8:\"new_vote\";s:8:\"New vote\";s:4:\"note\";s:7:\"Comment\";s:8:\"optional\";s:8:\"Optional\";s:7:\"options\";s:7:\"Options\";s:3:\"pie\";s:3:\"Pie\";s:6:\"repeat\";s:12:\"Repeat Every\";s:8:\"required\";s:8:\"Required\";s:4:\"save\";s:4:\"Save\";s:9:\"save_vote\";s:11:\"Submit vote\";s:4:\"skip\";s:4:\"Skip\";s:10:\"statistics\";s:10:\"Statistics\";s:6:\"status\";s:6:\"Status\";s:5:\"table\";s:5:\"Table\";s:4:\"text\";s:4:\"Text\";s:11:\"text_answer\";s:11:\"Text answer\";s:4:\"time\";s:7:\"Running\";s:5:\"title\";s:5:\"Title\";s:4:\"type\";s:4:\"Type\";s:5:\"until\";s:5:\"Until\";s:4:\"user\";s:4:\"User\";s:4:\"vote\";s:4:\"Vote\";s:5:\"votes\";s:5:\"Votes\";s:5:\"weeks\";s:5:\"Weeks\";s:5:\"worst\";s:5:\"Worst\";s:4:\"year\";s:4:\"Year\";s:13:\"barometer_add\";s:16:\"Add new Feedback\";s:27:\"barometer_conflict_anon_req\";s:91:\"Anonymization can not be combined with type \'Required\'. Please choose one of these options.\";}');
INSERT INTO `lng_modules` VALUES ('bibitem','en','a:58:{s:11:\"bibitem_add\";s:3:\"Add\";s:14:\"bibitem_author\";s:6:\"Author\";s:10:\"bibitem_av\";s:2:\"AV\";s:15:\"bibitem_bibitem\";s:27:\"Bibliographical information\";s:12:\"bibitem_book\";s:4:\"Book\";s:17:\"bibitem_booktitle\";s:10:\"Book title\";s:15:\"bibitem_catalog\";s:7:\"Catalog\";s:20:\"bibitem_choose_index\";s:44:\"Please select a bibliographical information:\";s:23:\"bibitem_cross_reference\";s:15:\"Cross reference\";s:14:\"bibitem_delete\";s:6:\"Delete\";s:20:\"bibitem_dissertation\";s:12:\"Dissertation\";s:15:\"bibitem_edition\";s:7:\"Edition\";s:14:\"bibitem_editor\";s:6:\"Editor\";s:13:\"bibitem_entry\";s:5:\"Entry\";s:18:\"bibitem_first_name\";s:10:\"First name\";s:23:\"bibitem_grey_literature\";s:15:\"Grey literature\";s:21:\"bibitem_how_published\";s:13:\"How published\";s:18:\"bibitem_identifier\";s:10:\"Identifier\";s:14:\"bibitem_inbook\";s:7:\"In book\";s:21:\"bibitem_inproceedings\";s:14:\"In proceedings\";s:19:\"bibitem_institution\";s:11:\"Institution\";s:16:\"bibitem_internet\";s:8:\"Internet\";s:12:\"bibitem_isbn\";s:4:\"ISBN\";s:12:\"bibitem_issn\";s:4:\"ISSN\";s:15:\"bibitem_journal\";s:7:\"Journal\";s:23:\"bibitem_journal_article\";s:15:\"Journal article\";s:15:\"bibitem_keyword\";s:7:\"Keyword\";s:13:\"bibitem_label\";s:5:\"Label\";s:16:\"bibitem_language\";s:8:\"Language\";s:17:\"bibitem_last_name\";s:9:\"Last name\";s:14:\"bibitem_manual\";s:6:\"Manual\";s:21:\"bibitem_master_thesis\";s:13:\"Master thesis\";s:19:\"bibitem_middle_name\";s:11:\"Middle name\";s:13:\"bibitem_month\";s:5:\"Month\";s:19:\"bibitem_new_element\";s:11:\"New element\";s:25:\"bibitem_newspaper_article\";s:17:\"Newspaper article\";s:17:\"bibitem_not_found\";s:41:\"No bibliographical information available.\";s:12:\"bibitem_note\";s:4:\"Note\";s:14:\"bibitem_number\";s:6:\"Number\";s:20:\"bibitem_organization\";s:12:\"Organization\";s:13:\"bibitem_pages\";s:5:\"Pages\";s:18:\"bibitem_phd_thesis\";s:10:\"PhD thesis\";s:21:\"bibitem_please_select\";s:13:\"Please select\";s:13:\"bibitem_print\";s:5:\"Print\";s:19:\"bibitem_proceedings\";s:11:\"Proceedings\";s:17:\"bibitem_publisher\";s:9:\"Publisher\";s:12:\"bibitem_save\";s:4:\"Save\";s:14:\"bibitem_school\";s:6:\"School\";s:14:\"bibitem_series\";s:6:\"Series\";s:21:\"bibitem_series_editor\";s:6:\"Editor\";s:20:\"bibitem_series_title\";s:12:\"Series title\";s:21:\"bibitem_series_volume\";s:6:\"Volume\";s:24:\"bibitem_technical_report\";s:16:\"Technical report\";s:12:\"bibitem_type\";s:4:\"Type\";s:19:\"bibitem_unpublished\";s:11:\"Unpublished\";s:11:\"bibitem_url\";s:3:\"URL\";s:23:\"bibitem_where_published\";s:15:\"Where published\";s:12:\"bibitem_year\";s:4:\"Year\";}');
INSERT INTO `lng_modules` VALUES ('chat','en','a:148:{s:11:\"cancel_talk\";s:14:\"Cancel address\";s:14:\"cancel_whisper\";s:14:\"Cancel whisper\";s:19:\"chat_access_blocked\";s:37:\"You are excluded from these chatrooms\";s:11:\"chat_active\";s:6:\"Active\";s:17:\"chat_active_users\";s:23:\"Further users (present)\";s:22:\"chat_add_allowed_hosts\";s:82:\"Please add the address of the host(s) which are allowed to access the chat server.\";s:20:\"chat_add_external_ip\";s:36:\"Please add the server\'s external IP.\";s:20:\"chat_add_internal_ip\";s:36:\"Please add the server\'s internal IP.\";s:27:\"chat_add_moderator_password\";s:32:\"Please add a moderator password.\";s:13:\"chat_add_port\";s:27:\"Please add the server port.\";s:25:\"chat_add_private_chatroom\";s:20:\"Add private chatroom\";s:12:\"chat_address\";s:7:\"Address\";s:17:\"chat_address_user\";s:7:\"Address\";s:9:\"chat_aqua\";s:4:\"aqua\";s:10:\"chat_arial\";s:5:\"Arial\";s:10:\"chat_black\";s:5:\"black\";s:15:\"chat_block_user\";s:5:\"Block\";s:12:\"chat_blocked\";s:17:\"Restricted access\";s:21:\"chat_blocked_unlocked\";s:6:\"Unlock\";s:18:\"chat_blocked_users\";s:13:\"Blocked users\";s:9:\"chat_blue\";s:4:\"blue\";s:9:\"chat_bold\";s:4:\"Bold\";s:18:\"chat_chatroom_body\";s:10:\"Chat room:\";s:20:\"chat_chatroom_rename\";s:14:\"Edit chat room\";s:14:\"chat_chatrooms\";s:10:\"Chat Rooms\";s:10:\"chat_color\";s:10:\"Font color\";s:16:\"chat_delete_sure\";s:47:\"Are you sure, you want to delete this chat room\";s:14:\"chat_drop_user\";s:11:\"User kicked\";s:9:\"chat_edit\";s:9:\"Edit chat\";s:10:\"chat_empty\";s:5:\"Empty\";s:25:\"chat_enter_valid_username\";s:30:\"Please enter a valid username.\";s:9:\"chat_face\";s:9:\"Font type\";s:12:\"chat_fuchsia\";s:7:\"fuchsia\";s:9:\"chat_gray\";s:4:\"gray\";s:10:\"chat_green\";s:5:\"green\";s:17:\"chat_hide_details\";s:12:\"Hide details\";s:16:\"chat_html_export\";s:11:\"HTML export\";s:10:\"chat_ilias\";s:17:\"ILIAS Chat module\";s:13:\"chat_inactive\";s:8:\"Inactive\";s:10:\"chat_input\";s:5:\"Input\";s:19:\"chat_insert_message\";s:23:\"Please insert a message\";s:20:\"chat_invitation_body\";s:24:\"Invitation to chat from:\";s:23:\"chat_invitation_subject\";s:15:\"Chat invitation\";s:16:\"chat_invite_user\";s:11:\"Invite user\";s:15:\"chat_invited_by\";s:10:\"Invited by\";s:11:\"chat_italic\";s:6:\"Italic\";s:22:\"chat_kick_user_session\";s:9:\"Kick user\";s:21:\"chat_kicked_from_room\";s:67:\"You have been kicked from this chatroom, you cannot write messages.\";s:14:\"chat_level_all\";s:3:\"All\";s:16:\"chat_level_debug\";s:5:\"Debug\";s:16:\"chat_level_error\";s:5:\"Error\";s:16:\"chat_level_fatal\";s:5:\"Fatal\";s:15:\"chat_level_info\";s:4:\"Info\";s:9:\"chat_lime\";s:4:\"lime\";s:11:\"chat_maroon\";s:6:\"maroon\";s:21:\"chat_messages_deleted\";s:27:\"Messages have been deleted.\";s:23:\"chat_moderator_password\";s:18:\"Moderator password\";s:9:\"chat_navy\";s:4:\"navy\";s:16:\"chat_new_message\";s:11:\"New message\";s:20:\"chat_no_active_users\";s:25:\"No further users present.\";s:15:\"chat_no_blocked\";s:26:\"No blocked users available\";s:18:\"chat_no_connection\";s:27:\"Cannot contact chat server.\";s:21:\"chat_no_delete_public\";s:38:\"The public chat room cannot be deleted\";s:28:\"chat_no_recordings_available\";s:42:\"No recordings are available at the moment.\";s:22:\"chat_no_refresh_public\";s:41:\"The public chat room cannot be refreshed.\";s:21:\"chat_no_rename_public\";s:33:\"The public room cannot be renamed\";s:22:\"chat_no_users_selected\";s:28:\"You have to select one user.\";s:18:\"chat_no_write_perm\";s:22:\"No permission to write\";s:10:\"chat_olive\";s:5:\"olive\";s:17:\"chat_online_users\";s:22:\"Further users (online)\";s:20:\"chat_private_message\";s:15:\"Private Message\";s:12:\"chat_profile\";s:7:\"Profile\";s:16:\"chat_public_room\";s:16:\"Public chat room\";s:11:\"chat_purple\";s:6:\"purple\";s:21:\"chat_recording_action\";s:6:\"Action\";s:26:\"chat_recording_description\";s:11:\"Description\";s:24:\"chat_recording_moderator\";s:9:\"Moderator\";s:24:\"chat_recording_not_found\";s:25:\"Could not find recording.\";s:22:\"chat_recording_running\";s:17:\"Recording running\";s:22:\"chat_recording_started\";s:17:\"Recording started\";s:22:\"chat_recording_stopped\";s:17:\"Recording stopped\";s:25:\"chat_recording_time_frame\";s:10:\"Time frame\";s:20:\"chat_recording_title\";s:18:\"Title of recording\";s:15:\"chat_recordings\";s:10:\"Recordings\";s:27:\"chat_recordings_delete_sure\";s:32:\"Deleting records - are you sure?\";s:23:\"chat_recordings_deleted\";s:24:\"Recordings were deleted.\";s:26:\"chat_recordings_select_one\";s:50:\"Please choose recordings you would like to delete.\";s:8:\"chat_red\";s:3:\"red\";s:12:\"chat_refresh\";s:7:\"Refresh\";s:14:\"chat_refreshed\";s:47:\"Deleted all messages of the selected chatrooms.\";s:15:\"chat_room_added\";s:19:\"Added new chat room\";s:14:\"chat_room_name\";s:17:\"Name of chat room\";s:17:\"chat_room_renamed\";s:18:\"Chat room renamed.\";s:16:\"chat_room_select\";s:17:\"Private chat room\";s:10:\"chat_rooms\";s:10:\"Chat Rooms\";s:18:\"chat_rooms_deleted\";s:21:\"Chat room(s) deleted.\";s:20:\"chat_select_one_room\";s:27:\"Please select one chat room\";s:19:\"chat_server_allowed\";s:13:\"Allowed hosts\";s:21:\"chat_server_allowed_b\";s:30:\"(e.g. 192.168.1.1,192.168.1.2)\";s:23:\"chat_server_external_ip\";s:14:\"Server Address\";s:23:\"chat_server_internal_ip\";s:18:\"Server internal IP\";s:19:\"chat_server_logfile\";s:13:\"Log file path\";s:20:\"chat_server_loglevel\";s:9:\"Log level\";s:22:\"chat_server_not_active\";s:29:\"The chat server is not active\";s:16:\"chat_server_port\";s:11:\"Server Port\";s:20:\"chat_server_settings\";s:20:\"Chat server settings\";s:19:\"chat_settings_saved\";s:14:\"Settings saved\";s:17:\"chat_show_details\";s:12:\"Show details\";s:11:\"chat_silver\";s:6:\"silver\";s:20:\"chat_start_recording\";s:15:\"Start recording\";s:11:\"chat_status\";s:6:\"Status\";s:17:\"chat_status_saved\";s:27:\"The status has been changed\";s:19:\"chat_stop_recording\";s:14:\"Stop recording\";s:11:\"chat_tahoma\";s:6:\"Tahoma\";s:9:\"chat_teal\";s:4:\"teal\";s:10:\"chat_times\";s:5:\"Times\";s:18:\"chat_title_missing\";s:21:\"Please insert a name.\";s:17:\"chat_to_chat_body\";s:11:\"To the chat\";s:9:\"chat_type\";s:9:\"Font face\";s:19:\"chat_unblocked_user\";s:37:\"The selected user have been unlocked.\";s:15:\"chat_underlined\";s:10:\"Underlined\";s:24:\"chat_unkick_user_session\";s:11:\"Unkick user\";s:25:\"chat_user_already_blocked\";s:52:\"The access for the selected user is already blocked.\";s:17:\"chat_user_blocked\";s:37:\"Blocked access for the selected user.\";s:17:\"chat_user_dropped\";s:11:\"User kicked\";s:17:\"chat_user_invited\";s:21:\"Invited user to chat.\";s:14:\"chat_user_name\";s:8:\"Username\";s:12:\"chat_whisper\";s:7:\"Whisper\";s:11:\"chat_yellow\";s:6:\"yellow\";s:5:\"chats\";s:5:\"Chats\";s:8:\"my_chats\";s:8:\"My Chats\";s:24:\"chat_server_ssl_settings\";s:12:\"SSL Settings\";s:20:\"chat_server_ssl_port\";s:15:\"Server SSL Port\";s:22:\"chat_server_ssl_active\";s:10:\"SSL active\";s:17:\"chat_add_ssl_port\";s:31:\"Please add the server SSL port.\";s:23:\"chat_notification_intro\";s:72:\"This mail was automatically sent to you by the ILIAS installation %s, %s\";s:25:\"chat_user_dropped_private\";s:58:\"The user was disinvited/removed from the private chatroom.\";s:24:\"chat_user_invited_public\";s:40:\"The user was invited to the public chat.\";s:25:\"chat_user_invited_private\";s:45:\"The user was invited to the private chatroom.\";s:19:\"chat_disinvite_user\";s:43:\"Disinvite/remove user from private chatroom\";s:20:\"chat_no_online_users\";s:24:\"No further users online.\";s:29:\"chat_cannot_connect_to_server\";s:58:\"ILIAS cannot build a socket connection to the chat server.\";s:20:\"chat_chat_invitation\";s:16:\"Chat Invitations\";s:21:\"chat_general_settings\";s:16:\"General Settings\";s:11:\"chat_sounds\";s:6:\"Sounds\";s:32:\"chat_new_invitation_sound_status\";s:53:\"Play a sound if a user receives a new chat invitation\";s:26:\"chat_sound_status_activate\";s:15:\"Activate Sounds\";s:28:\"chat_sound_status_deactivate\";s:17:\"Deactivate Sounds\";}');
INSERT INTO `lng_modules` VALUES ('common','en','a:3001:{s:14:\"access_expired\";s:7:\"expired\";s:21:\"enable_ext_lang_maint\";s:27:\"Enable Extended Maintenance\";s:22:\"disable_ext_lang_maint\";s:28:\"Disable Extended Maintenance\";s:20:\"lang_refresh_confirm\";s:44:\"Do you really want to refresh all languages?\";s:25:\"lang_refresh_confirm_info\";s:458:\"Extended language maintenance is currently activated. Refreshing the languages loads all language data from the ILIAS language files into the database. Local changes saved in the database before ILIAS 3.10.0 may be overwritten, if not exported before. This does not affect any \"*.lang.local\" files in the Customizing directory. Local changes saved with ILIAS 3.10.0 or higher are kept, if they are newer than the modification date of the local language file.\";s:20:\"delete_existing_file\";s:20:\"Delete Existing File\";s:9:\"res_links\";s:16:\"Repository Links\";s:15:\"short_inst_name\";s:11:\"Short Title\";s:20:\"short_inst_name_info\";s:96:\"This title will appear in the browser header title bar. If no value is entered, \'ILIAS\' is used.\";s:23:\"usr_filter_empty_result\";s:54:\"No users found that match the selected filter criteria\";s:16:\"access_unlimited\";s:9:\"unlimited\";s:23:\"usr_limited_access_only\";s:30:\"Users with limited access only\";s:19:\"usr_without_courses\";s:30:\"Users without courses assigned\";s:14:\"search_results\";s:14:\"Search results\";s:8:\"obj_cmps\";s:29:\"Modules, Services and Plugins\";s:13:\"obj_cmps_desc\";s:62:\"General settings for Repository Modules, Services and Plugins.\";s:31:\"user_profile_instant_messengers\";s:18:\"Instant Messengers\";s:18:\"instant_messengers\";s:18:\"Instant Messengers\";s:6:\"im_icq\";s:3:\"ICQ\";s:8:\"im_yahoo\";s:5:\"Yahoo\";s:6:\"im_msn\";s:3:\"MSN\";s:6:\"im_aim\";s:3:\"AIM\";s:8:\"im_skype\";s:5:\"Skype\";s:11:\"im_icq_icon\";s:8:\"ICQ Logo\";s:13:\"im_yahoo_icon\";s:10:\"Yahoo Logo\";s:11:\"im_msn_icon\";s:8:\"MSN Logo\";s:11:\"im_aim_icon\";s:8:\"AIM Logo\";s:13:\"im_skype_icon\";s:10:\"Skype Logo\";s:25:\"not_enabled_or_configured\";s:25:\"Not configured or enabled\";s:15:\"fold_create_grp\";s:13:\"Add new Group\";s:5:\"width\";s:5:\"Width\";s:6:\"height\";s:6:\"Height\";s:22:\"hide_own_online_status\";s:21:\"Hide My Online Status\";s:18:\"3rd_party_software\";s:18:\"3rd party software\";s:10:\"DD.MM.YYYY\";s:10:\"DD.MM.YYYY\";s:2:\"HH\";s:5:\"HH:MM\";s:13:\"absolute_path\";s:13:\"Absolute Path\";s:20:\"accept_usr_agreement\";s:22:\"Accept user agreement?\";s:6:\"access\";s:6:\"Access\";s:20:\"account_expires_body\";s:43:\"Your account is limited, it will expire at:\";s:23:\"account_expires_subject\";s:30:\"[ILIAS 3] Your account expires\";s:6:\"action\";s:6:\"Action\";s:14:\"action_aborted\";s:14:\"Action aborted\";s:7:\"actions\";s:7:\"Actions\";s:27:\"activate_assessment_logging\";s:32:\"Activate Test&Assessment logging\";s:14:\"activate_https\";s:43:\"HTTPS handling by ILIAS<br>(Payment, Login)\";s:17:\"activate_tracking\";s:10:\"Activation\";s:10:\"activation\";s:12:\"Edit Timings\";s:6:\"active\";s:6:\"Active\";s:12:\"active_roles\";s:12:\"Active Roles\";s:3:\"add\";s:3:\"Add\";s:10:\"add_author\";s:10:\"Add Author\";s:12:\"add_comments\";s:13:\"Edit comments\";s:13:\"add_condition\";s:22:\"Create New Association\";s:10:\"add_member\";s:10:\"Add Member\";s:11:\"add_members\";s:11:\"Add Members\";s:26:\"add_new_user_defined_field\";s:26:\"Add New User-defined Field\";s:33:\"add_new_user_defined_select_field\";s:18:\"Add New Select Box\";s:31:\"add_new_user_defined_text_field\";s:18:\"Add New Text Field\";s:8:\"add_note\";s:8:\"Add Note\";s:15:\"add_translation\";s:15:\"Add translation\";s:8:\"add_user\";s:14:\"Add local user\";s:22:\"add_user_defined_field\";s:13:\"Add New Field\";s:19:\"added_new_condition\";s:22:\"Created new condition.\";s:15:\"additional_info\";s:22:\"Additional Information\";s:14:\"adm_create_tax\";s:15:\"Create taxonomy\";s:19:\"adm_edit_permission\";s:26:\"Change permission settings\";s:8:\"adm_read\";s:30:\"Read access to System settings\";s:11:\"adm_visible\";s:27:\"System settings are visible\";s:9:\"adm_write\";s:26:\"Edit Basic system settings\";s:11:\"admin_panel\";s:20:\"Administration Panel\";s:12:\"all_commands\";s:12:\"All Commands\";s:14:\"basic_commands\";s:14:\"Basic Commands\";s:12:\"administrate\";s:12:\"Administrate\";s:18:\"administrate_users\";s:25:\"Local user administration\";s:14:\"administration\";s:14:\"Administration\";s:13:\"administrator\";s:13:\"Administrator\";s:5:\"adopt\";s:5:\"Adopt\";s:32:\"advanced_editing_allow_html_tags\";s:45:\"Allow the selected HTML tags for text editing\";s:40:\"advanced_editing_allow_javascript_editor\";s:25:\"Enable a Rich Text Editor\";s:36:\"advanced_editing_assessment_settings\";s:52:\"Allowed HTML Tags for the ILIAS Test&Assessment tool\";s:33:\"advanced_editing_cat_page_editing\";s:41:\"Enable Content Editing for Category Pages\";s:38:\"advanced_editing_cat_page_editing_desc\";s:127:\"This enables the content editing of category pages. When deactivated, the categories are just displayed as a set of item lists.\";s:30:\"advanced_editing_lm_js_editing\";s:35:\"Enable HTMLArea for Content Editing\";s:35:\"advanced_editing_lm_js_editing_desc\";s:92:\"Enables HTMLArea and JavaScript support for page editing in learning modules and glossaries.\";s:28:\"advanced_editing_lm_settings\";s:37:\"Learning Module and Glossary Settings\";s:23:\"advanced_editing_no_rte\";s:28:\"Do not use rich text editing\";s:25:\"advanced_editing_settings\";s:25:\"Advanced Editing Settings\";s:32:\"advanced_editing_survey_settings\";s:43:\"Allowed HTML Tags for the ILIAS survey tool\";s:24:\"advanced_editing_tinymce\";s:14:\"TinyMCE Editor\";s:24:\"adve_assessment_settings\";s:26:\"Test & Assessment Settings\";s:17:\"adve_cat_settings\";s:17:\"Category Settings\";s:20:\"adve_edit_permission\";s:26:\"Change Permission Settings\";s:21:\"adve_general_settings\";s:16:\"General Settings\";s:16:\"adve_lm_settings\";s:22:\"LM / Glossary Settings\";s:9:\"adve_read\";s:38:\"Access Advanced Editing Administration\";s:20:\"adve_survey_settings\";s:15:\"Survey Settings\";s:12:\"adve_visible\";s:42:\"Advanced Editing Administration is Visible\";s:10:\"adve_write\";s:31:\"Advanced Editing Administration\";s:10:\"agree_date\";s:9:\"Agreed on\";s:11:\"all_authors\";s:11:\"All authors\";s:16:\"all_global_roles\";s:12:\"Global roles\";s:7:\"all_lms\";s:20:\"All learning modules\";s:15:\"all_local_roles\";s:17:\"Local roles (all)\";s:11:\"all_objects\";s:11:\"All Objects\";s:9:\"all_roles\";s:9:\"All Roles\";s:10:\"all_topics\";s:10:\"All Topics\";s:8:\"all_tsts\";s:9:\"All tests\";s:9:\"all_users\";s:9:\"All Users\";s:18:\"allow_assign_users\";s:47:\"Allow user assignment for local administrators.\";s:14:\"allow_register\";s:44:\"Available in registration form for new users\";s:3:\"alm\";s:20:\"Learning Module AICC\";s:9:\"alm_added\";s:26:\"AICC Learning Module added\";s:10:\"alm_create\";s:27:\"Create AICC Learning Module\";s:10:\"alm_delete\";s:27:\"Delete AICC Learning Module\";s:19:\"alm_edit_permission\";s:26:\"Change permission settings\";s:8:\"alm_join\";s:33:\"Subscribe to AICC Learning Module\";s:9:\"alm_leave\";s:37:\"Unsubscribe from AICC Learning Module\";s:8:\"alm_read\";s:35:\"Read access to AICC Learning Module\";s:11:\"alm_visible\";s:31:\"AICC Learning Module is visible\";s:9:\"alm_write\";s:25:\"Edit AICC Learning Module\";s:23:\"already_delivered_files\";s:15:\"Submitted Files\";s:3:\"and\";s:3:\"and\";s:8:\"announce\";s:8:\"Announce\";s:16:\"announce_changes\";s:16:\"Announce Changes\";s:9:\"anonymous\";s:9:\"Anonymous\";s:7:\"answers\";s:7:\"Answers\";s:12:\"any_language\";s:12:\"Any language\";s:13:\"append_search\";s:21:\"Append search results\";s:21:\"application_completed\";s:23:\"Application is complete\";s:16:\"application_date\";s:16:\"Application Date\";s:13:\"applied_users\";s:13:\"Applied users\";s:5:\"apply\";s:5:\"Apply\";s:12:\"apply_filter\";s:12:\"Apply filter\";s:12:\"reset_filter\";s:12:\"Reset filter\";s:8:\"activate\";s:10:\"Set Active\";s:10:\"deactivate\";s:12:\"Set Inactive\";s:11:\"appointment\";s:11:\"Appointment\";s:16:\"appointment_list\";s:16:\"Appointment List\";s:12:\"approve_date\";s:11:\"Approved on\";s:17:\"approve_recipient\";s:20:\"Login ID of Approver\";s:7:\"archive\";s:7:\"Archive\";s:12:\"are_you_sure\";s:13:\"Are you sure?\";s:15:\"arrow_downright\";s:28:\"Arrow from top to down right\";s:15:\"articels_unread\";s:15:\"Unread articels\";s:5:\"as_of\";s:5:\"as of\";s:15:\"ascending_order\";s:15:\"Ascending order\";s:22:\"assessment_log_deleted\";s:69:\"The Test & Assessment log data has been deleted in the administration\";s:26:\"assessment_imap_line_color\";s:19:\"Imagemap Line Color\";s:22:\"assessment_log_logging\";s:7:\"Logging\";s:38:\"assessment_log_manual_scoring_activate\";s:27:\"Activate Manual Scoring for\";s:29:\"assessment_log_manual_scoring\";s:14:\"Manual Scoring\";s:34:\"assessment_log_manual_scoring_desc\";s:275:\"If the Manual Scoring is activated for a question type, all questions of this question type could be manually scored by a test author. Please be careful with these settings, because late manual scoring of automatically scored question types could cause even judical problems!\";s:14:\"assessment_log\";s:56:\"Create an Test&Assessment log for a specific time period\";s:23:\"assessment_log_datetime\";s:9:\"Date/Time\";s:23:\"assessment_log_for_test\";s:8:\"For test\";s:26:\"assessment_log_log_entries\";s:11:\"log entries\";s:21:\"assessment_log_no_log\";s:79:\"It is no log data available for the selected test and the selected time period!\";s:28:\"assessment_log_open_calendar\";s:71:\"Click here to open a calendar for date selection (JavaScript required!)\";s:23:\"assessment_log_question\";s:8:\"Question\";s:26:\"assessment_log_select_test\";s:28:\"--- Please select a test ---\";s:19:\"assessment_log_text\";s:11:\"Log message\";s:26:\"assessment_log_user_answer\";s:24:\"User answered a question\";s:27:\"assessment_log_user_answers\";s:17:\"Show user actions\";s:19:\"assessment_settings\";s:33:\"Global Test & Assessment settings\";s:38:\"assessment_settings_reporting_language\";s:18:\"Reporting language\";s:19:\"assessment_defaults\";s:38:\"Default settings for Test & Assessment\";s:25:\"assessment_use_javascript\";s:26:\"JavaScript for Drag & Drop\";s:30:\"assessment_use_javascript_desc\";s:79:\"Activates JavaScript output for drag&drop actions by default for the first time\";s:14:\"ass_log_output\";s:15:\"Log Data Output\";s:13:\"ass_log_admin\";s:23:\"Log Data Administration\";s:22:\"ass_log_count_datasets\";s:11:\"Log Entries\";s:12:\"ass_log_path\";s:13:\"Test Location\";s:23:\"ass_log_available_tests\";s:15:\"Available Tests\";s:22:\"ass_log_delete_entries\";s:18:\"Delete Log Entries\";s:15:\"ass_log_deleted\";s:52:\"The Log Data for the selected tests has been deleted\";s:27:\"ass_log_delete_no_selection\";s:54:\"Please select at least one test to delete the Log Data\";s:20:\"assf_edit_permission\";s:26:\"Change permission settings\";s:9:\"assf_read\";s:37:\"Access Test&Assessment Administration\";s:12:\"assf_visible\";s:41:\"Test&Assessment administration is visible\";s:10:\"assf_write\";s:35:\"Edit Test&Assessment administration\";s:18:\"assf_questiontypes\";s:17:\"Question Settings\";s:26:\"assf_allowed_questiontypes\";s:24:\"Available Question Types\";s:31:\"assf_allowed_questiontypes_desc\";s:224:\"All the checked question types will be available in this ILIAS installation. If you don\'t want to allow the creation of a certain question type in this installation, you must remove the selection in the associated check box.\";s:6:\"assign\";s:6:\"Assign\";s:18:\"assign_global_role\";s:21:\"Assign to Global Role\";s:15:\"assign_lo_forum\";s:15:\"Assign LO Forum\";s:17:\"assign_local_role\";s:20:\"Assign to Local Role\";s:19:\"assign_user_to_role\";s:19:\"Assign User to Role\";s:14:\"assigned_roles\";s:14:\"Assigned Roles\";s:14:\"assigned_users\";s:14:\"Assigned Users\";s:15:\"associated_user\";s:15:\"associated User\";s:16:\"associated_users\";s:16:\"associated Users\";s:18:\"at_least_one_style\";s:41:\"At least one style must remain activated.\";s:11:\"at_location\";s:11:\"at location\";s:10:\"attachment\";s:10:\"Attachment\";s:11:\"attachments\";s:11:\"Attachments\";s:6:\"attend\";s:6:\"Attend\";s:17:\"auth_active_roles\";s:43:\"Global roles available on registration form\";s:16:\"auth_allow_local\";s:26:\"Allow Local Authentication\";s:8:\"auth_cas\";s:3:\"CAS\";s:25:\"auth_cas_allow_local_desc\";s:91:\"This allows CAS users to authenticate with their local ILIAS username and a local password.\";s:13:\"auth_cas_auth\";s:28:\"Configure CAS Authentication\";s:18:\"auth_cas_auth_desc\";s:66:\"CAS requires PHP 4.3.1 or higher with CURL support (7.5 or higher)\";s:26:\"auth_cas_create_users_desc\";s:136:\"Creates automatically an ILIAS user account, for users that successfully authenticated against CAS, without having an ILIAS account yet.\";s:18:\"auth_cas_port_desc\";s:75:\"E.g. 443 if the full CAS server URI is https://auth.yourserver.com:443/cas/\";s:20:\"auth_cas_server_desc\";s:91:\"E.g. auth.yourserver.com if the full CAS server URI is https://auth.yourserver.com:443/cas/\";s:23:\"auth_cas_settings_saved\";s:18:\"CAS settings saved\";s:17:\"auth_cas_uri_desc\";s:86:\"Local URI, e.g. cas if the full CAS server URI is https://auth.yourserver.com:443/cas/\";s:31:\"auth_cas_user_default_role_desc\";s:57:\"This role is assigned to automatically created CAS users.\";s:14:\"auth_configure\";s:12:\"configure...\";s:17:\"auth_create_users\";s:39:\"Create non-existing users automatically\";s:12:\"auth_default\";s:15:\"Default setting\";s:28:\"auth_default_mode_changed_to\";s:38:\"Default authentication mode changed to\";s:20:\"auth_edit_permission\";s:26:\"Change permission settings\";s:9:\"auth_ldap\";s:4:\"LDAP\";s:14:\"auth_ldap_desc\";s:34:\"Authenticate users via LDAP server\";s:16:\"auth_ldap_enable\";s:19:\"Enable LDAP support\";s:24:\"auth_ldap_not_configured\";s:26:\"LDAP is not configured yet\";s:24:\"auth_ldap_settings_saved\";s:19:\"LDAP settings saved\";s:10:\"auth_local\";s:14:\"ILIAS database\";s:15:\"auth_local_desc\";s:53:\"Authenticate users via local ILIAS database (default)\";s:23:\"auth_login_instructions\";s:32:\"Instructions shown on login page\";s:9:\"auth_mode\";s:19:\"Authentication mode\";s:21:\"auth_mode_not_changed\";s:17:\"(Nothing changed)\";s:23:\"auth_mode_roles_changed\";s:41:\"Changed authentication mode for this Role\";s:26:\"auth_new_account_mail_desc\";s:154:\"Send new account e-mail to user, if user is generated automatically. A password will only be generated, if \"Allow Local Authentication\" is also activated.\";s:16:\"auth_per_default\";s:11:\"Per Default\";s:11:\"auth_radius\";s:6:\"RADIUS\";s:21:\"auth_radius_configure\";s:31:\"Configure RADIUS-Authentication\";s:16:\"auth_radius_desc\";s:36:\"Authenticate users via RADIUS server\";s:18:\"auth_radius_enable\";s:21:\"Enable RADIUS support\";s:26:\"auth_radius_not_configured\";s:28:\"RADIUS is not configured yet\";s:16:\"auth_radius_port\";s:4:\"Port\";s:18:\"auth_radius_server\";s:7:\"Servers\";s:23:\"auth_radius_server_desc\";s:108:\"You may add multiple servers with commas separated. Servers are rotated in Round robin fashion when queried.\";s:26:\"auth_radius_settings_saved\";s:21:\"RADIUS settings saved\";s:25:\"auth_radius_shared_secret\";s:13:\"Shared secret\";s:9:\"auth_read\";s:30:\"Access authentication settings\";s:26:\"auth_remark_non_local_auth\";s:122:\"When selecting another authentication mode than ILIAS database, you may not change user\'s login name and password anymore.\";s:19:\"auth_role_auth_mode\";s:19:\"Authentication mode\";s:11:\"auth_script\";s:6:\"Custom\";s:16:\"auth_script_desc\";s:38:\"Authenticate users via external script\";s:11:\"auth_select\";s:26:\"Select authentication mode\";s:9:\"auth_shib\";s:10:\"Shibboleth\";s:14:\"auth_shib_desc\";s:78:\"Authenticate users via Shibboleth, can be used as second authentication method\";s:24:\"auth_shib_not_configured\";s:32:\"Shibboleth is not configured yet\";s:15:\"auth_shibboleth\";s:10:\"Shibboleth\";s:9:\"auth_soap\";s:4:\"SOAP\";s:26:\"auth_soap_allow_local_desc\";s:92:\"This allows SOAP users to authenticate with their local ILIAS username and a local password.\";s:14:\"auth_soap_auth\";s:29:\"Configure SOAP Authentication\";s:19:\"auth_soap_auth_desc\";s:95:\"This settings deal only with SOAP based user authentication, not with the ILIAS SOAP interface.\";s:27:\"auth_soap_create_users_desc\";s:137:\"Creates automatically an ILIAS user account, for users that successfully authenticated against SOAP, without having an ILIAS account yet.\";s:19:\"auth_soap_namespace\";s:9:\"Namespace\";s:24:\"auth_soap_namespace_desc\";s:66:\"As defined in WSDL. Must be specified, if .NET SOAP style is used.\";s:19:\"auth_soap_port_desc\";s:87:\"E.g. 8080 if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php\";s:21:\"auth_soap_server_desc\";s:102:\"E.g. auth.yourserver.com if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php\";s:24:\"auth_soap_settings_saved\";s:34:\"SOAP authentication settings saved\";s:18:\"auth_soap_uri_desc\";s:108:\"Local URI, e.g. dir/server.php if the full SOAP server URI is http://auth.yourserver.com:8080/dir/server.php\";s:20:\"auth_soap_use_dotnet\";s:19:\"Use .NET SOAP Style\";s:19:\"auth_soap_use_https\";s:9:\"Use HTTPS\";s:27:\"auth_soap_user_default_role\";s:49:\"Default role assigned to SOAP authenticated users\";s:32:\"auth_soap_user_default_role_desc\";s:58:\"This role is assigned to automatically created SOAP users.\";s:22:\"auth_user_default_role\";s:12:\"Default Role\";s:12:\"auth_visible\";s:35:\"Authentication settings are visible\";s:10:\"auth_write\";s:28:\"Edit authentication settings\";s:23:\"authentication_settings\";s:14:\"Authentication\";s:6:\"author\";s:6:\"Author\";s:7:\"authors\";s:7:\"Authors\";s:17:\"auto_registration\";s:34:\"Automatically approve registration\";s:9:\"available\";s:9:\"Available\";s:19:\"available_languages\";s:19:\"Available Languages\";s:12:\"average_time\";s:12:\"Average time\";s:4:\"back\";s:4:\"Back\";s:19:\"back_to_crs_content\";s:22:\"Back to Course Content\";s:20:\"back_to_fold_content\";s:22:\"Back to Folder Content\";s:19:\"back_to_grp_content\";s:21:\"Back to Group Content\";s:6:\"basedn\";s:6:\"BaseDN\";s:10:\"basic_data\";s:10:\"Basic Data\";s:14:\"basic_settings\";s:14:\"Basic Settings\";s:9:\"benchmark\";s:9:\"Benchmark\";s:18:\"benchmark_settings\";s:18:\"Benchmark Settings\";s:10:\"benchmarks\";s:10:\"Benchmarks\";s:8:\"bib_data\";s:20:\"Bibliographical Data\";s:8:\"big_icon\";s:8:\"Big Icon\";s:10:\"bkm_import\";s:16:\"Import bookmarks\";s:13:\"bkm_import_ok\";s:59:\"Successfully imported %d bookmarks and %d bookmark folders.\";s:12:\"bkm_sendmail\";s:18:\"Send as attachment\";s:2:\"bm\";s:8:\"Bookmark\";s:3:\"bmf\";s:15:\"Bookmark Folder\";s:13:\"bookmark_edit\";s:13:\"Edit Bookmark\";s:20:\"bookmark_folder_edit\";s:20:\"Edit Bookmark Folder\";s:19:\"bookmark_folder_new\";s:19:\"New Bookmark Folder\";s:12:\"bookmark_new\";s:12:\"New Bookmark\";s:15:\"bookmark_target\";s:6:\"Target\";s:9:\"bookmarks\";s:9:\"Bookmarks\";s:12:\"bookmarks_of\";s:12:\"Bookmarks of\";s:12:\"bottom_frame\";s:12:\"Main Content\";s:7:\"btn_add\";s:3:\"Add\";s:13:\"btn_new_value\";s:9:\"New value\";s:8:\"btn_next\";s:8:\"Continue\";s:12:\"btn_previous\";s:4:\"Back\";s:17:\"btn_remove_system\";s:18:\"Remove from System\";s:12:\"btn_undelete\";s:8:\"Undelete\";s:2:\"by\";s:2:\"By\";s:11:\"by_location\";s:17:\"Order by location\";s:7:\"by_type\";s:13:\"Order by type\";s:5:\"bytes\";s:5:\"Bytes\";s:8:\"calendar\";s:8:\"Calendar\";s:6:\"cancel\";s:6:\"Cancel\";s:15:\"cannot_find_xml\";s:25:\"Cannot find any XML-file.\";s:32:\"cannot_uninstall_language_in_use\";s:51:\"You cannot uninstall the language currently in use!\";s:31:\"cannot_uninstall_systemlanguage\";s:41:\"You cannot uninstall the system language!\";s:17:\"cannot_unzip_file\";s:19:\"Cannot unpack file.\";s:33:\"cant_deactivate_if_users_assigned\";s:70:\"You cannot deactivate a style if there are still users assigned to it.\";s:3:\"cat\";s:8:\"Category\";s:4:\"wiki\";s:4:\"Wiki\";s:17:\"wiki_edit_content\";s:15:\"Edit Wiki Pages\";s:10:\"wiki_write\";s:36:\"Change Wiki Settings, Grade Learners\";s:9:\"wiki_read\";s:9:\"Read Wiki\";s:11:\"wiki_delete\";s:11:\"Delete Wiki\";s:9:\"wiki_copy\";s:9:\"Copy Wiki\";s:12:\"wiki_visible\";s:15:\"Wiki is visible\";s:20:\"wiki_edit_permission\";s:26:\"Change permission settings\";s:16:\"cat_create_write\";s:11:\"Create Wiki\";s:17:\"fold_create_write\";s:11:\"Create Wiki\";s:16:\"crs_create_write\";s:11:\"Create Wiki\";s:16:\"grp_create_write\";s:11:\"Create Wiki\";s:8:\"obj_wiki\";s:4:\"Wiki\";s:9:\"objs_wiki\";s:5:\"Wikis\";s:9:\"objs_lres\";s:18:\"Learning Resources\";s:8:\"wiki_new\";s:8:\"New Wiki\";s:8:\"wiki_add\";s:8:\"Add Wiki\";s:4:\"mcst\";s:9:\"Mediacast\";s:8:\"obj_mcst\";s:9:\"Mediacast\";s:9:\"objs_mcst\";s:10:\"Mediacasts\";s:8:\"mcst_new\";s:13:\"New Mediacast\";s:8:\"mcst_add\";s:13:\"Add Mediacast\";s:8:\"obj_pdts\";s:16:\"Personal Desktop\";s:13:\"obj_pdts_desc\";s:30:\"Configure the Personal Desktop\";s:11:\"move_blocks\";s:11:\"Move Blocks\";s:18:\"stop_moving_blocks\";s:18:\"Stop Moving Blocks\";s:6:\"before\";s:6:\"before\";s:5:\"cat_a\";s:10:\"a Category\";s:7:\"cat_add\";s:12:\"Add Category\";s:9:\"cat_added\";s:14:\"Category added\";s:26:\"cat_cat_administrate_users\";s:32:\"Administrate local user accounts\";s:14:\"cat_clear_page\";s:10:\"Clear Page\";s:10:\"cat_create\";s:15:\"Create Category\";s:14:\"cat_create_alm\";s:27:\"Create AICC Learning Module\";s:14:\"cat_create_cat\";s:15:\"Create Category\";s:15:\"cat_create_chat\";s:11:\"Create Chat\";s:14:\"cat_create_crs\";s:13:\"Create Course\";s:14:\"cat_create_dbk\";s:19:\"Create Digilib Book\";s:14:\"cat_create_exc\";s:15:\"Create Exercise\";s:15:\"cat_create_file\";s:11:\"Upload File\";s:14:\"cat_create_frm\";s:12:\"Create Forum\";s:14:\"cat_create_glo\";s:15:\"Create Glossary\";s:14:\"cat_create_grp\";s:12:\"Create Group\";s:14:\"cat_create_hlm\";s:27:\"Create HACP Learning Module\";s:15:\"cat_create_htlm\";s:27:\"Create HTML Learning Module\";s:15:\"cat_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:13:\"cat_create_lm\";s:28:\"Create ILIAS Learning Module\";s:14:\"cat_create_mep\";s:17:\"Create Media Pool\";s:14:\"cat_create_qpl\";s:25:\"Create Question Pool Test\";s:15:\"cat_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:14:\"cat_create_spl\";s:27:\"Create Question Pool Survey\";s:14:\"cat_create_svy\";s:13:\"Create Survey\";s:14:\"cat_create_tst\";s:11:\"Create Test\";s:14:\"cat_create_url\";s:10:\"Create URL\";s:15:\"cat_create_webr\";s:19:\"Create Web Resource\";s:10:\"cat_delete\";s:15:\"Delete Category\";s:8:\"cat_edit\";s:13:\"Edit Category\";s:19:\"cat_edit_permission\";s:26:\"Change permission settings\";s:7:\"cat_new\";s:12:\"New Category\";s:9:\"cat_pages\";s:14:\"Category Pages\";s:15:\"cat_pages_clear\";s:22:\"Category page cleared.\";s:21:\"cat_pages_not_created\";s:32:\"Category page not createded yet.\";s:16:\"cat_pages_undone\";s:38:\"Last changes for cagegory page undone.\";s:8:\"cat_read\";s:23:\"Read access to Category\";s:14:\"cat_read_users\";s:34:\"Read access to local user accounts\";s:26:\"cat_undo_last_page_changes\";s:22:\"Undo Last Page Changes\";s:11:\"cat_visible\";s:19:\"Category is visible\";s:9:\"cat_write\";s:13:\"Edit Category\";s:10:\"categories\";s:10:\"Categories\";s:19:\"categories_imported\";s:25:\"Category import complete.\";s:2:\"cc\";s:2:\"CC\";s:3:\"cen\";s:12:\"Centra Event\";s:7:\"cen_add\";s:16:\"Add Centra Event\";s:9:\"cen_added\";s:18:\"Centra Event added\";s:10:\"cen_delete\";s:19:\"Delete Centra Event\";s:8:\"cen_edit\";s:17:\"Edit Centra Event\";s:7:\"cen_new\";s:16:\"New Centra Event\";s:8:\"cen_save\";s:17:\"Save Centra Event\";s:10:\"censorship\";s:10:\"Censorship\";s:14:\"centra_account\";s:20:\"Centra Admin Account\";s:12:\"centra_rooms\";s:12:\"Centra Rooms\";s:13:\"centra_server\";s:13:\"Centra Server\";s:20:\"chac_edit_permission\";s:26:\"Change permission settings\";s:9:\"chac_read\";s:28:\"Read access to chat settings\";s:12:\"chac_visible\";s:25:\"Chat settings are visible\";s:10:\"chac_write\";s:18:\"Edit chat settings\";s:6:\"change\";s:6:\"Change\";s:24:\"change_active_assignment\";s:24:\"Change active assignment\";s:17:\"change_assignment\";s:17:\"Change assignment\";s:20:\"perm_special_options\";s:15:\"Special Options\";s:23:\"change_existing_objects\";s:23:\"Change existing Objects\";s:28:\"change_existing_objects_desc\";s:214:\"The permission settings of this role will be adpoted to ALL existing objects. If you want to change permissions only for specific object types please click the checkboxes to the right of the appropiate object type.\";s:29:\"role_protect_permissions_desc\";s:147:\"The object permissions cannot be changed by systems operations anymore. Furthermore only administrator of higher levels may change the permissions.\";s:22:\"change_existing_prefix\";s:15:\"Change existing\";s:22:\"change_existing_suffix\";s:6:\"&nbsp;\";s:29:\"change_existing_prefix_single\";s:6:\"Change\";s:29:\"change_existing_suffix_single\";s:6:\"&nbsp;\";s:32:\"change_existing_object_type_desc\";s:64:\"Also change permissions of already existing objects of that type\";s:19:\"change_header_title\";s:17:\"Edit Header Title\";s:14:\"change_lo_info\";s:14:\"Change LO Info\";s:15:\"change_metadata\";s:15:\"Change Metadata\";s:12:\"change_owner\";s:12:\"Change owner\";s:21:\"change_sort_direction\";s:21:\"Change sort direction\";s:10:\"changeable\";s:10:\"Changeable\";s:10:\"changed_to\";s:10:\"changed to\";s:7:\"chapter\";s:7:\"Chapter\";s:14:\"chapter_number\";s:14:\"Chapter Number\";s:13:\"chapter_title\";s:13:\"Chapter Title\";s:10:\"characters\";s:10:\"characters\";s:4:\"chat\";s:4:\"Chat\";s:14:\"chat_active_in\";s:15:\"Active in chat:\";s:8:\"chat_add\";s:8:\"Add Chat\";s:11:\"chat_delete\";s:11:\"Delete chat\";s:20:\"chat_edit_permission\";s:26:\"Change permission settings\";s:11:\"chat_invite\";s:4:\"Chat\";s:13:\"chat_moderate\";s:13:\"Moderate chat\";s:8:\"chat_new\";s:8:\"New Chat\";s:9:\"chat_read\";s:25:\"Read/Write access to chat\";s:17:\"chat_users_active\";s:12:\"Active users\";s:12:\"chat_visible\";s:15:\"Chat is visible\";s:10:\"chat_write\";s:9:\"Edit chat\";s:5:\"check\";s:5:\"Check\";s:7:\"checked\";s:7:\"Checked\";s:9:\"unchecked\";s:9:\"Unchecked\";s:7:\"textbox\";s:7:\"Textbox\";s:9:\"check_all\";s:9:\"Check all\";s:14:\"check_langfile\";s:31:\"Please check your language file\";s:15:\"check_languages\";s:15:\"Check Languages\";s:10:\"check_link\";s:10:\"Link check\";s:15:\"check_link_desc\";s:91:\"If enabled all external links in ILIAS learning modules will be checked if they are active.\";s:29:\"check_max_allowed_packet_size\";s:35:\"The page content size is too large.\";s:19:\"check_user_accounts\";s:19:\"Check user accounts\";s:24:\"check_user_accounts_desc\";s:114:\"If cron jobs are activated and this option is enabled, all users whose account expires will be informed by e-mail.\";s:19:\"check_web_resources\";s:19:\"Check Web Resources\";s:24:\"check_web_resources_desc\";s:64:\"If enabled all Web Resources will be checked if they are active.\";s:13:\"checked_files\";s:16:\"Importable files\";s:12:\"chg_language\";s:15:\"Change Language\";s:12:\"chg_password\";s:15:\"Change Password\";s:18:\"chg_ilias_password\";s:21:\"Change ILIAS Password\";s:32:\"chg_ilias_and_webfolder_password\";s:35:\"Change ILIAS and Webfolder Password\";s:15:\"choose_language\";s:20:\"Choose Your Language\";s:15:\"choose_location\";s:15:\"Choose Location\";s:24:\"choose_only_one_language\";s:31:\"Please choose only one language\";s:13:\"chown_warning\";s:84:\"Attention, you may loose access permissions on this object after changing the owner.\";s:4:\"city\";s:11:\"City, State\";s:12:\"cleaned_file\";s:22:\"File has been cleaned.\";s:15:\"cleaning_failed\";s:16:\"Cleaning failed.\";s:5:\"clear\";s:5:\"Clear\";s:6:\"client\";s:6:\"Client\";s:9:\"client_id\";s:9:\"Client ID\";s:9:\"client_ip\";s:9:\"Client IP\";s:9:\"clipboard\";s:9:\"Clipboard\";s:5:\"close\";s:5:\"Close\";s:12:\"close_window\";s:12:\"Close window\";s:7:\"cnt_new\";s:8:\"(%s New)\";s:8:\"collapse\";s:8:\"Collapse\";s:15:\"comma_separated\";s:15:\"Comma Separated\";s:7:\"comment\";s:7:\"Comment\";s:7:\"compose\";s:7:\"Compose\";s:9:\"condition\";s:9:\"Condition\";s:26:\"condition_already_assigned\";s:24:\"Object already assigned.\";s:24:\"condition_circle_created\";s:70:\"This association is not possible, since the objects would interdepend.\";s:17:\"condition_deleted\";s:18:\"Condition deleted.\";s:18:\"condition_finished\";s:8:\"Finished\";s:22:\"condition_not_finished\";s:12:\"Not finished\";s:16:\"condition_passed\";s:6:\"Passed\";s:22:\"condition_precondition\";s:14:\"Preconditions:\";s:23:\"condition_select_object\";s:25:\"Please select one object.\";s:20:\"condition_select_one\";s:29:\"-Please select one condition-\";s:16:\"condition_update\";s:4:\"Save\";s:18:\"conditions_updated\";s:16:\"Conditions saved\";s:7:\"confirm\";s:7:\"Confirm\";s:12:\"confirmation\";s:12:\"Confirmation\";s:17:\"conflict_handling\";s:17:\"Conflict handling\";s:11:\"cont_object\";s:6:\"Object\";s:12:\"contact_data\";s:19:\"Contact Information\";s:9:\"container\";s:9:\"Container\";s:7:\"content\";s:7:\"Content\";s:14:\"content_styles\";s:14:\"Content Styles\";s:7:\"context\";s:7:\"Context\";s:13:\"continue_work\";s:8:\"Continue\";s:6:\"contra\";s:6:\"Contra\";s:13:\"cookies_howto\";s:21:\"How to enable cookies\";s:13:\"copied_object\";s:13:\"Copied object\";s:4:\"copy\";s:4:\"Copy\";s:11:\"copyChapter\";s:4:\"Copy\";s:8:\"copyPage\";s:4:\"Copy\";s:7:\"copy_of\";s:7:\"Copy of\";s:14:\"copy_of_suffix\";s:6:\"- Copy\";s:16:\"copy_n_of_suffix\";s:13:\"- Copy (%1$s)\";s:7:\"copy_to\";s:2:\"to\";s:24:\"could_not_verify_account\";s:81:\"Sorry, we could not verify your account. Please contact the system administrator.\";s:5:\"count\";s:5:\"Count\";s:7:\"country\";s:7:\"Country\";s:6:\"course\";s:6:\"Course\";s:7:\"courses\";s:7:\"Courses\";s:6:\"create\";s:6:\"Create\";s:11:\"create_date\";s:10:\"Created on\";s:18:\"create_export_file\";s:18:\"Create export file\";s:9:\"create_in\";s:9:\"Create in\";s:17:\"create_stylesheet\";s:12:\"Create Style\";s:7:\"created\";s:13:\"Creation Date\";s:23:\"cron_forum_notification\";s:24:\"Send Forum Notifications\";s:28:\"cron_forum_notification_cron\";s:22:\"regularly per cron job\";s:28:\"cron_forum_notification_desc\";s:121:\"If enabled, all users, who want to be informed about new posts in specified forum topics, will get notifications by mail.\";s:32:\"cron_forum_notification_directly\";s:23:\"directly on new entries\";s:29:\"cron_forum_notification_never\";s:5:\"never\";s:22:\"cron_mail_notification\";s:23:\"Send Mail Notifications\";s:28:\"cron_mail_notification_never\";s:5:\"never\";s:27:\"cron_mail_notification_cron\";s:22:\"regularly per cron job\";s:27:\"cron_mail_notification_desc\";s:103:\"If enabled, all users, who want to be informed about new mail, will get notifications by external mail.\";s:9:\"cron_jobs\";s:9:\"Cron jobs\";s:14:\"cron_jobs_desc\";s:151:\"A cron job is an automated process that operates at predefined time intervals. You will find information about the setup in the \'INSTALL Documentation.\";s:17:\"cron_lucene_index\";s:26:\"Update Lucene search index\";s:22:\"cron_lucene_index_info\";s:118:\"If enabled, the lucene search index will be updated. Please configure the lucene server at \'Administration -> Search\'.\";s:3:\"crs\";s:6:\"Course\";s:5:\"crs_a\";s:8:\"a Course\";s:28:\"crs_activation_start_invalid\";s:40:\"The start and the end time is not valid.\";s:7:\"crs_add\";s:10:\"Add Course\";s:9:\"crs_added\";s:12:\"Course added\";s:39:\"crs_all_questions_answered_successfully\";s:46:\"You have successfully answered every question.\";s:12:\"crs_archives\";s:8:\"Archives\";s:22:\"crs_at_least_one_admin\";s:50:\"There has to be at least one course administrator.\";s:13:\"crs_available\";s:17:\"Available Courses\";s:30:\"crs_container_link_not_allowed\";s:44:\"It is not possible to link container objects\";s:10:\"crs_create\";s:13:\"Create Course\";s:14:\"crs_create_alm\";s:27:\"Create AICC Learning Module\";s:15:\"crs_create_chat\";s:11:\"Create Chat\";s:14:\"crs_create_dbk\";s:19:\"Create Digilib Book\";s:14:\"crs_create_exc\";s:15:\"Create Exercise\";s:15:\"crs_create_file\";s:11:\"Upload File\";s:15:\"crs_create_fold\";s:13:\"Create Folder\";s:14:\"crs_create_frm\";s:12:\"Create Forum\";s:14:\"crs_create_glo\";s:15:\"Create Glossary\";s:14:\"crs_create_grp\";s:12:\"Create Group\";s:14:\"crs_create_hlm\";s:27:\"Create HACP Learning Module\";s:15:\"crs_create_htlm\";s:27:\"Create HTML Learning Module\";s:15:\"crs_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:13:\"crs_create_lm\";s:28:\"Create ILIAS Learning Module\";s:14:\"crs_create_mep\";s:17:\"Create Media Pool\";s:14:\"crs_create_qpl\";s:25:\"Create Question Pool Test\";s:15:\"crs_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:14:\"crs_create_spl\";s:27:\"Create Question Pool Survey\";s:14:\"crs_create_svy\";s:13:\"Create Survey\";s:14:\"crs_create_tst\";s:11:\"Create Test\";s:15:\"crs_create_webr\";s:19:\"Create Web Resource\";s:10:\"crs_delete\";s:13:\"Delete Course\";s:8:\"crs_edit\";s:11:\"Edit Course\";s:26:\"crs_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:19:\"crs_edit_permission\";s:26:\"Change permission settings\";s:8:\"crs_info\";s:4:\"Info\";s:8:\"crs_join\";s:11:\"Join Course\";s:9:\"crs_leave\";s:12:\"Leave Course\";s:21:\"crs_management_system\";s:24:\"Course Management System\";s:21:\"crs_member_not_passed\";s:10:\"Not passed\";s:17:\"crs_member_passed\";s:6:\"Passed\";s:19:\"crs_members_gallery\";s:22:\"Course Members Gallery\";s:7:\"crs_new\";s:10:\"New Course\";s:14:\"crs_no_content\";s:15:\"Without content\";s:8:\"crs_read\";s:21:\"Read access to Course\";s:18:\"crs_status_blocked\";s:16:\"[Access refused]\";s:18:\"crs_status_pending\";s:26:\"[Waiting for registration]\";s:24:\"crs_subscribers_assigned\";s:20:\"Assigned new user(s)\";s:11:\"crs_visible\";s:17:\"Course is visible\";s:9:\"crs_write\";s:11:\"Edit Course\";s:15:\"cumulative_time\";s:15:\"Cumulative time\";s:14:\"cur_number_rec\";s:25:\"Current number of records\";s:10:\"current_ip\";s:11:\"Current IP:\";s:16:\"current_ip_alert\";s:97:\"Notice: if you enter a wrong ip you won\'t be able to access the system with this profile anymore.\";s:16:\"current_password\";s:16:\"Current Password\";s:20:\"custom_icon_size_big\";s:22:\"Custom icon size (big)\";s:25:\"custom_icon_size_standard\";s:27:\"Custom icon size (standard)\";s:21:\"custom_icon_size_tiny\";s:24:\"Custom icon size (small)\";s:3:\"cut\";s:3:\"Cut\";s:7:\"cutPage\";s:3:\"Cut\";s:5:\"daily\";s:5:\"daily\";s:12:\"data_privacy\";s:21:\"Data Privacy Settings\";s:8:\"database\";s:8:\"Database\";s:16:\"database_version\";s:24:\"Current Database Version\";s:7:\"dataset\";s:4:\"Item\";s:4:\"date\";s:4:\"Date\";s:10:\"dateplaner\";s:8:\"Calendar\";s:3:\"day\";s:3:\"Day\";s:4:\"days\";s:4:\"Days\";s:14:\"days_of_period\";s:14:\"Days of period\";s:7:\"db_host\";s:13:\"Database Host\";s:7:\"db_name\";s:13:\"Database Name\";s:14:\"db_need_update\";s:25:\"Database needs an update!\";s:7:\"db_pass\";s:17:\"Database Password\";s:7:\"db_type\";s:13:\"Database Type\";s:7:\"db_user\";s:13:\"Database User\";s:10:\"db_version\";s:16:\"Database Version\";s:3:\"dbk\";s:12:\"Digilib Book\";s:5:\"dbk_a\";s:14:\"a Digilib Book\";s:7:\"dbk_add\";s:16:\"Add Digilib Book\";s:9:\"dbk_added\";s:18:\"Digilib Book added\";s:10:\"dbk_create\";s:19:\"Create Digilib Book\";s:10:\"dbk_delete\";s:19:\"Delete Digilib Book\";s:26:\"dbk_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:19:\"dbk_edit_permission\";s:26:\"Change permission settings\";s:7:\"dbk_new\";s:16:\"New Digilib Book\";s:8:\"dbk_read\";s:27:\"Read access to Digilib Book\";s:11:\"dbk_visible\";s:23:\"Digilib Book is visible\";s:9:\"dbk_write\";s:17:\"Edit Digilib Book\";s:19:\"def_repository_view\";s:23:\"Default repository view\";s:7:\"default\";s:7:\"Default\";s:16:\"default_language\";s:16:\"Default Language\";s:21:\"default_perm_settings\";s:19:\"Default permissions\";s:12:\"default_role\";s:12:\"Default Role\";s:13:\"default_roles\";s:13:\"Default Roles\";s:12:\"default_skin\";s:12:\"Default Skin\";s:18:\"default_skin_style\";s:20:\"Default Skin / Style\";s:13:\"default_style\";s:13:\"Default Style\";s:13:\"default_value\";s:13:\"Default Value\";s:8:\"defaults\";s:8:\"Defaults\";s:6:\"delete\";s:6:\"Delete\";s:10:\"delete_all\";s:10:\"Delete All\";s:14:\"delete_all_rec\";s:18:\"Delete all records\";s:13:\"delete_object\";s:16:\"Delete Object(s)\";s:15:\"delete_selected\";s:15:\"Delete Selected\";s:14:\"delete_tr_data\";s:20:\"Delete tracking data\";s:7:\"deleted\";s:7:\"Deleted\";s:12:\"deleted_user\";s:25:\"The user has been deleted\";s:13:\"deleted_users\";s:13:\"Deleted users\";s:7:\"deliver\";s:7:\"Deliver\";s:10:\"department\";s:10:\"Department\";s:4:\"desc\";s:11:\"Description\";s:16:\"descending_order\";s:16:\"Descending order\";s:11:\"description\";s:11:\"Description\";s:16:\"desired_password\";s:16:\"Desired Password\";s:13:\"desktop_items\";s:22:\"Personal desktop items\";s:7:\"details\";s:7:\"Details\";s:7:\"disable\";s:7:\"disable\";s:13:\"disable_check\";s:13:\"Disable check\";s:8:\"disabled\";s:8:\"Disabled\";s:6:\"domain\";s:6:\"Domain\";s:4:\"down\";s:4:\"Down\";s:8:\"download\";s:8:\"Download\";s:27:\"download_all_returned_files\";s:27:\"Download all returned files\";s:6:\"drafts\";s:6:\"Drafts\";s:4:\"drop\";s:4:\"Drop\";s:4:\"edit\";s:4:\"Edit\";s:13:\"edit_comments\";s:35:\"Edit comments for the selected user\";s:12:\"edit_content\";s:12:\"Edit content\";s:9:\"edit_data\";s:9:\"edit data\";s:15:\"edit_operations\";s:15:\"Edit Operations\";s:9:\"edit_page\";s:9:\"Edit Page\";s:17:\"edit_page_content\";s:17:\"Edit Page Content\";s:17:\"edit_perm_ruleset\";s:29:\"Edit default permission rules\";s:15:\"edit_properties\";s:15:\"Edit Properties\";s:19:\"edit_roleassignment\";s:20:\"Edit role assignment\";s:15:\"edit_stylesheet\";s:10:\"Edit Style\";s:9:\"edited_at\";s:9:\"Edited at\";s:6:\"editor\";s:6:\"Editor\";s:5:\"email\";s:6:\"E-Mail\";s:14:\"email_feedback\";s:15:\"E-Mail feedback\";s:12:\"email_footer\";s:22:\"<br />powered by ILIAS\";s:15:\"email_not_valid\";s:44:\"The e-mail address you entered is not valid!\";s:6:\"enable\";s:6:\"Enable\";s:15:\"enable_calendar\";s:15:\"Enable Calendar\";s:19:\"enable_custom_icons\";s:19:\"Enable custom icons\";s:24:\"enable_custom_icons_info\";s:171:\"This allows to define custom icons for single categories, courses and groups. The properties section of categories, courses and groups will provide an image upload dialog.\";s:22:\"enable_fora_statistics\";s:26:\"Enable Statistics in Forum\";s:27:\"enable_fora_statistics_desc\";s:59:\"If disabled, nobody is able to access the forum statistics.\";s:22:\"disable_anonymous_fora\";s:23:\"Disable Anonymous Forum\";s:27:\"disable_anonymous_fora_desc\";s:122:\"If option is enabled, nobody is able to make a forum anonymous. Making an anonymous forum non-anonymous is still possible.\";s:25:\"enable_hist_user_comments\";s:31:\"Enable user comments in history\";s:30:\"enable_hist_user_comments_desc\";s:73:\"Give authors the opportunity to add comments to the history log of pages.\";s:14:\"enable_js_edit\";s:25:\"Enable JavaScript Editing\";s:19:\"enable_js_edit_info\";s:136:\"This option enables JavaScript editing for all content objects (ILIAS Learning Modules, Glossaries, Assessment Questions, Digilib Books)\";s:26:\"enable_password_assistance\";s:26:\"Enable password assistance\";s:19:\"enable_registration\";s:28:\"Enable new user registration\";s:12:\"enable_trash\";s:12:\"Enable Trash\";s:17:\"enable_trash_info\";s:164:\"If enabled, deleted Objects are moved into Trash and may be recovered later. When deactivating this option deleted Objects are removed irreversibly from the System!\";s:7:\"enabled\";s:7:\"Enabled\";s:22:\"enter_filename_deliver\";s:26:\"Enter file to be delivered\";s:9:\"enumerate\";s:9:\"Enumerate\";s:11:\"err_1_param\";s:17:\"Only 1 parameter!\";s:11:\"err_2_param\";s:17:\"Only 2 parameter!\";s:26:\"err_auth_cas_no_ilias_user\";s:126:\"Login failed. CAS authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.\";s:24:\"err_auth_ext_user_exists\";s:83:\"External account \'%s\' for authentication mode \'%s\' is already existing. (User \'%s\')\";s:27:\"err_auth_soap_no_ilias_user\";s:127:\"Login failed. SOAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.\";s:15:\"err_count_param\";s:29:\"Reason: Wrong parameter count\";s:24:\"err_enter_current_passwd\";s:34:\"Please enter your current password\";s:11:\"err_in_line\";s:13:\"Error in line\";s:12:\"err_inactive\";s:88:\"This account has not been activated. Please contact the system administrator for access.\";s:16:\"err_invalid_port\";s:19:\"Invalid port number\";s:20:\"err_ldap_auth_failed\";s:102:\"User not authenticated on LDAP server! Please ensure that you have the same password in ILIAS and LDAP\";s:23:\"err_ldap_connect_failed\";s:60:\"Connection to LDAP server failed! Please check your settings\";s:22:\"err_ldap_search_failed\";s:69:\"Connection to LDAP server failed! PLease check BaseDN and Search base\";s:23:\"err_ldap_user_not_found\";s:84:\"User not found on LDAP server! Please check attribute for login name and Objectclass\";s:14:\"err_no_cookies\";s:46:\"Please enable session cookies in your browser!\";s:21:\"err_no_langfile_found\";s:23:\"No language file found!\";s:12:\"err_no_param\";s:13:\"No parameter!\";s:16:\"err_over_3_param\";s:23:\"More than 3 parameters!\";s:23:\"err_role_not_assignable\";s:53:\"You cannot assign users to this role at this location\";s:19:\"err_session_expired\";s:24:\"Your session is expired!\";s:17:\"err_unknown_error\";s:13:\"Unknown Error\";s:16:\"err_wrong_header\";s:21:\"Reason: Wrong header.\";s:15:\"err_wrong_login\";s:23:\"Wrong Login or Password\";s:18:\"err_wrong_password\";s:14:\"Wrong Password\";s:5:\"error\";s:5:\"Error\";s:12:\"error_parser\";s:26:\"Error starting the parser.\";s:15:\"error_recipient\";s:15:\"Error Recipient\";s:3:\"exc\";s:8:\"Exercise\";s:7:\"exc_add\";s:12:\"Add Exercise\";s:9:\"exc_added\";s:14:\"Exercise added\";s:14:\"exc_ask_delete\";s:12:\"Delete file?\";s:14:\"exc_assign_usr\";s:11:\"Assign User\";s:10:\"exc_create\";s:15:\"Create exercise\";s:18:\"exc_date_not_valid\";s:21:\"The date is not valid\";s:20:\"exc_deassign_members\";s:16:\"Delete member(s)\";s:10:\"exc_delete\";s:15:\"Delete exercise\";s:11:\"exc_details\";s:16:\"Exercise details\";s:16:\"exc_download_all\";s:12:\"Download All\";s:18:\"exc_download_files\";s:14:\"Download Files\";s:16:\"exc_download_new\";s:12:\"Download New\";s:8:\"exc_edit\";s:20:\"New exercise created\";s:17:\"exc_edit_exercise\";s:13:\"Edit exercise\";s:26:\"exc_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:19:\"exc_edit_permission\";s:26:\"Change permission settings\";s:14:\"exc_edit_until\";s:10:\"Edit Until\";s:17:\"exc_exercise_sent\";s:13:\"Exercise Sent\";s:17:\"exc_feedback_sent\";s:13:\"Feedback Sent\";s:9:\"exc_files\";s:5:\"Files\";s:18:\"exc_files_returned\";s:15:\"Submitted Files\";s:10:\"exc_groups\";s:6:\"Groups\";s:18:\"exc_header_members\";s:18:\"Exercise (members)\";s:15:\"exc_instruction\";s:17:\"Work Instructions\";s:19:\"exc_last_submission\";s:15:\"Last Submission\";s:14:\"exc_mail_users\";s:20:\"Send mail to user(s)\";s:28:\"exc_members_already_assigned\";s:48:\"These user are already assigned to this exercise\";s:20:\"exc_members_assigned\";s:16:\"Members assigned\";s:26:\"exc_members_comments_saved\";s:59:\"The exercise comments for the selected user have been saved\";s:7:\"exc_new\";s:12:\"New exercise\";s:23:\"exc_no_members_assigned\";s:19:\"No members assigned\";s:11:\"exc_notices\";s:7:\"Notices\";s:7:\"exc_obj\";s:8:\"Exercise\";s:8:\"exc_read\";s:15:\"Access exercise\";s:22:\"exc_resubmitted_advice\";s:114:\"This symbol will be displayed in case that a new file has been submitted after the \"solved\" field has been checked\";s:9:\"exc_roles\";s:5:\"Roles\";s:16:\"exc_save_changes\";s:4:\"Save\";s:12:\"exc_schedule\";s:8:\"Schedule\";s:14:\"exc_search_for\";s:10:\"Search for\";s:19:\"exc_select_one_file\";s:31:\"Please select exactly one file.\";s:17:\"exc_send_exercise\";s:21:\"Send exercise by mail\";s:8:\"exc_sent\";s:48:\"The exercise has been sent to the selected users\";s:11:\"exc_sent_at\";s:16:\"Sent at <br />%s\";s:10:\"exc_status\";s:6:\"Status\";s:22:\"exc_status_resubmitted\";s:11:\"Resubmitted\";s:16:\"exc_status_saved\";s:16:\"Exercise updated\";s:15:\"exc_status_sent\";s:9:\"Delivered\";s:17:\"exc_status_solved\";s:6:\"Solved\";s:20:\"exc_status_submitted\";s:9:\"Submitted\";s:14:\"exc_submission\";s:10:\"Submission\";s:19:\"exc_time_over_short\";s:13:\"Time is over.\";s:16:\"exc_time_to_send\";s:22:\"Remaining Working Time\";s:16:\"exc_upload_error\";s:20:\"Error uploading file\";s:9:\"exc_users\";s:5:\"Users\";s:11:\"exc_visible\";s:19:\"Exercise is visible\";s:9:\"exc_write\";s:13:\"Edit exercise\";s:4:\"excs\";s:9:\"Exercises\";s:7:\"execute\";s:7:\"Execute\";s:18:\"exercise_time_over\";s:79:\"You have reached the end time of the exercise. You cannot longer deliver files!\";s:8:\"exp_html\";s:11:\"Export HTML\";s:6:\"expand\";s:6:\"Expand\";s:14:\"explorer_frame\";s:13:\"Explorer Tree\";s:6:\"export\";s:6:\"Export\";s:14:\"accessRestrict\";s:18:\"Set limited Access\";s:10:\"accessFree\";s:21:\"Remove limited Access\";s:19:\"access_free_granted\";s:44:\"Set the selected user(s) to unlimited access\";s:17:\"access_restricted\";s:42:\"Set the selected user(s) to limited access\";s:23:\"export_format_selection\";s:36:\"Please select the export file format\";s:13:\"export_format\";s:13:\"Export format\";s:20:\"export_group_members\";s:41:\"Export group members (to Microsoft Excel)\";s:11:\"export_html\";s:19:\"Export as HTML File\";s:10:\"export_xml\";s:18:\"Export as XML File\";s:14:\"extt_configure\";s:12:\"configure...\";s:20:\"extt_edit_permission\";s:26:\"Change permission settings\";s:10:\"extt_ilinc\";s:18:\"netucate LearnLinc\";s:29:\"extt_ilinc_additional_options\";s:18:\"Additional Options\";s:31:\"extt_ilinc_akclassvalues_active\";s:19:\"Enable cost centers\";s:36:\"extt_ilinc_akclassvalues_active_info\";s:93:\"With this option enabled you may use iLinc cost centers for Learnlinc-Seminars and Classrooms\";s:33:\"extt_ilinc_akclassvalues_required\";s:20:\"Cost center required\";s:38:\"extt_ilinc_akclassvalues_required_info\";s:71:\"Specifying at least one Cost center for a LearnLinc Seminar is required\";s:20:\"extt_ilinc_configure\";s:28:\"Configure netucate LearnLinc\";s:26:\"extt_ilinc_connection_data\";s:15:\"Connection data\";s:22:\"extt_ilinc_customer_id\";s:11:\"Customer ID\";s:15:\"extt_ilinc_desc\";s:131:\"Provides virtual classrooms. Commercial service. For an account and further information please contact netucate at www.netucate.com\";s:17:\"extt_ilinc_enable\";s:24:\"Enable LearnLinc support\";s:24:\"extt_ilinc_protocol_port\";s:15:\"Protocol & Port\";s:26:\"extt_ilinc_registrar_login\";s:8:\"Login ID\";s:27:\"extt_ilinc_registrar_passwd\";s:8:\"Password\";s:17:\"extt_ilinc_server\";s:6:\"Server\";s:25:\"extt_ilinc_settings_saved\";s:24:\"LearnLinc settings saved\";s:18:\"extt_ilinc_timeout\";s:36:\"Max time waiting for server response\";s:9:\"extt_name\";s:16:\"Software/Service\";s:9:\"extt_read\";s:36:\"Access third party software settings\";s:11:\"extt_remark\";s:123:\"All software and services listed above are not part of ILIAS and do not fall under the ILIAS open source licence agreement.\";s:20:\"extt_title_configure\";s:27:\"Configure external software\";s:12:\"extt_visible\";s:41:\"Third party software settings are visible\";s:10:\"extt_write\";s:30:\"Configure third party software\";s:12:\"faq_exercise\";s:12:\"FAQ Exercise\";s:3:\"fax\";s:3:\"Fax\";s:8:\"feedback\";s:8:\"Feedback\";s:18:\"feedback_recipient\";s:18:\"Feedback Recipient\";s:10:\"field_name\";s:10:\"Field Name\";s:10:\"field_type\";s:10:\"Field Type\";s:4:\"file\";s:4:\"File\";s:6:\"file_a\";s:6:\"a File\";s:8:\"file_add\";s:11:\"Upload File\";s:21:\"file_add_and_metadata\";s:29:\"Upload File and Edit Metadata\";s:10:\"file_added\";s:13:\"File uploaded\";s:11:\"file_delete\";s:11:\"Delete File\";s:9:\"file_edit\";s:9:\"Edit File\";s:20:\"file_edit_permission\";s:26:\"Change Permission settings\";s:9:\"file_icon\";s:9:\"File icon\";s:9:\"file_info\";s:16:\"File Information\";s:16:\"file_is_infected\";s:32:\"The file is infected by a virus.\";s:8:\"file_new\";s:18:\"Upload Single File\";s:14:\"file_not_found\";s:14:\"File Not Found\";s:14:\"file_not_valid\";s:15:\"File not valid!\";s:11:\"file_notice\";s:44:\"Please take note of the maximum file size of\";s:21:\"file_allowed_suffixes\";s:19:\"Allowed file types:\";s:9:\"file_read\";s:13:\"Download File\";s:16:\"file_suffix_repl\";s:30:\"File Upload Suffix Replacement\";s:21:\"file_suffix_repl_info\";s:164:\"Files ending with these suffixes (separated by comma) will be renamed with a suffix \".sec\" if uploaded into the webspace. This is done per default for the suffixes:\";s:10:\"file_valid\";s:14:\"File is valid!\";s:12:\"file_version\";s:24:\"Version Provided in File\";s:12:\"file_visible\";s:15:\"File is visible\";s:10:\"file_write\";s:9:\"Edit File\";s:8:\"filename\";s:8:\"Filename\";s:5:\"files\";s:5:\"Files\";s:14:\"files_location\";s:14:\"Files Location\";s:28:\"fill_out_all_required_fields\";s:35:\"Please fill out all required fields\";s:6:\"filter\";s:7:\"Filter:\";s:9:\"firstname\";s:10:\"First Name\";s:8:\"flatview\";s:9:\"Flat View\";s:4:\"fold\";s:6:\"Folder\";s:6:\"fold_a\";s:8:\"a Folder\";s:8:\"fold_add\";s:10:\"Add Folder\";s:10:\"fold_added\";s:12:\"Folder added\";s:15:\"fold_create_alm\";s:27:\"Create AICC Learning Module\";s:16:\"fold_create_chat\";s:11:\"Create Chat\";s:15:\"fold_create_dbk\";s:19:\"Create Digilib Book\";s:15:\"fold_create_exc\";s:15:\"Create Exercise\";s:16:\"fold_create_file\";s:11:\"Upload File\";s:16:\"fold_create_fold\";s:13:\"Create Folder\";s:15:\"fold_create_frm\";s:12:\"Create Forum\";s:15:\"fold_create_glo\";s:15:\"Create Glossary\";s:15:\"fold_create_hlm\";s:27:\"Create HACP Learning Module\";s:16:\"fold_create_htlm\";s:27:\"Create HTML Learning Module\";s:16:\"fold_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:14:\"fold_create_lm\";s:28:\"Create ILIAS Learning Module\";s:15:\"fold_create_mep\";s:17:\"Create Media Pool\";s:15:\"fold_create_qpl\";s:25:\"Create Question Pool Test\";s:16:\"fold_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:15:\"fold_create_spl\";s:27:\"Create Question Pool Survey\";s:15:\"fold_create_svy\";s:13:\"Create Survey\";s:15:\"fold_create_tst\";s:11:\"Create Test\";s:16:\"fold_create_webr\";s:19:\"Create Web Resource\";s:11:\"fold_delete\";s:13:\"Delete Folder\";s:9:\"fold_edit\";s:11:\"Edit Folder\";s:27:\"fold_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:20:\"fold_edit_permission\";s:26:\"Change Permission settings\";s:8:\"fold_new\";s:10:\"New Folder\";s:9:\"fold_read\";s:21:\"Read access to Folder\";s:12:\"fold_visible\";s:17:\"Folder is visible\";s:10:\"fold_write\";s:11:\"Edit Folder\";s:6:\"folder\";s:6:\"Folder\";s:7:\"folders\";s:7:\"Folders\";s:26:\"force_accept_usr_agreement\";s:35:\"You must accept the user agreement!\";s:8:\"forename\";s:8:\"Forename\";s:15:\"forgot_password\";s:16:\"Forgot password?\";s:15:\"forgot_username\";s:16:\"Forgot username?\";s:17:\"form_empty_fields\";s:29:\"Please complete these fields:\";s:5:\"forum\";s:5:\"Forum\";s:25:\"forum_direct_notification\";s:17:\"Dir. Notification\";s:26:\"forum_general_notification\";s:17:\"Gen. Notification\";s:12:\"forum_import\";s:12:\"Forum import\";s:17:\"forum_import_file\";s:11:\"Import file\";s:18:\"forum_notification\";s:12:\"Notification\";s:15:\"forum_notify_me\";s:32:\"Notify me when a reply is posted\";s:24:\"forum_notify_me_directly\";s:57:\"Please inform me about direct answers to my contribution.\";s:25:\"forum_notify_me_generally\";s:57:\"Please inform me about any new contributions to my topic.\";s:18:\"forum_post_replied\";s:34:\"Your forum entry has been replied.\";s:6:\"forums\";s:6:\"Forums\";s:15:\"forums_articles\";s:8:\"Articles\";s:16:\"forums_last_post\";s:14:\"Latest Article\";s:17:\"forums_moderators\";s:10:\"Moderators\";s:19:\"forums_new_articles\";s:12:\"New Articles\";s:15:\"forums_overview\";s:15:\"Forums Overview\";s:14:\"forums_threads\";s:6:\"Topics\";s:3:\"frm\";s:5:\"Forum\";s:5:\"frm_a\";s:7:\"a Forum\";s:19:\"frm_latest_postings\";s:15:\"Latest Articles\";s:7:\"frm_add\";s:9:\"Add Forum\";s:9:\"frm_added\";s:11:\"Forum added\";s:11:\"frm_article\";s:7:\"article\";s:10:\"frm_create\";s:12:\"Create Forum\";s:10:\"frm_delete\";s:12:\"Delete Forum\";s:15:\"frm_delete_post\";s:25:\"Delete a post, censorship\";s:8:\"frm_edit\";s:10:\"Edit Forum\";s:19:\"frm_edit_permission\";s:26:\"Change permission settings\";s:13:\"frm_edit_post\";s:15:\"Add new posting\";s:7:\"frm_new\";s:9:\"New Forum\";s:8:\"frm_read\";s:20:\"Read access to Forum\";s:22:\"frm_statistics_ranking\";s:7:\"Ranking\";s:14:\"frm_status_new\";s:12:\"Status \'New\'\";s:19:\"frm_status_new_desc\";s:77:\"Please select a duration how long the status \'New\' is kept for forum entries.\";s:11:\"frm_visible\";s:16:\"Forum is visible\";s:9:\"frm_write\";s:10:\"Edit forum\";s:4:\"from\";s:4:\"From\";s:8:\"fullname\";s:9:\"Full name\";s:9:\"functions\";s:9:\"Functions\";s:7:\"gdf_add\";s:14:\"Add Definition\";s:7:\"gdf_new\";s:14:\"New Definition\";s:6:\"gender\";s:6:\"Gender\";s:8:\"gender_f\";s:6:\"Female\";s:8:\"gender_m\";s:4:\"Male\";s:16:\"general_settings\";s:16:\"General settings\";s:8:\"generate\";s:8:\"Generate\";s:3:\"glo\";s:8:\"Glossary\";s:5:\"glo_a\";s:10:\"a Glossary\";s:7:\"glo_add\";s:12:\"Add Glossary\";s:9:\"glo_added\";s:14:\"Glossary added\";s:10:\"glo_create\";s:15:\"Create Glossary\";s:10:\"glo_delete\";s:15:\"Delete Glossary\";s:19:\"glo_edit_permission\";s:26:\"Change permission settings\";s:8:\"glo_join\";s:21:\"Subscribe to Glossary\";s:9:\"glo_leave\";s:25:\"Unsubscribe from Glossary\";s:8:\"glo_mode\";s:4:\"Mode\";s:13:\"glo_mode_desc\";s:321:\"A virtual glossary works like a normal glossary. Additionally it contains the terms from all glossaries that are located on the same level in the repository like the virtual glossary (level) respectively from all glossaries that are located downwards in the repository from the position of the virtual glossary (subtree).\";s:14:\"glo_mode_level\";s:25:\"virtual (this level only)\";s:15:\"glo_mode_normal\";s:6:\"normal\";s:16:\"glo_mode_subtree\";s:24:\"virtual (entire subtree)\";s:7:\"glo_new\";s:12:\"New Glossary\";s:8:\"glo_read\";s:23:\"Read access to Glossary\";s:15:\"glo_upload_file\";s:4:\"File\";s:11:\"glo_visible\";s:19:\"Glossary is visible\";s:9:\"glo_write\";s:13:\"Edit Glossary\";s:6:\"global\";s:6:\"Global\";s:14:\"global_default\";s:14:\"Global Default\";s:12:\"global_fixed\";s:12:\"Global Fixed\";s:15:\"global_settings\";s:15:\"Global settings\";s:11:\"global_user\";s:12:\"Global users\";s:10:\"glossaries\";s:10:\"Glossaries\";s:8:\"glossary\";s:8:\"Glossary\";s:14:\"glossary_added\";s:14:\"Glossary added\";s:19:\"group_access_denied\";s:13:\"Access Denied\";s:17:\"group_any_objects\";s:23:\"No subobjects available\";s:17:\"group_create_chat\";s:11:\"Create chat\";s:10:\"group_desc\";s:17:\"Group Description\";s:13:\"group_details\";s:13:\"Group Details\";s:17:\"group_filesharing\";s:18:\"Group File Sharing\";s:12:\"group_import\";s:12:\"Group import\";s:17:\"group_import_file\";s:11:\"Import file\";s:14:\"group_info_reg\";s:19:\"Admission procedure\";s:13:\"group_members\";s:13:\"Group Members\";s:13:\"group_memstat\";s:13:\"Member Status\";s:19:\"group_memstat_admin\";s:13:\"Administrator\";s:20:\"group_memstat_member\";s:6:\"Member\";s:10:\"group_name\";s:10:\"Group name\";s:23:\"group_new_registrations\";s:13:\"Join Requests\";s:21:\"group_no_registration\";s:10:\"Join group\";s:25:\"group_no_registration_msg\";s:33:\"You can join this group directly.\";s:19:\"group_not_available\";s:18:\"No group available\";s:13:\"group_objects\";s:13:\"Group Objects\";s:31:\"group_password_registration_msg\";s:126:\"If you know the group password, you can join this group. Please contact a group administrator, if you don\'t know the password.\";s:18:\"group_registration\";s:12:\"Registration\";s:34:\"group_registration_expiration_date\";s:15:\"Expiration Date\";s:34:\"group_registration_expiration_time\";s:15:\"Expiration Time\";s:26:\"group_registration_expired\";s:50:\"The time period for joining this group has expired\";s:30:\"group_registration_expired_msg\";s:121:\"The time period for joining this group has expired. Please contact a group administrator, if you want to join this group.\";s:23:\"group_registration_mode\";s:22:\"Registration Procedure\";s:23:\"group_registration_time\";s:19:\"Registration Period\";s:16:\"group_req_direct\";s:13:\"Join directly\";s:18:\"group_req_password\";s:24:\"Join with group password\";s:22:\"group_req_registration\";s:18:\"Request membership\";s:26:\"group_req_registration_msg\";s:135:\"You can request membership for this group. You will receive a message when a group administrator has accepted or declined your request.\";s:11:\"group_reset\";s:23:\"Reset Group Permissions\";s:12:\"group_status\";s:8:\"Group is\";s:19:\"group_status_closed\";s:6:\"Closed\";s:17:\"group_status_desc\";s:292:\"Determines the initial status of the group by using the permission settings from the role templates \'il_grp_status_closed\' or \'il_grp_status_open\'<br />Public: Group is visible; User may subscribe.<br />Closed: Group is not visible for non-members; User has to be invited by a member to join.\";s:19:\"group_status_public\";s:6:\"Public\";s:9:\"groupings\";s:22:\"Membership Limitations\";s:26:\"groupings_assigned_obj_crs\";s:16:\"Assigned Courses\";s:26:\"groupings_assigned_obj_grp\";s:15:\"Assigned Groups\";s:6:\"groups\";s:6:\"Groups\";s:15:\"groups_overview\";s:15:\"Groups Overview\";s:3:\"grp\";s:5:\"Group\";s:5:\"grp_a\";s:7:\"a Group\";s:7:\"grp_add\";s:9:\"Add Group\";s:14:\"grp_add_member\";s:13:\"Add Member(s)\";s:9:\"grp_added\";s:11:\"Group added\";s:19:\"grp_already_applied\";s:68:\"You have already applied to this group! Please wait for confirmation\";s:17:\"grp_app_send_mail\";s:24:\"Send applicant a message\";s:8:\"grp_back\";s:4:\"Back\";s:17:\"grp_count_members\";s:17:\"Number of members\";s:10:\"grp_create\";s:12:\"Create Group\";s:14:\"grp_create_alm\";s:27:\"Create AICC Learning Module\";s:15:\"grp_create_chat\";s:11:\"Create Chat\";s:14:\"grp_create_dbk\";s:19:\"Create Digilib Book\";s:14:\"grp_create_exc\";s:15:\"Create Exercise\";s:15:\"grp_create_file\";s:11:\"Upload File\";s:15:\"grp_create_fold\";s:13:\"Create Folder\";s:14:\"grp_create_frm\";s:12:\"Create Forum\";s:14:\"grp_create_glo\";s:15:\"Create Glossary\";s:14:\"grp_create_grp\";s:12:\"Create Group\";s:14:\"grp_create_hlm\";s:27:\"Create HACP Learning Module\";s:15:\"grp_create_htlm\";s:27:\"Create HTML Learning Module\";s:15:\"grp_create_icrs\";s:24:\"Create LearnLinc Seminar\";s:13:\"grp_create_lm\";s:28:\"Create ILIAS Learning Module\";s:14:\"grp_create_mep\";s:17:\"Create Media Pool\";s:14:\"grp_create_qpl\";s:25:\"Create Question Pool Test\";s:15:\"grp_create_sahs\";s:33:\"Create SCORM/AICC Learning Module\";s:14:\"grp_create_spl\";s:27:\"Create Question Pool Survey\";s:14:\"grp_create_svy\";s:13:\"Create Survey\";s:14:\"grp_create_tst\";s:11:\"Create Test\";s:15:\"grp_create_webr\";s:19:\"Create Web Resource\";s:10:\"grp_delete\";s:12:\"Delete Group\";s:24:\"grp_deleted_export_files\";s:23:\"Deleted selected files.\";s:18:\"grp_dismiss_member\";s:72:\"Are you sure you want to dismiss the following member(s) from the group?\";s:18:\"grp_dismiss_myself\";s:41:\"Are you sure you want to leave the group?\";s:8:\"grp_edit\";s:10:\"Edit Group\";s:26:\"grp_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:19:\"grp_edit_permission\";s:26:\"Change permission settings\";s:30:\"grp_err_administrator_required\";s:79:\"Member could not be removed, at least one administrator per group is required !\";s:49:\"grp_err_at_least_one_groupadministrator_is_needed\";s:49:\"Each group needs at least one group administrator\";s:13:\"grp_err_error\";s:17:\"An error occurred\";s:19:\"grp_err_last_member\";s:62:\"Last member could not be removed, please delete group instead.\";s:35:\"grp_err_member_could_not_be_removed\";s:73:\"Member could not be removed. Please verify all dependencies of this user.\";s:21:\"grp_err_no_permission\";s:54:\"You do not possess the permissions for this operation.\";s:25:\"grp_err_registration_data\";s:82:\"Please enter a password, the expiration date and time for a valid joining period !\";s:23:\"grp_header_edit_members\";s:12:\"Edit members\";s:8:\"grp_join\";s:19:\"User may join Group\";s:9:\"grp_leave\";s:20:\"User may leave Group\";s:14:\"grp_list_users\";s:10:\"List users\";s:30:\"grp_mail_body_new_subscription\";s:39:\"You have been subscribed to this group.\";s:36:\"grp_mail_body_subscription_cancelled\";s:35:\"Your membership has been cancelled.\";s:30:\"grp_mail_subj_new_subscription\";s:16:\"New subscription\";s:36:\"grp_mail_subj_subscription_cancelled\";s:22:\"Subscription cancelled\";s:21:\"grp_mem_change_status\";s:20:\"Change Member Status\";s:13:\"grp_mem_leave\";s:25:\"Dismiss member from group\";s:17:\"grp_mem_send_mail\";s:21:\"Send member a message\";s:19:\"grp_members_gallery\";s:21:\"Group Members Gallery\";s:27:\"grp_msg_applicants_assigned\";s:40:\"Applicant(s) assigned as group member(s)\";s:26:\"grp_msg_applicants_removed\";s:31:\"Applicant(s) removed from list.\";s:23:\"grp_msg_member_assigned\";s:35:\"User(s) assigned as group member(s)\";s:27:\"grp_msg_membership_annulled\";s:21:\"Cancelled membership.\";s:15:\"grp_name_exists\";s:68:\"There is already a group with this name! Please choose another name.\";s:7:\"grp_new\";s:9:\"New Group\";s:14:\"grp_new_search\";s:10:\"New search\";s:22:\"grp_no_groups_selected\";s:21:\"Please select a group\";s:20:\"grp_no_results_found\";s:16:\"No results found\";s:21:\"grp_no_roles_selected\";s:20:\"Please select a role\";s:11:\"grp_options\";s:7:\"Options\";s:8:\"grp_read\";s:20:\"Read access to Group\";s:12:\"grp_register\";s:4:\"Join\";s:16:\"grp_registration\";s:10:\"Join group\";s:26:\"grp_registration_completed\";s:25:\"You have joined the group\";s:30:\"grp_search_enter_search_string\";s:28:\"Please enter a search string\";s:18:\"grp_search_members\";s:11:\"User search\";s:19:\"grp_select_one_file\";s:23:\"Please select one file.\";s:24:\"grp_select_one_file_only\";s:31:\"Please select exactly one file.\";s:11:\"grp_visible\";s:16:\"Group is visible\";s:9:\"grp_write\";s:10:\"Edit Group\";s:5:\"guest\";s:5:\"Guest\";s:6:\"guests\";s:6:\"Guests\";s:17:\"header_searchable\";s:10:\"Searchable\";s:12:\"header_title\";s:12:\"Header Title\";s:4:\"help\";s:4:\"Help\";s:4:\"hide\";s:4:\"Hide\";s:12:\"hide_details\";s:12:\"Hide Details\";s:18:\"hide_private_notes\";s:10:\"Hide Notes\";s:14:\"hide_structure\";s:23:\"Disable Structured-View\";s:18:\"hist_dbk_delete_pg\";s:32:\"Page \"%1\" [%2] has been deleted.\";s:18:\"hist_dbk_delete_st\";s:35:\"Chapter \"%1\" [%2] has been deleted.\";s:18:\"hist_dbk_pg_create\";s:13:\"Page created.\";s:15:\"hist_dbk_pg_cut\";s:34:\"Page cut out of chapter \"%1\" [%2].\";s:17:\"hist_dbk_pg_paste\";s:35:\"Page pasted into chapter \"%1\" [%2].\";s:18:\"hist_dbk_pg_update\";s:13:\"Page changed.\";s:20:\"hist_dbk_st_cut_page\";s:34:\"Page \"%1\" [%2] cut out of chapter.\";s:22:\"hist_dbk_st_paste_page\";s:35:\"Page \"%1\" [%2] pasted into chapter.\";s:16:\"hist_file_create\";s:32:\"File created, file name is \"%1\".\";s:12:\"file_created\";s:20:\"File has been added.\";s:12:\"file_updated\";s:22:\"File has been updated.\";s:17:\"hist_file_replace\";s:56:\"File replaced, new file name is \"%1\", new version is %2.\";s:17:\"hist_lm_delete_pg\";s:32:\"Page \"%1\" [%2] has been deleted.\";s:17:\"hist_lm_delete_st\";s:35:\"Chapter \"%1\" [%2] has been deleted.\";s:17:\"hist_lm_pg_create\";s:13:\"Page created.\";s:14:\"hist_lm_pg_cut\";s:34:\"Page cut out of chapter \"%1\" [%2].\";s:16:\"hist_lm_pg_paste\";s:35:\"Page pasted into chapter \"%1\" [%2].\";s:17:\"hist_lm_pg_update\";s:13:\"Page changed.\";s:17:\"hist_lm_st_create\";s:16:\"Chapter created.\";s:19:\"hist_lm_st_cut_page\";s:34:\"Page \"%1\" [%2] cut out of chapter.\";s:21:\"hist_lm_st_paste_page\";s:35:\"Page \"%1\" [%2] pasted into chapter.\";s:15:\"hist_no_entries\";s:22:\"No entries in history.\";s:13:\"hist_webr_add\";s:39:\"Added new Web Resource with title: \"%1\"\";s:16:\"hist_webr_delete\";s:33:\"Deleted Web Resource. Title: \"%1\"\";s:16:\"hist_webr_update\";s:32:\"Update Web Resource. Title: \"%1\"\";s:7:\"history\";s:7:\"History\";s:13:\"hits_per_page\";s:9:\"Hits/Page\";s:3:\"hlm\";s:20:\"Learning Module HACP\";s:9:\"hlm_added\";s:26:\"HACP Learning Module added\";s:10:\"hlm_create\";s:27:\"Create HACP Learning Module\";s:10:\"hlm_delete\";s:27:\"Delete HACP Learning Module\";s:19:\"hlm_edit_permission\";s:26:\"Change permission settings\";s:8:\"hlm_join\";s:33:\"Subscribe to HACP Learning Module\";s:9:\"hlm_leave\";s:37:\"Unsubscribe from HACP Learning Module\";s:8:\"hlm_read\";s:35:\"Read access to HACP Learning Module\";s:11:\"hlm_visible\";s:31:\"HACP Learning Module is visible\";s:9:\"hlm_write\";s:25:\"Edit HACP Learning Module\";s:5:\"hobby\";s:17:\"Interests/Hobbies\";s:4:\"home\";s:11:\"Public Area\";s:4:\"host\";s:4:\"Host\";s:4:\"hour\";s:4:\"Hour\";s:5:\"hours\";s:7:\"Hour(s)\";s:12:\"hours_of_day\";s:12:\"Hours of day\";s:4:\"htlm\";s:20:\"Learning Module HTML\";s:8:\"htlm_add\";s:24:\"Add HTML Learning Module\";s:11:\"htlm_delete\";s:27:\"Delete HTML Learning Module\";s:9:\"htlm_edit\";s:36:\"Edit HTML Learning Module Properties\";s:27:\"htlm_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:20:\"htlm_edit_permission\";s:26:\"Change permission settings\";s:8:\"htlm_new\";s:24:\"New HTML Learning Module\";s:9:\"htlm_read\";s:25:\"Read HTML Learning Module\";s:12:\"htlm_visible\";s:31:\"HTML Learning Module is visible\";s:10:\"htlm_write\";s:25:\"Edit HTML Learning Module\";s:4:\"http\";s:4:\"HTTP\";s:17:\"http_not_possible\";s:44:\"This server is not supporting http requests.\";s:9:\"http_path\";s:9:\"Http Path\";s:18:\"https_not_possible\";s:49:\"This server is not supporting HTTPS connnections.\";s:8:\"i2passwd\";s:16:\"ILIAS 2 password\";s:4:\"icla\";s:19:\"LearnLinc Classroom\";s:8:\"icla_add\";s:23:\"Add LearnLinc Classroom\";s:12:\"icla_deleted\";s:30:\"LearnLinc classroom(s) deleted\";s:9:\"icla_edit\";s:24:\"Edit LearnLinc Classroom\";s:8:\"icla_new\";s:23:\"New LearnLinc Classroom\";s:13:\"icon_settings\";s:13:\"Icon Settings\";s:15:\"icons_in_header\";s:10:\"Header row\";s:18:\"icons_in_item_rows\";s:9:\"Item rows\";s:20:\"icons_in_typed_lists\";s:27:\"Icon position in item lists\";s:25:\"icons_in_typed_lists_info\";s:123:\"Determines where to display icons in item lists that are ordered by type within the repository and on the personal desktop.\";s:4:\"icrs\";s:17:\"LearnLinc Seminar\";s:8:\"icrs_add\";s:21:\"Add LearnLinc Seminar\";s:10:\"icrs_added\";s:23:\"LearnLinc Seminar added\";s:16:\"icrs_create_icla\";s:27:\"Create LearnLinc Classrooms\";s:11:\"icrs_delete\";s:24:\"Delete LearnLinc Seminar\";s:9:\"icrs_edit\";s:22:\"Edit LearnLinc Seminar\";s:20:\"icrs_edit_permission\";s:24:\"Edit permission settings\";s:9:\"icrs_join\";s:31:\"User may join LearnLinc Seminar\";s:10:\"icrs_leave\";s:32:\"User may leave LearnLinc Seminar\";s:20:\"icrs_members_gallery\";s:23:\"Seminar Members Gallery\";s:8:\"icrs_new\";s:21:\"New LearnLinc Seminar\";s:9:\"icrs_read\";s:32:\"Read access to LearnLinc Seminar\";s:12:\"icrs_visible\";s:28:\"LearnLinc Seminar is visible\";s:10:\"icrs_write\";s:22:\"Edit LearnLinc Seminar\";s:2:\"id\";s:2:\"ID\";s:10:\"identifier\";s:10:\"identifier\";s:25:\"if_no_title_then_filename\";s:38:\"Leave blank to use file name as title.\";s:20:\"if_no_title_then_url\";s:30:\"Leave blank to display the URL\";s:18:\"ignore_on_conflict\";s:18:\"Ignore on conflict\";s:17:\"il_chat_moderator\";s:14:\"Chat moderator\";s:12:\"il_crs_admin\";s:20:\"Course administrator\";s:13:\"il_crs_member\";s:13:\"Course member\";s:17:\"il_crs_non_member\";s:17:\"Course non-member\";s:20:\"il_grp_status_closed\";s:12:\"Group closed\";s:18:\"il_grp_status_open\";s:10:\"Group open\";s:12:\"il_crs_tutor\";s:12:\"Course tutor\";s:16:\"il_frm_moderator\";s:15:\"Forum moderator\";s:12:\"il_grp_admin\";s:19:\"Group administrator\";s:13:\"il_grp_member\";s:12:\"Group member\";s:13:\"il_icrs_admin\";s:31:\"LearnLinc Seminar administrator\";s:14:\"il_icrs_member\";s:24:\"LearnLinc Seminar member\";s:13:\"ilias_version\";s:13:\"ILIAS version\";s:14:\"ilinc_add_user\";s:11:\"Add user(s)\";s:18:\"ilinc_akclassvalue\";s:11:\"Cost center\";s:19:\"ilinc_akclassvalues\";s:12:\"Cost centers\";s:27:\"ilinc_classroom_always_open\";s:24:\"Classroom is always open\";s:22:\"ilinc_classroom_closed\";s:19:\"Classroom is closed\";s:20:\"ilinc_classroom_open\";s:17:\"Classroom is open\";s:16:\"ilinc_classrooms\";s:20:\"LearnLinc Classrooms\";s:25:\"ilinc_coursemember_status\";s:12:\"Attending as\";s:13:\"ilinc_courses\";s:18:\"LearnLinc Seminars\";s:20:\"ilinc_dismiss_member\";s:82:\"Are you sure you want to dismiss the following user(s) from the LearnLinc Seminar?\";s:20:\"ilinc_dismiss_myself\";s:69:\"Are you sure you want to dismiss yourself from the LearnLinc Seminar?\";s:12:\"ilinc_docent\";s:10:\"Instructor\";s:32:\"ilinc_err_administrator_required\";s:91:\"Member could not be removed, at least one administrator per LearnLinc Seminar is required !\";s:51:\"ilinc_err_at_least_one_groupadministrator_is_needed\";s:55:\"Each LearnLinc Seminar needs at least one administrator\";s:21:\"ilinc_err_last_member\";s:74:\"Last member could not be removed, please delete LearnLinc Seminar instead.\";s:37:\"ilinc_err_member_could_not_be_removed\";s:71:\"User could not be removed. Please verify all dependencies of that user.\";s:23:\"ilinc_err_no_permission\";s:54:\"You do not possess the permissions for this operation.\";s:27:\"ilinc_err_registration_data\";s:87:\"Please enter a password, the expiration date and time for a valid registration period !\";s:23:\"ilinc_header_edit_users\";s:27:\"Edit list of involved users\";s:8:\"ilinc_id\";s:8:\"iLinc ID\";s:11:\"ilinc_login\";s:11:\"iLinc Login\";s:12:\"ilinc_passwd\";s:14:\"iLinc Password\";s:20:\"ilinc_involved_users\";s:14:\"Involved Users\";s:32:\"ilinc_mail_body_new_subscription\";s:51:\"You have been subscribed to this LearnLinc Seminar.\";s:38:\"ilinc_mail_body_subscription_cancelled\";s:35:\"Your membership has been cancelled.\";s:32:\"ilinc_mail_subj_new_subscription\";s:16:\"New subscription\";s:38:\"ilinc_mail_subj_subscription_cancelled\";s:22:\"Subscription cancelled\";s:29:\"ilinc_manage_course_documents\";s:9:\"Materials\";s:23:\"ilinc_mem_change_status\";s:20:\"Change user\'s status\";s:15:\"ilinc_mem_leave\";s:35:\"Dismiss user from LearnLinc Seminar\";s:19:\"ilinc_mem_send_mail\";s:19:\"Send user a message\";s:16:\"ilinc_msg_joined\";s:32:\"You joined the LearnLinc Seminar\";s:25:\"ilinc_msg_member_assigned\";s:16:\"User(s) assigned\";s:29:\"ilinc_msg_membership_annulled\";s:22:\"Subscription cancelled\";s:22:\"ilinc_no_akclassvalues\";s:4:\"none\";s:24:\"ilinc_no_docent_assigned\";s:12:\"Not assigned\";s:12:\"ilinc_notset\";s:7:\"Not set\";s:12:\"ilinc_remark\";s:6:\"Remark\";s:23:\"ilinc_server_not_active\";s:26:\"iLinc Server not activated\";s:13:\"ilinc_student\";s:11:\"Participant\";s:25:\"ilinc_upload_pic_linktext\";s:6:\"Upload\";s:21:\"ilinc_upload_pic_text\";s:67:\"To display your picture in LearnLinc Seminars please use this link:\";s:5:\"image\";s:5:\"Image\";s:16:\"image_gen_unsucc\";s:93:\"Image generation unsuccessful. Contact your system administrator and verify the convert path.\";s:6:\"import\";s:6:\"Import\";s:10:\"import_alm\";s:19:\"Import AICC Package\";s:19:\"import_cat_localrol\";s:40:\"Create local role for every new category\";s:16:\"import_cat_table\";s:61:\"The following table is only meaningful if the checkbox is set\";s:17:\"import_categories\";s:17:\"Import Categories\";s:10:\"import_dbk\";s:19:\"Import Digilib Book\";s:18:\"import_failure_log\";s:18:\"Import failure log\";s:11:\"import_file\";s:11:\"Import File\";s:21:\"import_file_not_valid\";s:29:\"The import file is not valid.\";s:15:\"import_finished\";s:28:\"Number of imported messages.\";s:21:\"import_forum_finished\";s:28:\"The forum has been imported.\";s:15:\"import_glossary\";s:15:\"Import Glossary\";s:10:\"import_grp\";s:12:\"Import Group\";s:19:\"import_grp_finished\";s:32:\"Imported group without any error\";s:10:\"import_hlm\";s:19:\"Import HACP Package\";s:9:\"import_lm\";s:28:\"Import ILIAS Learning module\";s:10:\"import_qpl\";s:25:\"Import Question Pool Test\";s:25:\"import_questions_into_qpl\";s:37:\"Import question(s) into question pool\";s:16:\"import_root_user\";s:16:\"Import Root User\";s:11:\"import_sahs\";s:25:\"Import SCORM/AICC Package\";s:10:\"import_spl\";s:27:\"Import Question Pool Survey\";s:10:\"import_svy\";s:13:\"Import Survey\";s:10:\"import_tst\";s:11:\"Import Test\";s:12:\"import_users\";s:12:\"Import Users\";s:18:\"import_warning_log\";s:18:\"Import warning log\";s:9:\"important\";s:9:\"Important\";s:8:\"imported\";s:8:\"imported\";s:2:\"in\";s:2:\"in\";s:6:\"in_use\";s:13:\"User Language\";s:8:\"inactive\";s:8:\"Inactive\";s:5:\"inbox\";s:5:\"Inbox\";s:13:\"include_local\";s:50:\"include local language file when updating language\";s:4:\"info\";s:11:\"Information\";s:27:\"info_access_and_status_info\";s:29:\"Access- and Statusinformation\";s:23:\"info_access_permissions\";s:18:\"Access permissions\";s:20:\"info_accessFree_sure\";s:77:\"Are you sure you want to remove the limited access for the following user(s)?\";s:16:\"info_assign_sure\";s:54:\"Are you sure you want to assign the following user(s)?\";s:13:\"info_assigned\";s:8:\"assigned\";s:20:\"info_available_roles\";s:15:\"Available roles\";s:21:\"info_change_user_view\";s:11:\"Change User\";s:16:\"info_delete_sure\";s:59:\"Are you sure that you want to delete the following item(s)?\";s:18:\"info_activate_sure\";s:78:\"Are you sure that you want to approve the following user(s) as active user(s)?\";s:20:\"info_deactivate_sure\";s:81:\"Are you sure that you want to disapprove the following user(s) as active user(s)?\";s:28:\"info_delete_warning_no_trash\";s:102:\"(WARNING: Selected Objects will be removed irreversibly from System and may not be recovered anymore!)\";s:12:\"info_deleted\";s:17:\"Object(s) Deleted\";s:22:\"info_enter_login_or_id\";s:36:\"<i>(Enter login name or user ID)</i>\";s:23:\"info_err_user_not_exist\";s:52:\"User with that login name or user_id does not exists\";s:14:\"info_from_role\";s:27:\"Granted by Role / Ownership\";s:14:\"info_is_member\";s:14:\"User is member\";s:18:\"info_is_not_member\";s:20:\"User is not a member\";s:17:\"info_not_assigned\";s:12:\"not assigned\";s:20:\"info_owner_of_object\";s:15:\"Owner of object\";s:22:\"info_permission_origin\";s:17:\"Original Position\";s:22:\"info_permission_source\";s:15:\"Effective From*\";s:23:\"info_remark_interrupted\";s:116:\"Role is interrupted at this position. The role\'s default permission settings in effect are located in that position.\";s:10:\"info_short\";s:4:\"Info\";s:16:\"info_status_info\";s:19:\"Permissions of User\";s:10:\"info_trash\";s:15:\"Deleted Objects\";s:17:\"info_view_of_user\";s:4:\"User\";s:16:\"inform_user_mail\";s:38:\"Send mail to inform user about changes\";s:16:\"information_abbr\";s:4:\"Info\";s:19:\"ingmedia_all_offers\";s:6:\"All LE\";s:19:\"ingmedia_back_to_le\";s:10:\"Back to LE\";s:23:\"ingmedia_good_afternoon\";s:14:\"Good afternoon\";s:21:\"ingmedia_good_evening\";s:12:\"Good evening\";s:21:\"ingmedia_good_morning\";s:12:\"Good morning\";s:19:\"ingmedia_good_night\";s:10:\"Good night\";s:14:\"ingmedia_hello\";s:5:\"Hello\";s:25:\"ingmedia_info_about_work1\";s:2:\"On\";s:25:\"ingmedia_info_about_work2\";s:77:\", you worked here for the last time. You can continue there by clicking here:\";s:19:\"ingmedia_level_zero\";s:8:\"Level up\";s:19:\"ingmedia_pers_dates\";s:13:\"Personal data\";s:15:\"ingmedia_reg_fo\";s:17:\"Registered forums\";s:15:\"ingmedia_reg_le\";s:13:\"Registered LE\";s:18:\"ingmedia_use_info1\";s:193:\"Here you can change your personal data. Except for the INGMEDIA username and password, you do not have to fill out other fields. Remember that lost passwords can only be returned by e-mail (!).\";s:18:\"ingmedia_use_info2\";s:186:\"It is not allowed to use special characters (like , ; . = - * + #) in your INGMEDIA username and password. To be allowed to use the INGMEDIA platform, you must accept the user agreement.\";s:18:\"ingmedia_use_info3\";s:47:\"Please select one of the links in the side bar.\";s:18:\"ingmedia_use_title\";s:17:\"Change user data.\";s:19:\"ingmedia_user_agree\";s:9:\"Agreement\";s:15:\"ingmedia_vis_le\";s:10:\"Visited LE\";s:19:\"ingmedia_visited_le\";s:31:\"All LE you have visited so far.\";s:16:\"ingmedia_welcome\";s:35:\", welcome to your personal desktop!\";s:7:\"inifile\";s:8:\"Ini-File\";s:11:\"input_error\";s:11:\"Input error\";s:6:\"insert\";s:6:\"Insert\";s:18:\"insert_object_here\";s:18:\"Insert object here\";s:7:\"inst_id\";s:15:\"Installation ID\";s:9:\"inst_info\";s:17:\"Installation Info\";s:9:\"inst_name\";s:17:\"Installation Name\";s:7:\"install\";s:7:\"Install\";s:13:\"install_local\";s:18:\"Install With Local\";s:9:\"installed\";s:9:\"Installed\";s:15:\"installed_local\";s:20:\"Installed With Local\";s:11:\"institution\";s:11:\"Institution\";s:25:\"internal_local_roles_only\";s:32:\"Local roles (only autogenerated)\";s:15:\"internal_system\";s:15:\"Internal system\";s:10:\"ip_address\";s:10:\"IP Address\";s:15:\"is_already_your\";s:15:\"is already your\";s:4:\"item\";s:4:\"Item\";s:11:\"java_server\";s:11:\"Java-Server\";s:16:\"java_server_host\";s:4:\"Host\";s:16:\"java_server_info\";s:83:\"If activated, it is possible to search in PDF, HTML files and HTML-Learning modules\";s:25:\"java_server_no_connection\";s:41:\"Attention: Cannot connect to Java server.\";s:16:\"java_server_port\";s:4:\"Port\";s:18:\"java_server_readme\";s:17:\"Setup information\";s:4:\"join\";s:4:\"Join\";s:3:\"buy\";s:3:\"Buy\";s:2:\"kb\";s:5:\"KByte\";s:8:\"keywords\";s:8:\"Keywords\";s:7:\"lang_bg\";s:9:\"Bulgarian\";s:7:\"lang_cs\";s:5:\"Czech\";s:7:\"lang_da\";s:6:\"Danish\";s:15:\"lang_dateformat\";s:5:\"Y-m-d\";s:7:\"lang_de\";s:6:\"German\";s:7:\"lang_el\";s:5:\"Greek\";s:7:\"lang_et\";s:8:\"Estonian\";s:7:\"lang_en\";s:7:\"English\";s:7:\"lang_es\";s:7:\"Spanish\";s:7:\"lang_fi\";s:7:\"Finnish\";s:7:\"lang_fr\";s:6:\"French\";s:7:\"lang_ge\";s:8:\"Georgian\";s:7:\"lang_hu\";s:9:\"Hungarian\";s:7:\"lang_id\";s:10:\"Indonesian\";s:7:\"lang_it\";s:7:\"Italian\";s:7:\"lang_ja\";s:8:\"Japanese\";s:7:\"lang_lt\";s:10:\"Lithuanian\";s:7:\"lang_nl\";s:5:\"Dutch\";s:7:\"lang_no\";s:9:\"Norwegian\";s:9:\"lang_path\";s:13:\"Language Path\";s:7:\"lang_pl\";s:6:\"Polish\";s:7:\"lang_pt\";s:10:\"Portuguese\";s:7:\"lang_ro\";s:8:\"Romanian\";s:7:\"lang_ru\";s:7:\"Russian\";s:16:\"lang_sep_decimal\";s:1:\".\";s:17:\"lang_sep_thousand\";s:1:\",\";s:7:\"lang_sq\";s:8:\"Albanian\";s:7:\"lang_sr\";s:7:\"Serbian\";s:7:\"lang_sv\";s:7:\"Swedish\";s:15:\"lang_timeformat\";s:5:\"H:i:s\";s:22:\"lang_timeformat_no_sec\";s:3:\"H:i\";s:7:\"lang_uk\";s:9:\"Ukrainian\";s:12:\"lang_version\";s:1:\"1\";s:7:\"lang_vi\";s:10:\"Vietnamese\";s:7:\"lang_xx\";s:6:\"Custom\";s:7:\"lang_zh\";s:18:\"Simplified Chinese\";s:14:\"langfile_found\";s:19:\"Language file found\";s:8:\"language\";s:8:\"Language\";s:22:\"language_not_installed\";s:52:\"is not installed. Please install that language first\";s:9:\"languages\";s:9:\"Languages\";s:27:\"languages_already_installed\";s:42:\"Selected language(s) are already installed\";s:29:\"languages_already_uninstalled\";s:44:\"Selected language(s) are already uninstalled\";s:17:\"languages_updated\";s:41:\"All installed languages have been updated\";s:11:\"last_access\";s:11:\"Last Access\";s:11:\"last_change\";s:11:\"Last Change\";s:14:\"last_edited_on\";s:14:\"Last edited on\";s:10:\"last_login\";s:10:\"Last login\";s:11:\"last_update\";s:11:\"Last Update\";s:10:\"last_visit\";s:10:\"Last Visit\";s:8:\"lastname\";s:9:\"Last Name\";s:6:\"launch\";s:6:\"Launch\";s:4:\"ldap\";s:4:\"LDAP\";s:11:\"ldap_basedn\";s:11:\"LDAP BaseDN\";s:14:\"ldap_configure\";s:29:\"Configure LDAP Authentication\";s:20:\"ldap_edit_permission\";s:26:\"Change permission settings\";s:14:\"ldap_login_key\";s:24:\"Attribute for login name\";s:16:\"ldap_objectclass\";s:28:\"ObjectClass of user accounts\";s:11:\"ldap_passwd\";s:21:\"Your current password\";s:9:\"ldap_port\";s:9:\"LDAP Port\";s:9:\"ldap_read\";s:28:\"Read access to LDAP settings\";s:16:\"ldap_search_base\";s:16:\"LDAP Search base\";s:11:\"ldap_server\";s:15:\"LDAP Server URL\";s:8:\"ldap_tls\";s:12:\"Use LDAP TLS\";s:7:\"ldap_v2\";s:6:\"LDAPv2\";s:7:\"ldap_v3\";s:6:\"LDAPv3\";s:12:\"ldap_version\";s:22:\"LDAP protokoll version\";s:12:\"ldap_visible\";s:25:\"LDAP settings are visible\";s:10:\"ldap_write\";s:18:\"Edit LDAP settings\";s:15:\"learning module\";s:15:\"Learning Module\";s:16:\"learning_objects\";s:16:\"Learning Objects\";s:17:\"learning_progress\";s:17:\"Learning Progress\";s:16:\"learning_resourc\";s:17:\"Learning Resource\";s:17:\"learning_resource\";s:17:\"Learning Resource\";s:18:\"learning_resources\";s:18:\"Learning Resources\";s:5:\"level\";s:5:\"Level\";s:4:\"link\";s:4:\"Link\";s:10:\"link_check\";s:10:\"Link check\";s:19:\"link_check_body_top\";s:108:\"You receive this mail because you want to be informed about invalid links of the following learning modules:\";s:20:\"link_check_message_b\";s:61:\"If enabled, you will be informed about invalid links by mail.\";s:27:\"link_check_message_disabled\";s:16:\"Messages diabled\";s:26:\"link_check_message_enabled\";s:16:\"Messages enabled\";s:18:\"link_check_subject\";s:20:\"[ILIAS 3] Link check\";s:22:\"link_checker_refreshed\";s:14:\"Refreshed view\";s:17:\"link_dynamic_info\";s:54:\"You can add dynamic parameters like the ILIAS user id.\";s:13:\"linked_object\";s:26:\"The object has been linked\";s:12:\"linked_pages\";s:12:\"Linked Pages\";s:15:\"links_add_param\";s:14:\"Add parameter:\";s:19:\"links_dyn_parameter\";s:18:\"Dynamic parameters\";s:13:\"links_dynamic\";s:28:\"Dynamic Web Links parameters\";s:18:\"links_dynamic_info\";s:109:\"If enabled, it is possible to append dynamic parameters to Web Links. E.g. the ILIAS user id or the username.\";s:21:\"links_existing_params\";s:20:\"Existing parameters:\";s:10:\"links_name\";s:14:\"Parameter name\";s:19:\"links_no_name_given\";s:31:\"Please choose a parameter name.\";s:20:\"links_no_value_given\";s:32:\"Please choose a parameter value.\";s:19:\"links_not_available\";s:13:\"Not available\";s:23:\"links_parameter_deleted\";s:18:\"Parameter deleted.\";s:16:\"links_select_one\";s:14:\"- Select one -\";s:16:\"links_session_id\";s:16:\"ILIAS session id\";s:13:\"links_user_id\";s:13:\"ILIAS user id\";s:15:\"links_user_name\";s:14:\"ILIAS username\";s:11:\"links_value\";s:15:\"Parameter value\";s:13:\"list_of_pages\";s:10:\"Pages List\";s:17:\"list_of_questions\";s:13:\"Question List\";s:10:\"literature\";s:10:\"Literature\";s:20:\"literature_bookmarks\";s:20:\"Literature Bookmarks\";s:2:\"lm\";s:21:\"Learning Module ILIAS\";s:4:\"lm_a\";s:24:\"an ILIAS Learning Module\";s:6:\"lm_add\";s:25:\"Add ILIAS Learning Module\";s:8:\"lm_added\";s:27:\"ILIAS Learning Module added\";s:9:\"lm_create\";s:28:\"Create ILIAS Learning Module\";s:9:\"lm_delete\";s:28:\"Delete ILIAS Learning Module\";s:25:\"lm_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:18:\"lm_edit_permission\";s:26:\"Change permission settings\";s:7:\"lm_join\";s:34:\"Subscribe to ILIAS Learning Module\";s:8:\"lm_leave\";s:37:\"Unsubscribe from ILIASLearning Module\";s:6:\"lm_new\";s:25:\"New ILIAS Learning Module\";s:7:\"lm_read\";s:36:\"Read access to ILIAS Learning Module\";s:12:\"lm_type_aicc\";s:4:\"AICC\";s:12:\"lm_type_hacp\";s:4:\"HACP\";s:13:\"lm_type_scorm\";s:20:\"SCORM 1.2 (Java-RTE)\";s:17:\"lm_type_scorm2004\";s:31:\"SCORM 1.2/2004 (JavaScript-RTE)\";s:10:\"lm_visible\";s:32:\"ILIAS Learning Module is visible\";s:8:\"lm_write\";s:26:\"Edit ILIAS Learning Module\";s:3:\"lng\";s:8:\"Language\";s:4:\"lngf\";s:9:\"Languages\";s:20:\"lngf_edit_permission\";s:26:\"Change permission settings\";s:9:\"lngf_read\";s:32:\"Read access to Language settings\";s:10:\"lngf_write\";s:54:\"Write access, needed for extended language maintenance\";s:12:\"lngf_visible\";s:29:\"Language settings are visible\";s:2:\"lo\";s:15:\"Learning Object\";s:12:\"lo_available\";s:35:\"Overview Learning Modules & Courses\";s:13:\"lo_categories\";s:13:\"LO Categories\";s:7:\"lo_edit\";s:20:\"Edit Learning Object\";s:6:\"lo_new\";s:19:\"New Learning Object\";s:13:\"lo_no_content\";s:31:\"No Learning Resources Available\";s:14:\"lo_other_langs\";s:22:\"LOs in Other Languages\";s:11:\"lo_overview\";s:11:\"LO Overview\";s:5:\"local\";s:5:\"Local\";s:19:\"local_language_file\";s:19:\"local language file\";s:20:\"local_language_files\";s:20:\"local language files\";s:33:\"local_languages_already_installed\";s:53:\"Selected local language file(s) are already installed\";s:7:\"locator\";s:9:\"Location:\";s:8:\"location\";s:8:\"Location\";s:6:\"log_in\";s:5:\"Login\";s:9:\"logic_and\";s:3:\"and\";s:8:\"logic_or\";s:2:\"or\";s:5:\"login\";s:5:\"Login\";s:8:\"login_as\";s:12:\"Logged in as\";s:10:\"login_data\";s:10:\"Login data\";s:12:\"login_exists\";s:72:\"There is already a user with this login name! Please choose another one.\";s:13:\"login_invalid\";s:117:\"The chosen login is invalid! Only the following characters are allowed (minimum 3 characters): A-Z a-z 0-9 _.-+*@!$%~\";s:10:\"login_time\";s:11:\"Time online\";s:14:\"login_to_ilias\";s:14:\"Login to ILIAS\";s:22:\"login_to_ilias_via_cas\";s:49:\"Login to ILIAS via Central Authentication Service\";s:29:\"login_to_ilias_via_shibboleth\";s:18:\"Login to ILIAS via\";s:6:\"logout\";s:6:\"Logout\";s:11:\"logout_text\";s:56:\"You logged off from ILIAS. Your session has been closed.\";s:4:\"logs\";s:8:\"Log data\";s:3:\"los\";s:16:\"Learning Objects\";s:16:\"los_last_visited\";s:29:\"Last Visited Learning Objects\";s:12:\"last_visited\";s:12:\"Last Visited\";s:4:\"lres\";s:18:\"Learning Resources\";s:4:\"mail\";s:4:\"Mail\";s:11:\"mail_a_root\";s:7:\"Mailbox\";s:16:\"mail_addressbook\";s:12:\"Address Book\";s:15:\"mail_allow_smtp\";s:10:\"Allow SMTP\";s:12:\"mail_b_inbox\";s:5:\"Inbox\";s:12:\"mail_c_trash\";s:5:\"Trash\";s:13:\"mail_d_drafts\";s:6:\"Drafts\";s:17:\"mail_delete_error\";s:20:\"Error while deleting\";s:22:\"mail_delete_error_file\";s:19:\"Error deleting file\";s:11:\"mail_e_sent\";s:4:\"Sent\";s:20:\"mail_edit_permission\";s:26:\"Change Permission Settings\";s:13:\"mail_feedback\";s:13:\"Mail Feedback\";s:12:\"mail_folders\";s:12:\"Mail Folders\";s:11:\"mail_import\";s:6:\"Import\";s:16:\"mail_import_file\";s:11:\"Export file\";s:18:\"mail_intern_enable\";s:6:\"Enable\";s:17:\"mail_mail_visible\";s:24:\"User may use mail system\";s:13:\"mail_mails_of\";s:4:\"Mail\";s:19:\"mail_maxsize_attach\";s:20:\"Max. attachment size\";s:16:\"mail_maxsize_box\";s:17:\"Max. mailbox size\";s:17:\"mail_maxsize_mail\";s:14:\"Max. mail size\";s:19:\"mail_maxtime_attach\";s:29:\"Max. days to keep attachments\";s:17:\"mail_maxtime_mail\";s:22:\"Max. days to keep mail\";s:12:\"mail_members\";s:15:\"Mail to Members\";s:13:\"mail_not_sent\";s:14:\"Mail not sent!\";s:9:\"mail_read\";s:28:\"Read access to mail settings\";s:14:\"mail_search_no\";s:17:\"No entries found.\";s:16:\"mail_search_word\";s:11:\"Search word\";s:15:\"mail_select_one\";s:24:\"You must select one mail\";s:15:\"mail_send_error\";s:18:\"Error sending mail\";s:9:\"mail_sent\";s:10:\"Mail sent!\";s:14:\"mail_smtp_mail\";s:29:\"User may send e-mail via SMTP\";s:11:\"mail_system\";s:14:\"System Message\";s:19:\"mail_system_message\";s:38:\"User may send internal system messages\";s:18:\"mail_use_pear_mail\";s:13:\"Use Pear Mail\";s:23:\"mail_use_pear_mail_info\";s:149:\"Use Pear Mail to parse mailbox addresses. The built in parser in ILIAS is very limited. Pear Mail fully supports internet compliant e-mail addresses.\";s:21:\"mail_pear_mail_needed\";s:117:\"You need to install Pear Mail to use this function. To do this, enter <code>pear install Mail</code> on the terminal.\";s:12:\"mail_visible\";s:25:\"Mail settings are visible\";s:10:\"mail_write\";s:18:\"Edit mail settings\";s:12:\"mail_z_local\";s:12:\"User Folders\";s:5:\"mails\";s:5:\"Mails\";s:8:\"mails_pl\";s:7:\"Mail(s)\";s:15:\"main_menu_frame\";s:14:\"Top Level Menu\";s:20:\"manage_tracking_data\";s:20:\"Manage Tracking Data\";s:13:\"mark_all_read\";s:16:\"Mark All as Read\";s:15:\"mark_all_unread\";s:18:\"Mark All as Unread\";s:13:\"matriculation\";s:20:\"Matriculation number\";s:14:\"max_number_rec\";s:25:\"Maximum number of records\";s:8:\"max_time\";s:12:\"Maximum time\";s:6:\"member\";s:6:\"Member\";s:13:\"member_status\";s:13:\"Member Status\";s:7:\"members\";s:7:\"Members\";s:19:\"membership_annulled\";s:34:\"Your membership has been cancelled\";s:3:\"mep\";s:10:\"Media Pool\";s:7:\"mep_add\";s:14:\"Add Media Pool\";s:9:\"mep_added\";s:16:\"Added Media Pool\";s:10:\"mep_delete\";s:17:\"Delete Media Pool\";s:8:\"mep_edit\";s:26:\"Edit Media Pool Properties\";s:19:\"mep_edit_permission\";s:26:\"Change permission settings\";s:7:\"mep_new\";s:14:\"New Media Pool\";s:28:\"mep_not_insert_already_exist\";s:86:\"The following items have not been inserted because they are already in the media pool:\";s:8:\"mep_read\";s:23:\"Read Media Pool Content\";s:11:\"mep_visible\";s:21:\"Media Pool is visible\";s:9:\"mep_write\";s:23:\"Edit Media Pool Content\";s:11:\"mcst_delete\";s:16:\"Delete Mediacast\";s:11:\"feed_delete\";s:15:\"Delete Web Feed\";s:7:\"message\";s:7:\"Message\";s:15:\"message_content\";s:15:\"Message Content\";s:26:\"message_no_delivered_files\";s:36:\"You do not have submitted any files.\";s:10:\"message_to\";s:11:\"Message to:\";s:9:\"meta_data\";s:8:\"Metadata\";s:7:\"migrate\";s:7:\"Migrate\";s:8:\"min_time\";s:12:\"Minimum time\";s:6:\"minute\";s:6:\"Minute\";s:7:\"minutes\";s:9:\"Minute(s)\";s:7:\"missing\";s:7:\"Missing\";s:3:\"mob\";s:12:\"Media Object\";s:6:\"module\";s:6:\"module\";s:7:\"modules\";s:7:\"Modules\";s:5:\"month\";s:5:\"Month\";s:13:\"month_01_long\";s:7:\"January\";s:14:\"month_01_short\";s:3:\"Jan\";s:13:\"month_02_long\";s:8:\"February\";s:14:\"month_02_short\";s:3:\"Feb\";s:13:\"month_03_long\";s:5:\"March\";s:14:\"month_03_short\";s:3:\"Mar\";s:13:\"month_04_long\";s:5:\"April\";s:14:\"month_04_short\";s:3:\"Apr\";s:13:\"month_05_long\";s:3:\"May\";s:14:\"month_05_short\";s:3:\"May\";s:13:\"month_06_long\";s:4:\"June\";s:14:\"month_06_short\";s:3:\"Jun\";s:13:\"month_07_long\";s:4:\"July\";s:14:\"month_07_short\";s:3:\"Jul\";s:13:\"month_08_long\";s:6:\"August\";s:14:\"month_08_short\";s:3:\"Aug\";s:13:\"month_09_long\";s:9:\"September\";s:14:\"month_09_short\";s:3:\"Sep\";s:13:\"month_10_long\";s:7:\"October\";s:14:\"month_10_short\";s:3:\"Oct\";s:13:\"month_11_long\";s:8:\"November\";s:14:\"month_11_short\";s:3:\"Nov\";s:13:\"month_12_long\";s:8:\"December\";s:14:\"month_12_short\";s:3:\"Dec\";s:7:\"monthly\";s:7:\"monthly\";s:6:\"months\";s:6:\"Months\";s:4:\"move\";s:4:\"Move\";s:7:\"move_up\";s:7:\"Move Up\";s:9:\"move_down\";s:9:\"Move Down\";s:11:\"moveChapter\";s:4:\"Move\";s:8:\"movePage\";s:4:\"Move\";s:7:\"move_to\";s:7:\"Move to\";s:19:\"move_users_to_style\";s:19:\"Move Users to Style\";s:10:\"msg_cancel\";s:16:\"Action cancelled\";s:14:\"msg_changes_ok\";s:19:\"The changes were OK\";s:19:\"msg_clear_clipboard\";s:17:\"Clipboard cleared\";s:10:\"msg_cloned\";s:25:\"Selected object(s) copied\";s:18:\"msg_copy_clipboard\";s:53:\"Selected object(s) stored in clipboard (Action: copy)\";s:17:\"msg_cut_clipboard\";s:52:\"Selected object(s) stored in clipboard (Action: cut)\";s:14:\"msg_cut_copied\";s:25:\"Selected object(s) moved.\";s:16:\"msg_deleted_role\";s:12:\"Role deleted\";s:17:\"msg_deleted_roles\";s:13:\"Roles deleted\";s:23:\"msg_deleted_roles_rolts\";s:30:\"Roles & Role Templates deleted\";s:16:\"msg_deleted_rolt\";s:21:\"Role Template deleted\";s:17:\"msg_deleted_rolts\";s:21:\"Role Template deleted\";s:14:\"msg_error_copy\";s:10:\"Copy Error\";s:10:\"msg_failed\";s:20:\"Sorry, action failed\";s:20:\"msg_invalid_filetype\";s:17:\"Invalid file type\";s:16:\"msg_is_last_role\";s:57:\"You removed the last global role from the following users\";s:30:\"msg_last_role_for_registration\";s:122:\"At least one role must be available in the registration form for new users. This role is currently the only one available.\";s:18:\"msg_link_clipboard\";s:53:\"Selected object(s) stored in clipboard (Action: link)\";s:10:\"msg_linked\";s:26:\"Selected object(s) linked.\";s:19:\"msg_may_not_contain\";s:44:\"This object may not contain objects of type:\";s:23:\"msg_min_one_active_role\";s:52:\"Each user must have at least one active global role!\";s:16:\"msg_min_one_role\";s:45:\"Each user must have at least one global role!\";s:27:\"msg_multi_language_selected\";s:58:\"You selected the same language for different translations!\";s:23:\"msg_no_default_language\";s:86:\"No default language specified! You must define one translation as default translation.\";s:22:\"msg_no_delete_yourself\";s:40:\"You cannot delete your own user account.\";s:11:\"msg_no_file\";s:24:\"You didn\'t choose a file\";s:24:\"msg_no_language_selected\";s:82:\"No translation language specified! You must define a language for each translation\";s:31:\"msg_no_perm_assign_role_to_user\";s:55:\"You have no permission to change user\'s role assignment\";s:31:\"msg_no_perm_assign_user_to_role\";s:52:\"You have no permission to change the user assignment\";s:16:\"msg_no_perm_copy\";s:67:\"You have no permission to create a copy of the following object(s):\";s:18:\"msg_no_perm_create\";s:57:\"You have no permission to create the following object(s):\";s:26:\"msg_no_perm_create_object1\";s:32:\"You have no permission to create\";s:26:\"msg_no_perm_create_object2\";s:17:\"at this location!\";s:23:\"msg_no_perm_create_role\";s:35:\"You have no permission to add roles\";s:23:\"msg_no_perm_create_rolf\";s:120:\"You have no permission to create a Role Folder. Therefore you may not stop inheritance of roles or add local roles here.\";s:23:\"msg_no_perm_create_rolt\";s:44:\"You have no permission to add role templates\";s:23:\"msg_no_perm_create_user\";s:35:\"You have no permission to add users\";s:15:\"msg_no_perm_cut\";s:54:\"You have no permission to cut the following object(s):\";s:18:\"msg_no_perm_delete\";s:57:\"You have no permission to delete the following object(s):\";s:24:\"msg_no_perm_delete_track\";s:47:\"You have no permission to delete tracking data.\";s:16:\"msg_no_perm_link\";s:69:\"You have no permission to create a link from the following object(s):\";s:23:\"msg_no_perm_modify_role\";s:38:\"You have no permission to modify roles\";s:23:\"msg_no_perm_modify_rolt\";s:47:\"You have no permission to modify role templates\";s:23:\"msg_no_perm_modify_user\";s:42:\"You have no permission to modify user data\";s:17:\"msg_no_perm_paste\";s:56:\"You have no permission to paste the following object(s):\";s:16:\"msg_no_perm_perm\";s:50:\"You have no permission to edit permission settings\";s:16:\"msg_no_perm_read\";s:43:\"You have no permission to access this item.\";s:21:\"msg_no_perm_read_item\";s:43:\"You have no permission to access item \'%s\'.\";s:19:\"msg_no_perm_read_lm\";s:52:\"You have no permission to read this learning module.\";s:22:\"msg_no_perm_read_track\";s:51:\"You have no permission to access the user tracking.\";s:20:\"msg_no_perm_undelete\";s:59:\"You have no permission to undelete the following object(s):\";s:17:\"msg_no_perm_write\";s:31:\"You have no permission to write\";s:20:\"msg_no_rolf_allowed1\";s:10:\"The object\";s:20:\"msg_no_rolf_allowed2\";s:39:\"is not allowed to contain a Role Folder\";s:15:\"msg_no_scan_log\";s:28:\"Scan log not implemented yet\";s:20:\"msg_no_search_result\";s:16:\"No entries found\";s:20:\"msg_no_search_string\";s:23:\"Please enter your query\";s:38:\"msg_no_sysadmin_sysrole_not_assignable\";s:77:\"Only a System Administrator may assign users to the System Administrator Role\";s:12:\"msg_no_title\";s:21:\"Please enter a title.\";s:21:\"msg_input_is_required\";s:45:\"This input is required. Please enter a value.\";s:22:\"msg_no_type_accessible\";s:73:\"Sorry. You do not have the permissions to access any [type] of this list.\";s:21:\"msg_no_type_available\";s:50:\"Sorry. There is no [type] available at the moment.\";s:10:\"msg_no_url\";s:22:\"You didn\'t enter a URL\";s:26:\"msg_not_available_for_anon\";s:64:\"The page you have chosen is only accessible for registered users\";s:17:\"msg_not_in_itself\";s:47:\"It\'s not possible to paste the object in itself\";s:17:\"msg_nothing_found\";s:17:\"msg_nothing_found\";s:15:\"msg_obj_created\";s:15:\"Object created.\";s:14:\"msg_obj_exists\";s:41:\"This object already exists in this folder\";s:16:\"msg_obj_modified\";s:20:\"Modifications saved.\";s:15:\"msg_obj_no_link\";s:28:\"are not allowed to be linked\";s:26:\"msg_obj_not_deletable_sold\";s:71:\"Payment is activated for the following objects. They can no be deleted.\";s:22:\"msg_perm_adopted_from1\";s:32:\"Permission settings adopted from\";s:22:\"msg_perm_adopted_from2\";s:27:\"(Settings have been saved!)\";s:28:\"msg_perm_adopted_from_itself\";s:80:\"You cannot adopt permission settings from the current role/role template itself.\";s:11:\"msg_removed\";s:30:\"Object(s) removed from system.\";s:16:\"msg_role_exists1\";s:34:\"A role/role template with the name\";s:16:\"msg_role_exists2\";s:42:\"already exists! Please choose another name\";s:24:\"msg_role_reserved_prefix\";s:90:\"The prefix \'il_\' is reserved for automatically generated roles. Please choose another name\";s:33:\"msg_roleassignment_active_changed\";s:30:\"Active role assignment changed\";s:41:\"msg_roleassignment_active_changed_comment\";s:132:\"This setting is not saved to the user\'s profile! If the user logs in again, all active role assignments reset to their saved values.\";s:26:\"msg_roleassignment_changed\";s:23:\"Role assignment changed\";s:25:\"msg_sysrole_not_deletable\";s:33:\"The system role cannot be deleted\";s:24:\"msg_sysrole_not_editable\";s:149:\"The permission settings of the system role may not be changed. The system role grants all assigned users unlimited access to all objects & functions.\";s:15:\"msg_trash_empty\";s:28:\"There are no deleted objects\";s:13:\"msg_undeleted\";s:20:\"Object(s) undeleted.\";s:19:\"msg_user_last_role1\";s:51:\"The following users are assigned to this role only:\";s:19:\"msg_user_last_role2\";s:84:\"Please delete the users or assign them to another role in order to delete this role.\";s:26:\"msg_userassignment_changed\";s:23:\"User assignment changed\";s:10:\"multimedia\";s:10:\"Multimedia\";s:6:\"my_bms\";s:9:\"Bookmarks\";s:7:\"my_frms\";s:9:\"My Forums\";s:7:\"my_grps\";s:9:\"My Groups\";s:6:\"my_los\";s:19:\"My Learning Objects\";s:7:\"my_tsts\";s:8:\"My Tests\";s:4:\"name\";s:4:\"Name\";s:5:\"never\";s:5:\"never\";s:3:\"new\";s:3:\"New\";s:15:\"new_appointment\";s:15:\"New Appointment\";s:10:\"new_folder\";s:10:\"New Folder\";s:9:\"new_group\";s:9:\"New Group\";s:12:\"new_language\";s:12:\"New Language\";s:17:\"new_list_password\";s:15:\"New suggestions\";s:13:\"new_lowercase\";s:3:\"new\";s:8:\"new_mail\";s:9:\"New mail!\";s:10:\"html_block\";s:10:\"HTML Block\";s:4:\"feed\";s:8:\"Web Feed\";s:8:\"obj_feed\";s:8:\"Web Feed\";s:9:\"objs_feed\";s:9:\"Web Feeds\";s:20:\"feed_edit_permission\";s:26:\"Change permission settings\";s:12:\"feed_visible\";s:19:\"Web Feed is visible\";s:9:\"feed_read\";s:23:\"Read access to Web Feed\";s:10:\"feed_write\";s:13:\"Edit Web Feed\";s:20:\"mcst_edit_permission\";s:26:\"Change permission settings\";s:12:\"mcst_visible\";s:20:\"Mediacast is visible\";s:9:\"mcst_read\";s:24:\"Read access to Mediacast\";s:10:\"mcst_write\";s:14:\"Edit Mediacast\";s:20:\"nwss_edit_permission\";s:26:\"Change permission settings\";s:12:\"nwss_visible\";s:39:\"News and Web Feeds Settings are visible\";s:9:\"nwss_read\";s:42:\"Read access to News and Web Feeds Settings\";s:10:\"nwss_write\";s:32:\"Edit News and Web Feeds Settings\";s:20:\"tags_edit_permission\";s:26:\"Change permission settings\";s:12:\"tags_visible\";s:28:\"Tagging Settings are visible\";s:9:\"tags_read\";s:31:\"Read access to Tagging Settings\";s:10:\"tags_write\";s:21:\"Edit Tagging Settings\";s:15:\"cat_create_feed\";s:15:\"Create Web Feed\";s:15:\"grp_create_feed\";s:15:\"Create Web Feed\";s:15:\"crs_create_feed\";s:15:\"Create Web Feed\";s:15:\"cat_create_mcst\";s:16:\"Create Mediacast\";s:15:\"grp_create_mcst\";s:16:\"Create Mediacast\";s:15:\"crs_create_mcst\";s:16:\"Create Mediacast\";s:16:\"fold_create_mcst\";s:16:\"Create Mediacast\";s:12:\"access_users\";s:15:\"Logged in Users\";s:13:\"access_public\";s:6:\"Public\";s:12:\"access_scope\";s:6:\"Access\";s:14:\"activate_block\";s:8:\"Activate\";s:4:\"next\";s:4:\"Next\";s:24:\"no_agreement_description\";s:115:\"There is currently no user agreement text provided with this installation. Please contact the system administrator.\";s:9:\"delicious\";s:19:\"del.icio.us Account\";s:11:\"select_page\";s:11:\"Select Page\";s:8:\"nickname\";s:8:\"Nickname\";s:2:\"no\";s:2:\"No\";s:14:\"no_access_item\";s:43:\"You have no permission to access this item.\";s:21:\"no_access_item_public\";s:80:\"To access this item you need to be logged in and to have appropriate permissons.\";s:21:\"no_access_link_object\";s:39:\"You are not allowed to link this object\";s:22:\"no_bm_in_personal_list\";s:21:\"No bookmarks defined.\";s:24:\"no_chat_in_personal_list\";s:25:\"No chats in personal list\";s:11:\"no_checkbox\";s:32:\"Please select at least one item.\";s:21:\"no_condition_selected\";s:31:\"Please select one precondition.\";s:19:\"no_conditions_found\";s:25:\"No preconditions created.\";s:11:\"no_datasets\";s:18:\"The table is empty\";s:7:\"no_date\";s:7:\"No date\";s:14:\"no_description\";s:14:\"No description\";s:23:\"no_frm_in_personal_list\";s:27:\"No forums in personal list.\";s:19:\"no_global_role_left\";s:42:\"Every user has to be assigned to one role.\";s:23:\"no_grp_in_personal_list\";s:27:\"No groups in personal list.\";s:19:\"no_import_available\";s:29:\"Import not available for type\";s:20:\"no_import_file_found\";s:20:\"No import file found\";s:16:\"no_invalid_links\";s:23:\"No invalid links found.\";s:8:\"no_limit\";s:8:\"No limit\";s:22:\"no_lo_in_personal_list\";s:37:\"No learning objects in personal list.\";s:14:\"no_local_users\";s:23:\"There are no local user\";s:10:\"no_objects\";s:10:\"No objects\";s:16:\"no_parent_access\";s:37:\"No access to a superordinated object!\";s:13:\"no_permission\";s:41:\"You do not have the necessary permission.\";s:21:\"no_permission_to_join\";s:39:\"You are not allowed to join this group!\";s:32:\"no_roles_user_can_be_assigned_to\";s:98:\"There are no global roles the user can be assigned to. Therefore you are not allowed to add users.\";s:18:\"no_submission_made\";s:3:\"---\";s:8:\"no_title\";s:8:\"No Title\";s:23:\"no_tst_in_personal_list\";s:26:\"No tests in personal list.\";s:30:\"no_user_defined_fields_defined\";s:33:\"No user-defined fields available.\";s:16:\"no_users_applied\";s:21:\"Please select a user.\";s:17:\"no_users_selected\";s:23:\"Please select one user.\";s:24:\"no_xml_file_found_in_zip\";s:35:\"XML file within zip file not found:\";s:11:\"no_zip_file\";s:18:\"No zip file found.\";s:29:\"non_internal_local_roles_only\";s:30:\"Local roles (only userdefined)\";s:4:\"none\";s:4:\"None\";s:6:\"normal\";s:6:\"Normal\";s:12:\"not_accessed\";s:12:\"Not accessed\";s:16:\"not_accessed_yet\";s:16:\"Not accessed yet\";s:13:\"not_available\";s:13:\"Not Available\";s:19:\"not_implemented_yet\";s:19:\"Not implemented yet\";s:13:\"not_installed\";s:13:\"Not Installed\";s:13:\"not_logged_in\";s:21:\"You are not logged in\";s:4:\"note\";s:4:\"Note\";s:18:\"note_all_pub_notes\";s:9:\"All notes\";s:17:\"note_my_pub_notes\";s:13:\"My notes only\";s:5:\"notes\";s:5:\"Notes\";s:9:\"num_users\";s:15:\"Number of Users\";s:18:\"number_of_accesses\";s:18:\"Number of accesses\";s:17:\"number_of_records\";s:17:\"Number of records\";s:3:\"obj\";s:6:\"Object\";s:7:\"obj_adm\";s:14:\"Administration\";s:12:\"obj_adm_desc\";s:90:\"Main system settings folder containing all panels to administrate your ILIAS installation.\";s:8:\"obj_adve\";s:16:\"Advanced Editing\";s:13:\"obj_adve_desc\";s:105:\"Administration settings for advanced editing like JavaScript based Rich Text Editors, LaTeX support etc..\";s:7:\"obj_alm\";s:20:\"Learning Module AICC\";s:8:\"obj_assf\";s:19:\"Test and Assessment\";s:13:\"obj_assf_desc\";s:48:\"Platform settings for the Test & Assessment tool\";s:8:\"obj_auth\";s:31:\"Authentication and Registration\";s:13:\"obj_auth_desc\";s:97:\"Configure your authentication mode (local, LDAP, ...) and new account registration settings here.\";s:7:\"obj_cat\";s:8:\"Category\";s:7:\"obj_cen\";s:12:\"Centra Event\";s:8:\"obj_chac\";s:11:\"Chat Server\";s:13:\"obj_chac_desc\";s:54:\"Configure your chat server here. Enable/disable chats.\";s:8:\"obj_chat\";s:4:\"Chat\";s:7:\"obj_crs\";s:6:\"Course\";s:7:\"obj_dbk\";s:12:\"Digilib Book\";s:7:\"obj_exc\";s:8:\"Exercise\";s:8:\"obj_extt\";s:20:\"Third Party Software\";s:13:\"obj_extt_desc\";s:67:\"Configure external software or services that are supported by ILIAS\";s:8:\"obj_file\";s:4:\"File\";s:8:\"obj_fold\";s:6:\"Folder\";s:7:\"obj_frm\";s:5:\"Forum\";s:7:\"obj_glo\";s:8:\"Glossary\";s:7:\"obj_grp\";s:5:\"Group\";s:7:\"obj_hlm\";s:20:\"Learning Module HACP\";s:8:\"obj_htlm\";s:20:\"Learning Module HTML\";s:8:\"obj_icla\";s:19:\"LearnLinc Classroom\";s:8:\"obj_icrs\";s:17:\"LearnLinc Seminar\";s:8:\"obj_ldap\";s:13:\"LDAP Settings\";s:13:\"obj_ldap_desc\";s:36:\"Configure global LDAP Settings here.\";s:6:\"obj_lm\";s:21:\"Learning Module ILIAS\";s:7:\"obj_lng\";s:8:\"Language\";s:8:\"obj_lngf\";s:9:\"Languages\";s:13:\"obj_lngf_desc\";s:34:\"Manage your system languages here.\";s:6:\"obj_lo\";s:14:\"LearningObject\";s:8:\"obj_mail\";s:4:\"Mail\";s:13:\"obj_mail_desc\";s:36:\"Configure global mail settings here.\";s:7:\"obj_mep\";s:10:\"Media Pool\";s:7:\"obj_mob\";s:12:\"Media Object\";s:13:\"obj_not_found\";s:16:\"Object Not Found\";s:8:\"obj_note\";s:4:\"Note\";s:8:\"obj_notf\";s:19:\"Note Administration\";s:8:\"obj_objf\";s:18:\"Object Definitions\";s:13:\"obj_objf_desc\";s:69:\"Manage ILIAS object types and object permissions. (only for experts!)\";s:9:\"obj_owner\";s:23:\"This Object is owned by\";s:8:\"obj_pays\";s:7:\"Payment\";s:13:\"obj_pays_desc\";s:38:\"Configure payment settings and vendors\";s:6:\"obj_pg\";s:4:\"Page\";s:7:\"obj_qpl\";s:18:\"Question Pool Test\";s:8:\"obj_recf\";s:16:\"Restored Objects\";s:13:\"obj_recf_desc\";s:44:\"Contains restored Objects from System Check.\";s:8:\"obj_role\";s:4:\"Role\";s:8:\"obj_nwss\";s:18:\"News and Web Feeds\";s:8:\"obj_tags\";s:7:\"Tagging\";s:8:\"obj_mcts\";s:9:\"Mediacast\";s:13:\"obj_mcts_desc\";s:31:\"General settings for mediacast.\";s:13:\"obj_nwss_desc\";s:50:\"Settings for internal news and external web feeds.\";s:13:\"obj_tags_desc\";s:29:\"Settings for tagging feature.\";s:8:\"obj_rolf\";s:5:\"Roles\";s:13:\"obj_rolf_desc\";s:23:\"Manage your roles here.\";s:14:\"obj_rolf_local\";s:11:\"Local Roles\";s:19:\"obj_rolf_local_desc\";s:34:\"Contains local roles of object no.\";s:8:\"obj_rolt\";s:13:\"Role Template\";s:8:\"obj_root\";s:15:\"ILIAS root node\";s:15:\"invisible_block\";s:15:\"Invisible Block\";s:20:\"invisible_block_mess\";s:50:\"You do not have the permission to view this block.\";s:8:\"obj_sahs\";s:26:\"Learning Module SCORM/AICC\";s:8:\"obj_seas\";s:6:\"Search\";s:13:\"obj_seas_desc\";s:32:\"Manage the search settings here.\";s:7:\"obj_spl\";s:20:\"Question Pool Survey\";s:6:\"obj_st\";s:7:\"Chapter\";s:8:\"obj_stys\";s:16:\"Style and Layout\";s:13:\"obj_stys_desc\";s:42:\"Manage system skin and style settings here\";s:7:\"obj_svy\";s:6:\"Survey\";s:8:\"obj_svyf\";s:6:\"Survey\";s:13:\"obj_svyf_desc\";s:37:\"Platform settings for the Survey Tool\";s:7:\"obj_tax\";s:8:\"Taxonomy\";s:8:\"obj_taxf\";s:10:\"Taxonomies\";s:13:\"obj_taxf_desc\";s:21:\"Folder for taxonomies\";s:8:\"obj_trac\";s:30:\"Tracking and Learning Progress\";s:13:\"obj_trac_desc\";s:25:\"User access tracking data\";s:7:\"obj_tst\";s:4:\"Test\";s:7:\"obj_typ\";s:22:\"Object Type Definition\";s:8:\"obj_type\";s:11:\"Object Type\";s:7:\"obj_url\";s:3:\"URL\";s:8:\"obj_uset\";s:13:\"User Settings\";s:7:\"obj_usr\";s:4:\"User\";s:8:\"obj_user\";s:4:\"User\";s:8:\"obj_usrf\";s:13:\"User Accounts\";s:13:\"obj_usrf_desc\";s:26:\"Manage user accounts here.\";s:8:\"obj_webr\";s:12:\"Web Resource\";s:6:\"object\";s:6:\"Object\";s:12:\"object_added\";s:12:\"Object added\";s:17:\"object_duplicated\";s:13:\"Object copied\";s:15:\"object_imported\";s:15:\"Object imported\";s:7:\"objects\";s:7:\"Objects\";s:4:\"objf\";s:18:\"Object definitions\";s:20:\"objf_edit_permission\";s:26:\"Change permission settings\";s:9:\"objf_read\";s:33:\"Read access to Object definitions\";s:12:\"objf_visible\";s:30:\"Object definitions are visible\";s:10:\"objf_write\";s:23:\"Edit Object definitions\";s:8:\"objs_alm\";s:21:\"AICC Learning Modules\";s:8:\"objs_cat\";s:10:\"Categories\";s:9:\"objs_chat\";s:5:\"Chats\";s:12:\"objs_confirm\";s:14:\"Confirm Action\";s:8:\"objs_crs\";s:7:\"Courses\";s:8:\"objs_dbk\";s:13:\"Digilib Books\";s:11:\"objs_delete\";s:14:\"Delete objects\";s:8:\"objs_exc\";s:9:\"Exercises\";s:9:\"objs_file\";s:5:\"Files\";s:9:\"objs_fold\";s:7:\"Folders\";s:8:\"objs_frm\";s:6:\"Forums\";s:8:\"objs_glo\";s:10:\"Glossaries\";s:8:\"objs_grp\";s:6:\"Groups\";s:8:\"objs_hlm\";s:21:\"HACP Learning Modules\";s:9:\"objs_htlm\";s:21:\"HTML Learning Modules\";s:9:\"objs_icla\";s:20:\"LearnLinc Classrooms\";s:9:\"objs_icrs\";s:18:\"LearnLinc Seminars\";s:7:\"objs_lm\";s:22:\"ILIAS Learning Modules\";s:8:\"objs_lng\";s:9:\"Languages\";s:7:\"objs_lo\";s:16:\"Learning Objects\";s:8:\"objs_mep\";s:11:\"Media Pools\";s:8:\"objs_mob\";s:13:\"Media Objects\";s:9:\"objs_note\";s:5:\"Notes\";s:7:\"objs_pg\";s:5:\"Pages\";s:8:\"objs_qpl\";s:19:\"Question Pools Test\";s:9:\"objs_role\";s:5:\"Roles\";s:9:\"objs_rolt\";s:14:\"Role Templates\";s:9:\"objs_sahs\";s:27:\"SCORM/AICC Learning Modules\";s:8:\"objs_spl\";s:21:\"Question Pools Survey\";s:7:\"objs_st\";s:8:\"Chapters\";s:8:\"objs_svy\";s:7:\"Surveys\";s:8:\"objs_tst\";s:5:\"Tests\";s:9:\"objs_type\";s:12:\"Object Types\";s:8:\"objs_url\";s:4:\"URLs\";s:8:\"objs_usr\";s:5:\"Users\";s:9:\"objs_webr\";s:13:\"Web Resources\";s:2:\"of\";s:2:\"Of\";s:7:\"offline\";s:7:\"Offline\";s:15:\"offline_version\";s:15:\"Offline Version\";s:2:\"ok\";s:2:\"OK\";s:2:\"go\";s:2:\"Go\";s:8:\"hh_mm_ss\";s:8:\"HH:MM:SS\";s:5:\"hh_mm\";s:5:\"HH:MM\";s:3:\"old\";s:3:\"Old\";s:6:\"online\";s:6:\"Online\";s:14:\"online_chapter\";s:14:\"Online Chapter\";s:11:\"online_time\";s:25:\"Time online (DD:HH:MM:SS)\";s:14:\"online_version\";s:14:\"Online Version\";s:26:\"open_views_inside_frameset\";s:26:\"Open views inside frameset\";s:9:\"operation\";s:9:\"Operation\";s:8:\"optimize\";s:8:\"Optimize\";s:7:\"options\";s:7:\"Options\";s:22:\"options_for_subobjects\";s:22:\"Options for subobjects\";s:8:\"order_by\";s:8:\"Order by\";s:16:\"order_by_answers\";s:16:\"Order by Answers\";s:13:\"order_by_date\";s:13:\"Order by Date\";s:5:\"other\";s:5:\"Other\";s:8:\"overview\";s:8:\"Overview\";s:9:\"overwrite\";s:9:\"Overwrite\";s:5:\"owner\";s:5:\"Owner\";s:13:\"owner_updated\";s:14:\"Owner updated.\";s:4:\"page\";s:4:\"Page\";s:9:\"page_edit\";s:9:\"Edit Page\";s:5:\"pages\";s:5:\"Pages\";s:9:\"parameter\";s:9:\"Parameter\";s:5:\"parse\";s:5:\"Parse\";s:6:\"passed\";s:6:\"Passed\";s:6:\"passwd\";s:8:\"Password\";s:17:\"passwd_generation\";s:19:\"Password Generation\";s:22:\"passwd_generation_info\";s:65:\"If enabled, passwords can only be selected from a pretended list.\";s:14:\"passwd_invalid\";s:119:\"The new password is invalid! Only the following characters are allowed (minimum 6 characters): A-Z a-z 0-9 _.-+?#*@!$%~\";s:16:\"passwd_not_match\";s:81:\"Your entries for the new password don\'t match! Please re-enter your new password.\";s:12:\"passwd_wrong\";s:34:\"The password you entered is wrong!\";s:8:\"password\";s:8:\"Password\";s:28:\"password_assistance_disabled\";s:102:\"Password assistance is only then available, when user authentication is done via local ILIAS database.\";s:24:\"password_assistance_info\";s:239:\"If password assistance is enabled, a link with the text \"Forgot Password?\" is shown on the login page of ILIAS. Users can use this link to assign a new password to their user account, without needing assistance from a system administrator.\";s:5:\"paste\";s:5:\"Paste\";s:12:\"pasteChapter\";s:5:\"Paste\";s:9:\"pastePage\";s:5:\"Paste\";s:4:\"path\";s:4:\"Path\";s:12:\"path_not_set\";s:12:\"Path not set\";s:15:\"path_to_babylon\";s:15:\"Path to Babylon\";s:15:\"path_to_convert\";s:15:\"Path to Convert\";s:15:\"path_to_htmldoc\";s:15:\"Path to HTMLdoc\";s:12:\"path_to_java\";s:12:\"Path to Java\";s:13:\"path_to_unzip\";s:13:\"Path to Unzip\";s:11:\"path_to_zip\";s:11:\"Path to Zip\";s:6:\"pathes\";s:5:\"Paths\";s:11:\"pay_methods\";s:11:\"Pay methods\";s:15:\"payment_buyable\";s:7:\"Buyable\";s:13:\"payment_in_sc\";s:24:\"Already in shopping cart\";s:20:\"payment_payed_access\";s:12:\"Payed/Access\";s:14:\"payment_system\";s:14:\"Payment System\";s:9:\"pays_edit\";s:21:\"Edit payment settings\";s:20:\"pays_edit_permission\";s:26:\"Change permission settings\";s:9:\"pays_read\";s:23:\"Access payment settings\";s:12:\"pays_visible\";s:28:\"Payment settings are visible\";s:10:\"pays_write\";s:21:\"Edit payment settings\";s:10:\"pdf_export\";s:10:\"PDF Export\";s:10:\"per_object\";s:17:\"Access per object\";s:16:\"perm_role_info_1\";s:98:\"This form determines the permissions of role \'%s\' for newly created objects under the object \'%s\'.\";s:16:\"perm_role_info_2\";s:180:\"If you want to change the permissions of role \'%s\' for all already existing objects underneath \'%s\' you must check the option \'Change Existing Objects\' at the bottom of the screen.\";s:21:\"perm_role_info_glob_1\";s:94:\"This form determines the permissions of role \'%s\' for newly created objects in the repository.\";s:21:\"perm_role_info_glob_2\";s:174:\"If you want to change the permissions of role \'%s\' for all existing objects in the repository you must check the option \'Change Existing Objects\' at the bottom of the screen.\";s:13:\"perm_settings\";s:11:\"Permissions\";s:10:\"perma_link\";s:14:\"Permanent Link\";s:10:\"permission\";s:10:\"Permission\";s:17:\"permission_denied\";s:17:\"Permission Denied\";s:19:\"permission_settings\";s:26:\"Object Permission Settings\";s:24:\"permission_settings_info\";s:83:\"This form determines which role is allowed to do what with the current object \'%s\'.\";s:12:\"person_title\";s:5:\"Title\";s:13:\"personal_data\";s:20:\"Personal Information\";s:16:\"personal_desktop\";s:16:\"Personal Desktop\";s:16:\"personal_picture\";s:16:\"Personal Picture\";s:16:\"personal_profile\";s:16:\"Personal Profile\";s:7:\"persons\";s:7:\"Persons\";s:4:\"pg_a\";s:6:\"a page\";s:6:\"pg_add\";s:8:\"Add page\";s:8:\"pg_added\";s:10:\"Page added\";s:7:\"pg_edit\";s:9:\"Edit page\";s:6:\"pg_new\";s:8:\"New page\";s:5:\"phone\";s:5:\"Phone\";s:10:\"phone_home\";s:11:\"Phone, Home\";s:12:\"phone_mobile\";s:13:\"Phone, Mobile\";s:12:\"phone_office\";s:13:\"Phone, Office\";s:6:\"phrase\";s:6:\"Phrase\";s:13:\"please_choose\";s:12:\"-- Select --\";s:19:\"please_enter_target\";s:21:\"Please enter a target\";s:18:\"please_enter_title\";s:20:\"Please enter a title\";s:13:\"please_select\";s:19:\"-- Please Select --\";s:40:\"please_select_a_delivered_file_to_delete\";s:57:\"You must select at least one delivered file to delete it!\";s:42:\"please_select_a_delivered_file_to_download\";s:59:\"You must select at least one delivered file to download it!\";s:11:\"please_wait\";s:14:\"Please wait...\";s:4:\"port\";s:4:\"Port\";s:8:\"position\";s:8:\"Position\";s:27:\"precondition_not_accessible\";s:79:\"You do not have sufficient permission to view the precondition(s) of this item.\";s:13:\"preconditions\";s:13:\"Preconditions\";s:19:\"predefined_template\";s:24:\"Predefined role template\";s:20:\"presentation_options\";s:20:\"Presentation Options\";s:8:\"previous\";s:8:\"Previous\";s:5:\"print\";s:5:\"Print\";s:10:\"print_view\";s:10:\"Print View\";s:13:\"private_notes\";s:13:\"Private Notes\";s:3:\"pro\";s:3:\"Pro\";s:7:\"proceed\";s:7:\"Proceed\";s:7:\"profile\";s:7:\"Profile\";s:15:\"profile_changed\";s:42:\"ILIAS eLearning - Your profile has changed\";s:18:\"profile_incomplete\";s:61:\"Your profile is incomplete. Please fill in all required data.\";s:10:\"profile_of\";s:10:\"Profile of\";s:10:\"properties\";s:10:\"Properties\";s:11:\"pub_section\";s:11:\"Public Area\";s:6:\"public\";s:6:\"public\";s:12:\"public_notes\";s:12:\"Public Notes\";s:14:\"public_profile\";s:14:\"Public Profile\";s:26:\"public_profile_not_visible\";s:30:\"The User Profile is not public\";s:11:\"publication\";s:11:\"Publication\";s:16:\"publication_date\";s:16:\"Publication Date\";s:9:\"published\";s:9:\"Published\";s:23:\"publishing_organisation\";s:23:\"Publishing Organization\";s:7:\"purpose\";s:7:\"Purpose\";s:3:\"qpl\";s:18:\"Question Pool Test\";s:7:\"qpl_add\";s:22:\"Add Question Pool Test\";s:10:\"qpl_delete\";s:25:\"Delete Question Pool Test\";s:19:\"qpl_edit_permission\";s:26:\"Change permission settings\";s:7:\"qpl_new\";s:22:\"New Question Pool Test\";s:8:\"qpl_read\";s:33:\"Read access to Question Pool Test\";s:15:\"qpl_upload_file\";s:11:\"Upload file\";s:11:\"qpl_visible\";s:29:\"Question Pool Test is visible\";s:9:\"qpl_write\";s:23:\"Edit Question Pool Test\";s:9:\"quarterly\";s:9:\"quarterly\";s:10:\"query_data\";s:10:\"Query data\";s:8:\"question\";s:8:\"Question\";s:14:\"question_pools\";s:14:\"Question Pools\";s:4:\"quit\";s:4:\"Quit\";s:5:\"quote\";s:5:\"Quote\";s:4:\"read\";s:4:\"Read\";s:9:\"recf_edit\";s:19:\"Edit RecoveryFolder\";s:9:\"recipient\";s:9:\"Recipient\";s:16:\"referral_comment\";s:29:\"How did you hear about ILIAS?\";s:7:\"refresh\";s:7:\"Refresh\";s:17:\"refresh_languages\";s:17:\"Refresh Languages\";s:12:\"refresh_list\";s:12:\"Refresh List\";s:6:\"refuse\";s:6:\"Refuse\";s:24:\"reg_mail_body_salutation\";s:5:\"Hello\";s:19:\"reg_mail_body_text1\";s:27:\"Welcome to ILIAS eLearning!\";s:19:\"reg_mail_body_text2\";s:39:\"To access ILIAS use the following data:\";s:19:\"reg_mail_body_text3\";s:29:\"Further personal information:\";s:16:\"reg_mail_subject\";s:34:\"ILIAS eLearning - Your access data\";s:19:\"reg_passwd_via_mail\";s:62:\"Your password will be sent to your e-mail address given below.\";s:8:\"register\";s:8:\"Register\";s:13:\"register_info\";s:95:\"Please fill out the form to register (Fields marked with an asterisk are required information).\";s:16:\"registered_since\";s:16:\"Registered since\";s:15:\"registered_user\";s:15:\"registered User\";s:16:\"registered_users\";s:16:\"registered Users\";s:12:\"registration\";s:24:\"New account registration\";s:21:\"registration_disabled\";s:46:\"Only available when using local authentication\";s:20:\"registration_expired\";s:30:\"Registration period expired...\";s:10:\"related_to\";s:10:\"Related to\";s:6:\"remove\";s:6:\"Remove\";s:23:\"remove_personal_picture\";s:6:\"Remove\";s:18:\"remove_translation\";s:18:\"Remove translation\";s:6:\"rename\";s:6:\"Rename\";s:11:\"rename_file\";s:11:\"Rename File\";s:11:\"repeat_scan\";s:23:\"Repeating virus scan...\";s:18:\"repeat_scan_failed\";s:19:\"Repeat scan failed.\";s:20:\"repeat_scan_succeded\";s:21:\"Repeat scan succeded.\";s:12:\"replace_file\";s:12:\"Replace File\";s:5:\"reply\";s:5:\"Reply\";s:10:\"repository\";s:10:\"Repository\";s:16:\"repository_admin\";s:32:\"Repository Trash and Permissions\";s:21:\"repository_admin_desc\";s:81:\"Set permissions for repository items, restore or remove objects from system trash\";s:16:\"repository_frame\";s:18:\"Repository Content\";s:18:\"request_membership\";s:18:\"Request membership\";s:12:\"require_city\";s:12:\"Require city\";s:15:\"require_country\";s:15:\"Require country\";s:20:\"require_default_role\";s:12:\"Require role\";s:18:\"require_department\";s:18:\"Require department\";s:13:\"require_email\";s:14:\"Require e-mail\";s:11:\"require_fax\";s:11:\"Require fax\";s:17:\"require_firstname\";s:18:\"Require first name\";s:14:\"require_gender\";s:14:\"Require gender\";s:13:\"require_hobby\";s:13:\"Require hobby\";s:19:\"require_institution\";s:19:\"Require institution\";s:16:\"require_lastname\";s:17:\"Require last name\";s:13:\"require_login\";s:13:\"Require login\";s:17:\"require_mandatory\";s:9:\"mandatory\";s:21:\"require_matriculation\";s:28:\"Require matriculation number\";s:14:\"require_passwd\";s:16:\"Require password\";s:15:\"require_passwd2\";s:23:\"Require retype password\";s:18:\"require_phone_home\";s:18:\"Require home phone\";s:20:\"require_phone_mobile\";s:20:\"Require mobile phone\";s:20:\"require_phone_office\";s:20:\"Require office phone\";s:24:\"require_referral_comment\";s:24:\"Require referral comment\";s:14:\"require_street\";s:14:\"Require street\";s:15:\"require_zipcode\";s:16:\"Require zip code\";s:14:\"required_field\";s:8:\"Required\";s:5:\"reset\";s:5:\"Reset\";s:9:\"resources\";s:9:\"Resources\";s:15:\"retype_password\";s:15:\"Retype Password\";s:5:\"right\";s:5:\"Right\";s:6:\"rights\";s:6:\"Rights\";s:4:\"role\";s:4:\"Role\";s:6:\"role_a\";s:6:\"a Role\";s:8:\"role_add\";s:8:\"Add Role\";s:14:\"role_add_local\";s:14:\"Add local Role\";s:13:\"role_add_user\";s:19:\"Add User(s) to role\";s:10:\"role_added\";s:10:\"Role added\";s:24:\"role_assigned_desk_items\";s:22:\"Assigned desktop items\";s:26:\"role_assigned_desktop_item\";s:23:\"Created new assignment.\";s:15:\"role_assignment\";s:15:\"Role Assignment\";s:23:\"role_assignment_updated\";s:33:\"Role assignment has been updated.\";s:16:\"role_count_users\";s:15:\"Number of users\";s:12:\"role_deleted\";s:12:\"Role deleted\";s:26:\"role_deleted_desktop_items\";s:19:\"Deleted assignment.\";s:13:\"role_desk_add\";s:19:\"Assign desktop item\";s:22:\"role_desk_none_created\";s:39:\"No desktop items assigned to this role.\";s:9:\"role_edit\";s:9:\"Edit Role\";s:22:\"role_header_edit_users\";s:22:\"Change User Assignment\";s:15:\"role_list_users\";s:10:\"List users\";s:11:\"role_mailto\";s:26:\"Mail to all assigned Users\";s:8:\"role_new\";s:8:\"New Role\";s:15:\"role_new_search\";s:10:\"New search\";s:23:\"role_no_groups_selected\";s:21:\"Please select a group\";s:21:\"role_no_results_found\";s:16:\"No results found\";s:22:\"role_no_roles_selected\";s:20:\"Please select a role\";s:27:\"role_no_users_no_desk_items\";s:96:\"It is not possible to assign personal desktop items, since you cannot assign users to this role.\";s:24:\"role_protect_permissions\";s:19:\"Protect permissions\";s:31:\"role_search_enter_search_string\";s:28:\"Please enter a search string\";s:17:\"role_search_users\";s:11:\"User search\";s:24:\"role_select_desktop_item\";s:60:\"Please select one object that will be assigned to this role.\";s:20:\"role_select_one_item\";s:25:\"Please select one object.\";s:27:\"role_sure_delete_desk_items\";s:58:\"Are you sure you want to delete the following assignments?\";s:19:\"role_templates_only\";s:19:\"Role templates only\";s:18:\"role_user_deassign\";s:23:\"Deassign user from role\";s:14:\"role_user_edit\";s:17:\"Edit account data\";s:19:\"role_user_send_mail\";s:19:\"Send user a message\";s:5:\"roles\";s:5:\"Roles\";s:22:\"roles_of_import_global\";s:27:\"Global roles of import file\";s:21:\"roles_of_import_local\";s:26:\"Local roles of import file\";s:4:\"rolf\";s:5:\"Roles\";s:10:\"rolf_added\";s:17:\"Role Folder added\";s:16:\"rolf_create_role\";s:26:\"Create new Role definition\";s:16:\"rolf_create_rolt\";s:35:\"Create new Role definition template\";s:11:\"rolf_delete\";s:27:\"Delete Roles/Role templates\";s:20:\"rolf_edit_permission\";s:26:\"Change permission settings\";s:24:\"rolf_edit_userassignment\";s:31:\"Change user assignment of Roles\";s:9:\"rolf_read\";s:35:\"Read access to Roles/Role templates\";s:12:\"rolf_visible\";s:32:\"Roles/Role templates are visible\";s:10:\"rolf_write\";s:56:\"Edit default permission settings of Roles/Role templates\";s:4:\"rolt\";s:13:\"Role Template\";s:6:\"rolt_a\";s:15:\"a Role Template\";s:8:\"rolt_add\";s:17:\"Add Role Template\";s:10:\"rolt_added\";s:19:\"Role template added\";s:9:\"rolt_edit\";s:18:\"Edit Role Template\";s:8:\"rolt_new\";s:17:\"New Role Template\";s:15:\"root_create_cat\";s:26:\"User may create Categories\";s:9:\"root_edit\";s:21:\"Edit system root node\";s:20:\"root_edit_permission\";s:26:\"Change permission settings\";s:9:\"root_read\";s:27:\"Read access to ILIAS system\";s:12:\"root_visible\";s:23:\"ILIAS system is visible\";s:10:\"root_write\";s:33:\"Edit metadata of system root node\";s:3:\"row\";s:3:\"Row\";s:4:\"rows\";s:4:\"Rows\";s:18:\"rte_editor_enabled\";s:24:\"Rich Text Editor enabled\";s:19:\"rte_editor_disabled\";s:25:\"Rich Text Editor disabled\";s:4:\"sahs\";s:26:\"Learning Module SCORM/AICC\";s:10:\"sahs_added\";s:32:\"SCORM/AICC Learning Module added\";s:11:\"sahs_create\";s:33:\"Create SCORM/AICC Learning Module\";s:11:\"sahs_delete\";s:33:\"Delete SCORM/AICC Learning Module\";s:27:\"sahs_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:20:\"sahs_edit_permission\";s:26:\"Change permission settings\";s:9:\"sahs_join\";s:39:\"Subscribe to SCORM/AICC Learning Module\";s:10:\"sahs_leave\";s:43:\"Unsubscribe from SCORM/AICC Learning Module\";s:9:\"sahs_read\";s:41:\"Read access to SCORM/AICC Learning Module\";s:12:\"sahs_visible\";s:37:\"SCORM/AICC Learning Module is visible\";s:10:\"sahs_write\";s:31:\"Edit SCORM/AICC Learning Module\";s:10:\"salutation\";s:10:\"Salutation\";s:12:\"salutation_f\";s:8:\"Ms./Mrs.\";s:12:\"salutation_m\";s:3:\"Mr.\";s:4:\"save\";s:4:\"Save\";s:13:\"save_and_back\";s:13:\"Save And Back\";s:12:\"save_message\";s:12:\"Save Message\";s:12:\"save_refresh\";s:16:\"Save and Refresh\";s:11:\"save_return\";s:15:\"Save and Return\";s:13:\"save_settings\";s:13:\"Save Settings\";s:22:\"save_user_related_data\";s:29:\"Save user related access data\";s:5:\"saved\";s:5:\"Saved\";s:18:\"saved_successfully\";s:18:\"Saved Successfully\";s:6:\"search\";s:6:\"Search\";s:13:\"search_active\";s:20:\"Include active users\";s:10:\"search_for\";s:10:\"Search For\";s:9:\"search_in\";s:9:\"Search in\";s:15:\"search_inactive\";s:22:\"Include inactive users\";s:25:\"search_minimum_characters\";s:27:\"The minimum word length is:\";s:10:\"search_new\";s:10:\"New Search\";s:11:\"search_note\";s:125:\"If &quot;search in&quot; is left blank, all users will be searched. This allows you to find all active or all inactive users.\";s:16:\"search_recipient\";s:16:\"Search Recipient\";s:13:\"search_result\";s:13:\"Search result\";s:15:\"search_to_short\";s:23:\"Your query is to short.\";s:11:\"search_user\";s:11:\"Search User\";s:20:\"seas_edit_permission\";s:26:\"Change permission settings\";s:13:\"seas_max_hits\";s:8:\"Max hits\";s:18:\"seas_max_hits_info\";s:63:\"Please enter a number for the maximum number of search results.\";s:9:\"seas_read\";s:20:\"Read search settings\";s:11:\"seas_search\";s:23:\"Allow to use the search\";s:13:\"seas_settings\";s:15:\"Search settings\";s:12:\"seas_visible\";s:27:\"Search settings are visible\";s:10:\"seas_write\";s:20:\"Edit search settings\";s:6:\"second\";s:6:\"Second\";s:7:\"seconds\";s:9:\"Second(s)\";s:8:\"sections\";s:8:\"Sections\";s:6:\"select\";s:6:\"Select\";s:10:\"select_all\";s:10:\"Select All\";s:11:\"select_file\";s:11:\"Select file\";s:19:\"select_max_one_item\";s:27:\"Please select one item only\";s:11:\"select_mode\";s:11:\"Select mode\";s:21:\"select_object_to_copy\";s:41:\"Please select the object you want to copy\";s:21:\"select_object_to_link\";s:47:\"Please select the object which you want to link\";s:15:\"select_password\";s:21:\"Select a new password\";s:19:\"select_questionpool\";s:21:\"Insert questions into\";s:26:\"select_questionpool_option\";s:37:\"--- Please select a question pool ---\";s:8:\"selected\";s:8:\"Selected\";s:14:\"selected_items\";s:14:\"Personal Items\";s:19:\"selected_items_back\";s:22:\"Back to Personal Items\";s:4:\"send\";s:4:\"Send\";s:9:\"send_mail\";s:9:\"Send mail\";s:18:\"send_mail_selected\";s:32:\"Select mail recipients from list\";s:6:\"sender\";s:6:\"Sender\";s:4:\"sent\";s:4:\"Sent\";s:8:\"sequence\";s:8:\"Sequence\";s:9:\"sequences\";s:9:\"Sequences\";s:6:\"server\";s:6:\"Server\";s:11:\"server_data\";s:11:\"Server data\";s:15:\"server_software\";s:15:\"Server Software\";s:3:\"set\";s:3:\"Set\";s:13:\"set_edit_mode\";s:13:\"Set Edit Mode\";s:17:\"setSystemLanguage\";s:19:\"Set System Language\";s:15:\"setUserLanguage\";s:17:\"Set User Language\";s:11:\"set_offline\";s:11:\"Set Offline\";s:10:\"set_online\";s:10:\"Set Online\";s:8:\"settings\";s:8:\"Settings\";s:14:\"settings_saved\";s:14:\"Saved settings\";s:4:\"shib\";s:10:\"Shibboleth\";s:11:\"shib_active\";s:25:\"Enable Shibboleth support\";s:9:\"shib_city\";s:18:\"Attribute for city\";s:14:\"shib_configure\";s:34:\"Configure Shibboleh Authentication\";s:12:\"shib_country\";s:21:\"Attribute for country\";s:14:\"shib_data_conv\";s:38:\"Absolute path to data manipulation API\";s:22:\"shib_data_conv_warning\";s:59:\"The data manipulation API file you specified cannot be read\";s:15:\"shib_department\";s:24:\"Attribute for department\";s:20:\"shib_edit_permission\";s:26:\"Change permission settings\";s:10:\"shib_email\";s:28:\"Attribute for e-mail address\";s:20:\"shib_federation_name\";s:34:\"Name of your Shibboleth federation\";s:14:\"shib_firstname\";s:23:\"Attribute for firstname\";s:11:\"shib_gender\";s:41:\"Attribute for gender (must be \'m\' or \'f\')\";s:31:\"shib_general_login_instructions\";s:159:\"To log in via %s, please click on the login button and choose your organization of the following page.<br>If you have questions concerning this, please ask the\";s:36:\"shib_general_wayf_login_instructions\";s:126:\"In case you are not associated with the given organizations and you need access to a course on this server, please contact the\";s:13:\"shib_idp_list\";s:496:\"Provide a list of Identity Providers to let the user choose from on the ILIAS login page.<br>On each line there must be a comma-separated tuple for <strong>providerID of IdP</strong> (see the Shibboleth metadata file) and <strong>Name of IdP</strong> as it shall be displayed in the drow-down list.<br>As an optional third parameter you can add the <strong>location of a Shibboleth session initiator</strong> that shall be used in case your ILIAS installation is part of a multi federation setup.\";s:16:\"shib_institution\";s:25:\"Attribute for institution\";s:22:\"auth_shib_instructions\";s:93:\"Be sure to read the README for instructions on how to configure Shibboleth support for ILIAS.\";s:30:\"shib_invalid_home_organization\";s:35:\"Please choose a valid organization!\";s:13:\"shib_language\";s:22:\"Attribute for language\";s:13:\"shib_lastname\";s:22:\"Attribute for lastname\";s:10:\"shib_login\";s:27:\"Unique Shibboleth attribute\";s:17:\"shib_login_button\";s:131:\"Path to the image of a Shibboleth login button that is used to redirect users to the WAYF specified in the Shibboleth configuration\";s:24:\"shib_login_external_wayf\";s:25:\"Use external WAYF service\";s:24:\"shib_login_internal_wayf\";s:22:\"Use ILIAS WAYF service\";s:15:\"shib_login_type\";s:22:\"Organization selection\";s:14:\"shib_member_of\";s:19:\"I\'m a member of ...\";s:15:\"shib_phone_home\";s:31:\"Attribute for home phone number\";s:17:\"shib_phone_mobile\";s:33:\"Attribute for mobile phone number\";s:17:\"shib_phone_office\";s:33:\"Attribute for office phone number\";s:9:\"shib_read\";s:34:\"Read access to Shibboleth settings\";s:29:\"shib_select_home_organization\";s:83:\"For authentication via %s, please select your organization from the drop down list.\";s:19:\"shib_settings_saved\";s:34:\"The Shibboleth settings were saved\";s:11:\"shib_street\";s:20:\"Attribute for street\";s:10:\"shib_title\";s:19:\"Attribute for title\";s:11:\"shib_update\";s:26:\"Update this field on login\";s:22:\"shib_user_default_role\";s:41:\"Default role assigned to Shibboleth users\";s:12:\"shib_visible\";s:31:\"Shibboleth settings are visible\";s:10:\"shib_write\";s:24:\"Edit Shibboleth settings\";s:12:\"shib_zipcode\";s:21:\"Attribute for zipcode\";s:4:\"show\";s:4:\"Show\";s:12:\"show_details\";s:12:\"Show Details\";s:9:\"show_list\";s:9:\"Show List\";s:12:\"show_members\";s:15:\"Display Members\";s:13:\"pd_items_news\";s:30:\"Include News of Personal Items\";s:18:\"pd_items_news_info\";s:120:\"If activated, all news related to items that have been added to the personal desktop will be included in the news block.\";s:10:\"show_owner\";s:10:\"Show Owner\";s:15:\"tagging_my_tags\";s:7:\"My Tags\";s:18:\"show_private_notes\";s:10:\"Show Notes\";s:14:\"show_structure\";s:22:\"Enable Structured-View\";s:17:\"show_users_online\";s:17:\"Show active users\";s:9:\"signature\";s:9:\"Signature\";s:4:\"size\";s:4:\"Size\";s:10:\"skin_style\";s:20:\"Default Skin / Style\";s:13:\"standard_icon\";s:13:\"Standard Icon\";s:9:\"tiny_icon\";s:10:\"Small Icon\";s:4:\"smtp\";s:4:\"SMTP\";s:24:\"soap_user_administration\";s:23:\"Administration via SOAP\";s:29:\"soap_user_administration_desc\";s:48:\"If enabled, ILIAS can be administrated via SOAP.\";s:19:\"sort_by_this_column\";s:19:\"Sort by this column\";s:6:\"spacer\";s:6:\"Spacer\";s:3:\"spl\";s:20:\"Question Pool Survey\";s:7:\"spl_add\";s:24:\"Add Question Pool Survey\";s:10:\"spl_delete\";s:27:\"Delete Question Pool Survey\";s:19:\"spl_edit_permission\";s:26:\"Change permission settings\";s:7:\"spl_new\";s:24:\"New Question Pool Survey\";s:8:\"spl_read\";s:35:\"Read access to Question Pool Survey\";s:15:\"spl_upload_file\";s:11:\"Upload file\";s:11:\"spl_visible\";s:31:\"Question Pool Survey is visible\";s:9:\"spl_write\";s:25:\"Edit Question Pool Survey\";s:3:\"ssl\";s:11:\"SSL (HTTPS)\";s:4:\"st_a\";s:9:\"a chapter\";s:6:\"st_add\";s:11:\"Add chapter\";s:8:\"st_added\";s:13:\"Chapter added\";s:7:\"st_edit\";s:12:\"Edit chapter\";s:6:\"st_new\";s:11:\"New chapter\";s:15:\"standard_fields\";s:15:\"Standard Fields\";s:9:\"startpage\";s:10:\"Start page\";s:9:\"statistic\";s:9:\"Statistic\";s:6:\"status\";s:6:\"Status\";s:4:\"step\";s:4:\"Step\";s:16:\"stop_inheritance\";s:16:\"Stop inheritance\";s:6:\"street\";s:6:\"Street\";s:9:\"structure\";s:9:\"Structure\";s:3:\"sty\";s:5:\"Style\";s:16:\"style_activation\";s:16:\"Style Activation\";s:20:\"stys_edit_permission\";s:26:\"Change permission settings\";s:9:\"stys_read\";s:29:\"Read access to style settings\";s:12:\"stys_visible\";s:26:\"Style settings are visible\";s:10:\"stys_write\";s:19:\"Edit style settings\";s:11:\"subcat_name\";s:16:\"Subcategory Name\";s:14:\"subchapter_new\";s:14:\"New Subchapter\";s:7:\"subject\";s:7:\"Subject\";s:14:\"subject_module\";s:14:\"Subject Module\";s:6:\"submit\";s:6:\"Submit\";s:10:\"subobjects\";s:10:\"Subobjects\";s:12:\"subscription\";s:12:\"Subscription\";s:7:\"summary\";s:7:\"Summary\";s:26:\"sure_delete_selected_users\";s:52:\"Are you sure you want to delete the selected user(s)\";s:3:\"svy\";s:6:\"Survey\";s:7:\"svy_add\";s:10:\"Add survey\";s:10:\"svy_delete\";s:13:\"Delete survey\";s:19:\"svy_edit_permission\";s:26:\"Change permission settings\";s:14:\"svy_evaluation\";s:10:\"Statistics\";s:12:\"svy_finished\";s:8:\"finished\";s:10:\"svy_invite\";s:24:\"Invite users to a survey\";s:7:\"svy_new\";s:10:\"New survey\";s:14:\"svy_no_content\";s:20:\"No surveys available\";s:16:\"svy_not_finished\";s:12:\"not finished\";s:15:\"svy_not_started\";s:11:\"not started\";s:15:\"svy_participate\";s:23:\"Participate in a survey\";s:8:\"svy_read\";s:21:\"Read access to survey\";s:7:\"svy_run\";s:3:\"Run\";s:15:\"svy_upload_file\";s:11:\"Upload file\";s:11:\"svy_visible\";s:17:\"Survey is visible\";s:31:\"svy_warning_survey_not_complete\";s:27:\"The survey is not finished!\";s:9:\"svy_write\";s:11:\"Edit survey\";s:6:\"system\";s:6:\"System\";s:12:\"system_check\";s:12:\"System Check\";s:22:\"system_choose_language\";s:22:\"System Choose Language\";s:13:\"system_groups\";s:13:\"System Groups\";s:10:\"system_grp\";s:12:\"System Group\";s:18:\"system_information\";s:18:\"System Information\";s:15:\"system_language\";s:15:\"System Language\";s:14:\"system_message\";s:15:\"System Messages\";s:21:\"system_style_settings\";s:21:\"System Style Settings\";s:13:\"system_styles\";s:13:\"System Styles\";s:17:\"table_mail_import\";s:11:\"Mail import\";s:6:\"target\";s:6:\"Target\";s:3:\"tax\";s:8:\"Taxonomy\";s:7:\"tax_add\";s:12:\"Add Taxonomy\";s:10:\"tax_delete\";s:17:\"Delete taxonomies\";s:8:\"tax_edit\";s:13:\"Edit Taxonomy\";s:19:\"tax_edit_permission\";s:26:\"Change permission settings\";s:7:\"tax_new\";s:12:\"New Taxonomy\";s:8:\"tax_read\";s:25:\"Read access to taxonomies\";s:11:\"tax_visible\";s:19:\"Taxonomy is visible\";s:9:\"tax_write\";s:26:\"Write access to taxonomies\";s:20:\"taxf_edit_permission\";s:26:\"Change permission settings\";s:9:\"taxf_read\";s:30:\"Read access to taxonomy folder\";s:12:\"taxf_visible\";s:26:\"Taxonomy folder is visible\";s:10:\"taxf_write\";s:31:\"Write access to taxonomy folder\";s:4:\"term\";s:4:\"Term\";s:4:\"test\";s:4:\"Test\";s:11:\"test_intern\";s:11:\"Test Intern\";s:11:\"test_module\";s:11:\"Test Module\";s:5:\"tests\";s:5:\"Tests\";s:6:\"thread\";s:6:\"Thread\";s:9:\"thumbnail\";s:9:\"Thumbnail\";s:4:\"time\";s:4:\"Time\";s:6:\"time_d\";s:3:\"Day\";s:6:\"time_h\";s:4:\"Hour\";s:10:\"time_limit\";s:6:\"Access\";s:38:\"time_limit_add_time_limit_for_selected\";s:52:\"Please enter a time period for the selected user(s).\";s:24:\"time_limit_applied_users\";s:13:\"Applied users\";s:15:\"time_limit_from\";s:17:\"From (time limit)\";s:18:\"time_limit_message\";s:20:\"Message (time limit)\";s:28:\"time_limit_no_users_selected\";s:21:\"Please select a user.\";s:20:\"time_limit_not_valid\";s:24:\"The period is not valid.\";s:28:\"time_limit_not_within_owners\";s:60:\"Your access is limited. The period is outside of your limit.\";s:16:\"time_limit_owner\";s:18:\"Owner (time limit)\";s:18:\"time_limit_reached\";s:30:\"Your access period is expired.\";s:20:\"time_limit_unlimited\";s:22:\"Unlimited (time limit)\";s:16:\"time_limit_until\";s:18:\"Until (time limit)\";s:24:\"time_limit_users_updated\";s:17:\"User data updated\";s:11:\"time_limits\";s:6:\"Access\";s:12:\"time_segment\";s:14:\"Period of time\";s:5:\"title\";s:5:\"Title\";s:10:\"title_long\";s:10:\"Long Title\";s:2:\"to\";s:2:\"To\";s:14:\"to_client_list\";s:16:\"Client Selection\";s:10:\"to_desktop\";s:14:\"Add to Desktop\";s:5:\"today\";s:5:\"Today\";s:19:\"toggleGlobalDefault\";s:21:\"Toggle Global Default\";s:17:\"toggleGlobalFixed\";s:19:\"Toggle Global Fixed\";s:5:\"total\";s:5:\"Total\";s:8:\"tpl_path\";s:13:\"Template Path\";s:11:\"trac_delete\";s:20:\"Delete Tracking Data\";s:20:\"trac_edit_permission\";s:26:\"Change permission settings\";s:9:\"trac_read\";s:18:\"Read Tracking Data\";s:12:\"trac_visible\";s:24:\"User tracking is visible\";s:15:\"tracked_objects\";s:15:\"Tracked objects\";s:13:\"tracking_data\";s:13:\"Tracking Data\";s:25:\"tracking_data_del_confirm\";s:81:\"Do you really want to delete all tracking data of the specified month and before?\";s:21:\"tracking_data_deleted\";s:21:\"Tracking data deleted\";s:17:\"tracking_settings\";s:17:\"Tracking Settings\";s:11:\"translation\";s:11:\"Translation\";s:5:\"trash\";s:5:\"Trash\";s:10:\"tree_frame\";s:10:\"Tree Frame\";s:15:\"tree_frame_info\";s:96:\"Defines whether the tree frame (e.g. repository tree) should appear on the left or on the right.\";s:9:\"tree_left\";s:4:\"Left\";s:10:\"tree_right\";s:5:\"Right\";s:8:\"treeview\";s:9:\"Tree View\";s:3:\"tst\";s:4:\"Test\";s:7:\"tst_add\";s:8:\"Add test\";s:13:\"tst_anon_eval\";s:7:\"Results\";s:10:\"tst_delete\";s:11:\"Delete Test\";s:26:\"tst_edit_learning_progress\";s:22:\"Edit Learning Progress\";s:19:\"tst_edit_permission\";s:26:\"Change permission settings\";s:7:\"tst_new\";s:8:\"New test\";s:14:\"tst_no_content\";s:18:\"No tests available\";s:8:\"tst_read\";s:19:\"Read access to Test\";s:7:\"tst_run\";s:3:\"Run\";s:18:\"tst_tst_statistics\";s:25:\"Access to Test Statistics\";s:26:\"tst_statistical_evaluation\";s:10:\"Statistics\";s:15:\"tst_upload_file\";s:11:\"Upload file\";s:20:\"tst_user_not_invited\";s:39:\"You are not supposed to take this test.\";s:23:\"tst_user_wrong_clientip\";s:43:\"You don\'t have the right ip using this test\";s:11:\"tst_visible\";s:15:\"Test is visible\";s:29:\"tst_warning_test_not_complete\";s:25:\"The test is not complete!\";s:9:\"tst_write\";s:9:\"Edit Test\";s:27:\"txt_add_object_instruction1\";s:44:\"Browse to the location where you want to add\";s:27:\"txt_add_object_instruction2\";s:1:\".\";s:14:\"txt_registered\";s:112:\"You successfully registered to ILIAS. Please click on the button below to login to ILIAS with your user account.\";s:24:\"txt_registered_passw_gen\";s:109:\"You successfully registered to ILIAS. You should receive an e-Mail including your generated password shortly.\";s:13:\"txt_submitted\";s:228:\"You successfully submitted an account request to ILIAS. Your account request will be reviewed by the system administrators, and should be activated within 48 hours. You will not be able to log in until your account is activated.\";s:3:\"typ\";s:22:\"Object Type Definition\";s:4:\"type\";s:4:\"Type\";s:22:\"type_your_message_here\";s:22:\"Type Your Message Here\";s:13:\"udf_add_field\";s:9:\"Add Field\";s:15:\"udf_added_field\";s:16:\"Added new field.\";s:17:\"udf_delete_header\";s:12:\"Delete Field\";s:15:\"udf_delete_sure\";s:71:\"Are you sure you want to delete this field and all assigned user data ?\";s:21:\"udf_duplicate_entries\";s:29:\"The values have to be unique.\";s:17:\"udf_field_deleted\";s:14:\"Deleted field.\";s:23:\"udf_name_already_exists\";s:63:\"This field name already exists. Please choose a different name.\";s:14:\"udf_no_entries\";s:31:\"Please enter minimum one value.\";s:17:\"udf_no_name_given\";s:26:\"Please enter a field name.\";s:15:\"udf_type_select\";s:25:\"Select Box (fixed values)\";s:13:\"udf_type_text\";s:22:\"Text (optional values)\";s:23:\"udf_update_select_field\";s:15:\"Edit Select Box\";s:18:\"udf_update_success\";s:20:\"Saved modifications.\";s:21:\"udf_update_text_field\";s:15:\"Edit Text Field\";s:9:\"udf_value\";s:5:\"Value\";s:17:\"udf_value_deleted\";s:27:\"The value has been deleted.\";s:3:\"uid\";s:3:\"UID\";s:22:\"ums_create_new_account\";s:18:\"Create New Account\";s:15:\"ums_explanation\";s:183:\"Your external account could not be mapped to an ILIAS account. But ILIAS has found an account with your e-mail address. If this is your account, please login with your ILIAS password.\";s:17:\"ums_explanation_2\";s:61:\"If this is not your account, please hit \'Create New Account\'.\";s:17:\"ums_explanation_3\";s:198:\"Your external account could not be mapped to an ILIAS account. But ILIAS has found multiple accounts with your e-mail address. If one of those is your account, please login with your ILIAS password.\";s:17:\"ums_explanation_4\";s:65:\"If none of them is your account, please hit \'Create New Account\'.\";s:17:\"ums_login_account\";s:13:\"Login Account\";s:15:\"unambiguousness\";s:15:\"Unambiguousness\";s:11:\"uncheck_all\";s:11:\"Uncheck all\";s:9:\"uninstall\";s:9:\"Uninstall\";s:11:\"uninstalled\";s:12:\"uninstalled.\";s:7:\"unknown\";s:7:\"UNKNOWN\";s:9:\"unlabeled\";s:9:\"Unlabeled\";s:6:\"unread\";s:6:\"Unread\";s:16:\"unread_lowercase\";s:6:\"unread\";s:10:\"unselected\";s:10:\"Unselected\";s:11:\"unsubscribe\";s:19:\"Remove from desktop\";s:5:\"unzip\";s:5:\"Unzip\";s:2:\"up\";s:2:\"Up\";s:6:\"update\";s:4:\"Edit\";s:14:\"update_applied\";s:14:\"Update Applied\";s:15:\"update_language\";s:15:\"Update Language\";s:18:\"update_on_conflict\";s:18:\"Update on conflict\";s:6:\"upload\";s:6:\"Upload\";s:27:\"upload_error_file_not_found\";s:29:\"Upload error: File not found.\";s:20:\"uploaded_and_checked\";s:71:\"The file has been uploaded and checked, you can now start to import it.\";s:3:\"uri\";s:3:\"URI\";s:3:\"url\";s:3:\"URL\";s:5:\"url_a\";s:5:\"a URL\";s:7:\"url_add\";s:7:\"Add URL\";s:9:\"url_added\";s:9:\"URL added\";s:14:\"url_create_url\";s:10:\"Create URL\";s:10:\"url_delete\";s:10:\"Delete URL\";s:15:\"url_description\";s:15:\"URL Description\";s:8:\"url_edit\";s:8:\"Edit URL\";s:19:\"url_edit_permission\";s:26:\"Change Permission settings\";s:7:\"url_new\";s:7:\"New URL\";s:13:\"url_not_found\";s:14:\"File Not Found\";s:8:\"url_read\";s:8:\"Open URL\";s:12:\"url_to_latex\";s:23:\"URL to LaTeX CGI script\";s:11:\"url_visible\";s:14:\"URL is visible\";s:9:\"url_write\";s:8:\"Edit URL\";s:4:\"user\";s:4:\"User\";s:11:\"user_access\";s:15:\"Access per user\";s:10:\"user_added\";s:10:\"User added\";s:15:\"user_assignment\";s:15:\"User Assignment\";s:22:\"user_cant_receive_mail\";s:42:\"user is not allowed to use the mail system\";s:12:\"user_comment\";s:12:\"User comment\";s:19:\"user_defined_fields\";s:19:\"User-defined Fields\";s:17:\"user_defined_list\";s:28:\"Overview User-defined Fields\";s:12:\"user_deleted\";s:12:\"User deleted\";s:14:\"user_activated\";s:22:\"User has been approved\";s:16:\"user_deactivated\";s:25:\"User has been disapproved\";s:11:\"user_detail\";s:11:\"Detail Data\";s:16:\"user_ext_account\";s:16:\"External Account\";s:21:\"user_ext_account_desc\";s:84:\"Account used for external authentication. (CAS, SOAP, LDAP or Radius authentication)\";s:18:\"user_import_failed\";s:19:\"User import failed.\";s:13:\"user_imported\";s:21:\"User import complete.\";s:27:\"user_imported_with_warnings\";s:35:\"User import complete with warnings.\";s:13:\"user_language\";s:13:\"User Language\";s:21:\"user_new_account_mail\";s:16:\"New Account Mail\";s:26:\"user_new_account_mail_desc\";s:90:\"This mail can be sent when an ILIAS user is created by other means then self-registration.\";s:15:\"user_not_chosen\";s:34:\"You did not choose a group-member!\";s:14:\"user_not_known\";s:31:\"Please insert a valid username.\";s:18:\"user_profile_other\";s:17:\"Other Information\";s:26:\"user_send_new_account_mail\";s:23:\"Send new account e-mail\";s:15:\"user_statistics\";s:16:\"Statistical Data\";s:8:\"userdata\";s:9:\"User Data\";s:21:\"userfolder_export_csv\";s:22:\"Comma Separated Values\";s:27:\"userfolder_export_excel_x86\";s:15:\"Microsoft Excel\";s:22:\"userfolder_export_file\";s:4:\"File\";s:27:\"userfolder_export_file_size\";s:9:\"File size\";s:23:\"userfolder_export_files\";s:5:\"Files\";s:21:\"userfolder_export_xml\";s:3:\"XML\";s:8:\"username\";s:9:\"User Name\";s:14:\"ilias_username\";s:15:\"ILIAS User Name\";s:28:\"ilias_and_webfolder_username\";s:29:\"ILIAS and Webfolder User Name\";s:5:\"users\";s:5:\"Users\";s:18:\"users_not_imported\";s:71:\"The following users do not exist, their messages cannot become imported\";s:12:\"users_online\";s:12:\"Active Users\";s:28:\"users_online_show_associated\";s:42:\"Show members of my courses and groups only\";s:19:\"users_online_show_n\";s:23:\"Don\'t show active users\";s:19:\"users_online_show_y\";s:21:\"Show all active users\";s:12:\"usertracking\";s:13:\"User Tracking\";s:3:\"usr\";s:4:\"User\";s:5:\"usr_a\";s:6:\"a User\";s:15:\"usr_active_only\";s:17:\"Active Users only\";s:7:\"usr_add\";s:8:\"Add User\";s:9:\"usr_added\";s:10:\"User added\";s:13:\"usr_agreement\";s:14:\"User Agreement\";s:19:\"usr_agreement_empty\";s:30:\"The agreement contains no text\";s:8:\"usr_edit\";s:9:\"Edit User\";s:20:\"usr_filter_lastlogin\";s:18:\"Last login of user\";s:23:\"usr_filter_coursemember\";s:16:\"Member of course\";s:22:\"usr_filter_groupmember\";s:15:\"Member of group\";s:15:\"usr_filter_role\";s:13:\"Assigned role\";s:17:\"usr_hits_per_page\";s:19:\"Hits/page in tables\";s:17:\"usr_inactive_only\";s:19:\"Inactive Users only\";s:7:\"usr_new\";s:8:\"New User\";s:32:\"usr_settings_explanation_profile\";s:435:\"Check \'Visible\' to show fields in the registration form and personal user profile on the personal desktop. Check \'Changeable\' to allow the user to change the value in the personal profile. Please note that visible fields can always be entered in the registration form. Required fields are required in the registration form and the personal user profile. All data can be changed in the user administration independent on these settings.\";s:27:\"usr_settings_header_profile\";s:21:\"User profile settings\";s:35:\"usr_settings_header_profile_profile\";s:24:\"Personal profile setting\";s:18:\"usr_settings_saved\";s:40:\"Global user settings saved successfully!\";s:14:\"usr_skin_style\";s:12:\"Skin / Style\";s:9:\"usr_style\";s:10:\"User Style\";s:4:\"usrf\";s:13:\"User accounts\";s:16:\"usrf_create_user\";s:23:\"Create new user account\";s:11:\"usrf_delete\";s:20:\"Delete user accounts\";s:20:\"usrf_edit_permission\";s:30:\"Change access to user accounts\";s:24:\"usrf_edit_roleassignment\";s:39:\"Change role assignment of user accounts\";s:23:\"usrf_push_desktop_items\";s:44:\"Allow to push items on the personal desktop.\";s:9:\"usrf_read\";s:28:\"Read access to user accounts\";s:15:\"usrf_read_users\";s:40:\"Role assignment for local administrators\";s:12:\"usrf_visible\";s:25:\"User accounts are visible\";s:10:\"usrf_write\";s:18:\"Edit user accounts\";s:23:\"usrimport_action_failed\";s:19:\"Action %1$s failed.\";s:24:\"usrimport_action_ignored\";s:20:\"Ignored action %1$s.\";s:25:\"usrimport_action_replaced\";s:29:\"Replaced action %1$s by %2$s.\";s:21:\"usrimport_cant_delete\";s:56:\"Can\'t perform \"Delete\" action. No such user in database.\";s:21:\"usrimport_cant_insert\";s:59:\"Can\'t perform \"Insert\" action. User is already in database.\";s:21:\"usrimport_cant_update\";s:56:\"Can\'t perform \"Update\" action. No such user in database.\";s:32:\"usrimport_conflict_handling_info\";s:412:\"When \"Ignore on conflict\" is selected, ILIAS ignores an action, if it can not be performed (e. g. an \"Insert\" action is not done, if there is already a user with the same login in the database.)\\nWhen \"Update on conflict\" is selected, ILIAS updates the database if an action can not be performed. (e. g. an \"Insert\" action is replaced by an \"Update\" action, if a user with the same login exists in the database).\";s:41:\"usrimport_global_role_for_action_required\";s:61:\"At least one global role must be specified for \"%1$s\" action.\";s:21:\"usrimport_ignore_role\";s:11:\"Ignore role\";s:29:\"usrimport_login_is_not_unique\";s:20:\"Login is not unique.\";s:43:\"usrimport_with_specified_role_not_permitted\";s:41:\"Import with specified role not permitted.\";s:31:\"usrimport_xml_attribute_missing\";s:46:\"Attribute \"%2$s\" in element \"%1$s\" is missing.\";s:37:\"usrimport_xml_attribute_value_illegal\";s:62:\"Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is illegal.\";s:42:\"usrimport_xml_attribute_value_inapplicable\";s:85:\"Value \"%3$s\" of attribute \"%2$s\" in element \"%1$s\" is inapplicable for \"%4$s\" action.\";s:37:\"usrimport_xml_element_content_illegal\";s:44:\"Content \"%2$s\" of element \"%1$s\" is illegal.\";s:41:\"usrimport_xml_element_for_action_required\";s:51:\"Element \"%1$s\" must be specified for \"%2$s\" action.\";s:34:\"usrimport_xml_element_inapplicable\";s:49:\"Element \"%1$s\" is inapplicable for \"%2$s\" action.\";s:38:\"usrimport_no_insert_ext_account_exists\";s:63:\"Can\'t perform \"Insert\" action. External account already exists.\";s:38:\"usrimport_no_update_ext_account_exists\";s:63:\"Can\'t perform \"Update\" action. External account already exists.\";s:5:\"valid\";s:5:\"Valid\";s:8:\"validate\";s:8:\"Validate\";s:5:\"value\";s:5:\"Value\";s:5:\"vcard\";s:13:\"Visiting Card\";s:14:\"vcard_download\";s:22:\"Download Visiting Card\";s:7:\"vendors\";s:7:\"Vendors\";s:19:\"verification_failed\";s:19:\"Verification failed\";s:24:\"verification_failure_log\";s:24:\"Verification failure log\";s:16:\"verification_log\";s:16:\"Verification log\";s:24:\"verification_warning_log\";s:24:\"Verification warning log\";s:7:\"version\";s:7:\"Version\";s:8:\"versions\";s:8:\"Versions\";s:4:\"view\";s:4:\"View\";s:12:\"view_content\";s:12:\"View Content\";s:7:\"visible\";s:7:\"Visible\";s:14:\"visible_layers\";s:14:\"Visible Layers\";s:7:\"visitor\";s:7:\"Visitor\";s:8:\"visitors\";s:8:\"Visitors\";s:6:\"visits\";s:6:\"Visits\";s:13:\"web_resources\";s:13:\"Web Resources\";s:4:\"webr\";s:12:\"Web Resource\";s:11:\"webr_active\";s:6:\"Active\";s:8:\"webr_add\";s:16:\"Add Web Resource\";s:13:\"webr_add_item\";s:16:\"Add Web Resource\";s:11:\"webr_delete\";s:19:\"Delete Web Resource\";s:17:\"webr_delete_items\";s:22:\"Delete Web Resource(s)\";s:18:\"webr_deleted_items\";s:24:\"Deleted Web Resource(s).\";s:18:\"webr_disable_check\";s:13:\"Disable check\";s:9:\"webr_edit\";s:17:\"Edit Web Resource\";s:14:\"webr_edit_item\";s:17:\"Edit Web Resource\";s:20:\"webr_edit_permission\";s:26:\"Change permission settings\";s:16:\"webr_fillout_all\";s:36:\"Please fill out all required fields.\";s:17:\"webr_item_updated\";s:19:\"Saved modifications\";s:9:\"webr_join\";s:22:\"Subscribe Web Resource\";s:15:\"webr_last_check\";s:10:\"Last check\";s:21:\"webr_last_check_table\";s:11:\"Last check:\";s:10:\"webr_leave\";s:24:\"Unsubscribe Web Resource\";s:19:\"webr_modified_items\";s:20:\"Saved modifications.\";s:18:\"webr_never_checked\";s:13:\"Never checked\";s:8:\"webr_new\";s:20:\"Add new Web Resource\";s:21:\"webr_no_items_created\";s:24:\"No Web Resources created\";s:9:\"webr_read\";s:27:\"Read access to Web Resource\";s:22:\"webr_sure_delete_items\";s:59:\"Do you really want to delete the following Web Resource(s)?\";s:12:\"webr_visible\";s:23:\"Web Resource is visible\";s:10:\"webr_write\";s:17:\"Edit Web Resource\";s:11:\"webservices\";s:11:\"Webservices\";s:4:\"week\";s:4:\"Week\";s:6:\"weekly\";s:6:\"weekly\";s:5:\"weeks\";s:5:\"Weeks\";s:7:\"welcome\";s:7:\"Welcome\";s:13:\"who_is_online\";s:14:\"Who is online?\";s:14:\"width_x_height\";s:14:\"Width x Height\";s:4:\"with\";s:4:\"with\";s:5:\"write\";s:5:\"Write\";s:17:\"wrong_ip_detected\";s:95:\"Your access is denied because of a wrong client ip.<br>Please contact the system administrator.\";s:4:\"year\";s:4:\"Year\";s:5:\"years\";s:5:\"Years\";s:3:\"yes\";s:3:\"Yes\";s:23:\"you_may_add_local_roles\";s:23:\"You May Add Local Roles\";s:12:\"your_message\";s:12:\"Your Message\";s:3:\"zip\";s:8:\"Zip Code\";s:7:\"zipcode\";s:8:\"Zip Code\";s:13:\"no_start_file\";s:14:\"No Start File.\";s:12:\"access_until\";s:14:\"Access (until)\";s:4:\"news\";s:4:\"News\";s:11:\"access_from\";s:13:\"Access (from)\";s:21:\"access_restrict_enter\";s:56:\"Please set the period for the limited access restriction\";s:24:\"adopt_perm_from_template\";s:24:\"Copy Permission Settings\";s:13:\"edit_grouping\";s:26:\"Edit Membership Limitation\";s:27:\"grouping_select_exactly_one\";s:48:\"Please choose exactly one membership limitation.\";s:13:\"mail_settings\";s:13:\"Mail Settings\";s:10:\"my_courses\";s:10:\"My Courses\";s:14:\"auth_selection\";s:13:\"Login Options\";s:18:\"authenticate_ilias\";s:14:\"Login to ILIAS\";s:17:\"authenticate_with\";s:9:\"Login to:\";s:10:\"select_one\";s:18:\"Please select one.\";s:6:\"obj_ps\";s:20:\"Privacy and Security\";s:11:\"obj_ps_desc\";s:52:\"Configure global privacy and security settings here.\";s:18:\"ps_edit_permission\";s:26:\"Change Permission Settings\";s:10:\"ps_visible\";s:37:\"Privacy/Security Settings are Visible\";s:7:\"ps_read\";s:40:\"Read Access to Privacy/Security Settings\";s:8:\"ps_write\";s:21:\"Edit Privacy/Security\";s:21:\"ps_export_member_data\";s:27:\"User may Export Member Data\";s:34:\"users_online_show_short_associated\";s:29:\"Only course and group members\";s:25:\"users_online_show_short_n\";s:23:\"Don\'t show active users\";s:25:\"users_online_show_short_y\";s:21:\"Show all active users\";s:14:\"marked_entries\";s:14:\"Marked Entries\";s:6:\"legend\";s:6:\"Legend\";s:18:\"obj_webr_duplicate\";s:17:\"Copy Web Resource\";s:15:\"obj_webr_select\";s:36:\"-- Please select one Web Resource --\";s:18:\"obj_file_duplicate\";s:9:\"Copy File\";s:15:\"obj_file_select\";s:28:\"-- Please select one File --\";s:17:\"obj_exc_duplicate\";s:13:\"Copy Exercise\";s:14:\"obj_exc_select\";s:32:\"-- Please select one Exercise --\";s:13:\"auth_settings\";s:23:\"Authentication Settings\";s:17:\"login_information\";s:17:\"Login Information\";s:22:\"login_information_desc\";s:61:\"Please enter a login information for the respective language.\";s:32:\"login_information_settings_saved\";s:45:\"The login information were saved successfully\";s:17:\"obj_frm_duplicate\";s:10:\"Copy Forum\";s:14:\"obj_frm_select\";s:29:\"-- Please select one Forum --\";s:8:\"btn_back\";s:4:\"Back\";s:17:\"obj_tst_duplicate\";s:9:\"Copy Test\";s:17:\"obj_qpl_duplicate\";s:23:\"Copy Question Pool Test\";s:17:\"obj_spl_duplicate\";s:25:\"Copy Question Pool Survey\";s:14:\"obj_tst_select\";s:28:\"-- Please select one Test --\";s:14:\"obj_qpl_select\";s:42:\"-- Please select one Question Pool Test --\";s:14:\"obj_spl_select\";s:44:\"-- Please select one Question Pool Survey --\";s:17:\"obj_svy_duplicate\";s:11:\"Copy Survey\";s:14:\"obj_svy_select\";s:30:\"-- Please select one Survey --\";s:17:\"obj_crs_duplicate\";s:11:\"Copy Course\";s:14:\"obj_crs_select\";s:30:\"-- Please select one Course --\";s:15:\"crs_wizard_page\";s:22:\"Copy Course (Step 2/2)\";s:21:\"crs_copy_threads_info\";s:78:\"Please decide which course materials should be copied, linked or even omitted.\";s:8:\"omit_all\";s:8:\"Omit all\";s:8:\"copy_all\";s:8:\"Copy all\";s:8:\"link_all\";s:8:\"Link all\";s:4:\"omit\";s:4:\"Omit\";s:18:\"obj_fold_duplicate\";s:11:\"Copy Folder\";s:15:\"obj_fold_select\";s:30:\"-- Please select one Folder --\";s:16:\"fold_wizard_page\";s:22:\"Copy Folder (Step 2/2)\";s:22:\"fold_copy_threads_info\";s:71:\"Please decide which materials should be copied, linked or even omitted.\";s:17:\"obj_grp_duplicate\";s:10:\"Copy Group\";s:14:\"obj_grp_select\";s:29:\"-- Please select one Group --\";s:15:\"grp_wizard_page\";s:21:\"Copy Group (Step 2/2)\";s:21:\"grp_copy_threads_info\";s:71:\"Please decide which materials should be copied, linked or even omitted.\";s:8:\"objs_qst\";s:9:\"Questions\";s:18:\"container_no_items\";s:22:\"No Materials Available\";s:8:\"no_items\";s:8:\"No Items\";s:13:\"search_engine\";s:14:\"Search Engines\";s:20:\"enable_search_engine\";s:58:\"Open Public Area for Internet Search Engines (e.g Google).\";s:20:\"mod_rewrite_disabled\";s:49:\"The Apache-Module \'mod_rewrite\' is not available.\";s:20:\"allow_override_alert\";s:50:\"Rules for .htaccess are not interpreted correctly.\";s:8:\"cat_copy\";s:13:\"Copy Category\";s:9:\"chat_copy\";s:9:\"Copy Chat\";s:8:\"crs_copy\";s:11:\"Copy Course\";s:8:\"dbk_copy\";s:17:\"Copy Digilib-Book\";s:8:\"exc_copy\";s:13:\"Copy Exercise\";s:9:\"file_copy\";s:9:\"Copy File\";s:9:\"fold_copy\";s:11:\"Copy Folder\";s:8:\"frm_copy\";s:10:\"Copy Forum\";s:8:\"glo_copy\";s:13:\"Copy Glossary\";s:8:\"grp_copy\";s:10:\"Copy Group\";s:9:\"htlm_copy\";s:25:\"Copy HTML Learning Module\";s:9:\"icrs_copy\";s:22:\"Copy LearnLinc Seminar\";s:7:\"lm_copy\";s:20:\"Copy ILIAS Lernmodul\";s:9:\"mcst_copy\";s:14:\"Copy Mediacast\";s:9:\"sahs_copy\";s:31:\"Copy SCORM/AICC Learning Module\";s:8:\"svy_copy\";s:11:\"Copy Survey\";s:8:\"tst_copy\";s:9:\"Copy Test\";s:9:\"webr_copy\";s:17:\"Copy Web Resource\";s:12:\"missing_perm\";s:18:\"Missing Permission\";s:17:\"forums_anonymized\";s:16:\"Forum anonymized\";s:16:\"forums_anonymous\";s:6:\"anonym\";s:16:\"forums_your_name\";s:9:\"Your Name\";s:16:\"forums_use_alias\";s:113:\"You may use this alias for your posting. If you leave this field blank, your posting will be marked as anonymous.\";s:32:\"forums_enable_forum_notification\";s:34:\"Enable Notification for this Forum\";s:33:\"forums_disable_forum_notification\";s:35:\"Disable Notification for this Forum\";s:33:\"forums_forum_notification_enabled\";s:54:\"You will be notified about new messages in this forum.\";s:23:\"object_copy_in_progress\";s:16:\"Started Copying.\";s:20:\"further_informations\";s:19:\"Further Information\";s:12:\"applications\";s:12:\"Applications\";s:17:\"wizard_title_info\";s:59:\"Please enter the title of the object you want to duplicate.\";s:18:\"wizard_search_list\";s:67:\"Your search produced the following hits. Please select one of them.\";s:27:\"err_auth_ldap_no_ilias_user\";s:127:\"Login failed. LDAP authentication successful, but no corresponding ILIAS user exists. Please contact your system administrator.\";s:21:\"ext_acccount_required\";s:46:\"Please enter the name of the external account.\";s:15:\"err_check_input\";s:57:\"The settings could not be saved. Please check your input.\";s:8:\"filesize\";s:9:\"File Size\";s:8:\"filetype\";s:9:\"File Type\";s:11:\"passwd_list\";s:17:\"List of Passwords\";s:17:\"default_auth_mode\";s:29:\"Default Authentication Method\";s:22:\"default_auth_mode_info\";s:78:\"Please choose the authentication method that is preselected on the login page.\";s:29:\"err_auth_radius_no_ilias_user\";s:87:\"Login failed. Radius authentication successful, but no corresponding ILIAS user exists.\";s:10:\"header_zip\";s:36:\"Upload Multiple Files as Zip-Archive\";s:19:\"take_over_structure\";s:15:\"Adopt Structure\";s:24:\"take_over_structure_info\";s:116:\"If activated, directories in the zip file will be mapped to categories or, if used in groups or courses, to folders.\";s:18:\"msg_wrong_filetype\";s:22:\"File is no zip-archive\";s:19:\"zip_structure_error\";s:48:\"Archive contains same filenames. Upload aborted.\";s:14:\"archive_broken\";s:36:\"Archive seems to be broken or empty.\";s:12:\"precondition\";s:12:\"Precondition\";s:17:\"cond_ref_handling\";s:13:\"Link Settings\";s:15:\"cond_ref_shared\";s:34:\"Shared Preconditions for all Links\";s:15:\"cond_ref_unique\";s:30:\"Unique Preconditions for Links\";s:31:\"msg_input_does_not_match_regexp\";s:29:\"Please provide a valid value.\";s:28:\"msg_input_either_file_or_url\";s:43:\"You have to provide either a URL or a file.\";s:13:\"udf_type_date\";s:4:\"Date\";s:14:\"sorting_header\";s:20:\"Content Item Sorting\";s:20:\"sorting_title_header\";s:13:\"Sort by Title\";s:18:\"sorting_info_title\";s:54:\"Choose this mode to sort items automatically by title.\";s:21:\"sorting_manual_header\";s:13:\"Sort Manually\";s:19:\"sorting_info_manual\";s:60:\"This mode offers you the possibility to sort items manually.\";s:12:\"sorting_save\";s:12:\"Save Sorting\";s:14:\"frm_add_thread\";s:13:\"Add new topic\";s:4:\"bold\";s:4:\"Bold\";s:7:\"newline\";s:7:\"Newline\";s:16:\"ext_cat_settings\";s:31:\"Edit Advanced Category Settings\";s:17:\"edit_cat_settings\";s:26:\"Advanced Category Settings\";s:28:\"mail_search_groups_not_found\";s:54:\"No groups were found you are belonging to as a member.\";s:29:\"mail_search_courses_not_found\";s:55:\"No courses were found you are belonging to as a member.\";s:12:\"frm_add_post\";s:12:\"Add new post\";s:16:\"frm_moderate_frm\";s:25:\"Delete a post, censorship\";s:12:\"obj_calendar\";s:8:\"Calendar\";s:13:\"obj_cals_desc\";s:26:\"General Calendar settings.\";s:17:\"obj_cat_duplicate\";s:13:\"Copy Category\";s:14:\"obj_cat_select\";s:32:\"-- Please select one Category --\";s:15:\"cat_wizard_page\";s:24:\"Copy Category (Step 2/2)\";s:21:\"cat_copy_threads_info\";s:76:\"Please decide which category items should be copied, linked or even omitted.\";s:9:\"webfolder\";s:9:\"Webfolder\";s:15:\"mount_webfolder\";s:17:\"Open as webfolder\";s:15:\"obj_file_inline\";s:20:\"Learning Module File\";s:9:\"yesterday\";s:9:\"Yesterday\";s:8:\"tomorrow\";s:8:\"Tomorrow\";s:12:\"show_profile\";s:12:\"Show profile\";s:21:\"delete_selected_items\";s:6:\"Delete\";s:19:\"link_selected_items\";s:4:\"Link\";s:19:\"move_selected_items\";s:4:\"Move\";s:19:\"copy_selected_items\";s:4:\"Copy\";s:23:\"mail_no_recipient_found\";s:87:\"Enter a different mail address. ILIAS couldn\'t find a recipient with this mail address.\";s:30:\"mail_multiple_recipients_found\";s:97:\"Enter a more specific mail address. ILIAS found multiple possible recipients for this address: %s\";s:21:\"paste_clipboard_items\";s:5:\"Paste\";s:15:\"clear_clipboard\";s:15:\"Clear Clipboard\";s:15:\"disk_space_used\";s:15:\"Disk space used\";s:9:\"in_use_by\";s:9:\"In use by\";s:26:\"filename_extension_missing\";s:26:\"Filename extension missing\";s:27:\"filename_special_characters\";s:63:\"Due to the character / this object is not visible in webfolders\";s:35:\"filename_windows_special_characters\";s:95:\"Due to one of the characters \\ / : * ? \" < > | this object is not visible in Windows webfolders\";s:32:\"filename_windows_empty_extension\";s:94:\"Due to the character . at the end of the name this object is not visible in Windows webfolders\";s:29:\"filename_windows_webdav_issue\";s:71:\"Due to the character # this object is not visible in Windows webfolders\";s:25:\"filename_special_filename\";s:57:\"Objects with names . and .. are not visible in webfolders\";s:19:\"filename_visibility\";s:10:\"Visibility\";s:25:\"filename_hidden_unix_file\";s:16:\"Hidden Unix file\";s:27:\"filename_hidden_backup_file\";s:18:\"Hidden backup file\";s:25:\"filename_interoperability\";s:16:\"Interoperability\";s:25:\"readcount_anonymous_users\";s:33:\"Number of anonymous read accesses\";s:15:\"readcount_users\";s:37:\"Number of non-anonymous read accesses\";s:28:\"accesscount_registered_users\";s:38:\"Read by number of distinct ILIAS users\";s:13:\"state_changed\";s:7:\"changed\";s:20:\"state_changed_inside\";s:14:\"changed inside\";s:9:\"state_new\";s:3:\"new\";s:12:\"state_unread\";s:6:\"unread\";s:24:\"filename_extension_short\";s:9:\"Extension\";s:8:\"obj_facs\";s:15:\"Files & Folders\";s:13:\"obj_facs_desc\";s:44:\"Configure access to file and folder objects.\";s:13:\"enable_webdav\";s:20:\"Enable WebDAV access\";s:18:\"enable_webdav_info\";s:239:\"Allows WebDAV clients to access the repository as a webfolder. Users can open webfolders using the \"open as webfolder\" action in the repository, or by entering the following address in a WebDAV client: <a href=\"%1$s\" folder=\"%1$s\">%1$s</a>\";s:18:\"webfolder_index_of\";s:13:\"Index of %1$s\";s:22:\"webfolder_instructions\";s:22:\"Webfolder instructions\";s:27:\"webfolder_instructions_info\";s:479:\"The webfolder instructions are shown on browsers, which can not open a webfolder directly. You can use HTML code, and the following placeholders: <b>[WEBFOLDER_TITLE]</b>, <b>[WEBFOLDER_URI]</b>, <b>[WEBFOLDER_URI_IE]</b>, <b>[WEBFOLDER_URI_KONQUEROR]</b>, <b>[WEBFOLDER_URI_NAUTILUS]</b>, <b>[ADMIN_MAIL]</b>, <b>[IF_WINDOWS]</b>...<b>[/IF_WINDOWS]</b>, <b>[IF_MAC]</b>...<b>[/IF_MAC]</b>, <b>[IF_LINUX]</b>...<b>[/IF_LINUX]</b>. Clear the field to get the default instructions.\";s:32:\"webfolder_instructions_titletext\";s:22:\"Open %1$s as webfolder\";s:27:\"webfolder_instructions_text\";s:2823:\"<p>Follow the instructions below, to open <b>[WEBFOLDER_TITLE]</b> as a webfolder:</p>[IF_WINDOWS]<h3>Instructions for Windows Vista</h3><ol><li>Press the key combination Windows+E to open Windows Explorer.</li><li>Click on \'Add Network Place\' in the toolbar. The \'Add a Network Place\' wizard will open.</li><li>Click at the link \'Connect to a website\'.</li><li>Select the \'Choose Another Network Location\' option, and select \'Next\'.<li>In the \'Internet or Network Address\' field enter<br/><b>[WEBFOLDER_URI]</b><br/>then select \'Next\'.</li><li>Enter your login and password, and select \'OK\'.</li>Repeat this step until you get to the next dialog window.</li><li>Enter a name for the webfolder, then select \'Next\'.<li>Enter your login and password, and select \'OK\'.</li>Repeat this step until you get to the next dialog window.</li><li>Select \'Finish\'.</li><li>You can now access the webfolder from the start menu \'Computer\'.</li></ol><h3>Instructions for Windows XP with Internet Explorer 6</h3><ol><li>Start Internet Explorer 6</li><li>Choose the menu \'File &gt; Open...\'</li><li>In the \'Open\' field enter the following address:<br/><b>[WEBFOLDER_URI_IE]</b></li><li>Select the \'Open as web-folder\' option, then select \'OK\'.</li><li>Enter your login and password, and select \'OK\'.</li></ol><h3>Instructions for Windows XP without Internet Explorer 6</h3><ol><li>Double-click the \'My Network Places\' icon on the Desktop.</li><li>Click on \'Add Network Place\' from the \'Network Tasks\' menu on the left side of the window.</li><li>The \'Add a Network Place\' wizard will open, select \'Next\'.</li><li>Select the \'Choose Another Network Location\' option, and select \'Next\'.<li>In the \'Internet or Network Address\' field enter<br/><b>[WEBFOLDER_URI]</b><br/>then select \'Next\'.</li><li>Enter your login and password, and select \'OK\'.</li></ol>[/IF_WINDOWS][IF_MAC]<h3>Instructions for Mac OS X</h3><ol><li>Open the Finder</li><li>Choose the menu \'Go &gt; Connect to server...\'</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI]</b>, and select \'Connect\'.</li><li>Enter your login and password, and select \'OK\'.</li></ol>[/IF_MAC][IF_LINUX]<h3>Instructions for Linux with Konqueror</h3><ol><li>Start the Konqueror browser</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI_KONQUEROR]</b></li><li>Press the Enter key.</li><li>Enter your login and password, and select \'OK\'.</li></ol><h3>Instructions for Linux with Nautilus</h3><ol><li>Start the Nautilus browser</li><li>In the address field enter the following address:<br/><b>[WEBFOLDER_URI_NAUTILUS]</b></li><li>Press the Enter key.</li><li>Enter your login and password, and select \'OK\'.</li></ol>[/IF_LINUX]<p>If opening the webfolder does not work, please contact <a href=\\\"mailto:[ADMIN_MAIL]\\\">[ADMIN_MAIL]</a>.</p>\";s:24:\"use_default_instructions\";s:25:\"Use default instructions.\";s:27:\"use_customized_instructions\";s:28:\"Use customized instructions:\";s:22:\"inline_file_extensions\";s:17:\"Web-enabled files\";s:27:\"inline_file_extensions_info\";s:158:\"Files with these extensions are displayed in the browser window.<br/>For example: <b>gif jpg mp3 pdf png</b><br/> All other files are offered for downloading.\";s:18:\"webfolder_dir_info\";s:122:\"You got here, because your browser can\'t open webfolders. Read the <a href=\"%1$s\">instructions for opening webfolders</a>.\";s:24:\"webfolder_mount_dir_with\";s:167:\"Open this page as a Webfolder with <a href=\"%1$s\">Internet Explorer 6</a>, <a href=\"%2$s\">Konqueror</a>, <a href=\"%3$s\">Nautilus</a>, <a href=\"%4$s\">other Browser</a>.\";s:20:\"deleted_user_account\";s:20:\"Deleted user account\";s:8:\"obj_cals\";s:8:\"Calendar\";s:28:\"webdav_pear_auth_http_needed\";s:127:\"You need to install Pear Auth_HTTP to use this function. To do this, enter <code>pear install Auth_HTTP</code> on the terminal.\";s:15:\"survey_defaults\";s:28:\"Default Settings for Surveys\";s:27:\"survey_unlimited_invitation\";s:20:\"Unlimited Invitation\";s:32:\"survey_unlimited_invitation_desc\";s:126:\"Allows unlimited invitation in surveys. Unlimited invitation adds the survey to the personal desktop of every registered user.\";s:22:\"display_webdav_actions\";s:22:\"Display WebDAV actions\";s:27:\"display_webdav_actions_info\";s:111:\"Displays the action \'open as webfolder\' next to each category, folder, course and group item in the repository.\";s:8:\"obj_sess\";s:7:\"Session\";s:9:\"objs_sess\";s:8:\"Sessions\";s:18:\"obj_sess_duplicate\";s:12:\"Copy Session\";s:15:\"obj_sess_select\";s:31:\"-- Please select one Session --\";s:4:\"sess\";s:7:\"Session\";s:8:\"attempts\";s:8:\"Attempts\";s:17:\"decrease_attempts\";s:12:\"Attempts - 1\";s:14:\"mem_reg_period\";s:19:\"Registration Period\";s:9:\"mem_start\";s:19:\"Registration Start:\";s:7:\"mem_end\";s:17:\"Registration End:\";s:16:\"mem_participants\";s:12:\"Participants\";s:13:\"mem_max_users\";s:17:\"Maximum of Users:\";s:15:\"mem_free_places\";s:11:\"Free Places\";s:12:\"mem_reg_type\";s:17:\"Registration Type\";s:19:\"mem_reg_not_started\";s:32:\"The registration has not started\";s:25:\"mem_waiting_list_position\";s:34:\"Your Position on the Waiting List:\";s:16:\"mem_waiting_list\";s:22:\"Users on Waiting List:\";s:19:\"mem_alert_no_places\";s:35:\"There are no free places available.\";s:19:\"mem_already_on_list\";s:47:\"You are already subscribed to the waiting list.\";s:15:\"mem_reg_expired\";s:33:\"The registration time is expired.\";s:13:\"mem_unlimited\";s:9:\"Unlimited\";s:16:\"mail_attachments\";s:16:\"Mail attachments\";s:17:\"forum_attachments\";s:17:\"Forum attachments\";s:8:\"cal_from\";s:5:\"From:\";s:9:\"cal_until\";s:6:\"Until:\";s:23:\"chat_invite_public_room\";s:11:\"Public Chat\";s:22:\"chat_link_to_this_chat\";s:17:\"Link to this chat\";s:8:\"obj_rcrs\";s:11:\"Course-Link\";s:9:\"objs_rcrs\";s:12:\"Course-Links\";s:17:\"udf_type_datetime\";s:13:\"Date and Time\";s:9:\"object_id\";s:9:\"Object-Id\";s:12:\"organization\";s:8:\"Provider\";s:8:\"auth_ecs\";s:3:\"ECS\";s:10:\"csv_export\";s:10:\"CSV-Export\";s:15:\"res_links_short\";s:5:\"Links\";s:22:\"err_auth_mode_inactive\";s:42:\"Your authentication method is deactivated.\";s:20:\"missing_precondition\";s:20:\"Missing Precondition\";s:4:\"shop\";s:4:\"Shop\";s:16:\"assigned_members\";s:16:\"Assigned Members\";s:14:\"password_empty\";s:31:\"The password must not be empty.\";s:16:\"password_expired\";s:91:\"Your password is expired and have to be changed, because the last change was %s day(s) ago.\";s:24:\"new_pass_equals_old_pass\";s:36:\"The new password equals the old one.\";s:17:\"password_to_short\";s:56:\"The password must have at least a size of %s characters.\";s:16:\"password_to_long\";s:55:\"The password must have at most a size of %s characters.\";s:31:\"password_must_chars_and_numbers\";s:49:\"The password must contain characters and numbers.\";s:27:\"password_must_special_chars\";s:45:\"The password must contain special characters.\";s:37:\"password_change_on_first_login_demand\";s:83:\"Your initial password have to be changed before you can start using ILIAS services.\";s:15:\"zip_test_failed\";s:56:\"Zip-Test failed. Please contact you ILIAS administrator.\";s:8:\"ext_link\";s:4:\"Link\";s:26:\"selected_languages_updated\";s:56:\"The selected languages have been updated (if installed):\";s:29:\"lang_refresh_confirm_selected\";s:53:\"Do you really want to refresh the selected languages?\";s:22:\"enable_download_folder\";s:26:\"Enable Downloading Folders\";s:27:\"enable_download_folder_info\";s:67:\"Allows to download a folder including sub structures as a zip file.\";s:8:\"obj_crsr\";s:16:\"Course Reference\";s:9:\"objs_crsr\";s:17:\"Course References\";s:8:\"obj_catr\";s:18:\"Category Reference\";s:9:\"objs_catr\";s:19:\"Category References\";s:4:\"crsr\";s:16:\"Course Reference\";s:4:\"catr\";s:18:\"Category Reference\";s:12:\"reference_of\";s:13:\"Reference of:\";s:8:\"catr_new\";s:29:\"Create new Category Reference\";s:8:\"crsr_new\";s:27:\"Create new Course Reference\";s:9:\"catr_edit\";s:23:\"Edit Category Reference\";s:9:\"crsr_edit\";s:21:\"Edit Course Reference\";s:14:\"crsr_edit_info\";s:55:\"Please choose one course, for creating a new reference.\";s:14:\"catr_edit_info\";s:57:\"Please choose one category, for creating a new reference.\";s:17:\"reference_deleted\";s:25:\"Destination not available\";s:18:\"clone_target_title\";s:37:\"Selection of Target Folder (Step 1/2)\";s:12:\"clone_target\";s:13:\"Target Folder\";s:19:\"clone_option_in_cat\";s:25:\"Copy in Existing Category\";s:19:\"clone_option_in_crs\";s:23:\"Copy in Existing Course\";s:9:\"cat_title\";s:14:\"Category Title\";s:9:\"crs_title\";s:12:\"Course Title\";s:21:\"clone_existing_course\";s:20:\"Copy Existing Course\";s:9:\"objs_mail\";s:4:\"Mail\";}');
INSERT INTO `lng_modules` VALUES ('content','en','a:595:{s:17:\"cont_add_elements\";s:42:\"Click on placeholders to add new elements.\";s:16:\"cont_syntax_help\";s:11:\"Syntax Help\";s:16:\"cont_bullet_list\";s:11:\"Bullet List\";s:18:\"cont_numbered_list\";s:13:\"Numbered List\";s:19:\"cont_wiki_page_link\";s:14:\"Wiki Page Link\";s:27:\"cont_drag_and_drop_elements\";s:64:\"Drag and drop content elements on placeholders to move elements.\";s:27:\"cont_double_click_to_delete\";s:80:\"Double-click on content elements to select them for (de-)activation or deletion.\";s:15:\"cont_insert_map\";s:10:\"Insert Map\";s:13:\"cont_rollback\";s:8:\"Rollback\";s:26:\"cont_rollback_confirmation\";s:59:\"Do you really want to restore this old version of the page?\";s:10:\"cont_links\";s:5:\"Links\";s:19:\"cont_internal_links\";s:14:\"Internal Links\";s:24:\"cont_not_js_chap_editing\";s:30:\"Use No-JavaScript Editing Mode\";s:20:\"cont_js_chap_editing\";s:27:\"Use JavaScript Editing Mode\";s:25:\"cont_chapters_after_pages\";s:73:\"Please note that pages have to precede all subchapters of the same level.\";s:18:\"cont_add_rectangle\";s:13:\"Add Rectangle\";s:15:\"cont_add_circle\";s:10:\"Add Circle\";s:16:\"cont_add_polygon\";s:11:\"Add Polygon\";s:25:\"cont_edit_shape_rectangle\";s:22:\"Edit Shape (Rectangle)\";s:22:\"cont_edit_shape_circle\";s:19:\"Edit Shape (Circle)\";s:23:\"cont_edit_shape_polygon\";s:20:\"Edit Shape (Polygon)\";s:12:\"cont_new_mob\";s:16:\"New Media Object\";s:24:\"cont_mob_from_media_pool\";s:22:\"Choose From Media Pool\";s:22:\"cont_select_media_pool\";s:17:\"Select Media Pool\";s:15:\"cont_update_map\";s:8:\"Edit Map\";s:21:\"cont_table_properties\";s:16:\"Table Properties\";s:26:\"cont_table_cell_properties\";s:21:\"Table Cell Properties\";s:23:\"cont_set_tab_style_info\";s:48:\"Activate checkboxes in table cells to set style.\";s:26:\"cont_set_styles_and_widths\";s:21:\"Set Styles and Widths\";s:13:\"cont_location\";s:8:\"Location\";s:10:\"cont_align\";s:9:\"Alignment\";s:13:\"cont_revision\";s:8:\"Revision\";s:16:\"cont_insert_page\";s:11:\"Insert Page\";s:19:\"cont_insert_chapter\";s:14:\"Insert Chapter\";s:22:\"cont_insert_subchapter\";s:17:\"Insert Subchapter\";s:26:\"cont_insert_page_from_clip\";s:26:\"Paste Pages from Clipboard\";s:29:\"cont_insert_chapter_from_clip\";s:29:\"Paste Chapters from Clipboard\";s:32:\"cont_insert_subchapter_from_clip\";s:32:\"Paste Subchapters from Clipboard\";s:26:\"cont_pages_and_subchapters\";s:21:\"Subchapters and Pages\";s:11:\"cont_pc_new\";s:11:\"New Content\";s:16:\"cont_pc_modified\";s:16:\"Modified Content\";s:15:\"cont_pc_deleted\";s:15:\"Deleted Content\";s:17:\"cont_page_compare\";s:26:\"Compare Selected Revisions\";s:17:\"cont_previous_rev\";s:17:\"Previous Revision\";s:13:\"cont_next_rev\";s:13:\"Next Revision\";s:15:\"cont_latest_rev\";s:15:\"Latest Revision\";s:20:\"content_page_history\";s:12:\"Page History\";s:15:\"content_current\";s:7:\"Current\";s:12:\"content_last\";s:4:\"Last\";s:11:\"HTML export\";s:11:\"HTML Export\";s:27:\"cont_map_file_not_generated\";s:47:\"Sorry. Unable to generate map file for editing.\";s:10:\"PDF export\";s:10:\"PDF Export\";s:5:\"Pages\";s:5:\"Pages\";s:14:\"add_menu_entry\";s:17:\"Add menu entry >>\";s:3:\"all\";s:3:\"All\";s:9:\"all_pages\";s:26:\"the entire Learning module\";s:18:\"choose_public_mode\";s:29:\"Unregistered users may access\";s:19:\"choose_public_pages\";s:30:\"Choose public accessible pages\";s:6:\"citate\";s:6:\"Citate\";s:11:\"citate_from\";s:15:\"Citate From ...\";s:11:\"citate_page\";s:16:\"Citate this Page\";s:9:\"citate_to\";s:13:\"Citate To ...\";s:15:\"cont_Additional\";s:10:\"Additional\";s:12:\"cont_Special\";s:7:\"Special\";s:13:\"cont_Excursus\";s:8:\"Excursus\";s:9:\"cont_left\";s:4:\"Left\";s:10:\"cont_right\";s:5:\"Right\";s:11:\"cont_center\";s:6:\"Center\";s:15:\"cont_left_float\";s:14:\"Left, Floating\";s:16:\"cont_right_float\";s:15:\"Right, Floating\";s:15:\"cont_alphabetic\";s:20:\"Alphabetic A, B, ...\";s:17:\"cont_alphabetic_s\";s:20:\"Alphabetic a, b, ...\";s:11:\"cont_Circle\";s:6:\"Circle\";s:22:\"cont_delete_track_data\";s:20:\"Delete Tracking Data\";s:13:\"cont_Citation\";s:8:\"Citation\";s:9:\"cont_Code\";s:4:\"Code\";s:11:\"cont_bb_tip\";s:52:\"Tip: Styles can be applied quickly to selected text.\";s:12:\"cont_Example\";s:7:\"Example\";s:16:\"cont_e_g_example\";s:4:\"e.g.\";s:14:\"cont_Headline1\";s:10:\"Headline 1\";s:14:\"cont_Headline2\";s:10:\"Headline 2\";s:14:\"cont_Headline3\";s:10:\"Headline 3\";s:9:\"cont_List\";s:4:\"List\";s:14:\"cont_localfile\";s:10:\"Local File\";s:13:\"cont_Mnemonic\";s:8:\"Mnemonic\";s:10:\"cont_Block\";s:5:\"Block\";s:11:\"cont_Number\";s:6:\"Number\";s:9:\"cont_Poly\";s:7:\"Polygon\";s:9:\"cont_Rect\";s:9:\"Rectangle\";s:11:\"cont_Remark\";s:6:\"Remark\";s:10:\"cont_roman\";s:16:\"Roman I, II, ...\";s:12:\"cont_roman_s\";s:16:\"Roman i, ii, ...\";s:17:\"cont_TableContent\";s:13:\"Table Content\";s:14:\"cont_Unordered\";s:9:\"Unordered\";s:15:\"cont_act_number\";s:18:\"Chapter Numeration\";s:18:\"cont_activate_page\";s:13:\"Activate Page\";s:11:\"cont_active\";s:11:\"Enable Menu\";s:13:\"cont_add_area\";s:8:\"Add Area\";s:23:\"cont_add_change_comment\";s:18:\"Add change comment\";s:19:\"cont_add_definition\";s:14:\"Add Definition\";s:19:\"cont_add_fullscreen\";s:15:\"Add Full Screen\";s:18:\"cont_added_comment\";s:34:\"Comment has been added to history.\";s:15:\"cont_added_term\";s:10:\"Term added\";s:20:\"cont_all_definitions\";s:15:\"All Definitions\";s:14:\"cont_all_pages\";s:9:\"All Pages\";s:10:\"cont_annex\";s:5:\"Annex\";s:16:\"cont_api_adapter\";s:16:\"API Adapter Name\";s:20:\"cont_api_func_prefix\";s:20:\"API Functions Prefix\";s:18:\"cont_areas_deleted\";s:18:\"Map areas deleted.\";s:16:\"cont_assign_full\";s:18:\"Assign Full Screen\";s:15:\"cont_assign_std\";s:15:\"Assign Standard\";s:23:\"cont_assign_translation\";s:18:\"Assign translation\";s:24:\"cont_assignments_deleted\";s:33:\"The assignments have been deleted\";s:15:\"cont_autoindent\";s:11:\"Auto Indent\";s:9:\"cont_back\";s:4:\"Back\";s:14:\"cont_booktitle\";s:10:\"Book title\";s:11:\"cont_bottom\";s:6:\"Bottom\";s:27:\"cont_browser_not_js_capable\";s:61:\"JavaScript enabled editing is not supported for your browser.\";s:22:\"cont_cant_copy_folders\";s:38:\"Folders cannot be copied to clipboard.\";s:18:\"cont_cant_del_full\";s:42:\"Deletion of full screen file not possible.\";s:17:\"cont_cant_del_std\";s:44:\"Deletion of standard view file not possible.\";s:12:\"cont_caption\";s:7:\"Caption\";s:16:\"cont_change_type\";s:11:\"Change Type\";s:19:\"cont_chap_and_pages\";s:18:\"Chapters and Pages\";s:32:\"cont_chap_copy_select_target_now\";s:46:\"Chapter marked for copying. Select target now.\";s:27:\"cont_chap_select_target_now\";s:45:\"Chapter marked for moving. Select target now.\";s:13:\"cont_chapters\";s:8:\"Chapters\";s:23:\"cont_chapters_and_pages\";s:18:\"Chapters and Pages\";s:18:\"cont_chapters_only\";s:13:\"Chapters only\";s:19:\"cont_characteristic\";s:14:\"Characteristic\";s:20:\"cont_choose_cont_obj\";s:21:\"Choose Content Object\";s:20:\"cont_choose_glossary\";s:15:\"Choose Glossary\";s:24:\"cont_choose_media_source\";s:19:\"Choose Media Source\";s:21:\"cont_citation_err_one\";s:35:\"You must select exactly one edition\";s:33:\"cont_citation_selection_not_valid\";s:29:\"You\'re selection is not valid\";s:14:\"cont_citations\";s:9:\"Citations\";s:20:\"cont_click_br_corner\";s:60:\"Please click on the bottom right corner of the desired area.\";s:17:\"cont_click_center\";s:43:\"Please click on center of the desired area.\";s:17:\"cont_click_circle\";s:51:\"Please click on a circle point of the desired area.\";s:23:\"cont_click_next_or_save\";s:140:\"Please click on the next point of the polygon or save the area. (It is not necessary to click again on the starting point of this polygon !)\";s:21:\"cont_click_next_point\";s:46:\"Please click on the next point of the polygon.\";s:25:\"cont_click_starting_point\";s:50:\"Please click on the starting point of the polygon.\";s:20:\"cont_click_tl_corner\";s:56:\"Please click on the top left corner of the desired area.\";s:19:\"cont_confirm_delete\";s:42:\"Do you really want to delete this item(s)?\";s:12:\"cont_content\";s:7:\"Content\";s:16:\"cont_content_obj\";s:14:\"Content Object\";s:13:\"cont_contents\";s:8:\"Contents\";s:11:\"cont_coords\";s:11:\"Coordinates\";s:16:\"cont_copy_object\";s:11:\"copy object\";s:22:\"cont_copy_to_clipboard\";s:17:\"Copy to clipboard\";s:23:\"cont_copy_to_media_pool\";s:18:\"Copy to media pool\";s:15:\"cont_create_dir\";s:16:\"Create Directory\";s:23:\"cont_create_export_file\";s:18:\"Create Export File\";s:28:\"cont_create_export_file_html\";s:25:\"Create Export File (HTML)\";s:29:\"cont_create_export_file_scorm\";s:26:\"Create Export File (SCORM)\";s:27:\"cont_create_export_file_xml\";s:24:\"Create Export File (XML)\";s:18:\"cont_create_folder\";s:13:\"Create Folder\";s:24:\"cont_create_html_version\";s:19:\"Create HTML Package\";s:15:\"cont_create_mob\";s:19:\"Create Media Object\";s:16:\"cont_credit_mode\";s:38:\"Credit mode (for lesson mode \'normal\')\";s:15:\"cont_credit_off\";s:9:\"No Credit\";s:14:\"cont_credit_on\";s:6:\"Credit\";s:12:\"cont_credits\";s:7:\"Credits\";s:20:\"cont_cross_reference\";s:15:\"Cross reference\";s:18:\"cont_data_from_lms\";s:17:\"adlcp:datafromlms\";s:16:\"cont_de_activate\";s:13:\"(De-)Activate\";s:20:\"cont_deactivate_page\";s:15:\"Deactivate Page\";s:15:\"cont_def_layout\";s:14:\"Default Layout\";s:20:\"cont_def_lesson_mode\";s:19:\"Default lesson mode\";s:21:\"cont_def_organization\";s:7:\"default\";s:15:\"cont_definition\";s:10:\"Definition\";s:16:\"cont_definitions\";s:11:\"Definitions\";s:19:\"cont_del_assignment\";s:17:\"Delete assignment\";s:20:\"cont_delete_selected\";s:6:\"Delete\";s:17:\"cont_dependencies\";s:12:\"Dependencies\";s:20:\"cont_derive_from_obj\";s:18:\"Derive from Object\";s:12:\"cont_details\";s:7:\"Details\";s:13:\"cont_dir_file\";s:14:\"Directory/File\";s:15:\"cont_disable_js\";s:19:\"JavaScript inactive\";s:18:\"cont_disable_media\";s:14:\"Media inactive\";s:17:\"cont_disable_html\";s:13:\"HTML inactive\";s:16:\"cont_enable_html\";s:11:\"HTML active\";s:19:\"cont_download_title\";s:14:\"Download Title\";s:14:\"cont_downloads\";s:9:\"Downloads\";s:25:\"cont_insert_as_subchapter\";s:20:\"Insert as Subchapter\";s:22:\"cont_insert_as_chapter\";s:17:\"Insert as Chapter\";s:20:\"cont_save_all_titles\";s:11:\"Save Titles\";s:19:\"cont_downloads_desc\";s:43:\"Enable download of all public export files.\";s:26:\"cont_downloads_public_desc\";s:56:\"Allow download even for anonymous users (in public area)\";s:21:\"cont_insert_resources\";s:20:\"Insert Resource List\";s:21:\"cont_update_resources\";s:20:\"Update Resource List\";s:9:\"cont_type\";s:4:\"Type\";s:19:\"cont_insert_section\";s:14:\"Insert Section\";s:19:\"cont_update_section\";s:14:\"Update Section\";s:20:\"cont_ed_align_center\";s:13:\"Align: Center\";s:21:\"cont_ed_insert_repobj\";s:20:\"Insert Resource List\";s:19:\"cont_ed_insert_tabs\";s:11:\"Insert Tabs\";s:16:\"cont_insert_tabs\";s:11:\"Insert Tabs\";s:16:\"cont_update_tabs\";s:11:\"Update Tabs\";s:19:\"cont_number_of_tabs\";s:14:\"Number of Tabs\";s:18:\"cont_tabs_hor_tabs\";s:15:\"Horizontal Tabs\";s:19:\"cont_tabs_accordion\";s:9:\"Accordion\";s:18:\"cont_ed_insert_map\";s:10:\"Insert Map\";s:18:\"cont_ed_align_left\";s:11:\"Align: Left\";s:24:\"cont_ed_align_left_float\";s:17:\"Align: Left Float\";s:19:\"cont_ed_align_right\";s:12:\"Align: Right\";s:25:\"cont_ed_align_right_float\";s:18:\"Align: Right Float\";s:13:\"cont_ed_class\";s:5:\"Style\";s:16:\"cont_ed_col_left\";s:16:\"Move Column Left\";s:17:\"cont_ed_col_right\";s:17:\"Move Column Right\";s:17:\"cont_ed_copy_clip\";s:17:\"Copy to Clipboard\";s:14:\"cont_ed_delete\";s:6:\"Delete\";s:18:\"cont_ed_delete_col\";s:13:\"Delete Column\";s:19:\"cont_ed_delete_item\";s:11:\"Delete Item\";s:18:\"cont_ed_delete_row\";s:10:\"Delete Row\";s:12:\"cont_ed_edit\";s:4:\"Edit\";s:17:\"cont_ed_edit_prop\";s:15:\"Edit Properties\";s:14:\"cont_ed_enable\";s:22:\"(De-)Activate Elements\";s:10:\"cont_ed_go\";s:2:\"Go\";s:19:\"cont_ed_insert_code\";s:11:\"Insert Code\";s:23:\"cont_ed_insert_filelist\";s:16:\"Insert File List\";s:19:\"cont_ed_insert_list\";s:20:\"Insert Advanced List\";s:20:\"cont_ed_insert_media\";s:18:\"Insert Image/Media\";s:18:\"cont_ed_insert_par\";s:11:\"Insert Text\";s:21:\"cont_ed_insert_dtable\";s:17:\"Insert Data Table\";s:21:\"cont_ed_insert_atable\";s:21:\"Insert Advanced Table\";s:17:\"cont_ed_edit_data\";s:9:\"Edit Data\";s:22:\"cont_ed_insert_section\";s:14:\"Insert Section\";s:17:\"cont_ed_item_down\";s:14:\"Move Item Down\";s:15:\"cont_ed_item_up\";s:12:\"Move Item Up\";s:17:\"cont_ed_moveafter\";s:10:\"Move After\";s:18:\"cont_ed_movebefore\";s:11:\"Move Before\";s:21:\"cont_ed_new_col_after\";s:16:\"New Column After\";s:22:\"cont_ed_new_col_before\";s:17:\"New Column Before\";s:22:\"cont_ed_new_item_after\";s:14:\"New Item After\";s:23:\"cont_ed_new_item_before\";s:15:\"New Item Before\";s:21:\"cont_ed_new_row_after\";s:13:\"New Row After\";s:22:\"cont_ed_new_row_before\";s:14:\"New Row Before\";s:18:\"cont_ed_paste_clip\";s:20:\"Paste From Clipboard\";s:16:\"cont_ed_row_down\";s:13:\"Move Row Down\";s:14:\"cont_ed_row_up\";s:11:\"Move Row Up\";s:18:\"cont_ed_split_page\";s:17:\"Split to New Page\";s:23:\"cont_ed_split_page_next\";s:18:\"Split to Next Page\";s:13:\"cont_ed_width\";s:5:\"Width\";s:14:\"cont_edit_area\";s:9:\"Edit Area\";s:30:\"cont_edit_file_list_properties\";s:25:\"Edit File List Properties\";s:13:\"cont_edit_mob\";s:17:\"Edit Media Object\";s:24:\"cont_edit_mob_alias_prop\";s:37:\"Edit Media Object Instance Properties\";s:19:\"cont_edit_mob_files\";s:12:\"Object Files\";s:24:\"cont_edit_mob_properties\";s:28:\"Edit Media Object Properties\";s:13:\"cont_edit_par\";s:9:\"Edit Text\";s:13:\"cont_edit_src\";s:16:\"Edit Source Code\";s:24:\"cont_edit_tab_properties\";s:16:\"Table Properties\";s:14:\"cont_edit_term\";s:9:\"Edit Term\";s:12:\"cont_edition\";s:7:\"Edition\";s:21:\"cont_empty_mep_folder\";s:42:\"There are no media objects in this folder.\";s:14:\"cont_enable_js\";s:17:\"JavaScript active\";s:17:\"cont_enable_media\";s:12:\"Media active\";s:17:\"cont_export_files\";s:12:\"Export Files\";s:13:\"cont_external\";s:8:\"external\";s:17:\"cont_external_url\";s:12:\"external url\";s:9:\"cont_file\";s:4:\"File\";s:10:\"cont_files\";s:5:\"Files\";s:13:\"cont_fix_tree\";s:13:\"Fix structure\";s:21:\"cont_fix_tree_confirm\";s:140:\"Please execute this command only if the tree structure of this learning module is corrupted, e.g. if blank items occur in the explorer view.\";s:11:\"cont_footer\";s:6:\"Footer\";s:11:\"cont_format\";s:6:\"Format\";s:17:\"cont_format_error\";s:35:\"This operation is not allowed here!\";s:19:\"cont_frame_botright\";s:26:\"Content Details (Glossary)\";s:22:\"cont_frame_maincontent\";s:30:\"Learning Resource Main Content\";s:16:\"cont_frame_right\";s:15:\"Content Details\";s:14:\"cont_frame_toc\";s:17:\"Table of Contents\";s:19:\"cont_frame_topright\";s:31:\"Content Details (FAQ and Media)\";s:15:\"cont_free_pages\";s:10:\"Free Pages\";s:19:\"cont_full_is_in_dir\";s:56:\"Deletion not possible. Full screen file is in directory.\";s:15:\"cont_fullscreen\";s:11:\"Full Screen\";s:13:\"cont_get_link\";s:8:\"get link\";s:18:\"cont_get_orig_size\";s:17:\"Set original size\";s:13:\"cont_glo_menu\";s:4:\"Menu\";s:19:\"cont_glo_properties\";s:19:\"Glossary Properties\";s:11:\"cont_header\";s:6:\"Header\";s:11:\"cont_height\";s:6:\"Height\";s:18:\"cont_how_published\";s:13:\"How published\";s:9:\"cont_href\";s:4:\"href\";s:11:\"cont_id_ref\";s:13:\"identifierref\";s:13:\"cont_imagemap\";s:9:\"Image Map\";s:14:\"cont_import_id\";s:10:\"identifier\";s:21:\"cont_insert_file_item\";s:16:\"Insert File Item\";s:21:\"cont_insert_file_list\";s:16:\"Insert File List\";s:16:\"cont_insert_list\";s:20:\"Insert Advanced List\";s:15:\"cont_insert_mob\";s:19:\"Insert Media Object\";s:24:\"cont_insert_new_footnote\";s:19:\"insert new footnote\";s:15:\"cont_insert_par\";s:11:\"Insert Text\";s:18:\"cont_insert_search\";s:27:\"Please insert a search term\";s:15:\"cont_insert_src\";s:18:\"Insert source code\";s:17:\"cont_insert_table\";s:12:\"Insert Table\";s:13:\"cont_internal\";s:8:\"internal\";s:18:\"cont_internal_link\";s:13:\"internal link\";s:15:\"cont_is_visible\";s:9:\"isvisible\";s:9:\"cont_isbn\";s:4:\"ISBN\";s:9:\"cont_issn\";s:4:\"ISSN\";s:9:\"cont_item\";s:4:\"Item\";s:12:\"cont_journal\";s:7:\"Journal\";s:12:\"cont_keyword\";s:7:\"Keyword\";s:16:\"cont_last_access\";s:11:\"Last Access\";s:9:\"cont_link\";s:4:\"Link\";s:14:\"cont_link_area\";s:9:\"Link Area\";s:13:\"cont_link_ext\";s:15:\"Link (external)\";s:13:\"cont_link_int\";s:15:\"Link (internal)\";s:16:\"cont_link_select\";s:13:\"Internal Link\";s:14:\"cont_link_type\";s:9:\"Link Type\";s:16:\"cont_linked_mobs\";s:20:\"Linked media objects\";s:15:\"cont_list_files\";s:10:\"List Files\";s:20:\"cont_list_properties\";s:15:\"List Properties\";s:15:\"cont_lk_chapter\";s:7:\"Chapter\";s:19:\"cont_lk_chapter_new\";s:19:\"Chapter (New Frame)\";s:17:\"cont_lk_media_faq\";s:17:\"Media (FAQ Frame)\";s:20:\"cont_lk_media_inline\";s:14:\"Media (Inline)\";s:19:\"cont_lk_media_media\";s:19:\"Media (Media Frame)\";s:17:\"cont_lk_media_new\";s:17:\"Media (New Frame)\";s:12:\"cont_lk_page\";s:4:\"Page\";s:16:\"cont_lk_page_faq\";s:16:\"Page (FAQ Frame)\";s:16:\"cont_lk_page_new\";s:16:\"Page (New Frame)\";s:14:\"cont_lk_survey\";s:6:\"Survey\";s:12:\"cont_lk_term\";s:13:\"Glossary Term\";s:16:\"cont_lk_term_new\";s:25:\"Glossary Term (New Frame)\";s:12:\"cont_lm_menu\";s:4:\"Menu\";s:18:\"cont_lm_properties\";s:26:\"Learning Module Properties\";s:11:\"cont_lvalue\";s:12:\"Data element\";s:13:\"cont_manifest\";s:8:\"Manifest\";s:23:\"cont_no_page_in_chapter\";s:71:\"Sorry, but there is currently no activated content within this chapter.\";s:31:\"cont_page_currently_deactivated\";s:46:\"Sorry, but this page is currently deactivated.\";s:14:\"cont_map_areas\";s:10:\"Link Areas\";s:18:\"cont_def_map_areas\";s:18:\"Default Link Areas\";s:19:\"cont_inst_map_areas\";s:19:\"Instance Link Areas\";s:18:\"cont_mastery_score\";s:18:\"adlcp:masteryscore\";s:21:\"cont_max_time_allowed\";s:20:\"adlcp:maxtimeallowed\";s:17:\"cont_media_source\";s:12:\"Media Source\";s:18:\"cont_mep_structure\";s:20:\"Media Pool Structure\";s:26:\"cont_missing_preconditions\";s:75:\"You need to fulfill the following preconditions to access the chapter \"%s\".\";s:18:\"cont_mob_inst_prop\";s:19:\"Instance Properties\";s:17:\"cont_mob_def_prop\";s:18:\"Default Properties\";s:15:\"cont_mob_usages\";s:5:\"Usage\";s:10:\"cont_month\";s:5:\"Month\";s:16:\"cont_move_object\";s:11:\"move object\";s:26:\"cont_msg_multiple_editions\";s:54:\"It\'s not possible to show details of multiple editions\";s:9:\"cont_name\";s:4:\"Name\";s:13:\"cont_new_area\";s:13:\"New Link Area\";s:19:\"cont_new_assignment\";s:14:\"New assignment\";s:12:\"cont_new_dir\";s:13:\"New Directory\";s:13:\"cont_new_file\";s:8:\"New File\";s:18:\"cont_new_media_obj\";s:16:\"New Media Object\";s:13:\"cont_new_term\";s:8:\"New Term\";s:14:\"cont_no_access\";s:9:\"No Access\";s:21:\"cont_no_assign_itself\";s:39:\"The object cannot be assigned to itself\";s:16:\"cont_no_manifest\";s:48:\"No imsmanifest.xml file found in main directory.\";s:20:\"cont_no_object_found\";s:41:\"Could not find any object with this title\";s:12:\"cont_no_page\";s:14:\"No Page found.\";s:21:\"cont_no_subdir_in_zip\";s:83:\"Zip command failed or import file invalid.<br>It does not contain a subfolder \'%s\'.\";s:16:\"cont_no_zip_file\";s:30:\"Import file is not a zip file.\";s:9:\"cont_none\";s:4:\"None\";s:12:\"cont_nr_cols\";s:17:\"Number of Columns\";s:13:\"cont_nr_items\";s:15:\"Number of Items\";s:12:\"cont_nr_rows\";s:14:\"Number of Rows\";s:16:\"cont_obj_removed\";s:16:\"Objects removed.\";s:12:\"cont_offline\";s:16:\"Offline Versions\";s:18:\"cont_offline_files\";s:16:\"Offline versions\";s:21:\"cont_offline_versions\";s:16:\"Offline Versions\";s:13:\"cont_versions\";s:8:\"Versions\";s:20:\"cont_current_version\";s:15:\"Current Version\";s:11:\"cont_online\";s:6:\"Online\";s:7:\"cont_or\";s:2:\"or\";s:10:\"cont_order\";s:10:\"Order Type\";s:17:\"cont_organization\";s:12:\"Organization\";s:18:\"cont_organizations\";s:13:\"Organizations\";s:14:\"cont_orig_size\";s:13:\"Original Size\";s:21:\"cont_page_deactivated\";s:20:\"Page is deactivated.\";s:30:\"cont_page_deactivated_elements\";s:35:\"Page contains deactivated elements.\";s:16:\"cont_page_header\";s:11:\"Page Header\";s:14:\"cont_page_link\";s:9:\"Page Link\";s:27:\"cont_page_select_target_now\";s:42:\"Page marked for moving. Select target now.\";s:10:\"cont_pages\";s:5:\"Pages\";s:14:\"cont_parameter\";s:9:\"Parameter\";s:15:\"cont_parameters\";s:10:\"parameters\";s:25:\"cont_paste_from_clipboard\";s:20:\"Paste from clipboard\";s:23:\"cont_personal_clipboard\";s:18:\"Personal Clipboard\";s:15:\"cont_pg_content\";s:12:\"Page Content\";s:13:\"cont_pg_title\";s:10:\"Page Title\";s:18:\"cont_please_select\";s:13:\"please select\";s:16:\"cont_prereq_type\";s:24:\"adlcp:prerequisites.type\";s:18:\"cont_prerequisites\";s:19:\"adlcp:prerequisites\";s:12:\"cont_preview\";s:7:\"Preview\";s:15:\"cont_print_view\";s:10:\"Print View\";s:18:\"cont_public_access\";s:13:\"Public access\";s:17:\"cont_public_notes\";s:12:\"Public Notes\";s:22:\"cont_public_notes_desc\";s:64:\"Allow users to share notes on every page of the learning module.\";s:14:\"cont_publisher\";s:9:\"Publisher\";s:12:\"cont_purpose\";s:7:\"Purpose\";s:17:\"cont_current_page\";s:12:\"Current Page\";s:20:\"cont_current_chapter\";s:15:\"Current Chapter\";s:21:\"cont_selected_pg_chap\";s:23:\"Selected Pages/Chapters\";s:17:\"cont_ref_helptext\";s:40:\"(e.g. http://www.server.org/myimage.jpg)\";s:15:\"cont_ref_images\";s:17:\"Referenced Images\";s:14:\"cont_reference\";s:9:\"Reference\";s:22:\"cont_remove_fullscreen\";s:18:\"Remove Full Screen\";s:14:\"cont_removeiln\";s:29:\"really remove internal link ?\";s:20:\"cont_repository_item\";s:15:\"Repository Item\";s:19:\"cont_target_missing\";s:14:\"Target Missing\";s:23:\"cont_print_view_pre_glo\";s:39:\"Prevent Glossary Appendix in Print View\";s:26:\"cont_repository_item_links\";s:21:\"Repository Item Links\";s:23:\"cont_resize_explanation\";s:109:\"If this option is activated uploaded image files are automatically resized to the specified width and height.\";s:24:\"cont_resize_explanation2\";s:74:\"This function resizes local image files to the specified width and height.\";s:17:\"cont_resize_image\";s:13:\"Resize images\";s:13:\"cont_resource\";s:8:\"Resource\";s:18:\"cont_resource_type\";s:4:\"type\";s:14:\"cont_resources\";s:9:\"Resources\";s:11:\"cont_rvalue\";s:5:\"Value\";s:19:\"cont_saved_map_area\";s:14:\"Saved map area\";s:19:\"cont_saved_map_data\";s:14:\"Saved map data\";s:19:\"cont_sc_auto_review\";s:49:\"Set lesson mode \'review\' if student completed SCO\";s:24:\"cont_sc_less_mode_browse\";s:6:\"Browse\";s:24:\"cont_sc_less_mode_normal\";s:6:\"Normal\";s:20:\"cont_sc_stat_browsed\";s:7:\"Browsed\";s:22:\"cont_sc_stat_completed\";s:9:\"Completed\";s:19:\"cont_sc_stat_failed\";s:6:\"Failed\";s:23:\"cont_sc_stat_incomplete\";s:10:\"Incomplete\";s:26:\"cont_sc_stat_not_attempted\";s:13:\"Not attempted\";s:19:\"cont_sc_stat_passed\";s:6:\"Passed\";s:20:\"cont_sc_stat_running\";s:7:\"Running\";s:13:\"cont_sc_title\";s:5:\"title\";s:11:\"cont_school\";s:6:\"School\";s:10:\"cont_score\";s:5:\"Score\";s:15:\"cont_scorm_type\";s:15:\"adlcp:scormtype\";s:16:\"cont_select_item\";s:25:\"Select at least one item.\";s:24:\"cont_select_max_one_item\";s:27:\"Please select one item only\";s:24:\"cont_select_max_one_term\";s:20:\"Select one term only\";s:23:\"cont_select_one_edition\";s:35:\"Please select at least one edition.\";s:27:\"cont_select_one_translation\";s:29:\"Please select one translation\";s:35:\"cont_select_one_translation_warning\";s:53:\"It is not possible to show more than one translation.\";s:16:\"cont_select_term\";s:13:\"Select a term\";s:23:\"cont_select_translation\";s:48:\"Please select the assignment from the list above\";s:11:\"cont_series\";s:6:\"Series\";s:18:\"cont_series_editor\";s:13:\"Series editor\";s:17:\"cont_series_title\";s:12:\"Series title\";s:18:\"cont_series_volume\";s:13:\"Series volume\";s:14:\"cont_set_after\";s:12:\"insert after\";s:15:\"cont_set_before\";s:13:\"insert before\";s:15:\"cont_set_cancel\";s:6:\"cancel\";s:14:\"cont_set_class\";s:9:\"Set Class\";s:18:\"cont_set_edit_mode\";s:13:\"Set Edit Mode\";s:13:\"cont_set_into\";s:11:\"insert into\";s:13:\"cont_set_link\";s:9:\"Edit Link\";s:14:\"cont_set_shape\";s:10:\"Edit Shape\";s:19:\"cont_set_start_file\";s:14:\"Set Start File\";s:14:\"cont_set_width\";s:9:\"Set Width\";s:10:\"cont_shape\";s:5:\"Shape\";s:9:\"cont_show\";s:4:\"Show\";s:18:\"cont_show_citation\";s:18:\"Show with citation\";s:22:\"cont_show_line_numbers\";s:17:\"Show line numbers\";s:20:\"cont_show_print_view\";s:15:\"Show Print View\";s:9:\"cont_size\";s:12:\"Size (Bytes)\";s:17:\"cont_skip_chapter\";s:17:\"Skip this chapter\";s:11:\"cont_source\";s:6:\"Source\";s:8:\"cont_src\";s:11:\"Source code\";s:14:\"cont_src_other\";s:5:\"other\";s:13:\"cont_st_on_pg\";s:29:\"this function is not allowed.\";s:13:\"cont_st_title\";s:13:\"Chapter Title\";s:14:\"cont_startfile\";s:10:\"Start File\";s:11:\"cont_status\";s:6:\"Status\";s:18:\"cont_std_is_in_dir\";s:58:\"Deletion not possible. Standard view file is in directory.\";s:13:\"cont_std_view\";s:13:\"Standard View\";s:14:\"cont_structure\";s:9:\"structure\";s:10:\"cont_style\";s:5:\"Style\";s:16:\"cont_subchapters\";s:11:\"Subchapters\";s:23:\"cont_synchronize_frames\";s:18:\"Synchronise frames\";s:28:\"cont_synchronize_frames_desc\";s:157:\"This option synchronises the table of contents frame with the content frame and clears additional frames in 3 window view. But it also decreases performance.\";s:16:\"cont_paste_table\";s:11:\"Paste Table\";s:15:\"cont_html_table\";s:10:\"HTML Table\";s:22:\"cont_spreadsheet_table\";s:17:\"Spreadsheet Table\";s:10:\"cont_table\";s:5:\"Table\";s:17:\"cont_table_border\";s:12:\"Table Border\";s:22:\"cont_table_cellpadding\";s:18:\"Table Cell Padding\";s:22:\"cont_table_cellspacing\";s:18:\"Table Cell Spacing\";s:22:\"cont_table_html_import\";s:17:\"Import HTML Table\";s:27:\"cont_table_html_import_info\";s:68:\"Import only works with XHTML conform tables. Table must be root tag!\";s:29:\"cont_table_spreadsheet_import\";s:18:\"Spreadsheet Import\";s:34:\"cont_table_spreadsheet_import_info\";s:73:\"Paste table from spreadsheet application via clipboard into the textarea.\";s:16:\"cont_table_width\";s:11:\"Table Width\";s:25:\"cont_target_within_source\";s:40:\"Target must not be within source object.\";s:26:\"cont_operation_not_allowed\";s:30:\"This operation is not allowed.\";s:9:\"cont_term\";s:4:\"Term\";s:10:\"cont_terms\";s:5:\"Terms\";s:14:\"cont_text_code\";s:5:\"Code:\";s:13:\"cont_text_com\";s:8:\"Comment:\";s:13:\"cont_text_emp\";s:14:\"Emphatic Text:\";s:12:\"cont_text_fn\";s:9:\"Footnote:\";s:13:\"cont_text_iln\";s:20:\"Internal Link, e.g.:\";s:14:\"cont_text_quot\";s:10:\"Quotation:\";s:13:\"cont_text_str\";s:12:\"Strong Text:\";s:13:\"cont_text_tex\";s:11:\"LaTeX Code:\";s:13:\"cont_text_xln\";s:14:\"External Link:\";s:9:\"cont_time\";s:4:\"Time\";s:22:\"cont_time_limit_action\";s:21:\"adlcp:timelimitaction\";s:10:\"cont_title\";s:5:\"title\";s:20:\"cont_title_footnotes\";s:9:\"Footnotes\";s:8:\"cont_toc\";s:17:\"Table of Contents\";s:13:\"cont_toc_mode\";s:23:\"Table of Contents shows\";s:8:\"cont_top\";s:3:\"Top\";s:15:\"cont_total_time\";s:10:\"Total Time\";s:18:\"cont_tracking_data\";s:13:\"Tracking Data\";s:19:\"cont_tracking_items\";s:14:\"Tracking Items\";s:17:\"cont_translations\";s:14:\"Translation(s)\";s:26:\"cont_translations_assigned\";s:37:\"The translation(s) have been assigned\";s:15:\"cont_tree_fixed\";s:30:\"Tree structure has been fixed.\";s:11:\"cont_update\";s:6:\"Update\";s:17:\"cont_update_names\";s:12:\"Update Names\";s:16:\"cont_upload_file\";s:11:\"Upload File\";s:8:\"cont_url\";s:3:\"URL\";s:10:\"cont_usage\";s:5:\"Usage\";s:28:\"cont_users_have_mob_in_clip1\";s:40:\"This media object is in the clipboard of\";s:28:\"cont_users_have_mob_in_clip2\";s:8:\"user(s).\";s:18:\"cont_validate_file\";s:13:\"Validate File\";s:12:\"cont_version\";s:7:\"version\";s:25:\"cont_view_last_export_log\";s:15:\"Last Export Log\";s:20:\"cont_where_published\";s:15:\"Where published\";s:10:\"cont_width\";s:5:\"Width\";s:12:\"cont_wysiwyg\";s:15:\"Content WYSIWYG\";s:13:\"cont_xml_base\";s:8:\"xml:base\";s:9:\"cont_year\";s:4:\"Year\";s:21:\"cont_zip_file_invalid\";s:68:\"File is not a valid import file.<br>It does not contain a file \'%s\'.\";s:19:\"copied_to_clipboard\";s:30:\"Copied object(s) to clipboard.\";s:13:\"dgl_pagebreak\";s:9:\"Pagebreak\";s:19:\"glo_definition_abbr\";s:4:\"Def.\";s:16:\"glo_term_used_in\";s:44:\"The following resources linking to that term\";s:18:\"lm_menu_edit_entry\";s:15:\"Edit menu entry\";s:20:\"lm_menu_entry_target\";s:6:\"Target\";s:19:\"lm_menu_entry_title\";s:5:\"Title\";s:17:\"lm_menu_new_entry\";s:23:\"Create a new menu entry\";s:30:\"lm_menu_select_internal_object\";s:25:\"Select internal object >>\";s:28:\"lm_menu_select_object_to_add\";s:52:\"Please select the object you want to add to the menu\";s:15:\"msg_entry_added\";s:16:\"Menu entry added\";s:17:\"msg_entry_removed\";s:18:\"Menu entry removed\";s:17:\"msg_entry_updated\";s:18:\"Menu entry updated\";s:25:\"msg_page_no_public_access\";s:138:\"The page you called is not available in the public area. Only registered users may view this page. Please login first to access this page.\";s:19:\"msg_page_not_public\";s:18:\"Page is not public\";s:10:\"pages from\";s:10:\"Pages From\";s:3:\"par\";s:9:\"Paragraph\";s:2:\"pg\";s:4:\"Page\";s:14:\"public_section\";s:11:\"Public Area\";s:12:\"read offline\";s:12:\"Read Offline\";s:12:\"selectFooter\";s:16:\"Select As Footer\";s:12:\"selectHeader\";s:16:\"Select As Header\";s:13:\"select_a_file\";s:21:\"Please select a file.\";s:19:\"selected_pages_only\";s:30:\"only that pages selected below\";s:15:\"set_public_mode\";s:22:\"Set public access mode\";s:2:\"st\";s:7:\"Chapter\";s:12:\"start export\";s:12:\"Start Export\";s:18:\"seq_coursecomplete\";s:32:\"The current course is completed.\";s:14:\"seq_endsession\";s:37:\"The current course session has ended.\";s:11:\"seq_blocked\";s:35:\"The sequencing session was blocked.\";s:11:\"seq_nothing\";s:32:\"There is no activity to deliver.\";s:9:\"seq_error\";s:44:\"An internal error in the sequencer occurred.\";s:12:\"seq_deadlock\";s:31:\"The sequencer is in a deadlock.\";s:17:\"seq_invalidnavreq\";s:42:\"The sequencer received an invalid request.\";s:11:\"seq_abandon\";s:56:\"An Abandon Navigation Request was received an processed.\";s:14:\"seq_abandonall\";s:47:\"The current course session has been abandoned..\";s:7:\"seq_toc\";s:79:\"From the Table Of Contents on the left, choose an activity to begin the course.\";s:9:\"seq_close\";s:31:\"Please close the player-window.\";s:17:\"scplayer_showtree\";s:9:\"Show Tree\";s:17:\"scplayer_hidetree\";s:9:\"Hide Tree\";s:17:\"scplayer_continue\";s:8:\"Continue\";s:17:\"scplayer_previous\";s:8:\"Previous\";s:19:\"scplayer_suspendall\";s:11:\"Suspend All\";s:16:\"scplayer_exitall\";s:8:\"Exit All\";s:13:\"scplayer_exit\";s:4:\"Exit\";s:14:\"scplayer_start\";s:5:\"Start\";s:22:\"scplayer_phpmysqlcheck\";s:79:\"You need MYSQL 4.1 or higher and enabled JSON-support to use the JavaScript-RTE\";s:19:\"cont_sc_max_attempt\";s:23:\"Max. number of attempts\";s:20:\"cont_first_row_style\";s:15:\"First Row Style\";s:36:\"cont_selected_items_have_been_copied\";s:120:\"Selected items have been copied to the clipboard. Click appropriate placeholders to paste them into the learning module.\";s:33:\"cont_selected_items_have_been_cut\";s:117:\"Selected items have been cut to the clipboard. Click appropriate placeholders to paste them into the learning module.\";s:34:\"cont_choose_pages_or_chapters_only\";s:44:\"Please select either pages or chapters only.\";s:26:\"cont_sc_max_attempt_exceed\";s:57:\"Max. number of attempts for this module has been reached.\";s:19:\"cont_sc_new_version\";s:18:\"Upload new version\";s:15:\"cont_sc_version\";s:7:\"Version\";s:15:\"cont_export_all\";s:10:\"Export all\";s:20:\"cont_export_tracking\";s:20:\"Export Tracking Data\";s:15:\"cont_export_raw\";s:14:\"CMI (RAW) data\";s:19:\"cont_export_success\";s:25:\"Success-data (aggregated)\";s:16:\"cont_export_type\";s:11:\"Export-Type\";s:20:\"cont_import_tracking\";s:20:\"Import Tracking Data\";s:23:\"cont_invalid_new_module\";s:68:\"Incompatible module! Please make sure imsmanifest.xml is not changed\";s:21:\"cont_new_module_added\";s:43:\"New version of module uploaded successfully\";s:20:\"cont_tracking_byuser\";s:7:\"By User\";s:19:\"cont_tracking_bysco\";s:10:\"By Chapter\";}');
INSERT INTO `lng_modules` VALUES ('crs','en','a:556:{s:26:\"activation_times_not_valid\";s:37:\"The availability period is not valid.\";s:9:\"add_event\";s:11:\"Add Session\";s:8:\"assigned\";s:8:\"Assigned\";s:23:\"contact_email_not_valid\";s:32:\"the contact e-mail is not valid.\";s:21:\"crs_accept_subscriber\";s:24:\"Admission to course \"%s\"\";s:26:\"crs_accept_subscriber_body\";s:38:\"You have been admitted to course \"%s\".\";s:19:\"crs_access_password\";s:8:\"Password\";s:14:\"crs_activation\";s:10:\"Activation\";s:8:\"crs_news\";s:11:\"Course News\";s:20:\"crs_add_archive_html\";s:21:\"Create a HTML Archive\";s:19:\"crs_add_archive_xml\";s:20:\"Create a XML Archive\";s:16:\"crs_add_grouping\";s:19:\"Add course grouping\";s:22:\"crs_add_grp_assignment\";s:16:\"Assign course(s)\";s:20:\"crs_add_html_archive\";s:16:\"Add HTML archive\";s:14:\"crs_add_member\";s:13:\"Add Member(s)\";s:17:\"crs_add_objective\";s:13:\"Add Objective\";s:27:\"crs_add_remove_from_desktop\";s:23:\"Add/Remove from Desktop\";s:32:\"crs_add_remove_from_desktop_info\";s:62:\"Allow the members to add course items to the personal desktop.\";s:15:\"crs_add_starter\";s:16:\"Add Start Object\";s:19:\"crs_add_subscribers\";s:14:\"Add subscriber\";s:9:\"crs_added\";s:16:\"Added new course\";s:16:\"crs_added_member\";s:25:\"Addmission to course \"%s\"\";s:21:\"crs_added_member_body\";s:38:\"You have been admitted to course \"%s\".\";s:21:\"crs_added_new_archive\";s:28:\"A new archive has been added\";s:19:\"crs_added_objective\";s:42:\"A new learning objective has been created.\";s:18:\"crs_added_starters\";s:25:\"Assigned start object(s).\";s:17:\"crs_added_to_list\";s:96:\"You have been assigned to the waiting list. You are assigned to position %s on the waiting list.\";s:9:\"crs_admin\";s:13:\"Administrator\";s:19:\"crs_admin_no_notify\";s:31:\"Administrator (no notification)\";s:16:\"crs_admin_notify\";s:28:\"Administrator (notification)\";s:18:\"crs_administrators\";s:14:\"Administrators\";s:13:\"crs_allow_abo\";s:34:\"Allow subscription of course items\";s:28:\"crs_already_assigned_to_list\";s:45:\"You are already assigned to the waiting list.\";s:11:\"crs_archive\";s:8:\"Archives\";s:20:\"crs_archive_disabled\";s:11:\"Deactivated\";s:20:\"crs_archive_download\";s:37:\"Allow the Download of Course Archives\";s:16:\"crs_archive_info\";s:121:\"If enabled, all course content will we suppressed. Only HTML archives of this course will be available to course members.\";s:16:\"crs_archive_lang\";s:8:\"Language\";s:16:\"crs_archive_read\";s:11:\"Read access\";s:23:\"crs_archive_select_type\";s:12:\"Archive view\";s:16:\"crs_archive_type\";s:12:\"Archive type\";s:25:\"crs_archive_type_disabled\";s:13:\"Not available\";s:20:\"crs_archives_deleted\";s:32:\"The archive(s) have been deleted\";s:13:\"crs_auto_fill\";s:9:\"Auto Fill\";s:31:\"crs_availability_limitless_info\";s:120:\"Choose this mode for making the course available and accessible to users (depending on the registration settings below).\";s:27:\"crs_availability_until_info\";s:147:\"Choose this mode for making the course available and accessible to users for a fixed period of time (depending on the registration settings below).\";s:31:\"crs_availability_unvisible_info\";s:108:\"Choose this mode for preparing the course. Only course administators and tutors can see and edit the course.\";s:11:\"crs_blocked\";s:14:\"Access Refused\";s:18:\"crs_blocked_member\";s:32:\"Membership status in course \"%s\"\";s:23:\"crs_blocked_member_body\";s:49:\"Your membership for course \"%s\" has been blocked.\";s:23:\"crs_cancel_subscription\";s:25:\"Resigned from course \"%s\"\";s:28:\"crs_cancel_subscription_body\";s:39:\"A member has resigned from course \"%s\".\";s:17:\"crs_change_status\";s:28:\"Changes status of objective:\";s:28:\"crs_chapter_already_assigned\";s:36:\"These chapters are already assigned.\";s:11:\"crs_contact\";s:7:\"Contact\";s:24:\"crs_contact_consultation\";s:12:\"Consultation\";s:17:\"crs_contact_email\";s:6:\"E-Mail\";s:16:\"crs_contact_name\";s:4:\"Name\";s:17:\"crs_contact_phone\";s:9:\"Telephone\";s:26:\"crs_contact_responsibility\";s:14:\"Responsibility\";s:11:\"crs_content\";s:14:\"Course Content\";s:24:\"crs_copy_cat_not_allowed\";s:37:\"It is not possible to copy categories\";s:17:\"crs_count_members\";s:17:\"Number of members\";s:19:\"crs_count_questions\";s:19:\"Number of questions\";s:15:\"crs_create_date\";s:11:\"Create date\";s:17:\"crs_crs_structure\";s:16:\"Course structure\";s:9:\"crs_dates\";s:5:\"Dates\";s:20:\"crs_deassign_lm_sure\";s:48:\"Are you sure you want to delete this assignment?\";s:15:\"crs_delete_file\";s:12:\"Delete File?\";s:25:\"crs_delete_from_list_sure\";s:69:\"Are you sure, you want to deassign the following users from the list?\";s:28:\"crs_delete_from_waiting_list\";s:24:\"Remove from waiting list\";s:17:\"crs_delete_member\";s:8:\"Deassign\";s:23:\"crs_delete_members_sure\";s:60:\"Do you want to delete the following members from this course\";s:24:\"crs_delete_objectve_sure\";s:57:\"Are you sure, you want to delete the selected objectives?\";s:22:\"crs_delete_subscribers\";s:17:\"Delete subscriber\";s:27:\"crs_delete_subscribers_sure\";s:41:\"Do you want to delete the following users\";s:11:\"crs_details\";s:14:\"Course Details\";s:18:\"crs_dismiss_member\";s:37:\"Terminated membership for course \"%s\"\";s:23:\"crs_dismiss_member_body\";s:51:\"You membership for course \"%s\" has been terminated!\";s:16:\"crs_edit_archive\";s:13:\"Edit Archives\";s:16:\"crs_edit_content\";s:10:\"Edit items\";s:22:\"crs_edit_start_objects\";s:18:\"Edit Start Objects\";s:16:\"crs_edit_timings\";s:12:\"Edit Timings\";s:7:\"crs_end\";s:3:\"End\";s:18:\"crs_existing_files\";s:15:\"Existing Files:\";s:10:\"crs_export\";s:13:\"Course export\";s:8:\"crs_file\";s:4:\"File\";s:17:\"crs_file_download\";s:18:\"Files for Download\";s:13:\"crs_file_name\";s:9:\"File name\";s:18:\"crs_file_size_info\";s:8:\"Filesize\";s:12:\"crs_filename\";s:8:\"Filename\";s:15:\"crs_free_places\";s:16:\"Available Places\";s:8:\"crs_from\";s:5:\"From:\";s:20:\"crs_further_settings\";s:16:\"Further Settings\";s:16:\"crs_general_info\";s:20:\"General Informations\";s:24:\"crs_general_informations\";s:19:\"General Information\";s:12:\"crs_grouping\";s:15:\"Course grouping\";s:19:\"crs_grouping_assign\";s:17:\"Change assignment\";s:24:\"crs_grouping_delete_sure\";s:60:\"Do you really want to delete the following course groupings?\";s:20:\"crs_grouping_deleted\";s:24:\"Deleted course grouping.\";s:32:\"crs_grouping_modified_assignment\";s:19:\"Changed assignment.\";s:23:\"crs_grouping_select_one\";s:32:\"Please select a course grouping.\";s:13:\"crs_groupings\";s:16:\"Course groupings\";s:24:\"crs_groupings_ask_delete\";s:22:\"Delete course grouping\";s:24:\"crs_grp_already_assigned\";s:47:\"You are already member of this course grouping.\";s:18:\"crs_grp_assign_crs\";s:13:\"Assign course\";s:24:\"crs_grp_assigned_courses\";s:17:\"Assigned courses.\";s:29:\"crs_grp_assigned_courses_info\";s:17:\"Assigned courses:\";s:32:\"crs_grp_courses_already_assigned\";s:43:\"The selected courses were already assigned.\";s:22:\"crs_grp_crs_assignment\";s:17:\"Course assignment\";s:26:\"crs_grp_deassigned_courses\";s:17:\"Delete assignment\";s:19:\"crs_grp_enter_title\";s:21:\"Please enter a title.\";s:16:\"crs_grp_info_reg\";s:45:\"You can only register to one of this courses:\";s:30:\"crs_grp_matriculation_required\";s:134:\"This course grouping requires an unique matriculation number. <br />Please insert this value in your settings on the personal desktop.\";s:25:\"crs_grp_modified_grouping\";s:20:\"Saved modifications.\";s:26:\"crs_grp_no_course_selected\";s:25:\"Please select one course.\";s:27:\"crs_grp_no_courses_assigned\";s:20:\"No assigned courses.\";s:30:\"crs_grp_table_assigned_courses\";s:16:\"Assigned courses\";s:19:\"crs_header_archives\";s:15:\"Course Archives\";s:25:\"crs_header_delete_members\";s:14:\"Delete Members\";s:29:\"crs_header_delete_subscribers\";s:18:\"Delete subscribers\";s:23:\"crs_header_edit_members\";s:12:\"Edit Members\";s:18:\"crs_header_members\";s:14:\"Course members\";s:35:\"crs_header_remove_from_waiting_list\";s:28:\"Waiting list: deassign users\";s:17:\"crs_hide_link_lms\";s:14:\"Hide materials\";s:24:\"crs_hide_link_objectives\";s:15:\"Hide objectives\";s:16:\"crs_hide_link_or\";s:20:\"Hide other resources\";s:17:\"crs_hide_link_tst\";s:10:\"Hide tests\";s:8:\"crs_html\";s:4:\"HTML\";s:18:\"crs_important_info\";s:22:\"Important Informations\";s:17:\"crs_info_download\";s:18:\"Files for Download\";s:12:\"crs_info_reg\";s:10:\"Admittance\";s:25:\"crs_info_reg_confirmation\";s:143:\"You can request membership for this course. You will get a message from a course administrator when your request has been admitted or declined.\";s:24:\"crs_info_reg_deactivated\";s:28:\"Course admittance is closed.\";s:19:\"crs_info_reg_direct\";s:34:\"You can join this course directly.\";s:21:\"crs_info_reg_password\";s:86:\"If a course administrator has given you the course password, you can join this course.\";s:17:\"crs_info_settings\";s:19:\"Course Informations\";s:14:\"crs_info_start\";s:146:\"Please work through all of the course items stated below.<br />After you have processed all red marked objects new course items will be activated.\";s:26:\"crs_item_availability_info\";s:167:\"Choose this option for making the item available for a fixed period of time. If \'Visiblity\' is checked the item will remain visble but not accessible for the learners.\";s:24:\"crs_item_presetting_info\";s:65:\"Choose this option to offer the learners suggested editing times.\";s:22:\"crs_learning_materials\";s:9:\"Materials\";s:14:\"crs_list_users\";s:10:\"List users\";s:17:\"crs_lm_assignment\";s:28:\"Learning material assignment\";s:25:\"crs_lm_assignment_deleted\";s:19:\"Deleted assignment.\";s:15:\"crs_lm_deassign\";s:18:\"Delete assignment.\";s:30:\"crs_lm_no_assignments_selected\";s:29:\"Please select one assignment.\";s:24:\"crs_lms_already_assigned\";s:47:\"These learning materials were already assigned.\";s:13:\"crs_materials\";s:16:\"Course Materials\";s:23:\"crs_max_members_reached\";s:46:\"The maximum number of members has been reached\";s:21:\"crs_mem_change_status\";s:13:\"Change status\";s:17:\"crs_mem_send_mail\";s:9:\"Send Mail\";s:10:\"crs_member\";s:6:\"Member\";s:25:\"crs_member_administration\";s:17:\"Edit Participants\";s:18:\"crs_member_blocked\";s:16:\"Member (blocked)\";s:13:\"crs_member_of\";s:17:\"Member of course:\";s:20:\"crs_member_unblocked\";s:18:\"Member (unblocked)\";s:18:\"crs_member_updated\";s:27:\"The member has been updated\";s:11:\"crs_members\";s:7:\"Members\";s:19:\"crs_members_deleted\";s:15:\"Deleted members\";s:18:\"crs_members_footer\";s:16:\"course member(s)\";s:25:\"crs_members_footer_passed\";s:6:\"passed\";s:23:\"crs_members_print_title\";s:14:\"Course members\";s:17:\"crs_members_table\";s:19:\"Course Participants\";s:17:\"crs_members_title\";s:14:\"Course members\";s:13:\"crs_move_down\";s:9:\"Move down\";s:11:\"crs_move_up\";s:7:\"Move up\";s:14:\"crs_moved_item\";s:17:\"Moved course item\";s:19:\"crs_moved_objective\";s:25:\"Moved learning objective.\";s:14:\"crs_new_search\";s:10:\"New search\";s:20:\"crs_new_subscription\";s:23:\"User joined course \"%s\"\";s:25:\"crs_new_subscription_body\";s:30:\"A user has joined course \"%s\".\";s:28:\"crs_new_subscription_request\";s:27:\"Request to join course \"%s\"\";s:33:\"crs_new_subscription_request_body\";s:41:\"A user has requested to join course \"%s\".\";s:34:\"crs_new_subscription_request_body2\";s:107:\"You have to call the member administration of that course for accepting or refusing the membership request.\";s:23:\"crs_no_archive_selected\";s:20:\"No archives selected\";s:25:\"crs_no_archives_available\";s:31:\"There are no archives available\";s:24:\"crs_no_archives_selected\";s:24:\"Please select an archive\";s:23:\"crs_no_chapter_selected\";s:24:\"Please select a chapter.\";s:16:\"crs_no_exercises\";s:37:\"No exercises found inside this course\";s:25:\"crs_no_groupings_assigned\";s:37:\"No groupings assigned to this course.\";s:22:\"crs_no_groups_selected\";s:21:\"Please select a group\";s:18:\"crs_no_items_found\";s:8:\"No items\";s:15:\"crs_no_language\";s:11:\"No language\";s:18:\"crs_no_lm_selected\";s:36:\"Please select one learning material.\";s:19:\"crs_no_lms_assigned\";s:41:\"There are no learning materials assigned.\";s:24:\"crs_no_lms_inside_course\";s:47:\"No learning materials found inside this course.\";s:21:\"crs_no_lms_inside_crs\";s:91:\"No learning materials inside this course, which can be assigned to this learning objective.\";s:22:\"crs_no_member_selected\";s:24:\"Please select one member\";s:23:\"crs_no_members_assigned\";s:44:\"There are no members assigned to this course\";s:13:\"crs_no_notify\";s:31:\"No notify for new registrations\";s:25:\"crs_no_objective_selected\";s:28:\"Please select one objective.\";s:25:\"crs_no_objectives_created\";s:33:\"There are no objectives assigned.\";s:24:\"crs_no_question_selected\";s:27:\"Please select one question.\";s:25:\"crs_no_questions_assigned\";s:32:\"There are no questions assigned.\";s:20:\"crs_no_results_found\";s:16:\"No results found\";s:21:\"crs_no_roles_selected\";s:20:\"Please select a role\";s:22:\"crs_no_starter_created\";s:41:\"No start objects assigned to this course.\";s:27:\"crs_no_subscribers_selected\";s:20:\"Please select a user\";s:23:\"crs_no_tests_inside_crs\";s:78:\"No tests inside this course, which can be assigned to this learning objective.\";s:18:\"crs_no_users_added\";s:16:\"No members added\";s:21:\"crs_no_users_selected\";s:27:\"You did not select any user\";s:28:\"crs_no_valid_member_id_given\";s:18:\"No valid member Id\";s:17:\"crs_not_available\";s:15:\"-Not available-\";s:16:\"crs_notification\";s:12:\"Notification\";s:10:\"crs_notify\";s:28:\"Notify for new registrations\";s:6:\"crs_nr\";s:3:\"Nr.\";s:22:\"crs_number_users_added\";s:62:\"The following number of users has been assigned to the course:\";s:26:\"crs_objective_accomplished\";s:12:\"Accomplished\";s:28:\"crs_objective_assign_chapter\";s:15:\"Assign chapters\";s:23:\"crs_objective_assign_lm\";s:16:\"Save Assignments\";s:29:\"crs_objective_assign_question\";s:15:\"Assign question\";s:31:\"crs_objective_deassign_question\";s:17:\"Delete assignment\";s:34:\"crs_objective_delete_lm_assignment\";s:17:\"Delete assignment\";s:28:\"crs_objective_insert_percent\";s:44:\"Please enter only numbers between 0 and 100.\";s:22:\"crs_objective_modified\";s:27:\"Updated learning objective.\";s:28:\"crs_objective_no_title_given\";s:21:\"Please enter a title.\";s:30:\"crs_objective_not_accomplished\";s:16:\"Not accomplished\";s:33:\"crs_objective_overview_objectives\";s:19:\"Overview Objectives\";s:42:\"crs_objective_overview_question_assignment\";s:28:\"Overview Question Assignment\";s:21:\"crs_objective_pretest\";s:18:\"After initial test\";s:33:\"crs_objective_question_assignment\";s:19:\"Question assignment\";s:20:\"crs_objective_result\";s:16:\"After final test\";s:26:\"crs_objective_updated_test\";s:22:\"Updated modifications.\";s:18:\"crs_objective_view\";s:23:\"Objective oriented view\";s:14:\"crs_objectives\";s:19:\"Learning Objectives\";s:29:\"crs_objectives_assign_chapter\";s:14:\"Assign Chapter\";s:26:\"crs_objectives_assigned_lm\";s:42:\"The selected materials have been assigned.\";s:27:\"crs_objectives_assigned_lms\";s:27:\"Assigned learning materials\";s:37:\"crs_objectives_assigned_new_questions\";s:21:\"Added new assignment.\";s:33:\"crs_objectives_assigned_questions\";s:18:\"Assigned questions\";s:33:\"crs_objectives_chapter_assignment\";s:18:\"Chapter assignment\";s:37:\"crs_objectives_deassign_question_sure\";s:57:\"Are you sure, you want to delete the following questions?\";s:22:\"crs_objectives_deleted\";s:26:\"Delete learning objectives\";s:40:\"crs_objectives_edit_question_assignments\";s:24:\"Edit Question Assignment\";s:25:\"crs_objectives_info_final\";s:250:\"You did not accomplish all course objectives in the previous exam. <br />Please select all red marked objectives one after another and review the related materials. <br />After you have reviewed all red marked objectives, you can take the exam again.\";s:28:\"crs_objectives_info_finished\";s:69:\"Congratulations, you have accomplished all objectives of this course!\";s:24:\"crs_objectives_info_none\";s:142:\"The following is a list of the course objectives.<br /> Please select the objectives one after another and work through the related materials.\";s:27:\"crs_objectives_info_pretest\";s:312:\"The following are the results of your self assessment. <br />Please select the red marked objectives one after another and work through their related material. <br />After you have processed all red marked objectives, you can take the final exam of this course, which is located in the test section of this page.\";s:39:\"crs_objectives_info_pretest_non_suggest\";s:221:\"The following are the results of your self assessment. <br />According to this you have fullfilled any learning objective. You can now take the final exam of this course, which is located in the test section of this page.\";s:28:\"crs_objectives_lm_assignment\";s:30:\"Assignment of Course Materials\";s:25:\"crs_objectives_max_points\";s:14:\"Maximum points\";s:35:\"crs_objectives_no_question_selected\";s:27:\"Please select one question.\";s:27:\"crs_objectives_nr_questions\";s:19:\"Number of questions\";s:29:\"crs_objectives_qst_deassigned\";s:41:\"The question assignment has been deleted.\";s:25:\"crs_objectives_reset_sure\";s:86:\"You want to delete all results of this course. <br />All test results will be deleted.\";s:22:\"crs_objectives_reseted\";s:16:\"Reseted results.\";s:11:\"crs_offline\";s:7:\"Offline\";s:11:\"crs_options\";s:7:\"Options\";s:19:\"crs_other_groupings\";s:26:\"Groupings of other courses\";s:19:\"crs_other_resources\";s:15:\"Other Resources\";s:10:\"crs_passed\";s:6:\"Passed\";s:22:\"crs_password_not_valid\";s:26:\"Your password is not valid\";s:21:\"crs_password_required\";s:48:\"This registration procedure requires a password.\";s:7:\"crs_pdf\";s:3:\"PDF\";s:27:\"crs_persons_on_waiting_list\";s:27:\"Persons on the Waiting List\";s:14:\"crs_print_list\";s:10:\"Print list\";s:23:\"crs_question_assignment\";s:19:\"Question assignment\";s:7:\"crs_reg\";s:21:\"Registration Settings\";s:19:\"crs_reg_deactivated\";s:8:\"Disabled\";s:16:\"crs_reg_lim_info\";s:62:\"Registrations are only possible during a fixed period of time.\";s:16:\"crs_reg_max_info\";s:71:\"Define the maximum number of users that can be assigned to this course.\";s:19:\"crs_reg_notify_info\";s:114:\"If enabled all course administrators/tutors with status \'Notify\' will be informed by mail about new registrations.\";s:32:\"crs_reg_subscription_deactivated\";s:24:\"Registration is disabled\";s:32:\"crs_reg_subscription_end_earlier\";s:32:\"The registration time is expired\";s:40:\"crs_reg_subscription_max_members_reached\";s:40:\"The maximum number of users is exceeded.\";s:32:\"crs_reg_subscription_start_later\";s:34:\"The registration time starts later\";s:18:\"crs_reg_unlim_info\";s:109:\"If enabled, there is no time limit for registrations. Please choose one of the registration procedures below.\";s:13:\"crs_reg_until\";s:19:\"Registration Period\";s:29:\"crs_reg_user_already_assigned\";s:39:\"You are already assigned to this course\";s:31:\"crs_reg_user_already_subscribed\";s:53:\"You have already requested membership for this course\";s:20:\"crs_reg_user_blocked\";s:32:\"You are blocked from this course\";s:16:\"crs_registration\";s:19:\"Course Registration\";s:28:\"crs_registration_deactivated\";s:83:\"Choose this option for disabling course registration. No user can join this course.\";s:24:\"crs_registration_limited\";s:27:\"Limited Registration Period\";s:21:\"crs_registration_type\";s:22:\"Registration Procedure\";s:26:\"crs_registration_unlimited\";s:29:\"Unlimited Registration Period\";s:21:\"crs_reject_subscriber\";s:24:\"Declined for course \"%s\"\";s:26:\"crs_reject_subscriber_body\";s:51:\"Your request to join course \"%s\" has been declined.\";s:17:\"crs_reset_results\";s:13:\"Reset Results\";s:8:\"crs_role\";s:4:\"Role\";s:15:\"crs_role_status\";s:13:\"Role / Status\";s:30:\"crs_search_enter_search_string\";s:28:\"Please enter a search string\";s:14:\"crs_search_for\";s:10:\"Search for\";s:18:\"crs_search_members\";s:11:\"User search\";s:14:\"crs_search_str\";s:11:\"Search term\";s:27:\"crs_select_archive_language\";s:40:\"Please select a language for the archive\";s:25:\"crs_select_exactly_one_lm\";s:42:\"Please select exactly one learning module.\";s:26:\"crs_select_exactly_one_tst\";s:31:\"Please select exactly one test.\";s:20:\"crs_select_native_lm\";s:70:\"Single chapters can only be assigned to native ILIAS learning modules.\";s:22:\"crs_select_one_archive\";s:25:\"Please select one archive\";s:21:\"crs_select_one_object\";s:30:\"Please select one course item.\";s:28:\"crs_select_registration_type\";s:38:\"Please select an admittance procedure.\";s:18:\"crs_select_starter\";s:19:\"Select Start Object\";s:23:\"crs_set_on_waiting_list\";s:154:\"You can add your join request to the waiting list. You will receive a message from a course administrator when your request has been approved or rejected.\";s:12:\"crs_settings\";s:15:\"Course Settings\";s:18:\"crs_settings_saved\";s:14:\"Settings saved\";s:17:\"crs_show_link_lms\";s:23:\"Show learning materials\";s:24:\"crs_show_link_objectives\";s:15:\"Show objectives\";s:16:\"crs_show_link_or\";s:20:\"Show other resources\";s:17:\"crs_show_link_tst\";s:10:\"Show tests\";s:16:\"crs_show_members\";s:12:\"Show Members\";s:21:\"crs_show_members_info\";s:97:\"If activated, course members can access the members gallery and the send mail to members feature.\";s:24:\"crs_show_objectives_view\";s:14:\"Objective view\";s:8:\"crs_size\";s:9:\"File size\";s:19:\"crs_sort_activation\";s:18:\"Sort by Activation\";s:15:\"crs_sort_manual\";s:13:\"Sort Manually\";s:20:\"crs_sort_manual_info\";s:67:\"This mode offers you the possibility to sort course items manually.\";s:20:\"crs_sort_timing_info\";s:65:\"Sort course items be their activation time or timing presettings.\";s:14:\"crs_sort_title\";s:13:\"Sort by Title\";s:19:\"crs_sort_title_info\";s:61:\"Choose this mode to sort course items automatically by title.\";s:13:\"crs_sortorder\";s:4:\"Sort\";s:17:\"crs_sortorder_abo\";s:20:\"Content Item Sorting\";s:9:\"crs_start\";s:5:\"Start\";s:17:\"crs_start_objects\";s:13:\"Start Objects\";s:19:\"crs_starter_deleted\";s:19:\"Removed assignment.\";s:29:\"crs_starters_already_assigned\";s:33:\"This object was already assigned.\";s:10:\"crs_status\";s:6:\"Status\";s:18:\"crs_status_changed\";s:21:\"Status in course \"%s\"\";s:23:\"crs_status_changed_body\";s:44:\"Your status in course \"%s\" has been changed.\";s:13:\"crs_structure\";s:16:\"Course structure\";s:15:\"crs_subscribers\";s:13:\"Join Requests\";s:23:\"crs_subscribers_deleted\";s:21:\"Deleted subscriber(s)\";s:16:\"crs_subscription\";s:12:\"Subscription\";s:28:\"crs_subscription_max_members\";s:25:\"Limited Number of Members\";s:23:\"crs_subscription_notify\";s:24:\"Notify for subscriptions\";s:37:\"crs_subscription_options_confirmation\";s:18:\"Request Membership\";s:36:\"crs_subscription_options_deactivated\";s:11:\"Deactivated\";s:31:\"crs_subscription_options_direct\";s:13:\"Join Directly\";s:33:\"crs_subscription_options_password\";s:25:\"Join with Course Password\";s:26:\"crs_subscription_requested\";s:45:\"You have requested membership for the course.\";s:27:\"crs_subscription_successful\";s:26:\"You have joined the course\";s:21:\"crs_subscription_type\";s:17:\"Subscription type\";s:14:\"crs_suggest_lm\";s:30:\"Suggest learning materials if:\";s:18:\"crs_suggestion_end\";s:13:\"Suggested End\";s:33:\"crs_sure_delete_selected_archives\";s:44:\"Are you sure to delete the selected archives\";s:12:\"crs_syllabus\";s:8:\"Syllabus\";s:23:\"crs_table_start_objects\";s:13:\"Start Objects\";s:24:\"crs_test_status_complete\";s:8:\"Complete\";s:28:\"crs_test_status_not_complete\";s:12:\"Not complete\";s:22:\"crs_test_status_random\";s:11:\"Random test\";s:8:\"crs_time\";s:17:\"Subscription time\";s:32:\"crs_timings_availability_enabled\";s:21:\"Temporarily Available\";s:28:\"crs_timings_availability_tbl\";s:12:\"Availability\";s:22:\"crs_timings_changeable\";s:22:\"Time Target Changeable\";s:19:\"crs_timings_changed\";s:16:\"Timings Modified\";s:20:\"crs_timings_disabled\";s:16:\"Timings Disabled\";s:25:\"crs_timings_disabled_info\";s:42:\"Choose this option to disable any timings.\";s:20:\"crs_timings_duration\";s:8:\"Duration\";s:23:\"crs_timings_early_begin\";s:14:\"Earliest Start\";s:15:\"crs_timings_end\";s:11:\"Ending Time\";s:22:\"crs_timings_from_until\";s:12:\"(From/Until)\";s:19:\"crs_timings_in_days\";s:9:\"(In Days)\";s:23:\"crs_timings_info_active\";s:8:\"(Active)\";s:20:\"crs_timings_late_end\";s:10:\"Latest End\";s:23:\"crs_timings_not_changed\";s:20:\"Timings not Modified\";s:23:\"crs_timings_planed_info\";s:19:\"Planed Editing Time\";s:24:\"crs_timings_planed_start\";s:6:\"Planed\";s:22:\"crs_timings_presetting\";s:19:\"Time Target Enabled\";s:26:\"crs_timings_presetting_tbl\";s:11:\"Time Target\";s:24:\"crs_timings_short_active\";s:7:\"Enabled\";s:28:\"crs_timings_short_changeable\";s:10:\"Changeable\";s:33:\"crs_timings_short_limit_start_end\";s:10:\"Changeable\";s:27:\"crs_timings_short_start_end\";s:10:\"Suggestion\";s:17:\"crs_timings_start\";s:13:\"Starting Time\";s:26:\"crs_timings_start_end_info\";s:11:\"(Start/End)\";s:21:\"crs_timings_sug_begin\";s:15:\"Suggested Start\";s:19:\"crs_timings_sug_end\";s:13:\"Suggested End\";s:26:\"crs_timings_suggested_info\";s:22:\"Suggested Editing Time\";s:22:\"crs_timings_time_frame\";s:10:\"Time Frame\";s:24:\"crs_timings_update_error\";s:90:\"Your settings are not valid, please verify the timings for the following course materials:\";s:22:\"crs_timings_visibility\";s:74:\"If chosen, the material is visible even outside of the given availability.\";s:6:\"crs_to\";s:6:\"Until:\";s:9:\"crs_tutor\";s:5:\"Tutor\";s:19:\"crs_tutor_no_notify\";s:23:\"Tutor (no notification)\";s:16:\"crs_tutor_notify\";s:20:\"Tutor (notification)\";s:10:\"crs_tutors\";s:6:\"Tutors\";s:13:\"crs_unblocked\";s:13:\"Free entrance\";s:20:\"crs_unblocked_member\";s:21:\"Status in course \"%s\"\";s:25:\"crs_unblocked_member_body\";s:48:\"Your membership in course \"%s\" has been restored\";s:13:\"crs_unlimited\";s:9:\"Unlimited\";s:15:\"crs_unsubscribe\";s:11:\"Unsubscribe\";s:20:\"crs_unsubscribe_sure\";s:43:\"Do you want to unsubscribe from this course\";s:25:\"crs_unsubscribed_from_crs\";s:43:\"You have been unsubscribed from this course\";s:20:\"crs_update_objective\";s:23:\"Edit Learning Objective\";s:15:\"crs_users_added\";s:24:\"Added user to the course\";s:26:\"crs_users_already_assigned\";s:43:\"The user is already assigned to this course\";s:27:\"crs_users_removed_from_list\";s:58:\"The selected users have been removed from the waiting list\";s:16:\"crs_view_archive\";s:12:\"Archive View\";s:23:\"crs_view_info_objective\";s:75:\"This presentation mode is used for the presentation of learning objectives.\";s:20:\"crs_view_info_timing\";s:41:\"Presentation mode for timing presettings.\";s:13:\"crs_view_mode\";s:19:\"Course Presentation\";s:18:\"crs_view_objective\";s:23:\"Objective Oriented View\";s:15:\"crs_view_timing\";s:12:\"Timings View\";s:14:\"crs_visibility\";s:12:\"Availability\";s:24:\"crs_visibility_limitless\";s:9:\"Unlimited\";s:20:\"crs_visibility_until\";s:21:\"Temporarily Available\";s:24:\"crs_visibility_unvisible\";s:33:\"Offline (Course is not available)\";s:13:\"crs_wait_info\";s:107:\"If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.\";s:16:\"crs_waiting_list\";s:12:\"Waiting List\";s:7:\"crs_xml\";s:3:\"XML\";s:18:\"crs_youre_position\";s:33:\"Your Position on the Waiting List\";s:12:\"edit_content\";s:12:\"Edit Content\";s:17:\"edit_timings_list\";s:12:\"Edit Timings\";s:5:\"event\";s:7:\"Session\";s:19:\"event_add_new_event\";s:17:\"Added new session\";s:22:\"event_assign_materials\";s:16:\"Assign Materials\";s:27:\"event_assign_materials_info\";s:71:\"Assigned course materials will be displayed directly below the session.\";s:28:\"event_assign_materials_table\";s:30:\"Assignment of Course Materials\";s:13:\"event_btn_add\";s:11:\"Add Session\";s:10:\"event_date\";s:15:\"Date of Session\";s:15:\"event_date_time\";s:11:\"Date & Time\";s:17:\"event_delete_file\";s:12:\"Delete File?\";s:17:\"event_delete_sure\";s:38:\"Do really want to delete this session?\";s:10:\"event_desc\";s:11:\"Description\";s:22:\"event_details_workflow\";s:16:\"Details/Workflow\";s:18:\"event_edit_members\";s:17:\"Edit Participants\";s:14:\"event_end_date\";s:3:\"End\";s:25:\"event_etime_smaller_stime\";s:82:\"The ending time is earlier than the starting time. Please enter a valid time span.\";s:20:\"event_existing_files\";s:15:\"Existing Files:\";s:10:\"event_file\";s:4:\"File\";s:19:\"event_file_download\";s:18:\"Files for Download\";s:15:\"event_file_name\";s:8:\"Filename\";s:20:\"event_file_size_info\";s:8:\"Filesize\";s:20:\"event_full_time_info\";s:9:\"full-time\";s:13:\"event_fullday\";s:9:\"Full-Time\";s:19:\"event_fulltime_info\";s:13:\"All Day Event\";s:26:\"event_further_informations\";s:19:\"Further Information\";s:19:\"event_general_infos\";s:19:\"General Information\";s:24:\"event_general_properties\";s:19:\"General Information\";s:14:\"event_lecturer\";s:4:\"Name\";s:14:\"event_location\";s:8:\"Location\";s:19:\"event_participation\";s:13:\"Participation\";s:14:\"event_register\";s:8:\"Register\";s:16:\"event_registered\";s:41:\"You have been registered to this session.\";s:18:\"event_registration\";s:12:\"Registration\";s:23:\"event_registration_info\";s:39:\"Allow users to register to the session.\";s:31:\"event_registration_participance\";s:12:\"Registration\";s:23:\"event_save_participants\";s:17:\"Save Participance\";s:16:\"event_start_date\";s:5:\"Start\";s:18:\"event_table_create\";s:11:\"New Session\";s:18:\"event_table_update\";s:12:\"Edit Session\";s:22:\"event_tbl_participants\";s:20:\"List of Participants\";s:22:\"event_tbl_participated\";s:12:\"Participated\";s:20:\"event_tbl_registered\";s:10:\"Registered\";s:10:\"event_time\";s:4:\"Time\";s:11:\"event_title\";s:5:\"Title\";s:16:\"event_tutor_data\";s:31:\"Informations About the Lecturer\";s:16:\"event_unregister\";s:10:\"Unregister\";s:18:\"event_unregistered\";s:27:\"You have been unregistered.\";s:13:\"event_updated\";s:14:\"Saved Settings\";s:6:\"events\";s:8:\"Sessions\";s:14:\"events_deleted\";s:15:\"Session deleted\";s:10:\"import_crs\";s:13:\"Import Course\";s:13:\"learners_view\";s:13:\"Learners view\";s:28:\"subscription_times_not_valid\";s:37:\"The registration period is not valid.\";s:19:\"timing_accept_table\";s:16:\"Timings: Remarks\";s:15:\"timing_accepted\";s:8:\"Accepted\";s:19:\"timing_not_accepted\";s:12:\"Not Accepted\";s:13:\"timing_remark\";s:6:\"Remark\";s:20:\"timing_tutor_visible\";s:35:\"Remark is visible for course tutors\";s:18:\"timing_user_accept\";s:14:\"Accept Timings\";s:20:\"timing_user_accepted\";s:16:\"Timings Accepted\";s:7:\"timings\";s:7:\"Timings\";s:12:\"timings_edit\";s:12:\"Edit Timings\";s:10:\"timings_of\";s:11:\"Timings Off\";s:15:\"timings_timings\";s:7:\"Timings\";s:19:\"timings_timings_off\";s:33:\"Switch Timings Administration Off\";s:18:\"timings_timings_on\";s:32:\"Switch Timings Administration On\";s:16:\"timings_usr_edit\";s:12:\"Edit Timings\";s:11:\"tutor_email\";s:6:\"E-Mail\";s:15:\"tutor_firstname\";s:9:\"Firstname\";s:14:\"tutor_lastname\";s:8:\"Lastname\";s:10:\"tutor_name\";s:4:\"Name\";s:11:\"tutor_phone\";s:5:\"Phone\";s:11:\"tutor_title\";s:5:\"Title\";s:23:\"crs_mail_permanent_link\";s:55:\"Choose the following link to access the course content:\";s:22:\"crs_grp_added_grouping\";s:32:\"Added new membership limitation.\";s:16:\"crs_map_settings\";s:12:\"Map Settings\";s:14:\"crs_enable_map\";s:17:\"Enable Course Map\";s:16:\"crs_map_location\";s:19:\"Course Map Location\";s:15:\"crs_members_map\";s:18:\"Course Members Map\";s:26:\"grouping_change_assignment\";s:17:\"Change Assignment\";s:17:\"crs_reg_type_info\";s:69:\"This setting is only relevant, if the registration is not \'Disabled\'.\";s:14:\"crs_subscriber\";s:10:\"Subscriber\";s:14:\"export_members\";s:19:\"Export Participants\";s:20:\"crs_agreement_header\";s:14:\"User Agreement\";s:18:\"crs_user_agreement\";s:19:\"Released Data Types\";s:18:\"crs_info_agreement\";s:63:\"The following data types are visible for course administrators:\";s:9:\"crs_agree\";s:10:\"Acceptance\";s:14:\"crs_info_agree\";s:74:\"I accept, that the above data types are visible for course administrators.\";s:22:\"crs_agreement_required\";s:78:\"You have to accept the user agreement, if you want to register to this course.\";s:11:\"user_fields\";s:11:\"User Fields\";s:23:\"crs_user_agreement_info\";s:47:\"Visible Personal Data for Course Administrators\";s:14:\"event_overview\";s:26:\"Participations in Sessions\";s:11:\"event_digit\";s:5:\"Digit\";s:16:\"event_csv_export\";s:10:\"CSV Export\";s:18:\"event_participated\";s:12:\"Participated\";s:22:\"event_not_participated\";s:16:\"Not Participated\";s:32:\"crs_objective_assigned_materials\";s:27:\"Assigned Learning Materials\";s:26:\"crs_objective_assigned_qst\";s:18:\"Assigned Questions\";s:21:\"crs_objective_add_mat\";s:16:\"Assign Materials\";s:21:\"crs_objective_add_qst\";s:16:\"Assign Questions\";s:21:\"crs_show_link_session\";s:13:\"Show sessions\";s:21:\"crs_hide_link_session\";s:13:\"Hide sessions\";s:11:\"save_status\";s:11:\"Save Status\";s:18:\"crs_selected_users\";s:21:\"Selected Participants\";s:16:\"event_select_one\";s:31:\"-- Please select one session --\";s:18:\"events_clone_title\";s:17:\"Duplicate Session\";s:15:\"event_clone_btn\";s:17:\"Duplicate Session\";s:12:\"event_cloned\";s:32:\"The Session has been duplicated.\";s:11:\"event_files\";s:14:\"Assigned Files\";s:14:\"crs_reg_period\";s:17:\"Self-Registration\";s:21:\"crs_presentation_type\";s:17:\"Presentation Type\";s:23:\"crs_objective_err_limit\";s:38:\"Please enter points between %s and %s.\";s:25:\"crs_objective_qst_summary\";s:28:\"Overview Question Assignment\";s:23:\"crs_obj_required_points\";s:15:\"Required Points\";s:24:\"crs_objective_all_points\";s:12:\"Total Points\";s:20:\"crs_objective_points\";s:8:\"Point(s)\";s:23:\"crs_objective_wiz_title\";s:30:\"Learning Objective Description\";s:27:\"crs_objective_wiz_materials\";s:30:\"Assignment of Course Materials\";s:22:\"crs_objective_wiz_self\";s:22:\"Initial Test Questions\";s:28:\"crs_objective_wiz_self_limit\";s:23:\"Limits for Initial Test\";s:23:\"crs_objective_wiz_final\";s:20:\"Final Test Questions\";s:29:\"crs_objective_wiz_final_limit\";s:21:\"Limits for Final Test\";s:12:\"crs_wiz_next\";s:4:\"Save\";s:12:\"crs_wiz_back\";s:4:\"Back\";s:18:\"crs_objective_step\";s:4:\"Step\";s:29:\"crs_objective_self_assessment\";s:12:\"Initial Test\";s:24:\"crs_objective_final_test\";s:10:\"Final Test\";s:27:\"crs_objective_saved_sorting\";s:14:\"Saved sorting.\";s:18:\"crs_no_title_given\";s:40:\"Please insert a title for the objective.\";s:23:\"crs_objective_limit_err\";s:62:\"The required points shouldn\'t be higher than the total points.\";s:26:\"crs_no_objective_lms_found\";s:43:\"This course does not contain any materials.\";s:34:\"crs_subscription_max_members_short\";s:17:\"Number of Members\";s:23:\"max_members_not_numeric\";s:41:\"Please check the maximum number of users.\";s:24:\"sess_gen_attendance_list\";s:24:\"Generate Attendance List\";s:14:\"sess_date_time\";s:19:\"Session Appointment\";s:19:\"sess_gen_mark_title\";s:25:\"Generate Column for Notes\";s:16:\"sess_gen_comment\";s:28:\"Generate Column for Comments\";s:18:\"sess_gen_signature\";s:30:\"Generate Column for Signatures\";s:26:\"sess_print_attendance_list\";s:21:\"Print Attendance List\";s:14:\"sess_signature\";s:9:\"Signature\";s:20:\"sess_attendance_list\";s:15:\"Attendance List\";s:30:\"crs_archive_language_selection\";s:18:\"Language Selection\";s:22:\"crs_contact_email_info\";s:53:\"Enter one or more (comma seperated) E-mail addresses.\";s:20:\"crs_objective_status\";s:16:\"Objective Status\";s:22:\"crs_obj_final_req_info\";s:71:\"If this number of points is achieved, the learning objective is passed.\";s:24:\"crs_obj_initial_req_info\";s:98:\"If this number of points is achieved, no course materials will be recommended for further editing.\";s:28:\"crs_objective_wiz_title_info\";s:72:\"Please choose a title and a short description of the learning objective.\";s:32:\"crs_objective_wiz_materials_info\";s:91:\"You can assign course materials that are recommended for processing the learning objective.\";s:27:\"crs_objective_wiz_self_info\";s:130:\"Please define the initial test questions. Initial tests are intended to examine the previous knowledge of the course participants.\";s:33:\"crs_objective_wiz_self_limit_info\";s:52:\"Please define the limits for initial test questions.\";s:28:\"crs_objective_wiz_final_info\";s:35:\"Assignment of final test questions.\";s:34:\"crs_objective_wiz_final_limit_info\";s:60:\"Here you can define the limits for the final test questions.\";s:22:\"crs_suggested_sections\";s:18:\"Suggested Sections\";s:28:\"crs_timings_visibility_short\";s:10:\"Visibility\";}');
INSERT INTO `lng_modules` VALUES ('cntr','en','a:13:{s:23:\"cntr_view_info_sessions\";s:99:\"This content presentation groups all sessions first. After that the other course content is listed.\";s:21:\"cntr_view_info_simple\";s:55:\"This content presentation lists all items in one block.\";s:22:\"cntr_view_info_by_type\";s:60:\"This content presentation groups all items by resource type.\";s:24:\"cntr_hide_title_and_icon\";s:19:\"Hide Title and Icon\";s:23:\"cntr_old_editor_warning\";s:226:\"The maintenance of this editor will be discontinued in a future major releases of ILIAS. You may still use it to edit the content of this page now. But we recommend to switch to the standard page editor of ILIAS when possible.\";s:36:\"cntr_old_editor_open_standard_editor\";s:20:\"Open Standard Editor\";s:23:\"cntr_back_to_old_editor\";s:18:\"Back to Old Editor\";s:33:\"cntr_switch_to_new_editor_message\";s:211:\"This is the supported standard editor. Please use it to setup the content page. If you click the following link, the content presentation in the repository will switch from the old editor\'s content to this page.\";s:29:\"cntr_switch_to_new_editor_cmd\";s:36:\"Switch to this page for presentation\";s:20:\"cntr_switched_editor\";s:24:\"Switched to new content.\";s:18:\"cntr_view_sessions\";s:13:\"Sessions View\";s:16:\"cntr_view_simple\";s:11:\"Simple View\";s:17:\"cntr_view_by_type\";s:20:\"Grouped-by-Type View\";}');
INSERT INTO `lng_modules` VALUES ('crs_','en','a:1:{s:12:\"crs_archives\";s:8:\"Archives\";}');
INSERT INTO `lng_modules` VALUES ('dateplaner','en','a:313:{s:8:\"DateText\";s:7:\"Message\";s:8:\"Day_long\";s:8:\"Day View\";s:17:\"ERROR_DATE_EXISTS\";s:26:\"This event already exists.\";s:8:\"ERROR_DB\";s:21:\"Database write error!\";s:16:\"ERROR_DB_CONNECT\";s:29:\"The database is disconnected.\";s:13:\"ERROR_DEL_MSG\";s:75:\"This is a recurring event. Would you like to delete one event or the series\";s:13:\"ERROR_ENDDATE\";s:40:\"Wrong end date input. Format: dd/mm/yyyy\";s:13:\"ERROR_ENDTIME\";s:29:\"Wrong end time. Format: hh:mm\";s:15:\"ERROR_END_START\";s:52:\"Wrong end date input. End date is before start date.\";s:18:\"ERROR_FILE_CSV_MSG\";s:29:\"Please take a valid CSV File.\";s:16:\"ERROR_JAVASCRIPT\";s:131:\"<B><CENTER>your browser doesn\'t accept JavaScript.<br />Please close this Window after insert manually.<br />Thank you</CENTER></B>\";s:17:\"ERROR_ROTATIONEND\";s:50:\"Wrong recurring end date input. Format: dd/mm/yyyy\";s:19:\"ERROR_ROT_END_START\";s:72:\"Wrong recurring end date input. Recurring end date is before start date.\";s:15:\"ERROR_SHORTTEXT\";s:47:\"Wrong short text input. Short text is required.\";s:15:\"ERROR_STARTDATE\";s:42:\"Wrong start date input. Format: dd/mm/yyyy\";s:15:\"ERROR_STARTTIME\";s:31:\"Wrong start time. Format: hh:mm\";s:8:\"ERROR_TS\";s:21:\"Incorrect date format\";s:7:\"Fr_long\";s:6:\"Friday\";s:8:\"Fr_short\";s:2:\"Fr\";s:13:\"Language_file\";s:7:\"English\";s:12:\"Listbox_long\";s:14:\"List of Events\";s:7:\"Mo_long\";s:6:\"Monday\";s:8:\"Mo_short\";s:2:\"Mo\";s:10:\"Month_long\";s:10:\"Month View\";s:7:\"Sa_long\";s:8:\"Saturday\";s:8:\"Sa_short\";s:2:\"Sa\";s:7:\"Su_long\";s:6:\"Sunday\";s:8:\"Su_short\";s:2:\"Su\";s:4:\"Text\";s:4:\"Text\";s:7:\"Th_long\";s:8:\"Thursday\";s:8:\"Th_short\";s:2:\"Th\";s:7:\"Tu_long\";s:7:\"Tuesday\";s:8:\"Tu_short\";s:2:\"Tu\";s:4:\"View\";s:5:\"View:\";s:7:\"We_long\";s:9:\"Wednesday\";s:8:\"We_short\";s:2:\"We\";s:9:\"Week_long\";s:9:\"Week View\";s:8:\"add_data\";s:15:\"Additional Data\";s:4:\"app_\";s:5:\"Inbox\";s:8:\"app_date\";s:12:\"Create Event\";s:7:\"app_day\";s:8:\"Day View\";s:12:\"app_freetime\";s:47:\"Free time of other group members (catch a time)\";s:9:\"app_inbox\";s:5:\"Inbox\";s:8:\"app_list\";s:14:\"List of Events\";s:9:\"app_month\";s:10:\"Month View\";s:14:\"app_properties\";s:10:\"Properties\";s:8:\"app_week\";s:9:\"Week View\";s:11:\"application\";s:8:\"Calendar\";s:5:\"apply\";s:5:\"Apply\";s:4:\"back\";s:4:\"Back\";s:10:\"begin_date\";s:10:\"Begin Date\";s:8:\"busytime\";s:18:\"Busy time in group\";s:6:\"c_date\";s:12:\"Create Event\";s:8:\"changeTo\";s:10:\"Change to:\";s:12:\"changedDates\";s:14:\"Changed Events\";s:16:\"checkforfreetime\";s:19:\"Check for free time\";s:7:\"created\";s:7:\"Created\";s:4:\"date\";s:4:\"Date\";s:11:\"date_format\";s:9:\"m/d/Y H:i\";s:18:\"date_format_middle\";s:5:\"m/d/y\";s:7:\"del_all\";s:17:\"Delete all events\";s:7:\"del_one\";s:16:\"Delete one event\";s:12:\"deletedDates\";s:14:\"Deleted Events\";s:7:\"discard\";s:7:\"Discard\";s:12:\"dv_Grouptime\";s:9:\"Free time\";s:16:\"dv_button_cancel\";s:6:\"Cancel\";s:16:\"dv_button_delete\";s:6:\"Delete\";s:16:\"dv_button_insert\";s:6:\"Insert\";s:16:\"dv_button_update\";s:6:\"Update\";s:13:\"dv_date_begin\";s:11:\"Start Date:\";s:11:\"dv_date_end\";s:9:\"End Date:\";s:10:\"dv_date_hm\";s:11:\"Hour:Minute\";s:10:\"dv_enddate\";s:9:\"End date:\";s:14:\"dv_groupselect\";s:13:\"Group select:\";s:12:\"dv_groupview\";s:12:\"Group event:\";s:17:\"dv_groupview_text\";s:12:\"Group:<br />\";s:11:\"dv_keywords\";s:9:\"Keywords:\";s:16:\"dv_keywordselect\";s:15:\"Keyword select:\";s:10:\"dv_message\";s:8:\"Message:\";s:10:\"dv_noGroup\";s:8:\"no Group\";s:8:\"dv_noKey\";s:10:\"no Keyword\";s:10:\"dv_preview\";s:18:\"<b>! Preview !</b>\";s:11:\"dv_rotation\";s:11:\"Recurrence:\";s:16:\"dv_rotation_date\";s:16:\"Recurrence date:\";s:15:\"dv_rotation_end\";s:15:\"Recurrence end:\";s:12:\"dv_shorttext\";s:11:\"Short text:\";s:12:\"dv_startdate\";s:11:\"Start date:\";s:7:\"dv_text\";s:5:\"Text:\";s:12:\"dv_whole_day\";s:10:\"Whole day:\";s:17:\"dv_whole_rotation\";s:74:\"Would you like to delete the entire recurring series? (click the checkbox)\";s:8:\"end_date\";s:8:\"End Date\";s:16:\"endtime_for_view\";s:18:\"End time for view:\";s:17:\"error_minical_img\";s:31:\"Cannot create GD-picture-stream\";s:7:\"execute\";s:15:\"Execute choices\";s:11:\"extra_dates\";s:14:\"One Day Events\";s:4:\"free\";s:4:\"Free\";s:8:\"freetime\";s:18:\"Free Time in group\";s:5:\"group\";s:5:\"Group\";s:8:\"help_day\";s:17:\"Calendar Day View\";s:10:\"help_day_l\";s:57:\"In the day view all events of a chosen day are displayed.\";s:12:\"help_enddate\";s:29:\"End date - syntax[dd/mm/yyyy]\";s:14:\"help_enddate_l\";s:109:\"Contains the end time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.\";s:16:\"help_endrotation\";s:27:\"End time syntax[dd/mm/yyyy]\";s:18:\"help_endrotation_l\";s:109:\"At this day the repetition will end.<br />The symbol opens a small calendar for choosing the appropriate date\";s:12:\"help_endtime\";s:39:\"End time - syntax[hh/mm] 24-hour format\";s:14:\"help_endtime_l\";s:62:\"Contains the end time of the appointment using 24-hour format.\";s:13:\"help_filename\";s:15:\"dp_help_en.html\";s:12:\"help_fullday\";s:32:\"Whole day event - syntax[on/off]\";s:14:\"help_fullday_l\";s:127:\"If the event stretches over a whole day, please choose this option.<br />This will hide the start time, end time, and end date.\";s:12:\"help_further\";s:48:\"<br /><b>click here for further information.</b>\";s:10:\"help_group\";s:22:\"Group events selection\";s:12:\"help_group_l\";s:193:\"Contains the groups for which the logged-in user has administrator rights and for which a date can be created.<br />After choosing this it is possible to view the unscheduled time of the group.\";s:10:\"help_inbox\";s:14:\"Calendar Inbox\";s:12:\"help_inbox_l\";s:62:\"Here all new, changed, and deleted group events are displayed.\";s:12:\"help_keyword\";s:17:\"Keyword selection\";s:15:\"help_keywordUse\";s:17:\"Keyword selection\";s:17:\"help_keywordUse_l\";s:106:\"Choose one or more keywords from the dialog box.<br />TIP: use the CTRL key for selecting several entries.\";s:14:\"help_keyword_l\";s:58:\"Contains the keywords which a user can associate to dates.\";s:9:\"help_list\";s:19:\"Calendar event list\";s:11:\"help_list_l\";s:70:\"In the event list, all events of a given period of time are displayed.\";s:10:\"help_month\";s:19:\"Calendar month view\";s:12:\"help_month_l\";s:60:\"In the month view all events of a given month are displayed.\";s:19:\"help_properties_alt\";s:19:\"Changes the keyword\";s:21:\"help_properties_alt_l\";s:111:\"Choose a keyword from the dialog box.<br />Change the keyword in the text field. Important: max. 20 characters.\";s:19:\"help_properties_del\";s:19:\"Deletes the keyword\";s:21:\"help_properties_del_l\";s:77:\"Choose a keyword from the dialog box. Click the button to delete the keyword.\";s:22:\"help_properties_import\";s:27:\"Import of Outlook-CSV-Files\";s:24:\"help_properties_import_l\";s:112:\"Here a CSC-File can be selected, which contains Outlook-Events. These events will be imported into the calendar.\";s:19:\"help_properties_new\";s:33:\"Add a keyword, max. 20 characters\";s:21:\"help_properties_new_l\";s:70:\"Add a new keyword to the field \\\"new\\\". Important: max. 20 characters.\";s:20:\"help_properties_time\";s:35:\"Display time for day view/week view\";s:22:\"help_properties_time_l\";s:213:\"The standard display time for the day view and week view can be changed. If dates are outside of the display time for a given days or week, the display time will be changed for that time span. Standard is 8h -18h.\";s:13:\"help_rotation\";s:10:\"Recurrence\";s:15:\"help_rotation_l\";s:49:\"Contains the type of the recurrence / repetition.\";s:14:\"help_shorttext\";s:30:\"Short text, max. 50 characters\";s:16:\"help_shorttext_l\";s:51:\"Here one can enter the short text for a given date.\";s:14:\"help_startdate\";s:31:\"Start date - syntax[dd/mm/yyyy]\";s:16:\"help_startdate_l\";s:114:\"Contains the starting time of the event.<br />The symbol opens a small calendar for choosing the appropriate date.\";s:14:\"help_starttime\";s:41:\"Start time - syntax[hh/mm] 24-hour format\";s:16:\"help_starttime_l\";s:61:\"Contains the starting time of the event using 24-hour format.\";s:9:\"help_text\";s:4:\"Text\";s:11:\"help_text_l\";s:46:\"Here one can enter the text for a given event.\";s:9:\"help_week\";s:18:\"Calendar week view\";s:11:\"help_week_l\";s:58:\"In the week view all events of a given week are displayed.\";s:4:\"hour\";s:4:\"hour\";s:11:\"importDates\";s:24:\"Import of Outlook Events\";s:5:\"inbox\";s:5:\"Inbox\";s:17:\"insertImportDates\";s:42:\"These events were successfully registered:\";s:10:\"k_alldates\";s:10:\"All Events\";s:4:\"keep\";s:4:\"Keep\";s:7:\"keyword\";s:7:\"Keyword\";s:8:\"keywords\";s:8:\"Keywords\";s:11:\"last_change\";s:12:\"Last changed\";s:7:\"long_01\";s:7:\"January\";s:7:\"long_02\";s:8:\"February\";s:7:\"long_03\";s:5:\"March\";s:7:\"long_04\";s:5:\"April\";s:7:\"long_05\";s:3:\"May\";s:7:\"long_06\";s:4:\"June\";s:7:\"long_07\";s:4:\"July\";s:7:\"long_08\";s:6:\"August\";s:7:\"long_09\";s:9:\"September\";s:7:\"long_10\";s:7:\"October\";s:7:\"long_11\";s:8:\"November\";s:7:\"long_12\";s:8:\"December\";s:10:\"main_dates\";s:11:\"Main Events\";s:5:\"menue\";s:4:\"Menu\";s:6:\"mmonth\";s:10:\"Last Month\";s:5:\"month\";s:5:\"Month\";s:4:\"more\";s:4:\"More\";s:5:\"mweek\";s:9:\"Last Week\";s:6:\"myeahr\";s:9:\"Last Year\";s:8:\"newDates\";s:10:\"New Events\";s:10:\"newKeyword\";s:4:\"New:\";s:7:\"new_doc\";s:16:\"Create new event\";s:8:\"no_entry\";s:19:\"No events available\";s:10:\"o_day_date\";s:13:\"24-hour event\";s:2:\"of\";s:2:\"of\";s:8:\"open_day\";s:8:\"Day View\";s:6:\"pmonth\";s:10:\"Next Month\";s:9:\"printlist\";s:5:\"Print\";s:10:\"properties\";s:10:\"Properties\";s:5:\"pweek\";s:9:\"Next Week\";s:5:\"pyear\";s:9:\"Next Year\";s:4:\"r_14\";s:13:\"Every 14 days\";s:9:\"r_4_weeks\";s:13:\"Every 4 weeks\";s:5:\"r_day\";s:9:\"Every day\";s:10:\"r_halfyear\";s:15:\"Every half year\";s:7:\"r_month\";s:11:\"Every month\";s:14:\"r_nonrecurring\";s:4:\"Once\";s:6:\"r_week\";s:10:\"Every week\";s:6:\"r_year\";s:10:\"Every year\";s:14:\"readimportfile\";s:6:\"Insert\";s:8:\"rotation\";s:10:\"Recurrence\";s:14:\"rotation_dates\";s:17:\"Recurrence events\";s:13:\"semester_name\";s:13:\"Semester Name\";s:8:\"short_01\";s:3:\"Jan\";s:8:\"short_02\";s:3:\"Feb\";s:8:\"short_03\";s:3:\"Mar\";s:8:\"short_04\";s:3:\"Apr\";s:8:\"short_05\";s:3:\"May\";s:8:\"short_06\";s:3:\"Jun\";s:8:\"short_07\";s:3:\"Jul\";s:8:\"short_08\";s:3:\"Aug\";s:8:\"short_09\";s:3:\"Sep\";s:8:\"short_10\";s:3:\"Oct\";s:8:\"short_11\";s:3:\"Nov\";s:8:\"short_12\";s:3:\"Dec\";s:9:\"shorttext\";s:10:\"Short Text\";s:10:\"singleDate\";s:12:\"Single Event\";s:18:\"starttime_for_view\";s:20:\"Start time for view:\";s:8:\"timedate\";s:11:\"Time / Date\";s:9:\"timeslice\";s:5:\"Time:\";s:2:\"to\";s:2:\"to\";s:5:\"today\";s:5:\"Today\";s:8:\"viewlist\";s:4:\"View\";s:4:\"week\";s:4:\"Week\";s:8:\"wk_short\";s:2:\"WK\";s:4:\"year\";s:4:\"Year\";s:17:\"cal_user_settings\";s:17:\"Calendar Settings\";s:17:\"cal_user_timezone\";s:8:\"Timezone\";s:17:\"cal_timezone_info\";s:48:\"Please choose the nearest city in your timezone.\";s:14:\"cal_week_start\";s:10:\"Week Start\";s:19:\"cal_global_settings\";s:15:\"Global Settings\";s:13:\"cal_server_tz\";s:15:\"Server Timezone\";s:16:\"cal_def_timezone\";s:16:\"Default Timezone\";s:21:\"cal_def_timezone_info\";s:70:\"Please choose a default timezone for the presentation of appointments.\";s:18:\"cal_def_week_start\";s:10:\"Week Start\";s:20:\"cal_table_categories\";s:18:\"Calendar Selection\";s:12:\"cal_type_usr\";s:17:\"Personal Calendar\";s:20:\"yui_cal_choose_month\";s:6:\"Month:\";s:19:\"yui_cal_choose_year\";s:5:\"Year:\";s:20:\"cal_edit_appointment\";s:16:\"Edit Appointment\";s:8:\"cal_what\";s:5:\"Title\";s:22:\"cal_category_selection\";s:18:\"Calendar Selection\";s:9:\"cal_start\";s:5:\"Start\";s:7:\"cal_end\";s:3:\"End\";s:11:\"cal_fullday\";s:9:\"Date/Time\";s:17:\"cal_fullday_title\";s:13:\"All Day Event\";s:9:\"cal_where\";s:8:\"Location\";s:11:\"cal_new_app\";s:15:\"New Appointment\";s:19:\"cal_add_appointment\";s:18:\"Create Appointment\";s:15:\"cal_recurrences\";s:11:\"Recurrences\";s:9:\"cal_every\";s:6:\"Every:\";s:9:\"cal_day_s\";s:6:\"Day(s)\";s:10:\"cal_week_s\";s:7:\"Week(s)\";s:11:\"cal_month_s\";s:8:\"Month(s)\";s:10:\"cal_year_s\";s:7:\"Year(s)\";s:18:\"cal_no_recurrences\";s:14:\"No Recurrences\";s:9:\"cal_daily\";s:5:\"Daily\";s:10:\"cal_weekly\";s:6:\"Weekly\";s:11:\"cal_monthly\";s:7:\"Monthly\";s:10:\"cal_yearly\";s:6:\"Yearly\";s:6:\"cal_on\";s:3:\"On:\";s:10:\"cal_on_the\";s:7:\"On the:\";s:9:\"cal_first\";s:5:\"First\";s:10:\"cal_second\";s:6:\"Second\";s:9:\"cal_third\";s:5:\"Third\";s:10:\"cal_fourth\";s:6:\"Fourth\";s:9:\"cal_fifth\";s:5:\"Fifth\";s:8:\"cal_last\";s:4:\"Last\";s:6:\"cal_in\";s:2:\"in\";s:17:\"cal_edit_category\";s:13:\"Edit Calendar\";s:17:\"cal_calendar_name\";s:13:\"Calendar Name\";s:18:\"cal_calendar_color\";s:5:\"Color\";s:16:\"cal_del_cal_sure\";s:50:\"Do you really want to delete the chosen calendars?\";s:13:\"cal_no_ending\";s:11:\"No End Date\";s:10:\"cal_create\";s:6:\"Create\";s:16:\"cal_appointments\";s:14:\"Appointment(s)\";s:25:\"cal_assigned_appointments\";s:21:\"Assigned Appointments\";s:17:\"cal_no_recurrence\";s:13:\"No Recurrence\";s:16:\"cal_add_category\";s:19:\"Create New Calendar\";s:16:\"cal_del_app_sure\";s:55:\"Do you really want to delete the selected appointments?\";s:12:\"cal_duration\";s:8:\"Duration\";s:11:\"cal_weekday\";s:7:\"Weekday\";s:16:\"cal_day_of_month\";s:16:\"Day of the month\";s:15:\"grp_cal_reg_end\";s:16:\"Registration End\";s:17:\"grp_cal_reg_start\";s:18:\"Registration Start\";s:24:\"crs_cal_activation_start\";s:12:\"Course Start\";s:22:\"crs_cal_activation_end\";s:10:\"Course End\";s:17:\"crs_cal_reg_start\";s:18:\"Registration Start\";s:15:\"crs_cal_reg_end\";s:16:\"Registration End\";s:20:\"cal_default_calendar\";s:21:\"Personal Appointments\";s:11:\"cal_details\";s:19:\"Appointment Details\";s:12:\"cal_cal_type\";s:13:\"Calendar Type\";s:17:\"cal_type_personal\";s:16:\"Private Calendar\";s:15:\"cal_type_system\";s:15:\"Public Calendar\";s:9:\"cal_share\";s:14:\"Share Calendar\";s:17:\"cal_shared_header\";s:16:\"Shared Calendars\";s:15:\"cal_unshare_cal\";s:12:\"Stop Sharing\";s:25:\"cal_unshared_selected_usr\";s:53:\"Stopped sharing the calendar with the selected users.\";s:23:\"cal_share_search_header\";s:14:\"Share Calendar\";s:10:\"cal_search\";s:11:\"Search Term\";s:21:\"cal_search_info_share\";s:72:\"Please enter the name of the desired user/role for sharing the calendar.\";s:27:\"cal_share_search_usr_header\";s:14:\"User Selection\";s:13:\"cal_share_cal\";s:14:\"Share calendar\";s:23:\"cal_shared_selected_usr\";s:59:\"The calendar has been shared with the selected users/roles.\";s:20:\"cal_shared_calendars\";s:30:\"Shared Calendars (Invitations)\";s:8:\"cal_apps\";s:22:\"Number of Appointments\";s:16:\"cal_share_accept\";s:17:\"Accept Invitation\";s:17:\"cal_share_decline\";s:18:\"Decline Invitation\";s:25:\"cal_changed_events_header\";s:20:\"Changed Appointments\";s:12:\"cal_accepted\";s:8:\"Accepted\";s:12:\"cal_declined\";s:8:\"Declined\";s:20:\"cal_user_time_format\";s:11:\"Time Format\";s:20:\"cal_time_format_info\";s:52:\"Please choose a format for the presentation of time.\";s:24:\"cal_def_time_format_info\";s:52:\"Please choose a format for the presentation of time.\";s:19:\"cal_def_time_format\";s:19:\"Default Time Format\";s:28:\"cal_share_search_role_header\";s:14:\"Role Selection\";s:15:\"cal_cal_details\";s:16:\"Calendar Details\";s:12:\"cal_type_crs\";s:15:\"Course Calendar\";s:12:\"cal_type_grp\";s:14:\"Group Calendar\";s:13:\"cal_type_info\";s:84:\"Please choose one calendar type. \"Public Calendars\" are visible for all ILIAS users.\";}');
INSERT INTO `lng_modules` VALUES ('forum','en','a:103:{s:26:\"threads_moved_successfully\";s:59:\"The chosen topics were moved to another forum successfully.\";s:26:\"select_at_least_one_thread\";s:33:\"Please select at least one topic.\";s:31:\"topics_please_select_one_action\";s:24:\"Please select an action.\";s:37:\"no_forum_available_for_moving_threads\";s:48:\"No forum available to move the chosen topics to.\";s:18:\"move_chosen_topics\";s:18:\"Move Chosen Topics\";s:8:\"to_forum\";s:8:\"To Forum\";s:17:\"no_forum_selected\";s:46:\"No forum selected for moving the chosen topics\";s:17:\"sure_move_threads\";s:48:\"Are you sure you want to move the chosen topics?\";s:6:\"sticky\";s:6:\"Sticky\";s:18:\"make_topics_sticky\";s:18:\"Make Topics Sticky\";s:22:\"make_topics_non_sticky\";s:22:\"Make Topics Non-Sticky\";s:17:\"make_topic_sticky\";s:17:\"Make Topic Sticky\";s:21:\"make_topic_non_sticky\";s:21:\"Make Topic Non-Sticky\";s:11:\"topic_close\";s:6:\"Closed\";s:12:\"close_topics\";s:5:\"Close\";s:13:\"reopen_topics\";s:6:\"Reopen\";s:13:\"activate_post\";s:8:\"Activate\";s:15:\"deactivate_post\";s:10:\"Deactivate\";s:17:\"activate_post_txt\";s:147:\"Would you really like to activate the current post and if applicable all its child posts? Please note that all parent posts will be activated, too.\";s:19:\"deactivate_post_txt\";s:77:\"Would you really like to deactivate the current post and all its child posts?\";s:21:\"activate_only_current\";s:16:\"Activate Current\";s:27:\"activate_current_and_childs\";s:18:\"Activate All Posts\";s:29:\"deactivate_current_and_childs\";s:20:\"Deactivate All Posts\";s:41:\"forums_post_and_children_were_deactivated\";s:50:\"The post and all its child posts were deactivated.\";s:39:\"forums_post_and_children_were_activated\";s:48:\"The post and all its child posts were activated.\";s:25:\"forums_post_was_activated\";s:23:\"The post was activated.\";s:15:\"forum_anonymize\";s:17:\"Write anonymously\";s:20:\"forum_anonymize_desc\";s:78:\"Write this message anonymously (your ILIAS user name won\'t be shown anywhere).\";s:6:\"forums\";s:6:\"Forums\";s:15:\"forum_add_quote\";s:13:\"Add Quotation\";s:30:\"forums_all_threads_marked_read\";s:35:\"All topics have been marked as read\";s:18:\"forums_attachments\";s:11:\"Attachments\";s:22:\"forums_attachments_add\";s:14:\"Add attachment\";s:23:\"forums_attachments_edit\";s:15:\"Edit attachment\";s:16:\"forums_available\";s:16:\"Available Forums\";s:21:\"forums_censor_comment\";s:17:\"Comment of Censor\";s:34:\"post_censored_comment_by_moderator\";s:35:\"Post Censored, Comment by Moderator\";s:12:\"forums_count\";s:16:\"Number of Forums\";s:16:\"forums_count_art\";s:18:\"Number of Articles\";s:16:\"forums_count_thr\";s:16:\"Number of Topics\";s:17:\"forums_created_by\";s:10:\"Created by\";s:18:\"forums_delete_file\";s:17:\"Delete attachment\";s:27:\"forums_disable_notification\";s:35:\"Disable Notification for this Topic\";s:26:\"forums_download_attachment\";s:13:\"Download file\";s:16:\"forums_edit_post\";s:12:\"Edit Article\";s:26:\"forums_enable_notification\";s:34:\"Enable Notification for this Topic\";s:24:\"forums_info_censor2_post\";s:18:\"Revoke Censorship?\";s:23:\"forums_info_censor_post\";s:43:\"Are you sure you want to hide this article?\";s:23:\"forums_info_delete_post\";s:69:\"Are you sure you want to delete this article including any responses?\";s:16:\"forums_mark_read\";s:16:\"Mark All as Read\";s:18:\"forums_new_entries\";s:18:\"New Forums Entries\";s:17:\"forums_new_thread\";s:9:\"New Topic\";s:20:\"forums_not_available\";s:20:\"Forums Not Available\";s:19:\"forums_notification\";s:12:\"Notification\";s:27:\"forums_notification_enabled\";s:20:\"Notification enabled\";s:25:\"forums_notification_intro\";s:72:\"This mail was automatically sent to you by the ILIAS installation %s, %s\";s:31:\"forums_notification_is_disabled\";s:69:\"Your notification about new posts in this topic is not (yet) enabled.\";s:30:\"forums_notification_is_enabled\";s:81:\"At the moment your notification about new posts in this topic is already enabled.\";s:29:\"forums_notification_show_post\";s:13:\"Show post: %s\";s:27:\"forums_notification_subject\";s:20:\"New posting in forum\";s:15:\"forums_overview\";s:15:\"Forums Overview\";s:19:\"forums_post_deleted\";s:24:\"Article has been deleted\";s:20:\"forums_post_modified\";s:25:\"Article has been modified\";s:21:\"forums_post_new_entry\";s:30:\"A new article has been created\";s:33:\"forums_post_needs_to_be_activated\";s:76:\"A new article has been created, but it needs to be activated by a moderator.\";s:25:\"forums_no_posts_available\";s:72:\"This topic has no posts yet or the moderator deactivated the first post.\";s:12:\"forums_posts\";s:12:\"All articles\";s:26:\"forums_posts_not_available\";s:22:\"Articles Not Available\";s:19:\"forums_print_thread\";s:11:\"Print Topic\";s:17:\"forums_print_view\";s:10:\"Print View\";s:12:\"forums_quote\";s:5:\"Quote\";s:14:\"forums_respond\";s:10:\"Post Reply\";s:14:\"forums_subject\";s:7:\"Subject\";s:15:\"forums_the_post\";s:7:\"Article\";s:13:\"forums_thread\";s:5:\"Topic\";s:22:\"forums_thread_articles\";s:21:\"Articles of the topic\";s:25:\"forums_thread_create_date\";s:10:\"Created at\";s:25:\"forums_thread_create_from\";s:12:\"Created from\";s:20:\"forums_thread_marked\";s:34:\"The topic has been marked as read.\";s:23:\"forums_thread_new_entry\";s:26:\"New topic has been created\";s:28:\"forums_threads_not_available\";s:20:\"Topics Not Available\";s:22:\"forums_topics_overview\";s:15:\"Topics Overview\";s:17:\"forums_your_reply\";s:10:\"Your Reply\";s:21:\"frm_anonymous_posting\";s:17:\"Anonymous Posting\";s:26:\"frm_anonymous_posting_desc\";s:59:\"If enabled, anonymous posting is allowed within this forum.\";s:16:\"frm_default_view\";s:12:\"Default View\";s:40:\"frm_statistics_disabled_for_participants\";s:42:\"Statistics are disabled for forum members.\";s:22:\"frm_statistics_enabled\";s:17:\"Enable Statistics\";s:27:\"frm_statistics_enabled_desc\";s:46:\"Enable Posting Statistics for all participants\";s:22:\"frm_statistics_ranking\";s:18:\"Number of Postings\";s:18:\"frm_title_required\";s:22:\"Please insert a title.\";s:7:\"is_read\";s:12:\"Mark as Read\";s:8:\"new_post\";s:8:\"New Post\";s:18:\"activate_new_posts\";s:14:\"Activate Posts\";s:6:\"thread\";s:5:\"Topic\";s:20:\"post_activation_desc\";s:52:\"If enabled, the moderator has to activate new posts.\";s:15:\"frm_wizard_page\";s:21:\"Copy Forum (Step 2/2)\";s:21:\"fmr_copy_threads_info\";s:109:\"You have the possibility to copy single threads. Only the beginning of the chosen threads will be duplicated.\";s:28:\"forums_notification_disabled\";s:21:\"Notification disabled\";s:15:\"frm_moderator_f\";s:9:\"Moderator\";s:15:\"frm_moderator_m\";s:9:\"Moderator\";s:26:\"frm_post_not_activated_yet\";s:18:\"Not activated yet.\";s:14:\"frm_statistics\";s:10:\"Statistics\";}');
INSERT INTO `lng_modules` VALUES ('grp','en','a:79:{s:26:\"grp_registration_unlimited\";s:9:\"Unlimited\";s:16:\"crs_add_grouping\";s:25:\"Add Membership Limitation\";s:19:\"crs_grp_enter_title\";s:36:\"Please fill out all required fields.\";s:22:\"crs_grp_added_grouping\";s:32:\"Added new membership limitation.\";s:24:\"crs_grouping_delete_sure\";s:60:\"Are you sure you want to delete this membership limitation ?\";s:20:\"crs_grouping_deleted\";s:30:\"Deleted membership limitation.\";s:16:\"grp_map_settings\";s:12:\"Map Settings\";s:14:\"grp_enable_map\";s:16:\"Enable Group Map\";s:15:\"grp_members_map\";s:17:\"Group Members Map\";s:16:\"grp_map_location\";s:18:\"Group Map Location\";s:30:\"crs_grp_table_assigned_courses\";s:15:\"Assigned Groups\";s:26:\"grouping_change_assignment\";s:17:\"Change Assignment\";s:18:\"crs_grp_assign_crs\";s:20:\"Assignment of Groups\";s:27:\"crs_grp_no_courses_assigned\";s:18:\"No Groups Assigned\";s:23:\"crs_grouping_select_one\";s:40:\"Please select one membership limitation.\";s:16:\"crs_grp_info_reg\";s:45:\"You can only register to one of these groups:\";s:24:\"grp_deleted_export_files\";s:21:\"Deleted export files.\";s:19:\"grp_select_one_file\";s:23:\"Please select one file.\";s:15:\"grp_unsubscribe\";s:11:\"Unsubscribe\";s:10:\"grp_closed\";s:12:\"Closed Group\";s:15:\"grp_closed_info\";s:37:\"Group is not visible for non-members.\";s:16:\"grp_reg_disabled\";s:24:\"No Registration Possible\";s:21:\"grp_reg_disabled_info\";s:53:\"Only group administrators can add users to the group.\";s:15:\"grp_reg_request\";s:18:\"Request Membership\";s:20:\"grp_reg_request_info\";s:67:\"Interested users can send a request/message to group administrator.\";s:14:\"grp_reg_direct\";s:19:\"Direct Registration\";s:19:\"grp_reg_direct_info\";s:20:\"Direct registration.\";s:16:\"grp_pass_request\";s:24:\"Join With Group Password\";s:21:\"grp_reg_password_info\";s:65:\"Users need to type in the correct password for joining the group.\";s:18:\"grp_reg_limit_time\";s:7:\"Enabled\";s:17:\"grp_reg_limit_num\";s:23:\"Maximum Number of Users\";s:24:\"grp_reg_max_members_info\";s:70:\"Define the maximum number of users that can be assigned to this group.\";s:21:\"grp_waiting_list_info\";s:107:\"If enabled and the maximum number of users is exceeded, new registrations will be placed on a waiting list.\";s:16:\"grp_waiting_list\";s:19:\"Enable Waiting List\";s:22:\"grp_reg_limit_num_info\";s:27:\"Limited Registration Period\";s:13:\"grp_reg_start\";s:19:\"Registration Start:\";s:11:\"grp_reg_end\";s:17:\"Registration End:\";s:8:\"grp_open\";s:10:\"Open Group\";s:13:\"grp_open_info\";s:53:\"Non-members can see this group and join it directly..\";s:10:\"grp_public\";s:12:\"Public Group\";s:15:\"grp_public_info\";s:73:\"Group is visible for non-members but has special requirements to join it.\";s:7:\"grp_typ\";s:10:\"Group Type\";s:10:\"grp_admins\";s:14:\"Administrators\";s:11:\"grp_members\";s:7:\"Members\";s:18:\"grp_selected_users\";s:21:\"Selected Participants\";s:17:\"grp_delete_member\";s:6:\"Delete\";s:16:\"grp_notification\";s:12:\"Notification\";s:16:\"grp_edit_members\";s:17:\"Edit Participants\";s:16:\"grp_grp_info_reg\";s:45:\"You can only register to one of these groups:\";s:23:\"grp_set_on_waiting_list\";s:153:\"You can add your join request to the waiting list. You will receive a message from a group administrator when your request has been approved or rejected.\";s:17:\"grp_added_to_list\";s:96:\"You have been assigned to the waiting list. You are assigned to position %s on the waiting list.\";s:15:\"grp_users_added\";s:24:\"Added user to the group.\";s:26:\"grp_users_already_assigned\";s:44:\"The user is already assigned to this  group.\";s:23:\"grp_header_waiting_list\";s:12:\"Waiting List\";s:27:\"grp_users_removed_from_list\";s:59:\"The selected users have been removed from the waiting list.\";s:24:\"grp_general_informations\";s:19:\"General Information\";s:15:\"grp_information\";s:21:\"Important Information\";s:12:\"grp_settings\";s:14:\"Group Settings\";s:17:\"grp_info_settings\";s:17:\"Group Information\";s:17:\"grp_icon_settings\";s:10:\"Group Icon\";s:20:\"grp_information_info\";s:73:\"This information will be show on the info page and for new registrations.\";s:19:\"reg_grp_max_members\";s:25:\"Limited Number of Members\";s:15:\"grp_reg_limited\";s:17:\"Self-Registration\";s:19:\"grp_btn_unsubscribe\";s:22:\"Unsubscribe From Group\";s:30:\"grp_membership_request_subject\";s:42:\"%1$s %2$s would like to join group \"%3$s\".\";s:27:\"grp_membership_request_body\";s:218:\"%1$s %2$s has requested membership for group \"%5$s\".\\n\\nPlease accept or refuse this request on the \"Join Requests\" page of the group.\\n\\nGroup: %5$s\", %6$s\\n\\nRequestor: %1$s %2$s, %3$s, mailto:%4$s.\\n\\nSubject:\\n%7$s\";s:21:\"grp_accept_subscriber\";s:23:\"Admission to group \"%s\"\";s:26:\"grp_accept_subscriber_body\";s:47:\"You have been admitted to group \"%1$s\".\\n\\n%2$s\";s:21:\"grp_reject_subscriber\";s:23:\"Declined for group \"%s\"\";s:26:\"grp_reject_subscriber_body\";s:50:\"Your request to join group \"%s\" has been declined.\";s:23:\"grp_reg_req_info_screen\";s:141:\"You can request membership for this group. You will get a message from a group administrator when your request has been admitted or declined.\";s:26:\"grp_reg_passwd_info_screen\";s:83:\"If a group administrator has given you the group password, you can join this group.\";s:24:\"grp_reg_deac_info_screen\";s:27:\"Group admittance is closed.\";s:26:\"grp_reg_direct_info_screen\";s:33:\"You can join this group directly.\";s:25:\"reg_grp_max_members_short\";s:17:\"Number of Members\";s:21:\"grp_wrong_max_members\";s:41:\"Please check the maximum number of users.\";s:25:\"grp_warn_grp_type_changed\";s:85:\"Do you really want to change the group type? All permission settings will be reseted.\";s:21:\"grp_type_changed_info\";s:59:\"Changing the group type will reset all permission settings.\";s:15:\"grp_change_type\";s:17:\"Change Group Type\";}');
INSERT INTO `lng_modules` VALUES ('ilinc','en','a:14:{s:27:\"ilinc_member_administration\";s:17:\"Edit Participants\";s:13:\"akclassvalue1\";s:13:\"Cost center 1\";s:13:\"akclassvalue2\";s:13:\"Cost center 2\";s:13:\"akclassvalues\";s:12:\"Cost centers\";s:18:\"ilinc_akuservalue1\";s:13:\"Cost center 1\";s:18:\"ilinc_akuservalue2\";s:13:\"Cost center 2\";s:18:\"ilinc_akuservalues\";s:12:\"Cost centers\";s:23:\"ilinc_akuservalues_desc\";s:105:\"Enter here the code of the cost center(s) for this user. These values will be stored at the iLinc server.\";s:28:\"ilinc_akuservalues_refreshed\";s:20:\"Cost centers updated\";s:22:\"ilinc_connection_error\";s:37:\"Error: No connection to iLinc Server!\";s:20:\"ilinc_no_account_yet\";s:20:\"No iLinc Account yet\";s:16:\"ilinc_user_added\";s:36:\"User account created on iLinc server\";s:13:\"ilinc_user_id\";s:12:\"iLinc UserID\";s:19:\"ilinc_user_settings\";s:19:\"iLinc User settings\";}');
INSERT INTO `lng_modules` VALUES ('jscalendar','en','a:58:{s:14:\"about_calendar\";s:18:\"About the calendar\";s:19:\"about_calendar_long\";s:373:\"DHTML Date/Time Selector\\n(c) dynarch.com 2002-2003\\nFor latest version visit: http://dynarch.com/mishoo/calendar.epl\\nDistributed under GNU LGPL.  See http://gnu.org/licenses/lgpl.html for details.\\n\\nDate selection:\\n- Use the Â«, Â» buttons to select year\\n- Use the <, > buttons to select month\\n- Hold mouse button on any of the above buttons for faster selection.\";s:10:\"about_time\";s:144:\"\\n\\nTime selection:\\n- Click on any of the time parts to increase it\\n- or Shift-click to decrease it\\n- or click and drag for faster selection.\";s:5:\"close\";s:5:\"Close\";s:9:\"day_first\";s:16:\"Display %s first\";s:15:\"def_date_format\";s:8:\"%Y-%m-%d\";s:12:\"drag_to_move\";s:12:\"Drag to move\";s:8:\"go_today\";s:8:\"Go Today\";s:4:\"l_01\";s:7:\"January\";s:4:\"l_02\";s:8:\"Feburary\";s:4:\"l_03\";s:5:\"March\";s:4:\"l_04\";s:5:\"April\";s:4:\"l_05\";s:3:\"May\";s:4:\"l_06\";s:4:\"June\";s:4:\"l_07\";s:4:\"July\";s:4:\"l_08\";s:6:\"August\";s:4:\"l_09\";s:9:\"September\";s:4:\"l_10\";s:7:\"October\";s:4:\"l_11\";s:8:\"November\";s:4:\"l_12\";s:8:\"December\";s:4:\"l_fr\";s:6:\"Friday\";s:4:\"l_mo\";s:6:\"Monday\";s:4:\"l_sa\";s:8:\"Saturday\";s:4:\"l_su\";s:6:\"Sunday\";s:4:\"l_th\";s:8:\"Thursday\";s:4:\"l_tu\";s:7:\"Tuesday\";s:4:\"l_we\";s:9:\"Wednesday\";s:10:\"next_month\";s:26:\"Next month (hold for menu)\";s:9:\"next_year\";s:25:\"Next year (hold for menu)\";s:13:\"open_calendar\";s:71:\"Click here to open a calendar for date selection (JavaScript required!)\";s:10:\"part_today\";s:8:\" (today)\";s:10:\"prev_month\";s:27:\"Prev. month (hold for menu)\";s:9:\"prev_year\";s:26:\"Prev. year (hold for menu)\";s:4:\"s_01\";s:3:\"Jan\";s:4:\"s_02\";s:3:\"Feb\";s:4:\"s_03\";s:3:\"Mar\";s:4:\"s_04\";s:3:\"Apr\";s:4:\"s_05\";s:3:\"May\";s:4:\"s_06\";s:3:\"Jun\";s:4:\"s_07\";s:3:\"Jul\";s:4:\"s_08\";s:3:\"Aug\";s:4:\"s_09\";s:3:\"Sep\";s:4:\"s_10\";s:3:\"Oct\";s:4:\"s_11\";s:3:\"Nov\";s:4:\"s_12\";s:3:\"Dec\";s:4:\"s_fr\";s:2:\"Fr\";s:4:\"s_mo\";s:2:\"Mo\";s:4:\"s_sa\";s:2:\"Sa\";s:4:\"s_su\";s:2:\"Su\";s:4:\"s_th\";s:2:\"Th\";s:4:\"s_tu\";s:2:\"Tu\";s:4:\"s_we\";s:2:\"We\";s:11:\"select_date\";s:11:\"Select date\";s:4:\"time\";s:4:\"Time\";s:9:\"time_part\";s:37:\"(Shift-)Click or drag to change value\";s:5:\"today\";s:5:\"Today\";s:14:\"tt_date_format\";s:9:\"%a, %b %e\";s:2:\"wk\";s:2:\"wk\";}');
INSERT INTO `lng_modules` VALUES ('mail','en','a:135:{s:13:\"also_as_email\";s:14:\"Also as E-Mail\";s:2:\"bc\";s:3:\"BCC\";s:7:\"forward\";s:7:\"Forward\";s:9:\"linebreak\";s:10:\"Line break\";s:17:\"mail_account_mail\";s:12:\"Account Mail\";s:23:\"mail_account_mail_check\";s:17:\"Send Account Mail\";s:18:\"mail_add_recipient\";s:24:\"Please enter a recipient\";s:18:\"mail_add_subfolder\";s:13:\"Add Subfolder\";s:16:\"mail_add_subject\";s:22:\"Please enter a subject\";s:23:\"mail_add_to_addressbook\";s:19:\"Add to address book\";s:13:\"mail_add_type\";s:44:\"Please add the type of mail you want to send\";s:17:\"mail_addr_entries\";s:7:\"Entries\";s:41:\"mail_mailing_lists_no_addressbook_entries\";s:41:\"You have not any addressbook entries yet.\";s:51:\"mail_mailing_lists_all_addressbook_entries_assigned\";s:79:\"You have already assigned all of your addressbook entries to this mailing list.\";s:33:\"mail_assign_entry_to_mailing_list\";s:52:\"Assign an Entry of Your Address Book to Mailing List\";s:16:\"mail_attachments\";s:11:\"Attachments\";s:17:\"mail_bc_not_valid\";s:30:\"The BCC recipient is not valid\";s:14:\"mail_bc_search\";s:10:\"BCC search\";s:9:\"mail_byte\";s:4:\"Byte\";s:17:\"mail_cc_not_valid\";s:29:\"The CC recipient is not valid\";s:14:\"mail_cc_search\";s:9:\"CC search\";s:21:\"mail_change_to_folder\";s:17:\"Switch to folder:\";s:26:\"mail_check_your_email_addr\";s:32:\"Your e-mail address is not valid\";s:12:\"mail_compose\";s:15:\"Compose Message\";s:12:\"mail_deleted\";s:19:\"The mail is deleted\";s:18:\"mail_deleted_entry\";s:23:\"The entries are deleted\";s:20:\"mail_email_forbidden\";s:34:\"You are not allowed to send e-mail\";s:30:\"mail_enter_login_or_email_addr\";s:50:\"Please enter a valid login name or e-mail address.\";s:27:\"mail_enter_valid_email_addr\";s:36:\"Please enter a valid e-mail address.\";s:22:\"mail_enter_valid_login\";s:32:\"Please enter a valid login name.\";s:16:\"mail_entry_added\";s:15:\"Added new Entry\";s:18:\"mail_entry_changed\";s:20:\"The entry is changed\";s:17:\"mail_entry_exists\";s:50:\"An entry with the given login name already exists.\";s:14:\"mail_file_name\";s:9:\"File name\";s:14:\"mail_file_size\";s:9:\"File size\";s:18:\"mail_files_deleted\";s:23:\"The file(s) are deleted\";s:16:\"mail_folder_edit\";s:11:\"Edit Folder\";s:19:\"mail_folder_created\";s:29:\"A new folder has been created\";s:19:\"mail_folder_deleted\";s:27:\"The folder has been deleted\";s:18:\"mail_folder_exists\";s:38:\"A folder already exists with this name\";s:16:\"mail_folder_name\";s:11:\"Folder name\";s:24:\"mail_folder_name_changed\";s:27:\"The folder has been renamed\";s:19:\"mail_folder_options\";s:14:\"Folder Options\";s:28:\"mail_following_rcp_not_valid\";s:39:\"The following recipients are not valid:\";s:19:\"mail_global_options\";s:14:\"Global options\";s:13:\"mail_incoming\";s:13:\"Incoming mail\";s:18:\"mail_incoming_both\";s:20:\"local and forwarding\";s:19:\"mail_incoming_local\";s:10:\"only local\";s:18:\"mail_incoming_smtp\";s:25:\"forward to e-mail address\";s:23:\"mail_insert_folder_name\";s:27:\"Please insert a folder name\";s:17:\"mail_insert_query\";s:21:\"Please insert a query\";s:11:\"mail_intern\";s:8:\"Internal\";s:14:\"mail_mark_read\";s:14:\"Mark mail read\";s:16:\"mail_mark_unread\";s:16:\"Mark mail unread\";s:29:\"mail_maxsize_attachment_error\";s:20:\"The upload limit is:\";s:17:\"mail_message_send\";s:12:\"Message sent\";s:15:\"mail_move_error\";s:17:\"Error moving mail\";s:12:\"mail_move_to\";s:8:\"Move to:\";s:10:\"mail_moved\";s:23:\"The mail has been moved\";s:19:\"mail_moved_to_trash\";s:28:\"Mail has been moved to trash\";s:25:\"mail_notification_subject\";s:22:\"New mail in your inbox\";s:20:\"mail_nacc_admin_mail\";s:29:\"Mail address of Administrator\";s:21:\"mail_nacc_client_name\";s:11:\"Client Name\";s:19:\"mail_nacc_ilias_url\";s:19:\"URL of ILIAS system\";s:15:\"mail_nacc_login\";s:13:\"Login Account\";s:21:\"mail_nacc_no_pw_block\";s:94:\"This text block is only included, if the new user account has been created without a password.\";s:18:\"mail_nacc_pw_block\";s:96:\"This text block is only included, if the new user account has been created including a password.\";s:20:\"mail_nacc_salutation\";s:10:\"Salutation\";s:16:\"mail_nacc_target\";s:78:\"URL of target item, e.g. a linked course that is passed to ILIAS from outside.\";s:22:\"mail_nacc_target_block\";s:57:\"This text is only included, if a target item is provided.\";s:22:\"mail_nacc_target_title\";s:40:\"Title of target item, e.g. course title.\";s:21:\"mail_nacc_target_type\";s:53:\"Type of target item, e.g. \"Course\" for a course item.\";s:25:\"mail_nacc_use_placeholder\";s:38:\"The following placeholders may be used\";s:13:\"mail_new_file\";s:13:\"Add new file:\";s:22:\"mail_no_attach_allowed\";s:54:\"System messages are not allowed to contain attachments\";s:25:\"mail_no_attachments_found\";s:20:\"No attachments found\";s:30:\"mail_no_permissions_write_smtp\";s:47:\"You have no permission to write external e-mail\";s:23:\"mail_no_recipient_found\";s:87:\"Enter a different mail address. ILIAS couldn\'t find a recipient with this mail address.\";s:30:\"mail_multiple_recipients_found\";s:97:\"Enter a more specific mail address. ILIAS found multiple possible recipients for this address: %s\";s:15:\"mail_options_of\";s:7:\"Options\";s:18:\"mail_options_saved\";s:13:\"Options saved\";s:24:\"mail_recipient_not_valid\";s:26:\"The recipient is not valid\";s:6:\"mail_s\";s:7:\"Mail(s)\";s:13:\"mail_s_unread\";s:14:\"Unread Mail(s)\";s:22:\"mail_salutation_female\";s:18:\"Salutation, female\";s:23:\"mail_salutation_general\";s:19:\"Salutation, general\";s:20:\"mail_salutation_male\";s:16:\"Salutation, male\";s:10:\"mail_saved\";s:26:\"The message has been saved\";s:23:\"mail_search_addressbook\";s:22:\"search in address book\";s:18:\"mail_search_system\";s:16:\"search in system\";s:21:\"mail_select_one_entry\";s:25:\"You must select one entry\";s:20:\"mail_select_one_file\";s:24:\"You must select one file\";s:29:\"mail_send_with_system_address\";s:24:\"Send With System Address\";s:16:\"mail_sure_delete\";s:51:\"Are you sure you want to delete the marked mail(s)?\";s:22:\"mail_sure_delete_entry\";s:50:\"Are sure you want to delete the following entries?\";s:21:\"mail_sure_delete_file\";s:36:\"The file will be removed permanently\";s:23:\"mail_sure_delete_folder\";s:55:\"The folder and its contents will be removed permanently\";s:7:\"mail_to\";s:2:\"To\";s:22:\"mail_user_addr_n_valid\";s:44:\"Following users have no valid e-mail address\";s:16:\"mail_empty_trash\";s:11:\"Empty Trash\";s:29:\"mail_empty_trash_confirmation\";s:51:\"Are you sure you want to delete all mails in trash?\";s:30:\"mail_cronjob_notification_info\";s:61:\"You can activate a periodic notification about new mail here.\";s:25:\"mail_received_x_new_mails\";s:26:\"You received %s new mails.\";s:19:\"search_bc_recipient\";s:20:\"Search BCC Recipient\";s:19:\"search_cc_recipient\";s:19:\"Search CC Recipient\";s:12:\"send_mail_to\";s:7:\"Mail to\";s:26:\"mail_no_valid_mailing_list\";s:21:\"No Valid Mailing List\";s:35:\"activate_serial_letter_placeholders\";s:35:\"Activate Serial-Letter Placeholders\";s:19:\"placeholders_advise\";s:130:\"Placeholders are only resolved for recipients in the To field.%sRecipients in the CC and BCC field will get unsolved placeholders.\";s:17:\"search_recipients\";s:17:\"Search Recipients\";s:17:\"mail_list_members\";s:12:\"List members\";s:30:\"mail_members_added_addressbook\";s:28:\"Members added to addressbook\";s:19:\"mail_in_addressbook\";s:22:\"Already in addressbook\";s:26:\"mail_select_only_one_entry\";s:29:\"Please select only one entry.\";s:18:\"mail_select_course\";s:34:\"Please select at least one course.\";s:17:\"mail_select_group\";s:33:\"Please select at least one group.\";s:15:\"mail_my_entries\";s:10:\"My Entries\";s:15:\"mail_my_courses\";s:10:\"My Courses\";s:14:\"mail_my_groups\";s:9:\"My Groups\";s:21:\"mail_my_mailing_lists\";s:16:\"My Mailing Lists\";s:18:\"mail_mailing_lists\";s:13:\"Mailing Lists\";s:17:\"mail_mailing_list\";s:12:\"Mailing List\";s:28:\"mail_members_of_mailing_list\";s:23:\"Members of Mailing List\";s:21:\"mail_into_addressbook\";s:21:\"Take into Addressbook\";s:18:\"mail_group_members\";s:13:\"Group Members\";s:25:\"mail_entry_of_addressbook\";s:21:\"Entry of Address Book\";s:14:\"mail_new_entry\";s:9:\"New Entry\";s:15:\"mail_edit_entry\";s:10:\"Edit Entry\";s:22:\"mail_select_attachment\";s:41:\"Please select an attachment for download.\";s:24:\"advice_mail_body_secured\";s:130:\"Because of security reasons ILIAS removed some elements of your message. Please check the secured message and send the mail again.\";s:24:\"mail_auto_generated_info\";s:72:\"This mail was automatically sent to you by the ILIAS installation %s, %s\";s:28:\"mail_external_sender_noreply\";s:15:\"noreply-Adresse\";s:33:\"info_mail_external_sender_noreply\";s:128:\"Tragen Sie hier die E-Mail Adresse für externe System- oder Benachrichtigungsmails ein, die als Absender verwendet werden soll.\";s:35:\"mail_crs_list_members_not_available\";s:61:\"It is not possible to list the members of the marked courses.\";s:56:\"mail_crs_list_members_not_available_for_at_least_one_crs\";s:62:\"The members of at least one selected course can not be listed.\";}');
INSERT INTO `lng_modules` VALUES ('meta','en','a:596:{s:7:\"md_days\";s:5:\"Days:\";s:9:\"md_months\";s:6:\"Month:\";s:7:\"md_time\";s:5:\"Time:\";s:31:\"meta_accessibility_restrictions\";s:26:\"Accessibility Restrictions\";s:11:\"meta_active\";s:6:\"Active\";s:8:\"meta_add\";s:3:\"Add\";s:15:\"meta_annotation\";s:10:\"Annotation\";s:11:\"meta_atomic\";s:6:\"Atomic\";s:11:\"meta_author\";s:6:\"Author\";s:12:\"meta_browser\";s:7:\"Browser\";s:9:\"meta_c_AD\";s:7:\"Andorra\";s:9:\"meta_c_AE\";s:20:\"United Arab Emirates\";s:9:\"meta_c_AF\";s:11:\"Afghanistan\";s:9:\"meta_c_AG\";s:19:\"Antigua And Barbuda\";s:9:\"meta_c_AI\";s:8:\"Anguilla\";s:9:\"meta_c_AL\";s:7:\"Albania\";s:9:\"meta_c_AM\";s:7:\"Armenia\";s:9:\"meta_c_AN\";s:20:\"Netherlands Antilles\";s:9:\"meta_c_AO\";s:6:\"Angola\";s:9:\"meta_c_AQ\";s:10:\"Antarctica\";s:9:\"meta_c_AR\";s:9:\"Argentina\";s:9:\"meta_c_AS\";s:14:\"American Samoa\";s:9:\"meta_c_AT\";s:7:\"Austria\";s:9:\"meta_c_AU\";s:9:\"Australia\";s:9:\"meta_c_AW\";s:5:\"Aruba\";s:9:\"meta_c_AZ\";s:10:\"Azerbaijan\";s:9:\"meta_c_BA\";s:22:\"Bosnia And Herzegowina\";s:9:\"meta_c_BB\";s:8:\"Barbados\";s:9:\"meta_c_BD\";s:10:\"Bangladesh\";s:9:\"meta_c_BE\";s:7:\"Belgium\";s:9:\"meta_c_BF\";s:12:\"Burkina Faso\";s:9:\"meta_c_BG\";s:8:\"Bulgaria\";s:9:\"meta_c_BH\";s:7:\"Bahrain\";s:9:\"meta_c_BI\";s:7:\"Burundi\";s:9:\"meta_c_BJ\";s:5:\"Benin\";s:9:\"meta_c_BM\";s:7:\"Bermuda\";s:9:\"meta_c_BN\";s:17:\"Brunei Darussalam\";s:9:\"meta_c_BO\";s:7:\"Bolivia\";s:9:\"meta_c_BR\";s:6:\"Brazil\";s:9:\"meta_c_BS\";s:7:\"Bahamas\";s:9:\"meta_c_BT\";s:6:\"Bhutan\";s:9:\"meta_c_BV\";s:13:\"Bouvet Island\";s:9:\"meta_c_BW\";s:8:\"Botswana\";s:9:\"meta_c_BY\";s:7:\"Belarus\";s:9:\"meta_c_BZ\";s:6:\"Belize\";s:9:\"meta_c_CA\";s:6:\"Canada\";s:9:\"meta_c_CC\";s:23:\"Cocos (Keeling) Islands\";s:9:\"meta_c_CF\";s:24:\"Central African Republic\";s:9:\"meta_c_CG\";s:5:\"Congo\";s:9:\"meta_c_CH\";s:11:\"Switzerland\";s:9:\"meta_c_CI\";s:14:\"Cote D\' Ivoire\";s:9:\"meta_c_CK\";s:12:\"Cook Islands\";s:9:\"meta_c_CL\";s:5:\"Chile\";s:9:\"meta_c_CM\";s:8:\"Cameroon\";s:9:\"meta_c_CN\";s:5:\"China\";s:9:\"meta_c_CO\";s:8:\"Colombia\";s:9:\"meta_c_CR\";s:10:\"Costa Rica\";s:9:\"meta_c_CU\";s:4:\"Cuba\";s:9:\"meta_c_CV\";s:10:\"Cape Verde\";s:9:\"meta_c_CX\";s:16:\"Christmas Island\";s:9:\"meta_c_CY\";s:6:\"Cyprus\";s:9:\"meta_c_CZ\";s:14:\"Czech Republic\";s:9:\"meta_c_DE\";s:7:\"Germany\";s:9:\"meta_c_DJ\";s:8:\"Djibouti\";s:9:\"meta_c_DK\";s:7:\"Denmark\";s:9:\"meta_c_DM\";s:8:\"Dominica\";s:9:\"meta_c_DO\";s:18:\"Dominican Republic\";s:9:\"meta_c_DZ\";s:7:\"Algeria\";s:9:\"meta_c_EC\";s:7:\"Ecuador\";s:9:\"meta_c_EE\";s:7:\"Estonia\";s:9:\"meta_c_EG\";s:5:\"Egypt\";s:9:\"meta_c_EH\";s:14:\"Western Sahara\";s:9:\"meta_c_ER\";s:7:\"Eritrea\";s:9:\"meta_c_ES\";s:5:\"Spain\";s:9:\"meta_c_ET\";s:8:\"Ethiopia\";s:9:\"meta_c_FI\";s:7:\"Finland\";s:9:\"meta_c_FJ\";s:4:\"Fiji\";s:9:\"meta_c_FK\";s:16:\"Falkland Islands\";s:9:\"meta_c_FM\";s:10:\"Micronesia\";s:9:\"meta_c_FO\";s:13:\"Faroe Islands\";s:9:\"meta_c_FR\";s:6:\"France\";s:9:\"meta_c_FX\";s:20:\"France, Metropolitan\";s:9:\"meta_c_GA\";s:5:\"Gabon\";s:9:\"meta_c_GB\";s:14:\"United Kingdom\";s:9:\"meta_c_GD\";s:7:\"Grenada\";s:9:\"meta_c_GE\";s:7:\"Giorgia\";s:9:\"meta_c_GF\";s:13:\"French Guiana\";s:9:\"meta_c_GH\";s:5:\"Ghana\";s:9:\"meta_c_GI\";s:9:\"Gibraltar\";s:9:\"meta_c_GL\";s:9:\"Greenland\";s:9:\"meta_c_GM\";s:6:\"Gambia\";s:9:\"meta_c_GN\";s:6:\"Guinea\";s:9:\"meta_c_GP\";s:10:\"Guadeloupe\";s:9:\"meta_c_GQ\";s:17:\"Equatorial Guinea\";s:9:\"meta_c_GR\";s:6:\"Greece\";s:9:\"meta_c_GS\";s:44:\"South Georgia And The South Sandwich Islands\";s:9:\"meta_c_GT\";s:9:\"Guatemala\";s:9:\"meta_c_GU\";s:4:\"Guam\";s:9:\"meta_c_GW\";s:13:\"Guinea-Bissau\";s:9:\"meta_c_GY\";s:6:\"Guyana\";s:9:\"meta_c_HM\";s:27:\"Heard And Nc Donald Islands\";s:9:\"meta_c_HN\";s:8:\"Honduras\";s:9:\"meta_c_HR\";s:7:\"Croatia\";s:9:\"meta_c_HT\";s:5:\"Haiti\";s:9:\"meta_c_HU\";s:7:\"Hungary\";s:9:\"meta_c_ID\";s:9:\"Indonesia\";s:9:\"meta_c_IE\";s:7:\"Ireland\";s:9:\"meta_c_IL\";s:6:\"Israel\";s:9:\"meta_c_IN\";s:5:\"India\";s:9:\"meta_c_IO\";s:30:\"British Indian Ocean Territory\";s:9:\"meta_c_IQ\";s:4:\"Iraq\";s:9:\"meta_c_IR\";s:4:\"Iran\";s:9:\"meta_c_IS\";s:7:\"Iceland\";s:9:\"meta_c_IT\";s:5:\"Italy\";s:9:\"meta_c_JM\";s:7:\"Jamaica\";s:9:\"meta_c_JO\";s:6:\"Jordan\";s:9:\"meta_c_JP\";s:5:\"Japan\";s:9:\"meta_c_KE\";s:5:\"Kenya\";s:9:\"meta_c_KG\";s:10:\"Kyrgyzstan\";s:9:\"meta_c_KH\";s:8:\"Cambodia\";s:9:\"meta_c_KI\";s:8:\"Kiribati\";s:9:\"meta_c_KM\";s:7:\"Comoros\";s:9:\"meta_c_KN\";s:21:\"Saint Kitts And Nevis\";s:9:\"meta_c_KP\";s:40:\"North Korea (People\'s Republic Of Korea)\";s:9:\"meta_c_KR\";s:31:\"South Korea (Republic Of Korea)\";s:9:\"meta_c_KW\";s:6:\"Kuwait\";s:9:\"meta_c_KY\";s:14:\"Cayman Islands\";s:9:\"meta_c_KZ\";s:10:\"Kazakhstan\";s:9:\"meta_c_LA\";s:21:\"Lao People\'s Republic\";s:9:\"meta_c_LB\";s:7:\"Lebanon\";s:9:\"meta_c_LC\";s:11:\"Saint Lucia\";s:9:\"meta_c_LI\";s:13:\"Liechtenstein\";s:9:\"meta_c_LK\";s:9:\"Sri Lanka\";s:9:\"meta_c_LR\";s:7:\"Liberia\";s:9:\"meta_c_LS\";s:7:\"Lesotho\";s:9:\"meta_c_LT\";s:8:\"Lithunia\";s:9:\"meta_c_LU\";s:10:\"Luxembourg\";s:9:\"meta_c_LV\";s:6:\"Latvia\";s:9:\"meta_c_LY\";s:22:\"Libyan Arab Jamahiriya\";s:9:\"meta_c_MA\";s:7:\"Morocco\";s:9:\"meta_c_MC\";s:6:\"Monaco\";s:9:\"meta_c_MD\";s:7:\"Moldova\";s:9:\"meta_c_MG\";s:10:\"Madagascar\";s:9:\"meta_c_MH\";s:16:\"Marshall Islands\";s:9:\"meta_c_MK\";s:9:\"Macedonia\";s:9:\"meta_c_ML\";s:4:\"Mali\";s:9:\"meta_c_MM\";s:7:\"Myanmar\";s:9:\"meta_c_MN\";s:8:\"Mongolia\";s:9:\"meta_c_MO\";s:5:\"Macau\";s:9:\"meta_c_MP\";s:24:\"Northern Mariana Islands\";s:9:\"meta_c_MQ\";s:10:\"Martinique\";s:9:\"meta_c_MR\";s:10:\"Mauritania\";s:9:\"meta_c_MS\";s:10:\"Montserrat\";s:9:\"meta_c_MT\";s:5:\"Malta\";s:9:\"meta_c_MU\";s:9:\"Mauritius\";s:9:\"meta_c_MV\";s:8:\"Maldives\";s:9:\"meta_c_MW\";s:6:\"Malawi\";s:9:\"meta_c_MX\";s:6:\"Mexico\";s:9:\"meta_c_MY\";s:8:\"Malaysia\";s:9:\"meta_c_MZ\";s:10:\"Mozambique\";s:9:\"meta_c_NA\";s:7:\"Namibia\";s:9:\"meta_c_NC\";s:13:\"New Caledonia\";s:9:\"meta_c_NE\";s:5:\"Niger\";s:9:\"meta_c_NF\";s:14:\"Norfolk Island\";s:9:\"meta_c_NG\";s:7:\"Nigeria\";s:9:\"meta_c_NI\";s:9:\"Nicaragua\";s:9:\"meta_c_NL\";s:11:\"Netherlands\";s:9:\"meta_c_NO\";s:6:\"Norway\";s:9:\"meta_c_NP\";s:5:\"Nepal\";s:9:\"meta_c_NR\";s:5:\"Nauru\";s:9:\"meta_c_NU\";s:4:\"Niue\";s:9:\"meta_c_NZ\";s:11:\"New Zealand\";s:9:\"meta_c_OM\";s:4:\"Oman\";s:9:\"meta_c_PA\";s:6:\"Panama\";s:9:\"meta_c_PE\";s:4:\"Peru\";s:9:\"meta_c_PF\";s:16:\"French Polynesia\";s:9:\"meta_c_PG\";s:16:\"Papua New Guinea\";s:9:\"meta_c_PH\";s:11:\"Philippines\";s:9:\"meta_c_PK\";s:8:\"Pakistan\";s:9:\"meta_c_PL\";s:6:\"Poland\";s:9:\"meta_c_PM\";s:23:\"St. Pierre And Miquelon\";s:9:\"meta_c_PN\";s:8:\"Pitcairn\";s:9:\"meta_c_PR\";s:11:\"Puerto Rico\";s:9:\"meta_c_PT\";s:8:\"Portugal\";s:9:\"meta_c_PW\";s:5:\"Palau\";s:9:\"meta_c_PY\";s:8:\"Paraguay\";s:9:\"meta_c_QA\";s:5:\"Qatar\";s:9:\"meta_c_RE\";s:7:\"Reunion\";s:9:\"meta_c_RO\";s:7:\"Romania\";s:9:\"meta_c_RU\";s:14:\"Ran Federation\";s:9:\"meta_c_RW\";s:6:\"Rwanda\";s:9:\"meta_c_SA\";s:12:\"Saudi Arabia\";s:9:\"meta_c_SB\";s:15:\"Solomon Islands\";s:9:\"meta_c_SC\";s:10:\"Seychelles\";s:9:\"meta_c_SD\";s:5:\"Sudan\";s:9:\"meta_c_SE\";s:6:\"Sweden\";s:9:\"meta_c_SG\";s:9:\"Singapore\";s:9:\"meta_c_SH\";s:10:\"St. Helena\";s:9:\"meta_c_SI\";s:8:\"Slovenia\";s:9:\"meta_c_SJ\";s:30:\"Svalbard And Jan Mayen Islands\";s:9:\"meta_c_SK\";s:8:\"Slovakia\";s:9:\"meta_c_SL\";s:13:\"Siearra Leone\";s:9:\"meta_c_SM\";s:10:\"San Marino\";s:9:\"meta_c_SN\";s:7:\"Senegal\";s:9:\"meta_c_SO\";s:7:\"Somalia\";s:9:\"meta_c_SR\";s:8:\"Suriname\";s:9:\"meta_c_ST\";s:21:\"Sao Tome And Principe\";s:9:\"meta_c_SV\";s:11:\"El Salvador\";s:9:\"meta_c_SY\";s:20:\"Syrian Arab Republic\";s:9:\"meta_c_SZ\";s:9:\"Swaziland\";s:9:\"meta_c_TC\";s:24:\"Turks And Caicos Islands\";s:9:\"meta_c_TD\";s:4:\"Chad\";s:9:\"meta_c_TF\";s:27:\"French Southern Territories\";s:9:\"meta_c_TG\";s:4:\"Togo\";s:9:\"meta_c_TH\";s:8:\"Thailand\";s:9:\"meta_c_TJ\";s:10:\"Tajikistan\";s:9:\"meta_c_TK\";s:7:\"Tokelau\";s:9:\"meta_c_TM\";s:12:\"Turkmenistan\";s:9:\"meta_c_TN\";s:7:\"Tunisia\";s:9:\"meta_c_TO\";s:5:\"Tonga\";s:9:\"meta_c_TP\";s:10:\"East Timor\";s:9:\"meta_c_TR\";s:6:\"Turkey\";s:9:\"meta_c_TT\";s:19:\"Trinidad And Tobago\";s:9:\"meta_c_TV\";s:6:\"Tuvalu\";s:9:\"meta_c_TW\";s:6:\"Taiwan\";s:9:\"meta_c_TZ\";s:8:\"Tanzania\";s:9:\"meta_c_UA\";s:7:\"Ukraine\";s:9:\"meta_c_UG\";s:6:\"Uganda\";s:9:\"meta_c_UM\";s:27:\"U.S. Minor Outlying Islands\";s:9:\"meta_c_US\";s:5:\"U.S.A\";s:9:\"meta_c_UY\";s:7:\"Uruguay\";s:9:\"meta_c_UZ\";s:10:\"Uzbekistan\";s:9:\"meta_c_VA\";s:18:\"Vatican City State\";s:9:\"meta_c_VC\";s:32:\"Saint Vincent And The Grenadines\";s:9:\"meta_c_VE\";s:9:\"Venezuela\";s:9:\"meta_c_VG\";s:24:\"Virgin Islands (British)\";s:9:\"meta_c_VI\";s:19:\"Virgin Islands (US)\";s:9:\"meta_c_VN\";s:8:\"Viet Nam\";s:9:\"meta_c_VU\";s:7:\"Vanuatu\";s:9:\"meta_c_WF\";s:25:\"Wallis And Futuna Islands\";s:9:\"meta_c_WS\";s:5:\"Samoa\";s:9:\"meta_c_YE\";s:5:\"Yemen\";s:9:\"meta_c_YT\";s:7:\"Mayotte\";s:9:\"meta_c_ZA\";s:12:\"South Africa\";s:9:\"meta_c_ZM\";s:6:\"Zambia\";s:9:\"meta_c_ZR\";s:5:\"Zaire\";s:9:\"meta_c_ZW\";s:8:\"Zimbabwe\";s:9:\"meta_c_ZZ\";s:13:\"Other Country\";s:12:\"meta_catalog\";s:7:\"Catalog\";s:19:\"meta_choose_element\";s:41:\"Please choose an element you want to add!\";s:20:\"meta_choose_language\";s:24:\"Please choose a language\";s:19:\"meta_choose_section\";s:23:\"Please choose a section\";s:19:\"meta_classification\";s:14:\"Classification\";s:15:\"meta_collection\";s:10:\"Collection\";s:15:\"meta_competency\";s:10:\"Competency\";s:20:\"meta_contentprovider\";s:16:\"Content provider\";s:12:\"meta_context\";s:7:\"Context\";s:15:\"meta_contribute\";s:10:\"Contribute\";s:14:\"meta_copyright\";s:9:\"Copyright\";s:37:\"meta_copyright_and_other_restrictions\";s:32:\"Copyright and Other Restrictions\";s:9:\"meta_cost\";s:4:\"Cost\";s:13:\"meta_coverage\";s:8:\"Coverage\";s:12:\"meta_creator\";s:7:\"Creator\";s:18:\"meta_current_value\";s:13:\"Current value\";s:9:\"meta_date\";s:4:\"Date\";s:11:\"meta_delete\";s:6:\"Delete\";s:16:\"meta_description\";s:11:\"Description\";s:13:\"meta_diagramm\";s:7:\"Diagram\";s:14:\"meta_difficult\";s:9:\"Difficult\";s:15:\"meta_difficulty\";s:10:\"Difficulty\";s:10:\"meta_draft\";s:5:\"Draft\";s:13:\"meta_duration\";s:8:\"Duration\";s:9:\"meta_easy\";s:4:\"Easy\";s:11:\"meta_editor\";s:6:\"Editor\";s:14:\"meta_education\";s:9:\"Education\";s:16:\"meta_educational\";s:11:\"Educational\";s:22:\"meta_educational_level\";s:17:\"Educational Level\";s:26:\"meta_educational_objective\";s:21:\"Educational Objective\";s:25:\"meta_educationalvalidator\";s:21:\"Educational validator\";s:11:\"meta_entity\";s:6:\"Entity\";s:10:\"meta_entry\";s:5:\"Entry\";s:9:\"meta_exam\";s:4:\"Exam\";s:13:\"meta_exercise\";s:8:\"Exercise\";s:15:\"meta_experiment\";s:10:\"Experiment\";s:15:\"meta_expositive\";s:10:\"Expositive\";s:11:\"meta_figure\";s:6:\"Figure\";s:10:\"meta_final\";s:5:\"Final\";s:11:\"meta_format\";s:6:\"Format\";s:12:\"meta_general\";s:7:\"General\";s:10:\"meta_graph\";s:5:\"Graph\";s:22:\"meta_graphicaldesigner\";s:18:\"Graphical designer\";s:15:\"meta_has_format\";s:10:\"Has Format\";s:13:\"meta_has_part\";s:8:\"Has Part\";s:16:\"meta_has_version\";s:11:\"Has Version\";s:17:\"meta_hierarchical\";s:12:\"Hierarchical\";s:9:\"meta_high\";s:4:\"High\";s:21:\"meta_higher_education\";s:16:\"Higher Education\";s:7:\"meta_id\";s:2:\"Id\";s:9:\"meta_idea\";s:4:\"Idea\";s:15:\"meta_identifier\";s:10:\"Identifier\";s:10:\"meta_index\";s:5:\"Index\";s:23:\"meta_info_tlt_not_valid\";s:176:\"The current value is not valid. Therefore it can not be used other sections, e.g for learning progress statistics. Please insert atypical learning time in hours and/or minutes.\";s:14:\"meta_initiator\";s:9:\"Initiator\";s:25:\"meta_installation_remarks\";s:20:\"Installation Remarks\";s:27:\"meta_instructional_designer\";s:22:\"Instructional designer\";s:26:\"meta_instructionaldesigner\";s:22:\"Instructional designer\";s:27:\"meta_intended_end_user_role\";s:22:\"Intended End User Role\";s:24:\"meta_interactivity_level\";s:19:\"Interactivity Level\";s:23:\"meta_interactivity_type\";s:18:\"Interactivity Type\";s:16:\"meta_is_based_on\";s:11:\"Is Based On\";s:17:\"meta_is_basis_for\";s:12:\"Is Basis For\";s:17:\"meta_is_format_of\";s:12:\"Is Format Of\";s:15:\"meta_is_part_of\";s:10:\"Is Part Of\";s:21:\"meta_is_referenced_by\";s:16:\"Is Referenced By\";s:19:\"meta_is_required_by\";s:14:\"Is Required By\";s:18:\"meta_is_version_of\";s:13:\"Is Version Of\";s:12:\"meta_keyword\";s:7:\"Keyword\";s:9:\"meta_kind\";s:4:\"Kind\";s:9:\"meta_l_aa\";s:4:\"Afar\";s:9:\"meta_l_ab\";s:9:\"Abkhazian\";s:9:\"meta_l_af\";s:9:\"Afrikaans\";s:9:\"meta_l_am\";s:7:\"Amharic\";s:9:\"meta_l_ar\";s:6:\"Arabic\";s:9:\"meta_l_as\";s:8:\"Assamese\";s:9:\"meta_l_ay\";s:6:\"Aymara\";s:9:\"meta_l_az\";s:11:\"Azerbaijani\";s:9:\"meta_l_ba\";s:7:\"Bashkir\";s:9:\"meta_l_be\";s:12:\"Byelorussian\";s:9:\"meta_l_bg\";s:9:\"Bulgarian\";s:9:\"meta_l_bh\";s:6:\"Bihari\";s:9:\"meta_l_bi\";s:7:\"Bislama\";s:9:\"meta_l_bn\";s:14:\"Bengali;bangla\";s:9:\"meta_l_bo\";s:7:\"Tibetan\";s:9:\"meta_l_br\";s:6:\"Breton\";s:9:\"meta_l_ca\";s:7:\"Catalan\";s:9:\"meta_l_co\";s:8:\"Corsican\";s:9:\"meta_l_cs\";s:5:\"Czech\";s:9:\"meta_l_cy\";s:5:\"Welsh\";s:9:\"meta_l_da\";s:6:\"Danish\";s:9:\"meta_l_de\";s:6:\"German\";s:9:\"meta_l_dz\";s:7:\"Bhutani\";s:9:\"meta_l_el\";s:5:\"Greek\";s:9:\"meta_l_en\";s:7:\"English\";s:9:\"meta_l_eo\";s:9:\"Esperanto\";s:9:\"meta_l_es\";s:7:\"Spanish\";s:9:\"meta_l_et\";s:8:\"Estonian\";s:9:\"meta_l_eu\";s:6:\"Basque\";s:9:\"meta_l_fa\";s:15:\"Persian (farsi)\";s:9:\"meta_l_fi\";s:7:\"Finnish\";s:9:\"meta_l_fj\";s:4:\"Fiji\";s:9:\"meta_l_fo\";s:7:\"Faroese\";s:9:\"meta_l_fr\";s:6:\"French\";s:9:\"meta_l_fy\";s:7:\"Frisian\";s:9:\"meta_l_ga\";s:5:\"Irish\";s:9:\"meta_l_gd\";s:12:\"Scots gaelic\";s:9:\"meta_l_gl\";s:8:\"Galician\";s:9:\"meta_l_gn\";s:7:\"Guarani\";s:9:\"meta_l_gu\";s:8:\"Gujarati\";s:9:\"meta_l_ha\";s:5:\"Hausa\";s:9:\"meta_l_he\";s:6:\"Hebrew\";s:9:\"meta_l_hi\";s:5:\"Hindi\";s:9:\"meta_l_hr\";s:8:\"Croatian\";s:9:\"meta_l_hu\";s:9:\"Hungarian\";s:9:\"meta_l_hy\";s:8:\"Armenian\";s:9:\"meta_l_ia\";s:11:\"Interlingua\";s:9:\"meta_l_id\";s:10:\"Indonesian\";s:9:\"meta_l_ie\";s:11:\"Interlingue\";s:9:\"meta_l_ik\";s:7:\"Inupiak\";s:9:\"meta_l_is\";s:9:\"Icelandic\";s:9:\"meta_l_it\";s:7:\"Italian\";s:9:\"meta_l_iu\";s:9:\"Inuktitut\";s:9:\"meta_l_ja\";s:8:\"Japanese\";s:9:\"meta_l_jv\";s:8:\"Javanese\";s:9:\"meta_l_ka\";s:8:\"Georgian\";s:9:\"meta_l_kk\";s:6:\"Kazakh\";s:9:\"meta_l_kl\";s:11:\"Greenlandic\";s:9:\"meta_l_km\";s:9:\"Cambodian\";s:9:\"meta_l_kn\";s:7:\"Kannada\";s:9:\"meta_l_ko\";s:6:\"Korean\";s:9:\"meta_l_ks\";s:8:\"Kashmiri\";s:9:\"meta_l_ku\";s:7:\"Kurdish\";s:9:\"meta_l_ky\";s:7:\"Kirghiz\";s:9:\"meta_l_la\";s:5:\"Latin\";s:9:\"meta_l_ln\";s:7:\"Lingala\";s:9:\"meta_l_lo\";s:8:\"Laothian\";s:9:\"meta_l_lt\";s:10:\"Lithuanian\";s:9:\"meta_l_lv\";s:15:\"Latvian;lettish\";s:9:\"meta_l_mg\";s:8:\"Malagasy\";s:9:\"meta_l_mi\";s:5:\"Maori\";s:9:\"meta_l_mk\";s:10:\"Macedonian\";s:9:\"meta_l_ml\";s:9:\"Malayalam\";s:9:\"meta_l_mn\";s:9:\"Mongolian\";s:9:\"meta_l_mo\";s:9:\"Moldavian\";s:9:\"meta_l_mr\";s:7:\"Marathi\";s:9:\"meta_l_ms\";s:5:\"Malay\";s:9:\"meta_l_mt\";s:7:\"Maltese\";s:9:\"meta_l_my\";s:7:\"Burmese\";s:9:\"meta_l_na\";s:5:\"Nauru\";s:9:\"meta_l_ne\";s:6:\"Nepali\";s:9:\"meta_l_nl\";s:5:\"Dutch\";s:9:\"meta_l_no\";s:9:\"Norwegian\";s:9:\"meta_l_oc\";s:7:\"Occitan\";s:9:\"meta_l_om\";s:12:\"Afan (oromo)\";s:9:\"meta_l_or\";s:5:\"Oriya\";s:9:\"meta_l_pa\";s:7:\"Punjabi\";s:9:\"meta_l_pl\";s:6:\"Polish\";s:9:\"meta_l_ps\";s:13:\"Pashto;pushto\";s:9:\"meta_l_pt\";s:10:\"Portuguese\";s:9:\"meta_l_qu\";s:7:\"Quechua\";s:9:\"meta_l_rm\";s:14:\"Rhaeto-romance\";s:9:\"meta_l_rn\";s:7:\"Kurundi\";s:9:\"meta_l_ro\";s:8:\"Romanian\";s:9:\"meta_l_ru\";s:7:\"Russian\";s:9:\"meta_l_rw\";s:11:\"Kinyarwanda\";s:9:\"meta_l_sa\";s:8:\"Sanskrit\";s:9:\"meta_l_sd\";s:6:\"Sindhi\";s:9:\"meta_l_sg\";s:6:\"Sangho\";s:9:\"meta_l_sh\";s:14:\"Serbo-croatian\";s:9:\"meta_l_si\";s:10:\"Singhalese\";s:9:\"meta_l_sk\";s:6:\"Slovak\";s:9:\"meta_l_sl\";s:9:\"Slovenian\";s:9:\"meta_l_sm\";s:6:\"Samoan\";s:9:\"meta_l_sn\";s:5:\"Shona\";s:9:\"meta_l_so\";s:6:\"Somali\";s:9:\"meta_l_sq\";s:8:\"Albanian\";s:9:\"meta_l_sr\";s:7:\"Serbian\";s:9:\"meta_l_ss\";s:7:\"Siswati\";s:9:\"meta_l_st\";s:7:\"Sesotho\";s:9:\"meta_l_su\";s:9:\"Sundanese\";s:9:\"meta_l_sv\";s:7:\"Swedish\";s:9:\"meta_l_sw\";s:7:\"Swahili\";s:9:\"meta_l_ta\";s:5:\"Tamil\";s:9:\"meta_l_te\";s:6:\"Telugu\";s:9:\"meta_l_tg\";s:5:\"Tajik\";s:9:\"meta_l_th\";s:4:\"Thai\";s:9:\"meta_l_ti\";s:8:\"Tigrinya\";s:9:\"meta_l_tk\";s:7:\"Turkmen\";s:9:\"meta_l_tl\";s:7:\"Tagalog\";s:9:\"meta_l_tn\";s:8:\"Setswana\";s:9:\"meta_l_to\";s:5:\"Tonga\";s:9:\"meta_l_tr\";s:7:\"Turkish\";s:9:\"meta_l_ts\";s:6:\"Tsonga\";s:9:\"meta_l_tt\";s:5:\"Tatar\";s:9:\"meta_l_tw\";s:3:\"Twi\";s:9:\"meta_l_ug\";s:5:\"Uigur\";s:9:\"meta_l_uk\";s:9:\"Ukrainian\";s:9:\"meta_l_ur\";s:4:\"Urdu\";s:9:\"meta_l_uz\";s:5:\"Uzbek\";s:9:\"meta_l_vi\";s:10:\"Vietnamese\";s:9:\"meta_l_vo\";s:7:\"Volapuk\";s:9:\"meta_l_wo\";s:5:\"Wolof\";s:9:\"meta_l_xh\";s:5:\"Xhosa\";s:9:\"meta_l_yi\";s:7:\"Yiddish\";s:9:\"meta_l_yo\";s:6:\"Yoruba\";s:9:\"meta_l_za\";s:6:\"Zhuang\";s:9:\"meta_l_zh\";s:7:\"Chinese\";s:9:\"meta_l_zu\";s:4:\"Zulu\";s:13:\"meta_language\";s:8:\"Language\";s:12:\"meta_learner\";s:7:\"Learner\";s:27:\"meta_learning_resource_type\";s:22:\"Learning Resource Type\";s:12:\"meta_lecture\";s:7:\"Lecture\";s:14:\"meta_lifecycle\";s:9:\"Lifecycle\";s:11:\"meta_linear\";s:6:\"Linear\";s:15:\"meta_local_file\";s:10:\"Local File\";s:13:\"meta_location\";s:8:\"Location\";s:8:\"meta_low\";s:3:\"Low\";s:11:\"meta_mac_os\";s:5:\"MacOS\";s:12:\"meta_manager\";s:7:\"Manager\";s:20:\"meta_maximum_version\";s:15:\"Maximum Version\";s:11:\"meta_medium\";s:6:\"Medium\";s:18:\"meta_meta_metadata\";s:13:\"Meta-Metadata\";s:19:\"meta_metadatascheme\";s:15:\"Metadata Scheme\";s:20:\"meta_minimum_version\";s:15:\"Minimum Version\";s:10:\"meta_mixed\";s:5:\"Mixed\";s:15:\"meta_ms_windows\";s:10:\"MS-Windows\";s:13:\"meta_multi_os\";s:8:\"Multi-OS\";s:9:\"meta_name\";s:4:\"Name\";s:19:\"meta_narrative_text\";s:14:\"Narrative Text\";s:14:\"meta_networked\";s:9:\"Networked\";s:16:\"meta_new_element\";s:11:\"New Element\";s:7:\"meta_no\";s:2:\"No\";s:18:\"meta_no_annotation\";s:49:\"No metadata available for the Annotation section.\";s:22:\"meta_no_classification\";s:53:\"No metadata available for the Classification section.\";s:19:\"meta_no_educational\";s:50:\"No metadata available for the Educational section.\";s:17:\"meta_no_lifecycle\";s:48:\"No metadata available for the Lifecycle section.\";s:21:\"meta_no_meta_metadata\";s:52:\"No metadata available for the Meta-Metadata section.\";s:16:\"meta_no_relation\";s:47:\"No metadata available for the Relation section.\";s:14:\"meta_no_rights\";s:45:\"No metadata available for the Rights section.\";s:17:\"meta_no_technical\";s:48:\"No metadata available for the Technical section.\";s:9:\"meta_none\";s:4:\"None\";s:21:\"meta_operating_system\";s:16:\"Operating System\";s:17:\"meta_or_composite\";s:12:\"Or Composite\";s:10:\"meta_other\";s:5:\"Other\";s:33:\"meta_other_plattform_requirements\";s:27:\"Other Platform Requirements\";s:11:\"meta_pc_dos\";s:6:\"PC-DOS\";s:18:\"meta_please_select\";s:13:\"Please select\";s:17:\"meta_prerequisite\";s:12:\"Prerequisite\";s:22:\"meta_problem_statement\";s:17:\"Problem Statement\";s:14:\"meta_publisher\";s:9:\"Publisher\";s:12:\"meta_purpose\";s:7:\"Purpose\";s:18:\"meta_questionnaire\";s:13:\"Questionnaire\";s:14:\"meta_quickedit\";s:10:\"Quick Edit\";s:14:\"meta_reference\";s:9:\"Reference\";s:15:\"meta_references\";s:10:\"References\";s:13:\"meta_relation\";s:8:\"Relation\";s:16:\"meta_requirement\";s:11:\"Requirement\";s:13:\"meta_requires\";s:8:\"Requires\";s:13:\"meta_resource\";s:8:\"Resource\";s:12:\"meta_revised\";s:7:\"Revised\";s:11:\"meta_rights\";s:6:\"Rights\";s:9:\"meta_role\";s:4:\"Role\";s:11:\"meta_school\";s:6:\"School\";s:17:\"meta_scriptwriter\";s:12:\"Scriptwriter\";s:19:\"meta_security_level\";s:14:\"Security Level\";s:20:\"meta_self_assessment\";s:15:\"Self Assessment\";s:21:\"meta_semantic_density\";s:16:\"Semantic Density\";s:15:\"meta_simulation\";s:10:\"Simulation\";s:9:\"meta_size\";s:4:\"Size\";s:16:\"meta_skill_level\";s:11:\"Skill Level\";s:10:\"meta_slide\";s:5:\"Slide\";s:11:\"meta_source\";s:6:\"Source\";s:11:\"meta_status\";s:6:\"Status\";s:14:\"meta_structure\";s:9:\"Structure\";s:24:\"meta_subjectmatterexpert\";s:21:\"Subject matter expert\";s:10:\"meta_table\";s:5:\"Table\";s:10:\"meta_taxon\";s:5:\"Taxon\";s:15:\"meta_taxon_path\";s:10:\"Taxon Path\";s:12:\"meta_teacher\";s:7:\"Teacher\";s:14:\"meta_technical\";s:9:\"Technical\";s:25:\"meta_technicalimplementer\";s:21:\"Technical implementer\";s:23:\"meta_technicalvalidator\";s:19:\"Technical validator\";s:15:\"meta_terminator\";s:10:\"Terminator\";s:10:\"meta_title\";s:5:\"Title\";s:13:\"meta_training\";s:8:\"Training\";s:9:\"meta_type\";s:4:\"Type\";s:22:\"meta_typical_age_range\";s:17:\"Typical Age Range\";s:26:\"meta_typical_learning_time\";s:21:\"Typical Learning Time\";s:16:\"meta_unavailable\";s:11:\"Unavailable\";s:9:\"meta_unix\";s:4:\"Unix\";s:12:\"meta_unknown\";s:7:\"Unknown\";s:14:\"meta_validator\";s:9:\"Validator\";s:10:\"meta_value\";s:5:\"Value\";s:12:\"meta_version\";s:7:\"Version\";s:19:\"meta_very_difficult\";s:14:\"Very Difficult\";s:14:\"meta_very_easy\";s:9:\"Very Easy\";s:14:\"meta_very_high\";s:9:\"Very High\";s:13:\"meta_very_low\";s:8:\"Very Low\";s:8:\"meta_yes\";s:3:\"Yes\";s:11:\"md_advanced\";s:17:\"Advanced Metadata\";s:18:\"md_adv_record_list\";s:25:\"Datasets and Presentation\";s:16:\"md_adv_file_list\";s:12:\"Export Files\";s:20:\"md_record_list_table\";s:23:\"Available Metadata Sets\";s:9:\"md_fields\";s:6:\"Fields\";s:12:\"md_obj_types\";s:16:\"Assigned Objects\";s:25:\"md_adv_substitution_table\";s:47:\"Presentation in the Repository/Personal Desktop\";s:19:\"md_adv_substitution\";s:4:\"Text\";s:19:\"md_adv_placeholders\";s:12:\"Placeholders\";s:22:\"md_adv_placeholder_for\";s:16:\"Placeholder for:\";s:22:\"md_record_export_table\";s:12:\"Export Files\";s:14:\"md_adv_records\";s:17:\"Included Datasets\";s:22:\"md_adv_select_one_file\";s:23:\"Please choose one file.\";s:24:\"md_adv_delete_files_sure\";s:57:\"Do you really want to delete the following export  files?\";s:20:\"md_adv_deleted_files\";s:21:\"Deleted export files.\";s:23:\"md_adv_records_exported\";s:35:\"A new export file has been created.\";s:18:\"md_adv_edit_record\";s:12:\"Edit Dataset\";s:18:\"md_adv_field_table\";s:11:\"Edit Fields\";s:19:\"md_adv_field_fields\";s:6:\"Fields\";s:17:\"md_adv_searchable\";s:10:\"Searchable\";s:17:\"md_adv_edit_field\";s:10:\"Edit Field\";s:19:\"md_adv_create_field\";s:9:\"New Field\";s:16:\"md_adv_add_value\";s:9:\"Add Value\";s:16:\"md_adv_no_fields\";s:17:\"No Fields Defined\";s:22:\"md_adv_deleted_records\";s:15:\"Deleted Dataset\";s:25:\"md_adv_delete_fields_sure\";s:61:\"Do you really want to delete the following field definitions?\";s:23:\"md_adv_added_new_record\";s:17:\"Added new dataset\";s:20:\"md_adv_create_record\";s:11:\"New Dataset\";s:25:\"md_adv_delete_record_sure\";s:48:\"Do really want to delete the following datasets?\";s:13:\"md_adv_active\";s:6:\"Active\";s:21:\"md_copyright_settings\";s:18:\"Copyright Settings\";s:20:\"md_copyright_enabled\";s:26:\"Enable Copyright Selection\";s:22:\"md_copyright_selection\";s:21:\"Copyright Presettings\";s:7:\"md_used\";s:5:\"Usage\";s:20:\"md_copyright_preview\";s:19:\"Copyright (Preview)\";s:17:\"md_copyright_edit\";s:25:\"Edit Copyright Presetting\";s:18:\"md_copyright_value\";s:9:\"Copyright\";s:16:\"md_copyright_add\";s:24:\"Add Copyright Presetting\";s:17:\"md_delete_cp_sure\";s:52:\"Do you really want to delete the following entries ?\";s:21:\"md_copyrights_deleted\";s:17:\"Deleted Copyright\";s:11:\"meta_cp_own\";s:26:\"Own Copyright Information:\";s:16:\"md_adv_desc_show\";s:16:\"Show Description\";s:11:\"md_adv_show\";s:4:\"Show\";s:20:\"md_adv_import_record\";s:19:\"Import Metadata Set\";s:12:\"md_copyright\";s:9:\"Copyright\";s:24:\"md_copyright_enable_info\";s:65:\"Choose this option to offer a selection of predefined copyrights.\";s:18:\"md_adv_field_names\";s:11:\"Field Names\";s:18:\"md_adv_fields_show\";s:16:\"Show Field Names\";}');
INSERT INTO `lng_modules` VALUES ('payment','en','a:344:{s:13:\"currency_cent\";s:4:\"Cent\";s:13:\"currency_euro\";s:4:\"Euro\";s:8:\"duration\";s:8:\"Duration\";s:12:\"excel_export\";s:12:\"Excel export\";s:4:\"info\";s:33:\"Informations about the pay method\";s:24:\"pay_add_to_shopping_cart\";s:20:\"Add to shopping cart\";s:26:\"pay_added_to_shopping_cart\";s:28:\"Added item to shopping cart.\";s:7:\"pay_all\";s:3:\"All\";s:11:\"pay_article\";s:7:\"Article\";s:13:\"pay_bank_data\";s:9:\"Bank data\";s:11:\"pay_bill_no\";s:11:\"Incoice no.\";s:22:\"pay_bmf_account_holder\";s:14:\"Account holder\";s:22:\"pay_bmf_account_number\";s:14:\"Account number\";s:12:\"pay_bmf_back\";s:4:\"back\";s:17:\"pay_bmf_bank_code\";s:9:\"Bank code\";s:19:\"pay_bmf_card_holder\";s:11:\"Card holder\";s:19:\"pay_bmf_card_number\";s:11:\"Card number\";s:20:\"pay_bmf_check_number\";s:12:\"Check number\";s:30:\"pay_bmf_check_terms_conditions\";s:71:\"Please confirm that you\'ve read the terms and conditions and accept it.\";s:19:\"pay_bmf_credit_card\";s:11:\"Credit card\";s:24:\"pay_bmf_credit_card_data\";s:11:\"Credit card\";s:29:\"pay_bmf_credit_card_not_valid\";s:110:\"The credit card data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly.\";s:19:\"pay_bmf_debit_entry\";s:39:\"Debit entry (german bank accounts only)\";s:24:\"pay_bmf_debit_entry_data\";s:11:\"Debit entry\";s:29:\"pay_bmf_debit_entry_not_valid\";s:110:\"The debit entry data you\'ve entered isn\'t valid. Please check out whether all fields are filled out correctly.\";s:31:\"pay_bmf_description_credit_card\";s:249:\"Please check out whether all articles you would like to order are in the shopping cart. By filling in your credit card data and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds.\";s:31:\"pay_bmf_description_debit_entry\";s:257:\"Please check out whether all articles you would like to order are in the shopping cart. By filling in your data for the debit entry and clicking the \"Save\"-button you confirm your wish to order, that starts immediately. The data check may take some seconds.\";s:32:\"pay_bmf_description_payment_type\";s:25:\"Please select how to pay.\";s:33:\"pay_bmf_description_personal_data\";s:46:\"Please fill out the following form completely.\";s:20:\"pay_bmf_house_number\";s:12:\"House number\";s:16:\"pay_bmf_optional\";s:8:\"optional\";s:10:\"pay_bmf_or\";s:2:\"or\";s:26:\"pay_bmf_password_not_valid\";s:27:\"Your password wasn\'t valid.\";s:20:\"pay_bmf_payment_type\";s:14:\"Kind of paying\";s:30:\"pay_bmf_payment_type_not_valid\";s:76:\"The kind of paying you\'ve choosen isn\'t valid. Please select another option.\";s:21:\"pay_bmf_personal_data\";s:18:\"Your personal data\";s:31:\"pay_bmf_personal_data_not_valid\";s:93:\"Your personal data isn\'t valid. Please check out whether all fields are filled out correctly.\";s:21:\"pay_bmf_please_select\";s:13:\"Please select\";s:14:\"pay_bmf_po_box\";s:6:\"PO Box\";s:25:\"pay_bmf_server_error_code\";s:33:\"Payment server returns error code\";s:34:\"pay_bmf_server_error_communication\";s:46:\"Error while communictaion with payment server.\";s:29:\"pay_bmf_server_error_sysadmin\";s:60:\"Please contact system administrator for further information.\";s:27:\"pay_bmf_shopping_cart_empty\";s:28:\"Your shopping card is empty.\";s:23:\"pay_bmf_street_or_pobox\";s:47:\"Please enter street and house number or po box.\";s:24:\"pay_bmf_terms_conditions\";s:28:\"General terms and conditions\";s:29:\"pay_bmf_terms_conditions_read\";s:57:\"I\'ve read the general terms and conditions and accept it.\";s:29:\"pay_bmf_terms_conditions_show\";s:4:\"show\";s:14:\"pay_bmf_thanks\";s:36:\"Thank you. Your order was submitted.\";s:20:\"pay_bmf_total_amount\";s:12:\"Total amount\";s:23:\"pay_bmf_subtotal_amount\";s:15:\"Subtotal amount\";s:16:\"pay_bmf_validity\";s:11:\"valid until\";s:20:\"pay_bmf_vat_included\";s:12:\"VAT included\";s:18:\"pay_bmf_your_order\";s:10:\"Your order\";s:16:\"pay_change_price\";s:33:\"Change price/duration combination\";s:16:\"pay_click_to_buy\";s:7:\"Buy now\";s:17:\"pay_confirm_order\";s:52:\"Please confirm your order by entering your password.\";s:15:\"pay_customer_no\";s:12:\"Customer no.\";s:19:\"pay_deleted_booking\";s:27:\"The entry has been deleted.\";s:17:\"pay_deleted_items\";s:37:\"The selected items have been deleted.\";s:10:\"pay_ending\";s:9:\"ends with\";s:21:\"pay_entitled_retrieve\";s:29:\"Entitled to retrieve data for\";s:16:\"pay_expires_info\";s:76:\"This object is disposable. The payment has been expired, you can not buy it.\";s:10:\"pay_filter\";s:6:\"Filter\";s:22:\"pay_goto_buyed_objects\";s:23:\"Goto your buyed objects\";s:22:\"pay_goto_shopping_cart\";s:22:\"Goto the shopping cart\";s:10:\"pay_header\";s:7:\"Payment\";s:15:\"pay_hint_paypal\";s:15:\"Hint for PayPal\";s:8:\"pay_info\";s:310:\"Access to the following material is not for free. If you want to gain access to a certain learning object please select a price. You can purchase one or several learning objects by using the button \"shopping cart\" on your personal desktop.  You are going to gain immediate access to a chosen object and period.\";s:15:\"pay_info_paypal\";s:401:\"To pay for those objects that are in your shopping cart you\'ll leave ILIAS temporary and head for the PayPal website. Please follow the steps that are shown to you there. After paying successfully you\'ll be directed back to ILIAS automatically. Don\'t close the window of your browser at any time whilst the selling process. Otherwise the objects you\'ve bought can\'t be activated for you automatically.\";s:22:\"pay_item_already_in_sc\";s:49:\"This object already exists in your shopping cart.\";s:37:\"pay_item_already_in_sc_choose_another\";s:109:\"This object was already taken up in your shopping cart. Select if necessary a new price/duration combination.\";s:11:\"pay_locator\";s:7:\"Payment\";s:22:\"pay_message_attachment\";s:79:\"As a confirmation for your order we send you a bill (PDF format) as attachment.\";s:17:\"pay_message_hello\";s:4:\"Dear\";s:19:\"pay_message_regards\";s:15:\"Yours sincerely\";s:19:\"pay_message_subject\";s:16:\"Your ILIAS order\";s:18:\"pay_message_thanks\";s:33:\"Thank you for your ILIAS 3 order.\";s:22:\"pay_no_vendors_created\";s:18:\"No vendors created\";s:24:\"pay_not_buyed_any_object\";s:31:\"You have not bought any object.\";s:19:\"pay_order_date_from\";s:15:\"Order date from\";s:18:\"pay_order_date_til\";s:14:\"Order date til\";s:21:\"pay_payed_credit_card\";s:34:\"The order was paid by credit card.\";s:21:\"pay_payed_debit_entry\";s:34:\"The order was paid by debit entry.\";s:16:\"pay_payed_paypal\";s:29:\"The order was paid by PayPal.\";s:22:\"pay_paypal_error_fails\";s:58:\"PayPal reports errors that occured during the transaction.\";s:21:\"pay_paypal_error_info\";s:86:\"If necessary feel free to contact the system administrator of this ILIAS installation.\";s:30:\"pay_paypal_error_not_completed\";s:44:\"The transaction isn\'t totally completed yet.\";s:30:\"pay_paypal_error_prev_trans_id\";s:59:\"The transaction id given by PayPal was already used before.\";s:31:\"pay_paypal_error_wrong_customer\";s:63:\"Checking this transaction resulted in no match of the customer.\";s:28:\"pay_paypal_error_wrong_items\";s:65:\"Checking this transaction resulted in no match of the sold items.\";s:29:\"pay_paypal_error_wrong_vendor\";s:61:\"Checking this transaction resulted in no match of the vendor.\";s:17:\"pay_paypal_failed\";s:50:\"Your puchase of ILIAS objects using PayPal failed!\";s:18:\"pay_paypal_success\";s:118:\"Thanks for your purchase of ILIAS objects using PayPal! You\'ll receive a written confirmation in PDF format by e-mail.\";s:22:\"pay_paypal_unreachable\";s:54:\"The connection to the payment server of PayPal failed.\";s:16:\"pay_reset_filter\";s:12:\"Reset filter\";s:19:\"pay_select_one_item\";s:23:\"Please select one item.\";s:16:\"pay_select_price\";s:43:\"Please select a price/duration combination.\";s:14:\"pay_send_order\";s:10:\"Send order\";s:23:\"pay_shopping_cart_empty\";s:28:\"Your shopping cart is empty.\";s:12:\"pay_starting\";s:11:\"starts with\";s:9:\"pay_step1\";s:50:\"Your order - Schritt 1/3: Enter your personal data\";s:9:\"pay_step2\";s:48:\"Your order - Schritt 2/3: Choose kind of payment\";s:21:\"pay_step3_credit_card\";s:73:\"Your order - Schritt 3/3: Enter your credit card data and send your order\";s:21:\"pay_step3_debit_entry\";s:66:\"Your order - Schritt 3/3: Enter your bank data and send your order\";s:15:\"pay_update_view\";s:11:\"Update view\";s:11:\"paya_access\";s:6:\"Access\";s:17:\"paya_add_customer\";s:19:\"Add Selling Process\";s:14:\"paya_add_price\";s:13:\"Add new price\";s:20:\"paya_add_price_title\";s:9:\"New price\";s:21:\"paya_added_new_object\";s:60:\"Added new object. Please edit the pay method and the prices.\";s:20:\"paya_added_new_price\";s:17:\"Created new price\";s:18:\"paya_added_trustee\";s:20:\"Created new trustee.\";s:23:\"paya_bookings_available\";s:66:\"This object has been sold. Please delete all statistic data first.\";s:12:\"paya_buyable\";s:7:\"Buyable\";s:18:\"paya_buyed_objects\";s:14:\"Bought Objects\";s:20:\"paya_count_purchaser\";s:20:\"Number of purchasers\";s:13:\"paya_customer\";s:8:\"Customer\";s:32:\"paya_customer_added_successfully\";s:60:\"The selling process was added to the statistics sucessfully.\";s:17:\"paya_delete_price\";s:12:\"Delete price\";s:23:\"paya_delete_trustee_msg\";s:26:\"Deleted selected trustees.\";s:23:\"paya_deleted_last_price\";s:32:\"The last price has been deleted.\";s:19:\"paya_deleted_object\";s:39:\"Stoped payment for the selected object.\";s:20:\"paya_details_updated\";s:16:\"Details updated.\";s:13:\"paya_disabled\";s:8:\"Disabled\";s:17:\"paya_edit_details\";s:12:\"Edit Details\";s:20:\"paya_edit_pay_method\";s:15:\"Edit Pay Method\";s:16:\"paya_edit_prices\";s:11:\"Edit Prices\";s:22:\"paya_edit_prices_first\";s:29:\"Please edit the prices first.\";s:12:\"paya_enabled\";s:7:\"Enabled\";s:16:\"paya_enter_login\";s:26:\"Please enter an user name.\";s:22:\"paya_err_adding_object\";s:19:\"Error adding object\";s:26:\"paya_error_adding_customer\";s:68:\"An error occured while adding the selling process to the statistics.\";s:27:\"paya_error_mandatory_fields\";s:40:\"Please fill in all mandatory fields (*).\";s:29:\"paya_error_no_object_id_given\";s:24:\"Please choose an object.\";s:25:\"paya_error_update_booking\";s:28:\"Error saving statistic data.\";s:12:\"paya_expires\";s:14:\"Expire payment\";s:19:\"paya_filter_reseted\";s:15:\"Filter reseted.\";s:11:\"paya_header\";s:22:\"Payment Administration\";s:24:\"paya_insert_only_numbers\";s:28:\"Please insert only integers.\";s:12:\"paya_locator\";s:22:\"Payment Administration\";s:11:\"paya_months\";s:8:\"Month(s)\";s:24:\"paya_no_booking_id_given\";s:28:\"Error: no \'booking id\' given\";s:16:\"paya_no_bookings\";s:23:\"No statistic available.\";s:23:\"paya_no_object_selected\";s:25:\"Please select one object.\";s:24:\"paya_no_objects_assigned\";s:30:\"There are no sellable objects.\";s:23:\"paya_no_price_available\";s:19:\"No prices available\";s:23:\"paya_no_prices_selected\";s:23:\"Please select one price\";s:26:\"paya_no_settings_necessary\";s:51:\"There are no settings necessary for this pay method\";s:16:\"paya_no_trustees\";s:20:\"No trustees created.\";s:19:\"paya_no_valid_login\";s:28:\"This user name is not valid.\";s:23:\"paya_no_vendor_selected\";s:30:\"You haven\'t selected a vendor.\";s:24:\"paya_not_assign_yourself\";s:38:\"It is not possible to assign yourself.\";s:16:\"paya_not_buyable\";s:11:\"Not buyable\";s:11:\"paya_object\";s:7:\"Objects\";s:27:\"paya_object_not_purchasable\";s:39:\"It is not possible to sell this object.\";s:15:\"paya_order_date\";s:10:\"Order date\";s:15:\"paya_pay_method\";s:10:\"Pay method\";s:29:\"paya_pay_method_not_specified\";s:13:\"Not specified\";s:10:\"paya_payed\";s:5:\"Payed\";s:17:\"paya_payed_access\";s:12:\"Payed/Access\";s:13:\"paya_perm_obj\";s:12:\"Edit objects\";s:17:\"paya_perm_coupons\";s:12:\"Edit coupons\";s:14:\"paya_perm_stat\";s:15:\"Edit statistics\";s:20:\"paya_price_not_valid\";s:51:\"This price is not valid. Please insert only numbers\";s:26:\"paya_select_object_to_sell\";s:48:\"Please select the object which you want to sell.\";s:28:\"paya_select_pay_method_first\";s:35:\"Please select one pay method first.\";s:16:\"paya_sell_object\";s:11:\"Sell object\";s:18:\"paya_shopping_cart\";s:13:\"Shopping Cart\";s:14:\"paya_statistic\";s:9:\"Statistic\";s:23:\"paya_sure_delete_object\";s:88:\"Are you sure, you want to stop payment for this object? All assigned data will get lost.\";s:32:\"paya_sure_delete_selected_prices\";s:52:\"Are you sure you want to delete the selected prices?\";s:34:\"paya_sure_delete_selected_trustees\";s:54:\"Are you sure you want to delete the selected trustees?\";s:21:\"paya_sure_delete_stat\";s:48:\"Are you sure, you want to delete this statistic?\";s:16:\"paya_transaction\";s:11:\"Transaction\";s:18:\"paya_trustee_table\";s:8:\"Trustees\";s:13:\"paya_trustees\";s:8:\"Trustees\";s:17:\"paya_update_price\";s:13:\"Update prices\";s:20:\"paya_updated_booking\";s:18:\"Updated statistic.\";s:19:\"paya_updated_prices\";s:14:\"Updated prices\";s:21:\"paya_updated_trustees\";s:20:\"Updated permissions.\";s:26:\"paya_user_already_assigned\";s:22:\"User already assigned.\";s:11:\"paya_vendor\";s:6:\"Vendor\";s:20:\"pays_active_bookings\";s:75:\"There active bookings for the selected vendor(s). Please delete them first.\";s:13:\"pays_add_info\";s:42:\"Additional information for bill (optional)\";s:15:\"pays_add_vendor\";s:10:\"Add vendor\";s:17:\"pays_added_vendor\";s:16:\"Added new vendor\";s:12:\"pays_address\";s:16:\"Address for bill\";s:29:\"pays_already_assigned_vendors\";s:52:\"The following number of users were already assigned:\";s:21:\"pays_assigned_vendors\";s:68:\"The following number of users have been assigned to the vendor list:\";s:15:\"pays_auth_token\";s:28:\"Unique Token Given by PayPal\";s:14:\"pays_bank_data\";s:18:\"Bank data for bill\";s:9:\"pays_bill\";s:4:\"Bill\";s:8:\"pays_bmf\";s:3:\"BMF\";s:16:\"pays_cost_center\";s:11:\"Cost center\";s:26:\"pays_cost_center_not_valid\";s:33:\"Please enter a valid cost center.\";s:21:\"pays_currency_subunit\";s:28:\"Currency (1/100) (e.g. Cent)\";s:18:\"pays_currency_unit\";s:19:\"Currency (e.g. EUR)\";s:18:\"pays_delete_vendor\";s:13:\"Deassign user\";s:27:\"pays_deleted_number_vendors\";s:50:\"The following number of vendors have been deleted:\";s:16:\"pays_edit_vendor\";s:9:\"Edit user\";s:17:\"pays_email_vendor\";s:26:\"Mail Address of the Vendor\";s:12:\"pays_general\";s:7:\"General\";s:21:\"pays_general_settings\";s:16:\"General settings\";s:31:\"pays_general_settings_not_valid\";s:97:\"Your general settings aren\'t valid. Please check out whether all fields are filled out correctly.\";s:25:\"pays_header_select_vendor\";s:16:\"Vendor selection\";s:22:\"pays_no_username_given\";s:17:\"No username given\";s:28:\"pays_no_valid_username_given\";s:23:\"No valid username given\";s:23:\"pays_no_vendor_selected\";s:18:\"No vendor selected\";s:20:\"pays_number_bookings\";s:15:\"Active bookings\";s:23:\"pays_objects_bill_exist\";s:85:\"Pay method \'bill\' is activated for some objects. Therefore it can not be deactivated.\";s:22:\"pays_objects_bmf_exist\";s:84:\"Pay method \'BMF\' is activated for some objects. Therefore it can not be deactivated.\";s:25:\"pays_objects_paypal_exist\";s:87:\"Pay method \'PayPal\' is activated for some objects. Therefore it can not be deactivated.\";s:12:\"pays_offline\";s:7:\"Offline\";s:11:\"pays_online\";s:6:\"Online\";s:15:\"pays_page_style\";s:10:\"Page Style\";s:16:\"pays_pay_methods\";s:11:\"Pay methods\";s:11:\"pays_paypal\";s:6:\"PayPal\";s:20:\"pays_paypal_settings\";s:19:\"Settings for PayPal\";s:30:\"pays_paypal_settings_not_valid\";s:100:\"Your settings for PayPal aren\'t valid. Please check out whether all fields are filled out correctly.\";s:13:\"pays_pdf_path\";s:36:\"Path for generating bill as PDF file\";s:16:\"pays_server_host\";s:33:\"Server Host (e.g. www.paypal.com)\";s:16:\"pays_server_path\";s:42:\"Path to the Scripts (e.g. /cgi-bin/webscr)\";s:33:\"pays_sure_delete_selected_vendors\";s:51:\"Do you really want to delete the selected vendor(s)\";s:30:\"pays_too_many_vendors_selected\";s:55:\"Please select only one customer to perform this action.\";s:29:\"pays_updated_general_settings\";s:35:\"Your general settings were updated.\";s:23:\"pays_updated_pay_method\";s:19:\"Changed pay method.\";s:28:\"pays_updated_paypal_settings\";s:38:\"Your settings for PayPal were updated.\";s:26:\"pays_user_already_assigned\";s:48:\"This user is already assigned to the vendor list\";s:13:\"pays_vat_rate\";s:24:\"VAT rate in % (optional)\";s:11:\"pays_vendor\";s:6:\"Vendor\";s:7:\"price_a\";s:5:\"Price\";s:6:\"prices\";s:6:\"Prices\";s:6:\"update\";s:6:\"Update\";s:25:\"paya_coupons_codes_import\";s:12:\"Import Codes\";s:16:\"paya_coupons_add\";s:10:\"Add Coupon\";s:17:\"paya_coupons_edit\";s:11:\"Edit Coupon\";s:20:\"paya_coupons_coupons\";s:7:\"Coupons\";s:19:\"paya_coupons_coupon\";s:6:\"Coupon\";s:17:\"paya_coupons_type\";s:11:\"Coupon Type\";s:16:\"paya_coupons_fix\";s:3:\"fix\";s:24:\"paya_coupons_percentaged\";s:11:\"percentaged\";s:18:\"paya_coupons_title\";s:5:\"Title\";s:28:\"paya_coupons_number_of_codes\";s:15:\"Number of Codes\";s:27:\"paya_coupons_usage_of_codes\";s:14:\"Usage of Codes\";s:20:\"paya_coupons_objects\";s:7:\"Objects\";s:17:\"paya_coupons_from\";s:10:\"Valid From\";s:17:\"paya_coupons_till\";s:10:\"Valid Till\";s:26:\"paya_coupons_not_available\";s:23:\"No coupons created yet.\";s:24:\"paya_coupons_description\";s:11:\"Description\";s:18:\"paya_coupons_value\";s:5:\"Value\";s:23:\"paya_coupons_edit_codes\";s:10:\"Edit Codes\";s:25:\"paya_coupons_edit_objects\";s:12:\"Edit Objects\";s:18:\"paya_coupons_codes\";s:5:\"Codes\";s:17:\"paya_coupons_code\";s:4:\"Code\";s:27:\"paya_coupons_generate_codes\";s:14:\"Generate Codes\";s:25:\"paya_coupons_availability\";s:35:\"Maximum Number of Usage of one Code\";s:38:\"paya_coupons_code_deleted_successfully\";s:20:\"Deleted Successfully\";s:24:\"paya_coupons_code_length\";s:11:\"Code Length\";s:23:\"paya_coupons_code_chars\";s:5:\"Chars\";s:28:\"paya_coupons_code_generation\";s:15:\"Code Generation\";s:22:\"paya_coupons_type_auto\";s:13:\"Automatically\";s:22:\"paya_coupons_type_self\";s:8:\"Manually\";s:30:\"paya_coupons_no_codes_selected\";s:27:\"You did not select any code\";s:39:\"paya_coupons_sure_delete_selected_codes\";s:51:\"Are you sure you want to delete the selected codes?\";s:34:\"paya_coupons_sure_delete_all_codes\";s:42:\"Are you sure you want to delete all codes?\";s:32:\"paya_coupons_codes_not_available\";s:21:\"No codes created yet.\";s:29:\"paya_coupons_assigned_objects\";s:16:\"Assigned Objects\";s:31:\"paya_coupons_unassigned_objects\";s:18:\"Unassigned Objects\";s:22:\"paya_coupons_not_found\";s:17:\"No coupons found.\";s:22:\"paya_coupons_not_valid\";s:24:\"The coupon is not valid.\";s:31:\"paya_coupons_no_object_assigned\";s:33:\"No object assigned to the coupon.\";s:29:\"paya_coupons_coupon_not_found\";s:42:\"No coupon found for the code you typed in.\";s:27:\"paya_coupons_already_in_use\";s:83:\"The code you typed in belongs to the same coupon as a code which is already in use.\";s:25:\"paya_coupons_coupon_added\";s:13:\"Coupon added.\";s:33:\"paya_coupons_fix_selected_objects\";s:54:\"%s %s discount on the total amount of selected objects\";s:28:\"paya_coupons_fix_all_objects\";s:49:\"%s %s discount on the total amount of all objects\";s:41:\"paya_coupons_percentaged_selected_objects\";s:54:\"%s %s discount on the total amount of selected objects\";s:36:\"paya_coupons_percentaged_all_objects\";s:49:\"%s %s discount on the total amount of all objects\";s:31:\"paya_coupons_no_codes_generated\";s:19:\"No codes generated.\";s:25:\"paya_coupons_import_codes\";s:12:\"Import Codes\";s:38:\"paya_coupons_import_error_opening_file\";s:30:\"Error opening the import file!\";s:35:\"paya_coupon_codes_import_successful\";s:18:\"Import successful.\";s:17:\"pays_bmf_settings\";s:16:\"Settings for BMF\";s:18:\"pays_bmf_client_id\";s:9:\"Cliend Id\";s:26:\"pays_bmf_bewirtschafter_nr\";s:12:\"Operator No.\";s:24:\"pays_bmf_haushaltsstelle\";s:15:\"Haushaltsstelle\";s:18:\"pays_bmf_object_id\";s:9:\"Object Id\";s:34:\"pays_bmf_kennzeichen_mahnverfahren\";s:20:\"Dunning Procedure Id\";s:29:\"pays_bmf_waehrungskennzeichen\";s:19:\"Currency (e.g. EUR)\";s:24:\"pays_bmf_epayment_server\";s:15:\"ePayment-Server\";s:27:\"pays_bmf_client_certificate\";s:26:\"Path to Client-Certificate\";s:23:\"pays_bmf_ca_certificate\";s:22:\"Path to CA-Certificate\";s:16:\"pays_bmf_timeout\";s:7:\"Timeout\";s:25:\"pays_updated_bmf_settings\";s:35:\"Your settings for BMF were updated.\";s:27:\"pays_bmf_settings_not_valid\";s:97:\"Your settings for BMF aren\'t valid. Please check out whether all fields are filled out correctly.\";s:24:\"import_use_only_textfile\";s:58:\"Hint: Please use a plain-text file with one code per line.\";s:14:\"object_deleted\";s:14:\"Object Deleted\";s:12:\"user_deleted\";s:12:\"User Deleted\";s:24:\"statistics_filter_advice\";s:79:\"Please choose your favoured filter settings and press the \"Update View\" button.\";s:28:\"pay_crs_max_members_exceeded\";s:83:\"You cannot buy this course because the maximum number of users is already exceeded.\";s:6:\"topics\";s:6:\"Topics\";s:5:\"topic\";s:5:\"Topic\";s:10:\"edit_topic\";s:10:\"Edit Topic\";s:9:\"new_topic\";s:9:\"New Topic\";s:11:\"topic_title\";s:5:\"Title\";s:15:\"advanced_search\";s:15:\"Advanced Search\";s:10:\"set_filter\";s:10:\"Set Filter\";s:12:\"reset_filter\";s:12:\"Reset Filter\";s:9:\"filter_by\";s:2:\"by\";s:8:\"sort_asc\";s:14:\"sort ascending\";s:9:\"sort_desc\";s:15:\"sort descending\";s:4:\"sort\";s:4:\"Sort\";s:7:\"sort_by\";s:15:\"Sort Objects by\";s:10:\"price_from\";s:4:\"from\";s:16:\"select_one_topic\";s:32:\"Please select at least one topic\";s:14:\"topics_deleted\";s:43:\"The chosen topics were deleted successfully\";s:13:\"no_topics_yet\";s:21:\"No topics created yet\";s:11:\"topic_saved\";s:32:\"The topic was saved successfully\";s:12:\"topic_edited\";s:33:\"The topic was edited successfully\";s:18:\"sure_delete_topics\";s:50:\"Are you sure you want to delete the chosen topics?\";s:31:\"pay_topics_default_sorting_type\";s:30:\"Default Sorting Type of Topics\";s:36:\"pay_topics_default_sorting_direction\";s:35:\"Default Sorting Direction of Topics\";s:31:\"pay_topics_allow_custom_sorting\";s:24:\"Custom Sorting of Topics\";s:36:\"pay_topics_allow_custom_sorting_info\";s:88:\"If enabled, every user can determine the sorting of topics in the webshop independently.\";s:24:\"pay_topics_sort_by_title\";s:8:\"By Title\";s:23:\"pay_topics_sort_by_date\";s:7:\"By Date\";s:24:\"pay_topics_sort_manually\";s:8:\"Manually\";s:17:\"pay_sorting_value\";s:13:\"Sorting Value\";s:16:\"pay_save_sorting\";s:12:\"Save Sorting\";s:12:\"pay_max_hits\";s:8:\"Max hits\";s:17:\"pay_max_hits_info\";s:63:\"Please enter a number for the maximum number of search results.\";s:21:\"pay_personal_settings\";s:17:\"Personal Settings\";s:28:\"pay_manual_sorting_of_topics\";s:24:\"Manual Sorting of Topics\";s:14:\"sort_topics_by\";s:14:\"Sort Topics by\";s:20:\"sort_topics_by_title\";s:5:\"Title\";s:19:\"sort_topics_by_date\";s:4:\"Date\";s:20:\"sort_topics_manually\";s:8:\"Manually\";s:15:\"pay_enable_shop\";s:14:\"Enable Webshop\";s:20:\"pay_enable_shop_info\";s:70:\"If activated the ILIAS webshop is available and objects can be bought.\";s:30:\"payment_shop_not_objects_found\";s:34:\"No buyable objects could be found.\";s:27:\"payment_login_to_buy_object\";s:60:\"Please login to ILIAS to put objects into the shopping cart.\";s:12:\"pay_abstract\";s:8:\"Abstract\";s:17:\"pay_edit_abstract\";s:13:\"Edit Abstract\";s:13:\"pay_thumbnail\";s:9:\"Thumbnail\";}');
INSERT INTO `lng_modules` VALUES ('pwassist','en','a:17:{s:19:\"password_assistance\";s:19:\"Password Assistance\";s:20:\"pwassist_enter_email\";s:349:\"Please enter an e-mail address and submit the form.\\nILIAS will send an e-mail to that address. The e-mail contains all usernames which have registered this e-mail address.\\nChoose a suitable username and use the password service to retrieve a new password. If you do not retrieve any e-mail by this service please contact your course admin or %1$s.\";s:33:\"pwassist_enter_username_and_email\";s:379:\"Enter a user name and the associated e-mail address in the fields shown below.\\nILIAS will send a message to that e-mail address. The message contains an address for a web page, where you can enter a new password for the user account.\\nIn case you are unable to assign a password to your user account using this form, contact your course administration or send an e-mail to %1$s.\";s:40:\"pwassist_enter_username_and_new_password\";s:61:\"Enter the user name and the new password in the fields below.\";s:22:\"pwassist_invalid_email\";s:97:\"Please correct your e-mail address.\\nThe given e-mail address could not be found in the database.\";s:34:\"pwassist_invalid_username_or_email\";s:134:\"Please correct the text in the entry fields.\\nThe user name and e-mail address you have entered do not match an entry in the database.\";s:26:\"pwassist_invalid_auth_mode\";s:90:\"The user won\'t be authenticated directly at ILIAS. Thus, sending a password is impossible.\";s:24:\"pwassist_login_not_match\";s:141:\"Please enter another user name.\\nThe user name you have entered does not match the user name for which you had asked for password assistance.\";s:18:\"pwassist_mail_body\";s:1157:\"Register a new password for your user account:\\n\\t%1$s\\n\\nThis message has been generated automatically by the ILIAS server\\n\\t%2$s\\n\\nYou (or someone at %3$s) has asked for password assistance for the user account \"%4$s\".\\n\\nPlease check carefully the conditions listed below, and proceed accordingly:\\n\\n- If you have used the password assistance form on the ILIAS server by accident:\\nDelete this mail.\\n\\n- If you are certain, that you never asked for password assistance at this ILIAS server:\\nPlease contact %5$s.\\n\\n- If you asked for password assistance, please proceed as follows:\\n\\n1. Open your browser.\\n\\n2. Enter the following address in your browser:\\n\\t%6$s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your email program has inserted these line breaks.\\n\\n3. On the web page shown by your browser, enter a new password for your user account.\\n\\nPlease note, that for security reasons, you can perform the three steps above only exactly once and for a limited time only. Afterwards the address becomes invalid, and you have to use the password assistance page on the ILIAS server again.\";s:18:\"pwassist_mail_sent\";s:61:\"A message has been sent to %1$s.\\nPlease check your mail box.\";s:21:\"pwassist_mail_subject\";s:25:\"ILIAS Password Assistance\";s:22:\"pwassist_not_permitted\";s:105:\"Please enter another user name.\\nPassword assistance is not permitted for the user name you have entered.\";s:26:\"pwassist_password_assigned\";s:59:\"The password has been successfully assigned to user \"%1$s\".\";s:24:\"pwassist_session_expired\";s:261:\"Please fill in this form again.\\nYour password assistance session has expired. This may have happened, because you tried to use the link that has been sent by e-mail to you more than once, or because too much time has passed since the link has been sent to you.\";s:21:\"pwassist_update_error\";s:141:\"Please contact your system administrator.\\nThe password could not be assigned to the user account due to an error whe updating the data base.\";s:27:\"pwassist_username_mail_body\";s:908:\"These are the active username found for the given e-mail address:\\n%s\\n\\nThis message has been created automatically by the following ILIAS Server:\\n\\t%s\\n\\nYou (or somebody with IP  %s) have requested support for forgotten usernames for the e-mail address \'%s\'.\\n\\nPlease check the following and act as suggested::\\n\\n-You have requested this e-mail by accident:\\nDelete this e-mail.\\n\\n-You are sure, that you never requested this e-mail:\\nPlease contact %s.\\n\\n- If you requested this e-mail, please proceed as follows::\\n\\n1. Start your internet browser.\\n\\n2. Enter the following url:\\n\\t%s\\n\\nImportant: The address is a single line. If you see this address split into multiple lines, then your e-mail program has inserted these line breaks.\\n\\n3. Your Browser now shows the Password-Service. Use this page together with one of the usernames and the according e-mail address to retrieve a new password.\";s:23:\"pwassist_no_email_found\";s:112:\"You can not use the password assistance, since there is no e-Mail address for the user account you have entered.\";}');
INSERT INTO `lng_modules` VALUES ('rbac','en','a:90:{s:22:\"edit_learning_progress\";s:22:\"Edit Learning Progress\";s:16:\"filter_all_roles\";s:33:\"Show all roles of current context\";s:19:\"filter_global_roles\";s:22:\"Show only global roles\";s:18:\"filter_local_roles\";s:40:\"Show only local roles of current context\";s:25:\"filter_local_roles_object\";s:46:\"Show only local roles defined at this position\";s:25:\"filter_roles_local_policy\";s:53:\"Show only roles using a local policy at this position\";s:22:\"info_user_view_changed\";s:17:\"User view changed\";s:5:\"leave\";s:5:\"Leave\";s:20:\"msg_no_roles_of_type\";s:47:\"No Roles available with selected filter setting\";s:17:\"perm_administrate\";s:12:\"Administrate\";s:17:\"perm_class_create\";s:18:\"Create new objects\";s:22:\"perm_class_create_desc\";s:69:\"Determine which object types may be created under the current object.\";s:18:\"perm_class_general\";s:18:\"General operations\";s:23:\"perm_class_general_desc\";s:107:\"Common operations available for all objects. Hover the mousepointer over operation to get more information.\";s:17:\"perm_class_object\";s:18:\"Special operations\";s:22:\"perm_class_object_desc\";s:67:\"Object-specific operations, only available to certain object types.\";s:15:\"perm_class_rbac\";s:19:\"Permission settings\";s:20:\"perm_class_rbac_desc\";s:134:\"Access control to Permission settings (this menu) and local policy settings for automatic permission settings for new created objects.\";s:15:\"perm_local_role\";s:10:\"Local role\";s:20:\"perm_local_role_desc\";s:83:\"This role is locally defined at the current object and correspond to a local policy\";s:21:\"perm_use_local_policy\";s:16:\"Use local policy\";s:26:\"perm_use_local_policy_desc\";s:106:\"If local policy is activated, you may define different default permission settings for the current object.\";s:20:\"recf_edit_permission\";s:26:\"Change permission settings\";s:12:\"recf_visible\";s:28:\"Restored Objects are visible\";s:9:\"recf_read\";s:31:\"Read access to Restored Objects\";s:10:\"recf_write\";s:21:\"Edit Restored Objects\";s:19:\"mds_edit_permission\";s:26:\"Change permission settings\";s:11:\"mds_visible\";s:29:\"Metadata settings are visible\";s:8:\"mds_read\";s:32:\"Read access to Metadata settings\";s:9:\"mds_write\";s:22:\"Edit Metadata settings\";s:20:\"cals_edit_permission\";s:26:\"Change permission settings\";s:12:\"cals_visible\";s:29:\"Calendar settings are visible\";s:9:\"cals_read\";s:32:\"Read access to Calendar settings\";s:10:\"cals_write\";s:22:\"Edit Calendar settings\";s:12:\"sess_visible\";s:20:\"Sessions are visible\";s:9:\"sess_read\";s:23:\"Read access to Sessions\";s:10:\"sess_write\";s:13:\"Edit Sessions\";s:20:\"sess_edit_permission\";s:26:\"Change Permission Settings\";s:15:\"crs_create_sess\";s:14:\"Create Session\";s:9:\"sess_copy\";s:12:\"Copy Session\";s:14:\"crs_edit_event\";s:20:\"Edit Calendar Events\";s:14:\"grp_edit_event\";s:20:\"Edit Calendar Events\";s:15:\"sess_edit_event\";s:20:\"Edit Calendar Events\";s:15:\"cals_edit_event\";s:29:\"Administrate Public Calendars\";s:20:\"rcrs_edit_permission\";s:26:\"Change permission settings\";s:12:\"rcrs_visible\";s:22:\"Course-Link is visible\";s:9:\"rcrs_read\";s:26:\"Read access to Course-Link\";s:11:\"rcrs_delete\";s:18:\"Delete Course-Link\";s:15:\"cat_create_rcrs\";s:19:\"Create Course-Links\";s:10:\"rcrs_write\";s:16:\"Edit Course-Link\";s:15:\"cat_create_wiki\";s:11:\"Create Wiki\";s:15:\"crs_create_wiki\";s:11:\"Create Wiki\";s:15:\"grp_create_wiki\";s:11:\"Create Wiki\";s:16:\"fold_create_wiki\";s:11:\"Create Wiki\";s:20:\"crsr_edit_permission\";s:26:\"Change Permission Settings\";s:12:\"crsr_visible\";s:27:\"Course Reference is visible\";s:9:\"crsr_read\";s:31:\"Read access to Course Reference\";s:11:\"crsr_delete\";s:23:\"Delete Course Reference\";s:15:\"cat_create_crsr\";s:27:\"Create new Course Reference\";s:10:\"crsr_write\";s:21:\"Edit Course Reference\";s:9:\"crsr_copy\";s:21:\"Copy Course Reference\";s:20:\"catr_edit_permission\";s:26:\"Change Permission Settings\";s:12:\"catr_visible\";s:29:\"Category Reference is visible\";s:9:\"catr_read\";s:33:\"Read access to Category Reference\";s:11:\"catr_delete\";s:25:\"Delete Category Reference\";s:15:\"cat_create_catr\";s:25:\"Create Category Reference\";s:10:\"catr_write\";s:23:\"Edit Category Reference\";s:9:\"catr_copy\";s:23:\"Copy Category Reference\";s:16:\"root_create_catr\";s:25:\"Create Category Reference\";s:20:\"mcts_edit_permission\";s:26:\"Change permission settings\";s:9:\"mcts_read\";s:33:\"Read access to mediacast settings\";s:12:\"mcts_visible\";s:30:\"Mediacast settings are visible\";s:10:\"mcts_write\";s:23:\"Edit mediacast settings\";s:20:\"cmps_edit_permission\";s:26:\"Change permission settings\";s:9:\"cmps_read\";s:33:\"Read access to component settings\";s:12:\"cmps_visible\";s:30:\"Component settings are visible\";s:10:\"cmps_write\";s:23:\"Edit component settings\";s:20:\"pdts_edit_permission\";s:26:\"Change permission settings\";s:9:\"pdts_read\";s:40:\"Read access to personal desktop settings\";s:12:\"pdts_visible\";s:37:\"Personal desktop settings are visible\";s:10:\"pdts_write\";s:30:\"Edit personal desktop settings\";s:11:\"sess_delete\";s:14:\"Delete Session\";s:20:\"svyf_edit_permission\";s:26:\"Change permission settings\";s:9:\"svyf_read\";s:30:\"Read access to survey settings\";s:12:\"svyf_visible\";s:27:\"Survey settings are visible\";s:10:\"svyf_write\";s:20:\"Edit survey settings\";s:20:\"facs_edit_permission\";s:26:\"Change permission settings\";s:9:\"facs_read\";s:38:\"Read access to files & foldes settings\";s:12:\"facs_visible\";s:35:\"Files & foldes settings are visible\";s:10:\"facs_write\";s:28:\"Edit files & foldes settings\";}');
INSERT INTO `lng_modules` VALUES ('registration','en','a:49:{s:18:\"reg_add_assignment\";s:14:\"New Assignment\";s:20:\"reg_added_assignment\";s:21:\"Added new assignment.\";s:11:\"reg_approve\";s:29:\"Registration with Approvement\";s:16:\"reg_approve_info\";s:76:\"If checked any new user registration has to be approved by an administrator.\";s:19:\"reg_available_roles\";s:16:\"Available Roles:\";s:11:\"reg_default\";s:7:\"Default\";s:22:\"reg_deleted_assignment\";s:22:\"Deleted assignment(s).\";s:10:\"reg_direct\";s:19:\"Direct Registration\";s:15:\"reg_direct_info\";s:80:\"If this is checked, any new user registration request is automatically approved.\";s:12:\"reg_disabled\";s:24:\"No Registration Possible\";s:10:\"reg_domain\";s:6:\"Domain\";s:9:\"reg_email\";s:25:\"Automatic Role Assignment\";s:25:\"reg_email_role_assignment\";s:25:\"Role Assignment By Domain\";s:9:\"reg_fixed\";s:29:\"Selection From Specified List\";s:12:\"reg_info_pwd\";s:76:\"If enabled passwords will be send automatically to the new users per E-Mail.\";s:21:\"reg_mail_body_approve\";s:149:\"You already have registered to ILIAS eLearning and received a e-mail with your account data. Now your account has been activated by an administrator.\";s:21:\"reg_mail_body_profile\";s:13:\"Profile data:\";s:29:\"reg_mail_body_profile_changed\";s:26:\"your profile has changed !\";s:28:\"reg_mail_body_pwd_generation\";s:153:\"Your account request will be reviewed by an administrator, and should be activated within 48 hours. You will be informed about the approvement by e-mail.\";s:22:\"reg_mail_new_user_body\";s:31:\"A new user has been registered.\";s:18:\"reg_missing_domain\";s:27:\"Please fill out all fields.\";s:16:\"reg_missing_role\";s:27:\"Please fill out all fields.\";s:16:\"reg_notification\";s:13:\"Notifications\";s:21:\"reg_notification_info\";s:117:\"Enter one or more Login-Ids of users (comma seperated) that will be informed about new user registrations per e-mail.\";s:19:\"reg_role_assignment\";s:15:\"Role Assignment\";s:13:\"reg_role_info\";s:14:\"Assigned Roles\";s:14:\"reg_select_one\";s:24:\"Please select one entry.\";s:20:\"reg_selectable_roles\";s:16:\"Selectable Roles\";s:19:\"reg_settings_header\";s:25:\"New Registration Settings\";s:8:\"reg_type\";s:17:\"Registration Type\";s:22:\"reg_unknown_recipients\";s:35:\"The following logins are not valid:\";s:21:\"registration_settings\";s:17:\"New Registrations\";s:22:\"reg_access_limitations\";s:17:\"Access Limitation\";s:29:\"reg_enable_access_limitations\";s:24:\"Enable Access Limitation\";s:35:\"reg_access_limitation_limited_until\";s:23:\"Access is limited until\";s:34:\"reg_access_limitation_limited_time\";s:29:\"After registration access for\";s:26:\"reg_access_limitation_none\";s:16:\"Unlimited access\";s:34:\"reg_access_limitation_missing_mode\";s:53:\"Please choose for all roles an Access Limitation Mode\";s:33:\"reg_access_limitation_out_of_date\";s:53:\"One or more Roles have an outdated access limitation!\";s:27:\"reg_role_access_limitations\";s:59:\"Define access limitations of Roles for new registered Users\";s:26:\"reg_access_limitation_mode\";s:22:\"Access Limitation Mode\";s:36:\"reg_access_limitation_mode_unlimited\";s:20:\"No access limitation\";s:35:\"reg_access_limitation_mode_absolute\";s:33:\"Access is limited by a fixed date\";s:35:\"reg_access_limitation_mode_relative\";s:57:\"Limited access for a fixed time period after registration\";s:16:\"auth_radius_name\";s:28:\"Name of RADIUS Configuration\";s:21:\"auth_radius_name_desc\";s:50:\"Please choose a name for this server configuration\";s:16:\"auth_radius_sync\";s:20:\"User Synchronization\";s:23:\"auth_radius_role_select\";s:5:\"Role:\";s:21:\"auth_radius_sync_info\";s:91:\"If enabled new user accounts will be created automatically after successful authentication.\";}');
INSERT INTO `lng_modules` VALUES ('search','en','a:91:{s:20:\"search_user_extended\";s:20:\"Extended User Search\";s:18:\"search_user_simple\";s:18:\"Simple User Search\";s:18:\"last_search_result\";s:18:\"Last Search Result\";s:18:\"add_members_header\";s:11:\"Add members\";s:14:\"append_results\";s:14:\"Append results\";s:13:\"search_active\";s:20:\"Include active users\";s:23:\"search_added_new_folder\";s:17:\"Added new folder.\";s:15:\"search_advanced\";s:15:\"Advanced search\";s:18:\"search_all_results\";s:11:\"All results\";s:16:\"search_all_words\";s:9:\"All words\";s:10:\"search_and\";s:3:\"and\";s:10:\"search_any\";s:9:\"-- Any --\";s:15:\"search_any_word\";s:8:\"Any word\";s:11:\"search_area\";s:11:\"Search area\";s:16:\"search_area_info\";s:52:\"Please select an area where the search should start.\";s:12:\"search_below\";s:8:\"Beneath:\";s:13:\"search_change\";s:6:\"Change\";s:25:\"search_choose_object_type\";s:30:\"Please choose one object type.\";s:20:\"search_concatenation\";s:13:\"Concatenation\";s:14:\"search_content\";s:12:\"Page Content\";s:18:\"search_dbk_content\";s:25:\"Digital Library (content)\";s:15:\"search_dbk_meta\";s:26:\"Digital Library (metadata)\";s:18:\"search_delete_sure\";s:55:\"The object and its contents will be deleted permanently\";s:19:\"search_details_info\";s:58:\"Detailed search. Please select one or more resource types.\";s:13:\"search_direct\";s:13:\"Direct search\";s:16:\"search_fast_info\";s:64:\"Search for titles, descriptions and keywords in all object types\";s:22:\"search_for_grp_members\";s:24:\"Search for group members\";s:23:\"search_for_role_members\";s:23:\"Search for role members\";s:16:\"search_for_users\";s:16:\"Search for users\";s:16:\"search_full_info\";s:55:\"Choose this option to search in a large amount of data.\";s:12:\"search_group\";s:6:\"Groups\";s:16:\"search_grp_title\";s:10:\"Group name\";s:11:\"search_hits\";s:9:\"Found in:\";s:17:\"search_in_magazin\";s:17:\"In the repository\";s:16:\"search_in_result\";s:21:\"Search within results\";s:15:\"search_inactive\";s:22:\"Include inactive users\";s:12:\"search_index\";s:14:\"Indexed search\";s:16:\"search_like_info\";s:39:\"Choose this option to get best results.\";s:20:\"search_limit_reached\";s:107:\"Your search produced more than %s hits. You can restrict the search terms to receive more detailed results.\";s:17:\"search_lm_content\";s:28:\"Learning materials (content)\";s:14:\"search_lm_meta\";s:29:\"Learning materials (metadata)\";s:13:\"search_lucene\";s:13:\"Lucene search\";s:18:\"search_lucene_host\";s:13:\"Lucene-Server\";s:18:\"search_lucene_info\";s:83:\"If activated, it is possible to search in PDF, HTML files and HTML-Learning modules\";s:18:\"search_lucene_port\";s:11:\"Lucene-Port\";s:20:\"search_lucene_readme\";s:17:\"Setup information\";s:11:\"search_meta\";s:8:\"Metadata\";s:20:\"search_minimum_three\";s:50:\"Your search must be at least three characters long\";s:30:\"search_move_folder_not_allowed\";s:23:\"Folder cannot be moved.\";s:14:\"search_move_to\";s:8:\"Move to:\";s:24:\"search_my_search_results\";s:17:\"My search results\";s:17:\"search_new_folder\";s:10:\"New folder\";s:18:\"search_no_category\";s:43:\"You have not selected any search categories\";s:27:\"search_no_connection_lucene\";s:32:\"Cannot connect to Lucene server.\";s:15:\"search_no_match\";s:37:\"Your search did not match any results\";s:23:\"search_no_results_saved\";s:17:\"No results saved.\";s:21:\"search_no_search_term\";s:38:\"You have not selected any search terms\";s:19:\"search_no_selection\";s:22:\"You made no selection.\";s:21:\"search_object_renamed\";s:15:\"Object renamed.\";s:22:\"search_objects_deleted\";s:18:\"Object(s) deleted.\";s:20:\"search_objects_moved\";s:14:\"Objects moved.\";s:17:\"search_one_action\";s:18:\"Select one action.\";s:9:\"search_or\";s:2:\"or\";s:19:\"search_rename_title\";s:12:\"Rename title\";s:14:\"search_results\";s:14:\"Search results\";s:20:\"search_results_saved\";s:20:\"Search results saved\";s:17:\"search_role_title\";s:9:\"Role name\";s:21:\"search_save_as_select\";s:8:\"Save as:\";s:17:\"search_search_for\";s:10:\"Search for\";s:30:\"search_search_no_results_saved\";s:33:\"There are no search results saved\";s:21:\"search_search_results\";s:14:\"Search results\";s:18:\"search_search_term\";s:11:\"Search term\";s:32:\"search_select_exactly_one_object\";s:35:\"You must select exactly one object.\";s:20:\"search_select_folder\";s:78:\"Please select exactly one folder. It is not possible to rename search results.\";s:17:\"search_select_one\";s:17:\"Select one folder\";s:24:\"search_select_one_action\";s:21:\"--Select one action--\";s:31:\"search_select_one_folder_select\";s:21:\"--Select one folder--\";s:24:\"search_select_one_result\";s:33:\"Select at least one search result\";s:24:\"search_select_one_select\";s:21:\"--Select one folder--\";s:18:\"search_show_result\";s:4:\"Show\";s:14:\"search_tst_svy\";s:13:\"Tests/Surveys\";s:11:\"search_type\";s:11:\"Search Type\";s:11:\"search_user\";s:5:\"Users\";s:5:\"until\";s:5:\"up to\";s:11:\"search_page\";s:8:\"Results:\";s:16:\"search_page_next\";s:4:\"Next\";s:16:\"search_page_prev\";s:8:\"Previous\";s:12:\"search_users\";s:12:\"Search Users\";s:10:\"search_lom\";s:12:\"LOM Metadata\";s:13:\"search_adv_md\";s:17:\"Extended Metadata\";s:19:\"adv_md_search_title\";s:27:\"Search in Extended Metadata\";}');
INSERT INTO `lng_modules` VALUES ('style','en','a:56:{s:7:\"sty_all\";s:3:\"All\";s:14:\"sty_background\";s:10:\"Background\";s:25:\"sty_background_attachment\";s:21:\"Background Attachment\";s:20:\"sty_background_color\";s:16:\"Background Color\";s:20:\"sty_background_image\";s:16:\"Background Image\";s:23:\"sty_background_position\";s:19:\"Background Position\";s:21:\"sty_background_repeat\";s:17:\"Background Repeat\";s:10:\"sty_border\";s:6:\"Border\";s:16:\"sty_border_color\";s:12:\"Border Color\";s:16:\"sty_border_style\";s:12:\"Border Style\";s:16:\"sty_border_width\";s:12:\"Border Width\";s:10:\"sty_bottom\";s:6:\"Bottom\";s:9:\"sty_clear\";s:5:\"Clear\";s:9:\"sty_color\";s:6:\"Colour\";s:26:\"sty_confirm_del_ind_styles\";s:45:\"Confirm Deletion of Individual Content Styles\";s:31:\"sty_confirm_del_ind_styles_desc\";s:154:\"All learning modules with individual styles will be assigned to style \'%s\'. This will also delete all individual content styles. Are you sure to continue?\";s:25:\"sty_copy_other_stylesheet\";s:28:\"Copy Style from Local Source\";s:20:\"sty_create_ind_style\";s:23:\"Create Individual Style\";s:25:\"sty_create_new_stylesheet\";s:16:\"Create new Style\";s:10:\"sty_cursor\";s:6:\"Cursor\";s:17:\"sty_default_style\";s:13:\"Default Style\";s:15:\"sty_font_family\";s:11:\"Font Family\";s:13:\"sty_font_size\";s:9:\"Font Size\";s:16:\"sty_font_stretch\";s:12:\"Font Stretch\";s:14:\"sty_font_style\";s:10:\"Font Style\";s:16:\"sty_font_variant\";s:12:\"Font Variant\";s:15:\"sty_font_weight\";s:11:\"Font Weight\";s:21:\"sty_import_stylesheet\";s:12:\"Import Style\";s:20:\"sty_individual_style\";s:16:\"Individual Style\";s:21:\"sty_individual_styles\";s:17:\"Individual Styles\";s:8:\"sty_left\";s:4:\"Left\";s:18:\"sty_letter_spacing\";s:14:\"Letter Spacing\";s:15:\"sty_line_height\";s:11:\"Line Height\";s:10:\"sty_margin\";s:6:\"Margin\";s:22:\"sty_margin_and_padding\";s:18:\"Margin and Padding\";s:18:\"sty_move_lm_styles\";s:32:\"Change Style of Learning Modules\";s:14:\"sty_move_style\";s:12:\"Change Style\";s:23:\"sty_nr_learning_modules\";s:26:\"Number of Learning Modules\";s:11:\"sty_padding\";s:7:\"Padding\";s:9:\"sty_right\";s:5:\"Right\";s:22:\"sty_save_active_styles\";s:18:\"Save Active Styles\";s:24:\"sty_save_standard_styles\";s:20:\"Save Standard Styles\";s:9:\"sty_scope\";s:5:\"Scope\";s:13:\"sty_set_scope\";s:9:\"Set Scope\";s:10:\"sty_source\";s:6:\"Source\";s:11:\"sty_special\";s:7:\"Special\";s:18:\"sty_standard_style\";s:14:\"Standard Style\";s:8:\"sty_text\";s:4:\"Text\";s:14:\"sty_text_align\";s:14:\"Text Alignment\";s:19:\"sty_text_decoration\";s:15:\"Text Decoration\";s:15:\"sty_text_indent\";s:16:\"Text Indentation\";s:18:\"sty_text_transform\";s:14:\"Text Transform\";s:7:\"sty_top\";s:3:\"Top\";s:18:\"sty_vertical_align\";s:18:\"Vertical Alignment\";s:15:\"sty_white_space\";s:11:\"White Space\";s:16:\"sty_word_spacing\";s:12:\"Word Spacing\";}');
INSERT INTO `lng_modules` VALUES ('survey','en','a:460:{s:20:\"SurveyMatrixQuestion\";s:15:\"Matrix Question\";s:20:\"SurveyMetricQuestion\";s:15:\"Metric Question\";s:21:\"SurveyNominalQuestion\";s:16:\"Nominal Question\";s:21:\"SurveyOrdinalQuestion\";s:16:\"Ordinal Question\";s:18:\"SurveyTextQuestion\";s:5:\"Essay\";s:12:\"add_category\";s:10:\"Add Answer\";s:11:\"add_heading\";s:14:\"Add Text Block\";s:31:\"add_limits_for_standard_numbers\";s:89:\"Please enter a lower and upper limit for the standard numbers you want to add as answers.\";s:10:\"add_phrase\";s:10:\"Add Phrase\";s:23:\"add_phrase_introduction\";s:23:\"Please select a Phrase:\";s:20:\"add_standard_numbers\";s:20:\"Add Standard Numbers\";s:24:\"already_completed_survey\";s:81:\"You have already finished the survey! You are not able to enter the survey again.\";s:13:\"anonymization\";s:13:\"Anonymization\";s:32:\"anonymize_anonymous_introduction\";s:222:\"This survey anonymizes all user data. To grant you access to the survey, you must use a 5-character survey code which you can receive from the creator/maintainer of this survey<br />Please enter it in the text field below.\";s:26:\"anonymize_key_introduction\";s:330:\"This survey anonymizes all user data. To grant you access to the survey, a 5-character code was created by the system and will be sent to your ILIAS mail inbox when you start the survey (after answering the first question). Your survey access code is<br /><span class=\"bold\">%s</span><br />Please enter it in the text field below.\";s:22:\"anonymize_personalized\";s:19:\"Personalized Survey\";s:25:\"anonymize_registered_user\";s:24:\"Anonymized Survey Access\";s:29:\"anonymize_resume_introduction\";s:124:\"Please enter your survey access code to resume the survey. It was sent to your ILIAS mail inbox when you started the survey.\";s:28:\"anonymize_survey_description\";s:231:\"Anonymization removes any personal data from the survey statistics. A survey code is a five digit code which is needed to take part in an anonymized survey. For registered ILIAS users, a survey code will be generated automatically.\";s:19:\"anonymize_with_code\";s:24:\"Access with survey codes\";s:24:\"info_anonymize_with_code\";s:41:\"Anonymized Survey with Survey Code Access\";s:30:\"info_anonymize_registered_user\";s:17:\"Anonymized Survey\";s:27:\"info_anonymize_without_code\";s:45:\"Anonymized Survey without Access Restrictions\";s:22:\"anonymize_without_code\";s:11:\"Free access\";s:34:\"anonymous_with_personalized_survey\";s:59:\"You must be a registered user to run a personalized survey!\";s:6:\"answer\";s:6:\"Answer\";s:5:\"apply\";s:5:\"Apply\";s:15:\"arithmetic_mean\";s:15:\"Arithmetic Mean\";s:25:\"ask_insert_questionblocks\";s:78:\"Are you sure you want to insert the following question block(s) to the survey?\";s:20:\"ask_insert_questions\";s:72:\"Are you sure you want to insert the following question(s) to the survey?\";s:4:\"back\";s:7:\"<< Back\";s:6:\"before\";s:6:\"before\";s:20:\"browse_for_questions\";s:13:\"Add Questions\";s:13:\"cancel_survey\";s:18:\"Suspend the Survey\";s:26:\"cannot_create_survey_codes\";s:72:\"You do not possess sufficient permissions to create survey access codes!\";s:18:\"cannot_edit_survey\";s:61:\"You do not possess sufficient permissions to edit the survey!\";s:26:\"cannot_export_questionpool\";s:77:\"You do not possess sufficient permissions to export the survey question pool!\";s:20:\"cannot_export_survey\";s:63:\"You do not possess sufficient permissions to export the survey!\";s:22:\"cannot_maintain_survey\";s:65:\"You do not possess sufficient permissions to maintain the survey!\";s:21:\"cannot_manage_phrases\";s:64:\"You do not possess sufficient permissions to manage the phrases!\";s:25:\"cannot_participate_survey\";s:71:\"You do not possess sufficient permissions to participate in the survey!\";s:24:\"cannot_read_questionpool\";s:73:\"You do not possess sufficient permissions to read the question pool data!\";s:18:\"cannot_read_survey\";s:66:\"You do not possess sufficient permissions to read the survey data!\";s:22:\"cannot_save_metaobject\";s:64:\"You do not possess sufficient permissions to save the meta data!\";s:36:\"cannot_switch_to_online_no_questions\";s:96:\"The status cannot be changed to &quot;online&quot; because there are no questions in the survey!\";s:10:\"categories\";s:7:\"Answers\";s:8:\"category\";s:6:\"Answer\";s:23:\"category_delete_confirm\";s:54:\"Are you sure you want to delete the following answers?\";s:27:\"category_delete_select_none\";s:46:\"Please check at least one answer to delete it!\";s:20:\"category_nr_selected\";s:41:\"Number of users that selected this answer\";s:5:\"chart\";s:5:\"Chart\";s:29:\"check_category_to_save_phrase\";s:52:\"You must select a least one answer to save a phrase!\";s:5:\"codes\";s:12:\"Access Codes\";s:8:\"combobox\";s:8:\"Combobox\";s:13:\"concatenation\";s:13:\"Concatenation\";s:28:\"confirm_delete_all_user_data\";s:60:\"Are you sure you want to delete all user data of the survey?\";s:31:\"confirm_delete_single_user_data\";s:70:\"Are you sure you want to delete the survey data of the selected users?\";s:22:\"confirm_remove_heading\";s:47:\"Are you sure you want to remove the text block?\";s:22:\"confirm_sync_questions\";s:145:\"The question you changed is a copy which has been created for use with the active survey. Do you want to change the original of the question too?\";s:14:\"constraint_add\";s:16:\"Add Precondition\";s:11:\"constraints\";s:13:\"Preconditions\";s:38:\"constraints_first_question_description\";s:90:\"The first entity could not have any preconditions because there are no previous questions.\";s:24:\"constraints_introduction\";s:375:\"For every entity (a single question or a question block with multiple questions) one or more preconditions could be defined. These preconditions will be derived from the answers of the survey participants of questions which occur earlier in the survey. Since the first entity has no previous questions or questionblocks there is no possibility to define preconditions for it.\";s:28:\"constraints_list_of_entities\";s:43:\"Available survey entities for preconditions\";s:33:\"constraints_no_nonessay_available\";s:151:\"There are no previous questions or only essay questions available to calculate preconditions (essay questions are not valid to calculate preconditions)\";s:51:\"constraints_no_questions_or_questionblocks_selected\";s:53:\"Please select at least one question or questionblock!\";s:8:\"contains\";s:8:\"Contains\";s:8:\"continue\";s:11:\"Continue >>\";s:11:\"create_date\";s:7:\"Created\";s:10:\"create_new\";s:10:\"Create New\";s:39:\"create_questionpool_before_add_question\";s:67:\"You must create at least one question pool to store your questions!\";s:8:\"dc_agree\";s:5:\"agree\";s:9:\"dc_always\";s:6:\"always\";s:18:\"dc_definitelyfalse\";s:16:\"definitely false\";s:17:\"dc_definitelytrue\";s:15:\"definitely true\";s:10:\"dc_desired\";s:7:\"desired\";s:11:\"dc_disagree\";s:8:\"disagree\";s:7:\"dc_fair\";s:4:\"fair\";s:8:\"dc_false\";s:5:\"false\";s:7:\"dc_good\";s:4:\"good\";s:12:\"dc_manytimes\";s:10:\"many times\";s:15:\"dc_morenegative\";s:13:\"more negative\";s:15:\"dc_morepositive\";s:13:\"more positive\";s:16:\"dc_mostcertainly\";s:14:\"most certainly\";s:19:\"dc_mostcertainlynot\";s:18:\"most certainly not\";s:7:\"dc_must\";s:4:\"must\";s:10:\"dc_mustnot\";s:8:\"must not\";s:10:\"dc_neutral\";s:7:\"neutral\";s:8:\"dc_never\";s:5:\"never\";s:5:\"dc_no\";s:2:\"no\";s:16:\"dc_notacceptable\";s:14:\"not acceptable\";s:7:\"dc_poor\";s:4:\"poor\";s:9:\"dc_rarely\";s:6:\"rarely\";s:9:\"dc_should\";s:6:\"should\";s:12:\"dc_shouldnot\";s:10:\"should not\";s:12:\"dc_sometimes\";s:9:\"sometimes\";s:16:\"dc_stronglyagree\";s:14:\"strongly agree\";s:18:\"dc_stronglydesired\";s:16:\"strongly desired\";s:19:\"dc_stronglydisagree\";s:17:\"strongly disagree\";s:20:\"dc_stronglyundesired\";s:18:\"strongly undesired\";s:7:\"dc_true\";s:4:\"true\";s:12:\"dc_undecided\";s:9:\"undecided\";s:12:\"dc_undesired\";s:9:\"undesired\";s:10:\"dc_varying\";s:7:\"varying\";s:11:\"dc_verygood\";s:9:\"very good\";s:6:\"dc_yes\";s:3:\"yes\";s:20:\"define_questionblock\";s:21:\"Define Question Block\";s:16:\"delete_user_data\";s:44:\"Delete the Survey Data of the Selected Users\";s:20:\"description_maxchars\";s:86:\"If nothing entered the maximum number of characters for this text answer is unlimited.\";s:9:\"disinvite\";s:9:\"Disinvite\";s:21:\"display_all_available\";s:21:\"Display all available\";s:27:\"dp_standard_attitude_agree5\";s:77:\"Standard Attitude (strongly agree-agree-undecided-disagree-strongly disagree)\";s:35:\"dp_standard_attitude_agree_disagree\";s:34:\"Standard Attitude (agree-disagree)\";s:45:\"dp_standard_attitude_agree_undecided_disagree\";s:44:\"Standard Attitude (agree-undecided-disagree)\";s:29:\"dp_standard_attitude_desired5\";s:81:\"Standard Attitude (strongly desired-desired-neutral-undesired-strongly undesired)\";s:46:\"dp_standard_attitude_desired_neutral_undesired\";s:45:\"Standard Attitude (desired-neutral-undesired)\";s:38:\"dp_standard_attitude_desired_undesired\";s:37:\"Standard Attitude (desired-undesired)\";s:26:\"dp_standard_attitude_good5\";s:59:\"Standard Attitude (very good-good-fair-poor-not acceptable)\";s:44:\"dp_standard_attitude_good_fair_notacceptable\";s:44:\"Standard Attitude (good-fair-not acceptable)\";s:39:\"dp_standard_attitude_good_notacceptable\";s:39:\"Standard Attitude (good-not acceptable)\";s:26:\"dp_standard_attitude_must5\";s:61:\"Standard Attitude (must-should-undecided-should not-must not)\";s:36:\"dp_standard_attitude_shold_shouldnot\";s:37:\"Standard Attitude (should-should not)\";s:47:\"dp_standard_attitude_should_undecided_shouldnot\";s:47:\"Standard Attitude (should-undecided-should not)\";s:32:\"dp_standard_behaviour_certainly5\";s:91:\"Standard Behavior (most certainly-more positive-undecided-more negative-most certainly not)\";s:28:\"dp_standard_behaviour_yes_no\";s:26:\"Standard Behavior (yes-no)\";s:38:\"dp_standard_behaviour_yes_undecided_no\";s:36:\"Standard Behavior (yes-undecided-no)\";s:27:\"dp_standard_beliefs_always5\";s:57:\"Standard Beliefs (always-many times-varying-rarely-never)\";s:32:\"dp_standard_beliefs_always_never\";s:31:\"Standard Beliefs (always-never)\";s:42:\"dp_standard_beliefs_always_sometimes_never\";s:41:\"Standard Beliefs (always-sometimes-never)\";s:25:\"dp_standard_beliefs_true5\";s:72:\"Standard Beliefs (definitely true-true-undecided-false-definitely false)\";s:30:\"dp_standard_beliefs_true_false\";s:29:\"Standard Beliefs (true-false)\";s:40:\"dp_standard_beliefs_true_undecided_false\";s:39:\"Standard Beliefs (true-undecided-false)\";s:19:\"dp_standard_numbers\";s:16:\"Standard Numbers\";s:9:\"duplicate\";s:9:\"Duplicate\";s:13:\"duplicate_svy\";s:16:\"Duplicate Survey\";s:17:\"edit_ask_continue\";s:47:\"Do you want to continue and edit this question?\";s:29:\"edit_constraints_introduction\";s:87:\"You have selected the following question(s)/question block(s) to edit the preconditions\";s:12:\"edit_heading\";s:15:\"Edit Text Block\";s:8:\"end_date\";s:8:\"End Date\";s:16:\"end_date_reached\";s:53:\"You cannot start the survey. The end date is reached!\";s:18:\"enter_anonymous_id\";s:18:\"Survey Access Code\";s:18:\"enter_phrase_title\";s:27:\"Please enter a Phrase Title\";s:25:\"enter_questionblock_title\";s:35:\"Please enter a Questionblock Title!\";s:27:\"enter_valid_number_of_codes\";s:60:\"Please enter a valid number to generate survey access codes!\";s:11:\"enter_value\";s:13:\"Enter a Value\";s:17:\"error_add_heading\";s:39:\"Please enter a text for the text block!\";s:24:\"error_importing_question\";s:77:\"There was an error importing the question(s) from the file you have selected!\";s:33:\"error_retrieving_anonymous_survey\";s:121:\"The system could not find your survey data for survey code &quot;%s&quot;. Please check the survey code you have entered!\";s:16:\"eval_legend_link\";s:72:\"Please refer to the legend for the meaning of the column header symbols.\";s:10:\"evaluation\";s:10:\"Statistics\";s:17:\"evaluation_access\";s:17:\"Evaluation Access\";s:21:\"evaluation_access_all\";s:31:\"Evaluation Access for All Users\";s:29:\"evaluation_access_description\";s:131:\"Usually the access to the survey statistics is only granted to users with write permission for the survey (Evaluation Access = Off)\";s:22:\"evaluation_access_info\";s:40:\"You have access to the survey evaluation\";s:21:\"evaluation_access_off\";s:3:\"Off\";s:30:\"evaluation_access_participants\";s:41:\"Evaluation Access for Survey Participants\";s:20:\"existing_constraints\";s:22:\"Existing Preconditions\";s:4:\"exit\";s:4:\"Exit\";s:12:\"exp_type_csv\";s:27:\"Comma Separated Value (CSV)\";s:14:\"exp_type_excel\";s:15:\"Microsoft Excel\";s:14:\"export_data_as\";s:14:\"Export Data As\";s:23:\"export_all_survey_codes\";s:23:\"Export all Access Codes\";s:28:\"fill_out_all_category_fields\";s:59:\"Please fill out all answer fields before you add a new one!\";s:41:\"fill_out_all_required_fields_add_category\";s:59:\"Please fill out all required fields before you add answers!\";s:44:\"fill_out_all_required_fields_delete_category\";s:62:\"Please fill out all required fields before you delete answers!\";s:42:\"fill_out_all_required_fields_move_category\";s:60:\"Please fill out all required fields before you move answers!\";s:40:\"fill_out_all_required_fields_save_phrase\";s:61:\"Please fill out all required fields before you save a phrase!\";s:6:\"filter\";s:6:\"Filter\";s:25:\"filter_all_question_types\";s:18:\"All Question Types\";s:24:\"filter_all_questionpools\";s:18:\"All Question Pools\";s:26:\"filter_show_question_types\";s:19:\"Show Question Types\";s:25:\"filter_show_questionpools\";s:19:\"Show Question Pools\";s:29:\"form_data_modified_press_save\";s:75:\"The form data has been modified. Press the save button to keep the changes.\";s:15:\"found_questions\";s:15:\"Found Questions\";s:14:\"geometric_mean\";s:14:\"Geometric Mean\";s:13:\"given_answers\";s:13:\"Given Answers\";s:13:\"glossary_term\";s:13:\"Glossary Term\";s:13:\"harmonic_mean\";s:13:\"Harmonic Mean\";s:7:\"heading\";s:10:\"Text Block\";s:10:\"horizontal\";s:10:\"Horizontal\";s:25:\"import_error_closing_file\";s:30:\"Error closing the import file!\";s:25:\"import_error_opening_file\";s:30:\"Error opening the import file!\";s:36:\"import_error_survey_no_proper_values\";s:51:\"The survey properties do not contain proper values!\";s:33:\"import_error_survey_no_properties\";s:53:\"No survey properties found. Cannot import the survey!\";s:23:\"import_no_file_selected\";s:17:\"No file selected!\";s:15:\"import_question\";s:18:\"Import Question(s)\";s:22:\"import_wrong_file_type\";s:16:\"Wrong file type!\";s:12:\"insert_after\";s:12:\"Insert After\";s:13:\"insert_before\";s:13:\"Insert Before\";s:23:\"insert_missing_question\";s:65:\"Please select at least one question to insert it into the survey!\";s:28:\"insert_missing_questionblock\";s:71:\"Please select at least one question block to insert it into the survey!\";s:12:\"introduction\";s:12:\"Introduction\";s:27:\"introduction_manage_phrases\";s:90:\"Manage your own phrases which are available for all the ordinal questions you edit/create.\";s:10:\"invitation\";s:10:\"Invitation\";s:15:\"invitation_mode\";s:15:\"Invitation Mode\";s:14:\"invited_groups\";s:14:\"Invited Groups\";s:13:\"invited_users\";s:13:\"Invited Users\";s:19:\"label_resume_survey\";s:30:\"Enter your 5 digit survey code\";s:11:\"last_update\";s:11:\"Last Update\";s:6:\"layout\";s:6:\"Layout\";s:6:\"legend\";s:6:\"Legend\";s:11:\"lower_limit\";s:11:\"Lower Limit\";s:11:\"maintenance\";s:11:\"Maintenance\";s:14:\"manage_phrases\";s:10:\"My Phrases\";s:8:\"material\";s:8:\"Material\";s:27:\"material_added_successfully\";s:37:\"You successfully set a material link!\";s:13:\"material_file\";s:13:\"Material File\";s:23:\"matrix_error_no_columns\";s:40:\"Please fill in at least one column text!\";s:20:\"matrix_error_no_rows\";s:37:\"Please fill in at least one row text!\";s:17:\"matrix_appearance\";s:10:\"Appearance\";s:29:\"matrix_row_delete_select_none\";s:43:\"Please check at least one row to delete it!\";s:32:\"matrix_column_delete_select_none\";s:46:\"Please check at least one column to delete it!\";s:40:\"matrix_question_radio_button_not_checked\";s:45:\"Please select an option button for every row!\";s:36:\"matrix_question_checkbox_not_checked\";s:49:\"Please check at least one check box in every row!\";s:21:\"matrix_row_separators\";s:14:\"Row Separators\";s:24:\"matrix_column_separators\";s:17:\"Column Separators\";s:31:\"matrix_neutral_column_separator\";s:24:\"Neutral Column Separator\";s:43:\"matrix_neutral_column_separator_description\";s:151:\"Select the check box if you want to have a separator (thick line) between the neutral column and the other columns in the output of the Matrix Question\";s:33:\"matrix_row_separators_description\";s:118:\"Select the check box if you want to have separators (thin lines) between the rows in the output of the Matrix Question\";s:36:\"matrix_column_separators_description\";s:121:\"Select the check box if you want to have separators (thin lines) between the columns in the output of the Matrix Question\";s:25:\"matrix_bipolar_adjectives\";s:18:\"Bipolar Adjectives\";s:37:\"matrix_bipolar_adjectives_description\";s:104:\"You may use a pair of bipolar adjectives to scale the column responses to words, short phrases, or texts\";s:22:\"matrix_column_settings\";s:22:\"Matrix Column Settings\";s:17:\"matrix_subtype_sr\";s:32:\"Option Buttons (Single Response)\";s:17:\"matrix_subtype_mr\";s:31:\"Check Boxes (Multiple Response)\";s:19:\"matrix_subtype_text\";s:4:\"Text\";s:22:\"matrix_subtype_integer\";s:7:\"Integer\";s:21:\"matrix_subtype_double\";s:14:\"Floating Point\";s:19:\"matrix_subtype_date\";s:4:\"Date\";s:21:\"matrix_neutral_answer\";s:64:\"Text for a Neutral Column (\"Not Specified\", \"I don\'t know\" etc.)\";s:23:\"matrix_standard_answers\";s:11:\"Column Text\";s:11:\"matrix_rows\";s:11:\"Matrix Rows\";s:14:\"matrix_columns\";s:14:\"Matrix Columns\";s:19:\"matrix_subtype_time\";s:4:\"Time\";s:26:\"matrix_subtype_description\";s:85:\"Please select one of the above subtypes to define the behaviour of the answer fields.\";s:19:\"matrix_columns_rows\";s:17:\"Column/Row Editor\";s:8:\"maxchars\";s:28:\"Maximum Number of Characters\";s:7:\"maximum\";s:13:\"Maximum Value\";s:6:\"median\";s:6:\"Median\";s:14:\"median_between\";s:7:\"between\";s:8:\"menuback\";s:4:\"Back\";s:16:\"menubacktosurvey\";s:18:\"Back to the Survey\";s:22:\"message_mail_survey_id\";s:239:\"You have started the anonymized survey &quot;%s&quot;. To resume this survey you need the following 5 digit survey code:<br><br><strong>%s</strong><br><br>Resuming a survey is only possible, if you interrupt the survey before finishing it.\";s:30:\"metric_question_floating_point\";s:110:\"The value you entered is a floating point value. Floating point values are not allowed for this question type!\";s:27:\"metric_question_not_a_value\";s:45:\"The value you entered is not a numeric value!\";s:29:\"metric_question_out_of_bounds\";s:67:\"The value you entered is not between the minimum and maximum value!\";s:35:\"metric_subtype_description_interval\";s:287:\"Equivalent intervals between measurements allow a meaningful comparison between arbitrary pairs of measurements. The zero point on the scale is arbitrary, so negative values can be used. Examples of interval values are the year date in many calendars or the temperature in Celsius scale.\";s:43:\"metric_subtype_description_rationonabsolute\";s:267:\"In addition to the interval measurement there are also meaningful ratios between arbitrary pairs of numbers. The zero value on a ratio scale is non-arbitrary. Most physical quantities, such as length in centimeters or duration in seconds are measured on ratio scales.\";s:40:\"metric_subtype_description_ratioabsolute\";s:157:\"The ratio absolute measurement uses natural numbers additional to the non-arbitrary zero point for example the number of children in a family or probability.\";s:7:\"minimum\";s:13:\"Minimum Value\";s:28:\"missing_upper_or_lower_limit\";s:40:\"Please enter a lower and an upper limit!\";s:4:\"mode\";s:19:\"Most Selected Value\";s:21:\"mode_nr_of_selections\";s:16:\"Nr of Selections\";s:9:\"mode_text\";s:26:\"Most Selected Value (Text)\";s:33:\"multiple_choice_multiple_response\";s:35:\"Multiple Choice (Multiple Response)\";s:31:\"multiple_choice_single_response\";s:33:\"Multiple Choice (Single Response)\";s:35:\"multiple_choice_subtype_description\";s:196:\"Choose Multiple Choice (Single Response) if you want the participants to select only one answer and Multiple Choice (Multiple Response) if you want the participants to select one ore more answers.\";s:16:\"new_survey_codes\";s:25:\"new survey access code(s)\";s:18:\"next_question_rows\";s:26:\"Questions %d - %d of %d >>\";s:24:\"no_available_constraints\";s:35:\"There are no preconditions defined!\";s:33:\"no_category_selected_for_deleting\";s:63:\"Please select a least one answer if you want to delete answers!\";s:29:\"no_category_selected_for_move\";s:44:\"Please check at least one answer to move it!\";s:22:\"no_constraints_checked\";s:79:\"Please select a least one question or question block to edit the preconditions!\";s:29:\"no_question_selected_for_move\";s:46:\"Please check at least one question to move it!\";s:32:\"no_question_selected_for_removal\";s:66:\"Please check at least one question or question block to remove it!\";s:27:\"no_questionblocks_available\";s:38:\"There are no question blocks available\";s:22:\"no_questions_available\";s:33:\"There are no questions available!\";s:17:\"no_search_results\";s:28:\"There are no search results!\";s:27:\"no_target_selected_for_move\";s:34:\"You must select a target position!\";s:25:\"no_user_or_group_selected\";s:72:\"Please check an option what are you searching for (users and/or groups)!\";s:23:\"no_user_phrases_defined\";s:44:\"There are no user defined phrases available!\";s:31:\"nominal_question_mr_not_checked\";s:49:\"Please check at least one of the offered answers!\";s:28:\"nominal_question_not_checked\";s:40:\"Please check one of the offered answers!\";s:9:\"non_ratio\";s:8:\"Interval\";s:8:\"not_used\";s:8:\"not used\";s:10:\"obligatory\";s:10:\"obligatory\";s:3:\"off\";s:3:\"Off\";s:7:\"offline\";s:7:\"offline\";s:2:\"on\";s:2:\"On\";s:13:\"on_additional\";s:18:\"On, and additional\";s:2:\"or\";s:2:\"or\";s:28:\"ordinal_question_not_checked\";s:40:\"Please check one of the offered answers!\";s:11:\"orientation\";s:11:\"Orientation\";s:5:\"outro\";s:15:\"Final Statement\";s:28:\"percentage_of_entered_values\";s:43:\"Percentage of users that entered this value\";s:29:\"percentage_of_offered_answers\";s:29:\"Percentage of offered answers\";s:24:\"percentage_of_selections\";s:45:\"Percentage of users that selected this answer\";s:12:\"phrase_saved\";s:34:\"The phrase was saved successfully!\";s:13:\"please_select\";s:19:\"-- please select --\";s:16:\"predefined_users\";s:19:\"Predefined User Set\";s:7:\"preview\";s:7:\"Preview\";s:22:\"previous_question_rows\";s:26:\"<< Questions %d - %d of %d\";s:26:\"qpl_confirm_delete_phrases\";s:56:\"Are you sure you want to delete the following phrase(s)?\";s:28:\"qpl_confirm_delete_questions\";s:58:\"Are you sure you want to delete the following question(s)?\";s:20:\"qpl_copy_select_none\";s:46:\"Please check at least one question to copy it!\";s:39:\"qpl_define_questionblock_select_missing\";s:75:\"Please select a least two questions if you want to define a question block!\";s:29:\"qpl_delete_phrase_select_none\";s:45:\"Please check at least one phrase to delete it\";s:21:\"qpl_delete_rbac_error\";s:45:\"You have no rights to delete the question(s)!\";s:22:\"qpl_delete_select_none\";s:48:\"Please check at least one question to delete it!\";s:22:\"qpl_export_select_none\";s:47:\"Please check at least one question to export it\";s:31:\"qpl_past_questions_confirmation\";s:78:\"Are you sure you want to paste the following question(s) in the question pool?\";s:19:\"qpl_phrases_deleted\";s:18:\"Phrase(s) deleted.\";s:21:\"qpl_questions_deleted\";s:20:\"Question(s) deleted.\";s:20:\"qpl_questions_pasted\";s:19:\"Question(s) pasted.\";s:20:\"qpl_savephrase_empty\";s:28:\"Please enter a phrase title!\";s:21:\"qpl_savephrase_exists\";s:67:\"The phrase title already exists! Please enter another phrase title.\";s:22:\"qpl_unfold_select_none\";s:80:\"Please select at least one question block if you want to unfold question blocks!\";s:31:\"question_contains_no_categories\";s:46:\"There are no answers defined for this question\";s:24:\"question_has_constraints\";s:13:\"Preconditions\";s:13:\"question_icon\";s:13:\"Question Icon\";s:19:\"question_obligatory\";s:27:\"The question is obligatory!\";s:25:\"question_saved_for_upload\";s:224:\"The question was saved automatically in order to reserve hard disk space to store the uploaded file. If you cancel this form now, be aware that you must delete the question in the question pool if you do not want to keep it!\";s:13:\"question_type\";s:13:\"Question Type\";s:13:\"questionblock\";s:14:\"Question Block\";s:29:\"questionblock_has_constraints\";s:13:\"Preconditions\";s:18:\"questionblock_icon\";s:18:\"Questionblock Icon\";s:14:\"questionblocks\";s:15:\"Question Blocks\";s:9:\"questions\";s:9:\"Questions\";s:18:\"questions_inserted\";s:21:\"Question(s) inserted!\";s:17:\"questions_removed\";s:45:\"Question(s) and/or question block(s) removed!\";s:12:\"questiontype\";s:13:\"Question Type\";s:14:\"ratio_absolute\";s:14:\"Ratio-Absolute\";s:18:\"ratio_non_absolute\";s:18:\"Ratio-Non-Absolute\";s:19:\"ratio_scale_ge_zero\";s:65:\"The minimum value for a ratio scale must be greater or equal zero\";s:15:\"remove_question\";s:6:\"Remove\";s:16:\"remove_questions\";s:99:\"Are you sure you want to remove the following question(s) and/or question block(s) from the survey?\";s:12:\"reset_filter\";s:12:\"Reset Filter\";s:7:\"results\";s:7:\"Results\";s:13:\"resume_survey\";s:17:\"Resume the Survey\";s:19:\"save_back_to_survey\";s:30:\"Save and go back to the survey\";s:21:\"save_obligatory_state\";s:22:\"Save Obligatory States\";s:11:\"save_phrase\";s:14:\"Save as Phrase\";s:34:\"save_phrase_categories_not_checked\";s:66:\"Please check at least two answers to save answers in a new phrase!\";s:24:\"save_phrase_introduction\";s:175:\"If you want to save the answers below as default phrase, please enter a phrase title. You can access a default phrase whenever you want to add a phrase to an ordinal question.\";s:16:\"search_field_all\";s:20:\"Search in all fields\";s:10:\"search_for\";s:10:\"Search for\";s:13:\"search_groups\";s:12:\"Found Groups\";s:17:\"search_invitation\";s:36:\"Search for users or groups to invite\";s:16:\"search_questions\";s:16:\"Search Questions\";s:12:\"search_roles\";s:11:\"Found Roles\";s:11:\"search_term\";s:11:\"Search Term\";s:15:\"search_type_all\";s:28:\"Search in all Question Types\";s:11:\"found_users\";s:11:\"Found Users\";s:13:\"select_option\";s:31:\"--- Please select an option ---\";s:20:\"select_phrase_to_add\";s:49:\"Please select a phrase to add it to the question!\";s:21:\"select_prior_question\";s:23:\"Select a prior question\";s:19:\"select_questionpool\";s:59:\"Please select a question pool to store the created question\";s:25:\"select_questionpool_short\";s:20:\"Question Pool Survey\";s:15:\"select_relation\";s:17:\"Select a Relation\";s:17:\"select_svy_option\";s:30:\"--- Please select a survey ---\";s:31:\"select_target_position_for_move\";s:88:\"Please select a target position to move the answers and press one of the insert buttons!\";s:40:\"select_target_position_for_move_question\";s:92:\"Please select a target position to move the question(s) and press one of the insert buttons!\";s:12:\"select_value\";s:14:\"Select a Value\";s:9:\"selection\";s:9:\"Selection\";s:10:\"set_filter\";s:10:\"Set Filter\";s:17:\"show_questiontext\";s:25:\"Display the Question Text\";s:29:\"show_questiontext_description\";s:211:\"If this checkbox is selected, for every question in the question block the question text will be shown. If this checkbox is not selected, the question text of every question in the question block will be hidden.\";s:7:\"skipped\";s:7:\"skipped\";s:22:\"spl_general_properties\";s:18:\"General Properties\";s:19:\"spl_online_property\";s:6:\"Online\";s:31:\"spl_online_property_description\";s:64:\"If the questionpool is not online, it cannot be used in surveys.\";s:26:\"spl_select_file_for_import\";s:34:\"You must select a file for import!\";s:10:\"start_date\";s:10:\"Start Date\";s:22:\"start_date_not_reached\";s:60:\"You cannot start the survey until the start date is reached!\";s:12:\"start_survey\";s:12:\"Start Survey\";s:22:\"subject_mail_survey_id\";s:25:\"Your survey code for \"%s\"\";s:7:\"subtype\";s:7:\"Subtype\";s:11:\"survey_code\";s:18:\"Survey Access Code\";s:24:\"survey_code_message_sent\";s:75:\"A survey code which allows you to resume the survey was sent to your INBOX!\";s:20:\"survey_code_no_codes\";s:49:\"You have not created any survey access codes yet.\";s:15:\"survey_code_url\";s:21:\"URL for Direct Access\";s:20:\"survey_code_url_name\";s:40:\"URL (use right mouse button to copy URL)\";s:16:\"survey_code_used\";s:13:\"Code was used\";s:17:\"survey_codes_lang\";s:40:\"ILIAS language for the direct access URL\";s:29:\"survey_codes_no_anonymization\";s:82:\"You must create an anonymized survey with access codes to create new access codes!\";s:39:\"survey_error_insert_incomplete_question\";s:82:\"You tried to add an incomplete question to the survey! The question was not added.\";s:13:\"survey_finish\";s:13:\"Finish Survey\";s:26:\"survey_text_textwidth_desc\";s:54:\"Enter the width in characters for the text input field\";s:27:\"survey_text_textheight_desc\";s:55:\"Enter the height in characters for the text input field\";s:15:\"survey_finished\";s:63:\"You have finished the survey. Thank you for your participation!\";s:27:\"survey_has_datasets_warning\";s:134:\"The survey already contains datasets. You cannot edit the survey questions until you remove these datasets in the maintenance section.\";s:17:\"survey_is_offline\";s:51:\"You cannot start the survey! The survey is offline.\";s:11:\"survey_next\";s:7:\"Next >>\";s:22:\"survey_offline_message\";s:42:\"Can\'t invite users. The survey is offline!\";s:21:\"survey_online_warning\";s:59:\"The survey is online. You cannot edit the survey questions!\";s:15:\"survey_previous\";s:11:\"<< Previous\";s:22:\"survey_question_editor\";s:17:\"List of Questions\";s:26:\"survey_question_obligatory\";s:58:\"This question is obligatory. You must answer the question!\";s:24:\"survey_question_optional\";s:10:\"(Optional)\";s:16:\"survey_questions\";s:9:\"Questions\";s:33:\"survey_selected_user_data_deleted\";s:64:\"The survey data of the selected user(s) was deleted successfully\";s:18:\"survey_skip_finish\";s:22:\"Skip and Finish Survey\";s:16:\"survey_skip_next\";s:7:\"Skip >>\";s:20:\"survey_skip_previous\";s:7:\"<< Skip\";s:17:\"survey_skip_start\";s:25:\"Skip and Go To Start Page\";s:12:\"survey_start\";s:16:\"Go To Start Page\";s:23:\"survey_use_start_button\";s:49:\"You must enter the survey using the start button!\";s:25:\"svy_all_user_data_deleted\";s:46:\"All user data of this survey has been deleted!\";s:40:\"svy_check_evaluation_access_introduction\";s:136:\"Since this survey evaluation is only accessable by survey participants you need to enter your survey access code to open the evaluation.\";s:42:\"svy_check_evaluation_authentication_needed\";s:21:\"Authentication needed\";s:30:\"svy_check_evaluation_wrong_key\";s:127:\"You entered a wrong survey access code or you have not participated the survey. Your access to the survey evaluation is denied.\";s:22:\"svy_create_export_file\";s:18:\"Create Export File\";s:24:\"svy_delete_all_user_data\";s:20:\"Delete all User Data\";s:18:\"svy_eval_cumulated\";s:17:\"Cumulated Results\";s:15:\"svy_eval_detail\";s:27:\"Cumulated Results (Details)\";s:13:\"svy_eval_user\";s:21:\"User Specific Results\";s:16:\"svy_export_files\";s:12:\"Export Files\";s:8:\"svy_file\";s:4:\"File\";s:22:\"svy_general_properties\";s:18:\"General Properties\";s:38:\"svy_maintenance_information_no_results\";s:108:\"There are no existing user datasets for the survey. You need at least one user dataset to maintain the data.\";s:18:\"svy_missing_author\";s:92:\"You have not entered the author\'s name in the survey properties! Please add an authors name.\";s:21:\"svy_missing_questions\";s:92:\"You do not have any questions in the survey! Please add at least one question to the survey.\";s:17:\"svy_missing_title\";s:89:\"You have not entered a survey title! Please go to the metadata section and enter a title.\";s:14:\"svy_page_error\";s:114:\"There was an error answering a survey question. Please refer to the question to get more information on the error!\";s:15:\"svy_page_errors\";s:118:\"There were errors answering the survey questions. Please refer to the questions to get more information on the errors!\";s:26:\"svy_select_file_for_import\";s:34:\"You must select a file for import!\";s:24:\"svy_select_questionpools\";s:61:\"Please select a question pool to store the imported questions\";s:18:\"svy_select_surveys\";s:38:\"Please select a survey for duplication\";s:30:\"svy_selected_user_data_deleted\";s:64:\"The survey data of the selected user(s) was deleted successfully\";s:23:\"svy_show_questiontitles\";s:30:\"Show Question Titles in Survey\";s:8:\"svy_size\";s:4:\"Size\";s:26:\"svy_statistical_evaluation\";s:22:\"Statistical Evaluation\";s:18:\"svy_status_missing\";s:51:\"There are required elements missing in this survey!\";s:27:\"svy_status_missing_elements\";s:35:\"The following elements are missing:\";s:13:\"svy_status_ok\";s:62:\"The status of the survey is OK. There are no missing elements.\";s:26:\"text_maximum_chars_allowed\";s:91:\"Please do not enter more than a maximum of %s characters. Any characters above will be cut.\";s:28:\"text_question_not_filled_out\";s:33:\"Please fill out the answer field!\";s:18:\"text_resume_survey\";s:355:\"You are trying to resume an anonymized survey. To continue the survey with your previously entered values please enter the 5 digit survey code which you received after starting the survey (it was sent with a message to your ILIAS mail folder). Instead of typing your survey code you also can copy it from your inbox and paste it into the text field below.\";s:19:\"title_resume_survey\";s:37:\"Resume the Survey - Enter Survey Code\";s:6:\"unfold\";s:6:\"Unfold\";s:15:\"unlimited_users\";s:9:\"Unlimited\";s:17:\"uploaded_material\";s:17:\"Uploaded Material\";s:11:\"upper_limit\";s:11:\"Upper Limit\";s:27:\"upper_limit_must_be_greater\";s:53:\"The upper limit must be greater than the lower limit!\";s:4:\"used\";s:4:\"used\";s:14:\"users_answered\";s:14:\"Users Answered\";s:13:\"users_skipped\";s:13:\"Users Skipped\";s:16:\"value_nr_entered\";s:39:\"Number of users that entered that value\";s:6:\"values\";s:6:\"Values\";s:8:\"vertical\";s:8:\"Vertical\";s:29:\"view_constraints_introduction\";s:75:\"You are viewing the preconditions of the following question/question block:\";s:11:\"view_phrase\";s:11:\"View Phrase\";s:23:\"warning_question_in_use\";s:345:\"Warning! The question you want to edit is in use by the surveys listed below. If you decide to continue and save/apply the question, all answers of the surveys listed below will be deleted. If you want to change the question and use it in another survey, please choose duplicate in the question browser to create a new instance of this question.\";s:29:\"warning_question_not_complete\";s:29:\"The question is not complete!\";s:36:\"wrong_categories_selected_for_insert\";s:95:\"ILIAS could not perform the desired action. Please check exactly one answer as target position!\";s:22:\"wrong_survey_code_used\";s:92:\"You cannot enter the survey, because you tried to start it with an unauthorized survey code.\";s:36:\"msg_enter_value_for_valid_constraint\";s:52:\"Please enter a value to create a valid precondition!\";s:24:\"no_user_of_group_invited\";s:113:\"All users of the selected group(s) did not possess sufficient permissions to run the survey. No user was invited.\";s:23:\"no_user_of_role_invited\";s:112:\"All users of the selected role(s) did not possess sufficient permissions to run the survey. No user was invited.\";s:12:\"specialusers\";s:13:\"Special Users\";s:12:\"search_users\";s:12:\"Search Users\";s:18:\"adm_no_users_found\";s:49:\"No users were found that match the search string.\";s:27:\"adm_search_string_too_small\";s:57:\"Please enter at least two characters in the search field!\";s:22:\"adm_search_select_user\";s:32:\"Please select at least one user!\";s:20:\"adm_no_special_users\";s:79:\"There are no special users defined who are able to run a survey more than once.\";s:17:\"adm_special_users\";s:57:\"Special users who are able to run a survey more than once\";s:17:\"adm_removed_users\";s:13:\"Users removed\";s:22:\"adm_remove_select_user\";s:44:\"Please select at least one user for removal!\";s:20:\"use_google_chart_api\";s:20:\"Use Google Chart API\";s:25:\"use_google_chart_api_desc\";s:278:\"If checked, the charts in the cumulated results details of the survey statistics are drawn using the <a href=\"http://code.google.com/apis/chart/\" target=\"_blank\">Google Chart API</a>. Please note that a permanent internet connection is required for the Google Chart API to work.\";}');
INSERT INTO `lng_modules` VALUES ('trac','en','a:233:{s:13:\"found_objects\";s:13:\"Found Objects\";s:22:\"found_too_much_objects\";s:94:\"Thereby more than %s objects totally were found. Therefore refine your search request, please.\";s:16:\"info_all_objects\";s:67:\"The following user tracking refers to all objects of the type \'%s\'.\";s:15:\"info_dwell_time\";s:88:\"Attention: The total dwell time of an object isn\'t addicted to the given period of time!\";s:18:\"info_found_objects\";s:114:\"The user tracking refers to the following objects of the type \'%s\' that were found according to your search terms.\";s:18:\"info_valid_request\";s:55:\"The maximum valid time between two requests of an user.\";s:10:\"last_login\";s:10:\"Last login\";s:26:\"meta_typical_learning_time\";s:21:\"Typical learning time\";s:14:\"newUT_settings\";s:26:\"Learning Module Statistics\";s:9:\"obj_types\";s:12:\"Object Types\";s:16:\"search_area_info\";s:25:\"Please choose one object.\";s:12:\"search_terms\";s:14:\"Search term(s)\";s:10:\"select_one\";s:24:\"Please select one object\";s:12:\"stats_access\";s:6:\"Access\";s:14:\"stats_accesses\";s:8:\"Accesses\";s:9:\"stats_all\";s:3:\"All\";s:13:\"stats_chapter\";s:7:\"Chapter\";s:33:\"stats_chapter_average_page_number\";s:35:\"Average Number of Pages per Chapter\";s:28:\"stats_chapter_depth_coverage\";s:29:\"Degree of Coverage with Depth\";s:27:\"stats_chapter_fewest_access\";s:13:\"Fewest Access\";s:21:\"stats_chapter_listing\";s:15:\"Chapter Listing\";s:44:\"stats_chapter_longest_total_dwell_time_depth\";s:22:\"Total Dwell Time Depth\";s:31:\"stats_chapter_most_access_depth\";s:22:\"Most Access with Depth\";s:24:\"stats_chapter_most_pages\";s:10:\"Most Pages\";s:20:\"stats_chapter_number\";s:18:\"Number of Chapters\";s:23:\"stats_chapter_statisics\";s:18:\"Chapter Statistics\";s:40:\"stats_chapter_stubbiest_total_dwell_time\";s:26:\"Stubbiest Total Dwell Time\";s:17:\"stats_chapter_top\";s:36:\"Top-Chapter (variance, access, etc.)\";s:29:\"stats_chapter_total_statistic\";s:23:\"Total-Chapter-Statistic\";s:12:\"stats_choice\";s:9:\"Selection\";s:13:\"stats_current\";s:9:\"Currently\";s:11:\"stats_depth\";s:5:\"Depth\";s:14:\"stats_duration\";s:8:\"Duration\";s:16:\"stats_equivalent\";s:16:\"is equivalent to\";s:10:\"stats_hits\";s:4:\"Hits\";s:10:\"stats_hour\";s:1:\"h\";s:14:\"stats_interval\";s:8:\"Interval\";s:25:\"stats_interval_dwell_time\";s:22:\"Interval of Dwell Time\";s:26:\"stats_interval_page_access\";s:27:\"Interval of Access to Pages\";s:10:\"stats_last\";s:4:\"Last\";s:12:\"stats_legend\";s:6:\"Legend\";s:21:\"stats_measurable_hits\";s:39:\"Measurable Hits (Hits within a Session)\";s:12:\"stats_minute\";s:1:\"m\";s:16:\"stats_navigation\";s:57:\"Navigation/Observation Model (requires JRE 1.5 or higher)\";s:19:\"stats_new_selection\";s:13:\"New Selection\";s:16:\"stats_occurrence\";s:10:\"Occurrence\";s:8:\"stats_of\";s:2:\"of\";s:10:\"stats_page\";s:4:\"Page\";s:25:\"stats_page_average_access\";s:26:\"Average of Access to pages\";s:29:\"stats_page_average_dwell_time\";s:30:\"Average of Dwell Time to Pages\";s:27:\"stats_page_deviation_access\";s:28:\"Deviation of Access to Pages\";s:31:\"stats_page_deviation_dwell_time\";s:32:\"Deviation of Dwell Time to Pages\";s:24:\"stats_page_fewest_access\";s:13:\"Fewest Access\";s:28:\"stats_page_highest_deviation\";s:17:\"Highest Deviation\";s:27:\"stats_page_highest_varcoeff\";s:29:\"Highest Variation Coefficient\";s:26:\"stats_page_least_deviation\";s:15:\"Least Deviation\";s:18:\"stats_page_listing\";s:12:\"Page Listing\";s:37:\"stats_page_longest_average_dwell_time\";s:18:\"Average Dwell Time\";s:35:\"stats_page_longest_total_dwell_time\";s:16:\"Total Dwell Time\";s:26:\"stats_page_lowest_varcoeff\";s:28:\"Lowest Variation Coefficient\";s:24:\"stats_page_median_access\";s:25:\"Median of Access to Pages\";s:28:\"stats_page_median_dwell_time\";s:29:\"Median of Dwell Time to Pages\";s:22:\"stats_page_mode_access\";s:23:\"Mode of Access to Pages\";s:22:\"stats_page_most_access\";s:13:\"Most Accesses\";s:17:\"stats_page_number\";s:15:\"Number of Pages\";s:24:\"stats_page_number_access\";s:25:\"Number of Access to Pages\";s:23:\"stats_page_range_access\";s:24:\"Range of Access to Pages\";s:27:\"stats_page_range_dwell_time\";s:28:\"Range of Dwell Time to Pages\";s:39:\"stats_page_stubbiest_average_dwell_time\";s:28:\"Stubbiest Average Dwell Time\";s:37:\"stats_page_stubbiest_total_dwell_time\";s:26:\"Stubbiest Total Dwell Time\";s:27:\"stats_page_total_dwell_time\";s:22:\"Total-Pages-Dwell time\";s:26:\"stats_page_total_statistic\";s:21:\"Total-Pages-Statistic\";s:26:\"stats_page_varcoeff_access\";s:40:\"Variation Coefficient of Access to Pages\";s:30:\"stats_page_varcoeff_dwell_time\";s:44:\"Variation Coefficient of Dwell time to Pages\";s:26:\"stats_page_variance_access\";s:27:\"Variance of Access to Pages\";s:30:\"stats_page_variance_dwell_time\";s:31:\"Variance of Dwell Time to Pages\";s:11:\"stats_pages\";s:5:\"Pages\";s:21:\"stats_pages_statisics\";s:15:\"Page Statistics\";s:9:\"stats_sec\";s:3:\"sec\";s:13:\"stats_sel_lng\";s:7:\"English\";s:13:\"stats_session\";s:7:\"Session\";s:28:\"stats_session_average_length\";s:22:\"Average Session Length\";s:33:\"stats_session_average_page_access\";s:35:\"Average Access to Pages per Session\";s:23:\"stats_session_evaluable\";s:18:\"Evaluable Sessions\";s:30:\"stats_session_evaluable_access\";s:24:\"Evaluable Session Access\";s:27:\"stats_session_evaluable_usr\";s:14:\"Evaluable User\";s:26:\"stats_session_involved_usr\";s:24:\"Number of involved Users\";s:21:\"stats_session_listing\";s:15:\"Session Listing\";s:21:\"stats_session_longest\";s:15:\"Longest Session\";s:40:\"stats_session_longest_total_duration_usr\";s:31:\"Longest Total Duration per User\";s:18:\"stats_session_most\";s:13:\"Most Sessions\";s:20:\"stats_session_number\";s:18:\"Number of Sessions\";s:28:\"stats_session_total_duration\";s:30:\"Total Duration of all Sessions\";s:29:\"stats_session_total_statistic\";s:23:\"Total-Session-Statistic\";s:14:\"stats_sessions\";s:8:\"Sessions\";s:24:\"stats_sessions_statisics\";s:18:\"Session Statistics\";s:11:\"stats_start\";s:5:\"Start\";s:15:\"stats_summation\";s:9:\"Summation\";s:18:\"stats_tracked_user\";s:14:\"Selected Users\";s:11:\"stats_until\";s:5:\"until\";s:10:\"stats_user\";s:7:\"User(s)\";s:19:\"stats_user_selected\";s:13:\"User selected\";s:10:\"stats_with\";s:4:\"with\";s:16:\"total_dwell_time\";s:16:\"Total Dwell Time\";s:14:\"trac_activated\";s:18:\"Tracking Activated\";s:16:\"trac_active_both\";s:45:\"User Tracking and Learning Progress Activated\";s:19:\"trac_active_lp_only\";s:27:\"Learning Progress Activated\";s:19:\"trac_active_ut_only\";s:23:\"User Tracking Activated\";s:24:\"trac_added_no_shown_list\";s:36:\"The selected objects will be hidden.\";s:15:\"trac_anonymized\";s:10:\"Anonymized\";s:20:\"trac_anonymized_info\";s:46:\"If enabled, all statistics will be anonymized.\";s:13:\"trac_assigned\";s:8:\"Assigned\";s:16:\"trac_assignments\";s:11:\"Assignments\";s:10:\"trac_below\";s:6:\"Below:\";s:22:\"trac_collection_assign\";s:6:\"Assign\";s:24:\"trac_collection_deassign\";s:8:\"Deassign\";s:12:\"trac_comment\";s:7:\"Comment\";s:13:\"trac_comments\";s:8:\"Comments\";s:14:\"trac_completed\";s:9:\"Completed\";s:20:\"trac_crs_assignments\";s:26:\"Assignment of Course Items\";s:14:\"trac_crs_items\";s:23:\"Assignable Course Items\";s:16:\"trac_crs_members\";s:20:\"Course Participants:\";s:16:\"trac_crs_objects\";s:40:\"Learning Progress of Course Participants\";s:24:\"trac_crs_releavant_items\";s:12:\"Course Items\";s:23:\"trac_crs_relevant_items\";s:16:\"Course Materials\";s:20:\"trac_edit_collection\";s:120:\"Please assign materials. If the status of all assigned items is \'Completed\' the overall status is completed by the user.\";s:18:\"trac_edit_progress\";s:22:\"Edit Learning Progress\";s:14:\"trac_edit_time\";s:15:\"Processing Time\";s:16:\"trac_edit_visits\";s:78:\"Please define the number of visits that is neccessary to complete this object.\";s:16:\"trac_edited_scos\";s:17:\"Processed Content\";s:24:\"trac_editing_time_passed\";s:19:\"Editing Time Passed\";s:11:\"trac_failed\";s:6:\"Failed\";s:16:\"trac_filter_area\";s:4:\"Area\";s:18:\"trac_filter_hidden\";s:6:\"Hidden\";s:25:\"trac_filter_limit_reached\";s:78:\"The number of hits is limited to %s. Please use the filter to reduce the hits.\";s:21:\"trac_filter_no_access\";s:16:\"No objects found\";s:16:\"trac_filter_none\";s:4:\"None\";s:22:\"trac_filter_repository\";s:17:\"In the Repository\";s:24:\"trac_fold_relevant_items\";s:14:\"Folder Content\";s:23:\"trac_grp_relevant_items\";s:15:\"Group Materials\";s:16:\"trac_head_timing\";s:10:\"Edit Until\";s:9:\"trac_hide\";s:4:\"Hide\";s:16:\"trac_in_progress\";s:11:\"In Progress\";s:18:\"trac_inactive_both\";s:47:\"User Tracking and Learning Progress Deactivated\";s:16:\"trac_info_edited\";s:74:\"Set the status to \'Completed\' if you think you have processed all content.\";s:16:\"trac_last_access\";s:11:\"Last Access\";s:22:\"trac_learning_progress\";s:17:\"Learning Progress\";s:33:\"trac_learning_progress_tbl_header\";s:21:\"Learning Progress of:\";s:18:\"trac_lm_statistics\";s:17:\"Access Statistics\";s:21:\"trac_lp_determination\";s:38:\"Learning Progress Status Determination\";s:30:\"trac_lp_determination_info_crs\";s:69:\"Select the items that determine the overall learning progress status.\";s:30:\"trac_lp_determination_info_sco\";s:98:\"Select the items that determine the overall learning progress status of the SCORM learning module.\";s:14:\"trac_lp_filter\";s:6:\"Filter\";s:9:\"trac_mark\";s:4:\"Mark\";s:10:\"trac_marks\";s:5:\"Marks\";s:9:\"trac_mode\";s:4:\"Mode\";s:20:\"trac_mode_collection\";s:34:\"Automatic by Collection of Objects\";s:21:\"trac_mode_deactivated\";s:11:\"Deactivated\";s:27:\"trac_mode_exercise_returned\";s:15:\"Exercise Solved\";s:16:\"trac_mode_manual\";s:17:\"Manual by Learner\";s:20:\"trac_mode_objectives\";s:32:\"Automatic by Learning Objectives\";s:15:\"trac_mode_scorm\";s:38:\"Automatic by Collection of SCORM Items\";s:23:\"trac_mode_scorm_package\";s:32:\"Automatic by SCORM Course Status\";s:20:\"trac_mode_scorm_aicc\";s:38:\"Automatic by Collection of SCORM Items\";s:23:\"trac_mode_test_finished\";s:13:\"Test Finished\";s:21:\"trac_mode_test_passed\";s:11:\"Test Passed\";s:13:\"trac_mode_tlt\";s:21:\"Typical Learning Time\";s:16:\"trac_mode_visits\";s:16:\"Number of Visits\";s:24:\"trac_modifications_saved\";s:14:\"Saved settings\";s:10:\"trac_modus\";s:4:\"Mode\";s:17:\"trac_no_attempted\";s:13:\"Not Attempted\";s:15:\"trac_no_content\";s:53:\"No information about the learning progress available.\";s:24:\"trac_no_sahs_items_found\";s:17:\"No objects found.\";s:17:\"trac_not_accessed\";s:12:\"Not Accessed\";s:17:\"trac_not_assigned\";s:12:\"Not Assigned\";s:18:\"trac_not_attempted\";s:13:\"Not Attempted\";s:18:\"trac_not_completed\";s:13:\"Not Completed\";s:21:\"trac_not_participated\";s:16:\"Not Participated\";s:19:\"trac_not_registered\";s:14:\"Not Registered\";s:15:\"trac_num_visits\";s:16:\"Number of Visits\";s:12:\"trac_objects\";s:26:\"Learning Progress of Users\";s:16:\"trac_occurrences\";s:5:\"Path:\";s:17:\"trac_participated\";s:12:\"Participated\";s:20:\"trac_processing_time\";s:23:\"Assumed Processing Time\";s:13:\"trac_progress\";s:26:\"Personal Learning Progress\";s:10:\"trac_query\";s:20:\"Title / Description:\";s:23:\"trac_reached_objectives\";s:27:\"Reached Learning Objectives\";s:19:\"trac_reached_points\";s:14:\"Achieved Score\";s:19:\"trac_reached_visits\";s:15:\"Required Visits\";s:12:\"trac_refresh\";s:7:\"Refresh\";s:15:\"trac_registered\";s:10:\"Registered\";s:20:\"trac_required_visits\";s:25:\"Number of Required Visits\";s:24:\"trac_sahs_relevant_items\";s:13:\"Content Items\";s:15:\"trac_select_one\";s:21:\"You made no selection\";s:13:\"trac_settings\";s:8:\"Settings\";s:19:\"trac_settings_saved\";s:15:\"Saved settings.\";s:9:\"trac_show\";s:22:\"Show Learning Progress\";s:16:\"trac_show_hidden\";s:4:\"Show\";s:15:\"trac_spent_time\";s:10:\"Spent Time\";s:11:\"trac_status\";s:6:\"Status\";s:16:\"trac_time_passed\";s:21:\"Editing Time Exceeded\";s:17:\"trac_total_online\";s:17:\"Total Time Online\";s:21:\"trac_update_edit_user\";s:14:\"Saved settings\";s:19:\"trac_updated_status\";s:31:\"Saved learning progress status.\";s:14:\"trac_user_data\";s:9:\"User Data\";s:20:\"trac_user_activities\";s:20:\"Benutzeraktivitäten\";s:23:\"trac_repository_changes\";s:25:\"Changes in the repository\";s:13:\"trac_usr_list\";s:5:\"Users\";s:18:\"trac_valid_request\";s:26:\"Max. Time Between Requests\";s:13:\"trac_view_crs\";s:14:\"Back to Course\";s:14:\"trac_view_list\";s:12:\"Back to List\";s:11:\"trac_visits\";s:16:\"Number of Visits\";s:16:\"trac_visits_info\";s:37:\"Every page visit counts as one visit.\";s:28:\"tracking_time_span_not_valid\";s:39:\"Please enter a valid number of seconds.\";s:9:\"view_mode\";s:9:\"View Mode\";s:18:\"vm_access_of_users\";s:15:\"Access of Users\";s:17:\"vm_days_of_period\";s:14:\"Days of Period\";s:15:\"vm_times_of_day\";s:13:\"Times of Days\";s:26:\"trac_anonymized_info_short\";s:12:\"(Anonymized)\";s:26:\"trac_mode_deactivated_info\";s:31:\"No progress will be calculated.\";s:18:\"trac_mode_tlt_info\";s:77:\"Users who reached the Typical Learning Time will gain the status \'Completed\'.\";s:21:\"trac_mode_visits_info\";s:83:\"Define the number of visits that is required for completing this learning material.\";s:21:\"trac_mode_manual_info\";s:62:\"Users have to decide whether their status is completed or not.\";s:25:\"trac_mode_objectives_info\";s:109:\"The learning progress will be calculated automatically according to the number of passed learning objectives.\";s:25:\"trac_mode_collection_info\";s:70:\"Define the materials that will determine the learning progress status.\";s:20:\"trac_mode_scorm_info\";s:80:\"The learning progress status will be determined by the status of selected SCO\'s.\";s:28:\"trac_mode_scorm_package_info\";s:92:\"The learning progress status will be determined by the SCORM course package status directly.\";s:28:\"trac_mode_test_finished_info\";s:39:\"Users have to finish a test completely.\";s:26:\"trac_mode_test_passed_info\";s:71:\"The test has to be passed by an user to receive the status \'Completed\'.\";s:32:\"trac_mode_exercise_returned_info\";s:49:\"The status \'Completed\' can be set only by tutors.\";s:25:\"trac_mode_manual_by_tutor\";s:15:\"Manual by Tutor\";s:30:\"trac_mode_manual_by_tutor_info\";s:45:\"The overall status can only be set by tutors.\";s:15:\"trac_mode_event\";s:25:\"Participation in Sessions\";}');
INSERT INTO `lng_modules` VALUES ('exercise','en','a:11:{s:11:\"exc_comment\";s:7:\"Comment\";s:23:\"exc_comment_for_learner\";s:19:\"Comment for Learner\";s:10:\"exc_failed\";s:6:\"Failed\";s:23:\"exc_feedback_from_tutor\";s:19:\"Feedback from Tutor\";s:11:\"exc_grading\";s:7:\"Grading\";s:8:\"exc_mark\";s:4:\"Mark\";s:13:\"exc_notgraded\";s:10:\"Not Graded\";s:10:\"exc_passed\";s:6:\"Passed\";s:13:\"exc_send_mail\";s:9:\"Send Mail\";s:19:\"exc_your_submission\";s:15:\"Your Submission\";s:19:\"exc_crs_add_members\";s:27:\"Add students of this course\";}');
INSERT INTO `lng_modules` VALUES ('block_html','en','a:3:{s:21:\"block_html_block_head\";s:10:\"HTML Block\";s:22:\"block_html_block_title\";s:5:\"Title\";s:24:\"block_html_block_content\";s:7:\"Content\";}');
INSERT INTO `lng_modules` VALUES ('news','en','a:79:{s:27:\"news_block_news_for_context\";s:4:\"News\";s:18:\"news_no_news_items\";s:18:\"No news available.\";s:22:\"news_block_information\";s:125:\"The <b>News</b> block lists all news that are related to the <b>Personal Items</b> you have selected on the personal desktop.\";s:15:\"news_rss_period\";s:10:\"RSS Period\";s:18:\"news_period_x_days\";s:12:\"Last %s Days\";s:18:\"news_period_1_week\";s:9:\"Last Week\";s:19:\"news_period_x_weeks\";s:13:\"Last %s Weeks\";s:19:\"news_period_1_month\";s:10:\"Last Month\";s:20:\"news_period_x_months\";s:14:\"Last %s Months\";s:18:\"news_period_1_year\";s:9:\"Last Year\";s:26:\"news_allow_shorter_periods\";s:21:\"Allow Shorter Periods\";s:25:\"news_allow_longer_periods\";s:20:\"Allow Longer Periods\";s:31:\"news_allow_shorter_periods_info\";s:58:\"Users may select shorter news periods on personal desktop.\";s:30:\"news_allow_longer_periods_info\";s:57:\"Users may select longer news periods on personal desktop.\";s:20:\"news_x_files_created\";s:25:\"%s Files have been added.\";s:20:\"news_x_files_updated\";s:27:\"%s Files have been updated.\";s:19:\"news_1_file_created\";s:22:\"1 File has been added.\";s:19:\"news_1_file_updated\";s:24:\"1 File has been updated.\";s:15:\"news_x_postings\";s:28:\"%s Postings have been added.\";s:15:\"news_1_postings\";s:25:\"1 Posting has been added.\";s:14:\"news_pd_period\";s:28:\"Personal Desktop News Period\";s:19:\"news_pd_period_info\";s:127:\"Defines the time period used for news on the personal desktop. Select lower values, if you experience any performance problems.\";s:15:\"news_indefinite\";s:10:\"Indefinite\";s:17:\"news_loading_news\";s:15:\"Loading News...\";s:21:\"news_no_js_click_here\";s:38:\"If news are not displayed, click here.\";s:14:\"news_acc_cache\";s:26:\"Permission Check (Minutes)\";s:19:\"news_acc_cache_info\";s:175:\"Check read permissions for news items all x minutes (personal desktop only). \'0\' means everytime. Higher values improve performance, but news may link to non-accessible items.\";s:16:\"news_nr_of_items\";s:39:\"Number of Maximum News Items per Object\";s:21:\"news_nr_of_items_info\";s:227:\"Number of news items that are kept for an object (e.g. a file or a learning module) in the database. Please note, that container objects (e.g. categories, courses) may list more items, because they aggregate news of subobjects.\";s:15:\"news_related_to\";s:10:\"Related to\";s:14:\"news_all_items\";s:9:\"All Items\";s:23:\"news_edit_news_settings\";s:13:\"Edit Settings\";s:25:\"news_enable_internal_news\";s:20:\"Enable Internal News\";s:30:\"news_enable_internal_news_info\";s:148:\"Activates news blocks for categories, courses, groups and other objects. Users can subscribe to news and news are presented on the personal desktop.\";s:24:\"news_enable_internal_rss\";s:28:\"Enable RSS for Internal News\";s:29:\"news_enable_internal_rss_info\";s:114:\"Allows to publish news items via RSS. These items will be accessible outside of the system without authentication.\";s:38:\"news_first_letter_of_word_notification\";s:1:\"N\";s:18:\"news_notifications\";s:13:\"Notifications\";s:19:\"news_news_item_head\";s:9:\"News Item\";s:20:\"news_hide_news_block\";s:15:\"Hide News Block\";s:25:\"news_hide_news_block_info\";s:98:\"Hide block in learner\'s view. The news block will only be visible for users with write permission.\";s:22:\"news_hidden_news_block\";s:44:\"Block is currently hidden in learner\'s view.\";s:23:\"news_hide_news_per_date\";s:15:\"Show News After\";s:28:\"news_hide_news_per_date_info\";s:63:\"Only news that are newer than a certain date will be displayed.\";s:19:\"news_hide_news_date\";s:13:\"Starting Date\";s:23:\"news_default_visibility\";s:14:\"Default Access\";s:20:\"news_news_item_title\";s:8:\"Headline\";s:22:\"news_news_item_content\";s:4:\"Text\";s:27:\"news_news_item_content_long\";s:9:\"Long Text\";s:32:\"news_news_item_content_long_info\";s:40:\"This text will not be published via RSS.\";s:21:\"news_visibility_users\";s:15:\"Logged in Users\";s:22:\"news_visibility_public\";s:6:\"Public\";s:23:\"news_get_priv_feed_info\";s:307:\"This is a personal private news feed URL. The feed includes news that are declared as public and private by the author. This feed is protected by a password, which can be changed under \"Settings\". Please do not share this URL with other people. Please replace -password- in this URL with your Feed-Password.\";s:24:\"news_get_priv_feed_title\";s:25:\"Personal private Feed-URL\";s:24:\"news_enable_private_feed\";s:23:\"Enable private Newsfeed\";s:29:\"news_enable_private_feed_info\";s:148:\"If this option is enabled, public and private news can be obtained by personal RSS feeds outside of ILIAS. Authentification is provided by password.\";s:22:\"passwd_equals_ilpasswd\";s:59:\"Please enter a password different from your ILIAS-password.\";s:18:\"priv_feed_disabled\";s:26:\"Private Newsfeed disabled.\";s:18:\"priv_feed_settings\";s:25:\"Private Newsfeed settings\";s:25:\"priv_feed_no_access_title\";s:28:\"Private Newsfeed is disabled\";s:24:\"priv_feed_no_access_body\";s:64:\"Please contact the system administrator for further information.\";s:23:\"priv_feed_no_auth_title\";s:23:\"Authentification failed\";s:22:\"priv_feed_no_auth_body\";s:86:\"Please make sure you enabled your private Newsfeed and entered the password correctly.\";s:25:\"news_news_item_visibility\";s:6:\"Access\";s:15:\"news_news_items\";s:12:\"News Item(s)\";s:14:\"news_subscribe\";s:9:\"Subscribe\";s:16:\"news_unsubscribe\";s:11:\"Unsubscribe\";s:18:\"news_internal_news\";s:4:\"News\";s:17:\"news_get_feed_url\";s:12:\"Get Feed URL\";s:17:\"news_feed_url_for\";s:17:\"Feed URL for \'%s\'\";s:19:\"news_get_feed_title\";s:17:\"Personal Feed URL\";s:18:\"news_get_feed_info\";s:211:\"This is a personal news feed URL. The feed includes only news that are declared as public by the author. The feed is not protected by any authentication procedure. Please do not share this URL with other people.\";s:13:\"news_feed_url\";s:8:\"Feed URL\";s:13:\"news_settings\";s:13:\"News Settings\";s:25:\"news_notifications_public\";s:20:\"Public Notifications\";s:30:\"news_notifications_public_info\";s:175:\"If this option is enabled, notifications can be obtained by personal RSS feeds outside of ILIAS. Please note that this makes notifications accessible without authentification.\";s:16:\"news_public_feed\";s:14:\"Extra RSS Feed\";s:21:\"news_public_feed_info\";s:78:\"If this option is enabled, a separate RSS feed is provided for this Mediacast.\";s:30:\"news_news_item_visibility_info\";s:128:\"Public news can be accessed without authentication outside of ILIAS via RSS. Please do not include any confidential information.\";}');
INSERT INTO `lng_modules` VALUES ('feed','en','a:18:{s:15:\"feed_feed_items\";s:12:\"Feed Item(s)\";s:10:\"feed_proxy\";s:10:\"Proxy Host\";s:15:\"feed_proxy_info\";s:32:\"Proxy host for socket connection\";s:15:\"feed_proxy_port\";s:10:\"Proxy Port\";s:20:\"feed_proxy_port_info\";s:32:\"Proxy port for socket connection\";s:17:\"feed_loading_feed\";s:15:\"Loading Feed...\";s:21:\"feed_no_js_click_here\";s:37:\"If feed is not displayed, click here.\";s:22:\"feed_disable_rep_feeds\";s:40:\"Disable External Web Feeds in Categories\";s:27:\"feed_disable_rep_feeds_info\";s:127:\"This option deactivates all existing external web feed blocks, in case of an unexpected problem due to an external feed source.\";s:16:\"feed_nr_pd_feeds\";s:44:\"Number of External Feeds on Personal Desktop\";s:21:\"feed_nr_pd_feeds_info\";s:196:\"Sets the maximum number of external web feeds, that users may add to their personal desktop. Existing feeds are not deleted, if option is set to a lower value. \'0\' disables the feature completely.\";s:13:\"feed_settings\";s:27:\"External Web Feeds Settings\";s:21:\"feed_open_source_page\";s:18:\"Open in New Window\";s:21:\"block_feed_block_head\";s:17:\"External Web Feed\";s:22:\"block_feed_block_title\";s:5:\"Title\";s:25:\"block_feed_block_feed_url\";s:8:\"Feed URL\";s:17:\"feed_no_valid_url\";s:26:\"The Feed URL is not valid.\";s:30:\"block_feed_block_feed_url_info\";s:68:\"Must be a valid RSS/Atom URL, e.g. http://www.ilias.de/iosbb/rss.php\";}');
INSERT INTO `lng_modules` VALUES ('pdesk','en','a:8:{s:16:\"bm_num_bookmarks\";s:11:\"Bookmark(s)\";s:23:\"bm_num_bookmark_folders\";s:9:\"Folder(s)\";s:11:\"pdesk_intro\";s:33:\"Welcome to your Personal Desktop!\";s:12:\"pdesk_intro2\";s:160:\"This is your personal space for organising your working and learning. You can put resources from other areas on your personal desktop. Doing so takes two steps:\";s:12:\"pdesk_intro3\";s:69:\"Click on \'%s\' and browse the existing working and learning resources.\";s:12:\"pdesk_intro4\";s:104:\"If you found something of interest, add it to your desktop by clicking the <i>Add to Desktop</i> button.\";s:22:\"pdesk_feedback_request\";s:16:\"Feedback Request\";s:15:\"pdesk_feedbacks\";s:19:\"Feedback Request(s)\";}');
INSERT INTO `lng_modules` VALUES ('rep','en','a:7:{s:9:\"rep_intro\";s:26:\"Welcome to the Repository!\";s:10:\"rep_intro1\";s:247:\"In this area you can create learning and working resources for all users. All resources are organised in categories. Categories can reflect the structure of your organisation (e.g. departments), a hierarchie of disciplines, or classes of a school.\";s:10:\"rep_intro2\";s:53:\"Three steps are needed to build an initial structure:\";s:10:\"rep_intro3\";s:74:\"Click on the <i>%s</i> button besides the selection list on the top right.\";s:10:\"rep_intro4\";s:79:\"In the following form, enter a title and a description, and click on <i>%s</i>.\";s:10:\"rep_intro5\";s:65:\"By clicking on the title of the category you enter your category.\";s:10:\"rep_intro6\";s:83:\"After that procedure you may add any learning or working resource to your category.\";}');
INSERT INTO `lng_modules` VALUES ('delic','en','a:5:{s:14:\"delic_settings\";s:20:\"del.icio.us Settings\";s:22:\"delic_add_to_delicious\";s:18:\"Add to del.icio.us\";s:20:\"delic_extt_delicious\";s:11:\"del.icio.us\";s:20:\"delic_add_info_links\";s:37:\"Add del.icio.us Links on Info Screens\";s:18:\"delic_user_profile\";s:50:\"Enable del.icio.us Account Setting in User Profile\";}');
INSERT INTO `lng_modules` VALUES ('gmaps','en','a:10:{s:13:\"gmaps_api_key\";s:7:\"API Key\";s:25:\"gmaps_public_profile_info\";s:37:\"Show location in your public profile.\";s:18:\"gmaps_enable_gmaps\";s:18:\"Enable Google Maps\";s:23:\"gmaps_enable_gmaps_info\";s:59:\"Activates Google Maps in user profiles, groups and courses.\";s:16:\"gmaps_zoom_level\";s:10:\"Zoom Level\";s:14:\"gmaps_settings\";s:20:\"Google Maps Settings\";s:16:\"gmaps_extt_gmaps\";s:11:\"Google Maps\";s:18:\"gmaps_api_key_desc\";s:92:\"In order to use the Google Maps extension, you need to sign up for a Google Maps API key at:\";s:18:\"gmaps_std_location\";s:16:\"Default Location\";s:23:\"gmaps_std_location_desc\";s:48:\"Latitude / Longitude. Click map to set location.\";}');
INSERT INTO `lng_modules` VALUES ('ldap','en','a:98:{s:16:\"ldap_server_name\";s:26:\"Name of LDAP Configuration\";s:14:\"ldap_referrals\";s:9:\"Referrals\";s:29:\"ldap_server_security_settings\";s:17:\"Security Settings\";s:19:\"ldap_server_binding\";s:7:\"Binding\";s:19:\"ldap_bind_anonymous\";s:16:\"Bind Anonymously\";s:14:\"ldap_bind_user\";s:13:\"Bind as User:\";s:19:\"ldap_server_bind_dn\";s:7:\"User DN\";s:21:\"ldap_server_bind_pass\";s:8:\"Password\";s:28:\"ldap_authentication_settings\";s:23:\"Authentication Settings\";s:12:\"ldap_user_dn\";s:16:\"User Search Base\";s:15:\"ldap_user_scope\";s:12:\"Search Scope\";s:19:\"ldap_user_attribute\";s:24:\"Attribute for Login Name\";s:18:\"ldap_search_filter\";s:11:\"LDAP Filter\";s:23:\"ldap_group_restrictions\";s:29:\"Group Membership Restrictions\";s:13:\"ldap_group_dn\";s:8:\"Group DN\";s:16:\"ldap_group_scope\";s:12:\"Search Scope\";s:17:\"ldap_group_filter\";s:11:\"LDAP Filter\";s:15:\"ldap_group_name\";s:10:\"Group Name\";s:20:\"ldap_group_attribute\";s:19:\"Attribute for Group\";s:15:\"ldap_memberisdn\";s:21:\"Attribute Value is DN\";s:14:\"ldap_user_sync\";s:29:\"User Synchronization Settings\";s:16:\"ldap_moment_sync\";s:22:\"Type of Sychronization\";s:15:\"ldap_sync_login\";s:8:\"On Login\";s:14:\"ldap_sync_cron\";s:12:\"Per Cron-Job\";s:27:\"ldap_global_role_assignment\";s:21:\"ILIAS-Role Assignment\";s:17:\"ldap_group_member\";s:22:\"Group Member Attribute\";s:14:\"ldap_scope_one\";s:3:\"One\";s:14:\"ldap_scope_sub\";s:3:\"Sub\";s:15:\"ldap_scope_base\";s:4:\"Base\";s:21:\"ldap_server_name_info\";s:56:\"Please choose a name for this LDAP server configuration.\";s:20:\"ldap_server_url_info\";s:163:\"A fully qualified URL for specifying the protocol, url and port to connect to. E.g \"ldap://ldap.ilias.de:389\".  You may add multiple servers with commas separated.\";s:24:\"ldap_server_version_info\";s:32:\"LDAP version to use, ususally 3.\";s:19:\"ldap_referrals_info\";s:177:\"If set, determines whether the LDAP library automatically follows referrals returned by LDAP servers or not. This should be disabled if you are using an active directory server.\";s:21:\"ldap_search_base_info\";s:50:\"Gets prepended to basedn when searching for users.\";s:20:\"ldap_user_scope_info\";s:49:\"Scope for user searching. If unsure choose \"Sub\".\";s:16:\"ldap_filter_info\";s:109:\"Filter that will be added to the search filter this way: (&(userattr=username)<strong>(userfilter)</strong>).\";s:18:\"ldap_group_dn_info\";s:53:\"Gets prepended to \"BaseDN\" when searching for groups.\";s:22:\"ldap_group_filter_info\";s:147:\"Filter that will be added to the search filter when searching for a group: (&(groupattr=group)(memberattr=username)<strong>(groupfilter)</strong>).\";s:22:\"ldap_group_member_info\";s:160:\"The attribute of the group object where the user dn may be found. Choose \"Attribute Value is DN\" if the member attribute is the distinguished name of the users.\";s:20:\"ldap_group_name_info\";s:80:\"The name of the group users have to be a member of to authenticate successfully.\";s:25:\"ldap_group_attribute_info\";s:34:\"The group attribute to search for.\";s:19:\"ldap_user_sync_info\";s:87:\"Defines whether new users are automatically created on login or regularly per Cron-Job.\";s:21:\"ldap_global_role_info\";s:58:\"Please choose an ILIAS Role new users will be assigned to.\";s:21:\"ldap_group_scope_info\";s:49:\"Scope for group searching. If unsure choose \"Sub\"\";s:13:\"ldap_settings\";s:15:\"Server Settings\";s:17:\"ldap_user_mapping\";s:20:\"User Profile Mapping\";s:17:\"ldap_role_mapping\";s:32:\"ILIAS Role -> LDAP Group Mapping\";s:18:\"ldap_mapping_table\";s:51:\"Assignment of LDAP Attributes to ILIAS User Profile\";s:21:\"ldap_mapping_template\";s:25:\"Template for objectClass:\";s:22:\"ldap_update_field_info\";s:20:\"Update automatically\";s:18:\"ldap_role_settings\";s:35:\"LDAP Group Synchronization Settings\";s:16:\"ldap_role_active\";s:28:\"Enable Group Synchronization\";s:19:\"ldap_role_bind_user\";s:8:\"Usern DN\";s:19:\"ldap_role_bind_pass\";s:8:\"Password\";s:24:\"ldap_role_bind_user_info\";s:107:\"Please enter a distinguished name of a LDAP user account. This user needs write access for the LDAP groups.\";s:24:\"ldap_role_bind_pass_info\";s:8:\"Password\";s:24:\"ldap_new_role_assignment\";s:32:\"Add New Role -> Group Assignment\";s:15:\"ldap_ilias_role\";s:10:\"ILIAS Role\";s:14:\"ldap_role_info\";s:83:\"Enter the name of an ILIAS Role that will control the membership to the LDAP group.\";s:12:\"ldap_dn_info\";s:47:\"Enter the distinguished name of the LDAP group.\";s:16:\"ldap_member_info\";s:65:\"The attribute of the group object where the user dn may be found.\";s:22:\"ldap_missing_bind_user\";s:80:\"You have chosen \"Bind as User\": Please enter a valid LDAP username and password.\";s:28:\"ldap_missing_role_assignment\";s:58:\"Please choose a global role new users will be assigned to.\";s:17:\"ldap_tls_conflict\";s:107:\"LDAP-TLS can not be used in combination with LDAPv2. Please choose LDAP version \"3\" or disable TLS support.\";s:27:\"ldap_role_group_assignments\";s:34:\"Existing Role -> Group Assignments\";s:22:\"ldap_group_search_base\";s:17:\"Group Search Base\";s:25:\"ldap_deleted_role_mapping\";s:19:\"Deleted assignment.\";s:20:\"ldap_role_not_exists\";s:36:\"A role with that name does not exist\";s:21:\"ldap_group_membership\";s:16:\"Group Membership\";s:26:\"ldap_group_member_optional\";s:28:\"Group Membership is Optional\";s:22:\"ldap_group_user_filter\";s:11:\"User Filter\";s:24:\"ldap_group_optional_info\";s:198:\"If enabled, the group membership is not required for a successful authentication. Please enter a user filter for the members of these groups:<br />(&(userattr=username)<strong>(userfilter)</strong>)\";s:17:\"ldap_server_short\";s:11:\"Server URL:\";s:19:\"ldap_group_dn_short\";s:9:\"Group DN:\";s:23:\"ldap_group_member_short\";s:10:\"Attribute:\";s:21:\"ldap_ilias_role_short\";s:5:\"Role:\";s:14:\"ldap_info_text\";s:16:\"Information Text\";s:19:\"ldap_info_text_info\";s:176:\"If entered, this text will be shown on the info screen for the object this role is assigned to. Optionally this text is available in the Repository and on the Personal Desktop.\";s:20:\"ldap_info_text_short\";s:10:\"Info Text:\";s:22:\"ldap_mapping_info_type\";s:56:\"Show Information also in the Repository/Personal Desktop\";s:21:\"ldap_role_assignments\";s:15:\"Role Assignment\";s:22:\"ldap_add_role_ass_rule\";s:29:\"New Rule for Role Assignments\";s:20:\"ldap_assignment_type\";s:15:\"Assignment Type\";s:18:\"ldap_role_by_group\";s:15:\"Groupmembership\";s:18:\"ldap_role_grp_info\";s:74:\"Members of a specific LDAP Group will be assigned to the given ILIAS role.\";s:16:\"ldap_role_grp_at\";s:9:\"Attribute\";s:21:\"ldap_role_grp_dn_info\";s:56:\"Please enter the \"Distinguished Name\" of the LDAP Group.\";s:18:\"ldap_role_grp_isdn\";s:21:\"Attribute value is DN\";s:22:\"ldap_role_by_attribute\";s:14:\"LDAP Attribute\";s:17:\"ldap_role_at_info\";s:73:\"The assignment is based on a specific attribute in the LDAP user profile.\";s:17:\"ldap_role_at_name\";s:14:\"Attribute Name\";s:18:\"ldap_role_at_value\";s:15:\"Attribute Value\";s:17:\"ldap_tbl_role_ass\";s:12:\"Avtive Rules\";s:19:\"ldap_rule_condition\";s:9:\"condition\";s:21:\"ldap_btn_add_role_ass\";s:12:\"Add New Rule\";s:23:\"ldap_edit_role_ass_rule\";s:25:\"Edit Role Assignment Rule\";s:14:\"ldap_rule_type\";s:18:\"Type of Assignment\";s:25:\"ldap_confirm_del_role_ass\";s:22:\"Delete Role Assignment\";}');
INSERT INTO `lng_modules` VALUES ('ps','en','a:84:{s:12:\"show_privacy\";s:7:\"Privacy\";s:13:\"show_security\";s:8:\"Security\";s:15:\"ps_export_files\";s:12:\"Export Files\";s:7:\"ps_size\";s:10:\"Files Size\";s:13:\"ps_select_one\";s:29:\"Please select one export file\";s:22:\"ps_delete_export_files\";s:20:\"Deleted export files\";s:18:\"ps_export_settings\";s:15:\"Export Settings\";s:17:\"ps_user_selection\";s:22:\"Participants Selection\";s:15:\"ps_export_admin\";s:14:\"Administrators\";s:15:\"ps_export_tutor\";s:6:\"Tutors\";s:16:\"ps_export_member\";s:7:\"Members\";s:13:\"ps_export_sub\";s:11:\"Subscribers\";s:14:\"ps_export_wait\";s:25:\"Users on the Waiting List\";s:19:\"ps_export_user_data\";s:10:\"Data Types\";s:14:\"ps_export_data\";s:34:\"Data Types of the Personal Profile\";s:17:\"ps_perform_export\";s:16:\"Start CSV-Export\";s:21:\"ps_privacy_protection\";s:16:\"Privacy Settings\";s:22:\"ps_security_protection\";s:17:\"Security Settings\";s:17:\"ps_profile_export\";s:31:\"Protection of User Profile Data\";s:16:\"ps_export_course\";s:47:\"Advanced Export of User Profile Data in Courses\";s:17:\"ps_export_confirm\";s:39:\"User Confirmation when Entering Courses\";s:18:\"ps_crs_user_fields\";s:27:\"Course-Specific User Fields\";s:16:\"ps_cdf_add_field\";s:14:\"Add User Field\";s:11:\"ps_cdf_name\";s:4:\"Name\";s:11:\"ps_cdf_type\";s:4:\"Type\";s:15:\"ps_cdf_required\";s:14:\"Required Field\";s:16:\"ps_cdf_no_fields\";s:22:\"No User Fields Defined\";s:13:\"ps_field_type\";s:10:\"Field Type\";s:16:\"ps_type_txt_long\";s:28:\"Text Field (Optional Values)\";s:19:\"ps_type_select_long\";s:28:\"Selection Box (Fixed Values)\";s:17:\"ps_new_text_field\";s:18:\"Add new Text Field\";s:13:\"ps_name_field\";s:4:\"Name\";s:12:\"ps_type_text\";s:10:\"Text Field\";s:14:\"ps_type_select\";s:12:\"Select Field\";s:19:\"ps_new_select_field\";s:17:\"New Selection Box\";s:12:\"ps_cdf_value\";s:5:\"Value\";s:16:\"ps_btn_add_value\";s:9:\"New Value\";s:20:\"ps_cdf_no_name_given\";s:20:\"Please enter a name.\";s:18:\"ps_cdf_added_field\";s:24:\"Added new selection box.\";s:17:\"ps_cdf_select_one\";s:18:\"Please select one.\";s:18:\"ps_cdf_delete_sure\";s:48:\"Do you really want to delete these user fields ?\";s:14:\"ps_cdf_deleted\";s:19:\"Deleted user fields\";s:20:\"ps_edit_select_field\";s:18:\"Edit Selection Box\";s:20:\"ps_cdf_deleted_field\";s:13:\"Deleted value\";s:16:\"ps_files_deleted\";s:20:\"Export Files Deleted\";s:21:\"ps_agreement_accepted\";s:23:\"User Agreement Accepted\";s:15:\"ps_not_accepted\";s:12:\"Not Accepted\";s:21:\"ps_cdf_warning_modify\";s:131:\"Attention: Minimum one user has accepted the user agreement. Modifying these course specific fields will reset all user agreements.\";s:21:\"ps_agreement_req_info\";s:73:\"Please accept the user agreement for having access to the course content.\";s:11:\"ps_cdf_info\";s:29:\"Further Course-Specific Data:\";s:16:\"ps_required_info\";s:77:\"Further Course-Specific fields are required for accessing the course content.\";s:17:\"ps_warning_modify\";s:117:\"Attention: Minimum one user has accepted the user agreement. Modifying these settings will reset all user agreements.\";s:37:\"ps_error_message_https_header_missing\";s:95:\"If you enable the automatic https detection you have to provide a header name and header value.\";s:13:\"ps_auto_https\";s:16:\"Autodetect HTTPS\";s:25:\"ps_auto_https_description\";s:97:\"If enabled, ILIAS tries to detect the HTTPs Status by analysing the header value specified below.\";s:25:\"ps_auto_https_header_name\";s:11:\"Header Name\";s:26:\"ps_auto_https_header_value\";s:12:\"Header Value\";s:18:\"ps_edit_text_field\";s:15:\"Edit Text Field\";s:18:\"ps_show_grp_access\";s:43:\"Show last access time of group participants\";s:18:\"ps_show_crs_access\";s:44:\"Show last access time of course participants\";s:24:\"ps_account_security_mode\";s:16:\"Account Security\";s:32:\"ps_account_security_mode_default\";s:31:\"Standard Ilias Account Security\";s:35:\"ps_account_security_mode_customized\";s:27:\"Customized Account Security\";s:22:\"ps_password_min_length\";s:21:\"Minimum Password Size\";s:22:\"ps_password_max_length\";s:21:\"Maximum Password Size\";s:37:\"ps_password_chars_and_numbers_enabled\";s:22:\"Characters and Numbers\";s:33:\"ps_password_special_chars_enabled\";s:18:\"Special Characters\";s:19:\"ps_password_max_age\";s:20:\"Maximum Password Age\";s:21:\"ps_login_max_attempts\";s:22:\"Maximum Login Attempts\";s:42:\"ps_password_chars_and_numbers_enabled_info\";s:61:\"If enabled, passwords have to contain characters and numbers.\";s:38:\"ps_password_special_chars_enabled_info\";s:57:\"If enabled, passwords have to contain special characters.\";s:27:\"ps_password_min_length_info\";s:110:\"Sets the minimum size of account passwords. If set to 0 the passwords anyway have to have a minimum size of 1.\";s:27:\"ps_password_max_length_info\";s:84:\"Sets the maximum size of account passwords. Set this to 0 for disabling this option.\";s:24:\"ps_password_max_age_info\";s:83:\"Sets the maximum age of passwords in days. Set this to 0 for disabling this option.\";s:26:\"ps_login_max_attempts_info\";s:89:\" Sets the maximum count of wrong login attempts. Set this to 0 for disabling this option.\";s:44:\"ps_error_message_invalid_password_min_length\";s:45:\"Minimum password size may not be less than 0.\";s:44:\"ps_error_message_invalid_password_max_length\";s:45:\"Maximum password size may not be less than 0.\";s:41:\"ps_error_message_invalid_password_max_age\";s:44:\"Maximum password age may not be less than 0.\";s:43:\"ps_error_message_invalid_login_max_attempts\";s:46:\"Maximum login attempts may not be less than 0.\";s:52:\"ps_error_message_password_min2_because_chars_numbers\";s:96:\"Minimum password size may not be less than 2 if password have to contain characters and numbers.\";s:65:\"ps_error_message_password_min3_because_chars_numbers_specialchars\";s:116:\"Minimum password size may not be less than 3 if password have to contain characters, numbers and special characters.\";s:38:\"ps_error_message_password_max_less_min\";s:65:\"Maximum password size may not be less than minimum password size.\";s:41:\"ps_password_change_on_first_login_enabled\";s:30:\"Change Password on First Login\";s:46:\"ps_password_change_on_first_login_enabled_info\";s:100:\"If enabled, users have to change their password on first login (except users registered themselves).\";}');
INSERT INTO `lng_modules` VALUES ('form','en','a:24:{s:27:\"form_hierarchy_add_elements\";s:42:\"Click on placeholders to add new elements.\";s:29:\"form_hierarchy_drag_drop_help\";s:53:\"Drag and drop icons on placeholders to move elements.\";s:14:\"form_min_value\";s:13:\"Minimum Value\";s:14:\"form_max_value\";s:13:\"Maximum Value\";s:11:\"form_format\";s:6:\"Format\";s:23:\"form_msg_value_too_high\";s:43:\"Value too high. Please enter a lower value.\";s:22:\"form_msg_value_too_low\";s:43:\"Value too low. Please enter a higher value.\";s:31:\"form_msg_numeric_value_required\";s:29:\"Please enter a numeric value.\";s:26:\"form_msg_file_size_exceeds\";s:53:\"The uploaded file exceeds the max. allowed file size.\";s:32:\"form_msg_file_partially_uploaded\";s:42:\"The file could not be uploaded completely.\";s:23:\"form_msg_file_no_upload\";s:56:\"This input is required. Please select a file for upload.\";s:29:\"form_msg_file_missing_tmp_dir\";s:44:\"Temporary directory for file upload missing.\";s:34:\"form_msg_file_cannot_write_to_disk\";s:21:\"Cannot write to disk.\";s:32:\"form_msg_file_upload_stopped_ext\";s:33:\"File upload stopped by extension.\";s:29:\"form_msg_file_wrong_file_type\";s:16:\"Wrong file type.\";s:25:\"form_msg_file_virus_found\";s:29:\"Virus found in uploaded file.\";s:9:\"form_days\";s:4:\"Days\";s:10:\"form_hours\";s:5:\"Hours\";s:12:\"form_minutes\";s:7:\"Minutes\";s:12:\"form_seconds\";s:7:\"Seconds\";s:20:\"form_retype_password\";s:15:\"Retype Password\";s:31:\"form_password_required_for_auth\";s:58:\"Password is required for the chosen authentication method.\";s:34:\"form_password_not_allowed_for_auth\";s:79:\"It is not possible to change the password for the chosen authentication method.\";s:11:\"form_months\";s:6:\"Months\";}');
INSERT INTO `lng_modules` VALUES ('pd','en','a:21:{s:11:\"pd_settings\";s:16:\"Personal Desktop\";s:22:\"pd_enable_block_moving\";s:19:\"Enable Block Moving\";s:27:\"pd_enable_block_moving_info\";s:69:\"Allow users to reorganize the content blocks on the personal desktop.\";s:22:\"pd_enable_active_users\";s:25:\"Enable Active Users Block\";s:22:\"pd_time_before_removal\";s:33:\"Maximum Inactivity Time (Minutes)\";s:27:\"pd_time_before_removal_info\";s:81:\"After this time of inactivity, users are removed from the list of \"Active Users\".\";s:11:\"pd_osi_host\";s:8:\"OSI Host\";s:16:\"pd_osi_host_info\";s:63:\"Instant Messenger Online Status Indicator Host (optional). See:\";s:19:\"pd_enable_bookmarks\";s:16:\"Enable Bookmarks\";s:15:\"pd_enable_notes\";s:12:\"Enable Notes\";s:19:\"pd_enable_my_offers\";s:23:\"Enable \'Selected Items\'\";s:24:\"pd_enable_my_offers_info\";s:95:\"The view \'Selected Items\' contains all objects which are placed on the user\'s Personal Desktop.\";s:24:\"pd_enable_my_memberships\";s:23:\"Enable \'My Memberships\'\";s:29:\"pd_enable_my_memberships_info\";s:85:\"\'My Memberships\' contains all courses and groups the user is assigned to as a member.\";s:12:\"pd_my_offers\";s:14:\"Selected Items\";s:17:\"pd_my_memberships\";s:14:\"My Memberships\";s:30:\"pd_personal_items_default_view\";s:12:\"Default View\";s:35:\"pd_personal_items_default_view_info\";s:43:\"Choose the prefered view of Personal Items.\";s:27:\"pd_view_select_at_least_one\";s:86:\"You have to select at least one view, either \'Selected Items\' and/or \'My Memberships\'.\";s:23:\"pd_my_memberships_intro\";s:27:\"Welcome to Your Memberships\";s:24:\"pd_my_memberships_intro2\";s:74:\"This is your personal space for all courses and groups you participate in.\";}');
INSERT INTO `lng_modules` VALUES ('mcst','en','a:40:{s:17:\"mcst_add_new_item\";s:22:\"Add New Mediacast Item\";s:20:\"mcst_visibility_info\";s:64:\"Public items can be accessed via RSS without any authentication.\";s:13:\"mcst_duration\";s:9:\"Play Time\";s:13:\"mcst_nr_items\";s:15:\"Number of Items\";s:20:\"mcst_last_submission\";s:15:\"Last Submission\";s:18:\"mcst_duration_info\";s:77:\"If no value is entered, ILIAS tries do determine the play time automatically.\";s:15:\"mcst_media_cast\";s:9:\"Mediacast\";s:10:\"mcst_entry\";s:17:\"Mediacast Entries\";s:14:\"mcst_play_time\";s:9:\"Play Time\";s:17:\"mcst_det_playtime\";s:19:\"Determine Play Time\";s:13:\"mcst_settings\";s:18:\"Mediacast Settings\";s:22:\"mcst_incl_files_in_rss\";s:27:\"Include Media Files in Feed\";s:27:\"mcst_incl_files_in_rss_info\";s:131:\"If enabled, media files are includes as attachements in the RSS feed. Otherwise the feed just notifies subscribers about new items.\";s:14:\"mcst_edit_item\";s:19:\"Edit Mediacast Item\";s:19:\"mcst_standard_title\";s:17:\"Normal Media File\";s:24:\"mcst_audioportable_title\";s:42:\"Additional Audio File for Portable Devices\";s:24:\"mcst_videoportable_title\";s:42:\"Additional Video File for Portable Devices\";s:22:\"mcst_download_standard\";s:8:\"Download\";s:27:\"mcst_download_videoportable\";s:23:\"Download Video Portable\";s:27:\"mcst_download_audioportable\";s:23:\"Download Audio Portable\";s:24:\"mcst_clear_purpose_title\";s:6:\"Delete\";s:17:\"mcst_downloadable\";s:14:\"Download Links\";s:22:\"mcst_downloadable_info\";s:62:\"If this option is enabled, links for downloading are provided.\";s:26:\"mcst_media_cast_not_online\";s:23:\"Mediacast is not online\";s:31:\"mcst_media_cast_not_online_text\";s:44:\"Mediacast is not online or has been disabled\";s:20:\"mcst_global_settings\";s:15:\"Global Settings\";s:23:\"mcst_current_value_info\";s:39:\"Shows the current value of this format.\";s:28:\"mcst_standard_settings_title\";s:35:\"File Extensions for Standard Format\";s:27:\"mcst_standard_settings_info\";s:37:\"Comma separated list of file suffixes\";s:33:\"mcst_audioportable_settings_title\";s:32:\"File Extensions for Audio Format\";s:32:\"mcst_audioportable_settings_info\";s:37:\"Comma separated list of file suffixes\";s:33:\"mcst_videoportable_settings_title\";s:32:\"File Extensions for Video Format\";s:32:\"mcst_videoportable_settings_info\";s:37:\"Comma separated list of file suffixes\";s:18:\"mcst_edit_settings\";s:18:\"MediaCast Settings\";s:28:\"mcst_file_extension_settings\";s:15:\"File Extensions\";s:19:\"mcst_reference_info\";s:32:\"Provide URL pointing to resource\";s:30:\"mcst_news_item_visibility_info\";s:128:\"Public news can be accessed without authentication outside of ILIAS via RSS. Please do not include any confidential information.\";s:23:\"mcst_default_visibility\";s:14:\"Default Access\";s:21:\"mcst_visibility_users\";s:15:\"Logged in Users\";s:22:\"mcst_visibility_public\";s:6:\"Public\";}');
INSERT INTO `lng_modules` VALUES ('jsmath','en','a:12:{s:18:\"jsmath_extt_jsmath\";s:6:\"jsMath\";s:15:\"jsmath_settings\";s:15:\"jsMath Settings\";s:20:\"jsmath_enable_jsmath\";s:13:\"Enable jsMath\";s:25:\"jsmath_enable_jsmath_info\";s:76:\"Activates support for jsMath based mathematical output of LaTeX expressions.\";s:21:\"jsmath_path_to_jsmath\";s:14:\"Path to jsMath\";s:26:\"jsmath_path_to_jsmath_desc\";s:121:\"The path to the jsMath base directory relative to the ILIAS base directory, e.g. &quot;./Services/Javascript/jsMath&quot;\";s:21:\"jsmath_path_not_found\";s:88:\"Cannot find jsMath.js in the given path. Please check the jsMath location on the server!\";s:18:\"jsmath_enable_user\";s:21:\"Enable jsMath support\";s:23:\"jsmath_enable_user_desc\";s:205:\"Activate jsMath for the output of mathematical formulae. jsMath output produces scaleable formulae and requires activated Javascript. When jsMath output is deactived, formulae will be rendered as graphics.\";s:22:\"jsmath_default_setting\";s:14:\"Use as default\";s:27:\"jsmath_default_setting_info\";s:169:\"If checked, jsMath will be used as default method to render LaTeX code for all users who did not enable or disable the jsMath support in their personal profile settings.\";s:20:\"jsmath_no_javascript\";s:381:\"If you don\'t see the correct mathematical formula next to this hint, then you have jsMath output enabled but your web browser doesn\'t support JavaScript or JavaScript is disabled. To see mathematical formulae, please activate JavaScript in your web browser and reload this page or go to <strong>Personal Desktop &gt; Personal Profile &gt; jsMath</strong> and disable jsMath output.\";}');
INSERT INTO `lng_modules` VALUES ('trac#','en','a:1:{s:28:\"trac_mode_test_finished_info\";s:39:\"Users have to finish a test completely.\";}');
INSERT INTO `lng_modules` VALUES ('auth','en','a:7:{s:18:\"auth_rad_migration\";s:18:\"Account Migration:\";s:23:\"auth_rad_migration_info\";s:121:\"Activate this option to give new users the possibility to migrate their existing ILIAS accounts to Radius authentication.\";s:22:\"auth_account_migration\";s:17:\"New ILIAS Account\";s:17:\"auth_info_migrate\";s:119:\"If you have already an ILIAS account enter username and password to migrate your personal data (Mail, Test results...).\";s:13:\"auth_info_add\";s:88:\"Choose this option if you have never registered to ILIAS. A new account will be created.\";s:19:\"auth_radius_charset\";s:18:\"Character Encoding\";s:24:\"auth_radius_charset_info\";s:107:\"Please choose the character encoding for the communication with the radius server. If unsure, choose UTF-8.\";}');
INSERT INTO `lng_modules` VALUES ('cmps','en','a:53:{s:10:\"cmps_group\";s:5:\"Group\";s:20:\"cmps_current_version\";s:15:\"Current Version\";s:17:\"cmps_file_version\";s:19:\"Update File Version\";s:24:\"cmps_refresh_plugins_inf\";s:27:\"Refresh Plugins Information\";s:11:\"cmps_module\";s:6:\"Module\";s:31:\"cmps_no_language_file_available\";s:27:\"No language file available.\";s:32:\"cmps_no_db_update_file_available\";s:30:\"No DB update script available.\";s:12:\"cmps_version\";s:7:\"Version\";s:16:\"cmps_responsible\";s:11:\"Responsible\";s:11:\"cmps_update\";s:6:\"Update\";s:14:\"cmps_update_db\";s:9:\"Update DB\";s:12:\"cmps_refresh\";s:7:\"Refresh\";s:13:\"cmps_activate\";s:8:\"Activate\";s:15:\"cmps_deactivate\";s:10:\"Deactivate\";s:22:\"cmps_ilias_min_version\";s:18:\"Min. ILIAS Version\";s:22:\"cmps_ilias_max_version\";s:18:\"Max. ILIAS Version\";s:8:\"cmps_dir\";s:9:\"Directory\";s:11:\"cmps_active\";s:6:\"Active\";s:13:\"cmps_inactive\";s:8:\"Inactive\";s:11:\"cmps_status\";s:6:\"Status\";s:18:\"cmps_needs_upgrade\";s:111:\"The plugin version currently installed is older than a previously installed version. Please upgrade the plugin.\";s:17:\"cmps_needs_update\";s:13:\"Needs update.\";s:31:\"cmps_needs_newer_plugin_version\";s:75:\"This ILIAS version needs a newer plugin version. Please upgrade the plugin.\";s:30:\"cmps_needs_newer_ilias_version\";s:76:\"This plugin version only runs on newer ILIAS versions. Please upgrade ILIAS.\";s:17:\"cmps_show_details\";s:12:\"Show Details\";s:16:\"cmps_plugin_slot\";s:11:\"Plugin Slot\";s:14:\"cmps_component\";s:9:\"Component\";s:16:\"cmps_lang_prefix\";s:25:\"Language Variables Prefix\";s:23:\"cmps_plugin_db_prefixes\";s:17:\"DB Table Prefixes\";s:21:\"cmps_disable_creation\";s:16:\"Disable Creation\";s:15:\"cmps_rep_object\";s:22:\"Repository Object Type\";s:17:\"cmps_add_new_rank\";s:31:\"Position in Add-New-Object List\";s:16:\"cmps_plugin_dirs\";s:18:\"Plugin Directories\";s:25:\"cmps_plugin_lang_prefixes\";s:24:\"Plugin Language Prefixes\";s:18:\"cmps_edit_settings\";s:8:\"Settings\";s:12:\"cmps_modules\";s:7:\"Modules\";s:12:\"cmps_plugins\";s:7:\"Plugins\";s:11:\"cmps_plugin\";s:6:\"Plugin\";s:13:\"cmps_services\";s:8:\"Services\";s:12:\"cmps_service\";s:7:\"Service\";s:17:\"cmps_save_options\";s:12:\"Save Options\";s:13:\"cmps_main_dir\";s:14:\"Main Directory\";s:16:\"cmps_plugin_file\";s:11:\"Plugin File\";s:14:\"cmps_db_update\";s:16:\"DB Update Script\";s:14:\"cmps_available\";s:9:\"Available\";s:12:\"cmps_missing\";s:7:\"Missing\";s:15:\"cmps_class_file\";s:10:\"Class File\";s:15:\"cmps_lang_files\";s:14:\"Language Files\";s:13:\"cmps_database\";s:8:\"Database\";s:14:\"cmps_languages\";s:9:\"Languages\";s:16:\"cmps_basic_files\";s:11:\"Basic Files\";s:9:\"cmps_name\";s:4:\"Name\";s:7:\"cmps_id\";s:2:\"ID\";}');
INSERT INTO `lng_modules` VALUES ('wiki','en','a:50:{s:17:\"wiki_contributors\";s:12:\"Contributors\";s:31:\"wiki_page_deletion_confirmation\";s:44:\"Do you really want to delete this wiki page?\";s:14:\"wiki_wiki_page\";s:9:\"Wiki Page\";s:22:\"wiki_last_visited_page\";s:17:\"Last Visited Page\";s:31:\"wiki_short_title_already_in_use\";s:76:\"This title is already used by another wiki. Please select a different title.\";s:26:\"wiki_msg_short_name_regexp\";s:87:\"Short title must not start with a number and must not contain the following characters:\";s:24:\"wiki_feedback_from_tutor\";s:19:\"Feedback from Tutor\";s:17:\"wiki_introduction\";s:12:\"Introduction\";s:16:\"wiki_contributor\";s:11:\"Contributor\";s:17:\"wiki_page_changes\";s:12:\"Page Changes\";s:12:\"wiki_grading\";s:7:\"Grading\";s:14:\"wiki_notgraded\";s:10:\"Not Graded\";s:11:\"wiki_passed\";s:6:\"Passed\";s:11:\"wiki_failed\";s:6:\"Failed\";s:9:\"wiki_mark\";s:4:\"Mark\";s:13:\"wiki_settings\";s:13:\"Wiki Settings\";s:20:\"wiki_activate_rating\";s:15:\"Activate Rating\";s:23:\"wiki_what_links_to_page\";s:24:\"What links to page \"%s\"?\";s:15:\"wiki_start_page\";s:10:\"Start Page\";s:21:\"wiki_start_page_title\";s:16:\"Start Page Title\";s:14:\"wiki_main_page\";s:9:\"Main Page\";s:16:\"wiki_short_title\";s:11:\"Short Title\";s:19:\"wiki_orphaned_pages\";s:14:\"Orphaned Pages\";s:22:\"wiki_short_title_desc2\";s:131:\"This title will be used in links to the wiki. Once choosen you should not change this title, since users may loose their bookmarks.\";s:12:\"wiki_article\";s:7:\"Article\";s:10:\"wiki_pages\";s:5:\"Pages\";s:15:\"wiki_discussion\";s:10:\"Discussion\";s:9:\"wiki_edit\";s:4:\"Edit\";s:20:\"wiki_last_changed_by\";s:15:\"Last Changed By\";s:24:\"wiki_other_pages_linking\";s:32:\"Other Pages Linking to This Page\";s:35:\"wiki_number_users_notes_or_comments\";s:60:\"Number of users that attached notes or comments to this page\";s:15:\"wiki_created_by\";s:10:\"Created By\";s:17:\"wiki_page_deleted\";s:18:\"Wiki page deleted.\";s:17:\"wiki_last_changed\";s:11:\"Last Change\";s:18:\"wiki_no_start_page\";s:38:\"Wiki is missing a valid starting page.\";s:14:\"wiki_page_hits\";s:9:\"Page Hits\";s:12:\"wiki_history\";s:7:\"History\";s:21:\"wiki_quick_navigation\";s:21:\"Wiki Quick Navigation\";s:19:\"wiki_recent_changes\";s:14:\"Recent Changes\";s:20:\"wiki_what_links_here\";s:16:\"What Links Here?\";s:15:\"wiki_print_view\";s:10:\"Print View\";s:16:\"wiki_random_page\";s:11:\"Random Page\";s:14:\"wiki_all_pages\";s:9:\"All Pages\";s:14:\"wiki_new_pages\";s:9:\"New Pages\";s:18:\"wiki_popular_pages\";s:13:\"Popular Pages\";s:15:\"wiki_media_list\";s:10:\"Media List\";s:9:\"wiki_page\";s:4:\"Page\";s:16:\"wiki_wiki_search\";s:11:\"Wiki Search\";s:11:\"wiki_search\";s:6:\"Search\";s:19:\"wiki_search_results\";s:14:\"Search Results\";}');
INSERT INTO `lng_modules` VALUES ('tagging','en','a:7:{s:12:\"tagging_tags\";s:4:\"Tags\";s:16:\"tagging_settings\";s:8:\"Settings\";s:21:\"tagging_edit_settings\";s:13:\"Edit Settings\";s:22:\"tagging_enable_tagging\";s:14:\"Enable Tagging\";s:16:\"tagging_tag_info\";s:88:\"To attach tags to a ressource open the info screen of the ressource and enter your tags.\";s:25:\"tagging_resources_for_tag\";s:24:\"Resources tagged with %s\";s:17:\"tagging_all_users\";s:9:\"All Users\";}');
INSERT INTO `lng_modules` VALUES ('rating','en','a:3:{s:18:\"rating_your_rating\";s:11:\"Your Rating\";s:21:\"rating_average_rating\";s:14:\"Average Rating\";s:15:\"rating_nr_users\";s:10:\"%s User(s)\";}');
INSERT INTO `lng_modules` VALUES ('notes','en','a:9:{s:21:\"notes_public_comments\";s:15:\"Public Comments\";s:17:\"notes_add_comment\";s:11:\"Add Comment\";s:19:\"notes_show_comments\";s:13:\"Show Comments\";s:19:\"notes_hide_comments\";s:13:\"Hide Comments\";s:18:\"notes_all_comments\";s:12:\"All Comments\";s:17:\"notes_my_comments\";s:11:\"My Comments\";s:13:\"notes_comment\";s:7:\"Comment\";s:23:\"notes_activate_comments\";s:24:\"Activate Public Comments\";s:25:\"notes_deactivate_comments\";s:26:\"Deactivate Public Comments\";}');
INSERT INTO `lng_modules` VALUES ('ecs','en','a:80:{s:19:\"ecs_server_settings\";s:19:\"ECS Functionalities\";s:12:\"ecs_settings\";s:8:\"Settings\";s:15:\"ecs_communities\";s:12:\"Participants\";s:12:\"ecs_mappings\";s:16:\"ECS Data Mapping\";s:23:\"ecs_connection_settings\";s:19:\"Connection Settings\";s:10:\"ecs_active\";s:26:\"Enable ECS Functionalities\";s:14:\"ecs_server_url\";s:10:\"Server URL\";s:12:\"ecs_protocol\";s:8:\"Protocol\";s:8:\"ecs_port\";s:4:\"Port\";s:15:\"ecs_client_cert\";s:18:\"Client Certificate\";s:11:\"ecs_ca_cert\";s:14:\"CA Certificate\";s:12:\"ecs_cert_key\";s:15:\"Certificate Key\";s:16:\"ecs_key_password\";s:12:\"Key Password\";s:11:\"cert_serial\";s:25:\"Certificate Serial Number\";s:18:\"ecs_local_settings\";s:14:\"Local Settings\";s:11:\"ecs_polling\";s:12:\"Polling Time\";s:16:\"ecs_polling_info\";s:70:\"Please define the polling time for creation and update of Course-Links\";s:13:\"ecs_import_id\";s:9:\"Import ID\";s:18:\"ecs_import_id_info\";s:75:\"Please enter the ID of the category, where new Course-Links will be created\";s:24:\"ecs_error_extract_serial\";s:83:\"Cannot read serial number of certificate. Please check the client certificate path.\";s:16:\"ecs_participants\";s:12:\"Participants\";s:22:\"ecs_participants_infos\";s:20:\"Further Informations\";s:17:\"ecs_active_header\";s:14:\"Export Allowed\";s:22:\"ecs_enable_participant\";s:12:\"Allow Export\";s:7:\"ecs_dns\";s:10:\"Domainname\";s:9:\"ecs_email\";s:6:\"E-Mail\";s:15:\"ecs_mapping_tbl\";s:47:\"Mapping of ECS-Data to ILIAS Advanced Meta Data\";s:23:\"ecs_field_study_courses\";s:15:\"Study Course(s)\";s:18:\"ecs_field_lecturer\";s:11:\"Lecturer(s)\";s:20:\"ecs_field_courseType\";s:11:\"Course Type\";s:17:\"ecs_field_credits\";s:7:\"Credits\";s:15:\"ecs_field_start\";s:5:\"Start\";s:14:\"ecs_field_term\";s:4:\"Term\";s:13:\"ecs_field_day\";s:3:\"Day\";s:14:\"ecs_field_time\";s:4:\"Time\";s:14:\"ecs_field_room\";s:4:\"Room\";s:15:\"ecs_field_cycle\";s:5:\"Cycle\";s:16:\"ecs_ignore_field\";s:35:\"Disable export/update of this field\";s:10:\"ecs_export\";s:15:\"Course Releases\";s:23:\"ecs_export_obj_settings\";s:23:\"Course Release Settings\";s:19:\"ecs_export_disabled\";s:26:\"Do not release this Course\";s:18:\"ecs_export_enabled\";s:19:\"Release this Course\";s:14:\"ecs_publish_as\";s:11:\"Publish as:\";s:15:\"ecs_publish_for\";s:12:\"Release for:\";s:19:\"ecs_check_import_id\";s:54:\"The import id is not valid. Please check this setting.\";s:7:\"ecs_abr\";s:12:\"Abbreviation\";s:21:\"ecs_read_remote_links\";s:21:\"Update Remote-Courses\";s:19:\"ecs_remote_imported\";s:54:\"Informations about remote courses have been refreshed.\";s:24:\"ecs_remote_user_settings\";s:30:\"Settings for ECS User Accounts\";s:8:\"ecs_role\";s:15:\"Role Assignment\";s:20:\"ecs_global_role_info\";s:68:\"The chosen role will be assigned to newly created ECS user accounts.\";s:15:\"ecs_field_begin\";s:5:\"Begin\";s:13:\"ecs_field_end\";s:3:\"End\";s:10:\"ecs_import\";s:6:\"Import\";s:20:\"ecs_imported_content\";s:18:\"Imported E-Content\";s:17:\"ecs_imported_from\";s:13:\"Imported From\";s:13:\"ecs_meta_data\";s:9:\"Meta Data\";s:23:\"ecs_rcrs_created_body_a\";s:37:\"A new Remote Course has been created:\";s:24:\"ecs_new_econtent_subject\";s:21:\"New E-Content created\";s:17:\"ecs_notifications\";s:13:\"Notifications\";s:12:\"ecs_user_rcp\";s:28:\"Notification About ECS Users\";s:12:\"ecs_econ_rcp\";s:32:\"Notification About New E-Content\";s:17:\"ecs_user_rcp_info\";s:110:\"Enter one or more login names of users (comma seperated) that will be informed about new ECS users per e-mail.\";s:17:\"ecs_econ_rcp_info\";s:112:\"Enter one or more login names of users (comma seperated) that will be informed about new ECS content per e-mail.\";s:20:\"ecs_new_user_subject\";s:20:\"New ECS User Account\";s:17:\"ecs_new_user_body\";s:40:\"A new ECS user account has been created.\";s:20:\"ecs_new_user_profile\";s:18:\"User profile data:\";s:20:\"ecs_account_duration\";s:27:\"Activation Period Extension\";s:25:\"ecs_account_duration_info\";s:161:\"New ECS-User accounts are limited to the session duration. After assigning an user to a course the activation period will be extended by the given number months.\";s:12:\"ecs_no_value\";s:13:\"Not available\";s:24:\"ecs_field_semester_hours\";s:25:\"Semester Periods per Week\";s:18:\"ecs_field_courseID\";s:9:\"Course ID\";s:21:\"ecs_approval_rcp_info\";s:117:\"Enter one or more login names of users (comma seperated) that will be informed about new approved courses per e-mail.\";s:16:\"ecs_approval_rcp\";s:35:\"Notification About Approved Courses\";s:24:\"ecs_new_approval_subject\";s:30:\"A new course has been released\";s:25:\"ecs_export_created_body_a\";s:30:\"A new course has been released\";s:12:\"ecs_released\";s:6:\"Export\";s:20:\"ecs_released_content\";s:18:\"Released E-Content\";s:12:\"ecs_duration\";s:8:\"Duration\";s:21:\"ecs_event_appointment\";s:10:\"Event Date\";}');
INSERT INTO `lng_modules` VALUES ('rcrs','en','a:3:{s:17:\"rcrs_general_info\";s:20:\"General Informations\";s:23:\"rcrs_local_informations\";s:20:\"Further Informations\";s:9:\"rcrs_call\";s:18:\"Call Remote Course\";}');
INSERT INTO `lng_modules` VALUES ('mep','en','a:6:{s:17:\"mep_parent_folder\";s:13:\"Parent Folder\";s:13:\"mep_thumbnail\";s:9:\"Thumbnail\";s:25:\"mep_title_and_description\";s:21:\"Title and Description\";s:14:\"mep_create_mob\";s:19:\"Create Media Object\";s:17:\"mep_create_folder\";s:13:\"Create Folder\";s:15:\"mep_copy_to_mep\";s:18:\"Copy to Media Pool\";}');
/*!40000 ALTER TABLE `lng_modules` ENABLE KEYS */;

--
-- Table structure for table `lo_access`
--

CREATE TABLE `lo_access` (
  `timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `usr_id` int(11) NOT NULL default '0',
  `lm_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `lm_title` varchar(200) NOT NULL default ''
) TYPE=MyISAM;

--
-- Dumping data for table `lo_access`
--

/*!40000 ALTER TABLE `lo_access` DISABLE KEYS */;
/*!40000 ALTER TABLE `lo_access` ENABLE KEYS */;

--
-- Table structure for table `mail`
--

CREATE TABLE `mail` (
  `mail_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `folder_id` int(11) NOT NULL default '0',
  `sender_id` int(11) default NULL,
  `attachments` varchar(255) default NULL,
  `send_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `rcp_to` text,
  `rcp_cc` text,
  `rcp_bcc` text,
  `m_status` varchar(16) default NULL,
  `m_type` varchar(255) default NULL,
  `m_email` tinyint(1) default NULL,
  `m_subject` varchar(255) default NULL,
  `m_message` text,
  `import_name` text,
  `use_placeholders` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`mail_id`),
  KEY `jmp_uid` (`user_id`),
  KEY `folder_id` (`folder_id`),
  KEY `m_status` (`m_status`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail`
--

/*!40000 ALTER TABLE `mail` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail` ENABLE KEYS */;

--
-- Table structure for table `mail_attachment`
--

CREATE TABLE `mail_attachment` (
  `mail_id` int(11) NOT NULL default '0',
  `path` text NOT NULL,
  PRIMARY KEY  (`mail_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail_attachment`
--

/*!40000 ALTER TABLE `mail_attachment` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_attachment` ENABLE KEYS */;

--
-- Table structure for table `mail_obj_data`
--

CREATE TABLE `mail_obj_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `title` char(70) NOT NULL default '',
  `type` char(16) NOT NULL default '',
  PRIMARY KEY  (`obj_id`,`user_id`),
  KEY `jmp_uid` (`user_id`)
) TYPE=MyISAM AUTO_INCREMENT=8;

--
-- Dumping data for table `mail_obj_data`
--

/*!40000 ALTER TABLE `mail_obj_data` DISABLE KEYS */;
INSERT INTO `mail_obj_data` VALUES (2,6,'a_root','root');
INSERT INTO `mail_obj_data` VALUES (3,6,'b_inbox','inbox');
INSERT INTO `mail_obj_data` VALUES (4,6,'c_trash','trash');
INSERT INTO `mail_obj_data` VALUES (5,6,'d_drafts','drafts');
INSERT INTO `mail_obj_data` VALUES (6,6,'e_sent','sent');
INSERT INTO `mail_obj_data` VALUES (7,6,'z_local','local');
/*!40000 ALTER TABLE `mail_obj_data` ENABLE KEYS */;

--
-- Table structure for table `mail_options`
--

CREATE TABLE `mail_options` (
  `user_id` int(11) NOT NULL default '0',
  `linebreak` tinyint(4) NOT NULL default '0',
  `signature` text NOT NULL,
  `incoming_type` tinyint(3) default NULL,
  `cronjob_notification` tinyint(1) NOT NULL default '0',
  KEY `user_id` (`user_id`,`linebreak`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail_options`
--

/*!40000 ALTER TABLE `mail_options` DISABLE KEYS */;
INSERT INTO `mail_options` VALUES (6,60,'',NULL,0);
/*!40000 ALTER TABLE `mail_options` ENABLE KEYS */;

--
-- Table structure for table `mail_saved`
--

CREATE TABLE `mail_saved` (
  `user_id` int(11) NOT NULL default '0',
  `attachments` varchar(255) default NULL,
  `rcp_to` text,
  `rcp_cc` text,
  `rcp_bcc` text,
  `m_type` varchar(255) default NULL,
  `m_email` tinyint(1) default NULL,
  `m_subject` varchar(255) default NULL,
  `m_message` text,
  `use_placeholders` tinyint(1) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `mail_saved`
--

/*!40000 ALTER TABLE `mail_saved` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_saved` ENABLE KEYS */;

--
-- Table structure for table `mail_tree`
--

CREATE TABLE `mail_tree` (
  `tree` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`),
  KEY `jmp_tree` (`tree`)
) TYPE=MyISAM;

--
-- Dumping data for table `mail_tree`
--

/*!40000 ALTER TABLE `mail_tree` DISABLE KEYS */;
INSERT INTO `mail_tree` VALUES (6,2,0,1,12,1);
INSERT INTO `mail_tree` VALUES (6,3,2,2,3,2);
INSERT INTO `mail_tree` VALUES (6,4,2,4,5,2);
INSERT INTO `mail_tree` VALUES (6,5,2,6,7,2);
INSERT INTO `mail_tree` VALUES (6,6,2,8,9,2);
INSERT INTO `mail_tree` VALUES (6,7,2,10,11,2);
/*!40000 ALTER TABLE `mail_tree` ENABLE KEYS */;

--
-- Table structure for table `map_area`
--

CREATE TABLE `map_area` (
  `item_id` int(11) NOT NULL default '0',
  `nr` int(11) NOT NULL default '0',
  `shape` varchar(20) default NULL,
  `coords` varchar(200) default NULL,
  `link_type` char(3) default NULL,
  `title` varchar(200) default NULL,
  `href` varchar(200) default NULL,
  `target` varchar(50) default NULL,
  `type` varchar(20) default NULL,
  `target_frame` varchar(50) default NULL,
  PRIMARY KEY  (`item_id`,`nr`)
) TYPE=MyISAM;

--
-- Dumping data for table `map_area`
--

/*!40000 ALTER TABLE `map_area` DISABLE KEYS */;
/*!40000 ALTER TABLE `map_area` ENABLE KEYS */;

--
-- Table structure for table `media_item`
--

CREATE TABLE `media_item` (
  `id` int(11) NOT NULL auto_increment,
  `width` varchar(10) default NULL,
  `height` varchar(10) default NULL,
  `halign` enum('Left','Center','Right','LeftFloat','RightFloat') default NULL,
  `caption` text,
  `nr` int(11) NOT NULL default '0',
  `purpose` enum('Standard','Fullscreen','Additional','AudioPortable','VideoPortable') default NULL,
  `mob_id` int(11) NOT NULL default '0',
  `location` varchar(200) default NULL,
  `location_type` enum('LocalFile','Reference') NOT NULL default 'LocalFile',
  `format` varchar(200) default NULL,
  `param` text,
  `tried_thumb` enum('y','n') default 'n',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `media_item`
--

/*!40000 ALTER TABLE `media_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `media_item` ENABLE KEYS */;

--
-- Table structure for table `member_agreement`
--

CREATE TABLE `member_agreement` (
  `usr_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `accepted` tinyint(1) NOT NULL default '0',
  `acceptance_time` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `member_agreement`
--

/*!40000 ALTER TABLE `member_agreement` DISABLE KEYS */;
/*!40000 ALTER TABLE `member_agreement` ENABLE KEYS */;

--
-- Table structure for table `member_export_user_settings`
--

CREATE TABLE `member_export_user_settings` (
  `user_id` int(11) NOT NULL default '0',
  `settings` text NOT NULL,
  PRIMARY KEY  (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `member_export_user_settings`
--

/*!40000 ALTER TABLE `member_export_user_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `member_export_user_settings` ENABLE KEYS */;

--
-- Table structure for table `mep_tree`
--

CREATE TABLE `mep_tree` (
  `mep_id` int(11) NOT NULL default '0',
  `child` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  `lft` int(11) NOT NULL default '0',
  `rgt` int(11) NOT NULL default '0',
  `depth` smallint(6) NOT NULL default '0'
) TYPE=MyISAM;

--
-- Dumping data for table `mep_tree`
--

/*!40000 ALTER TABLE `mep_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `mep_tree` ENABLE KEYS */;

--
-- Table structure for table `meta_data`
--

CREATE TABLE `meta_data` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(3) NOT NULL default '',
  `title` varchar(200) NOT NULL default '',
  `language` varchar(200) NOT NULL default '',
  `description` blob NOT NULL,
  PRIMARY KEY  (`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_data`
--

/*!40000 ALTER TABLE `meta_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `meta_data` ENABLE KEYS */;

--
-- Table structure for table `meta_keyword`
--

CREATE TABLE `meta_keyword` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(3) NOT NULL default '',
  `language` char(2) NOT NULL default '',
  `keyword` varchar(200) NOT NULL default ''
) TYPE=MyISAM;

--
-- Dumping data for table `meta_keyword`
--

/*!40000 ALTER TABLE `meta_keyword` DISABLE KEYS */;
/*!40000 ALTER TABLE `meta_keyword` ENABLE KEYS */;

--
-- Table structure for table `meta_techn_format`
--

CREATE TABLE `meta_techn_format` (
  `tech_id` int(11) NOT NULL default '0',
  `format` varchar(150) default NULL,
  `nr` int(11) default NULL,
  KEY `tech_id` (`tech_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_techn_format`
--

/*!40000 ALTER TABLE `meta_techn_format` DISABLE KEYS */;
/*!40000 ALTER TABLE `meta_techn_format` ENABLE KEYS */;

--
-- Table structure for table `meta_techn_loc`
--

CREATE TABLE `meta_techn_loc` (
  `tech_id` int(11) NOT NULL default '0',
  `location` varchar(150) default NULL,
  `nr` int(11) default NULL,
  `type` enum('LocalFile','Reference') NOT NULL default 'LocalFile',
  KEY `tech_id` (`tech_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_techn_loc`
--

/*!40000 ALTER TABLE `meta_techn_loc` DISABLE KEYS */;
/*!40000 ALTER TABLE `meta_techn_loc` ENABLE KEYS */;

--
-- Table structure for table `meta_technical`
--

CREATE TABLE `meta_technical` (
  `tech_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(3) NOT NULL default '',
  `size` varchar(50) NOT NULL default '',
  `install_remarks` text NOT NULL,
  `install_remarks_lang` char(2) NOT NULL default '',
  `other_requirements` text NOT NULL,
  `other_requirements_lang` char(2) NOT NULL default '',
  `duration` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`tech_id`),
  KEY `obj_id` (`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `meta_technical`
--

/*!40000 ALTER TABLE `meta_technical` DISABLE KEYS */;
/*!40000 ALTER TABLE `meta_technical` ENABLE KEYS */;

--
-- Table structure for table `mob_parameter`
--

CREATE TABLE `mob_parameter` (
  `med_item_id` int(11) NOT NULL default '0',
  `name` varchar(50) default NULL,
  `value` text,
  KEY `mob_id` (`med_item_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `mob_parameter`
--

/*!40000 ALTER TABLE `mob_parameter` DISABLE KEYS */;
/*!40000 ALTER TABLE `mob_parameter` ENABLE KEYS */;

--
-- Table structure for table `mob_usage`
--

CREATE TABLE `mob_usage` (
  `id` int(11) NOT NULL default '0',
  `usage_type` varchar(10) NOT NULL default '',
  `usage_id` int(11) NOT NULL default '0',
  `usage_hist_nr` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`usage_type`,`usage_id`,`usage_hist_nr`)
) TYPE=MyISAM;

--
-- Dumping data for table `mob_usage`
--

/*!40000 ALTER TABLE `mob_usage` DISABLE KEYS */;
/*!40000 ALTER TABLE `mob_usage` ENABLE KEYS */;

--
-- Table structure for table `module_class`
--

CREATE TABLE `module_class` (
  `class` varchar(100) NOT NULL default '',
  `module` varchar(100) NOT NULL default '',
  `dir` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`class`)
) TYPE=MyISAM COMMENT='Class information of ILIAS Modules';

--
-- Dumping data for table `module_class`
--

/*!40000 ALTER TABLE `module_class` DISABLE KEYS */;
INSERT INTO `module_class` VALUES ('ilObjCategoryReferenceGUI','CategoryReference','classes');
INSERT INTO `module_class` VALUES ('ilChatHandlerGUI','Chat','classes');
INSERT INTO `module_class` VALUES ('ilChatPresentationGUI','Chat','classes');
INSERT INTO `module_class` VALUES ('ilObjCourseReferenceGUI','CourseReference','classes');
INSERT INTO `module_class` VALUES ('ilExerciseHandlerGUI','Exercise','classes');
INSERT INTO `module_class` VALUES ('ilGlossaryEditorGUI','Glossary','classes');
INSERT INTO `module_class` VALUES ('ilGlossaryPresentationGUI','Glossary','classes');
INSERT INTO `module_class` VALUES ('ilHTLMEditorGUI','HTMLLearningModule','classes');
INSERT INTO `module_class` VALUES ('ilHTLMPresentationGUI','HTMLLearningModule','classes');
INSERT INTO `module_class` VALUES ('ilLMEditorGUI','LearningModule','classes');
INSERT INTO `module_class` VALUES ('ilLMPresentationGUI','LearningModule','classes');
INSERT INTO `module_class` VALUES ('ilMediaCastHandlerGUI','MediaCast','classes');
INSERT INTO `module_class` VALUES ('ilMediaPoolPresentationGUI','MediaPool','classes');
INSERT INTO `module_class` VALUES ('ilObjRemoteCourseGUI','RemoteCourse','classes');
INSERT INTO `module_class` VALUES ('ilSAHSPresentationGUI','ScormAicc','classes');
INSERT INTO `module_class` VALUES ('ilSAHSEditGUI','ScormAicc','classes');
INSERT INTO `module_class` VALUES ('ilObjSurveyGUI','Survey','classes');
INSERT INTO `module_class` VALUES ('ilObjSurveyQuestionPoolGUI','SurveyQuestionPool','classes');
INSERT INTO `module_class` VALUES ('ilObjTestGUI','Test','classes');
INSERT INTO `module_class` VALUES ('ilObjQuestionPoolGUI','TestQuestionPool','classes');
INSERT INTO `module_class` VALUES ('ilLinkResourceHandlerGUI','WebResource','classes');
INSERT INTO `module_class` VALUES ('ilWikiHandlerGUI','Wiki','classes');
/*!40000 ALTER TABLE `module_class` ENABLE KEYS */;

--
-- Table structure for table `note`
--

CREATE TABLE `note` (
  `id` int(11) NOT NULL auto_increment,
  `rep_obj_id` int(11) NOT NULL default '0',
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` varchar(10) default NULL,
  `type` int(11) NOT NULL default '0',
  `author` int(11) NOT NULL default '0',
  `text` mediumtext,
  `label` int(11) NOT NULL default '0',
  `creation_date` datetime default NULL,
  `update_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `subject` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `i_author` (`author`),
  KEY `i_obj` (`rep_obj_id`,`obj_id`,`obj_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `note`
--

/*!40000 ALTER TABLE `note` DISABLE KEYS */;
/*!40000 ALTER TABLE `note` ENABLE KEYS */;

--
-- Table structure for table `note_data`
--

CREATE TABLE `note_data` (
  `note_id` int(11) NOT NULL default '0',
  `lo_id` int(11) NOT NULL default '0',
  `text` text,
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `important` enum('y','n') NOT NULL default 'n',
  `good` enum('y','n') NOT NULL default 'n',
  `question` enum('y','n') NOT NULL default 'n',
  `bad` enum('y','n') NOT NULL default 'n',
  PRIMARY KEY  (`note_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `note_data`
--

/*!40000 ALTER TABLE `note_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `note_data` ENABLE KEYS */;

--
-- Table structure for table `object_data`
--

CREATE TABLE `object_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `type` char(4) NOT NULL default 'none',
  `title` char(128) NOT NULL default '',
  `description` char(128) default NULL,
  `owner` int(11) NOT NULL default '0',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `import_id` char(50) NOT NULL default '',
  PRIMARY KEY  (`obj_id`),
  KEY `type` (`type`),
  KEY `title_index` (`title`),
  FULLTEXT KEY `title_desc` (`title`,`description`)
) TYPE=MyISAM AUTO_INCREMENT=163;

--
-- Dumping data for table `object_data`
--

/*!40000 ALTER TABLE `object_data` DISABLE KEYS */;
INSERT INTO `object_data` VALUES (2,'role','Administrator','Role for systemadministrators. This role grants access to everything!',-1,'2002-01-16 15:31:45','2003-08-15 13:18:57','');
INSERT INTO `object_data` VALUES (3,'rolt','Author','Role template for authors with write & create permissions.',-1,'2002-01-16 15:32:50','2005-07-20 16:13:42','');
INSERT INTO `object_data` VALUES (4,'role','User','Standard role for registered users. Grants read access to most objects.',-1,'2002-01-16 15:34:00','2005-07-20 16:01:03','');
INSERT INTO `object_data` VALUES (5,'role','Guest','Role grants only a few visible & read permissions.',-1,'2002-01-16 15:34:46','2005-07-20 16:01:35','');
INSERT INTO `object_data` VALUES (6,'usr','root user','ilias@yourserver.com',-1,'2002-01-16 16:09:22','2003-09-30 19:50:01','');
INSERT INTO `object_data` VALUES (7,'usrf','User accounts','Manage user accounts here.',-1,'2002-06-27 09:24:06','2004-01-20 12:23:47','');
INSERT INTO `object_data` VALUES (8,'rolf','Roles','Manage your roles here.',-1,'2002-06-27 09:24:06','2004-01-20 12:23:40','');
INSERT INTO `object_data` VALUES (1,'root','ILIAS','This is the root node of the system!!!',-1,'2002-06-24 15:15:03','2004-01-20 12:24:12','');
INSERT INTO `object_data` VALUES (9,'adm','System Settings','Folder contains the systems settings',-1,'2002-07-15 12:37:33','2002-07-15 12:37:33','');
INSERT INTO `object_data` VALUES (10,'objf','Objectdefinitions','Manage ILIAS object types and object permissions. (only for experts!)',-1,'2002-07-15 12:36:56','2004-01-20 12:23:53','');
INSERT INTO `object_data` VALUES (11,'lngf','Languages','Manage your system languages here.',-1,'2002-07-15 15:52:51','2004-01-20 12:24:06','');
INSERT INTO `object_data` VALUES (25,'typ','usr','User object',-1,'2002-07-15 15:53:37','2003-08-15 12:30:56','');
INSERT INTO `object_data` VALUES (34,'typ','lm','Learning module Object',-1,'2002-07-15 15:54:04','2003-08-15 12:33:04','');
INSERT INTO `object_data` VALUES (37,'typ','frm','Forum object',-1,'2002-07-15 15:54:22','2003-08-15 12:36:40','');
INSERT INTO `object_data` VALUES (15,'typ','grp','Group object',-1,'2002-07-15 15:54:37','2002-07-15 15:54:37','');
INSERT INTO `object_data` VALUES (16,'typ','cat','Category object',-1,'2002-07-15 15:54:54','2002-07-15 15:54:54','');
INSERT INTO `object_data` VALUES (17,'typ','crs','Course object',-1,'2002-07-15 15:55:08','2002-07-15 15:55:08','');
INSERT INTO `object_data` VALUES (19,'typ','mail','Mailmodule object',-1,'2002-07-15 15:55:49','2002-07-15 15:55:49','');
INSERT INTO `object_data` VALUES (21,'typ','adm','Administration Panel object',-1,'2002-07-15 15:56:38','2002-07-15 15:56:38','');
INSERT INTO `object_data` VALUES (22,'typ','usrf','User Folder object',-1,'2002-07-15 15:56:52','2002-07-15 15:56:52','');
INSERT INTO `object_data` VALUES (23,'typ','rolf','Role Folder object',-1,'2002-07-15 15:57:06','2002-07-15 15:57:06','');
INSERT INTO `object_data` VALUES (24,'typ','objf','Object-Type Folder object',-1,'2002-07-15 15:57:17','2002-07-15 15:57:17','');
INSERT INTO `object_data` VALUES (26,'typ','typ','Object Type Definition object',-1,'2002-07-15 15:58:16','2002-07-15 15:58:16','');
INSERT INTO `object_data` VALUES (27,'typ','rolt','Role template object',-1,'2002-07-15 15:58:16','2002-07-15 15:58:16','');
INSERT INTO `object_data` VALUES (28,'typ','lngf','Language Folder object',-1,'2002-08-28 14:22:01','2002-08-28 14:22:01','');
INSERT INTO `object_data` VALUES (29,'typ','lng','Language object',-1,'2002-08-30 10:18:29','2002-08-30 10:18:29','');
INSERT INTO `object_data` VALUES (30,'typ','role','Role Object',-1,'2002-08-30 10:21:37','2002-08-30 10:21:37','');
INSERT INTO `object_data` VALUES (31,'typ','dbk','Digilib Book',-1,'2003-08-15 10:07:29','2003-08-15 12:30:19','');
INSERT INTO `object_data` VALUES (33,'typ','root','Root Folder Object',-1,'2002-12-21 00:04:00','2003-08-15 12:04:20','');
INSERT INTO `object_data` VALUES (70,'lng','en','installed',-1,'0000-00-00 00:00:00','2008-11-25 10:56:32','');
INSERT INTO `object_data` VALUES (14,'role','Anonymous','Default role for anonymous users (with no account)',-1,'2003-08-15 12:06:19','2005-07-20 15:15:06','');
INSERT INTO `object_data` VALUES (18,'typ','mob','Multimedia object',-1,'0000-00-00 00:00:00','2003-08-15 12:03:20','');
INSERT INTO `object_data` VALUES (35,'typ','notf','Note Folder Object',-1,'2002-12-21 00:04:00','2002-12-21 00:04:00','');
INSERT INTO `object_data` VALUES (36,'typ','note','Note Object',-1,'2002-12-21 00:04:00','2002-12-21 00:04:00','');
INSERT INTO `object_data` VALUES (12,'mail','Mail Settings','Configure global mail settings here.',-1,'2003-08-15 10:07:28','2004-01-20 12:24:00','');
INSERT INTO `object_data` VALUES (20,'typ','sahs','SCORM/AICC Learning Module',-1,'2003-08-15 10:07:28','2003-08-15 12:23:10','');
INSERT INTO `object_data` VALUES (80,'rolt','il_grp_admin','Administrator role template of groups',-1,'2003-08-15 10:07:28','2005-07-20 17:04:15','');
INSERT INTO `object_data` VALUES (81,'rolt','il_grp_member','Member role template of groups',-1,'2003-08-15 10:07:28','2005-07-20 17:07:55','');
INSERT INTO `object_data` VALUES (82,'rolt','il_grp_status_closed','Group role template',-1,'2003-08-15 10:07:29','2003-08-15 13:21:38','');
INSERT INTO `object_data` VALUES (83,'rolt','il_grp_status_open','Group role template',-1,'2003-08-15 10:07:29','2003-08-15 13:21:25','');
INSERT INTO `object_data` VALUES (32,'typ','glo','Glossary',-1,'2003-08-15 10:07:30','2003-08-15 12:29:54','');
INSERT INTO `object_data` VALUES (13,'usr','Anonymous','Anonymous user account. DO NOT DELETE!',-1,'2003-08-15 10:07:30','2003-08-15 10:07:30','');
INSERT INTO `object_data` VALUES (71,'lng','de','not_installed',6,'2003-08-15 10:25:19','2003-09-30 19:50:06','');
INSERT INTO `object_data` VALUES (72,'lng','es','not_installed',6,'2003-08-15 10:25:19','2003-08-15 10:25:19','');
INSERT INTO `object_data` VALUES (73,'lng','it','not_installed',6,'2003-08-15 10:25:19','2003-08-15 10:25:19','');
INSERT INTO `object_data` VALUES (84,'typ','exc','Exercise object',-1,'2003-11-30 21:22:49','2003-11-30 21:22:49','');
INSERT INTO `object_data` VALUES (85,'typ','auth','Authentication settings',-1,'2003-11-30 21:22:49','2003-11-30 21:22:49','');
INSERT INTO `object_data` VALUES (86,'auth','Authentication settings','Select and configure authentication mode for all user accounts',-1,'2003-11-30 21:22:49','2003-11-30 21:22:49','');
INSERT INTO `object_data` VALUES (87,'typ','fold','Folder object',-1,'2003-11-30 21:22:50','2003-11-30 21:22:50','');
INSERT INTO `object_data` VALUES (88,'typ','file','File object',-1,'2003-11-30 21:22:50','2003-11-30 21:22:50','');
INSERT INTO `object_data` VALUES (89,'lng','fr','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (90,'lng','nl','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (91,'lng','pl','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (92,'lng','ua','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (93,'lng','zh','not_installed',6,'2004-01-20 12:22:17','2004-01-20 12:22:17','');
INSERT INTO `object_data` VALUES (94,'typ','tst','Test object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (95,'typ','qpl','Question pool object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (96,'typ','chat','Chat object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (97,'typ','chac','Chat server config object',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (98,'chac','Chat server settings','Configure chat server settings here',-1,'2004-02-18 21:17:40','2004-02-18 21:17:40','');
INSERT INTO `object_data` VALUES (99,'typ','recf','RecoveryFolder object',-1,'2004-03-09 18:13:16','2004-03-09 18:13:16','');
INSERT INTO `object_data` VALUES (100,'recf','__Restored Objects','Contains objects restored by recovery tool',-1,'2004-03-09 18:13:16','2004-03-09 18:13:16','');
INSERT INTO `object_data` VALUES (101,'typ','mep','Media pool object',-1,'2004-04-19 00:09:14','2004-04-19 00:09:14','');
INSERT INTO `object_data` VALUES (102,'typ','htlm','HTML LM object',-1,'2004-04-19 00:09:15','2004-04-19 00:09:15','');
INSERT INTO `object_data` VALUES (103,'typ','svy','Survey object',-1,'2004-05-15 01:18:59','2004-05-15 01:18:59','');
INSERT INTO `object_data` VALUES (104,'typ','spl','Question pool object (Survey)',-1,'2004-05-15 01:18:59','2004-05-15 01:18:59','');
INSERT INTO `object_data` VALUES (106,'typ','cals','Calendar Settings',-1,'2004-06-21 01:27:18','2004-06-21 01:27:18','');
INSERT INTO `object_data` VALUES (107,'cals','Calendar Settings','Configure Calendar Settings here',-1,'2004-06-21 01:27:18','2004-06-21 01:27:18','');
INSERT INTO `object_data` VALUES (108,'typ','trac','UserTracking object',-1,'2004-07-11 01:03:12','2004-07-11 01:03:12','');
INSERT INTO `object_data` VALUES (109,'trac','__User Tracking','System user tracking',-1,'2004-07-11 01:03:12','2004-07-11 01:03:12','');
INSERT INTO `object_data` VALUES (110,'rolt','il_crs_admin','Administrator template for course admins',-1,'2004-09-02 09:49:43','2005-07-20 16:47:58','');
INSERT INTO `object_data` VALUES (111,'rolt','il_crs_tutor','Tutor template for course tutors',-1,'2004-09-02 09:49:43','2005-07-20 16:55:04','');
INSERT INTO `object_data` VALUES (112,'rolt','il_crs_member','Member template for course members',-1,'2004-09-02 09:49:43','2005-07-20 16:59:41','');
INSERT INTO `object_data` VALUES (113,'typ','pays','Payment settings',-1,'2004-09-02 09:49:45','2004-09-02 09:49:45','');
INSERT INTO `object_data` VALUES (114,'pays','Payment settings','Payment settings',-1,'2004-09-02 09:49:45','2004-09-02 09:49:45','');
INSERT INTO `object_data` VALUES (115,'typ','assf','AssessmentFolder object',-1,'2005-01-07 17:21:15','2005-01-07 17:21:15','');
INSERT INTO `object_data` VALUES (116,'assf','__Test&Assessment','Test&Assessment Administration',-1,'2005-01-07 17:21:15','2005-01-07 17:21:15','');
INSERT INTO `object_data` VALUES (117,'typ','stys','Style Settings',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (118,'stys','System Style Settings','Manage system skin and style settings here',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (119,'typ','icrs','iLinc course object',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (120,'typ','icla','iLinc class room object',-1,'2005-03-02 08:59:01','2005-03-02 08:59:01','');
INSERT INTO `object_data` VALUES (121,'typ','crsg','Course grouping object',-1,'2005-03-02 08:59:02','2005-03-02 08:59:02','');
INSERT INTO `object_data` VALUES (122,'typ','webr','Link resource object',-1,'2005-03-13 22:41:38','2005-03-13 22:41:38','');
INSERT INTO `object_data` VALUES (123,'typ','seas','Search settings',-1,'2005-06-20 09:50:00','2005-06-20 09:50:00','');
INSERT INTO `object_data` VALUES (124,'seas','Search settings','Search settings',-1,'2005-06-20 09:50:00','2005-06-20 09:50:00','');
INSERT INTO `object_data` VALUES (125,'rolt','Local Administrator','Role template for local administrators.',6,'2005-07-20 15:33:13','2005-07-20 16:00:19','');
INSERT INTO `object_data` VALUES (126,'rolt','Co-Author','Role template for authors with limited permissions.',6,'2005-07-20 16:36:46','2005-07-20 16:42:50','');
INSERT INTO `object_data` VALUES (127,'typ','extt','external tools settings',-1,'2005-07-20 18:10:04','2005-07-20 18:10:04','');
INSERT INTO `object_data` VALUES (128,'extt','External tools settings','Configuring external tools',-1,'2005-07-20 18:10:04','2005-07-20 18:10:04','');
INSERT INTO `object_data` VALUES (129,'rolt','il_icrs_admin','Administrator template for LearnLink Seminars',-1,'2005-07-20 18:10:05','2005-07-20 18:10:05','');
INSERT INTO `object_data` VALUES (130,'rolt','il_icrs_member','Member template for LearnLink Seminars',-1,'2005-07-20 18:10:05','2005-07-20 18:10:05','');
INSERT INTO `object_data` VALUES (131,'rolt','il_crs_non_member','Non-member template for course object',-1,'2005-11-07 12:41:21','2005-11-07 12:41:21','');
INSERT INTO `object_data` VALUES (132,'chat','Public chat','Public chat',6,'2005-11-07 12:41:22','2005-11-07 12:41:22','');
INSERT INTO `object_data` VALUES (133,'rolf','132','(ref_id 24)',6,'2005-11-07 12:41:22','2005-11-07 12:41:22','');
INSERT INTO `object_data` VALUES (134,'role','il_chat_moderator_24','Moderator of chat obj_no.132',6,'2005-11-07 12:41:22','2005-11-07 12:41:22','');
INSERT INTO `object_data` VALUES (135,'typ','adve','Advanced editing object',-1,'2006-07-11 18:43:23','2006-07-11 18:43:23','');
INSERT INTO `object_data` VALUES (136,'adve','__AdvancedEditing','Advanced Editing',-1,'2006-07-11 18:43:23','2006-07-11 18:43:23','');
INSERT INTO `object_data` VALUES (137,'typ','ps','Privacy security settings',-1,'2007-02-26 17:58:49','2007-02-26 17:58:49','');
INSERT INTO `object_data` VALUES (138,'ps','__PrivacySecurity','Privacy and Security',-1,'2007-02-26 17:58:49','2007-02-26 17:58:49','');
INSERT INTO `object_data` VALUES (139,'typ','nwss','News settings',-1,'2007-02-26 17:58:50','2007-02-26 17:58:50','');
INSERT INTO `object_data` VALUES (140,'nwss','__NewsSettings','News Settings',-1,'2007-02-26 17:58:50','2007-02-26 17:58:50','');
INSERT INTO `object_data` VALUES (141,'typ','feed','External Feed',-1,'2007-02-26 17:58:50','2007-02-26 17:58:50','');
INSERT INTO `object_data` VALUES (142,'typ','mcst','Media Cast',-1,'2007-04-03 13:43:46','2007-04-03 13:43:46','');
INSERT INTO `object_data` VALUES (143,'typ','pdts','Personal desktop settings',-1,'2007-04-03 13:43:47','2007-04-03 13:43:47','');
INSERT INTO `object_data` VALUES (144,'pdts','__PersonalDesktopSettings','Personal Desktop Settings',-1,'2007-04-03 13:43:47','2007-04-03 13:43:47','');
INSERT INTO `object_data` VALUES (145,'typ','rcrs','Remote Course Object',-1,'2007-09-25 19:47:53','2007-09-25 19:47:53','');
INSERT INTO `object_data` VALUES (146,'typ','mds','Meta Data settings',-1,'2007-09-25 19:47:53','2007-09-25 19:47:53','');
INSERT INTO `object_data` VALUES (147,'mds','__MetaDataSettings','Meta Data Settings',-1,'2007-09-25 19:47:53','2007-09-25 19:47:53','');
INSERT INTO `object_data` VALUES (148,'rolt','il_frm_moderator','Moderator template for forum moderators',-1,'2007-11-27 14:43:12','2007-11-27 14:43:12','');
INSERT INTO `object_data` VALUES (149,'typ','cmps','Component settings',-1,'2008-06-02 16:08:54','2008-06-02 16:08:54','');
INSERT INTO `object_data` VALUES (150,'cmps','__ComponentSettings','Component Settings',-1,'2008-06-02 16:08:54','2008-06-02 16:08:54','');
INSERT INTO `object_data` VALUES (151,'typ','facs','File Access settings object',-1,'2008-06-02 16:08:55','2008-06-02 16:08:55','');
INSERT INTO `object_data` VALUES (152,'facs','__File Access','File Access settings',-1,'2008-06-02 16:08:55','2008-06-02 16:08:55','');
INSERT INTO `object_data` VALUES (153,'typ','svyf','Survey Settings',-1,'2008-06-02 16:08:55','2008-06-02 16:08:55','');
INSERT INTO `object_data` VALUES (154,'svyf','__SurveySettings','Survey Settings',-1,'2008-06-02 16:08:55','2008-06-02 16:08:55','');
INSERT INTO `object_data` VALUES (155,'typ','sess','Session object',-1,'2008-06-02 16:08:55','2008-06-02 16:08:55','');
INSERT INTO `object_data` VALUES (156,'typ','mcts','Mediacast settings',-1,'2008-06-02 16:08:56','2008-06-02 16:08:56','');
INSERT INTO `object_data` VALUES (157,'mcts','__MediacastSettings','Mediacast Settings',-1,'2008-06-02 16:08:56','2008-06-02 16:08:56','');
INSERT INTO `object_data` VALUES (158,'typ','wiki','Wiki',-1,'2008-06-02 16:08:57','2008-06-02 16:08:57','');
INSERT INTO `object_data` VALUES (159,'typ','crsr','Course Reference Object',-1,'2008-09-23 19:24:09','2008-09-23 19:24:09','');
INSERT INTO `object_data` VALUES (160,'typ','catr','Category Reference Object',-1,'2008-09-23 19:24:09','2008-09-23 19:24:09','');
INSERT INTO `object_data` VALUES (161,'typ','tags','Tagging settings',-1,'2008-09-23 19:24:09','2008-09-23 19:24:09','');
INSERT INTO `object_data` VALUES (162,'tags','__TaggingSettings','Tagging Settings',-1,'2008-09-23 19:24:09','2008-09-23 19:24:09','');
/*!40000 ALTER TABLE `object_data` ENABLE KEYS */;

--
-- Table structure for table `object_description`
--

CREATE TABLE `object_description` (
  `obj_id` int(11) NOT NULL default '0',
  `description` text NOT NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `object_description`
--

/*!40000 ALTER TABLE `object_description` DISABLE KEYS */;
/*!40000 ALTER TABLE `object_description` ENABLE KEYS */;

--
-- Table structure for table `object_reference`
--

CREATE TABLE `object_reference` (
  `ref_id` int(11) NOT NULL auto_increment,
  `obj_id` int(11) NOT NULL default '0',
  `deleted` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ref_id`),
  KEY `obj_id` (`obj_id`),
  KEY `obj_del` (`deleted`)
) TYPE=MyISAM AUTO_INCREMENT=36;

--
-- Dumping data for table `object_reference`
--

/*!40000 ALTER TABLE `object_reference` DISABLE KEYS */;
INSERT INTO `object_reference` VALUES (1,1,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (7,7,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (8,8,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (9,9,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (10,10,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (11,11,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (12,12,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (19,114,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (14,98,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (15,100,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (16,107,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (17,109,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (18,86,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (20,116,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (21,118,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (22,124,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (23,128,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (24,132,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (25,133,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (26,136,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (27,138,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (28,140,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (29,144,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (30,147,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (31,150,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (32,152,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (33,154,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (34,157,'0000-00-00 00:00:00');
INSERT INTO `object_reference` VALUES (35,162,'0000-00-00 00:00:00');
/*!40000 ALTER TABLE `object_reference` ENABLE KEYS */;

--
-- Table structure for table `object_translation`
--

CREATE TABLE `object_translation` (
  `obj_id` int(11) NOT NULL default '0',
  `title` varchar(128) NOT NULL,
  `description` text,
  `lang_code` char(2) NOT NULL default '',
  `lang_default` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`,`lang_code`)
) TYPE=MyISAM;

--
-- Dumping data for table `object_translation`
--

/*!40000 ALTER TABLE `object_translation` DISABLE KEYS */;
INSERT INTO `object_translation` VALUES (9,'Open Source eLearning','','en',1);
/*!40000 ALTER TABLE `object_translation` ENABLE KEYS */;

--
-- Table structure for table `page_history`
--

CREATE TABLE `page_history` (
  `page_id` int(11) NOT NULL default '0',
  `parent_type` varchar(4) NOT NULL default '',
  `hdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `parent_id` int(11) default NULL,
  `nr` int(11) default NULL,
  `user` int(11) default NULL,
  `content` mediumtext,
  `ilias_version` varchar(20) default NULL,
  PRIMARY KEY  (`page_id`,`parent_type`,`hdate`)
) TYPE=MyISAM;

--
-- Dumping data for table `page_history`
--

/*!40000 ALTER TABLE `page_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `page_history` ENABLE KEYS */;

--
-- Table structure for table `page_object`
--

CREATE TABLE `page_object` (
  `page_id` int(11) NOT NULL default '0',
  `parent_id` int(11) default NULL,
  `content` mediumtext,
  `parent_type` varchar(4) NOT NULL default 'lm',
  `last_change_user` int(11) default NULL,
  `view_cnt` int(11) default '0',
  `last_change` datetime default '0000-00-00 00:00:00',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `create_user` int(11) default NULL,
  `render_md5` varchar(32) default '',
  `rendered_content` mediumtext,
  `rendered_time` datetime default '0000-00-00 00:00:00',
  PRIMARY KEY  (`page_id`,`parent_type`),
  FULLTEXT KEY `content` (`content`)
) TYPE=MyISAM;

--
-- Dumping data for table `page_object`
--

/*!40000 ALTER TABLE `page_object` DISABLE KEYS */;
/*!40000 ALTER TABLE `page_object` ENABLE KEYS */;

--
-- Table structure for table `payment_bill_vendor`
--

CREATE TABLE `payment_bill_vendor` (
  `pobject_id` int(11) NOT NULL default '0',
  `gender` tinyint(2) default NULL,
  `firstname` char(64) default NULL,
  `lastname` char(64) default NULL,
  `title` char(64) default NULL,
  `institution` char(64) default NULL,
  `department` char(64) default NULL,
  `street` char(64) default NULL,
  `zipcode` char(16) default NULL,
  `city` char(64) default NULL,
  `country` char(64) default NULL,
  `phone` char(32) default NULL,
  `fax` char(32) default NULL,
  `email` char(64) default NULL,
  `account_number` char(32) default NULL,
  `bankcode` char(32) default NULL,
  `iban` char(64) default NULL,
  `bic` char(64) default NULL,
  `bankname` char(64) default NULL,
  PRIMARY KEY  (`pobject_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_bill_vendor`
--

/*!40000 ALTER TABLE `payment_bill_vendor` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_bill_vendor` ENABLE KEYS */;

--
-- Table structure for table `payment_coupons`
--

CREATE TABLE `payment_coupons` (
  `pc_pk` bigint(20) NOT NULL auto_increment,
  `usr_id` bigint(20) NOT NULL default '0',
  `pc_title` varchar(255) NOT NULL default '',
  `pc_description` text NOT NULL,
  `pc_type` enum('fix','percent') NOT NULL default 'fix',
  `pc_value` decimal(10,2) NOT NULL default '0.00',
  `pc_from` date NOT NULL default '0000-00-00',
  `pc_till` date NOT NULL default '0000-00-00',
  `pc_from_enabled` tinyint(1) NOT NULL default '0',
  `pc_till_enabled` tinyint(1) NOT NULL default '0',
  `pc_uses` int(11) NOT NULL default '0',
  `pc_last_change_usr_id` bigint(20) NOT NULL default '0',
  `pc_last_changed` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`pc_pk`),
  KEY `usr_id` (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_coupons`
--

/*!40000 ALTER TABLE `payment_coupons` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_coupons` ENABLE KEYS */;

--
-- Table structure for table `payment_coupons_codes`
--

CREATE TABLE `payment_coupons_codes` (
  `pcc_pk` bigint(20) NOT NULL auto_increment,
  `pcc_pc_fk` bigint(20) NOT NULL default '0',
  `pcc_code` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`pcc_pk`),
  KEY `pcc_pc_fk` (`pcc_pc_fk`),
  KEY `pcc_pc_fk_2` (`pcc_pc_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_coupons_codes`
--

/*!40000 ALTER TABLE `payment_coupons_codes` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_coupons_codes` ENABLE KEYS */;

--
-- Table structure for table `payment_coupons_objects`
--

CREATE TABLE `payment_coupons_objects` (
  `pco_pc_fk` bigint(20) NOT NULL default '0',
  `ref_id` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`pco_pc_fk`,`ref_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_coupons_objects`
--

/*!40000 ALTER TABLE `payment_coupons_objects` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_coupons_objects` ENABLE KEYS */;

--
-- Table structure for table `payment_coupons_tracking`
--

CREATE TABLE `payment_coupons_tracking` (
  `pct_pk` bigint(20) NOT NULL auto_increment,
  `pct_pcc_fk` bigint(20) NOT NULL default '0',
  `usr_id` bigint(20) NOT NULL default '0',
  `pct_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`pct_pk`),
  KEY `pct_pcc_fk` (`pct_pcc_fk`),
  KEY `usr_id` (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_coupons_tracking`
--

/*!40000 ALTER TABLE `payment_coupons_tracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_coupons_tracking` ENABLE KEYS */;

--
-- Table structure for table `payment_currencies`
--

CREATE TABLE `payment_currencies` (
  `currency_id` int(3) NOT NULL default '0',
  `unit` char(32) NOT NULL default '',
  `subunit` char(32) NOT NULL default '',
  PRIMARY KEY  (`currency_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_currencies`
--

/*!40000 ALTER TABLE `payment_currencies` DISABLE KEYS */;
INSERT INTO `payment_currencies` VALUES (1,'euro','cent');
/*!40000 ALTER TABLE `payment_currencies` ENABLE KEYS */;

--
-- Table structure for table `payment_objects`
--

CREATE TABLE `payment_objects` (
  `pobject_id` int(11) NOT NULL auto_increment,
  `ref_id` int(11) NOT NULL default '0',
  `status` int(2) NOT NULL default '0',
  `pay_method` int(2) NOT NULL default '0',
  `vendor_id` int(11) NOT NULL default '0',
  `pt_topic_fk` int(11) NOT NULL,
  `image` varchar(255) NOT NULL,
  PRIMARY KEY  (`pobject_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_objects`
--

/*!40000 ALTER TABLE `payment_objects` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_objects` ENABLE KEYS */;

--
-- Table structure for table `payment_prices`
--

CREATE TABLE `payment_prices` (
  `price_id` int(11) NOT NULL auto_increment,
  `pobject_id` int(11) NOT NULL default '0',
  `duration` int(4) NOT NULL default '0',
  `currency` int(4) NOT NULL default '0',
  `unit_value` char(6) default '0',
  `sub_unit_value` char(3) default '00',
  PRIMARY KEY  (`price_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_prices`
--

/*!40000 ALTER TABLE `payment_prices` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_prices` ENABLE KEYS */;

--
-- Table structure for table `payment_settings`
--

CREATE TABLE `payment_settings` (
  `settings_id` bigint(20) NOT NULL auto_increment,
  `currency_unit` varchar(255) NOT NULL default '',
  `currency_subunit` varchar(255) NOT NULL default '',
  `address` text NOT NULL,
  `bank_data` text NOT NULL,
  `add_info` text NOT NULL,
  `vat_rate` varchar(255) NOT NULL default '',
  `pdf_path` varchar(255) NOT NULL default '',
  `paypal` text NOT NULL,
  `bmf` text NOT NULL,
  `topics_allow_custom_sorting` tinyint(1) NOT NULL,
  `topics_sorting_type` tinyint(1) NOT NULL,
  `topics_sorting_direction` varchar(4) NOT NULL,
  `shop_enabled` tinyint(1) NOT NULL default '0',
  `max_hits` int(11) NOT NULL,
  PRIMARY KEY  (`settings_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_settings`
--

/*!40000 ALTER TABLE `payment_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_settings` ENABLE KEYS */;

--
-- Table structure for table `payment_shopping_cart`
--

CREATE TABLE `payment_shopping_cart` (
  `psc_id` int(11) NOT NULL auto_increment,
  `customer_id` int(11) NOT NULL default '0',
  `pobject_id` int(11) NOT NULL default '0',
  `price_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`psc_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_shopping_cart`
--

/*!40000 ALTER TABLE `payment_shopping_cart` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_shopping_cart` ENABLE KEYS */;

--
-- Table structure for table `payment_statistic`
--

CREATE TABLE `payment_statistic` (
  `booking_id` int(11) NOT NULL auto_increment,
  `transaction` char(64) default NULL,
  `pobject_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `b_vendor_id` int(11) default NULL,
  `b_pay_method` int(2) default NULL,
  `order_date` int(9) default NULL,
  `duration` char(16) default NULL,
  `price` char(16) NOT NULL default '',
  `discount` char(16) NOT NULL default '',
  `payed` int(2) NOT NULL default '0',
  `access` int(2) NOT NULL default '0',
  `voucher` char(64) default NULL,
  `transaction_extern` char(64) default NULL,
  PRIMARY KEY  (`booking_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_statistic`
--

/*!40000 ALTER TABLE `payment_statistic` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_statistic` ENABLE KEYS */;

--
-- Table structure for table `payment_statistic_coupons`
--

CREATE TABLE `payment_statistic_coupons` (
  `psc_ps_fk` bigint(20) NOT NULL default '0',
  `psc_pc_fk` bigint(20) NOT NULL default '0',
  `psc_pcc_fk` bigint(20) NOT NULL default '0',
  KEY `psc_ps_fk` (`psc_ps_fk`),
  KEY `psc_pc_fk` (`psc_pc_fk`),
  KEY `psc_pcc_fk` (`psc_pcc_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_statistic_coupons`
--

/*!40000 ALTER TABLE `payment_statistic_coupons` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_statistic_coupons` ENABLE KEYS */;

--
-- Table structure for table `payment_topics`
--

CREATE TABLE `payment_topics` (
  `pt_topic_pk` bigint(20) NOT NULL auto_increment,
  `pt_topic_title` varchar(255) NOT NULL,
  `pt_topic_sort` int(11) NOT NULL,
  `pt_topic_created` int(11) NOT NULL,
  `pt_topic_changed` int(11) NOT NULL,
  PRIMARY KEY  (`pt_topic_pk`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_topics`
--

/*!40000 ALTER TABLE `payment_topics` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_topics` ENABLE KEYS */;

--
-- Table structure for table `payment_topics_user_sorting`
--

CREATE TABLE `payment_topics_user_sorting` (
  `ptus_pt_topic_fk` int(11) NOT NULL,
  `ptus_usr_id` int(11) NOT NULL,
  `ptus_sorting` int(11) NOT NULL,
  PRIMARY KEY  (`ptus_pt_topic_fk`,`ptus_usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_topics_user_sorting`
--

/*!40000 ALTER TABLE `payment_topics_user_sorting` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_topics_user_sorting` ENABLE KEYS */;

--
-- Table structure for table `payment_trustees`
--

CREATE TABLE `payment_trustees` (
  `vendor_id` int(11) NOT NULL default '0',
  `trustee_id` int(11) NOT NULL default '0',
  `perm_stat` int(1) default NULL,
  `perm_obj` int(1) NOT NULL default '0',
  `perm_coupons` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`vendor_id`,`trustee_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_trustees`
--

/*!40000 ALTER TABLE `payment_trustees` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_trustees` ENABLE KEYS */;

--
-- Table structure for table `payment_vendors`
--

CREATE TABLE `payment_vendors` (
  `vendor_id` int(11) NOT NULL default '0',
  `cost_center` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`vendor_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `payment_vendors`
--

/*!40000 ALTER TABLE `payment_vendors` DISABLE KEYS */;
/*!40000 ALTER TABLE `payment_vendors` ENABLE KEYS */;

--
-- Table structure for table `personal_clipboard`
--

CREATE TABLE `personal_clipboard` (
  `user_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `type` char(4) NOT NULL default '',
  `title` char(70) NOT NULL default '',
  `insert_time` timestamp NOT NULL,
  `parent` int(11) NOT NULL default '0',
  `order_nr` int(11) NOT NULL default '0',
  PRIMARY KEY  (`user_id`,`item_id`,`type`)
) TYPE=MyISAM;

--
-- Dumping data for table `personal_clipboard`
--

/*!40000 ALTER TABLE `personal_clipboard` DISABLE KEYS */;
/*!40000 ALTER TABLE `personal_clipboard` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_cloze`
--

CREATE TABLE `qpl_answer_cloze` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `shuffle` enum('0','1') NOT NULL default '1',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `correctness` enum('0','1') NOT NULL default '0',
  `gap_id` int(10) unsigned NOT NULL default '0',
  `cloze_type` enum('0','1','2') default NULL,
  `lowerlimit` varchar(20) NOT NULL default '0',
  `upperlimit` varchar(20) NOT NULL default '0',
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_cloze`
--

/*!40000 ALTER TABLE `qpl_answer_cloze` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_cloze` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_imagemap`
--

CREATE TABLE `qpl_answer_imagemap` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `coords` text,
  `area` varchar(20) default NULL,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_imagemap`
--

/*!40000 ALTER TABLE `qpl_answer_imagemap` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_imagemap` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_matching`
--

CREATE TABLE `qpl_answer_matching` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `matchingtext` text,
  `matching_order` int(10) unsigned default NULL,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_matching`
--

/*!40000 ALTER TABLE `qpl_answer_matching` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_matching` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_matching_term`
--

CREATE TABLE `qpl_answer_matching_term` (
  `term_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL,
  `term` text NOT NULL,
  PRIMARY KEY  (`term_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_matching_term`
--

/*!40000 ALTER TABLE `qpl_answer_matching_term` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_matching_term` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_multiplechoice`
--

CREATE TABLE `qpl_answer_multiplechoice` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `imagefile` text,
  `points` double NOT NULL default '0',
  `points_unchecked` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_multiplechoice`
--

/*!40000 ALTER TABLE `qpl_answer_multiplechoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_multiplechoice` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_ordering`
--

CREATE TABLE `qpl_answer_ordering` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `solution_order` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_ordering`
--

/*!40000 ALTER TABLE `qpl_answer_ordering` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_ordering` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_singlechoice`
--

CREATE TABLE `qpl_answer_singlechoice` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `imagefile` text,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_singlechoice`
--

/*!40000 ALTER TABLE `qpl_answer_singlechoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_singlechoice` ENABLE KEYS */;

--
-- Table structure for table `qpl_answer_textsubset`
--

CREATE TABLE `qpl_answer_textsubset` (
  `answer_id` int(10) unsigned NOT NULL auto_increment,
  `question_fi` int(10) unsigned NOT NULL default '0',
  `answertext` text NOT NULL,
  `points` double NOT NULL default '0',
  `aorder` int(10) unsigned NOT NULL default '0',
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_answer_textsubset`
--

/*!40000 ALTER TABLE `qpl_answer_textsubset` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_answer_textsubset` ENABLE KEYS */;

--
-- Table structure for table `qpl_feedback_generic`
--

CREATE TABLE `qpl_feedback_generic` (
  `feedback_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `correctness` enum('0','1') NOT NULL default '0',
  `feedback` text NOT NULL,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`feedback_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_feedback_generic`
--

/*!40000 ALTER TABLE `qpl_feedback_generic` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_feedback_generic` ENABLE KEYS */;

--
-- Table structure for table `qpl_feedback_imagemap`
--

CREATE TABLE `qpl_feedback_imagemap` (
  `feedback_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `answer` int(11) NOT NULL default '0',
  `feedback` text NOT NULL,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`feedback_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_feedback_imagemap`
--

/*!40000 ALTER TABLE `qpl_feedback_imagemap` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_feedback_imagemap` ENABLE KEYS */;

--
-- Table structure for table `qpl_feedback_multiplechoice`
--

CREATE TABLE `qpl_feedback_multiplechoice` (
  `feedback_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `answer` int(11) NOT NULL default '0',
  `feedback` text NOT NULL,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`feedback_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_feedback_multiplechoice`
--

/*!40000 ALTER TABLE `qpl_feedback_multiplechoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_feedback_multiplechoice` ENABLE KEYS */;

--
-- Table structure for table `qpl_feedback_singlechoice`
--

CREATE TABLE `qpl_feedback_singlechoice` (
  `feedback_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `answer` int(11) NOT NULL default '0',
  `feedback` text NOT NULL,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`feedback_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_feedback_singlechoice`
--

/*!40000 ALTER TABLE `qpl_feedback_singlechoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_feedback_singlechoice` ENABLE KEYS */;

--
-- Table structure for table `qpl_numeric_range`
--

CREATE TABLE `qpl_numeric_range` (
  `range_id` int(11) NOT NULL auto_increment,
  `lowerlimit` varchar(20) NOT NULL default '0',
  `upperlimit` varchar(20) NOT NULL default '0',
  `points` double NOT NULL default '0',
  `aorder` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`range_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_numeric_range`
--

/*!40000 ALTER TABLE `qpl_numeric_range` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_numeric_range` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_cloze`
--

CREATE TABLE `qpl_question_cloze` (
  `question_fi` int(11) NOT NULL default '0',
  `textgap_rating` enum('ci','cs','l1','l2','l3','l4','l5') default NULL,
  `identical_scoring` enum('0','1') NOT NULL default '1',
  `fixed_textlen` int(11) default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_cloze`
--

/*!40000 ALTER TABLE `qpl_question_cloze` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_cloze` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_essay`
--

CREATE TABLE `qpl_question_essay` (
  `question_fi` int(11) NOT NULL default '0',
  `maxNumOfChars` int(11) NOT NULL default '0',
  `keywords` text,
  `textgap_rating` enum('ci','cs','l1','l2','l3','l4','l5') default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_essay`
--

/*!40000 ALTER TABLE `qpl_question_essay` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_essay` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_flash`
--

CREATE TABLE `qpl_question_flash` (
  `question_fi` int(11) NOT NULL,
  `params` text,
  `applet` varchar(150) NOT NULL,
  `width` int(11) NOT NULL default '550',
  `height` int(11) NOT NULL default '400',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_flash`
--

/*!40000 ALTER TABLE `qpl_question_flash` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_flash` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_flashapp`
--

CREATE TABLE `qpl_question_flashapp` (
  `question_fi` int(11) NOT NULL default '0',
  `flash_file` varchar(100) default NULL,
  `params` text,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_flashapp`
--

/*!40000 ALTER TABLE `qpl_question_flashapp` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_flashapp` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_imagemap`
--

CREATE TABLE `qpl_question_imagemap` (
  `question_fi` int(11) NOT NULL default '0',
  `image_file` varchar(100) default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_imagemap`
--

/*!40000 ALTER TABLE `qpl_question_imagemap` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_imagemap` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_javaapplet`
--

CREATE TABLE `qpl_question_javaapplet` (
  `question_fi` int(11) NOT NULL default '0',
  `image_file` varchar(100) default NULL,
  `params` text,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_javaapplet`
--

/*!40000 ALTER TABLE `qpl_question_javaapplet` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_javaapplet` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_matching`
--

CREATE TABLE `qpl_question_matching` (
  `question_fi` int(11) NOT NULL default '0',
  `shuffle` enum('0','1','2','3') NOT NULL default '1',
  `matching_type` enum('0','1') default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_matching`
--

/*!40000 ALTER TABLE `qpl_question_matching` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_matching` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_multiplechoice`
--

CREATE TABLE `qpl_question_multiplechoice` (
  `question_fi` int(11) NOT NULL default '0',
  `shuffle` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_multiplechoice`
--

/*!40000 ALTER TABLE `qpl_question_multiplechoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_multiplechoice` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_numeric`
--

CREATE TABLE `qpl_question_numeric` (
  `question_fi` int(11) NOT NULL default '0',
  `maxNumOfChars` int(11) NOT NULL default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_numeric`
--

/*!40000 ALTER TABLE `qpl_question_numeric` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_numeric` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_ordering`
--

CREATE TABLE `qpl_question_ordering` (
  `question_fi` int(11) NOT NULL default '0',
  `ordering_type` enum('0','1') default NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_ordering`
--

/*!40000 ALTER TABLE `qpl_question_ordering` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_ordering` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_singlechoice`
--

CREATE TABLE `qpl_question_singlechoice` (
  `question_fi` int(11) NOT NULL default '0',
  `shuffle` enum('0','1') NOT NULL default '1',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_singlechoice`
--

/*!40000 ALTER TABLE `qpl_question_singlechoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_singlechoice` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_textsubset`
--

CREATE TABLE `qpl_question_textsubset` (
  `question_fi` int(11) NOT NULL default '0',
  `textgap_rating` enum('ci','cs','l1','l2','l3','l4','l5') default NULL,
  `correctanswers` int(11) default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_question_textsubset`
--

/*!40000 ALTER TABLE `qpl_question_textsubset` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_question_textsubset` ENABLE KEYS */;

--
-- Table structure for table `qpl_question_type`
--

CREATE TABLE `qpl_question_type` (
  `question_type_id` int(3) unsigned NOT NULL auto_increment,
  `type_tag` char(35) NOT NULL default '',
  `plugin` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`question_type_id`)
) TYPE=MyISAM AUTO_INCREMENT=13;

--
-- Dumping data for table `qpl_question_type`
--

/*!40000 ALTER TABLE `qpl_question_type` DISABLE KEYS */;
INSERT INTO `qpl_question_type` VALUES (1,'assSingleChoice',0);
INSERT INTO `qpl_question_type` VALUES (2,'assMultipleChoice',0);
INSERT INTO `qpl_question_type` VALUES (3,'assClozeTest',0);
INSERT INTO `qpl_question_type` VALUES (4,'assMatchingQuestion',0);
INSERT INTO `qpl_question_type` VALUES (5,'assOrderingQuestion',0);
INSERT INTO `qpl_question_type` VALUES (6,'assImagemapQuestion',0);
INSERT INTO `qpl_question_type` VALUES (7,'assJavaApplet',0);
INSERT INTO `qpl_question_type` VALUES (8,'assTextQuestion',0);
INSERT INTO `qpl_question_type` VALUES (9,'assNumeric',0);
INSERT INTO `qpl_question_type` VALUES (10,'assTextSubset',0);
INSERT INTO `qpl_question_type` VALUES (12,'assFlashQuestion',0);
/*!40000 ALTER TABLE `qpl_question_type` ENABLE KEYS */;

--
-- Table structure for table `qpl_questionpool`
--

CREATE TABLE `qpl_questionpool` (
  `id_questionpool` int(11) NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `online` enum('0','1') NOT NULL default '0',
  `questioncount` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`id_questionpool`),
  KEY `obj_fi` (`obj_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_questionpool`
--

/*!40000 ALTER TABLE `qpl_questionpool` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_questionpool` ENABLE KEYS */;

--
-- Table structure for table `qpl_questions`
--

CREATE TABLE `qpl_questions` (
  `question_id` int(11) NOT NULL auto_increment,
  `question_type_fi` int(10) unsigned NOT NULL default '0',
  `obj_fi` int(10) unsigned NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `comment` text,
  `author` varchar(50) NOT NULL default '',
  `owner` int(11) NOT NULL default '0',
  `question_text` text NOT NULL,
  `working_time` time NOT NULL default '00:00:00',
  `points` double default NULL,
  `complete` enum('0','1') NOT NULL default '1',
  `created` varchar(14) NOT NULL default '',
  `original_id` int(11) default NULL,
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`question_id`),
  KEY `question_type_fi` (`question_type_fi`),
  KEY `original_id` (`original_id`),
  FULLTEXT KEY `title_desc` (`title`,`comment`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_questions`
--

/*!40000 ALTER TABLE `qpl_questions` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_questions` ENABLE KEYS */;

--
-- Table structure for table `qpl_suggested_solutions`
--

CREATE TABLE `qpl_suggested_solutions` (
  `suggested_solution_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `internal_link` varchar(50) default '',
  `import_id` varchar(50) default '',
  `subquestion_index` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`suggested_solution_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `qpl_suggested_solutions`
--

/*!40000 ALTER TABLE `qpl_suggested_solutions` DISABLE KEYS */;
/*!40000 ALTER TABLE `qpl_suggested_solutions` ENABLE KEYS */;

--
-- Table structure for table `rbac_fa`
--

CREATE TABLE `rbac_fa` (
  `rol_id` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  `assign` enum('y','n') default NULL,
  `protected` enum('y','n') default 'n',
  PRIMARY KEY  (`rol_id`,`parent`),
  KEY `jmp_parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_fa`
--

/*!40000 ALTER TABLE `rbac_fa` DISABLE KEYS */;
INSERT INTO `rbac_fa` VALUES (2,8,'y','y');
INSERT INTO `rbac_fa` VALUES (3,8,'n','n');
INSERT INTO `rbac_fa` VALUES (4,8,'y','n');
INSERT INTO `rbac_fa` VALUES (5,8,'y','n');
INSERT INTO `rbac_fa` VALUES (83,8,'n','n');
INSERT INTO `rbac_fa` VALUES (82,8,'n','n');
INSERT INTO `rbac_fa` VALUES (80,8,'n','y');
INSERT INTO `rbac_fa` VALUES (81,8,'n','n');
INSERT INTO `rbac_fa` VALUES (14,8,'y','n');
INSERT INTO `rbac_fa` VALUES (110,8,'n','y');
INSERT INTO `rbac_fa` VALUES (111,8,'n','n');
INSERT INTO `rbac_fa` VALUES (112,8,'n','n');
INSERT INTO `rbac_fa` VALUES (125,8,'n','y');
INSERT INTO `rbac_fa` VALUES (126,8,'n','n');
INSERT INTO `rbac_fa` VALUES (129,8,'n','y');
INSERT INTO `rbac_fa` VALUES (130,8,'n','n');
INSERT INTO `rbac_fa` VALUES (131,8,'n','n');
INSERT INTO `rbac_fa` VALUES (134,25,'y','n');
INSERT INTO `rbac_fa` VALUES (148,8,'n','n');
/*!40000 ALTER TABLE `rbac_fa` ENABLE KEYS */;

--
-- Table structure for table `rbac_operations`
--

CREATE TABLE `rbac_operations` (
  `ops_id` int(11) NOT NULL auto_increment,
  `operation` char(32) NOT NULL default '',
  `description` char(255) default NULL,
  `class` enum('create','general','object','rbac','admin','notused') NOT NULL default 'notused',
  `op_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`ops_id`),
  UNIQUE KEY `operation` (`operation`)
) TYPE=MyISAM AUTO_INCREMENT=69;

--
-- Dumping data for table `rbac_operations`
--

/*!40000 ALTER TABLE `rbac_operations` DISABLE KEYS */;
INSERT INTO `rbac_operations` VALUES (1,'edit_permission','edit permissions','rbac',NULL);
INSERT INTO `rbac_operations` VALUES (2,'visible','view object','general',100);
INSERT INTO `rbac_operations` VALUES (3,'read','access object','general',110);
INSERT INTO `rbac_operations` VALUES (4,'write','modify object','general',120);
INSERT INTO `rbac_operations` VALUES (6,'delete','remove object','general',130);
INSERT INTO `rbac_operations` VALUES (7,'join','join/subscribe','object',NULL);
INSERT INTO `rbac_operations` VALUES (8,'leave','leave/unsubscribe','object',NULL);
INSERT INTO `rbac_operations` VALUES (9,'add_post','edit forum articles','object',NULL);
INSERT INTO `rbac_operations` VALUES (10,'moderate_frm','delete forum articles','object',NULL);
INSERT INTO `rbac_operations` VALUES (11,'smtp_mail','send external mail','object',NULL);
INSERT INTO `rbac_operations` VALUES (12,'system_message','allow to send system messages','object',NULL);
INSERT INTO `rbac_operations` VALUES (13,'create_user','create new user account','create',NULL);
INSERT INTO `rbac_operations` VALUES (14,'create_role','create new role definition','create',NULL);
INSERT INTO `rbac_operations` VALUES (15,'create_rolt','create new role definition template','create',NULL);
INSERT INTO `rbac_operations` VALUES (16,'create_cat','create new category','create',NULL);
INSERT INTO `rbac_operations` VALUES (17,'create_grp','create new group','create',NULL);
INSERT INTO `rbac_operations` VALUES (18,'create_frm','create new forum','create',NULL);
INSERT INTO `rbac_operations` VALUES (19,'create_crs','create new course','create',NULL);
INSERT INTO `rbac_operations` VALUES (20,'create_lm','create new learning module','create',NULL);
INSERT INTO `rbac_operations` VALUES (21,'create_sahs','create new SCORM/AICC learning module','create',NULL);
INSERT INTO `rbac_operations` VALUES (22,'create_glo','create new glossary','create',NULL);
INSERT INTO `rbac_operations` VALUES (23,'create_dbk','create new digibook','create',NULL);
INSERT INTO `rbac_operations` VALUES (24,'create_exc','create new exercise','create',NULL);
INSERT INTO `rbac_operations` VALUES (25,'create_file','upload new file','create',NULL);
INSERT INTO `rbac_operations` VALUES (26,'create_fold','create new folder','create',NULL);
INSERT INTO `rbac_operations` VALUES (40,'edit_userassignment','change userassignment of roles','object',NULL);
INSERT INTO `rbac_operations` VALUES (41,'edit_roleassignment','change roleassignments of user accounts','object',NULL);
INSERT INTO `rbac_operations` VALUES (27,'create_tst','create new test','create',NULL);
INSERT INTO `rbac_operations` VALUES (28,'create_qpl','create new question pool','create',NULL);
INSERT INTO `rbac_operations` VALUES (29,'create_chat','create chat object','create',NULL);
INSERT INTO `rbac_operations` VALUES (30,'mail_visible','users can use mail system','object',NULL);
INSERT INTO `rbac_operations` VALUES (31,'create_mep','create new media pool','create',NULL);
INSERT INTO `rbac_operations` VALUES (32,'create_htlm','create new html learning module','create',NULL);
INSERT INTO `rbac_operations` VALUES (42,'create_svy','create new survey','create',NULL);
INSERT INTO `rbac_operations` VALUES (43,'create_spl','create new question pool (Survey)','create',NULL);
INSERT INTO `rbac_operations` VALUES (63,'create_sess','create session','create',NULL);
INSERT INTO `rbac_operations` VALUES (45,'invite','invite','object',NULL);
INSERT INTO `rbac_operations` VALUES (47,'cat_administrate_users','Administrate local user','object',NULL);
INSERT INTO `rbac_operations` VALUES (48,'read_users','read local users','object',NULL);
INSERT INTO `rbac_operations` VALUES (49,'push_desktop_items','Allow pushing desktop items','object',NULL);
INSERT INTO `rbac_operations` VALUES (50,'create_webr','create web resource','create',NULL);
INSERT INTO `rbac_operations` VALUES (51,'search','Allow using search','object',NULL);
INSERT INTO `rbac_operations` VALUES (52,'moderate','Moderate objects','object',NULL);
INSERT INTO `rbac_operations` VALUES (53,'create_icrs','create LearnLink Seminar','create',NULL);
INSERT INTO `rbac_operations` VALUES (54,'create_icla','create LearnLink Seminar room','create',NULL);
INSERT INTO `rbac_operations` VALUES (55,'edit_learning_progress','edit learning progress','object',NULL);
INSERT INTO `rbac_operations` VALUES (56,'tst_statistics','view the statistics of a test','object',NULL);
INSERT INTO `rbac_operations` VALUES (57,'export_member_data','Export member data','object',NULL);
INSERT INTO `rbac_operations` VALUES (58,'copy','Copy Object','general',115);
INSERT INTO `rbac_operations` VALUES (59,'create_feed','create external feed','create',NULL);
INSERT INTO `rbac_operations` VALUES (60,'create_mcst','create media cast','create',NULL);
INSERT INTO `rbac_operations` VALUES (61,'create_rcrs','create remote course','create',NULL);
INSERT INTO `rbac_operations` VALUES (62,'add_thread','Add Threads','object',NULL);
INSERT INTO `rbac_operations` VALUES (64,'edit_content','Edit content','object',NULL);
INSERT INTO `rbac_operations` VALUES (65,'create_wiki','create wiki','create',NULL);
INSERT INTO `rbac_operations` VALUES (66,'edit_event','Edit calendar event','object',NULL);
INSERT INTO `rbac_operations` VALUES (67,'create_crsr','create course reference','create',NULL);
INSERT INTO `rbac_operations` VALUES (68,'create_catr','create category reference','create',NULL);
/*!40000 ALTER TABLE `rbac_operations` ENABLE KEYS */;

--
-- Table structure for table `rbac_pa`
--

CREATE TABLE `rbac_pa` (
  `rol_id` int(11) NOT NULL default '0',
  `ops_id` text NOT NULL,
  `ref_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`rol_id`,`ref_id`),
  KEY `ref_id` (`ref_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_pa`
--

/*!40000 ALTER TABLE `rbac_pa` DISABLE KEYS */;
INSERT INTO `rbac_pa` VALUES (5,'a:2:{i:0;i:3;i:1;i:2;}',1);
INSERT INTO `rbac_pa` VALUES (14,'a:2:{i:0;i:3;i:1;i:2;}',1);
INSERT INTO `rbac_pa` VALUES (4,'a:2:{i:0;i:3;i:1;i:2;}',1);
INSERT INTO `rbac_pa` VALUES (2,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (3,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (4,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (5,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (14,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (80,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (81,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (82,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (83,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (110,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (111,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (112,'a:1:{i:0;s:2:\"51\";}',22);
INSERT INTO `rbac_pa` VALUES (134,'a:3:{i:0;i:52;i:1;i:3;i:2;i:2;}',24);
INSERT INTO `rbac_pa` VALUES (5,'a:1:{i:0;i:30;}',12);
INSERT INTO `rbac_pa` VALUES (4,'a:1:{i:0;i:30;}',12);
/*!40000 ALTER TABLE `rbac_pa` ENABLE KEYS */;

--
-- Table structure for table `rbac_ta`
--

CREATE TABLE `rbac_ta` (
  `typ_id` int(11) NOT NULL default '0',
  `ops_id` smallint(6) NOT NULL default '0',
  PRIMARY KEY  (`typ_id`,`ops_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_ta`
--

/*!40000 ALTER TABLE `rbac_ta` DISABLE KEYS */;
INSERT INTO `rbac_ta` VALUES (15,1);
INSERT INTO `rbac_ta` VALUES (15,2);
INSERT INTO `rbac_ta` VALUES (15,3);
INSERT INTO `rbac_ta` VALUES (15,4);
INSERT INTO `rbac_ta` VALUES (15,6);
INSERT INTO `rbac_ta` VALUES (15,7);
INSERT INTO `rbac_ta` VALUES (15,8);
INSERT INTO `rbac_ta` VALUES (15,17);
INSERT INTO `rbac_ta` VALUES (15,18);
INSERT INTO `rbac_ta` VALUES (15,20);
INSERT INTO `rbac_ta` VALUES (15,21);
INSERT INTO `rbac_ta` VALUES (15,22);
INSERT INTO `rbac_ta` VALUES (15,23);
INSERT INTO `rbac_ta` VALUES (15,24);
INSERT INTO `rbac_ta` VALUES (15,25);
INSERT INTO `rbac_ta` VALUES (15,26);
INSERT INTO `rbac_ta` VALUES (15,27);
INSERT INTO `rbac_ta` VALUES (15,28);
INSERT INTO `rbac_ta` VALUES (15,29);
INSERT INTO `rbac_ta` VALUES (15,31);
INSERT INTO `rbac_ta` VALUES (15,32);
INSERT INTO `rbac_ta` VALUES (15,42);
INSERT INTO `rbac_ta` VALUES (15,43);
INSERT INTO `rbac_ta` VALUES (15,50);
INSERT INTO `rbac_ta` VALUES (15,53);
INSERT INTO `rbac_ta` VALUES (15,55);
INSERT INTO `rbac_ta` VALUES (15,58);
INSERT INTO `rbac_ta` VALUES (15,59);
INSERT INTO `rbac_ta` VALUES (15,60);
INSERT INTO `rbac_ta` VALUES (15,65);
INSERT INTO `rbac_ta` VALUES (15,66);
INSERT INTO `rbac_ta` VALUES (16,1);
INSERT INTO `rbac_ta` VALUES (16,2);
INSERT INTO `rbac_ta` VALUES (16,3);
INSERT INTO `rbac_ta` VALUES (16,4);
INSERT INTO `rbac_ta` VALUES (16,6);
INSERT INTO `rbac_ta` VALUES (16,16);
INSERT INTO `rbac_ta` VALUES (16,17);
INSERT INTO `rbac_ta` VALUES (16,18);
INSERT INTO `rbac_ta` VALUES (16,19);
INSERT INTO `rbac_ta` VALUES (16,20);
INSERT INTO `rbac_ta` VALUES (16,21);
INSERT INTO `rbac_ta` VALUES (16,22);
INSERT INTO `rbac_ta` VALUES (16,23);
INSERT INTO `rbac_ta` VALUES (16,24);
INSERT INTO `rbac_ta` VALUES (16,25);
INSERT INTO `rbac_ta` VALUES (16,27);
INSERT INTO `rbac_ta` VALUES (16,28);
INSERT INTO `rbac_ta` VALUES (16,29);
INSERT INTO `rbac_ta` VALUES (16,31);
INSERT INTO `rbac_ta` VALUES (16,32);
INSERT INTO `rbac_ta` VALUES (16,42);
INSERT INTO `rbac_ta` VALUES (16,43);
INSERT INTO `rbac_ta` VALUES (16,47);
INSERT INTO `rbac_ta` VALUES (16,48);
INSERT INTO `rbac_ta` VALUES (16,50);
INSERT INTO `rbac_ta` VALUES (16,53);
INSERT INTO `rbac_ta` VALUES (16,58);
INSERT INTO `rbac_ta` VALUES (16,59);
INSERT INTO `rbac_ta` VALUES (16,60);
INSERT INTO `rbac_ta` VALUES (16,61);
INSERT INTO `rbac_ta` VALUES (16,65);
INSERT INTO `rbac_ta` VALUES (16,67);
INSERT INTO `rbac_ta` VALUES (16,68);
INSERT INTO `rbac_ta` VALUES (17,1);
INSERT INTO `rbac_ta` VALUES (17,2);
INSERT INTO `rbac_ta` VALUES (17,3);
INSERT INTO `rbac_ta` VALUES (17,4);
INSERT INTO `rbac_ta` VALUES (17,6);
INSERT INTO `rbac_ta` VALUES (17,7);
INSERT INTO `rbac_ta` VALUES (17,8);
INSERT INTO `rbac_ta` VALUES (17,17);
INSERT INTO `rbac_ta` VALUES (17,18);
INSERT INTO `rbac_ta` VALUES (17,20);
INSERT INTO `rbac_ta` VALUES (17,21);
INSERT INTO `rbac_ta` VALUES (17,22);
INSERT INTO `rbac_ta` VALUES (17,23);
INSERT INTO `rbac_ta` VALUES (17,24);
INSERT INTO `rbac_ta` VALUES (17,25);
INSERT INTO `rbac_ta` VALUES (17,26);
INSERT INTO `rbac_ta` VALUES (17,27);
INSERT INTO `rbac_ta` VALUES (17,28);
INSERT INTO `rbac_ta` VALUES (17,29);
INSERT INTO `rbac_ta` VALUES (17,31);
INSERT INTO `rbac_ta` VALUES (17,32);
INSERT INTO `rbac_ta` VALUES (17,42);
INSERT INTO `rbac_ta` VALUES (17,43);
INSERT INTO `rbac_ta` VALUES (17,50);
INSERT INTO `rbac_ta` VALUES (17,53);
INSERT INTO `rbac_ta` VALUES (17,55);
INSERT INTO `rbac_ta` VALUES (17,58);
INSERT INTO `rbac_ta` VALUES (17,59);
INSERT INTO `rbac_ta` VALUES (17,60);
INSERT INTO `rbac_ta` VALUES (17,63);
INSERT INTO `rbac_ta` VALUES (17,65);
INSERT INTO `rbac_ta` VALUES (17,66);
INSERT INTO `rbac_ta` VALUES (19,1);
INSERT INTO `rbac_ta` VALUES (19,2);
INSERT INTO `rbac_ta` VALUES (19,3);
INSERT INTO `rbac_ta` VALUES (19,4);
INSERT INTO `rbac_ta` VALUES (19,11);
INSERT INTO `rbac_ta` VALUES (19,12);
INSERT INTO `rbac_ta` VALUES (19,30);
INSERT INTO `rbac_ta` VALUES (20,1);
INSERT INTO `rbac_ta` VALUES (20,2);
INSERT INTO `rbac_ta` VALUES (20,3);
INSERT INTO `rbac_ta` VALUES (20,4);
INSERT INTO `rbac_ta` VALUES (20,6);
INSERT INTO `rbac_ta` VALUES (20,55);
INSERT INTO `rbac_ta` VALUES (20,58);
INSERT INTO `rbac_ta` VALUES (21,1);
INSERT INTO `rbac_ta` VALUES (21,2);
INSERT INTO `rbac_ta` VALUES (21,3);
INSERT INTO `rbac_ta` VALUES (21,4);
INSERT INTO `rbac_ta` VALUES (22,1);
INSERT INTO `rbac_ta` VALUES (22,2);
INSERT INTO `rbac_ta` VALUES (22,3);
INSERT INTO `rbac_ta` VALUES (22,4);
INSERT INTO `rbac_ta` VALUES (22,6);
INSERT INTO `rbac_ta` VALUES (22,13);
INSERT INTO `rbac_ta` VALUES (22,41);
INSERT INTO `rbac_ta` VALUES (22,48);
INSERT INTO `rbac_ta` VALUES (22,49);
INSERT INTO `rbac_ta` VALUES (23,1);
INSERT INTO `rbac_ta` VALUES (23,2);
INSERT INTO `rbac_ta` VALUES (23,3);
INSERT INTO `rbac_ta` VALUES (23,4);
INSERT INTO `rbac_ta` VALUES (23,6);
INSERT INTO `rbac_ta` VALUES (23,14);
INSERT INTO `rbac_ta` VALUES (23,15);
INSERT INTO `rbac_ta` VALUES (23,40);
INSERT INTO `rbac_ta` VALUES (24,1);
INSERT INTO `rbac_ta` VALUES (24,2);
INSERT INTO `rbac_ta` VALUES (24,3);
INSERT INTO `rbac_ta` VALUES (24,4);
INSERT INTO `rbac_ta` VALUES (28,1);
INSERT INTO `rbac_ta` VALUES (28,2);
INSERT INTO `rbac_ta` VALUES (28,3);
INSERT INTO `rbac_ta` VALUES (28,4);
INSERT INTO `rbac_ta` VALUES (31,1);
INSERT INTO `rbac_ta` VALUES (31,2);
INSERT INTO `rbac_ta` VALUES (31,3);
INSERT INTO `rbac_ta` VALUES (31,4);
INSERT INTO `rbac_ta` VALUES (31,6);
INSERT INTO `rbac_ta` VALUES (31,55);
INSERT INTO `rbac_ta` VALUES (31,58);
INSERT INTO `rbac_ta` VALUES (32,1);
INSERT INTO `rbac_ta` VALUES (32,2);
INSERT INTO `rbac_ta` VALUES (32,3);
INSERT INTO `rbac_ta` VALUES (32,4);
INSERT INTO `rbac_ta` VALUES (32,6);
INSERT INTO `rbac_ta` VALUES (32,58);
INSERT INTO `rbac_ta` VALUES (33,1);
INSERT INTO `rbac_ta` VALUES (33,2);
INSERT INTO `rbac_ta` VALUES (33,3);
INSERT INTO `rbac_ta` VALUES (33,4);
INSERT INTO `rbac_ta` VALUES (33,16);
INSERT INTO `rbac_ta` VALUES (33,68);
INSERT INTO `rbac_ta` VALUES (34,1);
INSERT INTO `rbac_ta` VALUES (34,2);
INSERT INTO `rbac_ta` VALUES (34,3);
INSERT INTO `rbac_ta` VALUES (34,4);
INSERT INTO `rbac_ta` VALUES (34,6);
INSERT INTO `rbac_ta` VALUES (34,55);
INSERT INTO `rbac_ta` VALUES (34,58);
INSERT INTO `rbac_ta` VALUES (37,1);
INSERT INTO `rbac_ta` VALUES (37,2);
INSERT INTO `rbac_ta` VALUES (37,3);
INSERT INTO `rbac_ta` VALUES (37,4);
INSERT INTO `rbac_ta` VALUES (37,6);
INSERT INTO `rbac_ta` VALUES (37,9);
INSERT INTO `rbac_ta` VALUES (37,10);
INSERT INTO `rbac_ta` VALUES (37,58);
INSERT INTO `rbac_ta` VALUES (37,62);
INSERT INTO `rbac_ta` VALUES (84,1);
INSERT INTO `rbac_ta` VALUES (84,2);
INSERT INTO `rbac_ta` VALUES (84,3);
INSERT INTO `rbac_ta` VALUES (84,4);
INSERT INTO `rbac_ta` VALUES (84,6);
INSERT INTO `rbac_ta` VALUES (84,55);
INSERT INTO `rbac_ta` VALUES (84,58);
INSERT INTO `rbac_ta` VALUES (85,1);
INSERT INTO `rbac_ta` VALUES (85,2);
INSERT INTO `rbac_ta` VALUES (85,3);
INSERT INTO `rbac_ta` VALUES (85,4);
INSERT INTO `rbac_ta` VALUES (87,1);
INSERT INTO `rbac_ta` VALUES (87,2);
INSERT INTO `rbac_ta` VALUES (87,3);
INSERT INTO `rbac_ta` VALUES (87,4);
INSERT INTO `rbac_ta` VALUES (87,6);
INSERT INTO `rbac_ta` VALUES (87,17);
INSERT INTO `rbac_ta` VALUES (87,18);
INSERT INTO `rbac_ta` VALUES (87,20);
INSERT INTO `rbac_ta` VALUES (87,21);
INSERT INTO `rbac_ta` VALUES (87,22);
INSERT INTO `rbac_ta` VALUES (87,23);
INSERT INTO `rbac_ta` VALUES (87,24);
INSERT INTO `rbac_ta` VALUES (87,25);
INSERT INTO `rbac_ta` VALUES (87,26);
INSERT INTO `rbac_ta` VALUES (87,27);
INSERT INTO `rbac_ta` VALUES (87,28);
INSERT INTO `rbac_ta` VALUES (87,29);
INSERT INTO `rbac_ta` VALUES (87,31);
INSERT INTO `rbac_ta` VALUES (87,32);
INSERT INTO `rbac_ta` VALUES (87,42);
INSERT INTO `rbac_ta` VALUES (87,43);
INSERT INTO `rbac_ta` VALUES (87,50);
INSERT INTO `rbac_ta` VALUES (87,53);
INSERT INTO `rbac_ta` VALUES (87,55);
INSERT INTO `rbac_ta` VALUES (87,58);
INSERT INTO `rbac_ta` VALUES (87,60);
INSERT INTO `rbac_ta` VALUES (87,65);
INSERT INTO `rbac_ta` VALUES (88,1);
INSERT INTO `rbac_ta` VALUES (88,2);
INSERT INTO `rbac_ta` VALUES (88,3);
INSERT INTO `rbac_ta` VALUES (88,4);
INSERT INTO `rbac_ta` VALUES (88,6);
INSERT INTO `rbac_ta` VALUES (88,58);
INSERT INTO `rbac_ta` VALUES (94,1);
INSERT INTO `rbac_ta` VALUES (94,2);
INSERT INTO `rbac_ta` VALUES (94,3);
INSERT INTO `rbac_ta` VALUES (94,4);
INSERT INTO `rbac_ta` VALUES (94,6);
INSERT INTO `rbac_ta` VALUES (94,55);
INSERT INTO `rbac_ta` VALUES (94,56);
INSERT INTO `rbac_ta` VALUES (94,58);
INSERT INTO `rbac_ta` VALUES (95,1);
INSERT INTO `rbac_ta` VALUES (95,2);
INSERT INTO `rbac_ta` VALUES (95,3);
INSERT INTO `rbac_ta` VALUES (95,4);
INSERT INTO `rbac_ta` VALUES (95,6);
INSERT INTO `rbac_ta` VALUES (96,1);
INSERT INTO `rbac_ta` VALUES (96,2);
INSERT INTO `rbac_ta` VALUES (96,3);
INSERT INTO `rbac_ta` VALUES (96,4);
INSERT INTO `rbac_ta` VALUES (96,6);
INSERT INTO `rbac_ta` VALUES (96,52);
INSERT INTO `rbac_ta` VALUES (96,58);
INSERT INTO `rbac_ta` VALUES (97,1);
INSERT INTO `rbac_ta` VALUES (97,2);
INSERT INTO `rbac_ta` VALUES (97,3);
INSERT INTO `rbac_ta` VALUES (97,4);
INSERT INTO `rbac_ta` VALUES (99,1);
INSERT INTO `rbac_ta` VALUES (99,2);
INSERT INTO `rbac_ta` VALUES (99,3);
INSERT INTO `rbac_ta` VALUES (99,4);
INSERT INTO `rbac_ta` VALUES (101,1);
INSERT INTO `rbac_ta` VALUES (101,2);
INSERT INTO `rbac_ta` VALUES (101,3);
INSERT INTO `rbac_ta` VALUES (101,4);
INSERT INTO `rbac_ta` VALUES (101,6);
INSERT INTO `rbac_ta` VALUES (102,1);
INSERT INTO `rbac_ta` VALUES (102,2);
INSERT INTO `rbac_ta` VALUES (102,3);
INSERT INTO `rbac_ta` VALUES (102,4);
INSERT INTO `rbac_ta` VALUES (102,6);
INSERT INTO `rbac_ta` VALUES (102,55);
INSERT INTO `rbac_ta` VALUES (102,58);
INSERT INTO `rbac_ta` VALUES (103,1);
INSERT INTO `rbac_ta` VALUES (103,2);
INSERT INTO `rbac_ta` VALUES (103,3);
INSERT INTO `rbac_ta` VALUES (103,4);
INSERT INTO `rbac_ta` VALUES (103,6);
INSERT INTO `rbac_ta` VALUES (103,45);
INSERT INTO `rbac_ta` VALUES (103,58);
INSERT INTO `rbac_ta` VALUES (104,1);
INSERT INTO `rbac_ta` VALUES (104,2);
INSERT INTO `rbac_ta` VALUES (104,3);
INSERT INTO `rbac_ta` VALUES (104,4);
INSERT INTO `rbac_ta` VALUES (104,6);
INSERT INTO `rbac_ta` VALUES (106,1);
INSERT INTO `rbac_ta` VALUES (106,2);
INSERT INTO `rbac_ta` VALUES (106,3);
INSERT INTO `rbac_ta` VALUES (106,4);
INSERT INTO `rbac_ta` VALUES (106,66);
INSERT INTO `rbac_ta` VALUES (108,1);
INSERT INTO `rbac_ta` VALUES (108,2);
INSERT INTO `rbac_ta` VALUES (108,3);
INSERT INTO `rbac_ta` VALUES (108,6);
INSERT INTO `rbac_ta` VALUES (113,1);
INSERT INTO `rbac_ta` VALUES (113,2);
INSERT INTO `rbac_ta` VALUES (113,3);
INSERT INTO `rbac_ta` VALUES (113,4);
INSERT INTO `rbac_ta` VALUES (115,1);
INSERT INTO `rbac_ta` VALUES (115,2);
INSERT INTO `rbac_ta` VALUES (115,3);
INSERT INTO `rbac_ta` VALUES (115,4);
INSERT INTO `rbac_ta` VALUES (117,1);
INSERT INTO `rbac_ta` VALUES (117,2);
INSERT INTO `rbac_ta` VALUES (117,3);
INSERT INTO `rbac_ta` VALUES (117,4);
INSERT INTO `rbac_ta` VALUES (119,1);
INSERT INTO `rbac_ta` VALUES (119,2);
INSERT INTO `rbac_ta` VALUES (119,3);
INSERT INTO `rbac_ta` VALUES (119,4);
INSERT INTO `rbac_ta` VALUES (119,6);
INSERT INTO `rbac_ta` VALUES (119,7);
INSERT INTO `rbac_ta` VALUES (119,8);
INSERT INTO `rbac_ta` VALUES (119,54);
INSERT INTO `rbac_ta` VALUES (119,58);
INSERT INTO `rbac_ta` VALUES (122,1);
INSERT INTO `rbac_ta` VALUES (122,2);
INSERT INTO `rbac_ta` VALUES (122,3);
INSERT INTO `rbac_ta` VALUES (122,4);
INSERT INTO `rbac_ta` VALUES (122,6);
INSERT INTO `rbac_ta` VALUES (122,58);
INSERT INTO `rbac_ta` VALUES (123,1);
INSERT INTO `rbac_ta` VALUES (123,2);
INSERT INTO `rbac_ta` VALUES (123,3);
INSERT INTO `rbac_ta` VALUES (123,4);
INSERT INTO `rbac_ta` VALUES (123,51);
INSERT INTO `rbac_ta` VALUES (127,1);
INSERT INTO `rbac_ta` VALUES (127,2);
INSERT INTO `rbac_ta` VALUES (127,3);
INSERT INTO `rbac_ta` VALUES (127,4);
INSERT INTO `rbac_ta` VALUES (135,1);
INSERT INTO `rbac_ta` VALUES (135,2);
INSERT INTO `rbac_ta` VALUES (135,3);
INSERT INTO `rbac_ta` VALUES (135,4);
INSERT INTO `rbac_ta` VALUES (137,1);
INSERT INTO `rbac_ta` VALUES (137,2);
INSERT INTO `rbac_ta` VALUES (137,3);
INSERT INTO `rbac_ta` VALUES (137,4);
INSERT INTO `rbac_ta` VALUES (137,57);
INSERT INTO `rbac_ta` VALUES (139,1);
INSERT INTO `rbac_ta` VALUES (139,2);
INSERT INTO `rbac_ta` VALUES (139,3);
INSERT INTO `rbac_ta` VALUES (139,4);
INSERT INTO `rbac_ta` VALUES (141,1);
INSERT INTO `rbac_ta` VALUES (141,2);
INSERT INTO `rbac_ta` VALUES (141,3);
INSERT INTO `rbac_ta` VALUES (141,4);
INSERT INTO `rbac_ta` VALUES (141,6);
INSERT INTO `rbac_ta` VALUES (142,1);
INSERT INTO `rbac_ta` VALUES (142,2);
INSERT INTO `rbac_ta` VALUES (142,3);
INSERT INTO `rbac_ta` VALUES (142,4);
INSERT INTO `rbac_ta` VALUES (142,6);
INSERT INTO `rbac_ta` VALUES (142,58);
INSERT INTO `rbac_ta` VALUES (143,1);
INSERT INTO `rbac_ta` VALUES (143,2);
INSERT INTO `rbac_ta` VALUES (143,3);
INSERT INTO `rbac_ta` VALUES (143,4);
INSERT INTO `rbac_ta` VALUES (145,1);
INSERT INTO `rbac_ta` VALUES (145,2);
INSERT INTO `rbac_ta` VALUES (145,3);
INSERT INTO `rbac_ta` VALUES (145,4);
INSERT INTO `rbac_ta` VALUES (145,6);
INSERT INTO `rbac_ta` VALUES (146,1);
INSERT INTO `rbac_ta` VALUES (146,2);
INSERT INTO `rbac_ta` VALUES (146,3);
INSERT INTO `rbac_ta` VALUES (146,4);
INSERT INTO `rbac_ta` VALUES (149,1);
INSERT INTO `rbac_ta` VALUES (149,2);
INSERT INTO `rbac_ta` VALUES (149,3);
INSERT INTO `rbac_ta` VALUES (149,4);
INSERT INTO `rbac_ta` VALUES (151,1);
INSERT INTO `rbac_ta` VALUES (151,2);
INSERT INTO `rbac_ta` VALUES (151,3);
INSERT INTO `rbac_ta` VALUES (151,4);
INSERT INTO `rbac_ta` VALUES (153,1);
INSERT INTO `rbac_ta` VALUES (153,2);
INSERT INTO `rbac_ta` VALUES (153,3);
INSERT INTO `rbac_ta` VALUES (153,4);
INSERT INTO `rbac_ta` VALUES (155,1);
INSERT INTO `rbac_ta` VALUES (155,2);
INSERT INTO `rbac_ta` VALUES (155,3);
INSERT INTO `rbac_ta` VALUES (155,4);
INSERT INTO `rbac_ta` VALUES (155,6);
INSERT INTO `rbac_ta` VALUES (155,58);
INSERT INTO `rbac_ta` VALUES (155,66);
INSERT INTO `rbac_ta` VALUES (156,1);
INSERT INTO `rbac_ta` VALUES (156,2);
INSERT INTO `rbac_ta` VALUES (156,3);
INSERT INTO `rbac_ta` VALUES (156,4);
INSERT INTO `rbac_ta` VALUES (158,1);
INSERT INTO `rbac_ta` VALUES (158,2);
INSERT INTO `rbac_ta` VALUES (158,3);
INSERT INTO `rbac_ta` VALUES (158,4);
INSERT INTO `rbac_ta` VALUES (158,6);
INSERT INTO `rbac_ta` VALUES (158,58);
INSERT INTO `rbac_ta` VALUES (158,64);
INSERT INTO `rbac_ta` VALUES (159,1);
INSERT INTO `rbac_ta` VALUES (159,2);
INSERT INTO `rbac_ta` VALUES (159,4);
INSERT INTO `rbac_ta` VALUES (159,6);
INSERT INTO `rbac_ta` VALUES (159,58);
INSERT INTO `rbac_ta` VALUES (160,1);
INSERT INTO `rbac_ta` VALUES (160,2);
INSERT INTO `rbac_ta` VALUES (160,4);
INSERT INTO `rbac_ta` VALUES (160,6);
INSERT INTO `rbac_ta` VALUES (160,58);
INSERT INTO `rbac_ta` VALUES (161,1);
INSERT INTO `rbac_ta` VALUES (161,2);
INSERT INTO `rbac_ta` VALUES (161,3);
INSERT INTO `rbac_ta` VALUES (161,4);
/*!40000 ALTER TABLE `rbac_ta` ENABLE KEYS */;

--
-- Table structure for table `rbac_templates`
--

CREATE TABLE `rbac_templates` (
  `rol_id` int(11) NOT NULL default '0',
  `type` char(5) NOT NULL default '',
  `ops_id` int(11) NOT NULL default '0',
  `parent` int(11) NOT NULL default '0',
  KEY `rol_id` (`rol_id`),
  KEY `type` (`type`),
  KEY `ops_id` (`ops_id`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_templates`
--

/*!40000 ALTER TABLE `rbac_templates` DISABLE KEYS */;
INSERT INTO `rbac_templates` VALUES (3,'grp',32,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',31,8);
INSERT INTO `rbac_templates` VALUES (5,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (5,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (5,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (5,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',29,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',28,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',27,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',50,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',43,8);
INSERT INTO `rbac_templates` VALUES (5,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (5,'seas',51,8);
INSERT INTO `rbac_templates` VALUES (5,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (5,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (5,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',26,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',25,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',24,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',23,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',22,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',42,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',21,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',20,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',18,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',4,8);
INSERT INTO `rbac_templates` VALUES (4,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (4,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (4,'feed',3,8);
INSERT INTO `rbac_templates` VALUES (4,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (4,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (4,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (4,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (4,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (4,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (4,'seas',51,8);
INSERT INTO `rbac_templates` VALUES (4,'mcst',3,8);
INSERT INTO `rbac_templates` VALUES (4,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (4,'mail',30,8);
INSERT INTO `rbac_templates` VALUES (4,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (4,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (5,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (5,'root',3,8);
INSERT INTO `rbac_templates` VALUES (5,'root',2,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',32,8);
INSERT INTO `rbac_templates` VALUES (4,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (4,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (4,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (4,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (4,'root',3,8);
INSERT INTO `rbac_templates` VALUES (5,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (4,'root',2,8);
INSERT INTO `rbac_templates` VALUES (83,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',31,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',28,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',27,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (4,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (4,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (4,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (4,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (5,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (4,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (4,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (80,'feed',6,8);
INSERT INTO `rbac_templates` VALUES (80,'feed',4,8);
INSERT INTO `rbac_templates` VALUES (5,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (4,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (80,'feed',3,8);
INSERT INTO `rbac_templates` VALUES (4,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (80,'feed',1,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',58,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',56,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (80,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',58,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (81,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (4,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (4,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (4,'file',3,8);
INSERT INTO `rbac_templates` VALUES (4,'file',2,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (80,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (81,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (4,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',22,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',21,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',20,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (81,'feed',3,8);
INSERT INTO `rbac_templates` VALUES (81,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (81,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (81,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (81,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (81,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (81,'mcst',3,8);
INSERT INTO `rbac_templates` VALUES (81,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (81,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (81,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (81,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (81,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (81,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (81,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (5,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (14,'seas',51,8);
INSERT INTO `rbac_templates` VALUES (14,'root',3,8);
INSERT INTO `rbac_templates` VALUES (14,'root',2,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (83,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (14,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (4,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (80,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (3,'file',6,8);
INSERT INTO `rbac_templates` VALUES (3,'file',4,8);
INSERT INTO `rbac_templates` VALUES (3,'file',3,8);
INSERT INTO `rbac_templates` VALUES (3,'file',2,8);
INSERT INTO `rbac_templates` VALUES (3,'file',1,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (3,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (3,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',50,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (80,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (80,'mcst',58,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (81,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (81,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (81,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (81,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (81,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (81,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (81,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (81,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (81,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (81,'file',3,8);
INSERT INTO `rbac_templates` VALUES (81,'file',2,8);
INSERT INTO `rbac_templates` VALUES (81,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (81,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (80,'mcst',6,8);
INSERT INTO `rbac_templates` VALUES (80,'mcst',4,8);
INSERT INTO `rbac_templates` VALUES (80,'mcst',3,8);
INSERT INTO `rbac_templates` VALUES (80,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (80,'mcst',1,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',58,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (80,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',58,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',58,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',66,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',65,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',60,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',59,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',58,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',50,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',43,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',42,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',32,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',31,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',29,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',28,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',27,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',26,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',25,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',24,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',22,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',21,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',20,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',18,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',17,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',4,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (80,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (4,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (5,'file',2,8);
INSERT INTO `rbac_templates` VALUES (4,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (5,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (4,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (5,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (110,'feed',6,8);
INSERT INTO `rbac_templates` VALUES (110,'feed',4,8);
INSERT INTO `rbac_templates` VALUES (110,'feed',3,8);
INSERT INTO `rbac_templates` VALUES (110,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (110,'feed',1,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',58,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',56,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',55,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (110,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',58,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (110,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (110,'sess',66,8);
INSERT INTO `rbac_templates` VALUES (110,'sess',58,8);
INSERT INTO `rbac_templates` VALUES (110,'sess',4,8);
INSERT INTO `rbac_templates` VALUES (110,'sess',3,8);
INSERT INTO `rbac_templates` VALUES (110,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (110,'sess',1,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (110,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (110,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (110,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (110,'mcst',58,8);
INSERT INTO `rbac_templates` VALUES (110,'mcst',6,8);
INSERT INTO `rbac_templates` VALUES (110,'mcst',4,8);
INSERT INTO `rbac_templates` VALUES (110,'mcst',3,8);
INSERT INTO `rbac_templates` VALUES (110,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (110,'mcst',1,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',58,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',55,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (110,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',58,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',55,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (110,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',58,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',55,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (110,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',66,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',65,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',60,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',59,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',58,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',50,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',43,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',42,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',32,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',31,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',29,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',28,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',27,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',26,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',25,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',24,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',23,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',22,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',21,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',20,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',18,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',17,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',4,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (110,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',58,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (111,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (111,'feed',4,8);
INSERT INTO `rbac_templates` VALUES (111,'feed',3,8);
INSERT INTO `rbac_templates` VALUES (111,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (111,'tst',58,8);
INSERT INTO `rbac_templates` VALUES (111,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (111,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (111,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',58,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (111,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (111,'sess',66,8);
INSERT INTO `rbac_templates` VALUES (111,'sess',58,8);
INSERT INTO `rbac_templates` VALUES (111,'sess',4,8);
INSERT INTO `rbac_templates` VALUES (111,'sess',3,8);
INSERT INTO `rbac_templates` VALUES (111,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (111,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (111,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (111,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (111,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (111,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (111,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (111,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (111,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (111,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (111,'mcst',58,8);
INSERT INTO `rbac_templates` VALUES (111,'mcst',4,8);
INSERT INTO `rbac_templates` VALUES (111,'mcst',3,8);
INSERT INTO `rbac_templates` VALUES (111,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (111,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (111,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (111,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (111,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (111,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (111,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (111,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (111,'glo',58,8);
INSERT INTO `rbac_templates` VALUES (111,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (111,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (111,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (112,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (112,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (112,'feed',3,8);
INSERT INTO `rbac_templates` VALUES (112,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (112,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (112,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (112,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (112,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (112,'sess',3,8);
INSERT INTO `rbac_templates` VALUES (112,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (112,'mcst',3,8);
INSERT INTO `rbac_templates` VALUES (112,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (112,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (112,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (112,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (112,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (112,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (112,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',8,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (112,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (112,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (112,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (112,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (112,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (112,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (112,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (112,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (112,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (112,'file',3,8);
INSERT INTO `rbac_templates` VALUES (112,'file',2,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',43,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',55,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (125,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (125,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (125,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (125,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (125,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (125,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (125,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (125,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (125,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (125,'mcst',6,8);
INSERT INTO `rbac_templates` VALUES (125,'mcst',2,8);
INSERT INTO `rbac_templates` VALUES (125,'mcst',1,8);
INSERT INTO `rbac_templates` VALUES (125,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (125,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (125,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',55,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (125,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',55,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'lm',1,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',55,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',6,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'htlm',1,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',6,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (125,'grp',1,8);
INSERT INTO `rbac_templates` VALUES (125,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (125,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (125,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (125,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (125,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (125,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (125,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (125,'file',6,8);
INSERT INTO `rbac_templates` VALUES (125,'file',2,8);
INSERT INTO `rbac_templates` VALUES (125,'file',1,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (125,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',55,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',6,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (125,'dbk',1,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',55,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',6,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (125,'crs',1,8);
INSERT INTO `rbac_templates` VALUES (125,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (125,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (125,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',58,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',50,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',48,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',47,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',43,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',42,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',32,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',31,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',29,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',28,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',27,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',25,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',24,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',23,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',22,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',21,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',42,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',32,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',31,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',29,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',28,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',27,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',26,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',25,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',24,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',22,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',21,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',20,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',18,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',17,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',6,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',4,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',1,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',50,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',43,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',42,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',32,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',31,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',29,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',28,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',27,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',25,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',24,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',22,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',21,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',20,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',19,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',18,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',17,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',16,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',6,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',1,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',6,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',1,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (3,'mep',6,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',1,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (3,'spl',6,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',1,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (3,'qpl',6,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',1,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',6,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',1,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',6,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',16,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',17,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',18,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',19,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',20,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',21,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',22,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',24,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',25,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',27,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',28,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',29,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',31,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',32,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',42,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',43,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',50,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (126,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (126,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (126,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (126,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (126,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (126,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (126,'file',2,8);
INSERT INTO `rbac_templates` VALUES (126,'file',3,8);
INSERT INTO `rbac_templates` VALUES (126,'file',4,8);
INSERT INTO `rbac_templates` VALUES (126,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (126,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (126,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (126,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (126,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (126,'grp',2,8);
INSERT INTO `rbac_templates` VALUES (126,'grp',3,8);
INSERT INTO `rbac_templates` VALUES (126,'grp',7,8);
INSERT INTO `rbac_templates` VALUES (126,'htlm',2,8);
INSERT INTO `rbac_templates` VALUES (126,'htlm',3,8);
INSERT INTO `rbac_templates` VALUES (126,'htlm',4,8);
INSERT INTO `rbac_templates` VALUES (126,'lm',2,8);
INSERT INTO `rbac_templates` VALUES (126,'lm',3,8);
INSERT INTO `rbac_templates` VALUES (126,'lm',4,8);
INSERT INTO `rbac_templates` VALUES (126,'sahs',2,8);
INSERT INTO `rbac_templates` VALUES (126,'sahs',3,8);
INSERT INTO `rbac_templates` VALUES (126,'sahs',4,8);
INSERT INTO `rbac_templates` VALUES (126,'mep',2,8);
INSERT INTO `rbac_templates` VALUES (126,'mep',3,8);
INSERT INTO `rbac_templates` VALUES (126,'mep',4,8);
INSERT INTO `rbac_templates` VALUES (126,'spl',2,8);
INSERT INTO `rbac_templates` VALUES (126,'spl',3,8);
INSERT INTO `rbac_templates` VALUES (126,'spl',4,8);
INSERT INTO `rbac_templates` VALUES (126,'qpl',2,8);
INSERT INTO `rbac_templates` VALUES (126,'qpl',3,8);
INSERT INTO `rbac_templates` VALUES (126,'qpl',4,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',2,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',3,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',4,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',45,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',46,8);
INSERT INTO `rbac_templates` VALUES (126,'tst',2,8);
INSERT INTO `rbac_templates` VALUES (126,'tst',3,8);
INSERT INTO `rbac_templates` VALUES (126,'tst',4,8);
INSERT INTO `rbac_templates` VALUES (126,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (126,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (126,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (110,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',58,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (110,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',65,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',60,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',58,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',32,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',31,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',28,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',27,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',23,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',22,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',21,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',20,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',17,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (110,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (110,'file',58,8);
INSERT INTO `rbac_templates` VALUES (110,'file',6,8);
INSERT INTO `rbac_templates` VALUES (110,'file',4,8);
INSERT INTO `rbac_templates` VALUES (110,'file',3,8);
INSERT INTO `rbac_templates` VALUES (110,'file',2,8);
INSERT INTO `rbac_templates` VALUES (110,'file',1,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',58,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (111,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',65,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',60,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',58,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (111,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (111,'file',58,8);
INSERT INTO `rbac_templates` VALUES (111,'file',4,8);
INSERT INTO `rbac_templates` VALUES (111,'file',3,8);
INSERT INTO `rbac_templates` VALUES (111,'file',2,8);
INSERT INTO `rbac_templates` VALUES (111,'exc',58,8);
INSERT INTO `rbac_templates` VALUES (111,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (111,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (111,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (111,'dbk',58,8);
INSERT INTO `rbac_templates` VALUES (112,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (112,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (112,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',58,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',6,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',4,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',3,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',2,8);
INSERT INTO `rbac_templates` VALUES (80,'glo',1,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',58,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (80,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',65,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',60,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',58,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',50,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',43,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',42,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',32,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',31,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',29,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',28,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',27,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',26,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',25,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',24,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',22,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',1,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',2,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',3,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',4,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',6,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',7,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',8,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',54,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',1,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',2,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',3,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',4,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',6,8);
INSERT INTO `rbac_templates` VALUES (129,'rolf',14,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',2,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',3,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',7,8);
INSERT INTO `rbac_templates` VALUES (130,'icrs',8,8);
INSERT INTO `rbac_templates` VALUES (131,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (131,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (131,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',55,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',55,8);
INSERT INTO `rbac_templates` VALUES (3,'dbk',55,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',55,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',55,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',55,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',58,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',20,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',19,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',18,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',17,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',16,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',6,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',55,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',55,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',21,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',20,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',18,8);
INSERT INTO `rbac_templates` VALUES (110,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',58,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',55,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',4,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',58,8);
INSERT INTO `rbac_templates` VALUES (3,'glo',58,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',58,8);
INSERT INTO `rbac_templates` VALUES (3,'fold',58,8);
INSERT INTO `rbac_templates` VALUES (3,'file',58,8);
INSERT INTO `rbac_templates` VALUES (3,'exc',58,8);
INSERT INTO `rbac_templates` VALUES (3,'htlm',58,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',58,8);
INSERT INTO `rbac_templates` VALUES (3,'chat',58,8);
INSERT INTO `rbac_templates` VALUES (3,'lm',58,8);
INSERT INTO `rbac_templates` VALUES (3,'sahs',58,8);
INSERT INTO `rbac_templates` VALUES (3,'svy',58,8);
INSERT INTO `rbac_templates` VALUES (3,'tst',58,8);
INSERT INTO `rbac_templates` VALUES (3,'webr',58,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',17,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',6,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',4,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',3,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',2,8);
INSERT INTO `rbac_templates` VALUES (80,'fold',1,8);
INSERT INTO `rbac_templates` VALUES (80,'file',58,8);
INSERT INTO `rbac_templates` VALUES (80,'file',6,8);
INSERT INTO `rbac_templates` VALUES (80,'file',4,8);
INSERT INTO `rbac_templates` VALUES (80,'file',3,8);
INSERT INTO `rbac_templates` VALUES (80,'file',2,8);
INSERT INTO `rbac_templates` VALUES (80,'file',1,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',58,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',55,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',6,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',4,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (110,'dbk',1,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',66,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',65,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',63,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',60,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',59,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',58,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',55,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',50,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',43,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',42,8);
INSERT INTO `rbac_templates` VALUES (111,'dbk',4,8);
INSERT INTO `rbac_templates` VALUES (111,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (111,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',66,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',65,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',63,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',60,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',59,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',58,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',55,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',50,8);
INSERT INTO `rbac_templates` VALUES (125,'cat',1,8);
INSERT INTO `rbac_templates` VALUES (126,'chat',58,8);
INSERT INTO `rbac_templates` VALUES (126,'exc',58,8);
INSERT INTO `rbac_templates` VALUES (126,'file',58,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',58,8);
INSERT INTO `rbac_templates` VALUES (126,'glo',58,8);
INSERT INTO `rbac_templates` VALUES (126,'htlm',58,8);
INSERT INTO `rbac_templates` VALUES (126,'lm',58,8);
INSERT INTO `rbac_templates` VALUES (126,'sahs',58,8);
INSERT INTO `rbac_templates` VALUES (126,'svy',58,8);
INSERT INTO `rbac_templates` VALUES (126,'tst',58,8);
INSERT INTO `rbac_templates` VALUES (126,'webr',58,8);
INSERT INTO `rbac_templates` VALUES (129,'icrs',58,8);
INSERT INTO `rbac_templates` VALUES (4,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (4,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (4,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (5,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (5,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',32,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',31,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',29,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',28,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',27,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',26,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',25,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',24,8);
INSERT INTO `rbac_templates` VALUES (112,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (112,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (112,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',22,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',21,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',20,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',43,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',42,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',29,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',26,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',25,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',24,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',6,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',4,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',3,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',2,8);
INSERT INTO `rbac_templates` VALUES (80,'exc',1,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',58,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',6,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',4,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (80,'dbk',1,8);
INSERT INTO `rbac_templates` VALUES (81,'dbk',3,8);
INSERT INTO `rbac_templates` VALUES (81,'dbk',2,8);
INSERT INTO `rbac_templates` VALUES (81,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (125,'feed',1,8);
INSERT INTO `rbac_templates` VALUES (125,'feed',2,8);
INSERT INTO `rbac_templates` VALUES (125,'feed',6,8);
INSERT INTO `rbac_templates` VALUES (125,'webr',1,8);
INSERT INTO `rbac_templates` VALUES (125,'webr',2,8);
INSERT INTO `rbac_templates` VALUES (125,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',18,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',17,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',4,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',18,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',17,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',8,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',7,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',6,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',4,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',58,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (3,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (4,'cat',3,8);
INSERT INTO `rbac_templates` VALUES (81,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (112,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (126,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',3,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',1,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',2,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',3,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',4,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',6,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',9,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',10,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',58,8);
INSERT INTO `rbac_templates` VALUES (148,'frm',62,8);
INSERT INTO `rbac_templates` VALUES (3,'root',2,8);
INSERT INTO `rbac_templates` VALUES (3,'root',3,8);
INSERT INTO `rbac_templates` VALUES (126,'root',2,8);
INSERT INTO `rbac_templates` VALUES (126,'root',3,8);
INSERT INTO `rbac_templates` VALUES (5,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (4,'cat',2,8);
INSERT INTO `rbac_templates` VALUES (112,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (125,'sess',3,8);
INSERT INTO `rbac_templates` VALUES (125,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (125,'sess',1,8);
INSERT INTO `rbac_templates` VALUES (3,'sess',4,8);
INSERT INTO `rbac_templates` VALUES (3,'sess',3,8);
INSERT INTO `rbac_templates` VALUES (3,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (3,'sess',1,8);
INSERT INTO `rbac_templates` VALUES (126,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (126,'sess',3,8);
INSERT INTO `rbac_templates` VALUES (112,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (131,'sess',2,8);
INSERT INTO `rbac_templates` VALUES (110,'crs',1,8);
INSERT INTO `rbac_templates` VALUES (3,'sess',58,8);
INSERT INTO `rbac_templates` VALUES (111,'crs',2,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',58,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',6,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',58,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',52,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',4,8);
INSERT INTO `rbac_templates` VALUES (3,'sess',66,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',66,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',3,8);
INSERT INTO `rbac_templates` VALUES (111,'chat',2,8);
INSERT INTO `rbac_templates` VALUES (3,'grp',66,8);
INSERT INTO `rbac_templates` VALUES (80,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (110,'chat',1,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (110,'webr',58,8);
INSERT INTO `rbac_templates` VALUES (110,'wiki',1,8);
INSERT INTO `rbac_templates` VALUES (110,'wiki',2,8);
INSERT INTO `rbac_templates` VALUES (110,'wiki',3,8);
INSERT INTO `rbac_templates` VALUES (110,'wiki',4,8);
INSERT INTO `rbac_templates` VALUES (110,'wiki',6,8);
INSERT INTO `rbac_templates` VALUES (110,'wiki',58,8);
INSERT INTO `rbac_templates` VALUES (110,'wiki',64,8);
INSERT INTO `rbac_templates` VALUES (111,'webr',3,8);
INSERT INTO `rbac_templates` VALUES (111,'webr',4,8);
INSERT INTO `rbac_templates` VALUES (111,'webr',58,8);
INSERT INTO `rbac_templates` VALUES (111,'wiki',2,8);
INSERT INTO `rbac_templates` VALUES (111,'wiki',3,8);
INSERT INTO `rbac_templates` VALUES (111,'wiki',4,8);
INSERT INTO `rbac_templates` VALUES (111,'wiki',58,8);
INSERT INTO `rbac_templates` VALUES (111,'wiki',64,8);
INSERT INTO `rbac_templates` VALUES (112,'wiki',2,8);
INSERT INTO `rbac_templates` VALUES (112,'wiki',3,8);
INSERT INTO `rbac_templates` VALUES (112,'wiki',64,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',6,8);
INSERT INTO `rbac_templates` VALUES (80,'webr',58,8);
INSERT INTO `rbac_templates` VALUES (80,'wiki',1,8);
INSERT INTO `rbac_templates` VALUES (80,'wiki',2,8);
INSERT INTO `rbac_templates` VALUES (80,'wiki',3,8);
INSERT INTO `rbac_templates` VALUES (80,'wiki',4,8);
INSERT INTO `rbac_templates` VALUES (80,'wiki',6,8);
INSERT INTO `rbac_templates` VALUES (80,'wiki',58,8);
INSERT INTO `rbac_templates` VALUES (80,'wiki',64,8);
INSERT INTO `rbac_templates` VALUES (81,'wiki',2,8);
INSERT INTO `rbac_templates` VALUES (81,'wiki',3,8);
INSERT INTO `rbac_templates` VALUES (81,'wiki',64,8);
INSERT INTO `rbac_templates` VALUES (4,'wiki',2,8);
INSERT INTO `rbac_templates` VALUES (4,'wiki',3,8);
INSERT INTO `rbac_templates` VALUES (4,'wiki',64,8);
INSERT INTO `rbac_templates` VALUES (5,'wiki',2,8);
INSERT INTO `rbac_templates` VALUES (3,'catr',1,8);
INSERT INTO `rbac_templates` VALUES (3,'crsr',1,8);
INSERT INTO `rbac_templates` VALUES (3,'catr',2,8);
INSERT INTO `rbac_templates` VALUES (3,'crsr',2,8);
INSERT INTO `rbac_templates` VALUES (3,'catr',4,8);
INSERT INTO `rbac_templates` VALUES (3,'crsr',4,8);
INSERT INTO `rbac_templates` VALUES (3,'catr',6,8);
INSERT INTO `rbac_templates` VALUES (3,'crsr',6,8);
INSERT INTO `rbac_templates` VALUES (3,'catr',58,8);
INSERT INTO `rbac_templates` VALUES (3,'crsr',58,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',68,8);
INSERT INTO `rbac_templates` VALUES (3,'cat',67,8);
INSERT INTO `rbac_templates` VALUES (3,'root',68,8);
INSERT INTO `rbac_templates` VALUES (126,'catr',1,8);
INSERT INTO `rbac_templates` VALUES (126,'crsr',1,8);
INSERT INTO `rbac_templates` VALUES (126,'catr',2,8);
INSERT INTO `rbac_templates` VALUES (126,'crsr',2,8);
INSERT INTO `rbac_templates` VALUES (126,'catr',4,8);
INSERT INTO `rbac_templates` VALUES (126,'crsr',4,8);
INSERT INTO `rbac_templates` VALUES (126,'catr',6,8);
INSERT INTO `rbac_templates` VALUES (126,'crsr',6,8);
INSERT INTO `rbac_templates` VALUES (126,'catr',58,8);
INSERT INTO `rbac_templates` VALUES (126,'crsr',58,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',68,8);
INSERT INTO `rbac_templates` VALUES (126,'cat',67,8);
INSERT INTO `rbac_templates` VALUES (126,'root',68,8);
INSERT INTO `rbac_templates` VALUES (110,'sess',6,8);
INSERT INTO `rbac_templates` VALUES (111,'sess',6,8);
INSERT INTO `rbac_templates` VALUES (3,'sess',6,8);
INSERT INTO `rbac_templates` VALUES (3,'crs',63,8);
/*!40000 ALTER TABLE `rbac_templates` ENABLE KEYS */;

--
-- Table structure for table `rbac_ua`
--

CREATE TABLE `rbac_ua` (
  `usr_id` int(11) NOT NULL default '0',
  `rol_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`rol_id`),
  KEY `usr_id` (`usr_id`),
  KEY `rol_id` (`rol_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `rbac_ua`
--

/*!40000 ALTER TABLE `rbac_ua` DISABLE KEYS */;
INSERT INTO `rbac_ua` VALUES (6,2);
INSERT INTO `rbac_ua` VALUES (13,14);
/*!40000 ALTER TABLE `rbac_ua` ENABLE KEYS */;

--
-- Table structure for table `read_event`
--

CREATE TABLE `read_event` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `last_access` timestamp NOT NULL,
  `read_count` int(11) NOT NULL default '0',
  `spent_seconds` int(11) NOT NULL default '0',
  `first_access` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `read_event`
--

/*!40000 ALTER TABLE `read_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `read_event` ENABLE KEYS */;

--
-- Table structure for table `reg_access_limitation`
--

CREATE TABLE `reg_access_limitation` (
  `role_id` int(11) unsigned NOT NULL default '0',
  `limit_absolute` int(11) unsigned default NULL,
  `limit_relative_d` int(11) unsigned default NULL,
  `limit_relative_m` int(11) unsigned default NULL,
  `limit_relative_y` int(11) unsigned default NULL,
  `limit_mode` enum('absolute','relative','unlimited') NOT NULL default 'absolute',
  PRIMARY KEY  (`role_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `reg_access_limitation`
--

/*!40000 ALTER TABLE `reg_access_limitation` DISABLE KEYS */;
/*!40000 ALTER TABLE `reg_access_limitation` ENABLE KEYS */;

--
-- Table structure for table `reg_email_role_assignments`
--

CREATE TABLE `reg_email_role_assignments` (
  `assignment_id` int(11) NOT NULL auto_increment,
  `domain` varchar(128) NOT NULL default '',
  `role` int(11) NOT NULL default '0',
  PRIMARY KEY  (`assignment_id`)
) TYPE=MyISAM AUTO_INCREMENT=2;

--
-- Dumping data for table `reg_email_role_assignments`
--

/*!40000 ALTER TABLE `reg_email_role_assignments` DISABLE KEYS */;
INSERT INTO `reg_email_role_assignments` VALUES (1,'',0);
/*!40000 ALTER TABLE `reg_email_role_assignments` ENABLE KEYS */;

--
-- Table structure for table `remote_course_settings`
--

CREATE TABLE `remote_course_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `local_information` text NOT NULL,
  `availability_type` tinyint(1) NOT NULL default '0',
  `start` int(11) NOT NULL default '0',
  `end` int(11) NOT NULL default '0',
  `remote_link` text NOT NULL,
  `mid` int(11) NOT NULL default '0',
  `organization` text NOT NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `remote_course_settings`
--

/*!40000 ALTER TABLE `remote_course_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `remote_course_settings` ENABLE KEYS */;

--
-- Table structure for table `role_data`
--

CREATE TABLE `role_data` (
  `role_id` int(11) NOT NULL default '0',
  `allow_register` tinyint(1) unsigned NOT NULL default '0',
  `assign_users` char(2) default '0',
  `auth_mode` enum('default','local','ldap','radius','shibboleth','script','cas','soap') NOT NULL default 'default',
  PRIMARY KEY  (`role_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `role_data`
--

/*!40000 ALTER TABLE `role_data` DISABLE KEYS */;
INSERT INTO `role_data` VALUES (2,0,'0','default');
INSERT INTO `role_data` VALUES (3,0,'0','default');
INSERT INTO `role_data` VALUES (4,0,'0','default');
INSERT INTO `role_data` VALUES (5,1,'0','default');
INSERT INTO `role_data` VALUES (14,0,'0','default');
INSERT INTO `role_data` VALUES (134,0,'0','default');
/*!40000 ALTER TABLE `role_data` ENABLE KEYS */;

--
-- Table structure for table `role_desktop_items`
--

CREATE TABLE `role_desktop_items` (
  `role_item_id` int(11) NOT NULL auto_increment,
  `role_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  `item_type` char(16) NOT NULL default '',
  KEY `role_item_id` (`role_item_id`,`role_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `role_desktop_items`
--

/*!40000 ALTER TABLE `role_desktop_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `role_desktop_items` ENABLE KEYS */;

--
-- Table structure for table `sahs_lm`
--

CREATE TABLE `sahs_lm` (
  `id` int(11) NOT NULL default '0',
  `online` enum('y','n') default 'n',
  `api_adapter` varchar(80) default 'API',
  `api_func_prefix` varchar(20) default 'LMS',
  `credit` enum('credit','no_credit') NOT NULL default 'credit',
  `default_lesson_mode` enum('normal','browse') NOT NULL default 'normal',
  `auto_review` enum('y','n') NOT NULL default 'n',
  `type` enum('scorm','aicc','hacp','scorm2004') default NULL,
  `max_attempt` int(11) default '0',
  `module_version` int(11) default '1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sahs_lm`
--

/*!40000 ALTER TABLE `sahs_lm` DISABLE KEYS */;
/*!40000 ALTER TABLE `sahs_lm` ENABLE KEYS */;

--
-- Table structure for table `sc_item`
--

CREATE TABLE `sc_item` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `identifierref` varchar(200) default NULL,
  `isvisible` enum('','true','false') default '',
  `parameters` text,
  `prereq_type` varchar(200) default NULL,
  `prerequisites` text,
  `maxtimeallowed` varchar(30) default NULL,
  `timelimitaction` varchar(30) default NULL,
  `datafromlms` text,
  `masteryscore` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_item`
--

/*!40000 ALTER TABLE `sc_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_item` ENABLE KEYS */;

--
-- Table structure for table `sc_manifest`
--

CREATE TABLE `sc_manifest` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `version` varchar(200) default NULL,
  `xml_base` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_manifest`
--

/*!40000 ALTER TABLE `sc_manifest` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_manifest` ENABLE KEYS */;

--
-- Table structure for table `sc_organization`
--

CREATE TABLE `sc_organization` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `structure` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_organization`
--

/*!40000 ALTER TABLE `sc_organization` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_organization` ENABLE KEYS */;

--
-- Table structure for table `sc_organizations`
--

CREATE TABLE `sc_organizations` (
  `obj_id` int(11) NOT NULL default '0',
  `default_organization` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_organizations`
--

/*!40000 ALTER TABLE `sc_organizations` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_organizations` ENABLE KEYS */;

--
-- Table structure for table `sc_resource`
--

CREATE TABLE `sc_resource` (
  `obj_id` int(11) NOT NULL default '0',
  `import_id` varchar(200) default NULL,
  `resourcetype` varchar(30) default NULL,
  `scormtype` enum('sco','asset') default NULL,
  `href` varchar(250) default NULL,
  `xml_base` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`),
  KEY `import_id` (`import_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resource`
--

/*!40000 ALTER TABLE `sc_resource` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_resource` ENABLE KEYS */;

--
-- Table structure for table `sc_resource_dependency`
--

CREATE TABLE `sc_resource_dependency` (
  `id` int(11) NOT NULL auto_increment,
  `res_id` int(11) default NULL,
  `identifierref` varchar(200) default NULL,
  `nr` int(11) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resource_dependency`
--

/*!40000 ALTER TABLE `sc_resource_dependency` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_resource_dependency` ENABLE KEYS */;

--
-- Table structure for table `sc_resource_file`
--

CREATE TABLE `sc_resource_file` (
  `id` int(11) NOT NULL auto_increment,
  `res_id` int(11) default NULL,
  `href` text,
  `nr` int(11) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resource_file`
--

/*!40000 ALTER TABLE `sc_resource_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_resource_file` ENABLE KEYS */;

--
-- Table structure for table `sc_resources`
--

CREATE TABLE `sc_resources` (
  `obj_id` int(11) NOT NULL default '0',
  `xml_base` varchar(200) default NULL,
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `sc_resources`
--

/*!40000 ALTER TABLE `sc_resources` DISABLE KEYS */;
/*!40000 ALTER TABLE `sc_resources` ENABLE KEYS */;

--
-- Table structure for table `scorm_object`
--

CREATE TABLE `scorm_object` (
  `obj_id` int(11) NOT NULL auto_increment,
  `title` varchar(200) default NULL,
  `type` char(3) default NULL,
  `slm_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `scorm_object`
--

/*!40000 ALTER TABLE `scorm_object` DISABLE KEYS */;
/*!40000 ALTER TABLE `scorm_object` ENABLE KEYS */;

--
-- Table structure for table `scorm_tracking`
--

CREATE TABLE `scorm_tracking` (
  `user_id` int(11) NOT NULL default '0',
  `sco_id` int(11) NOT NULL default '0',
  `lvalue` varchar(64) NOT NULL default '',
  `rvalue` text,
  `obj_id` int(11) NOT NULL default '0',
  `timestamp` timestamp NOT NULL,
  PRIMARY KEY  (`user_id`,`sco_id`,`lvalue`,`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `scorm_tracking`
--

/*!40000 ALTER TABLE `scorm_tracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `scorm_tracking` ENABLE KEYS */;

--
-- Table structure for table `scorm_tree`
--

CREATE TABLE `scorm_tree` (
  `slm_id` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `scorm_tree`
--

/*!40000 ALTER TABLE `scorm_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `scorm_tree` ENABLE KEYS */;

--
-- Table structure for table `search_data`
--

CREATE TABLE `search_data` (
  `obj_id` int(11) NOT NULL auto_increment,
  `user_id` int(11) NOT NULL default '0',
  `title` varchar(200) NOT NULL default '',
  `target` text NOT NULL,
  `type` varchar(4) NOT NULL default '',
  PRIMARY KEY  (`obj_id`,`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `search_data`
--

/*!40000 ALTER TABLE `search_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_data` ENABLE KEYS */;

--
-- Table structure for table `search_tree`
--

CREATE TABLE `search_tree` (
  `tree` int(11) NOT NULL default '0',
  `child` int(11) unsigned NOT NULL default '0',
  `parent` int(11) unsigned default NULL,
  `lft` int(11) unsigned NOT NULL default '0',
  `rgt` int(11) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`)
) TYPE=MyISAM;

--
-- Dumping data for table `search_tree`
--

/*!40000 ALTER TABLE `search_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `search_tree` ENABLE KEYS */;

--
-- Table structure for table `service_class`
--

CREATE TABLE `service_class` (
  `class` varchar(100) NOT NULL default '',
  `service` varchar(100) NOT NULL default '',
  `dir` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`class`)
) TYPE=MyISAM COMMENT='Class information of ILIAS Modules';

--
-- Dumping data for table `service_class`
--

/*!40000 ALTER TABLE `service_class` DISABLE KEYS */;
INSERT INTO `service_class` VALUES ('ilAdministrationGUI','Administration','classes');
INSERT INTO `service_class` VALUES ('ilHelpGUI','Help','classes');
INSERT INTO `service_class` VALUES ('ilStartUpGUI','Init','classes');
INSERT INTO `service_class` VALUES ('ilMailGUI','Mail','classes');
INSERT INTO `service_class` VALUES ('ilShopController','Payment','classes');
INSERT INTO `service_class` VALUES ('ilPersonalDesktopGUI','PersonalDesktop','classes');
INSERT INTO `service_class` VALUES ('ilSearchController','Search','classes');
/*!40000 ALTER TABLE `service_class` ENABLE KEYS */;

--
-- Table structure for table `settings`
--

CREATE TABLE `settings` (
  `module` varchar(50) NOT NULL default 'common',
  `keyword` varchar(50) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`module`,`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `settings`
--

/*!40000 ALTER TABLE `settings` DISABLE KEYS */;
INSERT INTO `settings` VALUES ('common','convert_path','');
INSERT INTO `settings` VALUES ('common','db_version','1367');
INSERT INTO `settings` VALUES ('common','ilias_version','3.2.3 2004-11-22');
INSERT INTO `settings` VALUES ('common','inst_info','');
INSERT INTO `settings` VALUES ('common','inst_name','');
INSERT INTO `settings` VALUES ('common','java_path','');
INSERT INTO `settings` VALUES ('common','language','en');
INSERT INTO `settings` VALUES ('common','ldap_basedn','');
INSERT INTO `settings` VALUES ('common','ldap_port','');
INSERT INTO `settings` VALUES ('common','ldap_server','');
INSERT INTO `settings` VALUES ('common','system_user_id','6');
INSERT INTO `settings` VALUES ('common','anonymous_role_id','14');
INSERT INTO `settings` VALUES ('common','error_recipient','');
INSERT INTO `settings` VALUES ('common','pub_section','');
INSERT INTO `settings` VALUES ('common','feedback_recipient','');
INSERT INTO `settings` VALUES ('common','unzip_path','');
INSERT INTO `settings` VALUES ('common','anonymous_user_id','13');
INSERT INTO `settings` VALUES ('common','zip_path','');
INSERT INTO `settings` VALUES ('common','enable_registration','1');
INSERT INTO `settings` VALUES ('common','system_role_id','2');
INSERT INTO `settings` VALUES ('common','recovery_folder_id','15');
INSERT INTO `settings` VALUES ('common','bench_max_records','10000');
INSERT INTO `settings` VALUES ('common','enable_bench','0');
INSERT INTO `settings` VALUES ('common','sys_user_tracking_id','17');
INSERT INTO `settings` VALUES ('common','enable_tracking','0');
INSERT INTO `settings` VALUES ('common','save_user_related_data','0');
INSERT INTO `settings` VALUES ('common','auth_mode','1');
INSERT INTO `settings` VALUES ('common','auto_registration','1');
INSERT INTO `settings` VALUES ('common','approve_recipient','');
INSERT INTO `settings` VALUES ('common','require_login','1');
INSERT INTO `settings` VALUES ('common','require_passwd','1');
INSERT INTO `settings` VALUES ('common','require_passwd2','1');
INSERT INTO `settings` VALUES ('common','require_firstname','1');
INSERT INTO `settings` VALUES ('common','require_gender','1');
INSERT INTO `settings` VALUES ('common','require_lastname','1');
INSERT INTO `settings` VALUES ('common','require_institution','');
INSERT INTO `settings` VALUES ('common','require_department','');
INSERT INTO `settings` VALUES ('common','require_street','');
INSERT INTO `settings` VALUES ('common','require_city','');
INSERT INTO `settings` VALUES ('common','require_zipcode','');
INSERT INTO `settings` VALUES ('common','require_country','');
INSERT INTO `settings` VALUES ('common','require_phone_office','');
INSERT INTO `settings` VALUES ('common','require_phone_home','');
INSERT INTO `settings` VALUES ('common','require_phone_mobile','');
INSERT INTO `settings` VALUES ('common','require_fax','');
INSERT INTO `settings` VALUES ('common','require_email','1');
INSERT INTO `settings` VALUES ('common','require_hobby','');
INSERT INTO `settings` VALUES ('common','require_default_role','1');
INSERT INTO `settings` VALUES ('common','require_referral_comment','');
INSERT INTO `settings` VALUES ('common','enable_js_edit','1');
INSERT INTO `settings` VALUES ('common','sys_assessment_folder_id','20');
INSERT INTO `settings` VALUES ('common','default_repository_view','flat');
INSERT INTO `settings` VALUES ('common','enable_calendar','1');
INSERT INTO `settings` VALUES ('common','custom_icon_big_width','32');
INSERT INTO `settings` VALUES ('common','custom_icon_big_height','32');
INSERT INTO `settings` VALUES ('common','custom_icon_small_width','22');
INSERT INTO `settings` VALUES ('common','custom_icon_small_height','22');
INSERT INTO `settings` VALUES ('common','icon_position_in_lists','header');
INSERT INTO `settings` VALUES ('common','new_registration_type','2');
INSERT INTO `settings` VALUES ('common','enable_trash','1');
INSERT INTO `settings` VALUES ('common','sys_advanced_editing_id','26');
INSERT INTO `settings` VALUES ('common','ilinc_akclassvalues_required','1');
INSERT INTO `settings` VALUES ('common','shib_hos_type','external_wayf');
INSERT INTO `settings` VALUES ('common','shib_federation_name','Shibboleth');
INSERT INTO `settings` VALUES ('common','shib_idp_list','');
INSERT INTO `settings` VALUES ('assessment','assessment_manual_scoring','8');
INSERT INTO `settings` VALUES ('common','show_user_activity','1');
INSERT INTO `settings` VALUES ('common','user_activity_time','5');
INSERT INTO `settings` VALUES ('common','block_activated_pdusers','1');
INSERT INTO `settings` VALUES ('common','custom_icon_tiny_width','16');
INSERT INTO `settings` VALUES ('common','custom_icon_tiny_height','16');
INSERT INTO `settings` VALUES ('common','usr_settings_hide_hide_own_online_status','1');
INSERT INTO `settings` VALUES ('news','acc_cache_mins','10');
INSERT INTO `settings` VALUES ('file_access','inline_file_extensions','');
INSERT INTO `settings` VALUES ('survey','unlimited_invitation','1');
INSERT INTO `settings` VALUES ('common','ps_account_security_mode','1');
/*!40000 ALTER TABLE `settings` ENABLE KEYS */;

--
-- Table structure for table `settings_deactivated_styles`
--

CREATE TABLE `settings_deactivated_styles` (
  `skin` varchar(100) NOT NULL default '',
  `style` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`skin`,`style`)
) TYPE=MyISAM;

--
-- Dumping data for table `settings_deactivated_styles`
--

/*!40000 ALTER TABLE `settings_deactivated_styles` DISABLE KEYS */;
/*!40000 ALTER TABLE `settings_deactivated_styles` ENABLE KEYS */;

--
-- Table structure for table `style_data`
--

CREATE TABLE `style_data` (
  `id` int(11) NOT NULL default '0',
  `uptodate` tinyint(2) default '0',
  `standard` tinyint(2) default '0',
  `category` int(11) default NULL,
  `active` tinyint(2) default '1',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `style_data`
--

/*!40000 ALTER TABLE `style_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `style_data` ENABLE KEYS */;

--
-- Table structure for table `style_folder_styles`
--

CREATE TABLE `style_folder_styles` (
  `folder_id` int(11) NOT NULL default '0',
  `style_id` int(11) NOT NULL default '0',
  KEY `f_id` (`folder_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `style_folder_styles`
--

/*!40000 ALTER TABLE `style_folder_styles` DISABLE KEYS */;
/*!40000 ALTER TABLE `style_folder_styles` ENABLE KEYS */;

--
-- Table structure for table `style_parameter`
--

CREATE TABLE `style_parameter` (
  `id` int(11) NOT NULL auto_increment,
  `style_id` int(11) NOT NULL default '0',
  `tag` varchar(100) default NULL,
  `class` varchar(100) default NULL,
  `parameter` varchar(100) default NULL,
  `value` varchar(100) default NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `style_parameter`
--

/*!40000 ALTER TABLE `style_parameter` DISABLE KEYS */;
/*!40000 ALTER TABLE `style_parameter` ENABLE KEYS */;

--
-- Table structure for table `survey_anonymous`
--

CREATE TABLE `survey_anonymous` (
  `anonymous_id` int(11) NOT NULL auto_increment,
  `survey_key` varchar(32) NOT NULL default '',
  `survey_fi` int(11) NOT NULL default '0',
  `user_key` varchar(40) default NULL,
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`anonymous_id`),
  KEY `survey_key` (`survey_key`,`survey_fi`),
  KEY `survey_fi` (`survey_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_anonymous`
--

/*!40000 ALTER TABLE `survey_anonymous` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_anonymous` ENABLE KEYS */;

--
-- Table structure for table `survey_answer`
--

CREATE TABLE `survey_answer` (
  `answer_id` int(11) NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `anonymous_id` varchar(32) NOT NULL default '',
  `value` double default NULL,
  `textanswer` text,
  `row` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`answer_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `question_fi` (`question_fi`),
  KEY `user_fi` (`user_fi`),
  KEY `anonymous_id` (`anonymous_id`),
  KEY `active_fi` (`active_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_answer`
--

/*!40000 ALTER TABLE `survey_answer` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_answer` ENABLE KEYS */;

--
-- Table structure for table `survey_category`
--

CREATE TABLE `survey_category` (
  `category_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `defaultvalue` enum('0','1') NOT NULL default '0',
  `owner_fi` int(11) NOT NULL default '0',
  `neutral` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`category_id`),
  KEY `owner_fi` (`owner_fi`)
) TYPE=MyISAM AUTO_INCREMENT=36;

--
-- Dumping data for table `survey_category`
--

/*!40000 ALTER TABLE `survey_category` DISABLE KEYS */;
INSERT INTO `survey_category` VALUES (1,'dc_desired','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (2,'dc_undesired','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (3,'dc_agree','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (4,'dc_disagree','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (5,'dc_good','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (6,'dc_notacceptable','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (7,'dc_should','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (8,'dc_shouldnot','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (9,'dc_true','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (10,'dc_false','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (11,'dc_always','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (12,'dc_never','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (13,'dc_yes','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (14,'dc_no','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (15,'dc_neutral','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (16,'dc_undecided','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (17,'dc_fair','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (18,'dc_sometimes','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (19,'dc_stronglydesired','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (20,'dc_stronglyundesired','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (21,'dc_stronglyagree','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (22,'dc_stronglydisagree','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (23,'dc_verygood','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (24,'dc_poor','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (25,'dc_must','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (26,'dc_mustnot','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (27,'dc_definitelytrue','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (28,'dc_definitelyfalse','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (29,'dc_manytimes','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (30,'dc_varying','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (31,'dc_rarely','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (32,'dc_mostcertainly','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (33,'dc_morepositive','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (34,'dc_morenegative','1',0,'0','2004-05-22 01:43:01');
INSERT INTO `survey_category` VALUES (35,'dc_mostcertainlynot','1',0,'0','2004-05-22 01:43:01');
/*!40000 ALTER TABLE `survey_category` ENABLE KEYS */;

--
-- Table structure for table `survey_constraint`
--

CREATE TABLE `survey_constraint` (
  `constraint_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `relation_fi` int(11) NOT NULL default '0',
  `value` double NOT NULL default '0',
  PRIMARY KEY  (`constraint_id`),
  KEY `question_fi` (`question_fi`),
  KEY `relation_fi` (`relation_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_constraint`
--

/*!40000 ALTER TABLE `survey_constraint` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_constraint` ENABLE KEYS */;

--
-- Table structure for table `survey_finished`
--

CREATE TABLE `survey_finished` (
  `finished_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `anonymous_id` varchar(32) default NULL,
  `state` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`finished_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `user_fi` (`user_fi`),
  KEY `anonymous_id` (`anonymous_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_finished`
--

/*!40000 ALTER TABLE `survey_finished` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_finished` ENABLE KEYS */;

--
-- Table structure for table `survey_invited_group`
--

CREATE TABLE `survey_invited_group` (
  `invited_group_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `group_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`invited_group_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `group_fi` (`group_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_invited_group`
--

/*!40000 ALTER TABLE `survey_invited_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_invited_group` ENABLE KEYS */;

--
-- Table structure for table `survey_invited_user`
--

CREATE TABLE `survey_invited_user` (
  `invited_user_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`invited_user_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `user_fi` (`user_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_invited_user`
--

/*!40000 ALTER TABLE `survey_invited_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_invited_user` ENABLE KEYS */;

--
-- Table structure for table `survey_material`
--

CREATE TABLE `survey_material` (
  `material_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `internal_link` varchar(50) default NULL,
  `import_id` varchar(50) default NULL,
  `material_title` varchar(255) default NULL,
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`material_id`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_material`
--

/*!40000 ALTER TABLE `survey_material` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_material` ENABLE KEYS */;

--
-- Table structure for table `survey_phrase`
--

CREATE TABLE `survey_phrase` (
  `phrase_id` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `defaultvalue` enum('0','1','2') NOT NULL default '0',
  `owner_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`phrase_id`),
  KEY `owner_fi` (`owner_fi`)
) TYPE=MyISAM AUTO_INCREMENT=23;

--
-- Dumping data for table `survey_phrase`
--

/*!40000 ALTER TABLE `survey_phrase` DISABLE KEYS */;
INSERT INTO `survey_phrase` VALUES (1,'dp_standard_attitude_desired_undesired','1',0,'2004-05-22 01:54:31');
INSERT INTO `survey_phrase` VALUES (2,'dp_standard_attitude_agree_disagree','1',0,'2004-05-22 01:54:58');
INSERT INTO `survey_phrase` VALUES (3,'dp_standard_attitude_good_notacceptable','1',0,'2004-05-22 01:55:18');
INSERT INTO `survey_phrase` VALUES (4,'dp_standard_attitude_shold_shouldnot','1',0,'2004-05-22 01:55:46');
INSERT INTO `survey_phrase` VALUES (5,'dp_standard_beliefs_true_false','1',0,'2004-05-22 01:56:13');
INSERT INTO `survey_phrase` VALUES (6,'dp_standard_beliefs_always_never','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (7,'dp_standard_behaviour_yes_no','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (8,'dp_standard_attitude_desired_neutral_undesired','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (9,'dp_standard_attitude_agree_undecided_disagree','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (10,'dp_standard_attitude_good_fair_notacceptable','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (11,'dp_standard_attitude_should_undecided_shouldnot','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (12,'dp_standard_beliefs_true_undecided_false','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (13,'dp_standard_beliefs_always_sometimes_never','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (14,'dp_standard_behaviour_yes_undecided_no','1',0,'2004-05-22 02:05:47');
INSERT INTO `survey_phrase` VALUES (15,'dp_standard_attitude_desired5','1',0,'2004-05-22 03:07:02');
INSERT INTO `survey_phrase` VALUES (16,'dp_standard_attitude_agree5','1',0,'2004-05-22 03:07:17');
INSERT INTO `survey_phrase` VALUES (17,'dp_standard_attitude_good5','1',0,'2004-05-22 03:07:29');
INSERT INTO `survey_phrase` VALUES (18,'dp_standard_attitude_must5','1',0,'2004-05-22 03:07:44');
INSERT INTO `survey_phrase` VALUES (19,'dp_standard_beliefs_true5','1',0,'2004-05-22 03:07:54');
INSERT INTO `survey_phrase` VALUES (20,'dp_standard_beliefs_always5','1',0,'2004-05-22 03:08:12');
INSERT INTO `survey_phrase` VALUES (21,'dp_standard_behaviour_certainly5','1',0,'2004-05-22 03:08:28');
INSERT INTO `survey_phrase` VALUES (22,'dp_standard_numbers','1',0,'2004-06-20 13:27:19');
/*!40000 ALTER TABLE `survey_phrase` ENABLE KEYS */;

--
-- Table structure for table `survey_phrase_category`
--

CREATE TABLE `survey_phrase_category` (
  `phrase_category_id` int(11) NOT NULL auto_increment,
  `phrase_fi` int(11) NOT NULL default '0',
  `category_fi` int(11) NOT NULL default '0',
  `sequence` int(11) NOT NULL default '0',
  PRIMARY KEY  (`phrase_category_id`),
  KEY `phrase_fi` (`phrase_fi`),
  KEY `category_fi` (`category_fi`)
) TYPE=MyISAM AUTO_INCREMENT=71;

--
-- Dumping data for table `survey_phrase_category`
--

/*!40000 ALTER TABLE `survey_phrase_category` DISABLE KEYS */;
INSERT INTO `survey_phrase_category` VALUES (1,1,1,1);
INSERT INTO `survey_phrase_category` VALUES (2,1,2,2);
INSERT INTO `survey_phrase_category` VALUES (3,2,3,1);
INSERT INTO `survey_phrase_category` VALUES (4,2,4,2);
INSERT INTO `survey_phrase_category` VALUES (5,3,5,1);
INSERT INTO `survey_phrase_category` VALUES (6,3,6,2);
INSERT INTO `survey_phrase_category` VALUES (7,4,7,1);
INSERT INTO `survey_phrase_category` VALUES (8,4,8,2);
INSERT INTO `survey_phrase_category` VALUES (9,5,9,1);
INSERT INTO `survey_phrase_category` VALUES (10,5,10,2);
INSERT INTO `survey_phrase_category` VALUES (11,6,11,1);
INSERT INTO `survey_phrase_category` VALUES (12,6,12,2);
INSERT INTO `survey_phrase_category` VALUES (13,7,13,1);
INSERT INTO `survey_phrase_category` VALUES (14,7,14,2);
INSERT INTO `survey_phrase_category` VALUES (15,8,1,1);
INSERT INTO `survey_phrase_category` VALUES (16,8,15,2);
INSERT INTO `survey_phrase_category` VALUES (17,8,2,3);
INSERT INTO `survey_phrase_category` VALUES (18,9,3,1);
INSERT INTO `survey_phrase_category` VALUES (19,9,16,2);
INSERT INTO `survey_phrase_category` VALUES (20,9,4,3);
INSERT INTO `survey_phrase_category` VALUES (21,10,5,1);
INSERT INTO `survey_phrase_category` VALUES (22,10,17,2);
INSERT INTO `survey_phrase_category` VALUES (23,10,6,3);
INSERT INTO `survey_phrase_category` VALUES (24,11,7,1);
INSERT INTO `survey_phrase_category` VALUES (25,11,16,2);
INSERT INTO `survey_phrase_category` VALUES (26,11,8,3);
INSERT INTO `survey_phrase_category` VALUES (27,12,9,1);
INSERT INTO `survey_phrase_category` VALUES (28,12,16,2);
INSERT INTO `survey_phrase_category` VALUES (29,12,10,3);
INSERT INTO `survey_phrase_category` VALUES (30,13,11,1);
INSERT INTO `survey_phrase_category` VALUES (31,13,18,2);
INSERT INTO `survey_phrase_category` VALUES (32,13,12,3);
INSERT INTO `survey_phrase_category` VALUES (33,14,13,1);
INSERT INTO `survey_phrase_category` VALUES (34,14,16,2);
INSERT INTO `survey_phrase_category` VALUES (35,14,14,3);
INSERT INTO `survey_phrase_category` VALUES (36,15,19,1);
INSERT INTO `survey_phrase_category` VALUES (37,15,1,2);
INSERT INTO `survey_phrase_category` VALUES (38,15,15,3);
INSERT INTO `survey_phrase_category` VALUES (39,15,2,4);
INSERT INTO `survey_phrase_category` VALUES (40,15,20,5);
INSERT INTO `survey_phrase_category` VALUES (41,16,21,1);
INSERT INTO `survey_phrase_category` VALUES (42,16,3,2);
INSERT INTO `survey_phrase_category` VALUES (43,16,16,3);
INSERT INTO `survey_phrase_category` VALUES (44,16,4,4);
INSERT INTO `survey_phrase_category` VALUES (45,16,22,5);
INSERT INTO `survey_phrase_category` VALUES (46,17,23,1);
INSERT INTO `survey_phrase_category` VALUES (47,17,5,2);
INSERT INTO `survey_phrase_category` VALUES (48,17,17,3);
INSERT INTO `survey_phrase_category` VALUES (49,17,24,4);
INSERT INTO `survey_phrase_category` VALUES (50,17,6,5);
INSERT INTO `survey_phrase_category` VALUES (51,18,25,1);
INSERT INTO `survey_phrase_category` VALUES (52,18,7,2);
INSERT INTO `survey_phrase_category` VALUES (53,18,16,3);
INSERT INTO `survey_phrase_category` VALUES (54,18,8,4);
INSERT INTO `survey_phrase_category` VALUES (55,18,26,5);
INSERT INTO `survey_phrase_category` VALUES (56,19,27,1);
INSERT INTO `survey_phrase_category` VALUES (57,19,9,2);
INSERT INTO `survey_phrase_category` VALUES (58,19,16,3);
INSERT INTO `survey_phrase_category` VALUES (59,19,10,4);
INSERT INTO `survey_phrase_category` VALUES (60,19,28,5);
INSERT INTO `survey_phrase_category` VALUES (61,20,11,1);
INSERT INTO `survey_phrase_category` VALUES (62,20,29,2);
INSERT INTO `survey_phrase_category` VALUES (63,20,30,3);
INSERT INTO `survey_phrase_category` VALUES (64,20,31,4);
INSERT INTO `survey_phrase_category` VALUES (65,20,12,5);
INSERT INTO `survey_phrase_category` VALUES (66,21,32,1);
INSERT INTO `survey_phrase_category` VALUES (67,21,33,2);
INSERT INTO `survey_phrase_category` VALUES (68,21,16,3);
INSERT INTO `survey_phrase_category` VALUES (69,21,34,4);
INSERT INTO `survey_phrase_category` VALUES (70,21,35,5);
/*!40000 ALTER TABLE `survey_phrase_category` ENABLE KEYS */;

--
-- Table structure for table `survey_question`
--

CREATE TABLE `survey_question` (
  `question_id` int(11) NOT NULL auto_increment,
  `questiontype_fi` int(11) NOT NULL default '0',
  `obj_fi` int(11) unsigned NOT NULL default '0',
  `owner_fi` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `description` varchar(200) NOT NULL default '',
  `author` varchar(100) NOT NULL default '',
  `questiontext` text NOT NULL,
  `obligatory` enum('0','1') NOT NULL default '1',
  `complete` enum('0','1') NOT NULL default '0',
  `created` varchar(14) NOT NULL default '',
  `original_id` int(11) default NULL,
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`question_id`),
  KEY `obj_fi` (`obj_fi`),
  KEY `owner_fi` (`owner_fi`),
  FULLTEXT KEY `title_desc` (`title`,`description`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question`
--

/*!40000 ALTER TABLE `survey_question` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question` ENABLE KEYS */;

--
-- Table structure for table `survey_question_constraint`
--

CREATE TABLE `survey_question_constraint` (
  `question_constraint_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `constraint_fi` int(11) NOT NULL default '0',
  PRIMARY KEY  (`question_constraint_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `question_fi` (`question_fi`),
  KEY `constraint_fi` (`constraint_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_constraint`
--

/*!40000 ALTER TABLE `survey_question_constraint` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_constraint` ENABLE KEYS */;

--
-- Table structure for table `survey_question_material`
--

CREATE TABLE `survey_question_material` (
  `material_id` int(11) NOT NULL auto_increment,
  `question_fi` int(11) NOT NULL default '0',
  `materials` text,
  `materials_file` varchar(200) NOT NULL default '',
  UNIQUE KEY `material_id` (`material_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_material`
--

/*!40000 ALTER TABLE `survey_question_material` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_material` ENABLE KEYS */;

--
-- Table structure for table `survey_question_matrix`
--

CREATE TABLE `survey_question_matrix` (
  `question_fi` int(11) NOT NULL default '0',
  `subtype` int(11) NOT NULL default '0',
  `column_separators` enum('0','1') NOT NULL default '0',
  `row_separators` enum('0','1') NOT NULL default '0',
  `neutral_column_separator` enum('0','1') NOT NULL default '1',
  `column_placeholders` int(11) NOT NULL default '0',
  `legend` enum('0','1') NOT NULL default '0',
  `singleline_row_caption` enum('0','1') NOT NULL default '0',
  `repeat_column_header` enum('0','1') NOT NULL default '0',
  `column_header_position` enum('0','1','2','3') NOT NULL default '0',
  `random_rows` enum('0','1') NOT NULL default '0',
  `column_order` enum('0','1','2') NOT NULL default '0',
  `column_images` enum('0','1') NOT NULL default '0',
  `row_images` enum('0','1') NOT NULL default '0',
  `bipolar_adjective1` varchar(255) default NULL,
  `bipolar_adjective2` varchar(255) default NULL,
  `layout` text,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_matrix`
--

/*!40000 ALTER TABLE `survey_question_matrix` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_matrix` ENABLE KEYS */;

--
-- Table structure for table `survey_question_matrix_rows`
--

CREATE TABLE `survey_question_matrix_rows` (
  `id_survey_question_matrix_rows` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `sequence` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_survey_question_matrix_rows`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_matrix_rows`
--

/*!40000 ALTER TABLE `survey_question_matrix_rows` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_matrix_rows` ENABLE KEYS */;

--
-- Table structure for table `survey_question_metric`
--

CREATE TABLE `survey_question_metric` (
  `question_fi` int(11) NOT NULL default '0',
  `subtype` enum('3','4','5') NOT NULL default '3',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_metric`
--

/*!40000 ALTER TABLE `survey_question_metric` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_metric` ENABLE KEYS */;

--
-- Table structure for table `survey_question_nominal`
--

CREATE TABLE `survey_question_nominal` (
  `question_fi` int(11) NOT NULL default '0',
  `subtype` enum('1','2') NOT NULL default '1',
  `orientation` enum('0','1','2') NOT NULL default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_nominal`
--

/*!40000 ALTER TABLE `survey_question_nominal` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_nominal` ENABLE KEYS */;

--
-- Table structure for table `survey_question_obligatory`
--

CREATE TABLE `survey_question_obligatory` (
  `question_obligatory_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `obligatory` enum('0','1') NOT NULL default '1',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`question_obligatory_id`),
  KEY `survey_fi` (`survey_fi`,`question_fi`)
) TYPE=MyISAM COMMENT='Contains the obligatory state of questions in a survey';

--
-- Dumping data for table `survey_question_obligatory`
--

/*!40000 ALTER TABLE `survey_question_obligatory` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_obligatory` ENABLE KEYS */;

--
-- Table structure for table `survey_question_ordinal`
--

CREATE TABLE `survey_question_ordinal` (
  `question_fi` int(11) NOT NULL default '0',
  `orientation` enum('0','1','2') NOT NULL default '0',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_ordinal`
--

/*!40000 ALTER TABLE `survey_question_ordinal` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_ordinal` ENABLE KEYS */;

--
-- Table structure for table `survey_question_text`
--

CREATE TABLE `survey_question_text` (
  `question_fi` int(11) NOT NULL default '0',
  `maxchars` int(11) default NULL,
  `width` int(11) NOT NULL default '50',
  `height` int(11) NOT NULL default '5',
  PRIMARY KEY  (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_question_text`
--

/*!40000 ALTER TABLE `survey_question_text` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question_text` ENABLE KEYS */;

--
-- Table structure for table `survey_questionblock`
--

CREATE TABLE `survey_questionblock` (
  `questionblock_id` int(11) NOT NULL auto_increment,
  `title` text,
  `show_questiontext` enum('0','1') default '1',
  `owner_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`questionblock_id`),
  KEY `owner_fi` (`owner_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_questionblock`
--

/*!40000 ALTER TABLE `survey_questionblock` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_questionblock` ENABLE KEYS */;

--
-- Table structure for table `survey_questionblock_question`
--

CREATE TABLE `survey_questionblock_question` (
  `questionblock_question_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `questionblock_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  PRIMARY KEY  (`questionblock_question_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `questionblock_fi` (`questionblock_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_questionblock_question`
--

/*!40000 ALTER TABLE `survey_questionblock_question` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_questionblock_question` ENABLE KEYS */;

--
-- Table structure for table `survey_questionpool`
--

CREATE TABLE `survey_questionpool` (
  `id_questionpool` int(11) NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `online` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`id_questionpool`),
  KEY `obj_fi` (`obj_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_questionpool`
--

/*!40000 ALTER TABLE `survey_questionpool` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_questionpool` ENABLE KEYS */;

--
-- Table structure for table `survey_questiontype`
--

CREATE TABLE `survey_questiontype` (
  `questiontype_id` int(11) NOT NULL auto_increment,
  `type_tag` varchar(30) NOT NULL default '',
  `plugin` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`questiontype_id`)
) TYPE=MyISAM AUTO_INCREMENT=6;

--
-- Dumping data for table `survey_questiontype`
--

/*!40000 ALTER TABLE `survey_questiontype` DISABLE KEYS */;
INSERT INTO `survey_questiontype` VALUES (1,'SurveyNominalQuestion',0);
INSERT INTO `survey_questiontype` VALUES (2,'SurveyOrdinalQuestion',0);
INSERT INTO `survey_questiontype` VALUES (3,'SurveyMetricQuestion',0);
INSERT INTO `survey_questiontype` VALUES (4,'SurveyTextQuestion',0);
INSERT INTO `survey_questiontype` VALUES (5,'SurveyMatrixQuestion',0);
/*!40000 ALTER TABLE `survey_questiontype` ENABLE KEYS */;

--
-- Table structure for table `survey_relation`
--

CREATE TABLE `survey_relation` (
  `relation_id` int(11) NOT NULL auto_increment,
  `longname` varchar(20) NOT NULL default '',
  `shortname` char(2) NOT NULL default '',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`relation_id`)
) TYPE=MyISAM AUTO_INCREMENT=7;

--
-- Dumping data for table `survey_relation`
--

/*!40000 ALTER TABLE `survey_relation` DISABLE KEYS */;
INSERT INTO `survey_relation` VALUES (1,'less','<','2004-05-18 07:57:53');
INSERT INTO `survey_relation` VALUES (2,'less_or_equal','<=','2004-05-18 07:58:08');
INSERT INTO `survey_relation` VALUES (3,'equal','=','2004-05-18 07:58:16');
INSERT INTO `survey_relation` VALUES (4,'not_equal','<>','2004-05-18 07:58:39');
INSERT INTO `survey_relation` VALUES (5,'more_or_equal','>=','2004-05-18 07:58:52');
INSERT INTO `survey_relation` VALUES (6,'more','>','2004-05-18 07:59:03');
/*!40000 ALTER TABLE `survey_relation` ENABLE KEYS */;

--
-- Table structure for table `survey_survey`
--

CREATE TABLE `survey_survey` (
  `survey_id` int(11) NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `author` varchar(50) NOT NULL default '',
  `introduction` text,
  `outro` text,
  `status` enum('0','1') NOT NULL default '1',
  `startdate` date default NULL,
  `enddate` date default NULL,
  `evaluation_access` enum('0','1','2') NOT NULL default '0',
  `invitation` enum('0','1') NOT NULL default '0',
  `invitation_mode` enum('0','1') NOT NULL default '1',
  `complete` enum('0','1') NOT NULL default '0',
  `created` varchar(14) NOT NULL default '',
  `anonymize` enum('0','1','2') NOT NULL default '0',
  `show_question_titles` enum('0','1') NOT NULL default '1',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`survey_id`),
  KEY `obj_fi` (`obj_fi`),
  FULLTEXT KEY `introduction` (`introduction`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_survey`
--

/*!40000 ALTER TABLE `survey_survey` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_survey` ENABLE KEYS */;

--
-- Table structure for table `survey_survey_question`
--

CREATE TABLE `survey_survey_question` (
  `survey_question_id` int(11) NOT NULL auto_increment,
  `survey_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `sequence` int(11) NOT NULL default '0',
  `heading` text,
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`survey_question_id`),
  KEY `survey_fi` (`survey_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_survey_question`
--

/*!40000 ALTER TABLE `survey_survey_question` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_survey_question` ENABLE KEYS */;

--
-- Table structure for table `survey_variable`
--

CREATE TABLE `survey_variable` (
  `variable_id` int(11) NOT NULL auto_increment,
  `category_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `value1` double default NULL,
  `value2` double default NULL,
  `sequence` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`variable_id`),
  KEY `category_fi` (`category_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `survey_variable`
--

/*!40000 ALTER TABLE `survey_variable` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_variable` ENABLE KEYS */;

--
-- Table structure for table `tree`
--

CREATE TABLE `tree` (
  `tree` int(10) NOT NULL default '0',
  `child` int(10) unsigned NOT NULL default '0',
  `parent` int(10) unsigned default NULL,
  `lft` int(10) unsigned NOT NULL default '0',
  `rgt` int(10) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  KEY `child` (`child`),
  KEY `parent` (`parent`),
  KEY `jmp_tree` (`tree`)
) TYPE=MyISAM;

--
-- Dumping data for table `tree`
--

/*!40000 ALTER TABLE `tree` DISABLE KEYS */;
INSERT INTO `tree` VALUES (1,1,0,1,140,1);
INSERT INTO `tree` VALUES (1,7,9,5,6,3);
INSERT INTO `tree` VALUES (1,8,9,7,8,3);
INSERT INTO `tree` VALUES (1,9,1,2,139,2);
INSERT INTO `tree` VALUES (1,10,9,9,10,3);
INSERT INTO `tree` VALUES (1,11,9,11,12,3);
INSERT INTO `tree` VALUES (1,12,9,3,4,3);
INSERT INTO `tree` VALUES (1,14,9,13,18,3);
INSERT INTO `tree` VALUES (1,15,9,19,20,3);
INSERT INTO `tree` VALUES (1,16,9,21,22,3);
INSERT INTO `tree` VALUES (1,17,9,23,24,3);
INSERT INTO `tree` VALUES (1,18,9,25,26,3);
INSERT INTO `tree` VALUES (1,19,9,27,28,3);
INSERT INTO `tree` VALUES (1,20,9,29,30,3);
INSERT INTO `tree` VALUES (1,21,9,31,32,3);
INSERT INTO `tree` VALUES (1,22,9,33,34,3);
INSERT INTO `tree` VALUES (1,23,9,35,36,3);
INSERT INTO `tree` VALUES (1,24,14,14,17,4);
INSERT INTO `tree` VALUES (1,25,24,15,16,5);
INSERT INTO `tree` VALUES (1,26,9,37,38,3);
INSERT INTO `tree` VALUES (1,27,9,39,40,3);
INSERT INTO `tree` VALUES (1,28,9,41,42,3);
INSERT INTO `tree` VALUES (1,29,9,43,44,3);
INSERT INTO `tree` VALUES (1,30,9,45,46,3);
INSERT INTO `tree` VALUES (1,31,9,47,48,3);
INSERT INTO `tree` VALUES (1,32,9,49,50,3);
INSERT INTO `tree` VALUES (1,33,9,51,52,3);
INSERT INTO `tree` VALUES (1,34,9,53,54,3);
INSERT INTO `tree` VALUES (1,35,9,55,56,3);
/*!40000 ALTER TABLE `tree` ENABLE KEYS */;

--
-- Table structure for table `tst_active`
--

CREATE TABLE `tst_active` (
  `active_id` int(10) unsigned NOT NULL auto_increment,
  `user_fi` int(10) unsigned NOT NULL default '0',
  `anonymous_id` varchar(5) default NULL,
  `test_fi` int(10) unsigned NOT NULL default '0',
  `sequence` text NOT NULL,
  `postponed` text,
  `lastindex` tinyint(4) NOT NULL default '1',
  `tries` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  `submitted` tinyint(3) unsigned default '0',
  `submittimestamp` datetime default NULL,
  PRIMARY KEY  (`active_id`),
  KEY `user_fi` (`user_fi`),
  KEY `test_fi` (`test_fi`),
  KEY `anonymous_id` (`anonymous_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_active`
--

/*!40000 ALTER TABLE `tst_active` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_active` ENABLE KEYS */;

--
-- Table structure for table `tst_active_qst_sol_settings`
--

CREATE TABLE `tst_active_qst_sol_settings` (
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(10) unsigned NOT NULL default '0',
  `solved` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`active_fi`,`question_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_active_qst_sol_settings`
--

/*!40000 ALTER TABLE `tst_active_qst_sol_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_active_qst_sol_settings` ENABLE KEYS */;

--
-- Table structure for table `tst_eval_settings`
--

CREATE TABLE `tst_eval_settings` (
  `eval_settings_id` int(11) NOT NULL auto_increment,
  `user_fi` int(11) NOT NULL default '0',
  `qworkedthrough` enum('0','1') NOT NULL default '1',
  `pworkedthrough` enum('0','1') NOT NULL default '1',
  `timeofwork` enum('0','1') NOT NULL default '1',
  `atimeofwork` enum('0','1') NOT NULL default '1',
  `firstvisit` enum('0','1') NOT NULL default '1',
  `lastvisit` enum('0','1') NOT NULL default '1',
  `resultspoints` enum('0','1') NOT NULL default '1',
  `resultsmarks` enum('0','1') NOT NULL default '1',
  `distancemedian` enum('0','1') NOT NULL default '1',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`eval_settings_id`),
  KEY `user_fi` (`user_fi`)
) TYPE=MyISAM COMMENT='User settings for statistical evaluation tool';

--
-- Dumping data for table `tst_eval_settings`
--

/*!40000 ALTER TABLE `tst_eval_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_eval_settings` ENABLE KEYS */;

--
-- Table structure for table `tst_invited_user`
--

CREATE TABLE `tst_invited_user` (
  `test_fi` int(11) NOT NULL default '0',
  `user_fi` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  `clientip` varchar(255) default NULL,
  PRIMARY KEY  (`test_fi`,`user_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_invited_user`
--

/*!40000 ALTER TABLE `tst_invited_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_invited_user` ENABLE KEYS */;

--
-- Table structure for table `tst_manual_feedback`
--

CREATE TABLE `tst_manual_feedback` (
  `manual_feedback_id` int(11) NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `pass` int(11) NOT NULL default '0',
  `feedback` text,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`manual_feedback_id`),
  KEY `active_fi` (`active_fi`),
  KEY `question_fi` (`question_fi`),
  KEY `pass` (`pass`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_manual_feedback`
--

/*!40000 ALTER TABLE `tst_manual_feedback` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_manual_feedback` ENABLE KEYS */;

--
-- Table structure for table `tst_mark`
--

CREATE TABLE `tst_mark` (
  `mark_id` int(10) unsigned NOT NULL auto_increment,
  `test_fi` int(10) unsigned NOT NULL default '0',
  `short_name` varchar(15) NOT NULL default '',
  `official_name` varchar(50) NOT NULL default '',
  `minimum_level` double NOT NULL default '0',
  `passed` enum('0','1') NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`mark_id`),
  KEY `test_fi` (`test_fi`)
) TYPE=MyISAM COMMENT='Mark steps of mark schemas';

--
-- Dumping data for table `tst_mark`
--

/*!40000 ALTER TABLE `tst_mark` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_mark` ENABLE KEYS */;

--
-- Table structure for table `tst_sequence`
--

CREATE TABLE `tst_sequence` (
  `active_fi` int(11) NOT NULL default '0',
  `pass` int(11) NOT NULL default '0',
  `sequence` text NOT NULL,
  `postponed` text,
  `hidden` text,
  `lastchange` timestamp NOT NULL,
  UNIQUE KEY `active_fi` (`active_fi`,`pass`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_sequence`
--

/*!40000 ALTER TABLE `tst_sequence` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_sequence` ENABLE KEYS */;

--
-- Table structure for table `tst_solutions`
--

CREATE TABLE `tst_solutions` (
  `solution_id` int(10) unsigned NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(10) unsigned NOT NULL default '0',
  `value1` text,
  `value2` text,
  `points` double default NULL,
  `pass` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`solution_id`),
  KEY `question_fi` (`question_fi`),
  KEY `active_fi` (`active_fi`)
) TYPE=MyISAM COMMENT='Test and Assessment solutions';

--
-- Dumping data for table `tst_solutions`
--

/*!40000 ALTER TABLE `tst_solutions` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_solutions` ENABLE KEYS */;

--
-- Table structure for table `tst_test_defaults`
--

CREATE TABLE `tst_test_defaults` (
  `test_defaults_id` int(11) NOT NULL auto_increment,
  `user_fi` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `defaults` text NOT NULL,
  `marks` text NOT NULL,
  `lastchange` timestamp NOT NULL,
  PRIMARY KEY  (`test_defaults_id`),
  KEY `user_fi` (`user_fi`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_test_defaults`
--

/*!40000 ALTER TABLE `tst_test_defaults` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_test_defaults` ENABLE KEYS */;

--
-- Table structure for table `tst_test_pass_result`
--

CREATE TABLE `tst_test_pass_result` (
  `active_fi` int(11) NOT NULL default '0',
  `pass` int(11) NOT NULL default '0',
  `points` double NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  `maxpoints` int(11) NOT NULL default '0',
  `questioncount` int(11) NOT NULL default '0',
  `answeredquestions` int(11) NOT NULL default '0',
  `workingtime` int(11) NOT NULL default '0',
  UNIQUE KEY `active_fi` (`active_fi`,`pass`)
) TYPE=MyISAM;

--
-- Dumping data for table `tst_test_pass_result`
--

/*!40000 ALTER TABLE `tst_test_pass_result` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_test_pass_result` ENABLE KEYS */;

--
-- Table structure for table `tst_test_question`
--

CREATE TABLE `tst_test_question` (
  `test_question_id` int(11) NOT NULL auto_increment,
  `test_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `sequence` int(10) unsigned NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`test_question_id`),
  KEY `test_fi` (`test_fi`),
  KEY `question_fi` (`question_fi`)
) TYPE=MyISAM COMMENT='Relation table for questions in tests';

--
-- Dumping data for table `tst_test_question`
--

/*!40000 ALTER TABLE `tst_test_question` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_test_question` ENABLE KEYS */;

--
-- Table structure for table `tst_test_random`
--

CREATE TABLE `tst_test_random` (
  `test_random_id` int(11) NOT NULL auto_increment,
  `test_fi` int(11) NOT NULL default '0',
  `questionpool_fi` int(11) NOT NULL default '0',
  `num_of_q` int(10) unsigned NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`test_random_id`),
  KEY `test_fi` (`test_fi`),
  KEY `questionpool_fi` (`questionpool_fi`)
) TYPE=MyISAM COMMENT='Questionpools taken for a random test';

--
-- Dumping data for table `tst_test_random`
--

/*!40000 ALTER TABLE `tst_test_random` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_test_random` ENABLE KEYS */;

--
-- Table structure for table `tst_test_random_question`
--

CREATE TABLE `tst_test_random_question` (
  `test_random_question_id` int(11) NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(11) NOT NULL default '0',
  `sequence` int(10) unsigned NOT NULL default '0',
  `pass` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`test_random_question_id`),
  KEY `question_fi` (`question_fi`),
  KEY `active_fi` (`active_fi`),
  KEY `pass` (`pass`)
) TYPE=MyISAM COMMENT='Relation table for random questions in tests';

--
-- Dumping data for table `tst_test_random_question`
--

/*!40000 ALTER TABLE `tst_test_random_question` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_test_random_question` ENABLE KEYS */;

--
-- Table structure for table `tst_test_result`
--

CREATE TABLE `tst_test_result` (
  `test_result_id` int(10) unsigned NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `question_fi` int(10) unsigned NOT NULL default '0',
  `points` double NOT NULL default '0',
  `pass` int(11) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`test_result_id`),
  UNIQUE KEY `active_fi` (`active_fi`,`question_fi`,`pass`),
  KEY `active_fi_2` (`active_fi`)
) TYPE=MyISAM COMMENT='Test and Assessment user results for test questions';

--
-- Dumping data for table `tst_test_result`
--

/*!40000 ALTER TABLE `tst_test_result` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_test_result` ENABLE KEYS */;

--
-- Table structure for table `tst_tests`
--

CREATE TABLE `tst_tests` (
  `test_id` int(10) unsigned NOT NULL auto_increment,
  `obj_fi` int(11) NOT NULL default '0',
  `author` varchar(50) NOT NULL default '',
  `introduction` text,
  `sequence_settings` tinyint(3) unsigned NOT NULL default '0',
  `score_reporting` tinyint(3) unsigned NOT NULL default '0',
  `instant_verification` enum('0','1') NOT NULL default '0',
  `answer_feedback` enum('0','1') NOT NULL default '0',
  `answer_feedback_points` enum('0','1') NOT NULL default '0',
  `fixed_participants` enum('0','1') NOT NULL default '0',
  `show_cancel` enum('0','1') NOT NULL default '1',
  `anonymity` enum('0','1') NOT NULL default '0',
  `nr_of_tries` tinyint(3) unsigned NOT NULL default '0',
  `use_previous_answers` enum('0','1') NOT NULL default '1',
  `title_output` enum('0','1','2') NOT NULL default '0',
  `processing_time` time default NULL,
  `enable_processing_time` enum('0','1') NOT NULL default '0',
  `reset_processing_time` smallint(6) NOT NULL default '0',
  `reporting_date` varchar(14) default NULL,
  `starting_time` varchar(14) default NULL,
  `ending_time` varchar(14) default NULL,
  `shuffle_questions` enum('0','1') NOT NULL default '0',
  `ects_output` enum('0','1') NOT NULL default '0',
  `ects_fx` float default NULL,
  `complete` enum('0','1') NOT NULL default '1',
  `created` varchar(14) default NULL,
  `TIMESTAMP` timestamp NOT NULL,
  `ects_a` double NOT NULL default '90',
  `ects_b` double NOT NULL default '65',
  `ects_c` double NOT NULL default '35',
  `ects_d` double NOT NULL default '10',
  `ects_e` double NOT NULL default '0',
  `random_test` enum('0','1') NOT NULL default '0',
  `keep_questions` tinyint(4) NOT NULL default '0',
  `random_question_count` int(11) default NULL,
  `count_system` enum('0','1') NOT NULL default '0',
  `mc_scoring` enum('0','1') NOT NULL default '0',
  `score_cutting` enum('0','1') NOT NULL default '0',
  `pass_scoring` enum('0','1') NOT NULL default '0',
  `password` varchar(20) default NULL,
  `allowedUsers` int(11) default NULL,
  `allowedUsersTimeGap` int(11) default NULL,
  `results_presentation` int(11) NOT NULL default '3',
  `show_summary` int(11) NOT NULL default '0',
  `show_question_titles` enum('0','1') NOT NULL default '1',
  `certificate_visibility` enum('0','1','2') NOT NULL default '0',
  `show_marker` tinyint(4) NOT NULL default '0',
  `kiosk` int(11) NOT NULL default '0',
  `resultoutput` int(11) NOT NULL default '0',
  `finalstatement` text,
  `showfinalstatement` int(11) NOT NULL default '0',
  `showinfo` int(11) NOT NULL default '1',
  `forcejs` int(11) NOT NULL default '0',
  `customstyle` varchar(128) default NULL,
  PRIMARY KEY  (`test_id`),
  KEY `obj_fi` (`obj_fi`),
  FULLTEXT KEY `introduction` (`introduction`)
) TYPE=MyISAM COMMENT='Tests in ILIAS Assessment';

--
-- Dumping data for table `tst_tests`
--

/*!40000 ALTER TABLE `tst_tests` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_tests` ENABLE KEYS */;

--
-- Table structure for table `tst_times`
--

CREATE TABLE `tst_times` (
  `times_id` int(11) NOT NULL auto_increment,
  `active_fi` int(11) NOT NULL default '0',
  `started` datetime NOT NULL default '0000-00-00 00:00:00',
  `finished` datetime NOT NULL default '0000-00-00 00:00:00',
  `pass` tinyint(4) NOT NULL default '0',
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`times_id`),
  KEY `active_fi` (`active_fi`),
  KEY `pass` (`pass`)
) TYPE=MyISAM COMMENT='Editing times of an assessment test';

--
-- Dumping data for table `tst_times`
--

/*!40000 ALTER TABLE `tst_times` DISABLE KEYS */;
/*!40000 ALTER TABLE `tst_times` ENABLE KEYS */;

--
-- Table structure for table `user_defined_field_definition`
--

CREATE TABLE `user_defined_field_definition` (
  `field_id` int(3) NOT NULL auto_increment,
  `field_name` tinytext NOT NULL,
  `field_type` tinyint(1) NOT NULL default '0',
  `field_values` text NOT NULL,
  `visible` tinyint(1) NOT NULL default '0',
  `changeable` tinyint(1) NOT NULL default '0',
  `required` tinyint(1) NOT NULL default '0',
  `searchable` tinyint(1) NOT NULL default '0',
  `export` tinyint(1) NOT NULL default '0',
  `course_export` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`field_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `user_defined_field_definition`
--

/*!40000 ALTER TABLE `user_defined_field_definition` DISABLE KEYS */;
/*!40000 ALTER TABLE `user_defined_field_definition` ENABLE KEYS */;

--
-- Table structure for table `usr_data`
--

CREATE TABLE `usr_data` (
  `usr_id` int(10) unsigned NOT NULL default '0',
  `login` varchar(80) NOT NULL default '',
  `passwd` varchar(32) NOT NULL default '',
  `firstname` varchar(32) NOT NULL default '',
  `lastname` varchar(32) NOT NULL default '',
  `title` varchar(32) NOT NULL default '',
  `gender` enum('m','f') NOT NULL default 'm',
  `email` varchar(80) NOT NULL default '',
  `institution` varchar(80) default NULL,
  `street` varchar(40) default NULL,
  `city` varchar(40) default NULL,
  `zipcode` varchar(10) default NULL,
  `country` varchar(40) default NULL,
  `phone_office` varchar(40) NOT NULL default '',
  `last_login` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `create_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `hobby` text NOT NULL,
  `department` varchar(80) NOT NULL default '',
  `phone_home` varchar(40) NOT NULL default '',
  `phone_mobile` varchar(40) NOT NULL default '',
  `fax` varchar(40) NOT NULL default '',
  `i2passwd` varchar(32) NOT NULL default '',
  `time_limit_owner` int(10) default '0',
  `time_limit_unlimited` int(2) default '0',
  `time_limit_from` int(10) default '0',
  `time_limit_until` int(10) default '0',
  `time_limit_message` int(2) default '0',
  `referral_comment` varchar(250) default '',
  `matriculation` varchar(40) default NULL,
  `active` int(4) unsigned NOT NULL default '0',
  `approve_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `agree_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `ilinc_id` int(10) unsigned default NULL,
  `ilinc_login` varchar(40) default NULL,
  `ilinc_passwd` varchar(40) default NULL,
  `client_ip` varchar(255) default NULL,
  `auth_mode` enum('default','local','ldap','radius','shibboleth','script','cas','soap','ecs') NOT NULL default 'default',
  `profile_incomplete` int(2) default '0',
  `ext_account` varchar(50) default NULL,
  `im_icq` varchar(40) default NULL,
  `im_yahoo` varchar(40) default NULL,
  `im_msn` varchar(40) default NULL,
  `im_aim` varchar(40) default NULL,
  `im_skype` varchar(40) default NULL,
  `feed_hash` varchar(32) default NULL,
  `delicious` varchar(40) default NULL,
  `latitude` varchar(30) NOT NULL default '',
  `longitude` varchar(30) NOT NULL default '',
  `loc_zoom` int(11) NOT NULL default '0',
  `login_attempts` tinyint(2) NOT NULL,
  `last_password_change` int(11) NOT NULL,
  PRIMARY KEY  (`usr_id`),
  KEY `login` (`login`,`passwd`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_data`
--

/*!40000 ALTER TABLE `usr_data` DISABLE KEYS */;
INSERT INTO `usr_data` VALUES (6,'root','dfa8327f5bfa4c672a04f9b38e348a70','root','user','','m','ilias@yourserver.com','','','','','','','2005-07-20 15:11:40','2003-09-30 19:50:01','0000-00-00 00:00:00','','','','','','',7,1,0,0,0,'',NULL,1,'0000-00-00 00:00:00','0000-00-00 00:00:00',NULL,NULL,NULL,NULL,'default',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','',0,0,1217068076);
INSERT INTO `usr_data` VALUES (13,'anonymous','294de3557d9d00b3d2d8a1e6aab028cf','anonymous','anonymous','','m','nomail',NULL,NULL,NULL,NULL,NULL,'','2003-08-15 11:03:36','2003-08-15 10:07:30','2003-08-15 10:07:30','','','','','','',7,1,0,0,0,'',NULL,1,'0000-00-00 00:00:00','0000-00-00 00:00:00',NULL,NULL,NULL,NULL,'local',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','',0,0,1217068076);
/*!40000 ALTER TABLE `usr_data` ENABLE KEYS */;

--
-- Table structure for table `usr_defined_data`
--

CREATE TABLE `usr_defined_data` (
  `usr_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_defined_data`
--

/*!40000 ALTER TABLE `usr_defined_data` DISABLE KEYS */;
INSERT INTO `usr_defined_data` VALUES (6);
INSERT INTO `usr_defined_data` VALUES (13);
/*!40000 ALTER TABLE `usr_defined_data` ENABLE KEYS */;

--
-- Table structure for table `usr_new_account_mail`
--

CREATE TABLE `usr_new_account_mail` (
  `lang` varchar(5) NOT NULL default '',
  `subject` varchar(200) default '',
  `body` mediumtext,
  `sal_f` varchar(200) NOT NULL default '',
  `sal_m` varchar(200) NOT NULL default '',
  `sal_g` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`lang`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_new_account_mail`
--

/*!40000 ALTER TABLE `usr_new_account_mail` DISABLE KEYS */;
/*!40000 ALTER TABLE `usr_new_account_mail` ENABLE KEYS */;

--
-- Table structure for table `usr_pref`
--

CREATE TABLE `usr_pref` (
  `usr_id` int(10) unsigned NOT NULL default '0',
  `keyword` char(40) NOT NULL default '',
  `value` char(40) default NULL,
  PRIMARY KEY  (`usr_id`,`keyword`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_pref`
--

/*!40000 ALTER TABLE `usr_pref` DISABLE KEYS */;
INSERT INTO `usr_pref` VALUES (6,'style','delos');
INSERT INTO `usr_pref` VALUES (6,'skin','default');
INSERT INTO `usr_pref` VALUES (6,'public_zip','n');
INSERT INTO `usr_pref` VALUES (6,'public_upload','n');
INSERT INTO `usr_pref` VALUES (6,'public_street','n');
INSERT INTO `usr_pref` VALUES (6,'public_profile','n');
INSERT INTO `usr_pref` VALUES (6,'public_phone','n');
INSERT INTO `usr_pref` VALUES (6,'public_institution','n');
INSERT INTO `usr_pref` VALUES (6,'public_hobby','n');
INSERT INTO `usr_pref` VALUES (6,'public_email','n');
INSERT INTO `usr_pref` VALUES (6,'public_country','n');
INSERT INTO `usr_pref` VALUES (6,'public_city','n');
INSERT INTO `usr_pref` VALUES (6,'language','en');
INSERT INTO `usr_pref` VALUES (6,'show_users_online','y');
INSERT INTO `usr_pref` VALUES (13,'show_users_online','y');
/*!40000 ALTER TABLE `usr_pref` ENABLE KEYS */;

--
-- Table structure for table `usr_pwassist`
--

CREATE TABLE `usr_pwassist` (
  `pwassist_id` varchar(32) NOT NULL default '',
  `expires` int(11) NOT NULL default '0',
  `ctime` int(11) NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pwassist_id`),
  UNIQUE KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_pwassist`
--

/*!40000 ALTER TABLE `usr_pwassist` DISABLE KEYS */;
/*!40000 ALTER TABLE `usr_pwassist` ENABLE KEYS */;

--
-- Table structure for table `usr_search`
--

CREATE TABLE `usr_search` (
  `usr_id` int(11) NOT NULL default '0',
  `search_result` text,
  `checked` text NOT NULL,
  `failed` text NOT NULL,
  `page` tinyint(2) NOT NULL default '0',
  `search_type` tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`,`search_type`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_search`
--

/*!40000 ALTER TABLE `usr_search` DISABLE KEYS */;
/*!40000 ALTER TABLE `usr_search` ENABLE KEYS */;

--
-- Table structure for table `usr_session`
--

CREATE TABLE `usr_session` (
  `session_id` varchar(80) NOT NULL default '',
  `expires` int(11) NOT NULL default '0',
  `data` text NOT NULL,
  `ctime` int(11) NOT NULL default '0',
  `user_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`session_id`),
  KEY `expires` (`expires`),
  KEY `user_id` (`user_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `usr_session`
--

/*!40000 ALTER TABLE `usr_session` DISABLE KEYS */;
/*!40000 ALTER TABLE `usr_session` ENABLE KEYS */;

--
-- Table structure for table `ut_access`
--

CREATE TABLE `ut_access` (
  `id` int(10) NOT NULL auto_increment,
  `user_id` int(10) unsigned NOT NULL default '0',
  `action_type` char(10) default NULL,
  `php_script` char(100) NOT NULL default '',
  `client_ip` char(15) default NULL,
  `acc_obj_type` char(10) NOT NULL default '',
  `acc_obj_id` int(10) NOT NULL default '0',
  `acc_sub_type` char(10) NOT NULL default '',
  `acc_sub_id` int(10) NOT NULL default '0',
  `language` char(15) default NULL,
  `browser` char(60) NOT NULL default '',
  `session_id` char(40) default NULL,
  `acc_time` datetime default NULL,
  PRIMARY KEY  (`id`),
  KEY `acc_obj_id` (`acc_obj_id`,`acc_sub_id`,`session_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_access`
--

/*!40000 ALTER TABLE `ut_access` DISABLE KEYS */;
/*!40000 ALTER TABLE `ut_access` ENABLE KEYS */;

--
-- Table structure for table `ut_lp_collections`
--

CREATE TABLE `ut_lp_collections` (
  `obj_id` int(11) NOT NULL default '0',
  `item_id` int(11) NOT NULL default '0',
  KEY `obj_id` (`obj_id`,`item_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_collections`
--

/*!40000 ALTER TABLE `ut_lp_collections` DISABLE KEYS */;
/*!40000 ALTER TABLE `ut_lp_collections` ENABLE KEYS */;

--
-- Table structure for table `ut_lp_filter`
--

CREATE TABLE `ut_lp_filter` (
  `usr_id` int(11) NOT NULL default '0',
  `filter_type` varchar(4) NOT NULL default '',
  `root_node` int(11) NOT NULL default '0',
  `hidden` text NOT NULL,
  `query_string` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_filter`
--

/*!40000 ALTER TABLE `ut_lp_filter` DISABLE KEYS */;
/*!40000 ALTER TABLE `ut_lp_filter` ENABLE KEYS */;

--
-- Table structure for table `ut_lp_marks`
--

CREATE TABLE `ut_lp_marks` (
  `obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `completed` int(1) NOT NULL default '0',
  `mark` varchar(32) NOT NULL default '',
  `comment` text NOT NULL,
  PRIMARY KEY  (`obj_id`,`usr_id`),
  KEY `obj_usr` (`obj_id`,`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_marks`
--

/*!40000 ALTER TABLE `ut_lp_marks` DISABLE KEYS */;
/*!40000 ALTER TABLE `ut_lp_marks` ENABLE KEYS */;

--
-- Table structure for table `ut_lp_settings`
--

CREATE TABLE `ut_lp_settings` (
  `obj_id` int(11) NOT NULL default '0',
  `obj_type` char(4) NOT NULL default '',
  `mode` tinyint(1) NOT NULL default '0',
  `visits` int(4) default '0',
  PRIMARY KEY  (`obj_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_lp_settings`
--

/*!40000 ALTER TABLE `ut_lp_settings` DISABLE KEYS */;
/*!40000 ALTER TABLE `ut_lp_settings` ENABLE KEYS */;

--
-- Table structure for table `ut_online`
--

CREATE TABLE `ut_online` (
  `usr_id` int(11) NOT NULL default '0',
  `online_time` int(11) NOT NULL default '0',
  `access_time` int(10) NOT NULL default '0',
  PRIMARY KEY  (`usr_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `ut_online`
--

/*!40000 ALTER TABLE `ut_online` DISABLE KEYS */;
/*!40000 ALTER TABLE `ut_online` ENABLE KEYS */;

--
-- Table structure for table `webr_items`
--

CREATE TABLE `webr_items` (
  `link_id` int(11) NOT NULL auto_increment,
  `webr_id` int(11) NOT NULL default '0',
  `title` varchar(127) default NULL,
  `description` text NOT NULL,
  `target` text,
  `active` tinyint(1) default NULL,
  `disable_check` tinyint(1) default NULL,
  `create_date` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  `last_check` int(11) default NULL,
  `valid` tinyint(1) NOT NULL default '0',
  KEY `link_id` (`link_id`,`webr_id`),
  FULLTEXT KEY `title` (`title`)
) TYPE=MyISAM;

--
-- Dumping data for table `webr_items`
--

/*!40000 ALTER TABLE `webr_items` DISABLE KEYS */;
/*!40000 ALTER TABLE `webr_items` ENABLE KEYS */;

--
-- Table structure for table `webr_params`
--

CREATE TABLE `webr_params` (
  `param_id` int(11) NOT NULL auto_increment,
  `webr_id` int(11) NOT NULL default '0',
  `link_id` int(11) NOT NULL default '0',
  `name` char(128) NOT NULL default '',
  `value` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`param_id`),
  KEY `link_id` (`link_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `webr_params`
--

/*!40000 ALTER TABLE `webr_params` DISABLE KEYS */;
/*!40000 ALTER TABLE `webr_params` ENABLE KEYS */;

--
-- Table structure for table `write_event`
--

CREATE TABLE `write_event` (
  `obj_id` int(11) NOT NULL default '0',
  `parent_obj_id` int(11) NOT NULL default '0',
  `usr_id` int(11) NOT NULL default '0',
  `action` varchar(8) NOT NULL default '',
  `ts` timestamp NOT NULL,
  PRIMARY KEY  (`obj_id`,`ts`,`parent_obj_id`,`action`),
  KEY `parent_key` (`parent_obj_id`,`ts`)
) TYPE=MyISAM;

--
-- Dumping data for table `write_event`
--

/*!40000 ALTER TABLE `write_event` DISABLE KEYS */;
INSERT INTO `write_event` VALUES (7,9,-1,'create','2002-06-26 21:24:06');
INSERT INTO `write_event` VALUES (8,9,-1,'create','2002-06-26 21:24:06');
INSERT INTO `write_event` VALUES (9,1,-1,'create','2002-07-15 00:37:33');
INSERT INTO `write_event` VALUES (10,9,-1,'create','2002-07-15 00:36:56');
INSERT INTO `write_event` VALUES (11,9,-1,'create','2002-07-15 03:52:51');
INSERT INTO `write_event` VALUES (12,9,-1,'create','2003-08-14 22:07:28');
INSERT INTO `write_event` VALUES (98,9,-1,'create','2004-02-18 15:17:40');
INSERT INTO `write_event` VALUES (100,9,-1,'create','2004-03-09 12:13:16');
INSERT INTO `write_event` VALUES (107,9,-1,'create','2004-06-20 13:27:18');
INSERT INTO `write_event` VALUES (109,9,-1,'create','2004-07-10 13:03:12');
INSERT INTO `write_event` VALUES (86,9,-1,'create','2003-11-30 15:22:49');
INSERT INTO `write_event` VALUES (114,9,-1,'create','2004-09-01 21:49:45');
INSERT INTO `write_event` VALUES (116,9,-1,'create','2005-01-07 11:21:15');
INSERT INTO `write_event` VALUES (118,9,-1,'create','2005-03-02 02:59:01');
INSERT INTO `write_event` VALUES (124,9,-1,'create','2005-06-19 21:50:00');
INSERT INTO `write_event` VALUES (128,9,-1,'create','2005-07-20 06:10:04');
INSERT INTO `write_event` VALUES (132,98,6,'create','2005-11-07 06:41:22');
INSERT INTO `write_event` VALUES (133,132,6,'create','2005-11-07 06:41:22');
INSERT INTO `write_event` VALUES (136,9,-1,'create','2006-07-11 06:43:23');
INSERT INTO `write_event` VALUES (138,9,-1,'create','2007-02-26 11:58:49');
INSERT INTO `write_event` VALUES (140,9,-1,'create','2007-02-26 11:58:50');
INSERT INTO `write_event` VALUES (144,9,-1,'create','2007-04-03 01:43:47');
INSERT INTO `write_event` VALUES (147,9,-1,'create','2007-09-25 07:47:53');
INSERT INTO `write_event` VALUES (150,9,-1,'create','2008-06-02 04:08:54');
INSERT INTO `write_event` VALUES (152,9,-1,'create','2008-06-02 04:08:55');
/*!40000 ALTER TABLE `write_event` ENABLE KEYS */;

--
-- Table structure for table `xhtml_page`
--

CREATE TABLE `xhtml_page` (
  `id` int(11) NOT NULL auto_increment,
  `content` mediumtext,
  `save_content` mediumtext,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xhtml_page`
--

/*!40000 ALTER TABLE `xhtml_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `xhtml_page` ENABLE KEYS */;

--
-- Table structure for table `xml_attribute_idx`
--

CREATE TABLE `xml_attribute_idx` (
  `node_id` int(10) unsigned NOT NULL default '0',
  `attribute_id` smallint(5) unsigned NOT NULL default '0',
  `value_id` smallint(5) unsigned NOT NULL default '0',
  KEY `node_id` (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_idx`
--

/*!40000 ALTER TABLE `xml_attribute_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_attribute_idx` ENABLE KEYS */;

--
-- Table structure for table `xml_attribute_name`
--

CREATE TABLE `xml_attribute_name` (
  `attribute_id` smallint(5) unsigned NOT NULL auto_increment,
  `attribute` char(32) NOT NULL default '',
  PRIMARY KEY  (`attribute_id`),
  UNIQUE KEY `attribute` (`attribute`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_name`
--

/*!40000 ALTER TABLE `xml_attribute_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_attribute_name` ENABLE KEYS */;

--
-- Table structure for table `xml_attribute_namespace`
--

CREATE TABLE `xml_attribute_namespace` (
  `attribute_id` smallint(5) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `namespace` char(64) NOT NULL default '',
  PRIMARY KEY  (`attribute_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_namespace`
--

/*!40000 ALTER TABLE `xml_attribute_namespace` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_attribute_namespace` ENABLE KEYS */;

--
-- Table structure for table `xml_attribute_value`
--

CREATE TABLE `xml_attribute_value` (
  `value_id` smallint(5) unsigned NOT NULL auto_increment,
  `value` char(32) NOT NULL default '0',
  PRIMARY KEY  (`value_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_attribute_value`
--

/*!40000 ALTER TABLE `xml_attribute_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_attribute_value` ENABLE KEYS */;

--
-- Table structure for table `xml_cdata`
--

CREATE TABLE `xml_cdata` (
  `node_id` int(10) unsigned NOT NULL auto_increment,
  `cdata` text NOT NULL,
  PRIMARY KEY  (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_cdata`
--

/*!40000 ALTER TABLE `xml_cdata` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_cdata` ENABLE KEYS */;

--
-- Table structure for table `xml_comment`
--

CREATE TABLE `xml_comment` (
  `node_id` int(10) unsigned NOT NULL auto_increment,
  `comment` text NOT NULL,
  PRIMARY KEY  (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_comment`
--

/*!40000 ALTER TABLE `xml_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_comment` ENABLE KEYS */;

--
-- Table structure for table `xml_element_idx`
--

CREATE TABLE `xml_element_idx` (
  `node_id` int(10) unsigned NOT NULL default '0',
  `element_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`node_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_element_idx`
--

/*!40000 ALTER TABLE `xml_element_idx` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_element_idx` ENABLE KEYS */;

--
-- Table structure for table `xml_element_name`
--

CREATE TABLE `xml_element_name` (
  `element_id` smallint(5) unsigned NOT NULL auto_increment,
  `element` char(32) NOT NULL default '',
  PRIMARY KEY  (`element_id`),
  UNIQUE KEY `element` (`element`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_element_name`
--

/*!40000 ALTER TABLE `xml_element_name` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_element_name` ENABLE KEYS */;

--
-- Table structure for table `xml_element_namespace`
--

CREATE TABLE `xml_element_namespace` (
  `element_id` smallint(5) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `namespace` char(64) NOT NULL default '',
  PRIMARY KEY  (`element_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_element_namespace`
--

/*!40000 ALTER TABLE `xml_element_namespace` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_element_namespace` ENABLE KEYS */;

--
-- Table structure for table `xml_entity_reference`
--

CREATE TABLE `xml_entity_reference` (
  `element_id` smallint(5) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `entity_reference` char(128) NOT NULL default '',
  PRIMARY KEY  (`element_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_entity_reference`
--

/*!40000 ALTER TABLE `xml_entity_reference` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_entity_reference` ENABLE KEYS */;

--
-- Table structure for table `xml_node_type`
--

CREATE TABLE `xml_node_type` (
  `node_type_id` int(11) NOT NULL auto_increment,
  `description` varchar(50) default NULL,
  `lft_delimiter` varchar(10) default NULL,
  `rgt_delimiter` varchar(10) default NULL,
  PRIMARY KEY  (`node_type_id`)
) TYPE=MyISAM AUTO_INCREMENT=11;

--
-- Dumping data for table `xml_node_type`
--

/*!40000 ALTER TABLE `xml_node_type` DISABLE KEYS */;
INSERT INTO `xml_node_type` VALUES (1,'ELEMENT_NODE','<','>');
INSERT INTO `xml_node_type` VALUES (2,'ATTRIBUTE_NODE(not used)','\"','\"');
INSERT INTO `xml_node_type` VALUES (3,'TEXT_NODE',NULL,NULL);
INSERT INTO `xml_node_type` VALUES (5,'ENTITY_REF_NODE','&',';');
INSERT INTO `xml_node_type` VALUES (4,'CDATA_SECTION_NODE','<![CDATA[',']]>');
INSERT INTO `xml_node_type` VALUES (8,'COMMENT_NODE','<!--','-->');
INSERT INTO `xml_node_type` VALUES (9,'DOCUMENT_NODE',NULL,NULL);
INSERT INTO `xml_node_type` VALUES (10,'DOCUMENT_TYPE_NODE',NULL,NULL);
INSERT INTO `xml_node_type` VALUES (6,'ENTITY_NODE','&',';');
/*!40000 ALTER TABLE `xml_node_type` ENABLE KEYS */;

--
-- Table structure for table `xml_object`
--

CREATE TABLE `xml_object` (
  `ID` int(11) NOT NULL auto_increment,
  `version` varchar(5) NOT NULL default '',
  `encoding` varchar(40) default NULL,
  `charset` varchar(40) default NULL,
  `TIMESTAMP` timestamp NOT NULL,
  PRIMARY KEY  (`ID`)
) TYPE=MyISAM COMMENT='Master Table for XML objects';

--
-- Dumping data for table `xml_object`
--

/*!40000 ALTER TABLE `xml_object` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_object` ENABLE KEYS */;

--
-- Table structure for table `xml_pi_data`
--

CREATE TABLE `xml_pi_data` (
  `leaf_id` int(10) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `leaf_text` text NOT NULL,
  PRIMARY KEY  (`leaf_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_pi_data`
--

/*!40000 ALTER TABLE `xml_pi_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_pi_data` ENABLE KEYS */;

--
-- Table structure for table `xml_pi_target`
--

CREATE TABLE `xml_pi_target` (
  `leaf_id` int(10) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `leaf_text` text NOT NULL,
  PRIMARY KEY  (`leaf_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_pi_target`
--

/*!40000 ALTER TABLE `xml_pi_target` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_pi_target` ENABLE KEYS */;

--
-- Table structure for table `xml_text`
--

CREATE TABLE `xml_text` (
  `node_id` int(10) unsigned NOT NULL default '0',
  `textnode` text NOT NULL,
  PRIMARY KEY  (`node_id`),
  FULLTEXT KEY `textnode` (`textnode`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_text`
--

/*!40000 ALTER TABLE `xml_text` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_text` ENABLE KEYS */;

--
-- Table structure for table `xml_tree`
--

CREATE TABLE `xml_tree` (
  `node_id` int(10) unsigned NOT NULL auto_increment,
  `xml_id` mediumint(8) unsigned NOT NULL default '0',
  `parent_node_id` int(10) unsigned NOT NULL default '0',
  `lft` smallint(5) unsigned NOT NULL default '0',
  `rgt` smallint(5) unsigned NOT NULL default '0',
  `node_type_id` tinyint(3) unsigned NOT NULL default '0',
  `depth` smallint(5) unsigned NOT NULL default '0',
  `prev_sibling_node_id` int(10) unsigned NOT NULL default '0',
  `next_sibling_node_id` int(10) unsigned NOT NULL default '0',
  `first_child_node_id` int(10) unsigned NOT NULL default '0',
  `struct` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`node_id`),
  KEY `xml_id` (`xml_id`)
) TYPE=MyISAM;

--
-- Dumping data for table `xml_tree`
--

/*!40000 ALTER TABLE `xml_tree` DISABLE KEYS */;
/*!40000 ALTER TABLE `xml_tree` ENABLE KEYS */;

--
-- Table structure for table `xmlnestedset`
--

CREATE TABLE `xmlnestedset` (
  `ns_book_fk` int(11) NOT NULL default '0',
  `ns_type` char(50) NOT NULL default '',
  `ns_tag_fk` int(11) default NULL,
  `ns_l` int(11) default NULL,
  `ns_r` int(11) default NULL,
  KEY `ns_tag_fk` (`ns_tag_fk`),
  KEY `ns_book_fk` (`ns_book_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmlnestedset`
--

/*!40000 ALTER TABLE `xmlnestedset` DISABLE KEYS */;
/*!40000 ALTER TABLE `xmlnestedset` ENABLE KEYS */;

--
-- Table structure for table `xmlparam`
--

CREATE TABLE `xmlparam` (
  `tag_fk` int(11) NOT NULL default '0',
  `param_name` char(50) NOT NULL default '',
  `param_value` char(255) NOT NULL default '',
  KEY `tag_fk` (`tag_fk`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmlparam`
--

/*!40000 ALTER TABLE `xmlparam` DISABLE KEYS */;
/*!40000 ALTER TABLE `xmlparam` ENABLE KEYS */;

--
-- Table structure for table `xmltags`
--

CREATE TABLE `xmltags` (
  `tag_pk` int(11) NOT NULL auto_increment,
  `tag_depth` int(11) NOT NULL default '0',
  `tag_name` char(50) NOT NULL default '',
  PRIMARY KEY  (`tag_pk`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmltags`
--

/*!40000 ALTER TABLE `xmltags` DISABLE KEYS */;
/*!40000 ALTER TABLE `xmltags` ENABLE KEYS */;

--
-- Table structure for table `xmlvalue`
--

CREATE TABLE `xmlvalue` (
  `tag_value_pk` int(11) NOT NULL auto_increment,
  `tag_fk` int(11) NOT NULL default '0',
  `tag_value` text NOT NULL,
  PRIMARY KEY  (`tag_value_pk`),
  KEY `tag_fk` (`tag_fk`),
  FULLTEXT KEY `tag_value` (`tag_value`)
) TYPE=MyISAM;

--
-- Dumping data for table `xmlvalue`
--

-- Dump completed on 2008-11-25  9:57:01
